(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
/**
 * @module fusioncharts.jqueryplugin
 * @private
 * @requires fusioncharts.transcoder.htmltable
 *
 * @export fusioncharts.jqueryplugin.js
 */

var FusionCharts = require('fusioncharts');
var jQuery = require('jquery');

// Require the html table module
require('./transcoder-htmltable/transcoder-htmltable');

FusionCharts.register('module', ['private', 'extensions.jQueryPlugin', function () {

    var global = this,
        win = global.window,
        lib = global.hcLib,
        doc = win.document,
        jQ = jQuery,
        renderFusionCharts,
        captureAllFusionChartsEvents,
        getChartObjectsFromSelection,
        configureLinkedCharts,
        math = win.Math,
        mathMin = math.min,
        isArray = lib.isArray,
        realtimeCommandMap = {
        feed: 'feedData',
        setdata: 'setData',
        setdataforid: 'setDataForId',
        getdata: 'getData',
        getdataforid: 'getDataForId',
        clear: 'clearChart',
        stop: 'stopUpdate',
        start: 'restartUpdate'
    },
        optionsParser = {
        feedData: function (options) {
            if (typeof options === 'string') {
                return [options];
            } else if (typeof options === 'object' && options.stream) {
                return [options.stream];
            } else {
                return false;
            }
        },
        getData: function (options) {
            // index is passed in case of multivalue charts.
            if (!isNaN(options)) {
                return [options];
            } else if (typeof options === 'object' && options.index) {
                return [options.index];
            } else {
                return [];
            }
        },
        getDataForId: function (options) {
            // index is passed in case of multivalue charts.
            if (typeof options === 'string') {
                return [options];
            } else if (typeof options === 'object' && options.id) {
                return [options.id];
            } else {
                return [];
            }
        },
        setData: function (options, value, label) {
            var arr = [];
            if (typeof options !== 'object') {
                arr = [options, value, label];
            } else {
                options.value && arr.push(options.value);
                options.label && arr.push(options.label);
            }

            return arr;
        },
        setDataForId: function (options, value, label) {
            var arr = [];
            if (typeof options === 'string' || typeof value === 'string' || typeof label === 'string') {
                arr = [options, value, label];
            } else if (typeof options === 'object') {
                options.value && arr.push(options.value);
                options.label && arr.push(options.label);
            }

            return arr;
        },
        clearChart: function (options) {
            return [options];
        },
        stopUpdate: function (options) {
            return [options];
        },
        restartUpdate: function (options) {
            return [options];
        }
    };

    // Assign FusionCharts object to global jQuery object for easy use.
    jQ.FusionCharts = global.core;

    /**
     * Used purely for rendering the FusionCharts.
     * Acts as a common method that is invoked by all the APIs that create a
     * FusionChart object
     *
     * @param {array} elemList is a list of all the HTML elements that
     * are selected using the jQuery selectors
     *
     * @param {object} chartOptions is the options that are to be passed to
     * the FusionCharts contructor.
     */

    renderFusionCharts = function (elemList, chartOptions) {
        var i, l, cO, chartObj, scriptElement;

        if (isArray(chartOptions) || chartOptions instanceof jQ) {
            l = mathMin(elemList.length, chartOptions.length);
        } else {
            l = elemList.length;
        }

        for (i = 0; i < l; i += 1) {

            // One-to-one mapping with the HTML elements in case of
            // multiple option objects.
            if (isArray(chartOptions) || chartOptions instanceof jQ) {
                cO = chartOptions[i];
            } else {
                cO = chartOptions;
            }

            // check if the element is appended to the window document or not.
            if (elemList[i].parentNode) {
                // Adding the renderAt option to the chartOptions tells the
                // constructor where to render the FusionCharts object.
                global.core.render(jQ.extend({}, cO, {
                    renderAt: elemList[i]
                }));
            } else {
                chartObj = new FusionCharts(jQ.extend({}, cO, {
                    renderAt: elemList[i]
                }));

                if (!jQ.FusionCharts.delayedRender) {
                    jQ.FusionCharts.delayedRender = {};
                }
                jQ.FusionCharts.delayedRender[chartObj.id] = elemList[i];

                scriptElement = doc.createElement('script');
                scriptElement.setAttribute('type', 'text/javascript');

                if (/msie/i.test(win.navigator.userAgent) && !win.opera) {
                    scriptElement.text = 'FusionCharts.items[\'' + chartObj.id + '\'].render();';
                } else {
                    scriptElement.appendChild(doc.createTextNode('FusionCharts.items[\'' + chartObj.id + '\'].render()'));
                }
                elemList[i].appendChild(scriptElement);
            }
        }
        return elemList;
    };

    /**
     *  Using jQuery's event model for attaching handlers to FusionCharts events.
     *  This is achieved by listening to the FusionCharts "*" event and then
     *  triggering a jQuery event on the associated DOM element.
     */
    captureAllFusionChartsEvents = function (event, args) {
        var containerElement;

        // Extending our event with the jQuery event model for proper
        // delegation and bubbling.
        jQ.extend(event, jQ.Event('fusioncharts' + event.eventType));

        // Checking if there is an associated DOM object
        if (event.sender && event.sender.options) {
            containerElement = event.sender.options.containerElement || event.sender.options.containerElementId;

            if (typeof containerElement === 'object') {
                jQ(containerElement).trigger(event, args);
            } else if (jQ('#' + containerElement).length) {
                jQ('#' + containerElement).trigger(event, args);
            } else {
                jQ(doc).trigger(event, args);
            }
        } else {
            // If there is no DOM object associated with the FusionCharts object
            // then triggering the event on the document itself for any possible
            // global handlers that might want to capture it.
            jQ(doc).trigger(event, args);
        }
    };

    global.addEventListener('*', captureAllFusionChartsEvents);

    /**
     * Used to select all the HTML object/embed elements that have been created
     * using the FusionCharts constructor
     *
     * @param {jQuery} obj, the selection of elements that need to be processed.
     *
     */
    getChartObjectsFromSelection = function (obj) {

        // The HTML object/embed may be part of the current selection or a
        // child of the current selection. Need to take both cases into account.
        // @note If the FusionCharts object has not been rendered yet, e.g in
        // case the container is not appended to the document, then 'find' for
        // that element will NOT return the corresponding FusionCharts object.
        return obj.filter(':FusionCharts').add(obj.find(':FusionCharts'));
    };

    /**
     *  Used to configure the links at various levels in a linked chart.
     *
     *  @param {jQuery} chartObjects The FusionCharts objects for which the link
     *  has to be configured.
     *
     *  @param {object} linkConfigObj contains the configuration details of the
     *  linked chart like swfUrl, height, width etc.
     *
     *  @param {string} level contains the level at which the user wants to
     *  configure the link.
     *
     */
    configureLinkedCharts = function (chartObjects, linkConfigObj, level) {

        if (typeof linkConfigObj === 'object') {
            chartObjects.each(function () {
                this.configureLink(linkConfigObj, level);
            });
        }
    };

    /**
     * @id: jQuery.fn.insertFusionCharts
     * @id: $.fn.insertFusionCharts
     *
     * @param {object} options contains the parameters that need to be passed
     * to the FusionCharts constructor
     *
     * Inserts the FusionCharts objects in the HTML elements that are selected
     * by the jQuery selector.
     */
    jQ.fn.insertFusionCharts = function (options) {
        return renderFusionCharts(this, options);
    };

    /**
     * @id: jQuery.fn.appendFusionCharts
     * @id: $.fn.appendFusionCharts
     *
     * @param {object} options contains that parameters that need to be passed
     * to the FusionCharts constructor
     *
     * Appends the FusionCharts objects immediately after the HTML elements
     * that are selected by the jQuery selector.
     */
    jQ.fn.appendFusionCharts = function (options) {
        options.insertMode = 'append';
        return renderFusionCharts(this, options);
    };

    /**
     * @id: jQuery.fn.prependFusionCharts
     * @id: $.fn.prependFusionCharts
     *
     * @param {object} options contains the parameters that need to be passed
     * to the FusionCharts constructor
     *
     *  Prepends the FusionCharts objects before the HTML elements that are
     *  selected by the jQuery selector.
     */
    jQ.fn.prependFusionCharts = function (options) {
        options.insertMode = 'prepend';
        return renderFusionCharts(this, options);
    };

    /**
     * @id: jQuery.fn.attrFusionCharts
     * @id: $.fn.attrFusionCharts
     *
     * @param {object|string} attr, If this is a string then it contains
     * the FusionCharts object's attribute that needs to be set or fetched.
     * If it is an object then, it contains the attributes along with the
     * corresponding values that need to be set on the FusionCharts object
     *
     * @param {string} attrVal, To be used if attr is a string. Contains the
     * value that needs to be set for the attribute that attr corresponds to.
     *
     *  Used to set or get the attribute(s) of the FusionCharts object.
     */
    jQ.fn.attrFusionCharts = function (attr, attrVal) {

        /**
         * @ignore
         * @todo Remove ignore
         *
         * @var {jQuery} chartsObjects stores the FusionCharts objects in
         * the selected HTML elements.
         * @var {object} transfer Holds all atttributes to be returned to the
         * callee Function.
         */
        var transfer = [],
            chartObjects = getChartObjectsFromSelection(this);

        if (attrVal !== undefined) {
            // Set the charts attribute attr with value attrVal.

            chartObjects.each(function () {
                this.FusionCharts.setChartAttribute(attr, attrVal);
            });
            return this;
        }
        if (typeof attr === 'object') {
            // Set the charts attributes, in the passed object's keys with
            // the corresponding values.

            chartObjects.each(function () {
                this.FusionCharts.setChartAttribute(attr);
            });
            return this;
        }

        // If both the above cases fail, user is trying to, in accordance with the
        // jQuery paradigm, get the value of the arrtibute.
        chartObjects.each(function () {
            transfer.push(this.FusionCharts.getChartAttribute(attr));
        });
        return transfer;
    };

    /**
     * @id jQuery.fn.updateFusionCharts
     * @id $.fn.updateFusionCharts
     *
     * @param {object} options Contains the new options that the FusionCharts
     * objects need to update themselves with. Currently, using this interface
     * the dataType, data, width, height, debugMode and swfUrl can be updated.
     */
    jQ.fn.updateFusionCharts = function (options) {

        var filterOpts = {},
            chartObjects = getChartObjectsFromSelection(this),
            updateOptions = [['swfUrl', false], ['type', false], ['height', false], ['width', false], ['containerBackgroundColor', true], ['containerBackgroundAlpha', true], ['dataFormat', false], ['dataSource', false]],
            i,
            l,
            fcChart,
            renderFlag,
            optStr,
            newChart;

        for (i = 0, l = updateOptions.length; i < l; i += 1) {
            optStr = updateOptions[i][0];
            filterOpts.type = filterOpts.type || filterOpts.swfUrl;
            if (options[optStr]) {
                if (updateOptions[i][1]) {
                    renderFlag = true;
                }
                filterOpts[optStr] = options[optStr];
            }
        }

        chartObjects.each(function () {
            // If height and width are given then resize the chart first.
            fcChart = this.FusionCharts;
            if (renderFlag) {
                newChart = fcChart.clone(filterOpts);
                newChart.render();
                return;
            }

            if (filterOpts.dataSource !== undefined || filterOpts.dataFormat !== undefined) {
                if (filterOpts.dataSource === undefined) {
                    fcChart.setChartData(fcChart.args.dataSource, filterOpts.dataFormat);
                } else if (filterOpts.dataFormat === undefined) {
                    fcChart.setChartData(filterOpts.dataSource, fcChart.args.dataFormat);
                } else {
                    fcChart.setChartData(filterOpts.dataSource, filterOpts.dataFormat);
                }
            }
            if (filterOpts.width !== undefined || filterOpts.height !== undefined) {
                fcChart.resizeTo(filterOpts.width, filterOpts.height);
            }
            if (filterOpts.type) {
                fcChart.chartType(filterOpts.type);
            }
        });

        return this;
    };

    /**
     *  @id: jQuery.fn.cloneFusionCharts
     *  @id: $.fn.cloneFusionCharts
     *
     *  @param {object} options The options object that takes the additional
     *  parameters to be passed while cloning the FusionCharts object.
     *
     *  @param {function} callback The callback function that has to be called
     *  once the FusionCharts objects have been cloned. This function will take
     *  the new clone objects as parameter.
     *
     */
    jQ.fn.cloneFusionCharts = function (callback, options) {

        var transfer, temp, chartObjects;

        // Check if the options parameter, which is not mandatory, has been
        // passed or not. If not, that means that options is the callback function.
        if (typeof callback !== 'function' && typeof options === 'function') {
            temp = callback;
            callback = options;
            options = temp;
        }

        transfer = [];
        chartObjects = getChartObjectsFromSelection(this);

        chartObjects.each(function () {
            transfer.push(this.FusionCharts.clone(options, {}, true));
        });

        callback.call(jQ(transfer), transfer);

        return this;
    };

    /**
     *  @id: jQuery.fn.disposeFusionCharts
     *  @id: $.fn.disposeFusionCharts
     *
     */
    jQ.fn.disposeFusionCharts = function () {

        var chartObjects = getChartObjectsFromSelection(this);

        chartObjects.each(function () {
            // Execute dispose on charts.
            this.FusionCharts.dispose();

            // Remove identifier reference variable
            delete this.FusionCharts;

            // cleanup any static objects pertaining to FusionCharts.
            if (this._fcDrillDownLevel === 0) {
                delete this._fcDrillDownLevel;
            }
        });

        return this;
    };

    /**
     * @id jQuery.fn.covertToFusionCharts
     * @id $.fn.convertToFusionCharts
     *
     * @param {object} chartOpts Configuration options to generate FusionCharts.
     * See documentation to get the list.
     *
     * @param {object} convertOpts Configuration options to convert the table
     * into a FusionCharts object.
     * See documentation to get the list.
     *
     */
    jQ.fn.convertToFusionCharts = function (chartOpts, convertOpts) {

        var transferObj = [];

        if (typeof chartOpts.dataConfiguration === 'undefined') {
            chartOpts.dataConfiguration = {};
        }

        jQ.extend(true, chartOpts.dataConfiguration, convertOpts);

        if (!chartOpts.dataSource) {
            chartOpts.dataSource = this.get(0);
        }

        if (!chartOpts.renderAt) {
            this.each(function () {
                transferObj.push(jQ('<div></div>').insertBefore(this).insertFusionCharts(chartOpts).get(0));
            });
        } else {
            if (typeof chartOpts.renderAt === 'string') {
                transferObj.push(jQ('#' + chartOpts.renderAt).insertFusionCharts(chartOpts).get(0));
            } else if (typeof chartOpts.renderAt === 'object') {
                transferObj.push(jQ(chartOpts.renderAt).insertFusionCharts(chartOpts).get(0));
            }
        }

        return jQ(transferObj);
    };

    /**
     * @id jQuery.fn.drillDownFusionChartsTo
     * @id $.fn.drillDownFusionChartsTo
     *
     * Used to set multi-level configurations of linked FusionCharts objects.
     * The levels are iterated depending on the number of configuration objects
     * in a single jQuery chain.
     *
     * To set the configuration at a specific level please refer to docs.
     */
    jQ.fn.drillDownFusionChartsTo = function () {
        var chartObjects = getChartObjectsFromSelection(this),
            j,
            len,
            i,
            l,
            configureOpts;

        // hack to support chaining of multiple drillDowns in a single chain
        if (typeof this._fcDrillDownLevel === 'undefined') {
            this._fcDrillDownLevel = 0;
        }

        for (j = 0, len = arguments.length; j < len; j += 1) {
            configureOpts = arguments[j];

            if (isArray(configureOpts)) {
                for (i = 0, l = configureOpts.length; i < l; i += 1) {
                    configureLinkedCharts(chartObjects, configureOpts[i], this._fcDrillDownLevel);
                    this._fcDrillDownLevel += 1;
                }
            } else {
                configureLinkedCharts(chartObjects, configureOpts, this._fcDrillDownLevel);
                this._fcDrillDownLevel += 1;
            }
        }
        return this;
    };

    /**
     * @id jQuery.fn.streamFusionChartsData
     * @id $.fn.streamFusionChartsData
     *
     * @param {string} command. Contains the type of operation to be performed on
     * the realtime charts. If not provided, by default the command would be 'feed'
     * that invokes the feedData method of the chart and passes the options to it.
     *
     * @param {object} options. Contains the options that has to be parsed (if it is a js object)
     * and passed to the chart method (corresponding to command).
     * If not an object, it is passed as is to the chart method.
     *
     * @param {object} value. To make the API morph the data setter methods (setData, setDataForId),
     * it can also be passed the same parameters as the setter functions.
     *
     * @param {object} label. To make the API morph the data setter methods (setData, setDataForId),
     * it can also be passed the same parameters as the setter functions.
    **/

    jQ.fn.streamFusionChartsData = function (command, options, value, label) {

        var chartObjects = getChartObjectsFromSelection(this),
            transfer = [],
            fcChart,
            method,
            params;

        // Convert the command to lower case and fetch the proper chart method name.
        method = realtimeCommandMap[command && command.toLowerCase()];

        // Check if the command provided is valid or not.
        if (method === undefined) {
            // this means the command is not a getter. which in turn means that
            // the command is a data stream string and has to be handled accordingly.
            if (arguments.length === 1) {
                params = [command];
                method = realtimeCommandMap.feed;
            } else {
                return this;
            }
        } else if (arguments.length === 1) {
            // command is to invoke a method without any parameters..
            params = [];
        } else {
            // optionsParser returns an array of parameters to be passed to the
            // chart method.
            params = optionsParser[method](options, value, label);
        }

        if (method === 'getData' || method === 'getDataForId') {
            chartObjects.each(function () {
                fcChart = this.FusionCharts;
                if (typeof fcChart[method] === 'function') {
                    transfer.push(fcChart[method].apply(fcChart, params));
                }
            });
            return transfer;
        } else {
            chartObjects.each(function () {
                fcChart = this.FusionCharts;
                if (typeof fcChart[method] === 'function') {
                    fcChart[method].apply(fcChart, params);
                }
            });
            return this;
        }
    };

    jQ.extend(jQ.expr[':'], {
        /**
         *  Extending the jQuery selector to select all object/embed elements that
         *  have been created using the FusionCharts constructor i.e that are an
         *  instance of FusionCharts.
         *
         *  @param {object} obj, Is the HTML element that is currently being
         *  checked.
         */
        FusionCharts: function (obj) {
            return obj.FusionCharts instanceof global.core;
        }
    });
}]);

module.exports = FusionCharts;

},{"./transcoder-htmltable/transcoder-htmltable":2,"fusioncharts":4,"jquery":5}],2:[function(require,module,exports){
/**
 * HTMLTable Data Handler
 * This module maps chart type alias with particular FusionCharts object.
 * @private
 *
 * @module fusioncharts.transcoder.htmltable
 */
var FusionCharts = require('fusioncharts');

FusionCharts.register('module', ['private', 'HTMLTableDataHandler', function () {

    var global = this,
        win = global.window,
        doc = win.document,


    /**
     *  Used to remove all textNodes in an array of nodes. Textnodes get created
     *  inadvertently, when the table HTML has newline and space. Returns an
     *  array of nodes that is not an HTMLCollection and has only the non-text
     *  nodes in it.
     *
     *  @param {array} nodeArr Contains the array of nodes that have to be
     *  sanitized.
     */
    sanitizeNodesArray = function (nodeArr) {
        var l,
            i,
            sanitizedArr = [];
        for (i = 0, l = nodeArr.length; i < l; i += 1) {
            // if nodeType != 3 then the node is not a text node.
            if (nodeArr[i].nodeType !== 3) {
                sanitizedArr.push(nodeArr[i]);
            }
        }
        return sanitizedArr;
    },


    /**
     * Used to merge two JSON objects. The copy is a deep copy and not a
     * reference copy.
     *
     * @param: {object} srcJSON, the source json.
     *
     * @param: {object} targetJSON, that json that needs to be merged with the
     * source json.
     *
     */
    mergeJSON = function (srcJSON, targetJSON) {
        var i, len, item;

        if (targetJSON instanceof Array) {
            for (i = 0, len = targetJSON.length; i < len; i++) {
                if (targetJSON[i] instanceof Array) {
                    if (srcJSON[i] === undefined) {
                        srcJSON[i] = [];
                    }
                    mergeJSON(srcJSON[i], targetJSON[i]);
                } else if (typeof targetJSON[i] === 'object') {
                    if (typeof srcJSON[i] === 'undefined') {
                        srcJSON[i] = {};
                    }
                    mergeJSON(srcJSON[i], targetJSON[i]);
                } else {
                    srcJSON[i] = targetJSON[i];
                }
            }
        } else if (typeof targetJSON === 'object') {
            for (item in targetJSON) {
                if (typeof srcJSON[item] === 'undefined') {
                    if (targetJSON[item] instanceof Array) {
                        srcJSON[item] = [];
                        mergeJSON(srcJSON[item], targetJSON[item]);
                    } else if (typeof srcJSON[item] === 'object') {
                        srcJSON[i] = {};
                        mergeJSON(srcJSON[i], targetJSON[i]);
                    } else {
                        srcJSON[i] = targetJSON[i];
                    }
                }
            }
        }

        return srcJSON;
    },


    /**
     *  Returns the <tbody> element of the table. In order to support W3C
     *  non-compliant HTML, wherein the table does not have a <tbody> containing
     *  the <tr> & <td> elements, the table itself is returned.
     *
     *  @param {object} tbl Is the table whose tbody needs to fetched.
     *
     */
    getTbody = function (tbl) {
        var tbodyArr = sanitizeNodesArray(tbl.childNodes);

        // Checking if the table's childNode is a tbody or not
        if (tbodyArr.length) {
            if (tbodyArr[0].nodeName === 'TBODY') {
                return tbodyArr[0];
            } else if (tbodyArr[0].nodeName === 'THEAD' && tbodyArr[1] && tbodyArr[1].nodeName === 'TBODY') {
                return tbodyArr[1];
            }
        }
        return tbl;
    },


    /**
     *  Returns an array containing the <td> in the <thead> tag.
     *
     *  @param {object} tbl Is the table whose tbody needs to fetched.
     *
     */
    getThead = function (tbl) {
        var tbodyArr = sanitizeNodesArray(tbl.childNodes);

        // Checking if the table's childNode is a tbody or not
        if (tbodyArr.length) {
            if (tbodyArr[0].nodeName === 'THEAD' && tbodyArr[1] && tbodyArr[1].nodeName === 'TBODY') {
                return tbodyArr[0].childNodes;
            }
        }
        return [];
    },


    /**
     *  Used to return the text in a given Element. Needed as firefox does not
     *  support 'innerText', which is a W3C standard and instead uses
     *  textContent attribute to store the text.
     *
     *  @param {object} nodeEle The HTML element whose text is needed.
     */
    getTextFromNode = function (nodeEle) {
        return nodeEle.innerText !== undefined ? nodeEle.innerText : nodeEle.textContent;
    },


    /**
     *  Used to convert an array of rows into an array of corresponding columns.
     *
     *  @param {array} rowArr The array of table rows that has to be transposed
     *  into an array of columns.
     */
    getColumnArr = function (rowArr) {

        var i,
            j,
            l,
            len,
            cellArr,
            rowSpanInc,
            colSpan = 1,
            columnArrIdx,
            rowSpan = {},
            returnObj = [];

        for (i = 0, l = rowArr.length; i < l; i += 1) {

            // get all the cells of the row
            cellArr = sanitizeNodesArray(rowArr[i].childNodes);
            colSpan = 1;
            rowSpanInc = 0;
            for (j = 0, len = cellArr.length; j < len; j += 1) {

                // if a previous row had a cell with a rowspan then this
                // rowspan needs to be taken into account while creating
                // column array.
                columnArrIdx = j + colSpan + rowSpanInc - 1;
                if (rowSpan[columnArrIdx] && i - rowSpan[columnArrIdx].rowNum < rowSpan[columnArrIdx].row) {
                    rowSpanInc += rowSpan[columnArrIdx].col;
                    columnArrIdx += rowSpan[columnArrIdx].col;
                }

                if (parseInt(cellArr[j].getAttribute('rowspan'), 10) > 1) {
                    if (!rowSpan[columnArrIdx]) {
                        rowSpan[columnArrIdx] = {};
                    }
                    rowSpan[columnArrIdx].rowNum = i;
                    rowSpan[columnArrIdx].row = parseInt(cellArr[j].getAttribute('rowspan'), 10);
                    // If the cell has both a rowspan and a colspan then they
                    // both need to be taken into consideration while calculating
                    // the column of cells in the susequent rows
                    if (parseInt(cellArr[j].getAttribute('colspan'), 10) > 1) {
                        rowSpan[columnArrIdx].col = parseInt(cellArr[j].getAttribute('colspan'), 10);
                    } else {
                        rowSpan[columnArrIdx].col = 1;
                    }
                }

                // The previous cells colspan, and the previous rows rowspans
                // also needs to be added to the current cells index to get the
                // proper column index.
                while (returnObj.length <= columnArrIdx) {
                    returnObj.push({ childNodes: [] });
                }
                returnObj[columnArrIdx].childNodes.push(cellArr[j]);

                // Adding the current cells colspan for subsequent cells in the
                // current row.
                if (parseInt(cellArr[j].getAttribute('colspan'), 10) > 1) {
                    colSpan += parseInt(cellArr[j].getAttribute('colspan'), 10) - 1;
                }
            }
        }

        return returnObj;
    },


    /**
     * Used to check if an item is present in an array or not.
     *
     * @param {array} arr The array which has to be checked
     *
     * @param {string|number|object} item The item which needs be checked if
     * present in array arr or not.
     */
    arrayContains = function (arr, item) {
        var i = arr.length;
        // Using a decrementing while loop (optimization) since the order in which the
        // array is traversed doesn't matter.
        while (i) {
            i -= 1;
            if (arr[i] === item) {
                return true;
            }
        }
        return false;
    },


    /**
     * Used to check if a particular row or column has all non numeric (or blank)
     * content. If so, then that particular row/column must be ignored.
     *
     * @param {array} nodeArr Is an array of all the rows/columns of the table.
     *
     * @param {number} index of the row/column that is not to be analysed as it
     * has already been set aside as the label row/column.
     *
     * @param {number} j is the cell index at which we have to check for the
     * presence of numeric data in all the other rows and columns.
     */

    checkData = function (nodeArr, j, index) {

        var i,
            l,
            childArr = sanitizeNodesArray(nodeArr[j].childNodes),
            text;

        for (i = 0, l = childArr.length; i < l; i += 1) {
            if (i !== index) {
                text = getTextFromNode(childArr[i]);
                if (parseFloat(text) === text) {
                    return true;
                }
            }
        }
        return false;
    },
        _blankString = '__fcBLANK__',
        _blankNo = 0,


    /**
     * Used to get the table row that has the labels (categories or legend) and
     * extract the label details from the corresponding row.
     *
     * @param {array} nodeArr Is an array of all the rows/columns of the table.
     *
     * @param {array} ignoreArr Is an array of all the indexes in the nodeArr
     * that need to be ignored. The items of this array can be negative as well.
     *
     * @param {string} index If the label row/column details have been given by
     * the user then this will contain the index which has the labels.
     *
     */
    getLabels = function (nodeArr, ignoreArr, index, opts) {

        var len,
            l,
            i,
            j,
            childArr,
            mostEmptyCellRow = null,
            internalLabel = [],
            emptyCellCount = [],
            textCellCount = 0,
            temp,
            returnObj = {},
            spanTotal = 0,
            spanLen,
            isRowLabel,
            maxIdx,
            spanLength,
            totalSpanLength = 0,
            tLabels;

        if (typeof index === 'undefined') {
            // Checking if the user has provided the index. If index has not been
            // passed then we assume that the user does not want to give a label row
            // or column.

            // Creating custom labels for all cells in the first row/column.
            childArr = sanitizeNodesArray(nodeArr[0].childNodes);
            for (j = 0, len = childArr.length; j < len; j += 1) {
                spanLen = j + spanTotal;
                internalLabel[spanLen] = _blankString + (spanLen + 1);

                temp = parseInt(childArr[j].colSpan, 10);
                temp = temp > 1 ? temp : parseInt(childArr[j].rowSpan, 10);
                if (temp > 1) {
                    for (l = 1; l < temp; l += 1) {
                        internalLabel[spanLen + l] = _blankString + (spanLen + l + 1);
                    }
                    spanTotal += temp - 1;
                }
            }

            // Deleting the labels for the rows/columns that the user wants to
            // ignore.
            for (i = 0, l = j + spanTotal, len = ignoreArr.length; i < len; i += 1) {
                if (ignoreArr[i] > 0) {
                    delete internalLabel[ignoreArr[i] - 1];
                } else {
                    delete internalLabel[l + ignoreArr[i]];
                }
            }

            return { 'index': -1, 'labelObj': internalLabel };
        } else if (index === 0) {
            // Checking if the user has provided the index. Since we expect row/column
            // indices starting from 1, if index is 0 then we use our internal logic
            // to find the label array from the given nodeArr.
            for (i = 0, l = nodeArr.length; i < l; i += 1) {
                childArr = sanitizeNodesArray(nodeArr[i].childNodes);
                emptyCellCount[i] = 0;
                textCellCount = 0;

                if (opts && opts._extractByHeaderTag) {
                    for (j = 0, len = childArr.length; j < len; j += 1) {
                        if (childArr[j].nodeName.toLowerCase() != 'th') {
                            continue;
                        }
                        tLabels = getLabels(nodeArr, ignoreArr, i + 1);
                        delete tLabels.labelObj[opts._rowLabelIndex];
                        return tLabels;
                    }
                } else {
                    for (j = 0, len = childArr.length; j < len; j += 1) {
                        if (arrayContains(ignoreArr, j + 1) || arrayContains(ignoreArr, j - len)) {
                            continue;
                        }
                        temp = getTextFromNode(childArr[j]);
                        // Checking if the cell is emtpy.
                        if (temp.replace(/^\s*/, '').replace(/\s*$/, '') === '') {
                            emptyCellCount[i] += 1;
                            continue;
                        }
                        // Checking if the cell has a non-number content
                        if (parseFloat(temp) != temp) {
                            textCellCount += 1;
                            // If there are at least 2 cells that have non-number
                            // content then we assume that they contain labels and
                            // fetch the labels from this array of nodes.
                            if (textCellCount > 1) {
                                return getLabels(nodeArr, ignoreArr, i + 1);
                            }
                        }
                    }
                }
                // If there are empty cells then we assume that the array with
                // the most number of empty cells must be the label array.
                if (i > 0) {
                    if (emptyCellCount[i - 1] > emptyCellCount[i]) {
                        mostEmptyCellRow = i - 1;
                    } else if (emptyCellCount[i - 1] < emptyCellCount[i]) {
                        mostEmptyCellRow = i;
                    }
                }
            }
            if (mostEmptyCellRow !== null) {
                return getLabels(nodeArr, ignoreArr, mostEmptyCellRow + 1);
            } else {
                return getLabels(nodeArr, ignoreArr);
            }
        }

        // If this is a negative number then, calulate the index from the
        // end of the table. e.g -1 would imply the last row.
        if (index < 0) {
            index += nodeArr.length;
        } else if (index > 0) {
            index -= 1;
        }

        /**
         * Once we have the index of the row/column that contains the labels we
         * go through only that row/column and extract the labels.
         */
        childArr = sanitizeNodesArray(nodeArr[index].childNodes);

        isRowLabel = nodeArr[0].nodeType !== undefined ? true : false;
        for (j = 0, len = childArr.length; j < len; j += 1) {
            spanLength = 0;
            if (isRowLabel) {
                if (childArr[j].colSpan !== '1') {
                    spanLength = parseInt(childArr[j].colSpan, 10);
                }
            } else if (childArr[j].rowSpan !== '1') {
                spanLength = parseInt(childArr[j].rowSpan, 10);
            }
            spanLength = spanLength > 1 ? spanLength : 0;
            temp = getTextFromNode(childArr[j]);
            if (temp.replace(/^\s*/, '').replace(/\s*$/, '') !== '') {
                returnObj[j + totalSpanLength] = temp;
            } else if (checkData(getColumnArr(nodeArr), j, index)) {
                // if the label text is missing in one of the cells of the labels
                // row/column we check for the presence of numeric data in other
                // cells of the corresponding column/row.

                returnObj[j + totalSpanLength] = _blankString + _blankNo;
                _blankNo += 1;
            }

            if (spanLength > 1) {
                // If the spanLength > 1, then we create additional labels for
                // rows/columns pertaining to the rowspan or colspan.
                temp = returnObj[j + totalSpanLength];
                for (i = 1; i < spanLength; i += 1) {
                    returnObj[j + totalSpanLength + i] = temp + ' (' + i + ')';
                }

                // totalSpanLength is used to adjust the indices of the
                // subsequent cells using the rowspan/colspan of the current
                // cell.
                totalSpanLength += spanLength - 1;
            }
        }

        // Deleting the rows/columns that the user wants to ignore.
        maxIdx = len + totalSpanLength;
        for (i = 0, len = ignoreArr.length; i < len; i += 1) {
            if (ignoreArr[i] > 0) {
                delete returnObj[ignoreArr[i] - 1];
            } else {
                delete returnObj[maxIdx + ignoreArr[i]];
            }
        }

        return { 'labelObj': returnObj, 'index': index };
    },
        extractDataFromTable = function (tbl, opts) {

        if (typeof tbl === 'string') {
            tbl = doc.getElementById(tbl);
        }

        if (typeof win.jQuery !== 'undefined' && tbl instanceof win.jQuery) {
            // jshint ignore: line
            tbl = tbl.get(0);
        }

        if (!tbl) {
            return { data: null };
        }

        if (opts.hideTable) {
            tbl.style.display = 'none';
        }

        var i,
            j,
            rowCells,
            cellText,
            dataMap = {},
            mapColumnIdx,
            columnSpan,
            len,
            item,
            rowSpan,
            cellEle,
            columnSpanObj = {},
            rowSpanObj = {},
            tableRows = sanitizeNodesArray(getThead(tbl)).concat(sanitizeNodesArray(getTbody(tbl).childNodes)),
            l = tableRows.length,
            dataRows = 0,
            dataColumns = 0,
            tempColumn = 0,
            rowLabelMap,
            m,
            k = 0,
            columnLabelMap,
            isSingleSeries = false,
            chartType = opts.chartType,
            tempMap,
            singleSeriesCharts = ['column2d', 'column3d', 'pie3d', 'pie2d', 'line', 'bar2d', 'area2d', 'doughnut2d', 'doughnut3d', 'pareto2d', 'pareto3d'];

        if (singleSeriesCharts.indexOf(chartType) !== -1) {
            isSingleSeries = true;
        }

        // use rowLabelSource and colLabelSource to avoid confusion
        opts.rowLabelSource = parseInt(opts.labelSource, 10);
        opts.colLabelSource = parseInt(opts.legendSource, 10);
        // Create the labels objects for the chart.

        if (opts.major === 'column') {
            rowLabelMap = opts.useLabels ? getLabels(tableRows, opts.ignoreCols, opts.rowLabelSource) : getLabels(tableRows, opts.ignoreCols);

            columnLabelMap = opts.useLegend ? getLabels(getColumnArr(tableRows), opts.ignoreRows, opts.colLabelSource) : getLabels(getColumnArr(tableRows), opts.ignoreRows);
        } else {
            tempMap = getLabels(getColumnArr(tableRows), opts.ignoreRows, opts.rowLabelSource);
            if (!opts.useLabels) {
                rowLabelMap = getLabels(getColumnArr(tableRows), opts.ignoreRows);
            } else {
                rowLabelMap = tempMap;
            }

            opts._rowLabelIndex = tempMap.index;
            opts._extractByHeaderTag = true;

            columnLabelMap = opts.useLegend ? getLabels(tableRows, opts.ignoreCols, opts.colLabelSource, opts) : getLabels(tableRows, opts.ignoreCols);

            delete opts._extractByHeaderTag;

            tempMap = rowLabelMap;
            rowLabelMap = columnLabelMap;
            columnLabelMap = tempMap;
        }

        delete rowLabelMap.labelObj[columnLabelMap.index];
        delete columnLabelMap.labelObj[rowLabelMap.index];

        // Creating the 2d map depending on whether the rows are the primary
        // keys or the columns.
        if (opts.major === 'row') {
            for (item in columnLabelMap.labelObj) {
                dataMap[item] = {};
            }
        } else {
            for (item in rowLabelMap.labelObj) {
                dataMap[item] = {};
            }
        }

        // Populating the dataMap.
        for (i = 0; i < l; i += 1) {
            if (rowLabelMap.index === i || columnLabelMap.labelObj[i] === undefined) {
                continue;
            }

            dataRows += 1;
            rowCells = sanitizeNodesArray(tableRows[i].childNodes);

            // columnSpanObj maintains the number of colspans in the current
            // row.
            // rowSpanObj maintains the number of rowspans in a rows x columns
            // map.
            columnSpanObj[i] = 0;
            rowSpanObj[i] = {};

            for (j = 0, len = rowCells.length; j < len; j += 1) {

                cellEle = rowCells[j];

                columnSpan = parseInt(cellEle.getAttribute('colspan'), 10);
                rowSpan = parseInt(cellEle.getAttribute('rowspan'), 10);

                mapColumnIdx = j + columnSpanObj[i];

                // Calculating the position of the current cell in the dataMap.
                while (k < i) {
                    if (rowSpanObj[k]) {
                        for (m in rowSpanObj[k]) {
                            if (m > mapColumnIdx) {
                                break;
                            }

                            if (i - k <= rowSpanObj[k][m].row) {
                                mapColumnIdx += rowSpanObj[k][m].col;
                            }
                        }
                    }
                    k += 1;
                }

                if (columnSpan > 1) {
                    columnSpanObj[i] += columnSpan - 1;
                }

                if (rowSpan > 1) {
                    if (columnSpan > 1) {
                        rowSpanObj[i][mapColumnIdx] = {
                            row: rowSpan - 1,
                            col: columnSpan
                        };
                    } else {
                        rowSpanObj[i][mapColumnIdx] = {
                            row: rowSpan - 1,
                            col: 1
                        };
                    }
                }
                if (columnLabelMap.index === mapColumnIdx || rowLabelMap.labelObj[mapColumnIdx] === undefined) {

                    continue;
                }

                tempColumn += 1;
                cellText = getTextFromNode(cellEle);
                // If the cell does not have any text then we covert it by
                // default to 0 or to an parameterized option set by user.
                if (cellText.replace(/^\s*/, '').replace(/\s*$/, '') === '') {
                    if (opts.convertBlankTo) {
                        cellText = opts.convertBlankTo;
                    } else {
                        continue;
                    }
                }

                // Filling up the dataMap based on the rowspan, colspan and
                // position(row=i, column=mapColumnIdx) information of the
                // table cell.
                columnSpan = columnSpan > 1 ? columnSpan : 1;
                rowSpan = rowSpan > 1 ? rowSpan : 1;

                if (opts.major === 'row') {
                    k = 0;
                    while (k < columnSpan) {
                        m = 0;
                        while (m < rowSpan) {
                            dataMap[i + m][mapColumnIdx + k] = parseFloat(cellText);
                            m += 1;
                        }
                        k += 1;
                    }
                } else {
                    k = 0;
                    while (k < columnSpan) {
                        m = 0;
                        while (m < rowSpan) {
                            dataMap[mapColumnIdx + k][i + m] = parseFloat(cellText);
                            m += 1;
                        }
                        k += 1;
                    }
                }
            }
            if (tempColumn > dataColumns) {
                dataColumns = tempColumn;
            }
        }

        return {
            data: dataMap,
            chartType: chartType ? !isSingleSeries ? 'multi' : 'single' : dataRows > 1 && dataColumns > 1 ? 'multi' : 'single',
            labelMap: columnLabelMap,
            legendMap: rowLabelMap
        };
    },
        createChartFromTable = function (data, obj, config) {

        // Default configuration for HTMLTable data-handler
        var opts = {
            chartAttributes: {},
            major: 'row',
            useLabels: true,
            useLegend: true,
            labelSource: 0,
            legendSource: 0,
            ignoreCols: [],
            ignoreRows: [],
            showLabels: true,
            showLegend: true,
            seriesColors: [],
            convertBlankTo: '0',
            hideTable: false,
            chartType: obj.chartType && obj.chartType(),

            // Private Variables
            labels: [],
            legend: [],
            data: []
        },
            i,
            item1,
            item2,
            categoryArr,
            datasetArr,
            chartJSON = {},
            datasets = {},
            dataObj,
            dataMap,
            labelMap,
            legendMap;

        global.extend(opts, config);

        dataObj = extractDataFromTable(data, opts);
        dataMap = dataObj.data;

        if (opts.major !== 'row') {
            labelMap = dataObj.legendMap, legendMap = dataObj.labelMap;
        } else {
            labelMap = dataObj.labelMap, legendMap = dataObj.legendMap;
        }

        // chartAttributes should contain the configuration attributes for the chart
        // e.g caption, xAxisName, yAxisName etc.
        chartJSON.chart = global.extend({}, opts.chartAttributes);

        if (dataObj.chartType === 'multi') {
            chartJSON.categories = [{ 'category': [] }];
            chartJSON.dataset = [];

            categoryArr = chartJSON.categories[0].category;
            datasetArr = chartJSON.dataset;

            i = 0;
            for (item1 in dataMap) {

                if (opts.showLabels === true) {
                    // If the user has provided custom labels then those should be
                    // shown instead of the extracted labels.
                    categoryArr.push(global.extend({
                        label: labelMap.labelObj[item1].indexOf(_blankString) != -1 ? '' : labelMap.labelObj[item1]
                    }, opts.labels[i]));
                } else {
                    categoryArr.push({ 'label': '' });
                }
                i += 1;
                for (item2 in dataMap[item1]) {
                    if (typeof datasets[item2] === 'undefined') {
                        datasets[item2] = [];
                    }
                    datasets[item2].push({ 'value': dataMap[item1][item2] });
                }
            }

            i = 0;
            for (item1 in datasets) {
                if (opts.showLegend === true) {
                    // If the user has provided custom labels then those should be
                    // shown instead of the extracted labels.
                    datasetArr.push(global.extend({
                        'seriesname': legendMap.labelObj[item1].indexOf(_blankString) !== -1 ? '' : legendMap.labelObj[item1],
                        'data': datasets[item1]
                    }, opts.legend[i]));
                } else {
                    datasetArr.push({
                        'seriesname': '',
                        'data': datasets[item1]
                    });
                }
                i += 1;
            }
        } else if (dataObj.chartType === 'single') {
            chartJSON.data = [];
            datasetArr = chartJSON.data;

            i = 0;
            if (opts.showLabels) {
                for (item1 in dataMap) {
                    for (item2 in dataMap[item1]) {
                        datasetArr.push(global.extend({
                            label: labelMap.labelObj[item1].indexOf(_blankString) !== -1 ? '' : labelMap.labelObj[item1],
                            value: dataMap[item1][item2]
                        }, opts.labels[i]));

                        i += 1;
                    }
                }
            } else {
                for (item1 in dataMap) {
                    for (item2 in dataMap[item1]) {
                        datasetArr.push({ 'value': dataMap[item1][item2] });
                    }
                }
            }
        }

        return {
            data: global.core.transcodeData(chartJSON, 'JSON', 'XML'),
            error: undefined
        };
    };

    global.addDataHandler('HTMLTable', {
        encode: function (data, obj, config) {
            return createChartFromTable(data, obj, config);
        },
        decode: function (data, obj) {
            /**
             * @private
             *
             * @typedef {RuntimeException} Error-07101734
             * @memberOf FusionCharts.debugger
             * @group debugger-error
             */
            global.raiseError(obj, '07101734', 'run', '::HTMLTableDataHandler.decode()', 'FusionCharts HTMLTable data-handler only supports decoding of data.');
            throw new Error('FeatureNotSupportedException()');
        },
        transportable: false
    });
}]);

module.exports = FusionCharts;

},{"fusioncharts":4}],3:[function(require,module,exports){
/*
 FusionCharts JavaScript Library
 Copyright FusionCharts Technologies LLP
 License Information at <http://www.fusioncharts.com/license>
*/
(function(la){"object"===typeof module&&"undefined"!==typeof module.exports?module.exports=la:la(FusionCharts)})(function(la){la.register("module",["private","modules.renderer.js-charts",function(){function Aa(d,L){for(var g=[],a=0,l=d.length;a<l;a++)g[a]=L.call(d[a],d[a],a,d);return g}function fa(d,L){var g=L?360:q;d=(d||0)%g;return 0>d?g+d:d}function Ka(d,L,g,a,l){return La((L-g[1]-a.top)/l,d-g[0]-a.left)}function oa(d){this.config={};this.linkedItems={chart:d}}var ha=this,R=ha.hcLib,Ma=R.hasTouch,
Da=ha.window,ma=Da.document,ua=R.Raphael,Na=R.getPosition,sa=R.BLANKSTRING,G=R.preDefStr,Ua=G.HUNDREDSTRING,G=G.NINETYSTRING,na=R.pluck,ia=R.pluckNumber,Va=R.getFirstValue,Za=R.extend2,U=R.toRaphaelColor,qa=R.hasSVG,Oa=R.hashify,$a="createTouch"in ma,fb=$a&&!(Da.navigator.maxTouchPoints||Da.navigator.msMaxTouchPoints),Ga=R.each,Fa=R.plotEventHandler,wa=R.componentDispose,Ea=8===Da.document.documentMode?"visible":"",xa=Math,va=xa.sin,pa=xa.cos,La=xa.atan2,ra=xa.round,za=xa.min,Ba=xa.max,Ha=xa.abs,
ta=xa.PI,a=xa.ceil,b=xa.floor,c=ta/180,h=180/ta,m=Math.PI,f=m/2,q=2*m,v=m+f,A=R.getFirstColor,n=R.getFirstAlpha,C=R.graphics.getDarkColor,p=R.graphics.getLightColor,I=R.graphics.convertColor,K=R.POSITION_BOTTOM,B=R.POSITION_RIGHT,k=R.chartAPI,x=R.COMMASTRING,aa=R.ZEROSTRING,N=R.ONESTRING,D=!R.CREDIT_REGEX.test(Da.location.hostname),Z={},X={};k("column2d",{standaloneInit:!0,friendlyName:"Column Chart",creditLabel:D,defaultDatasetType:"column",applicableDSList:{column:!0},singleseries:!0},k.sscartesian);
k("column3d",{friendlyName:"3D Column Chart",defaultDatasetType:"column3d",applicableDSList:{column3d:!0},defaultPlotShadow:1,creditLabel:D,is3D:!0,standaloneInit:!0,hasLegend:!1,singleseries:!0,fireGroupEvent:!0,defaultZeroPlaneHighlighted:!1},k.sscartesian3d,{showplotborder:0});k("bar2d",{friendlyName:"Bar Chart",isBar:!0,standaloneInit:!0,defaultDatasetType:"bar2d",creditLabel:D,applicableDSList:{bar2d:!0},singleseries:!0,spaceManager:k.barbase},k.ssbarcartesian);k("bar3d",{friendlyName:"3D Bar Chart",
defaultDatasetType:"bar3d",applicableDSList:{bar3d:!0},defaultPlotShadow:1,fireGroupEvent:!0,standaloneInit:!0,creditLabel:D,is3D:!0,isBar:!0,singleseries:!0,defaultZeroPlaneHighlighted:!1},k.ssbarcartesian3d,{showplotborder:0});k("area2d",{friendlyName:"Area Chart",standaloneInit:!0,creditLabel:D,defaultDatasetType:"area",singleseries:!0,defaultPlotShadow:0},k.sscartesian,{},k.areabase);k("line",{friendlyName:"Line Chart",standaloneInit:!0,creditLabel:D,defaultPlotShadow:1,singleseries:!0,axisPaddingLeft:0,
axisPaddingRight:0,defaultDatasetType:"line"},k.sscartesian,{zeroplanethickness:1,zeroplanealpha:40,showzeroplaneontop:0},k.areabase);k("pareto2d",{defaultDatasetType:"column2d",singleseries:!0,creditLabel:D,_createDatasets:function(){var d=this.components,L=this.jsonData,g=this.is3D,a=d.numberFormatter,l=L.data||L.dataset&&L.dataset[0]&&L.dataset[0].data,e=l&&l.length,b=L.chart,c=this.defaultDatasetType,L=new (la.get("component",["dataset","Pareto"])),r=ia(b.showcumulativeline,1),w=[],u,F;if(l){for(b=
0;b<e;b++)u=l[b],F=a.getCleanValue(u.value),null!==F&&"true"!==u.vline&&!0!==u.vline&&1!==u.vline&&"1"!==u.vline&&w.push(u);this.config.categories=w;a=d.dataset||(d.dataset=[]);(l=na(c))&&l.toLowerCase();l=la.register("component",["datasetGroup","column"]);l=d[void 0]=new l;l.chart=this;l.init();if(e=g?la.get("component",["dataset","Column3d"]):la.get("component",["dataset","Column"]))(g=a[0])?(c=w.length,l=g.components.data.length,c<l&&g.removeData(c,l-c),g.JSONData={data:w},L.configure.call(g)):
(g=new e,a.push(g),g.chart=this,g.index=b,l&&l.addDataSet(g,0,0),L.init(g,w,c));d=d.yAxis[1];if(r)d&&d.setAxisConfig({drawLabels:!0,drawPlotLines:!0,drawAxisName:!0,drawAxisLine:!0,drawPlotBands:!0,drawTrendLines:!0,drawTrendLabels:!0}),d.show(),e=la.get("component",["dataset","line"]),(g=a[1])?(c=w.length,l=g.components.data.length,c<l&&g.removeData(c,l-c),g.JSONData={data:w},L.configure.call(g)):(g=new e,a.push(g),g.chart=this,g.index=b,L.init(g,w,"line"));else{if(g=a[1])wa.call(g),a.pop();d&&(d.setAxisConfig({drawLabels:!1,
drawPlotLines:!1,drawAxisName:!1,drawAxisLine:!1,drawPlotBands:!1,drawTrendLines:!1,drawTrendLabels:!1}),d.hide())}}else this.setChartMessage()},_setCategories:function(){var d=this.components,L=this.jsonData,g=L.dataset,a=d.numberFormatter,d=d.xAxis,L=L.data||g&&g[0].data||[],g=[],l,e=L.length,b,c={},r=0,w;for(b=0;b<e;b++){l=L[b];w=a.getCleanValue(l.value,!0);if("true"===l.vline||"1"===l.vline||1===l.vline||!0===l.vline)c[r]=l;else if(null===w)continue;else l.value=w,g.push(l);r++}g.sort(function(d,
g){return g.value-d.value});for(b in c)g.splice(b,0,c[b]);d[0].setCategory(g)},standaloneInit:!0,hasLegend:!1,isPercentage:!0},k.msdybasecartesian,{plotfillalpha:G});k("pareto3d",{standaloneInit:!0,is3D:!0,friendlyName:"3D Pareto Chart",creditLabel:D,fireGroupEvent:!0,defaultPlotShadow:1,singleseries:!0,hasLegend:!1,defaultDatasetType:"column3d",_createDatasets:k.pareto2d,_setCategories:k.pareto2d,isPercentage:!0},k.msdybasecartesian3d,{plotfillalpha:G,use3dlineshift:1});k("pie2d",{friendlyName:"Pie Chart",
standaloneInit:!0,defaultSeriesType:"pie",defaultPlotShadow:1,reverseLegend:1,alignCaptionWithCanvas:0,sliceOnLegendClick:!0,isSingleSeries:!0,dontShowLegendByDefault:!0,defaultDatasetType:"Pie2D",applicableDSList:{Pie2D:!0},defaultZeroPlaneHighlighted:!1,creditLabel:D,_plotDragMove:function(d,L,g,a,l){var e=this.data("plotItem"),b=e.chart,e=e.seriesData,c=b.components.dataset[0].config;isNaN(d)||isNaN(L)||!c.enableRotation||e.singletonCase||e.isRightClicked||(d=Ka.call(l,g,a,e.pieCenter,e.chartPosition,
1),e.isRotating||(e.dragStartAngle!==d&&(e.isRotating=!0),ha.raiseEvent("RotationStart",{startingAngle:e._rotationalStartAngle=b._startingAngle()},b.chartInstance)),c.startAngle+=d-e.dragStartAngle,e.dragStartAngle=d,e.moveDuration=0,c.updateInited||(c.updateInited=!0,setTimeout(b._batchRotate||(b._batchRotate=function(){b._rotate();c.updateInited=!1}),50)))},_plotDragStart:function(d,L,g){var a=this.data("plotItem"),l=a.chart,a=a.seriesData,e=l.components.dataset[0].config,b=-e.startAngle;a.isRightClicked=
Ma||0===g.button||1===g.button?!1:!0;if(e.enableRotation&&!a.isRightClicked){a.isRotating=!1;e=l.linkedItems.container;l={left:0,top:0};if(e.getBoundingClientRect)e=e.getBoundingClientRect(),l.top=e.top+(Da.pageYOffset||ma.scrollTop||0)-(ma.clientTop||0),l.left=e.left+(Da.pageXOffset||ma.scrollLeft||0)-(ma.clientLeft||0);else for(;e;)l.left+=e.offsetLeft||0,l.top+=e.offsetTop||0,e!==ma.body&&e!==ma.documentElement&&(l.left-=e.scrollLeft||0,l.top-=e.scrollTop||0),e=e.offsetParent;a.chartPosition=l;
d=Ka.call(g,d,L,a.pieCenter,a.chartPosition,1);a.dragStartAngle=d;a.startingAngleOnDragStart=b}},_plotDragEnd:function(d){var L,g=this.data("plotItem"),a=g.chart,l=a.config,e=g.seriesData;e.isRightClicked||(l.clicked=!0,a.disposed||a._rotate(),!e.isRotating&&a._plotGraphicClick.call(g.graphic,d),delete l.clicked,e.isRotating&&(setTimeout(function(){e.isRotating=!1},0),ha.raiseEvent("RotationEnd",{startingAngle:L=a._startingAngle(),changeInAngle:L-e._rotationalStartAngle},a.chartInstance)))},_plotRollOver:function(d){var L=
this.plotItem||this.data("plotItem"),g=L.chart,a=g.components.dataset[0].config,l,e;a.isRotating||(Fa.call(this,g,d,"DataPlotRollOver"),g.onPlotHover(this,!0));a.isHovered=!0;(d=L.innerDiameter)&&(l=L.centerLabelConfig)&&(e=l.label)&&g.drawDoughnutCenterLabel(e,L.center[0],L.center[1],d,d,l,!1)},onPlotHover:function(d,L){var g=d.data("plotItem"),a=g.center,l=g.rolloverProperties||{},e=L?l.color:g.color,b=L?l.borderWidth:g.borderWidth,c=L?l.borderColor:g.borderColor;e&&(L&&(e.cx=a[0],e.cy=a[1],e.r=
g.radius),l.enabled&&g.graphic.attr({fill:U(e),"stroke-width":b,stroke:c}))},_plotRollOut:function(d){var L=this.plotItem||this.data("plotItem"),g=L.chart,a=g.components.dataset[0].config,l,e;a.isRotating||(Fa.call(this,g,d,"DataPlotRollOut"),g.onPlotHover(this,!1));a.isHovered=!1;(d=L.innerDiameter)&&(l=a.centerLabelConfig)&&((e=l.label)||!e)&&g.drawDoughnutCenterLabel(e,L.center[0],L.center[1],d,d,l,!1)},_rotate:function(){var d,L,g=this.components.dataset[0],a=g.config,l=g.components.data,e=this.config,
b=a.slicingDistance,g=g.config,c=q/g.valueTotal,r=e.canvasLeft+.5*e.canvasWidth,e=e.canvasTop+.5*e.canvasHeight,w=a.pieMinRadius,u=.5*(a.piePlotOptions.innerSize||0),F,t,f,h,m;F=(a.startAngle||0)%q;for(m=0;m<l.length;m+=1)f=l[m].config,h=l[m].graphics,d=f.y,null!==d&&void 0!==d&&(t=F,F-=g.singletonCase?q:d*c,d=.5*(F+t),f.angle=d,f.transX=pa(d)*b,f.transY=va(d)*b,f.slicedTranslation="t"+pa(d)*b+x+va(d)*b,(L=f._rotateAttrs)||(L=f._rotateAttrs={ringpath:[],transform:sa}),d=L.ringpath,d[0]=r,d[1]=e,d[2]=
w,d[3]=u,d[4]=F,d[5]=t,L.transform=f.sliced?f.slicedTranslation:sa,h.element.attr(L));this.placeDataLabels(!0,l,a)},getPlotData:function(d,L){var g=this.components.dataset[0],a=g.components.data[d].config,g=g.config.userData||(g.config.userData=[]),l,e;if(g[d])g=g[d];else{g=g[d]={};for(e in a)"object"!==typeof(l=a[e])&&"function"!==typeof l&&0!==e.indexOf("_")&&(g[e]=l);g.value=g.y;g.categoryLabel=g.label=g.seriesName;delete g.y;delete g.total;delete g.doNotSlice;delete g.name;delete g.seriesName;
delete g.centerAngle;delete g.showInLegend;delete g.angle;delete g.endAngle;delete g.isVisible;delete g.setColor;delete g.slicedTranslation;delete g.startAngle;delete g.transX;delete g.transY;delete g.pValue}g.sliced=L;return g},_plotGraphicClick:function(d){var L,g=this.element||this,a=g.plotItem||g.data("plotItem"),l=g.data("eventArgs")||{},e=a.chart,b=a.index,c=e.components.dataset[0],r=c.config,w=r.enableMultiSlicing,c=c.components.data[b],u=c.graphics,c=c.config,f=c.doNotSlice,t;L=c.slicedTranslation;
var m=e.get("config","animationObj"),h=m.duration||200,k=m.dummyObj,q=m.animObj,m=m.animType;!r.isRotating&&Fa.call(g,e,d);if(!(r.isRotating||r.singletonCase||f||(d=!w&&e.sliceInOtherPies(b),(t=c.sliced)&&d))){if($a&&!fb){d=(new Date).getTime();if(a.lastSliceTimeStamp&&400>d-a.lastSliceTimeStamp)return;a.lastSliceTimeStamp=d}r=u.element;a=u.connector;w=u.label||u.dataLabel;L="object"===typeof L?"t"+L:L;f=c.connectorPath;u=(t?-1:1)*c.transX;d=(t?-1:1)*c.transY;g=r.data("eventArgs")||r.data("eventArgs",
{});ha.raiseEvent("slicingStart",{slicedState:t,dataIndex:"index"in l&&l.index,data:e.getPlotData(b,t)},e.chartInstance);r.animateWith(k,q,{transform:t?"t0,0":L},h,m,function(){ha.raiseEvent("slicingEnd",{slicedState:t,dataIndex:"index"in l&&l.index,data:e.getPlotData(b,t)},e.chartInstance)});w&&w.x&&((L=w.data("textPos"))||(L=w.data("textPos",{x:w.x,y:w.y})),w.animateWith(k,q,{x:w.x+(t?0:u)},h,m),L.x=w.x+(t?0:u));f&&(L=f.slice(0),L[1]+=u,L[2]+=d,L[4]+=u,L[6]+=u,a.animateWith(k,q,{path:L},h,m),c.connectorPath=
L);return g.isSliced=t=c.sliced=!t}},sliceInOtherPies:function(d){var L=this.components.dataset[0],g=L.components.data,a=g.length,l=0,e;for(L.enableMultiSlicing=!0;a--;)a!==d&&(e=g[a]).config.sliced&&++l&&this._plotGraphicClick.call(e.graphics);L.enableMultiSlicing=!1;return!!l},placeDataLabels:function(){var d=function(d,g){return d.point.value-g.point.value},L=function(d,g){return d.angle-g.angle},g=["start","start","end","end"],c=[-1,1,1,-1],l=[1,1,-1,-1];return function(e,ba,h,r){var w=this.config,
u=this.components,F=u.dataset[0],t=F.graphics,k=F.config,p=w.canvasLeft,C=w.canvasTop,F=w.canvasWidth,n=p+.5*w.canvasWidth,A=C+.5*w.canvasHeight,Ja=this.linkedItems.smartLabel,B=k.dataLabelOptions,ab=B.style,P=ia(a(parseFloat(ab.lineHeight)),12),D=1===ba.length?w.singletonPlaceValue:!1,x=B.skipOverlapLabels,I=B.manageLabelOverflow,K=B.connectorPadding,J;J=r&&r.metrics||[n,A,2*k.pieMinRadius,k.innerSize||0];var y=J[1],z=J[0];r=.5*J[2];var k=[[],[],[],[]],n=h.labelsRadius=r+B.distance,H=A=parseInt(ab.fontSize,
10),S=H/2,K=[K,K,-K,-K];h=h.labelsMaxInQuadrant=b(n/H);var B=B.isSmartLineSlanted,O=J[3]/2,W,E,T,Q,Ra,Ia,ga,aa,G,ja,M,ea,V,ka,X;J=Number.POSITIVE_INFINITY;var da,Z;E=[];T=[];E=this.get("config","animationObj");var N=e?0:E.duration||0,U=E.dummyObj,fa=E.animObj,R=E.animType,ha=this._plotDragMove,ma=this._plotDragStart,sa=this._plotDragEnd,qa=this._plotRollOver,ya=this._plotRollOut,la=u.paper,Y=t.dataLabelContainer,ca,oa;Ja.useEllipsesOnOverflow(w.useEllipsesWhenOverflow);e||Ja.setStyle(ab);if(1==ba.length&&
!O&&D)E=ba[0],(ca=E.config._textAttrs).text&&(Z=E.graphics,da=E.config,M=Z.label,E.slicedTranslation=[p,C],ca["text-anchor"]="middle",ca.x=0,ca.y=0,ca.transform=["t",z,y],M?M.animateWith(U,fa,ca,N,R):M=Z.label=la.text(ca,oa,Y).drag(ha,ma,sa).hover(qa,ya),M.x=z,M.data("textPos",{x:z,y:y}).data("plotItem",ca.plotItem).data("eventArgs",ca.eventArgs),null!==da.y&&void 0!==da.y&&M.show(),Z.connector&&Z.connector.attr({path:[]}));else if(D)X=O+(r-O)/2,Ga(ba,function(d){da=d.config;(ca=da._textAttrs).text&&
(Z=d.graphics,M=Z.label,null!==da.y&&void 0!==da.y&&((ja=Z.connector)&&ja.show(),M&&M.show()),ca.transform="t0,0",G=da.angle,aa=y+X*va(G),Q=z+X*pa(G),ca._x=Q,ca._y=aa,d.sliced&&(ka=d.slicedTranslation,ea=ka[0]-p,V=ka[1]-C,Q+=ea,aa+=V),ca["text-anchor"]="middle",ca.x=0,ca.y=0,ca.transform=["t",Q,aa],M?M.animateWith(U,fa,ca,N,R):M=Z.label=la.text(ca,oa,Y).drag(ha,ma,sa).hover(qa,ya),M.x=ca._x,M.x=ca._x,M.y=ca._y,M.data("plotItem",ca.plotItem).data("eventArgs",ca.eventArgs),ca.visibility===Ea&&M.show())});
else{for(e=ba.length-1;0<=e;e--)if(E=ba[e],da=E.config,ca=da._textAttrs,ca.text=da.displayValue)Z=E.graphics,null!==da.y&&void 0!==da.y&&(M=Z.label,(ja=Z.connector)&&ja.show(),M&&M.show()),ca.text=da.displayValue,ca.transform="t0,0",G=da.angle%q,0>G&&(G=q+G),u=0<=G&&G<f?1:G<m?2:G<v?3:0,k[u].push({point:E,angle:G});for(e=ba=4;e--;){if(x&&(u=k[e].length-h,0<u))for(k[e].sort(d),t=k[e].splice(0,u),u=0,D=t.length;u<D;u+=1)E=t[u].point,ca=E.config._textAttrs,Z=E.graphics,Z.label&&Z.label.attr("visibility",
"hidden"),Z.connector&&Z.connector.attr({visibility:"hidden"});k[e].sort(L)}e=Ba(k[0].length,k[1].length,k[2].length,k[3].length);u=Ba(za(e,h)*H,n+H);T=k[0].concat(k[1]);E=k[2].concat(k[3]);for(e=T.length-1;0<=e;e--)t=T[e].point.config,delete t.clearance,delete t.clearanceShift,O=Ha(u*va(t.angle)),Math.abs(J-O)<2*P&&(t.clearance=0,T[e+1].point.clearanceShift=P/2),J=O;J=Number.POSITIVE_INFINITY;e=0;for(D=E.length;e<D;e++)t=E[e].point.config,delete t.clearance,delete t.clearanceShift,O=Ha(u*va(t.angle)),
Math.abs(J-O)<2*P&&(t.clearance=0,E[e-1].point.clearanceShift=P/2),J=O;k[1].reverse();for(k[3].reverse();ba--;){t=k[ba];D=t.length;x||(H=D>h?u/D:A,S=H/2);P=D*H;J=u;for(e=0;e<D;e+=1,P-=H)O=Ha(u*va(t[e].angle)),J<O?O=J:O<P&&(O=P),J=(t[e].oriY=O)-H;ab=g[ba];D=u-(D-1)*H;J=0;for(e=t.length-1;0<=e;--e,D+=H)if(E=t[e].point,G=t[e].angle,da=E.config,ca=da._textAttrs,ca.text&&(oa=da._textCss,Z=E.graphics,E=da.sliced,M=Z.label,O=Ha(u*va(G)),O<J?O=J:O>D&&(O=D),J=O+H,P=void 0===da.clearance?2*a(ia(parseFloat(da.style.border),
12),12):2*a(ia(parseFloat(da.style.border),da.clearance)),Ia=(O+t[e].oriY)/2,O=z+l[ba]*n*pa(xa.asin(Ia/u)),Ia*=c[ba],Ia+=y,ga=y+r*va(G),T=z+r*pa(G),(2>ba&&O<T||1<ba&&O>T)&&(O=T),Q=O+K[ba],aa=Ia-S-2,Ra=Q+K[ba],ca._x=Ra,I&&(W=1<ba?Ra-w.canvasLeft:w.canvasLeft+F-Ra,Ja.setStyle(da.style),P=ia(a(parseFloat(da.style.lineHeight)),12)+P,P=Ja.getSmartText(da.displayValue,W,P),void 0===da.clearance&&P.height>H&&(Ia+=H),ca.text=P.text,ca.tooltip=P.tooltext),ca._y=aa,E&&(ea=da.transX,V=da.transY,Q+=ea,O+=ea,
T+=ea,ga+=V,Ra+=ea),ca["text-anchor"]=ab,ca.vAlign="middle",ca.x=Ra,ca.y=Ia,(P=M&&M.data("textPos"))?M.attr({x:P.x,y:P.y}).animateWith(U,fa,ca,N):M=Z.label=la.text(ca,oa,Y).drag(ha,ma,sa).hover(qa,ya),M.x=ca._x,M._x=ca._x,M.y=ca._y,ca.tooltip&&(M.tooltip(ca.tooltip),delete ca.tooltip),ca.visibility===Ea&&M.show(),M.data("textPos",{x:Ra,y:Ia}).data("plotItem",ca.plotItem).data("eventArgs",ca.eventArgs),ja=Z.connector))da.connectorPath=P=["M",T,ga,"L",B?O:T,Ia,Q,Ia],(E=ja.data("connectorPath"))?w.clicked||
ja.attr({path:E.path}).animateWith(U,fa,{path:P},N):ja.attr({path:P}),ja.data("connectorPath",{path:P})}}}}(),_spaceManager:function(){var d=this.config,a=this.components,g=a.dataset[0],b=g.components.data,l=g.config,e=a.legend,c=a.colorManager,f=this.linkedItems.smartLabel,r=l.dataLabelCounter,w=0,u=this.jsonData.chart,a=ia(u.managelabeloverflow,0),F=ia(u.slicingdistance),t=l.preSliced||d.allPlotSliceEnabled!==aa||u.showlegend===N&&u.interactivelegend!==aa?Ha(ia(F,20)):0,k=ia(u.pieradius,0),m=(F=
ia(u.enablesmartlabels,u.enablesmartlabel,1))?ia(u.skipoverlaplabels,u.skipoverlaplabel,1):0,h=ia(u.issmartlineslanted,1),q=r?ia(u.labeldistance,u.nametbdistance,5):t,p=ia(u.smartlabelclearance,5),v=d.width,C=d.height,D=(this._manageActionBarSpace(.225*C)||{}).bottom,v=v-(d.marginRight+d.marginLeft),C=C-(d.marginTop+d.marginBottom)-(D?D+d.marginBottom:0),D=za(C,v),P=na(u.smartlinecolor,c.getColor("plotFillColor")),n=ia(u.smartlinealpha,100),A=ia(u.smartlinethickness,.7),g=l.dataLabelOptions=g._parseDataLabelOptions(),
c=g.style,c=r?ia(parseInt(c.lineHeight,10),12):0,x=0===k?.15*D:k,G=2*x,J={bottom:0,right:0},y=l.pieYScale,D=l.pieSliceDepth;g.connectorWidth=A;g.connectorPadding=ia(u.connectorpadding,5);g.connectorColor=I(P,n);r&&(F&&(q=p),q+=t);p=G+2*(c+q);p=this._manageChartMenuBar(p<C?C-p:C/2);C-=(p.top||0)+(p.bottom||0);l.showLegend&&(this.hasLegend=!0,na(u.legendposition,K).toLowerCase()!==B?(J=e._manageLegendPosition(C/2),C-=J.bottom):(J=e._manageLegendPosition(C/2),v-=J.right));this._allocateSpace(J);f.useEllipsesOnOverflow(d.useEllipsesWhenOverflow);
if(1!==r)for(;r--;)f.setStyle(b[r].config.style||d.dataLabelStyle),e=f.getOriSize(b[r].config.displayValue),w=Ba(w,e.width);0===k?x=this._stubRadius(v,w,C,q,t,c,x):(l.slicingDistance=t,l.pieMinRadius=x,g.distance=q);d=C-2*(x*y+c);l.managedPieSliceDepth=D>d?D-d:l.pieSliceDepth;g.isSmartLineSlanted=h;g.enableSmartLabels=F;g.skipOverlapLabels=m;g.manageLabelOverflow=a},_stubRadius:function(d,a,g,b,l,e,c){var f=this.components.dataset[0],r=f.config,w=ia(this.jsonData.chart.slicingdistance),f=r.dataLabelOptions||
(r.dataLabelOptions=f._parseDataLabelOptions()),u=0,u=za(d/2-a-l,g/2-e)-b;u>=c?c=u:w||(l=b=Ba(za(b-(c-u),l),10));r.slicingDistance=l;r.pieMinRadius=c;f.distance=b;return c},getDataSet:function(d){return this.components.dataset[d]},_startingAngle:function(d,a){var g,b=this.components.dataset[0].config,l=(g=b.startAngle)*-h+(0>-1*g?360:0);isNaN(d)||(b.singletonCase||b.isRotating?l=b.startAngle:(d+=a?l:0,b.startAngle=-d*c,this._rotate(d),l=d));return ra(100*((l%=360)+(0>l?360:0)))/100},eiMethods:{isPlotItemSliced:function(d){var a,
g,b,l=this.apiInstance;return l&&l.components.dataset&&(b=l.components.dataset[0])&&(a=b.components.data)&&a.length&&a[d]&&(g=a[d].config)&&g.sliced},addData:function(){var d,a=this.apiInstance;return a&&a.components.dataset&&(d=a.components.dataset[0])&&d.addData.apply(d,arguments)},removeData:function(){var d,a=this.apiInstance;return a&&a.components.dataset&&(d=a.components.dataset[0])&&d.removeData.apply(d,arguments)},updateData:function(){var d,a=this.apiInstance;return a&&a.components.dataset&&
(d=a.components.dataset[0])&&d.updateData.apply(d,arguments)},slicePlotItem:function(d,a){var g,b,l,e,c=this.apiInstance;return c&&c.components.dataset&&(g=c.components.dataset[0])&&(b=g.components.data)&&(e=b.length)&&b[d=g.config.reversePlotOrder?e-d-1:d]&&(l=b[d].config)&&((!!a!==l.sliced||void 0===a)&&c._plotGraphicClick.call(b[d].graphics.element)||l.sliced)},centerLabel:function(d,a){var g=this.apiInstance,b=g.components.dataset[0],l=b.config,e=l.piePlotOptions.innerSize,c=l.pieCenter,f=c[0],
c=c[1],l=l.centerLabelConfig,r;if("object"!==typeof a)a=l;else for(r in l)void 0===a[r]&&(a[r]=l[r]);a.label=d;b.centerLabelConfig=a;e&&g.drawDoughnutCenterLabel(d||"",f,c,e,e,a,!0)},startingAngle:function(d,a){return this.apiInstance._startingAngle(d,a)}}},k.guageBase,{plotborderthickness:1,alphaanimation:0,singletonPlaceValue:!0,usedataplotcolorforlabels:0,enableslicing:N});k("pie3d",{defaultDatasetType:"Pie3D",applicableDSList:{Pie3D:!0},is3D:!0,friendlyName:"3D Pie Chart",fireGroupEvent:!0,creditLabel:D,
getPointColor:function(d){return d},_configureManager:function(){var d=this.components.dataset[0],a=d.config,g=d.components,d=g.Pie3DManager,g=g.data;d&&d.configure(a.pieSliceDepth,1===g.length,a.use3DLighting,!1)},defaultPlotShadow:0,_preDrawCalculate:function(){var d,a,g=this.config,c=0,l=this.components.dataset[0],e=l.config;d=l.components;a=e.dataLabelOptions;var f=e.pie3DOptions=l._parsePie3DOptions(),k=na(e.startAngle,0)%q,r=e.managedPieSliceDepth,w=e.slicedOffset=f.slicedOffset,u=g.canvasWidth,
F=g.canvasHeight,t=[g.canvasLeft+.5*u,g.canvasTop+.5*F-.5*r],m,h,g=d.data,p,v=za(u,F),C,Ja=a.distance;m=e.pieYScale;var D=e.slicedOffsetY||(e.slicedOffsetY=w*e.pieYScale);p=d.Pie3DManager;t.push(2*e.pieMinRadius,f.innerSize||0);t=Aa(t,function(d,a){return(C=/%$/.test(d))?[u,F-r,v,v][a]*parseInt(d,10)/100:d});t[2]/=2;t[3]/=2;t.push(t[2]*m);t.push((t[2]+t[3])/2);t.push(t[5]*m);l.getX=function(d,a){h=xa.asin((d-t[1])/(t[2]+Ja));return t[0]+(a?-1:1)*pa(h)*(t[2]+Ja)};e.center=t;Ga(g,function(d){c+=d.config.y});
e.labelsRadius=t[2]+Ja;e.labelsRadiusY=e.labelsRadius*m;e.quadrantHeight=(F-r)/2;e.quadrantWidth=u/2;l=ra(1E3*k)/1E3;f=l+q;k=ia(parseInt(a.style.fontSize,10),10)+4;e.maxLabels=b(e.quadrantHeight/k);e.labelFontSize=k;e.connectorPadding=ia(a.connectorPadding,5);e.isSmartLineSlanted=na(a.isSmartLineSlanted,!0);e.connectorWidth=ia(a.connectorWidth,1);e.enableSmartLabels=a.enableSmartLabels;p||(p=d.Pie3DManager=new oa(this),this.get("graphics","datasetGroup").trackTooltip(!0));this._configureManager();
for(d=g.length-1;0<=d;--d)a=g[d],a=a.config,k=l,p=c?a.y/c:0,l=ra(1E3*(l+p*q))/1E3,l>f&&(l=f),m=l,a.shapeArgs={start:ra(1E3*k)/1E3,end:ra(1E3*m)/1E3},a.centerAngle=h=(m+k)/2%q,a.slicedTranslation=[ra(pa(h)*w),ra(va(h)*D)],k=pa(h)*t[2],e.radiusY=m=va(h)*t[4],a.tooltipPos=[t[0]+.7*k,t[1]+m],a.percentage=100*p,a.total=c},placeDataLabels:function(){var d=function(d,a){return d.point.value-a.point.value},b=function(d,a){return d.angle-a.angle},g=["start","start","end","end"],c=[-1,1,1,-1],l=[1,1,-1,-1];
return function(e){var ba,k,r=this.config,w=this.components,u=w.dataset[0],F=u.config,t=u.components.data,h=F.piePlotOptions,p=r.canvasLeft,C=r.canvasTop,D=r.canvasWidth,n=p+.5*r.canvasWidth,Ja=C+.5*r.canvasHeight,B=this.linkedItems.smartLabel,A=F.dataLabelOptions,P=A.style;ba=ia(a(parseFloat(P.lineHeight)),12);ba=Va(A.placeInside,!1);var x=A.skipOverlapLabels,I=A.manageLabelOverflow,K=A.connectorPadding,G=A.distance,J=A.connectorWidth,y=[[],[],[],[]],z=parseInt(P.fontSize,10),H=z,S=H/2,K=[K,K,-K,
-K],O=A.isSmartLineSlanted,W,E,T,Q,Z,aa,ga,X,N,ja,M,ea,V,ka,U,G=0<G,da=F.center||(F.center=[n,Ja,h.size,h.innerSize||0]),fa=da[1],R=da[0],h=da[2],n=da[4],Ja=F.labelsRadius,ha=ra(100*F.labelsRadiusY)/100,ma=F.maxLabels,oa=F.enableSmartLabels,sa=F.pieSliceDepth/2;E=this.get("config","animationObj");var qa=e?0:E.duration,la=E.dummyObj,ua=E.animObj,ya=E.animType,ta,Y,ca=this._plotDragMove,wa=this._plotDragStart,na=this._plotDragEnd,Aa=this._plotRollOver,Fa=this._plotRollOut,Ca=w.paper,Da=u.graphics.dataLabelContainer;
B.useEllipsesOnOverflow(r.useEllipsesWhenOverflow);if(F.dataLabelCounter)if(e||B.setStyle(P),1==t.length)E=t[0],ka=E.graphics,V=E.config,Y=V._textAttrs,ta=V._textCss,M=ka.label,U=ka.connector,V.slicedTranslation=[p,C],null!==V.y&&void 0!==V.y&&(Y.visibility=Ea,Y["text-anchor"]="middle",Y.x=R,Y.y=fa+S-2,Y._x=R),M?M.animateWith(la,ua,Y,qa,ya):M=ka.label=Ca.text(Y,ta,Da).drag(ca,wa,na).hover(Aa,Fa),Y._x&&(M.x=Y._x,delete Y.x),M.data("plotItem",Y.plotItem).data("eventArgs",Y.eventArgs),Y.visibility===
Ea&&M.show(),U&&U.hide();else if(ba)Ga(t,function(d){ka=d.graphics;V=d.config;Y=V._textAttrs;M=ka.label;if(null!==V.y&&void 0!==V.y){ja=V.angle;N=fa+da[6]*va(ja)+S-2;Z=R+da[5]*pa(ja);Y._x=Z;Y._y=N;if(V.sliced){d=d.slicedTranslation;var a=d[1]-C;Z+=d[0]-p;N+=a}Y.visibility=Ea;Y.align="middle";Y.x=Z;Y.y=N}M?M.animateWith(la,ua,Y,qa,ya):M=ka.label=Ca.text(Y,ta,Da).drag(ca,wa,na).hover(Aa,Fa);M.data("plotItem",Y.plotItem).data("eventArgs",Y.eventArgs);Y.visibility===Ea&&M.show();M.x=Y._x;M._x=Y._x;M._y=
Y._y});else{Ga(t,function(d){ka=d.graphics;V=d.config;ta=V._textCss;Y=V._textAttrs;if(Y.text=V.displayValue)ka=d.graphics,null!==V.y&&void 0!==V.y&&(M=ka.label,(U=ka.connector)&&U.show(),M&&M.show()),M=ka.label,ja=V.angle,0>ja&&(ja=q+ja),ea=0<=ja&&ja<f?1:ja<m?2:ja<v?3:0,y[ea].push({point:d,angle:ja})});for(w=r=4;w--;){if(x&&(u=y[w].length-ma,0<u))for(y[w].sort(d),F=y[w].splice(0,u),u=0,ba=F.length;u<ba;u+=1)E=F[u].point,ka=E.graphics,ka.label&&ka.label.attr("visibility","hidden"),ka.connector&&ka.connector.attr({visibility:"hidden"});
y[w].sort(b)}w=Ba(y[0].length,y[1].length,y[2].length,y[3].length);ha=Ba(za(w,ma)*H,ha+H);y[1].reverse();y[3].reverse();for(B.setStyle(P);r--;){u=y[r];ba=u.length;x||(H=ba>ma?ha/ba:z,S=H/2);F=ba*H;P=ha;for(w=0;w<ba;w+=1,F-=H)E=Ha(ha*va(u[w].angle)),P<E?E=P:E<F&&(E=F),P=(u[w].oriY=E)-H;F=g[r];t=ha-(ba-1)*H;P=0;for(w=u.length-1;0<=w;--w,t+=H)E=u[w].point,ka=E.graphics,V=E.config,Y=V._textAttrs,ta=V._textCss,null!==V.y&&Y.text&&(ja=u[w].angle,T=V.sliced,M=ka.label,E=Ha(ha*va(ja)),E<P?E=P:E>t&&(E=t),
P=E+H,ga=(E+u[w].oriY)/2,E=R+l[r]*Ja*pa(xa.asin(ga/ha)),ga*=c[r],ga+=fa,X=fa+n*va(ja),Q=R+h*pa(ja),(2>r&&E<Q||1<r&&E>Q)&&(E=Q),Z=E+K[r],N=ga+S-2,aa=Z+K[r],Y._x=aa,I&&(W=1<r?aa-p:p+D-aa,B.setStyle(V.style),ba=ia(a(parseFloat(V.style.lineHeight)),12)+(2*a(parseFloat(V.style.border),12)||0),ba=B.getSmartText(V.displayValue,W,ba),Y.text=ba.text,Y.tooltip=ba.tooltext),ja<m&&(ga+=sa,X+=sa,N+=sa),Y._y=N,T&&(ba=V.transX,T=V.transY,Z+=ba,E+=ba,Q+=ba,X+=T,aa+=ba),Y.visibility=Ea,Y["text-anchor"]=F,(ba=M&&M.data("textPos"))&&
M.attr({x:ba.x,y:ba.y}),Y.x=aa,Y.y=ga,!e&&ba?M.animateWith(la,ua,Y,qa,ya):M?Y&&M.attr(Y):M=ka.label=Ca.text(Y,ta,Da).drag(ca,wa,na).hover(Aa,Fa),M.data("textPos",{x:aa,y:ga}).data("plotItem",Y.plotItem).data("eventArgs",Y.eventArgs),M.x=Y._x,M._x=Y._x,M.y=Y._y,Y.tooltip&&(M.tooltip(Y.tooltip),delete Y.tooltip),G&&J&&oa&&(U=ka.connector,V.connectorPath||(k=!0),V.connectorPath=ba=["M",Q,X,"L",O?E:Q,ga,Z,ga],ba={path:ba,"stroke-width":J,stroke:A.connectorColor||"#606060",visibility:Ea},U&&(e||k?U.attr(ba):
U.animateWith(la,ua,ba,qa,ya))))}}}}(),animate:function(){var d,a,g,b,l=this,e=l.components.dataset[0],c=e.components.data;d=l.graphics.datasetGroup;var f=c.length;a=e.config.alphaAnimation;g=function(){l.disposed||l.disposing||l.placeDataLabels(!1)};var r=l.get("config","animationObj"),e=r.duration||0,w=r.dummyObj,u=r.animObj,r=r.animType;if(a)d.attr({opacity:0}),d.animateWith(w,u,{opacity:1},e,r,g);else for(d=0;d<f;d++)if(a=c[d],g=a.graphics,a=a.config,b=a.shapeArgs,a=2*ta,g=g.element)g.attr({start:a,
end:a}),g=b.start,b=b.end,(void 0).animateWith(w,u,{cx:g-a,cy:b-a},e,r)},_rotate:function(d){var a=this.components.dataset[0],g=a.config,a=a.components,b=a.data,l=g.slicedOffset,e=g.slicedOffsetY,c=g.startAngle,f;d=isNaN(d)?-g._lastAngle:d;f=(d-c)%360;g.startAngle=ia(d,g.startAngle)%360;f=-(f*ta)/180;a.Pie3DManager&&a.Pie3DManager.rotate(f);Ga(b,function(d){var a=[],g=d.config;d=d.graphics.element;var a=g.shapeArgs,b=a.start+=f,a=a.end+=f,c=g.angle=fa((b+a)/2),b=g.sliced,a=pa(c),c=va(c),a=g.slicedTranslation=
[ra(a*l),ra(c*e)];g.transX=a[0];g.transY=a[1];g.slicedX=b?pa(f)*l:0;g.slicedY=b?va(f)*e:0;d&&b&&d.attr({transform:"t"+a[0]+","+a[1]})});this.placeDataLabels(!0,b)},_plotRollOver:function(d){var a=this.data("plotItem"),g=a.chart,b=g.config,l=g.components.dataset[0],e=l.components.data[a.index],a=e.graphics.element,e=e.config.hoverEffects;l.config.isRotating||(Fa.call(a,g,d,"DataPlotRollOver"),e.enabled&&a.attr(e));b.isHovered=!0},_plotRollOut:function(d){var a=this.data("plotItem"),g=a.chart,b=g.config,
l=g.components.dataset[0],e=l.components.data[a.index],a=e.config,e=e.graphics.element;l.config.isRotating||(Fa.call(e,g,d,"DataPlotRollOut"),e.attr({color:a.color.color.split(",")[0],alpha:a._3dAlpha,borderWidth:a.borderWidth,borderColor:a.borderColor}));b.isHovered=!1},_plotDragStart:function(d,a,g){var b=this.data("plotItem").chart,l=b.components.dataset[0].config;l.isRightClicked=Ma||0===g.button||1===g.button?!1:!0;l.enableRotation&&!l.isRightClicked&&(l.isRotating=!1,d=Ka.call(g,d,a,l.center,
l.chartPosition=Na(b.linkedItems.container),l.pieYScale),l.dragStartAngle=d,l._lastAngle=-l.startAngle,l.startingAngleOnDragStart=l.startAngle)},_plotDragEnd:function(d){var a=this.data("plotItem"),g=a.index,a=a.chart,b=a.config,l=a.components.dataset[0],e=l.config,l=l.components.Pie3DManager,c=e.startAngle;e.isRightClicked||(e.isRotating?(setTimeout(function(){e.isRotating=!1},0),ha.raiseEvent("rotationEnd",{startingAngle:fa(c,!0),changeInAngle:c-e.startingAngleOnDragStart},a.chartInstance),!b.isHovered&&
l.colorObjs[g]&&l.onPlotHover(g,!1)):a._plotGraphicClick.call(this,d))},_plotDragMove:function(d,a,g,b,l){var e=this.data("plotItem").chart,c=e.components.dataset[0].config;isNaN(d)||isNaN(a)||!c.enableRotation||c.singletonCase||c.isRightClicked||(d=Ka.call(l,g,b,c.center,c.chartPosition,c.pieYScale),c.isRotating||(c.dragStartAngle!==d&&(c.isRotating=!0),ha.raiseEvent("rotationStart",{startingAngle:fa(c.startAngle,!0)},e.chartInstance)),a=d-c.dragStartAngle,c.dragStartAngle=d,c.moveDuration=0,c._lastAngle+=
180*a/ta,d=(new Date).getTime(),c._lastTime&&!(c._lastTime+c.timerThreshold<d))||(c._lastTime||e._rotate(),c.timerId=setTimeout(function(){e.disposed&&e.disposing||e._rotate()},c.timerThreshold),c._lastTime=d)},_stubRadius:function(d,a,g,b,l,e,c){var f=this.components.dataset[0],r=f.config,w=ia(f.config.slicingdistance),f=r.dataLabelOptions||(r.dataLabelOptions=f._parseDataLabelOptions()),u=0,u=r.pieYScale;g-=r.pieSliceDepth;u=za(d/2-a-l,(g/2-e)/u)-b;u>=c?c=u:w||(l=b=Ba(za(b-(c-u),l),10));r.slicingDistance=
l;r.pieMinRadius=c;f.distance=b;return c},_startingAngle:function(d,a){var g,b=this.components.dataset[0].config,l=(g=b.startAngle)+(0>g?360:0);isNaN(d)||b.singletonCase||b.isRotating||(d+=a?l:0,this._rotate(d),l=d);return ra(100*((l%=360)+(0>l?360:0)))/100}},k.pie2d,{plotborderthickness:.1,alphaanimation:1});k("doughnut2d",{friendlyName:"Doughnut Chart",defaultDatasetType:"Doughnut2D",creditLabel:D,applicableDSList:{Doughnut2D:!0},getPointColor:function(d,a,g){var c;d=A(d);a=n(a);100>g&&qa?(c=C(d,
b(100*(85-.2*(100-g)))/100),d=p(d,b(100*(100-.5*g))/100),a={FCcolor:{color:c+","+d+","+d+","+c,alpha:a+","+a+","+a+","+a,radialGradient:!0,gradientUnits:"userSpaceOnUse",r:g}}):a={FCcolor:{color:d+","+d,alpha:a+","+a,ratio:"0,100"}};return a},drawDoughnutCenterLabel:function(d,a,g,b,c,e,f){var k=this.components,r=k.dataset[0].config;e=e||r.lastCenterLabelConfig;var k=k.paper,w=this.linkedItems.smartLabel,u=this.graphics,F=u.datasetGroup,t=e.padding,h=2*e.textPadding,m={fontFamily:e.font,fontSize:e.fontSize+
"px",lineHeight:1.2*e.fontSize+"px",fontWeight:e.bold?"bold":"",fontStyle:e.italic?"italic":""},p=1.414*(.5*b-t)-h;c=1.414*(.5*c-t)-h;var q;w.setStyle(m);w.useEllipsesOnOverflow(this.config.useEllipsesWhenOverflow);w=w.getSmartText(d,p,c);(c=u.doughnutCenterLabel)?(c.attr("text")!==d&&this.centerLabelChange(d),q=u.centerLabelOvalBg):(e.bgOval&&(u.centerLabelOvalBg=q=k.circle(a,g,.5*b-t,F)),c=u.doughnutCenterLabel=k.text(F).hover(this.centerLabelRollover,this.centerLabelRollout).click(this.centerLabelClick),
c.chart=this);d?(c.css(m).attr({x:a,y:g,text:w.text,visibility:Ea,direction:r.textDirection,fill:U({FCcolor:{color:e.color,alpha:e.alpha}}),"text-bound":e.bgOval?"none":[U({FCcolor:{color:e.bgColor,alpha:e.bgAlpha}}),U({FCcolor:{color:e.borderColor,alpha:e.borderAlpha}}),e.borderThickness,e.textPadding,e.borderRadius]}).tooltip(e.toolText||w.tooltext),e.bgOval&&q&&q.attr({visibility:Ea,fill:Oa(e.bgColor),"fill-opacity":e.bgAlpha/100,stroke:Oa(e.borderColor),"stroke-width":e.borderThickness,"stroke-opacity":e.borderAlpha/
100})):(c.attr("visibility","hidden"),q&&q.attr("visibility","hidden"));f&&(r.lastCenterLabelConfig=e,r.centerLabelConfig=e)},centerLabelRollover:function(){var d=this.chart,a=d.config,g=d.chartInstance,b=g.ref,c=d.components.dataset[0].config.lastCenterLabelConfig,a={height:a.height,width:a.width,pixelHeight:b.offsetHeight,pixelWidth:b.offsetWidth,id:g.id,renderer:g.args.renderer,container:d.linkedItems.container,centerLabelText:c&&c.label};this.attr("text")&&ha.raiseEvent("centerLabelRollover",
a,g,this,d.hoverOnCenterLabel)},centerLabelRollout:function(){var d=this.chart,a=d.config,g=d.chartInstance,b=g.ref,c=d.components.dataset[0].config.lastCenterLabelConfig,a={height:a.height,width:a.width,pixelHeight:b.offsetHeight,pixelWidth:b.offsetWidth,id:g.id,renderer:g.args.renderer,container:d.linkedItems.container,centerLabelText:c&&c.label};this.attr("text")&&ha.raiseEvent("centerLabelRollout",a,g,this,d.hoverOffCenterLabel)},centerLabelClick:function(){var d=this.chart,a=d.config,g=d.chartInstance,
b=g.ref,c=d.components.dataset[0].config.lastCenterLabelConfig,d={height:a.height,width:a.width,pixelHeight:b.offsetHeight,pixelWidth:b.offsetWidth,id:g.id,renderer:g.args.renderer,container:d.linkedItems.container,centerLabelText:c&&c.label};this.attr("text")&&ha.raiseEvent("centerLabelClick",d,g)},centerLabelChange:function(d){var a=this.config,g=this.chartInstance,b=g.ref;ha.raiseEvent("centerLabelChanged",{height:a.height,width:a.width,pixelHeight:b.offsetHeight,pixelWidth:b.offsetWidth,id:g.id,
renderer:g.args.renderer,container:this.linkedItems.container,centerLabelText:d},g)},hoverOnCenterLabel:function(){var d=this.chart.components.dataset[0].config.lastCenterLabelConfig;(d.hoverColor||d.hoverAlpha)&&this.attr({fill:U({FCcolor:{color:d.hoverColor||d.color,alpha:d.hoverAlpha||d.alpha}})})},hoverOffCenterLabel:function(){var d=this.chart.components.dataset[0].config.lastCenterLabelConfig;(d.hoverColor||d.hoverAlpha)&&this.attr({fill:U({FCcolor:{color:d.color,alpha:d.alpha}})})}},k.pie2d,
{singletonPlaceValue:!1});k("doughnut3d",{friendlyName:"3D Doughnut Chart",defaultDatasetType:"Doughnut3D",creditLabel:D,applicableDSList:{Doughnut3D:!0},_configureManager:function(){var d=this.components.dataset[0],a=d.config,g=d.components,d=g.Pie3DManager,g=g.data;d&&d.configure(a.pieSliceDepth,1===g.length,a.use3DLighting,!0)}},k.pie3d);k("mscolumn2d",{standaloneInit:!0,friendlyName:"Multi-series Column Chart",creditLabel:D,defaultDatasetType:"column",applicableDSList:{column:!0},eiMethods:{}},
k.mscartesian);k("mscolumn3d",{standaloneInit:!0,defaultDatasetType:"column3d",friendlyName:"Multi-series 3D Column Chart",applicableDSList:{column3d:!0},defaultPlotShadow:1,fireGroupEvent:!0,is3D:!0,creditLabel:D,defaultZeroPlaneHighlighted:!1},k.mscartesian3d,{showplotborder:0});k("msbar2d",{standaloneInit:!0,friendlyName:"Multi-series Bar Chart",isBar:!0,hasLegend:!0,creditLabel:D,defaultDatasetType:"bar2d",applicableDSList:{bar2d:!0}},k.msbarcartesian);k("msbar3d",{standaloneInit:!0,defaultSeriesType:"bar3d",
friendlyName:"Multi-series 3D Bar Chart",fireGroupEvent:!0,defaultPlotShadow:1,is3D:!0,isBar:!0,hasLegend:!0,creditLabel:D,defaultZeroPlaneHighlighted:!1,defaultDatasetType:"bar3d",applicableDSList:{bar3d:!0}},k.msbarcartesian3d,{showplotborder:0});k("msarea",{standaloneInit:!0,friendlyName:"Multi-series Area Chart",creditLabel:D,defaultDatasetType:"area",defaultPlotShadow:0,applicableDSList:{area:!0}},k.areabase);k("msline",{standaloneInit:!0,friendlyName:"Multi-series Line Chart",creditLabel:D,
defaultDatasetType:"line",defaultPlotShadow:1,axisPaddingLeft:0,axisPaddingRight:0,applicableDSList:{line:!0}},k.areabase,{zeroplanethickness:1,zeroplanealpha:40,showzeroplaneontop:0});k("stackedarea2d",{friendlyName:"Stacked Area Chart",showsum:0,creditLabel:D},k.msarea,{plotfillalpha:Ua,isstacked:1});k("stackedcolumn2d",{friendlyName:"Stacked Column Chart",creditLabel:D},k.mscolumn2d,{isstacked:!0});k("stackedcolumn3d",{friendlyName:"3D Stacked Column Chart",creditLabel:D},k.mscolumn3d,{showplotborder:0},
k.stackedcolumn2d);k("stackedbar2d",{friendlyName:"Stacked Bar Chart",creditLabel:D},k.msbar2d,{maxbarheight:50},k.stackedcolumn2d);k("stackedbar3d",{friendlyName:"3D Stacked Bar Chart",creditLabel:D},k.msbar3d,{showplotborder:0},k.stackedcolumn2d);k("marimekko",{standaloneInit:!0,friendlyName:"Marimekko Chart",isValueAbs:!0,distributedColumns:!0,stack100percent:!0,defaultDatasetType:"marimekko",applicableDSList:{marimekko:!0},isStacked:!0,showsum:1,creditLabel:D,_setAxisLimits:function(){var d=this.components,
a=d.dataset,g=d.yAxis,d=d.xAxis,b,c=a.length,e,f=-Infinity,k=Infinity,r=Infinity,w=-Infinity,u,F,t={};u=this.config.categories;var h=[],m=function(d){f=Ba(f,d.max);k=za(k,d.min);w=Ba(w,d.xMax||-Infinity);r=za(r,d.xMin||Infinity)};for(e=0;e<c;e++)b=a[e],(F=b.groupManager)?t[b.type]=F:h.push(b);for(F in t)a=t[F].getDataLimits(),m(a);c=h.length;for(e=0;e<c;e++)a=h[e].getDataLimits(),m(a);-Infinity===f&&(f=0);Infinity===k&&(k=0);g[0].setAxisConfig({isPercent:this.config.isstacked?this.config.stack100percent:
0});g[0].setDataLimit(f,k);if(-Infinity!==w||Infinity!==r)d[0].config.xaxisrange={max:w,min:r},d[0].setDataLimit(w,r);g=t[F].getStackSumPercent();e=g.length;F=d[0].getCategoryLen();F>e&&u.splice(e,F-e);this._setCategories();e=d[0].getLimit();r=e.min;w=e.max;u=r;F=w-r;for(e=0;e<g.length;e++)a=g[e],c=F*a/100,a=u+c/2,d[0].updateCategory(e,{x:a}),u+=c}},k.mscartesian,{isstacked:!0,showpercentvalues:0,usepercentdistribution:1,showsum:1});k("msstackedcolumn2d",{standaloneInit:!0,defaultDatasetType:"column",
applicableDSList:{column:!0},friendlyName:"Multi-series Stacked Column Chart",_createDatasets:function(){var d=this.components,a=this.jsonData,g=a.dataset,b=g&&g.length||0,c,e,f,k=this.defaultDatasetType,r=this.applicableDSList,w,u,F,t,h,m,p=a.lineset||[],q=this.config,v=q.dataSetMap,C=q.lineSetMap,D=v&&v.length,A=d.legend,n=[],B=[],x=0;F=0;var I,K=-1,J,y=this.config.catLen,z=d.xAxis[0],H,S,O=d.dataset;if(g||0!==p.length){this.config.categories=a.categories&&a.categories[0].category;e=d.dataset=[];
for(a=0;a<b;a++){h=g[a];K++;if(h.dataset)for(S=!0,m=h.dataset&&h.dataset.length||0,n[a]=[],c=0;c<m;c++){if(F=h.dataset[c],w=(w=na(F.renderas,k))&&w.toLowerCase(),r[w]||(w=k),f=la.get("component",["dataset",w]))t="datasetGroup_"+w,u=la.register("component",["datasetGroup",w]),w=d[t],u&&!w?(w=d[t]=new u,w.chart=this,w.init()):w&&v&&0!==v.length&&!I&&(w.init(),I=!0),v&&v[a]&&v[a][c]?(f=v[a][c],f.index=x,t=f.JSONData,u=t.data.length,t=F.data&&F.data.length||0,J=z.getCategoryLen(),H=y-J,u-=t,u=this._getDiff(u,
t,H,J),t=u.diff,u=u.startIndex,0<t&&f.removeData(u,t,!1),f.JSONData=F,f.configure()):(f=new f,f.chart=this,f.index=x,f.init(F)),x++,n[a].push(f),e.push(f),w&&w.addDataSet(f,K,c)}else m=c=0,K--;h=v&&v[a]&&v[a].length;if(h>m)for(F=c,h=h-m+c;F<h;F++)w=v[a][F],A.removeItem(w.legendItemId),wa.call(w)}if(D>b)for(F=a,h=D-b+a;F<h;F++)for(m=v[F].length,c=0;c<m;c++)w=v[F][c],A.removeItem(w.legendItemId),wa.call(w);q.dataSetMap=n;if(this.lineset){a=0;for(b=p.length;a<b;a++)g=p[a],f=la.get("component",["dataset",
"line"]),f=new f,C&&C[a]?(f=C[a],f.index=x,t=f.JSONData,u=t.data.length,t=g.data&&g.data.length||0,u>t&&f.removeData(t,u-t,!1),f.JSONData=g,f.configure()):(f.chart=this,f.index=x,f.init(g)),B.push(f),e.push(f),x++;p=C&&C.length;if(p>b)for(F=a,h=p-b+a;F<h;F++)w=C[F],A.removeItem(w.legendItemId),wa.call(w);q.lineSetMap=B}S?this.config.catLen=z.getCategoryLen():(d.dataset=O,this.setChartMessage())}else this.setChartMessage()},creditLabel:D},k.mscartesian,{isstacked:!0});k("mscombi2d",{friendlyName:"Multi-series Combination Chart",
standaloneInit:!0,creditLabel:D,defaultDatasetType:"column",applicableDSList:{line:!0,area:!0,column:!0},_createDatasets:function(){var d=this.components,a=this.jsonData,g=a.dataset,b=g&&g.length,c,e,f=this.defaultDatasetType,k=this.applicableDSList;c=this.components.legend;var r=d.xAxis[0],w,u,h,t,m,p=this.config.isstacked,q,v,C=[],D={},A=this.config,n=this.config.catLen,B=A.datasetMap||(A.datasetMap={line:[],area:[],column:[],column3d:[],scrollcolumn2d:[]}),x={line:[],area:[],column:[],column3d:[],
scrollcolumn2d:[]};g||this.setChartMessage();this.config.categories=a.categories&&a.categories[0].category;a=d.dataset=[];c&&c.emptyItems();for(c=0;c<b;c++)if(m=g[c],t=m.parentyaxis||"",u=(u=this.config.isdual&&"s"===t.toLowerCase()?"line"===this.defaultSecondaryDataset?this.sDefaultDatasetType:na(m.renderas,this.sDefaultDatasetType):na(m.renderas,f))&&u.toLowerCase(),k[u]||(u=f),h=la.get("component",["dataset",u]))void 0===D[u]?D[u]=0:D[u]++,e="datasetGroup_"+u,t=la.register("component",["datasetGroup",
u]),(w=d[e])&&C.push(w),t&&!w&&(w=d[e]=new t,w.chart=this,w.init()),t=B[u],(e=t[0])?(delete e.legendItemId,w=r.getCategoryLen(),h=n-w,v=e.JSONData,q=v.data&&v.data.length,v=m.data&&m.data.length||0,q-=v,h=this._getDiff(q,v,h,w),w=h.diff,h=h.startIndex,0<w&&e.removeData(h,w,!1),e.index=c,e.JSONData=m,e.configure(),t.splice(0,1)):(e=new h,e.chart=this,e.index=c,w&&(p?w.addDataSet(e,0,D[u]):w.addDataSet(e,D[u],0)),e.init(m)),x[u].push(e),a.push(e);for(g in B)if(t=B[g],f=t[0]&&t[0].groupManager,b=t.length,
k=void 0===D[g]?0:D[g]+1,b)for(p&&f&&f.removeDataSet(0,k,b),d=0;d<b;d++)f&&!p&&f.removeDataSet(k,0,1),"column"===t[d].type&&!0===this.is3D?(t[d].visible=!1,t[d].draw()):wa.call(t[d]);A.datasetMap=x;this.config.catLen=r.getCategoryLen()}},k.areabase);k("mscombi3d",{standaloneInit:!0,friendlyName:"Multi-series 3D Combination Chart",defaultDatasetType:"column3d",is3D:!0,creditLabel:D,defaultPlotShadow:1,applicableDSList:{column3d:!0,line:!0,area:!0},_createDatasets:k.mscombi2d},k.mscartesian3d,{showplotborder:0},
k.areabase);k("mscolumnline3d",{friendlyName:"Multi-series Column and Line Chart",is3D:!0,creditLabel:D,defaultPlotShadow:1,applicableDSList:{column3d:!0,line:!0}},k.mscombi3d,{use3dlineshift:1,showplotborder:0},k.msarea);k("stackedcolumn2dline",{friendlyName:"Stacked Column and Line Chart",defaultDatasetType:"column",creditLabel:D,applicableDSList:{line:!0,column:!0}},k.mscombi2d,{isstacked:!0,stack100percent:0},k.msarea);k("stackedcolumn3dline",{friendlyName:"Stacked 3D Column and Line Chart",is3D:!0,
creditLabel:D,applicableDSList:{column3d:!0,line:!0}},k.mscombi3d,{use3dlineshift:1,isstacked:!0,stack100percent:0,showplotborder:0},k.msarea);k("mscombidy2d",{standaloneInit:!0,friendlyName:"Multi-series Dual Y-Axis Combination Chart",defaultDatasetType:"column",sDefaultDatasetType:"line",_createDatasets:k.mscombi2d,creditLabel:D,applicableDSList:{column:!0,line:!0,area:!0}},k.msdybasecartesian,{isdual:1},k.msarea);k("mscolumn3dlinedy",{standaloneInit:!0,friendlyName:"Multi-series 3D Column and Line Chart",
defaultDatasetType:"column3d",sDefaultDatasetType:"line",is3D:!0,creditLabel:D,_createDatasets:k.mscombi2d,defaultPlotShadow:1,applicableDSList:{column3d:!0,line:!0}},k.msdybasecartesian3d,{use3dlineshift:1,isdual:!0,showplotborder:0},k.msarea);k("stackedcolumn3dlinedy",{standaloneInit:!0,friendlyName:"Stacked 3D Column and Line Chart",is3D:!0,defaultDatasetType:"column3d",creditLabel:D,sDefaultDatasetType:"line",defaultSecondaryDataset:"line",_createDatasets:k.mscombi2d,applicableDSList:{column3d:!0,
line:!0}},k.msdybasecartesian3d,{use3dlineshift:1,isdual:!0,isstacked:!0,showplotborder:0},k.msarea);k("msstackedcolumn2dlinedy",{standaloneInit:!0,friendlyName:"Multi-series Dual Y-Axis Stacked Column and Line Chart",stack100percent:0,defaultDatasetType:"column",sDefaultDatasetType:"line",hasLineSet:!0,creditLabel:D,applicableDSList:{column:!0},lineset:!0,_createDatasets:k.msstackedcolumn2d},k.msdybasecartesian,{isdual:!0,haslineset:!0,isstacked:!0},k.msarea);k("scrollcolumn2d",{standaloneInit:!0,
friendlyName:"Scrollable Multi-series Column Chart",tooltipConstraint:"plot",canvasborderthickness:1,creditLabel:D,defaultDatasetType:"scrollcolumn2d",applicableDSList:{scrollcolumn2d:!0},avgScrollPointWidth:40,hasScroll:!0,defaultPlotShadow:1,_manageScrollerPosition:function(){var d=this.config,a;a=this._scrollBar.get;var g=this.components.scrollBar,b;a=a()[0];g.setConfiguaration(a.conf);a=d.scrollEnabled;b=g.getLogicalSpace();this._allocateSpace({bottom:d.shift=!1===a?0:b.height+g.conf.padding})},
_resetViewPortConfig:function(){this.config.viewPortConfig={scaleX:1,scaleY:1,x:0,y:0}},updateManager:function(d){var a=this.config,g=this.config.viewPortConfig,b=g.scaleX,c=this.graphics.datasetGroup,e=this.graphics.datalabelsGroup,f=this.graphics.trackerGroup,h=a.canvasWidth*(b-1)*d,r=this.components.xAxis[0],w=this.graphics.sumLabelsLayer;g.x=h/b;g="t"+-ra(h)+",0";a.lastScrollPosition=d;c.attr({transform:g});e.attr({transform:g});f.attr({transform:g});w&&w.attr({transform:g});d=r.getAxisConfig("animateAxis");
a=r.getAxisConfig("drawAxisName");r.setAxisConfig({animateAxis:!1,drawAxisName:!1});r.draw();r.setAxisConfig({animateAxis:d,drawAxisName:a})},_createToolBox:function(){var d=this.components,a=this._scrollBar,g=a.get,b=a.add,c,e,f=d.scrollBar;k.mscartesian._createToolBox.call(this);c=d.tb;e=(d.toolBoxAPI||c.getAPIInstances(c.ALIGNMENT_HORIZONTAL)).Scroller;a.clear();b({isHorizontal:!0},{scroll:function(d){return function(){d.updateManager.apply(d,arguments)}}(this)});a=g()[0];f||(d.scrollBar=(new e(a.conf,
c.idCount,c.pId)).attachEventHandlers(a.handler))},_setAxisScale:function(){var d=this.config,a=this.components.xAxis[0].getCategoryLen(),g=this.jsonData,c=d.scrollOptions||(d.scrollOptions={}),f=this.components.dataset,e=f.length,h,k,r=0,w;w=d.canvasWidth;var u=d.scrollToEnd,m=d.lastScrollPosition,g=ia(g.chart.numvisibleplot,b(d.width/this.avgScrollPointWidth));for(k=0;k<e;k++)h=f[k],"column"===h.type&&r++;this.config.isstacked&&(r=1);a*=r||1;2<=g&&g<a?(d.viewPortConfig.scaleX=a/=g,w=w*(a-1)*(void 0!==
m?m:u?1:0),d.viewPortConfig.x=w/a,c.vxLength=g/e,d.scrollEnabled=!0):d.scrollEnabled=!1},drawScrollBar:function(){var d=this,a=d.config,g=a.viewPortConfig,c=d.components,b=d.graphics,e=c.paper,f=c.xAxis[0],h=f.config,r=f.config.axisRange,k=a.scrollOptions||(a.scrollOptions={}),u=r.max,m=r.min,t=k.vxLength,p=c.scrollBar,r=p.node,q=a.scrollToEnd,v=a.lastScrollPosition,C=g.scaleX,D,A,B,n,x;n=void 0!==v?v:q?1:0;g=a.canvasLeft;q=a.canvasTop;v=a.canvasHeight;D=a.canvasWidth;c=c.canvas.config;A=c.canvasBorderWidth;
B=h.showAxisLine?h.axisLineThickness||0:0;x=ia(A,h.lineStartExtension);h=ia(A,h.lineEndExtension);k.viewPortMin=m;k.viewPortMax=u;C=k.scrollRatio=1/C;t=k.windowedCanvasWidth=f.getAxisPosition(t);f=k.fullCanvasWidth=f.getAxisPosition(u-m)-t;k=b.scrollBarParentGroup;k||(k=b.scrollBarParentGroup=e.group("scrollBarParentGroup",b.parentGroup).insertBefore(b.datalabelsGroup));!1!==a.scrollEnabled?(p.draw(g-x,q+v+A+B-2,{width:D+x+h,scrollRatio:C,roundEdges:c.isRoundEdges,fullCanvasWidth:f,windowedCanvasWidth:t,
scrollPosition:n,parentLayer:k}),!r&&function(){var a;ua.eve.on("raphael.scroll.start."+p.node.id,function(g){a=g;ha.raiseEvent("scrollstart",{scrollPosition:g},d.chartInstance)});ua.eve.on("raphael.scroll.end."+p.node.id,function(g){ha.raiseEvent("scrollend",{prevScrollPosition:a,scrollPosition:g},d.chartInstance)})}()):p&&p.node&&p.node.hide()},_drawDataset:function(){this._setClipping();k.mscartesian._drawDataset.call(this)},_setClipping:function(){var a=this.config,c=this.graphics.datasetGroup,
g=this.graphics.datalabelsGroup,b=this.graphics.trackerGroup,f=a.viewPortConfig,e=this.graphics.sumLabelsLayer,k=f.scaleX,h=this.get("config","animationObj"),r=h.duration,m=h.dummyObj,u=h.animObj,h=h.animType,f=f.x,a=a.height,F=this.components.canvas.config.clip["clip-canvas"],F=F&&F.slice(0)||[];this.config.clipSet?(c.animateWith(m,u,{"clip-rect":F},r,h),g.animateWith(m,u,{"clip-rect":F},r,h),b.attr({"clip-rect":F}),F[3]=a,F[1]=0,e&&e.animateWith(m,u,{"clip-rect":F},r,h)):(c.attr({"clip-rect":F}),
g.attr({"clip-rect":F}),b.attr({"clip-rect":F}),F[3]=a,F[1]=0,e&&e.attr({"clip-rect":F}));c.attr({transform:"T"+-(f*k)+",0"});g.attr({transform:"T"+-(f*k)+",0"});b.attr({transform:"T"+-(f*k)+",0"});e&&e.attr({transform:"T"+-(f*k)+",0"});this.config.clipSet=!0},configure:function(){var a=this.jsonData.chart,c;k.mscolumn2d.configure.call(this);c=this.config;c.scrollToEnd=ia(a.scrolltoend,0);c.lastScrollPosition=void 0}},k.scrollbase);k("scrollarea2d",{friendlyName:"Scrollable Multi-series Area Chart",
tooltipConstraint:"plot",canvasborderthickness:1,creditLabel:D,hasScroll:!0,defaultDatasetType:"scrollarea2d",applicableDSList:{scrollarea2d:!0},avgScrollPointWidth:75,defaultPlotShadow:0,_setAxisScale:function(){var a=this.config,c=this.components.xAxis[0].getCategoryLen(),g=this.jsonData,f=a.scrollOptions||(a.scrollOptions={}),l;l=a.lastScrollPosition;var e=a.scrollToEnd,h=a.canvasWidth,g=ia(g.chart.numvisibleplot,b(a.width/this.avgScrollPointWidth));2<=g&&g<c?(a.viewPortConfig.scaleX=c/=g,l=h*
(c-1)*(void 0!==l?l:e?1:0),a.viewPortConfig.x=l/c,f.vxLength=g,a.scrollEnabled=!0):a.scrollEnabled=!1}},k.scrollcolumn2d,{},k.areabase);k("scrollline2d",{friendlyName:"Scrollable Multi-series Line Chart",tooltipConstraint:"plot",canvasborderthickness:1,defaultDatasetType:"line",creditLabel:D,avgScrollPointWidth:75,defaultPlotShadow:1},k.scrollarea2d,{zeroplanethickness:1,zeroplanealpha:40,showzeroplaneontop:0},k.areabase);k("scrollstackedcolumn2d",{friendlyName:"Scrollable Stacked Column Chart",canvasborderthickness:1,
tooltipConstraint:"plot",avgScrollPointWidth:75,creditLabel:D},k.scrollcolumn2d,{},k.stackedcolumn2d);k("scrollcombi2d",{friendlyName:"Scrollable Combination Chart",tooltipConstraint:"plot",hasScroll:!0,canvasborderthickness:1,avgScrollPointWidth:40,applicableDSList:{area:!0,line:!0,column:!0},creditLabel:D,_createDatasets:k.mscombi2d},k.scrollcolumn2d,{},k.msarea);k("scrollcombidy2d",{friendlyName:"Scrollable Dual Y-Axis Combination Chart",tooltipConstraint:"plot",canvasborderthickness:1,avgScrollPointWidth:40,
hasScroll:!0,_drawDataset:k.scrollcolumn2d,updateManager:k.scrollcolumn2d,_setAxisScale:k.scrollcolumn2d,_createToolBox:k.scrollcolumn2d,_scrollBar:k.scrollcolumn2d,_manageScrollerPosition:k.scrollcolumn2d,drawScrollBar:k.scrollcolumn2d,_setClipping:k.scrollcolumn2d,creditLabel:D,configure:k.scrollcolumn2d},k.mscombidy2d,{isdual:!0},k.areabase);k("scatter",{friendlyName:"Scatter Chart",isXY:!0,standaloneInit:!0,hasLegend:!0,defaultZeroPlaneHighlighted:!1,creditLabel:D,defaultDatasetType:"Scatter",
applicableDSList:{Scatter:!0}},k.scatterBase);Za(R.eventList,{zoomedOut:"FC_ZoomedOut"});k("bubble",{friendlyName:"Bubble Chart",standaloneInit:!0,defaultDatasetType:"bubble",creditLabel:D,applicableDSList:{bubble:!0},getDataLimits:function(){var a=this.components.dataset,c,g,b,f=-Infinity,e=Infinity;c=0;for(b=a.length;c<b;c++)g=a[c],g=g.getDataLimits(),f=Ba(f,g.zMax||-Infinity),e=za(e,g.zMin||Infinity);f=-Infinity===f?0:f;e=Infinity===e?0:e;return{zMax:f,zMin:e}}},k.scatter);ua._availableAnimAttrs&&
ua._availableAnimAttrs.cx&&(ua._availableAnimAttrs.innerR=ua._availableAnimAttrs.depth=ua._availableAnimAttrs.radiusYFactor=ua._availableAnimAttrs.start=ua._availableAnimAttrs.end=ua._availableAnimAttrs.cx);oa.prototype={configure:function(a,c,g,b){var f=this.linkedItems.chart,e=f.get("components","paper"),f=f.get("graphics","datasetGroup");"object"===typeof a&&(a=a.depth,c=a.hasOnePoint,g=a.use3DLighting,b=a.isDoughnut);this.renderer||(this.renderer=e);this.hasOnePoint=c;this.use3DLighting=g;this.isDoughnut=
b;this.depth=a;!this.bottomBorderGroup&&(this.bottomBorderGroup=e.group("bottom-border",f));this.bottomBorderGroup.attr({transform:"t0,"+a});!this.slicingWallsBackGroup&&(this.slicingWallsBackGroup=e.group("slicingWalls-back-Side",f));!this.slicingWallsFrontGroup&&(this.slicingWallsFrontGroup=e.group("slicingWalls-front-Side",f));!this.topGroup&&(this.topGroup=e.group("top-Side",f));!this.pointElemStore&&(this.pointElemStore=[]);!this.slicingWallsArr&&(this.slicingWallsArr=[]);this.moveCmdArr=["M"];
this.lineCmdArr=["L"];this.closeCmdArr=["Z"];this.colorObjs=[]},getArcPath:function(a,c,b,f,l,e,h,k,r,m){return b==l&&f==e?[]:["A",h,k,0,m,r,l,e]},_parseSliceColor:function(a,c,b){var f,l,e,h,k,r,m,u,F,t,q,v,D,A,B;B=3;var n=(f=this.use3DLighting)?Z:X,K=b.radiusYFactor,G=b.cx,P=b.cy,aa=b.r,N=aa*K,fa=b.innerR||0,sb=G+aa,J=G-aa,y=G+fa,z=G-fa;c=c||100;b=c/2;n[a]&&n[a][c]?n=n[a][c]:(n[a]||(n[a]={}),n[a][c]||(n[a][c]={}),n=n[a][c],f?(f=C(a,80),l=C(a,75),r=p(a,85),m=p(a,70),u=p(a,40),F=p(a,50),p(a,30),t=
p(a,65),C(a,85),e=C(a,69),h=C(a,75),k=C(a,95)):(B=10,f=C(a,90),l=C(a,87),r=p(a,93),m=p(a,87),u=p(a,80),t=F=p(a,85),p(a,80),k=C(a,85),e=C(a,75),h=C(a,80)),q=l+x+r+x+m+x+r+x+l,D=c+x+c+x+c+x+c+x+c,v=l+x+a+x+r+x+a+x+l,A=b+x+b+x+b+x+b+x+b,u=l+x+a+x+u+x+a+x+l,e=h+x+r+x+F+x+r+x+e,h="FFFFFF"+x+"FFFFFF"+x+"FFFFFF"+x+"FFFFFF"+x+"FFFFFF",B=0+x+b/B+x+c/B+x+b/B+x+0,n.top=qa?{FCcolor:{gradientUnits:"userSpaceOnUse",radialGradient:!0,color:t+x+k,alpha:c+x+c,ratio:"0,100"}}:{FCcolor:{gradientUnits:"objectBoundingBox",
color:m+x+m+x+r+x+l,alpha:c+x+c+x+c+x+c,angle:-72,ratio:"0,8,15,77"}},n.frontOuter={FCcolor:{gradientUnits:"userSpaceOnUse",y1:0,y2:0,color:e,alpha:D,angle:0,ratio:"0,20,15,15,50"}},n.backOuter={FCcolor:{gradientUnits:"userSpaceOnUse",y1:0,y2:0,color:u,alpha:A,angle:0,ratio:"0,62,8,8,22"}},n.frontInner={FCcolor:{gradientUnits:"userSpaceOnUse",y1:0,y2:0,color:v,alpha:A,angle:0,ratio:"0,25,5,5,65"}},n.backInner={FCcolor:{gradientUnits:"userSpaceOnUse",y1:0,y2:0,color:q,alpha:D,angle:0,ratio:"0,62,8,8,22"}},
n.topBorder={FCcolor:{gradientUnits:"userSpaceOnUse",y1:0,y2:0,color:h,alpha:B,angle:0,ratio:"0,20,15,15,50"}},n.topInnerBorder={FCcolor:{gradientUnits:"userSpaceOnUse",y1:0,y2:0,color:h,alpha:B,angle:0,ratio:"0,50,15,15,20"}},n.bottom=U(I(a,b)),n.startSlice=U(I(f,c)),n.endSlice=U(I(f,c)));if(n.cx!==G||n.cy!==P||n.rx!==aa||n.radiusYFactor!==K||n.innerRx!==fa)qa&&(n.top.FCcolor.cx=G,n.top.FCcolor.cy=P,n.top.FCcolor.r=aa,n.top.FCcolor.fx=G-.3*aa,n.top.FCcolor.fy=P+1.2*N),n.topBorder.FCcolor.x1=n.backOuter.FCcolor.x1=
n.frontOuter.FCcolor.x1=J,n.topBorder.FCcolor.x2=n.backOuter.FCcolor.x2=n.frontOuter.FCcolor.x2=sb,n.topInnerBorder.FCcolor.x1=n.backInner.FCcolor.x1=n.frontInner.FCcolor.x1=z,n.topInnerBorder.FCcolor.x2=n.backInner.FCcolor.x2=n.frontInner.FCcolor.x2=y,n.cx=G,n.cy=P,n.rx=aa,n.radiusYFactor=K,n.innerRx=fa;return n},rotate:function(a){var c=this.pointElemStore,b=0,f=c.length,l;if(!this.hasOnePoint){for(;b<f;b+=1)l=c[b],l=l._confObject,l.start+=a,l.end+=a,this._setSliceShape(l);this.refreshDrawing()}},
removeSlice:function(a){var c=this.pointElemStore,b=a._confObject.elements,f=this.slicingWallsArr,l;l=c.length;var e;for(--l;0<=l;--l)e=c[l],e===a&&c.splice(l,1);l=f.length;for(--l;0<=l;--l)c=f[l],c!==b.startSlice&&c!==b.frontOuter1&&c!==b.frontOuter&&c!==b.backInner&&c!==b.endSlice||f.splice(l,1);a.hide&&a.hide();this._slicePool||(this._slicePool=[]);this._slicePool.push(a);this.refreshDrawing()},useSliceFromPool:function(){var a=this._slicePool||(this._slicePool=[]),c=this.slicingWallsArr,b=!1;
a.length&&(b=a.shift(),this.pointElemStore.push(b),b.show(),a=b._confObject.elements,c.push(a.startSlice,a.frontOuter1,a.frontOuter),a.backInner&&c.push(a.backInner),c.push(a.endSlice));return b},refreshDrawing:function(){var a=function(a,d){return a._conf.index-d._conf.index||a._conf.cIndex-d._conf.cIndex||a._conf.isStart-d._conf.isStart||a._conf.si-d._conf.si};return function(){var c=this.slicingWallsArr,b=0,h,l=c.length,e,k,p,r,w=this.slicingWallsFrontGroup,u=this.slicingWallsBackGroup;c.sort(a);
a:{var F=c[0]&&c[0]._conf.index,t,q;r=F<=m;e=1;for(h=c.length;e<h;e+=1)if(q=c[e]._conf.index,t=q<=m,t!=r||q<F)break a;e=0}for(;b<l;b+=1,e+=1)e===l&&(e=0),h=c[e],r=h._conf.index,r<f?w.appendChild(h):r<=m?(k?h.insertBefore(k):w.appendChild(h),k=h):r<=v?(p?h.insertBefore(p):u.appendChild(h),p=h):u.appendChild(h)}}(),_setSliceShape:function(a,c){var b=this.getArcPath,h=a.start,l=a.end,e=fa(h),k=fa(l),p,r,w,u,F,t,n,C,D,A,B,x,K,I,P,G,Z,aa=this.isDoughnut,N=a.radiusYFactor,J=a.cx,y=a.cy,z=a.r,H=z*N,S=z+
(qa?-1:2),O=H+(qa?-1:2),W=a.innerR||0,E=W*N,T=this.depth,Q=T+y,X=J+z,U=J-z,ga=J+W,R=J-W,ha=y-H,ja=["M",R,ha,"L",R,Q+H,"Z"],N=a.elements,M,ea,V,ka,ia,da="path",ma=(e+k)/2,la=e>k;r=pa(e);w=va(e);u=pa(k);F=va(k);t=J+z*r;n=y+H*w;C=J+S*r;D=y+O*w;M=n+T;ea=J+z*u;V=y+H*F;A=J+S*u;B=y+O*F;ka=V+T;aa?(x=J+W*r,K=y+E*w,G=K+T,I=J+W*u,P=y+E*F,Z=P+T,a.startSlice=["M",t,n,"L",t,M,x,G,x,K,"Z"],a.endSlice=["M",ea,V,"L",ea,ka,I,Z,I,P,"Z"]):(a.startSlice=["M",t,n,"L",t,M,J,Q,J,y,"Z"],a.endSlice=["M",ea,V,"L",ea,ka,J,Q,
J,y,"Z"]);qa?(p=(e>k?q:0)+k-e,a.clipTopPath=aa?[["M",t,n,"A",z,H,0,p>m?1:0,1,ea,V,"L",I,P,"A",W,E,0,p>m?1:0,0,x,K,"Z"]]:[["M",t,n,"A",z,H,0,p>m?1:0,1,ea,V,"L",J,y,"Z"]],a.clipOuterFrontPath1=[ja],a.clipTopBorderPath=[["M",C,D,"A",S,O,0,p>m?1:0,1,A,B,"L",ea,V,ea,V+1,"A",z,H,0,p>m?1:0,0,t,n+1,"L",t,n,"Z"]],h!=l?e>k?e<m?(a.clipOuterFrontPath=[["M",X,y,"A",z,H,0,0,1,ea,V,"v",T,"A",z,H,0,0,0,X,y+T,"Z"]],a.clipOuterFrontPath1=[["M",U,y,"A",z,H,0,0,0,t,n,"v",T,"A",z,H,0,0,1,U,y+T,"Z"]],a.clipOuterBackPath=
[["M",X,y,"A",z,H,0,1,0,U,y,"v",T,"A",z,H,0,1,1,X,y+T,"Z"]],aa&&(a.clipInnerBackPath=[["M",ga,y,"A",W,E,0,1,0,R,y,"v",T,"A",W,E,0,1,1,ga,y+T,"Z"]],a.clipInnerFrontPath=[["M",ga,y,"A",W,E,0,0,1,I,P,"v",T,"A",W,E,0,0,0,ga,y+T,"Z","M",R,y,"A",W,E,0,0,0,x,K,"v",T,"A",W,E,0,0,1,R,y+T,"Z"]])):k>m?(a.clipOuterFrontPath=[["M",X,y,"A",z,H,0,1,1,U,y,"v",T,"A",z,H,0,1,0,X,y+T,"Z"]],a.clipOuterBackPath=[["M",U,y,"A",z,H,0,0,1,ea,V,"v",T,"A",z,H,0,0,0,U,y+T,"Z","M",X,y,"A",z,H,0,0,0,t,n,"v",T,"A",z,H,0,0,1,X,
y+T,"Z"]],aa&&(a.clipInnerFrontPath=[["M",ga,y,"A",W,E,0,1,1,R,y,"v",T,"A",W,E,0,1,0,ga,y+T,"Z"]],a.clipInnerBackPath=[["M",R,y,"A",W,E,0,0,1,I,P,"v",T,"A",W,E,0,0,0,R,y+T,"Z","M",ga,y,"A",W,E,0,0,0,x,K,"v",T,"A",W,E,0,0,1,ga,y+T,"Z"]])):(a.clipOuterFrontPath=[["M",X,y,"A",z,H,0,0,1,ea,V,"v",T,"A",z,H,0,0,0,X,y+T,"Z"]],a.clipOuterBackPath=[["M",t,n,"A",z,H,0,0,1,X,y,"v",T,"A",z,H,0,0,0,t,M,"Z"]],aa&&(a.clipInnerFrontPath=[["M",ga,y,"A",W,E,0,0,1,I,P,"v",T,"A",W,E,0,0,0,ga,y+T,"Z"]],a.clipInnerBackPath=
[["M",x,K,"A",W,E,0,0,1,ga,y,"v",T,"A",W,E,0,0,0,x,G,"Z"]])):e<m?k>m?(a.clipOuterFrontPath=[["M",t,n,"A",z,H,0,0,1,U,y,"v",T,"A",z,H,0,0,0,t,M,"Z"]],a.clipOuterBackPath=[["M",U,y,"A",z,H,0,0,1,ea,V,"v",T,"A",z,H,0,0,0,U,y+T,"Z"]],aa&&(a.clipInnerFrontPath=[["M",x,K,"A",W,E,0,0,1,R,y,"v",T,"A",W,E,0,0,0,x,G,"Z"]],a.clipInnerBackPath=[["M",R,y,"A",W,E,0,0,1,I,P,"v",T,"A",W,E,0,0,0,R,y+T,"Z"]])):(a.clipOuterFrontPath=[["M",t,n,"A",z,H,0,0,1,ea,V,"v",T,"A",z,H,0,0,0,t,M,"Z"]],a.clipOuterBackPath=[ja],
aa&&(a.clipInnerFrontPath=[["M",x,K,"A",W,E,0,0,1,I,P,"v",T,"A",W,E,0,0,0,x,G,"Z"]],a.clipInnerBackPath=[ja])):(a.clipOuterFrontPath=[ja],a.clipOuterBackPath=[["M",t,n,"A",z,H,0,0,1,ea,V,"v",T,"A",z,H,0,0,0,t,M,"Z"]],aa&&(a.clipInnerFrontPath=[ja],a.clipInnerBackPath=[["M",x,K,"A",W,E,0,0,1,I,P,"v",T,"A",W,E,0,0,0,x,G,"Z"]])):a.clipOuterFrontPath=a.clipOuterBackPath=a.clipInnerBackPath=a.clipInnerFrontPath=[ja],da="litepath",a.clipBottomBorderPath=a.clipTopPath,a.startSlice=[a.startSlice],a.endSlice=
[a.endSlice]):(S=this.moveCmdArr,O=this.lineCmdArr,r=this.closeCmdArr,T=[J,y],w=[U,y],ha=[J,ha],u=[X,y],F=[J,y+H],ja=[U,Q],ia=[X,Q],C=[R,y],D=[ga,y],A=[R,Q],B=[ga,Q],a.clipOuterFrontPath1=[],h!=l?(e>k?e<m?(h=b(J,y,t,n,U,y,z,H,1,0),l=b(J,y,U,y,X,y,z,H,1,0),V=b(J,y,X,y,ea,V,z,H,1,0),a.clipOuterBackPath=S.concat(w,l,O,ia,b(J,Q,X,Q,U,Q,z,H,0,0),r),a.clipOuterFrontPath1=S.concat([t,n],h,O,ja,b(J,Q,U,Q,t,M,z,H,0,0),r),a.clipOuterFrontPath=S.concat(u,V,O,[ea,ka],b(J,Q,ea,ka,X,Q,z,H,0,0),r),a.clipTopBorderPath=
S.concat([t,n],h,l,V),aa?(z=b(J,y,I,P,ga,y,W,E,0,0),H=b(J,y,ga,y,R,y,W,E,0,0),K=b(J,y,R,y,x,K,W,E,0,0),a.clipInnerBackPath=S.concat(D,H,O,A,b(J,Q,R,Q,ga,Q,W,E,1,0),r),a.clipInnerFrontPath=S.concat(C,K,O,[x,G],b(J,Q,x,G,R,Q,W,E,1,0),r,S,[I,P],z,O,B,b(J,Q,ga,Q,I,Z,W,E,1,0),r),a.clipTopPath=a.clipTopBorderPath.concat(O,[I,P],z,H,K,r),a.clipTopBorderPath=a.clipTopBorderPath.concat(S,[I,P],z,H,K)):a.clipTopPath=a.clipTopBorderPath.concat(O,T,r)):k>m?(h=b(J,y,t,n,X,y,z,H,1,0),l=b(J,y,X,y,U,y,z,H,1,0),V=
b(J,y,U,y,ea,V,z,H,1,0),a.clipOuterFrontPath=S.concat(u,l,O,ja,b(J,Q,U,Q,X,Q,z,H,0,0),r),a.clipOuterBackPath=S.concat([t,n],h,O,ia,b(J,Q,X,Q,t,M,z,H,0,0),r,S,w,V,O,[ea,ka],b(J,Q,ea,ka,U,Q,z,H,0,0),r),a.clipTopBorderPath=S.concat([t,n],h,l,V),aa?(z=b(J,y,I,P,R,y,W,E,0,0),H=b(J,y,R,y,ga,y,W,E,0,0),K=b(J,y,ga,y,x,K,W,E,0,0),a.clipInnerFrontPath=S.concat(C,H,O,B,b(J,Q,ga,Q,R,Q,W,E,1,0),r),a.clipInnerBackPath=S.concat(D,K,O,[x,G],b(J,Q,x,G,ga,Q,W,E,1,0),r,S,[I,P],z,O,A,b(J,Q,R,Q,I,Z,W,E,1,0),r),a.clipTopPath=
a.clipTopBorderPath.concat(O,[I,P],z,H,K,r),a.clipTopBorderPath=a.clipTopBorderPath.concat(S,[I,P],z,H,K)):a.clipTopPath=a.clipTopBorderPath.concat(O,T,r)):(h=b(J,y,t,n,X,y,z,H,1,0),l=b(J,y,X,y,ea,V,z,H,1,0),a.clipOuterFrontPath=S.concat(u,l,O,[ea,ka],b(J,Q,ea,ka,X,Q,z,H,0,0),r),a.clipOuterBackPath=S.concat([t,n],h,O,ia,b(J,Q,X,Q,t,M,z,H,0,0),r),a.clipTopBorderPath=S.concat([t,n],h,l),aa?(z=b(J,y,I,P,ga,y,W,E,0,0),H=b(J,y,ga,y,x,K,W,E,0,0),a.clipInnerFrontPath=S.concat([I,P],z,O,B,b(J,Q,ga,Q,I,Z,
W,E,1,0),r),a.clipInnerBackPath=S.concat(D,H,O,[x,G],b(J,Q,x,G,ga,Q,W,E,1,0),r),a.clipTopPath=a.clipTopBorderPath.concat(O,[I,P],z,H,r),a.clipTopBorderPath=a.clipTopBorderPath.concat(S,[I,P],z,H)):a.clipTopPath=a.clipTopBorderPath.concat(O,T,r)):e<m?k>m?(h=b(J,y,t,n,U,y,z,H,1,0),l=b(J,y,U,y,ea,V,z,H,1,0),a.clipOuterBackPath=S.concat(w,l,O,[ea,ka],b(J,Q,ea,ka,U,Q,z,H,0,0),r),a.clipOuterFrontPath=S.concat([t,n],h,O,ja,b(J,Q,U,Q,t,M,z,H,0,0),r),a.clipTopBorderPath=S.concat([t,n],h,l),aa?(z=b(J,y,I,P,
R,y,W,E,0,0),H=b(J,y,R,y,x,K,W,E,0,0),a.clipInnerBackPath=S.concat([I,P],z,O,A,b(J,Q,R,Q,I,Z,W,E,1,0),r),a.clipInnerFrontPath=S.concat(C,H,O,[x,G],b(J,Q,x,G,R,Q,W,E,1,0),r),a.clipTopPath=a.clipTopBorderPath.concat(O,[I,P],z,H,r),a.clipTopBorderPath=a.clipTopBorderPath.concat(S,[I,P],z,H)):a.clipTopPath=a.clipTopBorderPath.concat(O,T,r)):(h=b(J,y,t,n,ea,V,z,H,1,0),a.clipOuterBackPath=S.concat([t,n]),a.clipTopBorderPath=a.clipOuterBackPath.concat(h),a.clipOuterFrontPath=a.clipTopBorderPath.concat(O,
[ea,ka],b(J,Q,ea,ka,t,M,z,H,0,0),r),aa?(z=b(J,y,I,P,x,K,W,E,0,0),a.clipInnerBackPath=S.concat([I,P]),a.clipTopPath=a.clipTopBorderPath.concat(O,[I,P],z,r),a.clipTopBorderPath=a.clipTopBorderPath.concat(S,[I,P],z),a.clipInnerFrontPath=a.clipInnerBackPath.concat(z,O,[x,G],b(J,Q,x,G,I,Z,W,E,1,0),r)):a.clipTopPath=a.clipTopBorderPath.concat(O,T,r)):(h=b(J,y,t,n,ea,V,z,H,1,0),a.clipOuterFrontPath=S.concat([t,n]),a.clipTopBorderPath=a.clipOuterFrontPath.concat(h),a.clipOuterBackPath=a.clipTopBorderPath.concat(O,
[ea,ka],b(J,Q,ea,ka,t,M,z,H,0,0),r),aa?(z=b(J,y,I,P,x,K,W,E,0,0),a.clipInnerFrontPath=S.concat([I,P]),a.clipTopPath=a.clipTopBorderPath.concat(O,[I,P],z,r),a.clipTopBorderPath=a.clipTopBorderPath.concat(a.clipInnerFrontPath,z),a.clipInnerBackPath=a.clipInnerFrontPath.concat(z,O,[x,G],b(J,Q,x,G,I,Z,W,E,1,0),r)):a.clipTopPath=a.clipTopBorderPath.concat(O,T,r)),h=S.concat(w,O,u),z=S.concat(ha,O,F),a.clipTopPath=a.clipTopPath.concat(h,z),a.clipOuterFrontPath=a.clipOuterFrontPath.concat(h),a.clipOuterFrontPath1=
a.clipOuterFrontPath1.concat(h),a.clipOuterBackPath=a.clipOuterBackPath.concat(h),aa&&(z=S.concat(C,O,D),a.clipInnerFrontPath=a.clipInnerFrontPath.concat(z),a.clipInnerBackPath=a.clipInnerBackPath.concat(z))):(a.clipTopPath=a.clipOuterFrontPath=a.clipOuterBackPath=[],aa&&(a.clipInnerFrontPath=a.clipInnerBackPath=[])),a.clipBottomBorderPath=a.clipTopBorderPath);c||(N.startSlice._conf.index=e,N.endSlice._conf.index=k,N.backOuter._conf.index=x=la&&(e<=v||k>v)||e<=v&&k>v?v:e>m?e:k,N.frontOuter._conf.index=
b=k<=f?k:e>k||e<=f?f:e,N.frontOuter1._conf.index=e,N.frontOuter1._conf.cIndex=m,e>k?(N.backOuter._conf.cIndex=e<v?v:q,N.startSlice._conf.cIndex=e<m?(e+m)/2:(e+q)/2,N.endSlice._conf.cIndex=N.frontOuter._conf.cIndex=0):N.backOuter._conf.cIndex=N.startSlice._conf.cIndex=N.endSlice._conf.cIndex=N.frontOuter._conf.cIndex=ma,p>m?N.frontOuter1.show().attr(da,a.clipOuterFrontPath1):N.frontOuter1.hide(),a.thisElement._attr(da,a.clipTopPath),N.bottom.attr(da,a.clipTopPath),N.bottomBorder.attr(da,a.clipBottomBorderPath),
N.topBorder&&N.topBorder.attr(da,a.clipTopBorderPath),N.frontOuter.attr(da,a.clipOuterFrontPath),N.backOuter.attr(da,a.clipOuterBackPath),aa&&(N.backInner.attr(da,a.clipInnerBackPath),N.frontInner.attr(da,a.clipInnerFrontPath),N.backInner._conf.index=x,N.frontInner._conf.index=b,e>k?(N.backInner._conf.cIndex=q,N.frontInner._conf.cIndex=0):N.backInner._conf.cIndex=N.frontInner._conf.cIndex=ma),this.hasOnePoint?(N.startSlice.hide(),N.endSlice.hide()):(N.startSlice.attr(da,a.startSlice).show(),N.endSlice.attr(da,
a.endSlice).show()))},_setSliceCosmetics:function(a){var b=a.thisElement,c=a.showBorderEffect,f=a.elements,h=I(a.borderColor,ia(a.borderAlpha,a.alpha)),e=a.borderWidth,k;a.color&&(a=this._parseSliceColor(a.color,a.alpha,a),qa?(k={fill:U(a.top),"stroke-width":0},c?f.topBorder.show().attr({fill:U(a.topBorder),"stroke-width":0}):(f.topBorder.hide(),k.stroke=h,k["stroke-width"]=e),b._attr(k)):(b._attr({fill:U(a.top),"stroke-width":0}),f.topBorder.attr({stroke:h,"stroke-width":e})),f.bottom.attr({fill:U(a.bottom)}),
f.bottomBorder.attr({stroke:h,"stroke-width":e}),f.frontOuter.attr({fill:U(a.frontOuter)}),f.frontOuter1.attr({fill:U(a.frontOuter)}),f.backOuter.attr({fill:U(a.backOuter)}),f.startSlice.attr({fill:U(a.startSlice),stroke:h,"stroke-width":e}),f.endSlice.attr({fill:U(a.endSlice),stroke:h,"stroke-width":e}),this.isDoughnut&&(f.frontInner.attr({fill:U(a.frontInner)}),f.backInner.attr({fill:U(a.backInner)})))},createSlice:function(){var a={stroke:!0,strokeWidth:!0,"stroke-width":!0,dashstyle:!0,"stroke-dasharray":!0,
translateX:!0,translateY:!0,"stroke-opacity":!0,fill:!0,opacity:!0,transform:!0,ishot:!0,cursor:!0,start:!0,end:!0,color:!0,alpha:!0,borderColor:!0,borderAlpha:!0,borderWidth:!0,rolloverProps:!0,showBorderEffect:!0,positionIndex:!0,cx:!0,cy:!0,radiusYFactor:!0,r:!0,innerR:!0},b=function(b,c){var e,f,g=this,h=g._confObject,k={},l=h.elements,r,m,w,n=h.Pie3DManager,p;"string"===typeof b&&void 0!==c&&null!==c&&(e=b,b={},b[e]=c);if(b&&"string"!==typeof b){for(e in b)if(f=b[e],a[e])if(h[e]=f,"ishot"===
e||"cursor"===e||"transform"===e)k[e]=f,p=!0;else if("start"===e||"end"===e||"cx"===e||"cy"===e||"radiusYFactor"===e||"r"===e||"innerR"===e)m=!0;else{if("color"===e||"alpha"===e||"borderColor"===e||"borderAlpha"===e||"borderWidth"===e)w=!0}else g._attr(e,f);m&&(n._setSliceShape(h),n.refreshDrawing());(w||m)&&n._setSliceCosmetics(h);if(p){for(r in l)l[r].attr(k);g._attr(k)}}else g=a[b]?h[b]:g._attr(b);return g},c=function(a,b){var c=this._confObject.elements,e;for(e in c)c[e].on(a,b);return this._on(a,
b)},f=function(a,b,c){var e,d=this._confObject.elements,f=-1<Da.navigator.userAgent.toLowerCase().indexOf("android");for(e in d)f?"topBorder"!==e&&"frontOuter"!==e&&"startSlice"!==e&&"endSlice"!==e||d[e].drag(a,b,c):d[e].drag(a,b,c);return this._drag(a,b,c)},h=function(){var a=this._confObject.elements,b;for(b in a)a[b].hide();return this._hide()},e=function(){var a=this._confObject.elements,b;for(b in a)a[b].show();return this._show()},k=function(){var a=this._confObject,b=a.elements,c;for(c in b)b[c].destroy();
qa&&(a.clipTop.destroy(),a.clipOuterFront.destroy(),a.clipOuterBack.destroy(),a.clipOuterFront1&&a.clipOuterFront1.destroy(),a.clipInnerFront&&a.clipInnerFront.destroy(),a.clipInnerBack&&a.clipInnerBack.destroy());return this._destroy()},m=function(a){var b=this._confObject.elements,c;for(c in b)b[c].tooltip(a);return this._tooltip(a)},r=function(a,b){var c=this._confObject.elements,e;if(void 0===b)return this._data(a);for(e in c)c[e].data(a,b);return this._data(a,b)},w=0;return function(){var a=
this.renderer,d,t={elements:{},Pie3DManager:this},n=this.slicingWallsArr,p=t.elements,q=qa?"litepath":"path";d=a[q](this.topGroup);d._confObject=t;t.thisElement=d;d._destroy=d.destroy;d.destroy=k;d._show=d.show;d.show=e;d._hide=d.hide;d.hide=h;d._on=d.on;d.on=c;d._drag=d.drag;d.drag=f;d._attr=d.attr;d.attr=b;d._tooltip=d.tooltip;d.tooltip=m;d._data=d.data;d.data=r;this.pointElemStore.push(d);p.topBorder=a[q](this.topGroup);p.bottom=a[q](this.bottomBorderGroup).attr({"stroke-width":0});p.bottomBorder=
a[q](this.bottomBorderGroup);p.frontOuter=a[q](this.slicingWallsFrontGroup).attr({"stroke-width":0});p.backOuter=a[q](this.slicingWallsFrontGroup).attr({"stroke-width":0});p.startSlice=a[q](this.slicingWallsFrontGroup);p.endSlice=a[q](this.slicingWallsFrontGroup);p.frontOuter1=a[q](this.slicingWallsFrontGroup).attr({"stroke-width":0});p.frontOuter._conf={si:w,isStart:.5};p.frontOuter1._conf={si:w,isStart:.5};p.startSlice._conf={si:w,isStart:0};p.endSlice._conf={si:w,isStart:1};p.backOuter._conf={si:w,
isStart:.4};n.push(p.startSlice,p.frontOuter1,p.frontOuter,p.backOuter,p.endSlice);this.isDoughnut&&(p.frontInner=a[q](this.slicingWallsFrontGroup).attr({"stroke-width":0}),p.backInner=a[q](this.slicingWallsFrontGroup).attr({"stroke-width":0}),p.backInner._conf={si:w,isStart:.5},p.frontInner._conf={si:w,isStart:.4},n.push(p.frontInner,p.backInner));w+=1;return d}}()};oa.prototype.constructor=oa},[3,2,2,"sr4"]]);la.register("module",["private","modules.renderer.js-zoomline",function(){var Aa=this,
fa=Aa.hcLib,Ka=fa.hashify,oa=Aa.window,ha=oa.document,R=oa.Image,Ma=oa.MouseEvent,Da=/msie/i.test(oa.navigator.userAgent)&&!oa.opera,ma=fa.chartAPI,ua=fa.extend2,Na=fa.addEvent,sa=fa.pluck,G=fa.pluckNumber,Ua=fa.getFirstColor,na=fa.graphics.convertColor,ia=fa.bindSelectionEvent,Va=fa.parseUnsafeString,Za=fa.componentDispose,U=fa.Raphael,qa=fa.toRaphaelColor,Oa=fa.hasTouch,$a=fa.plotEventHandler,fb=fa.getMouseCoordinate,Ga=!fa.CREDIT_REGEX.test(oa.location.hostname),Fa="rgba(192,192,192,"+(Da?.002:
1E-6)+")",wa=Math,Ea=wa.ceil,xa=wa.floor,va=wa.round,pa=wa.max,La=wa.min,ra=wa.cos,za=wa.sin,Ba=oa.parseFloat,Ha=oa.parseInt,ta;ua(fa.eventList,{zoomed:"FC_Zoomed",pinned:"FC_Pinned",resetzoomchart:"FC_ResetZoomChart"});ma("zoomline",{standaloneInit:!0,canvasborderthickness:1,defaultDatasetType:"zoomline",applicableDSList:{zoomline:!0},friendlyName:"Zoomable and Panable Multi-series Line Chart",creditLabel:Ga,_drawAxis:function(){var a=this.components.yAxis||[],b,c;b=0;for(c=a.length;b<c;b++)a[b].draw()},
_setCategories:function(){var a=this.config,b=this.jsonData,c=this.components.xAxis,h,m,f;m=a.cdmchar;var q=b.categories&&b.categories[0].category||[];if((a.cdm||"string"===typeof q)&&q.split){a=q.split(m);h=[];m=0;for(f=a.length;m<f;m+=1)h.push({label:a[m]});this.config.categories=b.categories[0].category=h}c[0].setAxisPadding(0,0);c[0].setCategory(h||q)},_createDatasets:function(){var a,b,c,h,m,f,q,v,A;m={};var n=this.config;a=this.components;v=this.jsonData;var C=v.dataset,p=C&&C.length,I=n.cdmchar,
K=n.cdm,B=this.defaultDatasetType,k=this.applicableDSList,n=this.components.legend.components.items||[];v=v.categories&&v.categories[0].category;C&&v||this.setChartMessage();this.config.categories=v;v=a.dataset||(a.dataset=[]);A=v.length;for(a=0;a<p;a++){q=C[a];if(K&&q.data&&q.data.split){f=q.data.split(I);h=[];b=0;for(c=f.length;b<c;b++)h.push({value:f[b]});q.data=h}b=q.parentyaxis||"";b=(b=this.isDual&&"s"===b.toLowerCase()?sa(q.renderas,this.sDefaultDatasetType):sa(q.renderas,B))&&b.toLowerCase();
k[b]||(b=B);if(c=la.get("component",["dataset",b]))void 0===m[b]?m[b]=0:m[b]++,(b=v[a])?(c=(b.JSONData.data||[]).length,h=(q.data||[]).length,c>h&&b.removeData(h,c-h,!1),v[a].JSONData=q,v[a].configure(),v[a]._deleteGridImages&&v[a]._deleteGridImages()):(b=new c,v.push(b),b.chart=this,b.index=a,b.init(q))}if(A>p){m=A-p;b=a;for(p=m+a;b<p;b++)Za.call(v[b]);v.splice(a,m);n.splice(a,m)}},isWithinCanvas:function(a,b){var c=fa.getMouseCoordinate(b.get("linkedItems","container"),a),h=c.chartX,m=c.chartY,
f=b.get("config"),q=f.canvasLeft,v=f.canvasTop,A=f.canvasLeft+f.canvasWidth,f=f.canvasHeight+f.canvasTop;c.insideCanvas=!1;c.originalEvent=a;h>q&&h<A&&m>v&&m<f&&(c.insideCanvas=!0);return c},highlightPoint:function(a,b,c,h,m,f){var q=this,v=q.config,A=q.components,n=q.graphics,C=A.paper,p=n.tracker,I=(A=A.dataset[m])&&A.config;m=A&&I.zoomedRadius||0;var K=A&&I.hoverCosmetics,A=K&&K.fill,I=K&&K.borderColor,K=K&&K.borderThickness,B={},B=function(a){fa.plotEventHandler.call(this,q,a)},k=function(a){fa.plotEventHandler.call(this,
q,a,"dataplotRollover")},x=function(a){fa.plotEventHandler.call(this,q,a,"dataplotRollout")};p||(p=n.tracker=C.circle(0,0,0,n.trackerGroup).attr({"clip-rect":v.canvasLeft+","+v.canvasTop+","+v.canvasWidth+","+v.canvasHeight}).click(B).trackTooltip(!0).hover(k,x));h&&p.data("eventArgs",{x:h.x,y:h.y,tooltip:h.tooltip,link:h.link});v.lastHoveredPoint=h;B=Number(a)?{r:m,fill:A,stroke:I,"stroke-width":K}:{r:m,fill:Fa,stroke:Fa,"stroke-width":0};p.attr(B).tooltip(f).transform("t"+(b+v.canvasLeft)+","+(c+
v.canvasTop));h&&q.fireMouseEvent("mouseover",p&&p.node,v.lastMouseEvent)},fireMouseEvent:function(a,b,c){var h;b&&a&&(c||(c={}),c.originalEvent&&(c=c.originalEvent),c.touches&&(c=c.touches[0]),b.dispatchEvent?(Ma?h=new Ma(a,{bubbles:!!c.bubbles,cancelable:!!c.cancelable,clientX:c.clientX||c.pageX&&c.pageX-ha.body.scrollLeft-ha.documentElement.scrollLeft||0,clientY:c.clientY||c.pageY&&c.pageY-ha.body.scrollTop-ha.documentElement.scrollTop||0,screenX:c.screenX||0,screenY:c.screenY||0,pageX:c.pageX||
0,pageY:c.pageY||0}):ha.createEvent&&(h=ha.createEvent("HTMLEvents"),h.initEvent(a,!!c.bubbles,!!c.cancelable)),h.eventName=a,h&&b.dispatchEvent(h)):ha.createEventObject&&b.fireEvent&&(h=ha.createEventObject(),h.eventType=a,h.eventName=a,b.fireEvent("on"+a,h)))},configure:function(){var a,b=this.jsonData.chart||{},c=this.components.colorManager,h=c.getColor("canvasBorderColor"),m;b.animation=0;b.showvalues=0;ma.msline.configure.call(this);m=this.config;a=m.style;ua(m,{useRoundEdges:G(b.useroundedges,
0),animation:!1,zoomType:"x",canvasPadding:G(b.canvaspadding,0),scrollColor:Ua(sa(b.scrollcolor,c.getColor("altHGridColor"))),scrollShowButtons:!!G(b.scrollshowbuttons,1),scrollHeight:G(b.scrollheight,16)||16,scrollBarFlat:G(b.flatscrollbars,0),allowPinMode:G(b.allowpinmode,1),skipOverlapPoints:G(b.skipoverlappoints,1),showToolBarButtonTooltext:G(b.showtoolbarbuttontooltext,1),btnResetChartTooltext:sa(b.btnresetcharttooltext,"Reset Chart"),btnZoomOutTooltext:sa(b.btnzoomouttooltext,"Zoom out one level"),
btnSwitchToZoomModeTooltext:sa(b.btnswitchtozoommodetooltext,"<strong>Switch to Zoom Mode</strong><br/>Select a subset of data to zoom into it for detailed view"),btnSwitchToPinModeTooltext:sa(b.btnswitchtopinmodetooltext,"<strong>Switch to Pin Mode</strong><br/>Select a subset of data and compare with the rest of the view"),pinPaneFill:na(sa(b.pinpanebgcolor,h),G(b.pinpanebgalpha,15)),zoomPaneFill:na(sa(b.zoompanebgcolor,"#b9d5f1"),G(b.zoompanebgalpha,30)),zoomPaneStroke:na(sa(b.zoompanebordercolor,
"#3399ff"),G(b.zoompaneborderalpha,80)),showPeakData:G(b.showpeakdata,0),maxPeakDataLimit:G(b.maxpeakdatalimit,b.maxpeaklimit,null),minPeakDataLimit:G(b.minpeakdatalimit,b.minpeaklimit,null),crossline:{enabled:G(b.showcrossline,1),line:{"stroke-width":G(b.crosslinethickness,1),stroke:Ua(sa(b.crosslinecolor,"#000000")),"stroke-opacity":G(b.crosslinealpha,20)/100},labelEnabled:G(b.showcrosslinelabel,b.showcrossline,1),labelstyle:{fontSize:Ba(b.crosslinelabelsize)?Ba(b.crosslinelabelsize)+"px":a.outCanfontSize,
fontFamily:sa(b.crosslinelabelfont,a.outCanfontFamily)},valueEnabled:G(b.showcrosslinevalues,b.showcrossline,1),valuestyle:{fontSize:Ba(b.crosslinevaluesize)?Ba(b.crosslinevaluesize)+"px":a.inCanfontSize,fontFamily:sa(b.crosslinevaluefont,a.inCanvasStyle.fontFamily)}},useCrossline:G(b.usecrossline,1),tooltipSepChar:sa(b.tooltipsepchar,", "),showTerminalValidData:G(b.showterminalvaliddata,0),cdmchar:sa(b.dataseparator,"|"),cdm:G(b.compactdatamode,0)})},getValuePixel:function(a){var b=this.config.viewPortConfig;
return b.ddsi+xa(a/b.ppp)},__toolbar:function(){var a,b,c,h,m=this,f=m.components,q=f.tb=new (la.register("component",["toolbox","toolbox"])),v=q.getDefaultConfiguration(),A,n;q.init({iAPI:{chart:m},graphics:m.graphics,chart:m,components:f});a=f.toolBoxAPI||q.getAPIInstances(q.ALIGNMENT_HORIZONTAL);b=a.SymbolStore;c=a.ComponentGroup;h=a.Toolbar;A=a.Symbol;n=a.Scroller;q.graphics={};return{reInit:function(){q.init({iAPI:{chart:m},graphics:m.graphics,chart:m,components:f})},addSymbol:function(a,b,c,
f){a=new A(a);c&&f.setConfiguaration({buttons:ua(ua({},v),c)});b.tooltext=c.tooltip;b&&a.attachEventHandlers(b);f.addSymbol(a);return a},addScroll:function(a,b){var c=new n(a);b&&c.attachEventHandlers(b);return c},addComponentGroup:function(a,b){var f;f=new c;f.setConfiguaration({group:{fill:b?b.fill:na("EBEBEB",0),borderThickness:b?G(b.borderThickness,0):0}});return f},addToolBox:function(a){var b,c=new h;for(b=0;b<a.length;b+=1)c.addComponent(a[b]);return c},setDrawingArea:function(a,b){a.drawingArea=
b;return a},draw:function(a){var b,c,f;for(b=0;b<a.length;b+=1)c=a[b],f=c.drawingArea,c.draw(f.x,f.y)},registerSymbol:function(a,c){b.register(a,c)},getLogicalSpace:function(a){return a.getLogicalSpace()},getNode:function(a){return a.node}}},__preDraw:function(){var a,b,c,h,m,f,q,v,A,n,C=this,p=C.components,I=p.paper,K=C.graphics;b=K.imageContainer;var B=C.config,k=B.canvasLeft,x=B.canvasWidth;a=C.jsonData.chart;var aa=B.cdm;c=p.xAxis[0];var N=B.viewPortConfig,D=C.components.canvas.config,Z=pa(D.canvasPadding,
D.canvasPaddingLeft,D.canvasPaddingRight);n=p.yAxis[0];v=K.datasetGroup;var D=B.canvasHeight,X=B.canvasTop,d=C.jsonData.chart,d=B.borderWidth||(B.borderWidth=G(d.showborder,1)?G(d.borderthickness,1):0),L=B.allowPinMode,g=B.crossline,N=c.getCategoryLen(),R=Ha(G(a.displaystartindex,1),10)-1,l=Ha(G(a.displayendindex,N||2),10)-1,e=0,ba=p.dataset,fa=ba.length,p=K.crossline;B.updateAnimDuration=500;b.transform("t"+k+","+X);b.attr({"clip-rect":k+","+X+","+x+","+D});B.status="zoom";B.maxZoomLimit=G(a.maxzoomlimit,
1E3);B.viewPortHistory=[];1>(b=G(a.pixelsperpoint,15))&&(b=1);(c=G(a.pixelsperlabel,a.xaxisminlabelwidth,c.getAxisConfig("labels").rotation?20:60))<b&&(c=b);(0>R||R>=(N-1||1))&&(R=0);(l<=R||l>(N-1||1))&&(l=N-1||1);N=B.viewPortConfig=ua(B.viewPortConfig,{amrd:G(a.anchorminrenderdistance,20),nvl:G(a.numvisiblelabels,0),cdm:aa,oppp:b,oppl:c,dsi:R,dei:l,vdl:l-R,clen:N,offset:0,step:1,llen:0,alen:0,ddsi:R,ddei:l,ppc:0});if(N.clen){for(;fa--;)a=ba[fa].config,e=pa(e,a.drawanchors&&(a.anchorradius||0)+(Number(a.anchorborderthickness)||
0)||0);B.overFlowingMarkerWidth=e;Z=B.canvasPadding=pa(e,Z);B._prezoomed=N.dei-N.dsi<N.clen-1;h=B._visw=B.canvasWidth-2*Z;m=B._visx=B.canvasLeft+Z;B._visout=-(B.height+D+1E3);B._ypvr=n&&n.getPVR()||0;a=B._yminValue=n.getLimit().min;f=B._ymin=n.getPixel(a);n=v.attr("clip-rect",[m-e,X,h+2*e,D]);K.scroll||(K.scroll=I.group("scroll").insertAfter(K.datasetGroup));L&&(v=U.crispBound(0,X-f,0,D,d),q=B["clip-pinrect"]=[v.x,X,v.width,v.height],A=(K.zoompin=I.group("zoompin")).insertBefore(n).transform(B._pingrouptransform=
["T",m,f]).hide(),K.pinrect=I.rect(0,X-f,h,D,A).attr({"stroke-width":0,stroke:"none",fill:B.pinPaneFill,"shape-rendering":"crisp",ishot:!0}),K.pintracker=I.rect(K.trackerGroup).attr({transform:A.transform(),x:0,y:X-f,width:0,height:D,stroke:"none",fill:Fa,ishot:!0,cursor:U.svg&&"ew-resize"||"e-resize"}).hide().drag(function(a){var b=m+a+this.__pindragdelta,c=this.__pinboundleft,e=this.__pinboundright,d=this.data("cliprect").slice(0);b<c?b=c:b>e&&(b=e);A.transform(["T",b,f]);K.pintracker.transform(A.transform());
U.svg||(d[0]=d[0]+b-m-this.__pindragdelta,A.attr("clip-rect",d));this.__pindragoffset=a},function(){this.__pinboundleft=0-q[0]+m+k;this.__pinboundright=this.__pinboundleft+h-q[2];this.data("cliprect",A.attr("clip-rect"));A._.clipispath=!0},function(){A._.clipispath=!1;this.__pindragdelta=this.__pindragoffset;delete this.__pindragoffset;delete this.__pinboundleft;delete this.__pinboundright}));d++;v=U.crispBound(k-d,X+D+d,x+d+d,B.scrollHeight,d);d--;ia(C,{attr:{stroke:B.zoomPaneStroke,fill:B.zoomPaneFill,
strokeWidth:0},selectionStart:function(){},selectionEnd:function(a){var b=a.selectionLeft-k;a=b+a.selectionWidth;K.crossline&&K.crossline.hide();C[B.viewPortConfig.pinned?"pinRangePixels":"zoomRangePixels"](b,a)}});g&&0!==g.enabled&&1===B.useCrossline?(p||(p=K.crossline=new ta),p.configure(C,g)):(g&&(g.enabled=0),p&&p.hide())}},resetZoom:function(){var a=this.config.viewPortHistory,b=a[0];if(!a.length)return!1;a.length=0;this.zoomTo(b.dsi,b.dei,b)&&Aa.raiseEvent("zoomReset",this._zoomargs,this.chartInstance,
[this.chartInstance.id]);return!0},eiMethods:{zoomOut:function(){var a;if(a=this.apiInstance)return a.zoomOut&&a.zoomOut()},zoomTo:function(a,b){var c;if(c=this.apiInstance)return c.zoomRange&&c.zoomRange(a,b)},resetChart:function(){var a;if(a=this.apiInstance)a.pinRangePixels&&a.pinRangePixels(),a.resetZoom&&a.resetZoom()},setZoomMode:function(a){var b;(b=this.apiInstance)&&b.activatePin&&b.activatePin(!a)},getViewStartIndex:function(){var a;if(this.apiInstance&&(a=this.apiInstance.config.viewPortConfig))return a.ddsi},
getViewEndIndex:function(){var a,b;if(this.apiInstance&&(a=this.apiInstance.config.viewPortConfig))return b=a.ddei-1,(b>=a.clen?a.clen:b)-1}},zoomOut:function(){var a,b,c=this.config;b=c.viewPortHistory;var h,m,f;a=b.pop();b=b[0]||c.viewPortConfig;a?(h=a.dsi,m=a.dei):c._prezoomed&&(h=0,m=b.clen-1);(f=this.zoomTo(h,m,a))&&Aa.raiseEvent("zoomedout",f,this.chartInstance);return!0},zoomRangePixels:function(a,b){var c=this.config,h=c.viewPortHistory,c=c.viewPortConfig,m=c.ppp,f=c.ddsi,q;h.push(c);(q=this.zoomTo(f+
xa(a/m),f+xa(b/m)))?Aa.raiseEvent("zoomedin",q,this.chartInstance):h.pop()},zoomRange:function(a,b){var c,h,m=this.config,f=m.viewPortConfig;h=this.components.xAxis[0];var q=m.viewPortHistory,v;q.push(f);c=h.getPixel(a);h=h.getPixel(b);f.x=c;f.scaleX=m.canvasWidth/(c-h);(v=this.zoomTo(+a,+b))?Aa.raiseEvent("zoomedin",v,this.chartInstance):q.pop()},zoomTo:function(a,b,c){var h,m;h=this.config;var f=this.components,q=h.viewPortConfig,v=h.canvasHeight;m=h.canvasLeft;var A=h.canvasTop,n=h.canvasBottom,
C=h.viewPortHistory,p=q.clen,I=this.components.xAxis[0];0>a&&(a=0);a>=p-1&&(a=p-1);b<=a&&(b=a+1);b>p-1&&(b=p-1);if(a===b||a===q.dsi&&b===q.dei)return!1;this.pinRangePixels();q=ua({},q);q.dsi=a;q.dei=b;q=h.viewPortConfig=q;c?this.updateVisual(c.x,c.y,c.scaleX,c.scaleY):(c=I.getPixel(a),h=I.getPixel(b),m=this.getOriginalPositions(c-m,A,h-m,n-A),this.zoomSelection(m[0],0,m[2],v));f.scrollBar.node.attr({"scroll-ratio":q.vdl/(p-!!p),"scroll-position":[q.dsi/(p-q.vdl-1),!0]});f={level:C.length+1,startIndex:a,
startLabel:I.getLabel(a).label,endIndex:b,endLabel:I.getLabel(b).label};Aa.raiseEvent("zoomed",f,this.chartInstance,[this.chartInstance.id,a,b,f.startLabel,f.endLabel,f.level]);return f},activatePin:function(a){var b=this.config.viewPortConfig,c=this.components.tb.graphics.pinButton;if(b.pinned^(a=!!a))return a||this.pinRangePixels(),Aa.raiseEvent("zoomModeChanged",{pinModeActive:a},this.chartInstance,[]),this.updateButtonVisual(c.node,a?"pressed":"enable"),b.pinned=a},updateButtonVisual:function(a,
b){return a.attr({disable:{config:{hover:{fill:"#FFFFFF","stroke-width":1,stroke:"#E3E3E3",cursor:"default"},normal:{fill:"#FFFFFF",stroke:"#E3E3E3","stroke-width":1,cursor:"default"},disable:{fill:"#FFFFFF","stroke-width":1,stroke:"#E3E3E3","stroke-opacity":1,cursor:"default"},pressed:{fill:"#FFFFFF","stroke-width":1,stroke:"#E3E3E3",cursor:"default"}},"button-disabled":!1,stroke:"#E3E3E3","stroke-opacity":1},enable:{config:{hover:{fill:"#FFFFFF","stroke-width":1,stroke:"#aaaaaa",cursor:"pointer"},
normal:{fill:"#FFFFFF",stroke:"#C2C2C2","stroke-width":1,cursor:"pointer"},disable:{fill:"#FFFFFF","stroke-width":1,stroke:"#E3E3E3","stroke-opacity":1,cursor:"pointer"},pressed:{fill:"#EFEFEF","stroke-width":1,stroke:"#C2C2C2",cursor:"pointer"}},"button-disabled":!1,fill:["#FFFFFF","#FFFFFF","#FFFFFF","#FFFFFF",!0],stroke:"#C2C2C2","stroke-opacity":1},pressed:{config:{pressed:{fill:["#FFFFFF","#FFFFFF","#FFFFFF","#FFFFFF",!0]}},fill:["#FFFFFF","#FFFFFF","#FFFFFF","#FFFFFF",!0],stroke:"#E3E3E3"}}[b])},
pinRangePixels:function(a,b){var c,h=this.components,m=h.paper,f=this.graphics,q=this.config,v=q.canvasLeft,A=q.viewPortConfig,n=f.zoompin;c=f.pinrect;var C=q["clip-pinrect"],p=q._pingrouptransform,h=h.dataset,I=b-a,K,B,k,f=f.pintracker;if(A&&n&&c){if(a===b)return n.hide(),f.hide(),A.pinned=!1;for(k=h.length;k--;)K=h[k],c=K.graphics,B=c.pinline,B||(B=c.pinline=m.path(n)),B.attr({path:c.lineElement.attrs.path,transform:["T",-q._visx,-q._ymin]}).attr(K.config.pin);C[0]=a+v;C[2]=I;n.attr({"clip-rect":C,
transform:p}).show();f.__pindragdelta=0;f.show().attr({transform:p,x:a,width:I});this.getValuePixel(a);this.getValuePixel(b);return A.pinned=!0}},_createLayers:function(){var a,b=this.components.paper;ma.scatter._createLayers.call(this);a=this.graphics;a.imageContainer=b.group("dataset-orphan",a.dataSetGroup);this.__preDraw();this.toogleDragPan(!0)},getValue:function(a){var b=this.config,c=this.components,h=b.viewPortConfig;a=this.getOriginalPositions(a.x,a.y,a.x,a.y);var m=c.xAxis[0].config.axisRange,
c=c.yAxis[0].config.axisRange,f=m.min,q=c.max;return{x:f+(a[0]-b.canvasLeft)/(b.canvasWidth*h.scaleX/(m.max-f)),y:q-(a[1]-b.canvasTop)/(b.canvasHeight*h.scaleY/(q-c.min))}},getOriginalPositions:function(a,b,c,h){var m=this.config,f=m.viewPortConfig,q=f.scaleX,v=f.scaleY,A=f.x,f=f.y,n=La(a,c);a=pa(a,c);c=La(b,h);b=pa(b,h);a=a>m.canvasWidth?m.canvasWidth:a;b=b>m.canvasHeight?m.canvasHeight:b;n=0>n?0:n;c=0>c?0:c;return[A+n/q,f+c/v,(a-n)/q,(b-c)/v]},zoomSelection:function(a,b,c,h){var m=this.config;c&&
h&&(c=Math.abs(m.canvasWidth/c),h=Math.abs(m.canvasHeight/h),this.updateVisual(a,b,c,h))},updateVisual:function(a,b,c,h,m){var f=this.config,q=f.viewPortConfig,v=f.canvasWidth,A=f.canvasHeight,n=f.viewPortHistory.slice(-1)[0]||q,f=f.maxZoomLimit;q.x=isNaN(a)?a=n.x:a;q.y=isNaN(b)?b=n.y:b;q.scaleX=c||(c=n.scaleX);q.scaleY=h||(h=n.scaleY);c>f&&(q.x=La(a,v-v/f),q.scaleX=f);h>f&&(q.y=La(b,A-A/f),q.scaleY=f);this.updateManager(m)},toogleDragPan:function(a){var b=this.config.viewPortConfig,c=b.status;a&&
(b.status="zoom"===c?"pan":"zoom")},resize:function(){var a=this.config,b=this.graphics,c=this.components.canvas,h=c.graphics,m=h.canvasBorderElement,h=h.canvasElement,c=c.config.canvasBorderThickness,f=c/2,q=a.canvasHeight-=c,v=a.canvasWidth-=2*c,A=a.canvasLeft+=c;a.canvasBottom-=c;a.canvasRight-=c;h?h.attr({x:A,y:a.canvasTop,height:q,width:v}):this.drawCanvas();m&&m.attr({x:A-f,y:a.canvasTop-f,height:q+c,width:v+c,"stroke-width":c});b.imageContainer.attr({"clip-rect":a.canvasLeft+","+a.canvasTop+
","+a.canvasWidth+","+a.canvasHeight}).transform("t"+a.canvasLeft+","+a.canvasTop);b.trackerElem.attr({x:a.canvasLeft,y:a.canvasTop,width:a.canvasWidth,height:a.canvasHeight});b.tracker&&b.tracker.attr({"clip-rect":a.canvasLeft+","+a.canvasTop+","+a.canvasWidth+","+a.canvasHeight})},updateManager:function(a){var b,c;c=this.components;var h=c.dataset,m=h.length;b=this.config;var f=b.viewPortConfig,q=b._ypvr,v=b._visw,A=this.components.xAxis[0],n=function(){return A.getPixel.apply(A,arguments)},C=A.getAxisConfig("labels").style,
p,I,K,B,k,x=this.updateButtonVisual,G=c.tb.graphics,N=G.zoomOutButton,G=G.resetButton,D=b.viewPortHistory;if(b.legendClicked)for(a=0;a<m;a+=1)h[a].draw();else{!f&&(f=b.viewPortConfig);p=f.oppp;k=K=f.nvl;I=f.dsi;K=f.dei;I=f.vdl=K-I;K=f.ppl=k?v/k:f.oppl;v=f.step=(B=f.ppp=v/I)<p?Ea(p/B):1;C=f.lskip=Ea(pa(K,Ba(C.lineHeight))/B/v);void 0!==a?(p=(f.clen-I-1)*a,f.offset=(p-(p=Ha(p)))*B,I=p+I):(p=f.dsi,I=f.dei,f.offset=0);B=f.norm=p%v;f.ddsi=p-=B;f.ddei=I=I+2*v-B;f.pvr=q;f._ymin=b._ymin;f._yminValue=b._yminValue;
f.x=(n(p)-n(A.getLimit().min)+f.offset)/f.scaleX;I-p>A.getCategoryLen()?f.scaleX=1:f.scaleX=A.getCategoryLen()/Math.abs(I-p-v-.9);void 0!==a&&c.scrollBar.node&&c.scrollBar.node.attr({"scroll-position":f._pos=a});c=A._getVisibleConfig();c=Math.ceil((c.maxValue-c.minValue+1)/k);b=b.viewPortConfig&&b.viewPortConfig.scaleX;b=Math.max(Math.round(A.getAxisConfig("labelStep")/b),k?c:C*v);A.setLabelConfig({step:b});b=A.getAxisConfig("animateAxis");k=A.getAxisConfig("drawAxisName");a&&A.setAxisConfig({animateAxis:!1,
drawAxisName:!1});A.draw();A.setAxisConfig({animateAxis:b,drawAxisName:k});for(a=0;a<m;a+=1)h[a].draw();x(N.node,f.vdl===f.clen-1?"disable":"enable");x(G.node,0<D.length?"enable":"disable");oa.FC_DEV_ENVIRONMENT&&oa.jQuery&&(la["debugger"].enable()?(this.debug=this.debug||(oa.jQuery("#fc-zoominfo").length||oa.jQuery("body").append('<pre id="fc-zoominfo">'),oa.jQuery("#fc-zoominfo").css({position:"absolute",left:"10px",top:"0","pointer-events":"none",opacity:.7,width:"250px",zIndex:"999",border:"1px solid #cccccc",
"box-shadow":"1px 1px 3px #cccccc",background:"#ffffff"})),this.debug.text(JSON.stringify(f,0,2))):(this.debug&&oa.jQuery("#fc-zoominfo").remove(),delete this.debug))}},_drawDataset:function(){ma.zoomline.updateManager.call(this)},getParsedLabel:function(a){var b=this.xlabels;return b.parsed[a]||(b.parsed[a]=Va(b.data[a]||""))},_createToolBox:function(){var a,b,c,h,m,f,q,v=this,A=v.config;q=A.allowPinMode;h=v.components;var n=A.showToolBarButtonTooltext;a=h.chartMenuBar;b=h.actionBar;a&&a.drawn||
b&&b.drawn||(ma.scrollcolumn2d._createToolBox.call(v),a=h.tb,b=a.graphics||(a.graphics={}),c=h.toolBoxAPI||a.getAPIInstances(a.ALIGNMENT_HORIZONTAL),c=c.Symbol,h=(h.chartMenuBar||h.actionBar).componentGroups[0],m=b.zoomOutButton=(new c("zoomOutIcon",void 0,a.idCount++,a.pId)).attachEventHandlers({click:function(){v.zoomOut()},tooltext:n&&A.btnZoomOutTooltext||""}),f=b.resetButton=(new c("resetIcon",void 0,a.idCount++,a.pId)).attachEventHandlers({click:function(){v.resetZoom()},tooltext:n&&A.btnResetChartTooltext||
""}),q&&(q=b.pinButton=(new c("pinModeIcon",void 0,a.idCount++,a.pId)).attachEventHandlers({click:function(){v.activatePin(!A.viewPortConfig.pinned)},tooltext:n&&A.btnSwitchToPinModeTooltext||""}),h.addSymbol(q,!0)),h.addSymbol(f,!0),h.addSymbol(m,!0))},_scrollBar:ma.scrollcolumn2d,_manageScrollerPosition:ma.scrollcolumn2d,draw:function(){var a,b,c,h,m,f,q,v,A,n,C=this,p=C.config,I=C.graphics||(C.graphics={});f=C.components;a=C.jsonData;h=a.dataset;var K=a.categories&&a.categories[0].category,B;ma.msline.draw.call(C);
q=p.canvasLeft;v=p.canvasTop;A=p.canvasHeight;n=p.canvasWidth;a=p.borderWidth;b=p.useRoundEdges;c=p.viewPortConfig;(B=I.toolboxParentGroup)||(B=I.toolboxParentGroup=f.paper.group("toolbarParentGroup",I.parentGroup));h&&K&&(a++,h=U.crispBound(q-a,v+A+a,n+a+a,p.scrollHeight,a),a--,f=(m=f.scrollBar)&&m.node,m.draw(h.x+(b&&-1||a%2),h.y-(b&&4||2),{isHorizontal:!0,width:h.width-(!b&&2||0),height:h.height,showButtons:p.scrollShowButtons,scrollRatio:c.vdl/(c.clen-!!c.clen),scrollPosition:[c.dsi/(c.clen-c.vdl-
1),!1],r:b&&2||0,parentLayer:B.insertBefore(I.datalabelsGroup)}),!f&&function(){var a;U.eve.on("raphael.scroll.start."+m.node.id,function(b){a=b;C.graphics.crossline&&C.graphics.crossline.disable(!0);Aa.raiseEvent("scrollstart",{scrollPosition:b},C.chartInstance)});U.eve.on("raphael.scroll.end."+m.node.id,function(b){C.graphics.crossline&&C.graphics.crossline.disable(!1);Aa.raiseEvent("scrollend",{prevScrollPosition:a,scrollPosition:b},C.chartInstance)})}())}},ma.msline,{showValues:0,zeroplanethickness:1,
zeroplanealpha:40,showzeroplaneontop:0});ma("zoomlinedy",{standaloneInit:!0,defaultDatasetType:"zoomline",applicableDSList:{zoomline:!0},creditLabel:Ga,friendlyName:"Zoomable and Panable Multi-series Dual-axis Line Chart",_spaceManager:ma.msdybasecartesian._spaceManager,_setAxisLimits:ma.msdybasecartesian._setAxisLimits,_createAxes:ma.msdybasecartesian._createAxes,_feedAxesRawData:ma.msdybasecartesian._feedAxesRawData},ma.zoomline,{isdual:!0});la.register("component",["dataset","zoomline",{_setConfigure:function(){var a=
this.config,b=this.chart.jsonData.chart,c=this.JSONData;a.drawanchors=G(b.drawanchors,b.showanchors,1);a.anchorradius=G(c.anchorradius,b.anchorradius,a.linethickness+2);this.__base__._setConfigure.apply(this,arguments)},configure:function(){var a,b,c={};a=this.chart.jsonData.chart;a.animation=0;a.showvalues=G(a.showvalues,0);this.__base__.configure.call(this);b=this.config;a=b.linethickness+G(a.pinlinethicknessdelta,1);c["stroke-width"]=0<a&&a||0;c["stroke-dasharray"]=[3,2];c.stroke=fa.hashify(b.linecolor);
c["stroke-opacity"]=b.alpha/100;c["stroke-linejoin"]=b["stroke-linejoin"]="round";c["stroke-linecap"]=b["stroke-linecap"]="round";b.pin=c;b.animation=!1;b.transposeanimduration=0},draw:function(){var a,b,c,h=!1,m=!1,f=this,q=f.JSONData,v=f.chart,A=v.components,n=f.config,C=f.index||f.positionIndex,p=v.config,I=v.jsonData.chart,K=f.components,B=K.data,k=B.length,x,aa=A.paper,N=A.xAxis[0],D=f.yAxis,Z,X,d=v.graphics,L=d.datalabelsGroup,g=fa.parseUnsafeString,U=fa.getValidValue,l,e,ba,ha,r,w,u,F,t,ia,
ma=n.linethickness,la=f.graphics.container,oa=f.graphics.trackerContainer,ta=function(a){$a.call(this,v,a)},ua=function(a){var b=this.data("dataObj");b.config.hoverEffects&&b&&b.graphics&&b.graphics.element&&f._hoverPlotAnchor(b,"DataPlotRollOver",I);$a.call(this,v,a,"DataPlotRollOver")},va=function(a){var b=this.data("dataObj");b.config.hoverEffects&&b&&b.graphics&&b.graphics.element&&f._hoverPlotAnchor(b,"DataPlotRollOut",I);$a.call(this,v,a,"DataPlotRollOut")},wa=p.viewPortConfig,P=p.showtooltip,
xa,ra=d.datasetGroup,na,za=n.shadow,J,y=f.graphics.dataLabelContainer,z={},H,S,O=v.is3D,W=n.use3dlineshift,E,T,Q,Aa=D.getAxisBase(),Ba=D.yBasePos=D.getAxisPosition(Aa),ga=N.getAxisPosition(0),Da=N.getAxisPosition(1)-ga,Ea,ja=O?10:0,M=O&&W?10:0,ea=[pa(0,p.canvasLeft-ja),pa(0,p.canvasTop-M),pa(1,p.canvasWidth+2*ja),pa(1,p.canvasHeight+M)],V=[pa(0,p.canvasLeft-ja),pa(0,p.canvasTop-M),1,pa(1,p.canvasHeight+2*M)],ka={},Ha=v.hasScroll||!1,da,Ga=n.lineDashStyle,Ka={color:n.linecolor,alpha:n.alpha};[qa(Ka),
Ga].join(":");var Na,Oa,Ma,Wa=f.graphics.lineElement,Xa=f.visible,Ua,Va,ya=f.pool||(f.pool={element:[]}),Za={},Y={},ca={},kb=n.anchorradius,lb,gb=[],mb,Ca,bb,cb,hb,ib,tb=p.showTerminalValidData,Ya=p.viewPortConfig,ub=p.showPeakData,nb=p.maxPeakDataLimit,ob=p.minPeakDataLimit,pb=G(p.useCrossline,0),Pa=Ya.step,jb=N.getPixel(Ya.step)-ga<Ya.amrd,qb=function(b,c){var d=b.graphics;S=b.config;r=S.setValue;ha=S.setLink;Ua=S.x||c;T=U(g(sa(S.setLevelTooltext,q.plottooltext,I.plottooltext)));E=S.showValue;z=
S.anchorProps;J=z.shadow;u=S.displayValue;Va=S.dip||0;b||(b=B[c]={graphics:{}});Ma={color:S.color,alpha:S.alpha};Q=S.dashStyle;Z=S.xPos||N.getAxisPosition(Ua)-ja;X=f.visible?D.getAxisPosition(r)+M:Ba;na=S.hoverEffects;z.isAnchorHoverRadius=na.anchorRadius;lb=N.getLabel(c);l=pb?"":S.toolText+(T?"":S.toolTipValue);w={index:c,link:ha,value:r,displayValue:u,categoryLabel:lb,toolText:l,id:n.userID,datasetIndex:C,datasetName:q.seriesname,visible:Xa};null===S.setValue||jb||(z.imageUrl?(H=new R,H.onload=
f._onAnchorImageLoad(f,c,w,Z,X),H.onerror=f._onErrorSetter(Z,X,c,f),H.src=z.imageUrl):(e=d.element,e||(e=ya.element&&ya.element.length?d.element=ya.element.shift():d.element=aa.polypath(la.anchorGroup)),e.attr({polypath:[z.symbol[1]||2,Z,X,z.radius,z.startAngle,Va],fill:qa({color:z.bgColor,alpha:z.bgAlpha}),stroke:qa({color:z.borderColor,alpha:z.borderAlpha}),"stroke-width":z.borderThickness,visibility:z.radius?Xa:"hidden"}).shadow(J,la.anchorShadowGroup).data("anchorRadius",z.radius).data("anchorHoverRadius",
na.anchorRadius).data("setRolloverAttr",ia).data("setRolloutAttr",t),e[r||0===r?"show":"hide"]()),ia={polypath:[na.anchorSides||2,Z,X,na.anchorRadius,na.startAngle,na.dip],fill:qa({color:na.anchorColor,alpha:na.anchorBgAlpha}),stroke:qa({color:na.anchorBorderColor,alpha:na.anchorBorderAlpha}),"stroke-width":na.anchorBorderThickness},t={polypath:[z.sides,Z,X,z.radius,z.startAngle,Va],fill:qa({color:z.bgColor,alpha:z.bgAlpha}),stroke:qa({color:z.borderColor,alpha:z.borderAlpha}),"stroke-width":z.borderThickness},
e&&e.data("anchorRadius",z.radius).data("anchorHoverRadius",na.anchorRadius).data("setRolloverAttr",ia).data("setRolloutAttr",t),kb=pa(z.radius,na&&na.anchorRadius||0),xa={cx:Z,cy:X,r:kb,cursor:ha?"pointer":"",stroke:Fa,"stroke-width":z.borderThickness,fill:Fa,ishot:!0,visibility:Xa},z.imageUrl||!ha&&!P||(ba=d.hotElement,ba||(ya.hotElement&&ya.hotElement.length?ba=d.hotElement=ya.hotElement.shift():(a=!0,ba=d.hotElement=aa.circle(oa))),ba.show().attr(xa),(ba||e).data("eventArgs",w).data("groupId",
void 0).data("dataObj",b),a&&(ba||e).click(ta).hover(ua,va),a=!1));b._xPos=Z;b._yPos=X;[qa(Ma||Ka),Q||Ga].join(":");ca=f.getLinePath([b],ca);Na=qa(Ma||Ka);Oa=Q||Ga;sa(S.setColor,S.setAlpha,S.setDashed);[Na,Oa].join(":");E&&!z.imageUrl&&f.drawLabel(c);gb.push(b)},vb=function(a,b){var c=a&&a.length,d=a.slice().sort(function(a,b){return a.config.setValue-b.config.setValue}),f=d&&d.pop().config.setValue,g=d.length&&d.shift().config.setValue||f,d=0;if(f>nb||g<ob)for(;d<c;){e=a[d];f=e.config.setValue;if(f>
nb||f<ob)f=b+d,qb(e,f);d+=1}},db=function(a,c){--a;c+=1;var d;for(x=a;x<c;x+=1)for(d in b=B[x]&&B[x].graphics||{},B[x]&&(B[x].config.isRemoving=!0),b)ya[d]||(ya[d]=[]),b[d]&&(ya[d].push(b[d].hide()),b[d]=void 0)},eb=wa.ddsi||0,Qa=wa.ddei||k,Sa=n._oldStartIndex,Ta=n._oldEndIndex,wb=n._oldStep,rb=K.removeDataArr,xb=rb&&rb.length;ra.line=ra.line||aa.group("line",ra);ra.lineConnector=ra.lineConnector||aa.group("line-connector",ra);la||(la=f.graphics.container={lineShadowGroup:aa.group("connector-shadow",
ra.line),anchorShadowGroup:aa.group("anchor-shadow",ra.lineConnector),lineGroup:aa.group("line",ra.line),anchorGroup:aa.group("anchors",ra.lineConnector)},la.lineGroup.trackTooltip(!0),Xa||(la.lineShadowGroup.hide(),la.anchorShadowGroup.hide(),la.lineGroup.hide(),la.anchorGroup.hide()));oa||(oa=f.graphics.trackerContainer=aa.group("line-hot",d.trackerGroup).toBack(),Xa||oa.hide());B||(B=f.components.data=[]);y||(y=f.graphics.dataLabelContainer=f.graphics.dataLabelContainer||aa.group("datalabel",L),
Xa||y.hide());Ea=Da*k;jb&&!n._oldHideAnchors?db(Sa,Ta):Pa!==wb?db(Sa,Ta):(eb>Sa&&db(Sa,eb>Ta?Ta:eb),Qa<Ta&&db(Qa<Sa?Sa:Qa,Ta),(eb<Sa||Qa>Ta)&&db(Sa,Ta));n._oldHideAnchors=jb;n._oldEndIndex=Qa;n._oldStep=Pa;f.setVisibility(Xa);for(x=n._oldStartIndex=eb;x<=Qa;x+=Pa){F=B[x]||{};S=F.config||{};S.isRemoving=!1;r=S.setValue||null;bb=x;if(tb)if(0===x&&null===r){mb=0;for(Ca=c=x;Ca<k;)if(null!==B[Ca].config.setValue||h?h=!0:Ca++,null===B[c].config.setValue&&!m&&c<=k?(c+=Pa,mb++):m=!0,h&&m){h=m=!1;break}0!==
Ca%Pa&&(S=B[Ca].config,bb=Ca)}else if(x>=k&&null===r){for(Ca=c=x;0<Ca&&(void 0!==B[Ca]||h?h=!0:Ca--,void 0===B[c]&&!m&&0<=c?c-=Pa:m=!0,!h||!m););0!==Ca%Pa&&(S=B[Ca].config,bb=Ca)}if(F=B[bb])qb(F,bb),ub&&1<Pa&&(cb=La(x+1,Qa),ib=La(cb+Pa,Qa),hb=ib===Qa?B.slice(cb):B.slice(cb,ib),hb.length&&vb(hb,cb))}Y=f.getLinePath(gb,{});Za=f.getLinePath(gb,Za);n.lastPath=Y;Wa||(Wa=ya.lineElement&&ya.lineElement.length?f.graphics.lineElement=ya.lineElement.shift():f.graphics.lineElement=aa.path(la.lineGroup));pb||
Wa.tooltipListenerAttached||(Wa.tooltipListenerAttached=!0,Wa.mousemove(function(a){Ya=p.viewPortConfig;var b=p._visx,c=Ya.step,d=Ya.ppp*c,b=fb(v.linkedItems.container,a).chartX-b,e;a=p.tooltipSepChar;b=(b+=d/2+Ya.offset)-b%d;e=(e=v.getValuePixel(b))+e%c;c=N.getLabel(e).label+a+f.components.data[e].config.formatedVal;c=n.seriesname&&n.seriesname+a+c||c;Wa.tooltip(0===p.crossline.enabled?c:!1)}));Wa.attr({path:Y.getPathArr(),"stroke-dasharray":Ga,"stroke-width":ma,stroke:qa(Ka),"stroke-linecap":"round",
"stroke-linejoin":2<=ma?"round":"miter"}).shadow(za,la.lineShadowGroup);Ha&&(da=ka.startPercent,ea[2]=Ea+V[0],1===da&&(V[0]=ea[2],ea[0]=0));ea[3]+=M;f.drawn=!0;xb&&f.remove()},setVisibility:function(a,b){var c=this.graphics,h=c&&c.container,m=c&&c.trackerContainer,c=c&&c.dataLabelContainer,f=a?"show":"hide";h.lineGroup[f]();h.anchorGroup[f]();h.anchorShadowGroup[f]();h.lineShadowGroup[f]();m[f]();c[f]();b&&this.transposeLimits(a)},transposeLimits:function(a){var b=this.chart,c=b.config,h=this.yAxis;
b._chartAnimation();this.visible=a;this._conatinerHidden=!a;b._setAxisLimits();h.draw();c.legendClicked=!0;b._drawDataset();delete c.legendClicked},hide:function(){this.setVisibility(!1,!0)},show:function(){this.setVisibility(!0,!0)}},"Line"]);ta=function(){};ta.prototype.configure=function(a,b){var c,h,m,f={},q=this,v=a.components,A=v.numberFormatter,n=v.paper,C=a.config;c=a.graphics;h=this.left=C._visx;m=this.top=C.canvasTop;var p=this.height=C.canvasHeight,I=this._visout=C._visout,K=this.plots=
a.components.dataset,B=c.datalabelsGroup,k,x,G=b.labelstyle,N=b.valuestyle,D=v.yAxis[0],Z=D.getLimit(),X=v.yAxis[1],d=X&&X.getLimit();x=this.tracker;var v=this.labels,L=this.positionLabel;k=a.get("linkedItems");var g=k.container,R=k.eventListeners||(k.eventListeners=[]);q.width=C._visw;k=this.group;k||(k=this.group=n.group("crossline-labels",B),this.container=g);k.attr({transform:["T",h,C._ymin]}).css(N);x||(x=q.tracker=g,R.push(Na(g,"touchstart mousemove",function(b){var c=q.onMouseMove,d=q.onMouseOut;
a.isWithinCanvas(b,a).insideCanvas?c.call(q,b):d.call(q,b)},q)),R.push(Na(g,"mousedown",function(){q.onMouseDown()},q)),R.push(Na(g,"mouseup",function(){q.onMouseUp()},q)),R.push(Na(g,"mouseout",function(){q.onMouseOut()},q)));x=this.line;x||(x=this.line=n.path(B).toBack());x.attr(ua({path:["M",h,m,"l",0,p]},b.line));v||(v=this.labels=b.valueEnabled&&n.set());b.labelEnabled?(f.x=I,f.y=m+p+(C.scrollHeight||0)+2.5,f["vertical-align"]="top",f.direction=C.textDirection,f.text="",L?(L.attr(f),L.css(G)):
L=this.positionLabel=n.text(f,G,c.datalabelsGroup).insertBefore(c.datasetGroup)):(L&&L.remove(),delete this.positionLabel);this.hide();this.ppixelRatio=-D.getPVR();this.spixelRatio=X&&-X.getPVR();this.yminValue=C._yminValue;this.pyaxisminvalue=Z.min;this.pyaxismaxvalue=Z.max;this.syaxisminvalue=d&&d.min;this.syaxismaxvalue=d&&d.max;this.positionLabels=C.xlabels||{data:[],parsed:[]};this.chart=a;this.getZoomInfo=function(){return C.viewPortConfig};this.getDataIndexFromPixel=function(b){return Math.round(a.components.xAxis[0].getValue(b))};
this.getPositionLabel=function(b){return(b=a.components.xAxis[0].getLabel(b))&&b.label||""};if(b.valueEnabled){c=0;for(h=K.length;c<h;c+=1)m=K[c],m=Ka(m.config.linecolor),f.x=0,f.y=I,f.fill=m,f.direction=C.textDirection,f.text="",f["text-bound"]=N["text-bound"],f.lineHeight=N.lineHeight,v[c]?v[c].attr(f):v[c]=v.items[c]=n.text(f,void 0,k);for(;c<v.items.length;c+=1)v[c].remove(),delete v[c],v.items.splice(c,1);this.numberFormatter=A}else if(v.items&&v.items.length){for(c=0;c<v.items.length;c+=1)v[c].remove(),
delete v[c];v.length=0}};ta.prototype.disable=function(a){void 0!==a&&(this.disabled=!!a)&&this.visible&&this.hide();return this.disabled};ta.prototype.onMouseOut=function(){this.hide();this.position=void 0};ta.prototype.onMouseDown=function(){!Oa&&this.hide();this._mouseIsDown=!0};ta.prototype.onMouseUp=function(){!Oa&&this.hide();delete this._mouseIsDown};ta.prototype.onMouseMove=function(a){if(!(this.disabled||this._mouseIsDown&&!Oa)){var b,c=this.getZoomInfo(),h=this.line,m=this.left,c=c.step,
f=this.chart,q=f.components.xAxis[0],f=f.get("config"),v=f.canvasLeft,A=q.getAxisConfig("axisDimention");a=fb(this.container,a).chartX-m;var m=q._getVisibleConfig(),A=A.x-v,n;n=(n=this.getDataIndexFromPixel(va(a)))+((b=n%c)>c/2?c-b:-b);a=q.getPixel(n)-A-v;h.transform(["T",va(a),0]);this.hidden&&0!==f.crossline.enabled&&this.show();(n<m.minValue||n>m.maxValue)&&this.hide();if(n!==this.position||this.hidden)this.position=n,this.lineX=a,this.updateLabels()}};ta.prototype.updateLabels=function(){var a=
this,b=a.labels,c=a.plots,h=a.width,m=a.position,f=a.lineX,q=xa(f),v=a.ppixelRatio,A=a.spixelRatio,n=a.yminValue,C=a._visout,p=a.numberFormatter,I=a.pyaxisminvalue,G=a.pyaxismaxvalue,B=a.syaxisminvalue,k=a.syaxismaxvalue,x=function(){function b(){this.y=0;this.lRef=void 0;this.__index=this.__shift=0}function c(a){for(var b=0;b<a;)this.push(b++);return this}function f(a){var b,c,d,g={},h=Number.POSITIVE_INFINITY;for(b=0;b<this.length;b++)c=this[b]-a,0>c?d=x.NEG:d=x.POS,c=e(c),c<=h&&(h=c,g.absValue=
c,g.noScaleSide=d);return g}function h(a){this.holes=c.call([],a)}var k=-1*a.height,d=n*v,m=0,g,p={},l,e=Math.abs,q=Math.floor,x={};"function"!=typeof Object.create&&(Object.create=function(){function a(){}var b=Object.prototype.hasOwnProperty;return function(c){var d,e,f;if("object"!=typeof c)throw new TypeError("Object prototype may only be an Object or null");a.prototype=c;f=new a;a.prototype=null;if(1<arguments.length)for(e in d=Object(arguments[1]),d)b.call(d,e)&&(f[e]=d[e]);return f}}());Array.prototype.indexOf||
(Array.prototype.indexOf=function(a,b){var c,d,e;if(null==this)throw new TypeError('"this" is null or not defined');d=Object(this);e=d.length>>>0;if(0===e)return-1;c=+b||0;Infinity===Math.abs(c)&&(c=0);if(c>=e)return-1;for(c=Math.max(0<=c?c:e-Math.abs(c),0);c<e;){if(c in d&&d[c]===a)return c;c++}return-1});Array.prototype.forEach||(Array.prototype.forEach=function(a,b){var c,d,e,f,g;if(null==this)throw new TypeError(" this is null or not defined");e=Object(this);f=e.length>>>0;if("function"!==typeof a)throw new TypeError(a+
" is not a function");1<arguments.length&&(c=b);for(d=0;d<f;)d in e&&(g=e[d],a.call(c,g,d,e)),d++});b.prototype.constructor=b;b.prototype.applyShift=function(a){this.__shift=a;this.lRef.calcY=this.y+=a*m};b.prototype.applyDirectIndex=function(a){this.__index=a;this.lRef.calcY=this.y=k-a*m*-1};try{Object.defineProperty(x,"POS",{enumerable:!1,configurable:!1,get:function(){return 1}}),Object.defineProperty(x,"NEG",{enumerable:!1,configurable:!1,get:function(){return-1}})}catch(r){x.POS=1,x.NEG=-1}h.prototype=
Object.create(Array.prototype);h.prototype.constructor=h;h.prototype.repositionHoles=function(){var a,b=0,c;for(a=this.holes.length=0;a<this.length;a++)c=this[a],!c&&(this.holes[b++]=a)};h.prototype.attachShift=function(a,c,d){var e,g=this.length;if(a===C)d.calcY=C;else if(g=c>g-1?g-1:c,e=this[g],c=new b,c.y=a,c.lRef=d,e){a=f.call(this.holes,g);d=g+a.absValue*a.noScaleSide;if(a.noScaleSide===x.POS)return c.applyDirectIndex(d),this.splice(d,1,c),this.holes.splice(this.holes.indexOf(d),1),d;if(a.noScaleSide===
x.NEG){a=this.splice(d+1,this.length-1);this.pop();a.forEach(function(a){a&&a.applyShift(-1)});for([].push.apply(this,a);this[d];)d++;this.push(0);this.repositionHoles();a=f.call(this.holes,d);d+=a.absValue*a.noScaleSide;c.applyDirectIndex(d);this.splice(d,1,c);this.repositionHoles();return this.length-1}}else c.applyDirectIndex(g),this.splice(g,1,c),this.holes.splice(this.holes.indexOf(g),1)};try{Object.defineProperty(p,"top",{enumerable:!1,configurable:!1,get:function(){return k}}),Object.defineProperty(p,
"bottom",{enumerable:!1,configurable:!1,get:function(){return d}})}catch(r){p.top=k,p.bottom=d}p.init=function(a,b){var c;m=a+2;k+=m/2;l=q(e(k)/m);g=new h(l);for(c=0;c<l;c++)g.push(0)};p.occupy=function(a,b){var c=q(e(k-a)/m);g&&g.attachShift(a,c,b)};return p}();b&&(b[0]&&b[0].attr({text:p.yAxis("0")}),b[0]&&x.init(b[0].getBBox().height,b.length),b.forEach(function(a,b){var f=c[b],h=f.components.data[m]&&f.components.data[m].config.setValue,p=f.config.parentYAxis;x.occupy(void 0===h||!f.visible||
(p?h>k||h<B:h>G||h<I)?C:p?(h-B)*A:(h-I)*v,a)}));b&&b.forEach(function(a,b){var k=c[b],n,v;(k=p[k.config.parentYAxis?"sYAxis":"yAxis"](k.components.data[m]&&k.components.data[m].config.setValue))?(a.attr({text:k}),k=(k=(k=(k=a.getBBox())&&k.width)&&.5*k)&&k+10,v=a.calcY,n=pa(0,La(q,h)),void 0!==v&&void 0!==n&&a.attr({x:n,y:v,"text-anchor":f<=k&&"start"||f+k>=h&&"end"||"middle","text-bound":["rgba(255,255,255,0.8)","rgba(0,0,0,0.2)",1,2.5]})):a.attr({x:-h})});a.positionLabel&&a.positionLabel.attr({x:f+
a.left,text:a.getPositionLabel(m),"text-bound":["rgba(255,255,255,1)","rgba(0,0,0,1)",1,2.5]})};ta.prototype.show=function(){this.disabled||(this.hidden=!1,this.group.attr("visibility","visible"),this.line.attr("visibility","visible"),this.positionLabel&&this.positionLabel.attr("visibility","visible"))};ta.prototype.hide=function(){this.hidden=!0;this.group.attr("visibility","hidden");this.line.attr("visibility","hidden");this.positionLabel&&this.positionLabel.attr("visibility","hidden")};ta.prototype.dispose=
function(){for(var a in this)this.hasOwnProperty(a)&&delete this[a]};U.addSymbol({pinModeIcon:function(a,b,c){var h=.5*c,m=a-c,f=a+c,q=a-h,v=a+h,A=a+.5,n=A+1,C=A+1.5,p=b-c,I=b+h,G=b-h,h=b+(c-h);return["M",m,p,"L",q,G,q,h,m,I,a-.5,I,a,b+c+.5,A,I,f,I,v,h,v,G,f,p,C,p,C,G,C,h,n,h,n,G,C,G,C,p,"Z"]},zoomOutIcon:function(a,b,c){a-=.2*c;b-=.2*c;var h=.8*c,m=U.rad(43),f=U.rad(48),q=a+h*ra(m),m=b+h*za(m),v=a+h*ra(f),f=b+h*za(f),A=U.rad(45),n=q+c*ra(A),C=m+c*za(A),p=v+c*ra(A);c=f+c*za(A);return["M",q,m,"A",
h,h,0,1,0,v,f,"Z","M",q+1,m+1,"L",n,C,p,c,v+1,f+1,"Z","M",a-2,b,"L",a+2,b,"Z"]},resetIcon:function(a,b,c){var h=a-c,m=(wa.PI/2+wa.PI)/2;a+=c*ra(m);var m=b+c*za(m),f=2*c/3;return["M",h,b,"A",c,c,0,1,1,a,m,"L",a+f,m-1,a+2,m+f-.5,a,m]}})}])});

},{}],4:[function(require,module,exports){
/*
 FusionCharts JavaScript Library
 Copyright FusionCharts Technologies LLP
 License Information at <http://www.fusioncharts.com/license>

 @version 3.11.3-sr.1
 FusionCharts JavaScript Library
 Copyright FusionCharts Technologies LLP
 License Information at <http://www.fusioncharts.com/license>

 @version 3.11.3-sr.1
 FusionCharts JavaScript Library
 Copyright FusionCharts Technologies LLP
 License Information at <http://www.fusioncharts.com/license>
*/
(function(Ab,Jb){"object"===typeof module&&module.exports?module.exports=Ab.document?Jb(Ab):function(g){if(!g.document)throw Error("Window with document not present");return Jb(g,!0)}:Ab.FusionCharts=Jb(Ab,!0)})("undefined"!==typeof window?window:this,function(Ab,Jb){"undefined"===typeof Ab&&"object"===typeof window&&(Ab=window);(function(g){if(!g.FusionCharts||!g.FusionCharts.version){var m=g.document,D=g.navigator,n={window:g},F=n.modules={},A=n.interpreters={},J=Object.prototype.toString,a=/msie/i.test(D.userAgent)&&
!g.opera,O=/loaded|complete/,d=!1,l=function(){var a=n.ready;n.ready=!0;n.raiseEvent&&(n.readyNotified=!0,n.raiseEvent("ready",{version:n.core.version,now:!a},n.core));n.readyNow=!a},N=function(a,d){var r,p;if(d instanceof Array)for(r=0;r<d.length;r+=1)"object"!==typeof d[r]?a[r]=d[r]:("object"!==typeof a[r]&&(a[r]=d[r]instanceof Array?[]:{}),N(a[r],d[r]));else for(r in d)"object"===typeof d[r]?(p=J.call(d[r]),"[object Object]"===p?("object"!==typeof a[r]&&(a[r]={}),N(a[r],d[r])):"[object Array]"===
p?(a[r]instanceof Array||(a[r]=[]),N(a[r],d[r])):a[r]=d[r]):a[r]=d[r];return a};n.extend=function(a,d,r,p){var c;r&&a.prototype&&(a=a.prototype);if(!0===p)N(a,d);else for(c in d)a[c]=d[c];return a};n.uniqueId=function(){return"chartobject-"+(n.uniqueId.lastId+=1)};n.uniqueId.lastId=0;n.policies={options:{chartTypeSourcePath:["typeSourcePath",""],product:["product","v3"],insertMode:["insertMode","replace"],safeMode:["safeMode",!0],overlayButton:["overlayButton",void 0],containerBackgroundColor:["containerBackgroundColor",
"#ffffff"],containerBackgroundOpacity:["containerBackgroundOpacity",1],containerClassName:["containerClassName","fusioncharts-container"],chartType:["type",void 0],baseChartMessageFont:["baseChartMessageFont","Verdana,sans"],baseChartMessageFontSize:["baseChartMessageFontSize","10"],baseChartMessageColor:["baseChartMessageColor","#666666"],baseChartMessageImageHAlign:["baseChartMessageImageHAlign","middle"],baseChartMessageImageVAlign:["baseChartMessageImageVAlign","middle"],baseChartMessageImageAlpha:["baseChartMessageImageAlpha",
100],baseChartMessageImageScale:["baseChartMessageImageScale",100],dataLoadStartMessage:["dataLoadStartMessage","Retrieving data. Please wait."],dataLoadErrorMessage:["dataLoadErrorMessage","Error in loading data."],dataInvalidMessage:["dataInvalidMessage","Invalid data."],dataEmptyMessage:["dataEmptyMessage","No data to display."],typeNotSupportedMessage:["typeNotSupportedMessage","Chart type not supported."],browserNotSupportedMessage:["browserNotSupportedMessage","This browser is not supported."],
loadMessage:["loadMessage","Loading chart. Please wait."],renderErrorMessage:["renderErrorMessage","Unable to render chart."]},attributes:{lang:["lang","EN"],id:["id",void 0]},width:["width","400"],height:["height","300"],src:["swfUrl",""]};A.stat="swfUrl id width height debugMode registerWithJS backgroundColor scaleMode lang detectFlashVersion autoInstallRedirect".split(" ");n.parsePolicies=function(a,d,r){var p,c,v;for(c in d)if(n.policies[c]instanceof Array)v=r[d[c][0]],a[c]=void 0===v?d[c][1]:
v;else for(p in"object"!==typeof a[c]&&(a[c]={}),d[c])v=r[d[c][p][0]],a[c][p]=void 0===v?d[c][p][1]:v};n.parseCommands=function(a,d,r){var p,c;"string"===typeof d&&(d=A[d]||[]);p=0;for(c=d.length;p<c;p++)a[d[p]]=r[p];return a};n.registrars={module:function(){return n.core.apply(n.core,arguments)}};n.core=function(a){if(!(this instanceof n.core)){if(1===arguments.length&&a instanceof Array&&"private"===a[0]){if(F[a[1]])return;F[a[1]]={};a[3]instanceof Array&&(n.core.version[a[1]]=a[3]);return"function"===
typeof a[2]?a[2].call(n,F[a[1]]):n}if(1===arguments.length&&"string"===typeof a)return n.core.items[a];n.raiseError&&n.raiseError(this,"25081840","run","",new SyntaxError('Use the "new" keyword while creating a new FusionCharts object'))}var d={};this.__state={};1===arguments.length&&"object"===typeof arguments[0]?d=arguments[0]:n.parseCommands(d,A.stat,arguments);1<arguments.length&&"object"===typeof arguments[arguments.length-1]&&(delete d[A.stat[arguments.length-1]],n.extend(d,arguments[arguments.length-
1]));this.id="undefined"===typeof d.id?this.id=n.uniqueId():d.id;this.args=d;n.core.items[this.id]instanceof n.core&&n.raiseWarning(this,"06091847","param","",Error('A FusionCharts object with the specified id "'+this.id+'" already exists. Renaming it to '+(this.id=n.uniqueId())));n.parsePolicies(this,n.policies,d);this.attributes.id=this.id;this.resizeTo&&this.resizeTo(d.width,d.height,!0);this.chartType&&this.chartType(d.type||d.swfUrl,!0);n.raiseEvent("beforeInitialize",d,this);n.core.items[this.id]=
this;n.core.defaultOptions=n.core.options;n.raiseEvent("initialized",d,this);return this};n.core.prototype={};n.core.prototype.constructor=n.core;n.extend(n.core,{id:"FusionCharts",version:["3","11","3","sr","1"],items:{},options:{},getObjectReference:function(a){return n.core.items[a].ref},register:function(a){return n.registrars[a=a&&a.toString&&a.toString().toLowerCase()]&&n.registrars[a].apply(n.core,Array.prototype.slice.call(arguments,1))},get:function(a){return n.registrars[a=a&&a.toString&&
a.toString().toLowerCase()]&&n.registrars[a].apply(n.core,Array.prototype.slice.call(arguments,1))}});g.FusionCharts=n.core;g.FusionMaps&&g.FusionMaps.legacy&&(n.core(["private","modules.core.geo",g.FusionMaps.legacy,g.FusionMaps.version]),d=!0);O.test(m.readyState)||m.loaded?(n.ready=!0,setTimeout(l,1)):function(){function N(){c||(c=!0,r&&clearTimeout(r),d||(g.FusionMaps&&g.FusionMaps.legacy&&n.core(["private","modules.core.geo",g.FusionMaps.legacy,g.FusionMaps.version]),g.FusionMaps=n.core),setTimeout(l,
1))}function w(){O.test(m.readyState)?N():r=setTimeout(w,10)}var r,p,c;m.addEventListener?m.addEventListener("DOMContentLoaded",N,!1):m.attachEvent&&g.attachEvent("onLoad",N);if(a)try{"https:"===g.location.protocol?m.write('<script id="__ie_onload_fusioncharts" defer="defer" src="//:">\x3c/script>'):m.write('<script id="__ie_onload_fusioncharts" defer="defer" src="javascript:void(0)">\x3c/script>'),p=m.getElementById("__ie_onload_fusioncharts"),p.onreadystatechange=function(){"complete"==this.readyState&&
N()}}catch(v){}/WebKit/i.test(D.userAgent)&&(r=setTimeout(w,10));g.onload=function(a){return function(){N();a&&a.call&&a.call(g)}}(g.onload)}();g.FusionMaps=n.core}})(Ab);FusionCharts.register("module",["private","modules.mantle.errormanager",function(){var g=this,m=g.window,D={type:"TypeException",range:"ValueRangeException",impl:"NotImplementedException",param:"ParameterException",run:"RuntimeException",comp:"DesignTimeError",undefined:"UnspecifiedException"},n=function(A,n,a,O,d,l){var N="#"+n+
" "+(A?A.id:"unknown-source")+O+" "+l+" >> ";d instanceof Error?(d.name=D[a],d.module="FusionCharts"+O,d.level=l,d.message=N+d.message,N=d.message,m.setTimeout(function(){throw d;},0)):N+=d;n={id:n,nature:D[a],source:"FusionCharts"+O,message:N};g.raiseEvent(l,n,A);if("function"===typeof m["FC_"+l])m["FC_"+l](n)},F;g.raiseError=function(g,m,a,O,d){n(g,m,a,O,d,"Error")};g.raiseWarning=function(g,m,a,O,d){n(g,m,a,O,d,"Warning")};F={outputHelpers:{text:function(g,m){F.outputTo("#"+g.eventId+" ["+(g.sender.id||
g.sender).toString()+'] fired "'+g.eventType+'" event. '+("error"===g.eventType||"warning"===g.eventType?m.message:""))},event:function(g,m){this.outputTo(g,m)},verbose:function(g,m){F.outputTo(g.eventId,g.sender.id,g.eventType,m)}},outputHandler:function(m,n){"function"!==typeof F.outputTo?g.core["debugger"].outputFailed=!0:(g.core["debugger"].outputFailed=!1,F.currentOutputHelper(m,n))},currentOutputHelper:void 0,outputTo:void 0,enabled:!1};F.currentOutputHelper=F.outputHelpers.text;g.extend(g.core,
{"debugger":{syncStateWithCharts:!0,outputFormat:function(g){return g&&"function"===typeof g.toLowerCase&&"function"===typeof F.outputHelpers[g=g.toLowerCase()]?(F.currentOutputHelper=F.outputHelpers[g],!0):!1},outputTo:function(m){"function"===typeof m?F.outputTo=m:null===m&&(g.core["debugger"].enable(!1),delete F.outputTo)},enable:function(m,n,a){var O;"object"===typeof m&&1===arguments.length&&(O=m,m=O.state,n=O.outputTo,a=O.outputFormat);"function"===typeof m&&("string"!==typeof n||2!==arguments.length&&
!O||(a=n),n=m,m=!0);if("boolean"===typeof m&&m!==F.enabled)g.core[(F.enabled=m)?"addEventListener":"removeEventListener"]("*",F.outputHandler);"function"===typeof n&&(F.outputTo=n);g.core["debugger"].outputFormat(a);return F.enabled},enableFirebugLite:function(){var n;m.console&&m.console.firebug?g.core["debugger"].enable(m.console.log,"verbose"):((n=m.document.getElementsByTagName("html"))&&n[0].setAttribute("debug","true"),g.loadScript("https://getfirebug.com/firebug-lite.js#overrideConsole=false,startOpened=true",
function(){g.core["debugger"].enable(m.console.log,"verbose")},"{ startOpened: true }",!0,!0))}},debugMode:{enabled:function(){m.setTimeout(function(){throw Error("Deprecated! Please use FusionCharts.debugger.enable instead.");},0);return g.core["debugger"].enable.apply(g.core["debugger"],arguments)}}},!1)}]);FusionCharts.register("module",["private","modules.mantle.eventmanager",function(){var g=this,m=g.window,D=g.core,n=Object.prototype.toString,F=n.call([]),A=function(a,d,l,r){try{a[0].call(d,
l,r||{})}catch(p){setTimeout(function(){throw p;},0)}},J=function(a,d,l){if(a instanceof Array)for(var r=0,p;r<a.length;r+=1){if(a[r][1]===d.sender||void 0===a[r][1])p=a[r][1]===d.sender?d.sender:g.core,A(a[r],p,d,l),!0===d.detached&&(a.splice(r,1),--r,d.detached=!1);if(!0===d.cancelled)break}},a={unpropagator:function(){return!1===(this.cancelled=!0)},detacher:function(){return!1===(this.detached=!0)},undefaulter:function(){return!1===(this.prevented=!0)},listeners:{},lastEventId:0,addListener:function(d,
l,w){var r,p;if(n.call(d)===F){r=[];for(p=0;p<d.length;p+=1)r.push(a.addListener(d[p],l,w));return r}if("string"!==typeof d)g.raiseError(w||g.core,"03091549","param","::EventTarget.addListener",Error("Unspecified Event Type"));else if("function"!==typeof l)g.raiseError(w||g.core,"03091550","param","::EventTarget.addListener",Error("Invalid Event Listener"));else return d=d.toLowerCase(),a.listeners[d]instanceof Array||(a.listeners[d]=[]),a.listeners[d].push([l,w]),l},removeListener:function(d,l,w){var r;
if("function"!==typeof l)g.raiseError(w||g.core,"03091560","param","::EventTarget.removeListener",Error("Invalid Event Listener"));else if(d instanceof Array)for(r=0;r<d.length;r+=1)a.removeListener(d[r],l,w);else if("string"!==typeof d)g.raiseError(w||g.core,"03091559","param","::EventTarget.removeListener",Error("Unspecified Event Type"));else if(d=d.toLowerCase(),d=a.listeners[d],d instanceof Array)for(r=0;r<d.length;r+=1)d[r][0]===l&&d[r][1]===w&&(d.splice(r,1),--r)},triggerEvent:function(d,l,
w,r,p,c){if("string"!==typeof d)g.raiseError(l,"03091602","param","::EventTarget.dispatchEvent",Error("Invalid Event Type"));else{d=d.toLowerCase();var v={eventType:d,eventId:a.lastEventId+=1,sender:l||Error("Orphan Event"),cancelled:!1,stopPropagation:this.unpropagator,prevented:!1,preventDefault:this.undefaulter,detached:!1,detachHandler:this.detacher};J(a.listeners[d],v,w);J(a.listeners["*"],v,w);switch(v.prevented){case !0:if("function"===typeof c)try{c.call(r||l||m,v,w||{})}catch(O){setTimeout(function(){throw O;
},0)}break;default:if("function"===typeof p)try{p.call(r||l||m,v,w||{})}catch(O){setTimeout(function(){throw O;},0)}}return!0}}},O=g.raiseEvent=function(d,l,w,r,p,c){return a.triggerEvent(d,w,l,r,p,c)},d=g.legacyEventList={},l={};g.disposeEvents=function(d){var l,w;for(l in a.listeners)for(w=0;w<a.listeners[l].length;w+=1)a.listeners[l][w][1]===d&&a.listeners[l].splice(w,1)};g.raiseEventWithLegacy=function(a,l,w,r,p,c,v){var g=d[a];O(a,l,w,p,c,v);g&&"function"===typeof m[g]&&setTimeout(function(){m[g].apply(p||
m,r)},0)};g.raiseEventGroup=function(a,d,w,r,p,c,v){var g=r.id,e=a+g;l[e]?(clearTimeout(l[e]),delete l[e]):g&&e?l[e]=setTimeout(function(){O(d,w,r,p,c,v);delete l[e]},0):O(d,w,r,p,c,v)};g.addEventListener=function(d,l){return a.addListener(d,l)};g.removeEventListener=function(d,l){return a.removeListener(d,l)};g.extend(D,{addEventListener:function(d,l){return a.addListener(d,l)},removeEventListener:function(d,l){return a.removeListener(d,l)},ready:function(a,d,l){g.ready?(D.ready=function(a,p){"function"===
typeof a&&setTimeout(function(){a.call(p||D,d||D)},0)},D.ready(a,l)):"function"===typeof a&&D.addEventListener("ready",function(){D.ready(a,d,l)});return this}});D.on=D.addEventListener;g.extend(D.prototype,{addEventListener:function(d,l){return a.addListener(d,l,this)},removeEventListener:function(d,l){return a.removeListener(d,l,this)}});D.prototype.on=D.prototype.addEventListener;g.policies.options.events=["events",{}];g.addEventListener("beforeInitialize",function(a){a=a.sender;var d=a.options.events,
l;if(d)for(l in d)"function"===typeof d[l]&&a.addEventListener(l,d[l])});g.ready&&!g.readyNotified&&(g.readyNotified=!0,g.raiseEvent("ready",{version:g.core.version,now:g.readyNow},g.core))}]);FusionCharts.register("module",["private","modules.mantle.ajax",function(){var g=this,m=g.window,D=parseFloat(m.navigator.appVersion.split("MSIE")[1]),n=5.5<=D&&7>=D?!0:!1,F=/mozilla/i.test(m.navigator.userAgent),A="file:"===m.location.protocol,J=m.ActiveXObject,a=(!J||!A)&&m.XMLHttpRequest,O={objects:0,xhr:0,
requests:0,success:0,failure:0,idle:0},d=function(){var l;if(a)return d=function(){O.xhr++;return new a},d();try{l=new J("Msxml2.XMLHTTP"),d=function(){O.xhr++;return new J("Msxml2.XMLHTTP")}}catch(g){try{l=new J("Microsoft.XMLHTTP"),d=function(){O.xhr++;return new J("Microsoft.XMLHTTP")}}catch(m){l=!1}}return l};g.core.ajax={stats:function(a){return a?O[a]:g.extend({},O)},headers:{"If-Modified-Since":"Sat, 29 Oct 1994 19:43:31 GMT","X-Requested-With":"XMLHttpRequest","X-Requested-By":"FusionCharts",
Accept:"text/plain, */*","Content-Type":"application/x-www-form-urlencoded; charset=UTF-8"}};D=g.ajax=function(a,d){this.onSuccess=a;this.onError=d;this.open=!1;O.objects++;O.idle++};g.extend(D.prototype,{headers:g.core.ajax.headers,transact:function(a,N,ga,w){var r=this,p=r.xmlhttp,c=r.headers,v=r.onError,M=r.onSuccess;a="POST"===a;var e,q=Object.prototype.hasOwnProperty,H;-1!==N.search(/^(http:\/\/|https:\/\/)/)&&m.location.hostname!==/(http:\/\/|https:\/\/)([^\/\:]*)/.exec(N)[2]?delete c["X-Requested-By"]:
!q.call(c,"X-Requested-By")&&(c["X-Requested-By"]="FusionCharts");if(!p||n||F)p=d(),r.xmlhttp=p;p.onreadystatechange=function(){try{4===p.readyState&&(!p.status&&A||200<=p.status&&300>p.status||304===p.status||1223===p.status||0===p.status?(M&&M(p.responseText,r,w,N),O.success++):v&&(v(Error("XmlHttprequest Error"),r,w,N),O.failure++),O.idle--,r.open=!1)}catch(a){v&&v(a,r,w,N),m.FC_DEV_ENVIRONMENT&&setTimeout(function(){throw a;},0),O.failure++}};try{p.open(a?"POST":"GET",N,!0);p.overrideMimeType&&
p.overrideMimeType("text/plain");if(a)if("string"===typeof ga)e=ga;else{e=[];for(H in ga)e.push(H+"="+(ga[H]+"").replace(/\=/g,"%3D").replace(/\&/g,"%26"));e=e.join("&")}else e=null;for(H in c)p.setRequestHeader(H,c[H]);p.send(e);O.requests++;O.idle++;r.open=!0}catch(t){g.raiseError(g.core,"1110111515A","run","XmlHttprequest Error",t.message)}return p},get:function(a,d){return this.transact("GET",a,void 0,d)},post:function(a,d,g){return this.transact("POST",a,d,g)},abort:function(){var a=this.xmlhttp;
this.open=!1;return a&&"function"===typeof a.abort&&a.readyState&&0!==a.readyState&&a.abort()},dispose:function(){this.open&&this.abort();delete this.onError;delete this.onSuccess;delete this.xmlhttp;delete this.open;O.objects--;return null}})}]);FusionCharts.register("module",["private","modules.mantle.runtime;1.1",function(){var g=this,m=g.window,D=/(^|[\/\\])(fusioncharts\.js)([\?#].*)?$/ig,n=/[\\\"<>;&]/,F=/^[^\S]*?(sf|f|ht)(tp|tps):\/\//i,A={},J={},a={},O={},d=g.purgeDOM=function(a){var l=a.attributes,
r,p;if(l)for(r=l.length-1;0<=r;--r)p=l[r].name,"function"===typeof a[p]&&(a[p]=null);if(l=a.childNodes)for(l=l.length,r=0;r<l;r+=1)d(a.childNodes[r])},l=function(a,d,r){var p,c;for(p in a)if(a[p]instanceof Array)d[a[p][0]]=r[p];else for(c in a[p])d[a[p][c][0]]=r[p][c]},N=/^(FusionCharts|FusionWidgets|FusionMaps)/;g.getScriptBaseUri=function(a){var d=m.document.getElementsByTagName("script"),r=d.length,p,c;for(c=0;c<r;c+=1)if(p=d[c].getAttribute("src"),void 0!==p&&null!==p&&null!==p.match(a))return p.replace(a,
"$1")};g.core.options.scriptBaseUri=function(){var a=g.getScriptBaseUri(D);return void 0===a?(g.raiseError(FusionCharts,"1603111624","run",">GenericRuntime~scriptBaseUri","Unable to locate FusionCharts script source location (URL)."),""):a}();g.isXSSSafe=function(a,d){return d&&null!==F.exec(a)?!1:null===n.exec(a)};g.xssEncode=function(a){return null===a||void 0===a||"function"!==typeof a.toString?"":a=a.toString().replace(/&/g,"&amp;").replace(/\'/g,"&#39;").replace(/\"/g,"&quot;").replace(/</g,
"&lt;").replace(/>/g,"&gt;")};g.loadScript=function(d,l,r,p,c){if(!d)return!1;var v=l&&l.success||l,M=l&&l.failure,e,q=g.hcLib,H=q.priorityList,t=q.schedular.addJob,L={type:"script",success:!1},K=function(){O[e]=clearTimeout(O[e]);L.success?v&&v(d,e):M&&M(d,e);g.raiseEvent("externalresourceload",L,g.core)};c=c?"":g.core.options.scriptBaseUri;e=c+d;g.isXSSSafe(e,!1)||(e="function"===typeof m.encodeURIComponent?m.encodeURIComponent(e):m.escape(e));L.path=c;L.src=e;L.file=d;if(!0===a[e]&&p)return L.success=
!0,L.notReloaded=!0,"function"===typeof l&&(l(),g.raiseEvent("externalresourceload",L,g.core)),!0;if(A[e]&&p)return!1;A[e]=!0;J[e]&&J[e].parentNode&&J[e].parentNode.removeChild(J[e]);l=J[e]=m.document.createElement("script");l.type="text/javascript";l.src=e;r&&(l["\v"==="v"?"text":"innerHTML"]=r);"function"===typeof v&&(a[e]=!1,O[e]=clearTimeout(O[e]),l.onload=function(){a[e]=!0;L.success=!0;t(K,void 0,void 0,H.render)},l.onerror=function(){a[e]=!1;A[e]=!1;t(K,void 0,void 0,H.render)},l.onreadystatechange=
function(){if("complete"===this.readyState||"loaded"===this.readyState)a[e]=!0,L.success=!0,t(K,void 0,void 0,H.render)});m.document.getElementsByTagName("head")[0].appendChild(l);"function"===typeof M&&(O[e]=setTimeout(function(){a[e]||K()},g.core.options.html5ResourceLoadTimeout||15E3));return!0};g.capitalizeString=function(a,d){return a?a.replace(d?/(^|\s)([a-z])/g:/(^|\s)([a-z])/,function(a,p,c){return p+c.toUpperCase()}):a};g.extend(g.core,{clone:function(a,d){var r=typeof a,p,c=g.extend({},
this.args,!1,!1);l(g.policies,c,this);l(g.renderer.getRendererPolicy(this.options.renderer),c,this);delete c.id;delete c.animate;delete c.stallLoad;p=c.link;c=g.extend({},c,!1,!1);c.link=p;switch(r){case "object":g.extend(c,a);break;case "boolean":d=a}return d?c:new g.core(c)},isActive:function(){if(!this.ref||m.document.getElementById(this.id)!==this.ref)return!1;try{return N.test(this.ref.signature())}catch(a){return!1}},chartType:function(a,d){var r=this.src,p=!0===d,c=this.options,v;"string"===
typeof a&&(d="object"===typeof d?d:{},r=a.replace(/[\?\#][\s\S]*$/g,""),v=null!==r.match(/\.swf\s*?$/ig),r=r.replace(/\.swf\s*?$/ig,""),c.chartType=r.replace(/^[\s\S]*\//ig,"").replace(/^fcmap_/i,""),c.chartTypeSourcePath=-1===r.indexOf("/")?d.chartTypeSourcePath||this.options.chartTypeSourcePath||g.core.options.chartTypeSourcePath||"":r.replace(/[^\/]*?$/ig,""),this.src=((g.core.options.scriptBaseUri||"")+(c.chartTypeSourcePath||g.core.options.chartTypeSourcePath||"")).replace(/\/\s*$/g,"")+"/"+
c.chartType.replace(/\.swf\s*?$/ig,"")+".swf",v&&(g.raiseWarning(this,"08101320181","comp","FusionCharts#chartType",'Chart type has ".swf" in alias and as such has been deprecated. Please use chart type alias.'),c.chartTypeSourcePath=g.core.options.chartTypeSourcePath||""),void 0!==d.dataSource&&null!==d.dataSource?this.setChartData(d.dataSource,d.dataFormat,d.dataConfiguration):this.isActive()&&!p&&this.render());return(c.chartType||"").toLowerCase()}},!0);m.getChartFromId=function(a){g.raiseWarning(this,
"11133001041","comp","GenericRuntime~getObjectFromId()",'Use of deprecated getChartFromId() or getMapFromId(). Replace with "FusionCharts()" or FusionCharts.items[].');return g.core.items[a]instanceof g.core?g.core.items[a].ref:m.swfobject&&m.swfobject.getObjectById(a)};m.getMapFromId=m.getChartFromId}]);FusionCharts.register("module",["private","api.printmanager",function(){var g=this;g.extend(g.core,{printManager:{configure:function(){g.raiseWarning(g.core,"28141714","impl",".printManager.configure",
"PrintManager is deprecated")},isReady:function(){g.raiseWarning(g.core,"28141714","impl",".printManager.isReady","PrintManager is deprecated");return!1},enabled:function(){g.raiseWarning(g.core,"28141714","impl",".printManager.enabled","PrintManager is deprecated");return!1},managedPrint:function(){g.raiseWarning(g.core,"28141714","impl",".printManager.managedPrint","PrintManager is deprecated")}}},!1)}]);FusionCharts.register("module",["private","modules.interface.renderer",function(){var g=this,
m=g.window,D=m.document,n=function(){g.raiseError(this,"25081845","run","::RendererManager",Error("No active renderer"))},F=g.FusionChartsDOMInsertModes={REPLACE:"replace",APPEND:"append",PREPEND:"prepend"},A={undefined:{render:n,remove:n,update:n,resize:n,config:n,policies:{}}},J={},a=function(a){return function(){var p=this.ref;if(void 0===p||null===p||"function"!==typeof p[a])g.raiseError(this,"25081617","run","#"+a+"()","ExternalInterface call failed. Check whether chart has been rendered.");
else return p[a].apply(p,arguments)}},O=function(a,p){return"function"===typeof a[p]?function(){return a[p].apply(a,arguments)}:a[p]},d=function(a,p){var c=D.getElementById(a),d=p.id||p.getAttribute("id"),l,e;if(null===c)return!1;if(a===d)return!0;d=p.getElementsByTagName("*");l=0;for(e=d.length;l<e;l++)if(d[l]===c)return!1;return!0},l=/[^\%\d]*$/ig,N=function(){var a=function(p){var c=p.parentNode;if(9===c.nodeType)return!1;var d="display";m.getComputedStyle?d=m.getComputedStyle(p)[d]:p.currentStyle&&
(d=p.currentStyle[d]);return"none"===d?!0:c?a(c):!1};return a}(),ga=function(){var a={},p,c=function(){var d=0,l=parseInt(g.core.options.visibilityTrackingInterval,10)||300,e,q,H,t,O;for(e in a)if(d+=1,q=a[e].chart,H=a[e].container,t=a[e].insertMode,O=a[e].callback,q.disposed||!N(H))delete a[e],--d,!q.disposed&&q.renderChart.call(q,H,t,O);p=d?setTimeout(c,l):clearTimeout(p)};return function(d,l,e,q){a[d.id]={chart:d,container:l,insertMode:e,callback:q};p||(p=setTimeout(c,parseInt(g.core.options.visibilityTrackingInterval,
10)||300))}}(),w;g.policies.options.containerElementId=["renderAt",void 0];g.policies.options.renderer=["renderer",void 0];g.policies.options.containerElementType=["containerElementType",void 0];g.policies.options.visibilityTrackingInterval=300;g.normalizeCSSDimension=function(a,p,c){a=void 0===a?c.offsetWidth||parseFloat(c.style.width):a;p=void 0===p?c.offsetHeight||parseFloat(c.style.height):p;var d={},l=c.style,e;l.width=a=a.toString?a.toString():"0";l.height=p=p.toString?p.toString():"0";if((d.widthIsRelative=
a.match(/^\s*\d*\.?\d*\%\s*$/)&&!a.match(/^\s*0\%\s*$/))&&0===c.offsetWidth)for(e=c;e=e.offsetParent;)if(0<e.offsetWidth){a=(e.offsetWidth*parseFloat(a.match(/\d*/)[0])/100).toString();break}if((d.heightIsRelative=p.match(/^\s*\d*\.?\d*\%\s*$/)&&!p.match(/^\s*0\%\s*$/))&&20>=c.offsetHeight)for(e=c;e=e.offsetParent;)if(0<e.offsetHeight){p=(e.offsetHeight*parseFloat(p.match(/\d*/)[0])/100).toString();break}d.width=a.replace?a.replace(/^\s*(\d*\.?\d*)\s*$/ig,"$1px"):a;d.height=p.replace?p.replace(/^\s*(\d*\.?\d*)\s*$/ig,
"$1px"):p;l.width=d.width;l.height=d.height;d.pixelWidth=d.widthIsRelative?c.offsetWidth:parseInt(d.width,10)||0;d.pixelHeight=d.heightIsRelative?c.offsetHeight:parseInt(d.height,10)||0;return d};w=g.renderer={register:function(a,p){if(!a||"function"!==typeof a.toString)throw Error("#03091436 ~renderer.register() Invalid value for renderer name.");a=a.toString().toLowerCase();if(void 0!==A[a])return g.raiseError(g.core,"03091438","param","::RendererManager>register",'Duplicate renderer name specified in "name"'),
!1;A[a]=p;return!0},userSetDefault:!1,setDefault:function(a){if(!a||"function"!==typeof a.toString)return g.raiseError(g.core,"25081731","param","::RendererManager>setDefault",'Invalid renderer name specified in "name"'),!1;if(void 0===A[a=a.toString().toLowerCase()])return g.raiseError(g.core,"25081733","range","::RendererManager>setDefault","The specified renderer does not exist."),!1;this.userSetDefault=!1;g.policies.options.renderer=["renderer",a];return!0},notifyRender:function(a){var p=g.core.items[a&&
a.id];p&&(!1!==a.success||a.silent)||g.raiseError(g.core.items[a.id],"25081850","run","::RendererManager",Error("There was an error rendering the chart. Enable FusionCharts JS debugger for more information."));if(p.ref=a.ref)a.ref.FusionCharts=g.core.items[a.id];g.raiseEvent("internal.DOMElementCreated",{},p)},protectedMethods:{options:!0,attributes:!0,src:!0,ref:!0,constructor:!0,signature:!0,link:!0,addEventListener:!0,removeEventListener:!0},getRenderer:function(a){return A[a]},getRendererPolicy:function(a){a=
A[a].policies;return"object"===typeof a?a:{}},currentRendererName:function(){return g.policies.options.renderer[1]},update:function(a){J[a.id].update.apply(a,Array.prototype.slice.call(arguments,1))},render:function(a){J[a.id].render.apply(a,Array.prototype.slice.call(arguments,1))},remove:function(a){J[a.id].remove.apply(a,Array.prototype.slice.call(arguments,1))},resize:function(a){J[a.id].resize.apply(a,Array.prototype.slice.call(arguments,1))},config:function(a){J[a.id].config.apply(a,Array.prototype.slice.call(arguments,
1))},dispose:function(a){J[a.id].dispose.apply(a,Array.prototype.slice.call(arguments,1))}};g.addEventListener("beforeInitialize",function(a){a=a.sender;var p=a.options.renderer.toLowerCase(),c;"string"===typeof a.options.renderer&&void 0===A[p]&&(a.options.renderer=g.policies.options.renderer[1]);a.options.renderer=p;J[a.id]=A[a.options.renderer];!0!==J[a.id].initialized&&"function"===typeof J[a.id].init&&(J[a.id].init(),J[a.id].initialized=!0);g.parsePolicies(a,J[a.id].policies||{},a.args);for(c in J[a.id].prototype)a[c]=
J[a.id].prototype[c];for(c in J[a.id].events)a.addEventListener(c,J[a.id].events[c])});g.addEventListener(["rendered","dataloaderror","nodatatodisplay","rendercancelled"],function(a,p){var c=a.sender;c instanceof g.core&&c.__state&&c.__state.rendering&&(g.raiseEvent("internal.rendered",p,c),delete c.__state.rendering)});g.addEventListener("loaded",function(d){var p=d.sender;d=d.sender.ref;var c,v;if(void 0!==d&&null!==d&&"function"===typeof d.getExternalInterfaceMethods){try{c=d.getExternalInterfaceMethods(),
c="string"===typeof c?c.split(","):[]}catch(l){c=[],g.raiseError(p,"13111126041","run","RendererManager^Loaded",Error("Error while retrieving data from the chart-object."+(l.message&&0<=l.message.indexOf("NPObject")?" Possible cross-domain security restriction.":"")))}for(d=0;d<c.length;d+=1)v=c[d],void 0===p[v]&&(p[v]=a(v));if(p.ref)for(v in c=w.protectedMethods,d=w.getRenderer(p.options.renderer).protectedMethods,p)if(d&&!c[v]&&!d[v]&&void 0===p.ref[v])try{p.ref[v]=O(p,v)}catch(l){}}});g.legacyEventList.resized=
"FC_Resized";g.extend(g.core.prototype,{render:function(a,p,c){var d=g.hcLib;c?"function"!==typeof c&&(c=void 0):"function"===typeof p?(c=p,p=void 0):p||"function"!==typeof a||(c=a,a=void 0);void 0===a&&(a=this.options.containerElementId);"string"===typeof a&&(a=D.getElementById(a));if(void 0===a||null===a)return g.raiseError(this,"03091456","run",".render()",Error("Unable to find the container DOM element.")),this;N(a)?ga(this,a,p,c):this.args.asyncRender?d.schedular.addJob(this.renderChart,this,
[a,p,c],d.priorityList.render):this.renderChart.call(this,a,p,c);return this},renderChart:function(a,p,c){var v=this,l,e,q;if(!this.disposed){if((q=m[this.id])&&q.FusionCharts&&q.FusionCharts===this||(q=this.ref)&&q.FusionCharts&&q.FusionCharts===this)g.renderer.dispose(this),q===m[this.id]&&(m[this.id]=void 0);void 0!==m[this.id]&&g.raiseError(this,"25081843","comp",".render",Error("#25081843:IECompatibility() Chart Id is same as a JavaScript variable name. Variable naming error. Please use unique name forchart JS variable, chart-id and container id."));
c?"function"!==typeof c&&(c=void 0):"function"===typeof p?(c=p,p=void 0):p||"function"!==typeof a||(c=a,a=void 0);p=(p||this.options.insertMode).toLowerCase()||F.REPLACE;void 0===a&&(a=this.options.containerElementId);"string"===typeof a&&(a=D.getElementById(a));if(void 0===a||null===a)return g.raiseError(this,"03091456","run",".render()",Error("Unable to find the container DOM element.")),this;if(d(this.id,a))return g.raiseError(this,"05102109","run",".render()",Error("A duplicate object already exists with the specific Id: "+
this.id)),this;l=D.createElement(this.options.containerElementType||"span");l.setAttribute("id",this.id);if("append"!==p&&"prepend"!==p)for(;a.hasChildNodes();)a.removeChild(a.firstChild);"prepend"===p&&a.firstChild?a.insertBefore(l,a.firstChild):a.appendChild(l);this.options.containerElement=a;this.options.containerElementId=a.id;if(p=l.style)p.position="relative",p.textAlign="left",p.lineHeight="normal",p.display="inline-block",p.zoom="1",p["vertical-align"]="middle",p.fontWeight="normal",p.fontVariant=
"normal",p.fontStyle="normal",p.textDecoration="none",p["*DISPLAY"]="inline",p.padding="0",p.margin="0",p.border="none",p.direction="ltr";this.options.containerClassName&&(l.className=this.options.containerClassName);p=g.normalizeCSSDimension(this.width,this.height,l);this.__state.renderedWidth=p.pixelWidth;this.__state.renderedHeight=p.pixelHeight;this.__state.rendering=!0;g.raiseEvent("beforeRender",e={container:a,width:this.width,height:this.height,renderer:this.options.renderer},this,void 0,function(a,
e){!0!==this.disposed&&g.renderer.render(v,l,function(){g.renderer.notifyRender.apply(this,arguments);if(c)try{c.call(a.sender,e.container)}catch(q){setTimeout(function(){throw q;})}})},function(){g.raiseEvent("renderCancelled",e,v)});return this}},remove:function(){g.renderer.remove(this);return this},resizeTo:function(a,p,c){var d=this,O=d.width,e=d.height,q=d.__state;(d.apiInstance&&d.apiInstance.config||{}).resize=!0;"object"===typeof a&&(c=p,p=a.h,a=a.w);a=null===a||void 0===a?O:a.toString().replace(l,
"");p=null===p||void 0===p?e:p.toString().replace(l,"");!0!==c?g.raiseEvent("beforeresize",{currentWidth:O,currentHeight:e,newWidth:a,newHeight:p},d,void 0,function(){d.width=a;d.height=p;g.renderer.resize(d,{width:a,height:p});g.raiseEventWithLegacy("resized",{width:d.width,height:d.height,prevWidth:O,prevHeight:e,pixelWidth:d.ref&&d.ref.offsetWidth||0,pixelHeight:d.ref&&d.ref.offsetHeight||0,originalWidth:q.renderedWidth,originalHeight:q.renderedHeight},d,[d.id,d.width,d.height])},function(){g.raiseEvent("resizecancelled",
{currentWidth:O,currentHeight:e,cancelledTargetWidth:a,cancelledTargetHeight:p},d)}):(d.width=a,d.height=p);return this},dispose:function(){var a=this,d={};g.raiseEvent("beforeDispose",d,a,void 0,function(){g.renderer.dispose(a);g.raiseEvent("disposed",d,a);g.disposeEvents(a);delete g.core.items[a.id];for(var c in a)a.hasOwnProperty(c)&&delete a[c];a.disposed=!0},function(){g.raiseEvent("disposeCancelled",d,a)})},configure:function(a,d){var c;a&&("string"===typeof a?(c={},c[a]=d):c=a,g.renderer.config(this,
c))}});g.extend(g.core,{setCurrentRenderer:function(){var a=w.setDefault.apply(w,arguments);w.userSetDefault=!0;return a},getCurrentRenderer:function(){return w.currentRendererName.apply(w,arguments)},render:function(a,d){return a instanceof g.core?(a.render(d),a):(new g.core(a)).render(d)}},!1)}]);FusionCharts.register("module",["private","modules.interface.transcoder",function(){var g=this,m=g.window,D=g.transcoders={},n={},F={},A=/url$/i,J=g._interactiveCharts={selectscatter:[!0,!1],dragcolumn2d:[!0,
!0],dragarea:[!0,!0],dragline:[!0,!0],dragnode:[!0,!0]},a=function(a,c,v,r){var e=v.obj;v=v.args;v.dataSource=a;v.xmlHttpRequestObject=c;v.source="XmlHttpRequest";v.url=r;g.raiseEvent("dataLoadRequestCompleted",v,e,void 0,d,l)},O=function(a,c,d){var l=d.obj;d=d.args;d.error=a;d.httpStatus=c.xhr&&c.xhr.status?c.xhr.status:-1;d.xmlHttpRequestObject=c;g.raiseEvent("dataLoadError",d,l);"function"===typeof m.FC_DataLoadError&&m.FC_DataLoadError(l.id,d)},d=function(a,c){a.sender.setChartData(c.dataSource,
c.dataFormat,c.config,c.successcallback,c.silent)},l=function(a,c){g.raiseEvent("dataLoadCancelled",c,a.sender);c.xmlHttpRequestObject.abort()},N=function(d,c){var v=d.sender,l=v.__state,e=c.url;v.options.dataSource=c.url;l.dhmXhrObj||(l.dhmXhrObj=new g.ajax(a,O));l.dhmXhrObj.get("function"===typeof m.decodeURIComponent?m.decodeURIComponent(e):m.unescape(e),{obj:v,args:c})},ga=function(a,c){var d=a.sender,l=d.__state;g.raiseEvent("dataLoadRequestCancelled",c,d);l&&l.dhmXhrObj&&l.dhmXhrObj.abort()},
w=function(a,c){var d=a.sender,l=d.__state,e=d.id;n[e]=c;F[e]&&delete F[e];F[e]={};l.dataReady=void 0;l.dataAvailable=!0;!0!==c.silent&&(!0!==d.options.safeMode||!0!==l.rendering||d.isActive()?(delete l.args,g.renderer.update(d,c)):(l.updatePending=c,g.raiseWarning(d,"23091255","run","::DataHandler~update","Renderer update was postponed due to async loading.")));g.raiseEvent("dataUpdated",c,d,void 0,c.successcallback)},r=function(a,c){g.raiseEvent("dataUpdateCancelled",c,a.sender,void 0,c.failurecallback)};
g.dataFormats={};g.policies.options.dataSource=["dataSource",void 0];g.policies.options.dataFormat=["dataFormat",void 0];g.policies.options.dataConfiguration=["dataConfiguration",void 0];g.policies.options.showDataLoadingMessage=["showDataLoadingMessage",!1];g.addDataHandler=function(a,c){if("string"!==typeof a||void 0!==D[a.toLowerCase()])g.raiseError(g.core,"03091606","param","::DataManager.addDataHandler",Error("Invalid Data Handler Name"));else{var d={},l=a.toLowerCase();D[l]=c;c.name=a;d["set"+
a+"Data"]=function(c,d,l){return this.setChartData(c,a,d,l)};c.transportable&&(d["set"+a+"Url"]=function(c,d,l){return this.setChartDataUrl(c,a,d,l)},g.dataFormats[a+"URL"]=l+"Url");d["get"+a+"Data"]=function(){return this.getChartData(a)};g.dataFormats[a]=l;g.extend(g.core,d,!0)}};g.extend(g.core.prototype,{setChartDataUrl:function(a,c,d,l,e){if(void 0===c||null===c||"function"!==typeof c.toString)c=this.options.dataFormat,g.raiseWarning(this,"03091609","param","FusionCharts#setChartDataUrl","Invalid Data Format. Reverting to current data format - "+
c);c=c.toString().toLowerCase();c=A.test(c)?c.slice(0,-3):c;g.raiseEvent("dataLoadRequested",{source:"XmlHttpRequest",url:a,dataFormat:c,silent:!!e,config:d,successcallback:l},this,void 0,N,ga)},setChartData:function(a,c,d,l,e){var q=this.options,H,t;if(void 0===c||null===c||"function"!==typeof c.toString)c=q.dataFormat,g.raiseWarning(this,"03091610","param","FusionCharts#setChartData","Invalid Data Format. Reverting to current data format - "+c);c=c.toString().toLowerCase();A.test(c)?this.setChartDataUrl(a,
c,d,l,e):(q.dataSource=a,H=c,q.dataFormat=c,t=D[H],"undefined"===typeof t?g.raiseError(g.core,"03091611","param","FusionCharts#setChartData",Error("Data Format not recognized")):(c=(c=g.renderer&&g.renderer.getRenderer(q.renderer||g.renderer.currentRendererName()))&&c.dataFormat,d=c===H?t.passthrough?t.passthrough(a,d,q.chartType):{data:a}:t.encode(a,this,d||q.dataConfiguration)||{},d["native"]=c===H,d.format=d["native"]?c:"xml",d.dataFormat=H,d.dataSource=a,d.silent=!!e,"function"===typeof l&&(d.successcallback=
l),g.raiseEvent("beforeDataUpdate",d,this,void 0,w,r)))},getChartData:function(a,c){var d=this.options,l=this.id,e;if(void 0===a||"function"!==typeof a.toString||void 0===(e=D[a=a.toString().toLowerCase()]))g.raiseError(this,"25081543","param","::transcoder~getChartData()",Error('Unrecognized data-format specified in "format"'));else return F[l][a]&&(F[l][a]=null),F[l][a]?d=F[l][a]:n[l]?(a===n[l].format?F[l][a]=n[l]:(F[l].xml||(F[l].xml="xml"===n[l].format?n[l]:D[n[l].format].encode(n[l].data,this,
d.dataConfiguration)),F[l][a]||(F[l][a]=e.decode(F[l].xml.data,this,d.dataConfiguration))),d=F[l][a]):d={error:Error("Data not defined")},!0===!!c?d:d.data},dataReady:function(a){return a?this.__state.dataAvailable:this.__state.dataReady}});g.extend(g.core,{transcodeData:function(a,c,d,l,e){if(c&&"function"===typeof c.toString&&d&&"function"===typeof d.toString&&void 0!==D[d=d.toString().toLowerCase()]&&void 0!==D[c=c.toString().toLowerCase()])return a=D[c].encode(a,this,e),c=D[d].decode(a.data,this,
e,c),c.error instanceof Error||(c.error=a.error),l?c:c.data;g.raiseError(this,"14090217","param",".transcodeData()",Error("Unrecognized data-format specified during transcoding."))}},!1);g.getRenderer&&!g.getRenderer("flash")||g.addEventListener("DataLoadRequested",function(a){var c=a.sender;c.options&&"flash"===c.options.renderer&&c.options.useLegacyXMLTransport&&a.preventDefault()});g.addEventListener("beforeInitialize",function(a){a=a.sender;var c=a.options,d=c.dataSource,l=g.renderer&&g.renderer.getRenderer(c.renderer);
delete n[a.id];F[a.id]={};if(void 0!==d&&null!==d){a.__state.dataSetDuringConstruction=!0;if("string"!==typeof c.dataFormat)switch(typeof d){case "function":d=c.dataSource=d.call(a,c.dataConfiguration);c.dataFormat="JSON";break;case "string":c.dataFormat=/^\s*?\{[\s\S]*\}\s*?$/g.test(a.options.dataFormat)?"JSON":"XML";break;case "object":c.dataFormat="JSON"}c.dataFormat&&c.dataFormat.toString&&(a.__state.dataFetchDuringConstruction=A.test(c.dataFormat.toString()));a.setChartData(d,c.dataFormat,void 0,
void 0,!0)}else l&&(a.__state.dataSetDuringConstruction=!1,g.raiseWarning(a,"1810131922A","param",":dataHandler~event:beforeInitialize","Data source was not defined during construction, hence set to blank renderer default - "+l.dataFormat),a.setChartData("",l.dataFormat,void 0,void 0,!0),a.__state.dataAvailable=!1)});g.addEventListener("beforeDispose",function(a){var c=a.sender;delete n[a.sender.id];delete F[a.sender.id];c&&c.__state&&c.__state.dhmXhrObj&&c.__state.dhmXhrObj.abort()});g.addEventListener("disposed",
function(a){delete F[a.sender.id]});g.addEventListener("loaded",function(a){a=a.sender;var c=a.__state.updatePending;a instanceof g.core&&void 0!==c&&(delete a.__state.updatePending,g.renderer.update(a,c))});g.addEventListener("dataUpdated",function(a,c){var d=a.sender,l=d.__state;l.rendering&&(l.dataFetchDuringConstruction||l.updatePending)&&(delete l.dataFetchDuringConstruction,delete l.updatePending,g.renderer.update(d,c))});g.addEventListener(["dataLoadError","dataInvalid"],function(a){a.sender.__state.dataAvailable=
!1});g.addEventListener("loaded",function(a){a=a.sender;var c=a.__state,d,l,e;e=function(a,c){return function(e){return!1===e?c.apply(this):this.ref.getUpdatedXMLData?g.core.transcodeData(this.ref.getUpdatedXMLData(),"xml",a):this.getData?this.getData(a):c.apply(this)}};if(a.chartType&&J[a.chartType()]&&J[a.chartType()][0]){for(d in g.transcoders)l=g.transcoders[d].name,l="get"+l+"Data",a[l]=e(d,a.constructor.prototype[l]),a[l]._dynamicdatarouter=!0;c.dynamicDataRoutingEnabled=!0}else if(c.dynamicDataRoutingEnabled){for(d in g.transcoders)l=
g.transcoders[d].name,l="get"+l+"Data",a.hasOwnProperty(l)&&a[l]._dynamicdatarouter&&delete a[l];c.dynamicDataRoutingEnabled=!1}})}]);"object"!==typeof JSON&&(JSON={});(function(){function g(a){return 10>a?"0"+a:a}function m(d){F.lastIndex=0;return F.test(d)?'"'+d.replace(F,function(d){var g=a[d];return"string"===typeof g?g:"\\u"+("0000"+d.charCodeAt(0).toString(16)).slice(-4)})+'"':'"'+d+'"'}function D(a,l){var g,n,w,r,p=A,c,v=l[a];v&&"object"===typeof v&&"function"===typeof v.toJSON&&(v=v.toJSON(a));
"function"===typeof O&&(v=O.call(l,a,v));switch(typeof v){case "string":return m(v);case "number":return isFinite(v)?String(v):"null";case "boolean":case "null":return String(v);case "object":if(!v)return"null";A+=J;c=[];if("[object Array]"===Object.prototype.toString.apply(v)){r=v.length;for(g=0;g<r;g+=1)c[g]=D(g,v)||"null";w=0===c.length?"[]":A?"[\n"+A+c.join(",\n"+A)+"\n"+p+"]":"["+c.join(",")+"]";A=p;return w}if(O&&"object"===typeof O)for(r=O.length,g=0;g<r;g+=1)"string"===typeof O[g]&&(n=O[g],
(w=D(n,v))&&c.push(m(n)+(A?": ":":")+w));else for(n in v)Object.prototype.hasOwnProperty.call(v,n)&&(w=D(n,v))&&c.push(m(n)+(A?": ":":")+w);w=0===c.length?"{}":A?"{\n"+A+c.join(",\n"+A)+"\n"+p+"}":"{"+c.join(",")+"}";A=p;return w}}"function"!==typeof Date.prototype.toJSON&&(Date.prototype.toJSON=function(){return isFinite(this.valueOf())?this.getUTCFullYear()+"-"+g(this.getUTCMonth()+1)+"-"+g(this.getUTCDate())+"T"+g(this.getUTCHours())+":"+g(this.getUTCMinutes())+":"+g(this.getUTCSeconds())+"Z":
null},String.prototype.toJSON=Number.prototype.toJSON=Boolean.prototype.toJSON=function(){return this.valueOf()});var n=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,F=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,A,J,a={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"},O;"function"!==typeof JSON.stringify&&(JSON.stringify=function(a,
l,g){var m;J=A="";if("number"===typeof g)for(m=0;m<g;m+=1)J+=" ";else"string"===typeof g&&(J=g);if((O=l)&&"function"!==typeof l&&("object"!==typeof l||"number"!==typeof l.length))throw Error("JSON.stringify");return D("",{"":a})});"function"!==typeof JSON.parse&&(JSON.parse=function(a,l){function g(a,d){var p,c,v=a[d];if(v&&"object"===typeof v)for(p in v)Object.prototype.hasOwnProperty.call(v,p)&&(c=g(v,p),void 0!==c?v[p]=c:delete v[p]);return l.call(a,d,v)}var O;a=String(a);n.lastIndex=0;n.test(a)&&
(a=a.replace(n,function(a){return"\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4)}));if(/^[\],:{}\s]*$/.test(a.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,"@").replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,"]").replace(/(?:^|:|,)(?:\s*\[)+/g,"")))return O=eval("("+a+")"),"function"===typeof l?g({"":O},""):O;throw new SyntaxError("JSON.parse");})})();FusionCharts.register("module",["private","modules.data.json",function(){var g=this,m=g.window,D=m.document,n=g.xssEncode,
F,A,J=function(a){var g,d;for(g in a)a.hasOwnProperty(g)&&(d=g.toLowerCase(),g!==d&&(a[d]=a[g],delete a[g]),"object"===typeof a[d]&&"data"!==d&&J(a[d]))};void 0===m.JSON&&g.raiseError(this,"1113062012","run","JSONDataHandler",Error("Could not find library support for JSON parsing."));g.policies.options.allowIESafeXMLParsing=["_allowIESafeXMLParsing",!0];F=function(){var a={set:!0,trendlines:!0,vtrendlines:!0,line:{trendlines:!0,vtrendlines:!0},data:!0,dataset:!0,lineset:!0,categories:!0,category:!0,
tasks:!0,linkeddata:!0,application:!0,definition:!0,axis:!0,connectors:!0,connector:{connectors:!0},trendset:!0,row:{rows:!0},column:{columns:!0},label:{labels:!0},color:{colorrange:!0},dial:{dials:!0},pointer:{pointers:!0},point:{trendpoints:!0},process:{processes:!0},task:{tasks:!0},milestone:{milestones:!0},datacolumn:{datatable:!0},text:{datacolumn:!0},item:{legend:!0},alert:{alerts:!0},groups:{annotations:!0},items:{groups:!0,data:!0},shapes:!0,shape:{shapes:!0},entitydef:!0,entity:{entitydef:!0}},
O={chart:"linkedchart",map:"linkedmap",set:"data",vline:{chart:"data",graph:"data",dataset:"data",categories:"category",linkedchart:"data"},apply:{application:"application"},style:{definition:"definition"},marker:{application:"application",definition:"definition",data:"items"},entity:{entitydef:"entitydef",data:"data"},shape:{shapes:"shapes"},connector:{connectors:{chart:"connector",linkedchart:"connector",map:"connectors",linkedmap:"connectors"}},annotationgroup:{annotations:"groups"},annotation:{groups:"items"}},
d={vline:{vline:"true"}},l={chart:!0,map:!0,graph:!0},n={dataset:"data",categories:"category"},A={target:"target",value:"value"},w={styles:{definition:!0,application:!0},chart:{value:!0,target:!0},graph:{value:!0,target:!0},linkedchart:{value:!0,target:!0},markers:{definition:!0,application:!0,shapes:!0,connectors:!0,data:!0},map:{entitydef:!0,data:!0},linkedmap:{entitydef:!0,data:!0}},r,p,c;r={append:function(c,d,e,q){!a[e]||!0!==a[e]&&!0!==a[e][q]?d[e]=c:(d[e]instanceof Array||(d[e]=[]),d[e].push(c))},
child:function(a,c,e,q){var p,t,m,K,F,S;for(p=0;p<c.length;p+=1)switch(m=c[p],t=m.nodeName.toLowerCase(),m.nodeType){case 1:K=r.attr(m.attributes);S=l[t];!0===S&&(F=K,K={},K[t]=F);S=d[t];"object"===typeof S&&g.extend(K,S);if(S=O[t])if("object"===typeof S&&"object"===typeof S[e])for(F in F=void 0,S[e]){if(q[F]){t=S[e][F];break}}else"object"===typeof S&&"string"===typeof S[e]?t=S[e]:"string"===typeof S&&(t=S);m.childNodes.length&&((S=w[e])&&S[t]?r.child(a,m.childNodes,t,q):r.child(K,m.childNodes,t,
q));(S=w[e])&&S[t]||r.append(K,a,t,e);break;case 3:if(S=A[e])t=S,K=m.data,r.append(K,a,t,e);S=n[e];"string"===typeof S&&q.chart&&parseInt(q.chart.compactdatamode,10)&&(t=S,K=m.data,a[t]=a[t]?a[t]+K:K)}},attr:function(a){var d,e={};if(!a||!a.length)return e;for(d=0;d<a.length;d+=1)"xml"===c&&(a[d].value?a[d].value=a[d].value.replace(/</g,"&lt;").replace(/>/g,"&gt;"):a[d].nodeValue&&(a[d].nodeValue=a[d].nodeValue.replace(/</g,"&lt;").replace(/>/g,"&gt;"))),e[a[d].nodeName.toLowerCase()]=a[d].value||
a[d].nodeValue;return e}};p=function(a){var c={},e,d,l,t,O,w,n,N,T;if("object"!==typeof a&&a&&"function"!==typeof a.toString)return p.errorObject=new TypeError("xml2json.parse()"),c;a=a.toString().replace(/<\!--[\s\S]*?--\x3e/g,"").replace(/<\?xml[\s\S]*?\?>/ig,"").replace(/&(?!([^;\n\r]+?;))/g,"&amp;$1");a=a.replace(/^\s\s*/,"");for(var A=/\s/,ga=a.length;A.test(a.charAt(--ga)););a=a.slice(0,ga+1);if(!a)return c;try{m.DOMParser?e=(new m.DOMParser).parseFromString(a,"text/xml"):D.body&&g.core.options.allowIESafeXMLParsing?
(d=D.createElement("xml"),d.innerHTML=a,D.body.appendChild(d),e=d.XMLDocument,D.body.removeChild(d)):(e=new m.ActiveXObject("Microsoft.XMLDOM"),e.async="false",e.loadXML(a));if(!(e&&e.childNodes&&1===e.childNodes.length&&(l=e.childNodes[0])&&l.nodeName&&(t=l.nodeName.toLowerCase()))||"chart"!==t&&"map"!==t&&"graph"!==t)return p.errorObject=new TypeError("xml2json.parse()"),c;if("graph"===t){O=e.createElement("chart");for(T=(n=l.attributes)&&n.length||0;T--;)O.setAttribute(n[T].name,n[T].value),n.removeNamedItem(n[T].name);
if(T=(N=l.childNodes)&&N.length||0)--T,w=l.removeChild(N[T]),O.appendChild(w);for(;T--;)w=l.removeChild(N[T]),O.insertBefore(w,O.firstChild);e.replaceChild(O,l);l=O}}catch(I){p.errorObject=I}l?(l.attributes&&(c[t]=r.attr(l.attributes)),l.childNodes&&r.child(c,l.childNodes,t,c),delete p.errorObject):p.errorObject=new TypeError("xml2json.parse()");return c};return function(a){delete p.errorObject;c=arguments[arguments.length-1];return{data:p(a),error:p.errorObject}}}();A=function(){var a,g;a={items:{explode:{data:"set",
groups:{annotations:"annotationgroup"},items:{groups:"annotation"}},text:{chart:{target:"target",value:"value"},graph:{target:"target",value:"value"}},dsv:{dataset:{data:"dataset"},categories:{category:"categories"}},attr:{chart:{chart:"chart"},graph:{graph:"graph"},map:{map:"map"},linkedmap:{map:"map"},linkedchart:{chart:"chart"}},group:{styles:{definition:"style",application:"apply"},map:{data:"entity",entitydef:"entity"},markers:{definition:"marker",application:"marker",shapes:"shape",connectors:"connector",
items:"marker"}},tag:{markers:{items:"data"}}},qualify:function(a,l,g){return"object"===typeof this.items[a][g]?this.items[a][g][l]:this.items[a][g]}};g=function(d,l,m,A){var w="",r="",p="",c="",v,M,e;l&&"function"===typeof l.toLowerCase&&(l=l.toLowerCase());if(void 0===m&&d[l])for(v in d[l])M=v.toLowerCase(),"compactdatamode"===M&&(A.applyDSV=1==d[l][v]);if(d instanceof Array)for(v=0;v<d.length;v+=1)p="string"===typeof d[v]?p+n(d[v]):p+g(d[v],l,m,A);else{for(v in d)M=v.toLowerCase().replace(/[`~!@#$%^&*()|+\=?;:'", <>\{\}\[\]\\\/]/gi,
""),d[v]instanceof Array&&(e=a.qualify("group",M,l))?(p=a.qualify("tag",M,l)||M,r+="<"+p+">"+g(d[v],e,l,A)+"</"+p+">"):"object"===typeof d[v]?(e=a.qualify("attr",M,l))?(c=g(d[v],e,l,A).replace(/\s*\/\>/ig,""),l=M):r+=g(d[v],M,l,A):A.applyDSV&&(e=a.qualify("dsv",M,l))?r+=d[v]:(e=a.qualify("text",M,l))?(p=a.qualify("tag",M,l)||e,r+="<"+p+">"+d[v]+"</"+p+">"):"vline"===M&&d[v]?l="vline":w+=" "+M+'="'+n(d[v]).toString().replace(/\"/ig,"&quot;")+'"';if(e=a.qualify("explode",m,l))l=e;p=l;p=(""!==c?c:"<"+
p)+w+(""!==r?">"+r+"</"+p+">":" />")}return p};return function(a){delete g.errorObject;if(a&&"string"===typeof a)try{a=JSON.parse(a)}catch(l){g.errorObject=l}return{data:g(a,a&&a.graph?"graph":a&&a.map?"map":"chart",void 0,{}),error:g.errorObject}}}();g.addDataHandler("JSON",{encode:A,decode:F,passthrough:function(a,g,d){g={data:{}};d=!!/zoomscatter/ig.test(d);if(!a)return g;if("string"!==typeof a)try{a=JSON.stringify(a)}catch(l){return g.error=l,g}try{d?(g.data=JSON.parse(a),J(g.data)):g.data=JSON.parse(a.replace(/"([^"]+)"[\s]*:/g,
function(a,d){return'"'+d.toLowerCase()+'":'}))}catch(l){console.log(l),g.error=l}return g},transportable:!0})}]);FusionCharts.register("module",["private","modules.data.xml",function(){var g=function(g){return{data:g,error:void 0}};this.addDataHandler("XML",{encode:g,decode:g,transportable:!0})}]);FusionCharts.register("module",["private","modules.data.csv",function(){var g=this,m=g.window,D=g.core,n=m.parseInt,F=m.parseFloat,A=function(a){return a},J;J=function(a){this.data=[];this.columnCount=
this.rowCount=0;this.configure(a)};J.decodeLiterals=function(a,g){return void 0!==a&&null!==a&&a.toString?a.replace("{tab}","\t").replace("{quot}",'"').replace("{apos}","'"):g};J.prototype.set=function(a,g,d){var l;if(this.rowCount<=a){for(l=this.rowCount;l<=a;l+=1)this.data[l]=[];this.rowCount=a+1}this.columnCount<=g&&(this.columnCount=g+1);this.data[a][g]=d};J.prototype.setRow=function(a,g){var d;if(this.rowCount<=a){for(d=this.rowCount;d<=a;d+=1)this.data[d]=[];this.rowCount=a+1}this.columnCount<
g.length&&(this.columnCount=g.length);this.data[a]=g};J.prototype.get=function(a,g){var d=this.data;return d[a]&&d[a][g]};J.prototype.configure=function(a){var g=J.decodeLiterals;this.delimiter=g(a.delimiter,",");this.qualifier=g(a.qualifier,'"');this.eolCharacter=g(a.eolCharacter,"\r\n");this.numberFormatted=!!n(a.numberFormatted,0)};J.prototype.clear=function(){this.data=[];this.columnCount=this.rowCount=0};J.prototype.toString=function(){var a,g,d="";for(a=0;a<this.rowCount;a+=1)g=this.qualifier+
this.data[a].join(this.qualifier+this.delimiter+this.qualifier)+this.qualifier,d+='""'===g?this.eolCharacter:g+this.eolCharacter;0<this.rowCount&&(d=d.slice(0,d.length-2));return d};g.addDataHandler("CSV",{encode:function(a,m){g.raiseError(m,"0604111215","run","::CSVDataHandler.encode()","FusionCharts CSV data-handler only supports encoding of data.");throw Error("FeatureNotSupportedException()");},decode:function(a,g){var d=D.transcodeData(a,"xml","json")||{},l=g.jsVars,m=l&&l.instanceAPI,n=m&&m.components,
w,r,p,c,v,M,e=d.chart||d.map||d.graph||{},q=!!e.exporterrorcolumns,H=d.categories&&d.categories[0]&&d.categories[0].category||[],t=d.map&&!d.chart||l&&l.instanceAPI&&"geo"===l.instanceAPI.defaultSeriesType,L=!1,K=!1,pa=!1,S=!1,T=!1,ba=A,aa={},I,ia,C,za,Ja,na,ea,ra,V,va;p=0;var nb=-1,La;w=new J({separator:e.exportdataseparator,qualifier:e.exportdataqualifier,numberFormatted:e.exportdataformattedval});D.formatNumber&&w.numberFormatted&&(ba=function(a,c){return D.formatNumber(a,e,c)});if(t)for(r in aa.geo=
!0,H=(t=n&&l.instanceAPI.components.dataset&&l.instanceAPI.components.dataset[0])&&t.components.data||[],w.setRow(0,["Id"," Short Name","Long Name","Value","Formatted Value"]),l=0,H)K=H[r],va=K.config,t=va.cleanValue,!0!==K.hidden&&w.setRow(++l,[r,va.shortLabel,va.label,null===t?"":t,va.formattedValue]);else if(void 0!==(I=d.dials&&d.dials.dial||d.pointers&&d.pointers.pointer||d.value))if(aa.gauge=!0,"string"===typeof I)w.set(0,0,ba(I)),aa.singlevalue=!0,"string"===typeof d.target&&(w.set(0,1,ba(d.target)),
aa.bullet=!0);else for(w.setRow(0,["Id","Value"]),aa.multivalue=!0,l=0,M=1,v=I.length;l<v;l+=1,M+=1)w.setRow(M,[M,ba(I[l].value)]);else if(I=d.dataset||!(d.data instanceof Array)&&[]){aa.multiseries=!0;p=1;if(ia=d.lineset)I=I.concat(ia),aa.lineset=!0;if(C=d.axis)I=I.concat(C),aa.multiaxis=!0;t=m.defaultDatasetType&&m.defaultDatasetType.toLowerCase();"dragnode"!==t&&"dragcolumn"!==t&&"dragline"!==t&&"dragarea"!==t||!m.getJSONData||(I=m.getJSONData().dataset);na=I.length;Ja=H.length;if(!(na=I.length)){for(l=
0;l<Ja;l+=1)ea=H[l],w.set(l+1,0,ea.label||ea.name);aa.multilevel=!0}for(l=0;l<na;l+=1)for(ra=I,ra[l].dataset?(ra=ra[l].dataset,c=0,za=ra.length):(ra=I,c=l,za=c+1);c<za&&!L&&!pa;c+=1)if(T=ra[c],nb++,!(n&&n.dataset&&n.dataset[nb]&&!1===n.dataset[nb].visible)){La=(t=n&&n.dataset&&n.dataset[nb])&&t.config&&t.config.parentYAxis;w.set(0,p,T.seriesname);"string"===typeof T.data&&(aa.compactdata=!0,T.data=T.data.split(e.dataseparator||"|"));M=v=0;for(V=T.data&&T.data.length||0;v<V||v<Ja;v+=1){ea=H[v];r=M+
1;t=T.data&&T.data[M]||{};if(void 0!==t.x&&void 0!==t.y){L=aa.xy=!0;break}if(void 0!==t.open||void 0!==t.high||void 0!==t.close||void 0!==t.low){S=aa.ohlc=!0;break}if(void 0!==t.rowid&&void 0!==t.columnid){pa=aa.heatmap=!0;break}if(v<Ja&&!ea.vline){w.set(r,0,ea.label||ea.name);ea=F(t?t.value:"");ea=isNaN(ea)?"":ba(ea,La);w.set(r,p,ea);if(K||q||t.errorvalue)K||w.set(0,p+1,"Error"),va=1,w.set(r,p+1,ba(t.errorvalue));M+=1}}va&&(p+=va,va=0);p+=1}ia&&(I=I.slice(0,-ia.length));C&&(I=I.slice(0,-C.length))}else if(I=
d.data){w.set(0,1,e.yaxisname||"Value");aa.singleseries=!0;T="1"==e.showsumatend;l=0;for(Ja=I.length;l<Ja;l+=1)t=I[l],t.vline||(ea=F(t.value?t.value:""),w.setRow(l+1,[t.label||t.name,isNaN(ea)?"":(p+=ea,ba(ea))]));T&&(aa.summation=!0,w.setRow(l+1,[e.sumlabel||"Total",ba(p)]))}if(S)for(w.clear(),w.setRow(0,["Open","Close","High","Low"]),l=0,r=1,I=d.dataset,za=I.length;l<za;l+=1)for(v=0,T=I[l]&&I[l].data||[],na=T.length;v<na;v+=1,r+=1)t=T[v]||{},w.setRow(v+1,[ba(t.open),ba(t.close),ba(t.high),ba(t.low)]);
else if(L)for(w.clear(),K=!1,va=0,w.setRow(0,["Series","x","y"]),l=0,r=1,I=d.dataset,za=I.length;l<za;l+=1){if(!(n&&n.dataset&&n.dataset[l]&&!1===n.dataset[l].visible))for(t=m.defaultDatasetType&&m.defaultDatasetType.toLowerCase(),"dragnode"===t&&m.getJSONData&&(I=m.getJSONData().dataset),v=0,T=I[l]&&I[l].data||[],na=T.length;v<na;v+=1,r+=1){t=T[v]||{};ea=[I[l].seriesname,ba(t.x),ba(t.y)];void 0!==t.z&&(ea.push(ba(t.z)),va||(w.set(0,3,"z"),va=1));if(K||q||void 0!==t.errorvalue||void 0!==t.horizontalerrorvalue||
void 0!==t.verticalerrorvalue)d=ba(t.errorvalue),ea.push(t.errorvalue,void 0===t.horizontalerrorvalue?d:ba(t.horizontalerrorvalue),void 0===t.verticalerrorvalue?d:ba(t.verticalerrorvalue)),K||(w.set(0,va+3,"Error"),w.set(0,va+4,"Horizontal Error"),w.set(0,va+5,"Vertical Error")),K=aa.error=!0;w.setRow(r,ea)}}else if(pa){w.clear();q={};L={};l=0;v=1;H=d.rows&&d.rows.row||[];for(m=H.length;l<m;l+=1,v+=1)ea=H[l],ea.id&&(q[ea.id.toLowerCase()]=v,w.set(v,0,ea.label||ea.id));l=0;v=1;H=d.columns&&d.columns.column||
[];for(m=H.length;l<m;l+=1,v+=1)ea=H[l],ea.id&&(L[ea.id.toLowerCase()]=v,w.set(0,v,ea.label||ea.id));T=d.dataset&&d.dataset[0]&&d.dataset[0].data||[];n=n&&n.dataset&&n.dataset[0]&&n.dataset[0].components&&n.dataset[0].components.data||[];l=0;for(m=T.length;l<m;l+=1)t=T[l],r=t.rowid.toLowerCase(),p=t.columnid.toLowerCase(),n[l]&&!1===n[l].visible||(q[r]||(q[r]=w.rowCount,w.set(w.rowCount,0,t.rowid)),L[p]||(L[p]=w.columnCount,w.set(0,w.columnCount,t.columnid)),w.set(q[r],L[p],ba(t.value)))}I=H=ia=C=
null;0<w.rowCount&&void 0===w.get(0,0)&&w.set(0,0,e.xaxisname||"Label");return{data:w.toString(),error:void 0,predictedFormat:aa}},transportable:!1});D.addEventListener("Loaded",function(a){a=a.sender;"javascript"!==a.options.renderer||a.getDataAsCSV||(a.getDataAsCSV=a.ref.getDataAsCSV=a.getCSVData)})}]);FusionCharts.register("module",["private","modules.renderer.js",function(){var g=this,m=g.window,D=m.document,n=g.core.options,F=/msie/i.test(m.navigator.userAgent)&&!m.opera,A=!(!m.SVGAngle&&!D.implementation.hasFeature("http://www.w3.org/TR/SVG11/feature#BasicStructure",
"1.1")),J=function(){},a=g.hcLib={cmdQueue:[]},O=a.moduleCmdQueue={base:[],charts:[],powercharts:[],widgets:[],maps:[]},d=a.moduleDependencies={},l=a.moduleMeta={base:"fusioncharts.js",charts:"fusioncharts.charts.js",powercharts:"fusioncharts.powercharts.js",widgets:"fusioncharts.widgets.js",maps:"fusioncharts.maps.js"},N={},ga=a.getMetaSentence=function(){var a={};return function(c){c=c&&c.replace(/(^\s*)|(\s*$)/g,"")||"";return a[c]||(a[c]={key:c,subject:c.replace(/[^\/]*?$/ig,""),predicate:c.replace(/^.*\//ig,
"")})}}(),w=a.getDependentModuleName=function(a){var c=[],e,l;a=ga(a).predicate;for(e in d)void 0!==(l=d[e][a])&&(c[l]=e);return c},r=a.hasModule=function(a){var c,e;if(a instanceof Array){c=0;for(e=a.length;c<e;c+=1)if(!g.modules["modules.renderer.js-"+ga(a[c]).predicate])return!1;return!0}return!!g.modules["modules.renderer.js-"+ga(a).predicate]},p=a.loadModule=function(a,c,e,d){a instanceof Array||(a=[a]);var p=a.length,v=0,m;m=function(){if(v>=p)c&&c();else{var w=a[v],O=w&&w.match(/[^\/]*$/i)[0],
n=l[w];v+=1;if(w){if(r(O)){m();return}if(N[O]){g.raiseError(d||g.core,"1112201445A","run","JavaScriptRenderer~loadModule() ","required resources are absent or blocked from loading.");e&&e(O);return}}else e&&e(O);w=g.core.options["html5"+g.capitalizeString(O)+"Src"];g.loadScript(void 0===w?n:w,{success:function(){r(O)?m():e&&e(O)},failure:e&&function(){e(O)}},void 0,!0)}};m()},c=a.executeWaitingCommands=function(a){for(var c;c=a.shift();)"object"===typeof c&&J[c.cmd].apply(c.obj,c.args)},v=function(a){delete a.sender.jsVars._reflowData;
a.sender.jsVars._reflowData={};delete a.sender.jsVars._reflowClean},M=function(){var a=function(){};a.prototype={LoadDataErrorText:"Error in loading data.",XMLLoadingText:"Retrieving data. Please wait",InvalidXMLText:"Invalid data.",ChartNoDataText:"No data to display.",ReadingDataText:"Reading data. Please wait",ChartNotSupported:"Chart type not supported.",PBarLoadingText:"",LoadingText:"Loading chart. Please wait",RenderChartErrorText:"Unable to render chart."};return a.prototype.constructor=a}(),
e=a.getContainerBackgroundColor=function(c){c=c.chartInstance;var e=c.options,d=e.containerBackgroundColor,e=e.containerBackgroundOpacity,l=c.jsVars.transparent;void 0!==l&&null!==l?e=c.jsVars.transparent?0:1:(e=parseFloat(e),0>e?e=0:1<e&&(e=1));d||(d="#ffffff");if(F&&!A)return e?d:"transparent";d=d.replace(/^#?([a-f0-9]+)/ig,"$1");d=a.graphics.HEXtoRGB(d);d[3]=e.toString();return"rgba("+d.join(",")+")"};a.injectModuleDependency=function(c,e,t){var l=!1,p=ga(c).subject;c=ga(c).predicate;e=void 0===
e?c:ga(e).predicate;d[c]||(d[c]={},O[c]||(O[c]=[],a.moduleMeta[c]=p+n.html5ScriptNamePrefix+(e&&e.replace&&e.replace(/^[\s\S]*\//ig,"").replace(/\?/g,"%3F").replace(/\#/g,"%23").replace(/\:/g,"%3A")||"")+n.html5ScriptNameSuffix),l=!0);d[c][e]=t||0;return l};a.needsModule=function(c,e){c=ga(c).predicate;e=ga(e).predicate;return void 0!==(a.moduleDependencies[c]&&a.moduleDependencies[c][e])};a.cleanupWaitingCommands=function(a){for(var c=a.chartType(),c=w(c),e,d=[],l;e=c.shift();){for(e=O[e]||[];l=
e.shift();)"object"===typeof l&&l.obj!==a&&d.push(l);e.concat(d);d=[]}};g.extend(g.core.options,{html5ScriptNameSuffix:".js",html5ScriptNamePrefix:"fusioncharts."});g.extend(J,{dataFormat:"json",ready:!1,policies:{jsVars:{},options:{showChartLoadingMessage:["showChartLoadingMessage",!0]}},init:function(){r("base")?J.ready=!0:p("base",function(){J.ready=!0;c(a.cmdQueue)},void 0,g.core)},render:function(c){var d=c,t=this.jsVars.msgStore;d&&this.options.showChartLoadingMessage&&(d.innerHTML='<small style="display: inline-block; *zoom:1; *display:inline; width: 100%; font-family: Verdana,sans; font-size: 10px; color: #666666; text-align: center; padding-top: '+
(parseInt(d.style.height,10)/2-5)+'px">'+(t.PBarLoadingText||t.LoadingText)+"</small>",d.style.backgroundColor=e(this));a.cmdQueue.push({cmd:"render",obj:this,args:arguments})},update:function(){a.cmdQueue.push({cmd:"update",obj:this,args:arguments})},resize:function(){a.cmdQueue.push({cmd:"resize",obj:this,args:arguments})},dispose:function(){var c=a.cmdQueue,e,d;e=0;for(d=c.length;e<d;e+=1)c[e].obj===this&&(c.splice(e,1),--d,--e)},load:function(){a.cmdQueue.push({cmd:"load",obj:this,args:arguments})},
config:function(a,c){var e,d=this.jsVars,l=d.msgStore,d=d.cfgStore,p=this.options,g;g={LoadingText:"loadMessage",ChartNotSupported:"typeNotSupportedMessage",RenderChartErrorText:"renderErrorMessage",XMLLoadingText:"dataLoadStartMessage",ChartNoDataText:"dataEmptyMessage",LoadDataErrorText:"dataLoadErrorMessage",InvalidXMLText:"dataInvalidMessage"};"string"===typeof a&&1<arguments.length&&(e=a,a={},a[e]=c);for(e in a)void 0!==l[e]?l[e]=a[e]:d[e.toLowerCase()]=a[e],g[e]?p[g[e]]=a[e]:p[e]=a[e]},protectedMethods:{},
events:{beforeInitialize:function(c){var e=c.sender;c=e.jsVars;var d;c.fcObj=e;c.msgStore=c.msgStore||new M;c.cfgStore=c.cfgStore||{};c.previousDrawCount=-1;c.drawCount=0;c._reflowData={};e.addEventListener("beforeRender",function(c){c.sender.jsVars.smartLabel=new a.SmartLabelManager(e.id,D.body||D.getElementsByTagName("body")[0]);c.detachHandler()});c.userModules instanceof Array||(d=c.userModules,c.userModules=[],"string"===typeof d&&(c.userModules=c.userModules.concat(d.split(","))));a.chartAPI&&
a.chartAPI[void 0]||(c.needsLoaderCall=!0)},initialized:function(a){a=a.sender;var c=a.jsVars;c.needsLoaderCall&&(delete c.needsLoaderCall,J.load.call(a))},beforeDataUpdate:v,beforeDispose:function(a){var c=a.sender.jsVars;c.smartLabel&&!c.smartLabel.disposed&&c.smartLabel.dispose();v.apply(this,arguments)},beforeRender:function(a){var c=a.sender.jsVars;delete c.drLoadAttempted;delete c.waitingModule;delete c.waitingModuleError;v.apply(this,arguments)},dataLoadRequested:function(a){a=a.sender;var c=
a.jsVars;delete c.loadError;a.ref&&a.options.showDataLoadingMessage?c.hcObj&&!c.hasNativeMessage&&c.hcObj.showLoading?c.hcObj.showMessage(c.msgStore.XMLLoadingText):a.ref.showChartMessage?a.ref.showChartMessage("XMLLoadingText"):c.stallLoad=!0:c.stallLoad=!0},dataLoadRequestCompleted:function(a){delete a.sender.jsVars.stallLoad},dataLoadError:function(a){var c=a.sender,e=c.jsVars,d=c.args,l=c.options;delete e.stallLoad;e.loadError=!0;c._chartMessageImageStyle={imageHAlign:d.dataLoadErrorMessageImageHAlign||
l.baseChartMessageImageHAlign,imageVAlign:d.dataLoadErrorMessageImageVAlign||l.baseChartMessageImageVAlign,imageAlpha:d.dataLoadErrorMessageImageAlpha||l.baseChartMessageImageAlpha,imageScale:d.dataLoadErrorMessageImageScale||l.baseChartMessageImageScale};c._chartMessageStyle={color:d.dataLoadErrorMessageColor||l.baseChartMessageColor,fontFamily:d.dataLoadErrorMessageFont||l.baseChartMessageFont,fontSize:d.dataLoadErrorMessageFontSize||l.baseChartMessageFontSize};c.apiInstance.setChartMessage&&(c.apiInstance.setChartMessage(l.dataLoadErrorMessage,
c),c.apiInstance.drawChartMessage());c.__state.dataFetchDuringConstruction&&delete c.__state.dataFetchDuringConstruction;v.apply(this,arguments)}},_call:function(a,c,e){a.apply(e||m,c||[])}});g.extend(J.prototype,{getSWFHTML:function(){g.raiseWarning(this,"11090611381","run","JavaScriptRenderer~getSWFHTML()","getSWFHTML() is not supported for JavaScript charts.")},addVariable:function(){g.raiseWarning(this,"11090611381","run","JavaScriptRenderer~addVariable()",'Use of deprecated "addVariable()". Replace with "configure()".');
g.core.prototype.configure.apply(this,arguments)},getXML:function(){g.raiseWarning(this,"11171116291","run","JavaScriptRenderer~getXML()",'Use of deprecated "getXML()". Replace with "getXMLData()".');return this.getXMLData.apply(this,arguments)},setDataXML:function(){g.raiseWarning(this,"11171116292","run","JavaScriptRenderer~setDataXML()",'Use of deprecated "setDataXML()". Replace with "setXMLData()".');return this.setXMLData.apply(this,arguments)},setDataURL:function(){g.raiseWarning(this,"11171116293",
"run","JavaScriptRenderer~setDataURL()",'Use of deprecated "SetDataURL()". Replace with "setXMLUrl()".');return this.setXMLUrl.apply(this,arguments)},hasRendered:function(){return!(!this.jsVars.hcObj||!this.jsVars.hcObj.hasRendered)},setTransparent:function(a){var c;if(c=this.jsVars)"boolean"!==typeof a&&null!==a&&(a=!0),c.transparent=null===a?!1:!0===a?!0:!1}});g.extend(g.core,{_fallbackJSChartWhenNoFlash:function(){m.swfobject.hasFlashPlayerVersion(g.core.options.requiredFlashPlayerVersion)||g.renderer.setDefault("javascript")},
_enableJSChartsForSelectedBrowsers:function(a){void 0!==a&&null!==a&&g.renderer.setDefault((new RegExp(a)).test(m.navigator.userAgent)?"javascript":"flash")},_doNotLoadExternalScript:function(a){var c,e;for(c in a)e=c.toLowerCase(),l[e]&&(N[e]=!!a[c])},_preloadJSChartModule:function(){throw"NotImplemented()";}});g.renderer.register("javascript",J);A||F?g.renderer.setDefault("javascript"):m.swfobject&&m.swfobject.hasFlashPlayerVersion&&!m.swfobject.hasFlashPlayerVersion(g.core.options.requiredFlashPlayerVersion)&&
(g.raiseWarning(g.core,"1204111846","run","JSRenderer","Switched to JavaScript as default rendering due to absence of required Flash Player."),g.renderer.setDefault("javascript"))}]);FusionCharts.register("module",["private","modules.renderer.polyfill",function(){"function"!=typeof Object.create&&(Object.create=function(){function g(){}var m=Object.prototype.hasOwnProperty;return function(D){var n,F,A;if("object"!=typeof D)throw new TypeError("Object prototype may only be an Object or null");g.prototype=
D;A=new g;g.prototype=null;if(1<arguments.length)for(F in n=Object(arguments[1]),n)m.call(n,F)&&(A[F]=n[F]);return A}}());Array.prototype.indexOf||(Array.prototype.indexOf=function(g,m){var D,n,F;if(null==this)throw new TypeError('"this" is null or not defined');n=Object(this);F=n.length>>>0;if(0===F)return-1;D=+m||0;Infinity===Math.abs(D)&&(D=0);if(D>=F)return-1;for(D=Math.max(0<=D?D:F-Math.abs(D),0);D<F;){if(D in n&&n[D]===g)return D;D++}return-1});Array.prototype.forEach||(Array.prototype.forEach=
function(g,m){var D,n,F,A,J;if(null==this)throw new TypeError(" this is null or not defined");F=Object(this);A=F.length>>>0;if("function"!==typeof g)throw new TypeError(g+" is not a function");1<arguments.length&&(D=m);for(n=0;n<A;)n in F&&(J=F[n],g.call(D,J,n,F)),n++});Array.prototype.indexOf||(Array.prototype.indexOf=function(g,m){var D;if(null==this)throw new TypeError('"this" is null or not defined');var n=Object(this),F=n.length>>>0;if(0===F)return-1;D=+m||0;Infinity===Math.abs(D)&&(D=0);if(D>=
F)return-1;for(D=Math.max(0<=D?D:F-Math.abs(D),0);D<F;){if(D in n&&n[D]===g)return D;D++}return-1});"function"!=typeof Object.create&&(Object.create=function(){function g(){}var m=Object.prototype.hasOwnProperty;return function(D){var n,F,A;if("object"!=typeof D)throw TypeError("Object prototype may only be an Object or null");g.prototype=D;n=new g;g.prototype=null;if(1<arguments.length)for(A in F=Object(arguments[1]),F)m.call(F,A)&&(n[A]=F[A]);return n}}());Function.prototype.bind||(Function.prototype.bind=
function(g){if("function"!==typeof this)throw new TypeError("Function.prototype.bind - what is trying to be bound is not callable");var m=Array.prototype.slice.call(arguments,1),D=this,n=function(){},F=function(){return D.apply(this instanceof n?this:g,m.concat(Array.prototype.slice.call(arguments)))};this.prototype&&(n.prototype=this.prototype);F.prototype=new n;return F});Array.prototype.reduce||(Array.prototype.reduce=function(g){if(null==this)throw new TypeError("Array.prototype.reduce called on null or undefined");
if("function"!==typeof g)throw new TypeError(g+" is not a function");var m=Object(this),D=m.length>>>0,n=0,F;if(2==arguments.length)F=arguments[1];else{for(;n<D&&!(n in m);)n++;if(n>=D)throw new TypeError("Reduce of empty array with no initial value");F=m[n++]}for(;n<D;n++)n in m&&(F=g(F,m[n],n,m));return F});Object.keys||(Object.keys=function(){var g=Object.prototype.hasOwnProperty,m=!{toString:null}.propertyIsEnumerable("toString"),D="toString toLocaleString valueOf hasOwnProperty isPrototypeOf propertyIsEnumerable constructor".split(" "),
n=D.length;return function(F){if("object"!==typeof F&&("function"!==typeof F||null===F))throw new TypeError("Object.keys called on non-object");var A=[],J;for(J in F)g.call(F,J)&&A.push(J);if(m)for(J=0;J<n;J++)g.call(F,D[J])&&A.push(D[J]);return A}}())}]);FusionCharts&&FusionCharts.register("module",["private","vendor.svgdecanvo",function(){var g=this.window,m=this.hcLib;(function(g){var m=g.document,F={},A={},J;J=function(a,g,d,l,m,n,w){var r={svg:"",context:"",callBack:"",imageArr:[],canvas:"",
dimention:{}};if(!(this instanceof J))throw"This function should be used as class";this._getStore=function(a){return"undefined"!=typeof r[a]?r[a]:!1};this._setStore=function(a,c){"undefined"!=typeof r[a]&&(r[a]=c)};this._setStore("dimention",{x:d,y:l,width:m,height:n});a&&this.setSVG(a);g&&this.setContext(g);w&&this.setCallback(w);this.drawOnCanvas()};J.prototype.setContext=function(a){var g;if(a.getContext&&a.getContext("2d"))g=a.getContext("2d"),this._setStore("canvas",a),this._setStore("context",
g);else throw"Please provide valid canvas";};J.prototype.getContext=function(){return this._getStore("context")};J.prototype.setSVG=function(a){if("undefined"!=typeof a.documentElement)this._setStore("svg",a);else if("<"==a.substr(0,1))a=A.StrToDom(a),this._setStore("svg",a);else throw"Please provide valid SVG";};J.prototype.getSVG=function(){return this._getStore("svg")};J.prototype.setCallback=function(a){"function"===typeof a&&this._setStore("callBack",a)};J.prototype.getCallback=function(){return this._getStore("callBack")};
J.prototype.drawOnCanvas=function(a,g,d,l,m,n,w){var r,p,c,v;a&&this.setSVG(a);g&&this.setContext(g);w&&this.setCallback(w);g=g||this._getStore("canvas");c=this._getStore("dimention");w=this.getCallback();r=this.getContext();(a=this.getSVG())&&r&&(v=A.getSvgDimention(a),p=v.width,g=v.height,d=d||c.x||0,l=l||c.y||0,m=m||c.width||p,n=n||c.height||g,p=v.width?m/p:1,g=v.height?n/g:1,A.startTransform("translate("+d+","+l+") scale("+p+","+g+")",r),r.save(),r.fillStyle="#ffffff",r.fillRect(0,0,m,n),r.restore(),
A.storeImagesInArr(this),A.drawNodes([a],[],this,r,function(){"function"===typeof w&&w();A.resetTransform(r)}))};F.common=function(a,g,d,l,m){var n=a.childNodes,w,r=function(){a.attributes&&l.restore();m&&m()};for(w in g)g.hasOwnProperty(w)&&"class"!=g[w].name&&"id"!=g[w].name&&"transform"!=g[w].name&&"clip-path"!=g[w].name&&"object"==typeof g[w]&&a.attributes&&!a.attributes[g[w].name]&&a.setAttribute([g[w].name],g[w].value);if(a.attributes&&a.attributes.style)for(w in styleArr=a.attributes.style.value.replace(/;$/,
"").split(";"),styleArr)if(styleArr.hasOwnProperty(w)&&(styleName=styleArr[w].split(":")[0].trim(),!a.attributes[styleName]||"undefined"==a.attributes[styleName].value))try{a.setAttribute(styleName,styleArr[w].split(":")[1].trim())}catch(p){}a.attributes&&(l.save(),a.attributes.transform&&A.startTransform(a.attributes.transform.value,l),a.attributes["clip-path"]&&A.applyClip(a.attributes["clip-path"].value,l,d));if(0===n.length||1===n.length&&!n[0].tagName)if("undefined"!==typeof a.tagName)if(g="draw"+
a.tagName,F[g])if(a.attributes.display&&"none"==a.attributes.display.value)r();else F[g](a,l,d,"draw",r);else r();else r();else A.drawNodes(n,"svg"==a.tagName?[]:a.attributes,d,l,r)};F.drawtext=function(a,g,d,l,m){this.drawtspan(a,g,d,l,m)};F.drawtspan=function(a,O,d,l,N){var F=a.innerHTML||a.textContent,w=a.attributes.x?a.attributes.x.value:0,r=a.attributes.y?a.attributes.y.value:0,p=a.attributes.dx?a.attributes.dx.value:0,c=a.attributes.dy?a.attributes.dy.value:0,v="serief",M="normal",e="16px",
q=[],H;m.getElementsByTagName("body")[0]&&(H=g.getComputedStyle(m.getElementsByTagName("body")[0],null),H.getPropertyValue("font-family")&&(v=H.getPropertyValue("font-family")),H.getPropertyValue("font-weight")&&(M=H.getPropertyValue("font-weight")),H.getPropertyValue("font-size")&&(e=H.getPropertyValue("font-size")));v=a.attributes["font-family"]?a.attributes["font-family"].value:v;M=a.attributes["font-weight"]?a.attributes["font-weight"].value:M;H=a.attributes["text-anchor"]?a.attributes["text-anchor"].value:
"start";e=a.attributes["font-size"]?a.attributes["font-size"].value:e;w=Number(w)+Number(p);r=Number(r)+Number(c);F=F.trim();H="middle"==H?"center":H;O.save();O.font=M+" "+e+" "+v;O.textAlign=H;if("draw"===l){if(!a.attributes.fill||a.attributes.fill&&"none"!=a.attributes.fill.value)A.applyFillEffect(a,O,d,q),O.fillText(F,w,r),A.endFillEffect(a,O);if(!a.attributes.stroke||a.attributes.stroke&&"none"!=a.attributes.stroke.value)A.applyStrokeEffect(a,O,d,q),O.strokeText(F,w,r),A.endStrokeEffect(a,O)}O.restore();
"function"===typeof N&&N()};F.drawcircle=function(a,g,d,l,m){var n=Number(a.attributes.cx.value),w=Number(a.attributes.cy.value),r=Number(a.attributes.r.value),p=[];g.beginPath();g.arc(n,w,r,0,2*Math.PI);A.bBoxFromPoint([n,1*n+1*r,1*n-1*r],[w,1*w+1*r,1*w-1*r],p);if("draw"===l){if(!a.attributes.fill||a.attributes.fill&&"none"!=a.attributes.fill.value)A.applyFillEffect(a,g,d,p),g.fill(),A.endFillEffect(a,g);if(!a.attributes.stroke||a.attributes.stroke&&"none"!=a.attributes.stroke.value)A.applyStrokeEffect(a,
g,d,p),g.stroke(),A.endStrokeEffect(a,g)}g.closePath();"function"===typeof m&&m()};F.drawrect=function(a,g,d,l,m){var n=Number(a.attributes.x.value),w=Number(a.attributes.y.value),r=a.attributes.rx?Number(a.attributes.rx.value):0,p=a.attributes.ry?Number(a.attributes.ry.value):0,c=Number(a.attributes.height.value),v=Number(a.attributes.width.value),M=[];A.bBoxFromPoint([n,n+v],[w,w+c],M);g.beginPath();g.moveTo(n+r,w);g.lineTo(n+v-r,w);g.quadraticCurveTo(n+v,w,n+v,w+p);g.lineTo(n+v,w+c-p);g.quadraticCurveTo(n+
v,w+c,n+v-r,w+c);g.lineTo(n+r,w+c);g.quadraticCurveTo(n,w+c,n,w+c-p);g.lineTo(n,w+p);g.quadraticCurveTo(n,w,n+r,w);if("draw"===l){if(!a.attributes.fill||a.attributes.fill&&"none"!=a.attributes.fill.value)A.applyFillEffect(a,g,d,M),g.fill(),A.endFillEffect(a,g);if(!a.attributes.stroke||a.attributes.stroke&&"none"!=a.attributes.stroke.value)A.applyStrokeEffect(a,g,d,M),g.stroke(),A.endStrokeEffect(a,g)}g.closePath();"function"===typeof m&&m()};F.drawellipse=function(a,g,d,l,m){var n=Number(a.attributes.cx.value),
w=Number(a.attributes.cy.value),r=Number(a.attributes.rx.value),p=Number(a.attributes.ry.value),c=.5522848*r,v=.5522848*p,M=n+r,e=w+p,q=[];g.beginPath();g.moveTo(n-r,w);g.bezierCurveTo(n-r,w-v,n-c,w-p,n,w-p);g.bezierCurveTo(n+c,w-p,M,w-v,M,w);g.bezierCurveTo(M,w+v,n+c,e,n,e);g.bezierCurveTo(n-c,e,n-r,w+v,n-r,w);A.bBoxFromPoint([n+r,n-r],[w+p,w-p],q);if("draw"===l){if(!a.attributes.fill||a.attributes.fill&&"none"!=a.attributes.fill.value)A.applyFillEffect(a,g,d,q),g.fill(),A.endFillEffect(a,g);if(!a.attributes.stroke||
a.attributes.stroke&&"none"!=a.attributes.stroke.value)A.applyStrokeEffect(a,g,d,q),g.stroke(),A.endStrokeEffect(a,g)}g.closePath();"function"===typeof m&&m()};F.drawimage=function(a,g,d,l,m){var n=a.attributes.x?Number(a.attributes.x.value):0,w=a.attributes.y?Number(a.attributes.y.value):0,r=a.attributes.height?Number(a.attributes.height.value):0,p=a.attributes.width?Number(a.attributes.width.value):0,c,v=d._getStore("imageArr");g.save();a.attributes.opacity&&(g.globalAlpha=a.attributes.opacity.value);
a.attributes["xlink:href"]?(c=a.attributes["xlink:href"].value,"complete"===v[c].status?(g.drawImage(v[c].obj,n,w,p,r),g.globalAlpha=1,g.restore(),"function"===typeof m&&m()):"error"===v[c].status?(g.globalAlpha=1,g.restore(),"function"===typeof m&&m()):"progress"===v[c].status?(v[c].callback=function(){g.drawImage(v[c].obj,n,w,p,r);g.globalAlpha=1;g.restore();"function"===typeof m&&m()},v[c].errCallback=function(){g.globalAlpha=1;g.restore();"function"===typeof m&&m()}):(g.globalAlpha=1,g.restore(),
"function"===typeof m&&m())):(g.globalAlpha=1,g.restore(),"function"===typeof m&&m())};F.drawpath=function(a,g,d,l,m){var n=a.attributes.d.value.match(/[a-z][^a-z"]*/ig),w=[],r,p,c,v=0,M=0,e;g.beginPath();for(r in n)if(n.hasOwnProperty(r))switch(p=n[r].substring(0,1),c=A.getArgsAsArray(n[r].substring(1,n[r].length)),p){case "M":v=Number(c[0]);M=Number(c[1]);g.moveTo(v,M);break;case "m":v+=Number(c[0]);M+=Number(c[1]);g.moveTo(v,M);break;case "L":for(e=0;c[e];e+=2)A.bBoxFromPoint([v,c[e]],[M,c[e+1]],
w),v=Number(c[e]),M=Number(c[e+1]),g.lineTo(v,M);break;case "l":for(e=0;c[e];e+=2)A.bBoxFromPoint([v,1*v+1*c[e]],[M,1*M+1*c[e+1]],w),v+=Number(c[e]),M+=Number(c[e+1]),g.lineTo(v,M);break;case "V":for(e=0;c[e];e+=1)A.bBoxFromPoint([v],[M,c[e]],w),M=Number(c[e]),g.lineTo(v,M);break;case "v":for(e=0;c[e];e+=1)A.bBoxFromPoint([v],[M,1*M+1*c[e]],w),M+=Number(c[e]),g.lineTo(v,M);break;case "H":for(e=0;c[e];e+=1)A.bBoxFromPoint([v,c[e]],[M],w),v=Number(c[e]),g.lineTo(v,M);break;case "h":for(e=0;c[e];e+=
1)A.bBoxFromPoint([v,1*v+1*c[e]],[M],w),v+=Number(c[e]),g.lineTo(v,M);break;case "Q":for(e=0;c[e];e+=4)A.qBezierBBox(v,M,c[e],c[e+1],c[e+2],c[e+3],w),g.quadraticCurveTo(Number(c[e]),Number(c[e+1]),Number(c[e+2]),Number(c[e+3])),v=Number(c[e+2]),M=Number(c[e+3]);break;case "q":for(e=0;c[e];e+=4)A.qBezierBBox(v,M,v+1*c[e],M+1*c[e+1],1*v+1*c[e+2],1*M+1*c[e+3],w),g.quadraticCurveTo(v+1*c[e],M+1*c[e+1],v+=Number(c[e+2]),M+=Number(c[e+3]));break;case "C":for(e=0;c[e];e+=6)A.cBezierBBox(v,M,c[e],c[e+1],
c[e+2],c[e+3],c[e+4],c[e+5],w),g.bezierCurveTo(c[e],c[e+1],c[e+2],c[e+3],c[e+4],c[e+5]),v=Number(c[e+4]),M=Number(c[e+5]);break;case "c":for(e=0;c[e];e+=6)A.cBezierBBox(v,M,v+1*c[e],1*M+1*c[e+1],v+1*c[e+2],1*M+1*c[e+3],v+1*c[e+4],1*M+1*c[e+5],w),g.bezierCurveTo(v+Number(c[e]),M+Number(c[e+1]),v+Number(c[e+2]),M+Number(c[e+3]),v+=Number(c[e+4]),M+=Number(c[e+5]));break;case "a":case "A":for(e=0;c[e];e+=7){var q=Number(c[e]),H=Number(c[e+1]),t,L,K,F,D,T,J,aa,I,ia,C,za,Ja,na;t=Math.PI/180*Number(c[e+
2]);L=Number(c[e+3]);K=Number(c[e+4]);F=Number(c[e+5]);D=Number(c[e+6]);T=Math.cos(t)*(v-F)/2+Math.sin(t)*(M-D)/2;J=-Math.sin(t)*(v-F)/2+Math.cos(t)*(M-D)/2;q=0>q?-q:q;H=0>H?-H:H;za=Math.pow(T,2)/Math.pow(q,2)+Math.pow(J,2)/Math.pow(H,2);1<za&&(q*=Math.sqrt(za),H*=Math.sqrt(za));za=q>H?q:H;Ja=q>H?1:q/H;na=q>H?H/q:1;L=(L==K?-1:1)*Math.sqrt((Math.pow(q,2)*Math.pow(H,2)-Math.pow(q,2)*Math.pow(J,2)-Math.pow(H,2)*Math.pow(T,2))/(Math.pow(q,2)*Math.pow(J,2)+Math.pow(H,2)*Math.pow(T,2)));isNaN(L)&&(L=0);
aa=L*q*J/H;I=-L*H*T/q;ia=aa*Math.cos(t)-I*Math.sin(t)+(v+F)/2;C=aa*Math.sin(t)+I*Math.cos(t)+(M+D)/2;L=A.angleBetweenVectors(1,0,(T-aa)/q,(J-I)/H);T=A.angleBetweenVectors((T-aa)/q,(J-I)/H,(-T-aa)/q,(-J-I)/H);0===K&&0<T&&(T-=Math.PI/180*360);1==K&&0>T&&(T+=Math.PI/180*360);if(0===q&&0===H){g.lineTo(F,D);break}g.save();q=A.combineTransformMatrix([[1,0,ia,0,1,C],[Math.cos(t),Math.sin(t),0,Math.sin(t),Math.cos(t),0],[Ja,0,0,0,na,0]]);g.transform(q[0],q[3],q[1],q[4],q[2],q[5]);g.arc(0,0,za,L,L+T,1-K);
g.restore();A.arcBBox(0,0,za,L,L+T,1-K,[q[0],q[3],q[1],q[4],q[2],q[5]],w);"A"==p?(v=Number(c[e+5]),M=Number(c[e+6])):(v+=Number(c[e+5]),M+=Number(c[e+6]))}break;case "Z":case "z":g.closePath()}if("draw"===l){if(!a.attributes.fill||a.attributes.fill&&"none"!=a.attributes.fill.value)A.applyFillEffect(a,g,d,w),g.fill(),A.endFillEffect(a,g);if(!a.attributes.stroke||a.attributes.stroke&&"none"!=a.attributes.stroke.value)A.applyStrokeEffect(a,g,d,w),g.stroke(),A.endStrokeEffect(a,g);m()}};A.drawNodes=function(a,
g,d,l,m){var n=a.length,w=-1,r=0,p=0,c=function(){var v;w+=1;w<n?(v=a[w],v.tagName&&"defs"===v.tagName&&(w+=1,v=a[w]),v.attributes&&(v.attributes.dy&&(p=v.attributes.dy.value=1*v.attributes.dy.value+1*p),v.attributes.dx&&(r=v.attributes.dx.value=1*v.attributes.dx.value+1*r)),F.common(v,g,d,l,c)):m&&m()};c()};A.getSvgDimention=function(a){var g={width:0,height:0};node=a.childNodes&&a.childNodes[0]&&a.childNodes[0].attributes;g.width=Number(node.width&&node.width.value||0);g.height=Number(node.height&&
node.height.value||0);return g};A.storeImagesInArr=function(a){var g=a.getSVG(),d,l;d=a._getStore("imageArr");a=g.getElementsByTagName("image");for(l in a)a.hasOwnProperty(l)&&a[l].attributes&&a[l].attributes["xlink:href"]&&(g=a[l].attributes["xlink:href"].value,d[g]||(d[g]=[],d[g].status="progress",d[g].callback=null,d[g].obj=new Image,d[g].obj.onload=function(a){return function(){var g=d[a].callback;g?(d[a].status="complete",g()):d[a].status="complete"}}(g),d[g].obj.onerror=function(a){return function(){var g=
d[a].errCallback;g?(d[a].status="error",g()):d[a].status="error"}}(g),d[g].obj.src=g))};A.startTransform=function(a,g){var d=a.match(/[^\s][a-z,0-9.\-(\s]+\)/gi),l,m;for(m in d)d.hasOwnProperty(m)&&(-1<d[m].indexOf("matrix")&&(l=A.stringToArgs(d[m]),g.transform(l[0],l[1],l[2],l[3],l[4],l[5])),-1<d[m].indexOf("translate")&&(l=A.stringToArgs(d[m]),g.translate(l[0]||0,l[1]||0)),-1<d[m].indexOf("rotate")&&(l=A.stringToArgs(d[m]),3==l.length?(g.translate(l[1],l[2]),g.rotate(Math.PI/180*l[0]),g.translate(-l[1],
-l[2])):g.rotate(Math.PI/180*l[0])),-1<d[m].indexOf("scale")&&(l=A.stringToArgs(d[m]),1==l.length?g.scale(l[0]||1,l[0]||1):g.scale(l[0]||1,l[1]||1)),-1<d[m].indexOf("skewX")&&(l=A.stringToArgs(d[m]),g.transform(1,0,Math.tan(Math.PI/180*l[0]),1,0,0)),-1<d[m].indexOf("skewY")&&(l=A.stringToArgs(d[m]),g.transform(1,Math.tan(Math.PI/180*l[0]),0,1,0,0)))};A.resetTransform=function(a){a.setTransform(1,0,0,1,0,0)};A.stringToArgs=function(a){a=/\(([^\)]+)/.exec(a)[1];return A.getArgsAsArray(a)};A.getArgsAsArray=
function(a){var g;a=a.trim().split(/[\s,]+/);for(g=0;g<a.length;g++)a[g].trim(),0===a[g].length&&a.splice(g,1);return a};A.applyFillEffect=function(a,g,d,l){g.globalAlpha=a.attributes["fill-opacity"]&&"none"!=a.attributes["fill-opacity"].value?a.attributes["fill-opacity"].value:1;a.attributes.fill&&-1<a.attributes.fill.value.indexOf("url(")?(a=A.getFillStyleById(/url\(.*#([^\)'"]+)/.exec(a.attributes.fill.value)[1],g,d,l),g.fillStyle=a):g.fillStyle=a.attributes.fill?a.attributes.fill.value:"#000000"};
A.endFillEffect=function(a,g){g.globalAlpha=1};A.applyStrokeEffect=function(a,g,d,l){a.attributes["stroke-opacity"]&&"none"!=a.attributes["stroke-opacity"].value&&(g.globalAlpha=a.attributes["stroke-opacity"].value);a.attributes["stroke-width"]&&(g.lineWidth=a.attributes["stroke-width"].value,0===a.attributes["stroke-width"].value&&(g.globalAlpha=0));a.attributes["stroke-linecap"]&&"none"!=a.attributes["stroke-linecap"].value&&(g.lineCap=a.attributes["stroke-linecap"].value);a.attributes["stroke-linejoin"]&&
"none"!=a.attributes["stroke-linejoin"].value&&(g.lineJoin=a.attributes["stroke-linejoin"].value);a.attributes["stroke-dasharray"]&&"none"!=a.attributes["stroke-dasharray"].value&&g.setLineDash&&g.setLineDash(A.getArgsAsArray(a.attributes["stroke-dasharray"].value));g.strokeStyle=a.attributes.stroke?a.attributes.stroke.value:"#000000"};A.endStrokeEffect=function(a,g){a.attributes["stroke-opacity"]&&"none"!=a.attributes["stroke-opacity"].value&&(g.globalAlpha=1,g.setLineDash&&g.setLineDash([]),g.lineWidth=
1);g.globalAlpha=1};A.applyClip=function(a,g,d){var l=d.getSVG(),m,n;if(-1!==a.indexOf("url(")){a=/url\(.*#([^\)'"]+)/.exec(a)[1];l=l.getElementById(a);l.attributes&&(g.save(),l.attributes.transform&&A.startTransform(l.attributes.transform.value,g));a=l.childNodes;for(m in a)a.hasOwnProperty(m)&&a[m].tagName&&a[m].constructor!==Array&&(n="draw"+a[m].tagName,a[m].attributes&&(g.save(),a[m].attributes.transform&&A.startTransform(a[m].attributes.transform.value,g)),F[n]&&(F[n](a[m],g,d,"clip"),g.closePath()),
a[m].attributes&&g.restore());l.attributes&&g.restore();g.clip()}};A.getFillStyleById=function(a,g,d,l){a=d.getSVG().getElementById(a);return"linearGradient"==a.tagName?A.getLinearGradient(a,g,l):"radialGradient"==a.tagName?A.getRadialGradient(a,g,l):"#FFFFFF"};A.getLinearGradient=function(a,g,d){var l=a.attributes.x1?A.getPercentValue(a.attributes.x1.value,d.xMax-d.xMin,d.xMin):0,m=a.attributes.y1?A.getPercentValue(a.attributes.y1.value,d.yMax-d.yMin,d.yMin):0,n=a.attributes.x2?A.getPercentValue(a.attributes.x2.value,
d.xMax-d.xMin,d.xMin):0;d=a.attributes.y2?A.getPercentValue(a.attributes.y2.value,d.yMax-d.yMin,d.yMin):0;var w;linGrad=g.createLinearGradient(l,m,n,d);a=a.childNodes;for(w in a)a.hasOwnProperty(w)&&a[w].attributes&&a[w].attributes["stop-color"]&&(g=A.toRGB(a[w].attributes["stop-color"].value),l=a[w].attributes["stop-opacity"]?a[w].attributes["stop-opacity"].value:1,g.status?linGrad.addColorStop(A.getPercentValue(a[w].attributes.offset.value,1,0),"rgba("+g.r+","+g.g+","+g.b+","+Number(l)+")"):linGrad.addColorStop(A.getPercentValue(a[w].attributes.offset.value,
1,0),a[w].attributes["stop-color"].value));return linGrad};A.getRadialGradient=function(a,g,d){var l=a.attributes.cx?A.getPercentValue(a.attributes.cx.value,d.xMax-d.xMin,d.xMin):d.xMin+.5*(d.xMax-d.xMin),m=a.attributes.cy?A.getPercentValue(a.attributes.cy.value,d.yMax-d.yMin,d.yMin):d.yMin+.5*(d.yMax-d.yMin),n=a.attributes.fx?A.getPercentValue(a.attributes.fx.value,d.xMax-d.xMin,d.xMin):d.xMin+.5*(d.xMax-d.xMin),w=a.attributes.fy?A.getPercentValue(a.attributes.fy.value,d.yMax-d.yMin,d.yMin):d.yMin+
.5*(d.yMax-d.yMin);d=a.attributes.r?A.getPercentValue(a.attributes.r.value,(d.yMax-d.yMin+d.xMax-d.xMin)/2,0):A.getPercentValue("50%",(d.yMax-d.yMin+d.xMax-d.xMin)/2,0);var r;g=g.createRadialGradient(n,w,0,l,m,d);a=a.childNodes;for(r in a)a.hasOwnProperty(r)&&a[r].attributes&&a[r].attributes["stop-color"]&&(l=A.toRGB(a[r].attributes["stop-color"].value),m=a[r].attributes["stop-opacity"]?a[r].attributes["stop-opacity"].value:1,l.status?g.addColorStop(A.getPercentValue(a[r].attributes.offset.value,
1,0),"rgba("+l.r+","+l.g+","+l.b+","+Number(m)+")"):g.addColorStop(A.getPercentValue(a[r].attributes.offset.value,1,0),a[r].attributes["stop-color"].value));return g};A.getPercentValue=function(a,g,d){return-1!=a.indexOf("%")?(a=/(\d.*)%/.exec(a)[1],100<a&&(a=100),a*g/100+1*d):1<a?a:a*g+1*d};A.bBoxFromPoint=function(a,g,d){"undefined"!==typeof d.xMin&&(a.push(d.xMin,d.xMax),g.push(d.yMin,d.yMax));d.xMin=Math.min.apply(this,a);d.xMax=Math.max.apply(this,a);d.yMin=Math.min.apply(this,g);d.yMax=Math.max.apply(this,
g)};A.arcBBox=function(a,g,d,l,m,n,w,r){var p,c,v;w instanceof Array&&(a=a*w[0]+a*w[2]+w[4],g=g*w[1]+g*w[3]+w[5]);v=function(a,c,d){a=(a+2*Math.PI)%(2*Math.PI);c=(c+2*Math.PI)%(2*Math.PI);if(a<=c)return a<=d&&d<=c?!0:!1;if(a>=c)return a>=d&&d>=c?!1:!0};w=l%(2*Math.PI);p=m%(2*Math.PI);n&&(w=m%(2*Math.PI),p=l%(2*Math.PI));n=a+d*Math.cos(w);l=g+d*Math.sin(w);c=a+d*Math.cos(p);m=g+d*Math.sin(p);n=[n,c];l=[l,m];v(w,p,0)&&(n.push(1*a+1*d),l.push(g));v(w,p,.5*Math.PI)&&(n.push(a),l.push(1*g+1*d));v(w,p,
Math.PI)&&(n.push(a-1*d),l.push(g));v(w,p,1.5*Math.PI)&&(n.push(a),l.push(g-1*d));a=Math.max.apply(this,n);g=Math.min.apply(this,n);d=Math.max.apply(this,l);w=Math.min.apply(this,l);"undefined"!==typeof r.xMin?(r.xMin=Math.min(g,r.xMin),r.xMax=Math.max(a,r.xMax),r.yMin=Math.min(w,r.yMin),r.yMax=Math.max(d,r.yMax)):(r.xMin=g,r.xMax=a,r.yMin=w,r.yMax=d)};A.qBezierBBox=function(a,g,d,l,m,n,w){var r=1*a-2*d+1*m,p=1*g-2*l+1*n;0===r||0===p?(l=Math.max(a,m),a=Math.min(a,m),m=Math.max(g,n),g=Math.min(g,n)):
(r=(a-d)/r,p=(g-l)/p,d=a*Math.pow(1-r,2)+2*d*(1-r)*r+m*Math.pow(r,2),p=g*Math.pow(1-p,2)+2*l*(1-p)*p+n*Math.pow(p,2),l=Math.max(a,m,d),a=Math.min(a,m,d),m=Math.max(g,n,p),g=Math.min(g,n,p));"undefined"!==typeof w.xMin?(w.xMin=Math.min(a,w.xMin),w.xMax=Math.max(l,w.xMax),w.yMin=Math.min(g,w.yMin),w.yMax=Math.max(m,w.yMax)):(w.xMin=a,w.xMax=l,w.yMin=g,w.yMax=m)};A.cBezierBBox=function(a,g,d,l,m,n,w,r,p){var c,v,A,e,q,H,t;null===m&&null===n&&(d=a+2/3*(d-a),m=g+2/3*(l-g),l=d+1/3*(w-a),n=m+1/3*(r-g));
t=function(a,c,e,d,g){return a*Math.pow(1-g,3)+3*c*g*Math.pow(1-g,2)+3*e*g*g*(1-g)+d*g*g*g};A=3*w-9*m+9*d-3*a;e=6*a-12*d+6*m;q=Math.pow(e,2)-4*A*(3*d-3*a);v=c=a;w<c&&(c=w);w>v&&(v=w);0<=q&&(H=(-e+Math.sqrt(q))/(2*A),0<H&&1>H&&(H=t(a,d,m,w,H),H<c&&(c=H),H>v&&(v=H)),A=(-e-Math.sqrt(q))/(2*A),0<A&&1>A&&(H=t(a,d,m,w,A),H<c&&(c=H),H>v&&(v=H)));A=3*r-9*n+9*l-3*g;e=6*g-12*l+6*n;q=Math.pow(e,2)-4*A*(3*l-3*g);d=a=g;r<a&&(a=r);r>d&&(d=r);0<=q&&(H=(-e+Math.sqrt(q))/(2*A),0<H&&1>H&&(m=t(g,l,n,r,H),m<a&&(a=m),
m>d&&(d=m)),A=(-e-Math.sqrt(q))/(2*A),0<A&&1>A&&(m=t(g,l,n,r,A),m<a&&(a=m),m>d&&(d=m)));"undefined"!==typeof p.xMin?(p.xMin=Math.min(c,p.xMin),p.xMax=Math.max(v,p.xMax),p.yMin=Math.min(a,p.yMin),p.yMax=Math.max(d,p.yMax)):(p.xMin=c,p.xMax=v,p.yMin=a,p.yMax=d)};A.combineTransformMatrix=function(a){var g=a.length-1,d;if(0>=g)return a[0];d=a[0];for(i=1;i<=g;i++)d[0]=d[0]*a[i][0]+d[1]*a[i][3],d[1]=d[0]*a[i][1]+d[1]*a[i][4],d[2]=d[0]*a[i][2]+d[1]*a[i][5]+1*d[2],d[3]=d[3]*a[i][0]+d[4]*a[i][3],d[4]=d[3]*
a[i][1]+d[4]*a[i][4],d[5]=d[3]*a[i][2]+d[4]*a[i][5]+1*d[5];return d};A.angleBetweenVectors=function(a,g,d,l){return(a*l<g*d?-1:1)*Math.acos((a*d+g*l)/(Math.sqrt(Math.pow(a,2)+Math.pow(g,2))*Math.sqrt(Math.pow(d,2)+Math.pow(l,2))))};A.toRGB=function(a){var g={r:0,g:0,b:0,status:0},d,l;d=function(a){for(l in a)a.hasOwnProperty(l)&&(0>a[l]||isNaN(a[l])?a[l]=0:255<a[l]&&(a[l]=255));return g={r:a[0],g:a[1],b:a[2],status:1}};a=a.trim();a.match(/^rgb\(|^rgba\(/i)?(a=/\(\s*(\d{1,3}),\s*(\d{1,3}),\s*(\d{1,3})/.exec(a),
d([parseInt(a[1]),parseInt(a[2]),parseInt(a[3])])):a.match(/^#/)&&(a=/(\w{2})(\w{2})(\w{2})/.exec(a),d([parseInt(a[1],16),parseInt(a[2],16),parseInt(a[3],16)]));return g};A.StrToDom=function(a){var m;g.DOMParser?(m=new DOMParser,m=m.parseFromString(a,"text/xml")):(m=new ActiveXObject("Microsoft.XMLDOM"),m.async=!1,m.loadXML(a));return m};g.SvgDeCanvo=J})(this.window||window);g.SvgDeCanvo&&(m.SvgDeCanvo=g.SvgDeCanvo,g.SvgDeCanvo=void 0)}]);FusionCharts.register("module",["private","modules.renderer.js-lib-attr",
function(){var g={},m=this.hcLib||(this.hcLib={}),D=Math.max,n=m.attrTypeNum=1,F=m.attrTypeBool=2;m.parseConfiguration=function(A,D,a,O,d,l){var N=m.attribDefs||g,ga,w,r,p=1,c;O=O||g;l=l||g;d=d||{};for(ga in A)if(!O[ga]&&((w=A[ga])||!1===w||0===w))switch(r=(c=l[ga]||N[ga])&&c.type,r){case n:w=Number(w);isNaN(w)||(D[ga]=w);break;case F:w=Number(w);isNaN(w)||(D[ga]=!!w);break;default:D[ga]=w}if(a)for(ga in D)void 0===D[ga]&&(c=l[ga]||N[ga])&&c.pAttr&&(D[ga]=a[c.pAttr]);for(;p;)for(ga in p=0,D)void 0===
D[ga]&&(c=l[ga]||N[ga])&&(c.attr?void 0!==(w=D[c.attr])&&(D[ga]=w,p+=1):c.parser&&void 0!==(w=c.parser(D,a,d))&&(D[ga]=w,p+=1))};m.setAttribDefs=function(g,n){var a=m.attribDefs,F,d;"string"===typeof g?(F={},F[g]=n):F=g;for(d in F)a[d]||(a[d]=F[d])};m.hasAttribDefs=function(g){return!!m.attribDefs[g]};m.attribDefs={setBorderWidth:{type:n,pAttr:"plotborderthickness"},plotborderthickness:{type:n,pAttr:"plotborderthickness"},showBorderEffect:{parser:function(g,m){return 1===+m.showplotborder&&.1===m.plotborderthickness?
1:0}},alphaanimation:{type:n},showplotborder:{type:n,pAttr:"showplotborder"},zeroplanethickness:{type:n},showzeroplaneontop:{type:n},usemessagelog:{type:n},showtooltip:{type:n,pAttr:"showtooltip"},seriesnameintooltip:{type:n},plothovereffect:{type:n,attr:"anchorhovereffect"},anchorhovereffect:{type:n,attr:"showhovereffect"},showhovereffect:{type:n},linethickness:{type:n,pAttr:"linethickness"},dashed:{type:n,pAttr:"linedashed"},linedashed:{type:n,attr:"plotborderdashed"},plotborderdashed:{type:n,pAttr:"plotborderdashed"},
linedashlen:{type:n,pAttr:"linedashlen"},linedashgap:{type:n,pAttr:"linedashgap"},anchoralpha:{pAttr:"anchoralpha"},anchorsides:{type:n,pAttr:"anchorsides"},anchorradius:{type:n,pAttr:"anchorradius"},anchorbgalpha:{pAttr:"anchorbgalpha"},anchorbgcolor:{pAttr:"anchorbgcolor"},anchorbordercolor:{pAttr:"anchorbordercolor"},anchorstartangle:{type:n,pAttr:"anchorstartangle"},anchorimageurl:{pAttr:"anchorimageurl"},anchorimagescale:{type:n,pAttr:"anchorimagescale"},anchorimagealpha:{pAttr:"anchorimagealpha"},
anchorimagepadding:{type:n,pAttr:"anchorimagepadding"},anchorborderthickness:{type:n,pAttr:"anchorborderthickness"},anchorshadow:{type:n,pAttr:"anchorshadow"},valuepadding:{type:n,pAttr:"valuepadding"},valueposition:{pAttr:"valueposition"},plotfillangle:{type:n,pAttr:"plotfillangle"},useplotgradientcolor:{type:n},rotatevalues:{type:n,pAttr:"rotatevalues"},includeinlegend:{type:n},connectnulldata:{type:n},plotfillalpha:{pAttr:"plotfillalpha"},alpha:{pAttr:"linealpha"},linealpha:{pAttr:"plotfillalpha"},
showvalues:{type:n,pAttr:"showvalues"},showpercentvalues:{type:n,parser:function(g){return g.isstacked&&g.stack100percent?1:0}},showpercentintooltip:{type:n,parser:function(g){return g.isstacked&&g.stack100percent?1:0}},stack100percent:{type:n,attr:"usepercentdistribution"},drawfullareaborder:{type:n},use3dlineshift:{type:n},parentyaxis:{type:n},radarborderthickness:{type:n},radarborderradius:{type:n},gaugeoriginx:{type:n},hasgaugeoriginx:{attr:"gaugeoriginx"},gaugeoriginy:{type:n},hasgaugeoriginy:{attr:"gaugeoriginy"},
gaugeradius:{type:n},hasgaugeradius:{attr:"gaugeradius"},showgaugeborder:{type:n},setAdaptiveMin:{type:n},adjustDiv:{type:n},axisNameWidth:{type:n},rotateAxisName:{type:n},useEllipsesWhenOverflow:{type:n},showZeroPlane:{type:n},zeroPlaneAlpha:{type:n},showZeroPlaneValue:{type:n},zeroPlaneOnTop:{type:n},trendlineThickness:{type:n},showTrendlinesOnTop:{type:n},trendlinesAreDashed:{type:n},trendlinesDashLen:{type:n},trendlinesDashGap:{type:n},showTrendlines:{type:n},showTrendlineLabels:{type:n},showLabels:{type:n},
rotateLabels:{type:n},slantLabel:{type:n},showAxisValues:{type:n},showTooltip:{type:n},maxLabelHeight:{type:n},useroundedges:{type:n,pAttr:"useroundedges"},placevaluesinside:{type:n},plotpaddingpercent:{type:n},use3dlighting:{type:n,pAttr:"use3dlighting"},usedataplotcolorforlabels:{type:n},plotspacepercent:{type:n,parser:function(g){return D(g.plotspacepercent%100,0)}},ratio:{pAttr:"plotfillratio"},base:{type:n},showMinorDivLineValues:{type:n},numMinorDivLines:{type:n},majorTMNumber:{type:n},majorTMHeight:{type:n},
showTickMarks:{type:n},majorTMThickness:{type:n},adjustTM:{type:F},minorTMNumber:{type:n},minorTMThickness:{type:n},tickMarkDistance:{type:n},placeTicksInside:{type:n},placeValuesInside:{type:n},axisValuePadding:{type:n},gridLineWidth:{type:n},showRadarBorder:{type:n},radarBorderThickness:{type:n},maxcolwidth:{type:n,parser:function(g){return Math.abs(g.maxcolwidth)}},maxbarheight:{type:n,parser:function(g){return Math.abs(g.maxbarheight)}},plotborderalpha:{parser:function(g,m){return m.plotborderalpha||
g.plotfillalpha}},autoscale:{type:n},plotborderdashlen:{type:n,pAttr:"plotborderdashlen"},plotborderdashgap:{type:n,pAttr:"plotborderdashgap"},plotfillratio:{pAttr:"plotfillratio"},drawverticaljoins:{type:n,pAttr:"drawverticaljoins"},useforwardsteps:{type:n,pAttr:"useforwardsteps"},minimizetendency:{type:n},usepercentdistribution:{type:n},stepatmiddle:{type:n}}}]);FusionCharts.register("module",["private","modules.renderer.js-lib",function(){var g=this,m=g.window,D,n=m.document,F=m.navigator,A=!(!m.SVGAngle&&
!n.implementation.hasFeature("http://www.w3.org/TR/SVG11/feature#BasicStructure","1.1")),J=/msie/i.test(F.userAgent)&&!m.opera,a=m.parseFloat,O=/\s+/g,d=/^#?/,l=/^rgba/i,N=/[#\s]/ig,ga=/\{br\}\s*/ig,w=/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i,r=Math.abs,p=Math.pow,c=Math.round,v=p(2,-24),M=Object.prototype.toString,e="ontouchstart"in n,F=e&&!(F.maxTouchPoints||F.msMaxTouchPoints),q="http://www.fusioncharts.com?BS=FCHSEvalMark&utm_source=FCS_trial&pver="+escape(g.core.version),H=/fusioncharts\.com|fusioncharts\.github\.io$/i,
t=!H.test(m.location.hostname);D=Math;var L=D.max,K=D.min,pa=m.Image,S={pageX:0,pageY:0},T="createTouch"in n,ba=T&&!(m.navigator.maxTouchPoints||m.navigator.msMaxTouchPoints),aa=g.hcLib||(g.hcLib={}),I=aa.SvgDeCanvo,ia=function(E){var b=E.data,h=b.chart,u=h.components.paper,f=E.state,a=Da(La(E.originalEvent)),z=a.target||a.originalTarget||a.srcElement||a.relatedTarget||a.fromElement,B=h.components.resizeBox,P=b.layerX=a.pageX-b.chartPosLeft,G=b.layerY=a.pageY-b.chartPosTop,c=P-b.ox,e=G-b.oy,d=b.bBox,
g=b.ox,V=b.oy,l=b.zoomX,t=b.zoomY,d=b.canvasY,p=b.canvasX,q=b.canvasW,m=b.canvasH,C=b.canvasX2,va=b.canvasY2,v=b.strokeWidth,c=b.attr;switch(f){case "start":E=Ja(this);b.chartPosLeft=E.left;b.chartPosTop=E.top;P=a.pageX-b.chartPosLeft;G=a.pageY-b.chartPosTop;b.oy=G;b.ox=P;b.allowMove=!1;B||(B=h.components.resizeBox=u.rect(h.graphics.trackerGroup).attr(c));P>p&&P<C&&G>d&&G<va&&(b.allowMove=!0);z&&z.ishot&&(b.allowMove=!1);B.attr({x:0,y:0,width:0,height:0}).show();break;case "end":d=B.getBBox();h={chart:h,
selectionLeft:d.x,selectionTop:d.y,selectionHeight:d.height,selectionWidth:d.width,originalEvent:E.originalEvent};b.isDragged&&(b.selectionEnd&&b.selectionEnd(h),b.isDragged=0);B.hide();delete b.oy;delete b.ox;break;default:b.allowMove&&(c=P-b.ox,e=G-b.oy,g=b.ox,V=b.oy,b.isDragged||(h={chart:h,selectionLeft:(l?K(g,g+c):p)+.5*v,selectionTop:(t?K(V,V+e):d)+.5*v,selectionHeight:0,selectionWidth:0,originalEvent:E.originalEvent},b.selectionStart&&b.selectionStart(h),b.isDragged=1),c=-(g-K(g-(g-L(g+c,p)),
C)),e=-(V-K(V-(V-L(V+e,d)),va)),B.attr({x:(l?K(g,g+c):p)+.5*v,y:(t?K(V,V+e):d)+.5*v,width:l?r(c):q,height:t?r(e):m}))}},C=function(b){var k=b.data;b=b.originalEvent;var h=b.target||b.originalTarget||b.srcElement||b.relatedTarget||b.fromElement,u=b.type,f=b.layerX,a=b.layerY;void 0===f&&(f=b.pageX-k.chartPosLeft,a=b.pageY-k.chartPosTop);"mousedown"===u&&(h.ishot=f>k.canvasX&&f<k.canvasX2&&a>k.canvasY&&a<k.canvasY2);"mouseup"===u&&setTimeout(function(){h.ishot=!1},1)},za=function(){var b="innerWidth",
k="innerHeight",h=n.documentElement||n.body,u=h;"innerWidth"in m?u=m:(b="clientWidth",k="clientHeight");return function(){return{width:u[b],height:u[k],scrollTop:h.scrollTop,scrollLeft:h.scrollLeft}}}(),Ja=function(b,k){var h={left:b.offsetLeft||0,top:b.offsetTop||0};for(b=b.offsetParent;b;)h.left+=b.offsetLeft||0,h.top+=b.offsetTop||0,b===n.body||b===n.documentElement||k||(h.left-=b.scrollLeft,h.top-=b.scrollTop),b=b.offsetParent;return h},na=function(b){return b&&b.replace(/\$/g,"$$$$")},ea=function(b,
k){return b||!1===b||0===b?b:k},ra=function(){var b,k,h;k=0;for(h=arguments.length;k<h;k+=1)if((b=arguments[k])||!1===b||0===b)return b;return""},V=function(){var b,k,h;k=0;for(h=arguments.length;k<h;k+=1)if((b=arguments[k])||!1===b||0===b)return b},va=function(b,k,h,u){return aa.dem.listen(b,k,h,u)},nb=function(b,k,h){return aa.dem.unlisten(b,k,h)},La=function(b){b=b.sourceEvent||b.originalEvent||b;return e&&b&&b.touches&&b.touches[0]||b||S},Da=function(){var b;return function(k){void 0===k.pageX&&
(k.pageX=k.clientX+(b||(b=m.document.body||m.document.documentElement)).scrollLeft,k.pageY=k.clientY+b.scrollTop);return k}}(),Ma=function(b,k){k=Da(La(k));var h=k.pageX,u=k.pageY,f=Ja(b);return{chartX:h-f.left,chartY:u-f.top,pageX:h,pageY:u}},Oa=function(b,k,h){b=n.createElement(b);for(var u in k)b.setAttribute(u,k[u]);h&&h.appendChild&&h.appendChild(b);return b},Wa=function(b){return b&&b.replace(/^#?([a-f0-9]+)/ig,"#$1")||"none"},Ka=function(){var b,k,h;k=0;for(h=arguments.length;k<h;k+=1)if(((b=
arguments[k])||!1===b||0===b)&&!isNaN(b=Number(b)))return b},Pa=function(b,k){b=b||!1===b||0===b?Number(b):NaN;return isNaN(b)?null:k?r(b):b},Ua=function(b){return"string"===typeof b?b.replace(ga,"<br />"):""},Sa=function(b,k){b=b.split(",")[k||0];b=b.replace(O,"");""==b&&(b="000000");return b.replace(d,"#")},ka=function(b){b=parseInt(b,10);if(isNaN(b)||100<b||0>b)b=100;return b},mb=function(b,k){for(var h=k.length,u=-1;h--;)if(b===k[h]){u=h;break}return u},Ga=function(){if(Array.isArray)return Array.isArray;
var b=Object.prototype.toString,k=b.call([]);return function(h){return b.call(h)===k}}(),Na=function(b,k,h,u,f){var a,z,B,P;f?(u.push(b),f.push(k)):(u=[b],f=[k]);if(k instanceof Array)for(a=0;a<k.length;a+=1){try{z=b[a],B=k[a]}catch(G){continue}if("object"!==typeof B)h&&void 0===B||(b[a]=B);else{if(null===z||"object"!==typeof z)z=b[a]=B instanceof Array?[]:{};P=mb(B,f);-1!==P?z=b[a]=u[P]:Na(z,B,h,u,f)}}else for(a in k){try{z=b[a],B=k[a]}catch(G){continue}if(null!==B&&"object"===typeof B)if(P=M.call(B),
"[object Object]"===P){if(null===z||"object"!==typeof z)z=b[a]={};P=mb(B,f);-1!==P?z=b[a]=u[P]:Na(z,B,h,u,f)}else"[object Array]"===P?(null!==z&&z instanceof Array||(z=b[a]=[]),P=mb(B,f),-1!==P?z=b[a]=u[P]:Na(z,B,h,u,f)):b[a]=B;else b[a]=B}return b},ya=function(b,k,h){if("object"!==typeof b&&"object"!==typeof k)return null;if("object"!==typeof k||null===k)return b;"object"!==typeof b&&(b=k instanceof Array?[]:{});Na(b,k,h);return b},Ia=function(b,k){var h;if(k instanceof Array)for(h=k.length-1;0<=
h;--h)"object"!==typeof k[h]?!0===k[h]&&b&&b.splice&&b.splice(h,1):M.call(k[h])===M.call(b[h])&&Ia(b[h],k[h]);else for(h in k)"object"!==typeof k[h]?!0===k[h]&&b&&b.splice&&b.splice(h,1):M.call(k[h])===M.call(b[h])&&Ia(b[h],k[h]);return b},Za=function(){var b=/^@window_/g;return function(k,h){var u=k.replace(/\[[\'\"]/g,".").replace(/[\'\"]\]/g,"").replace(/\[/g,".@window_").replace(/\]/g,"").split("."),f=m,a,z;z="";var B,P,G;P=u.length;for(G=0;G<P;G+=1){B=u[G];a=f;if(B.match(b))z=m[B.replace(b,"")],
f=f[z];else{if(void 0===f||null===f)throw(z||B).replace(b,"")+" is not defined";f=f[B]}z=B}!f||"function"!==typeof f.call&&f!==m.alert?setTimeout(function(){throw B.replace(b,"")+"() is not a function";},0):f===m.alert?f(h):f.call(a,h)}}(),wb=function(){var b="FusionChartslinkEval"+parseInt(+new Date,10);return function(k){try{m[b]=new Function(k),eval('window["'+b+'"]();')}catch(h){setTimeout(function(){throw h;},0)}A?delete m[b]:m[b]=null}}(),Hb=function(b){var k={image:!1};void 0!==b&&(b=b.replace(/^\s+/,
"").replace(/\s+$/,""),/^i\s*[\-]\s*/i.test(b)?(k.image=!0,k.string=b.replace(/^i\s*[\-]\s*/i,"")):k.string=b.replace(/^\\/,""));return k},Eb=function(b,k){b=Number(b);b=isNaN(b)?100:b;void 0!==k&&(b=b*k/100);return b%101},Ob=function(b,k,h){b=b.split(",");var u;void 0!==h&&(h=Ka(h.split(",")[0]));b[0]=Eb(b[0],h);for(u=1;u<k;u+=1)b[u]=b[0]*Eb(b[u],h)/100;return b.join(",")},kb=function(b,k,h){var u=0,f=0,a=0;h&&h.match(l)&&(h=h.split(","),u=h[0].slice(h[0].indexOf("(")+1),f=h[1],a=h[2],k||0===k||
(k=parseInt(100*h[3].slice(0,h[3].indexOf(")")),10)));if(b)if(b.match(l))h=b.split(","),u=h[0].slice(h[0].indexOf("(")+1),f=h[1],a=h[2];else{b=b.replace(N,"").split(",")[0];switch(b.length){case 3:b=b.charAt(0)+b.charAt(0)+b.charAt(1)+b.charAt(1)+b.charAt(2)+b.charAt(2);break;case 6:break;default:b=(b+"FFFFFF").slice(0,6)}u=parseInt(b.slice(0,2),16);f=parseInt(b.slice(2,4),16);a=parseInt(b.slice(4,6),16)}k||0===k||(k=100);"string"===typeof k&&(k=k.split(",")[0]);k=parseInt(k,10)/100;return"rgba("+
u+","+f+","+a+","+k+")"},cb=function(){var b={};return function(k){var h=(k=k||this)&&k.FCcolor||k,u=h.color,f=h.ratio,z=h.angle,Y=h.alpha,B=h.r,P=h.cx,G=h.cy,c=h.fx,e=h.fy,d=h.gradientUnits,g=h.x1,V=h.y1,l=h.x2,t=h.y2,p=1,q,m,C,va;if("string"===typeof k)return b[va="~"+k]||(b[va]=k.replace(/^#?([a-f0-9]{3,6})/ig,"#$1"));u=u||"";if(!u)return q;va=[u,Y,f,z,B,P,G,d,c,e,g,l,V,t].join("_").replace(/[\(\)\s,\xb0#]/g,"_");if(b[va])return b[va];f=f&&(f+"").split(",")||[];Y=(Y||0===Y)&&(Y+"").split(",")||
[];if(u=u.split(","))if(q="",1===u.length)C=u[0].replace(/^#?([a-f0-9]{3,6})/ig,"$1"),q=Y.length?"rgba("+sb(C).join(",")+","+.01*a(Y[0])+")":C.replace(/^#?([a-f0-9]{3,6})/ig,"#$1");else{k=0;for(m=u.length;k<m;k++)C=u[k].replace(/^#?([a-f0-9]{3,6})/ig,"$1"),isNaN(f[k])||(f[k]=a(f[k]),C+=":"+f[k],isNaN(f[k+1])||(f[k+1]=a(f[k+1])+f[k])),isNaN(Y[k])||""===Y[k]||(p=.01*Y[k]),u[k]="rgba("+sb(C).join(",")+","+p+")",isNaN(f[k])||(u[k]=u[k]+":"+f[k]);q+=u.join("-");if(void 0!==B||void 0!==c||void 0!==P||h.radialGradient)q=
"xr("+[c,e,B,P,G,d].join()+")"+q;else{q="-"+q;if(void 0!==g||void 0!==V||void 0!==l||void 0!==t)q="("+[g,V,l,t,d].join()+")"+q;void 0===z&&(z=0);q=360-a(z)%360+q}}return b[va]=q}}(),Xa=function(){return function(){return""}}(),lb=function(b){return b.replace(N,"").replace(d,"#")},db=function(b,k){k=(0>k||100<k?100:k)/100;b=b.replace(N,"");var h=parseInt(b,16),u=Math.floor(h/65536),f=Math.floor((h-65536*u)/256);return("000000"+(u*k<<16|f*k<<8|(h-65536*u-256*f)*k).toString(16)).slice(-6)},$a=function(b,
k){k=(0>k||100<k?100:k)/100;b=b.replace(N,"");var h=parseInt(b,16),u=Math.floor(h/65536),f=Math.floor((h-65536*u)/256);return("000000"+(256-(256-u)*k<<16|256-(256-f)*k<<8|256-(256-(h-65536*u-256*f))*k).toString(16)).slice(-6)},sb=function(b){b=parseInt(b,16);var k=Math.floor(b/65536),h=Math.floor((b-65536*k)/256);return[k,h,Math.floor(b-65536*k-256*h)]},tb=function(b,k){if("object"!==typeof b)return"";if(b.fontSize||b["font-size"])!b.fontSize&&b["font-size"]&&(b.fontSize=b["font-size"],delete b["font-size"]),
b.lineHeight=(parseFloat(b.fontSize)||k||10)*aa.lineHeightFactor+"px",delete b["line-height"];!b.lineHeight&&b["line-height"]&&(b.lineHeight=b["line-height"],delete b["line-height"]);return b.lineHeight},gb=function(b,k,h,u,f){var a=ra(b.labelbordercolor,k.bordercolor,h.labelbordercolor,""),z=V(b.labelbgcolor,k.bgcolor,h.labelbgcolor),B=Ka(b.labelborderthickness,k.borderthickness,h.labelborderthickness,1);f=Ka(h.usedataplotcolorforlabels,0)?f||u.color:u.color;a=a?kb(a,Ka(b.labelborderalpha,k.borderalpha,
h.labelborderalpha,b.labelalpha,k.alpha,h.labelalpha,100)):"";b={fontFamily:V(b.labelfont,k.font,h.labelfont,u.fontFamily),fontSize:V(b.labelfontsize,k.fontsize,h.labelfontsize,parseInt(u.fontSize,10))+"px",color:kb(V(b.labelfontcolor,k.fontcolor,h.labelfontcolor,f),Ka(b.labelfontalpha,k.fontalpha,h.labelfontalpha,b.labelalpha,k.alpha,h.labelalpha,100)),fontWeight:Ka(b.labelfontbold,k.fontbold,h.labelfontbold)?"bold":"normal",fontStyle:Ka(b.labelfontitalic,k.fontitalic,h.labelfontitalic)?"italic":
"normal",border:a||z?B+"px solid":"",borderColor:a,borderThickness:B,borderPadding:Ka(b.labelborderpadding,k.borderpadding,h.labelborderpadding,2),borderRadius:Ka(b.labelborderradius,k.borderradius,h.labelborderradius,0),backgroundColor:z?kb(z,Ka(b.labelbgalpha,k.bgalpha,h.labelbgalpha,b.labelalpha,k.alpha,h.labelalpha,100)):"",borderDash:Ka(b.labelborderdashed,k.borderdashed,h.labelborderdashed,0)?Ea(Ka(b.labelborderdashlen,k.borderdashlen,h.labelborderdashlen,4),Ka(b.labelborderdashgap,k.borderdashgap,
h.labelborderdashgap,2),B):"none"};b.lineHeight=tb(b);return b},Qa=function(){var b={top:{align:"center",verticalAlign:"top",textAlign:"center"},right:{align:"right",verticalAlign:"middle",textAlign:"left"},bottom:{align:"center",verticalAlign:"bottom",textAlign:"center"},left:{align:"left",verticalAlign:"middle",textAlign:"right"}},k=/([^\,^\s]+)\)$/g,h=function(b,k){var E;/^(bar|bar3d)$/.test(b)&&(this.isBar=!0,this.yPos="bottom",this.yOppPos="top",this.xPos="left",this.xOppPos="right");E=parseInt(k.labelstep,
10);this.labelStep=1<E?E:1;this.showLabel=Ka(k.showlabels,k.shownames,1);this.is3D=/3d$/.test(b)};h.prototype={isBar:!1,yPos:"left",yOppPos:"right",xPos:"bottom",xOppPos:"top",addAxisGridLine:function(h,f,a,z,B,P,G,c){var e=""===a?!1:!0,d=0<z||0<P.match(k)[1]?!0:!1,g;if(e||d)d||(P="rgba(0,0,0,0)",z=.1),g={isGrid:!0,width:z,dashStyle:B,color:P,value:f,zIndex:void 0===G?2:G},e&&(f=h.opposite?c?this.xOppPos:this.yOppPos:c?this.xPos:this.yPos,f=b[f],g.label={text:a,style:h.labels.style,textAlign:f.textAlign,
align:f.align,verticalAlign:f.verticalAlign,rotation:0,x:0,y:0}),h.plotLines.push(g);return g},addAxisAltGrid:function(b,k){if(!this.is3D){var E=Ka(b._lastValue,b.min),h=V(b._altGrid,!1);h&&b.plotBands.push({isGrid:!0,color:b.alternateGridColor,to:k,from:E,zIndex:1});b._lastValue=k;b._altGrid=!h}},addXaxisCat:function(k,f,h,a,z,B,P,G){var c=b[k.opposite?this.xOppPos:this.xPos];f={isGrid:!0,isDataLabel:!0,width:.1,color:"rgba(0,0,0,0)",value:f,label:{text:a,link:V(z.labellink,B.link,P.labellink),style:gb(z,
B,P,k.labels.style,G),textAlign:c.textAlign,align:c.align,verticalAlign:c.verticalAlign,rotation:0,x:0,y:0}};0!==h%this.labelStep&&(f.stepped=!0,f.label.style=k.steppedLabels.style);k.plotLines.push(f)},addVline:function(b,k,E,h){h=h._FCconf;var a=h.isBar,z=h.divlineStyle,B=Ua(k.label),P=!!Ka(k.showlabelborder,h.showVLineLabelBorder,1),G=!!Ka(k.showlabelbackground,1),c=V(k.labelhalign,a?"left":"center"),e=V(k.labelvalign,a?"middle":"bottom").toLowerCase(),d=Ka(k.labelposition,0),g=Ka(k.lineposition,
.5),l=Ka(k.showvlines,h.showVLines,1),t=Ka(k.alpha,h.vLineAlpha,80),q=V(k.color,h.vLineColor).replace(/^#?/,"#"),p=G?V(k.labelbgcolor,h.vLineLabelBgColor,"333333").replace(/^#?/,"#"):"",m=V(k.labelcolor,h.vLineLabelColor,k.color,h.vLineColor).replace(/^#?/,"#"),C=Ka(k.thickness,h.vLineThickness,1),va=.5*C,v=!!Number(V(k.dashed,0)),r=Ka(k.dashlen,5),w=Ka(k.dashgap,2),H=h.smartLabel,n=parseInt(z.fontSize,10)+2,ra=0,K=Ka(k.rotatelabel,h.rotateVLineLabels)?270:0,g=0>g||1<g?.5:g,d=0>d||1<d?0:d;H.setStyle(z);
H=H.getOriSize(B);q=kb(q,l?t:"0");if(a){switch(e){case "top":n-=H.height+va+2;break;case "middle":n-=.5*H.height+1;break;default:n+=va}k.labelhalign||(ra-=H.width*d)}else{switch(e){case "top":n=.5*-H.height+1;break;case "middle":n=0;break;default:n=.5*H.height}switch(c){case "left":ra+=C;break;case "right":ra-=C+1}}b.plotLines.push({isVline:!0,color:q,width:C,value:E-1+g,zIndex:Ka(k.showontop,h.showVLinesOnTop)?5:3,dashStyle:v?Ea(r,w,C):"none",label:{text:B,align:a?"left":"center",offsetScale:d,rotation:K,
y:n,x:ra,textAlign:c,backgroundColor:p,borderWidth:l&&P?1:0,borderType:l&&P?"solid":"",borderColor:l&&P?m:"",backgroundOpacity:l&&G?V(k.labelbgalpha,h.vLineLabelBgAlpha)/100:0,style:{color:l?m:q,fontSize:z.fontSize,fontFamily:z.fontFamily,lineHeight:z.lineHeight,backgroundColor:p}}})}};return h.prototype.constructor=h}(),vb=function(){var b=function(b,f,E,h,a){b=Math.abs(f-b);f=b/(E+1);k(b,E,h)||(a&&Number(f)/Number(h)<(1<h?2:.5)&&(h/=10),f=(Math.floor(f/h)+1)*h,b=f*(E+1));return b},k=function(b,
k,E){return h(b/(k+1))>h(E)?!1:!0},h=function(b){b=Math.abs(b);b=String(b);var k=0,E=b.indexOf(".");-1!=E&&(k=b.length-E-1);return k};return function(h,f,a,z,B,P,G,c){var e,d,g,V,l,q,t,p=0;h=!0===isNaN(h)||void 0===h?.1:h;f=!0===isNaN(f)||void 0===f?0:f;h===f&&0===h&&(h=.1);d=Math.max(Math.floor(Math.log(Math.abs(f))/Math.LN10),Math.floor(Math.log(Math.abs(h))/Math.LN10));e=Math.pow(10,d);2>Math.abs(h)/e&&2>Math.abs(f)/e&&(d--,e=Math.pow(10,d));d=Math.floor(Math.log(h-f)/Math.LN10);g=Math.pow(10,
d);0<h-f&&10<=e/g&&(e=g);d=(Math.floor(h/e)+1)*e;0>f?g=-1*(Math.floor(Math.abs(f/e))+1)*e:P?g=0:(g=Math.floor(Math.abs(f/e)-1)*e,g=0>g?0:g);B&&0>=h&&(d=0);B=a||0===a?!0:!1;P=z||0===z?!0:!1;h=!1===B||!0===B&&Number(a)<h&&h-Number(a)>v?d:Number(a);f=!1===P||!0===P&&Number(z)>f&&Number(z)-f>v?g:Number(z);z=Math.abs(h-f);if(!1===P&&!1===B&&c)if(0<h&&0>f)for(a=!1,B=10<e?e/10:e,c=b(f,h,G,B,!1),P=c-(G+1)*B;!1===a;){if(P+=(G+1)*B,k(P,G,B))if(c=P-z,d=P/(G+1),V=Math.min(Math.abs(f),h),g=V==Math.abs(f)?-1:1,
0===G)a=!0;else for(q=1;q<=Math.floor((G+1)/2);q++)l=d*q,!(l-V>c)&&l>V&&(t=P-l,t/d==Math.floor(t/d)&&l/d==Math.floor(l/d)&&(z=P,h=-1==g?t:l,f=-1==g?-l:-t,a=!0))}else a=b(f,h,G,e,!0),c=a-z,z=a,0<h?h+=c:f-=c;else c&&(a=function(b,f,E){for(var h=0,u=1,a;;){a=b+h*u;a=0===a?1:a;if(k(f,a,E))break;h=-1==u||h>b?++h:h;if(25<h){a=0;break}u=h<=b?-1*u:1}return a},0<G&&(c=a(G,z,e),0===c&&(c=a(G,z+1,e),p=1),G=c));return{Max:h,Min:f,Range:z,interval:e,divGap:(h-f+p)/(G+1)}}}(),jb=function(){var b=function(b,E,u){var f=
u.jsVars&&u.jsVars.smartLabel,a=b.offsetWidth,z=b.offsetHeight,B=this.chart;b=this.title;var P=u._chartMessageImageStyle,G=Hb(E);b.y=z/2;b.x=a/2;B.bgSWF=b.text=void 0;E=G.string;G.image?(B.bgSWF=E,B.bgImageHAlign=P.imageHAlign,B.bgImageVAlign=P.imageVAlign,B.bgImageScale=P.imageScale,B.bgSWFAlpha=P.imageAlpha):void 0!==E&&(f?(tb(b.style),f.setStyle(b.style),E=f.getSmartText(Ua(E),a,z),b.text=E.text):b.text=Ua(E),b.verticalAlign="middle");b.style=u._chartMessageStyle;delete u._chartMessageImageStyle;
delete u._chartMessageStyle};b.prototype={chart:{events:{},margin:[0,0,0,0],backgroundColor:{FCcolor:{alpha:0}}},credits:{href:q,text:"FusionCharts XT Trial",enabled:t},legend:{enabled:!1},title:{text:"",style:{fontFamily:"Verdana,sans",fontSize:"10px",color:"#666666"}},plotOptions:{series:{}},series:[{}],exporting:{enabled:!1},nativeMessage:!0};return b.prototype.constructor=b}(),ab={"true":{"true":{"true":"center","false":"center"},"false":{"true":"center","false":"center"}},"false":{"true":{"true":"right",
"false":"left"},"false":{"true":"left","false":"right"}}},Va=function(){return function(b,k,h,u,f,a,z){var B,P=h.trendStyle,G,c,e,d,g,l,q,t,p,m,C,va,v,r=a?"xAxis":"dataLabels";if(a?h.showVLines:h.showTrendlines)for(B=0,c=b.length;B<c;B+=1)if((v=b[B])&&v.line)for(G=0,e=v.line.length;G<e;G+=1)d=v.line[G],m=h.numberFormatter.getCleanValue(V(d.startvalue,d.value,0)),C=h.numberFormatter.getCleanValue(V(d.endvalue,V(d.startvalue,d.value,0))),a?t=k:u&&d.parentyaxis&&/^s$/i.test(d.parentyaxis)?(t=k[1],va=
1):t=k[0],l=t.max,q=t.min,g=!1,l>=m&&l>=C&&q<=m&&q<=C&&(u&&d.parentyaxis&&/^s$/i.test(d.parentyaxis)?g="1"!==V(d.valueonleft,h.trendlineValuesOnOpp):u||(g="1"===V(d.valueonright,h.trendlineValuesOnOpp)),l=!!Ka(d.istrendzone,a?1:0),(q=(a?h.showVLineLabels:h.showTrendlineLabels)?Ua(V(d.displayvalue,h.numberFormatter[r](g?C:m,va))):"")?(p=m<C,g={text:q,textAlign:f?"center":g?"left":"right",align:f?ab[l][!z][p]:g?"right":"left",verticalAlign:f?"bottom":"middle",rotation:0,x:0,y:0,style:P},q=V(d.color,
h.trendlineColor),d.alwaysVisible=l,q&&(g.style=ya({},P),g.style.color=kb(q,Ka(d.alpha,100)))):g=void 0,q=ea(Ua(V(d.tooltext,v.tooltext,h.trendLineToolText))),q=hb(q,[7,15,16,17,18,19],{startValue:m,startDataValue:h.numberFormatter[r](m,va),endValue:C,endDataValue:h.numberFormatter[r](C,va),axisName:t.title&&t.title.text},d),p=Ka(d.thickness,h.trendlineThickness,1),l?t.plotBands.push({isTrend:!0,color:kb(V(d.color,h.trendlineColor),V(d.alpha,h.trendlineAlpha,40)),from:m,to:C,label:g,zIndex:h.is3d||
"1"!==V(d.showontop,h.showTrendlinesOnTop)?3:5,tooltext:q,alwaysVisible:d.alwaysVisible}):t.plotLines.push({isTrend:!0,color:kb(V(d.color,h.trendlineColor,h.trendlineColor),V(d.alpha,h.trendlineAlpha,99)),value:m,to:C,width:p,dashStyle:"1"==V(d.dashed,h.trendlinesAreDashed)?Ea(Ka(d.dashlen,h.trendlinesDashLen),Ka(d.dashgap,h.trendlinesDashGap),p):"none",label:g,zIndex:h.is3d||"1"!==V(d.showontop,h.showTrendlinesOnTop)?3:5,tooltext:q}))}}(),Ea=function(b,k,h,u){return u||void 0===u?[b,k]:"none"},Ra=
function(){},xb=function(b,k,h,u,f){var a,z=xb[b],B;z||(B=function(){},B.prototype=h instanceof Ra?h:new Ra,B.prototype.constructor=B,z=xb[b]=new B,h&&(z.base=h),z.name=b,z.config={},null!==f&&(b=(f instanceof Ra?f:h instanceof Ra?h:{}).config)&&ya(z.config,b));u&&ya(z.config,u);for(a in k)switch(typeof k[a]){case "object":if(k[a]instanceof Ra){z[a]=k[a][a];break}default:z[a]=k[a];break;case "undefined":delete z[a]}return this instanceof xb?(k=function(){this.config={};this.__setDefaultConfig=function(){z&&
z.config&&ya(this.config,z.config)};this.__setDefaultConfig()},k.prototype=z,k.prototype.constructor=k,new k):z},hb=function(){var b=[{regex:/((^|[^\\])((\\)\\)*\$cleanvalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$cleanvalue))/ig,argIndex:2,argKey:"cleanvalue"},{regex:/((^|[^\\])((\\)\\)*\$datavalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$datavalue))/ig,argIndex:2,argKey:"formattedValue"},{regex:/((^|[^\\])((\\)\\)*\$value)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$value))/ig,argIndex:3,argKey:"value"},
{regex:/((^|[^\\])((\\)\\)*\$label)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$label))/ig,argIndex:2,argKey:"label"},{regex:/((^|[^\\])((\\)\\)*\$seriesname)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$seriesname))/ig,argIndex:5,argKey:"seriesname"},{regex:/((^|[^\\])((\\)\\)*\$yaxisname)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$yaxisname))/ig,argIndex:2,argKey:"yaxisName"},{regex:/((^|[^\\])((\\)\\)*\$xaxisname)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$xaxisname))/ig,argIndex:2,argKey:"xaxisName"},{regex:/((^|[^\\])((\\)\\)*\$displayvalue)/ig,
escapeRegex:/((^|[^\\])((\\)\\)*\\(\$displayvalue))/ig,argIndex:3,argKey:"displayvalue"},{regex:/((^|[^\\])((\\)\\)*\$xdatavalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$xdatavalue))/ig,argIndex:2,argKey:"xDataValue"},{regex:/((^|[^\\])((\\)\\)*\$ydatavalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$ydatavalue))/ig,argIndex:2,argKey:"yDataValue"},{regex:/((^|[^\\])((\\)\\)*\$xvalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$xvalue))/ig,argIndex:3,argKey:"x"},{regex:/((^|[^\\])((\\)\\)*\$yvalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$yvalue))/ig,
argIndex:3,argKey:"y"},{regex:/((^|[^\\])((\\)\\)*\$zvalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$zvalue))/ig,argIndex:3,argKey:"z"},{regex:/((^|[^\\])((\\)\\)*\$name)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$name))/ig,argIndex:3,argKey:"name"},{regex:/((^|[^\\])((\\)\\)*\$percentValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$percentValue))/ig,argIndex:2,argKey:"percentValue"},{regex:/((^|[^\\])((\\)\\)*\$startValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$startValue))/ig,argIndex:2,argKey:"startValue"},
{regex:/((^|[^\\])((\\)\\)*\$startDataValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$startDataValue))/ig,argIndex:2,argKey:"startDataValue"},{regex:/((^|[^\\])((\\)\\)*\$endValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$endValue))/ig,argIndex:2,argKey:"endValue"},{regex:/((^|[^\\])((\\)\\)*\$endDataValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$endDataValue))/ig,argIndex:2,argKey:"endDataValue"},{regex:/((^|[^\\])((\\)\\)*\$axisName)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$axisName))/ig,argIndex:2,
argKey:"axisName"},{regex:/((^|[^\\])((\\)\\)*\$cumulativevalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$cumulativevalue))/ig,argIndex:2,argKey:"cumulativeValue"},{regex:/((^|[^\\])((\\)\\)*\$cumulativedatavalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$cumulativedatavalue))/ig,argIndex:2,argKey:"cumulativeDataValue"},{regex:/((^|[^\\])((\\)\\)*\$cumulativePercentValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$cumulativePercentValue))/ig,argIndex:2,argKey:"cumulativePercentValue"},{regex:/((^|[^\\])((\\)\\)*\$cumulativepercentdatavalue)/ig,
escapeRegex:/((^|[^\\])((\\)\\)*\\(\$cumulativepercentdatavalue))/ig,argIndex:2,argKey:"cumulativePercentDataValue"},{regex:/((^|[^\\])((\\)\\)*\$sum)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$sum))/ig,argIndex:2,argKey:"sum"},{regex:/((^|[^\\])((\\)\\)*\$unformattedsum)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$unformattedsum))/ig,argIndex:2,argKey:"unformattedSum"},{regex:/((^|[^\\])((\\)\\)*\$targetvalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$targetvalue))/ig,argIndex:2,argKey:"targetValue"},{regex:/((^|[^\\])((\\)\\)*\$targetdatavalue)/ig,
escapeRegex:/((^|[^\\])((\\)\\)*\\(\$targetdatavalue))/ig,argIndex:2,argKey:"targetDataValue"},{regex:/((^|[^\\])((\\)\\)*\$processname)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$processname))/ig,argIndex:2,argKey:"processName"},{regex:/((^|[^\\])((\\)\\)*\$start)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$start))/ig,argIndex:2,argKey:"start"},{regex:/((^|[^\\])((\\)\\)*\$end)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$end))/ig,argIndex:2,argKey:"end"},{regex:/((^|[^\\])((\\)\\)*\$percentcomplete)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$percentcomplete))/ig,
argIndex:2,argKey:"percentComplete"},{regex:/((^|[^\\])((\\)\\)*\$taskpercentcomplete)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$taskpercentcomplete))/ig,argIndex:2,argKey:"taskPercentComplete"},{regex:/((^|[^\\])((\\)\\)*\$taskstartdate)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$taskstartdate))/ig,argIndex:2,argKey:"taskStartDate"},{regex:/((^|[^\\])((\\)\\)*\$taskenddate)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$taskenddate))/ig,argIndex:2,argKey:"taskEndDate"},{regex:/((^|[^\\])((\\)\\)*\$tasklabel)/ig,
escapeRegex:/((^|[^\\])((\\)\\)*\\(\$tasklabel))/ig,argIndex:2,argKey:"taskLabel"},{regex:/((^|[^\\])((\\)\\)*\$date)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$date))/ig,argIndex:2,argKey:"date"},{regex:/((^|[^\\])((\\)\\)*\$percentofprevvalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$percentofprevvalue))/ig,argIndex:2,argKey:"percentOfPrevValue"},{regex:/((^|[^\\])((\\)\\)*\$sname)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$sname))/ig,argIndex:2,argKey:"sName"},{regex:/((^|[^\\])((\\)\\)*\$lname)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$lname))/ig,
argIndex:2,argKey:"lName"},{regex:/((^|[^\\])((\\)\\)*\$fromid)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$fromid))/ig,argIndex:2,argKey:"fromId"},{regex:/((^|[^\\])((\\)\\)*\$fromlabel)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$fromlabel))/ig,argIndex:2,argKey:"fromLabel"},{regex:/((^|[^\\])((\\)\\)*\$toid)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$toid))/ig,argIndex:2,argKey:"toId"},{regex:/((^|[^\\])((\\)\\)*\$tolabel)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$tolabel))/ig,argIndex:2,argKey:"toLabel"},
{regex:/((^|[^\\])((\\)\\)*\$fromxvalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$fromxvalue))/ig,argIndex:2,argKey:"fromXValue"},{regex:/((^|[^\\])((\\)\\)*\$fromyvalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$fromyvalue))/ig,argIndex:2,argKey:"fromYValue"},{regex:/((^|[^\\])((\\)\\)*\$fromxdatavalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$fromxdatavalue))/ig,argIndex:2,argKey:"fromXDataValue"},{regex:/((^|[^\\])((\\)\\)*\$fromydatavalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$fromydatavalue))/ig,
argIndex:2,argKey:"fromYDataValue"},{regex:/((^|[^\\])((\\)\\)*\$fromlabel)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$fromlabel))/ig,argIndex:2,argKey:"fromLabel"},{regex:/((^|[^\\])((\\)\\)*\$toxvalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$toxvalue))/ig,argIndex:2,argKey:"toXValue"},{regex:/((^|[^\\])((\\)\\)*\$toyvalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$toyvalue))/ig,argIndex:2,argKey:"toYValue"},{regex:/((^|[^\\])((\\)\\)*\$toxdatavalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$toxdatavalue))/ig,
argIndex:2,argKey:"toXDataValue"},{regex:/((^|[^\\])((\\)\\)*\$toydatavalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$toydatavalue))/ig,argIndex:2,argKey:"toYDataValue"},{regex:/((^|[^\\])((\\)\\)*\$tolabel)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$tolabel))/ig,argIndex:2,argKey:"toLabel"},{regex:/((^|[^\\])((\\)\\)*\$openvalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$openvalue))/ig,argIndex:2,argKey:"openValue"},{regex:/((^|[^\\])((\\)\\)*\$closevalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$closevalue))/ig,
argIndex:2,argKey:"closeValue"},{regex:/((^|[^\\])((\\)\\)*\$highvalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$highvalue))/ig,argIndex:2,argKey:"highValue"},{regex:/((^|[^\\])((\\)\\)*\$lowvalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$lowvalue))/ig,argIndex:2,argKey:"lowValue"},{regex:/((^|[^\\])((\\)\\)*\$opendatavalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$opendatavalue))/ig,argIndex:2,argKey:"openDataValue"},{regex:/((^|[^\\])((\\)\\)*\$closedatavalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$closedatavalue))/ig,
argIndex:2,argKey:"closeDataValue"},{regex:/((^|[^\\])((\\)\\)*\$highdatavalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$highdatavalue))/ig,argIndex:2,argKey:"highDataValue"},{regex:/((^|[^\\])((\\)\\)*\$lowdatavalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$lowdatavalue))/ig,argIndex:2,argKey:"lowDataValue"},{regex:/((^|[^\\])((\\)\\)*\$maxvalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$maxvalue))/ig,argIndex:2,argKey:"maxValue"},{regex:/((^|[^\\])((\\)\\)*\$maxdatavalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$maxdatavalue))/ig,
argIndex:2,argKey:"maxDataValue"},{regex:/((^|[^\\])((\\)\\)*\$minvalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$minvalue))/ig,argIndex:2,argKey:"minValue"},{regex:/((^|[^\\])((\\)\\)*\$mindatavalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$mindatavalue))/ig,argIndex:2,argKey:"minDataValue"},{regex:/((^|[^\\])((\\)\\)*\$q1)/ig,argIndex:2,argKey:"Q1"},{regex:/((^|[^\\])((\\)\\)*\$unformattedQ1)/ig,argIndex:2,argKey:"unformattedQ1"},{regex:/((^|[^\\])((\\)\\)*\$q3)/ig,argIndex:2,argKey:"Q3"},{regex:/((^|[^\\])((\\)\\)*\$unformattedQ3)/ig,
argIndex:2,argKey:"unformattedQ3"},{regex:/((^|[^\\])((\\)\\)*\$median)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$median))/ig,argIndex:2,argKey:"median"},{regex:/((^|[^\\])((\\)\\)*\$unformattedMedian)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$unformattedMedian))/ig,argIndex:2,argKey:"unformattedMedian"},{regex:/((^|[^\\])((\\)\\)*\$SD)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$SD))/ig,argIndex:2,argKey:"SD"},{regex:/((^|[^\\])((\\)\\)*\$unformattedsd)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$unformattedsd))/ig,
argIndex:2,argKey:"unformattedsd"},{regex:/((^|[^\\])((\\)\\)*\$QD)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$QD))/ig,argIndex:2,argKey:"QD"},{regex:/((^|[^\\])((\\)\\)*\$unformattedQD)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$unformattedQD))/ig,argIndex:2,argKey:"unformattedQD"},{regex:/((^|[^\\])((\\)\\)*\$MD)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$MD))/ig,argIndex:2,argKey:"MD"},{regex:/((^|[^\\])((\\)\\)*\$unformattedMD)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$unformattedMD))/ig,argIndex:2,argKey:"unformattedMD"},
{regex:/((^|[^\\])((\\)\\)*\$mean)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$mean))/ig,argIndex:2,argKey:"mean"},{regex:/((^|[^\\])((\\)\\)*\$unformattedMean)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$unformattedMean))/ig,argIndex:2,argKey:"unformattedMean"},{regex:/((^|[^\\])((\\)\\)*\$unformattedMean)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$unformattedMean))/ig,argIndex:2,argKey:"unformattedMean"},{regex:/((^|[^\\])((\\)\\)*\$volumeValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$volumeValue))/ig,argIndex:2,
argKey:"volumeValue"},{regex:/((^|[^\\])((\\)\\)*\$volumeDataValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$volumeDataValue))/ig,argIndex:2,argKey:"volumeDataValue"},{regex:/((^|[^\\])((\\)\\)*\$fromXValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$fromXValue))/ig,argIndex:2,argKey:"fromXValue"},{regex:/((^|[^\\])((\\)\\)*\$fromYValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$fromYValue))/ig,argIndex:2,argKey:"fromYValue"},{regex:/((^|[^\\])((\\)\\)*\$fromXDataValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$fromXDataValue))/ig,
argIndex:2,argKey:"fromXDataValue"},{regex:/((^|[^\\])((\\)\\)*\$fromYDataValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$fromYDataValue))/ig,argIndex:2,argKey:"fromYDataValue"},{regex:/((^|[^\\])((\\)\\)*\$fromLabel)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$fromLabel))/ig,argIndex:2,argKey:"fromLabel"},{regex:/((^|[^\\])((\\)\\)*\$toXValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$toXValue))/ig,argIndex:2,argKey:"toXValue"},{regex:/((^|[^\\])((\\)\\)*\$toYValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$toYValue))/ig,
argIndex:2,argKey:"toYValue"},{regex:/((^|[^\\])((\\)\\)*\$toXDataValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$toXDataValue))/ig,argIndex:2,argKey:"toXDataValue"},{regex:/((^|[^\\])((\\)\\)*\$toYDataValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$toYDataValue))/ig,argIndex:2,argKey:"toYDataValue"},{regex:/((^|[^\\])((\\)\\)*\$tolabel)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$tolabel))/ig,argIndex:2,argKey:"toLabel"},{regex:/((^|[^\\])((\\)\\)*\$tlLabel)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$tlLabel))/ig,
argIndex:5,argKey:"tlLabel"},{regex:/((^|[^\\])((\\)\\)*\$trlabel)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$trlabel))/ig,argIndex:5,argKey:"trLabel"},{regex:/((^|[^\\])((\\)\\)*\$bllabel)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$bllabel))/ig,argIndex:5,argKey:"blLabel"},{regex:/((^|[^\\])((\\)\\)*\$brlabel)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$brlabel))/ig,argIndex:5,argKey:"brLabel"},{regex:/((^|[^\\])((\\)\\)*\$rowlabel)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$rowlabel))/ig,argIndex:5,argKey:"rowLabel"},
{regex:/((^|[^\\])((\\)\\)*\$columnlabel)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$columnlabel))/ig,argIndex:5,argKey:"columnLabel"},{regex:/((^|[^\\])((\\)\\)*\$errorvalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$errorvalue))/ig,argIndex:2,argKey:"errorValue"},{regex:/((^|[^\\])((\\)\\)*\$errordatavalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$errordatavalue))/ig,argIndex:2,argKey:"errorDataValue"},{regex:/((^|[^\\])((\\)\\)*\$errorpercentvalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$errorpercentvalue))/ig,
argIndex:2,argKey:"errorPercentValue"},{regex:/((^|[^\\])((\\)\\)*\$errorpercentdatavalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$errorpercentdatavalue))/ig,argIndex:2,argKey:"errorPercentDataValue"},{regex:/((^|[^\\])((\\)\\)*\$horizontalErrorValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$horizontalErrorValue))/ig,argIndex:2,argKey:"horizontalErrorValue"},{regex:/((^|[^\\])((\\)\\)*\$horizontalErrorDataValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$horizontalErrorDataValue))/ig,argIndex:2,argKey:"horizontalErrorDataValue"},
{regex:/((^|[^\\])((\\)\\)*\$verticalErrorValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$verticalErrorValue))/ig,argIndex:2,argKey:"verticalErrorValue"},{regex:/((^|[^\\])((\\)\\)*\$verticalErrorDataValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$verticalErrorDataValue))/ig,argIndex:2,argKey:"verticalErrorDataValue"},{regex:/((^|[^\\])((\\)\\)*\$horizontalErrorPercent)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$horizontalErrorPercentValue))/ig,argIndex:2,argKey:"horizontalErrorPercentValue"},{regex:/((^|[^\\])((\\)\\)*\$horizontalErrorPercentDataValue)/ig,
escapeRegex:/((^|[^\\])((\\)\\)*\\(\$horizontalErrorPercentDataValue))/ig,argIndex:2,argKey:"horizontalErrorPercentDataValue"},{regex:/((^|[^\\])((\\)\\)*\$verticalErrorPercent)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$verticalErrorPercentValue))/ig,argIndex:2,argKey:"verticalErrorPercentValue"},{regex:/((^|[^\\])((\\)\\)*\$verticalErrorPercentDataValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$verticalErrorPercentDataValue))/ig,argIndex:2,argKey:"verticalErrorPercentDataValue"},{regex:/((^|[^\\])((\\)\\)*\$xaxispercentvalue)/ig,
escapeRegex:/((^|[^\\])((\\)\\)*\\(\$xaxispercentvalue))/ig,argIndex:2,argKey:"xAxisPercentValue"},{regex:/((^|[^\\])((\\)\\)*\$percentdatavalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$percentdatavalue))/ig,argIndex:2,argKey:"percentDataValue"},{regex:/((^|[^\\])((\\)\\)*\$trType)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$trType))/ig,argIndex:4,argKey:"trtype"},{regex:/((^|[^\\])((\\)\\)*\$tlType)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$tlType))/ig,argIndex:4,argKey:"tltype"},{regex:/((^|[^\\])((\\)\\)*\$brType)/ig,
escapeRegex:/((^|[^\\])((\\)\\)*\\(\$brType))/ig,argIndex:4,argKey:"brtype"},{regex:/((^|[^\\])((\\)\\)*\$blType)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$blType))/ig,argIndex:4,argKey:"bltype"},{regex:/((^|[^\\])((\\)\\)*\$colorRangeLabel)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$colorRangeLabel))/ig,argIndex:5,argKey:"colorRangeLabel"},{regex:/((^|[^\\])((\\)\\)*\$zdatavalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$zdatavalue))/ig,argIndex:2,argKey:"zDataValue"},{regex:/((^|[^\\])((\\)\\)*\$svalue)/ig,
escapeRegex:/((^|[^\\])((\\)\\)*\\(\$svalue))/ig,argIndex:3,argKey:"svalue"},{regex:/((^|[^\\])((\\)\\)*\$positiveErrorValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$positiveErrorValue))/ig,argIndex:2,argKey:"positiveErrorValue"},{regex:/((^|[^\\])((\\)\\)*\$negativeErrorValue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$negativeErrorValue))/ig,argIndex:2,argKey:"negativeErrorValue"},{regex:/((^|[^\\])((\\)\\)*\$datasvalue)/ig,escapeRegex:/((^|[^\\])((\\)\\)*\\(\$datasvalue))/ig,argIndex:2,argKey:"formattedsValue"}],
k=[],h,u=b.length;for(h=0;h<u;h+=1)k.push(h);return function(){var f=arguments[0],h=arguments[1],u,a,z,B,P;Ga(h)||(h=k);if(f)for(P=h.length,B=0;B<P;B+=1)if(z=b[h[B]])u=na(ea((a=arguments[z.argIndex])&&a[z.argKey],"")+""),f=f.replace(z.regex,"$2$4"+(z.parsingMethod?z.parsingMethod(u):u)),f=f.replace(z.escapeRegex,"$2$4$5");return f}}(),yb=function(){var b=n.createElement("canvas");return!(!b.getContext||!b.getContext("2d"))},fb=function(b){var k,h,u;k=0<=b.split(",")[0].indexOf("base64")?m.atob(b.split(",")[1]):
m.unescape(b.split(",")[1]);b=b.split(",")[0].split(":")[1].split(";")[0];h=new Uint8Array(k.length);for(u=0;u<k.length;u++)h[u]=k.charCodeAt(u);return new m.Blob([h],{type:b})},Bb=function(){var b=m.navigator.userAgent,k;return-1!==(k=b.indexOf("Edge"))?{name:"Edge",version:b.substring(k+5,k+11)}:-1!==(k=b.indexOf("Chrome"))?{name:"Chrome",version:b.substring(k+7,k+11)}:-1!==(k=b.indexOf("MSIE"))?{name:"ie",version:b.substring(k+5,k+9)}:-1!==(k=b.indexOf("rv"))&&-1!==b.indexOf("Trident")?{name:"ie",
version:b.substring(k+5,k+9)}:-1!==(k=b.indexOf("Firefox"))?{name:"Firefox",version:b.substring(k+8,k+12)}:-1!==(k=b.indexOf("Safari"))?{name:"Safari",version:b.substring(k+7,k+11)}:{name:"default",version:"Not Known"}},zb=function(b){return b.replace(/<image [^\>]*\>/gi,function(b){return b.match(/href=["']\s*["']/)||b.match(/href=["']http:\/\/|href=["']https:\/\//)&&/(href=["']http:\/\/|href=["']https:\/\/)([^\/\:]*)/.exec(b)[2]&&m.location.hostname!==/(href=["']http:\/\/|href=["']https:\/\/)([^\/\:]*)/.exec(b)[2]?
"":b})},ib=function(b,k,h){var u=Bb(),f;"Chrome"===u.name||"Firefox"===u.name?("blob"===b&&(k=m.URL.createObjectURL(k)),f=n.createElement("a"),f.download=h,f.href=k,n.body.appendChild(f),f.onclick=function(){f.parentNode.removeChild(f)},f.click()):"ie"!==u.name&&"Edge"!==u.name||!m.navigator.msSaveBlob||(b="url"===b?fb(k):k,m.navigator.msSaveBlob(b,h))},ob=function(b,k){var h,u,f,a,z=k.exportTargetWindow,B=k.exportCallback,P=k.fusionCharts,G=k.paper,c=k.chartId;u=k.exportHandler;a=b.parameters;var e;
if("download"===k.exportAction){/webkit/ig.test(m.navigator.userAgent)&&"_self"===z&&(z=f=c+"export_iframe",e||(e=f=Oa("IFRAME",{name:f,width:"1px",height:"1px"},n.body),f.style.cssText="position:absolute;left:-10px;top:-10px;"));u=Oa("form",{method:"POST",action:u,target:z,style:"display:none;"},n.body);for(h in b)Oa("input",{type:"hidden",name:h,value:b[h]},u);u.submit();n.body.removeChild(u);u=void 0;h=a.match(/exportfilename=([^|]+)/)[1];a=a.match(/exportformat=([^|]+)/)[1];g.raiseEvent("exported",
{DOMId:c,height:G.height,width:G.width,fileName:h+"."+a,statusCode:void 0,statusMessage:void 0,notice:void 0},P.chartInstance);return!0}a=new g.ajax(function(b){var k={};b.replace(RegExp("([^?=&]+)(=([^&]*))?","g"),function(b,f,E,h){k[f]=h});B&&m[B]&&"function"===typeof m[B]&&m[B].call(m,k);g.raiseEvent("exported",k,P.chartInstance)},function(b){b={statusCode:0,statusMessage:"failure",error:b,DOMId:c,width:G&&G.width,height:G&&G.height};B&&m[B]&&"function"===typeof m[B]&&m[B].call(m,b);g.raiseEvent("exported",
b,P.chartInstance,[b])});for(h in b)b.hasOwnProperty(h)&&(b[h]=encodeURIComponent(b[h]));a.post(u,b)},pb=function(b,k){var h=0,u,f=0,a;b=b.replace(/NS\d+:/gi,"xlink:");b=zb(b);-1===b.indexOf("<image ")?k(b):(u=b.match(/<image [^\>]*\>/gi).length,b=b.replace(/<image [^\>]*\>/gi,function(z){z=z.replace(/(:href=")([^"]*)(")/gi,function(b,k,f,E){a=f;return k+"{{{"+h+"}}}"+E});var B=n.createElement("canvas"),P,G;P=B.getContext("2d");G=new pa;G.src=a;G.ind=h;G.onload=function(){B.width=this.width;B.height=
this.height;P.drawImage(this,0,0);var h=B.toDataURL("image/png");(new pa).src=h;b=b.replace(new RegExp("\\{\\{\\{"+G.ind+"\\}\\}\\}","g"),h);f++;u===f&&k(b)};h++;return z}))},b=function(b,k){pb(b,function(b){k("data:image/svg+xml;base64,"+m.btoa(m.unescape(encodeURIComponent('<?xml version="1.0" standalone="no"?><!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">'+b))))})},z=function(){var b,k,h,u,f,a,B,P;if(this&&this!==m){this.disposing=!0;if(b=this.components)for(h in b)if(k=
b[h],k instanceof Array)for(u=k.length,f=0;f<u;f++)(P=k[f])&&!this.disposing&&(P.dispose?P.dispose():z.call(P));else k&&!k.disposing&&(k.dispose?k.dispose():z.call(k));b=this.graphics;for(a in b)if(k=b[a])if(k.hide)k.hide(),k.followers&&k.followers[0]&&(k=k.followers[0].el)&&k.hide&&k.hide();else for(B in k)u=k[B],u.hide&&u.hide();for(h in this)delete this[h]}},B=function(b,k){return(b.pIndex||0)-(k.pIndex||0)},P={},G=Bb();G.hasCanvas=yb();G.hasSvg=A;g.registrars.component=function(b){var k,h,u,f,
a,z,B,G,c;if(b&&b.length&&b[0]&&b[0].toLowerCase&&(z=b[0].toLowerCase(),G=P[z]||(P[z]={}),b[1]&&b[1].toLowerCase)){z=b[1].toLowerCase();if(2==b.length){if("undefined"===typeof G[z])return}else{u=G[z]=G[z]||{constructor:function(){this.config={};this.__setDefaultConfig=function(){u&&u.defConfig&&ya(this.config,u.defConfig)};this.__setDefaultConfig()},defConfig:{}};f=u.constructor;c=u.defConfig;"undefined"!==typeof b[3]&&(B=b[3].toLowerCase(),h=G[B]);if(B&&h){k=new h.constructor;f.prototype=k;f.prototype.constructor=
f;B=b[2]||{};for(a in B)f.prototype[a]="undefined"!==typeof B[a]?B[a]:k[a];f.prototype.__base__=new h.constructor}else if(G[z])for(k in a=b[2],a)f.prototype[k]=a[k];else f.prototype=b[2],f.prototype.constructor=f;null!==b[5]&&("undefined"!==typeof b[5]&&(B=b[5].toLowerCase(),h=G[B]),h&&(h=h.defConfig,ya(c,h)));"undefined"!==typeof b[4]&&ya(c,b[4])}return G[z]&&G[z].constructor}};g.core._setLineHeightFactor=function(b){!(b=a(b))||0>b||(aa.lineHeightFactor=b)};aa.ColorRange=D=function(b){this.linkedItems=
{iapi:b};this.configure()};D.prototype={configure:function(){var b=this.linkedItems.iapi,k=b.jsonData,h=k.colorrange&&ya({},k.colorrange).color,k=K(L(Ka(k.chart.palette,0)-1,0),4),k=b.defaultPaletteOptions&&b.defaultPaletteOptions.paletteColors[k||0]||aa.defaultPaletteOptions.paletteColors[k||0],u=function(b,k){return b.minvalue-k.minvalue},f=b.components,a,z,B,P,G;delete this.defaultAsigned;k instanceof Array||(k=f.colorManager.getPlotColor(0));if(h&&0<h.length){for(z=B=h.length-1;0<=z;--z)if(b=
h[z])b.minvalue=f.numberFormatter.getCleanValue(b.minvalue),b.maxvalue=f.numberFormatter.getCleanValue(b.maxvalue),null===b.minvalue&&(null!==b.maxvalue?b.minvalue=b.maxvalue:z!==B&&h.splice(z,1)),void 0!==b.label&&(b.label=Ua(b.label)),void 0!==b.name&&(b.name=Ua(b.name)),null!==b.maxvalue&&b.minvalue>b.maxvalue&&(P=b.minvalue,b.minvalue=b.maxvalue,b.maxvalue=P);h.sort(u);h[0].code||(h[0].code=k[0]);void 0===ea(h[0].alpha)&&(h[0].alpha="100");z=0;for(B=h.length-1;z<B;z+=1)if(f=z+1,b=h[z],u=h[f],
u.code||(u.code=k[f]),void 0===ea(u.alpha)&&(u.alpha="100"),null===b.maxvalue&&(b.maxvalue=u.minvalue),b.maxvalue>u.minvalue){if(b.maxvalue>u.maxvalue){f=ya(b);f.maxvalue=b.maxvalue;G=f.minvalue=u.maxvalue;for(P=z+2;P<B&&h[P].minvalue<G;P+=1);h.splice(P,0,f);B+=1}b.maxvalue=u.minvalue}b=h[z];null===b.maxvalue&&(b.maxvalue=b.minvalue)}h&&0<h.length||(a||(a={code:"CCCCCC",alpha:"100",bordercolor:"000000",borderalpha:"100"}),h=[a],this.defaultAsigned=!0);this.colorArr=h},getColorObj:function(b){for(var k=
this.colorArr,h=0,u=k.length,f,a,z={};h<u;h+=1){z.index=h;f=k[h];a=k[h+1];if(b<f.minvalue)return z.nextObj=f,z;if(b>=f.minvalue&&b<=f.maxvalue)return z.colorObj=f,a&&b==a.minvalue&&(z.nextObj=a,z.isOnMeetPoint=!0),z;z.prevObj=f}z.index=h-1;return z},getColorRangeArr:function(b,k){var h,u=this.colorArr,f,a,z=[],B,P;if(!this.defaultAsigned&&(b>k&&(h=b,b=k,k=h),b<k&&(f=this.getColorObj(b),a=this.getColorObj(k),f&&a))){h=b;f=f.index;for(a=a.index;f<=a;f+=1)B=ya({},u[f]),B.minvalue!==h&&(B.minvalue=h),
z.push(B),P=B,h=B.maxvalue;P.maxvalue=k}return z}};D.prototype.constructor=D;aa.nonGradientColorRange=D=function(b){var k=b.sortLegend||!1,h=b.mapByCategory||!1,u=b.numberFormatter;b=(b.colorRange||{}).color;var f=this.colorArr=[],a,z,B,P,G,c,e=function(b,k){return b.maxvalue-k.maxvalue};this.mapByCategory=h;if(b&&(a=b.length)){for(z=0;z<a;z+=1)P=b[z],B=V(P.color,P.code),G=Ka(P.maxvalue),c=Ka(P.minvalue),P=V(P.label,P.displayvalue,h?"":u.dataLabels(c)+" - "+u.dataLabels(G)),(B&&G>c||h&&P)&&f.push({code:B,
maxvalue:G,minvalue:c,label:Ua(P),labelId:P.toLowerCase()});f.length?k&&f.sort(e):this.noValidRange=!0}};D.prototype={getColorObj:function(b){var k=this.colorArr,h=this.gradient?1:0,u=k[h],f;if(this.mapByCategory){for(b=Ua(b).toLowerCase();u;){if(u.labelId===b)return{code:u.code,seriesIndex:h};h+=1;u=k[h]}return{outOfRange:!0}}if(this.gradient){if(this.scaleMin<=b&&this.scaleMax>=b){for(;u&&u.maxvalue<b;)h+=1,u=k[h];b=(b-u.minvalue)/u.range;k=k[h-1].codeRGB;u=u.codeRGB;h=k[0];f=k[1];k=k[2];return{code:("000000"+
(h+(u[0]-h)*b<<16|f+(u[1]-f)*b<<8|k+(u[2]-k)*b).toString(16)).slice(-6)}}return{outOfRange:!0}}for(;u;){if(u.maxvalue>b&&u.minvalue<=b)return{code:u.code,seriesIndex:h};u.maxvalue===b&&(f=h);h+=1;u=k[h]}return(u=k[f])&&u.maxvalue===b?{code:u.code,seriesIndex:f}:{outOfRange:!0}}};D.prototype.constructor=D;g.extend(aa,{BLANKSTRINGPLACEHOLDER:"#BLANK#",BLANKSTRING:"",COLOR_BLACK:"000000",COLOR_GLASS:"rgba(255, 255, 255, 0.3)",COLOR_WHITE:"FFFFFF",COLOR_TRANSPARENT:"rgba(0,0,0,0)",HASHSTRING:"#",BREAKSTRING:"<br />",
STRINGSTRING:"string",OBJECTSTRING:"object",COMMASTRING:",",ZEROSTRING:"0",SAMPLESTRING:"Ay0",TESTSTR:"Ag",ONESTRING:"1",DECIMALSTRING:".",STRINGUNDEFINED:"undefined",POSITION_TOP:"top",POSITION_RIGHT:"right",POSITION_BOTTOM:"bottom",POSITION_LEFT:"left",POSITION_CENTER:"center",POSITION_MIDDLE:"middle",POSITION_START:"start",POSITION_END:"end",FC_CONFIG_STRING:"_FCconf",SHAPE_RECT:"rect",HUNDREDSTRING:"100",PXSTRING:"px",COMMASPACE:", ",TEXTANCHOR:"text-anchor",TOUCH_THRESHOLD_PIXELS:15,CLICK_THRESHOLD_PIXELS:5,
regex:{stripWhitespace:O,dropHash:d,startsRGBA:l,cleanColorCode:N,breakPlaceholder:ga,hexcode:/^#?[0-9a-f]{6}/i},fireEvent:function(b,k,h,u){aa.dem.fire(b,k,h,u)},plotEventHandler:function(b,k,h){k=k||{};var u=k.type,f=Ma(b.linkedItems.container,k),f=ya(f,this.data("eventArgs")),a=b.fireGroupEvent,z=this.data("groupId"),B=function(b,f){k.FusionChartsPreventEvent=!0;J&&f.toolText&&aa.toolTip&&aa.toolTip.preventTooltip()};"index"in f&&!("dataIndex"in f)&&(f.dataIndex=f.index);"value"in f&&!("dataValue"in
f)&&(f.dataValue=f.value);h=V(h,"dataplotclick").toLowerCase();"dataplotrollover"===h?(k.FusionChartsPreventEvent=!1,a?g.raiseEventGroup(z,h,f,b.chartInstance,void 0,void 0,B):g.raiseEvent(h,f,b.chartInstance,void 0,void 0,B)):a&&"dataplotclick"!==h?g.raiseEventGroup(z,h,f,b.chartInstance):g.raiseEvent(h,f,b.chartInstance);if(("click"===u||"mouseup"===u||"touchend"===u)&&/click/i.test(h)){if(T&&!ba){h=(new Date).getTime();if(this.lastClickTimeStamp&&400>h-this.lastClickTimeStamp){k&&(k.originalEvent||
k).preventDefault();return}this.lastClickTimeStamp=h}b.linkedItems&&b.linkedItems.linkClickFN.call({link:f.link},b)}},getEventCoordinate:Da,getMouseCoordinate:Ma,addEvent:va,removeEvent:nb,getTouchEvent:La,extend2:ya,deltend:function(b,k){if("object"!==typeof b||"object"!==typeof k)return null;Ia(b,k);return b},imprint:function(b,k,h){var u;if("object"!==typeof b||null===b)return k;if("object"!==typeof k||null===k)return b;for(u in k)if(void 0===b[u]||!h&&null===b[u])b[u]=k[u];return b},pluck:V,pluckNumber:Ka,
getFirstDefinedValue:function(){var b,k,h;k=0;for(h=arguments.length;k<h;k+=1)if((b=arguments[k])||!1===b||0===b||""==b)return b},createElement:Oa,hashify:Wa,dehashify:function(b){return b&&b.replace(/^#?([a-f0-9]+)/ig,"$1")||"none"},pluckFontSize:function(){var b,k,h;k=0;for(h=arguments.length;k<h;k+=1)if(((b=arguments[k])||!1===b||0===b)&&!isNaN(b=Number(b)))return 1>b?1:b;return 1},getValidValue:ea,getPosition:Ja,getViewPortDimension:za,bindSelectionEvent:function(b,k){k=k||{};var h=b.config,u=
b.linkedItems.container,f=h.zoomType,a=ya({},k.attr||{}),z=a["stroke-width"]=Ka(a.strokeWidth,a["stroke-width"],1),B=Ja(u),P=b.eventListeners||(b.eventListeners=[]);k=ya({chart:b,zoomX:/x/.test(f),zoomY:/y/.test(f),canvasY:h.canvasTop,canvasX:h.canvasLeft,canvasW:h.canvasWidth,canvasH:h.canvasHeight,canvasX2:h.canvasLeft+h.canvasWidth,canvasY2:h.canvasTop+h.canvasHeight,strokeWidth:z,chartPosLeft:B.left,chartPosTop:B.top,attr:a},k);a.stroke=ra(a.stroke,"rgba(51,153,255,0.8)");a.fill=ra(a.fill,"rgba(185,213,241,0.3)");
a.ishot=!0;u&&(nb(u,"pointerdrag",ia),P.push(va(u,"pointerdrag",ia,k)));h.link&&(nb(b.linkedItems.container,"mouseup mousedown",C),P.push(va(b.linkedItems.container,"mouseup mousedown",C,k)))},createContextMenu:function(b){var k=b.chart,h=k.smartLabel,u=k.logic.hcJSON&&k.logic.hcJSON.chart.useRoundEdges,f=aa.Raphael,a=function(b){var k=b.menufillcolor&&Wa(b.menufillcolor),f=b.menulabelcolor&&Wa(b.menulabelcolor),h=b.menufillhovercolor&&Wa(b.menufillhovercolor);b=b.menulabelhovercolor&&Wa(b.menulabelhovercolor);
return{attrs:{backgroundColor:k,color:f},hover:{backgroundColor:h,color:b}}}(k.definition.chart),z=function(b,k,h){k=k||{};b=(b=(b=b&&f.tintshade(b.color,.7))&&f.getRGB(b))&&"rgb("+[b.r,b.g,b.b].join()+")";return{backgroundColor:k.backgroundHoverColor||h.backgroundColor||b||"rgb(64, 64, 64)",color:k.hoverColor||h.color||"#FFFFFF"}}(b.basicStyle,b.hover,a.hover),B=function(b,k,f){k=ya({},k||{});k=ya(k,b);return{fontFamily:k.fontFamily||"Verdana,sans",fontSize:k.fontSize||"10px",color:k.color||f.color||
"#000000",backgroundColor:k.backgroundColor||f.backgroundColor||"rgb(255, 255, 255)"}}(b.basicStyle,b.attrs,a.attrs),P={textAlign:"left",align:"left",paddingLeft:"5px",paddingRight:"5px",paddingTop:"5px",cursor:"pointer",borderWidth:"0px"},G=b.items,c=b.position,e=b.verticalPadding||3,d=b.horizontalPadding||6,g={},V,l,q,t,p,m,C,va,v,r,H,w,ra;if(k)V=Ja(k.linkedItems.container);else return!1;t=function(){var b=g.items,k=b.length,f=0,E=0,a=0,z,G;g.menuItems||(g.menuItems=[]);for(h.setStyle(B);k--;)z=
b[k],z=h.getOriSize(z.text),a||(a=z.height+2*e),f+=a,E=L(E,z.width+2*d);g.height=f;g.width=E;g.itemH=a;this.style.width=E+"px";g.menuRect||(f=g.menuRect=n.createElement("div"),f.style.border="1px solid rgb(100, 100, 100)",u&&(f.style.mozBorderRadius="4px",f.style.webkitBorderRadius="4px",f.style.borderRadius="4px",f.style.overflow="hidden"),J&&!A?f.style.filter="progid:DXImageTransform.Microsoft.Shadow(Color=#999999,direction=135,strength=3)":(f.style.mozBoxShadow="3px 3px 3px #999",f.style.webkitBoxShadow=
"3px 3px 3px #999",f.style.boxShadow="3px 3px 3px #999"),this.appendChild(f));E=b.length;for(k=0;k<E;k+=1)if(z=b[k],g.menuItems[k])g.menuItems[k].label.innerHTML=z.text;else{g.menuItems[k]={};f=g.menuItems[k].box=n.createElement("div");f.style.height=a+"px";f.style.lineHeight=a+"px";for(G in P)f.style[G]=P[G];for(G in B)f.style[G]=B[G];g.menuRect.appendChild(f);f.innerHTML=z.text;aa.dem.listen(f,"click",ra);aa.dem.listen(f,"pointerhover",r);g.menuItems[k].box._itemIdx=k}for(;g.menuItems[k];)g.menuItems[k].box.parentNode.removeChild(g.menuItems[k].box),
g.menuItems.splice(k,1)};p=function(){q||(q=n.createElement("div"),q.style.position="absolute",q.style.zIndex="50",q.style.display="none",k.linkedItems.container.appendChild&&k.linkedItems.container.appendChild(q));return q};m=function(){l=setTimeout(g.hide,800)};C=function(){l&&clearTimeout(l)};va=function(b){var f=b.x;b=b.y;var h={x:f,y:b},E=g.width,u=g.height,a=k.chartHeight,z=k.chartWidth;f+E>z&&0<f-E?h.x-=E:f+E>z&&(h.x=0);b+u>a&&0<b-u&&(h.y-=u);return h};v=function(){g.hide()};r=function(b){b.target&&
b.target.parentNode&&("start"===b.state?H:w).call(b.target)};H=function(){var b=g.menuItems[this._itemIdx],k;C();for(k in z)b.box.style[k]=z[k]};w=function(){var b=g.menuItems[this._itemIdx],k;for(k in B)b.box.style[k]=B[k];m()};ra=function(b){var k=g.items[this._itemIdx];k.onclick&&k.onclick.call(k,b);b.originalEvent.stopPropagation?b.originalEvent.stopPropagation():b.originalEvent.cancelBubble=!0;g.hide()};g.showItem=function(b){b=this.menuItems[b];var k=this.height,f=this.itemH;b&&b._isHidden&&
(b.box.style.display="",this.height=k+f,b._isHidden=!1,b=va(c),this.left=b.x,this.top=b.y)};g.hideItem=function(b){b=this.menuItems[b];var k=this.height,f=this.itemH;b&&!b._isHidden&&(b.box.style.display="none",this.height=k-f,b._isHidden=!0,b=va(c),this.left=b.x,this.top=b.y)};g.redraw=function(){var b=this.menuContainer;this.items=G;b?t.call(this.menuContainer):c&&void 0!==c.x&&void 0!==c.y?(this.menuContainer=p(),t.call(this.menuContainer),b=va(c),this.left=b.x,this.top=b.y,this.menuContainer.style.left=
this.left+"px",this.menuContainer.style.top=this.top+"px"):(this.menuContainer=p(),t.call(this.menuContainer))};g.show=function(b){var k=this;b&&void 0!==b.x&&void 0!==b.y?(b=va(b),k.menuContainer.style.left=b.x+"px",k.menuContainer.style.top=b.y+"px"):(k.menuContainer.style.left=k.left+"px",k.menuContainer.style.top=k.top+"px");k.menuContainer.style.display="";setTimeout(function(){k.visible=!0;f.click(v)},400)};g.hide=function(){this.visible&&(this.visible=!1,g.menuContainer.style.display="none",
g.menuContainer.style.left=-g.width+"px",g.menuContainer.style.top=-g.height+"px",f.unclick(v))};g.update=function(b){b&&b.length&&(this.items=b,this.redraw())};g.updatePosition=function(b){var f=V.left,h=V.top;V=Ja(k.linkedItems.container);b?(c=b,b=va(b),this.left=b.x,this.top=b.y):(this.left-=f-V.left,this.top-=h-V.top)};g.add=function(b){var k=this.menuItems,f=k.length,E;h.setStyle(B);this.width=L(this.width,h.getOriSize(b.text).width);k[f]={};k=k[f].box=n.createElement("div");k.style.height=this.itemH+
"px";k.style.lineHeight=this.itemH+"px";for(E in P)k.style[E]=P[E];for(E in B)k.style[E]=B[E];g.menuRect.appendChild(k);k.innerHTML=b.text;aa.dem.listen(k,"click",ra);aa.dem.listen(k,"pointerhover",r);g.menuItems[f].box._itemIdx=f;this.height+=this.itemH};g.removeItems=function(){for(var b=this.menuItems,k=b&&b.length,f;k--;)f=b[k],aa.dem.unlisten(f.box,"click",ra),aa.dem.unlisten(f.box,"pointerhover",r),f.box&&f.box.parentNode&&f.box.parentNode.removeChild(f.box);delete this.menuItems;delete this.items};
g.setPosition=function(b){void 0!==b.x&&void 0!==b.y&&(this.menuContainer.style.x=b.x,this.menuContainer.style.y=b.y)};g.destroy=function(){this.removeItems();this.menuContainer.parentNode.removeChild(this.menuContainer)};G&&G.length&&(g.redraw(),g.hide());return g},each:function(b,k,h,u){var f;h||(h=b);u||(u={});if(Ga(b))for(f=0;f<b.length;f+=1){if(!1===k.call(h,b[f],f,b,u))return f}else if(null!==b&&void 0!==b)for(f in b)if(!1===k.call(h,b[f],f,b,u))return f},getDefinedColor:function(b,k){return b||
0===b||""===b?b:k},getFirstValue:ra,getFirstColor:Sa,getColorCodeString:function(b,k){var h="",u,f,a=0,z=k.split(",");for(f=z.length;a<f;a+=1)u=z[a].split("-"),h=2===u.length?"-1"!==u[0].indexOf("dark")?h+($a(b,100-parseInt(u[1],10))+","):h+(db(b,100-parseInt(u[1],10))+","):h+(z[a]+",");return h.substring(0,h.length-1)},pluckColor:function(b){if(ea(b))return b=b.split(",")[0],b=b.replace(O,""),""==b&&(b="000000"),b.replace(d,"#")},toRaphaelColor:cb,gradientify:Xa,trimString:function(b){b=b.replace(/^\s\s*/,
"");for(var k=/\s/,h=b.length;k.test(b.charAt(--h)););return b.slice(0,h+1)},getFirstAlpha:ka,parsePointValue:Pa,parseUnsafeString:Ua,parseTooltext:hb,toPrecision:function(b,k){var h=p(10,k);return c(b*h)/h},hasTouch:F,CREDIT_HREF:q,CREDIT_STRING:"FusionCharts XT Trial",getSentenceCase:function(b){b=b||"";return b.charAt(0).toUpperCase()+b.substr(1)},getCrispValues:function(b,k,h){var u=h%2/2;h=c(b+u)-u;b=c(b+k+u)-u-h;return{position:h,distance:b}},regescape:function(b){return b&&b.replace(/[\-\[\]{}()*+?.,\\\^$|#\s]/g,
"\\$&")},regReplaceEscape:na,getImageURL:Hb,isArray:Ga,preDefStr:{colors:{B90000:"B90000",FFFFFF:"FFFFFF",AAAAAA:"AAAAAA",c000000:"000000"},defaultFontStr:"Verdana,sans",line:"line",bar:"bar",column:"column",volume:"volume",HUNDREDSTRING:"100",SEVENTYSTRING:"70",NINETYSTRING:"90",AUTOSTRING:"auto",configStr:"config",animationObjStr:"animationObj",showHoverEffectStr:"showHoverEffect",hiddenStr:"hidden",visibleStr:"visible",columnStr:"columns",barStr:"bars",barHotStr:"bar-hot",colHotStr:"col-hot",shadowStr:"shadow",
dataLabelStr:"datalabel",errorBarStr:"errorBar",errorHotStr:"error-hot",errorShadowStr:"error-shadow",negativeValueStr:"negative-values",positiveValueStr:"positive-values",zeroPlaneStr:"zero-plane",categoryPlotsStr:"categoryplots",noneStr:"NONE",setRolloverAttrStr:"setRolloverAttr",setRolloutAttrStr:"setRolloutAttr",elementStr:"element",hotElementStr:"hotElement",strokeWidthStr:"stroke-width",strokeDashStr:"stroke-dasharray",strokeLineJoinStr:"stroke-linejoin",miterStr:"miter",visiblilityStr:"visibility",
ROUND:"round",PERCENTAGESTRING:"%",pStr:"p",sStr:"s",divLineAlpha3DStr:"divLineAlpha3D",divLineAlphaStr:"divLineAlpha",altVGridColorStr:"altVGridColor",altVGridAlphaStr:"altVGridAlpha",altHGridColorStr:"altHGridColor",altHGridAlphaStr:"altHGridAlpha",PLOTFILLCOLOR_STR:"plotFillColor",UNDERSCORE:"_",gaugeFillColorStr:"gaugeFillColor",gaugeBorderColorStr:"gaugeBorderColor",NORMAL:"normal",BOLD:"bold",POINTER:"pointer",POSITION_MIDDLE:"middle",POSITION_START:"start",POSITION_TOP:"top",POSITION_BOTTOM:"bottom",
POSITION_END:"end"},stubFN:function(){},falseFN:function(){return!1},stableSort:function(b,k){var h=b.length,u;for(u=0;u<h;u++)b[u].ssI=u;b.sort(function(b,h){var E=k(b,h);return 0===E?b.ssI-h.ssI:E});for(u=0;u<h;u++)delete b[u].ssI},hasSVG:A,CREDIT_REGEX:H,isIE:J,lineHeightFactor:1.2,getLinkAction:function(b,k){var h=function(b){return b};return function(u){var f=b.chart||b.map||{},a=Ka(f.unescapelinks,1),f=Ka(f.clickurloverridesplotlinks,0),z=ra(this.link,"");u=u.config&&u.config.link||"";var B=
f?V(u,z):V(z,u),P=B,G,c,e,d,l,q,t,p,C,va;void 0!==B&&(a&&(B=m.decodeURIComponent?m.decodeURIComponent(B):m.unescape(B)),B=B.replace(/^\s+/,"").replace(/\s+$/,""),-1!==B.search(/^[a-z]*\s*[\-\:]\s*/i)&&(l=B.split(/\s*[\-\:]\s*/)[0].toLowerCase(),va=l.length),setTimeout(function(){var f;switch(l){case "j":B=B.replace(/^j\s*\-/i,"j-");G=B.indexOf("-",2);-1===G?Za(B.slice(2)):Za(B.substr(2,G-2).replace(/\s/g,""),B.slice(G+1));break;case "javascript":wb(B.replace(/^javascript\s*\:/i,""));break;case "n":B.replace(/^n\s*\-/i,
"n-");m.open(h(B.slice(2),a));break;case "f":B=B.replace(/^f\s*\-/i,"f-");G=B.indexOf("-",2);-1!==G?(c=B.substr(2,G-2))&&m.frames[c]?m.frames[c].location=h(B.slice(G+1),a):m.open(h(B.slice(G+1),a),c):m.open(h(B.slice(2),a));break;case "p":B=B.replace(/p\s*\-/i,"p-");G=B.indexOf("-",2);e=B.indexOf(",",2);-1===G&&(G=1);d=h(B.slice(G+1),a);(f=m.open(d,B.substr(2,e-2),B.substr(e+1,G-e-1)))&&f.focus();break;case "newchart":case "newmap":":"===B.charAt(va)&&(G=B.indexOf("-",va+1),C=B.substring(va+1,G),
va=G);G=B.indexOf("-",va+1);q=B.substring(va+1,G).toLowerCase();switch(q){case "xmlurl":case "jsonurl":p=B.substring(G+1,B.length);break;case "xml":case "json":f=t=B.substring(G+1,B.length);var u={chart:{}},z;f=f.toLowerCase();if(b.linkeddata)for(z=0;z<b.linkeddata.length;z+=1)b.linkeddata[z].id.toLowerCase()===f&&(u=b.linkeddata[z].linkedchart||b.linkeddata[z].linkedmap);p=u;q="json"}g.raiseEvent("linkedChartInvoked",{alias:C,linkType:q.toUpperCase(),data:p},k);break;default:m.location.href=B}g.raiseEvent("linkClicked",
{linkProvided:P,linkInvoked:B,linkAction:l&&l.toLowerCase()},k)},0))}},graphics:{parseAlpha:Ob,convertColor:kb,getDarkColor:db,getLightColor:$a,mapSymbolName:function(b,k){var h="circle";b=Pa(b);3<=b&&(h=(k?"spoke_":"poly_")+b);return h},getColumnColor:function(b,k,h,u,f,a,z,B,P){var G,c;G=b.split(",");c=k.split(",");a=a.split(",");z=z.split(",");b=b.replace(/\s/g,"").replace(/\,$/,"");P?B={FCcolor:{color:G[0],alpha:c[0]}}:f?(b=G[0],c=c[0],B={FCcolor:{color:db(b,75)+","+$a(b,10)+","+db(b,90)+","+
$a(b,55)+","+db(b,80),alpha:c+","+c+","+c+","+c+","+c,ratio:"0,11,14,57,18",angle:B?"90":"0"}},a=[db(b,70)]):(k=Ob(k,G.length),B={FCcolor:{color:b,alpha:k,ratio:h,angle:B?-u:u}});return[B,{FCcolor:{color:a[0],alpha:z[0]}}]},getPointColor:function(b,k){var h,u;b=Sa(b);k=ka(k);h=$a(b,70);u=db(b,50);return{FCcolor:{gradientUnits:"objectBoundingBox",cx:.4,cy:.4,r:"100%",color:h+","+u,alpha:k+","+k,ratio:void 0,radialGradient:!0}}},getAngle:function(b,k,h){b=180*Math.atan(k/b)/Math.PI;2==h?b=180-b:3==
h?b+=180:4==h&&(b=360-b);return b},parseColor:lb,getValidColor:function(b){return w.test(lb(b))&&b},HSBtoRGB:function(b){var k=b[0],h=0,u=0,f=0,a=[],a=b[1]/100;b=b[2]/100;var z=k/60-Math.floor(k/60),B=b*(1-a),G=b*(1-z*a),a=b*(1-(1-z)*a);switch(Math.floor(k/60)%6){case 0:h=b;u=a;f=B;break;case 1:h=G;u=b;f=B;break;case 2:h=B;u=b;f=a;break;case 3:h=B;u=G;f=b;break;case 4:h=a;u=B;f=b;break;case 5:h=b,u=B,f=G}return a=[c(255*h),c(255*u),c(255*f)]},RGBtoHSB:function(b){var k=b[0],h=b[1];b=b[2];var u=Math.max(Math.max(k,
h),b),f=Math.min(Math.min(k,h),b),a=0,z=0;u==f?a=0:u==k?a=(60*(h-b)/(u-f)+360)%360:u==h?a=60*(b-k)/(u-f)+120:u==b&&(a=60*(k-h)/(u-f)+240);z=0===u?0:(u-f)/u;return[c(a),c(100*z),c(u/255*100)]},RGBtoHex:function(b){return("000000"+(b[0]<<16|b[1]<<8|b[2]).toString(16)).slice(-6)},rawRGBtoHEX:function(b){b=b.match(/[\d+]+/g).splice(0,3);return("000000"+(b[0]<<16|b[1]<<8|b[2]).toString(16)).slice(-6)},HEXtoRGB:sb,getCubePathOutline:function(b){var k=b[2]||0,h=b[4]||0,u=b[5]||0;return["M",b[0]||0,b[1]||
0,"l",h,-u,k,0,0,b[3]||0,-h,u,-k,0,"Z"]}},appliedCSS:["fontFamily","fontSize","fontWeight","fontStyle"],setImageDisplayMode:function(b,k,h,u,f,a,z,B){var G=u/100*B.width;u=u/100*B.height;B={};var P,c=a-2*f;P=z-2*f;var e=function(b,k,h,u,E,a){var z={};switch(b){case "top":z.y=f;break;case "bottom":z.y=a-u-f;break;case "middle":z.y=(a-u)/2}switch(k){case "left":z.x=f;break;case "right":z.x=E-h-f;break;case "middle":z.x=(E-h)/2}return z};switch(b){case "center":B.width=G;B.height=u;B.y=z/2-u/2;B.x=a/
2-G/2;break;case "stretch":B.width=a-2*f;B.height=z-2*f;B.y=f;B.x=f;break;case "tile":B.width=G;B.height=u;B.tileInfo={};B.tileInfo.xCount=b=Math.ceil(c/G);B.tileInfo.yCount=P=Math.ceil(P/u);k=e(k,h,G*b,u*P,a,z);B.y=k.y;B.x=k.x;break;case "fit":b=G/u>c/P?c/G:P/u;B.width=G*b;B.height=u*b;k=e(k,h,B.width,B.height,a,z);B.y=k.y;B.x=k.x;break;case "fill":b=G/u>c/P?P/u:c/G;B.width=G*b;B.height=u*b;k=e(k,h,B.width,B.height,a,z);B.y=k.y;B.x=k.x;break;default:k=e(k,h,G,u,a,z),B.width=G,B.height=u,B.y=k.y,
B.x=k.x}return B},setLineHeight:tb,parsexAxisStyles:gb,supportedStyle:{font:"font",fontFamily:"font-family","font-family":"font-family",fontWeight:"font-weight","font-weight":"font-weight",fontSize:"font-size","font-size":"font-size",lineHeight:"line-height","line-height":"line-height",textDecoration:"text-decoration","text-decoration":"text-decoration",color:"color",whiteSpace:"white-space","white-space":"white-space",padding:"padding",margin:"margin",background:"background",backgroundColor:"background-color",
"background-color":"background-color",backgroundImage:"background-image","background-image":"background-image",backgroundPosition:"background-position","background-position":"background-position",backgroundPositionLeft:"background-position-left","background-position-left":"background-position-left",backgroundPositionTop:"background-position-top","background-position-top":"background-position-top",backgroundRepeat:"background-repeat","background-repeat":"background-repeat",border:"border",borderColor:"border-color",
"border-color":"border-color",borderStyle:"border-style","border-style":"border-style",borderThickness:"border-thickness","border-thickness":"border-thickness",borderTop:"border-top","border-top":"border-top",borderTopColor:"border-top-color","border-top-color":"border-top-color",borderTopStyle:"border-top-style","border-top-style":"border-top-style",borderTopThickness:"border-top-thickness","border-top-thickness":"border-top-thickness",borderRight:"border-right","border-right":"border-right",borderRightColor:"border-right-color",
"border-right-color":"border-right-color",borderRightStyle:"border-right-style","border-right-style":"border-right-style",borderRightThickness:"border-right-thickness","border-right-thickness":"border-right-thickness",borderBottom:"border-bottom","border-bottom":"border-bottom",borderBottomColor:"border-bottom-color","border-bottom-color":"border-bottom-color",borderBottomStyle:"border-bottom-style","border-bottom-style":"border-bottom-style",borderBottomThickness:"border-bottom-thickness","border-bottom-thickness":"border-bottom-thickness",
borderLeft:"border-left","border-left":"border-left",borderLeftColor:"border-left-color","border-left-color":"border-left-color",borderLeftStyle:"border-left-style","border-left-Style":"border-left-style",borderLeftThickness:"border-left-thickness","border-left-thickness":"border-left-thickness"},getAxisLimits:vb,createTrendLine:Va,getDashStyle:Ea,axisLabelAdder:Qa,chartAPI:xb,createDialog:jb,isCanvasElemSupported:yb,componentDispose:z,componentConfigurer:function(b){var k,h,u=[],f,a,z,G={};b=b||
this;k=b.components;for(z in k)if(h=k[z],h instanceof Array)for(a=h.length,f=0;f<a;f+=1)u.push(h[f]);else u.push(h);u.sort(B);a=u.length;for(f=0;f<a;f+=1)h=u[f],k=h.customConfigFn,null!==k&&(k&&b[k]?G[k]||(b[k](),G[k]=!0):h.configure&&h.configure())},getSvgDataurl:b,removeCrossDomainImages:zb,getBrowserDetails:Bb,dataurlToBlob:fb,downloadCharts:function(b,k,h,u,f){k?ib(b,k,h):ob(u,f)},browserDetails:G,drawSvgOnCanvas:function(E,k,h,u,f,a,z){"ie"==G.name?(E=zb(E),new I(E,k,h,u,f,a,function(){z()})):
b(E,function(b){var E,B;E=k.getContext("2d");B=new pa;B.src=b;B.onload=function(){E.drawImage(B,h,u,f,a);z()}})},priorityList:{render:1,animation:2,entitydraw:2,label:3,tracker:4,kdTree:4}})}]);FusionCharts.register("module",["private","modules.renderer.js-schedular",function(){var g=[],m={},D=[],n={},F=0,A=this.window,J=this.hcLib.schedular={},a=A.requestAnimationFrame||A.webkitRequestAnimationFrame||A.mozRequestAnimationFrame||A.oRequestAnimationFrame||A.msRequestAnimationFrame||function(a){setTimeout(a,
16)},O=function(){for(var d,l=!1;!l;)(d=g[0])?(g.splice(0,1),--D[d.priority],0<g.length&&a(O),n[d.jobID]&&!d.executed&&(l=!0,d.scope?d.job.apply(d.scope,d.args):d.job(),d.callback&&"function"===typeof d.callback&&d.callback(),d.executed=!0,delete n[d.jobID])):l=!0};J.addJob=function(d,l,m,A,w,r){var p,c=0;w=w?A-1:A;"function"===typeof d&&(p="JOB"+ ++F+(A||1),d={job:d,scope:l,args:m,priority:A,callback:r,jobID:p});for(l=0;l<=w;l++)c+=D[l]||0;g.splice(c,0,d);n[p]=d;D[A]=(D[A]||0)+1;1===g.length&&a(O);
return p};J.removeJob=function(a){n[a]&&delete n[a]};J.pauseExecution=function(a){if(n[a])m[n[a]]=n[a],delete n[a];else return!1};J.resumeExecution=function(a){var g;if(g=m[a])J.addJob(g),delete m[a];else return!1}}]);FusionCharts&&FusionCharts.register("module",["private","vendor.redraphael",function(){var g=this.hcLib,m=this.window,D=m.Raphael,n;(function(m){(function(g,m){var a=/[\.\/]/,n=function(){},d=function(a,d){return a-d},l,F,D={n:{}},w=function(a,g){a=String(a);var c=F,m=Array.prototype.slice.call(arguments,
2),n=w.listeners(a),e=0,q,H=[],t={},L=[],K=l;l=a;for(var A=F=0,D=n.length;A<D;A++)"zIndex"in n[A]&&(H.push(n[A].zIndex),0>n[A].zIndex&&(t[n[A].zIndex]=n[A]));for(H.sort(d);0>H[e];)if(q=t[H[e++]],L.push(q.apply(g,m)),F)return F=c,L;for(A=0;A<D;A++)if(q=n[A],"zIndex"in q)if(q.zIndex==H[e]){L.push(q.apply(g,m));if(F)break;do if(e++,(q=t[H[e]])&&L.push(q.apply(g,m)),F)break;while(q)}else t[q.zIndex]=q;else if(L.push(q.apply(g,m)),F)break;F=c;l=K;return L.length?L:null};w._events=D;w.listeners=function(d){d=
d.split(a);var g=D,c,l,m,e,q,H,t,n=[g],w=[];m=0;for(e=d.length;m<e;m++){t=[];q=0;for(H=n.length;q<H;q++)for(g=n[q].n,c=[g[d[m]],g["*"]],l=2;l--;)if(g=c[l])t.push(g),w=w.concat(g.f||[]);n=t}return w};w.on=function(d,g){d=String(d);if("function"!=typeof g)return function(){};for(var c=d.split(a),l=D,m=0,e=c.length;m<e;m++)l=l.n,l=l.hasOwnProperty(c[m])&&l[c[m]]||(l[c[m]]={n:{}});l.f=l.f||[];m=0;for(e=l.f.length;m<e;m++)if(l.f[m]==g)return n;l.f.push(g);return function(a){+a==+a&&(g.zIndex=+a)}};w.f=
function(a){var d=[].slice.call(arguments,1);return function(){w.apply(null,[a,null].concat(d).concat([].slice.call(arguments,0)))}};w.stop=function(){F=1};w.nt=function(a){return a?(new RegExp("(?:\\.|\\/|^)"+a+"(?:\\.|\\/|$)")).test(l):l};w.nts=function(){return l.split(a)};w.off=w.unbind=function(d,g){if(d){var c=d.split(a),l,m,e,q,n,t,L=[D];q=0;for(n=c.length;q<n;q++)for(t=0;t<L.length;t+=e.length-2){e=[t,1];l=L[t].n;if("*"!=c[q])l[c[q]]&&e.push(l[c[q]]);else for(m in l)l.hasOwnProperty(m)&&e.push(l[m]);
L.splice.apply(L,e)}q=0;for(n=L.length;q<n;q++)for(l=L[q];l.n;){if(g){if(l.f){t=0;for(c=l.f.length;t<c;t++)if(l.f[t]==g){l.f.splice(t,1);break}!l.f.length&&delete l.f}for(m in l.n)if(l.n.hasOwnProperty(m)&&l.n[m].f){e=l.n[m].f;t=0;for(c=e.length;t<c;t++)if(e[t]==g){e.splice(t,1);break}!e.length&&delete l.n[m].f}}else for(m in delete l.f,l.n)l.n.hasOwnProperty(m)&&l.n[m].f&&delete l.n[m].f;l=l.n}}else w._events=D={n:{}}};w.once=function(a,d){var c=function(){w.unbind(a,c);return d.apply(this,arguments)};
return w.on(a,c)};w.version="0.4.2";w.toString=function(){return"You are running Eve 0.4.2"};"undefined"!=typeof module&&module.exports?module.exports=w:m||"undefined"==typeof define?g.eve=w:define("eve",[],function(){return w})})(this,!0);"undefined"===typeof m&&"object"===typeof window&&(m=window);(function(g,m,a){!a&&"function"===typeof define&&define.amd?define(["eve"],function(a){return m(g,a)}):m(g,"object"===typeof module&&"undefined"!==typeof module.exports?module.exports:g.eve)})(m,function(g,
D){function a(b){var k,f;void 0===a._url&&(a._url="");if(a.is(b,"function"))return e?b():D.on("raphael.DOMload",b);if(a.is(b,t))return a._engine.create[q](a,b.splice(0,3+a.is(b[0],H))).add(b);k=Array.prototype.slice.call(arguments,0);return a.is(k[k.length-1],"function")?(f=k.pop(),e?f.call(a._engine.create[q](a,k)):D.on("raphael.DOMload",function(){f.call(a._engine.create[q](a,k))})):a._engine.create[q](a,arguments)}function O(){return this.hex}function d(b,k){for(var f=[],h=0,u=b.length;u-2*!k>
h;h+=2){var E=[{x:+b[h-2],y:+b[h-1]},{x:+b[h],y:+b[h+1]},{x:+b[h+2],y:+b[h+3]},{x:+b[h+4],y:+b[h+5]}];k?h?u-4==h?E[3]={x:+b[0],y:+b[1]}:u-2==h&&(E[2]={x:+b[0],y:+b[1]},E[3]={x:+b[2],y:+b[3]}):E[0]={x:+b[u-2],y:+b[u-1]}:u-4==h?E[3]=E[2]:h||(E[0]={x:+b[h],y:+b[h+1]});f.push(["C",(-E[0].x+6*E[1].x+E[2].x)/6,(-E[0].y+6*E[1].y+E[2].y)/6,(E[1].x+6*E[2].x-E[3].x)/6,(E[1].y+6*E[2].y-E[3].y)/6,E[2].x,E[2].y])}return f}function l(b,k,f,h,u,E,a,z,B){null==B&&(B=1);B=(1<B?1:0>B?0:B)/2;for(var G=[-.1252,.1252,
-.3678,.3678,-.5873,.5873,-.7699,.7699,-.9041,.9041,-.9816,.9816],P=[.2491,.2491,.2335,.2335,.2032,.2032,.1601,.1601,.1069,.1069,.0472,.0472],Y=0,xa=0;12>xa;xa++)var c=B*G[xa]+B,e=c*(c*(-3*b+9*f-9*u+3*a)+6*b-12*f+6*u)-3*b+3*f,c=c*(c*(-3*k+9*h-9*E+3*z)+6*k-12*h+6*E)-3*k+3*h,Y=Y+P[xa]*mb(e*e+c*c);return B*Y}function N(b,k,f,h,u,E,a,z,B){if(!(0>B||l(b,k,f,h,u,E,a,z)<B)){var G=.5,P=1-G,Y;for(Y=l(b,k,f,h,u,E,a,z,P);.01<Pa(Y-B);)G/=2,P+=(Y<B?1:-1)*G,Y=l(b,k,f,h,u,E,a,z,P);return P}}function ga(b,k,f){b=
a._path2curve(b);k=a._path2curve(k);for(var h,u,E,z,B,G,P,Y,xa,c,e=f?0:[],Fa=0,wa=b.length;Fa<wa;Fa++)if(xa=b[Fa],"M"==xa[0])h=B=xa[1],u=G=xa[2];else{"C"==xa[0]?(xa=[h,u].concat(xa.slice(1)),h=xa[6],u=xa[7]):(xa=[h,u,h,u,B,G,B,G],h=B,u=G);for(var d=0,g=k.length;d<g;d++)if(c=k[d],"M"==c[0])E=P=c[1],z=Y=c[2];else{"C"==c[0]?(c=[E,z].concat(c.slice(1)),E=c[6],z=c[7]):(c=[E,z,E,z,P,Y,P,Y],E=P,z=Y);var ta;var V=xa,Ca=c;ta=f;var q=a.bezierBBox(V),t=a.bezierBBox(Ca);if(a.isBBoxIntersect(q,t)){for(var q=l.apply(0,
V),t=l.apply(0,Ca),q=Wa(~~(q/5),1),t=Wa(~~(t/5),1),qb=[],p=[],Ya={},m=ta?0:[],rb=0;rb<q+1;rb++){var C=a.findDotsAtSegment.apply(a,V.concat(rb/q));qb.push({x:C.x,y:C.y,t:rb/q})}for(rb=0;rb<t+1;rb++)C=a.findDotsAtSegment.apply(a,Ca.concat(rb/t)),p.push({x:C.x,y:C.y,t:rb/t});for(rb=0;rb<q;rb++)for(V=0;V<t;V++){var bb=qb[rb],va=qb[rb+1],Ca=p[V],C=p[V+1],Rb=.001>Pa(va.x-bb.x)?"y":"x",Ib=.001>Pa(C.x-Ca.x)?"y":"x",Cb;Cb=bb.x;var Gb=bb.y,r=va.x,v=va.y,n=Ca.x,Q=Ca.y,w=C.x,H=C.y;if(Wa(Cb,r)<Ka(n,w)||Ka(Cb,
r)>Wa(n,w)||Wa(Gb,v)<Ka(Q,H)||Ka(Gb,v)>Wa(Q,H))Cb=void 0;else{var R=(Cb*v-Gb*r)*(n-w)-(Cb-r)*(n*H-Q*w),ra=(Cb*v-Gb*r)*(Q-H)-(Gb-v)*(n*H-Q*w),K=(Cb-r)*(Q-H)-(Gb-v)*(n-w);if(K){var R=R/K,ra=ra/K,K=+R.toFixed(2),Kb=+ra.toFixed(2);Cb=K<+Ka(Cb,r).toFixed(2)||K>+Wa(Cb,r).toFixed(2)||K<+Ka(n,w).toFixed(2)||K>+Wa(n,w).toFixed(2)||Kb<+Ka(Gb,v).toFixed(2)||Kb>+Wa(Gb,v).toFixed(2)||Kb<+Ka(Q,H).toFixed(2)||Kb>+Wa(Q,H).toFixed(2)?void 0:{x:R,y:ra}}else Cb=void 0}Cb&&Ya[Cb.x.toFixed(4)]!=Cb.y.toFixed(4)&&(Ya[Cb.x.toFixed(4)]=
Cb.y.toFixed(4),bb=bb.t+Pa((Cb[Rb]-bb[Rb])/(va[Rb]-bb[Rb]))*(va.t-bb.t),Ca=Ca.t+Pa((Cb[Ib]-Ca[Ib])/(C[Ib]-Ca[Ib]))*(C.t-Ca.t),0<=bb&&1.001>=bb&&0<=Ca&&1.001>=Ca&&(ta?m++:m.push({x:Cb.x,y:Cb.y,t1:Ka(bb,1),t2:Ka(Ca,1)})))}ta=m}else ta=ta?0:[];if(f)e+=ta;else{q=0;for(t=ta.length;q<t;q++)ta[q].segment1=Fa,ta[q].segment2=d,ta[q].bez1=xa,ta[q].bez2=c;e=e.concat(ta)}}}return e}function w(b,k,f,h,u,E){null!=b?(this.a=+b,this.b=+k,this.c=+f,this.d=+h,this.e=+u,this.f=+E):(this.a=1,this.c=this.b=0,this.d=1,
this.f=this.e=0)}function r(){return this.x+" "+this.y+" "+this.width+" × "+this.height}function p(b,k,f,h,u,E){function a(b,k){var f,h,u,E;u=b;for(h=0;8>h;h++){E=((G*u+B)*u+z)*u-b;if(Pa(E)<k)return u;f=(3*G*u+2*B)*u+z;if(1E-6>Pa(f))break;u-=E/f}f=0;h=1;u=b;if(u<f)return f;if(u>h)return h;for(;f<h;){E=((G*u+B)*u+z)*u;if(Pa(E-b)<k)break;b>E?f=u:h=u;u=(h-f)/2+f}return u}var z=3*k,B=3*(h-k)-z,G=1-z-B,P=3*f,Y=3*(u-f)-P,xa=1-P-Y;return function(b,k){var f=a(b,k);return((xa*f+Y)*f+P)*f}(b,1/(200*E))}function c(b,
k){var f=[],h={};this.ms=k;this.times=1;if(b){for(var u in b)b.hasOwnProperty(u)&&(h[Da(u)]=b[u],f.push(Da(u)));f.sort(ab)}this.anim=h;this.top=f[f.length-1];this.percents=f}function v(b,k,f,h,u,E,z){f=Da(f);var B,G,P,Y,xa,c,e,Fa=b.ms,wa={},d={},g={};if(h)for(ta=0,V=la.length;ta<V;ta++){if(c=la[ta],c.el.id==k.id&&c.anim==b){c.percent!=f?(delete c.el.e,delete c.el,la.splice(ta,1),P=1):G=c;k.attr(c.totalOrigin);break}}else h=+d;for(var ta=0,V=b.percents.length;ta<V;ta++)if(b.percents[ta]==f||b.percents[ta]>
h*b.top){f=b.percents[ta];xa=b.percents[ta-1]||0;Fa=Fa/b.top*(f-xa);Y=b.percents[ta+1];B=b.anim[f];break}else h&&k.attr(b.anim[b.percents[ta]]);if(B){if(G)G.initstatus=h,G.start=new Date-G.ms*h;else{for(var Ca in B)if(B.hasOwnProperty(Ca))if(vb.hasOwnProperty(Ca)||k.ca[Ca]){wa[Ca]=k.attr(Ca);null==wa[Ca]&&(wa[Ca]=Qa[Ca]);d[Ca]=B[Ca];c=!1;switch(vb[Ca]){case H:((e=d[Ca]-wa[Ca])||isNaN(e))&&(c=!0);g[Ca]=e/Fa;break;case "colour":wa[Ca]=a.getRGB(wa[Ca]);ta=a.getRGB(d[Ca]);e={};e.r=ta.r-wa[Ca].r;e.g=ta.g-
wa[Ca].g;e.b=ta.b-wa[Ca].b;(e.r||e.g||e.b)&&(c=!0);g[Ca]={r:e.r/Fa,g:e.g/Fa,b:e.b/Fa};break;case "path":var l;if((wa[Ca].join?wa[Ca].join():wa[Ca])===(d[Ca].join?d[Ca].join():d[Ca])){c=!1;break}e=Ya(wa[Ca],d[Ca]);l=e[1];c=!0;wa[Ca]=e[0];g[Ca]=[];ta=0;for(V=wa[Ca].length;ta<V;ta++){g[Ca][ta]=[0];for(var q=1,t=wa[Ca][ta].length;q<t;q++)e=l[ta][q]-wa[Ca][ta][q],g[Ca][ta][q]=e/Fa}break;case "transform":e=k._;ta=Gb(e[Ca],d[Ca]);c=!0;if(ta)for(wa[Ca]=ta.from,d[Ca]=ta.to,g[Ca]=[],g[Ca].real=!0,ta=0,V=wa[Ca].length;ta<
V;ta++)for(g[Ca][ta]=[wa[Ca][ta][0]],q=1,t=wa[Ca][ta].length;q<t;q++)g[Ca][ta][q]=(d[Ca][ta][q]-wa[Ca][ta][q])/Fa;else ta=k.matrix||new w,e={_:{transform:e.transform},getBBox:function(){return k.getBBox(1)}},wa[Ca]=[ta.a,ta.b,ta.c,ta.d,ta.e,ta.f],bb(e,d[Ca]),d[Ca]=e._.transform,g[Ca]=[(e.matrix.a-ta.a)/Fa,(e.matrix.b-ta.b)/Fa,(e.matrix.c-ta.c)/Fa,(e.matrix.d-ta.d)/Fa,(e.matrix.e-ta.e)/Fa,(e.matrix.f-ta.f)/Fa];break;case "csv":V=La(B[Ca]).split(Eb);l=La(wa[Ca]).split(Eb);if("clip-rect"==Ca)for(wa[Ca]=
l,g[Ca]=[],ta=l.length;ta--;)((e=V[ta]-wa[Ca][ta])||isNaN(e))&&(c=!0),g[Ca][ta]=e/Fa;d[Ca]=V;break;default:for(V=[].concat(B[Ca]),l=[].concat(wa[Ca]),g[Ca]=[],ta=k.ca[Ca].length;ta--;)((e=(V[ta]||0)-(l[ta]||0))||isNaN(e))&&(c=!0),g[Ca][ta]=e/Fa}c||(delete wa[Ca],delete d[Ca],delete B[Ca],delete g[Ca])}else if(a._availableAttrs.hasOwnProperty(Ca)||"text"===Ca||k.ca[Ca])k.attr(Ca,B[Ca]),delete B[Ca];c=B.easing;Ca=a.easing_formulas[c];if(!Ca)if((Ca=La(c).match(cb))&&5==Ca.length){var qb=Ca;Ca=function(b){return p(b,
+qb[1],+qb[2],+qb[3],+qb[4],Fa)}}else Ca=Ea;c=B.start||b.start||+new Date;k.e=c={anim:b,percent:f,timestamp:c,start:c+(b.del||0),status:0,initstatus:h||0,stop:!1,ms:Fa,easing:Ca,from:wa,diff:g,to:d,el:k,callback:B.callback,prev:xa,next:Y,repeat:E||b.times,origin:k.attr(),totalOrigin:u,parentEl:z};la.push(c);if(h&&!G&&!P&&(c.stop=!0,c.start=new Date-Fa*h,1==la.length))return $b();P&&(c.start=new Date-c.ms*h);1==la.length&&(oa||ec())($b)}!1!==a.stopEvent&&D("raphael.anim.start."+k.id,k,b)}}function M(b){for(var k=
0;k<la.length;k++)la[k].el.paper==b&&la.splice(k--,1)}a.upgrade="1.0.0";a.version="2.1.0";a.eve=D;n=a;var e,q="apply",H="number",t="array",L=Array.prototype.slice,K=Array.prototype.splice,pa=Array.prototype.shift,S=function(){return function(){}.hasOwnProperty("prototype")}(),T={doc:g.document,win:g},ba=Object.prototype.hasOwnProperty.call(T.win,"Raphael"),aa=T.win.Raphael,I=T.doc,ia=T.win,C=a.supportsTouch="createTouch"in I,za=a.supportsOnlyTouch=C&&!(ia.navigator.maxTouchPoints||ia.navigator.msMaxTouchPoints),
Ja=function(){};a.ca=a.customAttributes=Ja.prototype;var na=function(){this.ca=this.customAttributes=new Ja;this._CustomAttributes=function(){};this._CustomAttributes.prototype=this.ca;this._elementsById={};this.id=a._oid++;D("raphael.new",this)},ea=a.fn=na.prototype=a.prototype,ra={circle:1,rect:1,path:1,ellipse:1,text:1,image:1,group:1},V="click dblclick mousedown mousemove mouseout mouseover mouseup touchstart touchmove touchend touchcancel dragstart dragmove dragend".split(" "),va=a._touchMap=
{mousedown:"touchstart",mousemove:"touchmove",mouseup:"touchend"},nb=a._dragEventMap={dragstart:"mousedown",dragmove:"mousemove",dragend:"mouseup"},La=String,Da=ia.parseFloat,Ma=ia.parseInt,Oa=Math,Wa=Oa.max,Ka=Oa.min,Pa=Oa.abs,Ua=Oa.pow,Sa=Oa.cos,ka=Oa.sin,mb=Oa.sqrt,Ga=Oa.round,Na=Oa.PI,ya=Na/180,Ia=180/Na,Za=La.prototype.toLowerCase,wb=La.prototype.toUpperCase,Hb=Object.prototype.toString,Eb=/[, ]+/,Ob=/\{(\d+)\}/g;a._ISURL=/^url\(['"]?([^\)]+?)['"]?\)$/i;var kb=/^\s*((#[a-f\d]{6})|(#[a-f\d]{3})|rgba?\(\s*([\d\.]+%?\s*,\s*[\d\.]+%?\s*,\s*[\d\.]+%?(?:\s*,\s*[\d\.]+%?)?)\s*\)|hsba?\(\s*([\d\.]+(?:deg|\xb0|%)?\s*,\s*[\d\.]+%?\s*,\s*[\d\.]+(?:%?\s*,\s*[\d\.]+)?)%?\s*\)|hsla?\(\s*([\d\.]+(?:deg|\xb0|%)?\s*,\s*[\d\.]+%?\s*,\s*[\d\.]+(?:%?\s*,\s*[\d\.]+)?)%?\s*\))\s*$/i,
cb=/^(?:cubic-)?bezier\(([^,]+),([^,]+),([^,]+),([^\)]+)\)/,Xa=/[\x09\x0a\x0b\x0c\x0d\x20\xa0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\u2028\u2029]*,[\x09\x0a\x0b\x0c\x0d\x20\xa0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\u2028\u2029]*/,lb=/,?([achlmqrstvxz]),?/gi,db=/([achlmrqstvz])[\x09\x0a\x0b\x0c\x0d\x20\xa0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\u2028\u2029,]*((-?\d*\.?\d*(?:e[\-+]?\d+)?[\x09\x0a\x0b\x0c\x0d\x20\xa0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\u2028\u2029]*,?[\x09\x0a\x0b\x0c\x0d\x20\xa0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\u2028\u2029]*)+)/ig,
$a=/([rstm])[\x09\x0a\x0b\x0c\x0d\x20\xa0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\u2028\u2029,]*((-?\d*\.?\d*(?:e[\-+]?\d+)?[\x09\x0a\x0b\x0c\x0d\x20\xa0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\u2028\u2029]*,?[\x09\x0a\x0b\x0c\x0d\x20\xa0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\u2028\u2029]*)+)/ig,sb=/(-?\d*\.?\d*(?:e[\-+]?\d+)?)[\x09\x0a\x0b\x0c\x0d\x20\xa0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\u2028\u2029]*,?[\x09\x0a\x0b\x0c\x0d\x20\xa0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\u2028\u2029]*/ig;
a._radial_gradient=/^x?r(?:\(([^\)]*?)\))?/;var tb={NaN:1,Infinity:1,"-Infinity":1},gb={hs:1,rg:1},Qa=a._availableAttrs={"arrow-end":"none","arrow-start":"none",blur:0,"clip-rect":"0 0 1e9 1e9","clip-path":"",cursor:"default",cx:0,cy:0,fill:"#fff","fill-opacity":1,font:'10px "Arial"',"font-family":'"Arial"',"font-size":"10","font-style":"normal","font-weight":400,gradient:0,height:0,href:"about:blank","letter-spacing":0,"line-height":12,"vertical-align":"middle",opacity:1,path:"M0,0",r:0,rx:0,ry:0,
src:"",stroke:"#000","stroke-dasharray":"","stroke-linecap":"butt","stroke-linejoin":"butt","stroke-miterlimit":0,"stroke-opacity":1,"stroke-width":1,target:"_blank","text-anchor":"middle",visibility:"",title:"",transform:"",rotation:0,width:0,x:0,y:0},vb=a._availableAnimAttrs={blur:H,"clip-rect":"csv","clip-path":"path",cx:H,cy:H,fill:"colour","fill-opacity":H,"font-size":H,height:H,opacity:H,path:"path",r:H,rx:H,ry:H,stroke:"colour","stroke-opacity":H,"stroke-width":H,transform:"transform",width:H,
x:H,y:H},jb={},ab=function(b,k){return Da(b)-Da(k)},Va=function(){},Ea=function(b){return b},Ra=a._rectPath=function(b,k,f,h,u){return u?[["M",b+u,k],["l",f-2*u,0],["a",u,u,0,0,1,u,u],["l",0,h-2*u],["a",u,u,0,0,1,-u,u],["l",2*u-f,0],["a",u,u,0,0,1,-u,-u],["l",0,2*u-h],["a",u,u,0,0,1,u,-u],["z"]]:[["M",b,k],["l",f,0],["l",0,h],["l",-f,0],["z"]]},xb=function(b,k,f,h){null==h&&(h=f);return[["M",b,k],["m",0,-h],["a",f,h,0,1,1,0,2*h],["a",f,h,0,1,1,0,-2*h],["z"]]},hb=a._getPath={group:function(){return!1},
path:function(b){return b.attr("path")},circle:function(b){b=b.attrs;return xb(b.cx,b.cy,b.r)},ellipse:function(b){b=b.attrs;return xb(b.cx,b.cy,b.rx,b.ry)},rect:function(b){b=b.attrs;return Ra(b.x,b.y,b.width,b.height,b.r)},image:function(b){b=b.attrs;return Ra(b.x,b.y,b.width,b.height)},text:function(b){b=b._getBBox();return Ra(b.x,b.y,b.width,b.height)}},yb=a.mapPath=function(b,k){if(!k)return b;var f,h,u,E,a,z,B;b=Ya(b);u=0;for(a=b.length;u<a;u++)for(B=b[u],E=1,z=B.length;E<z;E+=2)f=k.x(B[E],
B[E+1]),h=k.y(B[E],B[E+1]),B[E]=f,B[E+1]=h;return b};a.pick=function(){for(var b,k=0,f=arguments.length;k<f;k+=1)if((b=arguments[k])||!1===b||0===b)return b};var fb=a._lastArgIfGroup=function(b,k){var f=b.length-1,h=b[f];if(h&&h.constructor===a.el.constructor&&"group"===h.type)return k&&(b[f]=void 0,delete b[f],K.call(b,f,1)),h},Bb=a._serializeArgs=function(b){var k=b[0],f,h;if(a.is(k,"object")&&!a.is(k,"array")&&"group"!==k.type)for(f=k,k.path&&(k=k.path)&&!a.is(k,"string")&&a.is(k[0],t),k=1,h=arguments.length;k<
h;k+=2)f[arguments[k]]||(f[arguments[k]]=arguments[k+1]);else for(f={},k=1,h=arguments.length;k<h;k+=2)f[arguments[k]]=b[(k-1)/2]||arguments[k+1];return f},zb=a.merge=function(b,k,f,h,u){var E,a,z,B;u?(h.push(b),u.push(k)):(h=[b],u=[k]);if(k instanceof Array)for(E=0;E<k.length;E+=1){try{a=b[E],z=k[E]}catch(G){continue}if("object"!==typeof z)f&&void 0===z||(b[E]=z);else{if(null===a||"object"!==typeof a)a=b[E]=z instanceof Array?[]:{};B=checkCyclicRef(z,u);-1!==B?a=b[E]=h[B]:zb(a,z,f,h,u)}}else for(E in k){try{a=
b[E],z=k[E]}catch(G){continue}if(null!==z&&"object"===typeof z)if(B=Hb.call(z),"[object Object]"===B){if(null===a||"object"!==typeof a)a=b[E]={};B=checkCyclicRef(z,u);-1!==B?a=b[E]=h[B]:zb(a,z,f,h,u)}else"[object Array]"===B?(null!==a&&a instanceof Array||(a=b[E]=[]),B=checkCyclicRef(z,u),-1!==B?a=b[E]=h[B]:zb(a,z,f,h,u)):b[E]=z;else b[E]=z}return b};a.extend=function(b,k,f){if("object"!==typeof b&&"object"!==typeof k)return null;if("object"!==typeof k||null===k)return b;"object"!==typeof b&&(b=k instanceof
Array?[]:{});zb(b,k,f);return b};var ib=a.is=function(b,k){k=Za.call(k);return"finite"==k?!tb.hasOwnProperty(+b):k==t?b instanceof Array:"object"!==k||void 0!==b&&null!==b?"null"==k&&null===b||k==typeof b&&null!==b||"object"==k&&b===Object(b)||"array"==k&&Array.isArray&&Array.isArray(b)||Hb.call(b).slice(8,-1).toLowerCase()==k:!1};a.createUUID=function(b,k){return function(){return"xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(b,k).toUpperCase()}}(/[xy]/g,function(b){var k=16*Oa.random()|0;return("x"==
b?k:k&3|8).toString(16)});a.getElementID=function(b){return"rr-"+b};var ob=a.clone=S?function(b){if(Object(b)!==b)return b;var k=new b.constructor,f;for(f in b)"prototype"!==f&&b.hasOwnProperty(f)&&(k[f]=ob(b[f]));return k}:function(b){if(Object(b)!==b)return b;var k=new b.constructor,f;for(f in b)b.hasOwnProperty(f)&&(k[f]=ob(b[f]));return k};a._g=T;a.type=ia.ENABLE_RED_CANVAS&&(ia.CanvasRenderingContext2D||I.createElement("canvas").getContext)?"CANVAS":ia.SVGAngle||I.implementation.hasFeature("http://www.w3.org/TR/SVG11/feature#BasicStructure",
"1.1")?"SVG":"VML";if("VML"==a.type){var pb=I.createElement("div"),b;pb.innerHTML='<v:shape adj="1"/>';b=pb.firstChild;b.style.behavior="url(#default#VML)";if(!b||"object"!=typeof b.adj)return a.type="";pb=null}a.svg=!((a.vml="VML"==a.type)||(a.canvas="CANVAS"==a.type));a._Paper=na;a._id=0;a._oid=0;a.angle=function(b,k,f,h,u,E){return null==u?(b-=f,k-=h,b||k?(Oa.atan2(-k,-b)*Ia+540)%360:0):a.angle(b,k,u,E)-a.angle(f,h,u,E)};a.rad=function(b){return b%360*ya};a.deg=function(b){return b*Ia%360};a.snapTo=
function(b,k,f){var h;ib(f,"finite")||(f=10);if(ib(b,t))for(h=b.length;h--;){if(Pa(b[h]-k)<=f)return b[h]}else{b=+b;h=k%b;if(h<f)return k-h;if(h>b-f)return k-h+b}return k};a.setWindow=function(b){D("raphael.setWindow",a,T.win,b);ia=T.win=b;I=T.doc=T.win.document;a._engine.initWin&&a._engine.initWin(T.win)};var z=function(b){if(a.vml){var k=/^\s+|\s+$/g,f;try{var u=new ActiveXObject("htmlfile");u.write("<body>");u.close();f=u.body}catch(E){f=createPopup().document.body}var B=f.createTextRange();z=
h(function(b){try{f.style.color=La(b).replace(k,"");var h=B.queryCommandValue("ForeColor");return"#"+("000000"+((h&255)<<16|h&65280|(h&16711680)>>>16).toString(16)).slice(-6)}catch(u){return"none"}})}else{var G=T.doc.createElement("i");G.title="Raphaël Colour Picker";G.style.display="none";T.doc.body.appendChild(G);z=h(function(b){G.style.color=b;return T.doc.defaultView.getComputedStyle(G,"").getPropertyValue("color")})}return z(b)},B=function(){return"hsb("+[this.h,this.s,this.b]+")"},P=function(){return"hsl("+
[this.h,this.s,this.l]+")"},G=function(){return this.hex},E=function(b,k,f){null==k&&ib(b,"object")&&"r"in b&&"g"in b&&"b"in b&&(f=b.b,k=b.g,b=b.r);null==k&&ib(b,"string")&&(f=a.getRGB(b),b=f.r,k=f.g,f=f.b);if(1<b||1<k||1<f)b/=255,k/=255,f/=255;return[b,k,f]},k=function(b,k,f,h){var u={r:b*=255,g:k*=255,b:f*=255,hex:a.rgb(b,k,f),toString:G};ib(h,"finite")&&(u.opacity=h);return u};a.color=function(b){var k;a.is(b,"object")&&"h"in b&&"s"in b&&"b"in b?(k=a.hsb2rgb(b),b.r=k.r,b.g=k.g,b.b=k.b,b.hex=k.hex):
a.is(b,"object")&&"h"in b&&"s"in b&&"l"in b?(k=a.hsl2rgb(b),b.r=k.r,b.g=k.g,b.b=k.b,b.hex=k.hex):(a.is(b,"string")&&(b=a.getRGB(b)),a.is(b,"object")&&"r"in b&&"g"in b&&"b"in b?(k=a.rgb2hsl(b),b.h=k.h,b.s=k.s,b.l=k.l,k=a.rgb2hsb(b),b.v=k.b):(b={hex:"none"},b.r=b.g=b.b=b.h=b.s=b.v=b.l=-1));b.toString=G;return b};a.hsb2rgb=function(b,f,h,u){this.is(b,"object")&&"h"in b&&"s"in b&&"b"in b&&(h=b.b,f=b.s,b=b.h,u=b.o);var E,a,z;b=360*b%360/60;z=h*f;f=z*(1-Pa(b%2-1));h=E=a=h-z;b=~~b;h+=[z,f,0,0,f,z][b];E+=
[f,z,z,f,0,0][b];a+=[0,0,f,z,z,f][b];return k(h,E,a,u)};a.hsl2rgb=function(b,f,h,u){this.is(b,"object")&&"h"in b&&"s"in b&&"l"in b&&(h=b.l,f=b.s,b=b.h);if(1<b||1<f||1<h)b/=360,f/=100,h/=100;var E,a,z;b=360*b%360/60;z=2*f*(.5>h?h:1-h);f=z*(1-Pa(b%2-1));h=E=a=h-z/2;b=~~b;h+=[z,f,0,0,f,z][b];E+=[f,z,z,f,0,0][b];a+=[0,0,f,z,z,f][b];return k(h,E,a,u)};a.rgb2hsb=function(b,k,f){f=E(b,k,f);b=f[0];k=f[1];f=f[2];var h,u;h=Wa(b,k,f);u=h-Ka(b,k,f);b=((0==u?null:h==b?(k-f)/u:h==k?(f-b)/u+2:(b-k)/u+4)+360)%6*
60/360;return{h:b,s:0==u?0:u/h,b:h,toString:B}};a.rgb2hsl=function(b,k,f){f=E(b,k,f);b=f[0];k=f[1];f=f[2];var h,u,a;h=Wa(b,k,f);u=Ka(b,k,f);a=h-u;b=((0==a?null:h==b?(k-f)/a:h==k?(f-b)/a+2:(b-k)/a+4)+360)%6*60/360;h=(h+u)/2;return{h:b,s:0==a?0:.5>h?a/(2*h):a/(2-2*h),l:h,toString:P}};a._path2string=function(){return this.join(",").replace(lb,"$1")};var h=a._cacher=function(b,k,f){function h(){var u=L.call(arguments,0),E=u.join("␀"),a=h.cache=h.cache||{},z=h.count=h.count||[];if(a.hasOwnProperty(E)){a:for(var u=
z,z=E,B=0,G=u.length;B<G;B++)if(u[B]===z){u.push(u.splice(B,1)[0]);break a}return f?f(a[E]):a[E]}1E3<=z.length&&delete a[z.shift()];z.push(E);a[E]=b[q](k,u);return f?f(a[E]):a[E]}return h};a._preload=function(b,k){var f=I.createElement("img");f.style.cssText="position:absolute;left:-9999em;top:-9999em";f.onload=function(){k.call(this);this.onload=null;I.body.removeChild(this)};f.onerror=function(){I.body.removeChild(this)};I.body.appendChild(f);f.src=b};a.getRGB=h(function(b){var k,f,h,u,E;b&&ib(b,
"object")&&"opacity"in b&&(k=b.opacity);if(!b||(b=La(b)).indexOf("-")+1)return{r:-1,g:-1,b:-1,hex:"none",error:1,toString:O};if("none"==b)return{r:-1,g:-1,b:-1,hex:"none",toString:O};!gb.hasOwnProperty(b.toLowerCase().substring(0,2))&&"#"!==b.charAt()&&(b=z(b));if(b=b.match(kb)){b[2]&&(u=Ma(b[2].substring(5),16),h=Ma(b[2].substring(3,5),16),f=Ma(b[2].substring(1,3),16));b[3]&&(u=Ma((E=b[3].charAt(3))+E,16),h=Ma((E=b[3].charAt(2))+E,16),f=Ma((E=b[3].charAt(1))+E,16));b[4]&&(E=b[4].split(Xa),f=Da(E[0]),
"%"==E[0].slice(-1)&&(f*=2.55),h=Da(E[1]),"%"==E[1].slice(-1)&&(h*=2.55),u=Da(E[2]),"%"==E[2].slice(-1)&&(u*=2.55),"rgba"==b[1].toLowerCase().slice(0,4)&&(k=Da(E[3])),E[3]&&"%"==E[3].slice(-1)&&(k/=100));if(b[5])return E=b[5].split(Xa),f=Da(E[0]),"%"==E[0].slice(-1)&&(f*=2.55),h=Da(E[1]),"%"==E[1].slice(-1)&&(h*=2.55),u=Da(E[2]),"%"==E[2].slice(-1)&&(u*=2.55),"deg"!=E[0].slice(-3)&&"°"!=E[0].slice(-1)||(f/=360),"hsba"==b[1].toLowerCase().slice(0,4)&&(k=Da(E[3])),E[3]&&"%"==E[3].slice(-1)&&(k/=100),
a.hsb2rgb(f,h,u,k);if(b[6])return E=b[6].split(Xa),f=Da(E[0]),"%"==E[0].slice(-1)&&(f*=2.55),h=Da(E[1]),"%"==E[1].slice(-1)&&(h*=2.55),u=Da(E[2]),"%"==E[2].slice(-1)&&(u*=2.55),"deg"!=E[0].slice(-3)&&"°"!=E[0].slice(-1)||(f/=360),"hsla"==b[1].toLowerCase().slice(0,4)&&(k=Da(E[3])),E[3]&&"%"==E[3].slice(-1)&&(k/=100),a.hsl2rgb(f,h,u,k);b={r:f,g:h,b:u,toString:O};b.hex="#"+(16777216|u|h<<8|f<<16).toString(16).slice(1);a.is(k,"finite")&&(b.opacity=k);return b}return{r:-1,g:-1,b:-1,hex:"none",error:1,
toString:O}},a);a.tintshade=h(function(b,k){var f=a.getRGB(b),h;h=255;0>k&&(k*=-1,h=0);1<k&&(k=1);h=0===k?f:{r:h-(h-f.r)*k,g:h-(h-f.g)*k,b:h-(h-f.b)*k,toString:O};h.hex=a.rgb(h.r,h.g,h.b);f.error&&(h.error=f.error);"opacity"in f?(h.rgba="rgba("+[h.r,h.g,h.b,f.opacity].join()+")",h.opacity=f.opacity):h.rgba="rgb("+[h.r,h.g,h.b].join()+")";return h},a);a.hsb=h(function(b,k,f){return a.hsb2rgb(b,k,f).hex});a.hsl=h(function(b,k,f){return a.hsl2rgb(b,k,f).hex});a.rgb=h(function(b,k,f){return"#"+(16777216|
f|k<<8|b<<16).toString(16).slice(1)});a.getColor=function(b){b=this.getColor.start=this.getColor.start||{h:0,s:1,b:b||.75};var k=this.hsb2rgb(b.h,b.s,b.b);b.h+=.075;1<b.h&&(b.h=0,b.s-=.2,0>=b.s&&(this.getColor.start={h:0,s:1,b:b.b}));return k.hex};a.getColor.reset=function(){delete this.start};a.parsePathString=function(b){if(!b)return null;var k=u(b);if(k.arr)return xa(k.arr);var f={a:7,c:6,h:1,l:2,m:2,r:4,q:4,s:4,t:2,v:1,z:0},h=[];a.is(b,t)&&a.is(b[0],t)&&(h=xa(b));h.length||La(b).replace(db,function(b,
k,u){var E=[];b=k.toLowerCase();u.replace(sb,function(b,k){k&&E.push(+k)});"m"==b&&2<E.length&&(h.push([k].concat(E.splice(0,2))),b="l",k="m"==k?"l":"L");if("r"==b)h.push([k].concat(E));else for(;E.length>=f[b]&&(h.push([k].concat(E.splice(0,f[b]))),f[b]););});h.toString=a._path2string;k.arr=xa(h);return h};a.parseTransformString=h(function(b){if(!b)return null;var k=[];a.is(b,t)&&a.is(b[0],t)&&(k=xa(b));k.length||La(b).replace($a,function(b,f,h){var u=[];Za.call(f);h.replace(sb,function(b,k){k&&
u.push(+k)});k.push([f].concat(u))});k.toString=a._path2string;return k});var u=function(b){var k=u.ps=u.ps||{};k[b]?k[b].sleep=100:k[b]={sleep:100};setTimeout(function(){for(var f in k)k.hasOwnProperty(f)&&f!=b&&(k[f].sleep--,!k[f].sleep&&delete k[f])});return k[b]};a.findDotsAtSegment=function(b,k,f,h,u,E,a,z,B){var G=1-B,P=Ua(G,3),Y=Ua(G,2),c=B*B,xa=c*B,e=P*b+3*Y*B*f+3*G*B*B*u+xa*a,P=P*k+3*Y*B*h+3*G*B*B*E+xa*z,Y=b+2*B*(f-b)+c*(u-2*f+b),xa=k+2*B*(h-k)+c*(E-2*h+k),Fa=f+2*B*(u-f)+c*(a-2*u+f),c=h+
2*B*(E-h)+c*(z-2*E+h);b=G*b+B*f;k=G*k+B*h;u=G*u+B*a;E=G*E+B*z;z=90-180*Oa.atan2(Y-Fa,xa-c)/Na;(Y>Fa||xa<c)&&(z+=180);return{x:e,y:P,m:{x:Y,y:xa},n:{x:Fa,y:c},start:{x:b,y:k},end:{x:u,y:E},alpha:z}};a.bezierBBox=function(b,k,f,h,u,E,z,B){a.is(b,"array")||(b=[b,k,f,h,u,E,z,B]);b=rb.apply(null,b);return{x:b.min.x,y:b.min.y,x2:b.max.x,y2:b.max.y,width:b.max.x-b.min.x,height:b.max.y-b.min.y}};a.isPointInsideBBox=function(b,k,f){return k>=b.x&&k<=b.x2&&f>=b.y&&f<=b.y2};a.isBBoxIntersect=function(b,k){var f=
a.isPointInsideBBox;return f(k,b.x,b.y)||f(k,b.x2,b.y)||f(k,b.x,b.y2)||f(k,b.x2,b.y2)||f(b,k.x,k.y)||f(b,k.x2,k.y)||f(b,k.x,k.y2)||f(b,k.x2,k.y2)||(b.x<k.x2&&b.x>k.x||k.x<b.x2&&k.x>b.x)&&(b.y<k.y2&&b.y>k.y||k.y<b.y2&&k.y>b.y)};a.pathIntersection=function(b,k){return ga(b,k)};a.pathIntersectionNumber=function(b,k){return ga(b,k,1)};a.isPointInsidePath=function(b,k,f){var h=a.pathBBox(b);return a.isPointInsideBBox(h,k,f)&&(1==ga(b,[["M",k,f],["H",h.x2+10]],1)%2||1==ga(b,[["M",k,f],["V",h.y2+10]],1)%
2)};a._removedFactory=function(b){return function(){D("raphael.log",null,"Raphaël: you are calling to method “"+b+"” of removed object",b)}};var f=a.pathBBox=function(b){var k=u(b);if(!b)return{x:0,y:0,width:0,height:0,x2:0,y2:0};b=Ya(b);for(var f=0,h=0,E=[],a=[],z,B=0,G=b.length;B<G;B++)z=b[B],"M"==z[0]?(f=z[1],h=z[2],E.push(f),a.push(h)):(f=rb(f,h,z[1],z[2],z[3],z[4],z[5],z[6]),E=E.concat(f.min.x,f.max.x),a=a.concat(f.min.y,f.max.y),f=z[5],h=z[6]);b=Ka[q](0,E);z=Ka[q](0,a);E=Wa[q](0,E);a=Wa[q](0,
a);a={x:b,y:z,x2:E,y2:a,width:E-b,height:a-z};k.bbox=ob(a);return a},xa=function(b){b=ob(b);b.toString=a._path2string;return b},Y=a._pathToRelative=function(b){var k=u(b);if(k.rel)return xa(k.rel);a.is(b,t)&&a.is(b&&b[0],t)||(b=a.parsePathString(b));var f=[],h=0,E=0,z=0,B=0,G=0;"M"==b[0][0]&&(h=b[0][1],E=b[0][2],z=h,B=E,G++,f.push(["M",h,E]));for(var P=b.length;G<P;G++){var Y=f[G]=[],c=b[G];if(c[0]!=Za.call(c[0]))switch(Y[0]=Za.call(c[0]),Y[0]){case "a":Y[1]=c[1];Y[2]=c[2];Y[3]=c[3];Y[4]=c[4];Y[5]=
c[5];Y[6]=+(c[6]-h).toFixed(3);Y[7]=+(c[7]-E).toFixed(3);break;case "v":Y[1]=+(c[1]-E).toFixed(3);break;case "m":z=c[1],B=c[2];default:for(var e=1,Fa=c.length;e<Fa;e++)Y[e]=+(c[e]-(e%2?h:E)).toFixed(3)}else for(f[G]=[],"m"==c[0]&&(z=c[1]+h,B=c[2]+E),Y=0,e=c.length;Y<e;Y++)f[G][Y]=c[Y];c=f[G].length;switch(f[G][0]){case "z":h=z;E=B;break;case "h":h+=+f[G][c-1];break;case "v":E+=+f[G][c-1];break;default:h+=+f[G][c-2],E+=+f[G][c-1]}}f.toString=a._path2string;k.rel=xa(f);return f},wa=a._pathToAbsolute=
function(b){var k=u(b),f;if(k.abs)return xa(k.abs);a.is(b,t)&&a.is(b&&b[0],t)||(b=a.parsePathString(b));if(!b||!b.length)return f=["M",0,0],f.toString=a._path2string,f;var h=0,E=0,z=0,B=0,G=0;f=[];"M"==b[0][0]&&(h=+b[0][1],E=+b[0][2],z=h,B=E,G++,f[0]=["M",h,E]);for(var P=3==b.length&&"M"==b[0][0]&&"R"==b[1][0].toUpperCase()&&"Z"==b[2][0].toUpperCase(),Y,c=G,e=b.length;c<e;c++){f.push(G=[]);Y=b[c];if(Y[0]!=wb.call(Y[0]))switch(G[0]=wb.call(Y[0]),G[0]){case "A":G[1]=Y[1];G[2]=Y[2];G[3]=Y[3];G[4]=Y[4];
G[5]=Y[5];G[6]=+(Y[6]+h);G[7]=+(Y[7]+E);break;case "V":G[1]=+Y[1]+E;break;case "H":G[1]=+Y[1]+h;break;case "R":for(var Fa=[h,E].concat(Y.slice(1)),wa=2,g=Fa.length;wa<g;wa++)Fa[wa]=+Fa[wa]+h,Fa[++wa]=+Fa[wa]+E;f.pop();f=f.concat(d(Fa,P));break;case "M":z=+Y[1]+h,B=+Y[2]+E;default:for(wa=1,g=Y.length;wa<g;wa++)G[wa]=+Y[wa]+(wa%2?h:E)}else if("R"==Y[0])Fa=[h,E].concat(Y.slice(1)),f.pop(),f=f.concat(d(Fa,P)),G=["R"].concat(Y.slice(-2));else for(Fa=0,wa=Y.length;Fa<wa;Fa++)G[Fa]=Y[Fa];switch(G[0]){case "Z":h=
z;E=B;break;case "H":h=G[1];break;case "V":E=G[1];break;case "M":z=G[G.length-2],B=G[G.length-1];default:h=G[G.length-2],E=G[G.length-1]}}f.toString=a._path2string;k.abs=xa(f);return f},Fa=function(b,k,f,h){return[b,k,f,h,f,h]},Ca=function(b,k,f,h,u,E){var a=1/3,z=2/3;return[a*b+z*f,a*k+z*h,a*u+z*f,a*E+z*h,u,E]},ta=function(b,k,f,u,E,a,z,B,G,P){var Y=120*Na/180,c=ya*(+E||0),xa=[],e,Fa=h(function(b,k,f){var h=b*Sa(f)-k*ka(f);b=b*ka(f)+k*Sa(f);return{x:h,y:b}});if(P)d=P[0],e=P[1],a=P[2],wa=P[3];else{e=
Fa(b,k,-c);b=e.x;k=e.y;e=Fa(B,G,-c);B=e.x;G=e.y;Sa(ya*E);ka(ya*E);e=(b-B)/2;d=(k-G)/2;wa=e*e/(f*f)+d*d/(u*u);1<wa&&(wa=mb(wa),f*=wa,u*=wa);var wa=f*f,g=u*u,wa=(a==z?-1:1)*mb(Pa((wa*g-wa*d*d-g*e*e)/(wa*d*d+g*e*e)));a=wa*f*d/u+(b+B)/2;var wa=wa*-u*e/f+(k+G)/2,d=Oa.asin(((k-wa)/u).toFixed(9));e=Oa.asin(((G-wa)/u).toFixed(9));d=b<a?Na-d:d;e=B<a?Na-e:e;0>d&&(d=2*Na+d);0>e&&(e=2*Na+e);z&&d>e&&(d-=2*Na);!z&&e>d&&(e-=2*Na)}if(Pa(e-d)>Y){var xa=e,g=B,Ca=G;e=d+Y*(z&&e>d?1:-1);B=a+f*Sa(e);G=wa+u*ka(e);xa=ta(B,
G,f,u,E,0,z,g,Ca,[e,xa,a,wa])}a=e-d;E=Sa(d);Y=ka(d);z=Sa(e);e=ka(e);a=Oa.tan(a/4);f=4/3*f*a;a*=4/3*u;u=[b,k];b=[b+f*Y,k-a*E];k=[B+f*e,G-a*z];B=[B,G];b[0]=2*u[0]-b[0];b[1]=2*u[1]-b[1];if(P)return[b,k,B].concat(xa);xa=[b,k,B].concat(xa).join().split(",");P=[];B=0;for(G=xa.length;B<G;B++)P[B]=B%2?Fa(xa[B-1],xa[B],c).y:Fa(xa[B],xa[B+1],c).x;return P},qb=function(b,k,f,h,u,E,a,z,B){var G=1-B;return{x:Ua(G,3)*b+3*Ua(G,2)*B*f+3*G*B*B*u+Ua(B,3)*a,y:Ua(G,3)*k+3*Ua(G,2)*B*h+3*G*B*B*E+Ua(B,3)*z}},rb=h(function(b,
k,f,h,u,E,a,z){var B=u-2*f+b-(a-2*u+f),G=2*(f-b)-2*(u-f),P=b-f,Y=(-G+mb(G*G-4*B*P))/2/B,B=(-G-mb(G*G-4*B*P))/2/B,c=[k,z],xa=[b,a];"1e12"<Pa(Y)&&(Y=.5);"1e12"<Pa(B)&&(B=.5);0<Y&&1>Y&&(Y=qb(b,k,f,h,u,E,a,z,Y),xa.push(Y.x),c.push(Y.y));0<B&&1>B&&(Y=qb(b,k,f,h,u,E,a,z,B),xa.push(Y.x),c.push(Y.y));B=E-2*h+k-(z-2*E+h);G=2*(h-k)-2*(E-h);P=k-h;Y=(-G+mb(G*G-4*B*P))/2/B;B=(-G-mb(G*G-4*B*P))/2/B;"1e12"<Pa(Y)&&(Y=.5);"1e12"<Pa(B)&&(B=.5);0<Y&&1>Y&&(Y=qb(b,k,f,h,u,E,a,z,Y),xa.push(Y.x),c.push(Y.y));0<B&&1>B&&
(Y=qb(b,k,f,h,u,E,a,z,B),xa.push(Y.x),c.push(Y.y));return{min:{x:Ka[q](0,xa),y:Ka[q](0,c)},max:{x:Wa[q](0,xa),y:Wa[q](0,c)}}}),Ya=a._path2curve=h(function(b,k){var f=!k&&u(b);if(!k&&f.curve)return xa(f.curve);var h=wa(b),E=k&&wa(k),a={x:0,y:0,bx:0,by:0,X:0,Y:0,qx:null,qy:null},z={x:0,y:0,bx:0,by:0,X:0,Y:0,qx:null,qy:null},B=function(b,k){var f,h;if(!b)return["C",k.x,k.y,k.x,k.y,k.x,k.y];b[0]in{T:1,Q:1}||(k.qx=k.qy=null);switch(b[0]){case "M":k.X=b[1];k.Y=b[2];break;case "A":b=["C"].concat(ta[q](0,
[k.x,k.y].concat(b.slice(1))));break;case "S":f=k.x+(k.x-(k.bx||k.x));h=k.y+(k.y-(k.by||k.y));b=["C",f,h].concat(b.slice(1));break;case "T":k.qx=k.x+(k.x-(k.qx||k.x));k.qy=k.y+(k.y-(k.qy||k.y));b=["C"].concat(Ca(k.x,k.y,k.qx,k.qy,b[1],b[2]));break;case "Q":k.qx=b[1];k.qy=b[2];b=["C"].concat(Ca(k.x,k.y,b[1],b[2],b[3],b[4]));break;case "L":b=["C"].concat(Fa(k.x,k.y,b[1],b[2]));break;case "H":b=["C"].concat(Fa(k.x,k.y,b[1],k.y));break;case "V":b=["C"].concat(Fa(k.x,k.y,k.x,b[1]));break;case "Z":b=["C"].concat(Fa(k.x,
k.y,k.X,k.Y))}return b},G=function(b,k){if(7<b[k].length){b[k].shift();for(var f=b[k];f.length;)b.splice(k++,0,["C"].concat(f.splice(0,6)));b.splice(k,1);c=Wa(h.length,E&&E.length||0)}},P=function(b,k,f,u,a){b&&k&&"M"==b[a][0]&&"M"!=k[a][0]&&(k.splice(a,0,["M",u.x,u.y]),f.bx=0,f.by=0,f.x=b[a][1],f.y=b[a][2],c=Wa(h.length,E&&E.length||0))},Y=0,c=Wa(h.length,E&&E.length||0);for(;Y<c;Y++){h[Y]=B(h[Y],a);G(h,Y);E&&(E[Y]=B(E[Y],z));E&&G(E,Y);P(h,E,a,z,Y);P(E,h,z,a,Y);var e=h[Y],d=E&&E[Y],g=e.length,V=
E&&d.length;a.x=e[g-2];a.y=e[g-1];a.bx=Da(e[g-4])||a.x;a.by=Da(e[g-3])||a.y;z.bx=E&&(Da(d[V-4])||z.x);z.by=E&&(Da(d[V-3])||z.y);z.x=E&&d[V-2];z.y=E&&d[V-1]}E||(f.curve=xa(h));return E?[h,E]:h},null,xa);a._parseDots=h(function(b){for(var k=[],f=0,h=b.length;f<h;f++){var u={},E=b[f].match(/^([^:]*):?([\d\.]*)/);u.color=a.getRGB(E[1]);if(u.color.error)return null;u.opacity=u.color.opacity;u.color=u.color.hex;E[2]&&(u.offset=E[2]+"%");k.push(u)}f=1;for(h=k.length-1;f<h;f++)if(!k[f].offset){b=Da(k[f-1].offset||
0);E=0;for(u=f+1;u<h;u++)if(k[u].offset){E=k[u].offset;break}E||(E=100,u=h);E=Da(E);for(E=(E-b)/(u-f+1);f<u;f++)b+=E,k[f].offset=b+"%"}return k});var Cb=a._tear=function(b,k){b==k.top&&(k.top=b.prev);b==k.bottom&&(k.bottom=b.next);b.next&&(b.next.prev=b.prev);b.prev&&(b.prev.next=b.next)};a._tofront=function(b,k){if(k.top===b)return!1;Cb(b,k);b.next=null;b.prev=k.top;k.top.next=b;k.top=b;return!0};a._toback=function(b,k){if(k.bottom===b)return!1;Cb(b,k);b.next=k.bottom;b.prev=null;k.bottom.prev=b;
k.bottom=b;return!0};a._insertafter=function(b,k,f,h){Cb(b,f);b.parent=h;k===h.top&&(h.top=b);k.next&&(k.next.prev=b);b.next=k.next;b.prev=k;k.next=b};a._insertbefore=function(b,k,f,h){Cb(b,f);b.parent=h;k===h.bottom&&(h.bottom=b);k.prev&&(k.prev.next=b);b.prev=k.prev;k.prev=b;b.next=k};var Rb=a.toMatrix=function(b,k){var h=f(b),u={_:{transform:""},getBBox:function(){return h}};bb(u,k);return u.matrix};a.transformPath=function(b,k){return yb(b,Rb(b,k))};var bb=a._extractTransform=function(b,k){if(null==
k)return b._.transform;k=La(k).replace(/\.{3}|\u2026/g,b._.transform||"");var f=a.parseTransformString(k),h=0,u=0,E=0,z=1,B=1,G=b._,E=new w;G.transform=f||[];if(f)for(var u=0,P=f.length;u<P;u++){var Y=f[u],c=Y.length,xa=La(Y[0]).toLowerCase(),e=Y[0]!=xa,Fa=e?E.invert():0;"t"==xa&&3==c?e?(c=Fa.x(0,0),xa=Fa.y(0,0),e=Fa.x(Y[1],Y[2]),Fa=Fa.y(Y[1],Y[2]),E.translate(e-c,Fa-xa)):E.translate(Y[1],Y[2]):"r"==xa?2==c?(Fa=G.bb||(G.bb=b.getBBox(1)),E.rotate(Y[1],Fa.x+Fa.width/2,Fa.y+Fa.height/2),h+=Y[1]):4==
c&&(e?(e=Fa.x(Y[2],Y[3]),Fa=Fa.y(Y[2],Y[3]),E.rotate(Y[1],e,Fa)):E.rotate(Y[1],Y[2],Y[3]),h+=Y[1]):"s"==xa?2==c||3==c?(Fa=G.bb||(G.bb=b.getBBox(1)),E.scale(Y[1],Y[c-1],Fa.x+Fa.width/2,Fa.y+Fa.height/2),z*=Y[1],B*=Y[c-1]):5==c&&(e?(e=Fa.x(Y[3],Y[4]),Fa=Fa.y(Y[3],Y[4]),E.scale(Y[1],Y[2],e,Fa)):E.scale(Y[1],Y[2],Y[3],Y[4]),z*=Y[1],B*=Y[2]):"m"==xa&&7==c&&E.add(Y[1],Y[2],Y[3],Y[4],Y[5],Y[6]);G.dirtyT=1;b.matrix=E}b.matrix=E;G.sx=z;G.sy=B;G.deg=h;G.dx=u=E.e;G.dy=E=E.f;1==z&&1==B&&!h&&G.bbox?(G.bbox.x+=
+u,G.bbox.y+=+E):G.dirtyT=1},Ib=function(b){var k=b[0];switch(k.toLowerCase()){case "t":return[k,0,0];case "m":return[k,1,0,0,1,0,0];case "r":return 4==b.length?[k,0,b[2],b[3]]:[k,0];case "s":return 5==b.length?[k,1,1,b[3],b[4]]:3==b.length?[k,1,1]:[k,1]}},Gb=a._equaliseTransform=function(b,k){k=La(k).replace(/\.{3}|\u2026/g,b);b=a.parseTransformString(b)||[];k=a.parseTransformString(k)||[];for(var f=Wa(b.length,k.length),h=[],u=[],E=0,z,B,G,Y;E<f;E++){G=b[E]||Ib(k[E]);Y=k[E]||Ib(G);if(G[0]!=Y[0]||
"r"==G[0].toLowerCase()&&(G[2]!=Y[2]||G[3]!=Y[3])||"s"==G[0].toLowerCase()&&(G[3]!=Y[3]||G[4]!=Y[4]))return;h[E]=[];u[E]=[];z=0;for(B=Wa(G.length,Y.length);z<B;z++)z in G&&(h[E][z]=G[z]),z in Y&&(u[E][z]=Y[z])}return{from:h,to:u}};a._getContainer=function(b,k,f,h){var u;u=null!=h||a.is(b,"object")?b:T.doc.getElementById(b);if(null!=u)return u.tagName?null==k?{container:u,width:u.style.pixelWidth||u.offsetWidth,height:u.style.pixelHeight||u.offsetHeight}:{container:u,width:k,height:f}:{container:1,
x:b,y:k,width:f,height:h}};a.pathToRelative=Y;a._engine={};a.path2curve=Ya;a.matrix=function(b,k,f,h,u,E){return new w(b,k,f,h,u,E)};(function(b){function k(b){return b[0]*b[0]+b[1]*b[1]}function f(b){var h=mb(k(b));b[0]&&(b[0]/=h);b[1]&&(b[1]/=h)}b.add=function(b,k,f,h,u,E){var a=[[],[],[]],z=[[this.a,this.c,this.e],[this.b,this.d,this.f],[0,0,1]];k=[[b,f,u],[k,h,E],[0,0,1]];b&&b instanceof w&&(k=[[b.a,b.c,b.e],[b.b,b.d,b.f],[0,0,1]]);for(b=0;3>b;b++)for(f=0;3>f;f++){for(h=u=0;3>h;h++)u+=z[b][h]*
k[h][f];a[b][f]=u}this.a=a[0][0];this.b=a[1][0];this.c=a[0][1];this.d=a[1][1];this.e=a[0][2];this.f=a[1][2]};b.invert=function(){var b=this.a*this.d-this.b*this.c;return new w(this.d/b,-this.b/b,-this.c/b,this.a/b,(this.c*this.f-this.d*this.e)/b,(this.b*this.e-this.a*this.f)/b)};b.clone=function(){return new w(this.a,this.b,this.c,this.d,this.e,this.f)};b.translate=function(b,k){this.add(1,0,0,1,b,k)};b.scale=function(b,k,f,h){null==k&&(k=b);(f||h)&&this.add(1,0,0,1,f,h);this.add(b,0,0,k,0,0);(f||
h)&&this.add(1,0,0,1,-f,-h)};b.rotate=function(b,k,f){b=a.rad(b);k=k||0;f=f||0;var h=+Sa(b).toFixed(9);b=+ka(b).toFixed(9);this.add(h,b,-b,h,k,f);this.add(1,0,0,1,-k,-f)};b.x=function(b,k){return b*this.a+k*this.c+this.e};b.y=function(b,k){return b*this.b+k*this.d+this.f};b.get=function(b){return+this[La.fromCharCode(97+b)].toFixed(4)};b.toString=function(){return a.svg?"matrix("+[this.get(0),this.get(1),this.get(2),this.get(3),this.get(4),this.get(5)].join()+")":[this.get(0),this.get(2),this.get(1),
this.get(3),0,0].join()};b.toMatrixString=function(){return"matrix("+[this.get(0),this.get(1),this.get(2),this.get(3),this.get(4),this.get(5)].join()+")"};b.toFilter=function(){return"progid:DXImageTransform.Microsoft.Matrix(M11="+this.get(0)+", M12="+this.get(2)+", M21="+this.get(1)+", M22="+this.get(3)+", Dx="+this.get(4)+", Dy="+this.get(5)+", sizingmethod='auto expand')"};b.offset=function(){return[this.e.toFixed(4),this.f.toFixed(4)]};b.split=function(){var b={};b.dx=this.e;b.dy=this.f;var h=
[[this.a,this.c],[this.b,this.d]];b.scalex=mb(k(h[0]));f(h[0]);b.shear=h[0][0]*h[1][0]+h[0][1]*h[1][1];h[1]=[h[1][0]-h[0][0]*b.shear,h[1][1]-h[0][1]*b.shear];b.scaley=mb(k(h[1]));f(h[1]);b.shear/=b.scaley;var u=-h[0][1],h=h[1][1];0>h?(b.rotate=a.deg(Oa.acos(h)),0>u&&(b.rotate=360-b.rotate)):b.rotate=a.deg(Oa.asin(u));b.isSimple=!+b.shear.toFixed(9)&&(b.scalex.toFixed(9)==b.scaley.toFixed(9)||!b.rotate);b.isSuperSimple=!+b.shear.toFixed(9)&&b.scalex.toFixed(9)==b.scaley.toFixed(9)&&!b.rotate;b.noRotation=
!+b.shear.toFixed(9)&&!b.rotate;return b};b.toTransformString=function(b){b=b||this.split();return b.isSimple?(b.scalex=+b.scalex.toFixed(4),b.scaley=+b.scaley.toFixed(4),b.rotate=+b.rotate.toFixed(4),(b.dx||b.dy?"t"+[b.dx,b.dy]:"")+(1!=b.scalex||1!=b.scaley?"s"+[b.scalex,b.scaley,0,0]:"")+(b.rotate?"r"+[b.rotate,0,0]:"")):"m"+[this.get(0),this.get(1),this.get(2),this.get(3),this.get(4),this.get(5)]}})(w.prototype);var Kb=ia.navigator,Q=Kb.userAgent.match(/Version\/(.*?)\s/)||Kb.userAgent.match(/Chrome\/(\d+)/);
"Apple Computer, Inc."==Kb.vendor&&(Q&&4>Q[1]||"iP"==Kb.platform.slice(0,2))||"Google Inc."==Kb.vendor&&Q&&8>Q[1]?ea.safari=function(){var b=this.rect(-99,-99,this.width+99,this.height+99).attr({stroke:"none"});setTimeout(function(){b.remove()});return!0}:ea.safari=Va;for(var R=function(){this.returnValue=!1},jc=function(){return this.originalEvent.preventDefault()},ub=function(){this.cancelBubble=!0},kc=function(){return this.originalEvent.stopPropagation()},Ba=a.addEvent=function(){if(T.doc.addEventListener)return function(b,
k,f,h){var u=za&&va[k]||k,E;va[nb[k]]&&(u=va[nb[k]]);E=function(u){var E=T.doc.documentElement.scrollTop||T.doc.body.scrollTop,a=T.doc.documentElement.scrollLeft||T.doc.body.scrollLeft,z;if(C&&va.hasOwnProperty(za?k:nb[k]))for(var B=0,G=u.targetTouches&&u.targetTouches.length;B<G;B++)if(z=u.targetTouches[B].target,z==b||"tspan"==z.nodeName&&z.parentNode==b){z=u;u=u.targetTouches[B];u.originalEvent=z;u.preventDefault=jc;u.stopPropagation=kc;break}return f.call(h,u,u.clientX+a,u.clientY+E)};b.addEventListener(u,
E,!1);return function(){b.removeEventListener(u,E,!1);return!0}};if(T.doc.attachEvent)return function(b,k,f,h){var u=function(b){b=b||T.win.event;var k=b.clientX+(T.doc.documentElement.scrollLeft||T.doc.body.scrollLeft),u=b.clientY+(T.doc.documentElement.scrollTop||T.doc.body.scrollTop);b.preventDefault=b.preventDefault||R;b.stopPropagation=b.stopPropagation||ub;return f.call(h,b,k,u)};b.attachEvent("on"+k,u);return function(){b.detachEvent("on"+k,u);return!0}}}(),ha=[],W=function(b){for(var k=b.clientX,
f=b.clientY,h=T.doc.documentElement.scrollTop||T.doc.body.scrollTop,u=T.doc.documentElement.scrollLeft||T.doc.body.scrollLeft,E,z=ha.length;z--;){E=ha[z];if(C&&"touchmove"===b.type)for(var B=b.touches.length,G;B--;){if(G=b.touches[B],G.identifier==E.el._drag.id){k=G.clientX;f=G.clientY;(b.originalEvent?b.originalEvent:b).preventDefault();break}}else b.preventDefault();if(!E.el.removed){var B=a._engine.getNode(E.el),Y=B.nextSibling,P=B.parentNode,c=B.style.display;T.win.opera&&P.removeChild(B);B.style.display=
"none";G=E.el.paper.getElementByPoint(k,f);B.style.display=c;T.win.opera&&(Y?P.insertBefore(B,Y):P.appendChild(B));G&&D("raphael.drag.over."+E.el.id,E.el,G);k+=u;f+=h;D("raphael.drag.move."+E.el.id,E.move_scope||E.el,k-E.el._drag.x,f-E.el._drag.y,k,f,b)}}},Fb=function(b){a.undragmove(W).undragend(Fb);a.unmousemove(W).unmouseup(Fb);for(var k=ha.length,f;k--;)f=ha[k],f.el._drag={},D("raphael.drag.end."+f.el.id,f.end_scope||f.start_scope||f.move_scope||f.el,b);ha=[]},U=a.el={},Z=V.length;Z--;)(function(b){a[b]=
U[b]=function(k,f){a.is(k,"function")&&(this.events=this.events||[],this.events.push({name:b,f:k,unbind:Ba(this.shape||this.node||T.doc,b,k,f||this)}));return this};a["un"+b]=U["un"+b]=function(k){for(var f=this.events||[],h=f.length;h--;)if(f[h].name==b&&f[h].f==k){f[h].unbind();f.splice(h,1);!f.length&&delete this.events;break}return this}})(V[Z]);U.data=function(b,k){var f=jb[this.id]=jb[this.id]||{};if(1==arguments.length){if(a.is(b,"object")){for(var h in b)b.hasOwnProperty(h)&&this.data(h,b[h]);
return this}D("raphael.data.get."+this.id,this,f[b],b);return f[b]}f[b]=k;D("raphael.data.set."+this.id,this,k,b);return this};U.removeData=function(b){null==b?delete jb[this.id]:jb[this.id]&&delete jb[this.id][b];return this};U.getData=function(){return ob(jb[this.id]||{})};var X=[],da=function(){this.untrack=Ba(T.doc,"mouseup",ca,this)},ca=function(){this.untrack();this.untrack=null;return this.fn&&this.fn.apply(this.scope||this.el,arguments)};U.mouseup=function(b,k,f){if(!f)return a.mouseup.apply(this,
arguments);X.push(f={el:this,fn:b,scope:k});f.unbind=Ba(this.shape||this.node||T.doc,"mousedown",da,f);return this};U.unmouseup=function(b){for(var k=X.length,f;k--;)X[k].el===this&&X[k].fn===b&&(f=X[k],f.unbind(),f.untrack&&f.untrack(),X.splice(k,1));return f?this:a.unmouseup.apply(this,arguments)};U.hover=function(b,k,f,h){return this.mouseover(b,f).mouseout(k,h||f)};U.unhover=function(b,k){return this.unmouseover(b).unmouseout(k)};var Db=[];U.drag=function(b,k,f,h,u,E){function z(B){var G=T.doc.documentElement.scrollTop||
T.doc.body.scrollTop,Y=T.doc.documentElement.scrollLeft||T.doc.body.scrollLeft;this._drag.x=B.clientX+Y;this._drag.y=B.clientY+G;this._drag.id=B.identifier;C&&!za&&!ha.length&&a.dragmove(W).dragend(Fb);!ha.length&&a.mousemove(W).mouseup(Fb);ha.push({el:this,move_scope:h,start_scope:u,end_scope:E});k&&D.on("raphael.drag.start."+this.id,k);b&&D.on("raphael.drag.move."+this.id,b);f&&D.on("raphael.drag.end."+this.id,f);D("raphael.drag.start."+this.id,u||h||this,B.clientX+Y,B.clientY+G,B)}this._drag={};
Db.push({el:this,start:z});C&&!za&&this.dragstart(z);this.mousedown(z);return this};U.onDragOver=function(b){b?D.on("raphael.drag.over."+this.id,b):D.unbind("raphael.drag.over."+this.id)};U.undrag=function(){for(var b=Db.length;b--;)Db[b].el==this&&(this.unmousedown(Db[b].start),Db.splice(b,1),D.unbind("raphael.drag.*."+this.id));!Db.length&&a.unmousemove(W).unmouseup(Fb);delete this._drag};U.follow=function(b,k,f){if(b.removed||b.constructor!==a.el.constructor)return this;b.followers.push({el:this,
stalk:f={before:"insertBefore",after:"insertAfter"}[f],cb:k});f&&this[f](b);return this};U.unfollow=function(b){if(b.removed||b.constructor!==a.el.constructor)return this;for(var k=0,f=b.followers.length;k<f;k++)if(b.followers[k].el===this){b.followers.splice(k,1);break}return this};ea.hide=function(){this.canvas.style.visibility="hidden";return this};ea.show=function(){this.canvas.style.visibility="";return this};ea.group=function(){var b=arguments,k=fb(b,!0),b=a._engine.group(this,b[0],k);return this.__set__&&
this.__set__.push(b),this._elementsById[b.id]=b};ea.circle=function(){var b=arguments,k=fb(b,!0),b=Bb(b,"cx",0,"cy",0,"r",0,"fill","none","stroke","#000"),k=a._engine.circle(this,b,k);return this.__set__&&this.__set__.push(k),this._elementsById[k.id]=k};ea.rect=function(){var b=arguments,k=fb(b,!0),b=Bb(b,"x",0,"y",0,"width",0,"height",0,"r",0,"fill","none","stroke","#000"),k=a._engine.rect(this,b,k);return this.__set__&&this.__set__.push(k),this._elementsById[k.id]=k};ea.ellipse=function(){var b=
arguments,k=fb(b,!0),b=Bb(b,"x",0,"y",0,"rx",0,"ry",0,"fill","none","stroke","#000"),k=a._engine.ellipse(this,b,k);return this.__set__&&this.__set__.push(k),this._elementsById[k.id]=k};ea.path=function(){var b=arguments,k=fb(b,!0),f=this.config,b=Bb(b,"path","","fill","none","stroke","#000","stroke-linecap",f&&f["stroke-linecap"]||"butt"),k=a._engine.path(this,b,k);return this.__set__&&this.__set__.push(k),this._elementsById[k.id]=k};ea.image=function(){var b=arguments,k=fb(b,!0),b=Bb(b,"src","",
"x",0,"y",0,"width",0,"height",0);out=a._engine.image(this,b,k);return this.__set__&&this.__set__.push(out),this._elementsById[out.id]=out};ea.text=function(){var b=arguments,k=fb(b,!0),f=Bb(b,"x",0,"y",0,"text","","stroke","none","fill","#000","text-anchor","middle","vertical-align","middle"),b=a._engine.text(this,f,k,b[1]);return this.__set__&&this.__set__.push(b),this._elementsById[b.id]=b};ea.set=function(b){!a.is(b,"array")&&(b=K.call(arguments,0,arguments.length));var k=new Aa(b);this.__set__&&
this.__set__.push(k);return k};ea.setConfig=function(b,k){void 0!==b&&void 0!==k&&(this.config=this.config||{},this.config[b]=k);return this.config};ea.setStart=function(b){this.__set__=b||this.set()};ea.setFinish=function(b){b=this.__set__;delete this.__set__;return b};ea.setSize=function(b,k){return a._engine.setSize.call(this,b,k)};ea.setDimension=function(b,k){"object"===typeof b?this.setSize(b.width,b.height):this.setSize(b,k)};ea.attr=function(b){if(null==b)return{width:this.width,height:this.height};
if(a.is(b,"string"))return this[b];this.setDimension(b);return this};ea.status=function(b,k){return U.status.call(this,b,k)};ea.animateWith=function(b,k,f,h,u,E){return U.animateWith.call(this,b,k,f,h,u,E)};ea.animate=function(b,k,f,h){return U.animate.call(this,b,k,f,h)};ea.setViewBox=function(b,k,f,h,u){return a._engine.setViewBox.call(this,b,k,f,h,u)};ea.top=ea.bottom=null;ea.raphael=a;ea.getElementByPoint=function(b,k){var f,h,u=this.canvas,E=T.doc.elementFromPoint(b,k);if(T.win.opera&&"svg"==
E.tagName){h=u.getBoundingClientRect();f=u.ownerDocument;var a=f.body,z=f.documentElement;f=h.top+(T.win.pageYOffset||z.scrollTop||a.scrollTop)-(z.clientTop||a.clientTop||0);h=h.left+(T.win.pageXOffset||z.scrollLeft||a.scrollLeft)-(z.clientLeft||a.clientLeft||0);a=u.createSVGRect();a.x=b-h;a.y=k-f;a.width=a.height=1;f=u.getIntersectionList(a,null);f.length&&(E=f[f.length-1])}if(!E)return null;for(;E.parentNode&&E!=u.parentNode&&!E.raphael;)E=E.parentNode;E==this.canvas.parentNode&&(E=u);return E=
E&&E.raphael?this.getById(E.raphaelid):null};ea.getElementsByBBox=function(b){var k=this.set();this.forEach(function(f){a.isBBoxIntersect(f.getBBox(),b)&&k.push(f)});return k};ea.getById=function(b){return this._elementsById[b]||null};ea.forEach=function(b,k){for(var f=this.bottom;f&&!1!==b.call(k,f);)f=f.next;return this};ea.getElementsByPoint=function(b,k){var f=this.set();this.forEach(function(h){h.isPointInside(b,k)&&f.push(h)});return f};U.isPointInside=function(b,k){var f=this.realPath=this.realPath||
hb[this.type](this),h;return a.isPointInsidePath((h=this.attr("transform"))&&h.length&&a.transformPath(f,h)||f,b,k)};U.getBBox=function(b){if(this.removed)return{};var k=this._;if(b){if(k.dirty||!k.bboxwt)this.realPath=hb[this.type](this),k.bboxwt=f(this.realPath),k.bboxwt.toString=r,k.dirty=0;return k.bboxwt}if(k.dirty||k.dirtyT||!k.bbox){if(k.dirty||!this.realPath)k.bboxwt=0,this.realPath=hb[this.type](this);k.bbox=f(yb(this.realPath,this.matrix));k.bbox.toString=r;k.dirty=k.dirtyT=0}return k.bbox};
U.clone=function(){if(this.removed)return null;var b=this.paper[this.type]().attr(this.attr());this.__set__&&this.__set__.push(b);return b};U.glow=function(b){if("text"==this.type)return null;b=b||{};var k=(b.width||10)+(+this.attr("stroke-width")||1),f=b.fill||!1,h=b.opacity||.5,u=b.offsetx||0,E=b.offsety||0;b=b.color||"#000";for(var a=k/2,z=this.paper,B=z.set(),G=this.realPath||hb[this.type](this),G=this.matrix?yb(G,this.matrix):G,Y=1;Y<a+1;Y++)B.push(z.path(G).attr({stroke:b,fill:f?b:"none","stroke-linejoin":"round",
"stroke-linecap":"round","stroke-width":+(k/a*Y).toFixed(3),opacity:+(h/a).toFixed(3)}));return B.insertBefore(this).translate(u,E)};var eb=function(b,k,f,h,u,E,z,B,G){return null==G?l(b,k,f,h,u,E,z,B):a.findDotsAtSegment(b,k,f,h,u,E,z,B,N(b,k,f,h,u,E,z,B,G))},fa=function(b,k){return function(f,h,u){f=Ya(f);for(var E,z,B,G,Y="",P={},c=0,xa=0,e=f.length;xa<e;xa++){B=f[xa];if("M"==B[0])E=+B[1],z=+B[2];else{G=eb(E,z,B[1],B[2],B[3],B[4],B[5],B[6]);if(c+G>h){if(k&&!P.start){E=eb(E,z,B[1],B[2],B[3],B[4],
B[5],B[6],h-c);Y+=["C"+E.start.x,E.start.y,E.m.x,E.m.y,E.x,E.y];if(u)return Y;P.start=Y;Y=["M"+E.x,E.y+"C"+E.n.x,E.n.y,E.end.x,E.end.y,B[5],B[6]].join();c+=G;E=+B[5];z=+B[6];continue}if(!b&&!k)return E=eb(E,z,B[1],B[2],B[3],B[4],B[5],B[6],h-c),{x:E.x,y:E.y,alpha:E.alpha}}c+=G;E=+B[5];z=+B[6]}Y+=B.shift()+B}P.end=Y;E=b?c:k?P:a.findDotsAtSegment(E,z,B[0],B[1],B[2],B[3],B[4],B[5],1);E.alpha&&(E={x:E.x,y:E.y,alpha:E.alpha});return E}},fc=fa(1),ma=fa(),ac=fa(0,1);a.getTotalLength=fc;a.getPointAtLength=
ma;a.getSubpath=function(b,k,f){if(1E-6>this.getTotalLength(b)-f)return ac(b,k).end;b=ac(b,f,1);return k?ac(b,k).end:b};U.getTotalLength=function(){if("path"==this.type)return this.node.getTotalLength?this.node.getTotalLength():fc(this.attrs.path)};U.getPointAtLength=function(b){if("path"==this.type)return ma(this.attrs.path,b)};U.getSubpath=function(b,k){if("path"==this.type)return a.getSubpath(this.attrs.path,b,k)};var ja=a.easing_formulas={linear:function(b){return b},"<":function(b){return Ua(b,
1.7)},">":function(b){return Ua(b,.48)},"<>":function(b){var k=.48-b/1.04,f=mb(.1734+k*k);b=f-k;b=Ua(Pa(b),1/3)*(0>b?-1:1);k=-f-k;k=Ua(Pa(k),1/3)*(0>k?-1:1);b=b+k+.5;return 3*(1-b)*b*b+b*b*b},backIn:function(b){return b*b*(2.70158*b-1.70158)},backOut:function(b){--b;return b*b*(2.70158*b+1.70158)+1},elastic:function(b){return b==!!b?b:Ua(2,-10*b)*ka(2*(b-.075)*Na/.3)+1},bounce:function(b){b<1/2.75?b*=7.5625*b:b<2/2.75?(b-=1.5/2.75,b=7.5625*b*b+.75):b<2.5/2.75?(b-=2.25/2.75,b=7.5625*b*b+.9375):(b-=
2.625/2.75,b=7.5625*b*b+.984375);return b}};ja.easeIn=ja["ease-in"]=ja["<"];ja.easeOut=ja["ease-out"]=ja[">"];ja.easeInOut=ja["ease-in-out"]=ja["<>"];ja["back-in"]=ja.backIn;ja["back-out"]=ja.backOut;var la=[],oa,ec=function(){return oa=a.requestAnimFrame||g.webkitRequestAnimationFrame||g.mozRequestAnimationFrame||g.oRequestAnimationFrame||g.msRequestAnimationFrame||function(b){setTimeout(b,16)}},$b=function(){for(var b=+new Date,k=0;k<la.length;k++){var f=la[k];if(!(f.el.removed||f.paused||f.parentEl&&
f.parentEl.e&&f.parentEl.e.paused)){var h=b-f.start,E=f.ms,u=f.easing,z=f.from,B=f.diff,G=f.to,Y=f.el,P={},c,xa={},e=!1!==a.stopEvent,Fa;f.initstatus?(h=(f.initstatus*f.anim.top-f.prev)/(f.percent-f.prev)*E,f.status=f.initstatus,delete f.initstatus,f.stop&&(delete f.el,la.splice(k--,1))):f.status=(f.prev+h/E*(f.percent-f.prev))/f.anim.top;if(!(0>h))if(h<E){var wa=u(h/E),d;for(d in z)if(z.hasOwnProperty(d)){switch(vb[d]){case H:c=+z[d]+wa*E*B[d];break;case "colour":c="rgb("+[bc(Ga(z[d].r+wa*E*B[d].r)),
bc(Ga(z[d].g+wa*E*B[d].g)),bc(Ga(z[d].b+wa*E*B[d].b))].join()+")";break;case "path":c=[];h=0;for(u=z[d].length;h<u;h++){c[h]=[z[d][h][0]];G=1;for(xa=z[d][h].length;G<xa;G++)c[h][G]=(+z[d][h][G]+wa*E*B[d][h][G]).toFixed(4);c[h]=c[h].join(" ")}c=c.join(" ");break;case "transform":if(B[d].real)for(c=[],h=0,u=z[d].length;h<u;h++)for(c[h]=[z[d][h][0]],G=1,xa=z[d][h].length;G<xa;G++)c[h][G]=z[d][h][G]+wa*E*B[d][h][G];else c=function(b){return+z[d][b]+wa*E*B[d][b]},c=[["m",c(0),c(1),c(2),c(3),c(4),c(5)]];
break;case "csv":if("clip-rect"==d)for(c=[],h=4;h--;)c[h]=+z[d][h]+wa*E*B[d][h];break;default:for(u=[].concat(z[d]),c=[],h=Y.ca[d].length;h--;)c[h]=+u[h]+wa*E*B[d][h]}P[d]=c}Y.attr(P);e&&function(b,k,f){setTimeout(function(){D("raphael.anim.frame."+b,k,f)})}(Y.id,Y,f.anim)}else{(function(b,k,f){setTimeout(function(){e&&D("raphael.anim.frame."+k.id,k,f);e&&D("raphael.anim.finish."+k.id,k,f);a.is(b,"function")&&b.call(k)})})(f.callback,Y,f.anim);Y.attr(G);delete f.el;la.splice(k--,1);if(1<f.repeat&&
!f.next){for(Fa in G)G.hasOwnProperty(Fa)&&(xa[Fa]=f.totalOrigin[Fa]);f.el.attr(xa);v(f.anim,f.el,f.anim.percents[0],null,f.totalOrigin,f.repeat-1)}f.next&&!f.stop&&v(f.anim,f.el,f.next,null,f.totalOrigin,f.repeat)}}}a.svg&&Y&&Y.paper&&Y.paper.safari();la.length&&(oa||ec())($b)},bc=function(b){return 255<b?255:0>b?0:b};U.animateWith=function(b,k,f,h,E,u){var z=this;if(z.removed)return u&&u.call(z),z;if(0==h)return setTimeout(function(){a.is(u,"function")&&u.call(z)},0),z.attr(f);f=f instanceof c?
f:a.animation(f,h,E,u);v(f,z,f.percents[0],null,z.attr(),void 0,b);f=0;for(h=la.length;f<h;f++)if(la[f].anim==k&&la[f].el==b){la[h-1].start=la[f].start;break}return z};U.onAnimation=function(b){b?D.on("raphael.anim.frame."+this.id,b):D.unbind("raphael.anim.frame."+this.id);return this};c.prototype.delay=function(b){var k=new c(this.anim,this.ms);k.times=this.times;k.del=+b||0;return k};c.prototype.repeat=function(b){var k=new c(this.anim,this.ms);k.del=this.del;k.times=Oa.floor(Wa(b,0))||1;return k};
a.animation=function(b,k,f,h,E){if(b instanceof c)return b;if(a.is(f,"function")||!f)h=h||f||null,f=null;void 0===a.stopEvent&&(a.stopEvent=E);b=Object(b);k=+k||0;E={};var u,z;for(z in b)b.hasOwnProperty(z)&&Da(z)!=z&&Da(z)+"%"!=z&&(u=!0,E[z]=b[z]);return u?(f&&(E.easing=f),h&&(E.callback=h),new c({100:E},k)):new c(b,k)};U.animate=function(b,k,f,h){if(this.removed)return h&&h.call(this),this;b=b instanceof c?b:a.animation(b,k,f,h);v(b,this,b.percents[0],null,this.attr());return this};U.setTime=function(b,
k){b&&null!=k&&this.status(b,Ka(k,b.ms)/b.ms);return this};U.status=function(b,k){var f=[],h=0,E,u;if(null!=k)return v(b,this,-1,Ka(k,1)),this;for(E=la.length;h<E;h++)if(u=la[h],u.el.id==this.id&&(!b||u.anim==b)){if(b)return u.status;f.push({anim:u.anim,status:u.status})}return b?0:f};U.pause=function(b,k){var f=+new Date,h,E;for(E=0;E<la.length;E++)h=la[E],!(h.el.id===this.id||k&&h.parentEl&&h.parentEl.e.el&&h.parentEl.e.el.id===this.id)||b&&h.anim!=b||!1===D("raphael.anim.pause."+this.id,this,h.anim)||
(h.paused=!0,h.pauseStart=f);return this};U.resume=function(b,k){var f=+new Date,h,E;for(E=0;E<la.length;E++)h=la[E],!(h.el.id===this.id||k&&h.parentEl&&h.parentEl.e.el&&h.parentEl.e.el.id===this.id)||b&&h.anim!=b||!1===D("raphael.anim.resume."+this.id,this,h.anim)||(delete h.paused,h.el.status(h.anim,h.status),h.pauseEnd=f,h.start+=(h.parentEl&&h.parentEl.e.pauseEnd||h.pauseEnd)-(h.parentEl&&h.parentEl.e.pauseStart||h.pauseStart)||0);return this};U.stop=function(b,k,f){var h;if(k)for(h=la.length-
1;0<=h;h--)k=la[h],!(k.el.id===this.id||k.parentEl&&k.parentEl.id===this.id)||b&&la[h].anim!=b||(ele=k.el,f&&ele.attr(k.to),k.callback&&k.callback.call(ele),delete ele.e,delete k.el,la.splice(h,1));else for(h=0;h<la.length;h++)k=la[h],k.el.id!==this.id||b&&k.anim!==b||!1!==D("raphael.anim.stop."+this.id,this,k.anim)&&la.splice(h--,1);return this};D.on("raphael.remove",M);D.on("raphael.clear",M);U.toString=function(){return"Raphaël’s object"};U.toFront=function(){if(this.removed)return this;var b=
a._engine.getNode(this),k=this.parent,f=this.followers,h;a._tofront(this,k)&&k.canvas.appendChild(b);b=0;for(k=f.length;b<k;b++)(h=f[b]).stalk&&h.el[h.stalk](this);return this};U.toBack=function(){if(this.removed)return this;var b=a._engine.getNode(this),k=this.parent,f=this.followers,h;a._toback(this,k)&&k.canvas.insertBefore(b,k.canvas.firstChild);b=0;for(k=f.length;b<k;b++)(h=f[b]).stalk&&h.el[h.stalk](this);return this};U.insertAfter=function(b){if(this.removed)return this;var k=a._engine.getNode(this),
f=a._engine.getLastNode(b),h=b.parent.canvas,E=this.followers,u;f.nextSibling?h.insertBefore(k,f.nextSibling):h.appendChild(k);a._insertafter(this,b,this.parent,b.parent);k=0;for(f=E.length;k<f;k++)(u=E[k]).stalk&&u.el[u.stalk](b);return this};U.insertBefore=function(b){if(this.removed)return this;var k=a._engine.getNode(this),f=a._engine.getNode(b),h=this.followers,E;b.parent.canvas.insertBefore(k,f);a._insertbefore(this,b,this.parent,b.parent);this.parent=b.parent;k=0;for(f=h.length;k<f;k++)(E=
h[k]).stalk&&E.el[E.stalk](b);return this};U.appendChild=function(b){if(this.removed||"group"!==this.type)return this;var k=this.followers,f,h,E;if(b.parent===this)return b.toFront(),this;h=a._engine.getNode(b);a._tear(b,b.parent);this.canvas.appendChild(h);b.parent=this;!this.bottom&&(this.bottom=b);b.prev=this.top;b.next=null;this.top&&(this.top.next=b);this.top=b;h=0;for(E=k.length;h<E;h++)(f=k[h]).stalk&&f.el[f.stalk](b);return this};U.removeChild=function(b){if(this.removed||"group"!==this.type||
b.parent!==this)return this;var k=a._engine.getNode(b),f=this.paper;a._tear(b,this);f.canvas.appendChild(k);this.parent=f;!f.bottom&&(f.bottom=this);(this.prev=f.top)&&(f.top.next=this);f.top=this;this.next=null;return this};var Aa=function(b){this.items=[];this.length=0;this.type="set";if(b)for(var k=0,f=b.length;k<f;k++)!b[k]||b[k].constructor!=U.constructor&&b[k].constructor!=Aa||(this[this.items.length]=this.items[this.items.length]=b[k],this.length++)},qa=Aa.prototype;qa.push=function(){for(var b,
k,f=0,h=arguments.length;f<h;f++)!(b=arguments[f])||b.constructor!=U.constructor&&b.constructor!=Aa||(k=this.items.length,this[k]=this.items[k]=b,this.length++);return this};qa.pop=function(){this.length&&delete this[this.length--];return this.items.pop()};qa.forEach=function(b,k){for(var f=0,h=this.items.length;f<h&&!1!==b.call(k,this.items[f],f);f++);return this};for(var sa in U)U.hasOwnProperty(sa)&&(qa[sa]=function(b){return function(){var k=arguments;return this.forEach(function(f){f[b][q](f,
k)})}}(sa));qa.attr=function(b,k){if(b&&a.is(b,t)&&a.is(b[0],"object"))for(var f=0,h=b.length;f<h;f++)this.items[f].attr(b[f]);else for(f=0,h=this.items.length;f<h;f++)this.items[f].attr(b,k);return this};qa.clear=function(){for(;this.length;)this.pop()};qa.splice=function(b,k,f){b=0>b?Wa(this.length+b,0):b;k=Wa(0,Ka(this.length-b,isNaN(k)&&this.length||k));var h=[],E=[],u=[],z;for(z=2;z<arguments.length;z++)u.push(arguments[z]);for(z=0;z<k;z++)E.push(this[b+z]);for(;z<this.length-b;z++)h.push(this[b+
z]);var a=u.length;for(z=0;z<a+h.length;z++)this.items[b+z]=this[b+z]=z<a?u[z]:h[z-a];for(z=this.items.length=this.length-=k-a;this[z];)delete this[z++];return new Aa(E)};qa.exclude=function(b){for(var k=0,f=this.length;k<f;k++)if(this[k]==b)return this.splice(k,1),!0};qa.animate=function(b,k,f,h){!a.is(f,"function")&&f||(h=f||null);var E=this.items.length,u=E,z=this,B;if(!E)return this;h&&(B=function(){!--E&&h.call(z)});f=a.is(f,"string")?f:B;k=a.animation(b,k,f,B);for(b=this.items[--u].animate(k);u--;)this.items[u]&&
!this.items[u].removed&&this.items[u].animateWith(b,k,k);return this};qa.insertAfter=function(b){for(var k=this.items.length;k--;)this.items[k].insertAfter(b);return this};qa.getBBox=function(){for(var b=[],k=[],f=[],h=[],E=this.items.length;E--;)if(!this.items[E].removed){var u=this.items[E].getBBox();b.push(u.x);k.push(u.y);f.push(u.x+u.width);h.push(u.y+u.height)}b=Ka[q](0,b);k=Ka[q](0,k);f=Wa[q](0,f);h=Wa[q](0,h);return{x:b,y:k,x2:f,y2:h,width:f-b,height:h-k}};qa.clone=function(b){b=new Aa;for(var k=
0,f=this.items.length;k<f;k++)b.push(this.items[k].clone());return b};qa.toString=function(){return"Raphaël‘s set"};qa.glow=function(b){var k=this.paper.set();this.forEach(function(f,h){var E=f.glow(b);null!=E&&E.forEach(function(b,f){k.push(b)})});return k};a.registerFont=function(b){if(!b.face)return b;this.fonts=this.fonts||{};var k={w:b.w,face:{},glyphs:{}},f=b.face["font-family"],h;for(h in b.face)b.face.hasOwnProperty(h)&&(k.face[h]=b.face[h]);this.fonts[f]?this.fonts[f].push(k):this.fonts[f]=
[k];if(!b.svg){k.face["units-per-em"]=Ma(b.face["units-per-em"],10);for(var E in b.glyphs)if(b.glyphs.hasOwnProperty(E)&&(f=b.glyphs[E],k.glyphs[E]={w:f.w,k:{},d:f.d&&"M"+f.d.replace(/[mlcxtrv]/g,function(b){return{l:"L",c:"C",x:"z",t:"m",r:"l",v:"c"}[b]||"M"})+"z"},f.k))for(var u in f.k)f.hasOwnProperty(u)&&(k.glyphs[E].k[u]=f.k[u])}return b};ea.getFont=function(b,k,f,h){h=h||"normal";f=f||"normal";k=+k||{normal:400,bold:700,lighter:300,bolder:800}[k]||400;if(a.fonts){var E=a.fonts[b];if(!E){b=new RegExp("(^|\\s)"+
b.replace(/[^\w\d\s+!~.:_-]/g,"")+"(\\s|$)","i");for(var u in a.fonts)if(a.fonts.hasOwnProperty(u)&&b.test(u)){E=a.fonts[u];break}}var z;if(E)for(u=0,b=E.length;u<b&&(z=E[u],z.face["font-weight"]!=k||z.face["font-style"]!=f&&z.face["font-style"]||z.face["font-stretch"]!=h);u++);return z}};ea.print=function(b,k,f,h,E,u,z){u=u||"middle";z=Wa(Ka(z||0,1),-1);var B=La(f).split(""),G=0,Y=0,P="";a.is(h,f)&&(h=this.getFont(h));if(h){f=(E||16)/h.face["units-per-em"];var c=h.face.bbox.split(Eb);E=+c[0];var xa=
c[3]-c[1],e=0;u=+c[1]+("baseline"==u?xa+ +h.face.descent:xa/2);for(var c=0,Fa=B.length;c<Fa;c++){if("\n"==B[c])Y=d=G=0,e+=xa;else var wa=Y&&h.glyphs[B[c-1]]||{},d=h.glyphs[B[c]],G=G+(Y?(wa.w||h.w)+(wa.k&&wa.k[B[c]]||0)+h.w*z:0),Y=1;d&&d.d&&(P+=a.transformPath(d.d,["t",G*f,e*f,"s",f,f,E,u,"t",(b-E)/f,(k-u)/f]))}}return this.path(P).attr({fill:"#000",stroke:"none"})};ea.add=function(b){if(a.is(b,"array"))for(var k=this.set(),f=0,h=b.length,E;f<h;f++)E=b[f]||{},ra.hasOwnProperty(E.type)&&k.push(this[E.type]().attr(E));
return k};a.format=function(b,k){var f=a.is(k,t)?[0].concat(k):arguments;b&&a.is(b,"string")&&f.length-1&&(b=b.replace(Ob,function(b,k){return null==f[++k]?"":f[k]}));return b||""};a.fullfill=function(){var b=/\{([^\}]+)\}/g,k=/(?:(?:^|\.)(.+?)(?=\[|\.|$|\()|\[('|")(.+?)\2\])(\(\))?/g,f=function(b,f,h){var E=h;f.replace(k,function(b,k,f,h,u){k=k||h;E&&(k in E&&(E=E[k]),"function"==typeof E&&u&&(E=E()))});return E=(null==E||E==h?b:E)+""};return function(k,h){return String(k).replace(b,function(b,k){return f(b,
k,h)})}}();a.ninja=function(){ba?T.win.Raphael=aa:delete T.win.Raphael;return a};var ua=a.vml&&.5||0;a.crispBound=h(function(b,k,f,h,E){var u={},z;b=b||0;k=k||0;f=f||0;h=h||0;E=E||0;z=E%2/2+ua;u.x=Ga(b+z)-z;u.y=Ga(k+z)-z;u.width=Ga(b+f+z)-z-u.x;u.height=Ga(k+h+z)-z-u.y;u["stroke-width"]=E;0===u.width&&0!==f&&(u.width=1);0===u.height&&0!==h&&(u.height=1);return u},a);U.crisp=function(){var b=this.attrs,k,f=this.attr(["x","y","width","height","stroke-width"]),f=a.crispBound(f.x,f.y,f.width,f.height,
f["stroke-width"]);for(k in f)b[k]===f[k]&&delete f[k];return this.attr(f)};a.st=qa;a.define=function(b,k,f,h,E,u){var z;if(a.is(b,t))for(u=0,z=b.length;u<z;u++)a.define(b[u]);else if(a.is(b,"object"))a.define(b.name,b[b.name],b.ca,b.fn,b.e,b.data);else if(b&&!a.fn[b])return a.fn[b]=function(){var u=arguments,z=k.apply(this,u),B;if(h&&a.is(h,"object"))for(B in h)z[B]=h[B];if(E&&a.is(E,"object"))for(B in E)z[B]&&z[B](E[B]);if(f){if(a.is(f,"function"))z.ca[b]=f;else for(B in f)z.ca[B]=f[B];z.ca[b]&&
(a._lastArgIfGroup(u,!0),u.length&&z.attr(b,L.call(u)))}return z},f&&(a.fn[b].ca=f),h&&(a.fn[b].fn=h),E&&(a.fn[b].e=E),u&&(a.fn[b].data=u),a.fn[b]};(function(b,k,f){function h(){/in/.test(b.readyState)?setTimeout(h,9):a.eve("raphael.DOMload")}null==b.readyState&&b.addEventListener&&(b.addEventListener(k,f=function(){b.removeEventListener(k,f,!1);b.readyState="complete"},!1),b.readyState="loading");h()})(I,"DOMContentLoaded");D.on("raphael.DOMload",function(){e=!0});"undefined"===typeof m&&"object"===
typeof window&&(m=window);(function(){function b(k){for(var f={},h=k,E=f;h;)h.node&&h.node.style&&"none"===h.node.style.display&&(h.show(),E._doHide=!0),h=h.parent,E.parent={},E=E.parent;return function(){for(var b=k,h=f;b;)h._doHide&&b.hide(),b=b.parent,h=h.parent}}if(a.svg){var k=String,f=parseFloat,h=parseInt,E=Math,u=E.max,z=E.abs,B=E.pow,G=E.sqrt,Y=/[, ]+/,P=!(!/AppleWebKit/.test(a._g.win.navigator.userAgent)||/Chrome/.test(a._g.win.navigator.userAgent)&&!(29>a._g.win.navigator.appVersion.match(/Chrome\/(\d+)\./)[1])),
c=a.eve,xa={block:"M5,0 0,2.5 5,5z",classic:"M5,0 0,2.5 5,5 3.5,3 3.5,2z",diamond:"M2.5,0 5,2.5 2.5,5 0,2.5z",open:"M6,1 1,3.5 6,6",oval:"M2.5,0A2.5,2.5,0,0,1,2.5,5 2.5,2.5,0,0,1,2.5,0z"},e={};a.toString=function(){return"Your browser supports SVG.\nYou are running Raphaël "+this.version};a._url="";var Fa=function(b,k){var f=b.gradient;if(f){if(f===k)return;f.refCount--;f.refCount||f.parentNode.removeChild(f);delete b.gradient}k&&(b.gradient=k,k.refCount++)},d=a._createNode=function(b,f){if(f){"string"==
typeof b&&(b=d(b));for(var h in f)f.hasOwnProperty(h)&&("xlink:"==h.substring(0,6)?b.setAttributeNS("http://www.w3.org/1999/xlink",h.substring(6),k(f[h])):b.setAttribute(h,k(f[h])))}else b=a._g.doc.createElementNS("http://www.w3.org/2000/svg",b);return b},wa={userSpaceOnUse:"userSpaceOnUse",objectBoundingBox:"objectBoundingBox"},g={pad:"pad",redlect:"reflect",repeat:"repeat"},ta=function(b,h){if(!b.paper||!b.paper.defs)return 0;var Y="linear",P=b.paper,c=a.getElementID((P.id+"-"+h).replace(/[\(\)\s%:,\xb0#]/g,
"_")),xa=.5,e=.5,ta,Ca,V,l,q,t=b.node,qb=t.style,p=a._g.doc.getElementById(c);if(!p){h=k(h).replace(a._radial_gradient,function(b,k){Y="radial";k=k&&k.split(",")||[];l=k[5];q=k[6];var h=k[0],E=k[1],u=k[2],z=k[3],a=k[4],P=h&&E,c;u&&(ta=/\%/.test(u)?u:f(u));if(l===wa.userSpaceOnUse)return P&&(xa=h,e=E),z&&a&&(Ca=z,V=a,P||(xa=Ca,e=V)),"";P&&(xa=f(h),e=f(E),h=2*(.5<e)-1,.25<(c=B(xa-.5,2))+B(e-.5,2)&&.25>c&&(e=G(.25-c)*h+.5)&&.5!==e&&(e=e.toFixed(5)-1E-5*h));z&&a&&(Ca=f(z),V=f(a),h=2*(.5<V)-1,.25<(c=B(Ca-
.5,2))+B(V-.5,2)&&.25>c&&(V=G(.25-c)*h+.5)&&.5!==V&&(V=V.toFixed(5)-1E-5*h),P||(xa=Ca,e=V));return""});h=h.split(/\s*\-\s*/);if("linear"==Y){var p=h.shift(),Ya=p.match(/\((.*)\)/),m,Ya=Ya&&Ya[1]&&Ya[1].split(/\s*\,\s*/),p=-f(p);if(isNaN(p))return null;Ya&&Ya.length?(Ya[0]in wa?(l=Ya.shift(),Ya[0]in g&&(q=Ya.shift())):(Ya[4]&&(l=Ya[4]),Ya[5]&&(q=Ya[5])),m=[Ya[0]||"0%",Ya[1]||"0%",Ya[2]||"100%",Ya[3]||"0%"]):(m=[0,0,E.cos(a.rad(p)),E.sin(a.rad(p))],p=1/(u(z(m[2]),z(m[3]))||1),m[2]*=p,m[3]*=p,0>m[2]&&
(m[0]=-m[2],m[2]=0),0>m[3]&&(m[1]=-m[3],m[3]=0))}Ya=a._parseDots(h);if(!Ya)return null;p=d(Y+"Gradient",{id:c});p.refCount=0;l in wa&&p.setAttribute("gradientUnits",k(l));q in g&&p.setAttribute("spreadMethod",k(q));"radial"===Y?(void 0!==ta&&p.setAttribute("r",k(ta)),void 0!==Ca&&void 0!==V&&(p.setAttribute("cx",k(Ca)),p.setAttribute("cy",k(V))),p.setAttribute("fx",k(xa)),p.setAttribute("fy",k(e))):d(p,{x1:m[0],y1:m[1],x2:m[2],y2:m[3]});m=0;for(var rb=Ya.length;m<rb;m++)p.appendChild(d("stop",{offset:Ya[m].offset?
Ya[m].offset:m?"100%":"0%","stop-color":Ya[m].color||"#fff","stop-opacity":void 0===Ya[m].opacity?1:Ya[m].opacity}));P.defs.appendChild(p)}Fa(b,p);d(t,{fill:"url('"+a._url+"#"+c+"')",opacity:1,"fill-opacity":1});qb.fill="";qb.opacity=1;return qb.fillOpacity=1},Ca=function(b){var k=b.getBBox(1);d(b.pattern,{patternTransform:b.matrix.invert()+" translate("+k.x+","+k.y+")"})},V=function(b,f,h){if("path"==b.type){for(var E=k(f).toLowerCase().split("-"),u=b.paper,z=h?"end":"start",B=b.node,G=b.attrs,Y=
G["stroke-width"],P=E.length,c="classic",Fa,wa,g=3,ta=3,Ca=5;P--;)switch(E[P]){case "block":case "classic":case "oval":case "diamond":case "open":case "none":c=E[P];break;case "wide":ta=5;break;case "narrow":ta=2;break;case "long":g=5;break;case "short":g=2}"open"==c?(g+=2,ta+=2,Ca+=2,Fa=1,wa=h?4:1,E={fill:"none",stroke:G.stroke}):(wa=Fa=g/2,E={fill:G.stroke,stroke:"none"});b._.arrows?h?(b._.arrows.endPath&&e[b._.arrows.endPath]--,b._.arrows.endMarker&&e[b._.arrows.endMarker]--):(b._.arrows.startPath&&
e[b._.arrows.startPath]--,b._.arrows.startMarker&&e[b._.arrows.startMarker]--):b._.arrows={};if("none"!=c){var P="raphael-marker-"+c,V="raphael-marker-"+z+c+g+ta+"-obj"+b.id;a._g.doc.getElementById(P)?e[P]++:(u.defs.appendChild(d(d("path"),{"stroke-linecap":"round",d:xa[c],id:P})),e[P]=1);var l=a._g.doc.getElementById(V);l?(e[V]++,g=l.getElementsByTagName("use")[0]):(l=d(d("marker"),{id:V,markerHeight:ta,markerWidth:g,orient:"auto",refX:wa,refY:ta/2}),g=d(d("use"),{"xlink:href":"#"+P,transform:(h?
"rotate(180 "+g/2+" "+ta/2+") ":"")+"scale("+g/Ca+","+ta/Ca+")","stroke-width":(1/((g/Ca+ta/Ca)/2)).toFixed(4)}),l.appendChild(g),u.defs.appendChild(l),e[V]=1);d(g,E);u=Fa*("diamond"!=c&&"oval"!=c);h?(h=b._.arrows.startdx*Y||0,Y=a.getTotalLength(G.path)-u*Y):(h=u*Y,Y=a.getTotalLength(G.path)-(b._.arrows.enddx*Y||0));E={};E["marker-"+z]="url('"+a._url+"#"+V+"')";if(Y||h)E.d=a.getSubpath(G.path,h,Y);d(B,E);b._.arrows[z+"Path"]=P;b._.arrows[z+"Marker"]=V;b._.arrows[z+"dx"]=u;b._.arrows[z+"Type"]=c;b._.arrows[z+
"String"]=f}else h?(h=b._.arrows.startdx*Y||0,Y=a.getTotalLength(G.path)-h):(h=0,Y=a.getTotalLength(G.path)-(b._.arrows.enddx*Y||0)),b._.arrows[z+"Path"]&&d(B,{d:a.getSubpath(G.path,h,Y)}),delete b._.arrows[z+"Path"],delete b._.arrows[z+"Marker"],delete b._.arrows[z+"dx"],delete b._.arrows[z+"Type"],delete b._.arrows[z+"String"];for(E in e)e.hasOwnProperty(E)&&!e[E]&&(b=a._g.doc.getElementById(E))&&b.parentNode.removeChild(b)}},l={"":["none"],none:["none"],"-":[3,1],".":[1,1],"-.":[3,1,1,1],"-..":[3,
1,1,1,1,1],". ":[1,3],"- ":[4,3],"--":[8,3],"- .":[4,3,1,3],"--.":[8,3,1,3],"--..":[8,3,1,3,1,3]},q=function(b,f,h){var E=l[k(f).toLowerCase()],u,z,B;if(f=E||void 0!==f&&[].concat(f)){u=b.attrs["stroke-width"]||1;h={round:u,square:u,butt:0}[h["stroke-linecap"]||b.attrs["stroke-linecap"]]||0;z=f.length;B=E?u:1;if("none"==f[0])E=f;else for(E=[];z--;)E[z]=f[z]*B+(z%2?1:-1)*h,0>=E[z]&&(E[z]=.01+(1>=u?h:0)),isNaN(E[z])&&(E[z]=0);a.is(f,"array")&&d(b.node,{"stroke-dasharray":E.join(",")})}},t=function(b,
k){for(var f in k)c("raphael.attr."+f+"."+b.id,b,k[f],f),b.ca[f]&&b.attr(f,k[f])},qb=a._setFillAndStroke=function(b,f){if(b.paper.canvas){var E=b.node,B=b.attrs,G=b.paper,c=E.style,xa=c.visibility;f&&f.text&&f.text.replace&&(f.text=f.text.replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&<br\/>lt;|&l<br\/>t;|&lt<br\/>;/g,"<<br/>").replace(/&<br\/>gt;|&g<br\/>t;|&gt<br\/>;/g,"><br/>"));c.visibility="hidden";for(var e in f)if(f.hasOwnProperty(e)&&a._availableAttrs.hasOwnProperty(e)){var wa=f[e];B[e]=
wa;switch(e){case "blur":b.blur(wa);break;case "href":case "title":case "target":var g=E.parentNode;if("a"!=g.tagName.toLowerCase()){if(""==wa)break;var l=d("a");l.raphael=!0;l.raphaelid=E.raphaelid;g.insertBefore(l,E);l.appendChild(E);g=l}"target"==e?g.setAttributeNS("http://www.w3.org/1999/xlink","show","blank"==wa?"new":wa):g.setAttributeNS("http://www.w3.org/1999/xlink",e,wa);E.titleNode=g;break;case "cursor":c.cursor=wa;break;case "transform":b.transform(wa);break;case "rotation":a.is(wa,"array")?
b.rotate.apply(b,wa):b.rotate(wa);break;case "arrow-start":V(b,wa);break;case "arrow-end":V(b,wa,1);break;case "clip-path":var t=!0;case "clip-rect":g=!t&&k(wa).split(Y);b._.clipispath=!!t;if(t||4==g.length){b.clip&&b.clip.parentNode.parentNode.removeChild(b.clip.parentNode);var l=d("clipPath"),qb=d(t?"path":"rect");l.id=a.getElementID(a.createUUID());d(qb,t?{d:wa?B["clip-path"]=a._pathToAbsolute(wa):a._availableAttrs.path,fill:"none"}:{x:g[0],y:g[1],width:g[2],height:g[3],transform:b.matrix.invert()});
l.appendChild(qb);G.defs.appendChild(l);d(E,{"clip-path":"url('"+a._url+"#"+l.id+"')"});b.clip=qb}!wa&&(wa=E.getAttribute("clip-path"))&&((wa=a._g.doc.getElementById(wa.replace(/(^url\(#|\)$)/g,"")))&&wa.parentNode.removeChild(wa),d(E,{"clip-path":""}),11===document.documentMode&&E.removeAttribute("clip-path"),delete b.clip);break;case "path":"path"==b.type&&(d(E,{d:wa?B.path=a._pathToAbsolute(wa):a._availableAttrs.path}),b._.dirty=1,b._.arrows&&("startString"in b._.arrows&&V(b,b._.arrows.startString),
"endString"in b._.arrows&&V(b,b._.arrows.endString,1)));break;case "width":if(E.setAttribute(e,wa),b._.dirty=1,B.fx)e="x",wa=B.x;else break;case "x":B.fx&&(wa=-B.x-(B.width||0));case "rx":if("rx"==e&&"rect"==b.type)break;case "cx":E.setAttribute(e,wa);b.pattern&&Ca(b);b._.dirty=1;break;case "height":if(E.setAttribute(e,wa),b._.dirty=1,B.fy)e="y",wa=B.y;else break;case "y":B.fy&&(wa=-B.y-(B.height||0));case "ry":if("ry"==e&&"rect"==b.type)break;case "cy":E.setAttribute(e,wa);b.pattern&&Ca(b);b._.dirty=
1;break;case "r":"rect"==b.type?d(E,{rx:wa,ry:wa}):E.setAttribute(e,wa);b._.dirty=1;break;case "src":"image"==b.type&&E.setAttributeNS("http://www.w3.org/1999/xlink","href",wa);break;case "stroke-width":if(1!=b._.sx||1!=b._.sy)wa/=u(z(b._.sx),z(b._.sy))||1;G._vbSize&&(wa*=G._vbSize);P&&0===wa&&(wa=1E-6);E.setAttribute(e,wa);B["stroke-dasharray"]&&q(b,B["stroke-dasharray"],f);b._.arrows&&("startString"in b._.arrows&&V(b,b._.arrows.startString),"endString"in b._.arrows&&V(b,b._.arrows.endString,1));
break;case "stroke-dasharray":q(b,wa,f);break;case "fill":var p=k(wa).match(a._ISURL);if(p){var l=d("pattern"),Ya=d("image");l.id=a.getElementID(a.createUUID());d(l,{x:0,y:0,patternUnits:"userSpaceOnUse",height:1,width:1});d(Ya,{x:0,y:0,"xlink:href":p[1]});l.appendChild(Ya);(function(b){a._preload(p[1],function(){var k=this.offsetWidth,f=this.offsetHeight;d(b,{width:k,height:f});d(Ya,{width:k,height:f});G.safari()})})(l);G.defs.appendChild(l);c.fill="url('"+a._url+"#"+l.id+"')";d(E,{fill:c.fill});
b.pattern=l;b.pattern&&Ca(b);break}g=a.getRGB(wa);if(!g.error)delete f.gradient,delete B.gradient,!a.is(B.opacity,"undefined")&&a.is(f.opacity,"undefined")&&d(E,{opacity:B.opacity}),!a.is(B["fill-opacity"],"undefined")&&a.is(f["fill-opacity"],"undefined")&&d(E,{"fill-opacity":B["fill-opacity"]}),b.gradient&&Fa(b);else if(("circle"==b.type||"ellipse"==b.type||"r"!=k(wa).charAt())&&ta(b,wa)){if("opacity"in B||"fill-opacity"in B)if(g=a._g.doc.getElementById(E.getAttribute("fill").replace(/^url\(#|\)$/g,
"")))g=g.getElementsByTagName("stop"),d(g[g.length-1],{"stop-opacity":("opacity"in B?B.opacity:1)*("fill-opacity"in B?B["fill-opacity"]:1)});B.gradient=wa;B.fill="none";c.fill="";break}g.hasOwnProperty("opacity")?(d(E,{"fill-opacity":c.fillOpacity=1<g.opacity?g.opacity/100:g.opacity}),b._.fillOpacityDirty=!0):b._.fillOpacityDirty&&a.is(B["fill-opacity"],"undefined")&&a.is(f["fill-opacity"],"undefined")&&(E.removeAttribute("fill-opacity"),c.fillOpacity="",delete b._.fillOpacityDirty);case "stroke":g=
a.getRGB(wa);E.setAttribute(e,g.hex);c[e]=g.hex;"stroke"==e&&(g.hasOwnProperty("opacity")?(d(E,{"stroke-opacity":c.strokeOpacity=1<g.opacity?g.opacity/100:g.opacity}),b._.strokeOpacityDirty=!0):b._.strokeOpacityDirty&&a.is(B["stroke-opacity"],"undefined")&&a.is(f["stroke-opacity"],"undefined")&&(E.removeAttribute("stroke-opacity"),c.strokeOpacity="",delete b._.strokeOpacityDirty),b._.arrows&&("startString"in b._.arrows&&V(b,b._.arrows.startString),"endString"in b._.arrows&&V(b,b._.arrows.endString,
1)));break;case "gradient":"circle"!=b.type&&"ellipse"!=b.type&&"r"==k(wa).charAt()||ta(b,wa);break;case "line-height":case "vertical-align":break;case "visibility":"hidden"===wa?b.hide():b.show();break;case "opacity":B.gradient&&!B.hasOwnProperty("stroke-opacity")&&d(E,{"stroke-opacity":1<wa?wa/100:wa});case "fill-opacity":if(B.gradient){if(g=a._g.doc.getElementById(E.getAttribute("fill").replace(/^url\(#|\)$/g,"")))g=g.getElementsByTagName("stop"),d(g[g.length-1],{"stop-opacity":wa});break}default:"font-size"==
e&&(wa=h(wa,10)+"px"),g=e.replace(/(\-.)/g,function(b){return b.substring(1).toUpperCase()}),c[g]=wa,b._.dirty=1,E.setAttribute(e,wa)}}"text"===b.type&&!f["_do-not-tune"]&&m(b,f);c.visibility=xa}},p=a._updateFollowers=function(){var b,k,f,h=arguments,E=pa.call(h),u=pa.call(h);b=0;for(k=E.followers.length;b<k;b++)f=E.followers[b].el,f[u].apply(f,h)},m=function(b,h){if("text"==b.type&&(h.hasOwnProperty("text")||h.hasOwnProperty("font")||h.hasOwnProperty("font-size")||h.hasOwnProperty("x")||h.hasOwnProperty("y")||
h.hasOwnProperty("line-height")||h.hasOwnProperty("vertical-align"))){var u=b.attrs,z=b.node,B=z.firstChild&&a._g.doc.defaultView.getComputedStyle(z.firstChild,""),G=B?f(a._g.doc.defaultView.getComputedStyle(z.firstChild,"").getPropertyValue("font-size")):10,Y=f(h["line-height"]||u["line-height"])||1.2*G,P=u.hasOwnProperty("vertical-align")?u["vertical-align"]:"middle",c=(h.direction||(B?B.getPropertyValue("direction"):"initial")).toLowerCase(),xa=!!document.documentMode;isNaN(Y)&&(Y=1.2*G);a.is(h.text,
"array")&&(h.text=h.text.join("<br>"));P="top"===P?-.5:"bottom"===P?.5:0;if(h.hasOwnProperty("text")&&(h.text!==u.text||b._textdirty)){for(u.text=h.text;z.firstChild;)z.removeChild(z.firstChild);for(var e=k(h.text).split(/\n|<br\s*?\/?>/ig),G=[],Fa=0,wa=e.length;Fa<wa;Fa++)B=d("tspan"),Fa?d(B,{dy:Y,x:u.x}):d(B,{dy:Y*e.length*P,x:u.x}),e[Fa]||(B.setAttributeNS("http://www.w3.org/XML/1998/namespace","xml:space","preserve"),e[Fa]=" "),B.appendChild(a._g.doc.createTextNode(e[Fa])),z.appendChild(B),G[Fa]=
B,!xa&&"rtl"===c&&Fa<wa-1&&(B=d("tspan"),d(B,{visibility:"hidden","font-size":"0px"}),B.appendChild(a._g.doc.createTextNode("i")),z.appendChild(B));b._textdirty=!1}else for(G=z.getElementsByTagName("tspan"),Fa=xa=0,wa=G.length;Fa<wa;Fa++)if(B=G[Fa],c=B.attributes[0],!c||"visibility"!==c.name&&"visibility"!==c.nodeName||"hidden"!==c.value&&"hidden"!==c.nodeValue)Fa?d(B,{dy:Y,x:u.x}):(c=G[1]&&G[1].attributes[0],!c||"visibility"!==c.name&&"visibility"!==c.nodeName||"hidden"!==c.value&&"hidden"!==c.nodeValue||
(xa=E.floor(.5*G.length)),d(G[0],{dy:Y*(G.length-xa)*P,x:u.x}));d(z,{x:u.x,y:u.y});b._.dirty=1;z=b._getBBox();Y=u.y-(z.y+z.height/2);if(z.isCalculated)switch(u["vertical-align"]){case "top":Y=.75*z.height;break;case "bottom":Y=-(.25*z.height);break;default:Y=u.y-(z.y+.25*z.height)}Y&&a.is(Y,"finite")&&G[0]&&d(G[0],{dy:Y})}},Ya=function(b,k,f){f=f||k;f.canvas&&f.canvas.appendChild(b);this.node=this[0]=b;b.raphael=!0;b.raphaelid=this.id=a._oid++;this.matrix=a.matrix();this.realPath=null;this.attrs=
this.attrs||{};this.followers=this.followers||[];this.paper=k;this.ca=this.customAttributes=this.customAttributes||new k._CustomAttributes;this._={transform:[],sx:1,sy:1,deg:0,dx:0,dy:0,dirty:1};this.parent=f;!f.bottom&&(f.bottom=this);(this.prev=f.top)&&(f.top.next=this);f.top=this;this.next=null},rb=a.el;Ya.prototype=rb;rb.constructor=Ya;a._engine.getNode=function(b){b=b.node||b[0].node;return b.titleNode||b};a._engine.getLastNode=function(b){b=b.node||b[b.length-1].node;return b.titleNode||b};
rb.rotate=function(b,h,E){if(this.removed)return this;p(this,"rotate",b,h,E);b=k(b).split(Y);b.length-1&&(h=f(b[1]),E=f(b[2]));b=f(b[0]);null==E&&(h=E);if(null==h||null==E)E=this.getBBox(1),h=E.x+E.width/2,E=E.y+E.height/2;this.transform(this._.transform.concat([["r",b,h,E]]));return this};rb.scale=function(b,h,E,u){var z;if(this.removed)return this;p(this,"scale",b,h,E,u);b=k(b).split(Y);b.length-1&&(h=f(b[1]),E=f(b[2]),u=f(b[3]));b=f(b[0]);null==h&&(h=b);null==u&&(E=u);if(null==E||null==u)z=this.getBBox(1);
E=null==E?z.x+z.width/2:E;u=null==u?z.y+z.height/2:u;this.transform(this._.transform.concat([["s",b,h,E,u]]));return this};rb.translate=function(b,h){if(this.removed)return this;p(this,"translate",b,h);b=k(b).split(Y);b.length-1&&(h=f(b[1]));b=f(b[0])||0;this.transform(this._.transform.concat([["t",b,+h||0]]));return this};rb.transform=function(b){var k=this._;if(null==b)return k.transform;a._extractTransform(this,b);this.clip&&!k.clipispath&&d(this.clip,{transform:this.matrix.invert()});this.pattern&&
Ca(this);this.node&&d(this.node,{transform:this.matrix});if(1!=k.sx||1!=k.sy)b=this.attrs.hasOwnProperty("stroke-width")?this.attrs["stroke-width"]:1,this.attr({"stroke-width":b});return this};rb.hide=function(){p(this,"hide");!this.removed&&this.paper.safari(this.node.style.display="none");return this};rb.show=function(){p(this,"show");!this.removed&&this.paper.safari(this.node.style.display="");return this};rb.remove=function(){if(!this.removed&&this.parent.canvas){var b=a._engine.getNode(this),
k=this.paper,f=k.defs;k.__set__&&k.__set__.exclude(this);c.unbind("raphael.*.*."+this.id);for(this.gradient&&f&&Fa(this);f=this.followers.pop();)f.el.remove();for(;f=this.bottom;)f.remove();this._drag&&this.undrag();if(this.events)for(;f=this.events.pop();)f.unbind();this.parent.canvas.removeChild(b);this.removeData();delete k._elementsById[this.id];a._tear(this,this.parent);for(f in this)this[f]="function"===typeof this[f]?a._removedFactory(f):null;this.removed=!0}};rb._getBBox=function(){var k,
f=this.node,h={},E=this.attrs,u,z,a="text"===this.type,B=!!document.documentMode;B&&a?k=b(this):"none"===f.style.display&&(this.show(),z=!0);try{h=f.getBBox(),a&&(void 0===h.x&&(h.isCalculated=!0,u=E["text-anchor"],h.x=(E.x||0)-h.width*("start"===u?0:"middle"===u?.5:1)),void 0===h.y&&(h.isCalculated=!0,u=E["vertical-align"],h.y=(E.y||0)-h.height*("bottom"===u?1:"middle"===u?.5:0)))}catch(G){}finally{h=h||{}}B&&a?k&&k():z&&this.hide();return h};rb.attr=function(b,k){if(this.removed)return this;if(null==
b){var f={},h;for(h in this.attrs)this.attrs.hasOwnProperty(h)&&(f[h]=this.attrs[h]);f.gradient&&"none"==f.fill&&(f.fill=f.gradient)&&delete f.gradient;f.transform=this._.transform;f.visibility="none"===this.node.style.display?"hidden":"visible";return f}if(null==k&&a.is(b,"string")){if("fill"==b&&"none"==this.attrs.fill&&this.attrs.gradient)return this.attrs.gradient;if("transform"==b)return this._.transform;if("visibility"==b)return"none"===this.node.style.display?"hidden":"visible";var f=b.split(Y),
E={},u=0;for(h=f.length;u<h;u++)b=f[u],b in this.attrs?E[b]=this.attrs[b]:a.is(this.ca[b],"function")?E[b]=this.ca[b].def:E[b]=a._availableAttrs[b];return h-1?E:E[f[0]]}if(null==k&&a.is(b,"array")){E={};u=0;for(h=b.length;u<h;u++)E[b[u]]=this.attr(b[u]);return E}null!=k?(f={},f[b]=k):null!=b&&a.is(b,"object")&&(f=b);if(!1!==a.stopEvent)for(u in f)c("raphael.attr."+u+"."+this.id,this,f[u],u);var z={};for(u in this.ca)if(this.ca[u]&&f.hasOwnProperty(u)&&a.is(this.ca[u],"function")&&!this.ca["_invoked"+
u]){this.ca["_invoked"+u]=!0;h=this.ca[u].apply(this,[].concat(f[u]));delete this.ca["_invoked"+u];for(E in h)h.hasOwnProperty(E)&&(f[E]=h[E]);this.attrs[u]=f[u];!1===h&&(z[u]=f[u],delete f[u])}qb(this,f);var B,u=0;for(h=this.followers.length;u<h;u++)B=this.followers[u],B.cb&&!B.cb.call(B.el,f,this)||B.el.attr(f);for(E in z)f[E]=z[E];return this};rb.blur=function(b){if(0!==+b){var k=d("filter"),f=d("feGaussianBlur");this.attrs.blur=b;k.id=a.getElementID(a.createUUID());d(f,{stdDeviation:+b||1.5});
k.appendChild(f);this.paper.defs.appendChild(k);this._blur=k;d(this.node,{filter:"url('"+a._url+"#"+k.id+"')"})}else this._blur&&(this._blur.parentNode.removeChild(this._blur),delete this._blur,delete this.attrs.blur),this.node.removeAttribute("filter")};rb.on=function(b,k){if(this.removed)return this;var f=k;a.supportsTouch&&(b=a._touchMap[b]||"click"===b&&"touchstart"||b,f=function(b){b.preventDefault();k()});this.node["on"+b]=f;return this};a._engine.path=function(b,k,f){var h=d("path");b=new Ya(h,
b,f);b.type="path";qb(b,k);t(b,k);return b};a._engine.group=function(b,k,f){var h=d("g");b=new Ya(h,b,f);b.type="group";b.canvas=b.node;b.top=b.bottom=null;b._id=k||"";k&&h.setAttribute("class","raphael-group-"+b.id+"-"+k);return b};a._engine.circle=function(b,k,f){var h=d("circle");b=new Ya(h,b,f);b.type="circle";qb(b,k);t(b,k);return b};a._engine.rect=function(b,k,f){var h=d("rect");b=new Ya(h,b,f);b.type="rect";k.rx=k.ry=k.r;qb(b,k);t(b,k);return b};a._engine.ellipse=function(b,k,f){var h=d("ellipse");
b=new Ya(h,b,f);b.type="ellipse";qb(b,k);t(b,k);return b};a._engine.image=function(b,k,f){var h=d("image");b=new Ya(h,b,f);b.type="image";h.setAttribute("preserveAspectRatio","none");qb(b,k);t(b,k);return b};a._engine.text=function(b,k,f,h){var E=d("text");b=new Ya(E,b,f);b.type="text";b._textdirty=!0;h&&b.css&&b.css(h,void 0,!0);qb(b,k);t(b,k);return b};a._engine.setSize=function(b,k){this.width=b||this.width;this.height=k||this.height;this.canvas.setAttribute("width",this.width);this.canvas.setAttribute("height",
this.height);this._viewBox&&this.setViewBox.apply(this,this._viewBox);return this};a._engine.create=function(){var b=a._getContainer.apply(0,arguments),k=b&&b.container,f=b.x,h=b.y,E=b.width,b=b.height;if(!k)throw Error("SVG container not found.");var u=d("svg"),z;z="overflow:hidden;-webkit-tap-highlight-color:rgba(0,0,0,0);-webkit-user-select:none;-moz-user-select:-moz-none;-khtml-user-select:none;-ms-user-select:none;user-select:none;-o-user-select:none;cursor:default;vertical-align:middle;";var B,
f=f||0,h=h||0,E=E||512,b=b||342;d(u,{height:b,version:1.1,width:E,xmlns:"http://www.w3.org/2000/svg"});1==k?(u.style.cssText=z+"position:absolute;left:"+f+"px;top:"+h+"px",a._g.doc.body.appendChild(u),B=1):(u.style.cssText=z+"position:relative",k.firstChild?k.insertBefore(u,k.firstChild):k.appendChild(u));k=new a._Paper;k.width=E;k.height=b;k.canvas=u;d(u,{id:"raphael-paper-"+k.id});k.clear();k._left=k._top=0;B&&(k.renderfix=function(){});k.renderfix();return k};a._engine.setViewBox=function(b,k,
f,h,E){c("raphael.setViewBox",this,this._viewBox,[b,k,f,h,E]);var z=u(f/this.width,h/this.height),a=this.top,B=E?"meet":"xMinYMin",G;null==b?(this._vbSize&&(z=1),delete this._vbSize,G="0 0 "+this.width+" "+this.height):(this._vbSize=z,G=b+" "+k+" "+f+" "+h);for(d(this.canvas,{viewBox:G,preserveAspectRatio:B});z&&a;)B="stroke-width"in a.attrs?a.attrs["stroke-width"]:1,a.attr({"stroke-width":B}),a._.dirty=1,a._.dirtyT=1,a=a.prev;this._viewBox=[b,k,f,h,!!E];return this};a.prototype.renderfix=function(){var b=
this.canvas,k=b.style,f;try{f=b.getScreenCTM()||b.createSVGMatrix()}catch(h){f=b.createSVGMatrix()}b=-f.e%1;f=-f.f%1;if(b||f)b&&(this._left=(this._left+b)%1,k.left=this._left+"px"),f&&(this._top=(this._top+f)%1,k.top=this._top+"px")};a.prototype._desc=function(b){var k=this.desc;if(k)for(;k.firstChild;)k.removeChild(k.firstChild);else this.desc=k=d("desc"),this.canvas.appendChild(k);k.appendChild(a._g.doc.createTextNode(a.is(b,"string")?b:"Created with Red Raphaël "+a.version))};a.prototype.clear=
function(){var b;for(c("raphael.clear",this);b=this.bottom;)b.remove();for(b=this.canvas;b.firstChild;)b.removeChild(b.firstChild);this.bottom=this.top=null;b.appendChild(this.desc=d("desc"));b.appendChild(this.defs=d("defs"))};a.prototype.remove=function(){var b;for(c("raphael.remove",this);b=this.bottom;)b.remove();this.defs&&this.defs.parentNode.removeChild(this.defs);this.desc&&this.desc.parentNode.removeChild(this.desc);this.canvas.parentNode&&this.canvas.parentNode.removeChild(this.canvas);
for(b in this)this[b]="function"==typeof this[b]?a._removedFactory(b):null;this.removed=!0};var C=a.st,bb;for(bb in rb)rb.hasOwnProperty(bb)&&!C.hasOwnProperty(bb)&&(C[bb]=function(b){return function(){var k=arguments;return this.forEach(function(f){f[b].apply(f,k)})}}(bb))}})();"undefined"===typeof m&&"object"===typeof window&&(m=window);(function(){if(a.vml){var b=String,k=parseFloat,f=Math,h=f.round,E=f.max,u=f.min,z=f.sqrt,B=f.abs,G=/[, ]+/,Y=a.eve,P={M:"m",L:"l",C:"c",Z:"x",m:"t",l:"r",c:"v",
z:"x"},c=/([clmz]),?([^clmz]*)/gi,xa=/ progid:\S+Blur\([^\)]+\)/g,e=/-?[^,\s-]+/g,Fa={path:1,rect:1,image:1},wa={circle:1,ellipse:1},d=function(k){var f=/[ahqstv]/ig,E=a._pathToAbsolute;b(k).match(f)&&(E=a._path2curve);f=/[clmz]/g;if(E==a._pathToAbsolute&&!b(k).match(f))return(k=b(k).replace(c,function(b,k,f){var E=[],u="m"==k.toLowerCase(),z=P[k];f.replace(e,function(b){u&&2==E.length&&(z+=E+P["m"==k?"l":"L"],E=[]);E.push(h(21600*b))});return z+E}))||"m0,0";var f=E(k),u;k=[];for(var z=0,B=f.length;z<
B;z++){E=f[z];u=f[z][0].toLowerCase();"z"==u&&(u="x");for(var G=1,Y=E.length;G<Y;G++)u+=h(21600*E[G])+(G!=Y-1?",":"");k.push(u)}return k.length?k.join(" "):"m0,0"},g=function(b,k,f){var h=a.matrix();h.rotate(-b,.5,.5);return{dx:h.x(k,f),dy:h.y(k,f)}},ta=function(b,k,f,h,E,u){var z=b._,a=b.matrix,G=z.fillpos;b=b.node;var Y=b.style,P=1,c="",xa=21600/k,e=21600/f;Y.visibility="hidden";if(k&&f){b.coordsize=B(xa)+" "+B(e);Y.rotation=u*(0>k*f?-1:1);u&&(E=g(u,h,E),h=E.dx,E=E.dy);0>k&&(c+="x");0>f&&(c+=" y")&&
(P=-1);Y.flip=c;b.coordorigin=h*-xa+" "+E*-e;if(G||z.fillsize)if(h=(h=b.getElementsByTagName("fill"))&&h[0])b.removeChild(h),G&&(E=g(u,a.x(G[0],G[1]),a.y(G[0],G[1])),h.position=E.dx*P+" "+E.dy*P),z.fillsize&&(h.size=z.fillsize[0]*B(k)+" "+z.fillsize[1]*B(f)),b.appendChild(h);Y.visibility="visible"}};a._url="";a.toString=function(){return"Your browser doesn’t support SVG. Falling down to VML.\nYou are running Raphaël "+this.version};var Ca=function(k,f,h){f=b(f).toLowerCase().split("-");h=h?"end":
"start";for(var E=f.length,u="classic",z="medium",a="medium";E--;)switch(f[E]){case "block":case "classic":case "oval":case "diamond":case "open":case "none":u=f[E];break;case "wide":case "narrow":a=f[E];break;case "long":case "short":z=f[E]}k=k.node.getElementsByTagName("stroke")[0];k[h+"arrow"]=u;k[h+"arrowlength"]=z;k[h+"arrowwidth"]=a},V=function(b,k){for(var f in k)Y("raphael.attr."+f+"."+b.id,b,k[f],f),b.ca[f]&&b.attr(f,k[f])},l=a._setFillAndStroke=function(f,z){if(f.paper.canvas){f.attrs=f.attrs||
{};var B=f.node,Y=f.attrs,P=B.style,c=Fa[f.type]&&(z.x!=Y.x||z.y!=Y.y||z.width!=Y.width||z.height!=Y.height||z.cx!=Y.cx||z.cy!=Y.cy||z.rx!=Y.rx||z.ry!=Y.ry||z.r!=Y.r),xa=wa[f.type]&&(Y.cx!=z.cx||Y.cy!=z.cy||Y.r!=z.r||Y.rx!=z.rx||Y.ry!=z.ry),e="group"===f.type,g;for(g in z)z.hasOwnProperty(g)&&(Y[g]=z[g]);c&&(Y.path=a._getPath[f.type](f),f._.dirty=1);z.href&&(B.href=z.href);z.title&&(B.title=z.title);z.target&&(B.target=z.target);z.cursor&&(P.cursor=z.cursor);"blur"in z&&f.blur(z.blur);if(z.path&&
"path"==f.type||c)B.path=d(~b(Y.path).toLowerCase().indexOf("r")?a._pathToAbsolute(Y.path):Y.path),"image"==f.type&&(f._.fillpos=[Y.x,Y.y],f._.fillsize=[Y.width,Y.height],ta(f,1,1,0,0,0));"transform"in z&&f.transform(z.transform);"rotation"in z&&(P=z.rotation,a.is(P,"array")?f.rotate.apply(f,P):f.rotate(P));"visibility"in z&&("hidden"===z.visibility?f.hide():f.show());xa&&(P=+Y.cx,xa=+Y.cy,c=+Y.rx||+Y.r||0,g=+Y.ry||+Y.r||0,B.path=a.format("ar{0},{1},{2},{3},{4},{1},{4},{1}x",h(21600*(P-c)),h(21600*
(xa-g)),h(21600*(P+c)),h(21600*(xa+g)),h(21600*P)));"clip-rect"in z&&(P=b(z["clip-rect"]).split(G),4==P.length&&(P[0]=+P[0],P[1]=+P[1],P[2]=+P[2]+P[0],P[3]=+P[3]+P[1],c=e?B:B.clipRect||a._g.doc.createElement("div"),xa=c.style,e?(f.clip=P.slice(),c=f.matrix.offset(),c=[k(c[0]),k(c[1])],P[0]-=c[0],P[1]-=c[1],P[2]-=c[0],P[3]-=c[1],xa.width="1px",xa.height="1px"):B.clipRect||(xa.top="0",xa.left="0",xa.width=f.paper.width+"px",xa.height=f.paper.height+"px",B.parentNode.insertBefore(c,B),c.appendChild(B),
c.raphael=!0,c.raphaelid=B.raphaelid,B.clipRect=c),xa.position="absolute",xa.clip=a.format("rect({1}px {2}px {3}px {0}px)",P)),z["clip-rect"]||(e&&f.clip?(B.style.clip="rect(0px 10800px 10800px 0px)",delete f.clip):B.clipRect&&(B.clipRect.style.clip="rect(0px 10800px 10800px 0px)")));if(f.textpath||e)e=e?B.style:f.textpath.style,z.font&&(e.font=z.font),z["font-family"]&&(e.fontFamily='"'+z["font-family"].split(",")[0].replace(/^['"]+|['"]+$/g,"")+'"'),z["font-size"]&&(e.fontSize=z["font-size"]),z["font-weight"]&&
(e.fontWeight=z["font-weight"]),z["font-style"]&&(e.fontStyle=z["font-style"]);"arrow-start"in z&&Ca(f,z["arrow-start"]);"arrow-end"in z&&Ca(f,z["arrow-end"],1);if(null!=z.opacity||null!=z["stroke-width"]||null!=z.fill||null!=z.src||null!=z.stroke||null!=z["stroke-width"]||null!=z["stroke-opacity"]||null!=z["fill-opacity"]||null!=z["stroke-dasharray"]||null!=z["stroke-miterlimit"]||null!=z["stroke-linejoin"]||null!=z["stroke-linecap"]){e=B.getElementsByTagName("fill");P=-1;e=e&&e[0];!e&&(e=p("fill"));
"image"==f.type&&z.src&&(e.src=z.src);z.fill&&(e.on=!0);if(null==e.on||"none"==z.fill||null===z.fill)e.on=!1;e.on&&z.fill&&((xa=b(z.fill).match(a._ISURL))?(e.parentNode==B&&B.removeChild(e),e.rotate=!0,e.src=xa[1],e.type="tile",c=f.getBBox(1),e.position=c.x+" "+c.y,f._.fillpos=[c.x,c.y],a._preload(xa[1],function(){f._.fillsize=[this.offsetWidth,this.offsetHeight]})):(xa=a.getRGB(z.fill),e.color=xa.hex,e.src="",e.type="solid",xa.error&&(f.type in{circle:1,ellipse:1}||"r"!=b(z.fill).charAt())&&t(f,
z.fill,e)?(Y.fill="none",Y.gradient=z.fill,e.rotate=!1):"opacity"in xa&&!("fill-opacity"in z)&&(P=xa.opacity)));if(-1!==P||"fill-opacity"in z||"opacity"in z)xa=((+Y["fill-opacity"]+1||2)-1)*((+Y.opacity+1||2)-1)*((+P+1||2)-1),xa=u(E(xa,0),1),e.opacity=xa,e.src&&(e.color="none");B.appendChild(e);e=B.getElementsByTagName("stroke")&&B.getElementsByTagName("stroke")[0];P=!1;!e&&(P=e=p("stroke"));if(z.stroke&&"none"!=z.stroke||z["stroke-width"]||null!=z["stroke-opacity"]||z["stroke-dasharray"]||z["stroke-miterlimit"]||
z["stroke-linejoin"]||z["stroke-linecap"])e.on=!0;"none"!=z.stroke&&null!==z.stroke&&null!=e.on&&0!=z.stroke&&0!=z["stroke-width"]||(e.on=!1);xa=a.getRGB("stroke"in z?z.stroke:Y.stroke);e.on&&z.stroke&&(e.color=xa.hex);xa=((+Y["stroke-opacity"]+1||2)-1)*((+Y.opacity+1||2)-1)*((+xa.opacity+1||2)-1);c=.75*(k(z["stroke-width"])||1);xa=u(E(xa,0),1);null==z["stroke-width"]&&(c=Y["stroke-width"]);z["stroke-width"]&&(e.weight=c);c&&1>c&&(xa*=c)&&(e.weight=1);e.opacity=xa;z["stroke-linejoin"]&&(e.joinstyle=
z["stroke-linejoin"])||P&&(P.joinstyle="miter");e.miterlimit=z["stroke-miterlimit"]||8;z["stroke-linecap"]&&(e.endcap="butt"==z["stroke-linecap"]?"flat":"square"==z["stroke-linecap"]?"square":"round");z["stroke-dasharray"]&&(xa={"-":"shortdash",".":"shortdot","-.":"shortdashdot","-..":"shortdashdotdot",". ":"dot","- ":"dash","--":"longdash","- .":"dashdot","--.":"longdashdot","--..":"longdashdotdot"},e.dashstyle=xa.hasOwnProperty(z["stroke-dasharray"])?xa[z["stroke-dasharray"]]:z["stroke-dasharray"].join&&
z["stroke-dasharray"].join(" ")||"");P&&B.appendChild(e)}if("text"==f.type){f.paper.canvas.style.display="";B=f.paper.span;e=Y.font&&Y.font.match(/\d+(?:\.\d*)?(?=px)/);xa=Y["line-height"]&&(Y["line-height"]+"").match(/\d+(?:\.\d*)?(?=px)/);P=B.style;Y.font&&(P.font=Y.font);Y["font-family"]&&(P.fontFamily=Y["font-family"]);Y["font-weight"]&&(P.fontWeight=Y["font-weight"]);Y["font-style"]&&(P.fontStyle=Y["font-style"]);e=k(Y["font-size"]||e&&e[0])||10;P.fontSize=100*e+"px";xa=k(Y["line-height"]||xa&&
xa[0])||12;Y["line-height"]&&(P.lineHeight=100*xa+"px");a.is(z.text,"array")&&(z.text=f.textpath.string=z.text.join("\n").replace(/<br\s*?\/?>/ig,"\n"));f.textpath.string&&(B.innerHTML=b(f.textpath.string).replace(/</g,"&#60;").replace(/&/g,"&#38;").replace(/\n/g,"<br>"));B=B.getBoundingClientRect();f.W=Y.w=(B.right-B.left)/100;f.H=Y.h=(B.bottom-B.top)/100;f.X=Y.x;f.Y=Y.y;switch(Y["vertical-align"]){case "top":f.bby=f.H/2;break;case "bottom":f.bby=-f.H/2;break;default:f.bby=0}("x"in z||"y"in z||void 0!==
f.bby)&&(f.path.v=a.format("m{0},{1}l{2},{1}",h(21600*Y.x),h(21600*(Y.y+(f.bby||0))),h(21600*Y.x)+1));B="x y text font font-family font-weight font-style font-size line-height".split(" ");e=0;for(P=B.length;e<P;e++)if(B[e]in z){f._.dirty=1;break}switch(Y["text-anchor"]){case "start":f.textpath.style["v-text-align"]="left";f.bbx=f.W/2;break;case "end":f.textpath.style["v-text-align"]="right";f.bbx=-f.W/2;break;default:f.textpath.style["v-text-align"]="center",f.bbx=0}f.textpath.style["v-text-kern"]=
!0}}},q=a._updateFollowers=function(){var b,k,f,h=arguments,E=pa.call(h),u=pa.call(h);b=0;for(k=E.followers.length;b<k;b++)f=E.followers[b].el,f[u].apply(f,h)},t=function(f,h,E){f.attrs=f.attrs||{};var u=Math.pow,B="linear",G=".5 .5";f.attrs.gradient=h;h=b(h).replace(a._radial_gradient,function(b,f){B="radial";f=f&&f.split(",")||[];var h=f[3],E=f[4];h&&E&&(h=k(h),E=k(E),.25<u(h-.5,2)+u(E-.5,2)&&(E=z(.25-u(h-.5,2))*(2*(.5<E)-1)+.5),G=h+" "+E);return""});h=h.split(/\s*\-\s*/);if("linear"==B){var Y=
h.shift(),Y=-k(Y);if(isNaN(Y))return null}h=a._parseDots(h);if(!h)return null;f=f.shape||f.node;if(h.length){E.parentNode==f&&f.removeChild(E);E.on=!0;E.method="none";E.color=h[0].color;E.color2=h[h.length-1].color;for(var P=[],c=1,xa=void 0===h[0].opacity?1:h[0].opacity,e=0,Fa=h.length;e<Fa;e++)h[e].offset&&P.push(h[e].offset+" "+h[e].color),void 0!==h[e].opacity&&(c=h[e].opacity);E.colors=P.length?P.join():"0% "+E.color;E.opacity=c;E["o:opacity2"]=xa;"radial"==B?(E.type="gradientTitle",E.focus=
"100%",E.focussize="0 0",E.focusposition=G,E.angle=0):(E.type="gradient",E.angle=(270-Y)%360);f.appendChild(E)}return 1},qb=function(b,k,f){f=f||k;var h;f.canvas&&f.canvas.appendChild(b);h=p("skew");h.on=!0;b.appendChild(h);this.skew=h;this.node=this[0]=b;b.raphael=!0;b.raphaelid=this.id=a._oid++;this.Y=this.X=0;this.attrs=this.attrs||{};this.followers=this.followers||[];this.paper=k;this.ca=this.customAttributes=this.customAttributes||new k._CustomAttributes;this.matrix=a.matrix();this._={transform:[],
sx:1,sy:1,dx:0,dy:0,deg:0,dirty:1,dirtyT:1};this.parent=f;!f.bottom&&(f.bottom=this);(this.prev=f.top)&&(f.top.next=this);f.top=this;this.next=null},f=a.el;qb.prototype=f;f.constructor=qb;f.transform=function(k){if(null==k)return this._.transform;var f=this.paper._viewBoxShift,h=f?"s"+[f.scale,f.scale]+"-1-1t"+[f.dx,f.dy]:"",E;f&&(E=k=b(k).replace(/\.{3}|\u2026/g,this._.transform||""));a._extractTransform(this,h+k);var f=this.matrix.clone(),u=this.skew;k=this.node;var h=~b(this.attrs.fill).indexOf("-"),
z=!b(this.attrs.fill).indexOf("url(");f.translate(-.5,-.5);z||h||"image"==this.type?(u.matrix="1 0 0 1",u.offset="0 0",u=f.split(),h&&u.noRotation||!u.isSimple?(k.style.filter=f.toFilter(),f=this.getBBox(),h=this.getBBox(1),z=f.x2&&h.x2&&"x2"||"x",u=f.y2&&h.y2&&"y2"||"y",z=f[z]-h[z],f=f[u]-h[u],k.coordorigin=-21600*z+" "+-21600*f,ta(this,1,1,z,f,0)):(k.style.filter="",ta(this,u.scalex,u.scaley,u.dx,u.dy,u.rotate))):(k.style.filter="",u.matrix=b(f),u.offset=f.offset());E&&(this._.transform=E);return this};
f.rotate=function(f,h,E){if(this.removed)return this;q(this,"rotate",f,h,E);if(null!=f){f=b(f).split(G);f.length-1&&(h=k(f[1]),E=k(f[2]));f=k(f[0]);null==E&&(h=E);if(null==h||null==E)E=this.getBBox(1),h=E.x+E.width/2,E=E.y+E.height/2;this._.dirtyT=1;this.transform(this._.transform.concat([["r",f,h,E]]));return this}};f.translate=function(f,h){if(this.removed)return this;q(this,"translate",f,h);f=b(f).split(G);f.length-1&&(h=k(f[1]));f=k(f[0])||0;h=+h||0;this._.bbox&&(this._.bbox.x+=f,this._.bbox.y+=
h);this.transform(this._.transform.concat([["t",f,h]]));return this};f.scale=function(f,h,E,u){if(this.removed)return this;q(this,"scale",f,h,E,u);f=b(f).split(G);f.length-1&&(h=k(f[1]),E=k(f[2]),u=k(f[3]),isNaN(E)&&(E=null),isNaN(u)&&(u=null));f=k(f[0]);null==h&&(h=f);null==u&&(E=u);if(null==E||null==u)var z=this.getBBox(1);E=null==E?z.x+z.width/2:E;u=null==u?z.y+z.height/2:u;this.transform(this._.transform.concat([["s",f,h,E,u]]));this._.dirtyT=1;return this};f.hide=function(b){q(this,"hide",b);
!this.removed&&(this.node.style.display="none");return this};f.show=function(b){q(this,"show",b);!this.removed&&(this.node.style.display="");return this};f._getBBox=function(){return this.removed?{}:{x:this.X+(this.bbx||0)-this.W/2,y:this.Y+(this.bby||0)-this.H/2,width:this.W,height:this.H}};f.remove=function(){if(!this.removed&&this.parent.canvas){var b=a._engine.getNode(this),k=this.paper,f=this.shape;k.__set__&&k.__set__.exclude(this);Y.unbind("raphael.*.*."+this.id);f&&f.parentNode.removeChild(f);
for(b.parentNode&&b.parentNode.removeChild(b);b=this.followers.pop();)b.el.remove();for(;b=this.bottom;)b.remove();this._drag&&this.undrag();if(this.events)for(;b=this.events.pop();)b.unbind();this.removeData();delete k._elementsById[this.id];a._tear(this,this.parent);for(b in this)this[b]="function"===typeof this[b]?a._removedFactory(b):null;this.removed=!0}};f.attr=function(b,k){if(this.removed)return this;if(null==b){var f={},h;for(h in this.attrs)this.attrs.hasOwnProperty(h)&&(f[h]=this.attrs[h]);
f.gradient&&"none"==f.fill&&(f.fill=f.gradient)&&delete f.gradient;f.transform=this._.transform;f.visibility="none"===this.node.style.display?"hidden":"visible";return f}if(null==k&&a.is(b,"string")){if("fill"==b&&"none"==this.attrs.fill&&this.attrs.gradient)return this.attrs.gradient;if("visibility"==b)return"none"===this.node.style.display?"hidden":"visible";var f=b.split(G),E={},u=0;for(h=f.length;u<h;u++)b=f[u],b in this.attrs?E[b]=this.attrs[b]:a.is(this.ca[b],"function")?E[b]=this.ca[b].def:
E[b]=a._availableAttrs[b];return h-1?E:E[f[0]]}if(this.attrs&&null==k&&a.is(b,"array")){E={};u=0;for(h=b.length;u<h;u++)E[b[u]]=this.attr(b[u]);return E}null!=k&&(f={},f[b]=k);null==k&&a.is(b,"object")&&(f=b);if(!1!==a.stopEvent)for(u in f)Y("raphael.attr."+u+"."+this.id,this,f[u],u);if(f){var z={};for(u in this.ca)if(this.ca[u]&&f.hasOwnProperty(u)&&a.is(this.ca[u],"function")&&!this.ca["_invoked"+u]){this.ca["_invoked"+u]=!0;h=this.ca[u].apply(this,[].concat(f[u]));delete this.ca["_invoked"+u];
for(E in h)h.hasOwnProperty(E)&&(f[E]=h[E]);this.attrs[u]=f[u];!1===h&&(z[u]=f[u],delete f[u])}"text"in f&&"text"==this.type&&(a.is(f.text,"array")&&(f.text=f.text.join("\n")),this.textpath.string=f.text.replace(/<br\s*?\/?>/ig,"\n"));l(this,f);var B,u=0;for(h=this.followers.length;u<h;u++)B=this.followers[u],B.cb&&!B.cb.call(B.el,f,this)||B.el.attr(f);for(E in z)f[E]=z[E]}return this};f.blur=function(b){var k=this.node.runtimeStyle,f=k.filter,f=f.replace(xa,"");0!==+b?(this.attrs.blur=b,k.filter=
f+"  progid:DXImageTransform.Microsoft.Blur(pixelradius="+(+b||1.5)+")",k.margin=a.format("-{0}px 0 0 -{0}px",h(+b||1.5))):(k.filter=f,k.margin=0,delete this.attrs.blur);return this};f.on=function(b,k){if(this.removed)return this;this.node["on"+b]=function(){var b=a._g.win.event;b.target=b.srcElement;k(b)};return this};a._engine.getNode=function(b){b=b.node||b[0].node;return b.clipRect||b};a._engine.getLastNode=function(b){b=b.node||b[b.length-1].node;return b.clipRect||b};a._engine.group=function(b,
k,f){var h=a._g.doc.createElement("div"),E=new qb(h,b,f);h.style.cssText="position:absolute;left:0;top:0;width:1px;height:1px";E._id=k||"";k&&(h.className="raphael-group-"+E.id+"-"+k);(f||b).canvas.appendChild(h);E.type="group";E.canvas=E.node;E.transform=a._engine.group.transform;E.top=null;E.bottom=null;return E};a._engine.group.transform=function(f){if(null==f)return this._.transform;var h=this.node.style,E=this.clip,u=this.paper._viewBoxShift,z=u?"s"+[u.scale,u.scale]+"-1-1t"+[u.dx,u.dy]:"";u&&
(f=b(f).replace(/\.{3}|\u2026/g,this._.transform||""));a._extractTransform(this,z+f);f=this.matrix;z=f.offset();u=k(z[0])||0;z=k(z[1])||0;h.left=u+"px";h.top=z+"px";h.zoom=(this._.tzoom=f.get(0))+"";E&&(h.clip=a.format("rect({1}px {2}px {3}px {0}px)",[E[0]-u,E[1]-z,E[2]-u,E[3]-z]));return this};a._engine.path=function(b,k,f){var h=p("shape");h.style.cssText="position:absolute;left:0;top:0;width:1px;height:1px";h.coordsize="21600 21600";h.coordorigin=b.coordorigin;b=new qb(h,b,f);b.type=k.type||"path";
b.path=[];b.Path="";k.type&&delete k.type;l(b,k);V(b,k);return b};a._engine.rect=function(b,k,f){var h=a._rectPath(k.x,k.y,k.w,k.h,k.r);k.path=h;k.type="rect";b=b.path(k,f);k=b.attrs;b.X=k.x;b.Y=k.y;b.W=k.width;b.H=k.height;k.path=h;return b};a._engine.ellipse=function(b,k,f){k.type="ellipse";b=b.path(k,f);k=b.attrs;b.X=k.x-k.rx;b.Y=k.y-k.ry;b.W=2*k.rx;b.H=2*k.ry;return b};a._engine.circle=function(b,k,f){k.type="circle";b=b.path(k,f);k=b.attrs;b.X=k.x-k.r;b.Y=k.y-k.r;b.W=b.H=2*k.r;return b};a._engine.image=
function(b,k,f){var h=a._rectPath(k.x,k.y,k.w,k.h);k.path=h;k.type="image";k.stroke="none";b=b.path(k,f);f=b.attrs;var h=b.node,E=h.getElementsByTagName("fill")[0];f.src=k.src;b.X=f.x=k.x;b.Y=f.y=k.y;b.W=f.width=k.w;b.H=f.height=k.h;E.parentNode==h&&h.removeChild(E);E.rotate=!0;E.src=f.src;E.type="tile";b._.fillpos=[f.x,f.y];b._.fillsize=[f.w,f.h];h.appendChild(E);ta(b,1,1,0,0,0);return b};a._engine.text=function(k,f,E,u){var z=p("shape"),B=p("path"),G=p("textpath");x=f.x||0;y=f.y||0;text=f.text;
B.v=a.format("m{0},{1}l{2},{1}",h(21600*f.x),h(21600*f.y),h(21600*f.x)+1);B.textpathok=!0;G.string=b(f.text).replace(/<br\s*?\/?>/ig,"\n");G.on=!0;z.style.cssText="position:absolute;left:0;top:0;width:1px;height:1px";z.coordsize="21600 21600";z.coordorigin="0 0";k=new qb(z,k,E);k.shape=z;k.path=B;k.textpath=G;k.type="text";k.attrs.text=b(f.text||"");k.attrs.x=f.x;k.attrs.y=f.y;k.attrs.w=1;k.attrs.h=1;u&&k.css&&k.css(u,void 0,!0);l(k,f);V(k,f);z.appendChild(G);z.appendChild(B);return k};a._engine.setSize=
function(b,k){var f=this.canvas.style;this.width=b;this.height=k;b==+b&&(b+="px");k==+k&&(k+="px");b&&(f.width=b);k&&(f.height=k);f.clip="rect(0 "+f.width+" "+f.height+" 0)";this._viewBox&&a._engine.setViewBox.apply(this,this._viewBox);return this};a._engine.setViewBox=function(b,k,f,h,u){Y("raphael.setViewBox",this,this._viewBox,[b,k,f,h,u]);var z=this.width,B=this.height,a=1/E(f/z,h/B),G,P;u&&(G=B/h,P=z/f,f*G<z&&(b-=(z-f*G)/2/G),h*P<B&&(k-=(B-h*P)/2/P));this._viewBox=[b,k,f,h,!!u];this._viewBoxShift=
{dx:-b,dy:-k,scale:a};this.forEach(function(b){b.transform("...")});return this};var p;a._engine.initWin=function(k){var f=k.document;f.createStyleSheet().addRule(".rvml","behavior:url(#default#VML)");try{!f.namespaces.rvml&&f.namespaces.add("rvml","urn:schemas-microsoft-com:vml"),p=a._createNode=function(k,h){var E=f.createElement("<rvml:"+k+' class="rvml">'),u;for(u in h)E[u]=b(h[u]);return E}}catch(h){p=a._createNode=function(k,h){var E=f.createElement("<"+k+' xmlns="urn:schemas-microsoft.com:vml" class="rvml">'),
u;for(u in h)E[u]=b(h[u]);return E}}};a._engine.initWin(a._g.win);a._engine.create=function(){var b=a._getContainer.apply(0,arguments),k=b.container,f=b.height,h=b.width,E=b.x,b=b.y;if(!k)throw Error("VML container not found.");var u=new a._Paper,z=u.canvas=a._g.doc.createElement("div"),B=z.style,E=E||0,b=b||0,h=h||512,f=f||342;u.width=h;u.height=f;h==+h&&(h+="px");f==+f&&(f+="px");u.coordsize="21600000 21600000";u.coordorigin="0 0";z.id="raphael-paper-"+u.id;u.span=a._g.doc.createElement("span");
u.span.style.cssText="position:absolute;left:-9999em;top:-9999em;padding:0;margin:0;line-height:1;";z.appendChild(u.span);B.cssText=a.format("top:0;left:0;width:{0};height:{1};display:inline-block;cursor:default;position:relative;clip:rect(0 {0} {1} 0);overflow:hidden",h,f);1==k?(a._g.doc.body.appendChild(z),B.left=E+"px",B.top=b+"px",B.position="absolute"):k.firstChild?k.insertBefore(z,k.firstChild):k.appendChild(z);u.renderfix=function(){};return u};a.prototype.clear=function(){var b;for(Y("raphael.clear",
this);b=this.bottom;)b.remove();this.canvas.innerHTML="";this.span=a._g.doc.createElement("span");this.span.style.cssText="position:absolute;left:-9999em;top:-9999em;padding:0;margin:0;line-height:1;display:inline;";this.canvas.appendChild(this.span);this.bottom=this.top=null};a.prototype.remove=function(){var b;for(Y("raphael.remove",this);b=this.bottom;)b.remove();this.canvas.parentNode.removeChild(this.canvas);for(b in this)this[b]="function"==typeof this[b]?a._removedFactory(b):null;return!0};
var Ya=a.st,m;for(m in f)f.hasOwnProperty(m)&&!Ya.hasOwnProperty(m)&&(Ya[m]=function(b){return function(){var k=arguments;return this.forEach(function(f){f[b].apply(f,k)})}}(m))}})();ba&&(T.win.Raphael=a);return a},!0);g.Raphael=n;g.Raphael.desc="";D&&D!==n?m.Raphael=D:m.Raphael===n&&(m.Raphael=void 0)})(m||window)}]);FusionCharts.register("module",["private","fusioncharts.redraphael.helper",function(){var g=this.hcLib,m=g.Raphael,D={};m.fn._elementFromEvent=function(g){if(!g||this.removed)return null;
var m=g.srcElement||g.target||(g=g.originalEvent)&&(g.srcElement||g.target)||D;"tspan"===m.nodeName&&(m=m.parentNode);return this.getById(m.raphaelid)};m.requestAnimFrame=g.schedular.addJob&&function(m){g.schedular.addJob(m,void 0,void 0,g.priorityList.animation)}}]);FusionCharts.register("module",["private","fusioncharts.redraphael.css",function(){var g=this.hcLib,m=g.Raphael,D=m.eve,n=m._g,F=m.fn,A=m.el,J=/[, ]+/,a=/\B([A-Z]{1})/g,O,d;O=function(a){this.styleSheet="";this.rules={};this.ns=a||""};
d=O.prototype;d.getSheet=function(){var a=this.node;this.styleSheet=d.getStyleSheet("fusioncharts-raphael-stylesheet");this.styleSheet||(a=this.node=n.doc.createElement("style"),a.setAttribute("id",m.format("raphael-stylesheet-{0}",m._oid++)),a.setAttribute("type","text/css"),a.setAttribute("title","fusioncharts-raphael-stylesheet"),(n.doc.head||n.doc.getElementsByTagName("head")[0]).appendChild(this.node),this.styleSheet=d.getStyleSheet("fusioncharts-raphael-stylesheet"));return this.styleSheet};
d.getStyleSheet=function(a){for(var d=n.doc.styleSheets,g=d.length,m;g--;)if(m=d[g],m.title===a)return m};d.applyCSSRule=function(a,d){var g=this.styleSheet,m;if(!g)if(a&&d)g=this.getSheet();else return;m=(g.rules||g.cssRules||{}).length||0;g.insertRule?g.insertRule(a+"{"+d+"}",m):g.addRule&&g.addRule(a,d,m)};d.removeCSS=function(a){var d=this.styleSheet,g=d.rules||d.cssRules||{},m=g.length||0,r;for(a=a||this.ns;m--;)r=g[m],(new RegExp(a)).test(r.selectorText)&&(d.removeRule?d.removeRule(m):d.deleteRule(m))};
d.destroy=function(){this.removeCSS();delete this.node;delete this.styleSheet;delete this.ns;delete this.rules};d.clear=function(){this.removeCSS();this.rules={}};d.add=function(d,g,m){var n,r="",p=this.rules[d]||(this.rules[d]={}),c=m?"":"\t";m=m?":":": ";for(n in g)(p[n]=g[n])&&(r+=c+n.replace(a,"-$1").toLowerCase()+m+p[n]+";");this.applyCSSRule(d,r)};d.render=function(){this.setCssText()};d.setCssText=function(d){var g=d?"":"\t";d=d?":":": ";var m="",n="",r,p;for(r in this.rules){m="";n=r.replace(/(^|\,)/g,
"$1"+this.ns+" ");r=this.rules[r];for(p in r)r[p]&&(m+=g+p.replace(a,"-$1").toLowerCase()+d+r[p]+";");this.applyCSSRule(n,m)}};D.on("raphael.new",function(){this._stylesheet=this._stylesheet||new O;this.cssNamespace("")});D.on("raphael.remove",function(){this._stylesheet&&this._stylesheet.destroy();delete this._stylesheet});F.cssNamespace=function(a){arguments.length&&(this._stylesheet.ns=m.format("{0}#raphael-paper-{1}",a&&a+" "||"",this.id));return this._stylesheet.ns};F.cssAddRule=function(a,d){if(1===
arguments.length&&"object"===typeof a){for(var g in a)this.cssAddRule(g,a[g]);return this}return this._stylesheet.add(a,d),this};F.cssRender=function(){return m.svg&&this._stylesheet.render(),this};F.cssClear=function(){return this._stylesheet.clear(),this};m.ca["class"]=function(a){var d=this.node,g=this.paper,n="."+a,g=g._stylesheet&&g._stylesheet.rules,r=this.parent,p=this.attrs,c={},v;if(m.svg)a=a||"",d.setAttribute("class","group"===this.type&&this._id?"raphael-group-"+this.id+"-"+this._id+" "+
a:a);else if(m.vml&&(d.className="group"===this.type?a&&this._id+" "+a||this._id:"rvml "+a,n&&g)){a=g[n];for(v in a)"color"===v&&"text"===this.type&&(v="fill"),!p[v]&&(c[v]=a[v]);for(;r&&r.attr;){if(a=r.attr("class"))for(v in n="."+a+" "+n,a=g[n],a)"color"===v&&"text"===this.type&&(v="fill"),p[v]||c[v]||(c[v]=a[v]);r=r.parent}this.css(c)}};A.css=function(a,d,g){var n,r;if(this.removed)return this;this.styles||(this.styles={});if(null==d&&m.is(a,"string")){g=a.split(J);n={};r=0;for(d=g.length;r<d;r++)a=
g[r],a in this.styles&&(n[a]=this.styles[a]);return d-1?n:n[g[0]]}if(null==d&&m.is(a,"array")){n={};r=0;for(d=a.length;r<d;r++)n[a[r]]=this.styles(a[r]);return n}null!=d?(n={},n[a]=d):null!=a&&m.is(a,"object")&&(n=a);a={};for(r in n)d=r.replace(/\B([A-Z]{1})/g,"-$1").toLowerCase(),m._availableAttrs.hasOwnProperty(d)||"color"===d?("color"===d&&"text"===this.type&&(d="fill"),a[d]=n[r],a.dirty=!0):(D("raphael.css."+d+"."+this.id,this,n[r],d),this.node.style[d]=n[r],this.styles[d]=n[r]);r=0;for(d=this.followers.length;r<
d;r++)this.followers[r].el.attr(n);a.hasOwnProperty("dirty")&&(delete a.dirty,g&&(a["_do-not-tune"]=!0),this.attr(a));return this};A.removeCSS=function(a){var d,n,w;!a&&(a=g.appliedCSS);if(this.removed)return this;m.is(a,"string")&&(a=a.split(","));if(m.is(a,"array"))for(w=a.length,n=0;n<w;n++)d=a[n].replace(/\B([A-Z]{1})/g,"-$1").toLowerCase(),this.node.removeAttribute(d),this.node.style[d]="";return this}}]);FusionCharts.register("module",["private","modules.renderer.js-raphaelexport",function(){var g=
this.hcLib,m=g.Raphael,D=g.pluckNumber,n=g.pluck,F=m._availableAttrs,A=/^matrix\(|\)$/g,J=/\,/g,a=/\n|<br\s*?\/?>/ig,O=/[^\d\.]/ig,d=/[\%\(\)\s,\xb0#]/g,l=/group/ig,N=/&/g,ga=/"/g,w=/'/g,r=/</g,p=/>/g,c=0;(function(g){var m=Math,e=parseFloat,q=m.max,H=m.abs,t=m.pow,L=String,K=/[, ]+/,pa=[{reg:/xmlns\=\"http\:\/\/www.w3.org\/2000\/svg\"/ig,repStr:""},{reg:/^.*<svg /,repStr:'<svg xmlns:xlink="http://www.w3.org/1999/xlink" xmlns="http://www.w3.org/2000/svg" '},{reg:/\/svg>.*$/,repStr:"/svg>"},{reg:/<desc\>[^<]*<\/desc\>/,
repStr:""},{reg:/zIndex="[^"]+"/g,repStr:""},{reg:/url\((\\?[\'\"])[^#]+#/g,repStr:"url($1#"},{reg:/ href=/g,repStr:" xlink:href="},{reg:/(id|class|width|height)=([^" >]+)/g,repStr:'$1="$2"'},{reg:/:(path|rect)/g,repStr:"$1"},{reg:/<ima?ge? ([^\>]+?[^\/])\>/gi,repStr:"<image $1 />"},{reg:/<\/ima?ge?\>/g,repStr:""},{reg:/style="([^"]+)"/g,repStr:function(a){return a.toLowerCase()}}],S={blur:function(){},transform:function(){},src:function(a,c){c.attrSTR+=' xlink:href="'+c.attrs.src+'"'},path:function(a,
c){var e=c.attrs.path,e=g._pathToAbsolute(e||"");c.attrSTR+=' d="'+(e.toString&&e.toString()||"").replace(J," ")+'"'},gradient:function(a,c,l){var p=a.attrs.gradient,n="linear",r,w,ra,V=.5,va=.5,K=w="",La="",A,Ma,T,Wa;r=p.replace(d,"_");if(!l[r]){p=L(p).replace(g._radial_gradient,function(a,c){var d,g,q,l,p,C,r;c=c&&c.split(",")||[];n="radial";d=c[0];g=c[1];q=c[2];l=c[3];p=c[4];Wa=c[5];r=d&&g;q&&(T=/\%/.test(q)?q:e(q));if("userSpaceOnUse"===Wa)return r&&(V=d,va=g),l&&p&&(A=l,Ma=p,r||(V=A,va=Ma)),
"";r&&(V=e(d),va=e(g),d=2*(.5<va)-1,.25<(C=t(V-.5,2))+t(va-.5,2)&&.25>C&&(va=m.sqrt(.25-C)*d+.5)&&.5!==va&&(va=va.toFixed(5)-1E-5*d));l&&p&&(A=e(l),Ma=e(p),d=2*(.5<Ma)-1,.25<(C=t(A-.5,2))+t(Ma-.5,2)&&.25>C&&(Ma=m.sqrt(.25-C)*d+.5)&&.5!==Ma&&(Ma=Ma.toFixed(5)-1E-5*d),r||(V=A,va=Ma));return""});p=p.split(/\s*\-\s*/);if("linear"===n){w=p.shift();w=-e(w);if(isNaN(w))return null;ra=[0,0,m.cos(g.rad(w)),m.sin(g.rad(w))];w=1/(q(H(ra[2]),H(ra[3]))||1);ra[2]*=w;ra[3]*=w;0>ra[2]&&(ra[0]=-ra[2],ra[2]=0);0>ra[3]&&
(ra[1]=-ra[3],ra[3]=0)}p=g._parseDots(p);if(!p)return null;"radial"===n?(w='<radialGradient fx = "'+V+'" fy = "'+va+'" cy = "'+Ma+'" cx = "'+A+'" r = "'+T+'" gradientUnits = "'+Wa+'" id = "'+r+'">',K="</radialGradient>"):(w='<linearGradient x1 = "'+ra[0]+'" y1 = "'+ra[1]+'" x2 = "'+ra[2]+'" y2 = "'+ra[3]+'" gradientTransform ="matrix('+a.matrix.invert()+')" id = "'+r+'">',K="</linearGradient>");a=0;for(ra=p.length;a<ra;a++)La+='<stop offset="'+(p[a].offset?p[a].offset:a?"100%":"0%")+'" stop-color="'+
(p[a].color||"#fff")+'" stop-opacity="'+(void 0===p[a].opacity?1:p[a].opacity)+'" />';l[r]=!0;l.str+=w+La+K}c.attrSTR+=" fill=\"url('#"+r+"')\""},fill:function(a,c){var e=c.attrs,d=e.fill,q;a.attrs.gradient||(d=g.color(d),q=d.opacity,"text"===a.type?c.styleSTR+="fill:"+d+"; stroke-opacity:0; ":(c.attrSTR+=' fill="'+d+'"',e["fill-opacity"]||!q&&0!==q||(c.attrSTR+=' fill-opacity="'+q+'"')))},stroke:function(a,c){var e=c.attrs,d,q;d=g.color(e.stroke);q=d.opacity;"text"!==a.type&&(c.attrSTR+=' stroke="'+
d+'"',e["stroke-opacity"]||!q&&0!==q||(c.attrSTR+=' stroke-opacity="'+q+'"'))},"clip-rect":function(a,e,g){var q=L(e.attrs["clip-rect"]),l=q.split(K),q=q.replace(d,"_")+"__"+c++;4===l.length&&(g[q]||(g[q]=!0,g.str+='<clipPath id="'+q+'"><rect x="'+l[0]+'" y="'+l[1]+'" width="'+l[2]+'" height="'+l[3]+'" transform="matrix('+a.matrix.invert().toMatrixString().replace(A,"")+')"/></clipPath>'),e.attrSTR+=' clip-path="url(#'+q+')"')},cursor:function(a,c){var e=c.attrs.cursor;e&&(c.styleSTR+="cursor:"+e+
"; ")},font:function(a,c){c.styleSTR+="font:"+c.attrs.font.replace(/\"/ig," ")+"; "},"font-size":function(a,c){var e=n(c.attrs["font-size"],"10");e&&e.replace&&(e=e.replace(O,""));c.styleSTR+="font-size:"+e+"px; "},"font-weight":function(a,c){c.styleSTR+="font-weight:"+c.attrs["font-weight"]+"; "},"font-family":function(a,c){c.styleSTR+="font-family:"+c.attrs["font-family"]+"; "},"line-height":function(){},"clip-path":function(){},visibility:function(){},"vertical-align":function(){},"text-anchor":function(a,
c){var e=c.attrs["text-anchor"]||"middle";"text"===a.type&&(c.attrSTR+=' text-anchor="'+e+'"')},title:function(){},text:function(c,e){var d=e.attrs,g=d.text,q=n(d["font-size"],d.font,"10"),l=n(d["line-height"]),t,m,V;q&&q.replace&&(q=q.replace(O,""));q=D(q);l&&l.replace&&(l=l.replace(O,""));l=D(l,q&&1.2*q);t=q?.85*q:.75*l;q=d.x;m=n(d["vertical-align"],"middle").toLowerCase();g=L(g).split(a);V=g.length;d=0;for(t="top"===m?t:"bottom"===m?t-l*V:t-l*V*.5;d<V;d++)e.textSTR+="<tspan ",m=(g[d]||"").replace(N,
"&amp;").replace(ga,"&quot;").replace(w,"&#39;").replace(r,"&lt;").replace(p,"&gt;"),e.textSTR=d?e.textSTR+('dy="'+l+'" x="'+q+'" '):e.textSTR+('dy="'+t+'"'),e.textSTR+=">"+m+"</tspan>"}},T=function(a,c){var e="",d={attrSTR:"",styleSTR:"",textSTR:"",attrs:a.attr()},g=a.isShadow,q="",t="",m,V,p=d.attrs;if("none"===a.node.style.display||g)a.next&&(e+=T(a.next,c));else{for(m in p)if("gradient"!==m&&(void 0!==F[m]||S[m])&&void 0!==p[m])if(S[m])S[m](a,d,c);else d.attrSTR+=" "+m+'="'+p[m]+'"';a.attrs.gradient&&
S.gradient(a,d,c);"rect"===a.type&&p.r&&(d.attrSTR+=' rx="'+p.r+'" ry="'+p.r+'"');for(V in a.styles)d.styleSTR+=V+":"+a.styles[V]+"; ";"image"===a.type&&(d.attrSTR+=' preserveAspectRatio="none"');if("text"===a.type&&!p["text-anchor"])S["text-anchor"](a,d);a.bottom&&(q=T(a.bottom,c));a.next&&(t=T(a.next,c));g=a.type;g.match(l)&&(g="g");e+="<"+g+' transform="matrix('+a.matrix.toMatrixString().replace(A,"")+')" style="'+d.styleSTR+'"'+d.attrSTR+">"+d.textSTR+q+"</"+g+">"+t}return e},ba=function(a){a=
JSON.stringify(a);a=a.replace(/([a-z]+)([A-Z]+)([a-z]+)/g,function(a,c,e,d){return c+"-"+e.toLowerCase()+d});a=a.replace(/\"\,\"/g,'";"');a=a.replace(/\"/g," ");return a=a=a.replace(/\{|\}/g,"")},aa=function(a,c){var e,d,g,q,l,m=function(a){return a=a.match(/style\s*=/)?a.replace(/(style\s*=")([^"]+)/g,function(a,c,e){return c+g+e}):a.replace(/class\s*="[^"]*"/i,function(a){return a+' style="'+g+'" '})};for(e in c)if(c.hasOwnProperty(e))for(l in d=/\s+/,d=e.split(d),g=ba(c[e]),d)d.hasOwnProperty(l)&&
(q=d[l].trim().replace(".",""),q=new RegExp("<[^>]+("+q+")[^>]+","g"),a=a.replace(q,m));return a};g.fn.toSVG=function(a){var c="",e={str:""},d=0,q=pa.length,l="";if(g.svg){if(this.canvas&&this.canvas.parentNode){for(c=this.canvas.parentNode.innerHTML;d<q;d+=1)e=pa[d],c=c.replace(e.reg,e.repStr);this._stylesheet&&this._stylesheet.rules&&(c=aa(c,this._stylesheet.rules))}a||(c=c.replace(/<image[^\>]*\>/gi,function(a){return a.match(/href=\"data\:image/i)?a:""}))}else c='<svg style="overflow: hidden; position: relative;" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="'+
this.width+'" version="1.1" height="'+this.height+'">',this.bottom&&(l=T(this.bottom,e)),c+="<defs>"+e.str+"</defs>"+l+"</svg>",a||(c=c.replace(/<image[^\>]*\>[^\>]*\>/gi,function(a){return a.match(/href=\"data\:image/i)?a:""}));return c}})(m)}]);FusionCharts.register("module",["private","modules.renderer.js-raphaelshadow",function(){var g=this.window,m=Math.sqrt,D=g.parseFloat,n=g.parseInt,g=g.SVGFilterElement||g.SVGFEColorMatrixElement&&2===g.SVGFEColorMatrixElement.SVG_FECOLORMATRIX_TYPE_SATURATE,
F=this.hcLib.Raphael,A={"drop-shadow":"drop-shadow",stroke:"stroke",fill:"fill","stroke-width":"stroke-width","stroke-opacity":"stroke-opacity","stroke-linecap":"stroke-linecap","stroke-linejoin":"stroke-linejoin","shape-rendering":"shape-rendering",transform:"transform"},J=F._createNode,a;F.svg?(g&&(F.el.dropshadow=function(a,d,g,n){var A=this.node,w=this._.shadowFilter,r=this.paper.cacheShadows||(this.paper.cacheShadows={}),p="drop-shadow"+[a,d,g,n].join(" "),c;if("none"===a){if(w){--w.use;this.node.removeAttribute("filter");
if(!w.use){p=w.hash;for(c in w)a=w[c],a.parentNode&&a.parentNode.removeChild(a),delete w[c];delete r[p]}delete this._.shadowFilter}}else w&&r[p]===w||(w=this.paper.defs.appendChild(J("filter",{id:F.getElementID(F.createUUID()),width:"200%",height:"200%"})),n=F.color(n),n.error&&(n=F.color("rgba(0,0,0,1)")),c=F.pick(n.opacity,1),this._.shadowFilter=r[p]={use:1,filter:w,hash:p,offset:w.appendChild(J("feOffset",{result:"offOut","in":"SourceGraphic",dx:D(a),dy:D(d)})),matrix:w.appendChild(J("feColorMatrix",
{result:"matrixOut","in":"offOut",type:"matrix",values:"0 0 0 0 "+n.r/255+" 0 0 0 0 "+n.g/255+" 0 0 0 0 "+n.b/255+" 0 0 0 "+c+" 0"})),blur:w.appendChild(J("feGaussianBlur",{result:"blurOut","in":"matrixOut",stdDeviation:m(D(g))})),blend:w.appendChild(J("feComposite",{"in":"SourceGraphic",in2:"blurOut",operator:"over"}))},A.setAttribute("filter",'url("'+F._url+"#"+w.id+'")'));return this}),a=function(a,d){var g=this.__shadowscale,m={},n,w;for(w in a)switch(A[w]&&(m[w]=a[w],delete a[w]),w){case "transform":n=
d.matrix.clone();n.translate(this.__shadowx,this.__shadowy);this.transform(n.toTransformString());break;case "stroke-width":a[w]=((m[w]||1)+6-2*this.__shadowlevel)*g}this.attr(a);for(w in m)a[w]=m[w]},F.ca["drop-shadow"]=function(g,d,l,m,A,w){l=this._.shadows||(this._.shadows=[]);var r,p,c,v,D;if(!this.__shadowblocked)if("none"===g)for(;p=l.pop();)p.remove();else for(m=F.color(m),m.error&&(m=F.color("rgba(0,0,0,1)")),A instanceof Array?(r=A[0],A=A[1]):r=A,r=1/F.pick(r,1),A=1/F.pick(A,1),g=F.pick(g,
1)*r,d=F.pick(d,1)*r,r=.05*F.pick(m.opacity,1),c=n(this.attr("stroke-width")||1,10)+6,v=this.matrix.clone(),v.translate(g,d),D=1;3>=D;D++)p=(l[D-1]||this.clone().follow(this,a,!w&&"before")).attr({stroke:m.hex,"stroke-opacity":r*D,"stroke-width":(c-2*D)*A,transform:v.toTransformString(),"stroke-linecap":"round","stroke-linejoin":"round",fill:"none"}),p.__shadowlevel=D,p.__shadowscale=A,p.__shadowx=g,p.__shadowy=d,w&&w.appendChild(p),l.push(p);return!1},F.el.shadow=function(a,d,g,m){var n;g&&g.constructor===
F.el.constructor&&(m=g,g=void 0);"object"===typeof a&&(d&&d.constructor===F.el.constructor&&(m=d),d=a.opacity,g=a.scalefactor,n=!!a.useFilter,a=void 0===a.apply?!!d:a.apply);void 0===d&&(d=1);if(this.dropshadow){if(n)return a&&this.dropshadow(1,1,3,"rgb(64,64,64)")||this.dropshadow("none"),this;this._.shadowFilter&&this.dropshadow("none")}return this.attr("drop-shadow",a?[1,1,3,"rgba(64,64,64,"+d+")",g,m]:"none")}):F.vml?(F.ca["drop-shadow"]=function(a,d,g,m,n,w){var r=this._.shadow,p,c;if(this.isShadow)return!1;
"none"===a?r&&(this._.shadow=r.remove()):(r||(r=this._.shadow=this.clone(),w&&w.appendChild(r.follow(this))||r.follow(this,void 0,"before"),r.attr({fill:"none","fill-opacity":.5,"stroke-opacity":1}).isShadow=!0,0>=r.attr("stroke-width")&&r.attr("stroke-width",1)),w=r.node.runtimeStyle,p=w.filter.replace(/ progid:\S+Blur\([^\)]+\)/g,""),m=F.color(m),m.error&&(m=F.color("rgba(0,0,0,1)")),c=F.pick(m.opacity,1)/5,n=1/F.pick(n,1),a=F.pick(a,1)*n,d=F.pick(d,1)*n,r.translate(a,d),w.filter=p+" progid:DXImageTransform.Microsoft.Blur(pixelRadius="+
D(.4*g)+" makeShadow=True Color="+m.hex+' shadowOpacity="'+c+'");');return!1},F.el.shadow=function(a,d,g,m){g&&g.constructor===F.el.constructor&&(m=g,g=void 0);"object"===typeof a&&(d&&"group"===d.type&&(m=d),d=a.opacity,g=a.scalefactor,a=void 0===a.apply?!!d:a.apply);void 0===d&&(d=1);return this.attr("drop-shadow",a||!d?[1,1,5,"rgba(64,64,64,"+d+")",g,m]:"none")}):F.canvas&&(F.el.shadow=function(){return this})}]);FusionCharts.register("module",["private","modules.renderer.js-raphaelshapes",function(){var g=
this.window,m="createTouch"in g.document,D=/msie/i.test(g.navigator.userAgent)&&!g.opera,n=Math,F=n.cos,A=n.sin,J=n.abs,a=n.pow,O=n.atan2,d=n.tan,l=n.acos,N=n.min,ga=n.round,w=n.PI,r=n.sqrt,p=2*w,c=g.parseInt,v=g.parseFloat,M=String,e=Array.prototype.slice,q=a(2,-24),H="rgba(192,192,192,"+(D?.002:1E-6)+")",t=this.hcLib.Raphael,L=t.eve,K=t._createNode,pa=t._setFillAndStroke,S=t.el.constructor,T={speed:"optimizeSpeed",crisp:"crispEdges",precision:"geometricPrecision"},ba={enabled:!1,"false":!1,0:!1,
disabled:!0,"true":!0,1:!0},aa={Q:"L",Z:"X",q:"l",z:"x",",":" "},I=/,?([achlmqrstvxz]),?/gi,ia=/\s*\,\s*/g,C,za=function(){return this.join(",").replace(I,C)},Ja,na,ea=t._cacher(function(c,e,d,g){return r(a(d-c,2)+a(g-e,2))}),ra=t._cacher(function(a,c,e,d,g){var q=e-a,m=d-c;e=ea(a,c,e,d);return{x:a+q/e*g,y:c+m/e*g}});if(t.svg)L.on("raphael.attr.shape-rendering",function(a,c){var e=this.node;this.attrs[c]=a=T[a]||a||"auto";e.setAttribute(c,a);e.style.shapeRendering=a});else if(t.vml)L.on("raphael.attr.shape-rendering",
function(a){this.node.style.antialias="crisp"!==a});t.define&&t.define([{name:"polypath",polypath:function(){return this.path(void 0,t._lastArgIfGroup(arguments))},ca:{polypath:function(a,e,d,g,q,m){var l,p,n;l=[];a=c(a,10)||0;e=v(e)||0;d=v(d)||0;g=v(g)||0;q=null===q||isNaN(q)?.5*w:t.rad(q);m=null===m||isNaN(m)?0:v(m);p=q;if(2<a)switch(q=2*w/a,m){case 0:for(m=0;m<a;m++)l.push("L",e+g*F(-p),d+g*A(-p)),p+=q;l[0]="M";l.push("Z");break;case 1:for(m=0;m<a;m++)l.push("M",e,d,"L",e+g*F(-p),d+g*A(-p)),p+=
q;break;default:q*=.5;n=g*F(q)*(1-m);for(m=0;m<a;m++)l.push("L",e+g*F(-p),d+g*A(-p)),p+=q,l.push("L",e+n*F(-p),d+n*A(-p)),p+=q;l[0]="M";l.push("Z")}else 0===g?l.push("M",e,d,"L",e,d,"Z"):l.push("M",e-g,d,"A",g,g,0,0,0,e+g,d,"A",g,g,0,0,0,e-g,d,"Z");return{path:l}},r:function(a){var c=this.attrs.polypath;c[3]=a;this.attr("polypath",c);return!1}}},{name:"ringpath",ringpath:function(){return this.path(void 0,t._lastArgIfGroup(arguments))},ca:function(a,c,e,d,g,m){var l=m%p-g%p,t=m-g,n,C,r,v,H,ra;this._.ringangle=
.5*(g+m);J(t)<q?(n=F(g),t=A(g),e=["M",a+e*n,c+e*t,"L",a+d*n,c+d*t,"Z"]):(J(t)>q&&+(J(t)%p<q||p-J(t)%p<q)?(e=["M",a-e,c,"A",e,e,0,0,0,a+e,c,"A",e,e,0,0,0,a-e,c],0!==d&&(e=e.concat(["M",a-d,c,"A",d,d,0,0,1,a+d,c,"A",d,d,0,0,1,a-d,c]))):(n=F(g),t=A(g),C=F(m),m=A(m),l%=p,0>l&&(l+=p),l=l<w?0:1,r=a+e*n,H=c+e*t,v=a+e*C,ra=c+e*m,C=a+d*C,m=c+d*m,.01>J(r-v)&&.01>J(H-ra)&&(r=a+e*F(g+1.745329E-4),H=c+e*A(g+1.745329E-4)),e=["M",r,H,"A",e,e,0,l,1,v,ra,"L",C,m],0!==d&&(n=a+d*n,t=c+d*t,.01>J(C-n)&&.01>J(m-t)&&(n=
a+d*F(g+1.745329E-4),t=c+d*A(g+1.745329E-4)),e.push("A",d,d,0,l,0,n,t))),e.push("Z"));return{path:e}}},{name:"cubepath",cubepath:function(){var a={"stroke-linejoin":"round","shape-rendering":"precision",stroke:"none"},c=arguments,e=c.length-1,d=c[e],g,q;d&&d.constructor===t.el.constructor?c[e]=void 0:d=void 0;e=this.path(a,d);g=this.path(a,d);a=this.path(a,d);a._.cubetop=e.follow(a,void 0,"before");a._.cubeside=g.follow(a,void 0,"before");for(q in t.fn.cubepath.ca)a.ca[q]=t.fn.cubepath.ca[q];return a.attr("cubepath",
[c[0],c[1],c[2],c[3],c[4],c[5]])},fn:{_getBBox2:function(){var a=this._.cubeside.getBBox(),c=this._.cubetop.getBBox(),e=this.getBBox();return{x:e.x+c.height,y:e.y-a.width,width:e.width,height:e.height}}},ca:{cubepath:function(a,c,e,d,g,q){var m=this._.cubetop,l=this._.cubeside;a=a||0;c=c||0;e=e||0;d=d||0;g=g||0;q=q||0;this.attr("path",["M",a+e,c,"l",0,d,-e,0,0,-d,"z"]);m.attr("path",["M",a,c,"l",1,1,e-1,0,0,-1,g,-q,-e,0,"z"]);l.attr("path",["M",a+e-1,c+1,"l",0,d-1,1,0,g,-q,0,-d,-g,q]);return!1},"stroke-linejoin":function(){return{"stroke-linejoin":"round"}},
"drop-shadow":function(a,c,e,d){var g=this._.cubetop,q=this._.cubeside;this.dropshadow&&(g.dropshadow(a,-c,e,d),q.dropshadow(a,-c,e,d));return!1},fill:function(a,c){var e=this._.cubetop,d=this._.cubeside,g=this.attr("cubepath")||[0,0,0,0,0,0],q=g[2],m=g[4],g=g[5],l;a=t.color(a);c?(this.attr("fill",a),e.attr("fill",t.tintshade(a,-.78).rgba),d.attr("fill",t.tintshade(a,-.65).rgba)):(l="opacity"in a?"rgba("+[a.r,a.g,a.b,a.opacity]+")":"rgb("+[a.r,a.g,a.b]+")",this.attr("fill",[270,t.tintshade(l,.55).rgba,
t.tintshade(l,-.65).rgba].join("-")),d.attr("fill",[270,t.tintshade(l,-.75).rgba,t.tintshade(l,-.35).rgba].join("-")),e.attr("fill",[45+t.deg(O(g,m+q)),t.tintshade(l,-.78).rgba,t.tintshade(l,.22).rgba].join("-")));return!1}}},{name:"arcpath",arcpath:function(){return this.path(void 0,t._lastArgIfGroup(arguments))},ca:function(a,c,e,d){var g=(d-90)/180*Math.PI;return{path:["M",a,c-e,"A",e,e,0,180<d?1:0,1,a+e*Math.cos(g),c+e*Math.sin(g)]}}},{name:"scroller",scroller:function(a,c,e,d,g,q,m){var l=this.group("scroller",
m),p=l.attrs,n=l._.scroller={};g=g&&"horizontal"||"vertical";var C,r={},H,w,ra;n.track=this.rect(l).mousedown(function(a){var c=p["scroll-position"];a="horizontal"===p["scroll-orientation"]?a.layerX||a.x:a.layerY||a.y;a=(a-n.anchorOffset)/n.trackLength;C=t.animation({"scroll-position":a},2E3*J(c-a),"easeIn");l.animate(C);L("raphael.scroll.start."+l.id,l,c)}).mouseup(n._mouseupTrack=function(){this.stop(C);L("raphael.scroll.end."+this.id,this,p["scroll-position"])},l,!0);n.anchor=this.rect(l).drag(function(){r["scroll-position"]=
H+arguments[w]/n.trackLength;l.animate(r,0)},function(a,c,e){w="horizontal"===p["scroll-orientation"]?0:1;L("raphael.scroll.start."+l.id,l,H=p["scroll-position"]);e.stopPropagation()},function(){L("raphael.scroll.end."+l.id,l,H=p["scroll-position"])});for(ra in t.fn.scroller.fn)l[ra]=t.fn.scroller.fn[ra];for(ra in t.fn.scroller.ca)l.ca[ra]=t.fn.scroller.ca[ra];p["scroll-orientation"]=g;p["stroke-width"]=1;l.ca["scroll-repaint"]=l.ca["scroll-repaint-"+g];!t.is(q,"object")&&(q={});return l.attr({ishot:!0,
"scroll-display-buttons":q.showButtons&&"arrow"||"none","scroll-display-style":q.displayStyleFlat&&"flat"||"3d","scroll-ratio":v(q.scrollRatio)||1,"scroll-position":v(q.scrollPosition)||0,"scroll-repaint":[a,c,e,d]})},fn:{scroll:function(a,c){var e=this._.scroller;c=c||this;e.callback=function(){return a.apply(c,arguments)};return this},remove:function(){var a=this._.scroller,c;this.attr("scroll-display-buttons","none");a.track.unmouseup(a._mouseupTrack);for(c in a)a[c]&&a[c].remove&&a[c].remove(),
a[c]=null;delete this._.scroller;t.el.remove.apply(this,arguments)}},ca:{"stroke-width":function(){return!1},"drop-shadow":function(a,c,e,d,g,q){this._.scroller.track.attr("drop-shadow",[a,c,e,d,g,q]);return!1},"scroll-display-style":function(a){var c=this.attrs,e=c["scroll-display-style"],d=c.fill;a={flat:"flat","3d":"3d",transparent:"transparent"}[a]||e;d&&a!==e&&(c["scroll-display-style"]=a,this.attr("fill",d));return{"scroll-display-style":a}},"scroll-display-buttons":function(a){var c=this,e=
c.paper,d=c._.scroller,g=c.attrs,q=g["scroll-display-buttons"],m=g["scroll-repaint"],l,p;void 0===q&&(q="none");a={none:"none",arrow:"arrow"}[a]||q;a!==q&&(g["scroll-display-buttons"]=a,"none"===a&&d.start?(d.arrowstart.remove(),delete d.arrowstart,d.arrowend.remove(),delete d.arrowend,d.start.unmouseup(d._mouseupStart),d.start.remove(),delete d.start,d.end.unmouseup(d._mouseupEnd),d.end.remove(),delete d.end):(d.arrowstart=e.polypath(c),d.arrowend=e.polypath(c),d.start=e.rect(c).mousedown(function(){var a;
0!==(a=g["scroll-position"])&&(c.animate({"scroll-position":a-.1},100).animate(l=t.animation({"scroll-position":0},4500*a,"easeIn")),L("raphael.scroll.start."+c.id,c,a))}).mouseup(d._mouseupStart=function(){c.stop(l);L("raphael.scroll.end."+c.id,c,g["scroll-position"])},c,!0),d.end=e.rect(c).mousedown(function(){var a;1!==(a=g["scroll-position"])&&(c.animate({"scroll-position":a+.1},100).animate(p=t.animation({"scroll-position":1},4500*(1-a),"easeIn")),L("raphael.scroll.start."+c.id,c,a))}).mouseup(d._mouseupEnd=
function(){c.stop(p);L("raphael.scroll.end."+c.id,c,g["scroll-position"])},c,!0),g.fill&&c.attr("fill",g.fill)),m&&c.attr("scroll-repaint",m));return{"scroll-display-buttons":a}},"scroll-orientation":function(a){var c=this.attrs,e=c["scroll-repaint"],d=c["scroll-orientation"];a={horizontal:"horizontal",vertical:"vertical"}[a]||d;d!==a&&(this.ca["scroll-repaint"]=this.ca["scroll-repaint-"+a],e&&(e[2]+=e[3],e[3]=e[2]-e[3],e[2]-=e[3],this.attr("scroll-repaint",e)),c.fill&&this.attr("fill",c.fill));return{"scroll-orientation":a}},
"scroll-ratio":function(a){var c=this.attrs,e=c["scroll-ratio"],d=c["scroll-repaint"];a=1<a?1:.01>a?.01:v(a);d&&a!==e&&(c["scroll-ratio"]=a,this.attr("scroll-repaint",d));return{"scroll-ratio":a}},"scroll-position":function(a,c){var e=this.attrs,d="horizontal"===e["scroll-orientation"],g=e["scroll-repaint"],q=e["scroll-position"],m=this._.scroller,l=m.anchor;a=1<a?1:0>a?0:v(a);isNaN(a)&&(a=q);g&&(q!==a||c)&&(q=m.start&&m.start.attr(d&&"width"||"height")||0,d&&l.attr("x",g[0]+q+(g[2]-2*q-l.attr("width"))*
a+.5)||l.attr("y",g[1]+q+(g[3]-2*q-l.attr("height"))*a+.5),!c&&1>e["scroll-ratio"]&&(L("raphael.scroll.change."+this.id,this,a),m.callback&&m.callback(a)));return{"scroll-position":a}},r:function(a){var c=this._.scroller;c.track.attr("r",a);c.anchor.attr("r","none"===this.attrs["scroll-display-buttons"]&&a||0);return!1},"scroll-repaint-horizontal":function(a,c,e,d){var g=this.attrs,q=this._.scroller,m=g["scroll-ratio"],l=g["scroll-position"],p=0,t=e*m,g="none"===g["scroll-display-buttons"];e&&--e;
a&&(a+=.5);d&&--d;c&&(c+=.5);q.track.attr({width:e,height:d,y:c,x:a}).crisp();g||(p=N(d,.5*e),t-=2*p*m,q.start.attr({width:p,height:d,x:a,y:c}),q.arrowstart.attr("polypath",[3,a+.5*p,c+.5*d,.25*p,180]),q.end.attr({width:p,height:d,x:a+e-p,y:c}),q.arrowend.attr("polypath",[3,a+e-.5*p,c+.5*p,.25*p,0]));q.trackLength=e-2*p-t;q.trackOffset=a+p+.5;q.anchorOffset=q.trackOffset+.5*(t-1);q.anchor.attr({height:d,width:t-1,y:c,x:q.trackOffset+q.trackLength*l}).crisp()},"scroll-repaint-vertical":function(a,
c,e,d){var g=this.attrs,q=this._.scroller,m=g["scroll-ratio"],l=g["scroll-position"],p=0,t=d*m,g="none"===g["scroll-display-buttons"];e&&--e;a&&(a+=.5);d&&--d;c&&(c+=.5);q.track.attr({width:e,height:d,y:c,x:a}).crisp();g||(p=N(e,.5*d),t-=2*p*m,q.start.attr({width:e,height:p,x:a,y:c}),q.arrowstart.attr("polypath",[3,a+.5*e,c+.5*p,.25*p,90]),q.end.attr({width:e,height:p,x:a,y:c+d-p}),q.arrowend.attr("polypath",[3,a+.5*e,c+d-.5*p,.25*p,-90]));q.trackLength=d-2*p-t;q.trackOffset=c+p+.5;q.anchorOffset=
q.trackOffset+.5*(t-1);q.anchor.attr({height:0>t-1?0:t-1,width:e,y:q.trackOffset+q.trackLength*l,x:a}).crisp()},fill:function(a){var c=this.attrs,e=this._.scroller,d=c["scroll-repaint"],g="flat"===c["scroll-display-style"],q="horizontal"===c["scroll-orientation"],l={stroke:"none"},p;m&&d&&3<(p=16-d[q&&3||2])&&(l.stroke=H,l["stroke-width"]=p);a=t.color(a);a.error&&(a=t.color("#000000"));a="opacity"in a?"rgba("+[a.r,a.g,a.b,a.opacity]+")":"rgb("+[a.r,a.g,a.b]+")";l.fill=g&&a||[90*q,t.tintshade(a,.15).rgba,
a].join("-");l.stroke=t.tintshade(a,-.75).rgba;e.track.attr(l);l.fill=g&&t.tintshade(a,-.6).rgba||[270*q,t.tintshade(a,.3).rgba+":40",t.tintshade(a,-.7).rgba].join("-");l.stroke=t.tintshade(a,-.6).rgba;e.anchor.attr(l);l.stroke="none";"none"!==c["scroll-display-buttons"]&&(l.fill=H,e.start.attr(l),e.end.attr(l),l.fill=t.tintshade(a,-.4).rgba,e.arrowstart.attr(l),e.arrowend.attr(l));return!1}}},{name:"button",button:function(a,c,e,d,g,q){q=this.group("button",q);var l;q._.button={bound:this.rect(q),
tracker:this.rect(q).attr({fill:H,stroke:H,cursor:"pointer"}).data("compositeButton",q)};!t.is(g,"object")&&(g={});for(l in t.fn.button.fn)q[l]=t.fn.button.fn[l];for(l in t.fn.button.ca)q.ca[l]=t.fn.button.ca[l];return q.attr({ishot:!0,"button-padding":[g.horizontalPadding,g.verticalPadding],"button-label":e,"button-symbol":d,"button-disabled":g.disabled||"false","button-symbol-position":g.symbolPosition,"button-symbol-padding":g.symbolPadding}).attr("button-repaint",[a,c,g.width,g.height,g.r])},
data:{hoverin:function(){var a=this._.button,c=a.hoverbackIn,e=this._hover||{};e.fill||e.stroke||e["stroke-width"]||e.cursor?(e.fill&&this.bottom.attr("fill",e.fill)&&a.symbol.attr("fill",e.fill),e.stroke&&this.bottom.attr("stroke",e.stroke)&&a.symbol.attr("stroke",e.stroke),e["stroke-width"]&&this.bottom.attr("stroke-width",e["stroke-width"])&&a.symbol.attr("stroke-width",e["stroke-width"]),e.cursor&&a.tracker.attr("cursor",e.cursor),c&&c()):c&&!1===c(arguments)||this.attr("fill","hover");this.hovered=
!0},hoverout:function(){var a=this._.button,c=a.hoverbackOut,e=this._normal||{};e.fill||e.stroke||e["stroke-width"]||e.cursor?(e.fill&&this.bottom.attr("fill",e.fill)&&a.symbol.attr("fill",e.fill),e.stroke&&this.bottom.attr("stroke",e.stroke)&&a.symbol.attr("stroke",e.stroke),e["stroke-width"]&&this.bottom.attr("stroke-width",e["stroke-width"])&&a.symbol.attr("stroke-width",e["stroke-width"]),e.cursor&&a.tracker.attr("cursor",e.cursor),c&&c()):c&&!1===c(arguments)||this.attr("fill",(this.pressed||
this.active)&&"active"||"normal");this.hovered=!1},mousedown:function(){var a=this._.button,c=this._pressed||{};c.fill||c.stroke||c["stroke-width"]||c.cursor?(c.fill&&this.bottom.attr("fill",c.fill)&&a.symbol.attr("fill",c.fill),c.stroke&&this.bottom.attr("stroke",c.stroke)&&a.symbol.attr("stroke",c.stroke),c["stroke-width"]&&this.bottom.attr("stroke-width",c["stroke-width"])&&a.symbol.attr("stroke-width",c["stroke-width"]),c.cursor&&a.tracker.attr("cursor",c.cursor)):this.attr("fill","active");this.pressed=
!0},mouseup:function(){var a=this._.button,c=a.callback,e=this._normal||{};e.fill||e.stroke||e["stroke-width"]||e.cursor?(e.fill&&this.bottom.attr("fill",e.fill)&&a.symbol.attr("fill",e.fill),e.stroke&&this.bottom.attr("stroke",e.stroke)&&a.symbol.attr("stroke",e.stroke),e["stroke-width"]&&this.bottom.attr("stroke-width",e["stroke-width"])&&a.symbol.attr("stroke-width",e["stroke-width"]),e.cursor&&a.tracker.attr("cursor",e.cursor)):this.attr("fill",this.hovered&&"hover"||this.active&&"active"||"normal");
this.pressed=!1;c&&c(arguments)},mousemove:function(){var a=this._.button.mousemove;a&&a(arguments)}},fn:{tooltip:function(){t.el.tooltip&&t.el.tooltip.apply(this._.button.tracker,arguments);return this},buttonclick:function(a,c){var e=this._.button;c=c||this;e.callback=function(){return a.apply(c,arguments)};return this},labelcss:function(){var a=this._.button,c=a.label;a.cssArg=arguments;c&&c.css.apply(c,arguments);return this.attr("button-repaint",this.attrs["button-repaint"])},buttonhover:function(a,
c,e,d,g,q){var l=this._.button;e=e||this;d=d||this;q=q||this;g&&(l.mousemove=function(){return g.apply(q,arguments)});l.hoverbackIn=function(){return a.apply(e,arguments)};l.hoverbackOut=function(){return c.apply(d,arguments)};return this},remove:function(){var a=this._.button,c;this.attr("button-disabled","true");for(c in a)a[c]&&a[c].remove&&a[c].remove(),a[c]=null;delete this._.button;t.el.remove.apply(this,arguments)}},ca:{"button-active":function(a){this.attr("fill",(this.active=!!a)?"active":
this.hovered&&"hover"||"normal")},"button-disabled":function(a){var c=this._.button,e=c.tracker,d=this.attrs["button-disabled"],g=this.paper.button.data,q=this._disabled||{};a=ba[a];d=ba[d];if(void 0!==a&&a!==d)switch(a){case !0:q.fill||q.stroke||q["stroke-width"]||q.cursor?(q.fill&&this.bottom.attr("fill",q.fill)&&c.symbol.attr("fill",q.fill),q.stroke&&this.bottom.attr("stroke",q.stroke)&&c.symbol.attr("stroke",q.stroke),q["stroke-width"]&&this.bottom.attr("stroke-width",q["stroke-width"]&&c.symbol.attr("fill",
q.fill)),q.cursor&&c.tracker.attr("cursor",q.cursor)):e.attr("fill","rgba(204,204,205,.5)");e.unmousedown(g.mousedown).unmouseup(g.mouseup).unhover(g.hoverin,g.hoverout).unmousemove(g.mousemove);break;case !1:e.attr("fill",H).mousedown(g.mousedown,this).mouseup(g.mouseup,this,!0).hover(g.hoverin,g.hoverout,this,this).mousemove(g.mousemove,this)}},"button-label":function(a){var c=this._.button,e=this.attrs,d=c.label,g=c.cssArg,q=this.attrs["button-repaint"];a=M(a||"");"none"===a?d&&(c.label=d.remove()):
a&&(!d&&(d=c.label=this.paper.text(this).insertBefore(c.tracker)),d.attr({text:a,"text-anchor":"middle","vertical-align":"middle"}),g&&g.length&&d.css.apply(d,g));q&&e["button-label"]!==a&&this.attr("button-repaint",q)},"button-symbol":function(a){var c=this._.button,e=c.symbol,d=this.attrs["button-repaint"];a=M(a||"");"none"===a?(e&&(c.symbol=e.remove()),delete c.symbol):a&&!e&&(c.symbol=this.paper.symbol(this).insertAfter(c.bound));d&&this.attr("button-repaint",d)},"button-symbol-position":function(a){return{"button-symbol-position":{top:"top",
right:"right",bottom:"bottom",left:"left",none:"none"}[M(a).toLowerCase()]||"none"}},"button-symbol-padding":function(a){return{"button-symbol-padding":v(a)}},"button-padding":function(a,c){return{"button-padding":[null==a&&(a=5)||v(a),null==c&&a||v(c)]}},"button-repaint":function(a,c,e,d,g){var q=this._.button,l=q.bound,m=q.label,p=q.symbol,n=this.attrs,C=n["button-padding"],r=C[0],v=C[1],H,w;void 0===a&&(a=0);void 0===c&&(c=0);if(void 0===e||void 0===d)H=m&&m.getBBox()||{width:0,height:0},void 0===
e&&(e=2*r+H.width),void 0===d&&(d=2*v+H.height);l=t.crispBound(a,c,e,d,l.attr("stroke-width"));l.r=t.pick(g,ga(.1*N(d,e)));a=l.x;c=l.y;e=l.width;d=l.height;m&&m.attr({x:a+e/2,y:c+d/2});if(p){!t.is(w=n["button-symbol-padding"],"finite")&&(w=.2*d);g=d-v;H=.5*g;switch(n["button-symbol-position"]+(m&&"+"||"-")){case "right+":a=a+(e+(2*H+v))-H-r;c+=.5*d;m.attr("transform",["t",-(g+w),0]);break;case "left+":a=a+r+H;c+=.5*d;m.attr("transform",["t",g+w,0]);break;case "top+":a+=.5*e;c=c+C[1]+H;m.attr("transform",
["t",0,g+w]);break;case "bottom+":a+=.5*e;c=c+(d+(2*H+w))-v-H;m.attr("transform",["t",0,-(g+w)]);break;default:a+=.5*e,c+=.5*d}p.attr("symbol",[n["button-symbol"],a,c,H])}q.bound.attr(l);q.tracker.attr(l)},fill:function(a,c,e,d,g){var q=this._.button,l=q.bound,m=q.symbol,p=q.label,n={normal:q.gradient,active:q.gradientActive,hover:q.gradientHover}[a];n||(g||(a=t.getRGB(a),a.error&&(a=t.color("#cccccc")),a="opacity"in a?"rgba("+[a.r,a.g,a.b,a.opacity]+")":"rgb("+[a.r,a.g,a.b]+")"),q.gradient=g?a:[90,
t.tintshade(a,-.8).rgba+":0",t.tintshade(a,.8).rgba+":100"].join("-"),q.gradientActive=[270,t.tintshade(a,-.8).rgba+":0",t.tintshade(a,.8).rgba+":100"].join("-"),d=t.getRGB(d),d.error&&(d=a)||(d="opacity"in d?"rgba("+[d.r,d.g,d.b,d.opacity]+")":"rgb("+[d.r,d.g,d.b]+")"),q.gradientHover=g?d:[90,t.tintshade(d,-.9).rgba+":0",t.tintshade(d,.7).rgba+":100"].join("-"),e=e||t.tintshade(a,.2).rgba,c=c||t.tintshade(a,-.2).rgba,q.symbolFill=e,q.labelFill=c,n=(this.pressed||this.active)&&q.gradientActive||this.hovered&&
q.gradienthover||q.gradient);l.attr("fill",n);m&&m.attr("fill",q.symbolFill);p&&p.attr("fill",q.labelFill);return!1},stroke:function(a,c){var e=this._.button,d=e.symbol;a=t.color(a);a.error&&(a=t.color("#999999"));e.bound.attr("stroke",a);d&&d.attr("stroke",c||a);return!1},"stroke-width":function(a,c){var e=this._.button,d=e.symbol;e.bound.attr("stroke-width",a);e.tracker.attr("stroke-width",a);d&&d.attr("stroke-width",c);return!1},config:function(a){a.hover&&(this._hover={fill:a.hover.fill,stroke:a.hover.stroke,
"stroke-width":a.hover["stroke-width"],cursor:a.hover.cursor});a.disabled&&(this._disabled={fill:a.disabled.fill,stroke:a.disabled.stroke,"stroke-width":a.disabled["stroke-width"],cursor:a.disabled.cursor});a.pressed&&(this._pressed={fill:a.pressed.fill,stroke:a.pressed.stroke,"stroke-width":a.pressed["stroke-width"],cursor:a.pressed.cursor});a.normal&&(this._normal={fill:a.normal.fill,stroke:a.normal.stroke,"stroke-width":a.normal["stroke-width"],cursor:a.normal.cursor});a.symbol&&(a.symbol={stroke:a.normal.stroke,
"stroke-width":a.normal["stroke-width"]})}}},{name:"trianglepath",trianglepath:function(){var a=arguments,c=t._lastArgIfGroup(a);return this.path(c).attr("trianglepath",[a[0],a[1],a[2],a[3],a[4],a[5],a[6]||0,a[7]||0,a[8]||0])},fn:{sides:function(){var a=this._args;return[ea(a[0],a[1],a[2],a[3]),ea(a[2],a[3],a[4],a[5]),ea(a[4],a[5],a[0],a[1])]},enclosedAngles:function(){var c=this._sides;return[l((a(c[0],2)+a(c[2],2)-a(c[1],2))/(2*c[0]*c[2])),l((a(c[0],2)+a(c[1],2)-a(c[2],2))/(2*c[0]*c[1])),l((a(c[2],
2)+a(c[1],2)-a(c[0],2))/(2*c[2]*c[1]))]},semiperimeter:function(){var a=this._sides||this.sides();return(a[0]+a[1]+a[2])/2}},ca:{trianglepath:function(a,c,e,g,q,l,m,p,t){if(m||p||t){this._args=arguments;this._sides=this.sides();var n=this.enclosedAngles(),C;C=this.semiperimeter();C=r(C*(C-this._sides[0])*(C-this._sides[1])*(C-this._sides[2]))/C;n=[N(m,C)/d(n[0]/2),N(p,C)/d(n[1]/2),N(t,C)/d(n[2]/2)];n=[ra(a,c,q,l,n[0]),ra(a,c,e,g,n[0]),ra(e,g,a,c,n[1]),ra(e,g,q,l,n[1]),ra(q,l,e,g,n[2]),ra(q,l,a,c,
n[2])];this.attr({path:["M",n[0].x,n[0].y,"Q",a,c,n[1].x,n[1].y,"L",n[2].x,n[2].y,"Q",e,g,n[3].x,n[3].y,"L",n[4].x,n[4].y,"Q",q,l,n[5].x,n[5].y,"L",n[0].x,n[0].y]})}else this.attr({path:["M",a,c,"L",e,g,q,l,"Z"]})}}}]);t.ca["text-bound"]=function(a,c,e,d,g,q){var l=this.paper,m=this._.textbound;if("text"===this.type){if(!(c&&"none"!==c||a&&"none"!==a))return this._.textbound=m&&m.unfollow(this).remove(),!1;this.attrs["text-bound"]=arguments;e&&t.is(e,"finite")||(e=0);g&&t.is(g,"finite")||(g=0);!m&&
(m=this._.textbound=l.rect(0,0,0,0,this.group).follow(this,t.ca["text-bound"].reposition,"before"));m.attr({stroke:c,"stroke-width":e,fill:a,"shape-rendering":1===e&&"crisp"||"",r:g});q&&m.attr("stroke-dasharray",q);t.ca["text-bound"].reposition.call(m,this.attr(),this);return!1}};t.ca["text-bound"].reposition=function(a,c){var e={},d,g,q,l,m;a.hasOwnProperty("visibility")&&this.attr("visibility",a.visibility);if(a.hasOwnProperty("text-bound")||a.hasOwnProperty("x")||a.hasOwnProperty("y")||a.hasOwnProperty("text")||
a.hasOwnProperty("text-anchor")||a.hasOwnProperty("text-align")||a.hasOwnProperty("font-size")||a.hasOwnProperty("line-height")||a.hasOwnProperty("vertical-align")||a.hasOwnProperty("transform")||a.hasOwnProperty("rotation"))d=c.attrs["text-bound"],g=M(d&&d[3]||"0").split(ia),d=v(g[0])||0,g=t.pick(v(g[1]),d),q=c.getBBox(),l=q.width,m=q.height,isNaN(l)||(e.x=q.x-d,e.y=q.y-g,e.width=l+2*d,e.height=m+2*g),this.attr(e)};t.fn.symbol=function(){var a=arguments,c=a.length-1,e=a[c];e&&e.constructor===t.el.constructor?
a[c]=void 0:e=void 0;c=this.path(void 0,e);c.ca.symbol=t.fn.symbol.ca.symbol;return a.length===!!e+0?c:c.attr("symbol",a)};t.fn.getSuggestiveRotation=function(){var a,c,e;a=arguments[0];1===arguments.length?(c=a.angle,e=a.x,a=a.y):(c=a,e=arguments[1],a=arguments[2]);return"r"+(c||0)+","+e+","+a};t.fn.symbol.cache={"":t._cacher(function(a,c,e,d){return 3<arguments.length?["M",a,c,"h",e,"v",d,"h",-e,"v",-d,"z"]:["M",a-e,c-e,"h",e*=2,"v",e,"h",-e,"v",-e,"z"]})};t.fn.symbol.ca={symbol:function(a){var c=
t.is(a,"object")&&1===arguments.length&&!t.is(a,"function")?a:arguments,d;c===a&&(a=c[0]);c=(d=t.is(a,"function")&&a||t.fn.symbol.cache[a]||t.fn.symbol.cache[""])&&d.apply(t,e.call(c,1));t.is(c,"array")||t.is(c,"string")?this.attr("path",c):c&&this.attr(c)}};t.addSymbol=function(a,c){var e=t.is(c,"function")&&(e={},e[a]=c,e)||a,d=t.fn.symbol.cache,g=[],q;for(q in e)c=e[q],d[q]=t.is(c,"function")&&t._cacher(c,t)||(g.push(q),c);for(;q=g.pop();)d[q]=d[d[q]]};t.svg?(C="$1",Ja=function(a){a?"string"===
typeof a?a=a.replace(I,C):a.toString=za:a="M0,0";this.node.setAttribute("d",a.toString())},t._engine.litepath=function(a,c,e,d){a=K("path");(d||c).canvas.appendChild(a);c=new S(a,c,d);c.type="litepath";c.id=a.raphaelid=t._oid++;a.raphael=!0;pa(c,{fill:"none",stroke:"#000"});return c},t._getPath.litepath=function(a){return t.parsePathString(a.node.getAttribute("d"))}):t.vml&&(C=function(a,c){return aa[c]||c},na=function(){this._transform.apply(this,arguments);this._.bcoord&&(this.node.coordsize=this._.bcoord);
return this},Ja=function(a){a?"string"===typeof a?a=a.replace(I,C):a.toString=za:a="M0,0";this.node.path=a;return this},t._engine.litepath=function(a,c,e,d){a=K("shape");var g=a.style,q=new S(a,c,d);g.cssText="position:absolute;left:0;top:0;width:21600px;height:21600px;";e=v(e);isNaN(e)?a.coordsize="21600 21600":(q._.bzoom=e,g.width="1px",g.height="1px",a.coordsize=q._.bcoord=e+" "+e);a.coordorigin=c.coordorigin;q.type="litepath";q.id=a.raphaelid=t._oid++;a.raphael=!0;q._transform=q.transform;q.transform=
na;t._setFillAndStroke(q,{fill:"none",stroke:"#000"});(d||c).canvas.appendChild(a);c=K("skew");c.on=!0;a.appendChild(c);q.skew=c;return q},t._getPath.litepath=function(a){return t.parsePathString(a.node.path||"")});t.fn.litepath=function(a,c,e){c&&c.constructor===S&&(e=c,c=void 0);a&&a.constructor===S&&(e=a,a="");c=t._engine.litepath(a,this,c,e);c.ca.litepath=Ja;a&&c.attr("litepath",t.is(a,"array")?[a]:a);return this.__set__&&this.__set__.push(c),this._elementsById[c.id]=c}}]);FusionCharts.register("module",
["private","modules.renderer.js-htmlrenderer",function(){var g=this.hcLib,m=g.Raphael,D=g.dem,n=this.window,F=n.document,A=/msie/i.test(n.navigator.userAgent)&&!n.opera,J="VML"===m.type,a=g.hasTouch,O={cursor:"cursor"},d={x:"left",y:"top",strokeWidth:"borderThickness","stroke-width":"borderThickness",width:"width",height:"height"},l={fill:"backgroundColor",stroke:"borderColor",color:"color"},N={left:0,top:0,padding:0,border:"none",margin:0,outline:"none","-webkit-apperance":"none",position:"absolute",
zIndex:20},ga,w=function(a,c,g,l){a=F.createElement(a);for(var e in c)d[e]?a.style[e]=c[e]:a.setAttribute(e,c[e]);for(e in g)a.style[e]=g[e];l&&l.appendChild&&l.appendChild(a);return a},r;r=function(a,c,d){c&&c instanceof r&&(c=c.element);(this.element=w(a,d,N,c)).ishot="true";this.nodeName=a.toLowerCase();this.added=!!c};r.prototype={attr:function(a){var c=this.element,g={},m,e,q,n,t,r,w;if("object"!==typeof a){if(!(g=this[a])){if("string"===typeof a)c&&c.getAttribute&&(n=c.getAttribute(a));else if(void 0!==
a&&null!==a&&"object"===typeof a)for(q in a)c.setAttribute(q,a[q]);g=n}return g}for(m in a){q=a[m];if(O[m]){switch(m){case "cursor":"pointer"===q&&J&&(q="hand")}c.style[O[m]]=q;e=!0}else if(d[m])c.style[d[m]]=q+"px",e=!0;else if(l[m])c.style[l[m]]=q&&q.replace(/^#?([a-f0-9]+)/ig,"#$1")||"none",e=!0;else if(/^visibility$/i.test(m))e="hidden"===q,c.style.display=e?"none":"",this.hidden=e,e=!0;else if(/^opacity$/i.test(m))c.style.opacity=q,A&&(e=100*Number(q),c.style.filter="progid:DXImageTransform.Microsoft.Alpha(Opacity="+
e+")"),e=!0;else if(/^innerhtml$/i.test(m)){if(J&&"select"==c.nodeName.toLowerCase()){for(e=q.match(/<option\s?[\s\S]*?(\/>|><\/option>|>[\s\S]*?<\/option>)/ig);c.firstChild;)c.removeChild(c.firstChild);t=0;for(r=e.length;t<r;t+=1)n=e[t],w=F.createElement("option"),/<option\s([\s\S]*[\'\"])\s*?(\/>|>[\s\S]*<\/option>)/ig.test(n)&&(w.value=n.replace(/<option\s([\s\S]*[\'\"])\s*?(\/>|>[\s\S]*<\/option>)/ig,"$1").replace(/[\s\S]*value\s*\=\s*[\'\"]([\s\S]*)[\'\"]/,"$1")),w.text=n.replace(/<option\s*[\s\S]*[\'\"]?\s*?[\/>|\>]([\s\S]*)<\/option>/ig,
"$1 "),c.options.add(w)}else"input"!==c.nodeName.toLowerCase()&&void 0!==q&&(c.innerHTML=q||"");e=!0}else/^text$/i.test(m)?("input"!==c.nodeName.toLowerCase()&&(c.innerHTML="",void 0!==q&&c.appendChild(F.createTextNode(q))),e=!0):/^type$/i.test(m)&&A&&this.added&&(e=!0);e&&(g[m]=q,delete a[m],e=!1)}for(m in a)c.setAttribute(m,a[m]);for(m in g)this[m]=a[m]=g[m],delete g[m];return this},val:function(a){var c=this.element,d=void 0===a;return"input"===this.nodeName&&"checkbox"===c.getAttribute("type")?
d?this.checked()?1:0:this.checked(a):d?c.value:(c.value=a,this)},checked:function(a){var c=this.element;return void 0===a?c.checked:(a?c.setAttribute("checked","checked"):c.removeAttribute("checked"),this)},css:function(a,c){var d=this.element.style,g;if("object"===typeof a)for(g in a)d[g]=a[g];else g&&void 0!==c&&(d[g]=c);return this},translate:function(a,c){var d=this.element;void 0!==a&&(d.style.left=a+"px");void 0!==c&&(d.style.top=c+"px");return this},add:function(a,c){var d=this.element,g=a.element;
c?g.insertBefore(d,g.firstChild):g.appendChild(d);this.added=!0;return this},hide:function(){this.element.style.display="none";return this},show:function(){this.element.style.display="";return this},focus:function(){"function"===typeof this.element.focus?this.element.focus():g.dem.fire(this.element,"focus")},destroy:function(){var a=this.element||{};a.onclick=a.onmouseout=a.onmouseover=a.onmousemove=a.onblur=a.onfocus=null;ga||(ga=w("div"));a&&ga.appendChild(a);ga.innerHTML="";delete this.element;
return null},on:J?function(a,c){this.element["on"+a]=function(){var a=n.event;a.target=a.srcElement;c(a)};return this}:function(d,c){var g=c;a&&"click"===d&&(d="touchstart",g=function(a){a.preventDefault();c()});this.element["on"+d]=g;return this},bind:function(a,c,d){D.listen(this.element,a,c,d);return this},unbind:function(a,c){D.unlisten(this.element,a,c);return this},trigger:function(a,c){D.fire(this.element,a,c);return this},fadeIn:function(a,c){var d="fast"===a?400:1E3;this.show();this.attr({opacity:0});
g.danimate.animate(this.element,{opacity:1},d,"linear",c)},animate:function(a,c,d,m){g.danimate.animate(this.element,a,c,d,m)}};r.prototype.constructor=r;m.fn.html=function(a,c,d,g){var e={},q;c&&"type"in c&&(e.type=c.type,delete c.type);a=(new r(a,g,e)).css(d).attr(c);for(q in e)c[q]=e[q];return a}}]);FusionCharts.register("module",["private","modules.renderer.js-raphaeltooltip",function(){var g=this,m=g.window,D=m.document,n=D.body||D.getElementsByTagName("body")[0],F=g.hcLib,A=F.Raphael,J=A.eve,
a=F.createElement,O=F.addEvent,d=F.removeEvent,l=F.getPosition,N=F.hasTouch,ga=F.getTouchEvent,w=Math,r=w.ceil,p=w.floor,c={},v=m.screen.availHeight,M=m.screen.availWidth,e={E:1,moz:1,webkit:1,o:1,ms:1},q={borderRadius:"borderRadius",boxShadow:"boxShadow"},H=/\-([a-z])/ig,t=function(a,c){return c.toUpperCase()},L=function(a){var c=K.forbiddenStyle,d,g,m;for(d in a)g=H.test(d)?d.replace(H,t):d,void 0!==a[d]&&!c[g]&&(this[g]=a[d]),A.vml&&/color/ig.test(g)&&(this[g]=A.getRGB(this[g]).toString());for(d in q)if(this[d])for(m in e)this[m+
d]=this[d]},K=F.toolTip={elementId:"fusioncharts-tooltip-element",element:null,lastTarget:null,currentTarget:null,currentPaper:null,pointeroffset:12,prevented:!1,defaultStyle:F.extend2(L.prototype,{backgroundColor:"#ffffee",borderColor:"#000000",borderWidth:"1px",color:"#000000",fontSize:"10px",lineHeight:"12px",padding:"3px",borderStyle:"solid"}),defaultContainerStyle:{position:"absolute",textAlign:"left",margin:"0",zIndex:"99999",pointer:"default",display:"block"},forbiddenStyle:{}},pa=function(a){!0===
K._oobready?K._oobready=!1:(d(n,"touchstart",pa),!K.hidden&&K.currentTarget&&(a=a.srcElement||a.target||c,a.raphael&&K.currentTarget.paper.getById(a.raphaelid)===K.currentTarget||K.hide()))};A.svg&&(K.defaultContainerStyle.pointerEvents="none",K.defaultStyle.borderRadius="0",K.defaultStyle.boxShadow="none");A.vml&&(K.forbiddenStyle.borderRadius=!0,K.forbiddenStyle.boxShadow=!0,K.defaultStyle.filter="");K.setup=function(){var c=K.container,e=K.textElement,d=K.style,q=K.defaultContainerStyle,m=K.forbiddenStyle,
l;c||(c=K.element=a("span"),(D.body||D.getElementsByTagName("body")[0]).appendChild(c),c.setAttribute("id",K.elementId),d=K.containerStyle=c.style,e=K.textElement=a("span"),c.appendChild(e),K.style=A.vml?e.runtimeStyle:e.style,K.style.overflow="hidden",K.style.display="block",K.hidden=!1,K.hide());for(l in q)!m[l]&&(d[l]=q[l]);K.scatted=!0;J.on("raphael.drag.start.*",function(){K.scatted&&(K.waitingScat=!0)});J.on("raphael.drag.move.*",function(){K.waitingScat&&(K.block(),K.waitingScat=!1)});J.on("raphael.drag.end.*",
function(){K.waitingScat=!1;K.scatted&&K.unblock(!0)});J.on("raphael.remove",function(){if(K.currentPaper===this||K.currentTarget&&K.currentTarget.paper===this)K.hide(),K.currentTarget=K.currentPaper=null});g.addEventListener("LinkedChartInvoked",function(a){K.currentPaper===a.sender.apiInstance.components.paper&&K.hide()});g.addEventListener("realTimeUpdateComplete",function(a){K.currentPaper===a.sender.apiInstance.components.paper&&K.hide()})};K.restyle=function(a){var c=K.style,e;for(e in a)c[e]=
a[e]};K.onelement=function(a){if(!a.__tipProcessed){var c=this.paper,e="group"===this.type?c&&c._elementFromEvent(a):this,d=c.__tipStyle;e&&d&&e.__tipNeeded&&((a.originalEvent||a).FusionChartsPreventEvent&&K.preventTooltip(),K.hiding&&(K.hiding=clearTimeout(K.hiding)),K.currentPaper!==c&&(c.__tipCp=c.canvas&&l(c.canvas.parentNode,!0)||{},K.restyle(c.__tipStyle),K.currentPaper=c),K.lastTarget=K.currentTarget,K.currentTarget=e,(K.scatted=e.__tipScatted)&&K.unblock(!0),K.onredraw.call(this,a),a.__tipProcessed=
!0,N&&(K._oobready=!0,O(n||(n=D.body||D.getElementsByTagName("body")[0]),"touchstart",pa)))}};K.onredraw=function(a){a.__tipProcessed||(a.__tipProcessed=!0,(this.paper&&this.paper._elementFromEvent(a))===K.currentTarget&&(a=ga(a),K.x=p(a.pageX||a.clientX+D.body.scrollLeft+D.documentElement.scrollLeft||0),K.y=p(a.pageY||a.clientY+D.body.scrollTop+D.documentElement.scrollTop||0),K.redraw()))};K.onhide=function(a){a.__tipProcessed||(a.__tipProcessed=!0,(this.paper&&this.paper._elementFromEvent(a))===
K.currentTarget&&(K.hiding=setTimeout(K.hide,200)))};K.redraw=function(){if(!K.prevented&&!K.blocked&&K.currentTarget&&K.currentTarget.__tipNeeded){var a=K.currentTarget,c=a.paper,e=K.textElement,d=K.containerStyle,g=K.style,q=a.__tipText,a=K.pointeroffset,m=c.__tipCp,l=D.documentElement||D.body,t=l.scrollLeft,l=l.scrollTop,p=K.x,n=K.y,H,w,L=c.width,A=c.height,c=c.__tipConstrain;if(100>L||100>A)c=!1;K.hidden&&(K.containerStyle.top="-999em",K.show());q!==K.text&&(K.text=q,d.width=d.height="",e.innerHTML=
q,g.whiteSpace="nowrap",H=r(g.pixelWidth||e.offsetWidth||0),q=r(g.pixelHeight||e.offsetHeight||0),(K.textWidthOverflow=p+H>m.left+L)?(H=L-2*a>H?d.width:L-2*a||0,d.width=H&&H+"px"||"",g.whiteSpace="normal"):d.width="",(K.textHeightOverflow=q>A)?(d.height=(A||0)-2*a+"px",g.whiteSpace="normal"):d.height="");H=r(g.pixelWidth||e.offsetWidth||0);q=r(g.pixelHeight||e.offsetHeight||0);c?(K.textWidthOverflow?p=(p-H<m.left?m.left:p-H)-t:(w=p+a+H-(m.left-t+L-a))&&0<w&&(p-=w),K.textHeightOverflow?n=m.top-l:n+
a+q>m.top-l+A-a&&(n=n-q-1.5*a)):(t+M<p+a+H&&(p=p-H-a),l+v<n+a+q&&(n=n-q-1.5*a));d.left=(p+a||0)+"px";d.top=(n+a||0)+"px";K.hidden&&K.show()}};K.hide=function(){K.hiding&&(K.hiding=clearTimeout(K.hiding));K.containerStyle.display="none";K.hidden=!0;K.prevented=!1};K.show=function(){K.blocked||(K.hiding&&(K.hiding=clearTimeout(K.hiding)),K.containerStyle.display="inline",K.hidden=!1)};K.preventTooltip=function(){K.prevented=!0};K.block=function(){K.blocked=!0;K.containerStyle.display="none"};K.unblock=
function(a){K.blocked=!1;a&&(K.containerStyle.display=K.hidden&&"none"||"inline")};A.fn.tooltip=function(a,c,e){c&&(c=.4*(void 0===c.opacity?1:c.opacity),A.svg?a.boxShadow="1px 1px 3px rgba(64,64,64,"+c+")":a.filter='progid:DXImageTransform.Microsoft.Shadow(Strength=2, Direction=135, Color="#404040", shadowOpacity="'+c/2+'")');this.__tipStyle=new L(a);this.__tipCp=this.canvas&&l(this.canvas.parentNode,!0)||{};this.__tipConstrain=!!e;K.style&&K.restyle(this.__tipStyle);K.containerStyle&&K.hide();return this};
A.el.trackTooltip=function(a){var c=!!this.__tiptracking;if(void 0===a||(a=!!a)===c)return this;a?N?this.touchstart(K.onelement):(this.mouseover(K.onelement),this.mousemove(K.onredraw),this.mouseout(K.onhide)):N?this.untouchstart(K.onelement):(this.unmouseover(K.onelement),this.unmousemove(K.onredraw),this.unmouseout(K.onhide));this.__tiptracking=a;return this};A.el.tooltip=function(a,c,e,d,g){K.setup();A.el.tooltip=function(a,c,e,d,g){c=!1===a||void 0===a||""===a;this.__tipScatted=void 0===d?this.__tipScatted:
!d;void 0===this.__tipScatted&&(this.__tipScatted=!0);null!==g&&(this.__tip_blocked=g);c^!this.__tipText&&(this.__tipNeeded=!c);this.__tipText=a;if(K.currentTarget===this&&a!==K.text&&!K.hidden)K[c?"hide":"redraw"]();return this};return A.el.tooltip.call(this,a,c,e,d,g)};g.core._setTooltipZIndex=function(a){a=parseInt(a,10);K&&!isNaN(a)&&(K.defaultContainerStyle.zIndex=a,K.containerStyle&&(K.containerStyle.zIndex=a))}}]);FusionCharts.register("module",["private","modules.renderer.js-smartlabel",function(){var g=
this.hcLib,m=g.isIE,D=g.hasSVG,n=Math,F=n.max,A=n.round,n=this.window,J=/ HtmlUnit/.test(n.navigator.userAgent),a=n.document,O=/ AppleWebKit\//.test(n.navigator.userAgent),d=!!a.createElement("canvas").getContext,l=(n=!(!d||!a.createElement("canvas").getContext("2d")))&&n.measureText,N=/<br\/>/ig,ga=/&lt;|&gt;/g,w=[],r={" ":"&nbsp;"},n=function(){function p(a,c,e){if(!a||!a.length)return 0;var d=e.getWidthFunction(),g=0,q=0,q=d(a),m=q/a.length;e=c;g=Math.ceil(c/m);if(q<c)return a.length-1;g>a.length&&
(e=c-q,g=a.length);for(;0<e;)if(e=c-d(a.substr(0,g)),q=Math.floor(e/m))g+=q;else return g;for(;0>e;)if(e=c-d(a.substr(0,g)),q=Math.floor(e/m))g+=q;else break;return g}function c(c,e){e=5<e?e:5;this.maxContainers=20>e?e:20;this.last=this.first=null;this.containers={};this.length=0;this.rootNode=c;if(ba){var d=a.createElementNS("http://www.w3.org/2000/svg","svg");d.setAttributeNS("http://www.w3.org/2000/svg","xlink","http://www.w3.org/1999/xlink");d.setAttributeNS("http://www.w3.org/2000/svg","height",
"0");d.setAttributeNS("http://www.w3.org/2000/svg","width","0");this.svgRoot=d;this.rootNode.appendChild(d)}}function n(e,d,g){if("undefined"!==typeof e&&"object"!==typeof e){this.id=e;var l;"string"===typeof d&&(d=a.getElementById(d));a:{if(d&&(d.offsetWidth||d.offsetHeight)){if(d.appendChild){d.appendChild(d=a.createElement("div"));d.className="fusioncharts-smartlabel-container";d.setAttribute("aria-hidden","true");d.setAttribute("role","presentation");e=d;break a}}else if((e=a.getElementsByTagName("body")[0])&&
e.appendChild){d=a.createElement("div");d.className="fusioncharts-smartlabel-container";d.setAttribute("aria-hidden","true");d.setAttribute("role","presentation");e.appendChild(d);e=d;break a}e=void 0}e=this.parentContainer=e;e.innerHTML="WgI";if(J||!m&&!e.offsetHeight&&!e.offsetWidth)ba=!0;e.innerHTML="";for(l in q)e.style[l]=q[l];this.containerManager=new c(e,10);this.showNoEllipses=!g;this.init=!0;this.style={};this.setStyle()}}var M=g.supportedStyle,e={fontWeight:1,"font-weight":1,fontStyle:1,
"font-style":1,fontSize:1,"font-size":1,fontFamily:1,"font-family":1},q={position:"absolute",top:"-9999em",whiteSpace:"nowrap",padding:"0px",width:"1px",height:"1px",overflow:"hidden"},H=O?0:4.5,t=0,L=/\b_SmartLabel\b/,K=/\b_SmartLabelBR\b/,pa=/(<[^<\>]+?\>)|(&(?:[a-z]+|#[0-9]+);|.)/ig,S=RegExp("\\<span[^\\>]+?_SmartLabel[^\\>]{0,}\\>(.*?)\\<\\/span\\>","ig"),T=/<[^>][^<]*[^>]+>/i,ba=!1,aa=0,I=0,ia,C,za;a.getElementsByClassName?(ia="getElementsByClassName",C="_SmartLabel",za=!0):(ia="getElementsByTagName",
C="span",za=!1);c.prototype={get:function(a){var c=this.containers,e=this.length,d=this.maxContainers,g,q="",m="",m=this.getCanvasFont(a);for(g in M)void 0!==a[g]&&(q+=M[g]+":"+a[g]+";");if(!q)return!1;if(c[q])q=c[q],this.first!==q&&(q.prev&&(q.prev.next=q.next),q.next&&(q.next.prev=q.prev),q.next=this.first,q.next.prev=q,this.last===q&&(this.last=q.prev),q.prev=null,this.first=q);else{if(e>=d)for(a=e-d+1;a--;)this.removeContainer(this.last);q=this.addContainer(q,m)}return q},getCanvasFont:function(a){var c,
g=[];if(!d||!l)return!1;for(c in e)void 0!==a[c]&&g.push(a[c]);return g.join(" ")},setMax:function(a){var c=this.length;a=5<a?a:5;a=20>a?a:20;if(a<c){for(c-=a;c--;)this.removeContainer(this.last);this.length=a}this.maxContainers=a},addContainer:function(c,e){var d,g;this.containers[c]=g={next:null,prev:null,node:null,ellipsesWidth:0,lineHeight:0,dotWidth:0,avgCharWidth:4,keyStr:c,canvasStr:e,charCache:{}};g.next=this.first;g.next&&(g.next.prev=g);this.first=g;this.last||(this.last=g);this.length+=
1;d=g.node=a.createElement("div");this.rootNode.appendChild(d);m&&!D?d.style.setAttribute("cssText",c):d.setAttribute("style",c);d.setAttribute("aria-hidden","true");d.setAttribute("role","presentation");d.style.display="inline-block";d.innerHTML="WgI";g.lineHeight=d.offsetHeight;g.avgCharWidth=d.offsetWidth/3;ba?(d=g.svgText=a.createElementNS("http://www.w3.org/2000/svg","text"),d.setAttribute("style",c),this.svgRoot.appendChild(d),d.textContent="WgI",g.lineHeight=d.getBBox().height,g.avgCharWidth=
(d.getBBox().width-H)/3,d.textContent="...",g.ellipsesWidth=d.getBBox().width-H,d.textContent=".",g.dotWidth=d.getBBox().width-H):e?(d=g.canvas=a.createElement("canvas"),d.style.height=d.style.width="0px",this.rootNode.appendChild(d),g.context=d=d.getContext("2d"),d.font=e,g.ellipsesWidth=d.measureText("...").width,g.dotWidth=d.measureText(".").width):(d.innerHTML="...",g.ellipsesWidth=d.offsetWidth,d.innerHTML=".",g.dotWidth=d.offsetWidth,d.innerHTML="");return g},removeContainer:function(a){var c=
a.keyStr;c&&this.length&&a&&(--this.length,a.prev&&(a.prev.next=a.next),a.next&&(a.next.prev=a.prev),this.first===a&&(this.first=a.next),this.last===a&&(this.last=a.prev),a.node.parentNode.removeChild(a.node),a.canvas&&a.canvas.parentNode.removeChild(a.canvas),delete this.containers[c])},dispose:function(){var a,c=this.containers;this.maxContainers=null;for(a in c)this.removeContainer(c[a]);this.rootNode.parentNode.removeChild(this.rootNode);this.last=this.first=this.rootNode=null}};c.prototype.constructor=
c;n.prototype={dispose:function(){this.init&&(this.containerManager&&this.containerManager.dispose&&this.containerManager.dispose(),delete this.container,delete this.context,delete this.cache,delete this.containerManager,delete this.containerObj,delete this.id,delete this.style,delete this.parentContainer,delete this.showNoEllipses)},useEllipsesOnOverflow:function(a){this.init&&(this.showNoEllipses=!a)},getWidthFunction:function(){var a=this.context,c=this.container,e=this.containerObj.svgText;return e?
function(a){var c;e.textContent=a;a=e.getBBox();c=a.width-H;1>c&&(c=a.width);return c}:a?function(c){c=c&&c.split?c.split(N):w;for(var e=0,d=c.length,g=0,e=0;e<d;e+=1)g=F(a.measureText(c[e]||"").width,g);return g}:function(a){c.innerHTML=a;return c.offsetWidth}},getSmartText:function(c,e,d,g){if(!this.init)return!1;if(void 0===c||null===c)c="";var q={text:c,maxWidth:e,maxHeight:d,width:null,height:null,oriTextWidth:null,oriTextHeight:null,oriText:c,isTruncated:!1},m=!1,l,n,r=0,H,w,v,A,D,M=-1,J=A=
-1;n=this.container;var O=this.context,N=0;D=0;var Ga,Na,ya;ya=[];var Ia=0,Za=this.showNoEllipses?"":"...";v=this.lineHeight;var wb,N=[],M=l=-1;wb=function(a){a=a.replace(/^\s\s*/,"");for(var c=/\s/,e=a.length;c.test(a.charAt(--e)););return a.slice(0,e+1)};A=-1;Na=this.getWidthFunction();d===v&&(d*=1.2);if(n){if(!ba){(m=T.test(c))?(n.innerHTML=c,q.oriTextWidth=A=n.offsetWidth,q.oriTextHeight=D=n.offsetHeight):(w=c.replace(ga,function(a){return"&lt;"===a?"<":">"}),w=this.getOriSizeImprove(w,!0),q.oriTextWidth=
A=w.width,q.oriTextHeight=D=w.height);if(D<=d&&A<=e)return q.width=q.oriTextWidth=A,q.height=q.oriTextHeight=D,q;if(v>d)return q.text="",q.width=q.oriTextWidth=0,q.height=q.oriTextHeight=0,q}c=wb(c).replace(/(\s+)/g," ");v=this.showNoEllipses?e:e-t;if(m){r=c.replace(pa,"$2");c=c.replace(pa,'$1<span class="_SmartLabel">$2</span>');c=c.replace(/(<br\s*\/*\>)/g,'<span class="_SmartLabel _SmartLabelBR">$1</span>');n.innerHTML=c;Ia=n[ia](C);O=0;for(Na=Ia.length;O<Na;O+=1)if(c=Ia[O],za||L.test(c.className))wb=
c.innerHTML,""!==wb&&(" "===wb?M=N.length:"-"===wb&&(l=N.length),N.push({spaceIdx:M,dashIdx:l,elem:c}),ya.push(wb));Ia=0;l=N.length;aa=N[0].elem.offsetWidth;if(aa>e)return q.text="",q.width=q.oriTextWidth=q.height=q.oriTextHeight=0,q;aa>v&&!this.showNoEllipses&&(v=e-2*I,v>aa?Za="..":(v=e-I,v>aa?Za=".":(v=0,Za="")));ya=N[0].elem.offsetLeft;O=N[0].elem.offsetTop;if(g)for(;Ia<l;Ia+=1)c=N[Ia].elem,Na=c.offsetLeft-ya+c.offsetWidth,Na>v&&(Ga||(Ga=Ia),n.offsetWidth>e&&(H=Ia,Ia=l));else for(;Ia<l;Ia+=1)c=
N[Ia].elem,wb=c.offsetHeight+(c.offsetTop-O),Na=c.offsetLeft-ya+c.offsetWidth,g=null,Na>v?(Ga||(Ga=Ia),Na>e&&(A=N[Ia].spaceIdx,M=N[Ia].dashIdx,A>J?(N[A].elem.innerHTML="<br/>",J=A):M>J?(N[M].elem.innerHTML=M===Ia?"<br/>-":"-<br/>",J=M):c.parentNode.insertBefore(g=a.createElement("br"),c),c.offsetHeight+c.offsetTop>d?(g?g.parentNode.removeChild(g):J===M?N[M].elem.innerHTML="-":N[A].elem.innerHTML=" ",H=Ia,Ia=l):Ga=null)):wb>d&&(H=Ia,Ia=l);if(H<l){q.isTruncated=!0;Ga=Ga?Ga:H;for(Ia=l-1;Ia>=Ga;--Ia)c=
N[Ia].elem,c.parentNode.removeChild(c);for(;0<=Ia;--Ia)c=N[Ia].elem,K.test(c.className)?c.parentNode.removeChild(c):Ia=0}q.text=n.innerHTML.replace(S,"$1").replace(/\&amp\;/g,"&");q.isTruncated&&(q.text+=Za,q.tooltext=r)}else{ya=c.split("");l=ya.length;n="";H=[];Ga=ya[0];this.cache[Ga]?aa=this.cache[Ga].width:(aa=Na(Ga),this.cache[Ga]={width:aa});if(v>aa)H=c.substr(0,p(c,v,this)).split(""),Ia=H.length;else{if(aa>e)return q.text="",q.width=q.oriTextWidth=q.height=q.oriTextHeight=0,q;Za&&(v=e-2*I,v>
aa?Za="..":(v=e-I,v>aa?Za=".":(v=0,Za="")))}N=Na(H.join(""));D=this.lineHeight;if(g){for(;Ia<l;Ia+=1)if(Ga=H[Ia]=ya[Ia],this.cache[Ga]?aa=this.cache[Ga].width:(w&&(aa=w.detailObj[Ga])||(aa=Na(Ga)),this.cache[Ga]={width:aa}),N+=aa,N>v&&(n||(n=H.slice(0,-1).join("")),N>e))return q.text=wb(n)+Za,q.tooltext=q.oriText,q.width=Na(q.text),q.height=this.lineHeight,q;q.text=H.join("");q.width=N;q.height=this.lineHeight}else{for(;Ia<l;Ia+=1)if(Ga=H[Ia]=ya[Ia]," "!==Ga||O||(Ga="&nbsp;"),this.cache[Ga]?aa=this.cache[Ga].width:
(w&&(aa=w.detailObj[Ga])||(aa=Na(Ga)),this.cache[Ga]={width:aa}),N+=aa,N>v&&(n||(n=H.slice(0,-1).join("")),N>e)){A=c.substr(0,H.length).lastIndexOf(" ");M=c.substr(0,H.length).lastIndexOf("-");A>J?(N=Na(H.slice(J+1,A).join("")),H.splice(A,1,"<br/>"),J=A,g=A+1):M>J?(M===H.length-1?(N=Na(H.slice(J+1,A).join("")),H.splice(M,1,"<br/>-")):(N=Na(H.slice(J+1,A).join("")),H.splice(M,1,"-<br/>")),J=M,g=M+1):(H.splice(H.length-1,1,"<br/>"+ya[Ia]),A=H.length-2,N=Na(H.slice(J+1,A+1).join("")),J=A,g=Ia);D+=this.lineHeight;
if(D>d)return q.text=wb(n)+Za,q.tooltext=q.oriText,q.width=e,q.height=D-this.lineHeight,q;r=F(r,N);n=null;Ga=p(c.substr(g),v,this);N=Na(c.substr(g,Ga||1));H.length<g+Ga&&(H=H.concat(c.substr(H.length,g+Ga-H.length).split("")),Ia=H.length-1)}r=F(r,N);q.text=H.join("");q.width=r;q.height=D}return q}q.height=n.offsetHeight;q.width=n.offsetWidth}else q.error=Error("Body Tag Missing!");return q},setStyle:function(a){if(!this.init)return!1;if(a!==this.style||this.styleNotSet){a||(a=this.style);var c=a,
e=c.fontSize=c.fontSize||"12px";c.lineHeight=c.lineHeight||c["line-height"]||1.2*parseInt(e,10)+"px";this.style=a;(this.containerObj=a=this.containerManager.get(a))?(this.container=a.node,this.context=a.context,this.cache=a.charCache,this.lineHeight=a.lineHeight,t=a.ellipsesWidth,I=a.dotWidth,this.styleNotSet=!1):this.styleNotSet=!0}},getTextSize:function(a,c,e){if(!this.init)return!1;var d={text:a,width:null,height:null,oriTextWidth:null,oriTextHeight:null,isTruncated:!1},g=this.container;g&&(g.innerHTML=
a,d.oriTextWidth=g.offsetWidth,d.oriTextHeight=g.offsetHeight,d.width=Math.min(d.oriTextWidth,c),d.height=Math.min(d.oriTextHeight,e),d.width<d.oriTextWidth||d.height<d.oriTextHeight)&&(d.isTruncated=!0);return d},getOriSize:function(a){if(!this.init)return!1;var c={text:a,width:null,height:null},e=this.container,d=this.getWidthFunction(),g=0;if(ba){a=a.split(/(<br\s*\/*\>)/g);e=a.length;for(c.height=this.lineHeight*e;e--;)g=F(g,d(a[e]));c.width=g}else e&&(e.innerHTML=a,c.width=e.offsetWidth,c.height=
e.offsetHeight);return c},getOriSizeImprove:function(a,c){if(!this.init)return!1;var e,d,g,q=0,m=0,l={},t,p;if(!c)return this.calCharDimWithCache(a);e=a.split("");t=0;for(p=e.length;t<p;t++)d=e[t],g=this.calCharDimWithCache(d,!0,e.length),m=F(m,g.height),q+=g.width,l[d]=g.width;return{width:A(q),height:m,detailObj:l}},calCharDimWithCache:function(a,c,e){if(!this.init)return!1;var d=this.container,g=this.style||{},q=this.advancedCache||(this.advancedCache={}),m=this.advancedCacheKey||(this.advancedCacheKey=
[]),l=a+(g.fontSize||"")+(g.fontFamily||"")+(g.fontWeight||"")+(g.fontStyle||""),g=a+"init"+(g.fontSize||"")+(g.fontFamily||"")+(g.fontWeight||"")+(g.fontStyle||""),t;r[a]&&(a=r[a]);c?void 0===(c=q[g])&&(d.innerHTML=a.repeat?a.repeat(e):Array(e+1).join(a),c=d.offsetWidth,d.innerHTML=a,t=d.offsetWidth,c=q[g]=(c-e*t)/(e+1),m.push(g),500<m.length&&delete q[m.shift()]):c=0;if(e=q[l])return q=e.split(","),{width:parseFloat(q[0],10),height:parseFloat(q[1],10)};d.innerHTML=a;a={height:d.offsetHeight,width:d.offsetWidth+
c};q[l]=a.width+","+a.height;m.push(l);500<m.length&&delete q[m.shift()];return a}};return n.prototype.constructor=n}();g.SmartLabelManager=n}]);FusionCharts.register("module",["private","modules.renderer.js-numberformatter",function(){var g=this,m=g.hcLib,D=m.pluckNumber,n=m.extend2,F=m.getValidValue,A=m.pluck,J=m.getFirstValue,a=Math.abs,O=Math.pow,d=Math.round,l=function(a){return a&&a.replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&")},N={},ga=function(a){var d=[],c;for(c in a)d.push(c+"_"+a[c]);d.sort();
return d.join(",")},w=function(a){var d={},c;for(c in a)d[c.toLowerCase()]=a[c];return d};m.NumberFormatter=function(){function g(a,c,e){var m;if(0>=c)return d(a)+"";if(isNaN(c))return a+="",12<a.length&&-1!=a.indexOf(".")&&(c=12-a.split(".")[0].length,m=O(10,c),a=d(a*m)/m+""),a;m=O(10,c);a=d(a*m)/m+"";if(1==e)for(-1==a.indexOf(".")&&(a+=".0"),e=a.split("."),c-=e[1].length,e=1;e<=c;e++)a+="0";return a}function m(a,c,e,d,g){var l=Number(a),p="",n=!1,r="",w="",v=r=0;if(isNaN(l))return"";if(1E15<l)return l.toExponential(g?
1:14);r=0;v=a.length;-1!=a.indexOf(".")&&(p=a.substring(a.indexOf(".")+1,a.length),v=a.indexOf("."));0>l&&(n=!0,r=1);r=a.substring(r,v);a=r.length;g=d.length-1;l=d[g];if(a<l)w=r;else for(;a>=l;)w=(a-l?e:"")+r.substr(a-l,l)+w,a-=l,l=0>=--g?d[0]:d[g],a<l&&(w=r.substring(a,0)+w);""!=p&&(w=w+c+p);!0===n&&(w="-"+w);return w}var c,w={formatnumber:"1",formatnumberscale:"1",forcenumberscale:"0",defaultnumberscale:"",numberscaleunit:["K","M"],numberscalevalue:[1E3,1E3],numberprefix:"",numbersuffix:"",decimals:"",
forcedecimals:"0",yaxisvaluedecimals:"2",decimalseparator:".",thousandseparator:",",thousandseparatorposition:[3],indecimalseparator:"",inthousandseparator:"",sformatnumber:"1",sformatnumberscale:"0",sforcenumberscale:"0",sdefaultnumberscale:"",snumberscaleunit:["K","M"],snumberscalevalue:[1E3,1E3],snumberprefix:"",snumbersuffix:"",sdecimals:"2",sforcedecimals:"0",syaxisvaluedecimals:"2",xFormatNumber:"0",xFormatNumberScale:"0",xforcenumberscale:"0",xDefaultNumberScale:"",xNumberScaleUnit:["K","M"],
xNumberScaleValue:[1E3,1E3],xNumberPrefix:"",xNumberSuffix:""},M={mscombidy2d:{formatnumberscale:"1"}},e=function(a,c){var e=a.name,d=this.csConf=n({},w);(e=M[e])&&n(d,e);this.linkedItems={iapi:a};this.configure(c)};e.prototype={configure:function(a){var c=this.linkedItems.iapi,e=c.jsonData;a=a||e.chart;var e=c.name,d=this.csConf,g,m,p,r,M,aa,I,O,C,N,ga,na,ea,ra,V,va,nb,La,Da,Ma;this.csConf=d;this.useScaleRecursively=c.useScaleRecursively;F(a.numberscaleunit)&&(g=a.numberscaleunit.split(","));if(m=
F(a.snumberscaleunit,a.numberscaleunit))m=m.split(",");if(p=F(a.xnumberscaleunit,a.numberscaleunit))p=p.split(",");if(r=F(a.ticknumberscaleunit,a.numberscaleunit))r=r.split(",");if(M=F(a.ynumberscaleunit,a.numberscaleunit))M=M.split(",");F(a.numberscalevalue)&&(aa=a.numberscalevalue.split(","));if(ga=F(a.snumberscalevalue,a.numberscalevalue))ga=ga.split(",");if(I=F(a.xnumberscalevalue,a.numberscalevalue))I=I.split(",");if(O=F(a.ticknumberscalevalue,a.numberscalevalue))O=O.split(",");if(C=F(a.ynumberscalevalue,
a.numberscalevalue))C=C.split(",");if(F(a.thousandseparatorposition))for(N=a.thousandseparatorposition.split(","),na=N.length,ra=w.thousandseparatorposition[0];na--;)ea=parseInt(N[na],10),0>=ea&&(ea=ra),ra=N[na]=ea;c||(c={});na=D(a.scalerecursively,0);ea=D(a.sscalerecursively,na);ra=D(a.xscalerecursively,na);V=D(a.maxscalerecursion,-1);va=D(a.smaxscalerecursion,V);nb=D(a.xmaxscalerecursion,V);La=F(a.scaleseparator," ");Da=F(a.sscaleseparator,La);Ma=F(a.xscaleseparator,La);V||(V=-1);this.baseConf=
N={cacheStore:[],formatnumber:A(a.formatnumber,c.formatnumber,d.formatnumber),formatnumberscale:A(a.formatnumberscale,c.formatnumberscale,d.formatnumberscale),forcenumberscale:A(a.forcenumberscale,c.forcenumberscale,d.forcenumberscale),defaultnumberscale:J(a.defaultnumberscale,c.defaultnumberscale,d.defaultnumberscale),numberscaleunit:A(g,c.numberscaleunit,d.numberscaleunit).concat(),numberscalevalue:A(aa,c.numberscalevalue,d.numberscalevalue).concat(),numberprefix:J(a.numberprefix,c.numberprefix,
d.numberprefix),numbersuffix:J(a.numbersuffix,c.numbersuffix,d.numbersuffix),decimalprecision:parseInt("auto"===a.decimals?d.decimalprecision:A(a.decimals,a.decimalprecision,c.decimals,d.decimals,c.decimalprecision,d.decimalprecision),10),forcedecimals:A(a.forcedecimals,c.forcedecimals,d.forcedecimals),decimalseparator:A(a.decimalseparator,c.decimalseparator,d.decimalseparator),thousandseparator:A(a.thousandseparator,c.thousandseparator,d.thousandseparator),thousandseparatorposition:A(N,c.thousandseparatorposition,
d.thousandseparatorposition),indecimalseparator:J(a.indecimalseparator,c.indecimalseparator,d.indecimalseparator),inthousandseparator:J(a.inthousandseparator,c.inthousandseparator,d.inthousandseparator),scalerecursively:na,maxscalerecursion:V,scaleseparator:La};F(N.inthousandseparator)&&(this.baseConf._REGinthousandseparator=new RegExp(l(N.inthousandseparator),"g"));F(N.indecimalseparator)&&(this.baseConf._REGindecimalseparator=new RegExp(l(N.indecimalseparator)));this.Y=[];g={cacheStore:[],formatnumber:N.formatnumber,
formatnumberscale:N.formatnumberscale,forcenumberscale:N.forcenumberscale,defaultnumberscale:N.defaultnumberscale,numberscaleunit:N.numberscaleunit.concat(),numberscalevalue:N.numberscalevalue.concat(),numberprefix:N.numberprefix,numbersuffix:N.numbersuffix,decimalprecision:N.decimalprecision,forcedecimals:N.forcedecimals,decimalseparator:N.decimalseparator,thousandseparator:N.thousandseparator,thousandseparatorposition:N.thousandseparatorposition,indecimalseparator:N.indecimalseparator,inthousandseparator:N.inthousandseparator,
scalerecursively:na,maxscalerecursion:V,scaleseparator:La};c.useScaleRecursively&&(g.numberscalevalue&&g.numberscalevalue.length)==(g.numberscaleunit&&g.numberscaleunit.length)||(g.scalerecursively=na=0);aa={cacheStore:[],formatnumber:g.formatnumber,formatnumberscale:g.formatnumberscale,forcenumberscale:g.forcenumberscale,defaultnumberscale:g.defaultnumberscale,numberscaleunit:g.numberscaleunit.concat(),numberscalevalue:g.numberscalevalue.concat(),numberprefix:g.numberprefix,numbersuffix:g.numbersuffix,
decimalprecision:parseInt(A(a.yaxisvaluedecimals,g.decimalprecision,2),10),forcedecimals:A(a.forceyaxisvaluedecimals,g.forcedecimals),decimalseparator:g.decimalseparator,thousandseparator:g.thousandseparator,thousandseparatorposition:g.thousandseparatorposition.concat(),indecimalseparator:g.indecimalseparator,inthousandseparator:g.inthousandseparator,scalerecursively:na,maxscalerecursion:V,scaleseparator:La};ga={cacheStore:[],formatnumber:A(a.sformatnumber,c.sformatnumber,w.sformatnumber),formatnumberscale:A(a.sformatnumberscale,
c.sformatnumberscale,w.sformatnumberscale),forcenumberscale:A(a.sforcenumberscale,c.sforcenumberscale,w.sforcenumberscale),defaultnumberscale:J(a.sdefaultnumberscale,c.sdefaultnumberscale,g.defaultnumberscale),numberscaleunit:A(m,c.snumberscaleunit,w.snumberscaleunit).concat(),numberscalevalue:A(ga,c.snumberscalevalue,w.snumberscalevalue).concat(),numberprefix:J(a.snumberprefix,c.snumberprefix,w.snumberprefix),numbersuffix:J(a.snumbersuffix,c.snumbersuffix,w.snumbersuffix),decimalprecision:parseInt(A(a.syaxisvaluedecimals,
a.sdecimals,a.decimals,c.sdecimals,w.sdecimals),10),forcedecimals:A(a.forcesyaxisvaluedecimals,a.sforcedecimals,a.forcedecimals,c.sforcedecimals,w.sforcedecimals),decimalseparator:A(a.decimalseparator,c.decimalseparator,w.decimalseparator),thousandseparator:A(a.thousandseparator,c.thousandseparator,w.thousandseparator),thousandseparatorposition:g.thousandseparatorposition.concat(),indecimalseparator:A(a.indecimalseparator,c.indecimalseparator,w.indecimalseparator),inthousandseparator:A(a.inthousandseparator,
c.inthousandseparator,w.inthousandseparator),scalerecursively:ea,maxscalerecursion:va,scaleseparator:Da};m=n({},ga);m.decimalprecision=parseInt(A(a.sdecimals,a.decimals,a.syaxisvaluedecimals,c.sdecimals,w.sdecimals),10);m.forcedecimals=A(a.sforcedecimals,a.forcedecimals,a.forcesyaxisvaluedecimals,c.sforcedecimals,w.sforcedecimals);m.cacheStore=[];c.useScaleRecursively&&(ga.numberscalevalue&&ga.numberscalevalue.length)==(ga.numberscaleunit&&ga.numberscaleunit.length)||(ga.scalerecursively=ea=0);/^(bubble|scatter|selectscatter|zoomscatter)$/.test(e)&&
(aa.formatnumber=A(a.yformatnumber,aa.formatnumber),aa.formatnumberscale=A(a.yformatnumberscale,aa.formatnumberscale),aa.forcenumberscale=A(a.yforcenumberscale,aa.forcenumberscale),aa.defaultnumberscale=J(a.ydefaultnumberscale,aa.defaultnumberscale),aa.numberscaleunit=A(M,aa.numberscaleunit),aa.numberscalevalue=A(C,aa.numberscalevalue),aa.numberprefix=A(a.ynumberprefix,aa.numberprefix),aa.numbersuffix=A(a.ynumbersuffix,aa.numbersuffix),g.formatnumber=A(a.yformatnumber,g.formatnumber),g.formatnumberscale=
A(a.yformatnumberscale,g.formatnumberscale),g.forcenumberscale=A(a.yforcenumberscale,g.forcenumberscale),g.defaultnumberscale=J(a.ydefaultnumberscale,g.defaultnumberscale),g.numberscaleunit=A(a.ynumberscaleunit,g.numberscaleunit.concat()),g.numberscalevalue=A(a.ynumberscalevalue,g.numberscalevalue.concat()),g.numberprefix=A(a.ynumberprefix,g.numberprefix),g.numbersuffix=A(a.ynumbersuffix,g.numbersuffix));/^(pie2d|pie3d|doughnut2d|doughnut3d|marimekko|pareto2d|pareto3d)$/.test(e)&&(g.decimalprecision=
A(a.decimals,"2"));na&&(g.numberscalevalue.push(1),g.numberscaleunit.unshift(g.defaultnumberscale),aa.numberscalevalue.push(1),aa.numberscaleunit.unshift(aa.defaultnumberscale));ea&&(ga.numberscalevalue.push(1),ga.numberscaleunit.unshift(ga.defaultnumberscale),m.numberscalevalue.push(1),m.numberscaleunit.unshift(m.defaultnumberscale));this.Y[0]={yAxisLabelConf:aa,dataLabelConf:g};this.Y[1]={yAxisLabelConf:ga,dataLabelConf:m};this.paramLabels=g;this.param1=aa;this.param2=ga;this.paramLabels2=m;this.paramX=
{cacheStore:[],formatnumber:A(a.xformatnumber,N.formatnumber),formatnumberscale:A(a.xformatnumberscale,N.formatnumberscale),forcenumberscale:A(a.xforcenumberscale,N.forcenumberscale),defaultnumberscale:J(a.xdefaultnumberscale,N.defaultnumberscale),numberscaleunit:A(p,N.numberscaleunit.concat()),numberscalevalue:A(I,N.numberscalevalue.concat()),numberprefix:A(a.xnumberprefix,N.numberprefix),numbersuffix:A(a.xnumbersuffix,N.numbersuffix),decimalprecision:parseInt(A(a.xaxisvaluedecimals,a.xaxisvaluesdecimals,
N.decimalprecision,2),10),forcedecimals:A(a.forcexaxisvaluedecimals,0),decimalseparator:N.decimalseparator,thousandseparator:N.thousandseparator,thousandseparatorposition:N.thousandseparatorposition.concat(),indecimalseparator:N.indecimalseparator,inthousandseparator:N.inthousandseparator,scalerecursively:ra,maxscalerecursion:nb,scaleseparator:Ma};this.paramLegend=n(n({},N),{cacheStore:[],decimalprecision:parseInt(D(a.legendvaluedecimals,N.decimalprecision,2),10),forcedecimals:D(a.legendvalueforcedecimals,
N.forcedecimals,0),formatnumberscale:A(a.legendvalueformatnumberscale,N.formatnumberscale),forcenumberscale:A(a.legendvalueforcenumberscale,N.forcenumberscale),formatnumber:A(a.legendvalueformatnumber,N.formatnumber)});na&&(this.paramLegend.numberscalevalue.push(1),this.paramLegend.numberscaleunit.unshift(this.paramLegend.defaultnumberscale));c.useScaleRecursively&&(this.paramX.numberscalevalue&&this.paramX.numberscalevalue.length)==(this.paramX.numberscaleunit&&this.paramX.numberscaleunit.length)||
(this.paramX.scalerecursively=ra=0);ra&&(this.paramX.numberscalevalue.push(1),this.paramX.numberscaleunit.unshift(this.paramX.defaultnumberscale));this.paramScale={cacheStore:[],formatnumber:A(a.tickformatnumber,N.formatnumber),formatnumberscale:A(a.tickformatnumberscale,N.formatnumberscale),forcenumberscale:A(a.tickforcenumberscale,N.forcenumberscale),defaultnumberscale:J(a.tickdefaultnumberscale,N.defaultnumberscale),numberscaleunit:A(r,N.numberscaleunit.concat()),numberscalevalue:A(O,N.numberscalevalue.concat()),
numberprefix:A(a.ticknumberprefix,N.numberprefix),numbersuffix:A(a.ticknumbersuffix,N.numbersuffix),decimalprecision:parseInt(A(a.tickvaluedecimals,N.decimalprecision,"2"),10),forcedecimals:A(a.forcetickvaluedecimals,N.forcedecimals,0),decimalseparator:N.decimalseparator,thousandseparator:N.thousandseparator,thousandseparatorposition:N.thousandseparatorposition.concat(),indecimalseparator:N.indecimalseparator,inthousandseparator:N.inthousandseparator,scalerecursively:na,maxscalerecursion:V,scaleseparator:La};
na&&(this.paramScale.numberscalevalue.push(1),this.paramScale.numberscaleunit.unshift(this.paramScale.defaultnumberscale));this.timeConf={inputDateFormat:A(a.inputdateformat,a.dateformat,"mm/dd/yyyy"),outputDateFormat:A(a.outputdateformat,a.inputdateformat,a.dateformat,"mm/dd/yyyy"),days:"Sunday Monday Tuesday Wednesday Thursday Friday Saturday".split(" "),months:"January February March April May June July August September October November December".split(" "),daySuffix:" st nd rd th th th th th th th th th th th th th th th th th st nd rd th th th th th th th st".split(" ")};
this.cleaneValueCacheStore={};this.percentStrCacheStore={}},cleaneValueCacheStore:{},percentStrCacheStore:{},dispose:function(){this.Y&&delete this.Y;this.cleaneValueCacheStore&&delete this.cleaneValueCacheStore;this.percentStrCacheStore&&delete this.percentStrCacheStore;this.paramLabels&&delete this.paramLabels;this.param1&&delete this.param1;this.param2&&delete this.param2;this.paramLabels2&&delete this.paramLabels2;this.csConf&&delete this.csConf;this.iapi&&delete this.iapi;this.baseConf&&delete this.baseConf;
this.timeConf&&delete this.timeConf;this.paramX&&delete this.paramX;this.paramScale&&delete this.paramScale},parseMLAxisConf:function(c,e){var d=this.baseConf,g=this.csConf,m=D(c.scalerecursively,d.scalerecursively),l=D(c.maxscalerecursion,d.maxscalerecursion),p=F(c.scaleseparator,d.scaleseparator),n,r,aa,I,M,C;e=D(e,this.Y.length);F(c.numberscaleunit)&&(n=c.numberscaleunit.split(","));F(c.numberscalevalue)&&(r=c.numberscalevalue.split(","));l||(l=-1);if(F(c.thousandseparatorposition))for(aa=c.thousandseparatorposition.split(","),
I=aa.length,C=w.thousandseparatorposition[0];I--;)(M=D(a(aa[I])))?C=M:M=C,aa[I]=M;d={cacheStore:[],formatnumber:A(c.formatnumber,d.formatnumber),formatnumberscale:A(c.formatnumberscale,d.formatnumberscale),forcenumberscale:A(c.forcenumberscale,d.forcenumberscale),defaultnumberscale:J(c.defaultnumberscale,d.defaultnumberscale),numberscaleunit:A(n,d.numberscaleunit).concat(),numberscalevalue:A(r,d.numberscalevalue).concat(),numberprefix:J(c.numberprefix,d.numberprefix),numbersuffix:J(c.numbersuffix,
d.numbersuffix),forcedecimals:A(c.forcedecimals,d.forcedecimals),decimalprecision:parseInt("auto"===c.decimals?g.decimalprecision:A(c.decimals,d.decimalprecision),10),decimalseparator:A(c.decimalseparator,d.decimalseparator),thousandseparator:A(c.thousandseparator,d.thousandseparator),thousandseparatorposition:A(aa,d.thousandseparatorposition),indecimalseparator:J(c.indecimalseparator,d.indecimalseparator),inthousandseparator:J(c.inthousandseparator,d.inthousandseparator),scalerecursively:m,maxscalerecursion:l,
scaleseparator:p};this.useScaleRecursively&&(d.numberscalevalue&&d.numberscalevalue.length)==(d.numberscaleunit&&d.numberscaleunit.length)||(d.scalerecursively=m=0);l={cacheStore:[],formatnumber:d.formatnumber,formatnumberscale:d.formatnumberscale,forcenumberscale:d.forcenumberscale,defaultnumberscale:d.defaultnumberscale,numberscaleunit:d.numberscaleunit.concat(),numberscalevalue:d.numberscalevalue.concat(),numberprefix:d.numberprefix,numbersuffix:d.numbersuffix,decimalprecision:parseInt(A(c.yaxisvaluedecimals,
d.decimalprecision,2),10),forcedecimals:A(c.forceyaxisvaluedecimals,d.forcedecimals),decimalseparator:d.decimalseparator,thousandseparator:d.thousandseparator,thousandseparatorposition:d.thousandseparatorposition.concat(),indecimalseparator:d.indecimalseparator,inthousandseparator:d.inthousandseparator,scalerecursively:m,maxscalerecursion:l,scaleseparator:p};m&&(d.numberscalevalue.push(1),d.numberscaleunit.unshift(d.defaultnumberscale),l.numberscalevalue.push(1),l.numberscaleunit.unshift(l.defaultnumberscale));
this.Y[e]={dataLabelConf:d,yAxisLabelConf:l}},percentValue:function(a){var c=this.percentStrCacheStore[a];void 0===c&&(c=isNaN(this.paramLabels.decimalprecision)?"2":this.paramLabels.decimalprecision,c=this.percentStrCacheStore[a]=m(g(a,c,this.paramLabels.forcedecimals),this.paramLabels.decimalseparator,this.paramLabels.thousandseparator,this.paramLabels.thousandseparatorposition)+"%");return c},getCleanValue:function(c,e){var d=this.cleaneValueCacheStore[c];if(void 0===d||e){var g=this.baseConf,
d=c+"";g._REGinthousandseparator&&(d=d.replace(g._REGinthousandseparator,""));g._REGindecimalseparator&&(d=d.replace(g._REGindecimalseparator,"."));d=parseFloat(d);d=isFinite(d)?d:NaN;this.cleaneValueCacheStore[c]=d=isNaN(d)?null:e?a(d):d}return d},dataLabels:function(a,e){var d=this.Y[e]||(e?this.Y[1]:this.Y[0]),g,d=d&&d.dataLabelConf||this.baseConf;g=d.cacheStore[a];void 0===g&&(g=d.cacheStore[a]=c(a,d));return g},yAxis:function(a,e){var d=this.Y[e]||(e?this.Y[1]:this.Y[0]),g,d=d&&d.yAxisLabelConf||
this.baseConf;g=d.cacheStore[a];void 0===g&&(g=d.cacheStore[a]=c(a,d,!0));return g},xAxis:function(a){var e=this.paramX.cacheStore[a];void 0===e&&(e=this.paramX.cacheStore[a]=c(a,this.paramX,!0));return e},sYAxis:function(a){var e=this.Y[1],d,e=e&&e.yAxisLabelConf||this.baseConf;d=e.cacheStore[a];void 0===d&&(d=e.cacheStore[a]=c(a,e));return d},scale:function(a){var e=this.paramScale.cacheStore[a];void 0===e&&(e=this.paramScale.cacheStore[a]=c(a,this.paramScale));return e},getCleanTime:function(a){var c;
this.timeConf.inputDateFormat&&Date.parseExact&&(c=Date.parseExact(a,this.timeConf.inputDateFormat));return c&&c.getTime()},legendValue:function(a){var e=this.paramLegend.cacheStore[a];void 0===e&&(e=this.paramLegend.cacheStore[a]=c(a,this.paramLegend));return e},legendPercentValue:function(a){var c=this.percentStrCacheStore[a],e=this.paramLegend;void 0===c&&(c=isNaN(e.decimalprecision)?"2":e.decimalprecision,c=this.percentStrCacheStore[a]=m(g(a,c,e.forcedecimals),e.decimalseparator,e.thousandseparator,
e.thousandseparatorposition)+"%");return c},getDateValue:function(a){var c,e,d;a&&!/\//.test(this.timeConf.inputDateFormat)&&(a=a.replace(new RegExp(this.timeConf.inputDateFormat.replace(/[a-z]/ig,"").slice(0,1),"g"),"/"));a=/^dd/.test(this.timeConf.inputDateFormat)&&a&&a.replace(/(\d{1,2})\/(\d{1,2})\/(\d{2,4})/,"$2/$1/$3")||a;c=new Date(a);e=c.getTime();!e&&a&&/\:/.test(a)&&(a=a.split(":"),e=D(a[0],0),d=D(a[1],0),a=D(a[2],0),e=23<e?24===e&&0===d&&0===a?e:23:e,d=59<d?59:d,a=59<a?59:a,c=new Date,
c.setHours(e),c.setMinutes(d),c.setSeconds(a),e=c.getTime());return{ms:e,date:c}},getFormattedDate:function(a,c){var e="object"===typeof a&&a||new Date(a),d=this.timeConf,g=A(c,d.outputDateFormat),m=e.getFullYear(),l=e.getMonth(),p=e.getDate(),n=e.getDay(),r=e.getMinutes(),w=e.getSeconds(),e=e.getHours(),r=9<r?""+r:"0"+r,w=9<w?""+w:"0"+w,e=9<e?""+e:"0"+e;g.match(/dnl/)&&(g=g.replace(/dnl/ig,d.days[n]));g.match(/dns/)&&(g=g.replace(/dns/ig,d.days[n]&&d.days[n].substr(0,3)));g.match(/dd/)&&(g=g.replace(/dd/ig,
p));g.match(/mnl/)&&(g=g.replace(/mnl/ig,d.months[l]));g.match(/mns/)&&(g=g.replace(/mns/ig,d.months[l]&&d.months[l].substr(0,3)));g.match(/mm/)&&(g=g.replace(/mm/ig,l+1));g.match(/yyyy/)&&(g=g.replace(/yyyy/ig,m));g.match(/yy/)&&(g=g.replace(/yy/ig,(m%1E3%100+"").replace(/^(\d)$/,"0$1")));g.match(/hh12/)&&(g=g.replace(/hh12/ig,e%12||12));g.match(/hh/)&&(g=g.replace(/hh/ig,e));g.match(/mn/)&&(g=g.replace(/mn/ig,r));g.match(/ss/)&&(g=g.replace(/ss/ig,w));g.match(/ampm/)&&(g=g.replace(/ampm/ig,12>e?
"AM":"PM"));g.match(/ds/)&&(g=g.replace(/ds/ig,d.daySuffix[p]));return g}};e.prototype.constructor=e;c=function(a,c,e){if(null!==a){a=Number(a);var d=a+"",l,n,w,v,F;l=1==c.formatnumberscale?c.defaultnumberscale:"";F=(F=d.split(".")[1])?F.length:c.forcedecimals?"2":"";if(1==c.formatnumberscale){d=a;n=c.defaultnumberscale;a=c.numberscalevalue;l=c.numberscaleunit;var M=c.scalerecursively;w=c.forcenumberscale;v={};var I=n,N=0,C=[],J=[],O;w=D(w)||0;if(M){I=D(a[0])||1E3;for(N=0;N<a.length;N++)if(M=D(a[N])||
1E3,Math.abs(Number(d))>=M&&N<a.length-1)O=d%M,d=(d-O)/M,0===N&&0!==O&&""===l[N]&&w?(C.push(O/I),J.push(l[1]||"")):0!==O&&(1===N&&""===n&&w?(M=O+(C.length?C.pop():0),J.pop(),C.push(M)):C.push(O),J.push(l[N]));else{0===N&&""===n&&w?(d=Number(d)/I,C.push(d),J.push(l[1]||"")):(1===N&&""===n&&w?(M=d+(C.length?C.pop():0),J.pop(),C.push(M)):C.push(d),J.push(l[N]));break}C.reverse();J.reverse();v.value=C;v.scale=J}else{if(a.length===l.length)for(N=0;N<a.length;N++)if(M=D(a[N])||1E3,Math.abs(Number(d))>=
M)I=l[N]||"",d=Number(d)/M;else{0===N&&""===n&&w&&(I=l[0]||"",d=Number(d)/M);break}v.value=d;v.scale=I}n=v;a=d=n.value;l=n.scale}if(c.scalerecursively&&0!==c.formatnumberscale&&"0"!==c.formatnumberscale){e=n.value;n=n.scale;a=-1==c.maxscalerecursion?e.length:Math.min(e.length,c.maxscalerecursion);if(1==c.formatnumber)for(d="",v=0;v<a;v++)l=0===v?e[v]:Math.abs(e[v]),w=l+"",v==a-1&&(w=g(l,A(c.decimalprecision,F),c.forcedecimals)),d=d+m(w,c.decimalseparator,c.thousandseparator,c.thousandseparatorposition)+
n[v]+(v<a-1?c.scaleseparator:"");else for(d="",v=0;v<a;v++)d=d+(0===v?e[v]:Math.abs(e[v])+"")+n[v]+(v<a-1?c.scaleseparator:"");d=(c.numberprefix||"")+d+(c.numbersuffix||"")}else 1==c.formatnumber&&(d=g(a,A(c.decimalprecision,F),c.forcedecimals),d=m(d,c.decimalseparator,c.thousandseparator,c.thousandseparatorposition,e)),d=(c.numberprefix||"")+d+l+(c.numbersuffix||"");return d}};return e}();g.extend(g.core,{formatNumber:function(a,d,c){d=d&&w(d)||{};var g=ga(d),l;N[g]?l=N[g]:N[g]=l=new m.NumberFormatter(d,
{useScaleRecursively:!0});return l.dataLabels(a,c)}},!1);g.extend(g.core,{formatNumber:function(a,d,c,l){c=c&&w(c)||{};var A=this.jsVars.instanceAPI||{},e=A.numberFormatter,q;""===ga(c)?e?q=e:(e=this.getChartData(g.dataFormats.JSON,!0),e=e.data||{},e=e.chart||{},c=ga(e),N[c]?q=N[c]:N[c]=q=new m.NumberFormatter(e,A)):(e=this.getChartData(g.dataFormats.JSON,!0),e=e.data||{},e=e.chart||{},e=n(n({},e),c),c=ga(e),N[c]?q=N[c]:N[c]=q=new m.NumberFormatter(e,A));switch((d&&d.toLowerCase?d:"").toLowerCase()){case "yaxisvalues":a=
q.yAxis(a,l);break;case "xaxisvalues":a=q.xAxis(a);break;case "scale":a=q.scale(a);break;default:a=q.dataLabels(a,l)}return a}},!0)}]);FusionCharts.register("module",["private","modules.renderer.js-dom",function(){var g=this.hcLib,m=this.window,D=m.document,n=g.extend2,F="ontouchstart"in m;(function(g){var J=function(){var a={},d;a.pointerdrag={start:["mousedown"],end:["mouseup"],onStart:["mousemove"],postHandlers:{},preHandlers:{}};a.pointerhover={start:["mouseover"],end:["mouseout"]};a.click={start:["click"]};
a.escape={start:["keydown"],preHandlers:{start:function(a){a=a||m.event;return a.keyCode&&27===a.keyCode?!0:!1}}};F&&(d=a.pointerdrag,d.start.push("touchstart"),d.end.push("touchend"),d.onStart.push("touchmove"),d.postHandlers.onStart=function(a){a.preventDefault?a.preventDefault():a.returnValue=!1});return a}(),a;a=n({},J);g.dem=new function(){var g={},d={},l=D.addEventListener?function(a,c,d){a.addEventListener(c,d,!1)}:function(a,c,d){a.attachEvent("on"+c,d)},A=D.removeEventListener?function(a,
c,d){a.removeEventListener(c,d,!1)}:function(a,c,d){a.detachEvent("on"+c,d)},F=function(d,c,g){var l=[],e,q,n;n=a[c];g.start=function(a){a=a||m.event;for(var c=n.onStart,e=n.end,l=[],q=[],r=c&&c.length||0;r--;)l.push(w(d,c[r],g,"onStart"));for(r=e&&e.length||0;r--;)q.push(w(d,e[r],g,"end"));g.startUn=g.startUn?g.startUn.concat(l):l;g.endUn=g.endUn?g.endUn.concat(q):q;g.state="start";g.closure(a)};g.onStart=function(a){a=a||m.event;g.state="on";if(g.gDef&&g.gDef.preHandlers&&"function"===typeof g.gDef.preHandlers.onStart)g.gDef.preHandlers.onStart(a);
g.closure(a);if(g.gDef&&g.gDef.postHandlers&&"function"===typeof g.gDef.postHandlers.onStart)g.gDef.postHandlers.onStart(a)};g.end=function(a){a=a||m.event;for(var c=g.startUn,e=g.endUn,d=c&&c.length||0;d--;)c[d]();delete g.startUn;g.startUn=[];for(d=e&&e.length||0;d--;)e[d]();delete g.endUn;g.endUn=[];g.state="end";g.closure(a)};if(n)for(c=n.start,q=c.length;q--;)(e=c[q])&&l.push(w(d,e,g,"start"));return l},w=function(a,c,d,g){g=g||"closure";l(a,c,d[g]);return function(){A(a,c,d[g])}},r=function(a){return function(c){c=
c||m.event;a.handler.call(a.context||a.elem,{data:a.data,type:a.type,state:a.state,isGesture:a.isGesture,target:c.target||c.srcElement,originalEvent:c})}};return{listen:function(l,c,m,n,e){var q=this;c="string"===typeof c?c.split(" "):c;var H=c.length,t=[],A=function(a,c,e){t.push(function(){q.unlisten(a,c,e)})},K,N,J,T,ba;if(l.ownerDocument&&l.ownerDocument===D)for(;H--;)N=c[H],T=!!a[N],ba="function"===typeof m?m:m[H],J={handler:ba,elem:l,type:N,isGesture:T,gDef:T?a[N]:null,data:n,context:e,start:[],
end:[],links:{prev:null,next:null}},J.closure=r(J),T?((K=d[N])||(K=d[N]=[]),K.push(J),F(l,N,J)):((K=g[N])||(K=g[N]=[]),K.push(J),w(l,N,J)),A(l,N,ba);else for(;H--;)N=c[H],ba="function"===typeof m?m:m[H],J={handler:ba,elem:l,type:N,isGesture:T,data:n,context:e,start:[],end:[],links:{prev:null,next:null}},J.closure=r(J),(K=g[N])||(K=g[N]=[]),K.push(J),w(l,N,J),A(l,N,ba);return{unlisten:function(){for(var a=t.length;a--;)t[a]();t.length=0;t=null}}},unlisten:function(l,c,m){var n,e=!1,q,r;if(a[c])for(q=
(n=d[c])&&n.length||0;q--;){if(r=n[q],r.handler===m&&r.elem===l){var e=l,t=void 0,w=void 0,D=void 0,t=void 0;if(t=a[c])for(t=t.start,D=t.length;D--;)(w=t[D])&&A(e,w,r.start);n.splice(q,1);e=!0}}else for(q=(n=g[c])&&n.length||0;q--;)r=n[q],r.handler===m&&r.elem===l&&(A(l,c,r.closure),n.splice(q,1),e=!0);return e},fire:function(a,c,d,l){var e;if(a.ownerDocument&&a.ownerDocument===D)D.createEvent?(e=D.createEvent("HTMLEvents"),e.initEvent(c,!0,!0),d&&(d.originalEvent?d.originalEvent=e:n(e,d)),"function"===
typeof a[c]&&a[c].call(a),a.dispatchEvent(e)):(e=D.createEventObject(),e.eventType=c,d&&(d.originalEvent?d.originalEvent=e:n(e,d)),"function"===typeof a[c]&&a[c].call(a),a.fireEvent("on"+c,e)),l&&!e.returnValue&&l(e);else for(l=(c=g[c])&&c.length||0;l--;)e=c[l],e.elem===a&&e.closure(d)}}}})(g||m);(function(g){function F(a,d){var g="";D.defaultView&&D.defaultView.getComputedStyle?g=D.defaultView.getComputedStyle(a,"").getPropertyValue(d):a.currentStyle&&(d=d.replace(/\-(\w)/g,function(a,d){return d.toUpperCase()}),
g=a.currentStyle[d]);g=parseInt(g,10);return isNaN(g)?0:g}function a(a,g,n,r,p,c,v,A){var e=g/40,q=d[c||"linear"](r-n,e),H=0,t,D,K=m.requestAnimationFrame||m.webkitRequestAnimationFrame||m.mozRequestAnimationFrame||m.oRequestAnimationFrame||m.msRequestAnimationFrame||function(a){setTimeout(a,40)},F=function(c){var d;d=!1;c?(t||(t=c),D=c-t,c=Math.abs(n-r),d=(d=0>n-r?!1:!0)?Math.max(n-c/g*D,r)+A:Math.min(n+c/g*D,r)+A,a.style[p]=d,l&&"opacity"===p&&(d=100*Number(d),a.style.filter="progid:DXImageTransform.Microsoft.Alpha(Opacity="+
d+")"),D<g?K(F):v&&v()):H<e?(d=q[H],a.style[p]=n+d+A,l&&"opacity"===p&&(d=100*Number(d),a.style.filter="progid:DXImageTransform.Microsoft.Alpha(Opacity="+d+")"),H+=1,setTimeout(F,40)):v&&v()};A=A||"";K(F)}var O={width:{suffix:"px"},height:{suffix:"px"},opacity:!0,top:{suffix:"px"},left:{suffix:"px"}},d={linear:function(a,d){for(var g=[],l=a/d,m=0;m<d;m+=1)g[m]=l*(m+1);return g}},l=/msie/i.test(m.navigator.userAgent)&&!m.opera;g.danimate=n({animate:function(d,g,l,m,p){m={};var c={},n=function(){e+=
1;e===A&&"function"===typeof p&&p()},A=0,e=0,q,H;if(40>l){for(H in g)d.style[H]=g[H];p&&p()}else for(H in g)q=null,"x"===H?(q=H,H="left"):"y"===H&&(q=H,H="top"),O[H]&&(A+=1,m[H]=g[q||H],c[H]=F(d,H),q="object"===typeof O[H]&&O[H].suffix,a(d,l,c[H],m[H],H,"linear",n,q))}},{})})(g||m)}]);FusionCharts.register("module",["private","modules.renderer.js-colormanager",function(){var g=this.hcLib,m=g.pluckNumber,D=g.graphics.getDarkColor,n=g.graphics.getLightColor,F="AFD8F8 F6BD0F 8BBA00 FF8E46 008E8E D64646 8E468E 588526 B3AA00 008ED6 9D080D A186BE CC6600 FDC689 ABA000 F26D7D FFF200 0054A6 F7941C CC3300 006600 663300 6DCFF6".split(" "),
A="8BBA00 F6BD0F FF654F AFD8F8 FDB398 CDC309 B1D0D2 FAD1B9 B8A79E D7CEA5 C4B3CE E9D3BE EFE9AD CEA7A2 B2D9BA".split(" "),J=g.defaultPaletteOptions={paletteColors:[F,F,F,F,F],bgColor:["CBCBCB,E9E9E9","CFD4BE,F3F5DD","C5DADD,EDFBFE","A86402,FDC16D","FF7CA0,FFD1DD"],bgAngle:[270,270,270,270,270],bgRatio:["0,100","0,100","0,100","0,100","0,100"],bgAlpha:["50,50","60,50","40,20","20,10","30,30"],canvasBgColor:["FFFFFF","FFFFFF","FFFFFF","FFFFFF","FFFFFF"],canvasBgAngle:[0,0,0,0,0],canvasBgAlpha:["100",
"100","100","100","100"],canvasBgRatio:["","","","",""],canvasBorderColor:["545454","545454","415D6F","845001","68001B"],canvasBorderAlpha:[100,100,100,90,100],showShadow:[0,1,1,1,1],divLineColor:["717170","7B7D6D","92CDD6","965B01","68001B"],divLineAlpha:[40,45,65,40,30],altHGridColor:["EEEEEE","D8DCC5","99C4CD","DEC49C","FEC1D0"],altHGridAlpha:[50,35,10,20,15],altVGridColor:["767575","D8DCC5","99C4CD","DEC49C","FEC1D0"],altVGridAlpha:[10,20,10,15,10],anchorBgColor:["FFFFFF","FFFFFF","FFFFFF","FFFFFF",
"FFFFFF"],toolTipBgColor:["FFFFFF","FFFFFF","FFFFFF","FFFFFF","FFFFFF"],toolTipBorderColor:["545454","545454","415D6F","845001","68001B"],baseFontColor:["555555","60634E","025B6A","A15E01","68001B"],borderColor:["767575","545454","415D6F","845001","68001B"],borderAlpha:[50,50,50,50,50],legendBgColor:["FFFFFF","FFFFFF","FFFFFF","FFFFFF","FFFFFF"],legendBorderColor:["545454","545454","415D6F","845001","D55979"],plotGradientColor:["FFFFFF","FFFFFF","FFFFFF","FFFFFF","FFFFFF"],plotBorderColor:["333333",
"8A8A8A","FFFFFF","FFFFFF","FFFFFF"],plotFillColor:["767575","D8DCC5","99C4CD","DEC49C","FEC1D0"],bgColor3D:["FFFFFF","FFFFFF","FFFFFF","FFFFFF","FFFFFF"],bgAlpha3D:["100","100","100","100","100"],bgAngle3D:[90,90,90,90,90],bgRatio3D:["","","","",""],canvasBgColor3D:["DDE3D5","D8D8D7","EEDFCA","CFD2D8","FEE8E0"],canvasBaseColor3D:["ACBB99","BCBCBD","C8A06C","96A4AF","FAC7BC"],divLineColor3D:["ACBB99","A4A4A4","BE9B6B","7C8995","D49B8B"],divLineAlpha3D:[100,100,100,100,100],legendBgColor3D:["F0F3ED",
"F3F3F3","F7F0E8","EEF0F2","FEF8F5"],legendBorderColor3D:["C6CFB8","C8C8C8","DFC29C","CFD5DA","FAD1C7"],toolTipbgColor3D:["FFFFFF","FFFFFF","FFFFFF","FFFFFF","FFFFFF"],toolTipBorderColor3D:["49563A","666666","49351D","576373","681C09"],baseFontColor3D:["49563A","4A4A4A","49351D","48505A","681C09"],anchorBgColor3D:["FFFFFF","FFFFFF","FFFFFF","FFFFFF","FFFFFF"]},F=g.colorManager=function(a){this.linkedItems={iapi:a};this.configure()};F.prototype={configure:function(){var a=this.linkedItems.iapi,A=a.jsonData.chart||
{},d=g.extend2({},J),l=a.defaultPaletteOptions||{},F;d||(d={});for(F in l)d[F]=l[F];d=this.paletteOptions=d;l=this.themeEnabled=A.palettethemecolor;this.paletteIndex=(0<A.palette&&6>A.palette?A.palette:m(a.paletteIndex,1))-1;this.iterator=0;this.paletteColors=d.paletteColors[this.themeEnabled?0:this.paletteIndex];F=A.palettecolors;void 0!==F&&null!==F&&""!==A.palettecolors&&(this.paletteColors=A.palettecolors.split(/\s*\,\s*/));this.paletteLen=this.paletteColors.length;this.useFlatColors=m(A.useflatdataplotcolor,
a.useFlatColor,0);l&&(this.paletteIndex=5,d.bgColor[5]=n(l,35)+","+n(l,10),d.bgAngle[5]=270,d.bgRatio[5]="0,100",d.bgAlpha[5]="50,50",d.canvasBgColor[5]="FFFFFF",d.canvasBgAngle[5]=0,d.canvasBgAlpha[5]="100",d.canvasBgRatio[5]="",d.canvasBorderColor[5]=D(l,80),d.canvasBorderAlpha[5]=100,d.showShadow[5]=1,d.divLineColor[5]=D(l,20),d.divLineAlpha[5]=40,d.altHGridColor[5]=n(l,20),d.altHGridAlpha[5]=15,d.altVGridColor[5]=n(l,80),d.altVGridAlpha[5]=10,d.anchorBgColor[5]="FFFFFF",d.toolTipBgColor[5]="FFFFFF",
d.toolTipBorderColor[5]=D(l,80),d.baseFontColor[5]=l.split&&l.split(",")[0],d.borderColor[5]=D(l,60),d.borderAlpha[5]=50,d.legendBgColor[5]="FFFFFF",d.legendBorderColor[5]=D(l,80),d.plotGradientColor[5]="FFFFFF",d.plotBorderColor[5]=D(l,85),d.plotFillColor[5]=D(l,85),d.bgColor3D[5]="FFFFFF",d.bgAlpha3D[5]="100",d.bgAngle3D[5]=90,d.bgRatio3D[5]="",d.canvasBgColor3D[5]=n(l,20),d.canvasBaseColor3D[5]=n(l,40),d.divLineColor3D[5]=D(l,20),d.divLineAlpha3D[5]=40,d.legendBgColor3D[5]="FFFFFF",d.legendBorderColor3D[5]=
D(l,80),d.toolTipbgColor3D[5]="FFFFFF",d.toolTipBorderColor3D[5]=D(l,80),d.baseFontColor3D[5]=l.split&&l.split(",")[0],d.anchorBgColor3D[5]="FFFFFF",d.tickColor&&(d.tickColor[5]=D(l,90)),d.trendDarkColor&&(d.trendDarkColor[5]=D(l,90)),d.trendLightColor&&(d.trendLightColor[5]=n(l,d.TrendLightShadeOffset)),d.msgLogColor&&(d.msgLogColor[5]=n(l,80)),d.dialColor&&(d.dialColor[5]=D(l,95)+",FFFFFF,"+D(l,95)),d.dialBorderColor&&(d.dialBorderColor[5]=D(l,95)+",FFFFFF,"+D(l,95)),d.pivotColor&&(d.pivotColor[5]=
n(l,95)+",FFFFFF,"+n(l,95)),d.pivotBorderColor&&(d.pivotBorderColor[5]=D(l,95)+",FFFFFF,"+D(l,95)),d.pointerBorderColor&&(d.pointerBorderColor[5]=D(l,75)),d.pointerBgColor&&(d.pointerBgColor[5]=D(l,75)),d.thmBorderColor&&(d.thmBorderColor[5]=D(l,90)),d.thmFillColor&&(d.thmFillColor[5]=n(l,55)),d.gaugeBorderColor&&(d.gaugeBorderColor[5]=D(l,90)),d.gaugeFillColor&&(d.gaugeFillColor[5]=n(l,55)),d.cylFillColor&&(d.cylFillColor[5]=n(l,55)),d.periodColor&&(d.periodColor[5]=n(l,10)),d.winColor&&(d.winColor[5]=
"666666"),d.lossColor&&(d.lossColor[5]="CC0000"),d.drawColor&&(d.drawColor[5]="666666"),d.scorelessColor&&(d.scorelessColor[5]="FF0000"),d.gridColor&&(d.gridColor[5]=n(l,30)),d.categoryBgColor&&(d.categoryBgColor[5]=n(l,10)),d.dataTableBgColor&&(d.dataTableBgColor[5]=n(l,10)),d.gridResizeBarColor&&(d.gridResizeBarColor[5]=D(l,90)),d.scrollBarColor&&(d.scrollBarColor[5]=n(l,50)))},getColor:function(a){return this.paletteOptions[a][this.paletteIndex]},getPlotColor:function(a){var g=this.paletteColors;
a=this.useFlatColors?this.getColor("plotFillColor"):g[a%this.paletteLen];a||(this.iterator===this.paletteLen&&(this.iterator=0),a=g[this.iterator],this.iterator+=1);return a},parseColorMix:function(a,g){var d=[],l,m,A,w,r,p,c,v,F,e;g=g.replace(/\s/g,"");g=g.toLowerCase();if(""===g||null===g||void 0===g)d=[a];else for(m=g.split(","),A=a.split(","),w=Math.max(m.length,A.length,1),r=m[0],p=A[0],F=/[\{\}]/ig,e=0;e<w;e++)c=(m[e]||r).replace(F,""),v=A[e]||p,"color"==c?d.push(v):"light"==c.substr(0,5)?(l=
c.indexOf("-"),l=-1==l?1:c.substr(l+1,c.length-l),l=100-l,d.push(n(v,l))):"dark"==c.substr(0,4)?(l=c.indexOf("-"),l=-1==l?1:c.substr(l+1,c.length-l),l=100-l,d.push(D(v,l))):d.push(c);return d},parseAlphaList:function(a,g){var d=a.split(","),l=[],n,A=100,w;for(w=0;w<g;w++)n=m(d[w]),void 0!==n&&null!==n&&(A=n),l[w]=A;return l.join()},parseRatioList:function(a,g){var d=a.split(","),l=[],m=0,n,w;for(w=0;w<g;w++)n=d[w],n=isNaN(n)||void 0===n?0:Math.abs(Number(n)),n=100<n?100:n,l[w]=n,m+=n;m=100<m?100:
m;if(d.length<g)for(w=d.length;w<g;w++)l[w]=(100-m)/(g-d.length);l[-1]=0;return l.join()}};F.prototype.constructor=F;g.defaultGaugePaletteOptions={paletteColors:[A,A,A,A,A],bgColor:["CBCBCB,E9E9E9","CFD4BE,F3F5DD","C5DADD,EDFBFE","A86402,FDC16D","FF7CA0,FFD1DD"],bgAngle:[270,270,270,270,270],bgRatio:["0,100","0,100","0,100","0,100","0,100"],bgAlpha:["50,50","60,50","40,20","20,10","30,30"],toolTipBgColor:["FFFFFF","FFFFFF","FFFFFF","FFFFFF","FFFFFF"],toolTipBorderColor:["545454","545454","415D6F",
"845001","68001B"],baseFontColor:["555555","60634E","025B6A","A15E01","68001B"],tickColor:["333333","60634E","025B6A","A15E01","68001B"],trendDarkColor:["333333","60634E","025B6A","A15E01","68001B"],trendLightColor:["f1f1f1","F3F5DD","EDFBFE","FFF5E8","FFD1DD"],pointerBorderColor:["545454","60634E","415D6F","845001","68001B"],pointerBgColor:["545454","60634E","415D6F","845001","68001B"],canvasBgColor:["FFFFFF","FFFFFF","FFFFFF","FFFFFF","FFFFFF"],canvasBgAngle:[0,0,0,0,0],canvasBgAlpha:["100","100",
"100","100","100"],canvasBgRatio:["","","","",""],canvasBorderColor:["545454","545454","415D6F","845001","68001B"],canvasBorderAlpha:[100,100,100,90,100],altHGridColor:["EEEEEE","D8DCC5","99C4CD","DEC49C","FEC1D0"],altHGridAlpha:[50,35,10,20,15],altVGridColor:["767575","D8DCC5","99C4CD","DEC49C","FEC1D0"],altVGridAlpha:[10,20,10,15,10],borderColor:["767575","545454","415D6F","845001","68001B"],borderAlpha:[50,50,50,50,50],legendBgColor:["ffffff","ffffff","ffffff","ffffff","ffffff"],legendBorderColor:["545454",
"545454","415D6F","845001","D55979"],plotFillColor:["767575","D8DCC5","99C4CD","DEC49C","FEC1D0"],plotBorderColor:["999999","8A8A8A","6BA9B6","C1934D","FC819F"],msgLogColor:["717170","7B7D6D","92CDD6","965B01","68001B"],TrendLightShadeOffset:30}}]);FusionCharts.register("module",["private","modules.renderer.js-annotations",function(){var g=this,m=g.core,D=g.hcLib,n=g.window,F=/msie/i.test(n.navigator.userAgent)&&!n.opera,A=D.addEvent,J=D.removeEvent,a=D.hasTouch,O=n.Number,d=a?6:5,l="rgba(192,192,192,"+
(F?.002:1E-6)+")",F=Math,N=F.min,ga=F.max,w=F.sin,r=F.cos,p=F.PI,c=p/180,v=F.abs,M=g.extend,e=D.pluck,q=D.pluckNumber,H=D.graphics.convertColor,t=D.getValidValue,L=D.parseUnsafeString,K=D.setImageDisplayMode,pa=D.graphics.parseColor,S=D.setLineHeight,T=D.getMouseCoordinate,ba={style:{}},aa=D.toRaphaelColor,I=function(a,c){return{start:-a,end:-c,angle:a-c}},ia=function(a,c){var e=0;switch(a){case "startx":e=c.x;break;case "starty":e=c.y;break;case "x":case "middlex":case "centerx":e=c.x+c.width/2;
break;case "y":case "middley":case "centery":e=c.y+c.height/2;break;case "endx":e=c.x+c.width;break;case "endy":e=c.y+c.height;break;default:e=0}return e},C=function(a,c,e,d,g){var l,m,q=0,p=0;m=void 0===c||null===c?1:c;var n;if(!a||!a.toString)return{value:e,hasDynamicMacros:!1};a=a.toString();a=a.toLowerCase().replace(/\s/g,"");if(e=a.match(/^[\+\-]?\d+(\.\d+)?|[\+\-]\d+(\.\d+)?/g)){for(c=0;c<e.length;c+=1)q+=Number(e[c])||0;q*=m}if(e=a.match(/^[\+\-]?(\$[a-z0-9\.]+)|[\+\-](\$[a-z0-9\.]+)/g))for(c=
0;c<e.length;c+=1){l=e[c];var t=d,r=g,C=l.split("."),w=void 0,v=void 0,H=0;for(m=void 0;w=C.shift();)switch(typeof(v=t[w])){case "object":t=v[w];break;case "function":v=v(C,r),"-"===l.charAt()&&(v*=-1),m=!0;default:H+=O(v)||0,C.length=0}l=H;m&&(n=!0);p+=l}if(e=a.match(/^[\+\-]?\$\d+(\.\d+)?|[\+\-]\$\d+(\.\d+)?/g))for(c=0;c<e.length;c+=1)p=p+Number(e[c].replace("$",""))||0;return{value:q+p,hasDynamicMacros:n}},za=function(a,c,e){if(!c.removed){c=c.data("annotation");var d=c.getRenderer(),l=T(d.linkedItems.container,
e),m=l.annotationOptions=c.options,q=l.groupOptions=c.group.options;l._shape=c;"id"in m&&(l.annotationId=m.id);"id"in q&&(l.groupId=q.id);g.raiseEvent(a,l,d.chartInstance,e)}},Ja,na,ea;na=function(a,c,e,d,g,l){this.options=a;this.attrs={};this.css={};this.bounds={};this.shared=c;this.snaps=e||{};this.annotations=g;this.items=c=[];this._idstore=d;a.id&&(this._id=a.id,d[a.id]=this);if(a=a.items)for(d=0,e=a.length;d<e;d+=1)c.push(new ea(a[d],this)),c[d].chart=l};M(na.prototype,{scaleImageX:1,scaleImageY:1,
scaleText:1,scaleValue:1,scaleValueComplement:1,scaleX:1,scaleY:1});na.prototype.setup=function(){var a=this.options,c=this.shared,e=this.getRenderer();e&&(this.isBelow=0!==q(a.showbelow,a.showbelowchart,c.showbelow),this.useTracker=!this.isBelow&&e.graphics.trackerGroup&&this.shared.useTracker,this.raiseOwnEvents=c.interactionevents)};na.prototype.scale=function(){var a=this.options,c=this.shared,d=this.bounds,g=this.snaps,l=this.getRenderer(),m=c.rootxscale,p=c.rootyscale,n=d.xs=q(a.xscale,c.xscale,
100)/100,t=d.ys=q(a.yscale,c.yscale,100)/100,r,w,v;r=(r=this.annotations)&&r.resetScale;l&&(r&&(this.scaleText=1),this.scaleText*=t,this.scaleImageX*=n,this.scaleImageY*=t,0!==q(a.autoscale,c.autoscale)&&(n=q(a.origw,c.origw),t=q(a.origh,c.origh),n=l.config.width/n,t=l.config.height/t,l=0!==q(a.constrainedscale,c.constrainedscale),r=n<t?n:t,w=l?r:n,v=l?r:t,this.scaleValue=na.prototype.scaleValue*r,this.scaleValueComplement=na.prototype.scaleValueComplement*(l?r:n<t?t:n),this.scaleX=na.prototype.scaleX*
w,this.scaleY=na.prototype.scaleX*v,d.xs*=w,d.ys*=v,m*=w,p*=v,"1"==e(a.scaletext,c.scaletext)&&(this.scaleText=na.prototype.scaleText*v),"1"==e(a.scaleimages,c.scaleimages)&&(this.scaleImageX=na.prototype.scaleImageX*w,this.scaleImageY=na.prototype.scaleImageY*v)),d.x=C(e(a.x,a.xpos),m,0,g,this.isBelow).value+q(a.grpxshift,c.grpxshift,0),d.y=C(e(a.y,a.ypos),p,0,g,this.isBelow).value+q(a.grpyshift,c.grpyshift,0),this.xshift=q(a.xshift,c.xshift,0),this.yshift=q(a.yshift,c.yshift,0))};na.prototype.draw=
function(){var a=this.getRenderer(),c=this.options,e=this.bounds,d=this.items,g=a&&a.graphics,l,m=this.wrapper,p,n=[],t,r,C=this.chart,w=C&&C.config||{},C=w.annRenderDelay,w=w.resize,v=function(){t=0;for(r=n.length;t<r;t++)p=n[t],p.draw()},H=(l=this.annotations)&&l.resetScale;if(a){a.annotationRelativeLayer&&"axis"===a.annotationRelativeLayer?(l=g.axisTopGroup||g.datasetGroup,g=g.axisBottomGroup||g.datasetGroup):l=g=g.datasetGroup;m||(this.wrapper=m=a.components.paper.group("annotations"),l&&g&&(this.isBelow?
m.insertBefore(g):m.insertAfter(a.graphics.datalabelsGroup||l)));H&&this.wrapper.attr({transform:""});this.wrapper.attr({x:0,y:0,visibility:q(c.visible,1)?"":"hidden"}).translate(e.x,e.y);t=0;for(r=d.length;t<r;t+=1)p=d[t],p.scale(!0),p.queueDraw?p.queue():(n.push(p),p.setup());C&&!w?setTimeout(function(){v()},C):v();return this}};na.prototype.destroy=function(){for(var a=this.wrapper,c=this.items,e;e=c.shift();)e.destroy();a&&(this.wrapper=a.remove());this._idstore[this._id]===this&&delete this._idstore[this._id]};
na.prototype.addItem=function(a,c,e){var d=this.items,g=this._idstore;this.chart=e;d.push(a=new ea(a,this,g));c&&null!==this.getRenderer()&&(a.scale(),a.setup(),a.draw());return a};na.prototype.removeItem=function(a){for(var c=this.items,e=c.length;e--;)if(a===c[e]._id)return c.splice(e,1)};na.prototype.getRenderer=function(){return this.annotations&&this.annotations.getRenderer()||null};ea=function(a,c){var e=!1,d;this.options=a;this.chart=(this.group=c)&&c.chart;this.args=[];this.attrs={};this.attrsTracker=
{};this.style={};this.bounds={};this._idstore=c._idstore;a.id&&(this._id=a.id,c._idstore[a.id]=this);this.type=a.type&&a.type.toLowerCase&&a.type.toLowerCase();for(d in ea.eventNames)"function"===typeof a[d]&&(this[d]=a[d],e=!0);this.hasEvents=e;"function"===typeof a.onload&&(this.onload=a.onload)};g.extend(ea.prototype,{getAbsoluteBounds:function(){var a=this.bounds,c=a.x1,e=a.y1,d=a.x2,g=a.y2,l=N(c,d),m=N(e,g),c=ga(c,d)-l,e=ga(e,g)-m;return{x:l,width:c,y:m,height:e,r:a.r,unscaled:{width:c/a.xs,
height:e/a.ys}}},queue:function(){this.group.annotations.shapesToDraw.push(this)},scale:function(a){var c=this,d=c.group,g=d.bounds,l=c.bounds,m=c.options,p=d.snaps,n=e(m.x,m.xpos),t=e(m.y,m.ypos),r=e(m.tox,m.toxpos),w=e(m.toy,m.toypos),v=l.xs=g.xs,g=l.ys=g.ys,H=q(m.xshift,d.xshift,0),A=q(m.yshift,d.yshift,0),D;D=function(e,g,l,m){e=C(e,g,l,m,d.isBelow);e.hasDynamicMacros&&a&&(c.queueDraw=!0);return e.value};c.hasDimension=!0;c.hasDimensionX=!0;c.hasDimensionY=!0;l.x1=D(n,v,0,p)+H;void 0===r?(c.hasDimension=
!1,c.hasDimensionX=!1,l.x2=l.x1):l.x2=D(r,v,0,p)+H;l.y1=D(t,g,0,p)+A;void 0===w?(c.hasDimension=!1,c.hasDimensionY=!1,l.y2=l.y1):l.y2=D(w,g,0,p)+A;ea.angularShapeTypes[c.type]&&(l.angles=I(D(m.startangle,1,0,p),D(m.endangle,1,360,p)));l.r=D(m.radius,d.scaleValue,0,p)},setup:function(){var a=this.options,c=this.group,d=c.options,g=this.attrs,m=this.style,p=c.scaleValue,n=q(d.fillalpha,d.alpha,100),r=this.fillAlpha=e(a.fillalpha,a.alpha,n),C=this.fillColor=e(a.fillcolor,a.color,d.color),w=this.fillPattern=
e(a.fillpattern&&a.fillpattern.toLowerCase&&a.fillpattern.toLowerCase(),d.fillpattern&&d.fillpattern.toLowerCase&&d.fillpattern.toLowerCase()),v=this.bordered=q(a.showborder,ea.borderedShapeTypes[this.type],!!t(a.bordercolor)),A=this.borderColor=e(a.bordercolor,d.bordercolor,C),n=this.borderAlpha=q(a.borderalpha,a.alpha,d.borderalpha,n),D=this.dashed=!!q(a.dashed,0),I=q(a.borderthickness,a.thickness,2)*p;this.link=e(a.link,d.link);this.shadow="1"==e(a.showshadow,d.showshadow);void 0===C&&(C=ea.borderedShapeTypes[this.type]&&
"none"||"#ff0000",void 0===A&&(A="#ff0000"));v&&I?(g.stroke=H(A,n),g["stroke-linecap"]="round",g["stroke-width"]=I,D&&(g["stroke-dasharray"]=[q(a.dashlen,5)*p,q(a.dashgap,3)*p])):g.stroke="none";this.fillOptions={gradientUnits:"objectBoundingBox",color:C,alpha:r,ratio:e(a.fillratio,d.fillratio),angle:360-q(a.fillangle,0),radialGradient:"radial"===w};this.link&&(m.cursor="pointer",m._cursor="hand");g.visibility=q(a.visible,1)?"":"hidden";this.useTracker=c.useTracker;this.toolText=L(e(a.tooltext,d.tooltext));
if(this.useTracker||this.link||this.toolText)M(this.attrsTracker,{stroke:l,fill:l}),this.link&&(this.attrsTracker.ishot=+new Date);this.raiseOwnEvents=c.raiseOwnEvents},draw:function(){var a=this.getRenderer(),c=this.type,e=this.attrs,d=this.style,g=a&&a.components.paper,l=ea.types[c]&&ea.types[c].call&&ea.types[c].call(this,a),m=ea.imageShapeTypes[l],q=ea.textShapeTypes[l],p=m||q||ea.trackerShapeTypes[l],n=this.link||this.toolText,t=this.wrapper,c=this.tracker,r=a&&a.graphics.trackerGroup||this.group.wrapper,
C=!1,w=c||t,v=ea.eventNames,H=ea.ownEvents,D,I;if(a){if(l){if(t)if(t.elemType!==l){if(this.ownEventsAttached){for(I in H)w["un"+I].apply(t,H[I]);this.ownEventsAttached=!1}t=t.remove()}else if(this.hasEvents)for(D in v)(I=this[D])&&I.eventAttached&&(J(w.node,v[D],I),I.eventAttached=!1);m||(e.fill=aa(this.fillOptions));t?t.attr(e).css(d):(this.args.push(this.group.wrapper),t=this.wrapper="text"===l?g[l].call(g,e,d,this.group.wrapper):g[l].apply(g,this.args).attr(e).css(d),t.elemType=l,t.data("annotation",
this),C=!0,this.args.pop());!this.shadow||this.shadowAdded||m||q?t.shadow(this.shadowAdded=!1):t.shadow(this.shadowAdded=!0,ga(this.borderAlpha,this.fillOptions.alpha)/100);n?this.useTracker&&(c||(this.args.push(r),c=this.tracker=p?g.rect(0,0,0,0,0,r):g[l].apply(g,this.args),this.args.pop()),c.attr(e).attr(this.attrsTracker)):c&&(c=c.remove());w=c||t;if(this.raiseOwnEvents&&!this.ownEventsAttached){for(I in H)w[I].apply(t,H[I]);this.ownEventsAttached=!0}this.link&&w.click(a.linkedItems.linkClickFN,
this);this.toolText&&(w.tooltip(this.toolText||""),this.group.wrapper.trackTooltip(!0));if(this.hasEvents)for(D in v)(I=this[D])&&!I.eventAttached&&(A(w.node,v[D],I,this),I.eventAttached=!0);m||(c&&p&&(a=t.getBBox(),c.attr({x:a.x,y:a.y,width:a.width,height:a.height})),C&&this.onload&&this.onload(e))}return this}},destroy:function(){var a=this.wrapper,c=this.tracker,e=c||a,d=ea.eventNames,g=ea.ownEvents,l,m;if(a){if(this.ownEventsAttached){for(m in g)e["un"+m].apply(a,g[m]);this.ownEventsAttached=
!1}if(this.hasEvents)for(l in d)(m=this[l])&&m.eventAttached&&(J(e.node,d[l],m),m.eventAttached=!1);c&&(this.tracker=c.remove());this.wrapper=a.remove()}this._idstore[this._id]===this&&delete this._idstore[this._id]},getRenderer:function(){return this.group&&this.group.getRenderer()||null}});g.extend(ea,{imageShapeTypes:{image:!0},angularShapeTypes:{circle:!0,arc:!0},textShapeTypes:{text:!0},trackerShapeTypes:{image:!0,text:!0},borderedShapeTypes:{path:!0,line:!0},eventNames:{onmouseover:a?"touchstart":
"mouseover",onmouseout:"mouseout",onmousemove:a?"touchmove":"mousemove",onclick:"click"},ownEvents:{click:[function(a){za("annotationClick",this,a)}],hover:[function(a){za("annotationRollOver",this,a)},function(a){za("annotationRollOut",this,a)}]},textAlignOptions:{left:"start",right:"end",center:"middle"},textVerticalAlignOptions:{top:"bottom",middle:"middle",bottom:"top"},textRotationOptions:{0:"0",1:"270",right:"90",cw:"90",left:"270",ccw:"270"},types:{rectangle:function(){var a=this.args,c=this.attrs,
e=this.getAbsoluteBounds(),d=.5*e.width;e.r>d&&(e.r=d);a[0]=c.x=e.x;a[1]=c.y=e.y;a[2]=c.width=e.width;a[3]=c.height=e.height;a[4]=c.r=e.r;return"rect"},line:function(){var a=this.attrs,c=this.bounds;this.args[0]=a.path=["M",c.x1,c.y1,"L",c.x2,c.y2];1===a["stroke-width"]&&(a["shape-rendering"]="crisp");a["stroke-width"]<d&&(this.attrsTracker["stroke-width"]=d);this.bordered&&this.dashed&&(this.attrsTracker["stroke-dasharray"]="solid");return"path"},path:function(){var a=this.attrs,c=this.bounds;this.args[0]=
a.path=this.options.path;a.transform=["T",c.x1,c.y1,"S",c.xs,c.ys,c.x1,c.y1];1===a["stroke-width"]&&(a["shape-rendering"]="crisp");return"path"},polygon:function(){var a=this.args,c=this.attrs,e=this.options,d=this.bounds,g=this.group,l=g.snaps;a[0]=C(e.sides,1,5,l,g.isBelow).value;a[1]=d.x1;a[2]=d.y1;a[3]=d.r;a[4]=C(e.startangle,1,0,l,g.isBelow).value;a[5]=0;c.polypath=a.slice(0);return"polypath"},circle:function(a){var d=this.args,g=this.attrs,l=this.options,m=this.bounds,q=a.config.width,n=a.config.height,
t=this.group.scaleValueComplement,H=this.group.snaps,A=m.angles,I=this.group;a=m.r;e(l.radius)||(m.r=q<n?q*m.xs:n*m.ys,m.r=a=.3*m.r);l=C(l.yradius,t,a,H,I.isBelow).value;this.fillPattern||(this.fillOptions.radialGradient=!0,this.fillPattern="radial");"radial"===this.fillPattern&&(this.fillOptions.cx=this.fillOptions.cy=.5);n=A.angle%360;if(!n&&a===l)return d[0]=g.cx=m.x1,d[1]=g.cy=m.y1,d[2]=g.r=m.r,"circle";n||(A.angle=0<A.angle?A.angle-.001:A.angle+.001,A.start=A.end-A.angle);n||n==A.angle||(n=360);
q=A.start*c;A=A.end*c;n*=c;H=m.x1;I=m.y1;m=H+r(q)*a;t=I+w(q)*l;H+=r(A)*a;I+=w(A)*l;a=["M",m,t,"A",a,l,0,v(n)>=p?1:0,q<A?1:0,H,I,"Z"];d[0]=g.path=a;return"path"},arc:function(a){var d=this.options,g=this.args,l=this.attrs,m=this.bounds,q=a.config.width;a=a.config.height;var p=this.group,n=p.scaleValue,t=m.angles;e(d.radius)||(m.r=q<a?q*m.xs:a*m.ys,m.r*=.3);m.innerR=C(d.innerradius,n,.8*m.r,this.group.snaps,p.isBelow).value;m.innerR>m.r&&(m.innerR+=m.r,m.r=m.innerR-m.r,m.innerR-=m.r);this.fillPattern||
(this.fillOptions.radialGradient=!0,this.fillPattern="radial");"radial"===this.fillPattern&&(this.fillOptions.cx=this.fillOptions.cy=.5);g[0]=m.x1;g[1]=m.y1;g[2]=m.r;g[3]=m.innerR;g[4]=t.end*c;g[5]=t.start*c;l.ringpath=g.slice(0);return"ringpath"},text:function(a){var c=this.args,d=this.style,g=this.attrs,m=this.group,l=this.bounds,p=this.options,n=this.getAbsoluteBounds(),t=e(p.align,m.options.textalign,"center").toLowerCase(),r=e(p.valign,m.options.textvalign,"middle").toLowerCase(),C=L(e(p.text,
p.label)),w=a.linkedItems.smartLabel,v=q(p.wrap,m.options.wraptext,1),A,H,I=e(p.rotatetext,m.options.rotatetext,"0").toLowerCase(),I=ea.textRotationOptions[I],D="0"!==I?"y":"x",K=a.config.orphanStyles;a=M({},K.defaultStyle.style||{});K=m.id&&K[m.id.toLowerCase()]||ba;a=M(a,K.style);var K=parseFloat(a.fontSize),F=e(p.font,m.options.font,a.fontFamily),m=q(p.fontsize,m.options.fontsize,K)*m.scaleText;v&&(A=q(p.wrapwidth,this.hasDimensionX?n.width/l.xs:void 0),H=q(p.wrapheight,this.hasDimensionY?n.height/
l.ys:void 0),A&&(A*=l.xs),H&&(H*=l.ys));d.fontFamily=F;d.fontWeight=q(p.bold,p.isbold,0)?"bold":"normal";q(p.italic,p.isitalic,0)&&(d.fontStyle="italic");p.bgcolor&&(!g["text-bound"]&&(g["text-bound"]=[]),g["text-bound"][0]=pa(p.bgcolor));p.bordercolor&&(!g["text-bound"]&&(g["text-bound"]=[]),g["text-bound"][1]=pa(p.bordercolor),g["text-bound"][2]=q(p.borderthickness,1),g["text-bound"][3]=q(p.padding,1));p.fontcolor&&(g.fill=pa(p.fontcolor),this.fillOptions&&(this.fillOptions.color=g.fill));d.fontSize=
m+"px";m===K?d.lineHeight=a.lineHeight:S(d);g["text-anchor"]=ea.textAlignOptions[t]||ea.textAlignOptions.center;w.setStyle(d);d=w.getSmartText(C,A,H,!1);g["vertical-align"]=ea.textVerticalAlignOptions[r]||ea.textVerticalAlignOptions.middle;g["text-anchor"]===ea.textAlignOptions.left?n[D]+=q(p.leftmargin,0):g["text-anchor"]===ea.textAlignOptions.center&&(n[D]+=.5*q(p.leftmargin,0));"0"!==I&&(g.rotation=[parseFloat(I),n.x,n.y]);c[0]=g.x=n.x;c[1]=g.y=n.y;c[2]=g.text=d.text;d.tooltext&&(g.title=d.tooltext);
delete g.stroke;delete g["stroke-weight"];return"text"},image:function(a){var c=this,d=c.style,g=a.config.width,m=a.config.height;a=c.options;var l=c.attrs,p=c.args,r=t(a.url),C=c.group.scaleImageX*e(Number(a.xscale),100)/100,w=c.group.scaleImageY*e(Number(a.yscale),100)/100,v=c.getAbsoluteBounds(),A={width:1,height:1},H;if(!r)return p[0]=l.x=v.x,p[1]=l.y=v.y,p[2]=l.width=v.width,p[3]=l.height=v.height,p[4]=l.r=v.r,"rect";H=new n.Image;H.onload=function(){A=K("none","top","left",100,0,g,m,H);delete A.x;
delete A.y;A=M(A,{width:(c.hasDimensionX?v.unscaled.width:A.width)*C,height:(c.hasDimensionY?v.unscaled.height:A.height)*w});setTimeout(function(){var a,e,g;if(a=c.wrapper){a.attr(A);if(e=c.tracker)g=a.getBBox(),e.attr({x:g.x,y:g.y,width:g.width,height:g.height});a.css({opacity:d.opacity=ga(q(c.fillAlpha,c.borderAlpha),c.borderAlpha)/100})}c.onload&&c.onload(A)},0)};H.src=r;p[0]=l.src=r;p[1]=l.x=v.x;p[2]=l.y=v.y;p[3]=l.width=(c.hasDimensionX?v.unscaled.width:A.width)*C;p[4]=l.height=(c.hasDimensionY?
v.unscaled.height:A.height)*w;d.opacity=ga(q(c.fillAlpha,c.borderAlpha),c.borderAlpha)/100;delete l.stroke;delete l.fill;delete l["stroke-linecap"];return"image"}}});Ja=function(){this.groups=[];this._idstore={};this._options={}};D.Annotations=Ja;g.extend(Ja.prototype,{reset:function(a,c,e){var d=this.groups,g,m;this.chart=e;this.clear();if(m=this.setSnapPoints()){g={};for(var l in m)switch(typeof m[l]){case "object":case "function":g["-$"+l]=g["$"+l]=g["+$"+l]=m[l];break;default:g["$"+l]=g["+$"+
l]=m[l],g["-$"+l]=-1*m[l]}g=this._literals=g}c&&(this._options=c);if(a&&a.groups&&d)for(m=0;m<a.groups.length;m+=1)d.push(new na(a.groups[m],c,g,this._idstore,this,e)),d[m].chart=e},getRenderer:function(){return this._renderer},addGroup:function(a){var c=this.getRenderer();this.groups.push(a=new na(a,this._options,this._literals,this._idstore,this,this.chart));c&&(a.setup(),a.scale(),a.draw());return a},addItem:function(a,c,e){var d,m=this.getRenderer();"string"===typeof a?d=this._idstore[a]:(e=c,
c=a);if(d&&d.addItem){if(!m&&e){g.raiseWarning(this,"04031411430","run","Annotations~addItem()","Cannot draw the shapeif the group has not been drawn. Use Annotations~draw() to draw the group and pass the renderer to it.");return}a=d.addItem(c,e)}else a=this.addGroup({}).addItem(c,e);return a},draw:function(a,c){var e=this.groups,d,g,m;if(e&&(this._renderer=a||this._renderer))for(this.resetScale=c,g=0,m=e.length;g<m;g++)d=e[g],d.setup(),d.scale(),d.draw()},clear:function(){var a=this.groups,c;if(a){for(;c=
a.shift();)c.destroy();this.shapesToDraw=[]}},dispose:function(){var a;this.disposing=!0;this.clear();for(a in this)delete this[a];this.disposed=!0},hide:function(a){if(a=this._idstore[a])return a.attrs.visibility="hidden",a.wrapper&&a.wrapper.hide(),a},show:function(a){if(a=this._idstore[a])return a.attrs.visibility="",a.wrapper&&a.wrapper.show(),a},update:function(a,c,e){a=this._idstore[a];var d;if(a&&c){if("object"===typeof c)for(d in c.id&&delete c.id,c.type&&delete c.type,c)a.options[(d+"").toLowerCase()]=
c[d]+"";else a.options[(c+"").toLowerCase()]=e+"";a.wrapper&&(a.scale(),a.setup(),a.draw());return a}},destroy:function(a){var c=this._idstore[a],e=c.group;c&&"function"===typeof c.destroy&&(e&&e.removeItem(a),c.destroy())},shapesToDraw:[],setSnapPoints:function(){var a=this.chart,c=a.config,e=a.components,d=e.legend,g=e.gradientLegend,m=e.caption.config,e=e.subCaption.config,l=m.width||0,q=e.width||0,p,n=this.datasetFunction.bind(a),t=this.xAxisFunction.bind(a),r=this.yAxisFunction.bind(a);"end"===
m.align?(a=m.x-l,p=m.x-q):"start"===m.align?a=p=m.x:(a=m.x-l/2,p=m.x-q/2);d=c.gLegendEnabled?g.conf:d.config;return{canvasendx:c.canvasRight,canvasendy:c.canvasBottom,canvasheight:c.canvasHeight,canvasstartx:c.canvasLeft,canvasstarty:c.canvasTop,canvaswidth:c.canvasWidth,canvascenterx:c.canvasCenterX||c.canvasLeft+(c.canvasRight-c.canvasLeft)/2,canvascentery:c.canvasCenterY||c.canvasTop+(c.canvasBottom-c.canvasTop)/2,chartcenterx:c.width/2,chartcentery:c.height/2,chartstartx:0,chartstarty:0,chartendx:c.width,
chartendy:c.height,chartheight:c.height,chartwidth:c.width,chartleftmargin:c.marginLeft,chartrightmargin:c.marginRight,chartbottommargin:c.marginBottom,charttopmargin:c.marginTop,captionendx:a+m.width,captionendy:m.y+m.height,captionheight:m.height,captionstartx:a,captionstarty:m.y,captionwidth:l,subcaptionendx:p+e.width,subcaptionendy:e.y+e.height,subcaptionheight:e.height,subcaptionstartx:p,subcaptionstarty:e.y,subcaptionwidth:q,legendendx:d.xPos+d.width,legendendy:d.yPos+d.height,legendheight:d.height,
legendstartx:d.xPos,legendstarty:d.yPos,legendwidth:d.width,dataset:n,xaxis:t,yaxis:r,gaugestartx:c.gaugeStartX,gaugestarty:c.gaugeStartY,gaugeendx:c.gaugeEndX,gaugeendy:c.gaugeEndY,gaugecenterx:c.gaugeCenterX,gaugecentery:c.gaugeCenterY,gaugestartangle:c.gaugeStartAngle,gaugeendangle:c.gaugeEndAngle,gaugeradius:c.gaugeRadius,plotwidth:c.plotWidth,plotsemiwidth:c.plotSemiWidth}},datasetFunction:function(a,c){var e=this.components.dataset,d,g,m,l;m=this.is3D;if(!e||!e.length)return 0;isNaN(a[0])?d=
0:(d=Number(a[0]),a=a.slice(1));g=a[0];if("set"===g){isNaN(a[1])?(l=0,a=a.slice(1)):(l=Number(a[1]),a=a.slice(2));g=a[0];e=(e=e[d]&&e[d].components.data[l])&&(e.graphics.element||e.graphics.hotElement||e.graphics.upperBoxElem);if(!e)return 0;m=c&&m?e._getBBox2():e.getBBox();l=ia(g,m)}return l},xAxisFunction:function(a){var c=this.components&&this.components.xAxis&&this.components.xAxis[0],e,d;if(!c)return 0;d=a[0];if("label"===d){isNaN(a[1])?(e=0,a=a.slice(1)):(e=Number(a[1]),a=a.slice(2));d=a[0];
a=c._getLabelElement(e);if(!a)return 0;a=a.getBBox();e=ia(d,a)}return e},yAxisFunction:function(a){var c=this.components&&this.components.yAxis,e,d;if(!c||!c.length)return 0;isNaN(a[0])?e=0:(e=Number(a[0]),a=a.slice(1));e=c[e];if(!e)return 0;c=a[0];if("label"===c){isNaN(a[1])?(d=0,a=a.slice(1)):(d=Number(a[1]),a=a.slice(2));c=a[0];a=e._getLabelElement(d);if(!a)return 0;a=a.getBBox();d=ia(c,a)}return d}});g.core.addEventListener("beforeinitialize",function(a){"javascript"===a.sender.options.renderer&&
(a.sender.annotations=new Ja)});g.core.addEventListener("disposed",function(a){a.sender.annotations&&a.sender.annotations.dispose()});g.addEventListener("internal.animationComplete",function(a){a=a.sender;var c=a.annotations,e=c&&c.shapesToDraw,d=e&&e.length,g,m;a=a.apiInstance.config;var l=a.annRenderDelay,q=a.resize,p=(new Date).getTime(),n,t=function(){for(m=0;m<d;m++)g=e[m],g.draw()};if(d){for(m=0;m<d;m++)g=e[m],g.queueDraw=!1,g.scale(),g.setup();n=(new Date).getTime();l&&!q?setTimeout(function(){t();
c.shapesToDraw=[]},l-(n-p)):(t(),c.shapesToDraw=[])}a.resize=!1});m.addEventListener("rendered",function(a,c){if("javascript"===c.renderer){var e=a.sender;e.apiInstance&&(e.apiInstance.showAnnotation||(e.apiInstance.showAnnotation=function(){e.annotations.show.apply(e.annotations,arguments)}),e.apiInstance.hideAnnotation||(e.apiInstance.hideAnnotation=function(){e.annotations.hide.apply(e.annotations,arguments)}))}})}]);FusionCharts.register("module",["private","modules.renderer.jpegtopdf",function(){var g=
this.window,m=g.btoa,D=g.atob;this.hcLib.JpegToPdf=function(g,F){var A=[],J=0,a=g||500,O=F||500,d,l,N;d=function(a){J+=a.length+1;A.push(a)};this.addImage=function(a){a=/base64,(.+?)$/g.exec(a);N=D(a[1])};l=function(){var g=[],m,l;d("%PDF-1.7");g[1]=J;d("1 0 obj");d("/ProcSet [/PDF /Text /ImageB /ImageC /ImageI]");d("endobj");g[4]=J;d("4 0 obj");d("<< /Length 36>>");d("stream");d("q "+O+" 0 0 "+a+" 0 0 cm /Im3 Do Q");d("endstream");d("endobj");g[5]=J;d("5 0 obj");d("<</Type /Page /Parent 2 0 R /MediaBox [0 0 "+
O+" "+a+"] /Contents [4 0 R ] /Resources <</ProcSet 1 0 R /Font <<>> /XObject <</Im3 3 0 R >> >> >>");d("endobj");g[3]=J;d("3 0 obj");d("<</Type /XObject /Subtype /Image /Width "+O+" /Height "+a+" /ColorSpace /DeviceRGB /BitsPerComponent 8 /Filter /DCTDecode /Length "+N.length+">>");d("stream");d(N);d("endstream");d("endobj");g[2]=J;d("2 0 obj");d("<</Type /Pages /Kids [5 0 R ] /Count 1>>");d("endobj");g[6]=J;d("6 0 obj");d("<</Type /Catalog /Pages 2 0 R >>");d("endobj");m=J;d("xref");d("0 7");d("0000000000 65535 f ");
for(l=1;6>=l;l++)d(("0000000000"+g[l]).slice(-10)+" 00000 n ");d("trailer");d("<</Size 7 /Root 6 0 R >>");d("startxref");d(m);d("%%EOF");return A.join("\n")};this.getDataUrl=function(){return"data:application/pdf;base64,"+m(l())}}}]);FusionCharts.register("module",["private","modules.exporter.batch-export",function(){var g=this.window,m=this.hcLib,D=Math.max,n=g.Image,F=m.drawSvgOnCanvas,A=m.downloadCharts,J=m.browserDetails,a=m.pluckNumber,O=m.pluck,d=m.JpegToPdf,l=g.navigator.userAgent.match(/ (iPad|iPhone|iPod)/g),
N="https:"===g.location.protocol?"https://export.api3.fusioncharts.com/":"http://export.api3.fusioncharts.com/";FusionCharts.batchExport=function(m){var w=m||{},r,p,c,v,M,e=0,q=!1,H,t,L,K={exportTargetWindow:O(w.exportTargetWindow,l?"_blank":"_self"),exportAction:w.exportAction&&"save"===w.exportAction.toString().toLowerCase()&&"save"||"download",exportFileName:O(w.exportFileName,"FusionCharts"),exportHandler:O(w.exportHandler,N),exportParameters:O(w.exportParameters,""),exportFormat:O(w.exportFormat,
"PNG"),exportCallBack:O(w.exportCallBack,""),exportAtClientSide:a(w.exportAtClientSide,1)},pa=K.exportFormat.toLowerCase(),S=0,T=0,ba,aa=g.document,I=FusionCharts.items,ia=function(a){return a.match(/http:\/\/|https:\/\//)&&/(http:\/\/|https:\/\/)([^\/\:]*)/.exec(a)[2]&&g.location.hostname!==/(http:\/\/|https:\/\/)([^\/\:]*)/.exec(a)[2]?!1:!0},C=function(c,e,d,g){var m=c,l=e;isNaN(m)&&(m=a(e,g)*(d/g));isNaN(l)&&(l=a(c,d)*(g/d));return{width:m,height:l}},za=function(a){!K.exportAtClientSide||"undefined"===
typeof g.btoa||"Chrome"!==J.name&&"Firefox"!==J.name&&"Edge"!==J.name&&"ie"!==J.name?(a={charttype:"combined",stream:a,stream_type:"IMAGE-DATA",parameters:["exportfilename="+K.exportFileName,"exportformat="+pa,"exportaction="+K.exportAction,"exportparameters="+K].join("|")},A(null,null,null,a,K)):A("url",a,K.exportFileName+"."+pa)},Ja=function(a){var g;F(a,c,this.x,this.y,this.width,this.height,function(){--e;if(0===e&&q)switch(pa){case "png":za(c.toDataURL("image/png"));break;case "jpeg":za(c.toDataURL("image/jpeg"));
break;case "pdf":g=new d(S,T);g.addImage(c.toDataURL("image/jpeg"));za(g.getDataUrl());break;default:za(c.toDataURL("image/png"))}})};m=function(e){var d=w.background;c=aa.createElement("canvas");c.id="newCanvas";c.width=T;c.height=S;c.style.border="1px solid black";v=c.getContext("2d");v.fillStyle=d&&d.bgColor||"#ffffff";v.fillRect(0,0,T,S);d&&d.bgImage&&ia(d.bgImage)?(t=new n,t.src=d.bgImage,t._userData=d,v.globalAlpha=a(d.bgImageAlpha,100)/100,t.onload=function(){var c=this._userData,d=a(c.bgImageX,
0),g=a(c.bgImageY,0),m=C(Number(c.bgImageWidth),Number(c.bgImageHeight),this.width,this.height),c=m.width,m=m.height;try{v.drawImage(this,d,g,c,m)}finally{v.globalAlpha=1,e()}},t.onerror=function(){e()}):e()};if(J.hasCanvas){(function(){var a=w.charts,c,e,d,g;p=[];if(a)for(d in a)a.hasOwnProperty(d)&&(c=I[a[d].id])&&(e=a[d],g=C(Number(e.width),Number(e.height),c.width,c.height),p.push({id:c.id,width:g.width,height:g.height,x:e.x,y:e.y}));else for(d in I)I.hasOwnProperty(d)&&(c=I[d],p.push({id:c.id,
width:c.width,height:c.height}))})();ba=0;for(H=p.length;ba<H;ba+=1)L=p[ba],L.x=a(L.x,5),L.y=a(L.y,S+5),L.height=a(L.height),L.width=a(L.width),S=D(S,L.y+L.height),T=D(T,L.x+L.width);S=w.imageHeight||S+5;T=w.imageWidth||T+5;m(function(){return function(){ba=0;for(H=p.length;ba<H;ba+=1){L=p[ba];ba===H-1&&(q=!0);var a=L;r=FusionCharts.items[L.id];M=r.jsVars.instanceAPI.components.paper.toSVG(!0);e+=1;Ja.call(a?a:r,M)}}}())}}}]);FusionCharts.register("module",["private","modules.exporter.main",function(){var g=
this,m=g.window,D=g.hcLib,n=D.extend2,F=D.BLANKSTRING,A=D.graphics.RGBtoHex,J=/\s\bx\b=['"][^'"]+?['"]/ig,a=/\s\by\b=['"][^'"]+?['"]/ig,O=m.document,d=m.Image,l=D.JpegToPdf,N=D.browserDetails;D.exportChart=function(ga){var w=this,r=w.config,p=w.components,c=w.chartInstance,v=D.getSvgDataurl,M=D.removeCrossDomainImages,e=D.downloadCharts,q=r.exportOption;ga="object"===typeof ga&&function(a){var c={},e;for(e in a)c[e.toLowerCase()]=a[e];return c}(ga)||{};var H=n(n({},q),ga),t=(H.exportformat||"png").toLowerCase(),
L=H.exporthandler,K=(H.exportaction||F).toLowerCase(),pa=H.exporttargetwindow||F,S=H.exportfilename,T=H.exportparameters,ba=H.exportcallback,aa=H.exportwithimages,I=H.exportatclientside,ia,C,za;if(!q||!q.enabled||!L)return!1;g.raiseEvent("beforeExport",H,c,void 0,function(){function q(){var a,c,g;c=function(a){Da.stream=a;Da.stream_type="IMAGE-DATA";e(null,null,null,Da,Za)};N.hasCanvas&&"undefined"!==typeof m.btoa?(a=O.createElement("canvas"),a.width=La.width,a.height=La.height,"svg"===t?v(Oa,function(a){c(a)}):
D.drawSvgOnCanvas(Oa,a,0,0,La.width,La.height,function(){switch(t){case "png":c(a.toDataURL("image/png"));break;case "jpeg":c(a.toDataURL("image/jpeg"));break;case "pdf":g=new l(La.height,La.width);g.addImage(a.toDataURL("image/jpeg"));c(g.getDataUrl());break;default:c(a.toDataURL("image/jpeg"))}})):-1!==Ma.indexOf("<image ")?Wa?(Pa=(Ka=Ma.match(/<image [^\>]*\>/gi))&&Ka.length,ka=function(a){var c,e;(e=a.match(/data:image\/(.*);/))?a=e[1]:(c=a&&a.split("/"),c=c[c.length-1],a=c.split("."),c=a[0],
a=a[1]||"png","jpg"===a&&(a="jpeg"));return{name:c,type:a}},mb=function(a,c,e,g,m){var l=new d;l.onload=function(){var d="image/"+e,q=O.createElement("canvas"),p=q.getContext("2d"),n="";q.width=l.width;q.height=l.height;p.drawImage(l,0,0);n=q.toDataURL(d);ya[a]=n;Na(n,c,e,g,m)};l.onerror=function(){Ga()};l.src=a},Na=function(a,c,e,d,g){Sa["image_"+Ua]={name:c,type:e,encodedData:a,width:d,height:g};Ga()},Ga=function(){var a={},c,d,g,m,l,q=!1;Ua<Pa?(c=Ka[Ua].replace(/\"/g,""),c.split(" ").forEach(function(c){c=
c.split(/=(.+)?/);a[c[0]]=c[1]}),a["xlink:href"]&&(c=(d=ka(a["xlink:href"]))&&d.name||"temp_image_"+Ua,g=d&&d.type||"png",m=parseInt(a.width,10),l=parseInt(a.height,10),d=c+"."+g,ya[a["xlink:href"]]?q=!0:mb(a["xlink:href"],c,g,m,l)),c='xlink:href="'+a["xlink:href"],Ma=Ma.replace(c,'xlink:href="temp/'+d),Ua+=1,q&&Ga()):(Da.encodedImgData=JSON.stringify(Sa),Da.stream=Ma,e(null,null,null,Da,Za))},Ga()):e(null,null,null,Da,Za):e(null,null,null,Da,Za)}function n(){var a=S+"."+t;"svg"===t?v(Oa,function(c){e("url",
c,a)}):va(t,V)}function ea(){var a=0;ia=[];C.replace(/[^\r\n]+/g,function(c){ia[a]=[];c.replace(/"([^",]+)/g,function(c,e){ia[a].push(e)});a+=1})}function ga(){return"data:application/vnd.ms-excel;base64,"+function(a){return m.btoa(m.unescape(encodeURIComponent(a)))}("<html xmlns:o='urn:schemas-microsoft-com:office:office'xmlns:x='urn:schemas-microsoft-com:office:excel'xmlns='http://www.w3.org/TR/REC-html40'><head>\x3c!--[if gte mso 9]><xml><x:ExcelWorkbook><x:ExcelWorksheets><x:ExcelWorksheet><x:Name>{worksheet}</x:Name><x:WorksheetOptions><x:DisplayGridlines/></x:WorksheetOptions></x:ExcelWorksheet></x:ExcelWorksheets></x:ExcelWorkbook></xml><![endif]--\x3e</head><body>"+
function(){var a,c,e,d,g,m;if(!ia.length)return"";e=0;for(m=ia.length;e<m;e+=1)if(0===e){a="<thead valign='top'><tr>";d=0;for(g=ia[e].length;d<g;d+=1)a+="<th>"+ia[e][d]+"</th>";a+="</tr></thead>";c="<tbody>"}else{c+="<tr>";d=0;for(g=ia[e].length;d<g;d+=1)c+="<td>"+ia[e][d]+"</td>";c+="</tr>"}return"<table align='center' >"+a+(c+"</tbody>")+"</table>"}()+"</body></html>")}function V(a,c,d){d=d+"."+a;switch(a){case "pdf":a=new D.JpegToPdf(La.height,La.width);a.addImage(c);c=a.getDataUrl();e("url",c,
d);break;default:e("url",c,d)}}function va(a,c){var e;e=O.createElement("canvas");e.width=La.width;e.height=La.height;D.drawSvgOnCanvas(Oa,e,0,0,La.width,La.height,function(){switch(a){case "png":c(a,e.toDataURL("image/png"),S);break;case "jpeg":c(a,e.toDataURL("image/jpeg"),S);break;default:c(a,e.toDataURL("image/jpeg"),S)}})}var nb=c.id,La=p.paper,Da,Ma,Oa,Wa=D.isCanvasElemSupported(),Ka,Pa,Ua=0,Sa={},ka,mb,Ga,Na,ya={},Ia={DOMId:nb,height:La.height,width:La.width,fileName:S+"."+t,statusCode:void 0,
statusMessage:void 0,notice:void 0},Za={exportAction:K,exportTargetWindow:pa,exportCallback:ba,fusionCharts:w,paper:La,chartId:nb,exportHandler:L};if("xls"===t)if("undefined"!==typeof m.btoa)C=c.getCSVData();else return g.raiseEvent("exportCancelled",H,c),!1;else p.chartMenuBar&&p.chartMenuBar.group.attr("visibility","hidden"),Ma=La.toSVG(aa&&Wa&&"svg"!==t),Oa=La.toSVG(aa&&Wa),p.chartMenuBar&&p.chartMenuBar.group.attr("visibility","visible"),Ma=Ma.replace(/(\sd\s*=\s*["'])[M\s\d\.]*(["'])/ig,"$1M 0 0 L 0 0$2"),
Ma=Ma.replace(/NS\d+:/gi,"xlink:"),Ma=M(Ma),Oa=Oa.replace(/NS\d+:/gi,"xlink:"),Oa=Oa.replace(/(\sd\s*=\s*["'])[M\s\d\.]*(["'])/ig,"$1M 0 0 L 0 0$2"),Oa=Oa.replace(/(xlink:title\s*=\s*)['"].*["']/ig,""),Ma=Ma.replace(/[\w\-]+\=\"undefined\"/ig,""),Ma=Ma.replace(/(xlink:title\s*=\s*)['"].*["']/ig,""),Ma=Ma.replace(/rgba\(([^\)]+)\)/ig,function(a,c){return"#"+new A(c.split(","))}),Ma=Ma.replace(/<svg[^>]+/i,function(a){a.match(/height/i)||!La.height&&!r.height||(a+=' height="'+(La.height||r.height)+
'"');a.match(/width/i)||!La.width&&!r.width||(a+=' width="'+(La.width||r.width)+'"');return a}),Ma=Ma.replace(/(([\w]+\-)?opacity\s*=\s*)['"][\d\.]+e[\-\+][\d]+["']/ig,'$1"0.001"'),Ma=Ma.replace(/(([\w]+\-)?opacity\s*:\s*)[\d\.]+e[\-\+][\d]+/ig,"$10.001"),Ma=Ma.replace(/<text[^\>]+/ig,function(a){a=a.replace(/stroke\=[\"\']([a-z0-9\#]+)?[\"\']/ig,"");a=a.replace(/stroke\s*\:\s*([a-z0-9\#]+)?;?/ig,"");a=a.replace(/stroke-opacity\=[\"\']([a-z0-9\#]+)?[\"\']/ig,"");a=a.replace(/stroke-opacity\s*\:\s*([a-z0-9\#]+)?;?/ig,
"");a=a.replace(/(<text[^\>]+fill\=)([\"\'][^\"\']+[\"\'])([^\>]+)/ig,'$1$2 stroke=$2 stroke-width="0.2"$3');return a=a.replace(/(<text[^\>]+fill-opacity\=)([\"\'][^\"\']+[\"\'])([^\>]+)/ig,"$1$2 stroke-opacity=$2 $3")}),Ma=Ma.replace(/<(\b[^<>s\s]+\b)[^\>]+?opacity\s*=\s*['"][^1][^\>]+?(\/>|>[\s\r\n]*?<\/\1>)/ig,function(c,e){var d=J.exec(c)||F,g=a.exec(c)||F;return c+"<"+e+d+g+' opacity="1" stroke-opacity="1" fill="#cccccc" stroke-width="0" r="0" height="0.5" width="0.5" d="M 0 0 L 1 1" />'}),Da=
{charttype:c.chartType(),stream:Ma,stream_type:"svg",meta_bgColor:H.bgcolor||"",meta_bgAlpha:H.bgalpha||"1",meta_DOMId:c.id,meta_width:La.width||r.width,meta_height:La.height||r.height,parameters:["exportfilename="+S,"exportformat="+t,"exportaction="+K,"exportparameters="+T].join("|")};g.raiseEvent("exportDataReady",Da,c);"xls"===t?(ea(),za=ga(),!I||"download"!==K||"undefined"===typeof m.btoa||"Chrome"!==N.name&&"Firefox"!==N.name&&"Edge"!==N.name&&"ie"!==N.name?(Da={charttype:"combined",stream:za,
stream_type:"IMAGE-DATA",parameters:["exportfilename="+S,"exportformat="+t,"exportaction="+K,"exportparameters="+Za].join("|")},e(null,null,null,Da,Za)):(e("url",za,S+"."+t),g.raiseEvent("exported",Ia,c))):I&&"download"===K?"undefined"===typeof m.btoa||"Chrome"!==N.name&&"Firefox"!==N.name&&"Edge"!==N.name&&"ie"!==N.name?(g.raiseWarning(this,"14038823867","run","Export Feature","Client side export requirement not fulfiled so exporting through server side"),q()):(n(),g.raiseEvent("exported",Ia,c)):
q()},function(){g.raiseEvent("exportCancelled",H,c)})}}]);FusionCharts.register("module",["private","modules.renderer.js-component-toolbox",function(){function g(a){"number"===typeof a&&(a="'"+a+"'");return a.split("").reduce(function(a,c){a=(a<<5)-a+c.charCodeAt(0);return a&a},0)}function m(a,c){var e;if(a.getBBox)return a;e=a.getBoundingClientRect();a.getBBox=function(){return{x:c.x,y:c.y,width:e.right-e.left,height:e.bottom-e.top,isArtificial:!0}};return a}function D(a,c,e){var d,g;for(d in a)g=
a[d],void 0!==g&&null!==g&&(e?c[d]||(c[d]=g):c[d]=g)}function n(a,c){switch(a){case "click":return function(a){J.dem.listen(c,"click",function(c){c.target&&c.target.parentNode&&a.call(c.target)})};case "hover":return function(a,e){J.dem.listen(c,"pointerhover",function(c){c.target&&c.target.parentNode&&("start"===c.state?a:e).call(c.target)})}}}function F(){this.pool={}}function A(a,c){var e,d,g;d=this.elemTypes={KEY_RECT:"rect",KEY_TEXT:"text",KEY_GROUP:"group",KEY_SCROLLER:"scoller",KEY_BUTTON:"button",
KEY_PATH:"path",KEY_DIV:"div"};g=this.cachedState={};e=this.actions={};e[d.KEY_DIV]=function(){return O.createElement("div")};e[d.KEY_RECT]=function(c){return a.paper.rect(c)};e[d.KEY_TEXT]=function(c){return a.paper.text(c)};e[d.KEY_GROUP]=function(c,e){return a.paper.group(c,e)};e[d.KEY_SCROLLER]=function(c,e,d,g,m,l,q){return a.paper.scroller(c,e,d,g,m,l,q)};e[d.KEY_BUTTON]=function(c,e,d,g,m,l){return a.paper.button(c,e,d,g,m,l)};e[d.KEY_PATH]=function(c,e){return a.paper.path(c,e)};d=this.cache=
g[c]||(g[c]={});this._hideRecursive(d.pool);d.initialized||(e=d.pool=(new F).pool,e._tmp=c,d.initialized=!0)}var J=this.hcLib,a=J.Raphael,O=this.window.document,d=J.graphics,l=d.convertColor,N=d.getLightColor,ga=d.rawRGBtoHEX,w=J.pluckNumber,r=J.pluck,p={},c={},v={},M=J.extend2,e,q,H,t,L=function(){},K=J.BLANKSTRING,pa=l("FFFFFF",0),S=0;e=function(a,c,e){return["M",a-e,c-e]};q=function(a,c,e){var d=e/4;return["M",a-3*d,c,"L",a-d,c+e,a+e,c-e]};H=function(){a.addSymbol("Internal_CB",e);return{register:function(){var c,
e,d;if(1===arguments.length){e=arguments[0];if(null==e||"object"!==typeof e)return;d=e}else if(1<arguments.length){c=arguments[0];e=arguments[1];if("string"!==typeof c||"function"!==typeof e)return;d={};d[c]=e}else return;for(c in d)e=d[c],{}.hasOwnProperty.call(d,c)&&a.addSymbol(c,e)}}}();A.prototype._hideRecursive=function(a){var c,e,d,g,m,l;if(a)for(c in a)for(e in d=a[c],d)if(g=d[e],g instanceof Array)for(m=0,l=g.length;m<l;m++)g[m].hide&&g[m].hide();else g.hide&&g.hide()};A.prototype.isInitialized=
function(){return this.initialized};A.prototype.getCreationStatus=function(){return this.newCreationDataFlag};A.prototype.emptyPool=function(a){a=this.cachedState[a]||{};a.pool&&(a.pool={})};A.prototype.hideRecursive=function(a){this._hideRecursive((this.cachedState[a]||{}).pool)};A.prototype.getKeys=function(){return this.elemTypes};A.prototype.getComponent=function(a,c,e,d){var g=this.cachedState[c||0]||{};c=g.pool;var m=c[a],l,q,p,n=this.actions,t=0;m||(m=c[a]={});return(q=m[e])&&!(q instanceof
Array)||q instanceof Array&&0<q.length?function(){g.newCreationDataFlag=!1;return d?(p=q[t++])?p.show():q[t]=n[e].apply(g,arguments):q.show&&"function"===typeof q.show&&q.show()||q}:function(){g.newCreationDataFlag=!0;return d?(l=m[e]||(m[e]=[]),q=n[e].apply(g,arguments),l.push(q),q.show&&"function"===typeof q.show&&q.show()||q):m[e]=n[e].apply(g,arguments)}};t=function(a,d){function t(a){a=a||{};this.name=a.name;this.handler=a.handler||L;this.action=a.action&&a.action.toLowerCase()||"click";this.eventMap=
{};this.style={padding:"3px 8px",margin:"2px 0px",fontFamily:v.baseFontFamily,fontSize:v.baseFontSize+"px"};this.hoverOverStyle=a.hoverOverStyle||{};this.hoverOutStyle=a.hoverOutStyle||{};D(a.style||{},this.style);this.node=this.subConRef=void 0}function r(a,c){var e=this,d,g;d=c&&c.top||0;var m=c&&c.left,l=c&&c.right;this.container=a;this.position=r.POSITION_BOTTOM;this.atomicLists=[];this.refContainers=[];this.parentListCon=void 0;this.hideFnIds=[];this.target=void 0;m&&l||(this.positionCalculation=
!0);this.hoverOverStyle={background:"#333333",color:"#FFFFFF",cursor:"pointer"};this.hoverOutStyle={background:"#FFFFFF",color:"#000000"};this._defaultStyle={position:"absolute","z-index":50,top:void 0===d?"auto":d+"px",right:void 0===l?"auto":l+"px",left:void 0===m?"auto":m+"px",overflow:"hidden",background:"#ffffff",border:"1px solid #646464","box-shadow":"#999999 2px 2px 5px",padding:"5px 3px",display:"none"};d=this.container.style;for(g in this._defaultStyle)d[g]=this._defaultStyle[g];Oa.linkedItems&&
(Oa.linkedItems.container.appendChild(this.container),g=n("hover",this.container),g(function(){e.show(this)},function(){e.hide(300,this)}))}function A(a){this.listContainer=this.container=void 0;this.measurement=a}function C(a,c,e,d){this.symbol=a;this._id="TB_SYMBOL"+(e||0);this.node=void 0;this.pId=d;this.isPlaintext=c;this.conf={btnTextStyle:{"stroke-width":"1px",stroke:"none"}};this.evt={tooltext:void 0,click:L,hover:[L,L]}}function K(a,c,e,d){C.call(this,"Internal_CB");this._id="TB_CBSYMBOL"+
(e||0);this.symbol="Internal_CB";this.text={plaintext:a,node:void 0,style:La};this.pId=d;this.checked=!!c;this.textNode=void 0;this.interPadding=3;this.pos={};this.regSymbolCmd=void 0;this.checked?this.check():this.uncheck()}function F(a,e,d){C.call(this);this._id="TB_SCROLLER"+(e||0);this.pId=d;this.conf={};this.userConf=c;this.setConfiguaration(a);this.evt.scroll=L;return this}function J(a,c,e){var d;C.call(this,a,void 0,c,e);this.rawContextDefinitation=void 0;this.listContainerManager=(new A(this.position)).init(e);
d=this.listContainerManager.getFirstContainer();this.evt.hover=[function(a){d.show(m(a.target||a.fromElement,a))},function(a){d.hide(300,a.target)}]}function S(a,c){this.preId=a||0;this.id=void 0;this.symbolList=[];this.groupRect=void 0;this.pId=c;M(this.btnConfig={},p);M(this.groupConfig={},va)}function ra(a,c){V[this.id="TB_MASTER"+a||g((new Date).getTime())]=this;this.toolbarRect=void 0;this.componentGroups=[];this.toolbarConfig=nb;this.group=void 0;this.pId=c}var V={},va={hPadding:3,vPadding:3,
borderRadius:2,fill:l("DBDBDB",100),borderColor:l("B2B1B1",100),borderThickness:1,offsetAdjustment:1,radius:1,spacing:6},nb={hPadding:3,vPadding:3,borderRadius:0,fill:l("EBEBEB",100),borderColor:l("D1D0D0",100),borderThickness:1,offsetAdjustment:1,radius:0},La={fontFamily:"Verdana,sans",fontSize:"12px",fill:void 0,fontStyle:"normal",fontWeight:"normal"},Da,Ma,Oa;Ma=d.graphics;Oa=d.chart;Da=d.components;t.prototype.updateName=function(a){this.name=a;this.node&&(this.node.innerHTML=a)};t.prototype.assignSubContainer=
function(a){a instanceof r&&(this.subConRef=a)};t.prototype.stickIntoContainer=function(a,c){var e=this.node=O.createElement("div"),d=this.style,g,m,l,q=this;e&&(e.ishot=!0);this.handler&&(this.eventMap[this.action]=this.handler);a.appendChild(e);e.innerHTML=this.name;m=e.style;for(g in d)m[g]=d[g];d=n("hover",e);n("click",e)(function(){q.handler&&((l=q.eventMap.click)&&l.apply(q,[Oa]),c.hide())});d(function(){var a,c=e.style,d=q.hoverOverStyle;for(a in d)c[a]=d[a];q.subConRef&&q.subConRef.show(this)},
function(){var a,c=e.style,d=q.hoverOutStyle;for(a in d)c[a]=d[a];q.subConRef&&q.subConRef.hide(300,this)})};t.prototype.setStyle=function(a){D(a||{},this.style)};t.prototype.dispose=function(){var a=this.node;a&&a.remove&&a.remove();this.node=void 0};r.POSITION_TOP="top";r.POSITION_BOTTOM="bottom";r.prototype.addAtomicListItem=function(a){a instanceof t&&(this.atomicLists.push(a),a.stickIntoContainer(this.container,this))};r.prototype.show=function(a){var c=this.hideFnIds,e=Oa.config.width,d=this.positionCalculation,
g=0,m;this.target=this.target||a;for(m=c.length;g<m;g++)clearTimeout(c[g]);c.length=0;(c=this.parentListCon)?(c.show(this.target),this.container.style.left=c.container.offsetLeft+c.container.offsetWidth+"px",this.container.style.top=c.container.offsetTop+this.target.offsetTop+"px"):(c=a&&a.nodeName&&"DIV"===a.nodeName.toUpperCase()?!0:!1,c||(a=a.getBBox(),d&&(this.container.style.display="block",d=this.container.offsetWidth,d+a.x>e?(this.container.style.left="auto",this.container.style.right=e-a.x-
a.width+"px"):(this.container.style.left=a.x+"px",this.container.style.right="auto"),this.container.style.display="none"),this.position===J.POSITION_BOTTOM?(e=a.isArtificial?.5:1.5,this.container.style.top=a.y+a.height*e+"px",this.container.style.bottom="auto"):(this.container.style.bottom=Oa.config.height-a.y+"px",this.container.style.top="auto")));this.container.style.display="block"};r.prototype.hide=function(a){var c=this.container,e;(e=this.parentListCon)&&e.hide(300);this.hideFnIds.push(setTimeout(function(){c.style.display=
"none"},a))};r.prototype.dispose=function(){var a=this.atomicLists,c=this.refContainers,e,d;e=this.hideFnIds.length=0;for(d=a.length;e<d;e++)a[e].dispose();e=a.length=0;for(d=c.length;e<d;e++)c[e].dispose();c.length=0};A.prototype.init=function(c){var e=a.getKeys();this.container||(c=a.getComponent("div0",c,e.KEY_DIV),(c=c())&&(c.innerHTML=""),this.container=new r(c,this.measurement));return this};A.prototype.getFirstContainer=function(){return this.container};A.prototype.appendAsList=function(a,
c){var e=this,d,g=this.container.hoverOverStyle,m=this.container.hoverOutStyle;(function Ga(a,c){var l,q=0,p,n,w,C,v,A,H,D;H=c?c:e.container;l=a instanceof Array?a:[a];for(p=l.length;q<p;q++){n=l[q];w=new t({hoverOverStyle:g,hoverOutStyle:m});for(C in n)w.name=C,v=n[C],w.action=v.action,w.setStyle(v.style),-1!==C.search(/^<[^<]+>$/)&&(w.hoverOverStyle={},w.hoverOutStyle={},v.handler=L),A=v.handler,"function"!==typeof A?D=Ga(A,new r(O.createElement("div"))):w.handler=v.handler;H.addAtomicListItem(w);
D&&(D.parentListCon=H,H.refContainers.push(D),w.assignSubContainer(D));D=void 0}return d=H})(a,c);return d};A.prototype.dispose=function(){this.container.dispose();this.container=void 0};C.prototype.registerSymbol=function(a){H.register(this.symbol,a)};C.prototype._setConfiguaration=function(a){this.conf?D(a,this.conf,!0):this.conf=a};C.prototype.attachEventHandlers=function(a,c){var e=this.evt,d=a.tooltext,g=a.click||L,m=a.hover,l=c&&c.click||L,q=this;d&&(e.tooltext=d);e.click="function"===typeof g?
function(){l();g.apply(q,arguments)}:function(){var a=g.fn,c=g.context,e=(g.args||[]).slice(0);g.hasOwnProperty("context")?e.push(q):c=q;[].push.apply(e,arguments);l();a.apply(c,e)};m&&m instanceof Array&&(e.hover=m);this.node&&this.node.tooltip(this.evt.tooltext).buttonclick(this.evt.click).hover(this.evt.hover[0],this.evt.hover[1]);return q};C.prototype.getLogicalSpace=function(){return{width:this.conf.width,height:this.conf.height}};C.prototype.show=function(){var a=this.node;a&&a.css({display:"block"})};
C.prototype.hide=function(){var a=this.node;a&&a.css({display:"none"})};C.prototype.draw=function(c,e,d){var g=this.conf||{},m,q,p=a.getKeys(),n=Oa.get("config","animationObj"),t=n.animObj,r=n.dummyObj,w=n.duration;this.isPlaintext?q=this.symbol:m=this.symbol;void 0!==d.idCount&&(this._id+=d.idCount);g.hoverFill=g.hoverFill?l(g.hoverFill):l(N(ga(g.fill),80));d=this.node=a.getComponent(this._id,this.pId,p.KEY_BUTTON,!0)(c,e,q,m,{width:g.width,height:g.height,r:g.radius,verticalPadding:g.symbolHPadding*
g.scale,horizontalPadding:g.symbolHPadding},d.parentLayer).labelcss(this.conf.btnTextStyle);d.attr({ishot:!0,fill:[g.fill,g.labelFill,g.symbolFill,g.hoverFill,!0],stroke:[g.stroke,g.symbolStroke],"stroke-width":[g.strokeWidth,g.symbolStrokeWidth]}).tooltip(this.evt.tooltext).buttonclick(this.evt.click).hover(this.evt.hover[0],this.evt.hover[1]);a.getCreationStatus()||(this.node.unclick(),this.node.animateWith(r,t,{"button-repaint":[c,e,g.width,g.height,g.radius]},w,n.animType),this.node.attr({"button-label":q,
"button-padding":[g.symbolHPadding,g.symbolHPadding*g.scale]}),this.node.buttonclick(this.evt.click));d.getBBox=function(){return{x:c,y:e,width:g.width,height:g.height}};return d};C.prototype.dispose=function(){var a=this.node;a&&a.remove();this.node=void 0};K.prototype=Object.create(C.prototype);K.prototype.constructor=K;K.prototype.check=function(){var a=this.pos;this.checked=!0;this.regSymbolCmd=q;this.node&&(this.registerSymbol(this.regSymbolCmd),this.node.attr({"button-repaint":[a.x,a.y,a.width,
a.height,a.r]}))};K.prototype.uncheck=function(){var a=this.pos;this.checked=!1;this.regSymbolCmd=e;this.node&&(this.registerSymbol(this.regSymbolCmd),this.node.attr({"button-repaint":[a.x,a.y,a.width,a.height,a.r]}))};K.prototype.click=function(){this.checked?this.uncheck():this.check()};K.prototype.attachEventHandlers=function(a){var c=this;C.prototype.attachEventHandlers.apply(this,[a,{click:function(){c.click()}}])};K.prototype.getLogicalSpace=function(){var a=Oa.linkedItems.smartLabel,c=this.text.style,
e;e=C.prototype.getLogicalSpace.apply(this,arguments);a.useEllipsesOnOverflow(Oa.config.useEllipsesWhenOverflow);a.setStyle(c);a=a.getSmartText(this.text.plaintext);return{width:a.width+this.interPadding+e.width,height:Math.max(e.height,a.height)}};K.prototype.draw=function(c,e,d){var g,m=this.conf,l;l=Oa.linkedItems.smartLabel;var q=Da.colorManager,p=this.text.plaintext,n,t=a.getKeys();this.registerSymbol(this.regSymbolCmd);g=this.node=C.prototype.draw.apply(this,arguments);this.pos={x:c,y:e,width:m.width,
height:m.height,r:m.radius};n=this.text.style;n.fill=n.fill||"#"+q.getColor("baseFontColor");l.useEllipsesOnOverflow(Oa.config.useEllipsesWhenOverflow);l.setStyle(n);l=l.getSmartText(p);g=g.getBBox();q=a.getComponent(this._id,this.pId,t.KEY_TEXT);this.textNode=q(d.parentLayer).attr({text:p,x:g.x+g.width+l.width/2+this.interPadding,y:g.y+g.height/2}).css(n);m=m.height>l.height?m.height:l.height;q=a.getComponent(this._id,this.pId,t.KEY_RECT);return q(d.parentLayer).attr({height:m,width:g.width+l.width+
this.interPadding,x:c,y:e,stroke:pa})};K.prototype.dispose=function(){this.textNode&&this.textNode.remove();this.textNode=void 0;C.prototype.dispose.call(this)};F.prototype=Object.create(C.prototype);F.prototype.constructor=K;F.prototype.setConfiguaration=function(a){var e=Da.colorManager;c.color||(c.color="#"+e.getColor("altHGridColor"));D(c,this.conf);D(a,this.conf)};F.prototype.getLogicalSpace=function(){var a=this.conf,e={};D(c,e);D(e,a);return C.prototype.getLogicalSpace.call(this)};F.prototype.getDefaultLayer=
function(){var c=a.getKeys();return a.getComponent(this._id,this.pId,c.KEY_GROUP)("scroll")};F.prototype.registerSymbol=void 0;F.prototype._setConfiguaration=function(){};F.prototype.attachEventHandlers=function(a){a&&a.scroll&&"function"===typeof a.scroll&&(this.evt.scroll=a.scroll);C.prototype.attachEventHandlers.apply(this,arguments);return this};F.prototype.draw=function(){var e,d,g,m,l,q,p,n,t,r,C,v,A,H,K,F;K=this.conf;var I,L=a.getKeys(),J={},M=Oa.get("config","animationObj"),N=M.animObj,O=
M.dummyObj;g={};var aa=M.duration;1===arguments.length?(K=arguments[0],e=K.x,d=K.y,p=K.parentLayer,l=!!K.sepLayer):(e=arguments[0],d=arguments[1],l=arguments[2],K&&l?D(l,K):l={},p=l.parentLayer,l=!!l.sepLayer);D(c,g);K.isHorizontal?delete g.width:delete g.height;D(g,K);d+=K.padding;g=K.height;m=K.width;q=K.isHorizontal;F=K.startPercent;n=K.scrollRatio;t=K.showButtons;r=K.displayFlat;C=K.fullCanvasWidth;v=K.windowedCanvasWidth;A=K.color;H=K.roundEdges;J["scroll-repaint"]=[e,d,m,g];p=p?p:this.getDefaultLayer();
I=a.getComponent(this._id,this.pId,L.KEY_RECT);p=l?I("scroll-child"):p;I=a.getComponent(this._id,this.pId,L.KEY_SCROLLER);this.node=I(e,d,m,g,q,{scrollPosition:K.scrollPosition||w(F,0),displayStyleFlat:r,showButtons:t},p).data("fullCanvasWidth",C).data("windowedCanvasWidth",v).attr({"scroll-ratio":n,fill:A,r:H&&2||0}).scroll(this.evt.scroll);a.getCreationStatus()||(this.node.undrag(),this.node.animateWith(O,N,J,aa,M.animType),this.node.attr({"scroll-display-style":r?"flat":"3d","scroll-position":K.scrollPosition||
w(F,0)}).scroll(this.evt.scroll));return this.node};J.POSITION_TOP="top";J.POSITION_BOTTOM="bottom";J.prototype=Object.create(C.prototype);J.prototype.constructor=J;J.allNodes=[];J.prototype.getListRefernce=function(){return this.listContainerManager};J.prototype.attachEventHandler=function(a){var c=this.evt;if(a=a.tooltext)c.tooltext=a};J.prototype.getLogicalSpace=function(){var a=this.listContainerManager.getFirstContainer().atomicLists;return a&&0===a.length?{width:0,height:0}:C.prototype.getLogicalSpace.call(this)};
J.prototype.draw=function(){var a=this.listContainerManager.getFirstContainer().atomicLists;if(a&&0===a.length)return this.hide(),{getBBox:function(){return{width:0,height:0}}};a=C.prototype.draw.apply(this,arguments);J.allNodes.push(this.node);return a};J.prototype.dispose=function(){this.listContainerManager&&this.listContainerManager.dispose();this.listContainerManager=void 0;C.prototype.dispose.call(this)};S.prototype.addSymbol=function(a,c){var e=this.symbolList;c?e.unshift(a):e.push(a)};S.prototype.setConfiguaration=
function(a){var c=a.buttons;a=a.group;c&&D(c,this.btnConfig);a&&D(a,this.groupConfig)};S.prototype.draw=function(c,e,d){var g=this.preId,m=this.symbolList,l,q,p=this.groupConfig,n=this.btnConfig,t=e.x,r=e.y,w=0,C=0,v=Number.NEGATIVE_INFINITY;l=a.getKeys();g=this.id=g.toString()+d;Ma.toolbarGroup=Ma.toolbar||{};d=a.getComponent(this.id,this.pId,l.KEY_GROUP);c=d("toolbar-group"+g,c).trackTooltip(!0);d=a.getComponent(this.id,this.pId,l.KEY_RECT);g=this.groupRect=d(c).attr({height:0,width:0,x:t,y:r});
t+=p.hPadding;r+=p.vPadding;C+=p.hPadding;w+=p.vPadding;l=0;for(d=m.length;l<d;l++)q=m[l],q._setConfiguaration(n),q=q.draw(t,r,{parentLayer:c}),q=q.getBBox(),v<q.height&&(v=q.height),t+=q.width+(q=n.spacing);C+=t+p.hPadding-e.x-q-p.offsetAdjustment;w+=v+p.vPadding+p.offsetAdjustment;isFinite(w)||(w=0);isFinite(C)||(C=0);g.attr({height:w,width:C}).attr({fill:p.fill,r:p.radius,stroke:p.borderColor,"stroke-width":p.borderThickness});q=g.getBBox();return{height:q.height,width:q.width}};S.prototype.getLogicalSpace=
function(){var a=this.symbolList,c,e,d,g=0,m=0,l=Number.NEGATIVE_INFINITY,q=0;e=0;for(d=a.length;e<d;e++)c=a[e],c._setConfiguaration(this.btnConfig),c=c.getLogicalSpace(),m+=c.width+this.btnConfig.spacing,q+=c.width,l=l<c.height?c.height:l;if(!q)return{width:0,height:0};l!==Number.NEGATIVE_INFINITY&&m&&(m-=this.btnConfig.spacing-2*this.groupConfig.hPadding-this.groupConfig.offsetAdjustment,g=l+2*this.groupConfig.vPadding+this.groupConfig.offsetAdjustment);return{width:m,height:g}};S.prototype.dispose=
function(){for(var a=this.symbolList,c=0,e=a.length;c<e;c++)a[c].dispose();a.length=0;this.groupRect.remove()};ra.prototype.getId=function(){return this.id};ra.prototype.addComponent=function(a){this.componentGroups.push(a)};ra.prototype.draw=function(c,e,d){var g=this.componentGroups,m,l,q;q=this.id;var p=c,n=e,t;e=this.toolbarConfig;var r,w=Number.NEGATIVE_INFINITY;t=a.getKeys();d=d||{};l=Ma.toolbar=d.parentGroup||Ma.toolbar||{};d=a.getComponent(this.id,this.pId,t.KEY_GROUP,!0);this.group=q=d(q,
l);d=a.getComponent(this.id,this.pId,t.KEY_RECT,!0);t=this.toolbarRect=d(q).attr({height:0,width:0,x:p,y:n});p+=e.hPadding;n+=e.vPadding;d=0;for(l=g.length;d<l;d++)m=g[d],r=m.groupConfig.spacing||1,m=m.draw(q,{x:p,y:n},d),p+=m.width+r,w=w>m.height?w:m.height;g=w;c=p-r-e.hPadding-c;isFinite(g)||(g=0);isFinite(c)||(c=0);t.attr({height:g+=2*e.vPadding,width:c+=2*e.hPadding}).attr({fill:e.fill,r:e.radius,stroke:e.borderColor,"stroke-width":e.borderThickness});return{height:g,width:c}};ra.prototype.getLogicalSpace=
function(){var a=this.componentGroups,c,e,d,g=c=0,m=Number.NEGATIVE_INFINITY,l,q=0;c=0;for(e=a.length;c<e;c++)d=a[c],l=d.getLogicalSpace(),d=d.groupConfig.spacing||1,g+=l.width+d,q+=l.width,m=m<l.height?l.height:m;if(!q)return{width:0,height:0};g-=d-2*this.toolbarConfig.hPadding;c=m+2*this.toolbarConfig.vPadding;return{width:g,height:c}};ra.prototype.dispose=function(){for(var c=this.componentGroups,e=0,d=c.length;e<d;e++)c[e].dispose();c.length=0;this.toolbarRect.remove();a.emptyPool(this.pId)};
return{HorizontalToolbar:ra,ComponentGroup:S,Symbol:C,CheckboxSymbol:K,Scroller:F,SymbolWithContext:J,getInstanceById:function(a){return V[a]}}};FusionCharts.register("component",["toolbox","toolbox",{onceInitialized:!1,ALIGNMENT_HORIZONTAL:0,ALIGNMENT_VERTICAL:1,POSITION_TOP:0,POSITION_RIGHT:1,POSITION_BOTTOM:2,POSITION_LEFT:3,init:function(a){if(this.onceInitialized)return this.configure(),this._iCount;this._options=a;this._chart=a.chart;this._iCount=++S;this.configure();this.onceInitialized=!0;
return this._iCount},configure:function(){var a,e,d=this._chart.jsonData.chart;p.scale=w(d.toolbarbuttonscale,1.15);p.width=w(d.toolbarbuttonwidth,15);p.height=w(d.toolbarbuttonheight,15);p.radius=w(d.toolbarbuttonradius,2);p.spacing=w(d.toolbarbuttonspacing,5);p.fill=l(r(d.toolbarbuttoncolor,"ffffff"));p.labelFill=l(r(d.toolbarlabelcolor,"cccccc"));p.symbolFill=l(r(d.toolbarsymbolcolor,"ffffff"));p.hoverFill=r(d.toolbarbuttonhovercolor);p.stroke=l(r(d.toolbarbuttonbordercolor,"bbbbbb"));p.symbolStroke=
l(r(d.toolbarsymbolbordercolor,"9a9a9a"));p.strokeWidth=w(d.toolbarbuttonborderthickness,1);p.symbolStrokeWidth=w(d.toolbarsymbolborderthickness,1);e=p.symbolPadding=w(d.toolbarsymbolpadding,5);p.symbolHPadding=w(d.toolbarsymbolhpadding,e);p.symbolVPadding=w(d.toolbarsymbolvpadding,e);a=p.position=r(d.toolbarposition,"tr").toLowerCase();switch(a){case "tr":case "rt":case "top right":case "right top":a="tr";break;case "br":case "rb":case "bottom right":case "right bottom":a="br";break;case "tl":case "lt":case "top left":case "left top":a=
"tl";break;case "bl":case "lb":case "bottom left":case "left bottom":a="bl";break;default:a="tr"}e=p.hAlign="left"===(K+d.toolbarhalign).toLowerCase()?"l":a.charAt(1);a=p.vAlign="bottom"===(K+d.toolbarvalign).toLowerCase()?"b":a.charAt(0);p.hDirection=w(d.toolbarhdirection,"r"===e?-1:1);p.vDirection=w(d.toolbarvdirection,"b"===a?-1:1);p.vMargin=w(d.toolbarvmargin,6);p.hMargin=w(d.toolbarhmargin,10);d.toolbary&&d.toolbarx?(p.x=w(d.toolbarx),p.y=w(d.toolbary),delete p.spaceNotHardCoded):p.spaceNotHardCoded=
!0;c.color=d.scrollcolor&&l(d.scrollcolor);c.padding=w(d.scrollpadding,0);c.height=w(d.scrollheight,12);c.width=w(d.scrollwidth,12);c.displayFlat=w(d.flatscrollbars,0);c.scrollBar3DLighting=w(d.scrollbar3dlighting,1);c.startPercent=Math.min(1,Math.max(0,parseFloat(d.scrolltoend)||0));c.showButtons=!!w(d.scrollshowbuttons,1);c.buttonPadding=w(d.scrollbtnpadding,0);v.baseFontFamily=r(d.basefont,"Verdana,sans");v.baseFontSize=w(d.basefontsize,10);v.baseFontColor=r(d.basefontcolor,"595959")},getAPIInstances:function(a){var c=
{},e;e=this.componentPool=new A(this._chart.components,this._iCount);e=t(e,this._options);switch(a){case this.ALIGNMENT_HORIZONTAL:c.Toolbar=e.HorizontalToolbar}c.ComponentGroup=e.ComponentGroup;c.Symbol=e.Symbol;c.Scroller=e.Scroller;c.SymbolWithContext=e.SymbolWithContext;c.SymbolStore=H;c.CheckboxSymbol=e.CheckboxSymbol;return c},getDefaultConfiguration:function(){return p},clean:function(){this.componentPool.hideRecursive(this._iCount)}}])}]);FusionCharts.register("module",["private","modules.renderer.js-base",
function(){var g=this,m=g.hcLib,D=m.Raphael,n=D._availableAnimAttrs,F="VML"===D.type,A=g.window,J=A.document,a=m.BLANKSTRING,O=m.HUNDREDSTRING,d=m.preDefStr,l=d.configStr,N=d.animationObjStr,ga=d.NORMAL,w=d.BOLD,r=d.hiddenStr,p=d.visibleStr,c=d.ROUND,v=d.miterStr,M=d.POSITION_START,e=d.POSITION_TOP,q=d.POSITION_END,H=d.POSITION_BOTTOM,t=d.POSITION_MIDDLE,L=d.POINTER,K=d.noneStr,pa=d.SEVENTYSTRING,d=d.AUTOSTRING,S=m.parseConfiguration,T=m.componentConfigurer,ba=m.BLANKSTRING,aa="https:"===A.location.protocol?
"https://export.api3.fusioncharts.com/":"http://export.api3.fusioncharts.com/",I=m.pluck,ia=m.getValidValue,C=m.pluckNumber,za=m.getFirstValue,Ja=m.parseUnsafeString,na=m.extend2,ea=m.getDashStyle,ra=m.graphics.mapSymbolName,V=m.regex.dropHash,va=m.HASHSTRING,nb=A.Image,La=m.setImageDisplayMode,Da=m.removeEvent,Ma=m.getPosition,Oa=m.getMouseCoordinate,Wa=m.addEvent,Ka=8===A.document.documentMode?p:ba,Pa=m.toRaphaelColor,Ua=Math,Sa=Ua.min,ka=Ua.max,mb=Ua.abs,Ga=Ua.ceil,Na=Ua.floor,ya=Ua.round,Ia=Ua.sin,
Za=Ua.cos,wb=Math.PI,Hb=wb/2,Eb=2*wb,Ab=wb+Hb,kb=m.getFirstColor,cb=m.setLineHeight,Xa=m.pluckFontSize,lb=m.graphics.getDarkColor,db=m.graphics.getLightColor,$a=m.graphics.convertColor,sb=m.POSITION_CENTER,tb=m.POSITION_RIGHT,gb=m.POSITION_LEFT,Qa=m.chartAPI,vb=m.COMMASTRING,jb=m.PXSTRING,ab=m.componentDispose,Va,Ea=A.navigator.userAgent.match(/ (iPad|iPhone|iPod)/g),Ra={left:M,right:q,center:t},xb=m.each,hb="rgba(255,0,0,"+(m.isIE?.002:1E-6)+")",yb=m.BGRATIOSTRING,fb=m.graphics.getAngle,Bb=m.NumberFormatter,
zb=m.getLinkAction,ib=m.hasTouch=void 0!==J.documentElement.ontouchstart,ob={1:w,0:ga},pb=function(b){b=b.replace("rgba(",ba).split(",");return"#"+("000000"+(b[0]<<16|b[1]<<8|b[2]).toString(16)).slice(-6)},b=!m.CREDIT_REGEX.test(A.location.hostname),z=m.chartPaletteStr={chart2D:{bgColor:"bgColor",bgAlpha:"bgAlpha",bgAngle:"bgAngle",bgRatio:"bgRatio",canvasBgColor:"canvasBgColor",canvasBaseColor:"canvasBaseColor",divLineColor:"divLineColor",legendBgColor:"legendBgColor",legendBorderColor:"legendBorderColor",
toolTipbgColor:"toolTipbgColor",toolTipBorderColor:"toolTipBorderColor",baseFontColor:"baseFontColor",anchorBgColor:"anchorBgColor"},chart3D:{bgColor:"bgColor3D",bgAlpha:"bgAlpha3D",bgAngle:"bgAngle3D",bgRatio:"bgRatio3D",canvasBgColor:"canvasBgColor3D",canvasBaseColor:"canvasBaseColor3D",divLineColor:"divLineColor3D",divLineAlpha:"divLineAlpha3D",legendBgColor:"legendBgColor3D",legendBorderColor:"legendBorderColor3D",toolTipbgColor:"toolTipbgColor3D",toolTipBorderColor:"toolTipBorderColor3D",baseFontColor:"baseFontColor3D",
anchorBgColor:"anchorBgColor3D"}},B=function(){var b={},a,h=function(){var c,f,z,e,d=0,B,G,P=parseInt(g.core.options.resizeTrackingInterval,10)||300,m={},l=function(){m.itemVar._containerOffsetW=m.parentEle.offsetWidth;m.itemVar._containerOffsetH=m.parentEle.offsetHeight},q;for(c in b)d+=1,f=b[c],z=f.jsVars,B=f.ref,!f.disposed&&(e=B&&B.parentNode)&&(G=B.style)&&(/\%/g.test(G.width)||/\%/g.test(G.height))?(B=e.offsetWidth,q=e.offsetHeight,!z.resizeLocked&&(B&&z._containerOffsetW!==B||q&&z._containerOffsetH!==
q)&&(f.resizeTo&&f.resizeTo(),m.itemVar=z,m.parentEle=e,setTimeout(l,1))):(delete b[c],--d);a=d?setTimeout(h,P):clearTimeout(a)};return function(c,f){var z=c.jsVars,e=f||c.ref&&c.ref.parentNode||{};z._containerOffsetW=e.parentNode.offsetWidth;z._containerOffsetH=e.parentNode.offsetHeight;b[c.id]=c;a||(a=setTimeout(h,parseInt(g.core.options.resizeTrackingInterval,10)||300))}}(),P=m.schedular,G={getExternalInterfaceMethods:function(){var b=Qa[this.jsVars.type],b=b&&b.eiMethods,a="saveAsImage,print,exportChart,getXML,hasRendered,signature,cancelExport,getSVGString,lockResize,showChartMessage,",
h;if("string"===typeof b)a+=b+vb;else if(void 0!==b||null!==b)for(h in b)a+=h+vb;return a.substr(0,a.length-1)},drawOverlayButton:function(b){var a=this.jsVars,h=a.overlayButton,c,f;if(b&&b.show){h||(h=a.overlayButton=J.createElement("span"),m.dem.listen(h,"click",function(){g.raiseEvent("OverlayButtonClick",b,a.fcObj)}));for(c=b.message?b.message:"Back";h.firstChild;)h.removeChild(h.firstChild);h.appendChild(J.createTextNode(c));a.overlayButtonMessage=c;c={border:"1px solid "+(b.borderColor?b.borderColor.replace(V,
va):"#7f8975"),backgroundColor:b.bgColor?b.bgColor.replace(V,va):"#edefec",fontFamily:b.font?b.font:"Verdana,sans",color:"#"+b.fontColor?b.fontColor:"49563a",fontSize:(b.fontSize?b.fontSize:"10")+jb,padding:(b.padding?b.padding:"3")+jb,fontWeight:0===parseInt(b.bold,10)?ga:w,position:"absolute",top:"0",right:"0",_cursor:"hand",cursor:L};for(f in c)h.style[f]=c[f];a.hcObj.container.appendChild(h);a.overlayButtonActive=!0}else h&&(a.overlayButton=h.parentNode.removeChild(h),a.overlayButtonActive=!1,
delete a.overlayButtonMessage)},print:function(b){var a=this.apiInstance,h=na({},b);if(a.config.isPrinting||!a.config.hasRendered)return!1;g.raiseEvent("BeforePrint",h,a.chartInstance,void 0,function(){var b=a.linkedItems.container,f=[],c=b.parentNode,E=J.body||J.getElementsByTagName("body")[0],z=E.childNodes,e,d,B,G;a.config.isPrinting=!0;xb(z,function(b,a){1==b.nodeType&&(f[a]=b.style.display,b.style.display="none")});if(!1!==h.hideButtons){d=a.components.chartMenuBar.componentGroups[0].symbolList;
G=0;for(e=d.length;G<e;G++)if((B=d[G])instanceof a.components.toolBoxAPI.SymbolWithContext){B=B.getListRefernce().getFirstContainer();break}B.container.style.display=K}E.appendChild(a.linkedItems.container);A.print();setTimeout(function(){B.container.style.display=p;c.appendChild(b);xb(z,function(b,a){1==b.nodeType&&(b.style.display=f[a])});!1!==h.hideButtons&&(B.container.style.display=p);a.config.isPrinting=!1;g.raiseEvent("PrintComplete",h,a.chartInstance)},1E3)},function(){g.raiseEvent("PrintCancelled",
h,a.chartInstance)})},exportChart:function(b){return m.exportChart.call(this.apiInstance,b)},getSVGString:function(){return this.jsVars&&this.jsVars.instanceAPI&&this.jsVars.instanceAPI.components&&this.jsVars.instanceAPI.components.paper&&this.jsVars.instanceAPI.components.paper.toSVG()},resize:function(){var b=this.jsVars,a=b.container;b.instanceAPI&&b.instanceAPI.redraw?b.instanceAPI.redraw():m.createChart(b.fcObj,a,b.type,void 0,void 0,!1,!0);delete b.isResizing},lockResize:function(b){return"boolean"!==
typeof b?!!this.jsVars.resizeLocked:this.jsVars.resizeLocked=b},showChartMessage:function(b,a,h,c){var f=this.jsVars,z=this.FusionCharts.apiInstance,e=z.chartInstance.options;!c&&(c={});c={fontFamily:I(c.font,e.baseChartMessageFont,"Verdana,sans"),fontSize:C(c.fontSize,e.baseChartMessageFontSize,10),color:I(c.color&&$a(c.color,c.alpha),e.baseChartMessageColor)};f.msgStore[b]&&(b=f.msgStore[b]);a&&z&&z.config.hasRendered?(z._show(),this.showMessage(b,c,h)):(z._hide(),z.setChartMessage(b,{_chartMessageStyle:c}),
z.drawChartMessage());return b},showMessage:function(b,a,h){var c=this.apiInstance,f=c.config,z=c.components,e=c.graphics.messageGroup,d=z.chartMessage||(z.chartMessage={}),d=d.graphics||(d.graphics={}),B=z.paper,g=c.linkedItems.smartLabel,z=d.messageText,G=d.messageVeil,P=d.message,m=B.width,l=B.height;e||(c.graphics.messageGroup=e=B.group("messageGroup"));G||(G=d.messageVeil=B.rect(0,0,m,l,e).attr({fill:"rgba(0,0,0,0.2)",stroke:K}));G.show().toFront().attr("cursor",h?L:"default")[h?"click":"unclick"](c._hideChartMessage,
c);z||(z=d.messageText=B.text(m/2,l/2,ba,e));P&&P.hide();b=b||ba;g.setStyle(a);b=g.getSmartText(b,m-(f.marginRight||0)-(f.marginLeft||0),l-(f.marginTop||0)-(f.marginBotton||0));z.attr({"font-size":a.fontSize,"font-family":a.fontFamily,fill:a.color,text:b.text,ishot:!0,cursor:h?L:"default","line-height":14})[h?"click":"unclick"](c._hideChartMessage,c).show().toFront()},signature:function(){return"FusionCharts/3.4.0 (XT)"}};delete n.fill;delete n.stroke;g.core.options.resizeTrackingInterval=300;g.core.options.preventTrackResize=
!1;g.core.options.SVGDefinitionURL="relative";m.createChart=function(b,k,h,c,f,z,e){var d=b.jsVars,P,l=Qa[h||(h=b.chartType())],ta=b.apiInstance,q=d.hasNativeMessage;z=b.options;var p=b.args,n;k.offsetWidth&&k.offsetHeight&&(/^\s*absolute\s*$/i.test(g.core.options.SVGDefinitionURL)&&(D._url=(D._g&&D._g.win||A).location.href.replace(/#.*?$/,a)),n=function(a){var f={renderer:"javascript"},z=d.fcObj,P=z.width,xa=z.height,Fa=l&&l.eiMethods,p=d.overlayButton,n;k.jsVars=b.jsVars;q=d.hasNativeMessage;d.container=
k;d.hcObj=a;d.type=h;d.width=k.offsetWidth;d.height=k.offsetHeight;d.instanceAPI=ta;if(a.hasRendered){g.extend(k,G);if(Fa&&"string"!==typeof Fa)for(n in Fa)k[n]=Fa[n];d.overlayButtonActive&&p&&(p.innerHTML=ba,p.appendChild(J.createTextNode(d.overlayButtonMessage)),a.container.appendChild(p))}(/\%/g.test(P)||/\%/g.test(xa))&&k&&k.parentNode&&!g.core.options.preventTrackResize&&B(z,k);if(c&&(c({success:a.hasRendered,ref:k,id:b.id}),a.hasRendered)){m.raiseEvent("loaded",{type:h,renderer:"javascript"},
b,[b.id]);ta.config.hasRendered=!0;if(!0===b.disposed)return;q||(z.__state.firstRenderNotified=!0,setTimeout(function(){m.raiseEvent("rendered",{renderer:"javascript"},z,[z.id])},0))}a.hasRendered&&d.previousDrawCount<d.drawCount&&(f.width=d.width,f.height=d.height,f.drawCount=d.drawCount,f.displayingMessage=q,f.renderer=z.options.renderer,m.raiseEvent("drawcomplete",f,z,[z.id]),q||e||setTimeout(function(){z.__state&&!z.__state.firstRenderNotified&&m.raiseEvent("rendered",{renderer:"javascript"},
z,[z.id]);g.raiseEvent("renderComplete",f,z)},0))},ta&&ta.inited?(g.raiseEvent("internal.drawStart",{chartType:h,logicName:ta.name,logicBase:ta.base&&ta.base.name,defaultSeriesType:ta.defaultSeriesType},b),f=b.jsVars&&b.jsVars.themeObject&&b.jsVars.themeObject.getThemedJSONData()||b.getChartData(g.dataFormats.JSON,!0),P=f.data,ta.config&&ta.config.hasChartMessage&&ta._hideChartMessage(),ta.jsonData=P,e||m.raiseEvent("dataloaded",{},b,[b.id]),ta._removeWaitingJobs(),ta.graphics.dummyObj&&ta.graphics.dummyObj.stop(void 0,
!0,!0),ta.configure(),ta._feedAxesRawData(),ta._setCategories(),T(ta),ta.draw(),n({hasRendered:!0,container:k})):ta&&"base"===h?(ta.setChartMessage(f,b,k),ta.drawChartMessage()):(ta&&"base"===ta.name&&"base"!==h&&(ta.dispose(),ta=void 0),ta?ta.config&&ta.config.hasChartMessage&&ta._hideChartMessage():ta=b.apiInstance=l?new Qa(h):new Qa("base"),ta.chartInstance=b,ta.origRenderWidth=b.__state.renderedWidth,ta.origRenderHeight=b.__state.renderedHeight,"base"===h?(ta.setChartMessage(f,b,k),ta.drawChartMessage()):
void 0!==f?"string"===typeof f&&(ta.setChartMessage(f,b,k),ta.drawChartMessage(),q=d.hasNativeMessage=!0):!ta||!ta.init||ta&&"base"===ta.name?(b._chartMessageImageStyle={imageHAlign:I(p.typeNotSupportedMessageImageHAlign,z.baseChartMessageImageHAlign).toLowerCase(),imageVAlign:I(p.typeNotSupportedMessageImageVAlign,z.baseChartMessageImageVAlign).toLowerCase(),imageAlpha:C(p.typeNotSupportedMessageImageAlpha,z.baseChartMessageImageAlpha),imageScale:C(p.typeNotSupportedMessageImageScale,z.baseChartMessageImageScale)},
b._chartMessageStyle={color:p.typeNotSupportedMessageColor||z.baseChartMessageColor,fontFamily:p.typeNotSupportedMessageFont||z.baseChartMessageFont,fontSize:p.typeNotSupportedMessageFontSize||z.baseChartMessageFontSize},ta.setChartMessage(z.typeNotSupportedMessage,b,k),ta.drawChartMessage(),q=d.hasNativeMessage=!0):d.message?(ta.setChartMessage(d.message,b,k),ta.drawChartMessage(),q=d.hasNativeMessage=!0):d.loadError?(b._chartMessageImageStyle={imageHAlign:I(p.dataLoadErrorMessageImageHAlign,z.baseChartMessageImageHAlign).toLowerCase(),
imageVAlign:I(p.dataLoadErrorMessageImageVAlign,z.baseChartMessageImageVAlign).toLowerCase(),imageAlpha:C(p.dataLoadErrorMessageImageAlpha,z.baseChartMessageImageAlpha),imageScale:C(p.dataLoadErrorMessageImageScale,z.baseChartMessageImageScale)},b._chartMessageStyle={color:p.dataLoadErrorMessageColor||z.baseChartMessageColor,fontFamily:p.dataLoadErrorMessageFont||z.baseChartMessageFont,fontSize:p.dataLoadErrorMessageFontSize||z.baseChartMessageFontSize},ta.setChartMessage(z.dataLoadErrorMessage,b,
k),ta.drawChartMessage(),q=d.hasNativeMessage=!0):d.stallLoad?(b._chartMessageImageStyle={imageHAlign:I(p.dataLoadStartMessageImageHAlign,z.baseChartMessageImageHAlign).toLowerCase(),imageVAlign:I(p.dataLoadStartMessageImageVAlign,z.baseChartMessageImageVAlign).toLowerCase(),imageAlpha:C(p.dataLoadStartMessageImageAlpha,z.baseChartMessageImageAlpha),imageScale:C(p.dataLoadStartMessageImageScale,z.baseChartMessageImageScale)},b._chartMessageStyle={fontFamily:p.dataLoadStartMessageFont||z.baseChartMessageFont,
fontSize:p.dataLoadStartMessageFontSize||z.baseChartMessageFontSize,color:p.dataLoadStartMessageColor||z.baseChartMessageColor},ta.setChartMessage(z.dataLoadStartMessage,b,k),ta.drawChartMessage(),q=d.hasNativeMessage=!0,n({hasRendered:!0,container:k})):"zoomscatter"!==h||J.createElement("canvas").getContext?(g.raiseEvent("internal.drawStart",{chartType:h,logicName:ta.name,logicBase:ta.base&&ta.base.name,defaultSeriesType:ta.defaultSeriesType},b),f=b.jsVars&&b.jsVars.themeObject&&b.jsVars.themeObject.getThemedJSONData()||
b.getChartData(g.dataFormats.JSON,!0),P=f.data,f.error instanceof Error?(b._chartMessageImageStyle={imageHAlign:I(p.dataInvalidMessageImageHAlign,z.baseChartMessageImageHAlign).toLowerCase(),imageVAlign:I(p.dataInvalidMessageImageVAlign,z.baseChartMessageImageVAlign).toLowerCase(),imageAlpha:C(p.dataInvalidMessageImageAlpha,z.baseChartMessageImageAlpha),imageScale:C(p.dataInvalidMessageImageScale,z.baseChartMessageImageScale)},b._chartMessageStyle={fontFamily:p.dataInvalidMessageFont||z.baseChartMessageFont,
fontSize:p.dataInvalidMessageFontSize||z.baseChartMessageFontSize,color:p.dataInvalidMessageColor||z.baseChartMessageColor},ta.setChartMessage(z.dataInvalidMessage,b,k),ta.drawChartMessage(),q=d.hasNativeMessage=!0,b.__state.dataReady=!1,e||g.raiseEvent("dataInvalid",{error:f.error},d.fcObj,void 0,function(){m.raiseEvent("dataxmlinvalid",{},b,[b.id])})):(e||m.raiseEvent("dataloaded",{},b,[b.id]),!0!==ta.chartInstance.disposed&&ta.init(k,P,b,n))):(b._chartMessageImageStyle={imageHAlign:I(p.browserNotSupportedMessageImageHAlign,
z.baseChartMessageImageHAlign).toLowerCase(),imageVAlign:I(p.browserNotSupportedMessageImageVAlign,z.baseChartMessageImageVAlign).toLowerCase(),imageAlpha:C(p.browserNotSupportedMessageImageAlpha,z.baseChartMessageImageAlpha),imageScale:C(p.browserNotSupportedMessageImageScale,z.baseChartMessageImageScale)},b._chartMessageStyle={color:p.browserNotSupportedMessageColor||z.baseChartMessageColor,fontFamily:p.browserNotSupportedMessageFont||z.baseChartMessageFont,fontSize:p.browserNotSupportedMessageFontSize||
z.baseChartMessageFontSize},ta.setChartMessage(I(p.browserNotSupportedMessage,z.browserNotSupportedMessage),b,k),ta.drawChartMessage(),q=d.hasNativeMessage=!0)))};FusionCharts.register("component",["legend","legend",{customConfigFn:null,init:function(){this.graphics||(this.graphics={});this.item||(this.items=[]);this.components||(this.components={})},drawLegend:function(b,a){var h,c,f,z=this.chart,d=z.config;h=z.components;var B=h.paper,g=this.config,G=this.graphics||(this.graphics={}),P=z.graphics.legendGroup,
m;c=G.box;var p=G.caption,n,r=d.height-d.canvasBottom,w=d.canvasLeft,bb=d.canvasWidth,Ib=g.chartMarginLeft||0,Gb=g.chartMarginRight||0,v=g.chartMarginBottom||0,Q=d.actionBarHeight||0,R=g.actualCanvasMarginLeft||0,A=d.actualCanvasMarginBottom||0,H=d.actualCanvasMarginRight||0,K=g.alignLegendWithCanvas,F=d.height,I=d.canvasTop,W=g.width,Fb=g.height,U=d.borderWidth;f=g.borderRadius;var L=g.backgroundColor,X=g.borderColor,p=g.borderWidth||0,da=g.legendPos,J=.5*p,Db=.5*p+2,eb=C(g.padding,4),fa=.5*eb,O=
g.scroll.enabled,ma=g.drawn,z=z.get(l,N),T=z.dummyObj,ja=z.animObj,la=z.transposeAnimDuration,oa=z.animType,aa,S,V,pa,qa,z=h.legendScrollBar,sa=0,ua=0,sa=d.oriCanvasLeft,Ha=d.oriTopSpace,ua=d.oriBottomSpace,Ta=h.tb,ea=h.toolBoxAPI.Scroller;da===tb&&(g.align=tb,g.verticalAlign=t,n=g.layout="vertical");n?(void 0===b&&(b=d.width-Gb-H-W-U),void 0===a&&(sa=C(Ha,I),ua=C(ua,r),a=sa+.5*(F-ua-sa-Fb)+(g.y||0))):(void 0===b&&(n=d.width-(Ib+R+(Gb+H)),n=K?bb-W:n-W,w=K?C(sa,w):Ib+R,b=w+n/2),void 0===a&&(a=F-Fb-
A-v-Q));Fb=D.crispBound(b,a,W,Fb,p);b=Fb.x;a=Fb.y;W=Fb.width;Fb=Fb.height;ma?(g.xL&&(g.xL=Sa(ka(g.xL,Db),d.width-g.width-Db)),g.yL&&(g.yL=Sa(ka(g.yL,Db),d.height-g.height-Db)),P.show().animateWith(T,ja,{transform:["T",g.xL||b,g.yL||a]},la,oa)):P.show().transform(["T",b,a]);g.xPos=b;g.yPos=a;P.attr({cursor:g.legendAllowDrag?"move":ba});g.legendAllowDrag&&!g._dragEvtListenerBinded&&(P.drag(function(b,a){g.legendAllowDrag&&(pa=S+b,qa=V+a,pa=Sa(ka(pa,Db),d.width-g.width-Db),qa=Sa(ka(qa,Db),d.height-g.height-
Db),P.transform("t"+pa+","+qa),g.xPos=g.xL=pa,g.yPos=g.yL=qa)},function(){g.legendAllowDrag&&(S=g.xL||g.xPos,V=g.yL||g.yPos)}),g._dragEvtListenerBinded=!0);ma={x:0,y:0,width:W,height:Fb,r:f,stroke:X,"stroke-width":p,fill:L||"none",ishot:g.legendAllowDrag};c?(c.animateWith(T,ja,{x:0,y:0,width:W,height:Fb,r:f},la,oa),c.attr({stroke:X,"stroke-width":p,fill:L||"none"})):c=G.box=B.rect(ma,P);ma=g.drawn=!0;c.shadow(g&&g.shadow);m=G.itemGroup||(G.itemGroup=B.group("item",P));O?(c={isHorizontal:!1},f={scroll:function(b){m.transform(["T",
0,(aa-g.totalHeight)*b])},mousedown:function(b){b.preventDefault();b.stopPropagation()}},z=h.legendScrollBar,z||(h.legendScrollBar=z=(new ea(c,(Ta.idCount||0)+1,Ta.pId)).attachEventHandlers(f)),aa=Fb-eb,m.attr({"clip-rect":"0,"+fa+(","+W+","+aa)}),h=(aa+eb)/g.totalHeight,z.draw(W-10+fa-p,J,{height:Fb-p,scrollRatio:h,startPercent:0,color:g.legendScrollBgColor}),P.appendChild(z.node)):(z&&z.node&&z.node.hide(),m.attr({"clip-rect":null}),m.node&&m.node.removeAttribute("clip-path"));p=G.caption;if(g.title&&
g.title.text!==ba&&g.validLegendItem){switch(g.title.align){case M:O=eb;break;case q:O=W-eb-(O?10:0);break;default:O=.5*W}P.trackTooltip(!0);W=g.title.style;ma={text:g.title.text,title:g.title.originalText||ba,x:O,y:eb,fill:g.title.style.color,direction:g.textDirection,"line-height":W.lineHeight,"vertical-align":e,"text-anchor":g.title.align};eb={"font-weight":W.fontWeight,"font-style":W.fontStyle,"font-family":W.fontFamily,"font-size":W.fontSize};p?(p.show().attr(ma),p.css(eb)):p=G.caption=B.text(ma,
eb,m);p.tooltip(g.title.originalText)}else p&&p.hide();g.showLegend&&!1!==g.enabled?this._drawPointLegendItem():P.hide()},reverseLegendFn:function(){var b=this.components.items||[],a,h=[],c,f=0,z=this.config;for(a=b.length-1;0<=a;a--)b[a].configuration.mainDS?(c=a,h=h.concat(b.splice(c,f+1)),f=0):f++;h.length&&(z.orderReversed=!0,this.components.items=h.slice(0))},_manageLegendPosition:function(b){var a=this.config,h=this.chart.hasSubDataset,c=a.legendPos,f=this.components.items;a.reversed?h?!a.orderReversed&&
this.reverseLegendFn():f&&f.reverse():h&&a.orderReversed&&this.reverseLegendFn();return c===tb?this._placeLegendBlockRight(b):this._placeLegendBlockBottom(b)},_placeLegendBlockBottom:function(b){var k=this.chart,h=this.components,c=k.config,f=m.TESTSTR,z=c.width,e=c.height,d=c.canvasLeft,B=c.width-(c.canvasRight||0),g=k.linkedItems.smartLabel,G=this.config,P=G.chartMarginLeft,l=G.chartMarginRight,q=G.chartMarginTop,p=G.alignLegendWithCanvas,n=G.minimiseWrappingInLegend,t=G.legendScale,r=G.numColumns,
w=G.padding,v=2*b,Q=2*w,R=Q,A=G.title,H=A.padding,K=parseInt(G.itemStyle.fontSize,10)||10,D=h.items||[],F=D.length,h=G.oriSymbolPadding,I=G.textPadding,L=G.legendPadding,U=c.canvasMarginRight,Z=c.canvasMarginLeft,X=k.components.yAxis||[],k=X[0],X=X[1],k=k&&k.config||{},X=X&&X.config||{},J=k.nameMaxW,ca=X.nameMaxW,M=k.name&&k.name.style||{},N=X.name&&X.name.style||{},fa=k.axisName||ba,O=X.axisName||ba,ma=0,T=0,ja=0,la=0,oa=X=0,aa=0,S=0,V=[],pa=!1,qa=0,sa=0,ua,Ha,Ta=k=c.canvasWidth-c.canvasMarginLeft-
c.canvasMarginRight,ea;G.paddingBottom=c.height-c.canvasBottom;g.useEllipsesOnOverflow(c.useEllipsesWhenOverflow);g.setStyle(M);la=g.getOriSize(fa);g.setStyle(N);N=g.getOriSize(O);K+=1;0>=K&&(K=1);k-=Q;h*=t;K=Sa(K*t,k);0>=K&&(h=K=0);G.symbolWidth=K;G.textPadding=4;G.legendHeight=c=K+2*h;G.rowHeight=t=ka(parseInt(G.itemStyle.lineHeight,10)||12,c);w=I+h+w;g.setStyle(G.itemStyle);M=g.getOriSize(f).height;f=L+G.borderWidth/2+1;f=Sa(f,b-M-8);L=.05*t;if(la||N)ua=C(la.height,0)>C(N.height,0)?(ea=J)&&la.width:
(ea=ca)&&N.width;k=p?k:z-(ua+q>e-b?2*ea+l+P+U+Z:l+P+Z+U);G.initialItemY=0;G.initialItemX=0;if(G.showLegend&&0!==F){for(z=0;z<F;z+=1)ua=D[z],e=ua.config||(ua.config={}),q=ua.configuration,ua=e.name=Ja(q.label),ua===a||0===q.enabled||!1===q.enabled?e.enabled=0:(e.enabled=1,ja+=1,Ha=!0,ua=g.getOriSize(ua),ma=ka(ma,ua.width),oa=ka(oa,Sa(ua.height,v)),T+=ua.width);G.validLegendItem=Ha;la=T/ja;q=c+L+I+h+Q;T+=q*ja;G.x=(d-P-B+l)/2;G.x=!p&&T>Ta?0:G.x;if(Ha){la+=q;ma+=q;0<r&&ja<r&&(r=ja);T<=k&&(0>=r||r===ja)?
(r=ja,X=T/ja,pa=!0,oa>t&&(S=(oa-t)/2,t=oa)):0<r&&(X=k/r)>la?X>ma&&(X=ma):k>ma&&(n||1.5*la>ma)?(r=Na(k/ma),ja<r&&(r=ja),X=ma):k>=2*la?(r=Na(k/la),ja<r&&(r=ja),X=Na(k/r),X>ma&&(X=ma)):(r=1,X=k);G.itemWidth=X;d=Ga(X-q);0>d&&(h=d=I=0);G.symbolPadding=h;G.textPadding=I;G.width=X*r-L;A.oriText!==a&&(g.setStyle(A.style),ua=g.getSmartText(A.oriText,k,v),A.text=ua.text,ua.tooltext&&(A.originalText=ua.tooltext),A=ua.width+Q,G.width<A&&(G.initialItemX=(A-G.width)/2,G.width=A),G.initialItemY=aa=ua.height+H);
g.setStyle(G.itemStyle);for(z=0;z<F;z+=1)if(ua=D[z],e=ua.config,0!==e.enabled){0===d&&(V[sa]=!0,e.name=a,H=1,A=parseInt(sa/r,10),B=sa%r,e._legendX=B*X,e._legendY=A*t+Q,e._legendH=H*t,e._totalWidth=K+h);if(pa)ua=g.getOriSize(e.name),ua.height<t&&(e._legendTestY=(t-ua.height)/2),e._markerYGutter=S,e._legendX=qa,e._legendY=Q,e._legendH=t,e._totalWidth=K+w+ua.width,qa+=ua.width+q;else{ua=g.getSmartText(e.name,d,v);e.name=ua.text;for(ua.tooltext&&(e.originalText=ua.tooltext);!0===V[sa];)sa+=1;A=ua.height/
t;B=sa;for(H=0;H<A;H+=1,B+=r)V[B]=!0;ua.height<t&&(e._legendTestY=(t-ua.height)/2);A=parseInt(sa/r,10);B=sa%r;e._legendX=B*X;e._legendY=A*t+Q;e._legendH=H*t;e._totalWidth=K+w+ua.width}sa++}g=pa?1:Ga(V.length/r);G.height=G.totalHeight=R+(g*t+aa);G.rowHeight=t;G.legendNumColumns=r;G.height-2*h>b?(G.height=b,b=G.scroll||(G.scroll={}),b.enabled=!0,b.flatScrollBars=G.flatScrollBars,b.scrollBar3DLighting=G.scrollBar3DLighting,G.width=G.width+12>k?G.width:G.width+12):G.scroll.enabled=!1;f+=G.height;G.isActive=
!0;G.enabled=!0}else G.enabled=!1,f=G.width=0}else f=0,G.height=0,G.width=0;return{bottom:f,right:0}},_placeLegendBlockRight:function(b){var k=this.config,h=this.components,c=this.chart,f=c.config,z=c.linkedItems.smartLabel,e=c.components.canvas.config.canvasBorderThickness||0,d=k.textPadding,c=k.title.padding,B=k.oriSymbolPadding,g=k.legendPadding,G=k.legendScale,P=parseInt(k.itemStyle.fontSize,10),m=2*f.canvasHeight,l=0,q=2*k.padding,p=q,n={},t=!1,h=h.items||[],r=h.length,w,C,v,A=0;b-=q+g;P+=1;
0>=P&&(P=1);B*=G;P=Sa(P*G,b);0>=P&&(B=P=0);k.symbolPadding=B;k.symbolWidth=P;k.legendHeight=G=P+2*B;k.rowHeight=ka(parseInt(k.itemStyle.lineHeight,10)||12,G);e=g+k.borderWidth/2+e;C=b-G-g-d;0>C&&(C=0);z.useEllipsesOnOverflow(f.useEllipsesWhenOverflow);z.setStyle(k.itemStyle);if(k.showLegend&&0!==r){for(A=0;A<r;A+=1)w=h[A],f=w.config||(w.config={}),v=w.configuration,w=f.name=Ja(v.label),f._legendX=0,f._legendY=p,0===v.enabled||!1===v.enabled||w===a?f.enabled=0:(f.enabled=1,t=!0,0===C?(p+=f._legendH=
G,f.name=a,f._totalWidth=P+B):(w=z.getSmartText(w,C,m),f.name=w.text,w.tooltext&&(f.originalText=w.tooltext),w.height<G&&(f._legendTestY=(G-w.height)/2),f._totalWidth=P+B+d+w.width+g,p+=f._legendH=ka(w.height,G),l=ka(w.width,l)));(k.validLegendItem=t)?(k.itemWidth=l+G+g+d,k.width=k.itemWidth+q,k.title.oriText!==a&&(z.setStyle(k.title.style),w=z.getSmartText(k.title.oriText,b,m),k.title.text=w.text,w.tooltext&&(k.title.originalText=w.tooltext),z=w.width+q,k.width<z&&(k.initialItemX=(z-k.width)/2,k.width=
z),k.initialItemY=w.height+c,p+=k.initialItemY),k.height=k.totalHeight=p,e=Sa(k.width+e,b),n.right=e+g,k.isActive=!0,k.enabled=!0):(k.enabled=!1,k.width=0,n.right=0)}else n.right=0,k.height=0,k.width=0;return n},postSpaceManager:function(){var b=this.config,a=this.chart.config.canvasHeight;b.legendPos===tb&&(b.height>a?(b.height=a,b.scroll.enabled=!0,b.scroll.flatScrollBars=b.flatScrollBars,b.scroll.scrollBar3DLighting=b.scrollBar3DLighting,b.width+=(b.scroll.scrollBarWidth=10)+(b.scroll.scrollBarPadding=
2)):b.scroll.enabled=!1)},configure:function(){var b=this.chart,k=this.config,h=b.config,c=h.style,f=b.jsonData.chart||b.jsonData.map,e=b.components.colorManager,d=b.is3D?z.chart3D:z.chart2D,B,g,G=C(f.useroundedges,0);B=c.outCancolor;g=C(f.legendpadding,7);var P=I(f.legenditemfont,c.outCanfontFamily),m=C(f.legendiconscale,1),l=Xa(f.legenditemfontsize,c.fontSize),q=I(f.legenditemfontcolor,B).replace(/^#?([a-f0-9]+)/ig,"#$1"),p=I(f.legendiconbgcolor),n=I(f.legendiconbordercolor),t=I(f.legendiconbgalpha,
f.legendiconalpha,100),r=I(f.legendiconborderalpha,f.legendiconalpha,100),w=C(f.legendiconsides,4),v=C(f.legendiconborderthickness),Q=C(f.legendiconstartangle,45),R=kb(I(f.legenditemhoverfontcolor,q)),A=ob[C(f.legenditemfontbold,0)]||ba,c=Xa(f.legendcaptionfontsize,c.fontSize)+"px";k.isActive=!1;k.chartMarginTop=h.origMarginTop;k.chartMarginRight=h.origMarginRight;k.chartMarginBottom=h.origMarginBottom;k.chartMarginLeft=h.origMarginLeft;k.showLegend=C(f.showlegend,!b.dontShowLegendByDefault,1);l+=
"px";k.legendPos=I(f.legendposition,b.legendposition,H).toLowerCase();k.numColumns=C(f.legendnumcolumns,0);k.xL=k.yL=0;if(0>=m||5<m)m=1;k.drawCustomLegendIcon=C(f.drawcustomlegendicon,0);k.customLegendConfig={bgColor:p,borderColor:n,bgAlpha:t,borderAlpha:r,borderThickness:v,startAngle:Q,sides:w};k.legendScale=m;k.legendPadding=g;k.oriSymbolPadding=3;k.textPadding=4;k.alignLegendWithCanvas=C(f.alignlegendwithcanvas,1);k.itemStyle={color:$a(q),fontFamily:P,fontSize:l,fontWeight:A};cb(k.itemStyle);k.itemHiddenStyle=
{fontFamily:P,fontSize:l,color:$a(I(f.legenditemhiddencolor,"cccccc").replace(/^#?([a-f0-9]+)/ig,"#$1")),fontWeight:A};cb(k.itemHiddenStyle);k.title.style={fontFamily:I(f.legendcaptionfont,P),fontSize:c,color:I(f.legendcaptionfontcolor,B).replace(/^#?([a-f0-9]+)/ig,"#$1"),fontWeight:ob[C(f.legendcaptionfontbold,1)]||ba};k.title.align=Ra[f.legendcaptionalignment&&f.legendcaptionalignment.toLowerCase()||Ra.center]||Ra.center;k.itemHoverStyle={color:$a(R.replace(/^#?([a-f0-9]+)/ig,"#$1"))};k.title.style["text-anchor"]=
k.title.align;k.padding=4;h=I(f.legendbordercolor,e.getColor(d.legendBorderColor));B=C(f.legendborderalpha,100);g=C(f.legendbgalpha,100);k.backgroundColor=$a(I(f.legendbgcolor,e.getColor(d.legendBgColor)),g);k.borderColor=$a(h,B);k.borderWidth=C(f.legendborderthickness,!G||f.legendbordercolor?1:0);k.borderRadius=C(G,0);k.shadow=!!C(f.legendshadow,1);k.symbol3DLighting=!!C(f.use3dlighting,f.useplotgradientcolor,1);k.shadow&&(k.shadow={enabled:k.shadow,opacity:ka(B,g)/100});k.reversed=!!C(f.reverselegend,
0);k.style={padding:4};k.lineWidth=C(f.linethickness,2);(k.interactiveLegend=!1!==b.hasInteractiveLegend&&!!C(f.interactivelegend,1))?(k.interactiveLegend=!0,k.symbolStyle={_cursor:"hand",cursor:L}):(k.interactiveLegend=!1,k.itemStyle.cursor="default",k.itemHoverStyle.cursor="inherit");k.borderRadius=C(f.legendborderradius,G?3:0);k.legendAllowDrag=!!C(f.legendallowdrag,0);k.title.text=k.title.oriText=Ja(za(f.legendcaption,a));k.legendScrollBgColor=kb(I(f.legendscrollbgcolor,f.scrollcolor,e.getColor("altHGridColor")));
k.legendScrollBarColor=I(f.legendscrollbarcolor,h);k.legendScrollBtnColor=I(f.legendscrollbtncolor,h);k.minimiseWrappingInLegend=C(f.minimisewrappinginlegend,0);k.flatScrollBars=C(f.flatscrollbars,0);k.scrollBar3DLighting=C(f.scrollbar3dlighting,1);k.orderReversed=!1},_drawPointLegendItem:function(){var b=this,a=b.chart,h=a.hasSubDataset,c=a.config,f=a.get(l,N),z=f.transposeAnimDuration,d=f.animType,B=f.dummyObj,f=f.animObj,G=a.components.dataset,P=a.components.paper,q=b.config,p=q.reversed,n=b.components.items||
[],t=q.legendHeight,r=q.symbolPadding,w=q.symbolWidth,bb=q.interactiveLegend,Ib=q.textPadding||2,Gb=C(q.padding,4),c=c.textDirection,v=q.itemHiddenStyle,Q=q.itemStyle,A=q.itemHoverStyle,H=q.lineWidth,K=Q.color,D=v&&v.color||"#CCCCCC",v=b.graphics,F=v.itemGroup,ha=q.drawCustomLegendIcon,W=q.customLegendConfig,Fb,U,Z,X,J,ca,Db,eb,fa,O,T,aa,ja,la,oa,S,pa,ba,Aa,qa,sa,ua,Ha,Ta,ea,ga,ia,ka,na,Ga=m.hashify,Ja=function(b){var f=this.data("legendItem"),h=f.configuration.datasetObj||f.dataset,h=h.getEventArgs?
h.getEventArgs(f):{};b=Oa(a.chartInstance,b);h.chartX=b.chartX;h.chartY=b.chartY;h.pageX=b.pageX;h.pageY=b.pageY;h.legendItemIndex=f.index;h.legendItemId=f.legendItemId;h.preventDefaults=function(){};g.raiseEvent("LegendItemClicked",h,a.chartInstance)},za=function(b){var f=this.data("legendItem")||{},h=f.configuration.datasetObj||f.dataset,c=this.data("interactive"),h=h.getEventArgs?h.getEventArgs(f):{};b=Oa(a.chartInstance,b);var u=this.data("itemHoverStyle"),E=f.graphics&&f.graphics.legendItemText;
!1!==f.dataset.visible&&c&&E&&E.attr({fill:u.color});h.chartX=b.chartX;h.chartY=b.chartY;h.pageX=b.pageX;h.pageY=b.pageY;h.legendItemIndex=f.index;h.legendItemId=f.legendItemId;g.raiseEvent("LegendItemRollover",h,a.chartInstance)},Ea=function(b){var f=this.data("legendItem")||{},h=f.configuration.datasetObj||f.dataset,c=this.data("interactive"),h=h.getEventArgs?h.getEventArgs(f):{};b=Oa(a.chartInstance,b);var u=!1!==f.dataset.visible,E=this.data("itemStyle"),z=f.graphics&&f.graphics.legendItemText;
u&&c&&z&&z.attr({fill:E.color});h.chartX=b.chartX;h.chartY=b.chartY;h.pageX=b.pageX;h.pageY=b.pageY;h.legendItemIndex=f.index;h.legendItemId=f.legendItemId;g.raiseEvent("LegendItemRollout",h,a.chartInstance)},Ka=function(a){var f=this.data("legendItem"),k=f.dataset;this.data("interactive")&&f.legendClickFN.call(b,k,f,G);Ja.call(this,a)},ya=function(){ba=.5*w;pa=eb+r+ba;X=fa+(oa._markerYGutter||0)+r+ba;Na&&(ba*=.6);ka=ra(ua.anchorSide);qa=ua.symbol=ka&&ka.split("_")||[];Aa="spoke"===qa[0]?1:0;Da={polypath:[qa[1]||
2,pa,X,ba,ua.startAngle,ua.spoke||Aa]};Ia={cursor:Q.cursor||L,stroke:Z?Ha:D,fill:Z?Ta:D,"stroke-width":sa,ishot:bb}},La,Ia,Ma={},Na,Da,Ua;Fb=q.initialItemX||0;U=q.initialItemY||0;if(!1!==q.enabled&&q.showLegend){F.css(Q);T=0;for(aa=n.length;T<aa;T+=1)q=n[T],q.index=T,ua=q.configuration,ca=ua.type,oa=q.config=q.config||(q.config={}),v=q.graphics||(q.graphics={}),ja=q.dataset,ja.graphics&&(ja.graphics.legendGraphics=v),Ha=oa.strokeColor=ua.strokeColor||"000000",Ta=oa.fillColor=ua.fillColor||"000000",
oa.interactiveLegend=ua.interactiveLegend,oa.legendBackgroundColor=ua.legendBackgroundColor?Pa({color:ua.legendBackgroundColor,alpha:20}):Pa(hb),ea=ua.anchorSide,ga=oa.drawLine=ua.drawLine,H=ua.lineWidth||H,ia=ua.lineColor||Ha,eb=Fb+oa._legendX+Gb,fa=U+oa._legendY-Gb,sa=oa.strokeWidth=ua.strokeWidth||.5,O=oa._legendH,Z=!1!==ja.visible,ja=v.legendItemBackground,J=v.legendItemText,la=v.legendItemLine,S=v.legendItemSymbol,bb=I(oa.interactiveLegend,bb),!bb&&(Q.cursor="default"),0!==oa.enabled?(na=eb+
t+Ib-2,Ua=fa+(oa._legendTestY||0),Db={text:oa.name,fill:Z?K:D,"text-anchor":M,"vertical-align":e,cursor:Q.cursor||L,direction:c,"line-height":Q.lineHeight},La=Da=null,oa.textAttr=Db,J?(J.show().animateWith(B,f,{x:na,y:Ua},z,d),J.attr(Db)):(Db.x=na,Db.y=Ua,J=v.legendItemText=P.text(Db,F).data("legendItem",oa)),Na=!1,ha&&!1!==ua.customLegendIcon?(na=W.borderColor,J=I(W.borderAlpha),ia=W.bgColor,Db=I(W.bgAlpha,"100"),ea||"line"===ca||ga||"spline"===ca?(ca=Ga(ua.rawStrokeColor),ua.rawFillColor=Ga(ua.rawFillColor),
Ta=I(ia,ua.rawFillColor,oa.color),/^#/.test(Ta)&&(Ta=$a(Ta,Db)),ia=I(na,ca,oa.strokeColor),ia=$a(ia,J),oa.anchorSide=W.sides):(ca=I(ua.rawFillColor,oa.fillColor),Ta=I(ia,ca),Ta=$a(Ta,Db),W.borderColor?ia=$a(W.borderColor,J):(/rgb/.test(ca)&&(ca=pb(ca)),ia=db(ca,60).replace(V,va),ia=$a(ia,J))),oa.fillColor=Ta,oa.strokeColor=ia,ba=.5*w,pa=eb+r+ba,X=fa+(oa._markerYGutter||0)+r+ba,qa=(ka=ra(W.sides))&&ra(W.sides).split("_")||[],Aa="spoke"===qa[0]?1:0,Da={polypath:[qa[1]||2,pa,X,ba,W.startAngle,Aa]},Ia=
{cursor:Q.cursor||L,stroke:Z?ia:D,fill:Z?Ta:D,"stroke-width":C(W.borderThickness,1),ishot:bb}):"line"===ca||ga?(X=fa+(oa._markerYGutter||0)+r+.5*w,La={path:["M",eb+r,X,"L",eb+r+w,X]},Na=!0,Ma={"stroke-width":H,stroke:Z?ia:D,cursor:Q.cursor||L,ishot:bb},ea&&ya()):ea?ya():"line"!==ca&&(S=v.legendItemSymbol,ca=b._getSymbolPath(eb+r,fa+(oa._markerYGutter||0)+r,w,w,ca),Da={path:ca.path},Ia={"stroke-width":.5,stroke:Z?Ha:D,fill:Z?Ta:D,cursor:Q.cursor||L,ishot:bb}),La&&Na?(oa.lineAttr=Ma,la||(la=v.legendItemLine=
P.path(F),la.attr(La)),la.show().animateWith(B,f,La,z,d),la.attr(Ma).data("legendItem",oa)):la&&la.hide(),Da?(oa.symbolAttr=Ia,S||(S=v.legendItemSymbol=P.polypath(F),S.attr(Da)),S.show().animateWith(B,f,Da,z,d),S.attr(Ia),S.data("legendItem",oa)):S&&S.hide(),O={x:eb,y:fa,width:oa._totalWidth,height:O},la={r:0,fill:oa.legendBackgroundColor,"stroke-width":1,stroke:"none",cursor:Q.cursor||L,ishot:bb},ja||(ja=v.legendItemBackground=P.rect(F),ja.attr(O).mouseover(za).mouseout(Ea).click(Ka)),ja.show().animateWith(B,
f,O,z,d),ja.attr(la),ja.data("legendItem",q).data("interactive",bb).data("itemHoverStyle",A).data("itemStyle",Q)):(J&&J.hide(),ja&&ja.hide(),S&&S.hide(),la&&la.hide());!h&&p&&n.reverse()}},_getSymbolPath:function(b,a,h,c,f){var z=["M"],e,d,B;switch(f){case "column":case "dragcolumn":case "column3d":e=.25*h;f=.5*e;d=.7*c;B=.4*c;z=z.concat([b,a+c,"l",0,-d,e,0,0,d,"z","m",e+f,0,"l",0,-c,e,0,0,c,"z","m",e+f,0,"l",0,-B,e,0,0,B,"z"]);break;case "bar":case "bar3d":e=.3*h;f=.6*h;d=c/4;B=d/2;z=z.concat([b,
a,"L",b+f,a,b+f,a+d,b,a+d,"Z","M",b,a+d+B,"L",b+h,a+d+B,b+h,a+d+B+d,b,a+2*d+B,"Z","M",b,a+2*(d+B),"L",b+e,a+2*(d+B),b+e,a+c,b,a+c,"Z"]);break;case "area":case "area3d":case "areaspline":case "dragarea":d=.6*c;B=.2*c;f=.8*c;z=z.concat([b,a+f,"L",b,a+d,b+.3*h,a+B,b+.6*h,a+d,b+h,a+B,b+h,a+f,"Z"]);break;case "pie2d":case "pie3d":case "doughnut2d":case "doughnut3d":e=.5*h;f=.9*e;h=b+e+1;c=a+e-1;b=b+e-1;a=a+e+1;z=z.concat(["M",h,c,"L",h,c-f+1,"A",f-1,f-1,0,0,1,h+f-1,c,"Z","M",b,a,"L",b,a-f,"A",f,f,0,1,
0,b+f,a,"Z"]);break;case "boxandwhisker2d":z=z.concat([b,a,"L",b+h,a,b+h,a+c,b,a+c,"Z"]);break;default:z=z.concat([b,a,"L",b+h,a,b+h,a+c,b,a+c,"Z"])}return{path:z}},emptyItems:function(b,a){var h=this.components,c=h.items||(h.items=[]),f,z,h=void 0!==a?a:c.length,e=c.splice(b,h);b=0;for(h=e.length;b<h;b+=1)for(f in c=(e[b]||(e[b]={})).graphics,c)(z=c[f])&&z.remove&&"function"===typeof z.remove&&z.remove()},removeItem:function(b){var a=this.getItems()||[],h,c,f,z=a.length;for(h=0;h<z;h++)if(c=a[h],
f=c.legendItemId,b===f){ab.call(c);a.splice(h,1);break}},addItems:function(b,a,h){var c,f=this.components;c=this.lastItemId;var z=I(b.legendItemId,h.legendItemId),f=f.items||(f.items=[]);void 0!==z?(this.configureItems(z,{legendClickFN:a,configuration:h,dataset:b}),c=z):(void 0===c?this.lastItemId=c="FCLEGEND_0":(c=(c=c.split("_"))&&c[1],this.lastItemId=c="FCLEGEND_"+ ++c),f.push({legendItemId:c,dataset:b,legendClickFN:a,configuration:h||{}}));return c},configureItems:function(b,a){var h=this.components.items,
c,f,z=h.length,e,d;for(f=0;f<z&&(d=h[f],!d.dataset||(e=I(d.dataset.legendItemId,d.legendItemId),e!==b));f++);for(c in d)if(c in a)switch(c){case "configuration":this.mergeConf(a[c],d[c]);break;default:d[c]=a[c]}},mergeConf:function(b,a){var h,c;for(h in b)c=b[h],void 0!==c&&null!==c&&(a[h]=c)},getItems:function(){return this.components.items},hide:function(){this.chart.graphics.legendGroup.hide()}},void 0,{enabled:!0,symbolWidth:12,borderRadius:1,backgroundColor:"#FFFFFF",initialItemX:0,title:{text:ba,
x:0,y:0,padding:2},scroll:{},itemStyle:{}}]);FusionCharts.register("component",["toolbox","horizontaltoolbox",{init:function(b){this.config={type:b};this.components={};this.graphics={};this._configure()},_getPosition:function(){var b=this.config.type,a=b.frame,h=b.orientation,c=b.placement,f={chart:{outer:{left:0,right:0,top:0,bottom:0},inner:{left:0,right:0,top:0,bottom:0}},canvas:{outer:{left:0,right:0,top:0,bottom:0},inner:{left:0,right:0,top:0,bottom:0}}};!b&&(b={});return a&&c&&h?f[a][c][h]:
b},_configure:function(){var b,k,h=this.config,c=this.chart,f=c.jsonData.chart,z=c.config,c=z.width,z=z.height;h.scale=C(f.toolbarbuttonscale,1.15);h.width=C(f.toolbarbuttonwidth,15);h.height=C(f.toolbarbuttonheight,15);h.radius=C(f.toolbarbuttonradius,2);h.spacing=C(f.toolbarbuttonspacing,5);h.fill=$a(I(f.toolbarbuttoncolor,"ffffff"));h.labelFill=$a(I(f.toolbarlabelcolor,"cccccc"));h.symbolFill=$a(I(f.toolbarsymbolcolor,"ffffff"));h.hoverFill=$a(I(f.toolbarbuttonhovercolor,"ffffff"));h.stroke=$a(I(f.toolbarbuttonbordercolor,
"bbbbbb"));h.symbolStroke=$a(I(f.toolbarsymbolbordercolor,"9a9a9a"));h.strokeWidth=C(f.toolbarbuttonborderthickness,1);h.symbolStrokeWidth=C(f.toolbarsymbolborderthickness,1);b=h.symbolPadding=C(f.toolbarsymbolpadding,5);h.symbolHPadding=C(f.toolbarsymbolhpadding,b);h.symbolVPadding=C(f.toolbarsymbolvpadding,b);k=h.position=I(f.toolbarposition,"tr").toLowerCase();switch(k){case "tr":case "rt":case "top right":case "right top":k="tr";break;case "br":case "rb":case "bottom right":case "right bottom":k=
"br";break;case "tl":case "lt":case "top left":case "left top":k="tl";break;case "bl":case "lb":case "bottom left":case "left bottom":k="bl";break;default:k="tr"}b=h.hAlign=(a+f.toolbarhalign).toLowerCase()===gb?"l":k.charAt(1);k=h.vAlign=(a+f.toolbarvalign).toLowerCase()===H?"b":k.charAt(0);h.hDirection=C(f.toolbarhdirection,"r"===b?-1:1);h.vDirection=C(f.toolbarvdirection,"b"===k?-1:1);h.vMargin=C(f.toolbarvmargin,6);h.hMargin=C(f.toolbarhmargin,10);h.x=C(f.toolbarx,"l"===b?0:c);h.y=C(f.toolbary,
"t"===k?0:z)},_manageToolBoxPosition:function(b,a){var h,c,f=0,z=this.components;for(h in z)z.hasOwnProperty(h)&&(c=z[h],c=c._spaceOccupied(),f=ka(f,c.height));f>a&&this._postSpaceManager();return{top:0,bottom:f,left:0,right:0}},addItem:function(b){var a,h,c,f=this.components;for(a=0;a<b.length;a+=1)c=b[a],h=f[c.name]=new (FusionCharts.register("component",["toolButton","button"])),h.init(this,c),h.chart=this.chart},draw:function(){var b,a,h=this.components,c=this.x,f=this.y;for(b in h)h.hasOwnProperty(b)&&
(a=h[b],a.draw(c,f))},_postSpaceManager:function(){}}]);FusionCharts.register("component",["toolBox","verticalToolBox",{},"horizontaltoolbox"]);FusionCharts.register("component",["toolButton","button",{init:function(){this.config={};this.components={};this.graphics={};this._configure.apply(this,arguments)},_configure:function(b,a){var h=b.config,c=this.config;c.type=a.type;c.scale=C(a.scale,h.scale);c.width=C(a.width,h.width);c.height=C(a.height,h.height);c.radius=C(a.radius,h.radius);c.spacing=C(a.spacing,
h.spacing);c.fill=$a(I(a.fill,h.fill));h.x=C(a.x,h.x);h.y=C(a.y,h.y)},draw:function(){this["_draw"+this.config.type]()},_drawScroller:function(){var b=this.chart,a=b.components,h=b.config,c=b.jsonData.chart,f=a.paper,z=b.graphics,e=a.xAxis["0"]||{},d=e.config||{},B=d.rawAttr.axisLineThickness,a=h.scrollOptions||{},G=h.canvasTop,P=h.canvasLeft,l=h.canvasWidth,q=h.canvasHeight,p=h.canvasBorderWidth,d=p||(d.showLine?B:0),n=p||B,B=p||B,c=h.useRoundEdges||(h.useRoundEdges=C(c.useroundedges,0)),t,r,w,v,
A,Q,R,H,K,F,I,ha=z.scroller,p=z.datasetGroup,W;a.enabled&&(W=z.scroll=z.scroll||f.group("scroll").insertAfter(p),p=a.scrollRatio,v=C(a.startPercent),A=a.viewPortMax,Q=a.viewPortMin,r=a.vxLength,Ga(r),R=a.showButtons,H=a.height,K=a.padding,F=a.color,I=a.flatScrollBars,r=a.windowedCanvasWidth=e.getAxisPosition(r),t=a.fullCanvasWidth=e.getAxisPosition(A-Q)-r,w=ya(v*t),ha||(ha=z.scroller=f.scroller(P-n,G+q+d+K-!!d,l+n+B,H,!0,{showButtons:R,displayStyleFlat:I,scrollRatio:p,scrollPosition:v},W).data("fullCanvasWidth",
t).data("windowedCanvasWidth",r).attr({"scroll-display-style":I,fill:F,r:c&&2||0}).scroll(function(a){var f=h.viewPortConfig;w=-ya(a*t);f.x=-w/f.scaleX;m.chartAPI.mscolumn2d._drawDataset.call(b);e.draw()})),function(){var a;D.eve.on("raphael.scroll.start."+ha.node.id,function(f){a=f;g.raiseEvent("scrollstart",{scrollPosition:f},b.chartInstance)});D.eve.on("raphael.scroll.end."+ha.node.id,function(f){g.raiseEvent("scrollend",{prevScrollPosition:a,scrollPosition:f},b.chartInstance)})}());this._finalizeScrollPlots();
return a.enabled},_finalizeScrollPlots:function(){var b=this.chart,a=b.config,h=b.container,c=b.graphics,f=c.scroller,z=c.datasetGroup,e=c.datalabelsGroup,d=c.trackerGroup,B,G={},P,l,p=b.components.xAxis["0"]||{};P=a.scrollOptions||{};var n=C(P.startPercent),t=P.fullCanvasWidth,r,w=a.animation,v=P.startPercent,a=[ka(0,a.canvasLeft),ka(0,a.canvasTop),ka(1,a.canvasWidth),ka(1,a.canvasHeight)];P.enabled&&(z.attr({"clip-rect":a}),e.attr({"clip-rect":a}),d.attr({"clip-rect":a}),P=function(a){var k=c.canvas,
h=B.left,z=B.top,e={pageX:0,pageY:0},d=a.state,e=ib&&m.getTouchEvent(a)||e;a=a.originalEvent;h=(a.clientX||a.pageX||e.pageX)-h;z=(a.clientY||a.pageY||e.pageY)-z;switch(d){case M:l=k.isPointInside(h,z);G.ox=l&&h||null;if(!l)return!1;G.prevScrollPosition=f.attrs["scroll-position"];g.raiseEvent("scrollstart",{scrollPosition:G.prevScrollPosition},b.logic.chartInstance);break;case q:g.raiseEvent("scrollend",{prevScrollPosition:G.prevScrollPosition,scrollPosition:G.scrollPosition},b.logic.chartInstance);
l=!1;G={};break;default:l&&(k=h-G.ox,G.ox=h,G.scrollPosition=f.attrs["scroll-position"]-k/t,f.attr({"scroll-position":G.scrollPosition}))}},ib&&(B=Ma(h),h&&(Da(h,"pointerdrag",P),Wa(h,"pointerdrag",P))),0<n&&(r=-ya(n*t),z&&z.transform(["T",r,0]),d&&d.transform(["T",r,0]),p.setOffset&&p.setOffset(r),w&&v?b.animationCompleteQueue.push({fn:function(){e&&e.transform(["T",r,0])},scope:b}):e&&e.transform(["T",r,0])))},_spaceOccupied:function(){var b=this.config;return{x:b.x,y:b.y,width:b.width,height:b.height}}}]);
Qa("base",{creditLabel:b,setChartMessage:function(b,a,h){var z=this.components||(this.components={}),f=this.chartInstance,e=f.options,d=f.args,B=this.config||(this.config={}),g=this.linkedItems&&this.linkedItems.smartLabel||f.jsVars.smartLabel,G=m.getImageURL(void 0!==b?b:e.dataEmptyMessage),P,l;h&&!this.linkedItems?this.linkedItems={container:h}:h=this.linkedItems.container;P=B.prevWidth=h.offsetWidth;l=B.prevHeight=h.offsetHeight;b=B.height=Number(l);f=B.width=Number(P);B.hasChartMessage=!0;z.paper?
z.paper.setSize(P,l):(h=z.paper=new D(h,P,l),h.setConfig("stroke-linecap",c));G.image?(b=G.string,a=a?{imageHAlign:I(a._chartMessageImageStyle.imageHAlign,e.baseChartMessageImageHAlign).toLowerCase(),imageVAlign:I(a._chartMessageImageStyle.imageVAlign,e.baseChartMessageImageVAlign).toLowerCase(),imageAlpha:C(a._chartMessageImageStyle.imageAlpha,e.baseChartMessageImageAlpha),imageScale:C(a._chartMessageImageStyle.imageScale,e.baseChartMessageImageScale)}:{imageHAlign:I(d.dataEmptyMessageImageHAlign,
e.baseChartMessageImageHAlign).toLowerCase(),imageVAlign:I(d.dataEmptyMessageImageVAlign,e.baseChartMessageImageVAlign).toLowerCase(),imageAlpha:C(d.dataEmptyMessageImageAlpha,e.baseChartMessageImageAlpha),imageScale:C(d.dataEmptyMessageImageScale,e.baseChartMessageImageScale)},B.chartMessageType="image"):(a=a?{"font-family":a._chartMessageStyle.fontFamily||e.baseChartMessageFont,"font-size":a._chartMessageStyle.fontSize||e.baseChartMessageFontSize,fill:a._chartMessageStyle.color||e.baseChartMessageColor}:
{"font-family":d.dataEmptyMessageFont||e.baseChartMessageFont,"font-size":d.dataEmptyMessageFontSize||e.baseChartMessageFontSize,fill:d.dataEmptyMessageColor||e.baseChartMessageColor},g.setStyle(a),e=g.getSmartText(Ja(G.string),f,b),b={text:e.text,x:f/2,y:b/2},B.chartMessageType="text");B.chartMessageAttr=b;B.chartMessageStyle=a},_hideChartMessage:function(){var b=this.config,a=this.components.chartMessage.graphics,h;"image"===b.chartMessageType&&!a.backgroundImage&&a.backgroundElement&&(b.stopImageDraw=
!0);b&&(b.hasChartMessage=!1);for(h in a)a[h].hide?a[h].hide():a[h][0]&&a[h][0].hide()},drawChartMessage:function(){var b=this.config,a=this.components,h=a.paper,c,a=a.chartMessage||(a.chartMessage={}),a=a.graphics||(a.graphics={});c=this.graphics||(this.graphics={});var f=na(b.chartMessageAttr,b.chartMessageStyle);c=c.messageGroup||(c.messageGroup=h.group("messageGroup"));this._hideChartMessage();b.hasChartMessage=!0;"image"===b.chartMessageType?this._drawBackground(b.chartMessageAttr,b.chartMessageStyle):
a.message||"text"!==b.chartMessageType?(a.message=a.message.attr(f),a.message.show()):a.message=h.text(f,c);this._drawCreditLabel()},dispose:function(){var b=this.components,b=b&&b.paper,a=this.linkedItems&&this.linkedItems.eventListeners,h=a&&a.length;for(this._clearTimers&&this._clearTimers();h--;)a[h].unlisten();this._removeWaitingJobs();b&&(b.clear(),b.remove());this.chartInstance&&delete this.chartInstance.apiInstance;ab.call(this)},_removeWaitingJobs:function(){var b=this.jobList,a,h,c,f;for(f in b)for(c=
b[f],h=c.length,a=0;a<h;a++)P.removeJob(c[a])},_drawBackground:function(b,k){var h=this,c=h.components,f=h.graphics,z=h.jsonData&&h.jsonData.chart||{},d=c.paper,B=b?c.chartMessage:c.background,G=B.graphics,c=G.backgroundElement,P=G.borderElement,B=B.config||{},q=h.config,p=q.width,n=q.height,Ya,r,w,bb,v,Gb,A,Q=h.get&&h.get(l,N)||{},R=Q.animType,D=Q.animObj,ub=Q.dummyObj,F=Q.duration,Ba,ha,W=b?f.messageGroup:f.backgroundGroup,L=B.borderWidth||0,f=B.borderRadius,Q=B.borderDashStyle,U=B.borderColor,
J=B.bgSWF=I(b,z.bgimage,z.bgswf),X=B.bgSWFAlpha=C(k&&k.imageAlpha,z.bgimagealpha,z.bgswfalpha,100),da=B.imgClipRect=L+","+L+","+(p-2*L)+","+(n-2*L),ca=I(z.bgimagedisplaymode,K).toLowerCase(),M=(k&&ia(k.imageVAlign)||ia(z.bgimagevalign,a)).toLowerCase(),O=(k&&k.imageHAlign||z.bgimagehalign||a).toLowerCase(),fa=B.bgImageScale=C(k&&k.imageScale,z.bgimagescale,100),z=B.containerBackgroundColor=m.getContainerBackgroundColor(h);d.canvas.style.backgroundColor=z;"tile"==ca||"fill"==ca||"fit"==ca?(M!=e&&M!=
t&&M!=H&&(M=t),O!=gb&&O!=t&&O!=tb&&(O=t)):(M!=e&&M!=t&&M!=H&&(M=e),O!=gb&&O!=t&&O!=tb&&(O=gb));B.bgSWFAlpha=X;B.bgImageVAlign=M;B.bgImageHAlign=O;B.backgroundColor=B=!b&&h._getBackgroundCosmetics();z={x:L,y:L,width:p-2*L,height:n-2*L,stroke:"none",fill:Pa(B)};c?(c.animateWith(ub,D,{x:L,y:L,width:p-2*L,height:n-2*L},F,R),c.attr({stroke:"none",fill:Pa(B)})):G.backgroundElement=d.rect(z,W);z={x:L/2,y:L/2,width:p-L,height:n-L,stroke:U,"stroke-width":L,"stroke-dasharray":Q,fill:"none",r:f||0};P||b?b||
(P.animateWith(ub,D,{x:L/2,y:L/2,width:p-L,height:n-L,r:f||0},F,R),P.attr({stroke:U,"stroke-width":L,"stroke-dasharray":Q,fill:"none"})):G.borderElement=d.rect(z,W);if(J)Ya=new nb,w=r=1,Ya.onload=function(){if(q.stopImageDraw)q.stopImageDraw=!1;else{!G.backgroundImage&&(G.backgroundImage=[]);if(G.backgroundImage)for(ha=0,Ba=G.backgroundImage.length;ha<Ba;ha++)G.backgroundImage[ha].hide();bb=La(ca,M,O,fa,L,p,n,Ya);bb["clip-rect"]=da;if(bb.tileInfo)for(r=bb.tileInfo.xCount,w=Gb=bb.tileInfo.yCount,v=
bb.y,delete bb.tileInfo,A=0;r&&bb.width&&bb.height;)--Gb,G.backgroundImage[A]||(G.backgroundImage[A]=d.image(J,W)),G.backgroundImage[A].show(),G.backgroundImage[A].animateWith(ub,D,bb,F,R),G.backgroundImage[A].attr({src:J}).css({opacity:.01*X}),bb.y+=bb.height,0===Gb&&(Gb=w,--r,bb.x+=bb.width,bb.y=v),A++;else G.backgroundImage[0]||(G.backgroundImage[0]=d.image(J,W),G.backgroundImage[0].attr(bb)),G.backgroundImage[0].show(),G.backgroundImage[0].animateWith(ub,D,bb,F,R),G.backgroundImage[0].css({opacity:.01*
X}).attr({src:J,visibility:Ka,"clip-rect":da});g.raiseEvent("BackgroundLoaded",{url:J,bgImageAlpha:100*X,bgImageDisplayMode:ca,bgImageVAlign:M,bgImageHAlign:O,bgImageScale:fa,imageWidth:Ya.width,imageHeight:Ya.height},h.chartInstance)}},Ya.onerror=function(b){g.raiseEvent("BackgroundLoadError",{url:J,bgImageAlpha:100*X,error:b,bgImageDisplayMode:ca,bgImageVAlign:M,bgImageHAlign:O,bgImageScale:fa},h.chartInstance)},Ya.src=J;else if(G.backgroundImage)for(ha=0,Ba=G.backgroundImage.length;ha<Ba;ha++)G.backgroundImage[ha].hide()},
redraw:function(){var b=this.graphics.dummyObj;b&&b.stop(void 0,!0,!0);this.draw&&this.draw()},_drawCreditLabel:function(){var b=g.core.options.creditLabel,a=this.chartInstance.args.creditLabel,h=this.config.height,c=this.graphics,f=c.creditLabel,z=c.creditGroup,e=c.parentGroup||c.messageGroup,d=this.components.paper,B={href:m.CREDIT_HREF,text:m.CREDIT_STRING},b=this.creditLabel&&(void 0===a?!1!==b:!1!==a);z||(z=c.creditGroup=d.group("creditgroup"));e&&z.insertAfter(e);h={text:B.text,x:6,y:h-4,"vertical-align":H,
"text-anchor":M,fill:"rgba(0,0,0,0.5)",title:B.title||ba};c={fontSize:9,fontFamily:"Verdana,sans",cursor:L,_cursor:"hand"};b&&(f?f.attr(h).css(c):f=this.graphics.creditLabel=d.text(h,c,z).click(function(){try{A.open(B.href)}catch(b){(A.top||A).location.href=B.href}}))},eiMethods:{hideChartMessage:function(){var b=this.apiInstance;b._show.apply(b);b._hideChartMessage(b)}}});Qa("mscartesian",{standaloneInit:!1,tooltipConstraint:"chart",annotationInteractionEvents:!0,useScaleRecursively:!0,init:function(b,
a,h,c){h=this.chartInstance||h;var f=h.jsVars,z=a.colorrange,e;a.chart=a.chart||a.graph||a.map||{};this.jsonData=a;a=this.components||(this.components={});a.background||(a.background={graphics:{},config:{}});a.canvas||(a.canvas={graphics:{},config:{}});e=FusionCharts.register("component",["caption","caption"]);a.caption||(a.caption=new e);a.caption.init();a.caption.chart=this;e=FusionCharts.register("component",["caption","subCaption"]);a.subCaption||(a.subCaption=new e);a.subCaption.init();a.dataset||
(a.dataset=[]);this.linkedItems={container:b,smartLabel:f.smartLabel};a.colorManager=new m.colorManager(this);a.numberFormatter=new Bb(this);z&&(a.colorRange=new m.ColorRange(this));this._checkInvalidData()?m.raiseEvent("nodatatodisplay",{},h,[h.id]):(this._createLegend(),this._createGradientLegend(),this.configure(),this.disposeChartStyleSheet(),this._createAxes(),this._feedAxesRawData(),this.config.realtimeEnabled&&(h=FusionCharts.get("component",["manager","alert"]))&&(a.alertManager=new h,a.alertManager.init(this),
a.alertManager.configure()),this._createDatasets(),this._createQuadrant&&this._createQuadrant(),this.draw(),this.setChartEvents());c({hasRendered:!0,container:b})},_checkInvalidData:function(){var b=this.jsonData,a=this.chartInstance;if(!(this.isWidget||this.isMap||b.data&&0!==b.data.length||b.dataset||b.value||b.lineset||b.annotations||b.category||b.tasks||b.process||b.axis))return this.setChartMessage(),this.drawChartMessage(),a.__state.dataReady=!1,a.jsVars.hasNativeMessage=!0,a.jsVars.drawCount+=
1,!0},_createToolBox:function(){var b,a,h,c,f,z,e,d;f=!!A.btoa;var B=this,g=B.jsonData.chart,G=C(g.exportshowmenuitem),P=g.exportformats,l=B.chartMenuTools,g=l.get,q=l.set,l=this.components,p=B.config,n=p.exportOption.enabled;b=l.chartMenuBar;h=l.actionBar;var p=p.printOption.enabled,t={PNG:"Export As PNG",JPG:"Export As JPG",PDF:"Export As PDF",SVG:"Export As SVG",XLS:"Export As XLS"},r,w={},v=[],Q;if(!(b&&b.drawn||h&&h.drawn)){b=l.tb||(l.tb=new (FusionCharts.register("component",["toolbox","toolbox"])));
d=b.init({graphics:B.graphics||(B.graphics={}),chart:B,components:l});l.toolBoxAPI=h=l.toolBoxAPI||(l.toolBoxAPI=b.getAPIInstances(b.ALIGNMENT_HORIZONTAL));c=h.SymbolWithContext;a=h.SymbolStore;z=h.ComponentGroup;e=h.Toolbar;b.idCount=b.idCount||0;b.pId=d;h=b.getDefaultConfiguration();a.register("ContextIcon",function(b,a,f){var k=2*f;f=ya(k/4);var h=.7*ya(k/2),k=b-h;b+=h;h=a+f;f=a-f;return["M",k,a,"L",b,a,"M",k,h,"L",b,h,"M",k,f,"L",b,f]});a=new c("ContextIcon",b.idCount++,d);c=a.getListRefernce();
if(n&&0!==G){if(P)for(G=P.split("|"),w=0,n=G.length;w<n;w++)P=G[w].split("="),Q=P[0].toUpperCase(),t[Q]&&(t[Q]=P[1]||t[Q]),t[Q]&&(r||(r={}))&&(r[Q]=!0);G=function(b){return function(){m.exportChart.call(B,b)}};for(Q in t)"XLS"===Q&&!f||r&&!r[Q]||(w={},w[t[Q]]={handler:G({exportformat:Q}),action:"click"},v.push(w));q(v)}p&&q([{Print:{handler:function(b){B.chartInstance.print.call(B.chartInstance,b)},action:"click"}}]);c.appendAsList(g());f=new z(b.idCount++,d);f.setConfiguaration({buttons:h,group:{fill:hb,
borderColor:hb}});f.addSymbol(a);delete l.chartMenuBar;delete l.actionBar;b="t"===f.btnConfig.vAlign?l.chartMenuBar=new e(b.idCount++,b.pId):l.actionBar=new e(b.idCount++,b.pId);b.addComponent(f)}},chartMenuTools:function(){var b=[];return{get:function(){return b},set:function(a){var h,c=a.length||0;for(h=0;h<c;h+=1)b.push(a[h])},reset:function(a,h){var c=h.components,f=c.actionBar;(c=c.chartMenuBar)&&(c.drawn=!1);f&&(f.drawn=!1);b.length=0;a&&(a.idCount=0,a.clean())},update:function(b,a,c){var f=
c.components;c=c.components.toolBoxAPI.SymbolWithContext;var z=(f.chartMenuBar||f.actionBar).componentGroups,e,E,d,B,g,f=0;for(d=z.length;f<d;f++)for(E=z[f],E=E.symbolList||[],B=0,g=E.length;B<g;B++)E[B]instanceof c&&(e=E[B],e=e.getListRefernce().getFirstContainer().atomicLists);e=e||[];f=0;for(d=e.length;f<d;f++)if(c=e[f],c.name===b){c.updateName(a);break}}}}(),getConfig:function(b){return b?this.config[b]:this.config},get:function(b,a){var h=this[b];return a?h&&h[a]:h},disposeChartStyleSheet:function(){var b=
this.components.paper;b&&b.cssClear()},createChartStyleSheet:function(){this.components.paper.cssRender()},configure:function(){var b,k,h,c=this.components,f=this.jsonData,e,d=this.chartInstance,B=c.colorManager,g=this.is3D,G=g?z.chart3D:z.chart2D,P=this.isBar,l,q;l=!1;var p=c.legend,n={linear:"linear",easein:"easeIn",easeout:"easeOut",easeinout:"easeInOut",backin:"backIn",backout:"backOut",elastic:"elastic",bounce:"bounce"};f.chart=f.chart||f.graph||f.map||{};delete f.map;delete f.graph;e=f.chart;
!e&&(e=f.chart={});c.colorRange||(c.colorRange=new m.ColorRange(this));f=this.config||(this.config={});this.__setDefaultConfig();S(e,f);f.snapLiterals={};f.viewPortConfig={scaleY:1,scaleX:1,x:0,y:0};g&&(P?(f.xDepth=5,f.yDepth=5):(f.xDepth=10,f.yDepth=10),f.showCanvasBase=P=!!C(e.showcanvasbase,1),f.canvasBasePadding=C(e.canvasbasepadding,2),f.canvasBaseDepth=P?C(e.canvasbasedepth,10):0,f.canvasBgDepth=C(e.canvasbgdepth,3));c.colorManager&&c.colorManager.configure();f.placeAxisLabelsOnTop=C(e.placexaxislabelsontop,
0);f.enableAnimation=P=C(e.animation,e.defaultanimation,1);c=C(e.transposeanimation,0);P=P?1E3*C(e.animationduration,1):0;c=c?1E3*C(e.transposeanimduration,.2):0;f.animationObj&&(l=!0);f.animationObj=c={initAnimDuration:P,transposeAnimDuration:c};c.duration=l||void 0!==c.duration?c.transposeAnimDuration:c.initAnimDuration;for(q in n)q===I(e.animationeffect)&&(f.animationeffect=n[q]);f.showToolTip=C(e.showtooltip,1);f.exportOption={enabled:C(e.exportenabled,0),bgcolor:d.jsVars.transparent||0===C(d.options.containerBackgroundOpacity,
1)?a:d.options.containerBackgroundColor||"#ffffff",bgalpha:(d.jsVars.transparent?0:C(d.options.containerBackgroundOpacity,1))+a,exporttargetwindow:I(e.exporttargetwindow,Ea?"_blank":"_self"),exportaction:e.exportaction&&"save"===e.exportaction.toString().toLowerCase()&&"save"||"download",exportfilename:I(e.exportfilename,"FusionCharts"),exporthandler:I(e.html5exporthandler,e.exporthandler,aa),exportparameters:I(e.exportparameters,a),exportformat:I(e.exportformat,"PNG"),exportcallback:I(e.exportcallback,
a),exportwithimages:C(e.exportwithimages,1),exportatclientside:C(e.exportatclientside,0)};f.printOption={enabled:C(e.printshowbutton,e.showprintmenuitem,0)};f.chartMenuOptions={position:b=I(e.toolbarposition,"tr").toLowerCase(),hAlign:k=(a+e.toolbarhalign).toLowerCase()===gb?"l":b.charAt(1),vAlign:h=(a+e.toolbarvalign).toLowerCase()===H?"b":b.charAt(0),hDirection:C(e.toolbarhdirection,"r"===k?-1:1),vDirection:C(e.toolbarvdirection,"b"===h?-1:1),vMargin:C(e.toolbarvmargin,6),hMargin:C(e.toolbarhmargin,
10),x:C(e.toolbarx,"l"===k?0:f.width),y:C(e.toolbary,"t"===h?0:f.height)};b=f.style={};f.textDirection="1"===e.hasrtltext?"rtl":ba;b.inCanfontFamily=k=I(e.basefont,"Verdana,sans");b.inCanfontSize=h=Xa(e.basefontsize,10);b.inCancolor=d=I(e.basefontcolor,B.getColor(G.baseFontColor));b.outCanfontFamily=I(e.outcnvbasefont,k);b.fontSize=l=Xa(e.outcnvbasefontsize,h);b.outCanfontSize=l+jb;b.outCancolor=I(e.outcnvbasefontcolor,d).replace(/^#? ([a-f0-9]+)/ig,"#$1");b.baseFontSize=h;b.inCanfontSize=h+jb;b.inCancolor=
d.replace(/^#? ([a-f0-9]+)/ig,"#$1");b.inCanvasStyle=l={fontFamily:k,fontSize:h,color:d};b.inCanLineHeight=l=cb(l);q=(q=za(e.valuebordercolor,a))?$a(q,C(e.valueborderalpha,e.valuealpha,100)):a;f.showBorder=C(e.showborder,g?0:1);f.borderWidth=ka(f.showBorder?C(e.borderthickness,1):0,0);f.valuefontbold=C(e.valuefontbold,f.valuefontbold);f.dataLabelStyle=g={fontFamily:I(e.valuefont,k),fontSize:I(e.valuefontsize,parseInt(h,10))+jb,lineHeight:l,color:$a(I(e.valuefontcolor,d),C(e.valuefontalpha,e.valuealpha,
100)),fontWeight:f.valuefontbold?w:ga,fontStyle:C(e.valuefontitalic)?"italic":ga,border:q||e.valuebgcolor?C(e.valueborderthickness,1)+"px solid":ba,borderColor:q,borderThickness:C(e.valueborderthickness,1),borderPadding:C(e.valueborderpadding,2),borderRadius:C(e.valueborderradius,0),backgroundColor:e.valuebgcolor?$a(e.valuebgcolor,C(e.valuebgalpha,e.valuealpha,100)):a,borderDash:C(e.valueborderdashed,0)?ea(C(e.valueborderdashlen,4),C(e.valueborderdashgap,2),C(e.valueborderthickness,1)):"none"};cb(g);
f.orphanStyles={defaultStyle:{style:na({},b.inCanvasStyle)},connectorlabels:{style:na({},f.dataLabelStyle)},vyaxisname:{style:na({},b.inCanvasStyle)}};f.legendPosition=I(e.legendposition,H);f.logoURL=ia(e.logourl);f.logoPosition=I(e.logoposition,"tl").toLowerCase();f.logoAlpha=C(e.logoalpha,100);f.logoLink=ia(e.logolink);f.logoScale=C(e.logoscale,100);f.logoLeftMargin=C(e.logoleftmargin,0);f.logoTopMargin=C(e.logotopmargin,0);f.minChartWidthPercent=C(e.minchartwidth,this.minChartWidth,50)/100;f.minChartHeightPercent=
C(e.minchartheight,this.minChartHeight,50)/100;f.minCanvasWidthPercent=C(e.mincanvaswidth,this.minCanvasWidth,60)/100;f.minCanvasHeightPercent=C(e.mincanvasheight,this.minCanvasHeight,30)/100;this._parseBackgroundCosmetics();this.components.caption.configure();this._parseCanvasCosmetics();f.origMarginTop=C(e.charttopmargin,this.chartTopMargin,15);f.origMarginLeft=C(e.chartleftmargin,this.chartLeftMargin,15);f.origMarginBottom=C(e.chartbottommargin,this.chartBottomMargin,15);f.origMarginRight=C(e.chartrightmargin,
this.chartRightMargin,15);G=I(e.zeroplanecolor,e.divlinecolor,B.getColor(G.divLineColor));B=I(e.zeroplanealpha,e.divlinealpha,B.getColor("divLineAlpha"));f.zeroPlaneColor=$a(G,B);f.zeroPlaneBorderColor=$a(I(e.zeroplanebordercolor,G),C(e.zeroplaneshowborder,1)?B:0);f.zeroPlaneShowBorder=C(e.zeroplaneshowborder,1);f.dataStreamURL=Ja(e.datastreamurl);f.realtimeEnabled=B=C(e.realtimeenabled,this.isRealTime);f.showLegend=C(e.showlegend,this.showLegend,1);f.link=e.clickurl;f.annRenderDelay=1E3*C(e.annrenderdelay,
0);f.transposeAxis=C(this.transposeAxis,e.transposeaxis,0);f.useEllipsesWhenOverflow=C(e.useellipseswhenoverflow,e.useellipsewhenoverflow,1);this.chartMenuTools.reset(this.components.tb,this);f.gLegendPadding=C(e.legendpadding,10);B&&this._realTimeConfigure();this._setToolTipOptions();p.configure();this.linkedItems.linkClickFN=zb(this.jsonData,this.chartInstance);this._createConfigurableComponents()},_createConfigurableComponents:function(){var b=this.config,a=this.components,h;b.realtimeEnabled&&
b.usemessagelog&&(b=FusionCharts.get("component",["logger","message"]))&&(h=a.messageLogger,h||(a.messageLogger=new b,a.messageLogger.init(this)),a.messageLogger.configure())},_parseBackgroundCosmetics:function(){var b=this.is3D,a=this.components.background.config,h=this.components.colorManager,c=this.jsonData.chart,f;f=a.showBorder=C(c.showborder,this.showBorder,b?0:1);a.borderWidth=f=ka(f?C(c.borderthickness,1):0,0);a.borderRadius=a.borderRadius=C(c.borderradius,0);a.borderDashStyle=a.borderDashStyle=
C(c.borderdashed,0)?ea(C(c.borderdashlen,4),C(c.borderdashgap,2),f):"none";a.borderAlpha=I(c.borderalpha,b?"100":h&&h.getColor("borderAlpha"));a.borderColor=a.borderColor=$a(I(c.bordercolor,b?"#666666":h&&h.getColor("borderColor")),a.borderAlpha)},_parseCanvasCosmetics:function(){var b,a,h=this.config;a=this.components;var c=a.canvas.config,f=this.jsonData.chart;a=a.colorManager;var e,d=this.is3D?z.chart3D:z.chart2D,B=c.isRoundEdges=C(f.useroundedges,0);b=C(f.showxaxisline,f.showyaxisline,f.showaxislines,
0)?0:1;c.canvasBorderRadius=C(f.plotborderradius,B?2:0);b=c.showCanvasBorder=!!C(f.showcanvasborder,b,void 0,B?0:1);e=c.oriCanvasBorderThickness=ka(C(f.canvasborderthickness,B?0:C(this.canvasborderthickness,2),0));c.canvasBorderWidth=this.is3D?0:b?e:0;c.canvasBorderColor=$a(I(f.canvasbordercolor,a.getColor("canvasBorderColor")),I(f.canvasborderalpha,a.getColor("canvasBorderAlpha")));b=c.canBGAlpha=I(f.canvasbgalpha,a.getColor("canvasBgAlpha"));c.canBGColor={FCcolor:{color:I(f.canvasbgcolor,a.getColor(d.canvasBgColor)),
alpha:I(f.canvasbgalpha,100),angle:I(f.canvasbgangle,0),ratio:I(f.canvasbgratio)}};a=c.shadow=C(f.showshadow,B,0)&&B?{enabled:!0,opacity:b/100}:0;c.shadowOnCanvasFill=a&&a.enabled;h.origMarginTop=C(f.charttopmargin,15);h.origMarginLeft=C(f.chartleftmargin,15);h.origMarginBottom=C(f.chartbottommargin,15);h.origMarginRight=C(f.chartrightmargin,15);h.origCanvasLeftMargin=C(f.canvasleftmargin,0);h.origCanvasRightMargin=C(f.canvasrightmargin,0);h.origCanvasTopMargin=C(f.canvastopmargin,0);h.origCanvasBottomMargin=
C(f.canvasbottommargin,0);c.canvasPadding=C(f.canvaspadding,0);c.origCanvasTopPad=C(f.canvastoppadding,0);c.origCanvasBottomPad=C(f.canvasbottompadding,0);c.origCanvasLeftPad=C(f.canvasleftpadding,0);c.origCanvasRightPad=C(f.canvasrightpadding,0)},_preDraw:function(){this.config.realtimeEnabled&&this._setRealTimeCategories&&this._setRealTimeCategories();this._setAxisValuePadding();this._setAxisLimits()},_manageSpace:function(){var b=this.components.canvas.config,a=this.linkedItems.container,h=this.config,
c,f,z,e,d,B,g,G,P,m,l;h.width=c=a.offsetWidth;h.height=l=a.offsetHeight;h.minChartHeight=P=h.minChartHeightPercent*l;h.minChartWidth=m=h.minChartWidthPercent*c;h.minCanvasWidth=a=h.minCanvasWidthPercent*m;h.minCanvasHeight=f=h.minCanvasHeightPercent*P;h.marginTop=z=h.origMarginTop;h.marginLeft=e=h.origMarginLeft;h.marginBottom=d=h.origMarginBottom;h.marginRight=B=h.origMarginRight;h.canvasMarginTop=h.origCanvasTopMargin;h.canvasMarginLeft=h.origCanvasLeftMargin;h.canvasMarginBottom=h.origCanvasBottomMargin;
h.canvasMarginRight=h.origCanvasRightMargin;h.canvasHeight=g=h.height-h.marginTop-h.marginBottom;h.canvasWidth=G=h.width-h.marginLeft-h.marginRight;h.availableHeight=g-f;h.availableWidth=G-a;g<P&&(g=l-P,h.canvasHeight=P,l=z+d,h.marginTop=g*z/l,h.marginBottom=g*d/l,h.availableHeight=P-f);G<m&&(g=c-m,l=B+e,h.canvasWidth=m,h.marginLeft=g*e/l,h.marginRight=g*B/l,h.availableWidth=m-a);h.canvasLeft=h.marginLeft;h.canvasTop=h.marginTop;b.canvasPaddingLeft=Sa(b.origCanvasLeftPad,ya(.1*h.height));b.canvasPaddingRight=
Sa(b.origCanvasRightPad,ya(.1*h.height));b.canvasPaddingTop=Sa(b.origCanvasTopPad,ya(.1*h.height));b.canvasPaddingBottom=Sa(b.origCanvasBottomPad,ya(.1*h.height));this._spaceManager()},_postSpaceManagement:function(){var b=this.config,a=this.components,h=a.xAxis&&a.xAxis[0],c=a.yAxis&&a.yAxis[0],f=a.legend,z=b.xDepth,e=a.canvas.config,a=e.canvasBorderWidth,d=e.canvasPadding||0,B=e.canvasPaddingLeft,g=e.canvasPaddingRight,G=e.canvasPaddingTop,e=e.canvasPaddingBottom;h&&h.setAxisDimention({x:b.canvasLeft+
(z||0)+ka(B,d),y:b.canvasBottom+(b.shift||0)+a,opposite:b.canvasTop-a,axisLength:b.canvasWidth-(z||0)-ka(B,d)-ka(g,d)});h&&this._allocateXAxisLabelSpace(h);c&&c.setAxisDimention({x:b.canvasLeft-a,y:b.canvasTop+G,opposite:b.canvasRight+a,axisLength:b.canvasHeight-G-e});h&&h.shiftLabels(-z,0);f.postSpaceManager();this._adjustCanvasPadding()},_allocateXAxisLabelSpace:function(b){var a=this.config,h=b.getAxisEndLabelDisplaySpace();b=h.left;var c=h.right,f=h.top,h=h.bottom,z=a.availableWidth,e=a.availableHeight,
d=a.canvasLeft,B=a.canvasRight,g=a.canvasTop,G=a.canvasBottom,P=a.width,m=a.height,l=function(b,a){return b<a&&0<a?a-b:0};f+h>e&&(a=f+h,f=e*f/a,h=e*h/a);b+c>z&&(a=b+c,b=z*b/a,c=z*c/a);b=l(d,b);c=l(P-B,c);f=l(g,f);h=l(m-G,h);this._allocateSpace({left:b,right:c,top:f,bottom:h})},_animCallBack:function(){var b=this.config;b.animationStarted&&(g.raiseEvent("internal.animationComplete",{},this.chartInstance),b.animationStarted=!1)},_setAnimDuration:function(){var b=this.config.animationObj;b&&(b.duration=
b.transposeAnimDuration)},_setDataLabelStyle:function(){var b=this.config.dataLabelStyle;this.graphics.datalabelsGroup.css({fontFamily:b.fontFamily,fontSize:b.fontSize,fontWeight:b.fontWeight,fontStyle:b.fontStyle})},_updateVisuals:function(){var b=this.linkedItems.container,a=this.components,h=a.paper,z=a.tooltip,f=this.chartInstance,e=this.get(l,N),d=e.animType,B=e.dummyObj,g=e.animObj,e=e.duration,G=this.config,P,m=G.prevWidth,q=G.prevHeight;G.animationStarted=!0;h?((m||q)&&h.setSize(m,q),m={width:b.offsetWidth,
height:b.offsetHeight},P=!0,this._chartAnimation(!0),h.animateWith(B,g,m,e,d)):(h=a.paper=new D(b,b.offsetWidth,b.offsetHeight),h.setConfig("stroke-linecap",c));G.prevWidth=b.offsetWidth;G.prevHeight=b.offsetHeight;h.tooltip(z.style,z.config.shadow,z.config.constrain);this.setChartCursor();this._createLayers();this._setDataLabelStyle();!P&&this._chartAnimation(!0);this._drawBackground();!1!==this.hasCanvas&&this._drawCanvas();a.chartMenuBar&&this._drawChartMenuBar();this._manageCaptionPosition();
a.caption&&a.caption.draw();this.drawLegend();a.actionBar&&this.drawActionBar();this._drawAxis&&this._drawAxis();this._drawDataset();this._drawQuadrant&&this._drawQuadrant();this._drawCreditLabel();this._drawLogo();f.annotations&&this._drawAnnotations();this.drawAxisUpdateUI&&this.drawAxisUpdateUI();a.messageLogger&&a.messageLogger.isDrawn()&&a.messageLogger.draw();this.drawScrollBar&&this.drawScrollBar();this.showRTvalue&&G.realTimeConfig.showRTValue&&this._drawRealTimeValue()},_chartAnimation:function(b){var a=
this,h=a.graphics,c=a.components.paper,f=a.config.animationObj,z,e=f.duration||f.transposeAnimDuration,d=a.config,B=d.animationeffect,g=function(){a._animCallBack()};!e||d.parentElementPause?setTimeout(a._animCallBack.bind(a),0):(f.animObj=e=D.animation({x:0},e,B,g,!1),f.animType=B,(z=h.dummyObj)?z.attr({x:100}):(h.dummyObj=z=c.rect({x:100,y:0,width:10,height:30}),z.hide()),f.dummyObj=h.dummyObj,b?(z.stop(void 0,!0,!0),z.animate(e),z.pause(void 0,!0),d.parentElementPause=!0,setTimeout(function(){d.parentElementPause=
!1;a._setAnimDuration();z.resume(void 0,!0)},0)):(setTimeout(function(){a._setAnimDuration()},0),z.animate(e)))},draw:function(){var b=this.chartInstance;this.config.hasChartMessage?(this._hide(),this.drawChartMessage(),m.raiseEvent("nodatatodisplay",{},b,[b.id]),this.chartInstance.jsVars.drawCount+=1,this.chartInstance.__state.dataReady=!1,this.chartInstance.jsVars.hasNativeMessage=!0):(this._clearTimers&&this._clearTimers(),this._show(),this._preDraw(),this._createToolBox(),this._manageSpace(),
this._postSpaceManagement(),this._updateVisuals(),this.inited=!0,this.chartInstance.jsVars.drawCount+=1,this.chartInstance.__state.dataReady=!0,this.chartInstance.jsVars.hasNativeMessage=!1)},drawLegend:function(){var b=this.components,a=b.legend,b=b.gradientLegend,h=this.hasLegend;this.config.gLegendEnabled?(a&&a.hide(),this.drawGradientLegend&&this.drawGradientLegend()):(b&&b.elem&&b.elem.gl.carpet&&b.elem.gl.carpet.node&&b.elem.gl.carpet.group.hide(),!1!==h&&a.drawLegend())},manageGradientLegendSpace:function(b){var a=
this.components.gradientLegend,h=a&&a.conf,c;c=Sa(this.config.gLegendPadding,.5*b);h?(h=h.legendPosition,b=a.getLogicalSpace(b),c=h===H?{bottom:(b.height||0)+c}:{right:(b.width||0)+c}):c={bottom:0,right:0};return c},drawGradientLegend:function(){var b=this.components,a=this.config,h=this.jsonData.colorrange,c=b.gradientLegend||{},f=(c.conf||{}).legendPosition,z=a.canvasLeft,e=a.canvasTop,d=a.canvasWidth,B=a.canvasHeight,g=a.marginBottom,G=a.marginRight,P=this.hasGradientLegend,m,l,q;m=c.getLogicalSpace();
l=m.width;q=m.height;f===H?(f=d-l,G=z+(0>f?0:f/2),g=a.height-m.height-g-(a.actionBarHeight||0)):(f=B-q,g=e+(0>f?0:f/2),G=a.width-m.width-G);h&&P&&c.draw(G,g,{paper:b.paper,parentGroup:this.graphics.parentGroup})},_drawAxis:function(){var b=this.components,a=b.yAxis||[],h=b.xAxis||[],b=b.scale,c,f;c=0;for(f=h.length;c<f;c++)h[c].draw();c=0;for(f=a.length;c<f;c++)a[c].draw();b&&b.draw()},_drawAnnotations:function(){var b=this.jsonData,a=b.chart,h=this.config,c=h.width,f=h.height,h=b&&b.annotations||
{},z=this.chartInstance.annotations;if(b&&a&&C(a.showannotations,1)){var b=C(h.scaleonresize,a.scaleonresize,1),a={interactionevents:I(this.annotationInteractionEvents,!0),showbelow:I(h.showbelow,h.showbelowchart),autoscale:h.autoscale,scaletext:h.scaletext,scaleimages:h.scaleimages,constrainedscale:h.constrainedscale,scaleonresize:b,origw:I(h.origw,a.origw,this.origRenderWidth,c),origh:I(h.origh,a.origh,this.origRenderHeight,f),xshift:h.xshift,yshift:h.yshift,grpxshift:h.grpxshift,grpyshift:h.grpyshift,
xscale:h.xscale,yscale:h.yscale,rootxscale:C(h.xscale,100)/100,rootyscale:C(h.yscale,100)/100},e;a||(a={});for(e in void 0)a[e]=(void 0)[e];z.reset(h,a,this)}else z.clear();z.draw(this)},_clearTimers:function(){var b=this.config&&this.config.realTimeConfig,a=this.linkedItems.timers,h=a&&a.setTimeout,a=a&&a.setInterval,c;b&&(b.refreshIntervalFlag=!1);for(c in h)clearTimeout(h[c]);for(c in a)clearInterval(a[c])},_createLayers:function(){var b=this.graphics||(this.graphics={}),a,h,c=this.components.paper,
b=this.graphics;b.parentGroup=a=b.parentGroup||c.group("parentgroup");b.backgroundGroup=b.backgroundGroup||c.group("background",a);b.canvasGroup=b.canvasGroup||c.group("canvas",a);b.axisBottomGroup=b.axisBottomGroup||c.group("axisbottom",a);b.datasetGroup=h=b.datasetGroup||c.group("dataset",a);b.axisTopGroup=b.axisTopGroup||c.group("axistop",a);b.sumLabelsLayer=b.sumLabelsLayer||c.group("sumlabels",a);b.datalabelsGroup=b.datalabelsGroup||c.group("datalabel",a);b.legendGroup=b.legendGroup||c.group("legend",
a);b.captionGroup=b.captionGroup||c.group("caption",a);b.captionGroup.trackTooltip(!0);b.columnGroup=b.columnGroup||c.group("column",h);b.areaGroup=b.areaGroup||c.group("area",h);b.lineGroup=b.lineGroup||c.group("line",h);b.trackerGroup||(b.trackerGroup=c.group("tracker",a),b.trackerGroup.trackTooltip(!0));b.buttonGroup=b.buttonGroup||c.group("buttons")},_spaceManager:function(){var b,a,h=this.config,c=this.components,f=c.xAxis&&c.xAxis[0];a=c.yAxis&&c.yAxis||[];var z,e,d=c.legend.config.legendPos,
B=h.xDepth,g=h.yDepth,G=h.canvasBgDepth,P=h.canvasBaseDepth,m=h.canvasBasePadding,l=c.canvas.config.canvasBorderWidth,q=h.realTimeConfig&&h.realTimeConfig.showRTValue,p=h.borderWidth,n=h.canvasMarginTop,t=h.canvasMarginBottom,r=h.canvasMarginLeft,w=h.canvasMarginRight,c=h.minCanvasHeight,C=h.minCanvasWidth;b=h.minChartWidth;var v=h.minChartHeight,A=h.height,K=h.width,D=!1,F=!1,I,L=h.origCanvasTopMargin,J=h.origCanvasBottomMargin,U=h.origCanvasLeftMargin,Z=h.origCanvasRightMargin,X,da,M=[];h.canvasWidth-
2*p<b&&(e=(h.canvasWidth-b)/2);h.canvasHeight-2*p<v&&(z=(h.canvasHeight-v)/2);this._allocateSpace({top:z||p,bottom:z||p,left:e||p,right:e||p});p=0;for(e=a.length;p<e;p++)z=a[p],b=.7*h.availableWidth,b=z&&z.placeAxis(b)||{},M.push({axisIndex:p,spaceTaken:b}),z&&this._allocateSpace(b);h.yAxisSpaceAllocation=M;this._allocateSpace(this._manageActionBarSpace&&this._manageActionBarSpace(.225*h.availableHeight)||{});this._manageLegendSpace(void 0);a=d===H?.6*h.availableHeight:.6*h.availableWidth;g&&(this._allocateSpace({bottom:g}),
h.shift=B+m+P);G&&this._allocateSpace({right:G});h.canvasWidth-2*l<C&&(da=(h.canvasWidth-C)/2);this._allocateSpace({left:da||l,right:da||l});C>K-r-w&&(F=!0,g=h.canvasWidth-C,B=r+w,r=h.canvasMarginLeft=g*r/B,w=h.canvasMarginRight=g*w/B);r=r>h.canvasLeft?r-h.canvasLeft:0;w=w>K-h.canvasRight?w+h.canvasRight-K:0;this._allocateSpace({left:r,right:w});F&&(B=U+Z,F=h.canvasWidth,F>C&&(g=F-C,r=g*U/B,w=g*Z/B),this._allocateSpace({left:r,right:w}));h.actualCanvasMarginRight=w;h.actualCanvasMarginBottom=I;this._manageChartMenuBar(a);
a=.2*h.availableHeight;this._allocateSpace(this._getSumValueSpace(a));a=.3*h.availableHeight;h.realtimeEnabled&&(q?this._allocateSpace(this._realTimeValuePositioning(a)):this._hideRealTimeValue());this._resetViewPortConfig&&this._resetViewPortConfig();this._setAxisScale&&this._setAxisScale();a=.6*h.availableHeight;h.xAxisSpaceAllocation=I=f&&f.placeAxis(a);f&&this._allocateSpace(I);this._getDSspace&&this._allocateSpace(this._getDSspace(.4*h.canvasWidth));a=.3*h.availableHeight;this._manageScrollerPosition&&
this._manageScrollerPosition(a);h.canvasHeight-2*l<c&&(X=(h.canvasHeight-c)/2);this._allocateSpace({top:X||l,bottom:X||l});this._allocateSpace({bottom:P});c>A-n-t&&(D=!0,g=h.canvasHeight-c,B=n+t,n=h.canvasMarginTop=g*n/B,t=h.canvasMarginBottom=g*t/B);f=n>h.canvasTop?n-h.canvasTop:0;I=t>A-h.canvasBottom?t+h.canvasBottom-A:0;this._allocateSpace({top:f,bottom:I});D&&(B=L+J,P=h.canvasHeight,P>c&&(g=P-c,f=g*L/B,I=g*J/B),this._allocateSpace({top:f,bottom:I}));h.actualCanvasMarginTop=f;h.actualCanvasMarginLeft=
r},_manageLegendSpace:function(){var b=this.config,a=this.components,h=a.legend,c=a.gradientLegend,f;f=this.jsonData.colorrange;var a=this.hasLegend,z={},e=this.hasGradientLegend,d=C(this.jsonData.chart.mapbycategory,0);e&&f&&C(f.gradient)&&!d?(f=c.conf,e=!0,b.gLegendEnabled=!0,c=.5,f=f.legendPosition):(f=h.config,e=!1,b.gLegendEnabled=!1,f=f.legendPos,c=f===tb?.8:.4);b=f===tb?b.availableWidth*c:b.availableHeight*c;e?z=this.manageGradientLegendSpace(b):!1!==a&&(z=h._manageLegendPosition(b));this._allocateSpace({bottom:z.bottom||
0,right:z.right||0})},_getSumValueSpace:function(b){var a={},h=this.isBar,c=this.jsonData.chart,a=0!==this.showsum?C(c.showsum,this.showsum,0):0,f=this.config.stack100percent,z=this.config.isstacked,c=0,e=this.components["datasetGroup_"+this.defaultDatasetType],d=0;a&&f&&z&&e&&(a=e.getMaxSumValueSpace(),h?c=a.maxWidth:d=a.maxHeight,d>b&&(d=b),c>b&&(c=b));return{top:d,right:c}},_setAxisValuePadding:function(){var b=this.components.dataset,a=b.length,h,c,f=-Infinity,z=-Infinity,e=this.components.xAxis;
for(h=0;h<a;h++)c=b[h],c=c.getAxisValuePadding&&c.getAxisValuePadding()||{},f=ka(f,c.left||-Infinity),z=ka(z,c.right||-Infinity);-Infinity===f&&(f=0);-Infinity===z&&(z=0);e&&e[0].setAxisPadding(f,z)},_fetchCaptionPos:function(b){var a=this.config,h=this.components,c=a.width,f=h.chartMenuBar,z=f.componentGroups[0].btnConfig,f=f.getLogicalSpace().width,h=h.caption.config,e=h.width,z="l"===z.hAlign,d=a.width-b,B=a.origMarginRight,g=a.origMarginLeft,G=z?g:B;return h.align===t?(z?b:d)-e/2-G-f:h.align===
M?z?-1:c-a.canvasLeft-G-e-f+h.horizontalPadding:z?c-(B+g+f+e):-1},_manageChartMenuBar:function(b){var a=this.config,h=this.components,c=h.chartMenuBar,f=c&&c.getLogicalSpace(),h=h.caption.config,z=h.isOnTop,e=a.width/2,d=a.canvasRight,B=d?(a.canvasLeft+d)/2:e,d=0,e=h.alignWithCanvas?B:e,d=c&&c.componentGroups[0].btnConfig,c=f&&d.spaceNotHardCoded;d&&d.spaceNotHardCoded&&(d.x=C("l"===d.hAlign?0:a.width),d.y=C("t"===d.vAlign?0:a.height));delete h._offsetHeight;z?(b=this._manageCaptionSpacing(b),c&&
(d=this._fetchCaptionPos(e),h._offsetHeight=0>d?f.height:0,b.top=0>d?C(b.top,0)+f.height:ka(b.top,f.height))):(this._allocateSpace({top:c?f.height:0}),b=this._manageCaptionSpacing(b));this._allocateSpace(b);return{top:f?ka(f.height,b.top):b.top,bottom:b.bottom}},_manageActionBarSpace:function(){var b=this.config,a=this.components.actionBar,a=(a&&a.getLogicalSpace()||{}).height||0;b.actionBarHeight=a;return{bottom:a}},_getDSspace:function(b){var a=this.components.dataset,h,c=a.length,f,z,e={},d={left:0,
right:0,top:0,bottom:0,paddingLeft:0,paddingRight:0,paddingBottom:0,paddingTop:0},B;for(f=0;f<c;f++)if(h=a[f],z=h.groupManager)e[h.type]=z;else if(h.manageSpace)for(B in h=h.manageSpace&&h.manageSpace(),h)d[B]=ka(h[B],d[B]);for(B in e)if(z=e[B],z.manageSpace)for(B in h=z.manageSpace&&z.manageSpace(b),h)d[B]=ka(h[B],d[B]);a=d.paddingLeft;c=d.paddingRight;f=a+c;b<f&&(d.paddingLeft=b*a/f,d.paddingRight=b*c/f);return d},_adjustCanvasPadding:function(){for(var b=this.config,a=this.components,h=a.dataset,
c=h.length,f=a.xAxis&&a.xAxis[0],z=b.xDepth,e={},d,B,g,G=a.canvas.config,P=G.canvasBorderWidth,m=G.canvasPadding,a=0;a<c;a++)d=h[a],(B=d.groupManager)&&(e[d.type]=B);for(g in e)B=e[g],B.preDrawCalculate&&B.preDrawCalculate();this._getDSspace&&(this._allocateSpace(this._getDSspace(.4*b.canvasWidth)),f&&f.setAxisDimention({x:b.canvasLeft+(z||0)+ka(G.canvasPaddingLeft,m),y:b.canvasBottom+(b.shift||0)+P,opposite:b.canvasTop-P,axisLength:b.canvasWidth-(z||0)-ka(G.canvasPaddingLeft,m)-ka(G.canvasPaddingRight,
m)}))},_setAxisLimits:function(){var b=this.components,a=b.dataset,h=b.yAxis,b=b.xAxis,c,f=a.length,z,e=-Infinity,d=Infinity,B=Infinity,g=-Infinity,G,P,m,l={},q=[],p=function(b){P=I(b.xMax,-Infinity);m=I(b.xMin,Infinity);e=ka(e,b.max);d=Sa(d,b.min);g=ka(g,P);B=Sa(B,m)};for(z=0;z<f;z++)c=a[z],(G=c.groupManager)?l[c.type]=G:q.push(c);for(G in l)a=l[G].getDataLimits(),p(a);f=q.length;for(z=0;z<f;z++)a=q[z].getDataLimits(),p(a);p(this._getTrendLineMinMax("h"));-Infinity===e&&(e=0);Infinity===d&&(d=0);
this.config.yMax=e;this.config.yMin=d;h[0].setAxisConfig({isPercent:this.config.isstacked?this.config.stack100percent:0});h[0].setDataLimit(e,d);if(-Infinity!==g||Infinity!==B)b[0].config.xaxisrange={max:g,min:B},b[0].setDataLimit(g,B)},_getTrendLineMinMax:function(b,a){var h="v"===b?this.jsonData.vtrendlines:this.jsonData.trendlines,c={max:-Infinity,min:Infinity},f,z,e,d,B;a=a||"p";if(h)for(z=0,d=h.length;z<d;z+=1)for(e=0,B=h[z].line?h[z].line.length:0;e<B;e+=1)f=h[z].line[e],"s"===a&&"s"!==f.parentyaxis||
"s"!==a&&"s"===f.parentyaxis||(c.max=ka(f.startvalue||-Infinity,f.endvalue||-Infinity,c.max),c.min=Sa(f.startvalue||Infinity,f.endvalue||Infinity,c.min));return c},_setToolTipOptions:function(){var b=this.components,a=this.components.colorManager,h=this.jsonData.chart,c=b.tooltip||(c=b.tooltip={}),b=c.config||(b=c.config={}),f=this.config,z=f.style,f=f.style.inCanvasStyle,e,d,B;e=$a(I(h.tooltipbgcolor,a.getColor("toolTipBgColor")),I(h.tooltipbgalpha,100));a=$a(I(h.tooltipbordercolor,a.getColor("toolTipBorderColor")),
I(h.tooltipborderalpha,100));d=C(h.tooltipborderthickness,1)+"px";B=C(h.tooltippadding,3)+"px";c=c.style={fontFamily:z.inCanfontFamily,fontSize:z.inCanfontSize,lineHeight:f.lineHeight,color:$a(z.inCancolor),backgroundColor:e,borderColor:a,borderWidth:d,padding:B};h.tooltipcolor&&(c.color=kb(h.tooltipcolor));if(h.tooltipborderradius||h.useroundedges)c.borderRadius=C(h.tooltipborderradius,2)+"px";b.shadow=C(h.showtooltipshadow,h.showshadow,1)?{enabled:!0,opacity:ka(C(h.tooltipbgalpha,100),C(h.tooltipborderalpha,
100))/100}:!1;b.constrain=C(h.constraintooltip,1)},_createAxes:function(){var b=this.components,a=FusionCharts.register("component",["axis","cartesian"]),h;b.yAxis=[];b.xAxis=[];b.yAxis[0]=h=new a;b.xAxis[0]=b=new a;h.chart=this;b.chart=this;h.init();b.init();this._setCategories()},_feedAxesRawData:function(){var b=this.config,a=this.components,h=a.colorManager,c=this.jsonData,f=c.chart,e,d=this.is3d,B=d?z.chart3D:z.chart2D;e={outCanfontFamily:I(f.outcnvbasefont,f.basefont,"Verdana,sans"),outCanfontSize:Xa(f.outcnvbasefontsize,
f.basefontsize,10),outCancolor:I(f.outcnvbasefontcolor,f.basefontcolor,h.getColor(B.baseFontColor)).replace(/^#? ([a-f0-9]+)/ig,"#$1"),axisBreaks:f.xaxisbreaks,axisNamePadding:f.xaxisnamepadding,axisValuePadding:f.labelpadding,axisNameFont:f.xaxisnamefont,axisNameFontSize:f.xaxisnamefontsize,axisNameFontColor:f.xaxisnamefontcolor,axisNameFontBold:f.xaxisnamefontbold,axisNameFontItalic:f.xaxisnamefontitalic,axisNameBgColor:f.xaxisnamebgcolor,axisNameBorderColor:f.xaxisnamebordercolor,axisNameAlpha:f.xaxisnamealpha,
axisNameFontAlpha:f.xaxisnamefontalpha,axisNameBgAlpha:f.xaxisnamebgalpha,axisNameBorderAlpha:f.xaxisnameborderalpha,axisNameBorderPadding:f.xaxisnameborderpadding,axisNameBorderRadius:f.xaxisnameborderradius,axisNameBorderThickness:f.xaxisnameborderthickness,axisNameBorderDashed:f.xaxisnameborderdashed,axisNameBorderDashLen:f.xaxisnameborderdashlen,axisNameBorderDashGap:f.xaxisnameborderdashgap,useEllipsesWhenOverflow:f.useellipseswhenoverflow,divLineColor:I(f.vdivlinecolor,f.divlinecolor,h.getColor(B.divLineColor)),
divLineAlpha:I(f.vdivlinealpha,f.divlinealpha,d?h.getColor("divLineAlpha3D"):h.getColor("divLineAlpha")),divLineThickness:C(f.vdivlinethickness,f.divlinethickness,1),divLineIsDashed:!!C(f.vdivlinedashed,f.vdivlineisdashed,f.divlinedashed,f.divlineisdashed,0),divLineDashLen:C(f.vdivlinedashlen,f.divlinedashlen,4),divLineDashGap:C(f.vdivlinedashgap,f.divlinedashgap,2),showAlternateGridColor:C(f.showalternatevgridcolor,0),alternateGridColor:I(f.alternatevgridcolor,h.getColor("altVGridColor")),alternateGridAlpha:I(f.alternatevgridalpha,
h.getColor("altVGridAlpha")),numDivLines:C(f.numvdivlines,this.numVDivLines),labelFont:f.labelfont,labelFontSize:f.labelfontsize,labelFontColor:f.labelfontcolor,labelFontAlpha:f.labelalpha,labelFontBold:f.labelfontbold,labelFontItalic:f.labelfontitalic,maxLabelHeight:f.maxlabelheight,axisName:f.xaxisname,axisMinValue:f.xaxisminvalue,axisMaxValue:f.xaxismaxvalue,setAdaptiveMin:C(f.setadaptivexmin,this.setadaptivexmin,b.setadaptivexmin),adjustDiv:f.adjustvdiv,labelDisplay:f.labeldisplay,showLabels:f.showlabels,
rotateLabels:f.rotatelabels,slantLabel:C(f.slantlabels,f.slantlabel),labelStep:C(f.labelstep,f.xaxisvaluesstep),showAxisValues:C(f.showxaxisvalues,f.showxaxisvalue),showLimits:C(f.showvlimits,this.showvlimits),showDivLineValues:C(f.showvdivlinevalues,f.showvdivlinevalues,this.showvdivlinevalues),showZeroPlane:C(f.showvzeroplane,this.showzeroplane),zeroPlaneColor:f.vzeroplanecolor,zeroPlaneThickness:C(f.vzeroplanethickness,f.vdivlinethickness,b.zeroplanethickness,2),zeroPlaneAlpha:C(f.vzeroplanealpha,
f.vdivlinealpha,b.zeroplanealpha),showZeroPlaneValue:C(f.showvzeroplanevalue,this.showzeroplanevalue),trendlineColor:f.trendlinecolor,trendlineToolText:f.trendlinetooltext,trendlineThickness:f.trendlinethickness,trendlineAlpha:f.trendlinealpha,showTrendlinesOnTop:f.showtrendlinesontop,showAxisLine:d?0:C(f.showxaxisline,f.showaxislines,f.drawAxisLines,this.showxaxisline,0),axisLineThickness:C(f.xaxislinethickness,f.axislinethickness,1),axisLineAlpha:C(f.xaxislinealpha,f.axislinealpha,100),axisLineColor:I(f.xaxislinecolor,
f.axislinecolor,"#000000")};b={outCanfontFamily:I(f.outcnvbasefont,f.basefont,"Verdana,sans"),outCanfontSize:Xa(f.outcnvbasefontsize,f.basefontsize,10),outCancolor:I(f.outcnvbasefontcolor,f.basefontcolor,h.getColor(B.baseFontColor)).replace(/^#? ([a-f0-9]+)/ig,"#$1"),axisBreaks:f.yaxisbreaks,axisNamePadding:f.yaxisnamepadding,axisValuePadding:f.yaxisvaluespadding,axisNameFont:f.yaxisnamefont,axisNameFontSize:f.yaxisnamefontsize,axisNameFontColor:f.yaxisnamefontcolor,axisNameFontBold:f.yaxisnamefontbold,
axisNameFontItalic:f.yaxisnamefontitalic,axisNameBgColor:f.yaxisnamebgcolor,axisNameBorderColor:f.yaxisnamebordercolor,axisNameAlpha:f.yaxisnamealpha,axisNameFontAlpha:f.yaxisnamefontalpha,axisNameBgAlpha:f.yaxisnamebgalpha,axisNameBorderAlpha:f.yaxisnameborderalpha,axisNameBorderPadding:f.yaxisnameborderpadding,axisNameBorderRadius:f.yaxisnameborderradius,axisNameBorderThickness:f.yaxisnameborderthickness,axisNameBorderDashed:f.yaxisnameborderdashed,axisNameBorderDashLen:f.yaxisnameborderdashlen,
axisNameBorderDashGap:f.yaxisnameborderdashgap,axisNameWidth:f.yaxisnamewidth,useEllipsesWhenOverflow:f.useellipseswhenoverflow,rotateAxisName:C(f.rotateyaxisname,1),axisName:f.yaxisname,divLineColor:I(f.divlinecolor,h.getColor(B.divLineColor)),divLineAlpha:I(f.divlinealpha,d?h.getColor("divLineAlpha3D"):h.getColor("divLineAlpha")),divLineThickness:C(f.divlinethickness,1),divLineIsDashed:!!C(f.divlinedashed,f.divlineisdashed,0),divLineDashLen:C(f.divlinedashlen,4),divLineDashGap:C(f.divlinedashgap,
2),showAlternateGridColor:C(f.showalternatehgridcolor,1),alternateGridColor:I(f.alternatehgridcolor,h.getColor("altHGridColor")),alternateGridAlpha:I(f.alternatehgridalpha,h.getColor("altHGridAlpha")),numDivLines:C(f.numdivlines,this.numDivLines),axisMinValue:f.yaxisminvalue,axisMaxValue:f.yaxismaxvalue,setAdaptiveMin:C(f.setadaptivesymin,f.setadaptiveymin),adjustDiv:f.adjustdiv,labelStep:f.yaxisvaluesstep,showAxisValues:C(f.showyaxisvalues,f.showyaxisvalue,this.showyaxisvalues),showLimits:C(f.showyaxislimits,
f.showlimits,this.showLimits),showDivLineValues:C(f.showdivlinevalues,f.showdivlinevalue,this.showdivlinevalues),showZeroPlane:C(f.showzeroplane,this.showzeroplane),zeroPlaneColor:f.zeroplanecolor,zeroPlaneThickness:C(f.zeroplanethickness,f.divlinethickness,b.zeroplanethickness,2),zeroPlaneAlpha:C(f.zeroplanealpha,f.divlinealpha,b.zeroplanealpha),showZeroPlaneValue:C(f.showzeroplanevalue,this.showzeroplanevalue),showZeroPlaneOnTop:b.showzeroplaneontop,trendlineColor:f.trendlinecolor,trendlineToolText:f.trendlinetooltext,
trendlineThickness:f.trendlinethickness,trendlineAlpha:f.trendlinealpha,showTrendlinesOnTop:f.showtrendlinesontop,showAxisLine:d?0:C(f.showyaxisline,f.showaxislines,f.drawAxisLines,this.showyaxisline,0),axisLineThickness:C(f.yaxislinethickness,f.axislinethickness,1),axisLineAlpha:C(f.yaxislinealpha,f.axislinealpha,100),axisLineColor:I(f.yaxislinecolor,f.axislinecolor,"#000000")};e.vtrendlines=c.vtrendlines;b.trendlines=c.trendlines;c=a.yAxis&&a.yAxis[0];a=a.xAxis&&a.xAxis[0];c&&(c.setCommonConfigArr(b,
!0,!1,!1),c.configure());a&&(a.setCommonConfigArr(e,!1,!1,!1),a.configure())},_createLegend:function(){var b=this.components,a=FusionCharts.register("component",["legend","legend"]);Va=b.legend=new a;Va.chart=this;Va.init()},_createGradientLegend:function(){var b=this.components,a;this.hasGradientLegend&&(a=b.gradientLegend=b.gradientLegend||new (FusionCharts.register("component",["gradientLegend","gradientLegend"])),b.postLegendInitFn=a.init({chart:this}))},_setCategories:function(){var b=this.jsonData,
a=this.components.xAxis,b=b.categories&&b.categories[0].category;a&&a[0].setCategory(b)},_getDiff:function(b,a,h,c){h>b&&(b=h,a=c);return{diff:b,startIndex:a}},_createDatasets:function(){var b,a=this.components,h=a.xAxis[0],c=this.jsonData,f=c.dataset,z=f&&f.length,e,d,B,g=this.defaultDatasetType,G=this.applicableDSList,P=this.components.legend.components.items||[],m,l,q,p=this.config.isstacked,n,t,r=[],w=this.isRealTime,C=this.config.catLen,v={};f&&0!==f.length||this.setChartMessage();this.config.categories=
c.categories&&c.categories[0].category;e=a.dataset||(a.dataset=[]);d=e.length;for(c=0;c<z;c++)if(q=f[c],q.seriesname&&(q.seriesname=Ja(q.seriesname)),B=q.parentyaxis||ba,l=(l=this.isDual&&"s"===B.toLowerCase()?I(q.renderas,this.sDefaultDatasetType):I(q.renderas,g))&&l.toLowerCase(),G[l]||(l=g),b=FusionCharts.get("component",["dataset",l]))void 0===v[l]?v[l]=0:v[l]++,n="datasetGroup_"+l,B=FusionCharts.register("component",["datasetGroup",l]),(m=a[n])&&r.push(m),B&&!m&&(m=a[n]=new B,m.chart=this,m.init()),
(B=e[c])?(l=h.getCategoryLen(),b=C-l,n=w?B.components:B.JSONData,t=n.data&&n.data.length,n=w?0:q.data&&q.data.length||0,t-=n,b=this._getDiff(t,n,b,l),l=b.diff,b=b.startIndex,this.config._dataUpdated=!0,0<l&&B.removeData(b,l,!1),this.config._dataUpdated=!1,e[c].JSONData=q,e[c].configure(),e[c]._deleteGridImages&&e[c]._deleteGridImages()):(B=new b,e.push(B),B.chart=this,B.index=c,m&&(p?m.addDataSet(B,0,v[l]):m.addDataSet(B,v[l],0)),B.init(q));if(d>z){l=d-z;m&&p&&m.removeDataSet(0,c,l);a=c;for(z=l+c;a<
z;a++)m&&!p&&m.removeDataSet(c,0,1),ab.call(e[a]);e.splice(c,l);P.splice(c,l)}this.config.catLen=h.getCategoryLen()},_drawDataset:function(){var b=this.components.dataset,a,h=b.length,c,f,z={},e=[];for(c=0;c<h;c++)a=b[c],(f=a.groupManager)?z[a.type]=f:e.push(a);for(f in z)z[f].draw();h=e.length;for(c=0;c<h;c++)e[c].draw()},_drawCanvas:function(){var b=this.jsonData.chart,a=this.components,h=this.config,z=this.graphics,f=a.paper,e=a.canvas,a=e.graphics,d=e.config,e=d.clip={},B=a.canvasBorderElement,
g=this.get(l,N),G=g.animType,P=g.animObj,m=g.dummyObj,g=g.duration,q=a.canvasElement,p=h.canvasLeft,n=h.canvasTop,t=h.canvasWidth,r=h.canvasHeight,w=d.xDepth=h.xDepth||0,h=d.yDepth=h.yDepth||0,z=z.canvasGroup,A=d.canvasBorderRadius,H=d.canvasBorderWidth,Q=.5*H,R=d.canvasBorderColor,K=d.canBGColor,D=d.canBGAlpha,F=d.shadow,b=d.showCanvasBG=!!C(b.showcanvasbg,1),I=d.shadowOnCanvasFill,L=d.showCanvasBorder,d={x:p-Q,y:n-Q,width:t+H,height:r+H,r:A,"stroke-width":H,stroke:R,"stroke-linejoin":2<H?c:v};L?
B?(B.show(),B.animateWith(m,P,{x:p-Q,y:n-Q,width:t+H,height:r+H,r:A},g,G),B.attr({"stroke-width":H,stroke:R,"stroke-linejoin":2<H?c:v}),B.shadow(F)):a.canvasBorderElement=f.rect(d,z).shadow(F):B&&B.hide();e["clip-canvas"]=[ka(0,p-w),ka(0,n-h),ka(1,t+2*w),ka(1,r+h)];e["clip-canvas-init"]=[ka(0,p-w),ka(0,n-h),1,ka(1,r+2*h)];b?(d={x:p,y:n,width:t,height:r,r:A,"stroke-width":0,stroke:"none",fill:Pa(K)},q?(q.show(),q.animateWith(m,P,{x:p,y:n,width:t,height:r,r:A},g,G),q.attr({"stroke-width":0,stroke:"none",
fill:Pa(K)})):q=a.canvasElement=f.rect(d,z),I?q.shadow({opacity:D/100}):q.shadow(!1)):q&&q.hide()},_getBackgroundCosmetics:function(){var b=this.jsonData.chart,a=this.components.colorManager,h=this.is3D?z.chart3D:z.chart2D;return{FCcolor:{color:I(b.bgcolor,this.bgColor,a.getColor(h.bgColor)),alpha:I(b.bgalpha,this.bgAlpha,a.getColor(h.bgAlpha)),angle:I(b.bgangle,a.getColor(h.bgAngle)),ratio:I(b.bgratio,a.getColor(h.bgRatio))}}},_manageCaptionSpacing:function(b,a){return this.components.caption.manageSpace(b,
a)},_manageCaptionPosition:function(){this.components.caption.managePosition()},drawActionBar:function(){var b=this.config,a=this.components,h=a.actionBar||{},c=this.graphics,f=c.toolbarWrapperGroup,z=a.paper,e=h.componentGroups[0].btnConfig,a=h&&h.getLogicalSpace();h.toolbarConfig.fill=hb;h.toolbarConfig.vPadding=0;h.toolbarConfig.borderColor=hb;f||(f=c.toolbarWrapperGroup=z.group("toolbarWrapper",c.parentGroup).insertBefore(c.datalabelsGroup));e.spaceNotHardCoded?h.draw("b"===e.vAlign&&"r"===e.hAlign?
b.width-b.marginRight-a.width:b.marginLeft,b.height-b.marginBottom-a.height,{parentGroup:f}):h.draw(e.x,e.y);h.drawn=!0},_drawChartMenuBar:function(){var b=this.components.chartMenuBar,a=b.getLogicalSpace(),h=b.toolbarConfig,c=b.componentGroups[0].btnConfig,f=c.vDirection,z=c.hDirection,e=c.y,d=c.x;h.fill=hb;h.borderColor=hb;c.spaceNotHardCoded?(e+=c.vMargin*f+Sa(0,a.height*f),d+=c.hMargin*z-ka(0,a.width*z),b.draw("l"===c.hAlign?d+a.width:d-a.width,e)):b.draw(d,e);b.drawn=!0},_drawLogo:function(){var b=
this,a=b.components.paper,h=b.config,c=h.borderWidth||0,f=h.height,z=h.width,d=b.graphics.logoImage,B=h.logoURL,G=h.logoAlpha/100,P=h.logoPosition,m=h.logoLink,q=h.logoScale,p=h.logoLeftMargin,n=h.logoTopMargin,r,w,h=b.get(l,N),C=h.animType,v=h.animObj,A=h.dummyObj,K=h.duration,h={tr:{vAlign:e,hAlign:tb},bl:{vAlign:H,hAlign:gb},br:{vAlign:H,hAlign:tb},cc:{vAlign:t,hAlign:t}},Q,R,D;B?(Q=new nb,(D=h[P])||(D={vAlign:e,hAlign:gb}),Q.onload=function(){R=La("none",D.vAlign,D.hAlign,q,c,z,f,Q);F&&(R.w=R.width||
0,R.h=R.height||0);R.src=B;d?d.animateWith(A,v,R,K,C):d=b.graphics.logoImage=a.image(R);d.show();d.translate(p,n).css("opacity",G);m?d.css({cursor:L,_cursor:"hand"}):d.css({cursor:"default",_cursor:ga});if(d.events&&d.events.length)for(w=0,r=d.events.length;w<r;w++)d.events[w].unbind(),d.events.splice(w,1),--r,--w;d.mouseover(function(a){a=Oa(b.chartInstance.ref,a);g.raiseEvent("LogoRollover",{logoURL:B,logoAlpha:100*G,logoPosition:P||"tl",logoScale:q,logoLink:m,chartX:a.chartX,chartY:a.chartY,pageX:a.pageX,
pageY:a.pageY},b.chartInstance)});d.mouseout(function(a){a=Oa(b.chartInstance.ref,a);g.raiseEvent("LogoRollout",{logoURL:B,logoAlpha:100*G,logoPosition:P||"tl",logoScale:q,logoLink:m,chartX:a.chartX,chartY:a.chartY,pageX:a.pageX,pageY:a.pageY},b.chartInstance)});d.click(function(a){a=Oa(b.chartInstance.ref,a);g.raiseEvent("LogoClick",{logoURL:B,logoAlpha:100*G,logoPosition:P||"tl",logoScale:q,logoLink:m,chartX:a.chartX,chartY:a.chartY,pageX:a.pageX,pageY:a.pageY},b.chartInstance,void 0,function(){m&&
b.linkedItems.linkClickFN.call({link:m},b)})});g.raiseEvent("LogoLoaded",{logoURL:B,logoAlpha:100*G,logoPosition:P||"tl",logoScale:q,logoLink:m},b.chartInstance)},Q.onerror=function(a){g.raiseEvent("LogoLoadError",{logoURL:B,logoAlpha:100*G,logoPosition:P||"tl",logoScale:q,logoLink:m,error:a},b.chartInstance)},Q.src=B):d&&d.hide()},_addCSSDefinition:function(b,a){var h=this.components.paper;a.color&&(a.fill=a.color);h.cssAddRule(b,a)},_allocateSpace:function(b){var a=this.components.canvas.config,
h=this.config,c=h.canvasHeight,f=h.canvasWidth,z=h.availableHeight,e=h.availableWidth;h.canvasLeft+=b.left||0;h.canvasTop+=b.top||0;f=h.canvasWidth=ka(f-((b.left||0)+(b.right||0)),0);c=h.canvasHeight=ka(c-((b.top||0)+(b.bottom||0)),0);h.availableHeight=ka(z-((b.top||0)+(b.bottom||0)),0);h.availableWidth=ka(e-((b.left||0)+(b.right||0)),0);h.canvasRight=h.canvasLeft+f;h.canvasBottom=h.canvasTop+c;a.canvasPaddingLeft=ka(a.canvasPaddingLeft,b.paddingLeft||0);a.canvasPaddingRight=ka(a.canvasPaddingRight,
b.paddingRight||0);a.canvasPaddingTop=ka(a.canvasPaddingTop,b.paddingTop||0);a.canvasPaddingBottom=ka(a.canvasPaddingBottom,b.paddingBottom||0)},_updateCategory:function(b){var a=this.jsonData,a=a.categories&&a.categories[0].category,h=b.category,c=h.length,f=b.index,z=b.prepend;b=b.add;var e;for(e=0;e<c;e++)f?(b&&a.splice(f-1+e,0,h[e]),!b&&(a[f-1+e]=h[e])):z?(b&&a.splice(e,0,h[e]),!b&&(a[e]=h[e])):(b&&a.push(h),!b&&(a[a.length-1]=h))},realTimeUpdate:function(b){var a=this.components,h=a.xAxis&&a.xAxis[0],
a=a.dataset,c=b.dataset;b=b.categories&&b.categories.category||[];var f=h&&h.getCategoryLen(),z=this.config.realTimeConfig=this.config.realTimeConfig||(this.config.realTimeConfig={}),e=0,d;if(a){if(h){h.categoryInsert(f,b,!0);f=0;for(d=b.length;f<d;f++)b[f].vline||(e+=1);h.categoryDelete(0,e,!0)}this.config._sumValuesUpdated=!1;f=0;for(d=a.length;f<d;f++)e=c[f],a[f].addData(e),a[f].removeData(0,e.data.length),a[f].maxminFlag&&(z.maxminFlag=a[f].maxminFlag)}},_RTmanageSpace:function(){var b=this.config,
a=this.components,h=a.xAxis[0],c=a.yAxis[0],f=a.yAxis[1],z,e=a.canvas.config,a=e.canvasBorderWidth,d=e.canvasPaddingTop,B=e.canvasPaddingBottom,g=e.canvasPadding||0,G=e.canvasPaddingLeft,e=e.canvasPaddingRight,P;z=b.xAxisSpaceAllocation;P=b.yAxisSpaceAllocation||[];var m=P[0]&&P[0].spaceTaken||{},l=P[1]&&P[1].spaceTaken||{},q=b.primaryAxisOnleft,p,n,t;z=(b.xAxisSpaceAllocation=h.placeAxis(b.availableHeight+z.bottom)).bottom-z.bottom;0!==z&&(this._allocateSpace({bottom:z}),z=b.availableWidth,P[0].spaceTaken=
z=c.placeAxis(z+m.left),this._allocateSpace({left:z.left-m.left}),z=b.availableWidth,m=b.canvasLeft-a,n=b.canvasRight+a,f&&(p=n,t=m,0===q&&(q=m,m=p,p=q,q=n,n=t,t=q),P[1].spaceTaken=P=f.placeAxis(z+(l.right||0)),this._allocateSpace({right:(P.right||0)-(l.right||0)}),f.setAxisDimention({x:p,y:b.canvasTop+d,opposite:t,axisLength:b.canvasHeight-d-B})),h&&h.setAxisDimention({x:b.canvasLeft+ka(G,g),y:b.canvasBottom+(b.shift||0)+a,opposite:b.canvasTop-a,axisLength:b.canvasWidth-ka(G,g)-ka(e,g)}),c&&c.setAxisDimention({x:m,
y:b.canvasTop+d,opposite:n,axisLength:b.canvasHeight-d-B}),c.draw(),this._drawCanvas())},realTimeDraw:function(b,a,h,c,f){var z=this.components,e=z.xAxis&&z.xAxis[0],d=z.yAxis&&z.yAxis[0],B=z.yAxis&&z.yAxis[1],G=z.scale,z=z.dataset,P=this.config.realTimeConfig,m=P.sync,l=P.showRTValue,q=P.maxminFlag,p,n,t=z.length;n=(new Date).getTime();this._chartAnimation(m);this.rtManageSpace&&this._RTmanageSpace();if(z){e&&e.draw();this._setAxisLimits();q&&d&&d.draw();B&&B.draw();q&&G&&G.draw();for(e=0;e<t;e++)p=
z[e].groupManager,!p&&z[e].draw();l&&this._drawRealTimeValue&&this._drawRealTimeValue();p&&p.draw()}n=(new Date).getTime()-n;a={data:a,updateObject:P.legacyUpdateObj,prevData:h,source:b?"XmlHttpRequest":"feedData",latency:n};b&&(a.networkLatency=f,a.url=c);g.raiseEvent("realTimeUpdateComplete",a,this.chartInstance)},_getPrevData:function(){return this.config.realTimeConfig&&this.config.realTimeConfig.prevData},feedData:function(b,a,h,c){var f=this,z=f.config.realtimeEnabled,e=f.config.realTimeConfig||
(f.config.realTimeConfig={}),d,B=f.components,g=B.xAxis,G=f.components.dataset,P,m,l=e.clearInterval,q=e.refreshInterval,p=e.updateInterval,n=f.linkedItems.timers||(f.linkedItems.timers={setTimeout:{},setInterval:{}}),t=G.length,r=e.prevData;d=f._linearDataParser(b);if(z&&f.chartInstance.isActive()){if(e.clear){for(z=0;z<t;z++)G[z]._realTimeConfigure(!0);e.clear=!1}q<p&&(q=e.refreshInterval=e.updateInterval);B.messageLogger&&B.messageLogger.addLog(d);B.alertManager&&B.alertManager.processRTData(d);
f.realTimeUpdate(d);f.canvasPadding&&f._adjustCanvasPadding();q&&!1===e.clearIntervalFlag?(f.realTimeDraw(a,b,r,h,c),e.refreshIntervalFlag=!1):q&&!e.refreshIntervalFlag?(e.refreshIntervalFlag=!0,n.setTimeout.loadData=setTimeout(function(){P=(new Date).getTime();f.realTimeDraw(a,b,r,h,c);m=(new Date).getTime();e.refreshIntervalFlag=!1;e.refreshIntervalTimeDifference=m-P},1E3*q-(e.refreshIntervalTimeDifference||0)-(c||0))):q||f.realTimeDraw(a,b,r,h,c);l&&!e.clearIntervalFlag&&g&&(e.clearIntervalFlag=
!0,n.setTimeout.clearData=setTimeout(function(b){P=(new Date).getTime();try{clearTimeout(b.setTimeout.loadData)}catch(a){clearTimeout(n.setTimeout.loadData)}f._clearChart();m=(new Date).getTime();e.clearIntervalTimeDifference=m-P;e.clearIntervalFlag=!1},1E3*l-(e.clearIntervalTimeDifference||0)-(c||0),n));return!0}return!1},_clearChart:function(b){var a=this.components,h=a.xAxis&&a.xAxis[0],a=a.dataset,c=h.getCategoryLen(),f=this.config.realTimeConfig||(this.config.realTimeConfig={}),z=a.length;f.clear=
!0;if(a){h&&h.categoryDelete(0,c,!0);this.config._sumValuesUpdated=!1;for(c=0;c<z;c++)h=a[c],a[c].removeData(0,h.components.data.length),a[c].maxminFlag&&(f.maxminFlag=a[c].maxminFlag);this.realTimeDraw()}this._setRealTimeCategories();m.raiseEvent("ChartCleared",{source:b},this.chartInstance,[this.id,b])},_linearDataParser:function(b,c){var h,z,f,e,d,B,g,G,P,m,l,q,p,n,t,r,w,C,v,A,H,K,D=this.components.dataset,D=D&&D.length;n=this.config.realTimeConfig;var F=n.prevData=[],I=n.legacyUpdateObj={},L=
I.values=[],J=I.target=[],U=I.valueVisibility=[],Z=I.toolTexts=[],X=I.toolTextsTarget=[],M=I.colors=[],ca=I.links=[],N=0,O={categories:{category:[]},dataset:[]},fa=O.categories.category,T=O.dataset,ma,S=b,ja;b=b&&b.toString&&b.toString()||ba;this.rtParserModify&&(S=S.replace(/([^\\])(\|)/g,"$1,"),b=b.replace(/\|/g,","));h=b.split("&");n=0;for(t=h.length;n<t;n+=1)if(z=h[n].split("="),f=z[1],z=z[0],z!==a&&void 0!==z&&void 0!==f&&(f!==a||c))switch(ma=z.toLowerCase(),ma){case "label":I.labels=r=f.split(",");
break;case "vline":I.vlines=w=f.split(",");break;case "vlinelabel":I.vlineLabels=P=f.split(",");break;case "vlinecolor":I.vlineColors=m=f.split(",");break;case "vlinethickness":I.vlineThickness=l=f.split(",");break;case "vlinedashed":I.vlineDashed=q=f.split(",");break;case "value":C=f.split("|");break;case "target":v=f.split("|");break;case "showlabel":I.showLabels=p=f.split(",");break;case "showvalue":e=f.split("|");break;case "tooltext":d=(d=(d=S.match(/tooltext=(.*?\\&)*.*?[^\\]&/i))?d[0].substr(9,
d[0].length-10):S.match(/(tooltext=)(.*)/i)[2])&&d.replace(/([^\\])(\|)/g,"$1_FC@@**");d=d.split("_FC@@**");break;case "targettooltext":B=f.split("|");break;case "link":G=f.split("|");break;case "color":g=f.split("|");break;case "datastamp":I.dataStamp=A=f;break;case "stopupdate":I.pause=H="1"==f;break;case "clear":I.clear=K="1"==f;break;default:I[z]=O[z]=f}h=C&&C.length;for(n=0;n<h;n++)L[n]=C[n].split(","),J[n]=v&&v[n]&&v[n].split(","),U[n]=e&&e[n]&&e[n].split(","),X[n]=B&&B[n]&&B[n].split(","),
M[n]=g&&g[n]&&g[n].split(","),ca[n]=G&&G[n]&&G[n].split(","),d&&(ja=d[n])&&(ja=ja.replace(/([^\\])(\,)/g,"$1_FC@@**"),Z[n]=ja.split("_FC@@**")),N=ka(N,L[n].length);e=ka(r&&r.length||0,N||0);for(n=0;n<e;n++)fa.push({label:r&&r[n],color:m&&m[n],showlabel:p&&p[n]});w&&fa.push({label:P&&P[0],vline:w&&w[0],color:m&&m[0],thickness:l&&l[0],dashed:q&&q[0],showlabel:p&&p[0]});for(n=0;n<D;n++){l={};P=l.data=[];q=F[n]=[];for(m=0;m<e;m++)P.push({value:L[n]&&L[n][m],target:J[n]&&J[n][m],showvalue:U[n]&&U[n][m],
tooltext:Z[n]&&Z[n][m]&&Z[n][m].replace(/\\/g,""),tooltexttarget:X[n]&&X[n][m],color:M[n]&&M[n][m],link:ca[n]&&ca[n][m]}),q.push(L[n]&&L[n][m]);T.push(l)}H&&this._stopUpdate();K&&this._clearChart();A&&(this.config.dataStamp=A);return O},exportChart:function(b){return m.exportChart.call(this,b)},chartHoverManager:function(){return function(b){var a=b.type,c=b.data,z=c.linkedItems.eventListeners||(c.linkedItems.eventListeners=[]);"mouseover"!==a&&"touchstart"!==a||!1!==c.mouseStateIn||(c.mouseStateIn=
!0,c.onContainerRollOver(b),z.push(Wa(F?J:A,"mouseover",c.winMouseHover,c)))}}(),setChartEvents:function(){var b=this.linkedItems.eventListeners||(this.linkedItems.eventListeners=[]),a=this.components.paper.canvas,c=this.linkedItems.container,z=C(this.jsonData.chart.enablechartmousemoveevent,0);Da(c,"click",this.onContainerClick);b.push(Wa(c,"click",this.onContainerClick,this));Da(a,"mouseover",this.chartHoverManager,this);Da(a,"touchstart",this.chartHoverManager,this);Da(a,"mouseout",this.chartHoverManager,
this);Da(a,"touchend",this.chartHoverManager,this);b.push(Wa(a,"mouseover touchstart mouseout touchend",this.chartHoverManager,this));Da(c,"mousemove",this.onContainerMouseMove,this);Da(c,"touchmove",this.onContainerMouseMove,this);z&&b.push(Wa(c,"mousemove touchmove",this.onContainerMouseMove,this))},setChartCursor:function(){var b=this.config.link,a=this.components.paper.canvas.style;D.svg?a.cursor=b?L:"default":this.components.paper.canvas.style.cursor=b?"hand":"default"},onContainerClick:function(b){var a=
b.target||b.originalTarget||b.srcElement||b.relatedTarget||b.fromElement,c=a&&a.parentElement,z=a&&a.nodeName.toLowerCase(),f=b.data,e=f.chartInstance;b=m.getMouseCoordinate(f.linkedItems.container,b.originalEvent);e.ref&&(e=na({height:e.args.height,width:e.args.width,pixelHeight:e.ref.offsetHeight,pixelWidth:e.ref.offsetWidth,id:e.args.id,renderer:e.args.renderer,container:e.options.containerElement},b),g.raiseEvent("chartclick",e,f.chartInstance),a&&a.ishot&&f||"tspan"===z&&c&&c.ishot&&f||f.config.link&&
f.linkedItems.linkClickFN.call(f,f))},onContainerMouseMove:function(b){var a=b.data,c=a.chartInstance;b=m.getMouseCoordinate(a.linkedItems.container,b.originalEvent);c.ref&&(c=na({height:c.args.height,width:c.args.width,pixelHeight:c.ref.offsetHeight,pixelWidth:c.ref.offsetWidth,id:c.args.id,renderer:c.args.renderer,container:c.options.containerElement},b),g.raiseEvent("chartMouseMove",c,a.chartInstance))},onContainerRollOver:function(b){var a=b.data,c=a.chartInstance;b=m.getMouseCoordinate(a.linkedItems.container,
b.originalEvent);c.ref&&(c=na({height:c.args.height,width:c.args.width,pixelHeight:c.ref.offsetHeight,pixelWidth:c.ref.offsetWidth,id:c.args.id,renderer:c.args.renderer,container:c.options.containerElement},b),g.raiseEvent("chartRollOver",c,a.chartInstance))},onContainerRollOut:function(b){var a=b.chart,c=a.chartInstance;b=m.getMouseCoordinate(a.linkedItems.container,b.event);c.ref&&(c=na({height:c.args.height,width:c.args.width,pixelHeight:c.ref.offsetHeight,pixelWidth:c.ref.offsetWidth,id:c.args.id,
renderer:c.args.renderer,container:c.options.containerElement},b),g.raiseEvent("chartRollOut",c,a.chartInstance))},mouseStateIn:!1,winMouseHover:function(b){var a=b.originalEvent,a=a.target||a.originalTarget||a.srcElement||a.relatedTarget||a.fromElement,c=b.data,z=c.components.paper;b={chart:c,event:b.originalEvent};F?z.getById(a.parentNode.raphaelid)||(c.onContainerRollOut(b),c.mouseStateIn=!1,Da(J,"mouseover",c.winMouseHover)):a.viewportElement||(c.mouseStateIn=!1,c.onContainerRollOut(b),Da(A,"mouseover",
c.winMouseHover))},_show:function(){this.graphics&&this.graphics.parentGroup&&this.graphics.parentGroup.show()},_hide:function(){this.graphics&&this.graphics.parentGroup&&this.graphics.parentGroup.hide()},getJobList:function(){this.jobList||(this.jobList={trackerDrawID:[],labelDrawID:[],entityDrawID:[],kdTreeID:[]});return this.jobList}},Qa.base,{valuefontbold:0,usemessagelog:0,zeroplanethickness:void 0,animationeffect:"easeIn",showshadow:1,showhovereffect:void 0,plothovereffect:void 0,anchorhovereffect:void 0,
plotborderdashed:void 0,stack100percent:void 0,showpercentvalues:void 0,showpercentintooltip:void 0,plotbordercolor:void 0,showtooltip:1,seriesnameintooltip:1,rotatevalues:0,minimizetendency:0,plotfillangle:270,valuepadding:2,useplotgradientcolor:1,plotborderthickness:1,plotfillalpha:pa,showvalues:1,valueposition:d,tooltipsepchar:", ",usedataplotcolorforlabels:0,placevaluesinside:0,showplotborder:1,use3dlighting:1,useroundedges:0,plotspacepercent:20,plotpaddingpercent:void 0,plotfillratio:void 0,
maxcolwidth:50,plotborderdashlen:5,plotborderdashgap:4});FusionCharts.register("component",["caption","caption",{pIndex:2,customConfigFn:null,init:function(){var b=this.graphics;!this.components&&(this.components={});!b&&(this.graphics={})},configure:function(){var b=this.chart,a=b.jsonData.chart,c=b.components,z=c.caption,f=z.config,d=b.config.style,B=d.outCanfontFamily,g=d.outCancolor,d=d.fontSize,c=c.subCaption,G=c.config;z.components.text=Ja(a.caption);c.components.text=Ja(a.subcaption);f.style=
{fontFamily:I(a.captionfont,B),color:$a(I(a.captionfontcolor,g).replace(/^#? ([a-f0-9]+)/ig,"#$1")),fontSize:C(a.captionfontsize,d+3)+jb,fontWeight:0===C(a.captionfontbold)?ga:w};f.align=G.align=I(a.captionalignment,sb);switch(f.align){case tb:f.align=q;break;case gb:f.align=M;break;default:f.align=t}f.isOnTop=G.isOnTop=C(a.captionontop,1);f.isOnLeft=!C(a.captiononright,0);f.captionPosition=ia(a.captionposition,e).toLowerCase();f.alignWithCanvas=G.alignWithCanvas=C(b.aligncaptionwithcanvas,a.aligncaptionwithcanvas,
1);f.horizontalPadding=G.horizontalPadding=C(a.captionhorizontalpadding,f.alignWithCanvas?0:15);f.drawCaption=!0;cb(f.style);G.style={fontFamily:I(a.subcaptionfont,a.captionfont,B),color:$a(I(a.subcaptionfontcolor,a.captionfontcolor,g).replace(/^#? ([a-f0-9]+)/ig,"#$1")),fontSize:C(a.subcaptionfontsize,C(ka(C(a.captionfontsize)-3,-1),d)+C(b.subTitleFontSizeExtender,1))+jb,fontWeight:0===C(a.subcaptionfontbold,b.subTitleFontWeight,a.captionfontbold)?ga:w};cb(G.style)},draw:function(){var b=this.chart,
a=b.config,c=b.components,z=b.config.textDirection,f=b.graphics,d=f.captionGroup,B=c.paper,g=b.linkedItems.smartLabel,G=c.caption,P=G.graphics,m=P.captionElement,q=c.subCaption,c=q.graphics,n=c.subCaptionElement,w=G.components,G=G.config,C=q.config,v=G.style,A=C.style,q=q.components,Ib=w.text,H=q.text,K=G.x,Q=G.align,R,D=a.showToolTip;R=b.get(l,N);var b=R.animType,I=R.animObj,F=R.dummyObj,L=R.duration;!Ib&&!H||d||(d=f.captionGroup=B.group("caption"),d.trackTooltip(!0),f.tracker?d.insertBefore(f.trackerGroup):
d.insertAfter(f.datasetGroup));Ib?(R={text:w.text,fill:v.color,x:K,y:G.y,"text-anchor":Q||t,"vertical-align":G.verticalAlign||e,visibility:G.drawCaption?p:r,direction:z},m?(m.animateWith(F,I,{x:K,y:G.y,"text-anchor":Q||t,"vertical-align":G.verticalAlign||e,direction:z},L,b),m.attr({"text-anchor":Q||t,text:w.text,fill:v.color,visibility:G.drawCaption?p:r}),m.css(v)):m=P.captionElement=B.text(R,v,d),m.tooltip(w.originalText),g&&(g.useEllipsesOnOverflow(a.useEllipsesWhenOverflow),g.setStyle(v),g.getOriSize(w.text))):
m&&(P.captionElement=m.remove());H?(R={text:q.text,fill:A.color,x:K,y:C.y,"text-anchor":Q||t,"vertical-align":e,direction:z,visibility:G.drawCaption?p:r},n?(n.animateWith(F,I,{x:K,y:C.y,"text-anchor":Q||t,"vertical-align":e,direction:z},L,b),n.attr({"text-anchor":Q||t,text:q.text,fill:A.color,visibility:G.drawCaption?p:r}),n.css(A)):n=c.subCaptionElement=B.text(R,A,d),n.tooltip(q.originalText)):n&&(c.subCaptionElement=n.remove());d&&d.trackTooltip(D?!0:!1);Ib||H||!d||(f.captionGroup=d.remove())},
manageSpace:function(b,c){var h=this.chart,z=h.config,f=h.components,e=f.caption,d=f.subCaption,B=e.config,g=d.config,e=e.components,d=d.components,G=h.jsonData.chart,h=h.linkedItems.smartLabel,P=b,m=Ja(G.caption),l=Ja(G.subcaption),q=G=C(G.captionpadding,10),p=z.canvasWidth,n=!1,t,r,w=0,v=0,A=0,H=0,K=0,v=ka(f.canvas.config.canvasBorderThickness,0),D=f=0;!c&&(c=p);if(3<P){G<v&&(G=v+2);m!==a&&(t=B.style,H=Ga(C(parseFloat(t.fontHeight,10),parseFloat(t.lineHeight,10),12)));l!==a&&(r=g.style,K=C(parseInt(r.fontHeight,
10),parseInt(r.lineHeight,10),12));if(0<H||0<K)P=ka(P,0),w=H+K+G,w>P?(v=P-w,n=!0,v<G?G=ka(v,5):(v-=G,G=0,K>v?(A=K-v+10,K=0,d._originalText=d.text,d.text=ba):(v-=K,K=0,H>v&&(A=H-v)))):A=P-w,h.useEllipsesOnOverflow(z.useEllipsesWhenOverflow),0<H&&(h.setStyle(t),H+=A,t=h.getSmartText(m,c,H),A=H-t.height,B.height=H=t.height,e.text=t.text,e.originalText=t.tooltext?t.tooltext:!1,f=t.width),0<K&&(h.setStyle(r),K+=A,r=h.getSmartText(l,c,K),A=K-r.height,K=r.height,d.text=r.text,g.height=r.height,d.originalText=
r.tooltext?r.tooltext:!1,D=r.width),n&&0<A&&(G+=Sa(q-G,A)),B.captionPadding=G,B.height=H,B.width=f,g.width=D,g.height=K,w=H+K+G;w>z.canvasHeight?(w=0,B.drawCaption=!1):B.drawCaption=!0;z=B.isOnTop?{top:w}:{bottom:w,top:5}}else z={bottom:0,top:0},B.drawCaption=!1;return z},managePosition:function(){var b=this.chart,a=b.config,c=b.components,z=c.caption,f=z.config,e=f.widgetValueHeight||0,d=c.subCaption.config,B=f.x,g=a.canvasWidth,B=f.align,z=z.components.text,G=f.alignWithCanvas,P=f.horizontalPadding,
m=a.width,l=a.canvasLeft,p=a.canvasRight,n=a.marginRight,t=a.marginLeft,a=a.marginTop,r=(ya(l)||0)+C(g,m)/2,g=f.height,w=d.height,v=c.legend.config,A=v.height,H=v.legendPadding,R=v.legendPos,K=c.gradientLegend||{},D=0,I=!!(K.conf||{}).showLegend,F=b.config.borderWidth,c=c.actionBar,L=0;v.isActive||(A=0);I&&b.config.gLegendEnabled&&(D=K.getLogicalSpace().height);switch(B){case q:B=G?p-P:m-P;break;case M:B=G?l+P:P;break;default:B=G?r:t+.5*(m-t-n)||m/2}f.x=B;f.isOnTop?f.y=(F||0)+(a||0):(R===tb&&(D=A=
H=0),c&&(B=c.getLogicalSpace()||{},L=B.height,void 0===L||Infinity===L||0>L)&&(L=0),f.y=b.config.height-b.config.marginBottom-g-(w||0)-(F||0)-(H||0)-(A||0)-D-e-L);f.y+=f._offsetHeight||0;d.y=z?f.y+g+2:f.y||a||0}}]);FusionCharts.register("component",["caption","subcaption",{pIndex:2,init:function(){var b=this.graphics;!this.components&&(this.components={});!b&&(this.graphics={})}}]);Qa("scrollbase",{standaloneInit:!1,_scrollBar:function(){var b=[];return{get:function(){return b},clear:function(){b.length=
0},add:function(a,c){b.push({conf:a,handler:c})}}}()},Qa.mscartesian);Qa("msinversecartesian",{standaloneInit:!1,_createAxes:function(){var b=this.components,a=FusionCharts.register("component",["axis","cartesian"]),c;b.yAxis=[];b.xAxis=[];b.yAxis[0]=c=new a;b.xAxis[0]=b=new a;c.chart=this;b.chart=this;c.init();b.init();this._setCategories()},_feedAxesRawData:function(){var b=this.components,a=this.config,c=b.colorManager,e=this.jsonData,f=e.chart,d,B=(d=this.is3d)?z.chart3D:z.chart2D;d={outCanfontFamily:I(f.outcnvbasefont,
f.basefont,"Verdana,sans"),outCanfontSize:Xa(f.outcnvbasefontsize,f.basefontsize,10),outCancolor:I(f.outcnvbasefontcolor,f.basefontcolor,c.getColor(B.baseFontColor)).replace(/^#? ([a-f0-9]+)/ig,"#$1"),axisNamePadding:f.xaxisnamepadding,axisValuePadding:f.labelpadding,axisNameFont:f.xaxisnamefont,axisNameFontSize:f.xaxisnamefontsize,axisNameFontColor:f.xaxisnamefontcolor,axisNameFontBold:f.xaxisnamefontbold,axisNameFontItalic:f.xaxisnamefontitalic,axisNameBgColor:f.xaxisnamebgcolor,axisNameBorderColor:f.xaxisnamebordercolor,
axisNameAlpha:f.xaxisnamealpha,axisNameFontAlpha:f.xaxisnamefontalpha,axisNameBgAlpha:f.xaxisnamebgalpha,axisNameBorderAlpha:f.xaxisnameborderalpha,axisNameBorderPadding:f.xaxisnameborderpadding,axisNameBorderRadius:f.xaxisnameborderradius,axisNameBorderThickness:f.xaxisnameborderthickness,axisNameBorderDashed:f.xaxisnameborderdashed,axisNameBorderDashLen:f.xaxisnameborderdashlen,axisNameBorderDashGap:f.xaxisnameborderdashgap,useEllipsesWhenOverflow:f.useellipseswhenoverflow,divLineColor:I(f.vdivlinecolor,
f.divlinecolor,c.getColor(B.divLineColor)),divLineAlpha:I(f.vdivlinealpha,f.divlinealpha,d?c.getColor("divLineAlpha3D"):c.getColor("divLineAlpha")),divLineThickness:C(f.vdivlinethickness,f.divlinethickness,1),divLineIsDashed:!!C(f.vdivlinedashed,f.vdivlineisdashed,f.divlinedashed,f.divlineisdashed,0),divLineDashLen:C(f.vdivlinedashlen,f.divlinedashlen,4),divLineDashGap:C(f.vdivlinedashgap,f.divlinedashgap,2),showAlternateGridColor:C(f.showalternatevgridcolor,0),alternateGridColor:I(f.alternatevgridcolor,
c.getColor("altVGridColor")),alternateGridAlpha:I(f.alternatevgridalpha,c.getColor("altVGridAlpha")),numDivLines:f.numvdivlines,maxLabelHeight:f.maxlabelheight,labelFont:f.labelfont,labelFontSize:f.labelfontsize,labelFontColor:f.labelfontcolor,labelFontAlpha:f.labelalpha,labelFontBold:f.labelfontbold,labelFontItalic:f.labelfontitalic,axisName:f.xaxisname,axisMinValue:f.xaxisminvalue,axisMaxValue:f.xaxismaxvalue,setAdaptiveMin:f.setadaptivexmin,adjustDiv:f.adjustvdiv,labelDisplay:f.labeldisplay,showLabels:f.showlabels,
rotateLabels:f.rotatelabels,slantLabel:C(f.slantlabels,f.slantlabel),labelStep:C(f.labelstep,f.xaxisvaluesstep),showAxisValues:C(f.showxaxisvalues,f.showxaxisvalue),showLimits:f.showvlimits,showDivLineValues:C(f.showvdivlinevalues,f.showvdivlinevalues),showZeroPlane:f.showvzeroplane,zeroPlaneColor:f.vzeroplanecolor,zeroPlaneThickness:f.vzeroplanethickness,zeroPlaneAlpha:f.vzeroplanealpha,showZeroPlaneValue:f.showvzeroplanevalue,trendlineColor:f.trendlinecolor,trendlineToolText:f.trendlinetooltext,
trendlineThickness:f.trendlinethickness,trendlineAlpha:f.trendlinealpha,showTrendlinesOnTop:f.showtrendlinesontop,showAxisLine:C(f.showxaxisline,f.showaxislines,f.drawAxisLines,0),axisLineThickness:C(f.xaxislinethickness,f.axislinethickness,1),axisLineAlpha:C(f.xaxislinealpha,f.axislinealpha,100),axisLineColor:I(f.xaxislinecolor,f.axislinecolor,"#000000")};a={outCanfontFamily:I(f.outcnvbasefont,f.basefont,"Verdana,sans"),outCanfontSize:Xa(f.outcnvbasefontsize,f.basefontsize,10),outCancolor:I(f.outcnvbasefontcolor,
f.basefontcolor,c.getColor(B.baseFontColor)).replace(/^#? ([a-f0-9]+)/ig,"#$1"),axisNamePadding:f.yaxisnamepadding,axisValuePadding:f.yaxisvaluespadding,axisNameFont:f.yaxisnamefont,axisNameFontSize:f.yaxisnamefontsize,axisNameFontColor:f.yaxisnamefontcolor,axisNameFontBold:f.yaxisnamefontbold,axisNameFontItalic:f.yaxisnamefontitalic,axisNameBgColor:f.yaxisnamebgcolor,axisNameBorderColor:f.yaxisnamebordercolor,axisNameAlpha:f.yaxisnamealpha,axisNameFontAlpha:f.yaxisnamefontalpha,axisNameBgAlpha:f.yaxisnamebgalpha,
axisNameBorderAlpha:f.yaxisnameborderalpha,axisNameBorderPadding:f.yaxisnameborderpadding,axisNameBorderRadius:f.yaxisnameborderradius,axisNameBorderThickness:f.yaxisnameborderthickness,axisNameBorderDashed:f.yaxisnameborderdashed,axisNameBorderDashLen:f.yaxisnameborderdashlen,axisNameBorderDashGap:f.yaxisnameborderdashgap,axisNameWidth:f.yaxisnamewidth,useEllipsesWhenOverflow:f.useellipseswhenoverflow,rotateAxisName:C(f.rotateyaxisname,1),axisName:f.yaxisname,divLineColor:I(f.divlinecolor,c.getColor(B.divLineColor)),
divLineAlpha:I(f.divlinealpha,c.getColor("divLineAlpha")),divLineThickness:C(f.divlinethickness,1),divLineIsDashed:!!C(f.divlinedashed,f.divlineisdashed,0),divLineDashLen:C(f.divlinedashlen,4),divLineDashGap:C(f.divlinedashgap,2),showAlternateGridColor:C(f.showalternatehgridcolor,1),alternateGridColor:I(f.alternatehgridcolor,c.getColor("altHGridColor")),alternateGridAlpha:I(f.alternatehgridalpha,c.getColor("altHGridAlpha")),numDivLines:f.numdivlines,axisMinValue:f.yaxisminvalue,axisMaxValue:f.yaxismaxvalue,
setAdaptiveMin:f.setadaptiveymin,adjustDiv:f.adjustdiv,labelStep:f.yaxisvaluesstep,showAxisValues:C(f.showyaxisvalues,f.showyaxisvalue),showLimits:C(f.showyaxislimits,f.showlimits,this.showLimits),showDivLineValues:C(f.showdivlinevalues,f.showdivlinevalue),showZeroPlane:f.showzeroplane,zeroPlaneColor:f.zeroplanecolor,zeroPlaneThickness:C(f.zeroplanethickness,f.divlinethickness,a.zeroplanethickness,2),zeroPlaneAlpha:C(f.zeroplanealpha,f.zeroplanealpha,a.zeroplanealpha,80),showZeroPlaneValue:f.showzeroplanevalue,
showZeroPlaneOnTop:a.showzeroplaneontop,trendlineColor:f.trendlinecolor,trendlineToolText:f.trendlinetooltext,trendlineThickness:f.trendlinethickness,trendlineAlpha:f.trendlinealpha,showTrendlinesOnTop:f.showtrendlinesontop,showAxisLine:C(f.showyaxisline,f.showaxislines,f.drawAxisLines,0),axisLineThickness:C(f.yaxislinethickness,f.axislinethickness,1),axisLineAlpha:C(f.yaxislinealpha,f.axislinealpha,100),axisLineColor:I(f.yaxislinecolor,f.axislinecolor,"#000000")};d.vtrendlines=e.vtrendlines;a.trendlines=
e.trendlines;e=b.yAxis&&b.yAxis[0];b=b.xAxis&&b.xAxis[0];e&&(e.setCommonConfigArr(a,!0,!0,!1),e.configure());b&&(b.setCommonConfigArr(d,!1,!1,!1),b.configure(),b.setAxisConfig({isRelativeAxisInverse:!0}))}},Qa.mscartesian);Qa("sscartesian",{standaloneInit:!1,hasLegend:!1,_createDatasets:function(){var b=this.components,a=b.legend,c=this.jsonData,z=c.dataset,f=c.data||z&&z[0].data,e=this.defaultDatasetType,d,B,c=this._dataSegregator(f);this.config.categories=c.data;z=b.dataset||(b.dataset=[]);if(!f||
0===f.length)this.setChartMessage();else if(e&&(B=FusionCharts.get("component",["dataset",e])))if(f="datasetGroup_"+e,d=FusionCharts.register("component",["datasetGroup",e]),e=b[f],d&&!e&&(e=b[f]=new d,e.chart=this,e.init()),z[0]){b=z[0];e=b.JSONData;z=b.components.data||[];f=e.data.length-(b.config.showSum||0);B=c.data&&c.data.length||0;if(f>B){if(a)for(e=B;e<f;e++)z[e]&&z[e].legendItemId&&a.removeItem(z[e].legendItemId);b.removeData(B,f-B,!1)}b.JSONData=c;b.configure()}else b=new B,z.push(b),b.chart=
this,e&&e.addDataSet(b,0,0),b.index=0,b.init(c)},_dataSegregator:function(b){var a=[];xb(b,function(b){"true"!==b.vline&&!0!==b.vline&&1!==b.vline&&"1"!==b.vline&&a.push(b)});return{data:a}},_setCategories:function(){var b=this.jsonData,a=b.dataset;this.components.xAxis[0].setCategory(b.data||a&&a[0].data)}},Qa.mscartesian,{linethickness:4});Qa("msdybasecartesian",{standaloneInit:!1,_createAxes:function(){var b=this.components,a,c=FusionCharts.register("component",["axis","cartesian"]),z;b.yAxis=
[];b.xAxis=[];b.yAxis[0]=z=new c;b.yAxis[1]=a=new c;b.xAxis[0]=b=new c;z.chart=this;a.chart=this;b.chart=this;z.init();a.init();b.init();this._setCategories()},_feedAxesRawData:function(){var b=this.config,a=this.components,c=a.colorManager,e=this.jsonData,f=e.chart,d,B,g=this.is3d,G=g?z.chart3D:z.chart2D,P,m=b.primaryAxisOnleft=C(f.primaryaxisonleft,1),l=C(f.syncaxislimits,0);B=[{line:[]}];P=[{line:[]}];var q,p=e.trendlines||[];d={outCanfontFamily:I(f.outcnvbasefont,f.basefont,"Verdana,sans"),outCanfontSize:Xa(f.outcnvbasefontsize,
f.basefontsize,10),outCancolor:I(f.outcnvbasefontcolor,f.basefontcolor,c.getColor(G.baseFontColor)).replace(/^#? ([a-f0-9]+)/ig,"#$1"),axisNamePadding:f.xaxisnamepadding,axisValuePadding:f.labelpadding,axisNameFont:f.xaxisnamefont,axisNameFontSize:f.xaxisnamefontsize,axisNameFontColor:f.xaxisnamefontcolor,axisNameFontBold:f.xaxisnamefontbold,axisNameFontItalic:f.xaxisnamefontitalic,axisNameBgColor:f.xaxisnamebgcolor,axisNameBorderColor:f.xaxisnamebordercolor,axisNameAlpha:f.xaxisnamealpha,axisNameFontAlpha:f.xaxisnamefontalpha,
axisNameBgAlpha:f.xaxisnamebgalpha,axisNameBorderAlpha:f.xaxisnameborderalpha,axisNameBorderPadding:f.xaxisnameborderpadding,axisNameBorderRadius:f.xaxisnameborderradius,axisNameBorderThickness:f.xaxisnameborderthickness,axisNameBorderDashed:f.xaxisnameborderdashed,axisNameBorderDashLen:f.xaxisnameborderdashlen,axisNameBorderDashGap:f.xaxisnameborderdashgap,useEllipsesWhenOverflow:f.useellipseswhenoverflow,divLineColor:I(f.vdivlinecolor,f.divlinecolor,c.getColor(G.divLineColor)),divLineAlpha:I(f.vdivlinealpha,
f.divlinealpha,g?c.getColor("divLineAlpha3D"):c.getColor("divLineAlpha")),divLineThickness:C(f.vdivlinethickness,f.divlinethickness,1),divLineIsDashed:!!C(f.vdivlinedashed,f.vdivlineisdashed,f.divlinedashed,f.divlineisdashed,0),divLineDashLen:C(f.vdivlinedashlen,f.divlinedashlen,4),divLineDashGap:C(f.vdivlinedashgap,f.divlinedashgap,2),showAlternateGridColor:C(f.showalternatevgridcolor,0),alternateGridColor:I(f.alternatevgridcolor,c.getColor("altVGridColor")),alternateGridAlpha:I(f.alternatevgridalpha,
c.getColor("altVGridAlpha")),numDivLines:f.numvdivlines,maxLabelHeight:f.maxlabelheight,labelFont:f.labelfont,labelFontSize:f.labelfontsize,labelFontColor:f.labelfontcolor,labelFontAlpha:f.labelalpha,labelFontBold:f.labelfontbold,labelFontItalic:f.labelfontitalic,axisName:f.xaxisname,axisMinValue:f.xaxisminvalue,axisMaxValue:f.xaxismaxvalue,setAdaptiveMin:f.setadaptivexmin,adjustDiv:f.adjustvdiv,labelDisplay:f.labeldisplay,showLabels:f.showlabels,rotateLabels:f.rotatelabels,slantLabel:C(f.slantlabels,
f.slantlabel),labelStep:C(f.labelstep,f.xaxisvaluesstep),showAxisValues:C(f.showxaxisvalues,f.showxaxisvalue),showLimits:f.showvlimits,showDivLineValues:C(f.showvdivlinevalues,f.showvdivlinevalues),zeroPlaneColor:f.vzeroplanecolor,zeroPlaneThickness:C(f.vzeroplanethickness,f.vdivlinethickness,2),zeroPlaneAlpha:C(f.vzeroplanealpha,f.vdivlinealpha,b.zeroplanealpha),showZeroPlaneValue:f.showvzeroplanevalue,trendlineColor:f.trendlinecolor,trendlineToolText:f.trendlinetooltext,trendlineThickness:f.trendlinethickness,
trendlineAlpha:f.trendlinealpha,showTrendlinesOnTop:f.showtrendlinesontop,showAxisLine:g?0:C(f.showxaxisline,f.showaxislines,f.drawAxisLines,0),axisLineThickness:C(f.xaxislinethickness,f.axislinethickness,1),axisLineAlpha:C(f.xaxislinealpha,f.axislinealpha,100),axisLineColor:I(f.xaxislinecolor,f.axislinecolor,"#000000")};b={outCanfontFamily:I(f.outcnvbasefont,f.basefont,"Verdana,sans"),outCanfontSize:Xa(f.outcnvbasefontsize,f.basefontsize,10),outCancolor:I(f.outcnvbasefontcolor,f.basefontcolor,c.getColor(G.baseFontColor)).replace(/^#? ([a-f0-9]+)/ig,
"#$1"),axisNamePadding:C(f.pyaxisnamepadding,f.yaxisnamepadding),axisValuePadding:C(f.pyaxisvaluespadding,f.yaxisvaluespadding),axisNameFont:I(f.pyaxisnamefont,f.yaxisnamefont),axisNameFontSize:C(f.pyaxisnamefontsize,f.yaxisnamefontsize),axisNameFontColor:I(f.pyaxisnamefontcolor,f.yaxisnamefontcolor),axisNameFontBold:C(f.pyaxisnamefontbold,f.yaxisnamefontbold),axisNameFontItalic:C(f.pyaxisnamefontitalic,f.yaxisnamefontitalic),axisNameBgColor:I(f.pyaxisnamebgcolor,f.yaxisnamebgcolor),axisNameBorderColor:I(f.pyaxisnamebordercolor,
f.yaxisnamebordercolor),axisNameAlpha:C(f.pyaxisnamealpha,f.yaxisnamealpha),axisNameFontAlpha:C(f.pyaxisnamefontalpha,f.yaxisnamefontalpha),axisNameBgAlpha:C(f.pyaxisnamebgalpha,f.yaxisnamebgalpha),axisNameBorderAlpha:C(f.pyaxisnameborderalpha,f.yaxisnameborderalpha),axisNameBorderPadding:C(f.pyaxisnameborderpadding,f.yaxisnameborderpadding),axisNameBorderRadius:C(f.pyaxisnameborderradius,f.yaxisnameborderradius),axisNameBorderThickness:C(f.pyaxisnameborderthickness,f.yaxisnameborderthickness),axisNameBorderDashed:C(f.pyaxisnameborderdashed,
f.yaxisnameborderdashed),axisNameBorderDashLen:C(f.pyaxisnameborderdashlen,f.yaxisnameborderdashlen),axisNameBorderDashGap:C(f.pyaxisnameborderdashgap,f.yaxisnameborderdashgap),axisNameWidth:C(f.pyaxisnamewidth,f.yaxisnamewidth),useEllipsesWhenOverflow:f.useellipseswhenoverflow,rotateAxisName:C(f.rotateyaxisname,1),axisName:I(f.pyaxisname,f.yaxisname),divLineColor:I(f.divlinecolor,c.getColor(G.divLineColor)),divLineAlpha:I(f.divlinealpha,c.getColor("divLineAlpha")),divLineThickness:C(f.divlinethickness,
1),divLineIsDashed:!!C(f.divlinedashed,f.divlineisdashed,0),divLineDashLen:C(f.divlinedashlen,4),divLineDashGap:C(f.divlinedashgap,2),showAlternateGridColor:C(f.showalternatehgridcolor,1),alternateGridColor:I(f.alternatehgridcolor,c.getColor("altHGridColor")),alternateGridAlpha:I(f.alternatehgridalpha,c.getColor("altHGridAlpha")),numDivLines:f.numdivlines,axisMinValue:l?C(f.syaxisminvalue,f.pyaxisminvalue,f.yaxisminvalue):C(f.pyaxisminvalue,f.yaxisminvalue),axisMaxValue:l?C(f.syaxismaxvalue,f.pyaxismaxvalue,
f.yaxismaxvalue):C(f.pyaxismaxvalue,f.yaxismaxvalue),setAdaptiveMin:f.setadaptiveymin,adjustDiv:f.adjustdiv,labelStep:f.yaxisvaluesstep,showAxisValues:C(f.showyaxisvalues,f.showyaxisvalue),showLimits:C(f.showyaxislimits,f.showlimits,this.showLimits),showDivLineValues:C(f.showdivlinevalues,f.showdivlinevalue),zeroPlaneColor:f.zeroplanecolor,zeroPlaneThickness:C(f.zeroplanethickness,f.divlinethickness,b.zeroplanethickness,2),zeroPlaneAlpha:C(f.zeroplanealpha,f.divlinealpha,b.zeroplanealpha),showZeroPlaneValue:f.showzeroplanevalue,
showZeroPlaneOnTop:b.showzeroplaneontop,trendlineColor:f.trendlinecolor,trendlineToolText:f.trendlinetooltext,trendlineThickness:f.trendlinethickness,trendlineAlpha:f.trendlinealpha,showTrendlinesOnTop:f.showtrendlinesontop,showAxisLine:g?0:C(f.showyaxisline,f.showaxislines,f.drawAxisLines,0),axisLineThickness:C(f.yaxislinethickness,f.axislinethickness,1),axisLineAlpha:C(f.yaxislinealpha,f.axislinealpha,100),axisLineColor:I(f.yaxislinecolor,f.axislinecolor,"#000000")};c={outCanfontFamily:I(f.outcnvbasefont,
f.basefont,"Verdana,sans"),outCanfontSize:Xa(f.outcnvbasefontsize,f.basefontsize,10),outCancolor:I(f.outcnvbasefontcolor,f.basefontcolor,c.getColor(G.baseFontColor)).replace(/^#? ([a-f0-9]+)/ig,"#$1"),axisNamePadding:f.yaxisnamepadding,axisValuePadding:f.yaxisvaluespadding,axisNameFont:f.syaxisnamefont,axisNameFontSize:f.syaxisnamefontsize,axisNameFontColor:f.syaxisnamefontcolor,axisNameFontBold:f.syaxisnamefontbold,axisNameFontItalic:f.syaxisnamefontitalic,axisNameBgColor:f.syaxisnamebgcolor,axisNameBorderColor:f.syaxisnamebordercolor,
axisNameAlpha:f.syaxisnamealpha,axisNameFontAlpha:f.syaxisnamefontalpha,axisNameBgAlpha:f.syaxisnamebgalpha,axisNameBorderAlpha:f.syaxisnameborderalpha,axisNameBorderPadding:f.syaxisnameborderpadding,axisNameBorderRadius:f.syaxisnameborderradius,axisNameBorderThickness:f.syaxisnameborderthickness,axisNameBorderDashed:f.syaxisnameborderdashed,axisNameBorderDashLen:f.syaxisnameborderdashlen,axisNameBorderDashGap:f.syaxisnameborderdashgap,axisNameWidth:f.syaxisnamewidth,useEllipsesWhenOverflow:f.useellipseswhenoverflow,
rotateAxisName:C(f.rotateyaxisname,1),axisName:f.syaxisname,divLineColor:I(f.divlinecolor,c.getColor(G.divLineColor)),divLineAlpha:I(f.divlinealpha,c.getColor("divLineAlpha")),divLineThickness:C(f.divlinethickness,1),divLineIsDashed:!!C(f.divlinedashed,f.divlineisdashed,0),divLineDashLen:C(f.divlinedashlen,4),divLineDashGap:C(f.divlinedashgap,2),showAlternateGridColor:C(f.showalternatehgridcolor,1),alternateGridColor:I(f.alternatehgridcolor,c.getColor("altHGridColor")),alternateGridAlpha:I(f.alternatehgridalpha,
c.getColor("altHGridAlpha")),numDivLines:f.numdivlines,axisMinValue:l?C(f.syaxisminvalue,f.pyaxisminvalue,f.yaxisminvalue):f.syaxisminvalue,axisMaxValue:l?C(f.syaxismaxvalue,f.pyaxismaxvalue,f.yaxismaxvalue):f.syaxismaxvalue,setAdaptiveMin:f.setadaptivesymin||f.setadaptiveymin,adjustDiv:f.adjustdiv,labelStep:f.yaxisvaluesstep,showAxisValues:C(f.showsyaxisvalues,f.showsyaxisvalue,f.showyaxisvalues,f.showyaxisvalue),showLimits:C(f.showsecondarylimits,f.showyaxislimits,f.showlimits),showDivLineValues:C(f.showdivlinesecondaryvalue,
f.showyaxisvalues,f.showyaxisvalue,1),zeroPlaneColor:f.zeroplanecolor,zeroPlaneThickness:C(f.zeroplanethickness,f.divlinethickness,2),zeroPlaneAlpha:f.zeroplanealpha,showZeroPlaneValue:f.showzeroplanevalue,trendlineColor:f.trendlinecolor,trendlineToolText:f.trendlinetooltext,trendlineThickness:f.trendlinethickness,trendlineAlpha:f.trendlinealpha,showTrendlinesOnTop:f.showtrendlinesontop,showAxisLine:g?0:C(f.showsyaxisline,f.showaxislines,f.drawAxisLines,0),axisLineThickness:C(f.syaxislinethickness,
f.axislinethickness,1),axisLineAlpha:C(f.syaxislinealpha,f.axislinealpha,100),axisLineColor:I(f.syaxislinecolor,f.axislinecolor,"#000000")};d.vtrendlines=e.vtrendlines;l=0;for(G=p.length;l<G;l++)for(e=p[l]&&p[l].line||[],g=e.length,q=0;q<g;q++)f=e[q]||{},f.parentyaxis&&f.parentyaxis.toLowerCase(),"s"===f.parentyaxis?B[0].line.push(f):P[0].line.push(f);b.trendlines=P;c.trendlines=B;P=a.yAxis[0];B=a.yAxis[1];a=a.xAxis[0];1===m?(P.setCommonConfigArr(b,!0,!1,!1),B.setCommonConfigArr(c,!0,!1,!0)):(P.setCommonConfigArr(b,
!0,!1,!0),B.setCommonConfigArr(c,!0,!1,!1));a.setCommonConfigArr(d,!1,!1,!1);P.configure();B.configure();a.configure();B.setAxisConfig({isActive:!1,isPercent:this.isPercentage,axisIndex:1,uniqueClassName:1})},_setAxisLimits:function(){var b=this.components,a=b.dataset,c=b.yAxis,b=b.xAxis,z,f=a.length,e,d=-Infinity,B=Infinity,g=-Infinity,G=Infinity,P=Infinity,m=-Infinity,l,q,p;l=C(this.jsonData.chart.syncaxislimits,0);var n={};q=function(b){return-Infinity===b||Infinity===b?null:b};var t=function(b){r?
(g=ka(g,b.sYMax||b.max),G=Sa(G,b.sYMin||b.min)):(d=ka(d,b.max),B=Sa(B,b.min));m=ka(m,b.xMax||-Infinity);P=Sa(P,b.xMin||Infinity)},r=0;for(e=0;e<f;e++)z=a[e],p=z.groupManager,r=z.config.parentYAxis,p?(n[z.type]=p,n[z.type].yAxisIndex=r):(z=z.getDataLimits(),t(z));for(p in n)r=n[p].yAxisIndex,z=n[p].getDataLimits(),d=ka(d,z.max),B=Sa(B,z.min),g=ka(g,z.sYMax),G=Sa(G,z.sYMin);a=this._getTrendLineMinMax("h");p=this._getTrendLineMinMax("h","s");d=ka(d,a.max);B=Sa(B,a.min);g=ka(g,p.max);G=Sa(G,p.min);l?
(l=ka(d,g),q=Sa(B,G),c[0].setDataLimit(l,q),c[1].setDataLimit(l,q)):(d=q(d),B=q(B),g=q(g),G=q(G),c[0].setDataLimit(d,B),c[1].setDataLimit(g,G));c[0].getDivLineCount();if(-Infinity!==m||Infinity!==P)b[0].config.xaxisrange={max:m,min:P},b[0].setDataLimit(m,P)},_postSpaceManagement:function(){var b=this.config,a=this.components,c=a.yAxis,z=a.xAxis&&a.xAxis[0],f=c[0],c=c[1],e=a.legend,d=b.xDepth,B=a.canvas.config,g=B.canvasBorderWidth,G=B.canvasPadding,P=B.canvasPaddingLeft,m=B.canvasPaddingRight,a=B.canvasPaddingTop,
l=b.primaryAxisOnleft,B=B.canvasPaddingBottom;z&&z.setAxisDimention({x:b.canvasLeft+(d||0)+ka(P,G),y:b.canvasBottom+(b.shift||0)+g,opposite:b.canvasTop-g,axisLength:b.canvasWidth-(d||0)-ka(P,G)-ka(m,G)});l?(b.yAxisStartXPos=b.canvasLeft-g,b.sYAxisStartXPos=b.canvasRight+g):(b.yAxisStartXPos=b.canvasRight+g,b.sYAxisStartXPos=b.canvasLeft-g);g=b.yAxisStartXPos;G=b.sYAxisStartXPos;f&&f.setAxisDimention({x:g,y:b.canvasTop+a,opposite:G,axisLength:b.canvasHeight-a-B});c&&c.setAxisDimention({x:G,y:b.canvasTop+
a,opposite:g,axisLength:b.canvasHeight-a-B});z&&z.shiftLabels(-d,0);e.postSpaceManager();this.config.realtimeEnabled&&this._setRealTimeCategories&&this._setRealTimeCategories();this._adjustCanvasPadding()}},Qa.mscartesian);Qa("mscartesian3d",{standaloneInit:!1,is3d:!0,_createDatasets:function(){var b=this.components,a=b.xAxis[0],c=this.jsonData,z=c.dataset,f=z&&z.length,e,d,B,g=this.defaultDatasetType,G=this.applicableDSList,P=this.components.legend,m,l,q,p,n=this.config.isstacked,t,r,w=[],C=this.isRealTime,
v=this.config.catLen,A={};z||this.setChartMessage();this.config.categories=c.categories&&c.categories[0].category;e=b.dataset||(b.dataset=[]);d=e.length;for(c=0;c<f;c++)if(p=z[c],p.seriesname&&(p.seriesname=Ja(p.seriesname)),B=p.parentyaxis||ba,l=(l=this.isDual&&"s"===B.toLowerCase()?I(p.renderas,this.sDefaultDatasetType):I(p.renderas,g))&&l.toLowerCase(),G[l]||(l=g),q=FusionCharts.get("component",["dataset",l]))void 0===A[l]?A[l]=0:A[l]++,t="datasetGroup_"+l,B=FusionCharts.register("component",["datasetGroup",
l]),(m=b[t])&&w.push(m),B&&!m&&(m=b[t]=new B,m.chart=this,m.init()),(B=e[c])?(l=a.getCategoryLen(),t=v-l,q=C?B.components:B.JSONData,r=q.data&&q.data.length||0,q=p.data&&p.data.length||0,r-=q,t>r||(t=r,l=q),0<t&&B.removeData(l,t,!1),e[c].JSONData=p,e[c].configure(),e[c]._deleteGridImages&&e[c]._deleteGridImages()):(B=new q,e.push(B),B.chart=this,B.index=c,m&&(n?m.addDataSet(B,0,A[l]):m.addDataSet(B,A[l],0)),B.init(p));if(d>f){t=d-f;m&&n&&m.removeDataSet(0,c,t);b=c;for(f=t+c;b<f;b++)m&&!n&&m.removeDataSet(c,
0,1),e[b].visible=!1,e[b].draw(),P.removeItem(e[b].legendItemId);e.splice(c,t)}this.config.catLen=a.getCategoryLen()},_drawCanvas:function(){var b=this.config,a=b.canvasLeft,c=b.canvasTop,e=b.canvasWidth,f=b.canvasHeight,d=this.jsonData.chart,B=this.components,g=B.canvas,G=B.colorManager,B=B.paper,P=g.graphics,m=P.canvasBorderElement,q=P.canvasElement,p=g.config,n=p.clip={},g=this.graphics.canvasGroup,t=P.canvasBg,r=P.canvas3DBase,w=this.get(l,N),A=w.animType,H=w.animObj,K=w.dummyObj,w=w.duration,
Q=P.canvas3dbaseline,R=p.canvasBgColor,F=p.showCanvasBG=!!C(d.showcanvasbg,1),L=b.canvasBgDepth,J=b.showCanvasBase,Ba=b.canvasBaseDepth,ha=p.canvasBaseColor3D=I(d.canvasbasecolor,G.getColor("canvasBaseColor3D")),W=p.use3DLighting=C(d.use3dlighting,1),R=z.chart3D,M=p.canvasBorderRadius=C(d.plotborderradius,0),U=p.canvasBorderColor=$a(I(d.canvasbordercolor,G.getColor("canvasBorderColor"))),Z=p.canBGAlpha=I(d.canvasbgalpha,G.getColor("canvasBgAlpha")),X=p.canBGColor=I(d.canvasbgcolor,G.getColor(R.canvasBgColor)),
da=b.xDepth,d=b.yDepth,G=b.canvasBasePadding||2,R=W?p.canvasBgColor={FCcolor:{color:lb(X,85)+vb+db(X,55),alpha:Z+vb+Z,ratio:yb,angle:fb(b.width-(b.marginLeft+b.marginRight),b.height-(b.marginTop+b.marginBottom),1)}}:p.canvasBgColor=$a(X,Z);X.split(vb);Z.split(vb);da=p.xDepth=10;d=p.yDepth=10;b={x:a-0,y:c-0,width:e+0,height:f+0,r:M,"stroke-width":0,stroke:U,"stroke-linejoin":v};m?(m.animateWith(K,H,{x:a-0,y:c-0,width:e+0,height:f+0,r:M},w,A),m.attr({"stroke-width":0,stroke:U,"stroke-linejoin":v})):
P.canvasBorderElement=B.rect(b,g);n["clip-canvas"]=[ka(0,a-da),ka(0,c),ka(1,e+da),ka(1,f+d)];n["clip-canvas-init"]=[ka(0,a-da),ka(0,c-d),1,ka(1,f+2*d)];b={x:a,y:c,width:e,height:f,r:M,"stroke-width":0,stroke:"none",fill:Pa(R)};F?(q?(q.show(),q.animateWith(K,H,{x:a,y:c,width:e,height:f,r:M},w,A),q.attr({"stroke-width":0,stroke:"none",fill:Pa(R)})):P.canvasElement=B.rect(b,g),b=["M",a+e,",",c,"L",a+e+L,",",c+1.2*L,",",a+e+L,",",c+f-L,",",a+e,",",c+f,"Z"],t?(t.show(),t.animateWith(K,H,{path:b},w,A),
t.attr({path:b})):t=P.canvasBg=B.path(b,g),t.attr({"stroke-width":0,stroke:"none",fill:Pa(R)})):(q&&q.hide(),t&&t.hide());J?(b=a-da-G,m=c+f+d+G,q=da+G,t=d+G,r?(r.show(),r._.cubeside.show(),r._.cubetop.show(),r.animateWith(K,H,{cubepath:[b,m,e,Ba,q,t]},w,A),r.attr({cubepath:[b,m,e,Ba,q,t]})):r=P.canvas3DBase=B.cubepath(b,m,e,Ba,q,t,g),r.attr({stroke:"none","stroke-width":0,fill:[ha.replace(V,va),!W]}),Q?(Q.show(),Q.animateWith(K,H,{path:["M",a,c+f,"H",e+a]},w,A)):Q=P.canvas3dbaseline=B.path(void 0,
g),Q.attr({path:["M",a,c+f,"H",e+a],stroke:D.tintshade(ha.replace(V,va),.05).rgba})):(r&&(r.hide(),r._.cubeside.hide(),r._.cubetop.hide()),Q&&Q.hide())}},Qa.mscartesian,{showplotborder:0});Qa("msdybasecartesian3d",{standaloneInit:!1,is3d:!0,_drawCanvas:Qa.mscartesian3d},Qa.msdybasecartesian);Qa("sscartesian3d",{standaloneInit:!1,hasLegend:!1,is3d:!0,_drawCanvas:Qa.mscartesian3d},Qa.sscartesian,{showplotborder:0});Qa("msbarcartesian",{standaloneInit:!1,_createAxes:function(){var b=this.components,
a=FusionCharts.get("component",["axis","cartesian"]),c;b.yAxis=[];b.xAxis=[];b.yAxis[0]=c=new a;b.xAxis[0]=b=new a;c.chart=this;b.chart=this;c.init();b.init();this._setCategories()},_feedAxesRawData:function(){var b=this.config,a=this.components,c=a.colorManager,e=this.jsonData,f=e.chart,d,B=this.is3d,g=B?z.chart3D:z.chart2D;d={outCanfontFamily:I(f.outcnvbasefont,f.basefont,"Verdana,sans"),outCanfontSize:Xa(f.outcnvbasefontsize,f.basefontsize,10),outCancolor:I(f.outcnvbasefontcolor,f.basefontcolor,
c.getColor(g.baseFontColor)).replace(/^#? ([a-f0-9]+)/ig,"#$1"),axisNamePadding:f.xaxisnamepadding,maxLabelWidthPercent:f.maxlabelwidthpercent,axisValuePadding:f.labelpadding,axisNameFont:f.xaxisnamefont,axisNameFontSize:f.xaxisnamefontsize,axisNameFontColor:f.xaxisnamefontcolor,axisNameFontBold:f.xaxisnamefontbold,axisNameFontItalic:f.xaxisnamefontitalic,axisNameBgColor:f.xaxisnamebgcolor,axisNameBorderColor:f.xaxisnamebordercolor,axisNameAlpha:f.xaxisnamealpha,axisNameFontAlpha:f.xaxisnamefontalpha,
axisNameBgAlpha:f.xaxisnamebgalpha,axisNameBorderAlpha:f.xaxisnameborderalpha,axisNameBorderPadding:f.xaxisnameborderpadding,axisNameBorderRadius:f.xaxisnameborderradius,axisNameBorderThickness:f.xaxisnameborderthickness,axisNameBorderDashed:f.xaxisnameborderdashed,axisNameBorderDashLen:f.xaxisnameborderdashlen,axisNameBorderDashGap:f.xaxisnameborderdashgap,axisNameWidth:f.xaxisnamewidth,useEllipsesWhenOverflow:f.useellipseswhenoverflow,divLineColor:I(f.vdivlinecolor,f.divlinecolor,c.getColor(g.divLineColor)),
divLineAlpha:I(f.vdivlinealpha,f.divlinealpha,B?c.getColor("divLineAlpha3D"):c.getColor("divLineAlpha")),divLineThickness:C(f.vdivlinethickness,f.divlinethickness,1),divLineIsDashed:!!C(f.vdivlinedashed,f.vdivlineisdashed,f.divlinedashed,f.divlineisdashed,0),divLineDashLen:C(f.vdivlinedashlen,f.divlinedashlen,4),divLineDashGap:C(f.vdivlinedashgap,f.divlinedashgap,2),showAlternateGridColor:C(f.showalternatehgridcolor,1),alternateGridColor:I(f.alternatehgridcolor,c.getColor("altHGridColor")),alternateGridAlpha:I(f.alternatehgridalpha,
c.getColor("altHGridAlpha")),numDivLines:f.numvdivlines,labelFont:f.labelfont,labelFontSize:f.labelfontsize,labelFontColor:f.labelfontcolor,labelFontAlpha:f.labelalpha,labelFontBold:f.labelfontbold,labelFontItalic:f.labelfontitalic,axisName:f.xaxisname,axisMinValue:f.xaxisminvalue,axisMaxValue:f.xaxismaxvalue,setAdaptiveMin:f.setadaptivexmin,adjustDiv:f.adjustvdiv,labelDisplay:f.labeldisplay,showLabels:f.showlabels,rotateLabels:f.rotatelabels,slantLabel:C(f.slantlabels,f.slantlabel),labelStep:C(f.labelstep,
f.xaxisvaluesstep),showAxisValues:C(f.showxaxisvalues,f.showxaxisvalue),showLimits:f.showvlimits,showDivLineValues:C(f.showvdivlinevalues,f.showvdivlinevalues),zeroPlaneColor:f.vzeroplanecolor,zeroPlaneThickness:C(f.vzeroplanethickness,f.vdivlinethickness,2),zeroPlaneAlpha:C(f.vzeroplanealpha,f.vdivlinealpha,b.zeroplanealpha),showZeroPlaneValue:f.showvzeroplanevalue,trendlineColor:f.trendlinecolor,trendlineToolText:f.trendlinetooltext,trendlineThickness:f.trendlinethickness,rotateAxisName:C(f.rotatexaxisname,
1),trendlineAlpha:f.trendlinealpha,showTrendlinesOnTop:f.showtrendlinesontop,showAxisLine:B?0:C(f.showxaxisline,f.showaxislines,f.drawAxisLines,0),axisLineThickness:C(f.xaxislinethickness,f.axislinethickness,1),axisLineAlpha:C(f.xaxislinealpha,f.axislinealpha,100),axisLineColor:I(f.xaxislinecolor,f.axislinecolor,"#000000")};b={outCanfontFamily:I(f.outcnvbasefont,f.basefont,"Verdana,sans"),outCanfontSize:Xa(f.outcnvbasefontsize,f.basefontsize,10),outCancolor:I(f.outcnvbasefontcolor,f.basefontcolor,
c.getColor(g.baseFontColor)).replace(/^#? ([a-f0-9]+)/ig,"#$1"),axisNamePadding:f.yaxisnamepadding,axisValuePadding:f.yaxisvaluespadding,axisNameFont:f.yaxisnamefont,axisNameFontSize:f.yaxisnamefontsize,axisNameFontColor:f.yaxisnamefontcolor,axisNameFontBold:f.yaxisnamefontbold,axisNameFontItalic:f.yaxisnamefontitalic,axisNameBgColor:f.yaxisnamebgcolor,axisNameBorderColor:f.yaxisnamebordercolor,axisNameAlpha:f.yaxisnamealpha,axisNameFontAlpha:f.yaxisnamefontalpha,axisNameBgAlpha:f.yaxisnamebgalpha,
axisNameBorderAlpha:f.yaxisnameborderalpha,axisNameBorderPadding:f.yaxisnameborderpadding,axisNameBorderRadius:f.yaxisnameborderradius,axisNameBorderThickness:f.yaxisnameborderthickness,axisNameBorderDashed:f.yaxisnameborderdashed,axisNameBorderDashLen:f.yaxisnameborderdashlen,axisNameBorderDashGap:f.yaxisnameborderdashgap,axisNameWidth:f.yaxisnamewidth,useEllipsesWhenOverflow:f.useellipseswhenoverflow,axisName:f.yaxisname,divLineColor:I(f.divlinecolor,c.getColor(g.divLineColor)),divLineAlpha:I(f.divlinealpha,
B?c.getColor("divLineAlpha3D"):c.getColor("divLineAlpha")),divLineThickness:C(f.divlinethickness,1),divLineIsDashed:!!C(f.divlinedashed,f.divlineisdashed,0),divLineDashLen:C(f.divlinedashlen,4),divLineDashGap:C(f.divlinedashgap,2),showAlternateGridColor:C(f.showalternatevgridcolor,1),alternateGridColor:I(f.alternatevgridcolor,c.getColor("altVGridColor")),alternateGridAlpha:I(f.alternatevgridalpha,c.getColor("altVGridAlpha")),numDivLines:f.numdivlines,axisMinValue:f.yaxisminvalue,axisMaxValue:f.yaxismaxvalue,
setAdaptiveMin:f.setadaptiveymin,adjustDiv:f.adjustdiv,labelStep:f.yaxisvaluesstep,showAxisValues:C(f.showyaxisvalues,f.showyaxisvalue),showLimits:C(f.showyaxislimits,f.showlimits,this.showLimits),showDivLineValues:C(f.showdivlinevalues,f.showdivlinevalue),zeroPlaneColor:f.zeroplanecolor,zeroPlaneThickness:C(f.zeroplanethickness,f.divlinethickness,2),zeroPlaneAlpha:C(f.zeroplanealpha,f.divlinealpha,b.zeroplanealpha),showZeroPlaneValue:f.showzeroplanevalue,trendlineColor:f.trendlinecolor,trendlineToolText:f.trendlinetooltext,
trendlineThickness:f.trendlinethickness,trendlineAlpha:f.trendlinealpha,isTrendZone:0,showTrendlinesOnTop:f.showtrendlinesontop,showAxisLine:B?0:C(f.showyaxisline,f.showaxislines,f.drawAxisLines,0),axisLineThickness:C(f.yaxislinethickness,f.axislinethickness,1),axisLineAlpha:C(f.yaxislinealpha,f.axislinealpha,100),axisLineColor:I(f.yaxislinecolor,f.axislinecolor,"#000000"),numberFormatterFn:"yAxis"};b.vtrendlines=e.trendlines;d.trendlines=e.vtrendlines;e=a.yAxis[0];a=a.xAxis[0];e.setCommonConfigArr(b,
!1,!1,!1);a.setCommonConfigArr(d,!0,!0,!1);e.configure();a.configure()},_spaceManager:function(){var b,a,c=this.config,z=this.components,f=z.yAxis&&z.yAxis[0],e=z.xAxis&&z.xAxis||[];a=z.legend.config.legendPos;var d=c.xDepth,B=c.yDepth,g=c.canvasBgDepth,G=c.canvasBaseDepth,P=c.canvasBasePadding,m=z.canvas.config.canvasBorderWidth,l=c.realTimeConfig&&c.realTimeConfig.showRTValue,q=c.borderWidth,p=c.canvasMarginTop,n=c.canvasMarginBottom,t=c.canvasMarginLeft,r=c.canvasMarginRight,z=c.minCanvasHeight,
w=c.minCanvasWidth,C=c.minChartWidth,v=c.minChartHeight,A=c.height,K=c.width,D=!1,F=!1,I,L=c.origCanvasTopMargin,J=c.origCanvasBottomMargin,M=c.origCanvasLeftMargin,U=c.origCanvasRightMargin,Z,X,da;c.canvasWidth-2*q<C&&(Z=(c.canvasWidth-C)/2);c.canvasHeight-2*q<v&&(b=(c.canvasHeight-v)/2);this._allocateSpace({top:b||q,bottom:b||q,left:Z||q,right:Z||q});e=e[0];b=.7*c.availableWidth;c.yAxisSpaceAllocation=b=e&&e.placeAxis(b);e&&this._allocateSpace(b);e=.225*c.availableHeight;e=this._manageActionBarSpace&&
this._manageActionBarSpace(e)||{};this._allocateSpace(e);this._manageLegendSpace();a=a===H?.6*c.availableHeight:.6*c.availableWidth;B&&(this._allocateSpace({left:B}),c.shift=d+P+G);g&&this._allocateSpace({top:g});c.canvasWidth-2*m<w&&(da=(c.canvasWidth-w)/2);this._allocateSpace({left:da||m,right:da||m});w>K-t-r&&(F=!0,B=c.canvasWidth-w,d=t+r,t=c.canvasMarginLeft=B*t/d,r=c.canvasMarginRight=B*r/d);t=t>c.canvasLeft?t-c.canvasLeft:0;r=r>K-c.canvasRight?r+c.canvasRight-K:0;this._allocateSpace({left:t,
right:r});this._allocateSpace({left:G});F&&(d=M+U,G=c.canvasWidth,G>w&&(B=G-w,t=B*M/d,r=B*U/d),this._allocateSpace({left:t,right:r}));c.actualCanvasMarginRight=r;c.actualCanvasMarginBottom=I;this._manageChartMenuBar(a);a=.2*c.availableHeight;this._allocateSpace(this._getSumValueSpace(a));a=.3*c.availableHeight;c.realtimeEnabled&&(l?this._allocateSpace(this._realTimeValuePositioning(a)):this._hideRealTimeValue());a=.6*c.availableHeight;c.xAxisSpaceAllocation=I=f&&f.placeAxis(a);f&&this._allocateSpace(I);
a=.3*c.availableHeight;this._manageScrollerPosition&&this._manageScrollerPosition(a);c.canvasHeight-2*m<z&&(X=(c.canvasHeight-z)/2);this._allocateSpace({top:X||m,bottom:X||m});z>A-p-n&&(D=!0,B=c.canvasHeight-z,d=p+n,p=c.canvasMarginTop=B*p/d,n=c.canvasMarginBottom=B*n/d);f=p>c.canvasTop?p-c.canvasTop:0;I=n>A-c.canvasBottom?n+c.canvasBottom-A:0;this._allocateSpace({top:f,bottom:I});D&&(d=L+J,n=c.canvasHeight,n>z&&(B=n-z,f=B*L/d,I=B*J/d),this._allocateSpace({top:f,bottom:I}));c.actualCanvasMarginTop=
f;c.actualCanvasMarginLeft=t},_postSpaceManagement:function(){var b=this.config,a=this.components,c=a.xAxis&&a.xAxis[0],z=a.yAxis&&a.yAxis[0],f=a.legend,e=b.xDepth,d=a.canvas.config,a=d.canvasBorderWidth,B=d.canvasPadding,g,G,P;z&&this._allocateXAxisLabelSpace(z);g=d.canvasPaddingLeft;G=d.canvasPaddingRight;P=d.canvasPaddingTop;d=d.canvasPaddingBottom;z&&z.setAxisDimention({x:b.canvasLeft+g,y:b.canvasBottom+a,opposite:b.canvasTop-a,axisLength:b.canvasWidth-g-G});c&&c.setAxisDimention({x:b.canvasLeft-
(b.shift||0)-a,y:b.canvasTop+(e||0)+ka(P,B),opposite:b.canvasRight+a,axisLength:b.canvasHeight-(e||0)-ka(P,B)-ka(d,B)});f.postSpaceManager()}},Qa.mscartesian,{maxbarheight:50});Qa("ssbarcartesian",{standaloneInit:!1,_createAxes:Qa.msbarcartesian,_feedAxesRawData:Qa.msbarcartesian,_spaceManager:Qa.msbarcartesian,_postSpaceManagement:Qa.msbarcartesian,_allocateXAxisLabelSpace:Qa.msbarcartesian},Qa.sscartesian);Qa("msbarcartesian3d",{standaloneInit:!1,_createDatasets:Qa.mscartesian3d,is3d:!0,_drawCanvas:function(){var b=
this.config,a=b.canvasLeft,h=b.canvasTop,e=b.canvasWidth,f=b.canvasHeight,d=this.jsonData.chart,B=this.components,g=B.canvas,G=B.colorManager,B=B.paper,P=g.graphics,m=P.canvasBorderElement,q=P.canvasElement,p=g.config,n=p.clip={},g=this.graphics.canvasGroup,t=P.canvasBg,r=P.canvas3DBase,w=this.get(l,N),A=w.animType,H=w.animObj,K=w.dummyObj,w=w.duration,Q=P.canvas3dbaseline,R=p.canvasBgColor,F=p.showCanvasBG=!!C(d.showcanvasbg,1),L=b.canvasBgDepth,J=b.showCanvasBase,Ba=b.canvasBaseDepth,ha=p.canvasBaseColor3D=
I(d.canvasbasecolor,G.getColor("canvasBaseColor3D")),W=p.use3DLighting=C(d.use3dlighting,1),R=z.chart3D,M=p.canvasBorderRadius=C(d.plotborderradius,0),U=p.canvasBorderWidth=0,Z=.5*U,X=p.canvasBorderColor=$a(I(d.canvasbordercolor,G.getColor("canvasBorderColor"))),da=p.canBGAlpha=I(d.canvasbgalpha,G.getColor("canvasBgAlpha")),ca=p.canBGColor=I(d.canvasbgcolor,G.getColor(R.canvasBgColor)),G=p.xDepth,d=p.yDepth,R=W?p.canvasBgColor={FCcolor:{color:lb(ca,85)+vb+db(ca,55),alpha:da+vb+da,ratio:yb,angle:fb(b.width-
(b.marginLeft+b.marginRight),b.height-(b.marginTop+b.marginBottom),1)}}:p.canvasBgColor=$a(ca,da);ca.split(vb);da.split(vb);G=p.xDepth=5;d=p.yDepth=5;b={x:a-Z,y:h-Z,width:e+U,height:f+U,r:M,"stroke-width":U,stroke:X,"stroke-linejoin":2<U?c:v};m?(m.animateWith(K,H,{x:a-Z,y:h-Z,width:e+U,height:f+U,r:M},w,A),m.attr({"stroke-width":U,stroke:X,"stroke-linejoin":2<U?c:v})):P.canvasBorderElement=B.rect(b,g);n["clip-canvas"]=[ka(0,a-G),ka(0,h),ka(1,e+G),ka(1,f+d)];n["clip-canvas-init"]=[ka(0,a-G),ka(0,h-
d),1,ka(1,f+2*d)];b={x:a,y:h,width:e,height:f,r:M,"stroke-width":0,stroke:"none",fill:Pa(R)};F?(q?(q.show(),q.animateWith(K,H,{x:a,y:h,width:e,height:f,r:M},w,A),q.attr({"stroke-width":0,stroke:"none",fill:Pa(R)})):P.canvasElement=B.rect(b,g),e=["M",a,",",h,"L",a+1.2*L,",",h-L,",",a+e-L,",",h-L,",",a+e,",",h,"Z"],t?(t.show(),t.animateWith(K,H,{path:e},w,A),t.attr({path:e})):t=P.canvasBg=B.path(e,g),t.attr({"stroke-width":0,stroke:"none",fill:Pa(R)})):(q&&q.hide(),t&&t.hide());J?(e=a-G-Ba-1,b=h+d+
1,m=G+1,q=d+1,r?(r.show(),r._.cubeside.show(),r._.cubetop.show(),r.animateWith(K,H,{cubepath:[e,b,Ba,f,m,q]},w,A),r.attr({cubepath:[e,b,Ba,f,m,q]})):r=P.canvas3DBase=B.cubepath(e,b,Ba,f,m,q,g),r.attr({stroke:"none","stroke-width":0,fill:[ha.replace(V,va),!W]}),Q?(Q.show(),Q.animateWith(K,H,{path:["M",a,h,"V",f+h]},w,A)):Q=P.canvas3dbaseline=B.path(void 0,g),Q.attr({path:["M",a,h,"V",f+h],stroke:D.tintshade(ha.replace(V,va),.05).rgba})):(r&&(r.hide(),r._.cubeside.hide(),r._.cubetop.hide()),Q&&Q.hide())}},
Qa.msbarcartesian,{showplotborder:0});Qa("ssbarcartesian3d",{standaloneInit:!1,_createAxes:Qa.msbarcartesian,_feedAxesRawData:Qa.msbarcartesian,_drawCanvas:Qa.msbarcartesian3d,_spaceManager:Qa.msbarcartesian,_postSpaceManagement:Qa.msbarcartesian,_allocateXAxisLabelSpace:Qa.msbarcartesian},Qa.sscartesian3d);Qa("mspolar",{standaloneInit:!1,hasCanvas:!1,_createAxes:function(){var b=this.components,a=FusionCharts.register("component",["axis","polarcartesan"]),c=FusionCharts.register("component",["axis",
"polar"]);b.yAxis=[];b.xAxis=[];b.yAxis[0]=a=new a;b.xAxis[0]=b=new c;a.chart=this;b.chart=this;a.init();b.init();a.setAxisConfig({polarAxis:b});this._setCategories()},_feedAxesRawData:function(){var b=this.components,a=b.colorManager,c=this.jsonData,e=c.chart,f,d=(f=this.is3d)?z.chart3D:z.chart2D;f={outCanfontFamily:I(e.outcnvbasefont,e.basefont,"Verdana,sans"),outCanfontSize:Xa(e.outcnvbasefontsize,e.basefontsize,10),outCancolor:I(e.outcnvbasefontcolor,e.basefontcolor,a.getColor(d.baseFontColor)).replace(/^#? ([a-f0-9]+)/ig,
"#$1"),axisNamePadding:e.xaxisnamepadding,axisValuePadding:e.labelpadding,axisNameFont:e.xaxisnamefont,axisNameFontSize:e.xaxisnamefontsize,axisNameFontColor:e.xaxisnamefontcolor,axisNameFontBold:e.xaxisnamefontbold,axisNameFontItalic:e.xaxisnamefontitalic,axisNameBgColor:e.xaxisnamebgcolor,axisNameBorderColor:e.xaxisnamebordercolor,axisNameAlpha:e.xaxisnamealpha,axisNameFontAlpha:e.xaxisnamefontalpha,axisNameBgAlpha:e.xaxisnamebgalpha,axisNameBorderAlpha:e.xaxisnameborderalpha,axisNameBorderPadding:e.xaxisnameborderpadding,
axisNameBorderRadius:e.xaxisnameborderradius,axisNameBorderThickness:e.xaxisnameborderthickness,axisNameBorderDashed:e.xaxisnameborderdashed,axisNameBorderDashLen:e.xaxisnameborderdashlen,axisNameBorderDashGap:e.xaxisnameborderdashgap,useEllipsesWhenOverflow:e.useellipseswhenoverflow,divLineColor:I(e.vdivlinecolor,e.divlinecolor,a.getColor(d.divLineColor)),divLineAlpha:I(e.vdivlinealpha,e.divlinealpha,f?a.getColor("divLineAlpha3D"):a.getColor("divLineAlpha")),divLineThickness:C(e.vdivlinethickness,
e.divlinethickness,1),divLineIsDashed:!!C(e.vdivlinedashed,e.vdivlineisdashed,e.divlinedashed,e.divlineisdashed,0),divLineDashLen:C(e.vdivlinedashlen,e.divlinedashlen,4),divLineDashGap:C(e.vdivlinedashgap,e.divlinedashgap,2),showAlternateGridColor:C(e.showalternatevgridcolor,1),alternateGridColor:I(e.alternatevgridcolor,a.getColor("altVGridColor")),alternateGridAlpha:I(e.alternatevgridalpha,a.getColor("altVGridAlpha")),numDivLines:e.numvdivlines,labelFont:e.labelfont,labelFontSize:e.labelfontsize,
labelFontColor:e.labelfontcolor,labelFontAlpha:e.labelalpha,labelFontBold:e.labelfontbold,labelFontItalic:e.labelfontitalic,axisName:e.yaxisname,axisMinValue:e.xaxisminvalue,axisMaxValue:e.xaxismaxvalue,setAdaptiveMin:e.setadaptivexmin,adjustDiv:e.adjustvdiv,labelDisplay:e.labeldisplay,showLabels:e.showlabels,rotateLabels:e.rotatelabels,slantLabel:C(e.slantlabels,e.slantlabel),labelStep:C(e.labelstep,e.xaxisvaluesstep),showAxisValues:C(e.showxaxisvalues,e.showxaxisvalue),showLimits:e.showvlimits,
showDivLineValues:C(e.showvdivlinevalues,e.showvdivlinevalues),zeroPlaneColor:e.vzeroplanecolor,zeroPlaneThickness:e.vzeroplanethickness,zeroPlaneAlpha:e.vzeroplanealpha,showZeroPlaneValue:e.showvzeroplanevalue,trendlineColor:e.trendlinecolor,trendlineToolText:e.trendlinetooltext,trendlineThickness:e.trendlinethickness,trendlineAlpha:e.trendlinealpha,showTrendlinesOnTop:e.showtrendlinesontop,showAxisLine:C(e.showxaxisline,e.showaxislines,e.drawAxisLines,0),axisLineThickness:C(e.xaxislinethickness,
e.axislinethickness,1),axisLineAlpha:C(e.xaxislinealpha,e.axislinealpha,100),axisLineColor:I(e.xaxislinecolor,e.axislinecolor,"#000000"),showRadarBorder:e.showradarborder,radarBorderColor:e.radarbordercolor,radarBorderThickness:e.radarborderthickness,radarBorderAlpha:e.radarborderalpha,radarFillColor:e.radarfillcolor,radarFillAlpha:e.radarfillalpha,radarSpikeColor:e.radarspikecolor,radarSpikeThickness:e.radarspikethickness,radarSpikeAlpha:e.radarspikealpha,radarInLineAlpha:e.radarinlinealpha};a={outCanfontFamily:I(e.outcnvbasefont,
e.basefont,"Verdana,sans"),outCanfontSize:Xa(e.outcnvbasefontsize,e.basefontsize,10),outCancolor:I(e.outcnvbasefontcolor,e.basefontcolor,a.getColor(d.baseFontColor)).replace(/^#? ([a-f0-9]+)/ig,"#$1"),axisNamePadding:e.yaxisnamepadding,axisValuePadding:e.yaxisvaluespadding,axisNameFont:e.yaxisnamefont,axisNameFontSize:e.yaxisnamefontsize,axisNameFontColor:e.yaxisnamefontcolor,axisNameFontBold:e.yaxisnamefontbold,axisNameFontItalic:e.yaxisnamefontitalic,axisNameBgColor:e.yaxisnamebgcolor,axisNameBorderColor:e.yaxisnamebordercolor,
axisNameAlpha:e.yaxisnamealpha,axisNameFontAlpha:e.yaxisnamefontalpha,axisNameBgAlpha:e.yaxisnamebgalpha,axisNameBorderAlpha:e.yaxisnameborderalpha,axisNameBorderPadding:e.yaxisnameborderpadding,axisNameBorderRadius:e.yaxisnameborderradius,axisNameBorderThickness:e.yaxisnameborderthickness,axisNameBorderDashed:e.yaxisnameborderdashed,axisNameBorderDashLen:e.yaxisnameborderdashlen,axisNameBorderDashGap:e.yaxisnameborderdashgap,axisNameWidth:e.yaxisnamewidth,useEllipsesWhenOverflow:e.useellipseswhenoverflow,
rotateAxisName:C(e.rotateyaxisname,1),axisName:e.xaxisname,divLineColor:I(e.divlinecolor,a.getColor(d.divLineColor)),divLineAlpha:I(e.divlinealpha,a.getColor("divLineAlpha")),divLineThickness:C(e.divlinethickness,1),divLineIsDashed:!!C(e.divlinedashed,e.divlineisdashed,0),divLineDashLen:C(e.divlinedashlen,4),divLineDashGap:C(e.divlinedashgap,2),showAlternateGridColor:C(e.showalternatehgridcolor,1),alternateGridColor:I(e.alternatehgridcolor,a.getColor("altHGridColor")),alternateGridAlpha:I(e.alternatehgridalpha,
a.getColor("altHGridAlpha")),numDivLines:e.numdivlines,axisMinValue:e.yaxisminvalue,axisMaxValue:e.yaxismaxvalue,setAdaptiveMin:e.setadaptiveymin,adjustDiv:e.adjustdiv,labelStep:e.yaxisvaluesstep,showAxisValues:C(e.showyaxisvalues,e.showyaxisvalue),showLimits:C(e.showyaxislimits,e.showlimits,this.showLimits),showDivLineValues:C(e.showdivlinevalues,e.showdivlinevalue),zeroPlaneColor:e.zeroplanecolor,zeroPlaneThickness:C(e.zeroplanethickness,e.divlinethickness,2),zeroPlaneAlpha:e.zeroplanealpha,showZeroPlaneValue:e.showzeroplanevalue,
trendlineColor:e.trendlinecolor,trendlineToolText:e.trendlinetooltext,trendlineThickness:e.trendlinethickness,trendlineAlpha:e.trendlinealpha,showTrendlinesOnTop:e.showtrendlinesontop,showAxisLine:C(e.showyaxisline,e.showaxislines,e.drawAxisLines,0),axisLineThickness:C(e.yaxislinethickness,e.axislinethickness,1),axisLineAlpha:C(e.yaxislinealpha,e.axislinealpha,100),axisLineColor:I(e.yaxislinecolor,e.axislinecolor,"#000000")};f.vtrendlines=c.trendlines;a.trendlines=c.vtrendlines;c=b.yAxis[0];b=b.xAxis[0];
c.setCommonConfigArr(a,!0,!1,!1);b.setCommonConfigArr(f,!1,!1,!1);c.configure();b.configure()},_spaceManager:function(){var b,a,c=this.config;a=this.components;var e=c.radarborderthickness,f=c.legendPosition,z=a.xAxis&&a.xAxis[0],d=a.yAxis&&a.yAxis[0];b=this.hasLegend;a=a.legend;var B;B=f===H?.3*c.canvasHeight:.3*c.canvasWidth;!1!==b&&z&&this._allocateSpace(a._manageLegendPosition(B));a=.7*c.canvasHeight;b=.7*c.canvasWidth;z&&this._allocateSpace(z.placeAxis(b,a));b=.7*c.canvasWidth;d&&d.placeAxis(b);
b=.225*c.availableHeight;b=this._manageActionBarSpace&&this._manageActionBarSpace(b)||{};this._allocateSpace(b);b=0<c.radarradius?2*c.radarradius:Sa(c.canvasHeight,c.canvasWidth);c.canvasHeight>b&&(a=mb((c.canvasHeight-b)/2),this._allocateSpace({top:a,bottom:a}));c.canvasWidth>b&&(a=mb((c.canvasWidth-b)/2),this._allocateSpace({left:a,right:a}));a=f===H?.6*c.availableHeight:.6*c.availableWidth;this._manageChartMenuBar(a);d.setAxisDimention({x:c.canvasLeft+c.canvasWidth/2-e/2,y:c.canvasTop,axisLength:c.canvasHeight/
2});z.setAxisConfig({centerX:c.canvasLeft+c.canvasWidth/2,centerY:c.canvasTop+c.canvasHeight/2,radius:Sa(c.canvasWidth/2,c.canvasHeight/2)-e/2})}},Qa.mscartesian);Qa("mslog",{standaloneInit:!1,_createAxes:function(){var b=this.components,a=FusionCharts.register("component",["axis","cartesian"]),c=FusionCharts.register("component",["axis","log"]);b.yAxis=[];b.xAxis=[];b.yAxis[0]=c=new c;b.xAxis[0]=b=new a;c.chart=this;b.chart=this;c.init();b.init();this._setCategories()},_feedAxesRawData:function(){var b=
this.components,a=b.colorManager,c=this.jsonData,e=c.chart,f,d=(f=this.is3d)?z.chart3D:z.chart2D,B=1===C(e.invertyaxis,0)?!0:!1;f={outCanfontFamily:I(e.outcnvbasefont,e.basefont,"Verdana,sans"),outCanfontSize:Xa(e.outcnvbasefontsize,e.basefontsize,10),outCancolor:I(e.outcnvbasefontcolor,e.basefontcolor,a.getColor(d.baseFontColor)).replace(/^#? ([a-f0-9]+)/ig,"#$1"),axisNamePadding:e.xaxisnamepadding,axisValuePadding:e.labelpadding,axisNameFont:e.xaxisnamefont,axisNameFontSize:e.xaxisnamefontsize,
axisNameFontColor:e.xaxisnamefontcolor,axisNameFontBold:e.xaxisnamefontbold,axisNameFontItalic:e.xaxisnamefontitalic,axisNameBgColor:e.xaxisnamebgcolor,axisNameBorderColor:e.xaxisnamebordercolor,axisNameAlpha:e.xaxisnamealpha,axisNameFontAlpha:e.xaxisnamefontalpha,axisNameBgAlpha:e.xaxisnamebgalpha,axisNameBorderAlpha:e.xaxisnameborderalpha,axisNameBorderPadding:e.xaxisnameborderpadding,axisNameBorderRadius:e.xaxisnameborderradius,axisNameBorderThickness:e.xaxisnameborderthickness,axisNameBorderDashed:e.xaxisnameborderdashed,
axisNameBorderDashLen:e.xaxisnameborderdashlen,axisNameBorderDashGap:e.xaxisnameborderdashgap,useEllipsesWhenOverflow:e.useellipseswhenoverflow,divLineColor:I(e.vdivlinecolor,e.divlinecolor,a.getColor(d.divLineColor)),divLineAlpha:I(e.vdivlinealpha,e.divlinealpha,f?a.getColor("divLineAlpha3D"):a.getColor("divLineAlpha")),divLineThickness:C(e.vdivlinethickness,e.divlinethickness,1),divLineIsDashed:!!C(e.vdivlinedashed,e.vdivlineisdashed,e.divlinedashed,e.divlineisdashed,0),divLineDashLen:C(e.vdivlinedashlen,
e.divlinedashlen,4),divLineDashGap:C(e.vdivlinedashgap,e.divlinedashgap,2),showAlternateGridColor:C(e.showalternatevgridcolor,0),alternateGridColor:I(e.alternatevgridcolor,a.getColor("altVGridColor")),alternateGridAlpha:I(e.alternatevgridalpha,a.getColor("altVGridAlpha")),numDivLines:e.numvdivlines,maxLabelHeight:e.maxlabelheight,labelFont:e.labelfont,labelFontSize:e.labelfontsize,labelFontColor:e.labelfontcolor,labelFontAlpha:e.labelalpha,labelFontBold:e.labelfontbold,labelFontItalic:e.labelfontitalic,
axisName:e.xaxisname,axisMinValue:e.xaxisminvalue,axisMaxValue:e.xaxismaxvalue,setAdaptiveMin:e.setadaptivexmin,adjustDiv:e.adjustvdiv,labelDisplay:e.labeldisplay,showLabels:e.showlabels,rotateLabels:e.rotatelabels,slantLabel:C(e.slantlabels,e.slantlabel),labelStep:C(e.labelstep,e.xaxisvaluesstep),showAxisValues:C(e.showxaxisvalues,e.showxaxisvalue),showLimits:e.showvlimits,showDivLineValues:C(e.showvdivlinevalues,e.showvdivlinevalues),showZeroPlane:e.showvzeroplane,zeroPlaneColor:e.vzeroplanecolor,
zeroPlaneThickness:e.vzeroplanethickness,zeroPlaneAlpha:e.vzeroplanealpha,showZeroPlaneValue:e.showvzeroplanevalue,trendlineColor:e.trendlinecolor,trendlineToolText:e.trendlinetooltext,trendlineThickness:e.trendlinethickness,trendlineAlpha:e.trendlinealpha,showTrendlinesOnTop:e.showtrendlinesontop,showAxisLine:C(e.showxaxisline,e.showaxislines,e.drawAxisLines,0),axisLineThickness:C(e.xaxislinethickness,e.axislinethickness,1),axisLineAlpha:C(e.xaxislinealpha,e.axislinealpha,100),axisLineColor:I(e.xaxislinecolor,
e.axislinecolor,"#000000")};a={outCanfontFamily:I(e.outcnvbasefont,e.basefont,"Verdana,sans"),outCanfontSize:Xa(e.outcnvbasefontsize,e.basefontsize,10),outCancolor:I(e.outcnvbasefontcolor,e.basefontcolor,a.getColor(d.baseFontColor)).replace(/^#? ([a-f0-9]+)/ig,"#$1"),axisNamePadding:e.yaxisnamepadding,axisValuePadding:e.yaxisvaluespadding,axisNameFont:e.yaxisnamefont,axisNameFontSize:e.yaxisnamefontsize,axisNameFontColor:e.yaxisnamefontcolor,axisNameFontBold:e.yaxisnamefontbold,axisNameFontItalic:e.yaxisnamefontitalic,
axisNameBgColor:e.yaxisnamebgcolor,axisNameBorderColor:e.yaxisnamebordercolor,axisNameAlpha:e.yaxisnamealpha,axisNameFontAlpha:e.yaxisnamefontalpha,axisNameBgAlpha:e.yaxisnamebgalpha,axisNameBorderAlpha:e.yaxisnameborderalpha,axisNameBorderPadding:e.yaxisnameborderpadding,axisNameBorderRadius:e.yaxisnameborderradius,axisNameBorderThickness:e.yaxisnameborderthickness,axisNameBorderDashed:e.yaxisnameborderdashed,axisNameBorderDashLen:e.yaxisnameborderdashlen,axisNameBorderDashGap:e.yaxisnameborderdashgap,
axisNameWidth:e.yaxisnamewidth,useEllipsesWhenOverflow:e.useellipseswhenoverflow,rotateAxisName:C(e.rotateyaxisname,1),axisName:e.yaxisname,divLineColor:I(e.divlinecolor,a.getColor(d.divLineColor)),divLineAlpha:I(e.divlinealpha,a.getColor("divLineAlpha")),divLineThickness:C(e.divlinethickness,2),divLineIsDashed:!!C(e.divlinedashed,e.divlineisdashed,0),divLineDashLen:C(e.divlinedashlen,4),divLineDashGap:C(e.divlinedashgap,2),showAlternateGridColor:C(e.showalternatehgridcolor,1),alternateGridColor:I(e.alternatehgridcolor,
a.getColor("altHGridColor")),alternateGridAlpha:I(e.alternatehgridalpha,a.getColor("altHGridAlpha")),numDivLines:e.numdivlines,axisMinValue:e.yaxisminvalue,axisMaxValue:e.yaxismaxvalue,setAdaptiveMin:e.setadaptiveymin,adjustDiv:e.adjustdiv,labelStep:e.yaxisvaluesstep,showAxisValues:C(e.showyaxisvalues,e.showyaxisvalue),showLimits:C(e.showyaxislimits,e.showlimits,this.showLimits),showDivLineValues:C(e.showdivlinevalues,e.showdivlinevalue),showZeroPlane:e.showzeroplane,zeroPlaneColor:e.zeroplanecolor,
zeroPlaneThickness:e.zeroplanethickness,zeroPlaneAlpha:e.zeroplanealpha,showZeroPlaneValue:e.showzeroplanevalue,trendlineColor:e.trendlinecolor,trendlineToolText:e.trendlinetooltext,trendlineThickness:e.trendlinethickness,trendlineAlpha:e.trendlinealpha,showTrendlinesOnTop:e.showtrendlinesontop,showAxisLine:C(e.showyaxisline,e.showaxislines,e.drawAxisLines,0),axisLineThickness:C(e.yaxislinethickness,e.axislinethickness,1),axisLineAlpha:C(e.yaxislinealpha,e.axislinealpha,100),base:e.base,logBase:e.logbase,
axisLineColor:I(e.yaxislinecolor,e.axislinecolor,"#000000"),showMinorDivLineValues:C(e.showminordivlinevalues,0),numMinorDivLines:e.numminordivlines};"1"===a.base&&(a.base=10,a.logBase=10);a.minorDivlinecolor=I(e.minordivlinecolor,a.divLineColor);a.minorDivLineThickness=I(e.minordivlinethickness,1);a.minorDivLineAlpha=I(e.minordivlinealpha,a.divLineAlpha/2);f.vtrendlines=c.vtrendlines;a.trendlines=c.trendlines;c=b.yAxis[0];b=b.xAxis[0];c.setCommonConfigArr(a,!0,B,!1);b.setCommonConfigArr(f,!1,!1,
!1);c.configure();b.configure()},_setAxisLimits:function(){var b=this.components,a=b.dataset,c=b.yAxis,b=b.xAxis,e,f=a.length,z,d=-Infinity,B=Infinity,g=Infinity,G=-Infinity,P,m={},l=[],q=function(b){d=ka(d,b.max);B=Sa(B,b.min);G=ka(G,b.xMax||-Infinity);g=Sa(g,b.xMin||Infinity)};for(z=0;z<f;z++)e=a[z],(P=e.groupManager)?m[e.type]=P:l.push(e);for(P in m)a=m[P].getDataLimits(),q(a);f=l.length;for(z=0;z<f;z++)a=l[z].getDataLimits(),q(a);q(this._getTrendLineMinMax("h"));-Infinity===d&&(d=1);Infinity===
B&&(B=1);c[0].setDataLimit(d,B);if(-Infinity!==G||Infinity!==g)b[0].config.xaxisrange={max:G,min:g},b[0].setDataLimit(G,g)}},Qa.mscartesian);Qa("guageBase",{standaloneInit:!1,hasCanvas:!1,_createAxes:function(){},_feedAxesRawData:function(){},_setCategories:function(){},_setAxisLimits:function(){},_adjustCanvasPadding:function(){},placeDataLabels:function(){var b=function(b,a){return b.point.value-a.point.value},a=function(b,a){return b.angle-a.angle},c=[M,M,q,q],e=[-1,1,1,-1],f=[1,1,-1,-1];return function(z,
d,B,g){var G=this.config,P=this.components.dataset[0].conf,m=G.canvasLeft,l=G.canvasTop,q=G.canvasWidth,p=m+.5*G.canvasWidth,n=l+.5*G.canvasHeight,w=this.linkedItems.smartLabel,v=P.dataLabelOptions,A=v.style,H=C(Ga(parseFloat(A.lineHeight)),12),Q=za(v.placeLabelsInside,1===d.length?!0:!1),K=v.skipOverlapLabels,D=v.manageLabelOverflow,I=v.connectorPadding,F;F=g&&g.metrics||[p,n,2*P.pieMinRadius,P.innerSize||0];var L=F[1],J=F[0];g=.5*F[2];var W=[[],[],[],[]],P=B.labelsRadius=g+v.distance,n=p=parseInt(A.fontSize,
10),M=n/2,I=[I,I,-I,-I];B=B.labelsMaxInQuadrant||(B.labelsMaxInQuadrant=Na(P/n));var v=v.isSmartLineSlanted,U=F[3]/2,Z,X,da,ca,N,O,fa,T,ma,S,ja,la,oa,aa,V,pa;F=Number.POSITIVE_INFINITY;var ba,qa;da=[];X=[];w.useEllipsesOnOverflow(G.useEllipsesWhenOverflow);z||w.setStyle(A);if(1==d.length&&!U&&Q)da=d[0],(ja=da.dataLabel)&&ja.show(),da.slicedTranslation=[m,l],ja&&(ja.attr({visibility:Ka,align:t,transform:["t",J,L]}),ja.x=J);else if(Q)pa=U+(g-U)/2,xb(d,function(b){ba=b.config;qa=b.graphics;(ja=qa.label)&&
ja.show();ja&&(S=ba.angle,ma=L+pa*Ia(S),N=J+pa*Za(S),ja.x=N,ja._x=N,ja.y=ma,b.sliced&&(V=b.slicedTranslation,oa=V[0]-m,aa=V[1]-l,N+=oa,ma+=aa),ja.attr({visibility:Ka,align:t,transform:["t",N,ma]}))});else{xb(d,function(b){ba=b.config;qa=b.graphics;(ja=qa.label)&&ja.show();ja&&(S=ba.angle%Eb,0>S&&(S=Eb+S),la=0<=S&&S<Hb?1:S<wb?2:S<Ab?3:0,W[la].push({point:b,angle:S}))});for(d=z=4;d--;){if(K&&(G=W[d].length-B,0<G))for(W[d].sort(b),A=W[d].splice(0,G),G=0,X=A.length;G<X;G+=1)da=A[G].point,da.dataLabel.attr({visibility:r}),
da.connector&&da.connector.attr({visibility:r});W[d].sort(a)}d=ka(W[0].length,W[1].length,W[2].length,W[3].length);G=ka(Sa(d,B)*n,P+n);X=W[0].concat(W[1]);da=W[2].concat(W[3]);for(d=X.length-1;0<=d;d--)A=X[d].point.config,delete A.clearance,delete A.clearanceShift,U=mb(G*Ia(A.angle)),Math.abs(F-U)<2*H&&(A.clearance=0,X[d+1].point.clearanceShift=H/2),F=U;F=Number.POSITIVE_INFINITY;d=0;for(X=da.length;d<X;d++)A=da[d].point.config,delete A.clearance,delete A.clearanceShift,U=mb(G*Ia(A.angle)),Math.abs(F-
U)<2*H&&(A.clearance=0,da[d-1].point.clearanceShift=H/2),F=U;W[1].reverse();for(W[3].reverse();z--;){A=W[z];X=A.length;K||(n=X>B?G/X:p,M=n/2);H=X*n;F=G;for(d=0;d<X;d+=1,H-=n)U=mb(G*Ia(A[d].angle)),F<U?U=F:U<H&&(U=H),F=(A[d].oriY=U)-n;Q=c[z];X=G-(X-1)*n;F=0;for(d=A.length-1;0<=d;--d,X+=n)if(da=A[d].point,S=A[d].angle,ba=da.config,qa=da.graphics,da=ba.sliced,ja=qa.label,U=mb(G*Ia(S)),U<F?U=F:U>X&&(U=X),F=U+n,H=void 0===ba.clearance?2*Ga(C(parseFloat(ba.style.border),12),12):2*Ga(C(parseFloat(ba.style.border),
ba.clearance)),fa=(U+A[d].oriY)/2,U=J+f[z]*P*Za(Ua.asin(fa/G)),fa*=e[z],fa+=L,T=L+g*Ia(S),ca=J+g*Za(S),(2>z&&U<ca||1<z&&U>ca)&&(U=ca),N=U+I[z],ma=fa-M-2,O=N+I[z],ja.x=O,ja._x=O,D&&(Z=1<z?O-this.canvasLeft:this.canvasLeft+q-O,w.setStyle(ba.style),H=C(Ga(parseFloat(ba.style.lineHeight)),12)+H,H=w.getSmartText(ba.labelText,Z,H),void 0===ba.clearance&&H.height>n&&(fa+=n),ja.attr({text:H.text}).tooltip(H.tooltext)),ja.y=ma,da&&(oa=ba.transX,aa=ba.transY,N+=oa,U+=oa,ca+=oa,T+=aa,O+=oa),ja.attr({visibility:Ka,
"text-anchor":Q,vAlign:t,x:O,y:fa}),H=qa.connector)qa.connectorPath=da=["M",ca,T,"L",v?U:ca,fa,N,fa],H.attr({path:da,visibility:Ka})}}}}()},Qa.sscartesian);Qa("scatterBase",{standaloneInit:!1,_setCategories:function(){var b=this.jsonData,a=this.components.xAxis,c=I(b.chart.xaxislabelmode,"categories"),b=b.categories&&b.categories[0].category;a[0].setAxisConfig({xAxisLabelMode:"categories"});"auto"!==c&&"mixed"!==c&&b&&0<b.length?a[0].setCategory(b):"auto"!==c?(a[0].setCategory(b,!1),a[0].setAxisConfig({xAxisLabelMode:"mixed"})):
a[0].setAxisConfig({xAxisLabelMode:"auto"})},_setAxisLimits:function(){var b=this.components,a=this.jsonData,c=b.xAxis,e=I(a.chart.xaxislabelmode,"categories"),a=a.categories&&a.categories[0],a=(a&&a.category||[]).slice(),f,z,d,B,g;f=Infinity;d=-Infinity;var G,P;Qa("mscartesian")._setAxisLimits.call(this);z=c[0].getLimit();B=z.tickInterval;for(g=0;g<a.length;g+=1)if(G=a[g].x)G<f&&(f=G),G>d&&(d=G);g=this._getTrendLineMinMax("v");d=ka(d,g.max);f=Sa(f,g.min);if(d>z.max||f<z.min)d=ka(d,z.max),f=Sa(f,
z.min),c[0].setDataLimit(d,f);if("mixed"===e||"auto"===e||!(a&&0<a.length)){d=[];f=b.numberFormatter.xAxis;if("mixed"===e)for(g=0,e=a.length;g<e;g+=1)d[a[g].x||a[g].y||g]=!0;else a=[];G=c[0].getAxisConfig();P=g=z.min;for(e=z.max;g<=e;)d[g]||a.push({label:ba+f.call(b.numberFormatter,g),x:g,showverticalline:0===g?G.showZeroPlane:1,isNumeric:!0,linecolor:0===g?G.zeroPlaneColor:G.divLineColor,linealpha:0===g?G.zeroPlaneAlpha:G.divLineAlpha,linethickness:0===g?G.zeroPlaneThickness:G.divLineThickness,linedashed:G.divLineIsDashed,
linedashLen:G.divLineDashLen,linedashgap:G.divLineDashGap}),0>g&&0<g+B?(g=0,P+=B):g<P?g=P:(g+=B,P+=B);c[0].setCategory(a,!1)}},_createQuadrant:function(){var b;b=this.components;var a=FusionCharts.register("component",["quadrant","cartesian"]);b.quadrant=b=new a;b.chart=this;b.init()},_drawQuadrant:function(){this.components.quadrant.draw()},_getDiff:function(b,a){return{diff:b,startIndex:a}}},Qa.mscartesian,{zeroplanethickness:1,zeroplanealpha:40,showzeroplaneontop:0,setadaptivexmin:1});Qa("areabase",
{standaloneInit:!1},Qa.mscartesian,{anchorborderthickness:1,anchorimageurl:void 0,anchorimagepadding:1,anchorsides:1,anchoralpha:void 0,anchorbgalpha:O,anchorimagealpha:O,anchorimagescale:100,anchorstartangle:90,anchorshadow:0,anchorbgcolor:void 0,anchorbordercolor:void 0,anchorradius:3,showvalues:1,plotfillalpha:pa,linedashlen:5,linedashgap:4,linedashed:void 0,linealpha:O,linethickness:2,drawfullareaborder:1,connectnulldata:0})}]);FusionCharts.register("module",["private","modules.renderer.js-renderer",
function(){var g=this.window,m=this.hcLib,D=m.Raphael,n=m.parseConfiguration,F=/msie/i.test(g.navigator.userAgent)&&!g.opera,A=g.Image,J="VML"===D.type,a=m.BLANKSTRING,O=m.getPosition,d=m.COMMASPACE,l=m.ZEROSTRING,N=m.BGRATIOSTRING,ga=m.hasSVG,w="rgba(192,192,192,"+(F?.002:1E-6)+")",F=m.TOUCH_THRESHOLD_PIXELS,r=m.CLICK_THRESHOLD_PIXELS,p=m.extend2,c=m.pluck,v=m.parsexAxisStyles,M=m.toPrecision,e=m.pluckNumber,q=m.setLineHeight,H=m.pluckFontSize,t=m.toRaphaelColor,L=m.graphics.convertColor,K=m.parseUnsafeString,
pa=m.getDefinedColor,S=m.graphics.getDarkColor,T=m.ONESTRING,ba=m.getFirstAlpha,aa=m.HUNDREDSTRING,I=m.getDashStyle,ia=m.plotEventHandler,C=m.hasTouch?F:r,za=m.getCrispValues,Ja=m.getValidValue,na=m.getFirstValue,ea=m.parseTooltext,ra=m.regex.dropHypeash,V=m.HASHSTRING,F=m.preDefStr,va=F.noneStr,nb=F.configStr,La=F.animationObjStr,Da=F.showHoverEffectStr,Ma=F.columnStr,Oa=F.barStr,Wa=F.barHotStr,Ka=F.shadowStr,Pa=F.visibleStr,Ua=F.hiddenStr,Sa=F.negativeValueStr,ka=F.positiveValueStr,mb=F.zeroPlaneStr,
Ga=F.categoryPlotsStr,Na=F.setRolloverAttrStr,ya=F.setRolloutAttrStr,Ia=F.elementStr,Za=F.hotElementStr,wb=F.dataLabelStr,Hb=F.strokeWidthStr,Eb=F.strokeDashStr,Ab=F.miterStr,kb=F.POSITION_MIDDLE,cb=F.POSITION_START,Xa=F.POSITION_TOP,lb=F.POSITION_BOTTOM,db=F.POSITION_END,$a=m.graphics.getCubePathOutline,sb=function(b,a){var c=!1,e=a%2,d;b[1]===b[4]&&(c=b[1],d=ab(c),b[1]=b[4]=e?d>c?d-.5:d+.5:d,c=!0);b[2]===b[5]&&(c=b[2],d=ab(c),b[2]=b[5]=e?d>c?d-.5:d+.5:d,c=!0);return{path:b,isCrisped:c}},tb=8===
g.document.documentMode?Pa:"",gb=Math,Qa=gb.sqrt,vb=gb.sin,jb=gb.cos,ab=gb.round,Va=gb.min,Ea=gb.max,Ra=gb.abs,xb=gb.ceil,hb=gb.floor,yb=gb.pow,fb=gb.log,Bb=gb.PI,zb=2*Bb,ib=m.getFirstColor,ob=m.graphics.getLightColor,pb=m.schedular;D.ca.ishot=function(b){if(this.removed)return!1;var a=this.node;b=b||"";a.ishot=b;switch(this.type){case "group":for(a=this.bottom;a;)a.attr("ishot",b),a=a.next;break;case "text":if(D.svg)for(a=a.getElementsByTagName("tspan")[0];a;)a.ishot=b,a=a.nextSibling}return!1};
D.addSymbol({printIcon:function(b,a,c){var e=.75*c,d=.5*c,g=.33*c,k=ab(b-c)+.5,h=ab(a-c)+.5,u=ab(b+c)+.5;c=ab(a+c)+.5;var f=ab(b-e)+.5,m=ab(a-e)+.5,e=ab(b+e)+.5,l=ab(a+d)+.5,q=ab(b+d)+.5,p=ab(a+g)+.5;b=ab(b-d)+.5;g=ab(a+g+g)+.5;return["M",f,h,"L",e,h,e,m,f,m,"Z","M",k,m,"L",k,l,f,l,f,a,e,a,e,l,u,l,u,m,"Z","M",f,a,"L",f,c,e,c,e,a,"Z","M",q,p,"L",b,p,"M",q,g,"L",b,g]},exportIcon:function(b,a,c){var e=.66*c,d=.5*e,g=ab(b-c)+.5,k=ab(a-c)+.5,h=ab(b+c)+.5;c=ab(a+c)-.5;var u=ab(b-d)+.5,f=a<c-3?c-3:ab(a)+
.5,d=ab(b+d)-.5,m=ab(b+e)-.5,e=ab(b-e)+.5;return["M",g,f,"L",g,c,h,c,h,f,h,c,g,c,"Z","M",b,c-1,"L",e,a,u,a,u,k,d,k,d,a,m,a,"Z"]}});FusionCharts.register("component",["axis","cartesian",{pIndex:2,customConfigFn:"_feedAxesRawData",init:function(b,a,c,e){var d;this.graphics={};this.components={};d=this.config;d.isVertical=a;d.isReverse=c;d.isOpposit=e;d.isActive=!0;d.drawLabels=!0;d.drawOnlyCategoryLine=!1;d.drawLabelsOpposit=!1;d.drawLabelOnBothSide=!1;d.drawPlotlines=!0;d.drawAxisLine=!0;d.drawPlotBands=
!0;d.drawAxisName=!0;d.drawAxisNameOpposit=!1;d.axisNameAlignCanvas=!1;d.drawAxisNameFromBottom=!1;d.drawTrendLines=!0;d.drawTrendLabels=!0;d.drawTick=!0;d.drawTickMinor=!0;d.animateAxis=!0;d.drawAxisLineWRTCanvas=!0;d.isRelativeAxisInverse=!1;d.axisIndex=0;d.uniqueClassName=0;d.viewPortRatio={};d.canvas={};d.rawAttr=b;d.axisRange={};d.isConfigured=!0;d.axisDimention={};d.extremeLabels={firstLabel:{},lastLabel:{}};d._setRangeAgain=!1;d._defaultForceDecimal=void 0;d._defaultDecimalPrecision=void 0},
setCommonConfigArr:function(b,a,c,e){var d=this.config;d.rawAttr=b;d.isVertical=a;d.isReverse=c;d.isOpposit=e},configure:function(){var b=this.config,a=b.rawAttr,d=this.chart,g=d.components,G=this.chart.is3D,d=d.jsonData.chart,E=g.numberFormatter;b.trendLines=a.trendlines;b.vTrendLines=a.vtrendlines;this.__setDefaultConfig();n(a,b);b.axisName=K(a.axisName);b.axisValuePadding=b.axisNamePadding||e(a.axisValuePadding,4);b.axisNamePadding=b.axisNamePadding||e(a.axisNamePadding,5);b.maxLabelWidthPercent=
e(a.maxLabelWidthPercent);b.maxLabelWidthPercent=Ra(b.maxLabelWidthPercent);b.numDivLines=e(a.numDivLines,4);0>b.numDivLines&&(b.numDivLines=0);b.categoryNumDivLines=e(a.numDivLines,0);0>b.axisValuePadding&&(b.axisValuePadding=0);b.categoryDivLinesFromZero=1;b.axisMinValue=E.getCleanValue(a.axisMinValue);b.axisMaxValue=E.getCleanValue(a.axisMaxValue);b.zeroPlaneColor=c(a.zeroPlaneColor,a.divLineColor);b.zeroPlaneThickness=c(a.zeroPlaneThickness,a.divLineThickness);b.axisLineColor=L(a.axisLineColor,
a.axisLineAlpha);b.tickAlpha=e(a.tickAlpha,b.axisLineAlpha);b.tickColor=L(c(a.tickColor,a.axisLineColor),b.tickAlpha);b.tickWidth=e(a.tickWidth,b.axisLineThickness);b.showVLines=e(d.showvlines,1);b.showVLinesOnTop=e(d.showvlinesontop,0);b.showVLineLabels=e(d.showvlinelabels,this.showVLineLabels,1);b.showVLineLabelBorder=e(d.showvlinelabelborder,1);b.rotateVLineLabels=e(d.rotatevlinelabels,0);b.vLineColor=c(d.vlinecolor,"333333");b.vLineLabelColor=c(d.vlinelabelcolor);b.vLineThickness=c(d.vlinethickness,
1);b.vLineAlpha=e(d.vlinealpha,80);b.vLineLabelBgColor=c(d.vlinelabelbgcolor,"ffffff");b.vLineLabelBgAlpha=e(d.vlinelabelbgalpha,G?50:100);b.staggerLines=Math.max(e(d.staggerlines,2),2);1>b.staggerlines&&(b.staggerlines=1);b.trendlineValuesOnOpp=c(a.trendlineValuesOnOpp,a.trendlineValuesOnOpp,0);b.labelDisplay=c(a.labelDisplay,"auto").toLowerCase();b.labelStep=e(a.labelStep,0);b.labelStep=ab(b.labelStep);0>b.labelStep&&(b.labelStep=0);b._oriLabelStep=b.labelStep;b.showLimits=e(a.showLimits,b.showAxisValues);
b.showUpperLimit=a.showLimits;b.showDivLineValues=e(a.showDivLineValues,b.showAxisValues);b.showCanvasBorder=g.canvas.config.showCanvasBorder?1:0;b.axisBreak=a.axisBreaks;b.isBreak=!!b.axisBreak;b.isBreak&&this._processAxisBreak();g=(g=na(a.axisNameBorderColor,""))?L(g,e(a.axisNameBorderAlpha,a.axisNameAlpha,100)):"";b.name=b.name||{};b.name.style={fontFamily:c(a.axisNameFont,a.outCanfontFamily),fontSize:c(a.axisNameFontSize,parseInt(a.outCanfontSize,10))+"px",color:L(c(a.axisNameFontColor,a.outCancolor),
e(a.axisNameFontAlpha,a.axisNameAlpha,100)),fontWeight:e(a.axisNameFontBold,1)?"bold":"normal",fontStyle:e(a.axisNameFontItalic)?"italic":"normal",border:g||a.axisNameBgColor?e(a.axisNameBorderThickness,1)+"px solid":void 0,borderColor:g,borderThickness:e(a.axisNameBorderThickness,1),borderPadding:e(a.axisNameBorderPadding,2),borderRadius:e(a.axisNameBorderRadius,0),backgroundColor:a.axisNameBgColor?L(a.axisNameBgColor,e(a.axisNameBgAlpha,a.axisNameAlpha,100)):"",borderDash:e(a.axisNameBorderDashed,
0)?I(e(a.axisNameBorderDashLen,4),e(a.axisNameBorderDashGap,2),e(a.axisNameBorderThickness,1)):"none"};b.name.style.lineHeight=q(b.name.style);g=(g=na(d.trendvaluebordercolor,""))?L(g,e(d.trendvalueborderalpha,d.trendvaluealpha,100)):"";b.trend=b.trend||{};b.trend.trendStyle={fontFamily:c(d.trendvaluefont,a.outCanfontFamily),color:c(d.trendvaluefontcolor,a.trendlineColor,a.outCancolor,"333333"),fontSize:H(d.trendvaluefontsize,parseInt(a.outCanfontSize,10))+"px",fontWeight:e(d.trendvaluefontbold)?
"bold":"normal",fontStyle:e(d.trendvaluefontitalic)?"italic":"normal",border:g||d.trendvaluebgcolor?e(d.trendvalueborderthickness,1)+"px solid":"",borderColor:g,borderThickness:e(d.trendvalueborderthickness,1),borderPadding:e(d.trendvalueborderpadding,2),borderRadius:e(d.trendvalueborderradius,0),backgroundColor:d.trendvaluebgcolor?L(d.trendvaluebgcolor,e(d.trendvaluebgalpha,d.trendvaluealpha,100)):"",borderDash:e(d.trendvalueborderdashed,0)?I(e(d.trendvalueborderdashlen,4),e(d.trendvalueborderdashgap,
2),e(d.trendvalueborderthickness,1)):"none"};b.trend.trendStyle.lineHeight=q(b.trend.trendStyle);b.labels=b.labels||{};b.lines=b.lines||{};b.band=b.band||{};g=(g=na(d.labelbordercolor,""))?L(g,e(d.labelborderalpha,d.labelalpha,100)):"";b.labels.style={fontFamily:c(a.labelFont,a.outCanfontFamily),fontSize:e(a.labelFontSize,parseInt(a.outCanfontSize,10))+"px",fontWeight:e(a.labelFontBold)?"bold":"normal",fontStyle:e(a.labelFontItalic)?"italic":"normal",color:L(c(a.labelFontColor,a.outCancolor),e(a.labelFontAlpha,
100)),labelLink:d.labellink,border:g||d.labelbgcolor?e(d.labelborderthickness,1)+"px solid":"",borderColor:g,borderThickness:e(d.labelborderthickness,1),borderPadding:e(d.labelborderpadding,2),borderRadius:e(d.labelborderradius,0),backgroundColor:d.labelbgcolor?L(d.labelbgcolor,e(d.labelbgalpha,d.labelalpha,100)):"",borderDash:e(d.labelborderdashed,0)?I(e(d.labelborderdashlen,4),e(d.labelborderdashgap,2),e(d.labelborderthickness,1)):"none"};b.labels.style.lineHeight=q(b.labels.style);b.numberFormatterFn=
c(a.numberFormatterFn);b.axisEndLabelDisplaySpace={left:0,right:0,top:0,bottom:0};b.isConfigured=!0;b._defaultForceDecimal=void 0;b._defaultDecimalPrecision=void 0},_processAxisBreak:function(){var b=this.config,a,c,d,g;b.breakPoints=[];a=b.axisBreak.split("|");d=0;g=a.length;for(c=0;d<g;d+=1)a[d]=a[d].split(","),isNaN(a[d][0])||isNaN(a[d][1])||(b.breakPoints[c]={start:e(a[d][0]),end:e(a[d][1]),length:e(a[d][2],0)},c+=1);b.breakPoints.sort(function(b,a){return b.start-a.start});b.hasBreakPoints=!0;
this._validateBreakPoints()},_validateBreakPoints:function(){var b=this.config,a=b.breakPoints,c=0,e,d=a.length;for(e=0;e<d;e+=1)c+=a[e].end-a[e].start;b.totalBreakAmount=c},_getRelativeBreakValue:function(b){var a=this.config.breakPoints,c,e=a.length,d=0;for(c=0;c<e;c+=1){if(b>=a[c].start&&b<=a[c].end)return a[c].start-d;if(b<a[c].start)break;d+=a[c].end-a[c].start}return b-d},_getRealBreakValue:function(b){var a=this.config.breakPoints,c,e=a.length;for(c=0;c<e;c+=1)if(b>=a[c].start)b+=a[c].end-
a[c].start;else if(b<a[c].start)break;return b},getBreakPoints:function(){var b=this.config;return b.hasBreakPoints?b.breakPoints:!1},setCanvas:function(b){this.config.canvas=b},getAxisBase:function(){var b=this.config,a=b.axisRange.min,c=b.axisRange.max;return 0>a&&0<c?0:b.isReverse?c:0>=c?c:a},getValue:function(b){var a=this.config,c=a.axisRange,e=a.canvas,d=a.axisDimention||{},g=this.chart.config,k=g.viewPortConfig,h=d.axisLength||e.canvasWidth||g.canvasWidth,d=d.axisLength||e.canvasHeight||g.canvasHeight,
e=c.max,c=c.min,g=e-c;a.isVertical?(h=d*k.scaleY/g,b=a.isReverse?c+(k.y*k.scaleY+Number(b))/h:e-(k.y*k.scaleY+Number(b))/h):(h=h*k.scaleX/g,b=a.isReverse?e-(k.x*k.scaleX+Number(b))/h:c+(k.x*k.scaleX+Number(b))/h);return b},_getLabelElement:function(b){var a=this.components;return this.config.hasCategory?a&&a.categoryLabel&&a.categoryLabel[b]&&a.categoryLabel[b].graphics&&a.categoryLabel[b].graphics.label:this.graphics&&this.graphics.labels&&this.graphics.labels[b]},_getVisibleConfig:function(){var b=
this.config,a=b.axisRange,c=b.canvas,e=b.axisDimention||{},d=this.chart.config,g=d.viewPortConfig,k=e.axisLength||c.canvasWidth||d.canvasWidth,c=e.axisLength||c.canvasHeight||d.canvasHeight,e=a.max,a=a.min,d=e-a;b.isVertical?(d/=c,b=g.scaleY,k=e-d*g.y,c=e-d*(g.y+c/b)):(d/=k,b=g.scaleX,c=a+d*g.x,k=a+d*(g.x+k/b));return{maxValue:k,minValue:c}},_adjustNumberFormatter:function(b){var a=this.config,c=a.axisIndex,e=this.chart.components,d=a._defaultDecimalPrecision,g=a._defaultForceDecimal,k=0,c=a.isVertical||
"yAxis"===a.numberFormatterFn?(e.numberFormatter.Y[c]||e.numberFormatter.Y[0]).yAxisLabelConf:e.numberFormatter.paramX;void 0!==d?c.decimalprecision=d:a._defaultDecimalPrecision=c.decimalprecision;void 0!==g?c.forcedecimals=g:a._defaultForceDecimal=c.forcedecimals;0<parseInt(b)||!(b=b.toString().split(".")[1])||(k=b.match(/^[0]*/)[0].length,k+1>c.decimalprecision&&(c.forcedecimals=1),c.decimalprecision=Ea(k+1,c.decimalprecision))},_setTickIntervalAfterZoom:function(){var b=this.config,a=this.chart.config.viewPortConfig,
c=b.isVertical,d=b.axisRange,g=m.getAxisLimits,E=b.numDivLines,k=b.setAdaptiveMin,h=b.adjustDiv,h=b.rawAttr,u,f,l,q;b.hasCategory||(c=c?a.scaleY:a.scaleX,a=e(h.axisrange?h.axisrange.max:d.max),q=e(h.axisrange?h.axisrange.min:d.min),f=d.max,l=d.min,k=u=!k,h=e(1===c?b.adjustDiv:0),b=g(a,q,f,l,u,k,E*c,h),d.min=Number(M(b.Min,10)),d.max=Number(M(b.Max,10)),d.tickInterval=Number(M(b.divGap,10)),this._adjustNumberFormatter(d.tickInterval),0===d.tickInterval&&(d.tickInterval=1))},_getAttribAsObj:function(b){var a,
c={};for(a in b)b.hasOwnProperty(a)&&"string"===typeof b[a]&&b[a]&&(c[a]=b[a]);return c},_extractAttribToEnd:function(b,a){var c;b._attrib=p({},a);b._attrib=p(b._attrib,this._getAttribAsObj(b));for(c in b)b.hasOwnProperty(c)&&b[c]&&"object"===typeof b[c]&&"_attrib"!==c&&this._extractAttribToEnd(b[c],b._attrib)},setCategory:function(b,a){var c;function d(b){var a={labelfont:["fontFamily"],labelfontcolor:["fontColor"],labelfontsize:["fontSize",function(b){return b?e(b)+"px":void 0}],labelfontbold:["fontWeight",
function(b){return b?"bold":"normal"}],labelfontitalic:["fontStyle",function(b){return b?"italic":"normal"}],labelfontalpha:["fontAlpha"]},f=function(b){return b},c=!1,h,k,z,B={},g,G;for(h in E)"category"===h||h in b||(k=E[h],b[h]=k);for(h in a){z=a[h];g=z[0];G=z[1]||f;k=b[h];z=b[g.toLowerCase()];if(void 0!==k||void 0!==z)if(void 0!==(k=G(k))||void 0!==(k=G(z)))B[g]=k,c=!0;c&&(b.style=B)}}var g=this.chart.jsonData.categories,E=g&&g[0]||{},g=this.config,k=g.axisRange;c=b&&b.length;var h=g.startPad||
0,u=g.endPad||0,f=0,m=void 0!==a?a:!0,l,q,p,n,t,r;g.hasCategory=1;g.categories={};n=g.categories.category=[];t=g.categories.vline=[];q=g.categories.catIdMap={};g.isCategoryAnimate=!1;g.isCategoryVlineAnimate=!1;for(p=0;p<c;p+=1)(l=b[p])||(l={}),r=Number(l.x),"true"!==l.vline&&!0!==l.vline&&1!==l.vline&&"1"!==l.vline?(l.id&&(q[l.id.toLowerCase()]={catObj:l,index:p}),d(l),r===r&&(l.x=r,g.irregularCatAxis=!0),n.push(l),n[f].label=K(n[f].label),f+=1):(l.startIndex=n.length-1,t.push(l));g.oriCatLen=f-
1;1===f&&(0===h&&(h=.5),0===u&&(u=.5));m&&(c=f-1+u,k.min=Number(M(-h,10)),k.max=Number(M(c,10)),k.tickInterval=Number(M(1,10)));g.isConfigured=!0},updateCategory:function(b,a){var c=this.config,e,d;e=c.categories.category;if(e[b])for(d in a)a.hasOwnProperty(d)&&(e[b][d]=a[d]);c.isConfigured=!0},categoryInsert:function(b,a,c){var e=this.config,d=e.axisRange,g=a.length,k=e.endPad||0,h,u,f,m,l;h=e.categories.category;f=e.categories.catIdMap;u=e.categories.vline;for(m=0;m<g;m+=1)l=a[m],"true"!==l.vline&&
!0!==l.vline&&1!==l.vline&&"1"!==l.vline?(l.id&&(f[l.id]={catObj:l,i:b}),h.splice(b,0,l),b+=1):(l.startIndex=b-2,u.push(l));c&&(d.max=Number(M(h.length-1+k,10)));e.isConfigured=!0},categoryDelete:function(b,a,c){var e=this.config,d=e.axisRange,g,k,h;e.isCategoryAnimate=!0;g=e.animateCategories=e.categories.category.slice();k=0;for(h=g.length;k<h;k++)g[k].animate=!0,g[k].leftShift=a,g[k]["delete"]=k<a;e.isCategoryVlineAnimate=!0;g=e.animateCategoriesVline=e.categories.vline.slice();k=0;for(h=g.length;k<
h;k++)g[k].animate=!0,g[k].leftShift=a;e.categories.category.splice(b,a);this._shiftVline(b,a,"left");c&&(d.max-=a);e.isConfigured=!0},categoryUpdate:function(b,a){var c=this.config,e;e=c.categories.category;e[b]&&(e[b]=a);c.isConfigured=!0},_getRotateTextTransformString:function(b,a,c){var e,d="";b=b.matrix.toMatrixString();b.replace(/\(([^\)]*)/,function(b,k){e=k.split(",");e[4]=Number(e[4])+a;e[5]=Number(e[5])+c;d=e.join();return b});d="m"+d;""===b&&(d="t"+a+","+c);return d},_shiftVline:function(b,
a,c){var e=this.config,d=e.categories.vline,e=e.categories.category.length,g=d.length,k,h;for(k=0;k<g;k+=1)if(h=d[k],h.startIndex>=b&&(h.startIndex="right"===c?h.startIndex+a:h.startIndex-a,0>h.startIndex-a||h.startIndex-a>=e))d.splice(k,1),--g,--k},shiftLabels:function(b,a){var c=this.config.labels;c.shiftX=b;c.shiftY=a},setAxisPadding:function(b,a){var c=this.config;b=c.startPad=e(b,0);a=c.endPad=e(a,0);0===c.oriCatLen&&(0===b&&(b=.5),0===a&&(a=.5));c.hasCategory?0<=c.oriCatLen&&this.setAxisRange({max:c.oriCatLen+
a,min:-b}):c.originalMax&&c.originalMin&&this.setDataLimit(c.originalMax,c.originalMin)},setAxisConfig:function(b){var a=this.config,c;for(c in b)b.hasOwnProperty(c)&&(a[c]=b[c])},getAxisConfig:function(b){var a=this.config;return b?a[b]:a},setLabelConfig:function(b){var a=this.config.labels,c;for(c in b)b.hasOwnProperty(c)&&(a[c]=b[c])},setAxisRange:function(b){var a=this.config.axisRange,c;for(c in b)b.hasOwnProperty(c)&&void 0!==a[c]&&(a[c]=b[c])},getAxisEndLabelDisplaySpace:function(){return this.config.axisEndLabelDisplaySpace||
{}},getDivLineCount:function(){var b=this.config.axisRange;return Ra((b.max-b.min)/b.tickInterval)-1},getLabel:function(b){var a=this.config;b=a.categories&&a.categories.category[b];return{label:b&&(b.oriLabel||b.label),tooltext:b&&b.tooltext}},getCategoryFromId:function(b){var a=this.config;return(b=a.categories&&a.categories.catIdMap[b])?b:{}},getCategoryPositionById:function(b){var a=this.config;return(b=a.categories&&a.categories.catIdMap[b])?b.catObj.x||b.index:!1},getClosestDiv:function(b,a){var c=
this.config,e=c.axisRange,d=e.tickInterval,g=e.min,e=b;c.hasCategory&&(g=0,d=1);a=a||d/2;g=(b-g)%d;d-=g;c.showZeroPlaneValue&&0>b-g&&0<b&&(g=b);c.showZeroPlaneValue&&0<b+d&&0>b&&(d=-b);g<=d?g<=a&&(e=b-g):d<=a&&(e=b+d);return e},setAxisDimention:function(b){var a=this.config,a=a.axisDimention||(a.axisDimention={});a.x=e(b.x,a.x);a.y=e(b.y,a.y);a.opposite=e(b.opposite,a.opposite);a.axisLength=e(b.axisLength,a.axisLength)},setDataLimit:function(b,a){var c=this.config,d=c.axisRange,g=m.getAxisLimits,
E=c.isPercent?100:c.axisMaxValue,k=c.isPercent?0:c.axisMinValue,h=c.numDivLines,u=c.setAdaptiveMin,f=c.adjustDiv,l=c.startPad||0,q=c.endPad||0;c.originalMax=b;c.originalMin=a;b=c.isPercent?100:b+q;a=c.isPercent?0:a-l;u=l=!u;c.hasBreakPoints&&(b-=c.totalBreakAmount);c=g(e(b,E),e(a,k),E,k,l,u,h,f);d.min=Number(M(c.Min,10));d.max=Number(M(c.Max,10));d.tickInterval=Number(M(c.divGap,10));this._adjustNumberFormatter(d.tickInterval);0===d.tickInterval&&(d.tickInterval=1)},getPixel:function(b){var a=this.config,
c=a.canvas,e=this.chart.config,d=a.axisDimention||{},g=e.viewPortConfig,k=d.axisLength||c.canvasHeight||e.canvasHeight,h=d.y||c.canvasTop||e.canvasTop,u=d.x||c.canvasLeft||e.canvasLeft,f=d.y+d.axisLength||c.canvasBottom||e.canvasBottom,c=d.x+d.axisLength||c.canvasRight||e.canvasRight,e=a.axisRange.min;a.hasBreakPoints&&(b=this._getRelativeBreakValue(b));g||(g={x:u,y:h,scaleX:1,scaleY:1});a.isVertical?(d=-this.getPVR(),b=a.isReverse?f-((b-e)*d+(k*g.scaleY-g.y*g.scaleY)):h+((b-e)*d+(k*g.scaleY-g.y*
g.scaleY))):(d=this.getPVR(),b=a.isReverse?c-((b-e)*d-g.x*g.scaleX):u+((b-e)*d-g.x*g.scaleX));return b},_getCustomPixel:function(b,a){var c=this.config,e=c.canvas,d=this.chart.config,g=c.axisRange,k=d.viewPortConfig,h=a||e.canvasHeight||d.canvasHeight,u=a||e.canvasWidth||d.canvasWidth,f=e.canvasTop||d.canvasTop,m=e.canvasLeft||d.canvasLeft,l=l||d.canvasBottom,e=e.canvasRight||d.canvasRight,d=g.min,g=g.max-d;c.hasBreakPoints&&(b=this._getRelativeBreakValue(b));k||(k={x:m,y:f,scaleX:1,scaleY:1});c.isVertical?
(u=-(h*k.scaleY/g),c=c.isReverse?l-((b-d)*u+(h*k.scaleY-k.y*k.scaleY)):f+((b-d)*u+(h*k.scaleY-k.y*k.scaleY))):(u=u*k.scaleX/g,c=c.isReverse?e-((b-d)*u-k.x*k.scaleX):m+((b-d)*u-k.x*k.scaleX));return c},getLimit:function(){var b=this.config.axisRange;return{min:b.min,max:b.max,tickInterval:b.tickInterval}},getAxisPosition:function(b){return this.getPixel(b)},getPVR:function(){var b=this.config,a=b.canvas,c=b.isVertical,e=b.axisRange,d=b.axisDimention||{},g=this.chart.config,b=g.viewPortConfig,k=d.axisLength||
a.canvasHeight||g.canvasHeight,a=d.axisLength||a.canvasWidth||g.canvasWidth,e=e.max-e.min,e=0<e?e:1;return c?k*b.scaleY/e:a*b.scaleX/e},_isZoomed:function(){var b=this.chart.config;if(this.config.isVertical){if(b.viewPortConfig&&1===b.viewPortConfig.scaleY)return!1}else if(b.viewPortConfig&&1===b.viewPortConfig.scaleX)return!1;return!0},draw:function(){var b=this.config,a=b.canvas,c=this.chart,e=c.config,d=b.isVertical,g=c.graphics,k=c.components.paper,h=e.viewPortConfig,u=b.viewPortRatio||{},f=a.canvasLeft||
e.canvasLeft,m=a.canvasTop||e.canvasTop,l=a.canvasWidth||e.canvasWidth,q=a.canvasHeight||e.canvasHeight,a=b.axisContainer,e=b.axisLabelContainerTop,p=b.axisPlotLineContainer,n=b.axisPlotLineContainerTop,t=b.vlineLabelContainer,r=b.axisBandContainer,w=b.axisNameContainer,C=b.axisTrendContainerTop,v=b.axisTrendContainerBottom,A=b.axisTrendLabelContainer,H=b.axisAxisLineContainer,K=b.axisAxisLineContainerBottom,D=b.divLineThickness||0,F=g.axisBottomGroup,Q=g.axisTopGroup,R=b.animateAxis,I,L,J,Ba,ha,
W,M,U,Z,X,N,ca,O;Z=h.y*h.scaleY;X=h.x*h.scaleX;c=c.get("config","animationObj");N=c.animObj;ca=c.dummyObj;I=c.transposeAnimDuration;O=d?f+","+(m-D)+","+l+","+(q+2*D):f-D+","+m+","+(l+2*D)+","+q;D=g.axisBandGroup=g.axisBandGroup||k.group("dataset-Band-group",F);L=g.axisPlotLineGroup=g.axisPlotLineGroup||k.group("dataset-Line-group",F);U=g.axisTrendGroupBottom=g.axisTrendGroupBottom||k.group("dataset-Trend-group-bottom",F);J=g.axisPlotLineGroupTop=g.axisPlotLineGroupTop||k.group("dataset-Line-group-top",
Q);ha=g.axisNameGroup=g.axisNameGroup||k.group("dataset-Name-group",F);Ba=g.axisLineGroup=g.axisLineGroup||k.group("axis-Line-group",Q);M=g.axisTrendGroupTop=g.axisTrendGroupTop||k.group("dataset-Trend-group-top",Q);W=g.axisLabelGroup=g.axisLabelGroup||k.group("dataset-Label-group",F);g=g.axisLabelGroupTop=g.axisLabelGroupTop||k.group("dataset-Label-group",Q);a||(b.axisContainer=a=k.group("dataset-axis",W));e||(b.axisLabelContainerTop=e=k.group("dataset-top-label",g));H||(b.axisAxisLineContainer=
k.group("axis-line-tick",Ba));t||(b.vlineLabelContainer=t=k.group("axis-vline-label",Ba));r?I&&R?r.animateWith(ca,N,{"clip-rect":f+","+m+","+l+","+q},I,c.animType):r.attr({"clip-rect":f+","+m+","+l+","+q}):(b.axisBandContainer=r=k.group("dataset-axis-bands",D),r.attr({"clip-rect":f+","+m+","+l+","+q}));p?I&&R?p.animateWith(ca,N,{"clip-rect":O},I,c.animType):p.attr({"clip-rect":O}):(b.axisPlotLineContainer=p=k.group("dataset-axis-lines",L),p.attr({"clip-rect":O}));n?I&&R?n.animateWith(ca,N,{"clip-rect":O},
I,c.animType):n.attr({"clip-rect":O}):(b.axisPlotLineContainerTop=n=k.group("dataset-axis-lines-top",J),n.attr({"clip-rect":O}));C?I&&R?C.animateWith(ca,N,{"clip-rect":f+","+m+","+l+","+q},I,c.animType):C.attr({"clip-rect":f+","+m+","+l+","+q}):(b.axisTrendContainerTop=C=k.group("dataset-axis-trend-top",M),C.attr({"clip-rect":f+","+m+","+l+","+q}));v?I&&R?v.animateWith(ca,N,{"clip-rect":f+","+m+","+l+","+q},I,c.animType):v.attr({"clip-rect":f+","+m+","+l+","+q}):(b.axisTrendContainerBottom=v=k.group("dataset-axis-trend-bottom",
U),v.attr({"clip-rect":f+","+m+","+l+","+q}));A||(b.axisTrendLabelContainer=k.group("dataset-axis-trend-label",M));w||(b.axisNameContainer=k.group("dataset-axis-name",ha));K||(b.axisAxisLineContainerBottom=k.group("axis-line-tick-bottom",F));u.scaleX!==h.scaleX||u.scaleY!==h.scaleY?(u.scaleX=h.scaleX,u.scaleY=h.scaleY):d?(b=Z-h.y*h.scaleY,t.transform("t0,"+b),a.transform("t0,"+b),e.transform("t0,"+b),p.transform("t0,"+b),n.transform("t0,"+b),r.transform("t0,"+b),C.transform("t0,"+b),v.transform("t0,"+
b)):(b=X-h.x*h.scaleX,t.transform("t"+b+",0"),a.transform("t"+b+",0"),e.transform("t"+b+",0"),p.transform("t"+b+",0"),n.transform("t"+b+",0"),r.transform("t"+b+",0"),C.transform("t"+b+",0"),v.transform("t"+b+",0"));this._drawComponents()},hide:function(){var b=this.config;b.axisContainer&&(b.axisLabelContainerTop.hide(),b.axisContainer.hide(),b.axisPlotLineContainer.hide(),b.axisPlotLineContainerTop.hide(),b.axisBandContainer.hide(),b.axisNameContainer.hide(),b.axisTrendContainerTop.hide(),b.axisTrendContainerBottom.hide(),
b.axisTrendLabelContainer.hide(),b.axisAxisLineContainer.hide(),b.axisAxisLineContainerBottom.hide())},show:function(){var b=this.config;b.axisContainer&&(b.axisLabelContainerTop.show(),b.axisContainer.show(),b.axisPlotLineContainer.show(),b.axisPlotLineContainerTop.show(),b.axisBandContainer.show(),b.axisNameContainer.show(),b.axisTrendContainerTop.show(),b.axisTrendContainerBottom.show(),b.axisTrendLabelContainer.show(),b.axisAxisLineContainer.show(),b.axisAxisLineContainerBottom.show())},_drawComponents:function(){var b=
this.config,a=this.chart.is3D,c,e;b.drawAxisName&&this._drawAxisName();b.drawAxisLine&&this._drawAxisLine();b.drawAxisLine&&b.hasBreakPoints&&this._drawBreakPoints();b.isActive||(c=b.lines.isDraw,e=b.band.isDraw,b.lines.isDraw=0,b.band.isDraw=0);b.hasCategory?(b.drawLabels&&this._drawCategory(),b.drawOnlyCategoryLine&&this._drawCategoryLine()):(b.drawLabels&&this._drawLabel(),b.drawPlotlines&&this._drawPlotLine());b.hasCategory&&"auto"!==b.xAxisLabelMode?(b.drawPlotlines&&this._drawCategoryVline(),
b.drawPlotlines&&!a&&this._drawCategoryPlotLine(),b.drawPlotBands&&!b.hasBreakPoints&&!a&&this._drawCategoryPlotBand(),"mixed"===b.xAxisLabelMode&&b.drawPlotBands&&!b.hasBreakPoints&&!a&&this._drawPlotBand()):b.drawPlotBands&&!b.hasBreakPoints&&!a&&this._drawPlotBand();b.isActive||(b.lines.isDraw=c,b.band.isDraw=e);b.drawTrendLines&&this._drawTrendLine();b.isConfigured=!1},_manageReuseableElement:function(b,a,c){var e=this.config.isConfigured,d=this.chart.components.paper,g,k,h,u;g=b._graphicElem||
(b._graphicElem=[]);k=b._freeElem||(b._freeElem=[]);h=b._usedElem||(b._usedElem={});u=b._drawnIds={};return{getElement:function(b,m){var l=m||{};u[b]=!0;if(h[b])return h[b]._applyAllAttr=e,h[b]._firstTimeDraw=!1,h[b];if(0<k.length)return h[b]=k.pop(),h[b]._applyAllAttr=!0,h[b]._firstTimeDraw=!1,h[b];g.push(d[a](l,c));h[b]=g[g.length-1];h[b]._firstTimeDraw=!0;h[b]._applyAllAttr=!1;return h[b]},freeUnusedElement:function(){for(var b in h)h.hasOwnProperty(b)&&!u[b]&&(h[b].attr({visibility:"hidden"}),
k.push(h[b]),delete h[b])}}},_drawLabel:function(){var b=this.config,a=b.canvas,c=b.axisDimention||{},e=this.chart,d=e.config,g=e.components,k=b.axisRange,h=b.isOpposit,u,f=b.labels,m=f.style,l,q,p=b.isVertical,n=b.animateAxis,t=k.max,r=k.min,w=a.canvasTop||d.canvasTop,C=a.canvasLeft||d.canvasLeft,v=a.canvasBottom||d.canvasBottom,a=a.canvasRight||d.canvasRight,d=b.axisNameContainer,A=b.labelPadding,H=b.showUpperLimit,K=g.paper,D=b.labelMaxH,F=b.labelMaxW,Q=b.extremeLabels,R=p?c.x:c.y,c=c.opposite,
I=b.drawLabelOnBothSide,L=this.graphics.labels||[],J=0,Ba=!0,ha=!1,W,N,U,Z={fontFamily:m.fontFamily,fontSize:m.fontSize,fontWeight:m.fontWeight,fontStyle:m.fontStyle,lineHeight:m.lineHeight},X,da,ca,O,T,fa=function(){(H||!H&&1>=b.labels.step)&&!ha&&l<t&&l+u>t&&(q=l=t-u,ha=!0);b.showZeroPlane&&0>l&&0<l+u?(l=0,q+=u):l<q?l=q:(l+=u,q+=u)};m.lineHeight&&(W=m.lineHeight,-1!==W.indexOf("px")&&(W=W.replace("px",""),W=parseFloat(W)));if(b.labels.isDraw){!I&&b.drawLabelsOpposit&&(h=!h,R=c);Ba=e.get("config",
"animationObj");ca=Ba.animObj;O=Ba.dummyObj;e=Ba.transposeAnimDuration;T=Ba.animType;Ba=Ra(this.getPixel(r)-this.getPixel(r+k.tickInterval));p?(b.labelMaxH>Ba&&!b.hasCategory&&(N=xb(b.labelMaxH/Ba)),N>b.labels.step&&(b.labels.step=N)):(b.labelMaxW>Ba&&!b.hasCategory&&(N=xb(b.labelMaxW/Ba)),N>b.labels.step&&(b.labels.step=N,H=!0));b.labels.step?u=k.tickInterval*b.labels.step:u=k.tickInterval;U=b.labels.rotation;k=this._getVisibleConfig();Ba=this._isZoomed();J=r+u*hb((k.minValue-3*u-r)/u);N=r+u*hb((k.maxValue+
3*u-r)/u);J=J<r?r:J;N=N>t?t:N;X={fill:m.color,"line-height":W,"font-size":m.fontSize};I&&(da={fill:m.color,"line-height":W,"font-size":m.fontSize});p||(U?(X["text-anchor"]=h?cb:db,X["vertical-align"]="center",I&&(da["text-anchor"]=h?db:cb,da["vertical-align"]="center")):(X["vertical-align"]=h?lb:Xa,I&&(da["vertical-align"]=h?Xa:lb)));d.css(Z);Q.firstLabel={};Q.lastLabel={};q=l=J;for(J=0;l<=N;){if(!Ba||!(l<k.minValue||l>k.maxValue))if(b.labels.drawNormalVal||b.labels.drawLimitVal&&(l===r||l===t))if(b.labels.drawNormalVal||
l===r||l===t)if(b.labels.drawLimitVal||l!==r&&l!==t)if(0!==b.showZeroPlane&&0!==b.showZeroPlaneValue||0!==l){if(1===b.showZeroPlane&&1===b.showZeroPlaneValue&&(0>l&&0<l+u||0<l&&0>l-u)&&l!==r&&l!==t)if(p){if(this.getPixel(l)+D>=this.getPixel(0)&&this.getPixel(0)>=this.getPixel(l)-D){fa();continue}}else if(this.getPixel(l)+F>=this.getPixel(0)&&this.getPixel(0)>=this.getPixel(l)-F){fa();continue}m=b.hasBreakPoints?M(this._getRealBreakValue(l),10):M(l,10);if(p)W=b.numberFormatterFn?g.numberFormatter[b.numberFormatterFn]:
b.isPercent?g.numberFormatter.percentValue:g.numberFormatter.yAxis,W=""+W.call(g.numberFormatter,m,b.axisIndex),X["text-anchor"]=h?cb:db,X.text=W,X.x=h?(R||a)+A:(R||C)-A,X.y=this.getPixel(m),I&&(da["text-anchor"]=h?db:cb,da.text=W,da.x=h?(c||C)-A:(c||a)+A,da.y=this.getPixel(m));else{W=b.numberFormatterFn?g.numberFormatter[b.numberFormatterFn]:b.isPercent?g.numberFormatter.percentValue:g.numberFormatter.xAxis;W=""+W.call(g.numberFormatter,m);X.text=W;X.x=this.getPixel(m);X.y=h?(R||w)-A:(R||v)+A;if(l!==
t&&H&&X.x+b.labelMaxW>a){fa();continue}I&&(da.text=W,da.x=this.getPixel(m),da.y=h?(c||v)+A:(c||w)-A)}f.shiftX&&(X.x+=f.shiftX);f.shiftY&&(X.y+=f.shiftY);X.transform=K.getSuggestiveRotation(U,X.x,X.y);L[J]?(m=L[J],e&&n?m.animateWith(O,ca,X,e,T):m.attr(X)):L[J]=m=K.text(X,d);J+=1;I&&(da.transform=K.getSuggestiveRotation(U,da.x,da.y),L[J]?(m=L[J],e&&n?m.animateWith(O,ca,da,e,T):m.attr(da)):L[J]=m=K.text(da,d),J+=1);l===t?Q.lastLabel.graphic=m:l===r&&(Q.firstLabel.graphic=m)}fa()}if(L[J])for(l=J;l<L.length;l++)L[l].attr({text:""});
this.graphics.labels=L}else if(L[J])for(l=J;l<L.length;l++)L[l].attr({text:""})},_drawAxisName:function(){var b=this.config,a=b.canvas,c=this.chart,d=c.config,g=c.components,E=b.axisDimention||{},k=b.name.style,h=b.name.value,u=b.isVertical,f=b.isOpposit,m=c.linkedItems.smartLabel,l=a.canvasBottom||d.canvasBottom,q=a.canvasLeft||d.canvasLeft,p=a.canvasRight||d.canvasRight,n=a.canvasTop||d.canvasTop,t=a.canvasHeight||d.canvasHeight,r=a.canvasWidth||d.canvasWidth,a=b.axisNameContainer,w=b.axisNamePadding,
C=b.nameMaxH,v=b.nameMaxW,A=u?E.x:E.y,H=E.opposite,K=this.graphics.axisName||{},E=e(b.name.rotation,u?270:90),g=g.paper,D={fontFamily:k.fontFamily,fontSize:k.fontSize,lineHeight:k.lineHeight,fontWeight:k.fontWeight,fontStyle:k.fontStyle},I=b.animateAxis,Q,R,F,L;b.name.isDraw?(Q=c.get("config","animationObj"),R=Q.animObj,F=Q.dummyObj,c=Q.transposeAnimDuration,L=Q.animType,Q={fontFamily:k.fontFamily,fill:k.color,"vertical-align":"center","font-size":k.fontSize,"line-height":k.lineHeight},m.useEllipsesOnOverflow(d.useEllipsesWhenOverflow),
m.setStyle({fontSize:k.fontSize,fontFamily:k.fontFamily,lineHeight:k.lineHeight,fontWeight:k.fontWeight}),!b.drawLabelOnBothSide&&b.drawAxisNameOpposit&&(f=!f,A=H),u?(b.relativeAxis&&b.relativeAxis.config&&b.relativeAxis.config.axisNamePadding&&(w=Ea(b.relativeAxis.config.axisNamePadding,w)),f&&d.canvasMarginRight&&(w=Ea(w,d.canvasMarginRight-d.marginLeft-v)),!f&&d.canvasMarginLeft&&(w=Ea(w,d.canvasMarginLeft-d.marginRight-v)),r=b.axisNameAlignCanvas||d.captionalignment&&"left"==d.captionalignment?
t:Ea(t,b.oriCanvasHeight||0),E?(h=m.getSmartText(h,r,v),m=h.tooltext,r=h.width):(h=m.getSmartText(h,v,r),m=h.tooltext,r=h.height),d=b.drawAxisNameFromBottom?l-r/2:r>t?d.height/2:n+t/2,Q.text=h.text,Q.x=f?(A||p)+w+v/2:(A||q)-w-v/2,Q.y=d):(h=m.getSmartText(h,r,C),m=h.tooltext,f&&d.canvasMarginTop&&(w=Ea(w,d.canvasMarginTop-d.marginTop-C)),!f&&d.canvasMarginBottom&&(w=Ea(w,d.canvasMarginBottom-d.marginBottom-C)),Q.text=h.text,Q.x=q+r/2,Q.y=f?(A||n)-w-C/2:(A||l)+w+C/2),Q.transform=g.getSuggestiveRotation(u?
E:0,Q.x,Q.y),this.graphics.axisName?(Q.visibility=Pa,c&&I?K.animateWith(F,R,Q,c,L):K.attr(Q),b.showTooltip&&m&&K.trackTooltip(!0),K.css(D)):(K=g.text(Q,D,a).tooltip(m),b.showTooltip&&m&&K.trackTooltip(!0)),""!==h.text?K.attr({"text-bound":[k.backgroundColor,k.borderColor,k.borderThickness,k.borderPadding,k.borderRadius,k.borderDash]}):K.attr({"text-bound":[]}),this.graphics.axisName=K):this.graphics.axisName&&this.graphics.axisName.attr({visibility:Ua})},_drawPlotLine:function(){var b=this.config,
a=b.axisRange,c=a.tickInterval,e=b.isVertical,d=b.canvas,g=this.chart,k=this.chart.is3D,h=g.config,u=d.canvasBottom||h.canvasBottom,f=d.canvasLeft||h.canvasLeft,m=d.canvasRight||h.canvasRight,d=d.canvasTop||h.canvasTop,h=a.max,a=a.min,l=b.axisPlotLineContainer,q=b.axisPlotLineContainerTop,p=b.showCanvasBorder,n=g.components.paper,t=this.graphics.line||[],r=0,w=L(b.divLineColor,b.divLineAlpha),C=b.divLineThickness,v=b.divLineIsDashed?I(b.divLineDashLen,b.divLineDashGap,C):"none",A=L(b.zeroPlaneColor,
b.zeroPlaneAlpha),H=b.zeroPlaneThickness,K=b.animateAxis,D,F,Q,R,J,ub,M,Ba,v={stroke:w,"stroke-width":C,"stroke-dasharray":v};2>Ra(this.getPixel(a)-this.getPixel(a+c))&&(b.lines.isDraw=0);if(b.lines.isDraw){r=g.get("config","animationObj");ub=r.animObj;M=r.dummyObj;g=r.transposeAnimDuration;Ba=r.animType;F=this._getVisibleConfig();r=a+c*hb((F.minValue-3*c-a)/c);F=a+c*hb((F.maxValue+3*c-a)/c);r=r<a?a:r;F=F>h?h:F;J=l;R=Q=r;for(r=0;Q<=F;)0===b.showZeroPlane&&0===Q||p&&(Q===h||Q===a)||(0===Q&&Q!==a&&
Q!==h&&(v.stroke=A,v["stroke-width"]=H,b.showZeroPlaneOnTop&&!k&&(J=q)),D=b.hasBreakPoints?this._getRealBreakValue(Q):Q,D=e?sb(["M",f,this.getPixel(D),"L",m,this.getPixel(D)],C):sb(["M",this.getPixel(D),d,"L",this.getPixel(D),u],C),v.path=D.path,v["shape-rendering"]=D.isCrisped?"crisp":void 0,t[r]?(D=t[r],J.appendChild(D),g&&K?D.animateWith(M,ub,v,g,Ba):D.attr(v)):(D=n.path(v,J),t[r]=D),0===Q&&Q!==a&&Q!==h&&(v.stroke=w,v["stroke-width"]=C,J=l),r+=1),b.showZeroPlane&&0>Q&&0<Q+c?(Q=0,R+=c):Q<R?Q=R:
(Q+=c,R+=c);if(t[r])for(Q=r;Q<t.length;Q++)t[Q].attr({path:[]});this.graphics.line=t}else if(t[r])for(Q=r;Q<t.length;Q++)t[Q].attr({path:[]})},_drawAxisLine:function(){var b=this.config,a=b.axisRange,c=b.isVertical,d=b.isOpposit,g=b.canvas,E=this.chart,k=E.config,h=b.breakPoints,u=g.canvasBottom||k.canvasBottom,f=g.canvasLeft||k.canvasLeft,m=g.canvasRight||k.canvasRight,l=g.canvasTop||k.canvasTop,g=b.axisDimention||{},q=c?g.x:g.y,p=b.drawAxisLineWRTCanvas,n=E.jsonData.chart,g=E.components.paper,k=
this.graphics.axisLine||[],t=!1,r=0,w=a.max,C=a.min,a=a.tickInterval,v=b.axisAxisLineContainerBottom,A={},H=b.animateAxis,K,D,F,A=1===e(n.showyaxisline,n.showyaxisline)?e(n.yaxislinethickness,n.pyaxislinethickness,1):0;if(b.showAxisLine){K=E.get("config","animationObj");n=K.animObj;F=K.dummyObj;E=K.transposeAnimDuration;K=K.animType;if(c)if(d?q=(p?m:q||m)+b.axisLineThickness/2:(q=p?f:q||f,q-=b.axisLineThickness/2),b.hasBreakPoints){A=["M",q,u,"L"];u=0;for(p=h.length;u<p;u+=1)f=this.getPixel(h[u].start),
A.push(q,f,"M",q,f-4,"L");A.push(q,l)}else D=sb(["M",q,u,"L",q,l],b.axisLineThickness),A=D.path;else if(d?(q=p?l:q||l,q-=b.axisLineThickness/2):(q=p?u:q||u,q+=b.axisLineThickness/2),b.hasBreakPoints){A=["M",f-A,q,"L"];u=0;for(p=h.length;u<p;u+=1)f=this.getPixel(h[u].start),A.push(f,q,"M",f-4,q,"L");A.push(m,q)}else D=sb(["M",f-A,q,"L",m,q],b.axisLineThickness),A=D.path;k[r]?(h=k[r],E&&H?h.animateWith(F,n,{path:A,stroke:b.axisLineColor,"stroke-linecap":"butt","stroke-width":b.axisLineThickness,"shape-rendering":D.isCrisped?
"crisp":void 0},E,K):h.attr({path:A,"stroke-linecap":"butt",stroke:b.axisLineColor,"stroke-width":b.axisLineThickness,"shape-rendering":D.isCrisped?"crisp":void 0})):(h=g.path({path:A,"stroke-linecap":"butt",stroke:b.axisLineColor,"stroke-width":b.axisLineThickness},v),k[r]=h);r+=1;if(b.drawTick&&b.tickLength)for(A={stroke:b.tickColor,"stroke-width":b.tickWidth},d=c?d?q+b.tickLength:q-b.tickLength:d?q-b.tickLength:q+b.tickLength,D=this._getVisibleConfig(),r=C+a*hb((D.minValue-3*a-C)/a),D=C+a*hb((D.maxValue+
3*a-C)/a),D=D>w?w:D,u=r<C?C:r,r=1;u<=D;u+=a)C=b.hasBreakPoints?this._getRealBreakValue(u):u,C=this.getPixel(C),A.path=c?"M"+q+" "+C+"L"+d+" "+C:"M"+C+" "+q+"L"+C+" "+d,k[r]?(C=k[r],E&&H?C.animateWith(F,n,A,E,K):C.attr(A)):(C=g.path(A,v),k[r]=C),!t&&u<w&&u+a>w&&(u=w-a,t=!0),r+=1}if(k[r])for(u=r;u<k.length;u++)k[u].attr({path:[]});this.graphics.axisLine=k},_drawBreakPoints:function(){var b=this.config,a=b.isVertical,c=this.chart,e=c.config,d=b.breakPoints,e=b.canvas.canvasLeft||e.canvasLeft,g=c.components.paper,
k=this.graphics.brokeLine||[],h=c.graphics,u=b.animateAxis,f,m,l,q,p,n,t,r;if(b.showAxisLine)for(f=c.get("config","animationObj"),n=f.animObj,t=f.dummyObj,c=f.transposeAnimDuration,r=f.animType,f=0,q=d.length;f<q;f+=1)a?(m=e-b.axisLineThickness/2,l=this.getPixel(d[f].start),l=["M",m-4,l+4/3,"L",m+4,l-4/3,"M",m-4,l-8/3,"L",m+4,l-16/3]):l=["M",0,0],k[f]?(m=k[f],c&&u?m.animateWith(t,n,{path:l,stroke:b.axisLineColor,"stroke-width":b.axisLineThickness},c,r):m.attr({path:l,stroke:b.axisLineColor,"stroke-width":b.axisLineThickness})):
(m=g.path({path:l,stroke:b.axisLineColor,"stroke-width":b.axisLineThickness},h.axisLineGroup),k[f]=m),p+=1;if(k[p])for(f=p;f<k.length;f++)k[f].attr({path:[]});this.graphics.brokeLine=k},_drawPlotBand:function(){var b=this.config,a=b.axisRange,c=b.canvas,e=this.chart,d=e.config,g=c.canvasLeft||d.canvasLeft,k=c.canvasTop||d.canvasTop,h=c.canvasHeight||d.canvasHeight,c=c.canvasWidth||d.canvasWidth,d=a.tickInterval,u=b.isVertical,f=b.isReverse,m=a.max,l=a.min,a=b.axisBandContainer,q=e.components.paper,
p=this.graphics.band||[],n=0,r=b.showAlternateGridColor,w=b.alternateGridColor,C=b.alternateGridAlpha,v=b.animateAxis,A,H,K,D,F;2>Ra(this.getPixel(l)-this.getPixel(l+d))&&(b.band.isDraw=0);if(r&&b.band.isDraw){n=e.get("config","animationObj");r=n.animObj;D=n.dummyObj;e=n.transposeAnimDuration;F=n.animType;A=this._getVisibleConfig();n=l+d*hb((A.minValue-3*d-l)/d);A=l+d*hb((A.maxValue+3*d-l)/d);n=n<l?l:n;A=A>m?m:A;m=ab((n-l)/d)+1;w={fill:t(L(w,C)),"stroke-width":0};l=this.getPVR();H=C=n;for(n=0;C<A;m+=
1)0===m%2&&(K=b.showZeroPlane&&0>C&&0<C+d?C:C!==H?H-C:d,u?(w.x=g,w.y=this.getPixel(f?C:C+Ra(K)),w.width=c,w.height=Ra(K*l)):(w.x=this.getPixel(C),w.y=k,w.width=Ra(K*l),w.height=h),p[n]?(K=p[n],e&&v?K.animateWith(D,r,w,e,F):K.attr(w)):(K=q.rect(w,a),p[n]=K),n+=1),b.showZeroPlane&&0>C&&0<C+d?(C=0,H+=d):C<H?C=H:(C+=d,H+=d);if(p[n])for(C=n;C<p.length;C++)p[C].attr({x:0,y:0,width:0,height:0,fill:null,"stroke-width":0});this.graphics.band=p}else if(p[n])for(C=n;C<p.length;C++)p[C].attr({x:0,y:0,width:0,
height:0,fill:null,"stroke-width":0})},_drawTrendLine:function(){var b=this.config,a=b.canvas,d=this.chart,g=d.config,G=d.components,E=b.isOpposit,k=b.isVertical,h=d.is3D,u=b.axisIndex,f=G.numberFormatter,m=a.canvasBottom||g.canvasBottom,l=a.canvasLeft||g.canvasLeft,q=a.canvasRight||g.canvasRight,p=a.canvasTop||g.canvasTop,n=a.canvasHeight||g.canvasHeight,a=a.canvasWidth||g.canvasWidth,t=b.axisRange,g=t.max,t=t.min,r,w,C=b.trend.trendStyle,v=b.labelPadding,A=b.axisTrendContainerTop,H=b.axisTrendContainerBottom,
D=b.axisTrendLabelContainer,G=G.paper,F=this.components.trendObj||[],J={fontFamily:C.fontFamily,fontSize:C.fontSize,lineHeight:C.lineHeight,fontWeight:C.fontWeight,fontStyle:C.fontStyle},Q=b.vTrendLines,R=b.trendLines,M=!0,ub=b.drawTrendLabels,N=b.axisDimention||{},Ba=b.animateAxis,ha,W,O,U,Z,X,da=0,ca,S,eb,fa,aa,ma,V,ja,la,oa,ba;aa=this._getVisibleConfig();b.hasBreakPoints&&(aa.minValue=this._getRealBreakValue(aa.minValue),aa.maxValue=this._getRealBreakValue(aa.maxValue));(M=this._isZoomed())?(r=
Ea(this.getPixel(aa.minValue),this.getPixel(aa.maxValue)),w=Va(this.getPixel(aa.minValue),this.getPixel(aa.maxValue))):(aa.minValue=t,aa.maxValue=g);Q?la=E?(N.opposite||m)-(b.trendBottomPadding||0):(N.y||m)+(b.trendBottomPadding||0):(la=E?(N.opposite||l)+(v||0):(N.x||l)-(v||0),oa=E?(N.x||q)+(v||0):(N.opposite||q)+(v||0));if(E=R||Q){ha=d.get("config","animationObj");v=ha.animObj;N=ha.dummyObj;d=ha.transposeAnimDuration;ba=ha.animType;O=0;for(U=E.length;O<U;O+=1)for(ha=0,W=E[O].line&&E[O].line.length;ha<
W;ha+=1)ma=E[O].line[ha],ca=k?"yAxis":"xAxis",S=f.getCleanValue(c(ma.startvalue,ma.value,0)),X=Number(ma.endvalue)||void 0,Z=Ja(K(c(ma.tooltext,E[0].tooltext,b.trendlineToolText))),Z=ea(Z,[7,15,16,17,18,19],{startValue:S,startDataValue:f[ca](S,u),endValue:X||S,endDataValue:f[ca](X||S,u),axisName:b.axisName},ma),S>g||S<t||X>g||X<t||!(Q&&S>=aa.minValue&&S<=aa.maxValue||X&&X>=aa.minValue&&X<=aa.maxValue||X&&S<=aa.minValue&&X>=aa.maxValue||R&&S>aa.minValue&&S<=aa.maxValue||X&&X>=aa.minValue&&X<=aa.maxValue||
X&&S>=aa.minValue&&X<=aa.maxValue)||(Q?(fa=K(ma.displayvalue||""),V=this.getPixel(b.hasBreakPoints?this._getRelativeBreakValue(S):S),eb=e(ma.istrendzone,b.isTrendZone,1),ja=X?this.getPixel(b.hasBreakPoints?this._getRelativeBreakValue(X):X):0,void 0!==X&&""!==X&&X!==S&&eb?(eb={fill:L(c(ma.color,b.trendlineColor),c(ma.alpha,b.trendlineAlpha,40)),"stroke-width":0,path:["M",V,p,"L",V,m,"L",ja,m,"L",ja,p,"Z"]},fa={fill:L(c(ma.color,C.color),c(ma.alpha,b.trendlineAlpha,99)),"vertical-align":Xa,text:fa,
x:V+(ja-V)/2,y:la}):(eb=e(ma.thickness,b.trendlineThickness,1),eb=eb>a?1:eb,S=X?sb(["M",V,p,"L",ja,m],eb):sb(["M",V,p,"L",V,m],eb),eb={stroke:L(c(ma.color,b.trendlineColor),c(ma.alpha,b.trendlineAlpha,99)),"stroke-width":eb,"stroke-dasharray":c(ma.dashed,b.trendlinesAreDashed)===T?I(e(ma.dashlen,b.trendlinesDashLen),e(ma.dashgap,b.trendlinesDashGap),eb):"none","shape-rendering":S.isCrisped?"crisp":void 0,path:S.path},fa={fill:L(c(ma.color,C.color),c(ma.alpha,b.trendlineAlpha,99)),"vertical-align":Xa,
text:fa,x:X?ja:V,y:la}),M&&(!ub||fa.x>r||fa.x<w)&&(fa.text="")):R&&(fa=K(ma.displayvalue||""),ca=e(ma.valueonright,0),eb=e(ma.istrendzone,b.isTrendZone,0),V=this.getPixel(S),ja=X?this.getPixel(X):0,void 0!==X&&""!==X&&X!==S&&eb?(eb={fill:L(c(ma.color,b.trendlineColor),c(ma.alpha,b.trendlineAlpha,40)),"stroke-width":0,path:["M",l,V,"L",q,V,"L",q,ja,"L",l,ja,"Z"]},fa={"text-anchor":ca?cb:db,fill:L(c(ma.color,C.color),c(ma.alpha,b.trendlineAlpha,99)),text:fa,x:ca?oa:la,y:V+(ja-V)/2}):(eb=e(ma.thickness,
b.trendlineThickness,1),eb=eb>n?1:eb,S=X?sb(["M",l,V,"L",q,ja],eb):sb(["M",l,V,"L",q,V],eb),eb={stroke:L(c(ma.color,b.trendlineColor),c(ma.alpha,b.trendlineAlpha,99)),"stroke-width":eb,"stroke-dasharray":c(ma.dashed,b.trendlinesAreDashed)===T?I(e(ma.dashlen,b.trendlinesDashLen),e(ma.dashgap,b.trendlinesDashGap),eb):"none","shape-rendering":S.isCrisped?"crisp":void 0,path:S.path},fa={"text-anchor":ca?cb:db,fill:L(c(ma.color,C.color),c(ma.alpha,b.trendlineAlpha,99)),text:fa,x:ca?oa:la,y:X?ca?ja:V:V}),
M&&(!ub||fa.y>r||fa.y<w)&&(fa.text="")),X=e(ma.showontop),X=h||1!==X&&1!==b.showTrendlinesOnTop?H:A,F[da]?(ca=F[da].graphics.drawing,S=F[da].graphics.label,X.appendChild(ca),F[da].graphics.config.text=fa.text,d&&Ba?(ca.animateWith(N,v,eb,d,ba),S.animateWith(N,v,fa,d,ba)):(ca.attr(eb),S.attr(fa)),S.css(J),S.tooltip(ma.valueToolText)):(ca=G.path(eb,X),S=G.text(fa,J,D),S.tooltip(ma.valueToolText),F[da]={},F[da].graphics={},F[da].graphics.drawing=ca,F[da].graphics.label=S,F[da].graphics.config={text:fa.text}),
b.showTooltip&&ma.valueToolText?S.trackTooltip(!0):S.trackTooltip(!1),b.showTooltip&&Z?ca.tooltip(Z).trackTooltip(!0):ca.trackTooltip(!1),da+=1);if(F[da])for(ha=da;ha<F.length;ha++)F[ha].graphics.drawing.attr({path:["M",0,0]}),F[ha].graphics.label.attr({text:"","text-bound":[]});this.components.trendObj=F;for(ha=0;ha<da;ha++)F[ha].graphics.label.attr({"text-bound":F[ha].graphics.config.text?[C.backgroundColor,C.borderColor,C.borderThickness,C.borderPadding,C.borderRadius,C.borderDash]:[]})}if(F[da])for(ha=
da;ha<F.length;ha++)F[ha].graphics.drawing.attr({path:["M",0,0]}),F[ha].graphics.label.attr({text:"","text-bound":[]})},_drawCategory:function(){var b,a,d,g,G,E,k=this.config,h=k.axisDimention||{},u=k.canvas,f=this.chart,m=f.config,l=k.isOpposit,p=k.labels,n=p.style,t=k.isVertical,r=u.canvasBottom||m.canvasBottom,w=u.canvasLeft||m.canvasLeft,C=u.canvasRight||m.canvasRight,u=u.canvasTop||m.canvasTop,v=k.axisContainer,m=k.labelPadding,A=f.components.paper,H=t?h.x:h.y,h=h.opposite,K=k.drawLabelOnBothSide,
D=this.components.categoryLabel||(this.components.categoryLabel=[]),F=f.jsonData.categories,J,Q,R,M=function(b){return function(a){ia.call(this,f,a,b)}},ub=0,ub=0,N=k.animateAxis,Ba,ha,W,O,U,Z,X,da,ca,S,T,fa,aa,V,ba;U=(W=k.isCategoryAnimate&&k.animateCategories?k.animateCategories:k.categories.category)?W.length-1:0;fa=0<k.labels.step?k.labels.step:1;this._drawCategoryLine(W,0,U);if(k.labels.isDraw){Ba=f.get("config","animationObj");V=Ba.animObj;ba=Ba.dummyObj;ha=Ba.transposeAnimDuration;Ba=Ba.animType;
t&&(O=Ra(this.getPixel(0)-this.getPixel(1)),k.labelMaxH>O&&(ub=xb(k.labelMaxH/O)),ub>k.labels.step&&(k.labels.step=ub));O=this.getPVR();aa=this._isZoomed();X=this._getVisibleConfig();da=k.labels.rotation;!k.drawLabelOnBothSide&&k.drawLabelsOpposit&&(l=!l,H=h);F&&F[0]&&"auto"!==k.xAxisLabelMode&&(J=F[0].font,Q=F[0].fontsize,R=F[0].fontcolor);J={fontFamily:c(J,n.fontFamily),fontSize:c(Q,n.fontSize),fontWeight:c(n.fontWeight),fontStyle:c(n.fontStyle)};J.lineHeight=q(J);v.css(J);F=this._manageReuseableElement(this.components.categoryLabel,
"text",v);for(ub=Q=0;Q<=U;Q+=fa)if(v=W[Q])if(a=e(v.x,v.y,Q),!(0===e(v.showlabel,k.showLabels,1)||aa&&(a<X.minValue||a>X.maxValue))&&("auto"!==k.xAxisLabelMode&&"mixed"!==k.xAxisLabelMode||0!==k.showZeroPlane&&0!==k.showZeroPlaneValue||0!==a)&&(k.labels.drawNormalVal||k.labels.drawLimitVal&&(0===Q||Q===U))&&(k.labels.drawNormalVal||0===Q||Q===U)&&(k.labels.drawLimitVal||0!==Q&&Q!==U)){g=c(v.font,v.labelfont);G=c(v.fontsize,v.labelfontsize);E=c(v.fontbold,v.labelfontbold)?e(v.fontbold,v.labelfontbold,
0)?"bold":"normal":void 0;S=c(v.fontitalic,v.labelfontitalic)?e(v.fontitalic,v.labelfontitalic,0)?"italic":"normal":void 0;d=L(c(v.fontcolor,v.labelfontcolor,R,n.color),e(v.labelalpha,k.rawAttr.labelFontAlpha,f.singleseries?void 0:v.alpha,100));g||G||E||S?(b={},g&&(b.fontFamily=g),G&&(b.fontSize=G),E&&(b.fontWeight=E),S&&(b.fontStyle=S),b.lineHeight=G?q(b):J.lineHeight):b=void 0;if(b||J)g=(b||J).lineHeight,-1!==g.indexOf("px")&&(ca=g.replace(/px/i,""),ca=parseFloat(ca));S=this.getPixel(a);t?(G=v.label||
"",E=Number(v.labelPadding)||0,g={fill:d,"line-height":ca,opacity:1,"text-anchor":l?cb:db,text:G,cursor:v.link||v.labellink||n.labelLink?"pointer":"",x:l?(H||C)+m:(H||w)-m,y:E?S+E:S},K&&(T={fill:d,"line-height":ca,opacity:1,"text-anchor":l?db:cb,text:G,cursor:v.link||v.labellink||n.labelLink?"pointer":"",x:l?(h||w)-m:(h||C)+m,y:E?S+E:S})):(G=v.label||"",E=Number(v.labelPadding)||0,g={fill:d,"line-height":ca,opacity:1,text:G,cursor:v.link||v.labellink||n.labelLink?"pointer":"",x:S,y:l?(H||u)-m:(H||
r)+m},K&&(T={fill:d,"line-height":ca,opacity:1,text:G,cursor:v.link||v.labellink||n.labelLink?"pointer":"",y:l?(h||r)+m:(h||u)-m}),da?(g["text-anchor"]=l?cb:db,g["vertical-align"]="center",K&&(T["text-anchor"]=l?db:cb,T["vertical-align"]="center")):(g["text-anchor"]=kb,g["vertical-align"]=l?lb:Xa,K&&(T["vertical-align"]=l?Xa:lb,T["text-anchor"]=kb)),E&&(g.y=l?g.y-E:g.y+E,K&&(T.y=l?T.y+E:T.y-E)));p.shiftX&&(g.x+=p.shiftX,K&&(T.x+=p.shiftX));p.shiftY&&(g.y+=p.shiftY,K&&(T.y+=p.shiftY));g.transform=
A.getSuggestiveRotation(da,g.x,g.y);K&&(T.transform=A.getSuggestiveRotation(da,T.x,T.y));D[ub]||(D[ub]={},D[ub].graphics={},D[ub].config={});d=D[ub].graphics.label=F.getElement("p"+a,g);d._applyAllAttr&&d.attr(g);b&&d._firstTimeDraw?(d.css(b),d._appliedCss=!0):d._applyAllAttr&&!d._firstTimeDraw&&b?(d.css({fontFamily:b&&b.fontFamily?b.fontFamily:J.fontFamily,fontSize:b&&b.fontSize?b.fontSize:J.fontSize,fontWeight:b&&b.fontWeight?b.fontWeight:J.fontWeight,fontStyle:b&&b.fontStyle?b.fontStyle:J.fontStyle}),
d._appliedCss=!0):d._appliedCss&&!b&&(d.removeCSS(),delete d._appliedCss);d._firstTimeDraw||(d._applyAllAttr?(G=g,G.visibility=tb):G={x:g.x,y:g.y,transform:g.transform,visibility:tb},ha&&N&&!v.animate?d.animateWith(ba,V,G,ha,Ba):d.attr(G));k.showTooltip&&v.labelTooltext?(d.tooltip(v.labelTooltext),d.trackTooltip(!0)):d.trackTooltip(!1);K&&(Z=D[ub].graphics.secondLabel=F.getElement("s"+a,T),Z.css(b),Z._firstTimeDraw||(Z._applyAllAttr?(G=T,G.visibility=tb):G={x:T.x,y:T.y,transform:g.transform,visibility:tb},
ha&&N&&!v.animate?Z.animateWith(ba,V,G,ha,Ba):Z.attr(G)),k.showTooltip&&v.labelTooltext?(Z.tooltip(v.labelTooltext),Z.trackTooltip(!0)):Z.trackTooltip(!1));d._firstTimeDraw&&d.click(M("dataLabelClick")).hover(M("dataLabelRollOver"),M("dataLabelRollOut"));d.data("eventArgs",{link:v.link||v.labellink||n.labelLink,text:g.text,index:ub});K&&(Z._firstTimeDraw&&Z.click(M("dataLabelClick")).hover(M("dataLabelRollOver"),M("dataLabelRollOut")),D[ub].graphics.secondLabel.data("eventArgs",{link:v.link||v.labellink||
n.labelLink,text:g.text,index:ub}));v.animate&&!t&&(b={x:g.x-v.leftShift*O},v["delete"]&&(b.opacity=0),b.transform=A.getSuggestiveRotation(da,b.x,g.y),D[ub].graphics.label.animateWith(ba,V,b,ha,Ba),K&&(b={x:T.x-v.leftShift*O},v["delete"]&&(b.opacity=0),b.transform=A.getSuggestiveRotation(da,b.x,T.y),D[ub].graphics.secondLabel.animateWith(ba,V,b,ha,Ba)));if(d._applyAllAttr||d._firstTimeDraw)e(v.borderthickness,v.labelborderthickness)&&e(v.borderthickness,v.labelborderthickness,1),b=v.bordercolor||
v.labelbordercolor?L(v.bordercolor||v.labelbordercolor,e(v.borderalpha,v.labelborderalpha,v.alpha,v.labelalpha,100)):"",a=e(v.borderthickness,v.labelborderthickness),d=e(v.borderpadding,v.labelborderpadding),g=e(v.borderradius,v.labelborderradius),G=v.bgcolor||v.labelbgcolor?L(v.bgcolor||v.labelbgcolor,e(v.bgalpha,v.labelbgalpha,v.alpha,v.labelalpha,k.rawAttr.labelFontAlpha,100)):"",E=e(v.borderdashed,v.labelborderdashed,0)?I(e(v.borderdashlen,v.labelborderdashlen,4),e(v.borderdashgap,v.labelborderdashgap,
2),e(v.borderthickness,v.labelborderthickness,1)):0===e(v.borderdashed,v.labelborderdashed)?"none":n.borderDash,v.label?(D[ub].graphics.label.attr({"text-bound":[c(G,n.backgroundColor),c(b,n.borderColor),c(a,n.borderThickness),c(d,n.borderPadding),c(g,n.borderRadius),c(E,n.borderDash)]}),K&&D[ub].graphics.secondLabel.attr({"text-bound":[c(G,n.backgroundColor),c(b,n.borderColor),c(a,n.borderThickness),c(d,n.borderPadding),c(g,n.borderRadius),c(E,n.borderDash)]})):(D[ub].graphics.label.attr({"text-bound":[]}),
K&&D[Q].graphics.secondLabel.attr({"text-bound":[]}));ub+=1}this.components.categoryLabel=D;F.freeUnusedElement()}},_drawCategoryLine:function(b,a,d){var g=this.config,G=g.canvas,E=this.chart,k=E.config,h=E.components,u=g.isVertical,f=G.canvasBottom||k.canvasBottom,m=G.canvasLeft||k.canvasLeft,l=G.canvasRight||k.canvasRight,G=G.canvasTop||k.canvasTop,k=g.axisPlotLineContainer,q=g.showCanvasBorder,p=g.xAxisLabelMode,n=h.paper,h=h.colorManager,t=this.components.categoryLabelLine||[],r=E.jsonData.categories,
w,v,C,A,H,K,D=0,F=g.animateAxis,Q,R,J,M,N,Ba,ha,W;b||(b=g.isCategoryAnimate&&g.animateCategories?g.animateCategories:g.categories.category);a=a||0;d=d||b?b.length-1:0;if(g.drawPlotlines){D=E.get("config","animationObj");Ba=D.animObj;ha=D.dummyObj;E=D.transposeAnimDuration;W=D.animType;this.getPVR();N=this._isZoomed();R=this._getVisibleConfig();r&&r[0]&&(w=r[0].verticallinecolor,v=r[0].verticallinealpha,C=r[0].verticallinethickness,A=r[0].verticallinedashed,H=r[0].verticallinedashlen,K=r[0].verticallinedashgap);
r=a;for(D=0;r<=d;r+=1)(Q=b[r])&&(!q||"auto"!==p&&"mixed"!==p||r!==d&&r!==a)&&(M=e(Q.x,Q.y,r),1!==Number(Q.showverticalline)||N&&(M<R.minValue||M>R.maxValue)||(J=this.getPixel(M),M={stroke:L(c(Q.linecolor,w,g.divLineColor,h.getColor("divLineColor")),c(Q.linealpha,v,h.getColor("divLineAlpha"))),"stroke-width":e(Q.linethickness,C,1)},M["stroke-dasharray"]=e(Q.linedashed,A,0)?I(e(Q.linedashLen,H,4),e(Q.linedashgap,K,2),M["stroke-width"]):"none",J=u?sb(["M",m,J,"L",l,J],M["stroke-width"]):sb(["M",J,G,
"L",J,f],M["stroke-width"]),M.path=J.path,M["shape-rendering"]=J.isCrisped?"crisp":void 0,t[D]?(J=t[D].graphics.line,J.attr(M),E&&F&&!Q.animate?J.animateWith(ha,Ba,M,E,W):J.attr(M)):(J=n.path(M,k),t[D]={},t[D].graphics={},t[D].config={},t[D].graphics.line=J),D+=1));this.components.categoryLabelLine=t}if(t[D])for(r=D;r<t.length;r++)t[r].graphics.line.attr({path:["M",0,0]})},_drawCategoryVline:function(){var b=this.config,d=b.axisRange,g=d.min,d=d.max,P=b.canvas,G=this.chart,E=G.config,k=E.style||{},
h=G.components.paper,u=P.canvasBottom||E.canvasBottom,f=P.canvasLeft||E.canvasLeft,m=P.canvasRight||E.canvasRight,l=P.canvasTop||E.canvasTop,q=P.canvasHeight||E.canvasHeight,P=P.canvasWidth||E.canvasWidth,p=b.categories.category,n=b.isVertical,t=G.linkedItems.smartLabel,r=b.axisPlotLineContainerTop,w=b.axisPlotLineContainer,v=b.vlineLabelContainer,C=b.isRelativeAxisInverse,A={fontFamily:E.style.inCanfontFamily,fontSize:E.style.inCanfontSize,color:E.style.inCancolor,lineHeight:E.style.inCanLineHeight},
H=this.components.categoryVline||[],D=this.components.categoryVlineLabel||[],F=0,J=0,Q=b.animateAxis,R,M,N,O,Ba,ha,W,S,U,Z,X,da,ca,T,aa,fa,V,ma,ba,ja,la,oa,pa,ea,ia,Aa,qa,sa,ua,Ha,Ta,ga;M=b.isCategoryVlineAnimate&&b.animateCategoriesVline?b.animateCategoriesVline:b.categories.vline;R=G.get("config","animationObj");sa=R.animObj;ua=R.dummyObj;G=R.transposeAnimDuration;R=R.animType;O=M.length;N=this.getPVR();Ha=this._isZoomed();Ta=this._getVisibleConfig();for(W=0;W<O;W++)Ba=M[W],ha=K(Ba.label),S=!!e(Ba.showlabelborder,
b.showVLineLabelBorder,1),U=!!e(Ba.showlabelbackground,1),Z=c(Ba.labelhalign,n?cb:kb),"center"==Z?Z=kb:"left"==Z?Z=cb:"right"==Z&&(Z=db),X=c(Ba.labelvalign,n?kb:lb).toLowerCase(),X==kb?X="center":X==Xa?X=lb:X==lb&&(X=Xa),da=e(Ba.labelposition,0),ca=e(Ba.lineposition,.5),T=e(Ba.showvlines,b.showVLines,1),aa=e(Ba.alpha,b.vLineAlpha,80),fa=c(Ba.color,b.vLineColor).replace(/^#?/,"#"),U=U?c(Ba.labelbgcolor,b.vLineLabelBgColor,"333333").replace(/^#?/,"#"):a,oa=c(Ba.labelcolor,b.vLineLabelColor,Ba.color,
k.inCancolor,b.vLineColor).replace(/^#?/,"#"),V=e(Ba.thickness,b.vLineThickness,1),ma=!!Number(c(Ba.dashed,0)),ba=e(Ba.dashlen,5),la=e(Ba.dashgap,2),ja=A.fontSize,parseInt(ja.replace(/px/i,""),10),ja=e(Ba.rotatelabel,b.rotateVLineLabels)?270:0,ca=0>ca||1<ca?.5:ca,da=0>da||1<da?0:da,t.useEllipsesOnOverflow(E.useEllipsesWhenOverflow),t.setStyle(A),t.getOriSize(ha),fa=L(fa,T?aa:"0"),aa=1===Number(Ba.showontop)||1===b.showVLinesOnTop?r:w,Aa=!1,ga=Ba.animate&&!n?Ba.startIndex+1:Ba.startIndex,pa=p[ga],
ea=p[ga+1],pa?ea||(ia=p[0]&&p[0].x?d:b.oriCatLen,Aa=!0):(ia=p[0]&&p[0].x?g:-1,Aa=!0),Aa||(ia=e(pa.x,pa.y,ga),ca*=ia-e(ea.x,ea.y,ga+1)),ca=ia+Ra(ca),Ha&&(ca<Ta.minValue||ca>Ta.maxValue)||!Ba.animate&&(ca<g||ca>d)||Ba.animate&&(ca<g||ca>d+qa)||(ca=this.getPixel(ca),ba={opacity:1,stroke:fa,"stroke-width":V,"stroke-dasharray":ma?I(ba,la,V):"none"},ma={opacity:1,text:ha,"text-anchor":Z,"vertical-align":X,"text-bound":[]},oa={fill:T?oa:fa,fontSize:A.fontSize,fontFamily:A.fontFamily,lineHeight:A.lineHeight,
backgroundColor:U},n?(la=sb(["M",f,ca,"L",m,ca],V),ba.path=la.path,ma.x=f+P*(C?1-da:da),ma.y=ca):(la=sb(["M",ca,l,"L",ca,u],V),ba.path=la.path,ma.x=ca,ma.y=l+q*(C?1-da:da)),ba["shape-rendering"]=la.isCrisped?"crisp":void 0,Z==cb?ma.x+=2:Z==db&&(ma.x-=2),X==Xa?ma.Y+=2:X==lb&&(ma.Y-=2),H[F]?(Z=H[F].graphics.drawing,aa.appendChild(Z),G&&Q&&!Ba.animate?Z.animateWith(ua,sa,ba,G):Z.attr(ba)):(Z=h.path(ba,aa),H[F]={},H[F].graphics={},H[F].config={},H[F].graphics.drawing=Z),ha&&(ma.transform=h.getSuggestiveRotation(ja,
ma.x,ma.y),D[J]?(Z=D[J].graphics.label,Z.css(oa),G&&Q&&!Ba.animate?Z.animateWith(ua,sa,ma,G,R):Z.attr(ma)):(Z=h.text(ma,oa,v).css(oa),D[J]={},D[J].graphics={},D[J].config={},D[J].graphics.label=Z)),Ba.animate&&!n&&(qa=Ba.leftShift*N,Z={x:ma.x-qa},la=sb(["M",ca-qa,l,"L",ca-qa,u],V),V={path:la.path,"shape-rendering":la.isCrisped?"crisp":void 0},Ba["delete"]&&(Z.opacity=0,Z["text-bound"]=[],V.opacity=0),ha&&D[J].graphics.label.animateWith(ua,sa,Z,G,R),H[F].graphics.drawing.animateWith(ua,sa,V,G,R)),
ha&&(D[J].graphics.label.attr({"text-bound":[U,T&&S?fa:a,T&&S?1:0,2,void 0,T&&S?"solid":a]}),J++),F++);if(H[F])for(W=F;W<H.length;W++)H[W].graphics.drawing.attr({path:["M",0,0]});if(D[J])for(W=J;W<D.length;W++)D[W].graphics.label.attr({text:"","text-bound":[]});this.components.categoryVline=H;this.components.categoryVlineLabel=D},_drawCategoryPlotLine:function(){var b=this.config,a=b.isVertical,c=b.axisRange,e=c.max,d=c.min,g=b.canvas,k=this.chart,h=k.config,u=b.categories.category,f=u.length,c=g.canvasBottom||
h.canvasBottom,m=g.canvasLeft||h.canvasLeft,l=g.canvasRight||h.canvasRight,g=g.canvasTop||h.canvasTop,h=b.axisPlotLineContainer,q=k.components.paper,p=this.graphics.line||[],n=0,t=L(b.divLineColor,b.divLineAlpha),r=b.divLineThickness,w=b.divLineIsDashed?I(b.divLineDashLen,b.divLineDashGap,r):"none",v=b.animateAxis,C,A,t={stroke:t,"stroke-width":r,"stroke-dasharray":w};if(u[0]&&(void 0!==u[0].x||void 0!==u[0].y)){if(p[n]&&"categories"===b.xAxisLabelMode)for(e=n;e<p.length;e++)p[e].attr({path:[]})}else if(b.lines.isDraw&&
b.categoryNumDivLines){n=k.get("config","animationObj");u=n.animObj;w=n.dummyObj;k=n.transposeAnimDuration;A=n.animType;b.categoryDivLinesFromZero&&(d=0,e=f-1);f=Ra(e-d)/(b.categoryNumDivLines+1);f=0===f?1:f;C=this._getVisibleConfig();n=d+f*hb((C.minValue-3*f-d)/f);C=d+f*hb((C.maxValue+3*f-d)/f);n=(n<d?d:n)+f;C=(C>e?e:C)-f;e=n;for(n=0;e<=C;e+=f)d=b.hasBreakPoints?this._getRealBreakValue(e):e,d=a?sb(["M",m,this.getPixel(d),"L",l,this.getPixel(d)],r):sb(["M",this.getPixel(d),g,"L",this.getPixel(d),
c],r),t.path=d.path,t["shape-rendering"]=d.isCrisped?"crisp":void 0,p[n]?(d=p[n],k&&v?d.animateWith(w,u,t,k,A):d.attr(t)):(d=q.path(t,h),p[n]=d),n+=1;if(p[n])for(e=n;e<p.length;e++)p[e].attr({path:[]});this.graphics.line=p}else if(p[n])for(e=n;e<p.length;e++)p[e].attr({path:[]})},_drawCategoryPlotBand:function(){var b=this.config,a=b.axisRange,c=a.max,e=a.min,d=b.canvas,g=this.chart,k=g.config,h=b.categories.category,u=h.length,a=d.canvasLeft||k.canvasLeft,f=d.canvasRight||k.canvasRight,m=d.canvasTop||
k.canvasTop,l=d.canvasHeight||k.canvasHeight,d=d.canvasWidth||k.canvasWidth,k=b.isVertical,q=b.axisBandContainer,p=g.components.paper,n=this.graphics.band||[],r=0,w=b.showAlternateGridColor,v=b.alternateGridColor,C=b.alternateGridAlpha,A=b.categoryDivLinesFromZero,H=b.animateAxis,D,K,F;if(h[0]&&(void 0!==h[0].x||void 0!==h[0].y)){if(n[r])for(C=r;C<n.length;C++)n[C].attr({x:0,y:0,width:0,height:0,fill:null,"stroke-width":0})}else if(w&&b.band.isDraw&&b.categoryNumDivLines){r=g.get("config","animationObj");
h=r.animObj;w=r.dummyObj;g=r.transposeAnimDuration;F=r.animType;A&&(e=0,c=u-1);b=Ra(c-e)/(b.categoryNumDivLines+1);b=0===b?1:b;r=this._getVisibleConfig();u=e+b*hb((r.minValue-3*b-e)/b);A=e+b*hb((r.maxValue+3*b-e)/b);u=u<e?e:u;A=A>c?c:A;e=ab((u-e)/b);u+=b;v={fill:t(L(v,C)),"stroke-width":0};K=this.getPVR();C=u;for(r=0;C-b<A;e+=1,C+=b)0===e%2&&(D=C===u?b+Ra(this.getValue(0))+1:C===A?b+Ra(this.getValue(f-a)-c):b,k?(v.x=a,v.y=C===A?this.getPixel(C-Ra(b)):this.getPixel(C-Ra(D)),v.width=d,v.height=Ra(D*
K)):(v.x=C===A?this.getPixel(C-Ra(b)):this.getPixel(C-Ra(D)),v.y=m,v.width=Ra(D*K),v.height=l),n[r]?(D=n[r],g&&H?D.animateWith(w,h,v,g,F):D.attr(v)):(D=p.rect(v,q),n[r]=D),r+=1);if(n[r])for(C=r;C<n.length;C++)n[C].attr({x:0,y:0,width:0,height:0,fill:null,"stroke-width":0});this.graphics.band=n}else if(n[r])for(C=r;C<n.length;C++)n[C].attr({x:0,y:0,width:0,height:0,fill:null,"stroke-width":0})},resetNumericAxisComponents:function(){var b=this.graphics.line,a=this.graphics.labels,c;if(b&&b[0])for(c=
0;c<b.length;c+=1)b[c].attr({path:[]});if(a&&a[0])for(c=0,b=a.length;c<b;c+=1)a[c].attr({text:""})},resetCategoryAxisComponents:function(){var b=this.graphics.line,a=this.components.categoryVline,c=this.components.categoryLabel,e=this.components.categoryLabelLine,d;if(b&&b[0])for(d=0;d<b.length;d+=1)b[d].attr({path:[]});if(c&&c[0])for(d=0,b=c.length;d<b;d+=1)c[d].graphics.label.attr({text:"","text-bound":[]}),c[d].graphics.secondLabel&&c[d].graphics.secondLabel.attr({text:"","text-bound":[]});if(e&&
e[0])for(d=0,b=e.length;d<b;d+=1)e[d].graphics.line.attr({path:["M",0,0]});if(a&&a[0])for(d=0,b=a.length;d<b;d+=1)a[d].graphics.drawing.attr({path:["M",0,0]}),a[d].graphics.label.attr({text:"","text-bound":[]})},placeAxis:function(b){return this.config.isVertical?this._placeVerticalAxis(b):this._placeHorizontalAxis(b)},_placeVerticalAxis:function(b){var a=this.config,d=this.chart,g=d.config,G=d.components,E=d.linkedItems.smartLabel,k=a.axisRange,h=a.name,u=a.isOpposit,f=G.numberFormatter,m=g.canvasHeight,
l=a.labelPadding=e(a.rawAttr.axisValuePadding,4),q=e(a.rawAttr.axisNamePadding,5),p=a.useEllipsesWhenOverflow,n=a.name.style,t=a.trend.trendStyle,r=a.axisName,w=a.trendLines,v=a.drawLabelsOpposit,C=a.drawAxisNameOpposit,A=a.drawLabelOnBothSide,H=0,D=0,F=0,I=0,Q=0,R={left:0,right:0},J="",L="",M=0,N,ha,W,O,U,Z,X;g.viewPortConfig&&1!==g.viewPortConfig.scaleY&&(a._setRangeAgain=!0);a._setRangeAgain&&this._setTickIntervalAfterZoom();a.oriCanvasHeight=m;0>l&&(a.labelPadding=2);M=a.drawTick&&a.tickLength?
a.axisLineThickness+a.tickLength:a.axisLineThickness;a.showAxisLine?(a.labelPadding=e(l,2)+M,0>a.labelPadding&&(a.labelPadding=(0>a.axisLineThickness?0:M)+2),b-=a.axisLineThickness):(a.labelPadding=e(l,2),0>a.labelPadding&&(a.labelPadding=2));l=k.max;ha=k.min;a.name.rotation=0;a.labels.step=a.labelStep;a.labels.isDraw=1;a.lines.isDraw=1;a.band.isDraw=1;a.labels.drawNormalVal=a.showDivLineValues;a.labels.drawLimitVal=a.showLimits;M=n.lineHeight;M=Number(M.replace(/px/i,""));M<b&&(b-=M);1!==a.showLimits&&
1!==a.showDivLineValues&&(a.labels.isDraw=0);N=a.drawLabels?this._getVMaxLabelDimention(A?b-2*a.labelPadding/2:b-a.labelPadding):{width:0,height:0};if(N.width+a.labelPadding>b&&!a.hasCategory||0===N.width)a.labels.isDraw=0;a.labels.isDraw&&(a.labelMaxW=N.width,a.labelMaxH=N.height,H=N.width+a.labelPadding,D=A?2*H:H);if(a.drawTrendLines&&a.drawTrendLabels&&w){k=a.isPercent?G.numberFormatter.percentValue:a.isVertical?G.numberFormatter.yAxis:G.numberFormatter.xAxis;E.useEllipsesOnOverflow(g.useEllipsesWhenOverflow);
E.setStyle({fontSize:t.fontSize,fontFamily:t.fontFamily,lineHeight:t.lineHeight,fontWeight:t.fontWeight});g=0;for(t=w.length;g<t;g+=1)for(N=0,O=w[g].line&&w[g].line.length;N<O;N+=1)U=w[g].line[N],Z=f.getCleanValue(c(U.startvalue,U.value,0)),X=e(U.endvalue,Z),Z<=l&&Z>=ha&&X<=l&&X>=ha&&(a.isOpposit&&(U.valueonright=1),Z=e(U.valueonright,0),I=1===Z?U.endvalue||U.startvalue:U.startvalue||U.endvalue,W=K(U.origText||U.displayvalue||I||""),W===I&&(W=""+k.call(G.numberFormatter,W)),Z?W.length>L.length&&(L=
W):W.length>J.length&&(J=W));N=E.getOriSize(L);Q=N.width+a.labelPadding;N=E.getOriSize(J);I=N.width+a.labelPadding;u?(Q>D&&Q>b&&(Q=b),D=Ea(D,Q+a.labelPadding),I>b-D&&(I=Va(I,b-D))):(I>D&&I>b&&(I=b),D=Ea(D,I+a.labelPadding),Q>b-D&&(Q=Va(Q,b-D)));g=0;for(t=w.length;g<t;g+=1)for(N=0,O=w[g].line&&w[g].line.length;N<O;N+=1){U=w[g].line[N];Z=f.getCleanValue(c(U.startvalue,U.value,0));X=e(U.endvalue,Z);W=1===Number(U.valueonright)?U.origText||U.displayvalue||""+X||"":U.origText||U.displayvalue||""+Z||"";
W=K(""+W);if(Number(W)===X||Number(W)===Z)W=""+k.call(G.numberFormatter,W);U.origText=W;J=(Z=e(U.valueonright,0))?E.getSmartText(W,Q,d.canvasHeight,p):E.getSmartText(W,D,d.canvasHeight,p);U.displayvalue=J.text;J.tooltext?U.valueToolText=J.tooltext:delete U.valueToolText}}b+=M;!a.drawAxisName||0>=b-D-Q||""===r?(h.isDraw=!1,h.value=""):(E.setStyle({fontSize:n.fontSize,fontFamily:n.fontFamily,lineHeight:n.lineHeight,fontWeight:n.fontWeight}),h.isDraw=!0,a.rotateAxisName?(a.name.rotation=u?90:270,d=E.getSmartText(r,
m,b-D-Q),h.value=r,a.nameMaxW=Va(d.height)):(d=E.getSmartText(r,b-D-Q,m),h.value=r,a.nameMaxW=Va(d.width,b-D),a.nameMaxH=d.height,0<=a.axisNameWidth&&(a.nameMaxW=Va(a.nameMaxW,a.axisNameWidth))),F=a.nameMaxW+q);u?(A?(R.left+=Ea(H,I),R.right+=Ea(H,Q)):v?(R.left+=Ea(H,I),R.right+=Q):(R.left+=I,R.right+=Ea(H,Q)),C?(a.axisNamePadding=R.left+q,R.left+=F):(a.axisNamePadding=R.right+q,R.right+=F)):(A?(R.left+=Ea(H,I),R.right+=Ea(H,Q)):v?(R.left+=I,R.right+=Ea(H,Q)):(R.left+=Ea(H,I),R.right+=Q),C?(a.axisNamePadding=
R.right+q,R.right+=F):(a.axisNamePadding=R.left+q,R.left+=F));h.isDraw&&a.axisNamePadding+a.nameMaxW>b&&(a.axisNamePadding=b-a.nameMaxW);return R},_placeHorizontalAxis:function(b){var a=this.config,d=this.chart,g=d.config,G=d.components,E=d.linkedItems.smartLabel,k=a.axisRange,h=a.name,u=a.isOpposit,f=G.numberFormatter,l=a.drawLabelsOpposit,m=a.drawAxisNameOpposit,q=a.drawLabelOnBothSide,p=0,n=g.canvasWidth,t=a.labelPadding=e(a.rawAttr.axisValuePadding,4),r=e(a.rawAttr.axisNamePadding,5),w=a.useEllipsesWhenOverflow,
v=a.name.style,C=a.trend.trendStyle,A=a.axisName,H=a.vTrendLines,D,F,I=0,Q=0,R={top:0,bottom:0},J=0,L=0,M,N,ha,W,O,U;g.viewPortConfig&&1!==g.viewPortConfig.scaleX&&(a._setRangeAgain=!0);a._setRangeAgain&&this._setTickIntervalAfterZoom();0>t&&(a.labelPadding=2);L=a.drawTick&&a.tickLength?a.axisLineThickness+a.tickLength:a.axisLineThickness;a.showAxisLine?(a.labelPadding=e(t,2)+L,0>a.labelPadding&&(a.labelPadding=(0>a.axisLineThickness?0:L)+2),b-=a.axisLineThickness):(a.labelPadding=e(t,2),0>a.labelPadding&&
(a.labelPadding=2));t=k.max;k=k.min;a.labels.rotation=0;a.labels.step=a.labelStep;a.labels.isDraw=1;a.lines.isDraw=1;a.band.isDraw=1;a.labels.drawNormalVal=a.showDivLineValues;a.labels.drawLimitVal=a.showLimits;L=v.lineHeight;L=Number(L.replace(/px/i,""));L<b&&(b-=L);a.rotateLabels&&"stagger"!==a.labelDisplay&&"none"!==a.labelDisplay&&(a.labelDisplay="rotate");1!==a.showLimits&&1!==a.showDivLineValues&&(a.labels.isDraw=0);W=a.drawLabels?this._getHMaxLabelDimention(q?(b-2*a.labelPadding)/2:b-a.labelPadding):
{width:0,height:0};a.labels.rotation?W.width+a.labelPadding>b&&!a.hasCategory&&(a.labels.isDraw=0):W.height+a.labelPadding>b&&!a.hasCategory&&(a.labels.isDraw=0);a.labels.isDraw&&(a.labels.rotation?(a.labelMaxW=W.height,a.labelMaxH=W.width,p=W.width+a.labelPadding):(a.labelMaxW=W.width,a.labelMaxH=W.height,p=W.height+a.labelPadding),I=q?2*p:p);I=Ea(I,a.labelPadding);W=I<=b?b-I:b;if(a.drawTrendLines&&a.drawTrendLabels&&H&&a.isActive)for(U=a.isPercent?G.numberFormatter.percentValue:a.isVertical?G.numberFormatter.yAxis:
G.numberFormatter.xAxis,E.useEllipsesOnOverflow(g.useEllipsesWhenOverflow),E.setStyle({fontSize:C.fontSize,fontFamily:C.fontFamily,lineHeight:C.lineHeight,fontWeight:C.fontWeight}),g=0,F=H.length;g<F;g+=1)for(M=0,ha=H[g].line&&H[g].line.length;M<ha;M+=1)O=H[g].line[M],D=f.getCleanValue(c(O.startvalue,O.value,0)),N=e(O.endvalue,D),D<=t&&D>=k&&N<=t&&N>=k&&(D=e(O.valueonright,0),D=1===D?O.endvalue||O.startvalue:O.startvalue||O.endvalue,N=K(O.origText||O.displayvalue||D||""),N===D&&(N=""+U.call(G.numberFormatter,
N)),O.origText=N,D=E.getSmartText(N,d.canvasWidth,C.lineHeight,w),N=D.height+2,0>W-N?O.displayvalue="":(O.displayvalue=D.text,J=J<D.height?D.height:J),D.tooltext?O.valueToolText=D.tooltext:delete O.valueToolText);I+=J;W=W-J+L;b+=L;!a.drawAxisName||0>=W||""===A?(h.isDraw=!1,h.value=""):(E.setStyle({fontSize:v.fontSize,fontFamily:v.fontFamily,lineHeight:v.lineHeight,fontWeight:v.fontWeight}),h.isDraw=!0,d=E.getSmartText(A,n,W),h.value=A,a.nameMaxW=n,a.nameMaxH=d.height,Q=d.height+r,a.axisNamePadding=
r+I,a.axisNamePadding+d.height>b&&(a.axisNamePadding=b-d.height,Q=d.height+a.axisNamePadding-I));u?(q?(R.bottom+=p+J,R.top+=p):l?R.bottom+=p+J:(R.top+=p,R.bottom+=J),a.trendBottomPadding=R.bottom-J+2,m?R.bottom+=Q:R.top+=Q):(q?(R.bottom+=p+J,R.top+=p):l?(R.top+=p,R.bottom+=J):R.bottom+=p+J,a.trendBottomPadding=R.bottom-J+2,m?R.top+=Q:R.bottom+=Q);return R},_getHMaxLabelDimention:function(b){function a(b,f){switch(f.toLowerCase()){case "left":return Math.abs(c._getCustomPixel(b));case "right":return Math.abs(l.width-
c._getCustomPixel(b))}}var c=this,d=c.config,g=c.chart,l=g.config,k=g.components,h=g.linkedItems.smartLabel,u=d.axisRange,f=d.labels,g=d.labelDisplay,m=d.slantLabel,n=f.style,t=d.maxLabelHeight,r=u.tickInterval,w=d.staggerLines,v=d.labelStep,C=l.canvasLeft,A=l.canvasRight,H=w-2,D,K,F=u.max,I=u.min,v=0,J=d.categories&&d.categories.category,L=0,Q,R,N,O={text:void 0,width:Number.NEGATIVE_INFINITY,style:void 0},u=Number.NEGATIVE_INFINITY,S,Ba,ha,W,T=function(){},U=T,Z=T,X=T,da={},ca,aa,V,fa,ba,ma=0,pa=
!1,ja=0,la,oa=!1,ea,ia,ga,Aa=Number.POSITIVE_INFINITY,qa,sa=Number.POSITIVE_INFINITY;if(d.hasCategory&&(!J||0===J.length))return{width:0,height:0};"rotate"===g&&(d.rotateLabels=1);d.hasCategory||(d.irregularCatAxis=!1);D=0===H?1:1===H?1.5:H;h.useEllipsesOnOverflow(l.useEllipsesWhenOverflow);h.setStyle({fontSize:n.fontSize,fontFamily:n.fontFamily,lineHeight:n.lineHeight,fontWeight:n.fontWeight});if(d.irregularCatAxis){J.sort(function(b,a){return b.x-a.x});H=0;for(L=J.length;H<L;H++){Q=J[H];if(void 0!==
fa){sa=Math.abs(Q.x-fa);ia=Ra(c._getCustomPixel(I)-c._getCustomPixel(I+sa));h.setStyle(Q.style||{});ea=h.getOriSize("W");ea=ea.width;if(ia<1.2*ea){Q.label="";sa=Aa;continue}ga._individualIWR=ia;Q._individualIWL=ia;Aa=sa}ga=Q;fa=Q.x}sa===Number.POSITIVE_INFINITY&&(sa=Math.floor(Math.min(Q.x,F-Q.x)),sa=Math.max(sa,4));H=0;for(L=J.length;H<L;H++)Q=J[H],H||(Q._individualIWL=Infinity),H===L-1&&(Q._individualIWR=Infinity),Q.individualIW=Math.min(Q._individualIWL,Q._individualIWR);N=Ra(c._getCustomPixel(I)-
c._getCustomPixel(I+sa));N=Math.min(2*a(J[0].x,"left"),2*a(J[L-1].x,"right"),N)}else N=Ra(c._getCustomPixel(I)-c._getCustomPixel(I+r));b=t?t:b;da.__root__={getHeight:function(b){return parseInt(J[b]._ovrStyle.lineHeight.replace(/(\d+)px/,"$1"),10)},getWidth:function(){return b},getCalculatedLabelStep:function(b){var a=0,f=b.length,e=Number.NEGATIVE_INFINITY,k,g=0,z;if(d.irregularCatAxis)return d.labelStep;for(;a<f;a++)if(k=b[a])k.label||(k.label=""),R={fontSize:n.fontSize,fontFamily:n.fontFamily,
lineHeight:n.lineHeight,fontWeight:n.fontWeight},g++,k.style=k.style||{},p(R,k.style),R.lineHeight=q(R),h.setStyle(R),d.rotateLabels&&(z=parseInt(R.lineHeight.replace(/(\d+)px/,"$1"),10)),S=h.getSmartText(k.label,void 0,z),k=0===d.rotateLabels?60<S.width?60:S.width:S.height,e=Math.max(k,e);b=Math.floor(Ra(c._getCustomPixel(F)-c._getCustomPixel(I))/e);if(g<=b)return d.labelStep;g=Math.max(Math.ceil(g/b),d.labelStep);N=Ra(c._getCustomPixel(I)-c._getCustomPixel(I+g));return g}};da._inProp={};da.getCopyById=
function(b){var a=this.__root__,c=this._inProp.copyStore,f,c=c||{};if(f=c[b])return f;p(f=c[b]={},a);return f};if(d.hasCategory){switch(g){case "rotate":f.rotation=m?300:270;W=da.getCopyById("rotate");break;case "stagger":W=da.getCopyById("stagger");W.getHeight=function(b){var a;a=(b=d.categories.category[b])&&b.style||(b.style={});R={fontSize:n.fontSize,fontFamily:n.fontFamily,lineHeight:n.lineHeight,fontWeight:n.fontWeight};p(R,a);h.setStyle(R);return h.getOriSize(b.label).height};W.getWidth=function(b){return b.individualIW?
b.individualIW:2*N*D-4};X=function(a){var c,f=a.length,e=0,d,k,g;h.setStyle(n);c=h.getOriSize("WWW").height;if(Math.floor(a[f-1]._cumulativeSum)<=Math.ceil(f*(c+2)))k=Math.floor(b/c),w=0>k-w?k:w;else{k=Math.floor(b/(c+4));do for(e=0,g=k,d=g-1,f=a.length;d<f;){f-d<k&&(d=f-1);c=a[d];e=c._cumulativeSum-e;if(~~e>-~b){pa=!0;break}else pa=!1;e=c._cumulativeSum;d+=g}while(k--&&pa);k++;w=Math.min(w,k)}};U=function(b){var a,c,f,e,d=0;e=0;for(f=b.length;e<f;e++)a=b[e],a.stepSkipped||(c=a&&a.style||{},(c=c.lineHeight)||
(c=n.lineHeight),(K=d++%w)?a.labelPadding=c.replace(/px/i,"")*K:a.labelPadding=0)};break;case "none":W=da.getCopyById("none");W.getHeight=T;Z=W.getWidth=T;d.rotateLabels&&(f.rotation=m?300:270,la=b);W.getCalculatedLabelStep=function(){return d.labelStep};break;default:W=da.getCopyById("auto"),W.getHeight=function(){return b},W.getWidth=function(b){return b.individualIW?b.individualIW:N-8},Z=function(b,a){var c,k,g,z;if(!d.irregularCatAxis&&(h.setStyle(b),c=h.getOriSize("WWW"),c=c.width,c>=N&&0!==
d.rotateLabels)){f.rotation=m?300:270;f.forceRotate=!0;W=da.getCopyById("rotate");Ba=W.getWidth;ha=W.getHeight;c=O.width=0;for(k=a.length;c<k;c++)(g=a[c])&&(g.label||g.oriLabel)&&0!==e(g.showlabel,d.showLabels,1)&&(z=g._ovrStyle,h.setStyle({fontSize:z.fontSize,fontFamily:z.fontFamily,lineHeight:z.lineHeight,fontWeight:z.fontWeight}),S=h.getSmartText(g.oriLabel,Ba(g),ha(c)),g.label=S.text,g.labelTooltext=S.tooltext,g._sLabel=S,O.width<S.width&&(O.text=S.text,O.width=S.width,O.style=z));ca=O.text}}}Ba=
W.getWidth;ha=W.getHeight;v=d.labels.step=d.labelStep=d._oriLabelStep;v=d.labels.step=d.labelStep=W.getCalculatedLabelStep(J);H=0;for(L=J.length;H<L;H++)(Q=J[H])&&(Q.label||Q.oriLabel)&&0!==e(Q.showlabel,d.showLabels,1)&&(oa=!0,R={fontSize:n.fontSize,fontFamily:n.fontFamily,lineHeight:n.lineHeight,fontWeight:n.fontWeight},p(R,Q.style),R.lineHeight=q(R),h.setStyle(R),H%v&&(Q.stepSkipped=!0,ja++),Q._ovrStyle=R,S=h.getSmartText(Q.oriLabel||Q.label,Ba(Q),ha(H)),ma+=Q._nLineHeight=S.height+2,Q._cumulativeSum=
ma,Q.oriLabel=Q.oriLabel||Q.label,Q.label=S.text,Q.labelTooltext=S.tooltext,Q._sLabel=S,O.width<S.oriTextWidth&&(p(O,S),O.style=R),u<S.height&&(u=S.height));if(!oa)return{height:0,width:0};X(J,ja);U(J,ja);Z(O.style,J);ca=O.text||"";if("mixed"===d.xAxisLabelMode)for(Q=d.isPercent?k.numberFormatter.percentValue:k.numberFormatter.xAxis,v=ca.length,H=I;H<=F;H+=r)fa=d.hasBreakPoints?c._getRealBreakValue(H):H,fa=""+Q.call(k.numberFormatter,fa,d.axisIndex),fa.length>v&&(ca=fa,v=fa.length);O.height=Math.max(u,
O.height||0);aa=J.length;H=0;for(L=J.length;H<L&&(ba=J[H],!ba._sLabel);H++);L=J.length;for(H=L-1;0<=H&&(qa=J[H],!qa._sLabel);H--);V=c._isZoomed();f.rotation||V?(d.axisEndLabelDisplaySpace.left=0,d.axisEndLabelDisplaySpace.right=0):(d.axisEndLabelDisplaySpace.left=Math.max(C-(c._getCustomPixel(ba.x||0)-ba._sLabel.width/2),0),d.axisEndLabelDisplaySpace.right=Math.max(c._getCustomPixel(qa.x||aa-1)+qa._sLabel.width/2-A,0));ba=O}else{Q=d.numberFormatterFn?k.numberFormatter[d.numberFormatterFn]:d.isPercent?
k.numberFormatter.percentValue:k.numberFormatter.xAxis;for(H=I;H<=F;H+=r)fa=d.hasBreakPoints?M(c._getRealBreakValue(H),10):M(H,10),fa=""+Q.call(k.numberFormatter,fa,d.axisIndex),H===I&&(aa=fa),H===F&&(V=fa),fa.length>v&&(ca=fa,v=fa.length);h.setStyle({fontSize:n.fontSize,fontFamily:n.fontFamily,lineHeight:n.lineHeight,fontWeight:n.fontWeight});ba=h.getOriSize(ca||"");"rotate"===g&&(f.rotation=270);d.rotateLabels&&(f.rotation=m?300:270);f.rotation||(aa=h.getOriSize(aa||""),V=h.getOriSize(V||""),d.axisEndLabelDisplaySpace.left=
aa.width/2+2,d.axisEndLabelDisplaySpace.right=V.width/2+2)}d.hasCategory&&"stagger"===g&&(ba.height=w*O.height);ba.width=la?Math.min(la,ba.width):ba.width;return ba},_getVMaxLabelDimention:function(b){var a,d,g,G,l=this.config,k=this.chart,h=k.components,u=k.config,f=k.linkedItems.smartLabel,m=l.axisRange,p=l.labels.style,n=m.tickInterval,t=l.useEllipsesWhenOverflow;d=l.maxLabelWidthPercent;var r=m.max;g=m.min;m=0;G=k.jsonData.categories;var k={height:0,width:0},w,v;f.useEllipsesOnOverflow(u.useEllipsesWhenOverflow);
f.setStyle({fontSize:p.fontSize,fontFamily:p.fontFamily,lineHeight:p.lineHeight,fontWeight:p.fontWeight});if(l.hasCategory){G&&(w=G[0].font,v=G[0].fontsize);d&&(u=d/100*u.width,u<b&&(b=u));h=l.categories.category;u=0;for(n=h.length;u<n;u++)r=h[u],0!==e(r.showlabel,l.showLabels)&&(a=c(r.font,r.labelfont,w,p.fontFamily),d=c(r.fontsize,r.labelfontsize,v,p.fontSize).replace(/px/i,"")+"px",g="normal"==p.fontWeight?e(r.fontbold,r.labelfontbold,0)?"bold":"normal":p.fontWeight,G="normal"==p.fontStyle?e(r.fontitalic,
r.labelfontitalic,0)?"italic":"normal":p.fontStyle,a={fontFamily:c(a,w,p.fontFamily),fontSize:c(d,v,p.fontSize),fontWeight:c(g,p.fontWeight),fontStyle:c(G,p.fontStyle)},a.lineHeight=q(a),f.setStyle(a),a=f.getSmartText(r.oriLabel||r.label,b,p.lineHeight,t),r.oriLabel=r.oriLabel||r.label,r.label=a.text,r.labelTooltext=a.tooltext,a.width>m&&(k=a,m=a.width));return k}b=l.numberFormatterFn?h.numberFormatter[l.numberFormatterFn]:l.isPercent?h.numberFormatter.percentValue:h.numberFormatter.yAxis;for(u=g;u<=
r;u+=n)p=l.hasBreakPoints?M(this._getRealBreakValue(u),10):M(u,10),p=""+b.call(h.numberFormatter,p,l.axisIndex),p.length>m&&(a=p,m=p.length);return f.getOriSize(a)},getLogAxisLimits:function(b,a,c,e,d,g){var k=function(b){return null===b||void 0===b||""===b||isNaN(b)?!1:!0},h=0,u=[],f,l,m,q,p,n,t,r;b===a&&(a-=a/100);k(c)&&Number(c)>=b?b=Number(c):(c=1<d?xb(fb(b)/fb(d)):hb(fb(b)/fb(d)),b=yb(d,c),l=c);l||(l=1<d?xb(fb(b)/fb(d)):hb(fb(b)/fb(d)));k(e)&&Number(e)<=a?a=Number(e):(c=1<d?hb(fb(a)/fb(d)):xb(fb(a)/
fb(d)),a=yb(d,c),f=c);f||(f=1<d?hb(fb(a)/fb(d)):xb(fb(a)/fb(d)));e=Number(String(fb(d)/fb(10)));g=Number(g)||(hb(e)==e?8:4);1<d?(m=l,q=f):0<d&&1>d&&(m=f,q=l);e=l;for(f=m;f>=q;--f)if(m=yb(d,e),a<=m&&b>=m&&(u[h++]={value:m,ismajor:!0}),f!=q){l=1<d?-1:1;m=yb(d,e)-yb(d,e+l);c=m/(g+1);for(k=1;k<=g;++k)m=yb(d,e+l)+c*k,a<=m&&b>=m&&(u[h++]={value:m,ismajor:!1});1<d?e--:e++}for(t in u)for(r in u[t])"value"==r&&(p||(p=u[t][r]==a&&(u[t].isextreme=u[t].isMin=!0)),n||(n=u[t][r]==b&&(u[t].isextreme=u[t].isMax=
!0)));p||(u[h++]={value:a,ismajor:!0,isMin:!0,isextreme:!0});n||(u[h]={value:b,ismajor:!0,isMax:!0,isextreme:!0});return{Max:b,Min:a,divArr:u}},getCategoryLen:function(){return this.config.categories?this.config.categories.category.length:0},getCleanValue:function(b,a){var c=this.chart;return(this.components.numberFormatter||c.components.numberFormatter).getCleanValue(b,a)},dataLabels:function(b){var a=this.chart;return(this.components.numberFormatter||a.components.numberFormatter).dataLabels(b,this.config.axisIndex)},
setNumberFormatter:function(b){this.components.numberFormatter=b}},void 0,{setAdaptiveMin:0,adjustDiv:1,axisNameWidth:void 0,rotateAxisName:0,useEllipsesWhenOverflow:1,divLineColor:void 0,divLineAlpha:void 0,divLineThickness:void 0,divLineIsDashed:void 0,divLineDashLen:void 0,divLineDashGap:void 0,showAlternateGridColor:void 0,alternateGridColor:void 0,alternateGridAlpha:void 0,showZeroPlane:1,zeroPlaneAlpha:80,showZeroPlaneValue:1,showZeroPlaneOnTop:1,showAxisLine:void 0,axisLineThickness:void 0,
axisLineAlpha:void 0,tickLength:void 0,trendlineToolText:void 0,trendlineColor:"333333",trendlineThickness:1,trendlineAlpha:void 0,showTrendlinesOnTop:0,trendlinesAreDashed:0,trendlinesDashLen:5,trendlinesDashGap:2,isTrendZone:void 0,showTrendlines:1,showTrendlineLabels:1,showLabels:1,maxLabelHeight:void 0,rotateLabels:void 0,slantLabel:0,showAxisValues:1,showTooltip:1}]);FusionCharts.register("component",["axis","log",{configure:function(){var b=this.config,a=b.rawAttr,d=this.chart.components,g=
d.numberFormatter,d=d.colorManager;FusionCharts.register("component",["axis","cartesian"]).prototype.configure.call(this);b.minorDivlinecolor=L(c(a.minorDivlinecolor,d.getColor("divLineColor")),e(a.minorDivLineAlpha,d.getColor("divLineAlpha")/2));b.axisMinValue=g.getCleanValue(a.axisMinValue);b.axisMaxValue=g.getCleanValue(a.axisMaxValue);0>=b.axisMinValue&&(b.axisMinValue=void 0);0>=b.axisMaxValue&&(b.axisMaxValue=void 0);b.minorDivLineThickness=e(a.minorDivLineThickness,1)},setDataLimit:function(b,
a){var c=this.config,d=c.axisRange,g=this.getLogAxisLimits,l=c.axisMaxValue,k=c.axisMinValue,c=g(e(b,l),e(a,k),l,k,c.base,c.numMinorDivLines);d.min=Number(M(c.Min,10));d.max=Number(M(c.Max,10));d.divArr=c.divArr||{}},_setTickIntervalAfterZoom:function(){var b=this.config,a=this.chart.config.viewPortConfig,c=b.isVertical,d=b.axisRange,g=this.getLogAxisLimits,l=b.rawAttr,k,h;b.hasCategory||(c=c?a.scaleY:a.scaleX,a=e(l.axisrange?l.axisrange.max:d.max),h=e(l.axisrange?l.axisrange.min:d.min),l=1===c?b.axisMaxValue:
d.max,k=1===c?b.axisMinValue:d.min,e(1===c?b.adjustDiv:0),b=g(a,h,l,k,b.base,b.numMinorDivLines),d.min=Number(M(b.Min,10)),d.max=Number(M(b.Max,10)),d.divArr=b.divArr||{})},getPixel:function(b){var a=this.config,c=this.chart.config,e=a.axisRange,d=c.viewPortConfig,g=c.canvasHeight,k=c.canvasWidth,h=c.canvasTop,u=c.canvasLeft,f=c.canvasBottom,c=c.canvasRight,l=e.max,e=e.min,m=a.base,q=fb(l)/m,p=fb(e)/m;b=fb(b)/m-p;d||(d={x:u,y:h,scaleX:1,scaleY:1});a.isVertical?(k=-g*d.scaleY/(q-p),a=a.isReverse?f-
(b*k+(g*d.scaleY-d.y*d.scaleY)):h+(b*k+(g*d.scaleY-d.y*d.scaleY))):(k=k*d.scaleX/(fb(l-e)/m),a=a.isReverse?c-(b*k-d.x*d.scaleX):u+(b*k-d.x*d.scaleX));return a},_drawPlotLine:function(){var b=this.config,a=b.axisRange,c=b.isVertical,e=this.chart,d=e.config,g=d.canvasLeft,k=d.canvasRight,h=d.canvasTop,d=d.canvasBottom,u=b.showCanvasBorder,f=a.max,l=a.min,m=b.axisPlotLineContainer,q=e.components.paper,p=this.graphics.line||[],n=0,t=L(b.divLineColor,b.divLineAlpha),r=b.divLineThickness,w=b.divLineIsDashed?
I(b.divLineDashLen,b.divLineDashGap,r):"none",v=L(b.zeroPlaneColor,b.zeroPlaneAlpha),C=b.zeroPlaneThickness,A=b.animateAxis,H,D,K,F,Q,R,J,N,M;F={stroke:t,"stroke-width":r,"stroke-dasharray":w};w={stroke:b.minorDivlinecolor,"stroke-width":b.minorDivLineThickness,"stroke-dasharray":w};if(b.lines.isDraw){H=e.get("config","animationObj");N=H.animObj;M=H.dummyObj;e=H.transposeAnimDuration;H=H.animType;this._getVisibleConfig();Q=a.divArr;R=Q.length;for(a=0;a<R;a++)if(K=Q[a],J=K.value,D=this.getPixel(J),
K=K.ismajor?F:w,!u||J!==l&&J!==f)if(0!==b.showZeroPlaneValue||0!==b.showZeroPlane||0!==J)0===J&&1===b.showZeroPlane&&1===b.showZeroPlaneValue&&(K.stroke=v,K["stroke-width"]=C),K.path=c?"M"+g+" "+D+"L"+k+" "+D:"M"+D+" "+h+"L"+D+" "+d,p[n]?(D=p[n],e&&A?D.animateWith(M,N,K,e,H):D.attr(K)):(D=q.path(K,m),p[n]=D),0===J&&1===b.showZeroPlane&&1===b.showZeroPlaneValue&&(K.stroke=t,K["stroke-width"]=r),n+=1;if(p[n])for(a=n;a<p.length;a++)p[a].attr({path:[]});this.graphics.line=p}else if(p[n])for(a=n;a<p.length;a++)p[a].attr({path:[]})},
_drawLabel:function(){var b=this.config,a=this.chart,c=a.config,e=a.components,d=b.axisRange,g=b.isOpposit,k,h=b.labels,u=h.style,f=b.isVertical,l=d.max,m=d.min,q=c.canvasBottom,p=c.canvasLeft,n=c.canvasRight,c=c.canvasTop,t=b.axisContainer,r=b.labelPadding,w=e.paper,v=b.labelMaxH,C=b.labelMaxW,A=b.axisStartPosition,H=this.graphics.labels||[],D=0,K=b.animateAxis,F,Q,I,J,L,N,M,O={fontFamily:u.fontFamily,fontSize:u.fontSize,fontWeight:u.fontWeight,fontStyle:u.fontStyle,lineHeight:u.lineHeight},W,S,
U,Z;u.lineHeight&&(N=u.lineHeight,-1!==N.indexOf("px")&&(N=N.replace("px",""),parseFloat(N)));if(b.labels.isDraw){F=a.get("config","animationObj");a=F.animObj;N=F.dummyObj;U=F.animType;F=F.transposeAnimDuration;Ra(this.getPixel(m)-this.getPixel(m+d.tickInterval));Z=this._isZoomed();b.labels.step?k=d.tickInterval*b.labels.step:k=d.tickInterval;L=b.labels.rotation;J=this._getVisibleConfig();u={fill:u.color,"font-size":u.fontSize};t.css(O);O=d.divArr;W=O.length;for(d=0;d<W;d++)if(S=O[d],M=S.value,Q=
this.getPixel(M),!(!S.ismajor&&!b.showMinorDivLineValues||I&&Q>I-b.labelMaxH&&Q<I+b.labelMaxH||Z&&(M<J.minValue||M>J.maxValue)||!b.labels.drawNormalVal&&(!b.labels.drawLimitVal||M!==m&&M!==l)||!b.labels.drawNormalVal&&M!==m&&M!==l||!(b.labels.drawLimitVal||M!==m&&M!==l)||0===b.showZeroPlaneValue&&0===b.showZeroPlane&&0===M)){if(1===b.showZeroPlane&&1===b.showZeroPlaneValue&&(0>M&&0<M+k||0<M&&0>M-k))if(f){if(Q+v>=this.getPixel(0)&&this.getPixel(0)>=Q-v)continue}else if(Q+C>=this.getPixel(0)&&this.getPixel(0)>=
Q-C)continue;f?(I=b.numberFormatterFn?e.numberFormatter[b.numberFormatterFn]:b.isPercent?e.numberFormatter.percentValue:e.numberFormatter.yAxis,I=""+I.call(e.numberFormatter,M),M=b.hasCategory?b.categories.category[d].labelPadding||0:0,u["text-anchor"]=g?cb:db,u.text=I,u.x=g?(A||n)+r:(A||p)-r,u.y=M?Q+M:Q,I=u.y):(I=b.numberFormatterFn?e.numberFormatter[b.numberFormatterFn]:b.isPercent?e.numberFormatter.percentValue:e.numberFormatter.xAxis,I=""+I.call(e.numberFormatter,M),M=b.hasCategory?Number(b.categories.category[d].labelPadding)||
0:0,u.text=I,u.x=Q,u.y=g?(A||c)-r:(A||q)+r,M&&(u.y+=M),L?(u["text-anchor"]=g?cb:db,u["vertical-align"]="center"):u["vertical-align"]=g?lb:Xa,I=u.x);h.shiftX&&(u.x+=h.shiftX);h.shiftY&&(u.y+=h.shiftY);u.transform=w.getSuggestiveRotation(L,u.x,u.y);H[D]?(Q=H[D],F&&K?Q.animateWith(N,a,u,F,U):Q.attr(u)):H[D]=w.text(u,t);D+=1}if(H[D])for(d=D;d<H.length;d++)H[d].attr({text:""});this.graphics.labels=H}else if(H[D])for(d=D;d<H.length;d++)H[d].attr({text:""})},_drawPlotBand:function(){},_getVMaxLabelDimention:function(){var b=
this.config,a=this.chart,c=a.components,e=a.linkedItems.smartLabel,d=b.labels.style,g=0,k=b.axisRange.divArr,h=k.length,u;e.useEllipsesOnOverflow(a.config.useEllipsesWhenOverflow);e.setStyle({fontSize:d.fontSize,fontFamily:d.fontFamily,lineHeight:d.lineHeight,fontWeight:d.fontWeight});a=b.isPercent?c.numberFormatter.percentValue:c.numberFormatter.xAxis;for(b=0;b<h;b++)d=k[b],d=""+a.call(c.numberFormatter,d.value),d.length>g&&(u=d,g=d.length);return e.getOriSize(u)},_getHMaxLabelDimention:function(){var b=
this.config,a=this.chart,c=a.components,e=a.linkedItems.smartLabel,d=b.labels.style,g=0,k=b.axisRange.divArr,h=k.length,u;e.useEllipsesOnOverflow(a.config.useEllipsesWhenOverflow);e.setStyle({fontSize:d.fontSize,fontFamily:d.fontFamily,lineHeight:d.lineHeight,fontWeight:d.fontWeight});a=b.isPercent?c.numberFormatter.percentValue:c.numberFormatter.xAxis;for(b=0;b<h;b++)d=k[b],d=""+a.call(c.numberFormatter,d.value),d.length>g&&(u=d,g=d.length);return e.getOriSize(u)},getCleanValue:function(b){var a=
null,c=this.chart.components.numberFormatter;b=Ra(b);0<b&&(a=c.getCleanValue(b));return a}},"cartesian",{base:10,showMinorDivLineValues:1,numMinorDivLines:void 0}]);FusionCharts.register("component",["axis","polarcartesan",{_drawComponents:function(){var b=this.config;b.drawLabels&&this._drawLabel();b.drawPlotlines&&this._drawPlotLine()},_drawPlotLine:function(){var b=this.config,a=b.axisRange,c=a.tickInterval,e=this.chart,d=a.max,a=a.min,g=b.axisPlotLineContainer,k=e.components.paper,h=this.graphics.line||
[],u=0,f=L(b.divLineColor,b.divLineAlpha),l=b.divLineThickness,m=b.divLineIsDashed?I(b.divLineDashLen,b.divLineDashGap,l):"none",q=L(b.zeroPlaneColor,b.zeroPlaneAlpha),p=b.zeroPlaneThickness,n=b.animateAxis,t,r,w,v,C,A,H,D,K,m={stroke:f,"stroke-width":l,"stroke-dasharray":m};t=e.get("config","animationObj");D=t.animObj;K=t.dummyObj;e=t.transposeAnimDuration;t=t.animType;if(b.lines.isDraw){w=this._getVisibleConfig();u=a+c*hb((w.minValue-3*c-a)/c);w=a+c*hb((w.maxValue+3*c-a)/c);u=u<a?a:u;w=w>d?d:w;
C=d=u;for(u=0;d<w;){if(d!==a&&(0!==b.showZeroPlane||0!==d)){0===d&&1===b.showZeroPlane&&(m.stroke=q,m["stroke-width"]=p);m.path=["M"];r=b.polarAxis;v=r.config.categories.category;A=v.length;for(v=0;v<A;v++)H=r.getPixel(v,r.config.centerY-this.getPixel(d)),m.path.push(H.x,H.y,"L");m.path.pop();m.path.push("Z");h[u]?(r=h[u],e&&n?r.animateWith(K,D,m,e,t):r.attr(m)):(r=k.path(m,g),h[u]=r);0===d&&1===b.showZeroPlane&&(m.stroke=f,m["stroke-width"]=l);u+=1}b.showZeroPlane&&0>d&&0<d+c?(d=0,C+=c):d<C?d=C:
(d+=c,C+=c)}if(h[u])for(d=u;d<h.length;d++)h[d].attr({path:[]});this.graphics.line=h}else if(h[u])for(d=u;d<h.length;d++)h[d].attr({path:[]})}},"cartesian"]);FusionCharts.register("component",["axis","gauge",{configure:function(){var b=this.config,a=b.rawAttr,d=this.chart.components.colorManager;FusionCharts.register("component",["axis","cartesian"]).prototype.configure.call(this);b.majorTMColor=L(c(a.majorTMColor,d.getColor("tickColor")),e(a.majorTMAlpha,100));b.tickValueStep=e(a.tickValueStep,1);
b.tickValueStep=ab(b.tickValueStep);0>=b.tickValueStep&&(b.tickValueStep=1);b.connectTickMarks=b.showTickMarks?e(a.connectTickMarks,1):0;b.showTickValues=e(a.showTickValues,b.showTickMarks);b.reverseScale=1==e(a.reverseScale,0);b.minorTMColor=L(c(a.minorTMColor,b.majorTMColor),e(a.minorTMAlpha,b.majorTMAlpha,100));b.minorTMHeight=b.showTickMarks?e(a.minorTMHeight,ab(b.majorTMHeight/2)):0;b.tickValueDistance=e(a.tickValueDistance,0)+2;b.upperLimitDisplay=K(a.upperLimitDisplay)||"";b.lowerLimitDisplay=
K(a.lowerLimitDisplay)||"";b.drawTickMarkConnector=a.drawTickMarkConnector||0},setDataLimit:function(b,a){var c=this.config,d=c.axisRange,g=this.getGaugeAxisLimit,m=c.upperlimit,k=c.lowerlimit,h=c.setAdaptiveMin,u=c.majorTMNumber,c=c.adjustTM,f;f=!h;g=g.call(this,e(b,m),e(a,k),m,k,h,f,u,c);d.min=Number(M(g.min,10));d.max=Number(M(g.max,10));d.tickInterval=g.majorTickInt||1;d.numMajorTM=g.numMajorTM},_setTickIntervalAfterZoom:function(){},_drawComponents:function(){var b=this.config;b.drawTick&&this._drawTick();
b.drawLabels&&this._drawLabel();b.drawTrendLines&&this._drawTrendLine()},_drawTick:function(){var b=this.config,a=b.axisRange,c=a.tickInterval,e=b.isVertical,d=b.isOpposit,g=b.drawTick,k=b.drawTickMinor,h=b.canvas,u=this.chart,f=u.config,m=h.canvasBottom||f.canvasBottom,l=h.canvasLeft||f.canvasLeft,q=h.canvasRight||f.canvasRight,p=h.canvasTop||f.canvasTop,h=a.max,f=a.min,n=u.components.paper,t=this.graphics.tick||[],r=b.minorTMNumber,a=a.numMajorTM||b.majorTMNumber,w=b.axisAxisLineContainer,v=0,C=
b.animateAxis,A,H,D,K,F,Q;D={stroke:b.majorTMColor,"stroke-width":b.majorTMThickness,"stroke-linecap":"round"};H={stroke:b.minorTMColor,"stroke-width":b.minorTMThickness,"stroke-linecap":"round"};if(b.lines.isDraw&&g){A=u.get("config","animationObj");u=A.animObj;F=A.dummyObj;g=A.transposeAnimDuration;A=A.animType;e?d?b.placeTicksInside?(d=q-b.tickMarkDistance,m=d-b.majorTMHeight,l=d-b.minorTMHeight):(d=q+b.tickMarkDistance,m=d+b.majorTMHeight,l=d+b.minorTMHeight):b.placeTicksInside?(d=l+b.tickMarkDistance,
m=d+b.majorTMHeight,l=d+b.minorTMHeight):(d=l-b.tickMarkDistance,m=d-b.majorTMHeight,l=d-b.minorTMHeight):d?b.placeTicksInside?(d=p+b.tickMarkDistance,m=d+b.majorTMHeight,l=d+b.minorTMHeight):(d=p-b.tickMarkDistance,m=d-b.majorTMHeight,l=d-b.minorTMHeight):b.placeTicksInside?(d=m-b.tickMarkDistance,m=d-b.majorTMHeight,l=d-b.minorTMHeight):(d=m+b.tickMarkDistance,m=d+b.majorTMHeight,l=d+b.minorTMHeight);b=b.drawTickMarkConnector?e?["M",d,this.getPixel(f),"L",d,this.getPixel(h)]:["M",this.getPixel(f),
d,"L",this.getPixel(h),d]:[];D.path=b;t[v]?(b=t[v],g&&C?b.animateWith(F,u,{path:D},g,A):b.attr({path:D})):(b=n.path(D,w),t[v]=b);v+=1;for(p=0;p<a;p+=1)if(Q=p<a-1?M(Number(f+c*p),10):h,D.path=e?"M"+d+" "+this.getPixel(Q)+"L"+m+" "+this.getPixel(Q):"M"+this.getPixel(Q)+" "+d+"L"+this.getPixel(Q)+" "+m,t[v]?(b=t[v],g&&C?b.animateWith(F,u,D,g,A):b.attr(D)):(b=n.path(D,w),t[v]=b),v+=1,Q!==h&&k)for(q=c/(r+1),K=1;K<=r;K+=1)H.path=e?"M"+d+" "+this.getPixel(Q+q*K)+"L"+l+" "+this.getPixel(Q+q*K):"M"+this.getPixel(Q+
q*K)+" "+d+"L"+this.getPixel(Q+q*K)+" "+l,t[v]?(b=t[v],g&&C?b.animateWith(F,u,H,g,A):b.attr(H)):(b=n.path(H,w),t[v]=b),v+=1;if(t[v])for(p=v;p<t.length;p++)t[p].attr({path:[]});this.graphics.tick=t}else if(t[v])for(p=v;p<t.length;p++)t[p].attr({path:[]})},_drawLabel:function(){var b=this.config,a=b.canvas,c=b.axisDimention||{},e=this.chart,d=e.config,g=e.components,k=e.linkedItems.smartLabel,h=b.axisRange,u=b.isOpposit,f=b.isReverse,m=h.numMajorTM||b.majorTMNumber,l=b.labels,q=l.style,p=b.isVertical,
n=h.max,t=h.min,r=a.canvasTop||d.canvasTop,w=a.canvasLeft||d.canvasLeft,v=a.canvasBottom||d.canvasBottom,a=a.canvasRight||d.canvasRight,C=b.axisLabelContainerTop,A=b.labelPadding,H=g.paper,D=b.labelMaxH,K=b.labelMaxW,c=p?c.x:c.y,F=this.graphics.labels||[],Q=0,I=b.animateAxis,J,L,N,O,ha,W;W={fontFamily:q.fontFamily,fontSize:q.fontSize,fontWeight:q.fontWeight,fontStyle:q.fontStyle,lineHeight:q.lineHeight};var S,U,Z,X;q.lineHeight&&(O=q.lineHeight,-1!==O.indexOf("px")&&(O=O.replace("px",""),O=parseFloat(O)));
if(b.labels.isDraw){J=e.get("config","animationObj");S=J.animObj;U=J.dummyObj;e=J.transposeAnimDuration;J=J.animType;L=Ra(this.getPixel(t)-this.getPixel(t+h.tickInterval));p?(b.labelMaxH>L&&!b.hasCategory&&(ha=xb(b.labelMaxH/L)),ha>b.labels.step&&(b.labels.step=ha)):(b.labelMaxW>L&&!b.hasCategory&&(ha=xb(b.labelMaxW/L)),ha>b.labels.step&&(b.labels.step=ha),Z=w,X=d.width-a);ha=(p?K:L/2)*b.labels.step;D=p?L/2:D;h=h.tickInterval;K=b.labels.step?b.labels.step:1;k.useEllipsesOnOverflow(d.useEllipsesWhenOverflow);
k.setStyle({fontSize:q.fontSize,fontFamily:q.fontFamily,lineHeight:q.lineHeight,fontWeight:q.fontWeight});C.css(W);for(d=0;d<m;d+=K)if(L=d<m-K?M(Number(t+h*d),10):n,b.labels.drawNormalVal||b.labels.drawLimitVal&&(L===t||L===n))if(b.labels.drawNormalVal||L===t||L===n)if(b.labels.drawLimitVal||L!==t&&L!==n){W=g.numberFormatter.scale;if(L===t&&b.lowerLimitDisplay)W=k.getSmartText(b.lowerLimitDisplay,ha,D+O/2),N=W.text;else if(L===n&&b.upperLimitDisplay)W=k.getSmartText(b.upperLimitDisplay,ha,D+O/2),
N=W.text;else if(b.labels.drawNumericVal||L!==t&&L!==n)if(b.labels.drawNumericVal)N=W.call(g.numberFormatter,L),W=k.getOriSize(""+N);else continue;else if(W=k.getSmartText(W.call(g.numberFormatter,L),ha,D+O/2),W.text===W.oriText)N=W.text;else continue;p?(N={fill:q.color,"line-height":O,"text-anchor":u?cb:db,text:N,x:u?(c||a)+A:(c||w)-A,y:this.getPixel(L)},(!f&&L===t&&b.lowerLimitDisplay||f&&L===n&&b.upperLimitDisplay)&&W.height>O&&(N["vertical-align"]=lb),(!f&&L===n&&b.upperLimitDisplay||f&&L===t&&
b.lowerLimitDisplay)&&W.height>O&&(N["vertical-align"]=Xa),b.placeValuesInside&&(N["text-anchor"]=u?db:cb)):(N={fill:q.color,"line-height":O,text:N,"text-anchor":kb,x:this.getPixel(L),y:u?(c||r)-A:(c||v)+A},(!f&&L===t||f&&L===n)&&W.width>2*Z&&(N["text-anchor"]=cb),(!f&&L===n||f&&L===t)&&W.width>2*X&&(N["text-anchor"]=db),N["vertical-align"]=b.placeValuesInside?u?Xa:lb:u?lb:Xa);l.shiftX&&(N.x+=l.shiftX);l.shiftY&&(N.y+=l.shiftY);F[Q]?(L=F[Q],e&&I?L.animateWith(U,S,N,e,J):L.attr(N)):F[Q]=L=H.text(N,
C);W&&W.tooltext?(L.tooltip(W.tooltext),L.trackTooltip(!0)):L.trackTooltip(!1);Q+=1}if(F[Q])for(d=Q;d<F.length;d++)F[d].attr({text:""});this.graphics.labels=F}else if(F[Q])for(d=Q;d<F.length;d++)F[d].attr({text:""})},placeAxis:function(b){var a=this.chart,c=a.components,e=a.linkedItems.smartLabel,d=this.config,g=d.axisRange,k=d.isVertical,h=d.isOpposit,u=d.labels.style,f=g.tickInterval,m=g.max,l=g.min,q,p=0,n=0,g="",t,r,w,v,C;t={left:0,right:0,top:0,bottom:0};if(0>=b)return t;d.labels.isDraw=!0;d.labels.drawNumericVal=
!0;d.labels.drawNormalVal=d.showTickValues;d.labels.drawLimitVal=d.showLimits;d.lines.isDraw=!0;d.labels.step=d.tickValueStep;d.labelPadding=0;e.useEllipsesOnOverflow(a.config.useEllipsesWhenOverflow);e.setStyle({fontSize:u.fontSize,fontFamily:u.fontFamily,lineHeight:u.lineHeight,fontWeight:u.fontWeight});d.drawTick&&d.showTickMarks&&d.lines.isDraw?(b-=d.tickMarkDistance,n=Ea(d.minorTMHeight,d.majorTMHeight),d.placeTicksInside?(b+=d.tickMarkDistance,d.placeValuesInside&&(d.labelPadding=d.tickMarkDistance+
n)):n>b?d.lines.isDraw=!1:(k?h?t.right+=n+d.tickMarkDistance:t.left+=n+d.tickMarkDistance:h?t.top+=n+d.tickMarkDistance:t.bottom+=n+d.tickMarkDistance,b-=n,d.placeValuesInside||(d.labelPadding=d.tickMarkDistance+n))):d.lines.isDraw=!1;b-=d.tickValueDistance;if(d.drawLabels&&(d.showTickValues||d.showLimits)){a=Ra(this._getCustomPixel(l)-this._getCustomPixel(l+f))/2;d.labelPadding+=d.tickValueDistance;b-=d.tickValueDistance;q=c.numberFormatter.scale;for(r=l+f;r<m;r+=f)u=""+q.call(c.numberFormatter,
M(r,10)),u.length>p&&(g=u,p=u.length);n=e.getOriSize(g);k?n.width>b&&(d.labels.drawNumericVal=!1,d.upperLimitDisplay||d.lowerLimitDisplay||(d.labels.isDraw=!1),g="",n=e.getOriSize(g)):n.height>b&&(d.labels.drawNumericVal=!1,d.upperLimitDisplay||d.lowerLimitDisplay||(d.labels.isDraw=!1),g="",n=e.getOriSize(g));p=k?b:a;u=k?a:b;d.showLimits?(r=q.call(c.numberFormatter,m),v=q.call(c.numberFormatter,l),c=d.upperLimitDisplay||""+r,q=d.lowerLimitDisplay||""+v,C=e.getOriSize(c),C.width>n.width&&(w=e.getSmartText(c,
p,u),c===r&&w.text===w.oriText||d.labels.drawNumericVal)&&(g=c,n=C),r=e.getOriSize(q),r.width>n.width&&(w=e.getSmartText(q,p,u),q===v&&w.text===w.oriText||d.labels.drawNumericVal)&&(g=q),""===g&&(g=e.getOriSize(d.upperLimitDisplay).width>e.getOriSize(d.lowerLimitDisplay).width?c:q,n=e.getOriSize(g))):d.labels.drawLimitVal=!1;if(k)e.getSmartText(g,p,u);else for(r=l;r<=m;r+=f)if(l=e.getSmartText(g,p,u),""===l.text)p+=a;else break;l=e.getSmartText(g,p,u);d.labelMaxW=Ea(l.width,n.width);d.labelMaxH=Ea(l.height,
n.height);!d.placeValuesInside&&d.labels.isDraw?k?(d.labelMaxW=Va(d.labelMaxW,b),h?t.right+=d.labelMaxW+d.tickValueDistance:t.left+=d.labelMaxW+d.tickValueDistance):(d.labelMaxH=Va(d.labelMaxH,b),h?t.top+=d.labelMaxH+d.tickValueDistance:t.bottom+=d.labelMaxH+d.tickValueDistance):d.labelPadding=-d.labelPadding}else d.labels.isDraw=!1;return d.spaceTaken=t},getGaugeAxisLimit:function(b,a,c,e,d,g,k,h){var u=!0,f=!0,l=Number(c),m=Number(e),q,p;p={max:0,min:0,MajorTickInterval:1,numMajorTM:k};if(c&&e)l>
b&&(b=l),m<a&&(a=m);else if(isNaN(b)&&(b=.9,f=!1),isNaN(a)&&(a=0,u=!1),b===a&&0===b&&(isNaN(l)||(b=l),isNaN(l)||0===l))b=.9;q=Math.max(Math.floor(Math.log(Math.abs(a))/Math.LN10),Math.floor(Math.log(Math.abs(b))/Math.LN10));k=yb(10,q);2>Math.abs(b)/k&&2>Math.abs(a)/k&&(q--,k=yb(10,q));q=yb(10,Math.floor(Math.log(b-a)/Math.LN10));0<b-a&&10<=k/q&&(k=q);q=(Math.floor(b/k)+1)*k;0>a?g=-1*(Math.floor(Math.abs(a/k))+1)*k:g?g=0:(g=Math.floor(Math.abs(a/k)-1)*k,g=0>g?0:g);d&&0>=b&&(q=0);p.max=!c||c&&l<b&&
f?q:l;p.min=!e||e&&m>a&&u?g:m;p.min>p.max?p.min==m&&p.max==l?(b=p.min,p.min=p.max,p.max=b):p.min==m?p.max=p.min+1:p.max==l&&(p.min=p.max-1):p.min==p.max&&(p.max=p.min+1);p.range=Math.abs(p.max-p.min);p.MajorTickInterval=k;this.calcTickInterval(p,c,h);return p},calcTickInterval:function(b,a,c){var e=0;-1!=b.numMajorTM&&2>b.numMajorTM&&(b.numMajorTM=2);a||a||-1===b.numMajorTM?(b.numMajorTM=-1==b.numMajorTM?5:b.numMajorTM,c&&(a=function(b,a){for(var c=0,e=1,d;;){d=b.numMajorTM+c*e;d=0===d?1:d;if(a.isRangeDivisible(b.range,
d,b.MajorTickInterval))break;c=-1==e||c>b.numMajorTM?++c:c;if(25<c){d=b.numMajorTM;break}e=c<=b.numMajorTM?-1*e:1}b.numMajorTM=1<d?d:b.numMajorTM},c=b.numMajorTM,a(b,this),2===b.numMajorTM&&(b.numMajorTM=c,1<b.range&&(b.range+=1,0>b.min?--b.min:b.max+=1),a(b,this),e=0))):(b.numMajorTM=-1==b.numMajorTM?5:b.numMajorTM,a=this.getDivisibleRange(b.min,b.max,b.range,b.numMajorTM,b.MajorTickInterval,!0),c=a-b.range,b.range=a,0<b.max?b.max+=c:b.min-=c);b.majorTickInt=(b.max-b.min+e)/(b.numMajorTM-1)},isRangeDivisible:function(b,
a,c){b/=a-1;a=new m.MathExt;return a.numDecimals(b)>a.numDecimals(c)?!1:!0},getDivisibleRange:function(b,a,c,e,d,g){if(3>e)return c;b=Math.abs(a-b);a=b/(e-1);this.isRangeDivisible(b,e,d)||(g&&Number(a)/Number(d)<(1<d?2:.5)&&(d/=10),a=(Math.floor(a/d)+1)*d,b=a*(e-1));return b}},"cartesian",{majorTMNumber:-1,majorTMHeight:6,showTickMarks:1,majorTMThickness:1,upperlimit:void 0,lowerlimit:void 0,adjustTM:1,minorTMNumber:4,minorTMThickness:1,tickMarkDistance:3,placeTicksInside:0,placeValuesInside:0}]);
FusionCharts.register("component",["axis","polarGauge",{configure:function(){var b=this.config,a=b.rawAttr;FusionCharts.register("component",["axis","gauge"]).prototype.configure.call(this);b.upperLimitDisplay=a.upperLimitDisplay||"";b.lowerLimitDisplay=a.lowerLimitDisplay||"";b.polarPadding=4},_drawComponents:function(){var b=this.config;b.drawTick&&this._drawTick();b.drawLabels&&this._drawLabel();b.drawTrendLines&&this._drawTrendLine()},getAxisPosition:function(b,a){return this.getPixel(b,a)},getPixel:function(b,
a){var c=this.config,d=c.axisRange,g=d.min,l=d.max-g,k=c.startAngle||zb/2,h=c.totalAngle||zb/2,u=c.centerX||0,d=c.centerY||0;a=e(a,c.radius,0);c=k+h/l*(b-g);g=u+a*jb(c);d+=a*vb(c);return{x:g,y:d,angle:c}},getAngle:function(b){var a=this.config,c=a.axisRange,d=c.min;return(a.startAngle||zb/2)+(a.totalAngle||zb/2)/(c.max-d)*(b-d)},placeAxis:function(b){var a=this.config,c=this.chart,d=c.components,e=c.linkedItems.smartLabel,g=a.axisRange,k=a.labels.style,h=g.tickInterval,u=a.upperLimitDisplay,f=a.lowerLimitDisplay,
l=g.max,m=g.min,g=0,q,p;p={left:0,right:0,top:0,bottom:0};e.useEllipsesOnOverflow(c.config.useEllipsesWhenOverflow);e.setStyle({fontSize:k.fontSize,fontFamily:k.fontFamily,lineHeight:k.lineHeight,fontWeight:k.fontWeight});a.labels.isDraw=1;a.labels.drawNormalVal=1;a.labels.drawLimitVal=1;a.lines.isDraw=1;a.labels.step=a.tickValueStep;a.labelPadding=0;if(a.drawLabels&&a.showTickValues&&0<b){Ra(this.getPixel(m)-this.getPixel(m+h));a.labelPadding+=a.tickValueDistance;c=d.numberFormatter.scale;for(k=
m;k<=l;k+=h)m=""+c.call(d.numberFormatter,M(k,10)),m.length>g&&(q=m,g=m.length);d=e.getOriSize(q);if(d.width>b/2)return a.labels.isDraw=!1,p;a.showLimits?(u.length>g&&(q=u,g=u.length),f.length>g&&(q=f)):a.labels.drawLimitVal=!1;d=e.getOriSize(q);a.labelMaxW=d.width;a.labelMaxW>b/2&&(a.labelMaxW=b/2);a.labelMaxH=d.height;a.placeValuesInside?a.labelPadding=-a.labelPadding:(p.right+=a.labelMaxW+a.tickValueDistance,p.left+=a.labelMaxW+a.tickValueDistance,p.top+=a.labelMaxH+a.tickValueDistance,p.bottom+=
a.labelMaxH+a.tickValueDistance)}else a.labels.isDraw=!1;return p},_drawLabel:function(){var b=this.config,a=this.chart,c=a.components,d=b.axisRange,g=a.linkedItems.smartLabel,l,k=b.labels.style,h=b.labelPadding||0,u=!1,f=b.radius,m=e(b.gaugeOuterRadius,f),f=e(b.gaugeInnerRadius,f),q=b.centerX,p=b.centerY,n=b.placeValuesInside,t=b.labelMaxH,r=b.labelMaxW,w=d.max,v=d.min,C=b.axisLabelContainerTop,A=c.paper,H=this.graphics.labels||[],D=0,K=b.animateAxis,F,I,Q;F={fontFamily:k.fontFamily,fontSize:k.fontSize,
fontWeight:k.fontWeight,fontStyle:k.fontStyle,lineHeight:k.lineHeight};var J,L,N;k.lineHeight&&(Q=k.lineHeight,-1!==Q.indexOf("px")&&(Q=Q.replace("px",""),Q=parseFloat(Q)));g.useEllipsesOnOverflow(a.config.useEllipsesWhenOverflow);g.setStyle({fontSize:k.fontSize,fontFamily:k.fontFamily,lineHeight:k.lineHeight,fontWeight:k.fontWeight});if(b.labels.isDraw){D=a.get("config","animationObj");J=D.animObj;L=D.dummyObj;a=D.transposeAnimDuration;N=D.animType;b.labels.step?l=d.tickInterval*b.labels.step:l=
d.tickInterval;C.css(F);d=v;for(D=0;d<=w;d+=l)if(b.labels.drawNormalVal||b.labels.drawLimitVal&&(d===v||d===w))if(b.labels.drawNormalVal||d===v||d===w)if(b.labels.drawLimitVal||d!==v&&d!==w)if(0!==b.showZeroPlaneValue||0!==b.showZeroPlane||0!==d)F=c.numberFormatter.scale,d===v&&b.lowerLimitDisplay?(F=g.getSmartText(b.lowerLimitDisplay,r,t),F=F.text):d===w&&b.upperLimitDisplay?(F=g.getSmartText(b.upperLimitDisplay,r,t),F=F.text):F=F.call(c.numberFormatter,M(d,10)),I=n?this.getPixel(d,f+h-b.polarPadding):
this.getPixel(d,m+h+b.polarPadding),F={fill:k.color,"line-height":Q,text:F,x:I.x,y:I.y},I.x>q-10&&I.x<q+10&&I.y<p?(F["text-anchor"]=kb,F["text-valign"]=n?Xa:lb):I.x>q-10&&I.x<q+10&&I.y<p?(F["text-anchor"]=kb,F["text-valign"]=n?lb:Xa):(F["text-anchor"]=I.x<q?n?cb:db:n?db:cb,F["text-valign"]="center"),H[D]?(I=H[D],a&&K?I.animateWith(L,J,F,a,N):I.attr(F)):H[D]=A.text(F,C),D+=1,!u&&d<w&&d+l>w&&(d=w-l,u=!0);if(H[D])for(d=D;d<H.length;d++)H[d].attr({text:""});this.graphics.labels=H}else if(H[D])for(d=D;d<
H.length;d++)H[d].attr({text:""})},_drawTick:function(){var b=this.config,a=b.axisRange,c=a.tickInterval,d=b.drawTick,g=b.drawTickMinor,l=this.chart,k=l.components,h=a.max,u=a.min,f=b.radius,a=e(b.gaugeOuterRadius,f),f=e(b.gaugeInnerRadius,f),k=k.paper,m=this.graphics.tick||[],q=b.minorTMNumber,p=0,n=b.animateAxis,t=!1,r,w,v,C,A,H,D,F,K,I;F=b.axisAxisLineContainer;C={stroke:b.majorTMColor,"stroke-width":b.majorTMThickness,"stroke-linecap":"round"};v={stroke:b.minorTMColor,"stroke-width":b.minorTMThickness,
"stroke-linecap":"round"};if(b.lines.isDraw&&d){p=l.get("config","animationObj");l=p.animObj;K=p.dummyObj;d=p.transposeAnimDuration;I=p.animType;w=this._getVisibleConfig();p=u+c*gb.floor((w.minValue-3*c-u)/c);w=u+c*gb.floor((w.maxValue+3*c-u)/c);w=w>h?h:w;u=p<u?u:p;for(p=0;u<=w;u+=c)if(b.placeTicksInside?(r=this.getPixel(u,f),A=this.getPixel(u,f+b.majorTMHeight)):(r=this.getPixel(u,a),A=this.getPixel(u,a-b.majorTMHeight)),C.path="M"+r.x+" "+r.y+"L"+A.x+" "+A.y,m[p]?(r=m[p],d&&n?r.animateWith(K,l,
C,d,I):r.attr(C)):(r=k.path(C,F),m[p]=r),p+=1,!t&&u<h&&u+c>h&&(u=h-c,t=!0),u<h&&g)for(A=c/(q+1),D=1;D<=q;D+=1)H=u+A*D,b.placeTicksInside?(r=this.getPixel(H,f),H=this.getPixel(H,f+b.minorTMHeight)):(r=this.getPixel(H,a),H=this.getPixel(H,a-b.minorTMHeight)),v.path="M"+r.x+" "+r.y+"L"+H.x+" "+H.y,m[p]?(r=m[p],d&&n?r.animateWith(K,l,v,d,I):r.attr(v)):(r=k.path(v,F),m[p]=r),p+=1;if(m[p])for(u=p;u<m.length;u++)m[u].attr({path:[]});this.graphics.tick=m}else if(m[p])for(u=p;u<m.length;u++)m[u].attr({path:[]})},
_drawPlotBand:function(){},_drawPlotLine:function(){},_drawTrendLine:function(){var b,a,d,g,l,m,k,h,u,f,q,p,n,t,r,w,v,C,A=this.config,H=A.axisRange,D=H.max,H=H.min,F=this.chart;p=F.config;var J=F.linkedItems.smartLabel,N=F.components,M=N.colorManager,Q=A.scaleFactor,R=A.centerX||0,O=A.centerY||0,S=A.canvas.canvasWidth||p.canvasWidth,T=A.trend.trendStyle,Ba=A.axisTrendContainerTop,ha=A.axisTrendContainerBottom,W=A.axisTrendLabelContainer,aa=N.paper,U=this.components.trendObj||[],Z={fontFamily:T.fontFamily,
fontSize:T.fontSize,lineHeight:T.lineHeight,fontWeight:T.fontWeight,fontStyle:T.fontStyle},X=A.trendPoints,da=gb.PI/180,ca={},V=A.animateAxis,ba,fa,pa;ba=0;var ma;g={};h={};d={};l={};var ea={},ja,la,oa,ia,ga,ka,Aa,qa,sa,ua,Ha,Ta;if(X){ba=F.get("config","animationObj");ua=ba.animObj;Ha=ba.dummyObj;F=ba.transposeAnimDuration;Ta=ba.animType;J.useEllipsesOnOverflow(p.useEllipsesWhenOverflow);J.setStyle(Z);ba=fa=0;for(pa=X.point.length;fa<pa;fa+=1)ja=X.point[fa],la=e(ja.startvalue,ja.value),oa=e(ja.endvalue,
la),ma=la!==oa,la<=D&&la>=H&&oa<=D&&oa>=H&&(b=la,a=oa,Ja(K(ja.markertooltext)),d=Ja(K(ja.displayvalue),ma?"":N.numberFormatter.scale(la)),e(ja.showontop,A.ticksBelowGauge,A.ticksBelowGraph,1),g=c(ja.color,M.getColor("trendLightColor")),l=e(ja.alpha,99),m=e(ja.thickness,1),k=ja.dashed?I(ja.dashlen||2,ja.dashgap||2,ja.thickness||1):"",h=e(ja.usemarker,0),u=L(c(ja.markercolor,ja.color,M.getColor("trendLightColor")),100),f=L(c(ja.markerbordercolor,ja.bordercolor,M.getColor("trendDarkColor")),100),q=e(e(ja.markerradius)*
Q,5),p=na(ja.markertooltext),n=e(e(ja.trendvaluedistance,A.trendValueDistance)*Q,A.tickValueDistance),t=e(ja.valueinside,A.placeValuesInside,0),r=e(ja.showborder,1),w=L(c(ja.bordercolor,ja.color,M.getColor("trendDarkColor")),e(ja.borderalpha,ja.alpha,100)),v=e(e(ja.radius)*Q),C=e(e(ja.innerradius)*Q),ia=Math.cos(89.99*da),ga=-ia,v=e(v,A.gaugeOuterRadius),C=e(C,ma?Math.max(A.gaugeInnerRadius-15,0):A.gaugeInnerRadius),ka=this.getPixel(la,v),Aa=this.getPixel(la,C),qa=ka.x,ka=ka.y,sa=Aa.x,Aa=Aa.y,oa=
this.getAngle(oa),la=this.getAngle(la),ma?(la>oa&&(la+=oa,oa=la-oa,la-=oa),g={fill:L(g,l),"stroke-width":r?m:0,stroke:w,"stroke-dasharray":k},l={ringpath:[R,O,v,C,la,oa]}):(g={"stroke-width":r?m:0,stroke:w,"stroke-linecap":"round","stroke-dasharray":k},l={path:["M",qa,ka,"L",sa,Aa]}),h?(h={fill:u,"stroke-width":1,stroke:f},ea={polypath:[3,qa,ka,q,(-la+Math.PI)/da,0]}):h={},""!==d?(ca=(a+b)/2,oa=this.getAngle(ca-H),b=Math.cos(oa),a=Math.sin(oa),q=J.getOriSize(d).width,t?(ca=C-2-n,n=b>ia?db:b<ga?cb:
kb):(ca=v+2+n,n=b>ia?cb:b<ga?db:kb),qa=R+ca*b,ka=O+ca*a,ca=J.getOriSize(d).height,ca=J.getSmartText(d,S,ca),qa=S<qa+q?S-q/2:qa<q?q/2:qa,q>S&&(qa=S/2),d={fill:ja.color||T.color,text:ca.text,"text-anchor":n,"vertical-align":Xa,x:qa,y:ka},ja=ca.height,ka=b>ia||b<ga?ka+(-(ja/2)+.4*ja*a*(t?-1:1)):t?ka+-(0>a?0:ja):ka+-(0<a?0:ja),d.y=ka):d={text:""},U[ba]?(t=U[ba].graphics.drawing,ma=U[ba].graphics.label,ia=U[ba].graphics.marker,t.attr(g),ia.attr(h),ia.tooltip(p),ma.css(Z).tooltip(ca.oriText),F&&V?(t.animateWith(Ha,
ua,l,F,Ta),ia.animateWith(Ha,ua,ea,F,Ta),ma.animateWith(Ha,ua,d,F,Ta)):(t.attr(l),ia.attr(ea),ma.attr(d)),A.showTooltip&&ca.oriText?ma.trackTooltip(!0):ma.trackTooltip(!1),ia.trackTooltip(A.showTooltip&&""!==p)):(t=ma?aa.ringpath(R,O,v,C,la,oa,ha):aa.path(Ba),ma=aa.text(d,Z,W),ia=aa.polypath(Ba),t.attr(g),t.attr(l),ia.attr(h),ia.attr(ea),ia.tooltip(p),ma.tooltip(ca.oriText),A.showTooltip&&ca.oriText?ma.trackTooltip(!0):ma.trackTooltip(!1),ia.trackTooltip(A.showTooltip&&""!==p),U[ba]={},U[ba].graphics=
{},U[ba].graphics.drawing=t,U[ba].graphics.label=ma,U[ba].graphics.marker=ia),ba+=1);this.components.trendObj=U}if(U[ba])for(fa=ba;fa<U.length;fa++)U[fa].graphics.drawing.attr({path:["M",0,0]}),U[fa].graphics.marker.attr({polypath:["M",0,0]}),U[fa].graphics.label.attr({text:"","text-bound":[]});for(fa=0;fa<ba;fa++)U[fa].graphics.label.attr({"text-bound":[T.backgroundColor,T.borderColor,T.borderThickness,T.borderPadding,T.borderRadius,T.borderDash]})}},"gauge",{trendPoints:void 0,ticksBelowGauge:void 0,
ticksBelowGraph:void 0,trendValueDistance:void 0}]);FusionCharts.register("component",["axis","polar",{configure:function(){var b=this.config,a=b.rawAttr,d=this.chart.components.colorManager;FusionCharts.register("component",["axis","cartesian"]).prototype.configure.call(this);b.gridLineColor=L(c(a.radarSpikeColor,d.getColor("divLineColor")),e(a.radarSpikeAlpha,a.radarInLineAlpha,d.getColor("divLineAlpha")));b.radarBorderColor=L(c(a.radarBorderColor,d.getColor("divLineColor")),e(a.radarBorderAlpha,
100));b.radarFillColor=L(c(a.radarFillColor,d.getColor("altHGridColor")),e(a.radarFillAlpha,d.getColor("altHGridAlpha")))},_drawComponents:function(){var b=this.config;b.drawLabels&&b.hasCategory&&this._drawCategory()},getAxisPosition:function(b,a){return this.getPixel(b,a)},getPixel:function(b,a){var c=this.config,d=c.axisRange,g=d.min,l=d.max-g+1,k=c.startAngle||-(zb/4),h=c.totalAngle||-zb,u=c.centerX||0,d=c.centerY||0;a=e(a,c.radius,0);c=k+h/l*(b-g);g=u+a*jb(c);d+=a*vb(c);return{x:g,y:d}},_drawCategory:function(){var b=
this.config,a=this.chart,d=b.isOpposit,g=b.labels,l=g.style,m=b.axisContainer,k=b.axisPlotLineContainer,h=a.components.paper,u=this.components.categoryLabel||[],f=this.graphics.radarBorder||[],p=a.jsonData.categories,n=b.categories.category,t=b.labelPadding,r,w,v,C,A,H,D=b.gridLineColor,F=b.gridLineWidth,K=function(b){return function(c){ia.call(this,a,c,b)}},J=0,N=b.centerX,M=b.centerY,Q=b.animateAxis,R,O,S,T,Ba,ha,W,aa,U,Z,X;aa=e(b.radius,0);S=n?n.length-1:0;R=a.get("config","animationObj");U=R.animObj;
Z=R.dummyObj;O=R.transposeAnimDuration;X=R.animType;C={stroke:b.radarBorderColor,fill:b.radarFillColor,"stroke-width":b.radarBorderThickness,path:["M"]};if(0!==b.showRadarBorder){for(J=R=0;R<=S;R++)ha=this.getPixel(R,aa),C.path.push(ha.x,ha.y,"L");C.path.pop();C.path.push("Z")}f[0]?O&&Q?f[0].animate(C,O):f[0].attr(C):f[0]=h.path(C,k);this.graphics.radarBorder=f;if(b.labels.isDraw){p&&(r=p[0].font,w=p[0].fontsize,v=p[0].fontcolor);for(J=R=0;R<=S;R++)if(f=n[R],ha=e(f.x,f.y,R),b.labels.drawNormalVal||
b.labels.drawLimitVal&&(0===R||ha===S))if(b.labels.drawNormalVal||0===ha||ha===S)if(b.labels.drawLimitVal||0!==ha&&ha!==S){p=c(f.font,f.labelfont);C=c(f.fontsize,f.labelfontsize);A=e(f.fontbold,f.labelfontbold,0)?"bold":void 0;H=e(f.fontitalic,f.labelfontitalic,0)?"italic":void 0;Ba=L(c(f.fontcolor,f.labelfontcolor,v,l.color),e(f.labelalpha,b.rawAttr.labelFontAlpha,100));p={fontFamily:c(p,r,l.fontFamily),fontSize:c(C,w,l.fontSize),fontWeight:c(A,l.fontWeight),fontStyle:c(H,l.fontStyle)};p.lineHeight=
q(p);p.lineHeight&&(T=p.lineHeight,-1!==T.indexOf("px")&&(T=T.replace(/px/i,""),T=parseFloat(T)));C=this.getPixel(ha,aa+t);H=C.x;W=C.y;C=f.label||"";if(0===e(f.showlabel,1)||0===b.showLabels)C="";A=Number(f.labelPadding)||0;Ba={fill:Ba,"line-height":T,"font-size":l.fontSize,text:C,cursor:f.link?"pointer":"",x:H,y:W};A&&(Ba.y+=A);Ba["vertical-align"]=d?lb:Xa;0===R?(Ba["text-anchor"]=kb,Ba["vertical-align"]=lb):R===(S+1)/2?(Ba["text-anchor"]=kb,Ba["vertical-align"]=Xa):(Ba["text-anchor"]=R<(S+1)/2?
db:cb,Ba["vertical-align"]="center");ha=this.getPixel(ha,aa);A={stroke:D,"stroke-width":F,"stroke-dasharray":"none",path:["M",N,M,"L",ha.x,ha.y]};g.shiftX&&(Ba.x+=g.shiftX);g.shiftY&&(Ba.y+=g.shiftY);u[J]?(ha=u[J].graphics.line,O&&Q?ha.animateWith(Z,U,A,O,X):ha.attr(A),A=u[J].graphics.label,O&&Q?A.animateWith(Z,U,Ba,O,X):A.attr(Ba),A.css(p),b.showTooltip&&f.tooltext?(A.tooltip(f.tooltext),A.trackTooltip(!0)):A.trackTooltip(!1)):(ha=h.path(A,k),A=h.text(Ba,p,m),b.showTooltip&&f.tooltext?(A.tooltip(f.tooltext),
A.trackTooltip(!0)):A.trackTooltip(!1),A.click(K("datalabelclick")).hover(K("dataLabelRollOver"),K("dataLabelRollOut")),u[J]={},u[J].graphics={},u[J].config={},u[J].graphics.line=ha,u[J].graphics.label=A);u[J].config.labelBox={label:C,lineHeight:p.lineHeight,border:e(f.borderthickness,f.labelborderthickness)?e(f.borderthickness,f.labelborderthickness,1)+"px solid":"",borderColor:f.bordercolor||f.labelbordercolor?L(f.bordercolor||f.labelbordercolor,e(f.borderalpha,f.labelborderalpha,f.alpha,f.labelalpha,
100)):"",borderThickness:e(f.borderthickness,f.labelborderthickness),borderPadding:e(f.borderpadding,f.labelborderpadding),borderRadius:e(f.borderradius,f.labelborderradius),backgroundColor:f.bgcolor||f.labelbgcolor?L(f.bgcolor||f.labelbgcolor,e(f.bgalpha,f.labelbgalpha,f.alpha,f.labelalpha,100)):"",borderDash:e(f.borderdashed,f.labelborderdashed,0)?I(e(f.borderdashlen,f.labelborderdashlen,4),e(f.borderdashgap,f.labelborderdashgap,2),e(f.borderthickness,f.labelborderthickness,1)):0===e(f.borderdashed,
f.labelborderdashed)?"none":l.borderDash};u[J].graphics.label.data("eventArgs",{link:f.link||f.labellink||l.labelLink,text:Ba.text,index:J});J+=1}if(u[J])for(R=J;R<u.length;R++)u[R].graphics.line.attr({path:["M",0,0]}),u[R].graphics.label.attr({text:"","text-bound":[]});this.components.categoryLabel=u}else if(u[J])for(R=J;R<u.length;R++)u[R].graphics.line.attr({path:["M",0,0]}),u[R].graphics.label.attr({text:"","text-bound":[]});for(R=0;R<J;R++)b=u[R].config.labelBox,b.label?u[R].graphics.label.attr({"text-bound":[c(b.backgroundColor,
l.backgroundColor),c(b.borderColor,l.borderColor),c(b.borderThickness,l.borderThickness),c(b.borderPadding,l.borderPadding),c(b.borderRadius,l.borderRadius),c(b.borderDash,l.borderDash)]}):u[R].graphics.label.attr({"text-bound":[]})},placeAxis:function(b,a){var d,g,l,m,k,h,u=this.config,f=this.chart,p=f.linkedItems.smartLabel,n=u.labels.style,t=f.jsonData.categories,r=u.labelPadding=e(u.rawAttr.axisValuePadding,10),w=u.useEllipsesWhenOverflow,v=0,C=0,A=0,H=0,D=a/2,F=a/2,K=b/2,I=b/2,J,L;J=u.categories.category;
u.labels.isDraw=1;u.labels.drawNormalVal=1;u.labels.drawLimitVal=1;if(u.showLabels)for(t&&(k=t[0].font,h=t[0].fontsize),u=0,t=J.length;u<t;u++)L=J[u],d=L.font,g=L.fontsize,l=L.fontbold?"bold":"normal",m=L.fontitalic?"italic":"normal",d={fontFamily:c(d,k,n.fontFamily),fontSize:c(g,h,n.fontSize),fontWeight:c(l,n.fontWeight),fontStyle:c(m,n.fontStyle)},g=q(d),p.useEllipsesOnOverflow(f.config.useEllipsesWhenOverflow),p.setStyle(d),0===u?(d=p.getSmartText(L.label,b,Va(g,D),w),L.oriLabel=L.label,L.label=
d.text,d.width+=r,d.height+=r,d.height>v&&(H=v=d.height)):u===t/2?(d=p.getSmartText(L.label,b,Va(g,F),w),L.oriLabel=L.label,L.label=d.text,d.width+=r,d.height+=r,d.height>H&&(H=d.height)):u<t/2?(d=p.getSmartText(L.label,I,g,w),L.oriLabel=L.label,L.label=d.text,d.width+=r,d.height+=r,d.width>C&&(C=d.width)):(d=p.getSmartText(L.label,K,g,w),L.oriLabel=L.label,L.label=d.text,d.width+=r,d.height+=r,d.width>A&&(A=d.width));return{top:v,left:C,right:A,bottom:H}}},"cartesian",{axisValuePadding:10,gridLineWidth:1,
showRadarBorder:1,radarBorderThickness:2}]);FusionCharts.register("component",["dataset","Column",{type:"column",pIndex:2,customConfigFn:"_createDatasets",configure:function(){var b=this.chart,a=this.config,d=this.JSONData,g=b.singleseries,l=b.config.isdual,E=b.config,k=b.jsonData.chart,h=b.components,u=h.colorManager,f=a.plotColor=u.getPlotColor(this.index||this.positionIndex),q=e(d.dashed,k.plotborderdashed),p=e(k.useplotgradientcolor,1),t,r,w=m.getDashStyle;r=b.isBar;var v=b.is3D,C;this.__setDefaultConfig();
n(d,a,E,{data:!0});a.showplotborder=e(k.showplotborder,v?0:1);t=E.plotborderdashlen;E=E.plotborderdashgap;a.plotfillangle=e(360-k.plotfillangle,r?180:90);a.plotfillalpha=r=c(d.alpha,k.plotfillalpha,aa);a.plotColor=c(d.color,f);a.legendSymbolColor=a.plotColor;a.plotgradientcolor=m.getDefinedColor(k.plotgradientcolor,u.getColor("plotGradientColor"));!p&&(a.plotgradientcolor="");a.plotborderalpha=c(k.plotborderalpha,r,aa);a.plotbordercolor=c(k.plotbordercolor,v&&!g?"#ffffff":u.getColor("plotBorderColor"));
a.plotborderdashstyle=q?w(t,E,void 0):"none";a.showShadow=v?e(k.showshadow,1):e(k.showshadow,u.getColor("showShadow"));a.definedGroupPadding=Ea(e(k.plotspacepercent),0);a.parentYAxis=l?C="s"===c(d.parentyaxis&&d.parentyaxis.toLowerCase(),"p")?1:0:C=0;this.yAxis=h.yAxis[C];this.visible=1===e(d.visible,!Number(d.initiallyhidden),1);!0===this.visible?this._conatinerHidden=!1:this._containerHidden=!0;this._setConfigure();this._realTimeConfigure&&this._realTimeConfigure();!1!==b.hasLegend&&this._addLegend()},
_setConfigure:function(b,a){var d=this.chart,g=d.config,l=this.config,E=this.JSONData,k=b||E.data,h=d.singleseries,u=d.components,f=u.xAxis[0],q=f.getCategoryLen(),q=b?b.data.length:q,p=d.jsonData.chart,u=u.colorManager,n=l.showplotborder,r=l.plotColor,w=g.showtooltip,v=m.parseUnsafeString,C=g.yaxisname,A=g.xaxisname,H=g.tooltipsepchar,D=g.seriesnameintooltip,F=m.parseTooltext,K,I,J,N,Q,R,M=l.plotborderdashlen,O=l.plotborderdashgap,S=g.plotborderthickness,T=g.useroundedges,ha=g.plothovereffect,W=
l.plotfillangle,aa,U,Z,X=l.plotborderdashstyle,da,ca,ba,V,fa,pa,ma,ia,ja,la=m.getDashStyle,oa=this.components.data,ea=d.isBar,ga=d.is3D,ka,Aa=-Infinity,qa=Infinity,sa=this.yAxis,ua=g.use3dlighting,Ha=g.usedataplotcolorforlabels,Ta;oa||(oa=this.components.data=[]);this.visible=1===e(this.visible,this.JSONData.visible,!Number(this.JSONData.initiallyhidden),1);for(ka=0;ka<q;ka++)b?(R=b&&b.data[ka]||{},Ta=void 0!==a?a+ka:oa.length-q+ka,I=oa[Ta]):(I=oa[ka],R=k&&k[ka]||{}),d=I&&I.config,I||(I=oa[ka]={}),
I.config||(d=oa[ka].config={}),d.showValue=e(R.showvalue,l.showvalues),d.setValue=I=sa.getCleanValue(R.value,g.stack100percent),d.setLink=c(R.link),d.toolTipValue=r=sa.dataLabels(I),d.setDisplayValue=N=v(R.displayvalue),d.displayValue=c(N,r),r=e(R.dashed),N=e(R.dashlen,M),K=O=e(R.dashgap,O),null!==I&&(Aa=Ea(Aa,I),qa=Va(qa,I)),d.plotBorderDashStyle=N=1===r?la(N,K,S):0===r?"none":X,h?(r=u.getPlotColor(e(Ta-q,ka)),r=c(R.color,r),Ha&&f.updateCategory(ka,{labelfontcolor:L(r)}),Z=c(R.alpha,R.borderalpha,
l.plotborderalpha,aa).toString()):(r=c(R.color,l.plotColor),Z=c(R.alpha,l.plotborderalpha,aa).toString()),U=c(R.ratio,l.ratio),aa=c(R.alpha,l.plotfillalpha),d.shadow={opacity:l.showShadow?aa/100:0},0>I&&!T&&(Q=l.plotfillangle,W=ea?180-W:360-W),d.colorArr=K=m.graphics.getColumnColor(r+","+l.plotgradientcolor,aa,U,W,T,l.plotbordercolor,Z,ea?1:0,ga?!0:!1),da=f.getLabel(e(Ta-q,ka)),d.origLabel=I=Ja(v(da.label)),I=d.label=Ja(v(da.tooltext))||I,0!==ha&&(da=c(R.hovercolor,E.hovercolor,p.plotfillhovercolor,
p.columnhovercolor,r),ca=c(R.hoveralpha,E.hoveralpha,p.plotfillhoveralpha,p.columnhoveralpha,aa),ba=c(R.hovergradientcolor,E.hovergradientcolor,p.plothovergradientcolor,l.plotgradientcolor),!ba&&(ba=""),U=c(R.hoverratio,E.hoverratio,p.plothoverratio,U),V=e(360-R.hoverangle,360-E.hoverangle,360-p.plothoverangle,W),fa=c(R.borderhovercolor,E.borderhovercolor,p.plotborderhovercolor,l.plotbordercolor),pa=c(R.borderhoveralpha,E.borderhoveralpha,p.plotborderhoveralpha,p.plotfillhoveralpha,p.columnhoveralpha,
Z,aa),Z=e(R.borderhoverthickness,E.borderhoverthickness,p.plotborderhoverthickness,l.showplotborder&&S),ma=R.borderhoverdashed||E.borderhoverdashed||p.plotborderhoverdashed,ia=e(R.borderhoverdashgap,E.borderhoverdashgap,p.plotborderhoverdashgap,M),ja=e(R.borderhoverdashlen,E.borderhoverdashlen,p.plotborderhoverdashlen,O),ma=void 0!==ma?Number(ma)?la(ja,ia,Z):"":N,1==ha&&da===r&&(da=ob(da,70)),r=m.graphics.getColumnColor(da+","+ba,ca,U,V,T,fa,pa.toString(),ea?1:0,ga?!0:!1),d.setRolloutAttr={fill:ga?
[t(K[0]),!ua]:t(K[0]),stroke:n&&t(K[1]),"stroke-width":S,"stroke-dasharray":N},d.setRolloverAttr={fill:ga?[t(r[0]),!ua]:t(r[0]),stroke:t(r[1]),"stroke-width":Z,"stroke-dasharray":ma}),K=d.toolTipValue,d.origToolText=r=Ja(v(c(R.tooltext,E.plottooltext,p.plottooltext))),w?null===K?R=!1:void 0!==r?(N=[1,2,3,4,5,6,7],I={yaxisName:C,xaxisName:A,formattedValue:K,label:I},R=F(r,N,I,R,p,E)):(D&&(J=na(E&&E.seriesname)),R=J?J+H:"",R+=I?I+H:""):R=!1,d.toolText=R,d.setTooltext=R,Q&&(W=Q),Ta++;l.maxValue=Aa;l.minValue=
qa},init:function(b){var a=this.chart;if(!b)return!1;this.JSONData=b;this.chartGraphics=a.chartGraphics;this.components={};this.graphics={};this.configure()},_addLegend:function(){var b=this.chart,a=b.isBar,c=b.jsonData.chart,d,g;g=this.config;var l=ib(g.legendSymbolColor),b=b.components.legend;d=e(c.use3dlighting,c.useplotgradientcolor,1);c=ob(l,60).replace(ra,V);d?(d=ob(l,40),a={FCcolor:{color:l+","+l+","+d+","+l+","+l,ratio:"0,30,30,30,10",angle:a?0:270,alpha:"100,100,100,100,100"}}):a={FCcolor:{color:l,
angle:a?0:270,ratio:"0",alpha:"100"}};g={enabled:g.includeinlegend,type:this.type,fillColor:t(a),strokeColor:t(c),rawFillColor:l,rawStrokeColor:l,label:na(this.JSONData.seriesname)};this.legendItemId=b.addItems(this,this.legendInteractivity,g)},legendInteractivity:function(b,a){var c=this.config,d=b.visible,e=a.config,g=a.graphics,k=c.itemHiddenStyle.color,c=c.itemStyle.color,h=e.fillColor,l,e=e.strokeColor;d?b.hide():b.show();d={legendItemSymbol:{fill:d?k:h,stroke:d?k:e},legendItemText:{fill:d?k:
c},legendItemLine:{stroke:d?k:e}};for(l in g)(k=g[l])&&d[l]&&k.attr(d[l])},draw:function(){var b=this,a=b.JSONData,d=b.chart.jsonData.chart,g=b.config,l=g.legendInteractivity,E=b.groupManager,k=b.index,h,u,f=b.visible,q=b.chart,p=q.getJobList(),n=q.config,r=q.components,v=r.paper,A=r.xAxis[0],H=A.getCategoryLen(),D=b.yAxis,F=q.graphics.columnGroup,K=n.isstacked,I,J,L,N=q.graphics,M=N.sumLabelsLayer,Q=m.parseUnsafeString,R=m.getValidValue,O=m.Raphael,S=n.showtooltip,T=q.get("config","animationObj"),
Ba=T.animObj,ha=T.dummyObj,W=T.duration,aa=T.animType,U=A.getAxisPosition(0),Z=A.getAxisPosition(1),X=g.groupMaxWidth=Z-U,da=n.definedgrouppadding,ca=n.plotspacepercent/200,ba=E.getDataSetPosition(b),V=E.stackSumValue[b.positionIndex],fa=n.maxcolwidth,pa=(1-.01*da)*X||Va(X*(1-2*ca),1*fa),ma=e(ba.columnWidth,pa/1),ia,ja=ba.xPosOffset||0,la=ba.height,oa,ea,ga=b.components,ka=ga.data,Aa,qa,sa,ua,Ha,Ta,na,ra=b.drawn,va=ga.removeDataArr,Ga=va&&va.length,Ja=ga.addDataArr,za=Ja&&Ja.length,Ea,Ka=D.getLimit(),
La=Ka.min,Ia=0<Ka.max&&0>La,Da,ya=D.getAxisBase(),Na=D.yBasePos=D.getAxisPosition(ya),Ma,Ua,Pa=n.plotborderthickness,Qa=n.useroundedges,Oa=b.graphics,Sa=Oa.container,Wa=Oa.trackerContainer,$a=Oa.dataLabelContainer,Xa=Oa.shadowContainer,cb=ga.pool,db=N.trackerGroup,ab,fb=1,ib,Za,kb,gb=A.getAxisPosition(H-1)+ja,nb=A.getAxisPosition(0)+ja,mb,ob=!0,lb,sb=b.startPosition,tb=q.isInverse,vb,jb=function(){!1!==b.visible||!1!==b._conatinerHidden&&void 0!==b._conatinerHidden||(Sa.hide(),Wa.hide(),Xa.hide(),
$a&&$a.hide(),b._conatinerHidden=!0);this.show()},zb=function(){M.show()},wb=function(){return sb?function(b,a){b.x=nb-X*(za-a);b.y=J;b.height=oa}:!1===sb?function(b){b.x=gb+X*fb++;b.y=J;b.height=oa}:function(b){b.width=0}},xb,yb=q.config.viewPortConfig,Bb=yb.x,Ab=yb.scaleX,Hb=n.showplotborder;ra&&(wb=wb());Sa||(Sa=b.graphics.container=v.group("columns",F),f?Sa.show():Sa.hide());Wa||(Wa=b.graphics.trackerContainer=v.group("col-hot",db),f||Wa.hide());Xa||(Xa=b.graphics.shadowContainer=v.group("shadow",
F).toBack(),f||Xa.hide());f&&(Sa.show(),Wa.show(),Xa.show());for(u=0;u<H;u++)if(Ha=(na=(Aa=ka[u])&&Aa.config)&&na.setValue,void 0===Aa||void 0===Ha||null===Ha){if(ib=Aa&&Aa.graphics)for(Za in ib)ib[Za].hide()}else if(lb=Aa.trackerConfig={},Da=0<=Ha,ua=na.setLink,ab=na.colorArr,Aa.graphics||(ka[u].graphics={}),Ta=na.displayValue,Ma=Da?na.previousPositiveY:na.previousNegativeY,qa=R(Q(c(na.origToolText,a.plottooltext,d.plottooltext))),K&&(Ma=b._parseValues(u,Ma,V[u],qa),Ha=na.value),Ua=D.getAxisPosition(Ma||
ya),I=A.getAxisPosition(u)+ja+Bb*Ab,0!==la?(J=D.getAxisPosition(Ha+(Ma||0)),oa=Ra(Ua-J)):(oa=0,J=Ua),J=Va(J,Ua),E.isCrisp?(L=O.crispBound(I,J,ma,oa,Pa),I=L.x,vb=hb(oa)===L.height,kb=hb(J)!==L.y,J=L.y,ia=L.width,oa=L.height):ia=ma,f&&0<Pa&&(0===Pa%2&&(tb&&Ia?Da?!kb&&(oa+=1):!vb&&--J:Da?kb&&--J:vb&&(oa+=1)),Ea=Math.floor(Pa/2),tb&&Ia?Da?oa-=Ea:J+=Ea:Da?J+=Ea:oa-=Ea),xb=na.shadow,ea=!1!==na.toolText?na.toolText+(qa?"":na.toolTipValue):"",mb=na.plotBorderDashStyle,lb.eventArgs={index:u,link:ua,value:Ha,
displayValue:Ta,categoryLabel:na.origLabel,toolText:ea,id:"",datasetIndex:k,datasetName:a.seriesname,visible:f},Aa._xPos=I,Aa._yPos=J,Aa._height=oa,Aa._width=ia,Aa._index=u,(sa=Aa.graphics.element)||(h={x:I,y:Na,width:ia,height:1,r:Qa,ishot:!S,fill:t(ab[0]),stroke:t(ab[1]),"stroke-width":Hb?Pa:0,"stroke-dasharray":mb,"stroke-linejoin":"miter",visibility:f},ra&&(wb(h,u),cb&&cb.element[0]&&(sa=Aa.graphics.element=cb.element[0],sa.attr(h),cb.element.splice(0,1)),Aa._newXPos=h.x),sa?na.elemCreated=!1:
(sa=Aa.graphics.element=v.rect(h,Sa),na.elemCreated=!0),ra||(sa.animateWith(ha,Ba,{y:J,height:oa||1},W,aa,ob&&zb),ob=!1)),(sa=Aa.graphics.element)&&ra&&(na.elemCreated=!1,h={x:I,y:J,width:ia,height:oa||1,r:Qa},K||!1!==b.visible||0===la||(delete h.y,delete h.height),l||sa.attr({fill:t(ab[0]),stroke:t(ab[1]),"stroke-width":Hb?Pa:0,"stroke-linejoin":"miter","stroke-dasharray":mb,ishot:!S,visibility:f}),sa.animateWith(ha,Ba,h,W,aa,ob&&jb),ob=!1),sa.shadow(xb,Xa).data("BBox",L),ua||S)oa<C&&(J-=(C-oa)/
2,oa=C),lb.attr={x:I,y:J,width:ia,height:oa,r:Qa,cursor:ua?"pointer":"",stroke:w,"stroke-width":Hb?Pa:0,fill:w,ishot:!0,visibility:f};ra?b.drawTracker():p.trackerDrawID.push(pb.addJob(b.drawTracker,b,[],m.priorityList.tracker));ra?b.drawLabel():p.labelDrawID.push(pb.addJob(b.drawLabel,b,[],m.priorityList.label));!ra&&M.hide();E.drawSumValueFlag&&E.drawSumValueFlag&&E.drawSumValue();b.drawn=!0;Ga&&b.remove()},drawTracker:function(){var b=this.chart,a=this.components,c=a.pool,a=a.data,d=b.config.plothovereffect,
e=b.components,g=e.paper,e=e.xAxis[0].getCategoryLen(),k=this.graphics.trackerContainer,h,l,f,m,q,p,n,t,r=function(a){ia.call(this,b,a)},w=function(a){return function(c){var f=this.getData();0!==f.showHoverEffect&&!0!==f.draged&&(a.attr(this.getData().setRolloverAttr),ia.call(this,b,c,"DataPlotRollOver"))}},v=function(a){return function(c){var f=this.getData();0!==f.showHoverEffect&&!0!==f.draged&&(a.attr(this.getData().setRolloutAttr),ia.call(this,b,c,"DataPlotRollOut"))}};for(f=0;f<e;f++)if(m=a[f],
void 0!==m&&(l=m.config,h=m.trackerConfig,(q=m.graphics)&&q.element)){q=q.element;n=m.graphics.hotElement;if(t=h.attr)n?n.attr(t):c&&c.hotElement[0]?(n=m.graphics.hotElement=c.hotElement[0],n.attr(t),c.hotElement.splice(0,1)):(n=m.graphics.hotElement=g.rect(t,k),p=!0);(n||q).data("eventArgs",h.eventArgs).data(Da,d).data(Na,l.setRolloverAttr||{}).data(ya,l.setRolloutAttr||{}).tooltip(h.eventArgs&&h.eventArgs.toolText);(p||l.elemCreated)&&(n||q).click(r).hover(w(q),v(q))}},show:function(){var b=this.graphics&&
this.graphics.container,a=this.graphics&&this.graphics.trackerContainer,c=this.graphics&&this.graphics.dataLabelContainer,d=this.graphics&&this.graphics.shadowContainer,e=this.chart.is3D,g=this.components.data,k=this.chart.config.categories,h=this.yAxis,l=this.chart,f=l.components.xAxis[0],k=Va(this.JSONData.data&&this.JSONData.data.length,k&&k.length);this.config.legendInteractivity=!0;l._chartAnimation();this.visible=!0;this._conatinerHidden=!1;if(e)for(b=0;b<k;b++)g[b]&&g[b].graphics&&g[b].graphics.element&&
g[b].graphics.element.attr({visibility:Pa}),g[b]&&g[b].graphics&&g[b].graphics.hotElement&&g[b].graphics.hotElement.attr({visibility:Pa});else b.show(),a.show();d.show();c&&c.show();l.config.transposeAxis&&(l._setAxisLimits(),h.draw());l.isRealTime&&f.draw();l._drawDataset();this.config.legendInteractivity=!1},hide:function(){var b=this.yAxis,a=this.chart,c=a.components.xAxis[0];a._chartAnimation();this.visible=!1;this.config.legendInteractivity=!0;a.config.transposeAxis&&(a._setAxisLimits(),b.draw());
a.isRealTime&&c.draw();a._drawDataset();this.config.legendInteractivity=!1},drawLabel:function(b,a){var c=this.chart,d=c.config,g=c.graphics,l=c.components,k=c.get("config","animationObj"),h=k.dummyObj,u=k.animObj,f=k.animType,k=k.duration,m=l.paper,q=c.linkedItems.smartLabel,n=c.config.dataLabelStyle,t=this.config.legendInteractivity,r=l.xAxis[0].getCategoryLen(),w=this.components,l=w.data,w=w.pool,v=this.visible,C,A,d=d.rotatevalues?270:0,H,D,F,K,I,J=this.graphics.dataLabelContainer,Q=this.labelDrawn;
C=e(b,0);r=e(a,r);g=g.datalabelsGroup;J||(J=this.graphics.dataLabelContainer=m.group("datalabel",g));v?J.show():J.hide();q.useEllipsesOnOverflow(c.config.useEllipsesWhenOverflow);q.setStyle(n);for(g=C;g<r;g++)if(C=l[g],void 0!==C&&(v=C.graphics))I=C&&C.config,F=C._yPos,K=C._xPos,D=I.setValue,A=I.displayValue,(H=I.showValue)&&null!==D?(t&&I._state||(H=q.getOriSize(A),I._state=d?{labelWidth:H.height,labelHeight:H.width}:{labelWidth:H.width,labelHeight:H.height}),D=this._getValuePosition({labelWidth:I._state.labelWidth,
labelHeight:I._state.labelHeight,width:C._width,height:C._height,yPos:F,xPos:K,value:D}),F=D.textX,D=D.textY,A={x:F,y:D,text:A},t||(A=p(A,{visibility:Pa,"line-height":n.lineHeight,fill:n.color,"text-bound":[n.backgroundColor,n.borderColor,n.borderThickness,n.borderPadding,n.borderRadius,n.borderDash]})),!v.label&&Q&&c.isRealTime&&(I=p({},A),I.x=A.x-K+(C._newXPos||0),I.transform=m.getSuggestiveRotation(d,I.x,D),w&&w.label[0]?(v.label=w.label[0].attr(I),w.label.splice(0,1)):v.label=m.text(I,J)),A.transform=
m.getSuggestiveRotation(d,F,D),(C=v.label)||(C=v.label=m.text(A,J)),C.show(),Q&&C.animateWith(h,u,A,k,f)):v.label&&(v.label.attr({"text-bound":[]}),v.label.hide());this.labelDrawn=!0},_getValuePosition:function(b){var a=this.chart,d=a.components,e=a.config,g=d.canvas.config,l=d.yAxis[0],d=g.xDepth,g=g.yDepth,k=e.canvasTop,h=e.canvasHeight+g,u,f,m,q=b.yPos,p=a.is3D,a=a.config.isstacked,n=e.valuepadding+2,t=b.height;u=b.width;e=e.placevaluesinside;m=b.labelHeight;var r=l.getAxisConfig("isReverse"),
w=l.getAxisConfig("axisRange"),v=w.min,l=b.value,w=0<w.max&&0>v;b=b.xPos;r&&w&&(f=0>l?!1:!0);f=c(f,0>l);m=r=m+n;n=.5*r+n;u=b+.5*u;b=f?k+h-(q+t+g):q-k;a?(h=Va(k+h-.5*m,q+.5*t+(g||0)),h=Ea(k+.5*m,h),u-=d):e?t>=m?(h=q+(f?t-n:n),p&&(u-=d,h+=g)):b>=m?(h=q+(f?t+n:-n),p&&f&&(u-=d,h+=g)):(h=q+(f?t-n:n),p&&(u-=d,h+=g)):b>=m?(h=q+(f?t+n:-n),p&&(f?(u-=d,h+=g):u-=d/2)):(h=q+(f?t-n:n),p&&(u-=d,h+=g));return{textX:u,textY:h}},_parseValues:function(b,a,c,d){var e=this.chart.config;b=this.components.data[b].config;
var g=e.showpercentvalues,k=e.showpercentintooltip,h=b.setValue,e=e.stack100percent,l=this.chart.components.numberFormatter,f=this.yAxis,m=b.setDisplayValue,h=(this.visible?h||0:0)/c*100,l=l.percentValue(h);e&&(b.value=h,a=(a||0)/c*100);k&&(b.toolTipValue=l);g&&!m&&(b.displayValue=l);d&&(b.toolText=ea(b.setTooltext,[14,24,25,112],{percentValue:l,sum:f.dataLabels(c),unformattedSum:c}));return a},getDataLimits:function(){return{max:this.config.maxValue,min:this.config.minValue}},addData:function(b,
a,c){var d=this.components,e=this.chart.components.numberFormatter,g=d.data,k=b.data,h=k.length,l=this.config,f=l.maxValue,l=l.minValue,m=this.maxminFlag,q;d.addDataArr=b.data;if(0===a)this.startPosition=!0;else if(a+h===g.length||void 0===a)this.startPosition=!1;for(q=0;q<h;q++)if(void 0!==a?g.splice(a+q,0,{config:{}}):g.push({config:{}}),!m&&(d=e.getCleanValue(k[q].value),d>f||d<l))m=this.maxminFlag=!0;this._setConfigure(b,a);m&&this.setMaxMin();c&&this.draw()},hideElements:function(b){b.hide()},
removeData:function(b,a,c){var d=this.components,e=d.data,g=d.removeDataArr||(d.removeDataArr=[]),k=this.config,h=this.groupManager,l=this.maxminFlag;void 0===a&&(a=1);b=b||0;if(b+a===e.length)this.endPosition=!0;else if(0===b||void 0===b)this.endPosition=!1;d.removeDataArr=g=g.concat(e.splice(b,a));h&&h.removeSumLabels&&h.removeSumLabels(b,a,this.positionIndex);d=g.length;for(b=0;b<d;b++)if(g[b]){a=g[b].config;if(a.setValue===k.maxValue||a.setValue===k.minValue)l=this.maxminFlag=!0;if(l)break}l&&
this.setMaxMin();c&&this.draw()},updateData:function(b,a,c){var d=this.config,e=d.maxValue,g=d.prevMin,k=this.chart,h=this.groupManager||this,l=k.components,f=l.xAxis||l.yAxis,m=f&&l.xAxis[0],l=f&&l.yAxis[0];this._setConfigure(b,a);this.setMaxMin();if(d.maxValue!==e||d.minValue!==g)this.maxminFlag=!0;c&&(k._setAxisLimits(),f&&m.draw(),f&&l.draw(),h.draw())},setMaxMin:function(){var b=this.components.data,a=this.config,c,d,e=b.length,g=-Infinity,k=Infinity;for(c=0;c<e;c++)b[c]&&(d=b[c].config,d=d.setValue,
void 0!==d&&(g=Ea(g,d),k=Va(k,d)));a.maxValue=g;a.minValue=k},hidingPosition:function(){var b=this.components.removeDataArr.length,a=this.config.groupMaxWidth;return!1===this.endPosition?function(c){return{x:c._xPos-a*b,y:c._yPos}}:!0===this.endPosition?function(c){return{x:c._xPos+a*b||0,y:c._yPos}}:function(){return{width:0}}},remove:function(){var b=this.components,a=b.removeDataArr,c=b.pool||(b.pool={element:[],hotElement:[],label:[]}),d=this.chart,e=d.get("config","animationObj"),g=e.duration,
k=e.dummyObj,h=e.animObj,e=e.animType,l=this.maxminFlag,f,m,q,p,n=d.components.paper,t=d.config.rotatevalues,r=this.chart.config.realTimeConfig&&this.chart.config.realTimeConfig.clear,w=this.hidingPosition(),v=function(){this.hide()};for(q=a.length-1;0<=q;q--)if(d=a[q],a.splice(q,1),d&&d.graphics){m=d.graphics;for(f in m)"label"===f&&void 0===this.startPosition&&void 0===this.endPosition&&m[f].hide(),p=w(d),"label"===f&&(p.transform=n.getSuggestiveRotation(t,p.x,p.y)),r&&m[f].hide(),m[f].animateWith(k,
h,p,g,e,v);d.graphics.element&&(c.element=c.element.concat(d.graphics.element));d.graphics.hotElement&&(c.hotElement=c.hotElement.concat(d.graphics.hotElement));d.graphics.label&&(c.label=c.label.concat(d.graphics.label))}b.pool=c;l&&this.setMaxMin()},getAxisValuePadding:function(){return{left:.5,right:.5}},manageSpace:function(){var b=this.config||(this.config={}),a=this.chart,c=a.config.rotatevalues,d=a.components.xAxis[0],g=a.components.yAxis[0],l=a.config.dataLabelStyle,k=(this.components||{}).data||
[],h=b.leftMostData||k[0],k=b.rightMostData||k[k.length-1],m,f,q={};m={};var p=0,n=0,t,r=d.getPixel(0),q=a.linkedItems.smartLabel,w={paddingLeft:0,paddingRight:0};m=0;var v=this.groupManager,v="column"===this.type&&v.getDataSetPosition(this),C=this.getAxisValuePadding(),A=b.topMostData,b=b.bottomMostData;h&&(h=h.config,t=h.showValue,f=h&&h.anchorProps||{},t&&(m=h.displayValue,q.useEllipsesOnOverflow(a.config.useEllipsesWhenOverflow),q.setStyle(l),m=q.getOriSize(m),m=c?m.height:m.width),null!==h.setValue&&
(p=e(f.radius,0)+e(f.borderThickness,0)/2,n=(m||0)/2-(d.getPixel(C.left)-r)-(v&&v.xPosOffset+v.columnWidth/2||0),0>n&&(n=0)),w.paddingLeft=Ea(p,n));k&&(h=k.config,t=h.showValue,f=h&&h.anchorProps||{},t&&!c&&(m=h.displayValue,q.setStyle(l),q=q.getOriSize(m),m=c?q.height:q.width),null!==h.setValue&&(p=e(f.radius,0)+e(f.borderThickness,0)/2,n=(m||0)/2-(d.getPixel(C.right)-r)+(v&&v.xPosOffset+v.columnWidth/2||0),0>n&&(n=0)),w.paddingRight=Ea(p,n));A&&(f=(h=A.config)&&h.anchorProps||{},null!==h.setValue&&
(p=e(f.radius,0)+e(f.borderThickness,0)/2,n=Math.max(p-(g.getPixel(h.setValue.y)-g.getPixel(g.getLimit().max)),0)),w.paddingTop=n);b&&(f=(h=b.config)&&h.anchorProps||{},null!==h.setValue&&(p=e(f.radius,0)+e(f.borderThickness,0)/2,n=Math.max(p-(g.getPixel(g.getLimit().min)-g.getPixel(h.setValue.y)),0)),w.paddingBottom=n);return w},getPlotClickFn:function(b){return function(a){ia.call(this,b,a)}},getEventArgs:function(){return{datasetName:(this.JSONData||{}).seriesname,datasetIndex:this.index,id:(this.config||
{}).userID,visible:this.visible}},rolloverResponseSetter:function(b,a){var c=a.jsonData.chart;return function(d){var e=this.data("hoverEnabled"),g=this.data("draged"),k=this.data("dataset");!0!==g&&(k._hoverFunc(b,"DataPlotRollOver",e,c),ia.call(this,a,d,"DataPlotRollOver"))}},rolloutResponseSetter:function(b,a){var c=a.jsonData.chart;return function(d){var e=this.data("hoverEnabled"),g=this.data("draged"),k=this.data("dataset");!0!==g&&(k._hoverFunc(b,"DataPlotRollOut",e,c),ia.call(this,a,d,"DataPlotRollOut"))}}},
void 0,{showvalues:void 0,includeinlegend:1,plotfillalpha:void 0,plotfillangle:void 0,ratio:void 0}]);FusionCharts.register("component",["dataset","realtimecolumn",{_realTimeConfigure:function(b){var a=this.chart,c=this.components.data,d=[],e=a.config.realTimeConfig.numDisplaySets;b=b?0:a.components.xAxis[0].getCategoryLen();b<e?(d.length=e-b,this.components.data=d.concat(c)):b>e&&this.components.data.splice(e,b-e)}},"Column"]);FusionCharts.register("component",["dataset","scrollcolumn2d",{},"Column"]);
FusionCharts.register("component",["dataset","Column3D",{draw:function(){var b=this,d=b.JSONData,g=b.chart.jsonData.chart,l=b.config,G=b.groupManager,q=b.index,k=b.chart.config.categories,h,u,f=b.chart,p=f.getJobList(),n=f.config,r=f.components.paper,v=f.components.xAxis[0],A=b.yAxis,H=f.graphics.columnGroup,D=f.config.isstacked,F,K,I=f.graphics,J=m.parseUnsafeString,L=m.getValidValue,N=n.showtooltip,M=f.get(nb,La),O=M.animType,Q=M.animObj,R=M.dummyObj,M=M.duration,S=v.getAxisPosition(0),T=v.getAxisPosition(1),
T=l.groupMaxWidth=T-S,aa=l.definedGroupPadding,Ba=n.plotspacepercent/200,ha=G.getDataSetPosition(b),S=G.stackSumValue[b.positionIndex],W=n.maxcolwidth,T=(1-.01*aa)*T||Va(T*(1-2*Ba),1*W),T=e(ha.columnWidth,T/1),ba,aa=ha.xPosOffset||0,ha=ha.height,U,Ba=b.components.data,Z,X,da,ca,W=A.getLimit();X=W.max;var V=W.min,W=A.getAxisBase(),pa=A.yBasePos=A.getAxisPosition(W),fa=0,ia=n.plotborderthickness;ca=b.graphics.container;var ma=b.graphics.dataLabelContainer,ea=b.graphics.shadowContainer,ja=I.trackerGroup,
la,oa,ga,na,ra,Aa,qa,sa,ua,I=l.use3dlighting,Ha,Ta=!0,Ja=!1,Ea=b.visible,za=(b.components.removeDataArr||[]).length,Da=b.components.pool||[],Ia=n.showplotborder,ya,Na,Qa,Oa=function(){var a,c;if(!1===b.visible&&(!1===b._conatinerHidden||void 0===b._conatinerHidden)){a=b.components.data;for(c=0;c<h;c++)a[c]&&a[c].graphics&&a[c].graphics.element&&a[c].graphics.element.attr("visibility",Ua),a[c]&&a[c].graphics&&a[c].graphics.hotElement&&a[c].graphics.hotElement.attr("visibility",Ua);ea.hide();ma&&ma.hide();
b._conatinerHidden=!0}},Wa=function(){G.drawSumValueFlag&&G.drawSumValue()};ca||(ca=b.graphics.container=f.datasetLayers=f.datasetLayers||r.group(Ma,H));ea||(ea=b.graphics.shadowContainer=r.group(Ka,H).toBack());f._cacheObj||(f._cacheObj={});!f._cacheObj.elemAttr&&(f._cacheObj.elemAttr={});ya=f._cacheObj.elemAttr;!f._cacheObj.zeroplaneAttr&&(f._cacheObj.zeroplaneAttr={});ra=f._cacheObj.zeroplaneAttr;!f._cacheObj.cubepathObj&&(f._cacheObj.cubepathObj={});Na=f._cacheObj.cubepathObj;h=v.getCategoryLen();
if(Ea)for(u=0;u<h;u++)Ba[u].graphics&&Ba[u].graphics.element&&Ba[u].graphics.element.attr("visibility",Pa),Ba[u].graphics&&Ba[u].graphics.hotElement&&Ba[u].graphics.hotElement.attr("visibility",Pa);H=ca.negative=ca.negative||r.group(Sa,ca);ga=ca.column=ca.column||r.group(ka,ca);na=ja.negative=ja.negative||r.group(Sa,ja);ja=ja.column=ja.column||r.group(ka,ja);0>V&&0<=X?(u=ca.zeroPlane,ra.fill=[n.zeroPlaneColor,!I],ra.stroke=n.zeroPlaneBorderColor||"none",ra[Hb]=n.zeroPlaneShowBorder?1:0,u?(u=[f.config.canvasLeft-
10,pa+10,f.config.canvasWidth,1,10,10,u],G.graphics.zeroplane.show(),G.graphics.zeroplane._.cubetop.show(),G.graphics.zeroplane._.cubeside.show(),Na.cubepath=u,G.graphics.zeroplane.animateWith(R,Q,Na,M,O),G.graphics.zeroplane.attr(ra)):(u=ca.zeroPlane=r.group(mb,ca).insertBefore(ga),!G.graphics&&(G.graphics={}),G.graphics.zeroplane=r.cubepath(f.config.canvasLeft-10,pa+10,f.config.canvasWidth,1,10,10,u).attr(ra))):G.graphics&&G.graphics.zeroplane&&G.graphics.zeroplane.hide()&&G.graphics.zeroplane._.cubetop.hide()&&
G.graphics.zeroplane._.cubeside.hide();(ra=H.data(Ga))||(H.data(Ga,Array(h)),ra=H.data(Ga));(Aa=ga.data(Ga))||(ga.data(Ga,Array(h)),Aa=ga.data(Ga));(qa=na.data(Ga))||(na.data(Ga,Array(h)),qa=na.data(Ga));(sa=ja.data(Ga))||(ja.data(Ga,Array(h)),sa=ja.data(Ga));for(u=0;u<h;u++)if(Z=(ca=(n=Ba[u])&&n.config)&&ca.setValue,void 0!==n&&void 0!==Z&&null!==Z){Qa=n.trackerConfig={};!n||void 0!==Z&&null!==Z||(n.graphics&&n.graphics.element&&(n.graphics.element.hide(),n.graphics.element._.cubeside.hide(),n.graphics.element._.cubetop.hide()),
n.graphics&&n.graphics.hotElement&&n.graphics.hotElement.hide());ra[u]=ra[u]||r.group(H);Aa[u]=Aa[u]||r.group(ga);qa[u]=qa[u]||r.group(na);sa[u]=sa[u]||r.group(ja);n.graphics||(Ba[u].graphics={});X=ca.setLink;V=ca.colorArr;da=ca.displayValue;F=0<=Z?ca.previousPositiveY:ca.previousNegativeY;U=L(J(c(ca.origToolText,d.plottooltext,g.plottooltext)));D&&(F=b._parseValues(u,F,S[u],U),Z=ca.value);ba=A.getAxisPosition(F||W);f=v.getAxisPosition(u)+aa;0!==ha?(K=A.getAxisPosition(Z+(F||0)),F=Ra(ba-K)):(F=0,
K=ba);K=Va(K,ba);ba=T;(Qa.isNegative=ua=0>Z)?(la=ra,oa=qa):(la=Aa,oa=sa);Qa.targetGroupTracker=oa;U=!1!==ca.toolText&&ca.toolText+(U?"":ca.toolTipValue);Qa.eventArgs={index:u,link:X,value:Z,displayValue:da,categoryLabel:k[u].label,toolText:U?U:"",id:a,datasetIndex:q,datasetName:d.seriesname,visible:Ea};M||(pa=K,fa=F);da=f;U=K;oa=ba;Ha=F;f-=10;K+=10;n.graphics.element?(Ja=!0,Z=n.graphics.element,la[u].appendChild(Z._.cubetop),la[u].appendChild(Z._.cubeside),la[u].appendChild(Z),Na.cubepath=[f,!0===
b.visible||0===ha||D?K:Z.attrs.cubepath[1],ba,!0===b.visible||0===ha||D?F:Z.attrs.cubepath[3],10,10],Z.animateWith(R,Q,Na,M,O,Ta&&Oa),ya.fill=[t(V[0]),!I],ya.ishot=!0,ya.stroke=Ia&&t(V[1]),ya[Hb]=Ia?ia:0,ya[Eb]=ca.plotBorderDashStyle,ya.cursor=X?"pointer":a,ya.visibility&&delete ya.visibility,ya.cubepath&&delete ya.cubepath,Z.attr(ya),ca.elemCreated=!1):(Da.element&&Da.element.length?(Z=n.graphics.element=Da.element.shift(),la[u].appendChild(Z._.cubetop),la[u].appendChild(Z._.cubeside),la[u].appendChild(Z),
Z.show()):Z=n.graphics.element=r.cubepath(la[u]),ya.cubepath=[f,M?pa+10:K,ba,M?0:fa,10,10],ya.fill=[t(V[0]),!I],ya.ishot=!0,ya.stroke=Ia&&t(V[1]),ya[Hb]=Ia?ia:0,ya[Eb]=ca.plotBorderDashStyle,ya.cursor=X?"pointer":a,ya.visibility=Ea?Pa:Ua,Z.attr(ya),Na.cubepath=[f,K,ba,F,10,10],Z.animateWith(R,Q,Na,M,O,Ta&&Wa),Ta=!1,n._newXPos=f,ca.elemCreated=!0);Z.shadow(ca.shadow,ea).data("BBox",{height:fa,width:ba,x:f,y:K});if(X||N)F<C&&(K-=(C-F)/2,F=C),Qa.attr={path:$a([f,K,ba,F,10,10]),cursor:X?"pointer":a,stroke:ia&&
w||va,"stroke-width":Ia?l.plotBorderThickness:0,fill:w,ishot:!0};D&&ua&&Z.toBack();n._xPos=da;n._yPos=U;n._height=Ha;n._width=oa}p.trackerDrawID.push(pb.addJob(b.drawTracker,b,[],m.priorityList.tracker));b.drawn?b.drawLabel():p.labelDrawID.push(pb.addJob(b.drawLabel,b,[],m.priorityList.label));b.drawn=!0;G.drawSumValueFlag&&Ja&&G.drawSumValueFlag&&G.drawSumValue();za&&b.remove()},drawTracker:function(){var b=this.chart,a=this.components.data,c=b.config,d=c.isstacked,c=c.plothovereffect,e=b.components,
g=e.paper,e=e.xAxis[0].getCategoryLen(),k,h,l,f,m,q,p,n,t,r=this.components.pool||[],w=function(a){ia.call(this,b,a)},v=function(a){return function(c){var f=this.getData();0!==f.showHoverEffect&&!0!==f.draged&&(a.attr(this.getData().setRolloverAttr),ia.call(this,b,c,"DataPlotRollOver"))}},C=function(a){return function(c){var f=this.getData();0!==f.showHoverEffect&&!0!==f.draged&&(a.attr(this.getData().setRolloutAttr),ia.call(this,b,c,"DataPlotRollOut"))}};for(l=0;l<e;l++)if(f=a[l],void 0!==f&&(h=
f&&f.config,k=f.trackerConfig,m=f.graphics)){m=f.graphics.element;t=k.targetGroupTracker;if(n=k.attr)f.graphics.hotElement?(p=f.graphics.hotElement,t[l].appendChild(p),p.attr(n),q=!1):(r.hotElement&&r.hotElement.length?(p=f.graphics.hotElement=r.hotElement.shift(),t[l].appendChild(p),p.show()):(p=f.graphics.hotElement=g.path(t[l]),q=!0),p.attr(n));p=f.graphics.hotElement;(p||m).data("eventArgs",k.eventArgs).data(Da,c).data(Na,h.setRolloverAttr||{}).data(ya,h.setRolloutAttr||{}).tooltip(k.eventArgs&&
k.eventArgs.toolText);(q||h.elemCreated)&&(p||m).click(w).hover(v(m),C(m));d&&k.isNegative&&p&&p.toBack()}},remove:function(){var b=this,a=b.components,c=a.removeDataArr,d=a.pool||(a.pool={element:[],hotElement:[],label:[]}),e=c.length,g=b.config.groupMaxWidth,k,h=b.maxminFlag,l,f,m;(function(){return!1===b.endPosition?function(){return{x:k._xPos-g*e}}:!0===b.endPosition?function(){return{x:k._xPos+g*e||0}}:function(){return{width:0}}})();for(m=0;m<e;m++)if(k=c[0],c.splice(0,1),k&&k.graphics){f=k.graphics;
for(l in f)f[l].hide();k.graphics.element&&(d.element=d.element.concat(k.graphics.element));k.graphics.hotElement&&(d.hotElement=d.hotElement.concat(k.graphics.hotElement));k.graphics.label&&(d.label=d.label.concat(k.graphics.label))}a.pool=d;h&&b.setMaxMin()}},"Column",{use3dlighting:void 0}]);FusionCharts.register("component",["dataset","Waterfall2D",{configure:function(){var b,d,g=this.chart,l=g.components;b=this.config;d=this.JSONData;var q=d.data,p=g.config.categories,p=Va(p&&p.length,q&&q.length),
k=g.jsonData.chart,h=l.colorManager,u,f=h.getPlotColor(this.index||this.positionIndex),n=e(d.dashed,k.plotborderdashed),r=e(k.useplotgradientcolor,1),w=e(k.showtooltip,1),v=m.parseUnsafeString,C=v(k.yaxisname),A=v(k.xaxisname),H=v(c(k.tooltipsepchar,", ")),D=m.parseTooltext,F,K,I,J,N,M,O,Q,R,S,T,ba,Ba,ha,W,V,U,Z,X,da,ca,ia,ea,fa,ga,ma,ka,ja=m.getDashStyle,la=this.components.data,oa=l.numberFormatter,ra;u={};u=u.dataObj||(u.dataObj={});ra=u.chart||(u.chart={});U=c(k.connectorthickness,1);var ya,va=
-Infinity,Aa=Infinity,qa=0,sa=0,ua=0,Ha,Ta,Ga,za;this.visible=1===e(this.JSONData.visible,!Number(this.JSONData.initiallyhidden),1);u=b.showplotborder=e(k.showplotborder,1);b.plotBorderThickness=N=u?e(k.plotborderthickness,1):0;b.isRoundEdges=M=e(k.useroundedges,0);b.plotBorderAlpha=T=u?c(k.plotborderalpha,I,aa):0;b.plotBorderColor=ba=c(k.plotbordercolor,h.getColor("plotBorderColor").split(",")[0]);b.plotgradientcolor=S=r?pa(k.plotgradientcolor,h.getColor("plotGradientColor")):a;b.plotDashLen=r=e(k.plotborderdashlen,
6);b.plotDashGap=J=e(k.plotborderdashgap,3);b.use3DLighting=e(k.use3dlighting,1);b.showSum=ya=e(k.showsumatend,1);b.plotColor=c(d.color,f);b.plotfillAngle=Q=e(360-k.plotfillangle,90);b.showShadow=M?e(k.showshadow,1):e(k.showshadow,h.getColor("showShadow"));b.showHoverEffect=O=e(k.plothovereffect,k.showhovereffect,void 0);b.plotFillAlpha=c(d.alpha,k.plotfillalpha,aa);b.plotRadius=e(k.useRoundEdges,b.isRoundEdges?1:0);b.plotFillRatio=R=c(d.ratio,k.plotfillratio);b.plotBorderDashStyle=Ba=n?ja(r,J,N):
"none";b.showValues=e(d.showvalues,k.showvalues,1);b.valuePadding=e(k.valuepadding,2);b.enableAnimation=f=e(k.animation,k.defaultanimation,1);b.animation=f?{duration:1E3*e(k.animationduration,1)}:!1;ra.transposeAnimation=b.transposeAnimation=e(k.transposeanimation,ra.transposeAnimation,f);b.transposeAnimDuration=1E3*e(k.transposeanimduration,.2);b.showTooltip=e(k.showtooltip,1);b.stack100Percent=e(g.stack100percent,k.stack100percent,0);b.definedGroupPadding=Ea(e(k.plotspacepercent),0);b.plotSpacePercent=
Ea(e(k.plotspacepercent,20)%100,0);b.maxColWidth=e(k.maxcolwidth,50);b.showPercentValues=e(k.showpercentvalues,0);b.showPercentInToolTip=e(k.showpercentintooltip,0);b.plotPaddingPercent=e(k.plotpaddingpercent);b.rotateValues=e(k.rotatevalues)?270:0;b.placeValuesInside=e(k.placevaluesinside,0);b.parentYAxis=ra="s"===c(d.parentyaxis&&d.parentyaxis.toLowerCase(),"p")?1:0;la||(la=this.components.data=[]);b.zLine=Ta={step:!0,data:[],dashStyle:"1"===k.connectordashed?ja(e(k.connectordashlen,2),e(k.connectordashgap,
2),U):"none",useForwardSteps:!0,color:L(c(k.connectorcolor,"000000"),c(k.connectoralpha,100)),lineWidth:U};for(g=0;g<p;g+=1)ha=q[g],V=oa.getCleanValue(ha.value),K=e(ha.issum,0),ha.vline||K?delete ha._value:(qa+=V,ha._value=V);Ha=oa.dataLabels(qa);ya&&(ya=!0,p+=1,Ga={label:na(k.sumlabel,"Total"),_value:qa,value:qa,issum:1,cumulative:1});for(za=g=0;g<p;g+=1)ha=q[g],U=(V=la[g])&&V.config,V||(V=la[g]={graphics:{}}),V.config||(U=la[g].config={}),!ha&&ya&&(ha=q[g]=Ga),f=c(ha.color,h.getPlotColor(g)),V.vline||
(V=ha._value,delete ha._value,U.issum=K=e(ha.issum,0),I=U.isCumulative=e(ha.cumulative,1),K?(V=I?sa:sa===ua?sa:sa-ua,U.lastComTotal=ua,ua=sa,Ta.data.push({y:null,x:za-.5})):sa+=V,va=Ea(va,sa),Aa=Va(Aa,sa),U.total=sa,K=U.showLabel=e(ha.showlabel,k.showlabels,1),K=U.dataLabel=v(K?na(ha.label,ha.name):a),0<V?(Z=c(ha.color,k.positivecolor,f),0!==O&&(X=c(ha.positivehovercolor,k.positivehovercolor,k.plotfillhovercolor,k.columnhovercolor,Z))):(Z=c(ha.color,k.negativecolor,f),0!==O&&(X=c(ha.negativehovercolor,
k.negativehovercolor,k.plotfillhovercolor,k.columnhovercolor,Z))),I=c(ha.alpha,b.plotFillAlpha),F=e(ha.dashed,n),da=e(ha.dashlen,r),ca=J=e(ha.dashgap,J),U.showValue=e(ha.showvalue,b.showValues),U.setValue=W=V,U.setLink=c(ha.link),U.toolTipValue=W=oa.dataLabels(W,ra),U.setDisplayValue=ia=Ja(v(ha.displayvalue)),U.displayValue=c(ia,W),U.plotBorderDashStyle=F=1===F?ja(da,ca,N):0===F?"none":Ba,U.colorArr=Z=m.graphics.getColumnColor(Z+","+S.replace(/,+?$/,""),I,R,Q,M,ba,T.toString(),0,!1),0!==O&&(da=c(ha.alpha,
ha.hoveralpha,d.hoveralpha,k.plotfillhoveralpha,k.columnhoveralpha,I),ca=c(ha.hovergradientcolor,d.hovergradientcolor,k.plothovergradientcolor,S),!ca&&(ca=""),W=c(ha.hoverratio,d.hoverratio,ha.ratio,k.plothoverratio,R),ia=e(360-ha.hoverangle,360-d.hoverangle,360-k.plothoverangle,Q),ea=c(ha.borderhovercolor,d.borderhovercolor,k.plotborderhovercolor,ba),fa=c(ha.borderhoveralpha,d.borderhoveralpha,k.plotborderhoveralpha,T,I),I=e(ha.borderhoverthickness,d.borderhoverthickness,k.plotborderhoverthickness,
N),ga=e(ha.borderhoverdashed,d.borderhoverdashed,k.plotborderhoverdashed),ma=e(ha.borderhoverdashgap,d.borderhoverdashgap,k.plotborderhoverdashgap,r),ka=e(ha.borderhoverdashlen,d.borderhoverdashlen,k.plotborderhoverdashlen,J),ga=ga?ja(ka,ma,I):F,1===O&&X===f&&(X=ob(X,70)),f=m.graphics.getColumnColor(X+","+ca,da,W,ia,M,ea,fa.toString(),0,!1),U.setRolloutAttr={fill:t(Z[0]),stroke:u&&t(Z[1]),"stroke-width":N,"stroke-dasharray":F},U.setRolloverAttr={fill:t(f[0]),stroke:u&&t(f[1]),"stroke-width":I,"stroke-dasharray":ga}),
F=U.toolTipValue,f=Ja(v(c(ha.tooltext,d.plottooltext,k.plottooltext))),w?void 0!==f?(I=[1,2,3,5,6,7,20,21,24,25],K={formattedValue:F,label:K,yaxisName:C,xaxisName:A,cumulativeValue:sa,cumulativeDataValue:oa.dataLabels(sa),sum:Ha,unformattedSum:qa},f=D(f,I,K,ha,k,d)):f=null===F?!1:K!==a?K+H+F:F:f=!1,Ta.data.push({y:null===V?null:sa,x:za}),za+=1,U.toolText=f,U.setTooltext=f);b.maxValue=va;b.minValue=Aa;b.connectNullData=e(k.connectnulldata,0);b.showConnectors=e(k.showconnectors,1);b=d.catData;for(g=
0;g<b.length;g+=1)d=b[g],q.splice(d.index,0,d.data);l.xAxis[0].setCategory(q);this.maxminFlag=!1},draw:function(){var b,a,c,d=this,g=d.chart,l=g.getJobList(),k=g.config.canvasBottom;c=g.graphics.datasetGroup;var h=d.JSONData,u=d.config,f=d.groupManager,q=d.positionIndex,p=d.chart.config.categories,n=h.data,r=p&&p.length,v=n&&n.length,A,n=d.visible,H=g.components,D=H.paper,F=H.xAxis[0],K=H.yAxis[0],I=d.components,J,L,N,M=g.graphics,Q=m.Raphael,R=u.showTooltip,O=F.getAxisPosition(0),O=F.getAxisPosition(1)-
O,S=u.definedGroupPadding,T=u.plotSpacePercent/200,ba=f.getDataSetPosition(d),ha=u.maxColWidth,O=(1-.01*S)*O||Va(O*(1-2*T),1*ha),O=e(ba.columnWidth,O/1),W,S=ba.xPosOffset||0,ba=ba.height,aa,U,I=I.data,Z,T=K.getAxisBase(),ha=K.yBasePos=K.getAxisPosition(T),X=0,da=u.showShadow,ca=u.plotBorderThickness,V=u.plotRadius,pa=d.graphics.container,fa=d.graphics.trackerContainer,ia=d.graphics.dataLabelContainer,ma=d.graphics.shadowContainer;Z=M.trackerGroup;var ea,ja,M=!0,la=!1,oa=d.pool||(d.pool={}),ga=function(){!1!==
d.visible||!1!==d._conatinerHidden&&void 0!==d._conatinerHidden||(pa.hide(),fa.hide(),ma.hide(),ia&&ia.hide(),d._conatinerHidden=!0)},ka=function(){d.drawLabel()},na=g.get("config","animationObj"),Aa=na.duration||0,qa=na.dummyObj,sa=na.animObj,na=na.animType,ua,H=H.canvas.config.clip["clip-canvas"].slice(0);pa||(pa=d.graphics.container=D.group("columns",c),n||pa.hide());pa.attr("clip-rect",H);fa||(fa=d.graphics.trackerContainer=D.group("col-hot",Z),n||fa.hide());ma||(ma=d.graphics.shadowContainer=
D.group("shadow",c).toBack(),n||ma.hide());u.showConnectors&&d.drawLine();u=Va(r,v);for(r=0;r<u;r++)if(ua=(v=I[r])&&(v.trackerConfig={}),a=v&&v.config,H=(c=v&&v.graphics)&&c.element,a)(A=a.setValue,J=0<=A,null===A)?H&&H.hide():(Z=a.setLink,ea=a.colorArr,v.graphics||(I[r].graphics={}),b=a.displayValue,L=J?a.previousPositiveY:a.previousNegativeY,a.issum?a.isCumulative||(L=a.lastComTotal):L=I[r-1]&&I[r-1].config.total,W=K.getAxisPosition(L||T),J=F.getAxisPosition(r)+S,0!==ba?(L=K.getAxisPosition(A+(L||
0)),aa=Ra(W-L)):(aa=0,L=W),L=Va(L,W),ab(L+aa)>=k&&(aa+=ca/2),f.isCrisp?(N=Q.crispBound(J,L,O,aa,ca),J=N.x,L=N.y,W=N.width,aa=N.height):W=O,U=a.toolText,ja=a.plotBorderDashStyle,ua.eventArgs={index:r,link:Z,value:A,displayValue:b,categoryLabel:p[r].label,toolText:U,id:"",datasetIndex:q,datasetName:h.seriesname,visible:n,setRolloutAttr:a.setRolloutAttr,setRolloverAttr:a.setRolloverAttr},Aa||(ha=L,X=aa),A={ishot:!R,fill:t(ea[0]),stroke:t(ea[1]),"stroke-width":ca,"stroke-linejoin":"miter",visibility:n},
a={x:J,y:ha,width:W,height:X||1,r:V,"stroke-dasharray":ja},v._xPos=J,v._yPos=L,v._height=aa,v._width=W,b=!1,H?(la=!0,a.y=L,a.height=aa||1,H.attr(A).animateWith(qa,sa,a,Aa,na,M&&ga)):(oa.element&&oa.element.length?H=c.element=oa.element.shift():(H=c.element=D.rect(pa),b=!0),H.show().attr(A).attr(a),Aa?(H.animateWith(qa,sa,{y:L,height:aa||1},Aa,na,M&&ka),M=!1):la=!0),H.shadow({opacity:da},ma).data("BBox",N),Z||R?(aa<C&&(L-=(C-aa)/2,aa=C),ua.attr={x:J,y:L,width:W,height:aa,r:V,cursor:Z?"pointer":"",
stroke:w,"stroke-width":ca,fill:w,ishot:!0,visibility:n}):b&&d.attachCallBack.call(H,d,g,v));l.trackerDrawID.push(pb.addJob(d.drawTracker,d,[],m.priorityList.tracker));la&&d.drawLabel()},attachCallBack:function(b,a,c){this.click(b.getPlotClickFn(a)).hover(b.rolloverResponseSetter(c,a),b.rolloutResponseSetter(c,a))},drawTracker:function(){var b,a,c=this.chart,d=this.config,e=this.components,g=e.pool,k=this.JSONData.data,k=k&&k.length,e=e.data,h=c.components,l=h.paper,f=h.xAxis[0].getCategoryLen(),
h=this.graphics.trackerContainer,m,q,p,n,t,r=this.components.removeDataArr||(this.components.removeDataArr=[]),w;p=0;for(w=Va(f,k);p<w;p++){n=!1;q=(a=e[p])&&a.config;m=a&&a.trackerConfig;f=(b=a&&a.graphics)&&b.element;t=b&&b.hotElement;b=m&&m.eventArgs;if(null===q.setValue)t&&t.hide();else if(m=m.attr)t?t.attr(m):g&&g.hotElement&&g.hotElement[0]?(t=a.graphics.hotElement=g.hotElement[0],g.hotElement.splice(0,1),t.attr(m)):(t=a.graphics.hotElement=l.rect(m,h),n=!0),t.show(),n&&this.attachCallBack.call(t||
f,this,c,a);!(a=b&&b.toolText)&&b&&(b.toolText="");b&&(t||f).tooltip(a).data("eventArgs",b).data("hoverEnabled",0!==d.showHoverEffect).data(Na,b.setRolloverAttr).data(ya,b.setRolloutAttr).data("setElem",f).data("dataset",this)}e.length>k&&r.push(e.pop());r.length&&this.remove()},drawLine:function(){var b=this.chart,a=b.components,c=b.graphics,d=this.config,g=a.paper,l,k,h=a.xAxis[0],a=a.yAxis[0],m=a.getAxisBase();l=a.getAxisPosition(m);var m=this.graphics.lineContainer,f=d.definedGroupPadding,q=d.plotSpacePercent/
200,p=h.getAxisPosition(0),p=h.getAxisPosition(1)-p,n=d.maxColWidth,f=((1-.01*f)*p||Va(p*(1-2*q),1*n))/2,t=d.zLine,d=d.connectNullData,q=t.data,p=q.length,n=this.graphics,r=t.dashStyle,w=t.color,t=t.lineWidth,v,C=n.zLine,A=null,H=[],D=[],K=b.get("config","animationObj"),b=K.duration||0,F=K.dummyObj,I=K.animObj,K=K.animType,c=c.datalabelsGroup;k=n.dataLabelContainer;k||(k=this.graphics.dataLabelContainer=g.group("datalabel",c));m||(m=n.lineContainer=g.group("line-connector",k));a.yBasePos=l;for(c=
0;c<p;c+=1)k=q[c],l=k.y,null===l?(D.length=0,0===d&&(A=null)):(k=e(k.x,c),l=a.getAxisPosition(l),k=h.getAxisPosition(k),k=za(k,t,t).position,l=za(l,t,t).position,null!==A?(D.length&&(H=H.concat(D),D.length=0),H.push("M",v,A,"m",-f,0,"H",k,"h",f,"m",0,l-A)):D.push("M",k,l),v=k,A=l);C||(C=n.zLine=g.path(m).attr({path:H,"stroke-linecap":"round","stroke-opacity":0}));C.animateWith(F,I,{path:H,"stroke-opacity":1,"stroke-dasharray":r,stroke:w,"stroke-linejoin":2<=t?"round":"miter","stroke-width":t},b,K)},
hidingPosition:function(){return function(){return{width:0}}},_hoverFunc:function(b,a,c){var d=b.graphics[Za]||b.graphics[Ia];a="DataPlotRollOver"===a?d.data(Na):d.data(ya);c&&b.graphics[Ia].attr(a)}},"Column"]);FusionCharts.register("component",["dataset","Bar2D",{type:"bar",draw:function(){var b=this,d=b.JSONData,g=b.chart.jsonData.chart,l=b.config,q=b.groupManager,p=b.index,k=d.data,h=b.chart.config.categories,u,f,n,r,v=b.chart,A=v.getJobList(),H=v.config,D=v.components.paper,K=v.components.xAxis[0],
F=v.components.yAxis[0];u=v.graphics.columnGroup;var I=v.config.isstacked,J,L,N,M=v.graphics,O=m.parseUnsafeString,S=m.getValidValue,Q=m.Raphael,R=H.showtooltip,T=K.getAxisPosition(0),aa=K.getAxisPosition(1),ba=l.groupMaxWidth=Ra(aa-T),V=l.definedGroupPadding,ha=H.plotspacepercent/200,W=q.getDataSetPosition(b),l=q.stackSumValue[b.positionIndex],pa=H.maxcolwidth,U=v.get(nb,La),v=U.animType,T=U.animObj,aa=U.dummyObj,U=U.duration,ba=(1-.01*V)*ba||Va(ba*(1-2*ha),1*pa),ba=e(W.columnWidth,ba/1),Z,V=W.xPosOffset||
0,W=W.height,X,ha=b.components.data,da,ca,ia,ea,fa,pa=F.getLimit(),ga=pa.min,pa=0<pa.max&&0>ga,ga=F.getAxisBase(),ma=F.yBasePos=F.getAxisPosition(ga),ka,ja=0,la=H.plotborderthickness,oa=la/2,na=H.useroundedges,ra=b.graphics.container,ya=b.graphics.trackerContainer,Aa=b.graphics.dataLabelContainer,qa=b.graphics.shadowContainer;r=M.trackerGroup;var sa,M=b.visible,ua=!0,Ha=!1,Ta=(b.components.removeDataArr||[]).length,va=b.components.pool||[],H=H.showplotborder,za,Ga=function(){!1!==b.visible||!1!==
b._conatinerHidden&&void 0!==b._conatinerHidden||(ra.hide(),ya.hide(),qa.hide(),Aa&&Aa.hide(),b._conatinerHidden=!0)},Ja=function(){q.drawSumValueFlag&&q.drawSumValue()};ra||(ra=b.graphics.container=D.group(Oa,u),M||ra.hide());ya||(ya=b.graphics.trackerContainer=D.group(Wa,r),M||ya.hide());qa||(qa=b.graphics.shadowContainer=D.group(Ka,u).toBack(),M||qa.hide());M&&(ra.show(),ya.show(),qa.show());u=K.getCategoryLen();for(r=0;r<u;r++)if(f=k&&k[r],n=(fa=(da=ha[r])&&da.config)&&fa.setValue,void 0!==da&&
void 0!==n&&null!==n){za=da.trackerConfig={};!da||void 0!==n&&null!==n||(da.graphics&&da.graphics.element&&da.graphics.element.hide(),da.graphics&&da.graphics.hotElement&&da.graphics.hotElement.hide());ia=fa.setLink;sa=fa.colorArr;X=0<=n;da.graphics||(ha[r].graphics={});ea=fa.displayValue;Z=X?fa.previousPositiveY:fa.previousNegativeY;ca=S(O(c(f.tooltext,d.plottooltext,g.plottooltext)));I&&(Z=b._parseValues(r,Z,l[r],ca),n=fa.value);ka=F.getAxisPosition(Z||ga);f=K.getAxisPosition(r)+V;0!==W?(L=F.getAxisPosition(n+
(Z||0)),J=Math.abs(ka-L)):(J=0,L=ka);L=Math.min(L,ka);0<J-la&&0<la&&(pa?I?(L+=oa,X||Z)?X&&(J=J-la+1,Z&&(L=L-la+1)&&(J=J+la-1)):J-=la:(L+=oa,J-=la):X&&(L-=oa));q.isCrisp?(N=Q.crispBound(f,L,ba,J,la),f=N.x,L=N.y,Z=N.width,J=N.height):Z=ba;X=!1!==fa.toolText&&fa.toolText+(ca?"":fa.toolTipValue);ca=fa.plotBorderDashStyle;za.eventArgs={index:r,link:ia,value:n,displayValue:ea,categoryLabel:h[r].label,toolText:X?X:"",id:a,datasetIndex:p,datasetName:d.seriesname,visible:M};U||(ma=L,ja=J);n={x:ma,y:f,width:ja||
1,height:Z,r:na,ishot:!R,fill:t(sa[0]),stroke:t(sa[1]),"stroke-width":H?la:0,"stroke-dasharray":ca,"stroke-linejoin":Ab,visibility:Pa};da._xPos=L;da._yPos=f;da._height=Z;da._width=J;if(da.graphics.element){Ha=!0;da=da.graphics.element;n={x:L,y:f,height:Z};if(!0===b.visible||0===W||I)n.width=J;da.animateWith(aa,T,n,U,v,ua&&Ga);da.attr({ishot:!R,fill:t(sa[0]),stroke:t(sa[1]),"stroke-width":H?la:0,"stroke-dasharray":ca,"stroke-linejoin":Ab,visibility:Pa});fa.elemCreated=!1}else va.element&&va.element.length?
(da=da.graphics.element=va.element.shift(),da.show()):da=da.graphics.element=D.rect(ra),da.attr(n),da.animateWith(aa,T,{x:L,width:J||1},U,v,ua&&Ja),fa.elemCreated=!0,ua=!1;da.shadow(fa.shadow,qa).data("BBox",N);if(ia||R)J<C&&(L-=(C-J)/2,J=C),za.attr={x:L,y:f,width:J,height:Z,r:na,cursor:ia?"pointer":a,stroke:w,"stroke-width":H?la:0,fill:w,ishot:!0,visibility:M}}A.trackerDrawID.push(pb.addJob(b.drawTracker,b,[],m.priorityList.tracker));b.drawn?b.drawLabel():A.labelDrawID.push(pb.addJob(b.drawLabel,
b,[],m.priorityList.label));b.drawn=!0;q.drawSumValueFlag&&Ha&&q.drawSumValueFlag&&q.drawSumValue();Ta&&b.remove()},drawLabel:function(){var b=this.chart,c=b.graphics,d=b.config,g=b.components.canvas.config,l=b.config.dataLabelStyle,m=this.JSONData.data,k=b.config.categories,h=b.is3D,u=b.config.isstacked,f=k&&k.length,q=m.length,k=this.components.data,p=b.components.paper,n=b.linkedItems.smartLabel,t,r,w=g.yDepth,g=g.xDepth,v=b.components.numberFormatter,C=a,A,H=d.placevaluesinside,D=d.canvasWidth,
K=d.canvasLeft,F,d=d.valuepadding+2,I,J,L,R=b.get(nb,La),b=R.duration,N=R.animType,M=R.dummyObj,R=R.animObj,O=this.graphics.dataLabelContainer,S,T,W=this.components.pool||{};L=this.visible;c=c.datalabelsGroup;O||(O=this.graphics.dataLabelContainer=p.group(wb,c),L||O.hide());L&&O.show();n.setStyle(l);c=f<q?f:q;for(f=0;f<c;f++)if(t=k[f],void 0!==t&&(q=t.graphics))if(A=m[f],I=t._yPos,L=t._xPos,r=t.config,J=v.getCleanValue(A.value),A=0>e(J),F=t._height,t=t._width,S=u?kb:A?H?cb:db:H?db:cb,C=r.displayValue,
T=q.label,r.showValue&&void 0!==C&&null!==C&&C!==a&&null!==J){r={text:C,fill:l.color,"text-bound":[l.backgroundColor,l.borderColor,l.borderThickness,l.borderPadding,l.borderRadius,l.borderDash],"line-height":l.lineHeight,visibility:Pa};C=n.getOriSize(C);C=C.width;C+=d;T=d;I+=.5*F;F=L+(A?0:t);J=A?L-K:K+D-(L+t);u?(F+=.5*(A?t:-t),F=Ea(K+.5*C,F),F=Va(K+D-.5*C,F),F-=h?g:0,I+=h?w:0):H?t>=C?(F+=A?T:-T,h&&(I+=w,F-=g)):C<J?(F+=A?-T:T,S=A?db:cb,h&&A&&(F-=g)):(A?(F=L+t+Ea(C-L-t+K,0)-T,S=db):(F=L-Ea(C-(K+D-L),
0)+T,S=cb),h&&(F-=g,I+=w)):J>=C?(F+=A?-T:T,h&&A&&(F-=g,I+=g)):(F+=A?T+C:-(T+C),h&&(F-=g,I+=w));if(F>K+D||F<K)F=K+4,S=cb;r["text-anchor"]=S;(T=q.label||W.label&&W.label.shift())?T.show().animateWith(M,R,{x:F,y:I},b,N).attr(r):(r.x=F,r.y=I,q.label=p.text(r,O))}else T&&T.hide()},remove:function(){var b=this.components,a=b.removeDataArr,c=b.pool||(b.pool={element:[],hotElement:[],label:[]}),d=a.length,e,g=this.maxminFlag,k,h,l;for(l=0;l<d;l++)if(e=a[0],a.splice(0,1),e&&e.graphics){h=e.graphics;for(k in h)h[k].hide();
e.graphics.element&&(c.element=c.element.concat(e.graphics.element));e.graphics.hotElement&&(c.hotElement=c.hotElement.concat(e.graphics.hotElement));e.graphics.label&&(c.label=c.label.concat(e.graphics.label))}b.pool=c;g&&this.setMaxMin()}},"Column"]);FusionCharts.register("component",["dataset","Bar3D",{draw:function(){var b=this,d=b.JSONData,g=b.chart.jsonData.chart,l=b.config,q=b.groupManager,p=b.index,k=d.data,h=b.chart.config.categories,u,f,n,r,v=b.chart,A=v.getJobList(),H=v.config,D=v.components.paper,
F=v.components.xAxis[0],K=v.components.yAxis[0];r=v.graphics.columnGroup;var I=H.isstacked,J,L,N=v.graphics,M=m.parseUnsafeString,O=m.getValidValue,T=H.showtooltip,Q=F.getAxisPosition(0),R=F.getAxisPosition(1),S=l.groupMaxWidth=Ra(R-Q),aa=l.definedGroupPadding,ba=H.plotspacepercent/200,V=q.getDataSetPosition(b),l=q.stackSumValue[b.positionIndex],ha=H.maxcolwidth,W=v.get(nb,La),Q=W.animType,R=W.animObj,pa=W.dummyObj,W=W.duration,S=(1-.01*aa)*S||Va(S*(1-2*ba),1*ha),S=e(V.columnWidth,S/1),U,aa=V.xPosOffset||
0,V=V.height,Z,ba=b.components.data,X,da,ca,ia,ea,ha=K.getLimit(),fa=ha.max,ga=ha.min,ha=K.getAxisBase(),ma=K.yBasePos=K.getAxisPosition(ha),na=0,ja=H.plotborderthickness,la=b.graphics.container,oa=b.graphics.dataLabelContainer,ra=b.graphics.shadowContainer,ya=N.trackerGroup,za,Aa,qa,sa,ua=H.use3dlighting,N=!0,Ha=!1,Ta=b.visible,Ja=(b.components.removeDataArr||[]).length,Ea=b.components.pool||[],Da=H.showplotborder,Ia,Na=function(){var a,c;if(!1===b.visible&&(!1===b._conatinerHidden||void 0===b._conatinerHidden)){oa&&
oa.hide();a=b.components.data;for(c=0;c<u;c++)a[c]&&a[c].graphics&&a[c].graphics.element&&a[c].graphics.element.attr("visibility",Ua),a[c]&&a[c].graphics&&a[c].graphics.hotElement&&a[c].graphics.hotElement.attr("visibility",Ua);ra.hide();b._conatinerHidden=!0}},Ma=function(){var a=b.components.data,c;for(c=0;c<u;c++)a[c]&&a[c].graphics&&a[c].graphics.element&&a[c].graphics.element.attr("fill",[t(a[c].config.colorArr[0]),!ua]);q.drawSumValueFlag&&q.drawSumValue()};la||(la=b.graphics.container=v.datasetLayers=
v.datasetLayers||D.group(Oa,r));ra||(ra=b.graphics.shadowContainer=D.group(Ka,r).toBack());u=F.getCategoryLen();if(Ta)for(r=0;r<u;r++)ba[r].graphics&&ba[r].graphics.element&&ba[r].graphics.element.attr("visibility",Pa),ba[r].graphics&&ba[r].graphics.hotElement&&ba[r].graphics.hotElement.attr("visibility",Pa);X=la.negative=la.negative||D.group(Sa,la);ca=la.column=la.column||D.group(ka,la);ea=ya.negative=ya.negative||D.group(Sa,ya);ya=ya.column=ya.column||D.group(ka,ya);0>ga&&0<=fa?(r=la.zeroPlane)?
(r=[ma-5,v.config.canvasTop+5,1,v.config.canvasHeight,5,5,r],q.graphics.zeroplane.show(),q.graphics.zeroplane._.cubetop.show(),q.graphics.zeroplane._.cubeside.show(),q.graphics.zeroplane.animateWith(pa,R,{cubepath:r},W,Q),q.graphics.zeroplane.attr({fill:[H.zeroPlaneColor,!ua],stroke:H.zeroPlaneBorderColor||"none","stroke-width":H.zeroPlaneShowBorder?1:0})):(r=la.zeroPlane=D.group(mb,la).insertBefore(ca),!q.graphics&&(q.graphics={}),q.graphics.zeroplane=D.cubepath(ma-5,v.config.canvasTop+5,1,v.config.canvasHeight,
5,5,r).attr({fill:[H.zeroPlaneColor,!ua],stroke:H.zeroPlaneBorderColor||"none","stroke-width":H.zeroPlaneShowBorder?1:0})):q.graphics&&q.graphics.zeroplane&&q.graphics.zeroplane.hide()&&q.graphics.zeroplane._.cubetop.hide()&&q.graphics.zeroplane._.cubeside.hide();(v=X.data(Ga))||(X.data(Ga,Array(u)),v=X.data(Ga));(fa=ca.data(Ga))||(ca.data(Ga,Array(u)),fa=ca.data(Ga));(la=ea.data(Ga))||(ea.data(Ga,Array(u)),la=ea.data(Ga));(ga=ya.data(Ga))||(ya.data(Ga,Array(u)),ga=ya.data(Ga));for(r=0;r<u;r+=1)v[r]=
v[r]||D.group(X),fa[r]=fa[r]||D.group(ca),la[r]=la[r]||D.group(ea),ga[r]=ga[r]||D.group(ya);r=0;for(Aa=u-1;r<u;r++,Aa--)if(f=k&&k[r],da=(ea=(X=ba[r])&&X.config)&&ea.setValue,void 0!==X&&void 0!==da&&null!==da){Ia=X.trackerConfig={};!X||void 0!==da&&null!==da||(X.graphics&&X.graphics.element&&(X.graphics.element.hide(),X.graphics.element._.cubeside.hide(),X.graphics.element._.cubetop.hide()),X.graphics&&X.graphics.hotElement&&X.graphics.hotElement.hide());ca=ea.setLink;ya=ea.colorArr;X.graphics||(ba[r].graphics=
{});ia=ea.displayValue;J=0<=da?ea.previousPositiveY:ea.previousNegativeY;Z=O(M(c(f.tooltext,d.plottooltext,g.plottooltext)));I&&(J=b._parseValues(r,J,l[r],Z),da=ea.value);U=K.getAxisPosition(J||ha);f=F.getAxisPosition(r)+aa;0!==V?(L=K.getAxisPosition(da+(J||0)),J=Math.abs(U-L)):(J=0,L=U);L=Math.min(L,U);U=S;(Ia.isNegative=qa=0>da)?(n=v,za=la):(n=fa,za=ga);Ia.targetGroupTracker=za;Z=!1!==ea.toolText&&ea.toolText+(Z?"":ea.toolTipValue);Ia.eventArgs={index:r,link:ca,value:da,displayValue:ia,categoryLabel:h[r].label,
toolText:Z?Z:"",id:a,datasetIndex:p,datasetName:d.seriesname,visible:Ta};W||(ma=L,na=J);ia=f;Z=L;za=U;sa=J;f+=5;L-=5;X.graphics.element?(Ha=!0,da=X.graphics.element,n[Aa].appendChild(da._.cubetop),n[Aa].appendChild(da._.cubeside),n[Aa].appendChild(da),n={cubepath:[L,f,!0===b.visible||0===V||I?J:da.attrs.cubepath[2],U,5,5]},da.animateWith(pa,R,n,W,Q,N&&Na),da.attr({fill:[t(ya[0]),!ua],ishot:!0,stroke:Da&&t(ya[1]),"stroke-width":Da?H.plotborderthickness:0,"stroke-dasharray":ea.plotBorderDashStyle,cursor:ca?
"pointer":a}),ea.elemCreated=!1):(Ea.element&&Ea.element.length?(da=X.graphics.element=Ea.element.shift(),n[Aa].appendChild(da._.cubetop),n[Aa].appendChild(da._.cubeside),n[Aa].appendChild(da),da.show()):da=X.graphics.element=D.cubepath(n[Aa]),da.attr({cubepath:[W?ma-5:L,f,W?0:na,U,5,5],fill:[t(ya[0]),!ua],ishot:!0,stroke:Da&&t(ya[1]),"stroke-width":Da?H.plotborderthickness:0,"stroke-dasharray":ea.plotBorderDashStyle,cursor:ca?"pointer":a,visibility:Ta?Pa:Ua}),da.animateWith(pa,R,{cubepath:[L,f,J,
U,5,5]},W,Q,N&&Ma),N=!1,X._newXPos=f,ea.elemCreated=!0);da.shadow(ea.shadow,ra).data("BBox",{height:U,width:na,x:L,y:f});if(ca||T)J<C&&(L-=(C-J)/2,J=C),Ia.attr={path:$a([L,f,J,U,5,5]),cursor:ca?"pointer":a,stroke:ja&&w||va,"stroke-width":Da?H.plotborderthickness:0,fill:w,ishot:!0};I&&!qa||da.toBack();X._xPos=Z;X._yPos=ia;X._height=za;X._width=sa}A.trackerDrawID.push(pb.addJob(b.drawTracker,b,[],m.priorityList.tracker));b.drawn?b.drawLabel():A.labelDrawID.push(pb.addJob(b.drawLabel,b,[],m.priorityList.label));
b.drawn=!0;q.drawSumValueFlag&&Ha&&q.drawSumValueFlag&&q.drawSumValue();Ja&&b.remove()},drawTracker:function(){var b=this.chart,a=this.components.data,c=b.config,d=c.isstacked,c=c.plothovereffect,e=b.components,g=e.paper,e=e.xAxis[0].getCategoryLen(),k,h,l,f,m,q,p,n,r,t,v=this.components.pool||[],w=function(a){ia.call(this,b,a)},C=function(a){return function(c){var d=this.getData();0!==d.showHoverEffect&&!0!==d.draged&&(a.attr(this.getData().setRolloverAttr),ia.call(this,b,c,"DataPlotRollOver"))}},
A=function(a){return function(c){var d=this.getData();0!==d.showHoverEffect&&!0!==d.draged&&(a.attr(this.getData().setRolloutAttr),ia.call(this,b,c,"DataPlotRollOut"))}};f=0;for(l=e-1;f<e;f++,l--)if(m=a[f],void 0!==m&&(h=m&&m.config,k=m.trackerConfig,q=m.graphics)){q=m.graphics.element;t=k.targetGroupTracker;if(r=k.attr)m.graphics.hotElement?(n=m.graphics.hotElement,t[l].appendChild(n),n.attr(r),p=!1):(v.hotElement&&v.hotElement.length?(n=m.graphics.hotElement=v.hotElement.shift(),t[l].appendChild(n),
n.show()):(n=m.graphics.hotElement=g.path(t[l]),p=!0),n.attr(r));n=m.graphics.hotElement;(n||q).data("eventArgs",k.eventArgs).data(Da,c).data(Na,h.setRolloverAttr||{}).data(ya,h.setRolloutAttr||{}).tooltip(k.eventArgs&&k.eventArgs.toolText);(p||h.elemCreated)&&(n||q).click(w).hover(C(q),A(q));(!d||k.isNegative)&&n&&n.toBack()}},remove:function(){var b=this,a=b.components,c=a.removeDataArr,d=a.pool||(a.pool={element:[],hotElement:[],label:[]}),e=c.length,g=b.config.groupMaxWidth,k,h=b.maxminFlag,l,
f,m;(function(){return!1===b.endPosition?function(){return{x:k._xPos-g*e}}:!0===b.endPosition?function(){return{x:k._xPos+g*e||0}}:function(){return{width:0}}})();for(m=0;m<e;m++)if(k=c[0],c.splice(0,1),k&&k.graphics){f=k.graphics;for(l in f)f[l].hide();k.graphics.element&&(d.element=d.element.concat(k.graphics.element));k.graphics.hotElement&&(d.hotElement=d.hotElement.concat(k.graphics.hotElement));k.graphics.label&&(d.label=d.label.concat(k.graphics.label))}a.pool=d;h&&b.setMaxMin()}},"Bar2D"]);
FusionCharts.register("component",["datasetGroup","Column",{init:function(){this.positionStackArr=[];this.stackSumValue=[];this.stackConfig=[];this.drawSumValueFlag=!0},addDataSet:function(b,a,c){var d=this.positionStackArr[a];b.groupManager=this;b.positionIndex=a;b.stackIndex=c;d||(d=this.positionStackArr[a]=[]);d[c]={dataSet:b}},removeDataSet:function(b,a,c){var d=this.positionStackArr[b];d&&d[a]&&d.splice(a,c);0===d.length&&this.positionStackArr.splice(b,1)},draw:function(){var b=this.positionStackArr,
a=b.length,c,d,e,g,k=this.chart;c=k.config.viewPortConfig.scaleX||1;d=k.graphics.columnGroup;g=k.graphics;e=k.components.canvas.config.clip["clip-canvas"].slice(0);g=g.datalabelsGroup;var h=k.get("config","animationObj"),k=h.animType,l=h.animObj,f=h.dummyObj,m=e[2],h=h.duration;e[2]*=c;d.attrs["clip-rect"]||d.attr({"clip-rect":e});g.attrs["clip-rect"]||g.attr({"clip-rect":[e[0],0,m,e[3]+e[1]]});d.animateWith(f,l,{"clip-rect":e},h,k);g.animateWith(f,l,{"clip-rect":[e[0],0,m,e[3]+e[1]]},h,k);this.preDrawCalculate();
this.drawSumValueFlag=!0;for(c=0;c<a;c++)for(d=b[c],e=d.length,this.manageClip=!0,d=0;d<e;d++)g=b[c][d].dataSet,g.draw()},getDataSetPosition:function(b){var a=this.numVisiblePositions,c=this.stackConfig[b.positionIndex||0];b=b.visible;var d;if(c){if(!b&&c.visible||0===a)d=0;return{xPosOffset:c.xPosOffset,columnWidth:c.columnWidth,height:d}}},preDrawCalculate:function(){var b=this.chart,a=b.config.transposeAxis,c=this.stackConfig,d=this.stackSumValue,g=this.positionStackArr,l=this.sumValues=[],k=this.dataLimits=
[],h=!1,m=b.config.isstacked,f=g.length,q,p,n,r,t,v,w,C,A,H,D,F,K,I,J,L,R,N=b.isBar,M=b.jsonData.chart,O=b.components.xAxis[0],S=e(N?M.overlapbars:M.overlapcolumns,b.is3D?0:1),T=O.getAxisPosition(0),W=O.getAxisPosition(1),ba=Ra(W-T),U=Ea(e(M.plotspacepercent),0),Z=e(M.plotpaddingpercent),T=Ea(e(M.plotspacepercent,20)%100,0),X=T/200,da,W=!0,ca,aa,V;for(w=this.numVisiblePositions=0;w<f;w++){C=g[w].length;L=c[w]||(c[w]={});L.visible=!1;L.previousVisibleCount=this.numVisiblePositions;aa=[];for(R=0;R<
C;R++)if(V=Infinity,r=g[w][R],ca=r.dataSet.yAxis,r&&!1!==r.dataSet.visible&&(L.visible=!0),m){v=g[w][R+1];A=R;for(h=!1;0<=A&&!h;)h=(q=g[w][--A])&&q.dataSet.visible;t=r&&r.dataSet.components.data;J=v&&v.dataSet.components.data;H=r.dataSet.components.data;D=q&&q.dataSet.components.data;H||(H=r.dataSet.components.data=[]);F=t&&t.length;for(v=0;v<F;v++){(K=H[v])||(K=H[v]={config:{}});I=D&&D[v];if(!I)for(;0<=A&&!I;)if(h=(q=g[w][--A])&&q.dataSet.visible)I=(D=q&&q.dataSet.components.data)&&D[v];K=K.config;
K.value=h=ca.getCleanValue(t[v].config.setValue);n=(I=I&&I.config)&&I.value;!aa[v]&&(aa[v]=(n||0===n)&&!0);p=(I&&I.previousPositiveY||0)+(I&&(0<n?n:0)||0);n=(I&&I.previousNegativeY||0)+(I&&(0>n?n:0)||0);K.previousPositiveY=p;K.previousNegativeY=n;V=Va(V,(n||p)+K.setValue);J&&J[v]&&J[v].config.setValue||(d[w]||(d[w]=[],d[w].parentYAxis=r.dataSet.config.parentYAxis),d[w][v]=p+(r.dataSet.visible&&Ra(h))+Ra(n),!d[w][v]&&(d[w][v]=1),l&&(l[w]||(l[w]=[]),l[w][v]=l[w][v]||{},null!==h&&(K=r.dataSet.visible,
l[w][v].visible=aa[v]||K&&!0,l[w][v].positive=p+(0<=h?K&&h:0),l[w][v].negative=n+(0>h?K&&h:0))))}v=g[w][R+1];A=R;if(!a)for(q=g[w][R-1],t=r&&r.dataSet.components.data,J=v&&v.dataSet.components.data,H=r.dataSet.components.data,D=q&&q.dataSet.components.data,F=t&&t.length,v=0;v<F;v++){K=H[v];I=D&&D[v];if(!I)for(;0<=A&&!I;)I=(D=(q=g[w][--A])&&q.dataSet.components.data)&&D[v];K=K.config;K.value=h=ca.getCleanValue(t[v].config.setValue);I=I&&I.config;V=Va(V,(n||p)+K.setValue);da=(I&&I.previousPositiveDataLimit||
0)+(I&&(0<I.value?I.value:0)||0);I=(I&&I.previousNegativeDataLimit||0)+(I&&(0>I.value?I.value:0)||0);K.previousPositiveDataLimit=da;K.previousNegativeDataLimit=I;J&&J[v]&&J[v].config.setValue||!k||(k[w]||(k[w]=[],k[w].parentYAxis=r.dataSet.config.parentYAxis),k[w][v]=k[w][v]||{},null!==h&&(k[w][v].positive=da+(0<=h?h:0),k[w][v].negative=I+(0>h?h:0)))}V&&(r.dataSet.config.minValue=V)}L.visible&&(this.numVisiblePositions+=1)}a&&(this.dataLimits=this.sumValues);a=this.numVisiblePositions;w=Ra(e(N?M.maxbarheight:
M.maxcolwidth,b.maxColWidth||50));b=(1-.01*U)*ba||Va(ba*(1-2*X),w*(a||1));N=b/2;M=0===a?b:b/a;S=Va(M-1,1<a?S||void 0!==Z?0<Z?M*Z/100:0:4:0);for(w=0;w<f;w++)c=this.stackConfig[w],Z=c.previousVisibleCount,c.xPosOffset=Z*M-N+S/2,M-=S,c.columnWidth=c.visible||0===a?M:0,M+=S;f=O.getAxisPosition(0)-N;4>O.getAxisPosition(1)-N-(f+b)&&(W=!1);"0"==T&&(W=!0);this.isCrisp=W},getMaxSumValueSpace:function(){var b=this.stackSumValue,a=this.chart,c={},d=b.length,e=a.components.numberFormatter,g,k=0,h=0,l,f,m,q=a.linkedItems.smartLabel;
l=a.config.dataLabelStyle;q.useEllipsesOnOverflow(a.config.useEllipsesWhenOverflow);q.setStyle(l);for(a=0;a<d;a++)for(l=b[a],m=l.length,f=0;f<m;f++)c=l[f],c=e.dataLabels(c),c=q.getOriSize(c),g=c.width,c=c.height,h=Ea(h,g),k=Ea(k,c);return{maxWidth:h,maxHeight:k}},drawSumValue:function(){var b=this.chart,a=b.components,c=a.paper,d=this.positionStackArr,g=this.stackConfig,l=b.linkedItems.smartLabel,k,h=b.config.rotatevalues?270:0,a=a.xAxis[0],m,f=b.config.isstacked,q,p=b.config.dataLabelStyle,n,r,t,
v,w,C,A,H,D,F,K=this.sumValuesDrawn,I,J,L,R,N=a.getPVR(),M,O=this.pool,S=!1,T=!1,W=b.get("config","animationObj"),aa=W.duration,U=W.dummyObj,Z=W.animObj,W=W.animType,X=b.config.stack100percent,da;t=e(b.jsonData.chart.showsum,b.showsum,0);var ca=1,ba=!1,V=this.sumValues,fa=b.config.canvasTop,pa=b.components.canvas.config.clip["clip-canvas"].slice(0),ma,ea=b.graphics.sumLabelsLayer;pa[1]=0;pa[3]+=fa;this.drawSumValueFlag=!1;if(f)if(t){ea.css(p);l.setStyle(p);ea.show();!this.graphics&&(this.graphics=
{});k=this.graphics.sumLabels;f=this.graphics.sumLabelContainer;k||(k=this.graphics.sumLabels=[]);f||(f=this.graphics.sumLabelContainer=[]);ba=k.length;t=V.length;if(ba>t)for(;t<ba;t++){fa=k[t].length;for(v=0;v<fa;v++)m=k[t][v]||{},(F=m.element)&&F.hide();(fa=f[t])&&fa.hide();k.pop();f.pop()}fa=d.length;for(t=0;t<fa;t++){(k=f[t])||(k=f[t]=this.graphics.sumLabelContainer[t]||c.group("sumlabels",ea));b.isRealTime&&k.attr({"clip-rect":pa});v=d[t][0].dataSet;m=v.yAxis;q=V[t];C=a.getCategoryLen();w=this.graphics.sumLabels[t]=
this.graphics.sumLabels[t]||[];D=0;g[t].visible||(T=!0);da=g[t].xPosOffset;M=g[t].columnWidth;L=a.getPixel(C-1)+da;I=v.addDataArr&&v.addDataArr.length;S=v.startPosition;J=this.removedSumLabels&&this.removedSumLabels[t]&&this.removedSumLabels[t].length;for(v=0;v<C;v++,D++)if(ba=!1,k.show(),A=q[v]||{},F=A.positive,H=A.negative,!w[D]&&(w[D]={}),void 0!==F||void 0!==H)if(r=F+H,r=m.dataLabels(r),R=Ra(H)>F?H:F,F=w[D].element,!A.visible)F&&F.hide();else if(r||""===r)A=p.backgroundColor,H=p.borderColor,ma=
l.getOriSize(r),n=this.getSumValueConfig({xValue:v,columnWidth:M,sumValue:R,xPosOffset:da,stack100percent:X,yAxis:m}),R=this.getSumValuePosition(ma,{stack100percent:X,rotateValues:h,xPos:n.xPos,yPos:n.yPos,sumValue:R}),n=R.x,r={text:r,fill:p.color,"text-bound":[A,H,p.borderThickness,p.borderPadding,p.borderRadius,p.borderDash],"line-height":p.lineHeight,visibility:Pa},R.transform=c.getSuggestiveRotation(h,n,R.y),F||(O&&O.sumLabels[t]&&O.sumLabels[t][0]?(w[D].element=F=O.sumLabels[t][0],O.sumLabels[t].shift()):
(r.x=n,r.y=R.y,r.transform=R.transform,R["text-anchor"]&&(r["text-anchor"]=R["text-anchor"]),w[D].element=F=c.text(r,k),ba=!0),K&&aa&&(A=S,A=!0===A?NaN-N*(I-t):!1===A?L+N*ca++:n,F.attr({x:A,y:R.y,transform:c.getSuggestiveRotation(h,A,R.y)}))),ba||(F.show().animateWith(U,Z,R,aa,W),F.attr(r));J&&this.removeGraphics(t);T&&(k.hide(),T=!1)}}else ea.hide();this.sumValuesDrawn=!0},getSumValueConfig:function(b){var a=this.chart,c=b.columnWidth,d=b.yAxis,e=a.config.viewPortConfig,g=e.x,k=e.scaleX,e=b.stack100percent,
h=b.sumValue,l=b.xPosOffset;b=a.components.xAxis[0].getAxisPosition(b.xValue)+l+g*k;d=d.getAxisPosition(e?100:h);return{xPos:b+.5*c,yPos:d}},getSumValuePosition:function(b,a){var c=this.chart,d=c.config,e=d.canvasBottom,g=d.canvasTop,k=c.is3D,h=a.stack100percent,l=d.yDepth,d=d.xDepth,f=a.yPos,m,q=a.xPos,p=c.components.canvas.config.canvasBorderWidth,n=a.sumValue;m=c=a.rotateValues?b.width:b.height;m=m/2+2;h?f=g<=c?m:g-m-p:(0<=n&&(g=f-g,f=g<c?f+m-g:f-m),0>n&&(f=e-f<c?f-m:f+m,k&&(q-=d,f+=l)));return{x:q,
y:f}},removeGraphics:function(b){var a=this.removedSumLabels||[],c=this.positionStackArr[b][0].dataSet,d=c.endPosition,e=c.config.rotateValues,g=this.chart,c=(g.config.realTimeConfig||{}).clear,k=g.components.paper,h=a[b]&&a[b].length||0,l=g.components.xAxis[0],f=this.pool||(this.pool={sumLabels:[]}),m=l.getPVR(),q=g.get("config","animationObj"),p,g=function(){this.hide()},l=q.dummyObj,n=q.animObj,r=q.transposeAnimDuration,t=q.animType,v;v=function(){return!1===d?function(b){var a=b.attr("x")-m*h;
b=b.attr("y");return{x:a,transform:k.getSuggestiveRotation(e,a,b)}}:function(b){var a=b.attr("x")+m*h||0;b=b.attr("y");return{x:a,transform:k.getSuggestiveRotation(e,a,b)}}}();f.sumLabels||(f.sumLabels=[]);for(q=0;q<h;q++)p=a[b][0]&&a[b][0].element,a[b].splice(0,1),p&&(void 0===d||c?p&&p.hide().attr({"text-bound":[]}):r?p.animateWith(l,n,v(p),r,t,g):(p.stop(),p.hide()),f.sumLabels[b]||(f.sumLabels[b]=[]),f.sumLabels[b]=f.sumLabels[b].concat(p))},removeSumLabels:function(b,a,c){var d=this.chart,e=
(this.graphics||{}).sumLabels||[],g;if(e.length){this.removedSumLabels||(this.removedSumLabels=[]);this.removedSumLabels[c]||(this.removedSumLabels[c]=[]);if(!this.removedSumLabels[c].length||!d.config._sumValuesUpdated||d.config._dataUpdated){for(g=b;g<b+a;g++)e[c].push({});this.removedSumLabels[c]=this.removedSumLabels[c].concat(e[c].splice(b,a))}d.config._sumValuesUpdated=!0}},getDataLimits:function(){var b=this.chart,a=this.positionStackArr,c,d,e,g,k,h=-Infinity,l=Infinity,f,m,q;c=b.config.isstacked;
var b=b.config.transposeAxis,p=-Infinity,n=Infinity;e=k=Infinity;var r;this.preDrawCalculate();g=this.dataLimits;if(c){c=0;for(m=g.length;c<m;c++)for(f=g[c].length,r=g[c].parentYAxis,d=0;d<f;d++)q=g[c][d],void 0!==q.positive&&void 0!==q.negative&&(1===r?(h=Ea(h,q.positive),l=Va(l,q.negative),e=Va(e,h)):(p=Ea(p,q.positive),n=Va(n,q.negative),k=Va(k,p)));0===n&&(n=k);0===l&&(l=e)}g=a.length;for(c=0;c<g;c++)for(d=a[c],k=d.length,d=0;d<k;d++)e=a[c][d].dataSet,!1===e.visible&&b||(e=e.config,1===e.parentYAxis?
(h=Ea(h,e.maxValue),l=Va(l,e.minValue)):(p=Ea(p,e.maxValue),n=Va(n,e.minValue)));this.maxValue=p;this.minValue=n;return{max:p,min:n,sYMax:h,sYMin:l}},manageSpace:function(){var b=this.positionStackArr,a,c,d,e,g=b.length,k={paddingLeft:-Infinity,paddingRight:-Infinity};for(a=0;a<g;a++)for(d=b[a].length,e=0;e<d;e++)c=b[a][e].dataSet,c=c.manageSpace&&c.manageSpace()||{},k.paddingLeft=Ea(c.paddingLeft,k.paddingLeft),k.paddingRight=Ea(c.paddingRight,k.paddingRight);return k}}]);FusionCharts.register("component",
["datasetGroup","realtimecolumn",{},"Column"]);FusionCharts.register("component",["datasetGroup","Waterfall2D",{},"column"]);FusionCharts.register("component",["datasetGroup","Column3d",{},"column"]);FusionCharts.register("component",["datasetGroup","bar2d",{getSumValueConfig:function(b){var a=this.chart,c=b.columnWidth,d=b.yAxis,e=a.config.viewPortConfig,g=e.x,k=e.scaleX,e=b.stack100percent,h=b.sumValue,l=b.xPosOffset;b=a.components.xAxis[0].getAxisPosition(b.xValue)+l+g*k;d=d.getAxisPosition(e?
100:h);return{xPos:d,yPos:b+.5*c}},getSumValuePosition:function(b,a){var c=this.chart,d=c.config,e=d.canvasLeft,g=d.canvasWidth,k=c.is3D,h=a.stack100percent,l=d.yDepth,d=d.xDepth,f,m={},q=a.sumValue,p=a.xPos,n=a.yPos,r=c.components.canvas.config.canvasBorderWidth,c=f=a.rotateValues?b.height:b.width,c=c/2+2;h?(p+=r,m["text-anchor"]=cb):(0<=q?(e=e+g-p,e<f?(p=p-c+e,k&&(p-=d,n+=l)):p+=c):(e=p-e,e<f?(p=p+c-e-(k?d:0),n+=k?l:0):(p-=c,k&&(p-=d,n+=l))),m["text-anchor"]=kb);m.x=p;m.y=n;return m}},"column"]);
FusionCharts.register("component",["datasetGroup","bar3d",{},"bar2d"]);FusionCharts.register("component",["datasetGroup","scrollcolumn2d",{},"column"]);FusionCharts.register("component",["datasetGroup","Area",{draw:function(){var b=this.chart,a=b.graphics,c=this.positionStackArr,d,g=c.length;d=a.areaGroup;var a=a.columnGroup,l=b.components.paper,b=e(b.jsonData.chart.areaovercolumns,1);d.area=d.area||l.group("area",d);d.areaConnector=d.areaConnector||l.group("area-connector",d);d.shadows||(d.shadows=
l.group("shadow",d).toBack());b?a&&d.insertAfter(a):d.toBack();this.preDrawCalculate();for(d=0;d<g;d++)for(b=c[d],b=b.length,a=0;a<b;a++)l=c[d][a].dataSet,l.draw();this.drawn=!0}},"column"]);FusionCharts.register("component",["datasetGroup","scrollarea2d",{},"Area"]);FusionCharts.register("component",["dataset","area",{type:"area",_parseShadowOptions:function(){var b=this.chart,a=this.config,c=b.jsonData.chart,b=e(b.defaultPlotShadow,b.components.colorManager.getColor("showShadow"));return{opacity:e(c.showshadow,
b)?a.alpha/100:0}},configure:function(){var b=this.chart,a=b.components,d=b.config,g=this.config,l=this.JSONData,q=b.jsonData.chart,k=b.singleseries,h=a.colorManager,u=e(this.index,this.stackIndex),f=e(l.showplotborder,q.showplotborder||1),u=!k||Ja(q.palettecolors)?h.getPlotColor(u):h.getColor("plotFillColor").split(/\s*\,\s*/)[0],p,r=d.isdual,t=d.haslineset;this.__setDefaultConfig();n(l,g,b.config,{data:!0});g.plotColor=u;g.parentYAxis=r?t?p=1:p="s"===c(l.parentyaxis&&l.parentyaxis.toLowerCase(),
"p")?1:0:p=0;this.yAxis=a.yAxis[p];g.valueposition=g.valueposition.toLowerCase();g.plotfillcolor=c(l.color,q.plotfillcolor,u);g.plotgradientcolor=0!==d.useplotgradientcolor?m.getDefinedColor(q.plotgradientcolor,h.getColor("plotGradientColor")):"";g.plotfillalpha=c(l.alpha,d.plotfillalpha);g.fillColor={color:g.plotfillcolor+(g.plotgradientcolor?","+g.plotgradientcolor:""),alpha:g.plotfillalpha,angle:g.plotfillangle};g.plotborderalpha=f?c(l.plotborderalpha,q.plotborderalpha,l.alpha,q.plotfillalpha,
"95"):0;g.plotbordercolor=c(l.plotbordercolor,q.plotbordercolor,q.areabordercolor,k?Ja(q.palettecolors)?h.getPlotColor(0):h.getColor("plotBorderColor").split(/\s*\,\s*/)[0]:"666666");g.plotborderdashstyle=g.dashed?m.getDashStyle(g.plotborderdashlen,g.plotborderdashgap,g.plotborderthickness):"none";g.linecolor=c(l.color,q.linecolor,g.plotColor);g.legendSymbolColor="line"===this.type?g.linecolor:g.plotfillcolor;a=m.getDashStyle(g.linedashlen,g.linedashgap,g.linethickness);g.lineDashStyle=g.dashed?a:
"none";g.shadow=this._parseShadowOptions();g.drawanchors=e(l.drawanchors,l.showanchors,q.drawanchors,q.showanchors);g.anchorbgcolor=c(l.anchorbgcolor,d.anchorbgcolor,h.getColor("anchorBgColor"));g.anchorbordercolor=c(l.anchorbordercolor,d.anchorbordercolor,g.linecolor,g.plotColor);this.components.data=this.components.data||(this.components.data=[]);this.visible=1===e(l.visible,!Number(l.initiallyhidden),1);this._setConfigure();this._realTimeConfigure&&this._realTimeConfigure();!1!==b.hasLegend&&this._addLegend()},
_setConfigure:function(b,a){var d=this.chart,g=m.parseUnsafeString,l=this.config,q=d.config,k=this.JSONData,h=d.jsonData.chart,u=b||k.data||[],f,p=d.components.xAxis[0],n=b?b.data.length:p.getCategoryLen(),r,t,v,w,C,A,H=-Infinity,D=Infinity,F=g(q.yaxisname),K=g(q.xaxisname),I=this.yAxis,J=q.tooltipsepchar,L=q.linedashed,Q;l.imageCount=0;r=this.components.data;r||(r=this.components.data=[]);for(v=0;v<n;v++)b?(d=b&&b.data[v]||{},Q=void 0!==a?a+v:r.length-n+v,f=r[Q]):(f=r[v],d=u&&u[v]||{}),t=f&&f.config,
f||(f=r[v]={}),f.config||(t=r[v].config={}),f.graphics||(f.graphics={}),C=e(Q-n,v),t.setValue=w=I.getCleanValue(d.value,l.stack100percent),t.setLink=c(d.link),t.anchorProps=this._parseAnchorProperties(C),C=p.getLabel(C),t.label=Ja(g(C.tooltext||C.label)),t.showValue=e(d.showvalue,l.showvalues),t.dashed=e(d.dashed,L),t.dashStyle=t.dashed?m.getDashStyle(l.linedashlen,l.linedashgap,l.linethickness):"none",t.color=c(d.color,l.linecolor),t.setColor=d.color,t.setAlpha=d.alpha,t.setDashed=d.dashed,t.alpha=
c(d.alpha,d.linealpha,l.linealpha),null!==w&&(H=Ea(H,w),D=Va(D,w)),t.setTooltext=g(d.toolText),t.toolTipValue=w=I.dataLabels(w),t.setDisplayValue=C=g(d.displayvalue),t.displayValue=c(C,w),t.formatedVal=C=t.toolTipValue,t.setTooltext=m.getValidValue(g(c(d.tooltext,k.plottooltext,h.plottooltext))),t.valuePosition=c(d.valueposition,l.valueposition),t.valuePosition&&(t.valuePosition=t.valuePosition.toLowerCase()),q.showtooltip?null===C?w=!1:void 0!==t.setTooltext?(w=[1,2,3,4,5,6,7],C={yaxisName:F,xaxisName:K,
formattedValue:C,label:t.label},w=m.parseTooltext(t.setTooltext,w,C,d,h,k)):(q.seriesnameintooltip&&(A=m.getFirstValue(k&&k.seriesname)),w=A?A+J:"",w+=t.label?t.label+J:""):w=!1,t.toolText=w,t.setLevelTooltext=t.setTooltext,t.setTooltext=w,t.hoverEffects=this._parseHoverEffectOptions(f,d),t.anchorProps.isAnchorHoverRadius=t.hoverEffects.anchorRadius;l.maxValue=H;l.minValue=D;this.ErrorValueConfigure&&this.ErrorValueConfigure()},init:function(b){this.JSONData=b;this.components={};this.graphics={};
this.configure()},draw:function(){var b=this,a=b.chart,d=a.jsonData,e=a.graphics,g=a.config,l=a.getJobList(),k=a.components,h=b.JSONData,u=d.chart,f=b.config,q=a.config.isstacked,n=b.groupManager.stackSumValue[0],r=b.stackIndex,v,w,H=k.paper,D=k.xAxis[0],F=b.yAxis,K,I,J,L=g.showtooltip,N,M=b.components.data,O=b.components.removeDataArr||[],Q=O.length,R,S,T,ba,aa,ha,W,V,U=e.areaGroup,Z=F.getAxisBase(),X,da,ca=f.plotbordercolor,pa=f.plotborderalpha,ea=f.plotborderdashstyle,fa=f.plotborderthickness,
ia=b.graphics.container,ma=b.graphics.trackerContainer,ga=e.trackerGroup,ja,la=m.parseUnsafeString,oa=f.fillColor,ka=a.is3D,na=function(){!1!==b.visible||!1!==b._conatinerHidden&&void 0!==b._conatinerHidden||(ia.areaGroup.hide(),Ha.hide(),ia.anchorShadowGroup.hide(),ia.anchorGroup.hide(),ma.hide(),Da&&Da.hide(),b._conatinerHidden=!0)},ra=function(){!1!==b.visible&&(ia.anchorShadowGroup.show(),ia.anchorGroup.show(),Da.show(),Ha.show());U.area.attr({"clip-rect":null});U.area.node&&U.area.node.removeAttribute("clip-path");
a._animCallBack()},Aa=f.shadow,qa,sa=b.visible,ua,Ha=b.graphics.shadowContainer,Ta,va={},Ga=e.datalabelsGroup,Da=b.graphics.dataLabelContainer,Ia=D.getPVR(),Ka,Ma=ka?10:0,La,Qa=ka?10:0,Pa=a.components.scrollBar,Oa=a.components.canvas.config.clip,Ra=p([],Oa["clip-canvas"]),Sa=p([],Oa["clip-canvas-init"]),Va=g.height,Wa=!g.drawfullareaborder,Xa=b.graphics.connector,$a=b.components.pool||(b.components.pool={}),cb=0,ab=!0!==b.drawn,db,hb,fb,ib=b.startPosition,Za={},kb={},mb=a.get("config","animationObj")||
{},gb=mb.duration,ob=mb.dummyObj,nb=mb.animObj,lb=mb.animType,vb=f.lastPath||{},wb,sb=!0,tb,jb,xb,yb,zb,Bb=a.config.viewPortConfig,Ab=Bb.x,Hb=Bb.scaleX,Pb,Eb,Sb,Jb,Tb,Vb=b.chart.config.realTimeConfig&&b.chart.config.realTimeConfig.clear,Qb=0,Ub=!ab&&gb,Mb=0,Nb;f.imagesLoaded=0;b.noOfNewDataAtEnd=0;ia||(ia=b.graphics.container={anchorShadowGroup:H.group("anchor-shadow",U.areaConnector),areaGroup:H.group("area",U.area),anchorGroup:H.group("anchors",U.areaConnector)},sa||(ia.anchorShadowGroup.hide(),
ia.areaGroup.hide(),ia.anchorGroup.hide()));Ha||(Ha=b.graphics.shadowContainer=H.group("shadows",U.shadows),sa||Ha.hide());ma||(ma=b.graphics.trackerContainer=H.group("area-hot",ga));Da||(Da=b.graphics.dataLabelContainer=b.graphics.dataLabelContainer||H.group("datalabel",Ga),sa||Da.hide());sa&&(ia.anchorShadowGroup.show(),ia.areaGroup.show(),ia.anchorGroup.show(),Ha.show(),Da.show(),ma.show(),b._conatinerHidden=!1);f.groupMaxWidth=D.getAxisPosition(1)-D.getAxisPosition(0);v=D.getCategoryLen();Ka=
Ia*v;if(Vb)for(w=0,v=O.length;w<v;w++)b._removeDataVisuals(O.shift());else b._shiftOffRemovedPoints();Za=f.removePath;a.isRealTime&&(Ra[1]=0,Ra[3]=Va,ia.areaGroup.attr({"clip-rect":Ra}),Da.attr({"clip-rect":Ra}),ia.anchorGroup.attr({"clip-rect":Ra}),ia.anchorShadowGroup.attr({"clip-rect":Ra}),Ha.attr({"clip-rect":Ra}));for(w=0;w<v;w++)N=(R=M[w])&&R.config,R&&void 0!==N.setValue&&(R.graphics||(R.graphics={}),db=D.getLabel(w).label,aa=N.setValue,ba=N.setLink,va=N.anchorProps||{},Ta=va.shadow,K=Ja(la(c(N.setLevelTooltext,
h.plottooltext,u.plottooltext))),N&&(X=0<=aa?N.previousPositiveY:N.previousNegativeY),q&&aa&&(X=b._parseValues(w,X,n[w],K),aa=N.value),T=R.graphics.element,Pb=R.graphics.image,null!==aa?(da=F.getAxisPosition(X||Z)+Qa,J=b.visible?F.getAxisPosition(aa+(X||0))+Qa:da,I=D.getAxisPosition(w)-Ma+Ab*Hb,I=za(I,fa,fa).position,J=za(J,fa,fa).position,Eb=va.symbol,Sb=va.radius,Jb=va.startAngle,tb=va.bgColor,zb=va.bgAlpha,jb=va.borderColor,yb=va.borderAlpha,xb=va.borderThickness,qa=N.hoverEffects,S=L?N.toolText+
(K?"":N.toolTipValue):"",N.finalTooltext=S,ha=N.eventArgs=N.eventArgs||{},ha.index=w,ha.link=ba,ha.value=aa,ha.displayValue=N.displayValue,ha.categoryLabel=db,ha.toolText=S,ha.id=b.userID,ha.datasetIndex=r||0,ha.datasetName=h.seriesname,ha.visible=sa,qa.enabled&&(N.setRolloverAttr={polypath:[qa.anchorSides||2,I,J,qa.anchorRadius,qa.startAngle,qa.dip],fill:t({color:qa.anchorColor,alpha:qa.anchorBgAlpha}),stroke:t({color:qa.anchorBorderColor,alpha:qa.anchorBorderAlpha}),"stroke-width":qa.anchorBorderThickness},
N.setRolloutAttr={polypath:[va.symbol[1]||2,I,J,va.radius,va.startAngle,0],fill:t({color:va.bgColor,alpha:va.bgAlpha}),stroke:t({color:va.borderColor,alpha:va.borderAlpha}),"stroke-width":va.borderThickness},V=N.setRolloverAttr,W=N.setRolloutAttr),Tb={polypath:[Eb[1]||2,I,J,Sb,Jb,0]},!T&&Ub&&!0!==ib&&(fb=v+cb,hb=D.getPixel(fb),R._baseXPos=R._xPos=hb,R._yPos=J,R._baseYPos=da,vb=this.getLinePath([R],vb),cb++),va.imageUrl?(N.anchorImageLoaded=!1,ua=new A,ua.onload=b._onAnchorImageLoad(b,w,ha,I,J,R),
ua.onerror=b._onErrorSetter(b,w),ua.src=va.imageUrl,Qb++):(Pb&&Pb.hide(),T||($a.element&&$a.element.length?T=R.graphics.element=$a.element.shift():(T=R.graphics.element=H.polypath(ia.anchorGroup),T.attr(Tb)),Ub&&T.attr({polypath:[va.symbol[1]||2,hb,J,va.radius,va.startAngle,0]})),T.show().attr({transform:""}).animateWith(ob,nb,Tb,gb,lb,sb&&na),T.attr({fill:t({color:tb,alpha:zb}),stroke:t({color:jb,alpha:yb}),"stroke-width":xb,visibility:Sb?sa:Ua}).shadow(Ta,ia.anchorShadowGroup),sb=!1,Pb&&Pb.hide(),
qa.enabled&&T&&T.data("anchorRadius",va.radius).data("anchorHoverRadius",qa.anchorRadius).data(Na,V).data(ya,W),Nb=N.trackerConfig||(N.trackerConfig={}),Nb.trackerRadius=Ea(va.radius,qa&&!q&&qa.anchorRadius||0,C)+va.borderThickness/2)):(T&&T.hide(),Pb&&Pb.hide()),R._xPos=I,R._yPos=J,R._baseXPos=I,R._baseYPos=da,Mb++);f.noOfImages=Qb;f.totalImages=Qb;0===Qb&&(l.trackerDrawID.push(pb.addJob(b.drawTracker,b,[],m.priorityList.tracker)),!0===b.drawn?b.drawLabel():l.labelDrawID.push(pb.addJob(b.drawLabel,
b,[],m.priorityList.label)));kb=this.getLinePath(M,{});Q&&a.isRealTime?(Za=this.getLinePath(M,Za),wb=Za.getPathArr()):wb=kb.getPathArr();f.lastPath=kb;Pa&&(La=Pa.conf.startPercent,Ra[2]=Ka+Sa[0],1===La&&(Sa[0]=Ra[2],Ra[0]=0));Ra[3]+=Qa;(ja=b.graphics.lineElement)?gb&&a.isRealTime&&ja.attr({path:vb.getPathArr()}):(ja=b.graphics.lineElement=H.path(ia.areaGroup),ja.attr({path:kb.getPathArr()}),gb&&sa&&(ia.anchorGroup.hide(),ia.anchorShadowGroup.hide(),Ha.hide(),Da.hide(),U.area.attr({"clip-rect":Sa}).animate({"clip-rect":Ra},
gb,lb,ra)));Vb?ja.hide():ja.show().animateWith(ob,nb,{path:wb},gb,lb,sb&&na);sb=!1;ja.attr({stroke:t({color:ca,alpha:pa}),"stroke-width":Wa?0:fa,fill:t(oa),"stroke-linecap":"round","stroke-linejoin":2<fa?"round":"miter","stroke-dasharray":ea}).shadow(Aa,Ha);Wa?(Xa=b.graphics.connector,Xa||(Xa=b.graphics.connector=H.path({path:kb.pathArr,stroke:t({color:ca,alpha:pa}),"stroke-width":fa,"stroke-linecap":"round","stroke-linejoin":2<fa?"round":"miter","stroke-dasharray":ea},ia.areaGroup)),Xa.show().animateWith(ob,
nb,{path:kb.pathArr},gb,lb)):Xa&&Xa.hide();b.drawn=!0},drawTracker:function(){var b=this.chart,a=this.components.data,c,d,e,g,k,h,l=this.components.pool||[],f,m=this.graphics.trackerContainer,q,p,n=b.components.paper,t=a.length,r,v;for(v=0;v<t;v++)if(c=a[v])d=c.config,e=d.trackerConfig,void 0!==e&&(r=e.trackerRadius||0,e=d.hoverEffects,g=c._xPos,k=c._yPos,h=d.setLink,f=d.finalTooltext,q=d.eventArgs,p=d.groupId,d=d.setValue,k={cx:g,cy:k,r:r,cursor:h?"pointer":"",stroke:w,fill:w,ishot:!0,visibility:Pa},
g=c.graphics.hotElement||l.hotElement&&l.hotElement.shift(),null!==d?(g?g.show().attr(k):(g=c.graphics.hotElement=n.circle(k,m),g.click(this.getPlotClickFn(b)).hover(this.rolloverResponseSetter(c,b),this.rolloutResponseSetter(c,b))),g.data("eventArgs",q).data("groupId",p).data("hoverEnabled",e.enabled).data("dataset",this).tooltip(f)):g&&g.hide())},getPathArr:function(){var b=this.pathArr,a=this.path2Arr;return b.length||a.length?b.concat(a):[]},_getPathString:function(b){var a=b.length,c="",d;for(d=
0;d<a;d+=1)c+=" "+b[d];return c},getLinePath:function(b,a,c){var d=this.chart.config.connectnulldata,e=a||{};a=e.lastValidValue||!1;var g=e.temp||[],k=e.temp2||[],h=e.pathArr||[],l=e.path2Arr||[],f,m,q,p,n=b.length,e=e.pointsJoined||0,t,r,n=c&&c.end||n;for(c=c&&c.begin||0;c<n;c++)if(t=b[c])f=t.config,r=f.setValue,void 0!==r&&(f=t._xPos,m=t._yPos,q=t._baseXPos,p=t._baseYPos,null===r?d||(0<e&&("Z"!==l[l.length-1]&&void 0!==p&&l.push("Z"),h=h.concat(l),l=[]),g=[],k=[],a=!1):a?(g.length&&(h=h.concat(g),
void 0!==q&&(l=k,k=[]),g=[],e++),h.push(f,",",m),void 0!==p&&l.unshift(f,",",p)):(g.push("M",f,",",m,"L"),void 0!==p&&k.push(q,",",p),e=0,a=!0));"Z"!==l[l.length-1]&&0<e&&void 0!==p&&l.push("Z");return{pathArr:h,path2Arr:l,lastValidValue:a,pointsJoined:e,temp:g,temp2:k,getPathArr:this.getPathArr}},_shiftOffRemovedPoints:function(){var b=this,a=b.chart,c=b.config,d=b.components.removeDataArr,e,g=a.components.xAxis[0].getPVR();e=a.get("config","animationObj");var a=e.duration,k=b.drawn&&a,h=e.dummyObj,
l=e.animObj,f=e.animType,m,q,p,n,t,r={},v,w,C=b.components.removeElementsArr=b.components.removeElementsArr||(b.components.removeElementsArr=[]),A=c.hideAnimFlag=!1,H=function(){var a=b.components.removeElementsArr,c=a.length,d;for(d=0;d<c;d++)b._removeDataVisuals(a.shift())},D,F;if(d){e=d.length;for(v=0;v<e;v++){if(F=d[0])if(C.push(F),k){m=F.config.setValue;q=F._xPos;if(void 0==q){d.splice(0,1);continue}p=F.graphics.element;n=F.graphics.label;t=F.graphics.image;w=F.graphics.connector;null!==m&&(m=
e*g,D="T,"+-m+",0",F._xPos=q-m,q=F._xPos,F._baseXPos=q,p&&p.animateWith(h,l,{transform:D},a,f,!A&&H),c.hideAnimFlag=!0,n&&n.animateWith(h,l,{transform:D},a,f),t&&t.animateWith(h,l,{transform:D},a,f),w&&w.hide());r=b.getLinePath([F],r)}else H();d.splice(0,1)}c.removePath=r}},_removeDataVisuals:function(b){var a=this.components.pool||(this.components.pool={}),c,d,e;if(b)for(c in d=b.graphics,d)b=a[c]||(a[c]=[]),e=d[c],e.hide&&"function"===typeof e.hide&&(e.attr({"text-bound":[]}),e.hide(),e.shadow&&
e.shadow(!1)),b.push(d[c])},_parseAnchorProperties:function(b,a){var d=this.config,g=this.type,l="area"===(!this.chart.config.anchoralpha&&g)?0:1,q=this.JSONData,k=this.chart.jsonData.chart,h=(a||q.data||[])[b]||{},g={},u=m.graphics.mapSymbolName,f,p;f=void 0!==c(h.anchorstartangle,q.anchorstartangle,k.anchorstartangle,h.anchorimagealpha,q.anchorimagealpha,k.anchorimagealpha,h.anchorimagescale,q.anchorimagescale,k.anchorimagescale,h.anchorimagepadding,q.anchorimagepadding,k.anchorimagepadding,h.anchorimageurl,
q.anchorimageurl,k.anchorimageurl,h.anchorradius,q.anchorradius,k.anchorradius,h.anchorbgcolor,q.anchorbgcolor,k.anchorbgcolor,h.anchorbordercolor,q.anchorbordercolor,k.anchorbordercolor,h.anchoralpha,q.anchoralpha,k.anchoralpha,h.anchorsides,q.anchorsides,k.anchorsides,h.anchorborderthickness,q.anchorborderthickness,k.anchorborderthickness,void 0);p=e(h.drawanchors,d.drawanchors);g.enabled=f?e(p,f):e(p,l);g.startAngle=e(h.anchorstartangle,d.anchorstartangle);g.imageAlpha=e(h.anchorimagealpha,d.anchorimagealpha);
g.imageScale=e(h.anchorimagescale,d.anchorimagescale);g.imagePadding=e(h.anchorimagepadding,d.anchorimagepadding);0>g.imagePadding&&(g.imagePadding=0);g.imageUrl=c(h.anchorimageurl,d.anchorimageurl);g.imageUrl&&d.imageCount++;g.radius=e(h.anchorradius,d.anchorradius);g.isAnchorRadius=c(h.anchorradius,q.anchorradius,k.anchorradius);g.bgColor=c(h.anchorbgcolor,d.anchorbgcolor);l=g.enabled?ba(c(h.anchoralpha,d.anchoralpha,g.enabled?aa:"0")):0;g.anchorAlpha=l;g.bgAlpha=ba(c(h.anchorbgalpha,d.anchorbgalpha,
l))*l/100;g.imageAlpha=g.imageAlpha*l/100;g.borderColor=c(h.anchorbordercolor,d.anchorbordercolor);g.borderAlpha=l;g.sides=c(h.anchorsides,d.anchorsides);g.borderThickness=c(h.anchorborderthickness,d.anchorborderthickness);g.symbol=u(g.sides).split("_");d=e(h.anchorshadow,d.anchorshadow)&&1<=g.radius;g.shadow={opacity:d?l/100:0};return g},_onErrorSetter:function(b){return function(){var a=b.config,c=b.chart.getJobList();a.imagesLoaded++;a.imagesLoaded===a.imageCount&&(!0===b.drawn?b.drawTracker():
c.trackerDrawID.push(pb.addJob(b.drawTracker,b,[],m.priorityList.tracker)),!0===b.drawn?b.drawLabel():c.labelDrawID.push(pb.addJob(b.drawLabel,b,[],m.priorityList.label)))}},_onAnchorImageLoad:function(b,a,c,d,e,g){return function(){var c=b.chart,h=c.getJobList(),l=b.config,f=c.config,q=c.components.paper,B=b.components.data,n=void 0!==g?g:B[a],r=n.config,v=n.graphics,w=r.anchorProps,C=b.graphics.container,A=C.anchorGroup,H=C.anchorShadowGroup,D=c.get("config","animationObj"),C=D.dummyObj,F=D.animObj,
K=D.animType,D=D.duration,I=w.imageUrl,L=c.components.xAxis[0],N=B.length,B=r.hoverEffects,c=w.imageScale,Q=w.imageAlpha,R=B.imageHoverAlpha,M=B.imageHoverScale,O=this.height*c*.01,T=this.width*c*.01,S=this.width*M*.01,aa=this.height*M*.01,W=f.showtooltip,ba=b.startPosition,U=b.noOfNewDataAtEnd,Z=b.allImagesDrawn&&D,X=r.setLink,da,ca,V,pa,fa,ia,ma,ea,ja,la,oa,f=b.config.animFlag,ga=l.noOfImages,ka=l.noOfImagesDrawn=l.noOfImagesDrawn||(l.noOfImagesDrawn=0),na=b.components.pool||{};r.isRemoving||(ka=
r.trackerConfig||(r.trackerConfig={}),J?(fa={x:d-this.width*c*.005,y:e-this.height*c*.005,width:T,height:O,alpha:Q},ea={x:d-this.width*M*.005,y:e-this.height*M*.005,width:S,height:this.height*M*.01,alpha:R},(R=v.element)&&"image"!==R.type&&(R.remove(),R=v.element=null),R||(v.element=R=q.image(I,A)),R.css({opacity:.01*Q}).data("alwaysInvisible",!c).data("setRolloverProperties",B).data(Na,ea).data(ya,fa).data("imgRef",this).data("anchorRadius",c).data("anchorHoverRadius",M),R.animateWith(C,F,fa,D,K),
ka.trackerRadius=Va(T,O)/2):(da=w.symbol[1],ia=B.isAnchorHoverRadius,ca=w.isAnchorRadius,ca=w.radius=ca?w.radius:Va(T,O)/2,V=w.shadow,fa=w.imagePadding,B.radius=ia?B.anchorRadius:ca+1,pa=B.radius-fa-.5*B.anchorBorderThickness,ia=ca-fa-.5*w.borderThickness,ea={},oa=[da||2,d,e,ca,w.startAngle,void 0],w.markerRadius=ca,la={fill:t({color:w.bgColor,alpha:w.bgAlpha}),"stroke-width":w.borderThickness,stroke:t({color:w.borderColor,alpha:w.borderAlpha})},fa=p({polypath:oa},la),B&&(ea={polypath:[B.anchorSides||
2,d,e,B.radius,B.startAngle,B.dip],fill:t({color:B.anchorColor,alpha:B.anchorBgAlpha}),"stroke-width":B.anchorBorderThickness,stroke:t({color:B.anchorBorderColor,alpha:B.anchorBorderAlpha})},ma=Ea(B.anchorAlpha,B.anchorBorderAlpha),R>ma&&(R=ma)),w.bgAlpha&&w.borderAlpha&&(ma=Ea(w.bgAlpha,w.borderAlpha),Q>ma&&(Q=ma)),ma=v.element,oa={polypath:fa.polypath},ma||(na.element&&na.element.length?ma=v.element=na.element.shift():(ma=v.element=q.polypath(A),ma.attr(oa)),Z&&!0!==ba&&(ja=L.getPixel(N+U),b.noOfNewDataAtEnd+=
1,L=[da||2,ja,e,ca,w.startAngle,void 0],ma.attr({transform:"",polypath:L}))),ma&&ma.attr({transform:""}),ma.show().animateWith(C,F,oa,D,K,f&&void 0).attr(la),f=b.config.animFlag=!1,ma.attr({fill:t({color:w.bgColor,alpha:w.bgAlpha}),ishot:!W,"stroke-width":w.borderThickness,stroke:t({color:w.borderColor,alpha:w.borderAlpha}),cursor:X?"pointer":"",visibility:ca?Pa:Ua}).data("alwaysInvisible",!ca).data("setRolloverProperties",B).data(Na,ea).data(ya,fa).data("anchorRadius",ca).data("anchorHoverRadius",
B&&B.radius).shadow(V,H),H=q.polypath(da||2,d,e,0<ia?ia:0,w.startAngle,void 0,A).attr({visibility:Ua}),fa=b._getPathString(H.attrs.path),H.remove(),H=q.polypath(da||2,d,e,0<pa?pa:0,B.startAngle,B.dip,A).attr({visibility:Ua}),L=b._getPathString(H.attrs.path),H.remove(),w.imgRefWidth=this.width,w.imgRefHeight=this.height,w.imgRefScale=c,w.rolloutClipRadius=ia,fa={x:d-this.width*c*.005,y:e-this.height*c*.005,width:T,height:O,alpha:Q,"clip-path":fa},ea={x:d-this.width*M*.005,y:e-this.height*M*.005,width:S,
height:aa,alpha:R,"clip-path":L},R=v.image,R||(na.image&&na.image.length?(R=v.image=na.image.shift(),R.show()):v.image=R=q.image(I,A),Z&&(H=q.polypath(da||2,ja,e,0<ia?ia:0,w.startAngle,void 0).attr({visibility:Ua}),q=b._getPathString(H.attrs.path),H.remove(),ja={x:ja-this.width*c*.005,y:e-this.height*c*.005,width:T,height:O,alpha:Q,"clip-path":q},R.attr({transform:""}).attr(ja))),R.attr({src:I}),R.attr({visibility:ca?Pa:Ua}).css({opacity:.01*Q}).data("alwaysInvisible",!c).data("setRolloverProperties",
B).data(Na,ea).data(ya,fa).data("anchorRadius",c).data("imgRef",this).data("anchorHoverRadius",M),R.attr({transform:""}).animateWith(C,F,{x:fa.x,y:fa.y,width:fa.width,height:fa.height,"clip-path":fa["clip-path"]},D,K,f&&void 0),R.attr({alpha:fa.alpha}),ca=Ea(ca,B&&B.anchorRadius||0,2),ka.trackerRadius=ca+(w.borderThickness||0)/2),n._xPos=d,n._yPos=e,l.imagesLoaded++,r.anchorImageLoaded=!0,l.imagesLoaded===l.imageCount&&(!0===b.drawn?b.drawTracker():h.trackerDrawID.push(pb.addJob(b.drawTracker,b,[],
m.priorityList.tracker)),!0===b.drawn?b.drawLabel():h.labelDrawID.push(pb.addJob(b.drawLabel,b,[],m.priorityList.label))),ka=l.noOfImagesDrawn+=1,ka===ga&&(b.allImagesDrawn=!0))}},_hideGraphics:function(b){var a,c;for(c in b)b.hasOwnProperty(c)&&(a=b[c])&&(a.hide?a.hide():this._hideGraphics(a))},getPlotClickFn:function(b){return function(a){ia.call(this,b,a)}},show:function(){var b=this.chart,a=b.components.xAxis[0],c=this.yAxis;b._chartAnimation();this.visible=!0;this._conatinerHidden=!1;b.config.transposeAxis&&
(b._setAxisLimits(),c.draw());b.isRealTime&&a.draw();b._drawDataset()},hide:function(){var b=this.chart,a=this.yAxis,c=b.components.xAxis[0];b._chartAnimation();this.visible=!1;b.config.transposeAxis&&(b._setAxisLimits(),a.draw());b.isRealTime&&c.draw();b._drawDataset()},_parseHoverEffectOptions:function(b,a){var d=this.JSONData,g=this.chart,l=g.jsonData.chart,g=g.config,m=b.config.anchorProps||{},k=g.plothovereffect,h=this.config.drawanchors,q={enabled:!1};a=a||{};0!==k&&0!==h&&(q.enabled=void 0!==
c(a.hovercolor,a.anchorhovercolor,a.hovercolor,d.hovercolor,a.anchorbghovercolor,d.anchorbghovercolor,l.anchorbghovercolor,d.anchorhovercolor,l.anchorhovercolor,a.hoveralpha,a.anchorhoveralpha,d.anchorhoveralpha,l.anchorhoveralpha,a.bghoveralpha,a.anchorbghoveralpha,d.anchorbghoveralpha,l.anchorbghoveralpha,a.anchorborderhovercolor,a.borderhovercolor,d.anchorborderhovercolor,l.anchorborderhovercolor,a.anchorborderhoverthickness,a.borderhoverthickness,d.anchorborderhoverthickness,l.anchorborderhoverthickness,
a.anchorborderhoveralpha,a.borderhoveralpha,d.anchorborderhoveralpha,l.anchorborderhoveralpha,a.hoverdip,a.anchorhoverdip,d.anchorhoverdip,l.anchorhoverdip,a.anchorhoverstartangle,d.anchorhoverstartangle,l.anchorhoverstartangle,a.hoversides,a.anchorhoversides,d.anchorhoversides,l.anchorhoversides,a.hoverradius,a.anchorhoverradius,d.anchorhoverradius,l.anchorhoverradius,d.plotfillhovercolor,l.plotfillhovercolor,g.plothovereffect,void 0),q.startAngle=e(a.anchorhoverstartangle,d.anchorhoverstartangle,
l.anchorhoverstartangle,m.startAngle),q.anchorSides=e(a.hoversides,a.anchorhoversides,d.anchorhoversides,l.anchorhoversides,m.sides),q.anchorRadius=e(a.anchorhoverradius,d.anchorhoverradius,l.anchorhoverradius),q.isAnchorHoverRadius=q.anchorRadius,q.anchorRadius=e(q.anchorRadius,m.radius+(k?2:0)),q.anchorScale=c(a.hoverscale,d.anchorscale,l.anchorscale),q.imageHoverScale=e(a.anchorimagehoverScale,d.anchorimagehoverscale,l.anchorimagehoverscale,110),q.imageHoverAlpha=e(a.anchorimagehoveralpha,d.anchorimaghoverealpha,
l.anchorimagehoveralpha),q.anchorAlpha=c(a.anchorhoveralpha,a.hoveralpha,d.anchorhoveralpha,l.anchorhoveralpha,m.anchorAlpha),q.anchorColor=ib(c(a.hovercolor,a.anchorhovercolor,a.hoverColor,a.anchorbghovercolor,d.anchorbghovercolor,d.anchorhovercolor,d.hovercolor,l.anchorbghovercolor,l.anchorhovercolor,l.plotfillhovercolor,m.bgColor)),q.anchorBgAlpha=c(a.bghoveralpha,a.anchorbghoveralpha,d.anchorbghoveralpha,l.anchorbghoveralpha,l.plotfillhoveralpha,m.bgAlpha),q.anchorBgAlpha=q.anchorBgAlpha*q.anchorAlpha/
100,q.anchorBorderColor=c(a.borderhovercolor,a.anchorborderhovercolor,d.anchorborderhovercolor,l.anchorborderhovercolor,m.borderColor),q.anchorBorderAlpha=c(a.borderhoveralpha,a.anchorborderhoveralpha,d.anchorborderhoveralpha,l.anchorborderhoveralpha,q.anchorAlpha,m.borderAlpha),q.anchorBorderThickness=e(a.borderhoverthickness,a.anchorborderhoverthickness,d.anchorborderhoverthickness,l.anchorborderhoverthickness,l.anchorBorderThickness,m.borderThickness),q.dip=c(a.hoverdip,a.anchorhoverdip,d.anchorhoverdip,
l.anchorhoverdip,m.dip),q.anchorAnimation=e(a.anchorhoveranimation,d.anchorhoveranimation,l.anchorhoveranimation,1));return q},_hoverPlotAnchor:function(b,a){var c=b.graphics.element,d=b.graphics.label,e=b.config||{},e=e&&e.anchorProps.imageUrl,g=J&&e?b.graphics.element:b.graphics.image,k=c.data(Na),h=c.data(ya),l="DataPlotRollOver"===a?c.data(Na):c.data(ya),e="image"===c.type,f=c.data("anchorRadius"),m=c.data("anchorHoverRadius"),q=d&&(d.data("isBelow")?1:-1)*(e?.5*(k.height-h.height):m-f),p=b.config.hoverEffects,
n,t={polypath:l.polypath},l={fill:l.fill,"stroke-width":l["stroke-width"],stroke:l.stroke},r=d&&d.data("rotation")||"",q={transform:"T0,"+("DataPlotRollOver"===a?q:0)+r},k=!(/,0\)$/.test(k.fill)&&/,0\)$/.test(h.fill))&&c.data("anchorHoverRadius")-c.data("anchorRadius")&&p.anchorAnimation&&50;g&&(n=g.data(Na),h=g.data(ya),n="DataPlotRollOver"==a?n:h);if("DataPlotRollOver"==a&&0!==m||"DataPlotRollOut"==a&&0!==f)c.attr({visibility:Pa}),g&&g.attr({visibility:Pa});g&&g.css({opacity:.01*n.alpha});e?c.css({opacity:.01*
t.alpha}):c.attr(l);c.stop();c.animate(t,k,"easeOut",function(){("DataPlotRollOver"==a&&!m||"DataPlotRollOut"==a&&!f)&&c.attr({visibility:Ua})});g&&g.animate(n,k,"easeOut",function(){("DataPlotRollOver"==a&&!m||"DataPlotRollOut"==a&&!f)&&g.attr({visibility:Ua})});d&&d.stop();k&&d&&d.animate(q,k,"easeOut")},drawLabel:function(b){var c=this.chart,d=c.config,e=c.linkedItems.smartLabel,g=c.config.dataLabelStyle,l=this.components.data,k=c.components.paper,h=c.get("config","animationObj"),m=h.duration,
f=!0===this.drawn&&m,q=d.stack100percent,p=h.dummyObj,n=h.animObj,t="",h=h.animType,r=d.rotatevalues?270:0,w=d.canvasTop,v=d.canvasHeight,C=c.config.isstacked,A,H=this.graphics.dataLabelContainer,D=c.components.xAxis[0],F=0,K=D.getCategoryLen(),I=this.startPosition,J=this.components.pool||{},L,N,M,O,T,S,aa,W,ba,U,Z;void 0!==b?(Z=b,U=Z+1):(Z=0,U=l.length);for(e.setStyle({"font-weight":g.fontWeight,"font-style":g.fontStyle,"font-family":g.fontFamily,"font-size":g.fontSize,"line-height":g.lineHeight});Z<
U;Z++)if(L=(b=(O=l[Z])&&O.config)&&b.setValue,O&&void 0!==L){T=b.anchorProps;L=O.graphics;M=O._yPos;O=O._xPos;T=L.element?L.image&&.5*L.element.attr("height")||T.radius-3:0;A=d.valuepadding+2+T;T=b.valuePosition;switch(T){case "above":S=0;break;case "below":S=1;break;default:T=l[Z-1]&&l[Z-1].config||{},W=l[Z+1]&&l[Z+1].config||{},C&&q?(T=T.value,ba=W.value,W=b.value):(T=T.setValue,ba=W.setValue,W=b.setValue),S=Z?T>W?1:(null==ba&&ba)>W?1:0:0}t=b.displayValue;ba=b.showValue;T=L.label;void 0!==t&&null!==
t&&t!==a&&null!==W&&ba?(ba={text:t,fill:g.color,"text-bound":[g.backgroundColor,g.borderColor,g.borderThickness,g.borderPadding,g.borderRadius,g.borderDash]},t=e.getOriSize(t),r?(b._state={labelWidth:t.height,labelHeight:t.width},b._rotated=!0):(b._state={labelWidth:t.width,labelHeight:t.height},b._rotated=!1),t=N=b._state.labelHeight,t+=A,A=.5*N+A,N=M-w,aa=w+v-M,t+=4,S?aa>t?(M+=A,b._valueBelowPoint=1):N>t&&(M-=A,b._valueBelowPoint=0):N>t?(M-=A,b._valueBelowPoint=0):aa>t&&(M+=A,b._valueBelowPoint=
1),A=S=!1,T||(J.label&&J.label.length?(L.label=T=J.label.shift(),L.label.show()):(ba.x=O,ba.y=M,ba.transform=k.getSuggestiveRotation(r,O,M),L.label=T=k.text(ba,H),A=!0),f&&c.isRealTime&&!0!==I&&(L=K+F,L=D.getPixel(L),L instanceof Object&&(L=L.x),T.attr({x:L,y:M,transform:k.getSuggestiveRotation(r,L,M)}),F++,S=!0)),A||T.attr(ba),A&&!S||T.show().animateWith(p,n,{x:O,y:M,transform:k.getSuggestiveRotation(r,O,M)},m,h),T.data("isBelow",b._valueBelowPoint),T.data("rotation",k.getSuggestiveRotation(r,O,
M))):T&&T.hide()}},getAxisValuePadding:function(){var b=(this.chart||{}).hasScroll;return{left:b?.5:0,right:b?.5:0}},hidingPosition:function(){return function(){return{polypath:[[2,0,0,0,0,0]],text:""}}},_hoverFunc:function(b,a,c,d){if(c)return this._hoverPlotAnchor(b,a,d)}},"column",{valueposition:void 0,plotborderdashlen:void 0,plotborderdashgap:void 0,plotborderdashstyle:void 0,plotborderthickness:void 0,linethickness:void 0,linedashlen:void 0,linedashgap:void 0,dashed:void 0,linedashstyle:void 0,
linecolor:void 0,linealpha:void 0,anchorbgcolor:void 0,anchorbordercolor:void 0,anchorradius:void 0,anchoralpha:void 0,anchorimageurl:void 0,anchorsides:void 0,anchorbgalpha:void 0,anchorborderthickness:void 0,anchorshadow:void 0,anchorstartangle:void 0,anchorimagealpha:void 0,anchorimagescale:void 0,anchorimagepadding:void 0,alpha:void 0,parentyaxis:void 0}]);FusionCharts.register("component",["dataset","scrollarea2d",{},"area"]);FusionCharts.register("component",["dataset","realtimearea",{_realTimeConfigure:FusionCharts.get("component",
["dataset","realtimecolumn"]).prototype._realTimeConfigure},"area"]);FusionCharts.register("component",["datasetGroup","realtimearea",{},"area"]);FusionCharts.register("component",["datasetGroup","radar",{},"area"]);FusionCharts.register("component",["dataset","radar",{type:"radar",configure:function(){var b=this.config,a=this.chart,d=a.jsonData.chart,e=this.JSONData,a=a.components.colorManager.getPlotColor(this.index);this.__base__.configure.call(this);b.plotfillcolor=c(e.color,d.plotfillcolor,a);
b.plotbordercolor=c(e.plotbordercolor,d.plotbordercolor,d.areabordercolor,a).split(",")[0];b.fillColor.color=b.plotfillcolor;b.legendSymbolColor=b.plotfillcolor},_addLegend:function(){var b=this.chart,a=b.jsonData.chart,c,d;d=this.config;var b=b.components.legend,g=d.legendSymbolColor;c=e(a.use3dlighting,a.useplotgradientcolor,1);a=ob(g,60).replace(ra,V);c?(c=ob(g,40),c={FCcolor:{color:g+","+g+","+c+","+g+","+g,ratio:"0,70,30",angle:270,alpha:"100,100,100,100,100"}}):c={FCcolor:{color:g,angle:0,ratio:"0",
alpha:"100"}};d={enabled:d.includeInLegend,type:this.type,fillColor:t(c),strokeColor:t(a),rawFillColor:g,label:na(this.JSONData.seriesname)};this.legendItemId=b.addItems(this,this.legendInteractivity,d)},draw:function(){var b=this,a=b.chart,d=a.getJobList(),e=a.graphics,g=a.config,l=a.components,k=b.JSONData,h=a.jsonData.chart,q=b.config,f=b.index,p=k.data||[],n,r,w,v=l.paper,H=l.xAxis[0],D=b.yAxis,F,K,I,J=g.showtooltip,L,N=b.components.data,M,O,Q,R,T,S,ba=D.getAxisBase(),aa,l=q.plotbordercolor,V=
q.plotborderalpha,W=q.plotBorderDashStyle,pa=q.plotborderthickness,U=b.graphics.container,Z=b.graphics.trackerContainer,X=e.trackerGroup,da=[],ca,ia=m.parseUnsafeString,ea=!1,fa=q.fillColor,ga=a.is3D,ma=e.areaGroup,ka=a.get("config","animationObj"),ja=ka.duration,la=ka.dummyObj,oa=ka.animObj,ka=ka.animType,na=function(){!1===b.visible&&(U.areaGroup.hide(),sa.hide(),U.lineShadowGroup.hide(),U.anchorShadowGroup.hide(),U.anchorGroup.hide(),Z.hide(),Ta&&Ta.hide(),b._conatinerHidden=!0)},ra=function(){U.areaGroup.attr({"clip-rect":null});
!1!==b.visible&&(U.lineShadowGroup.show(),U.anchorShadowGroup.show(),U.anchorGroup.show(),Ta.show());a._animCallBack()},va=q.shadow,Aa,qa=b.visible,sa=U&&U.shadowContainer,ua,Ha={},Ha=e.datalabelsGroup,Ta=b.graphics.dataLabelContainer,za=ga?10:0,e=b.components.removeDataArr||[],ga=e.length,Da=b.components.pool||{},Ga=!0,Ia=0,Ka,Ma,La=0;q.imagesLoaded=0;U||(U=b.graphics.container={lineShadowGroup:v.group("connector-shadow",ma.areaConnector),anchorShadowGroup:v.group("anchor-shadow",ma.areaConnector),
areaGroup:v.group("area",ma.area),anchorGroup:v.group("anchors",ma.areaConnector)},qa||(U.lineShadowGroup.hide(),U.anchorShadowGroup.hide(),U.areaGroup.hide(),U.anchorGroup.hide()));sa||(sa=b.graphics.shadowContainer=ma.shadows||(ma.shadows=v.group("shadows",U.areaGroup).toBack()),qa||sa.hide());Z||(Z=b.graphics.trackerContainer=v.group("area-hot"),qa||Z.hide());N||(N=b.components.data);X&&X.appendChild(Z);Ta||(Ta=b.graphics.dataLabelContainer=b.graphics.dataLabelContainer||v.group("datalabel",Ha),
qa||Ta.hide());qa&&(U.lineShadowGroup.show(),U.anchorShadowGroup.show(),U.areaGroup.show(),U.anchorGroup.show(),Ta.show(),Z.show());n=H.getCategoryLen();X=H.config.centerX;ca=H.config.centerY;for(w=0;w<n;w++)r=p[w]||{},L=(M=N[w])&&M.config,Ka=H.getLabel(w).label,R=L.setValue,Q=L.setLink,Ha=L.anchorProps,ua=Ha.shadow,F=Ja(ia(c(r.tooltext,k.plottooltext,h.plottooltext))),M.graphics||(M.graphics={}),L&&(aa=0<=R?L.previousPositiveY:L.previousNegativeY),K=M.graphics,r=K.element,Ma=K.image,null===R?(!1!==
ea?da.push("L",X,",",ca):da.push("M",X,",",ca),ea=!1,r&&r.hide()):(K=D.getAxisPosition(aa||ba)+za,I=b.visible?D.getAxisPosition(R+(aa||0))+za:K,K=H.getAxisPosition(w,g.canvasTop+g.canvasHeight/2-I),I=K.y,K=K.x,Aa=L.hoverEffects,O=J?L.toolText+(F?"":L.toolTipValue):"",L.finalTooltext=O,F=L.eventArgs||(L.eventArgs={}),F.index=w,F.link=Q,F.value=R,F.displayValue=L.displayValue,F.categoryLabel=Ka,F.toolText=O,F.id=b.userID,F.datasetIndex=f||0,F.datasetName=k.seriesname,F.visible=qa,Aa.enabled&&(L.setRolloverAttr=
{polypath:[Aa.anchorSides||2,K,I,Aa.anchorRadius,Aa.startAngle,Aa.dip],fill:t({color:Aa.anchorColor,alpha:Aa.anchorBgAlpha}),stroke:t({color:Aa.anchorBorderColor,alpha:Aa.anchorBorderAlpha}),"stroke-width":Aa.anchorBorderThickness},L.setRolloutAttr={polypath:[Ha.symbol[1]||2,K,I,Ha.radius,Ha.startAngle,0],fill:t({color:Ha.bgColor,alpha:Ha.bgAlpha}),stroke:t({color:Ha.borderColor,alpha:Ha.borderAlpha}),"stroke-width":Ha.borderThickness},S=L.setRolloverAttr,T=L.setRolloutAttr),Ha.imageUrl?(L.anchorImageLoaded=
!1,L=new A,L.onload=b._onAnchorImageLoad(b,w,F,K,I),L.onerror=b._onErrorSetter(b,w),L.src=Ha.imageUrl,La++):(Ma&&Ma.hide(),r||(Da.element&&Da.element.length?r=M.graphics.element=Da.element.shift():(r=M.graphics.element=v.polypath(U.anchorGroup),r.attr({polypath:[Ha.symbol[1]||2,K,I,Ha.radius,Ha.startAngle,0]}))),r.show().animateWith(la,oa,{polypath:[Ha.symbol[1]||2,K,I,Ha.radius,Ha.startAngle,0]},ja,ka,Ga&&na),Ga=!1,r.attr({fill:t({color:Ha.bgColor,alpha:Ha.bgAlpha}),stroke:t({color:Ha.borderColor,
alpha:Ha.borderAlpha}),"stroke-width":Ha.borderThickness,visibility:Ha.radius?qa:Ua}).shadow(ua,U.anchorShadowGroup).data("anchorRadius",Ha.radius).data("anchorHoverRadius",Aa.anchorRadius).data(Na,S).data(ya,T),Aa.enabled&&r&&r.data("anchorRadius",Ha.radius).data("anchorHoverRadius",Aa.anchorRadius).data(Na,S).data(ya,T),L.trackerConfig||(L.trackerConfig={}),L.trackerConfig.trackerRadius=Ea(Ha.radius,Aa&&!0&&Aa.anchorRadius||0,C)+(Ha.borderThickness||0)/2),M._xPos=K,M._yPos=I,ea?(da.push("L",K,",",
I),Ia++):(0===w?da.push("M",K,",",I):da.push("L",K,",",I),ea=!0));da.push("Z");q.noOfImages=q.totalImages=La;0===La&&(d.trackerDrawID.push(pb.addJob(b.drawTracker,b,[],m.priorityList.tracker)),d.labelDrawID.push(pb.addJob(b.drawLabel,b,[],m.priorityList.label)));g=da.concat([]);d=b.graphics.lineElement;d||(d=b.graphics.lineElement=v.path(U.areaGroup),d.attr({path:da}),ja&&qa&&(U.anchorGroup.hide(),U.anchorShadowGroup.hide(),Ta.hide(),ma.scale(.01,.01,X,ca).animateWith(la,oa,{transform:"s1,1"},ja,
ka,ra)));d.show().animateWith(la,oa,{path:g},ja,ka,Ga&&na).attr({stroke:t({color:l,alpha:V}),"stroke-width":pa,fill:t(fa),"stroke-linecap":"round","stroke-linejoin":2<pa?"round":"miter","stroke-dasharray":W}).shadow(va,sa);b.drawn=!0;for(w=0;w<ga;w++)b._removeDataVisuals(e.shift())}},"area"]);FusionCharts.register("component",["dataset","Line",{type:"line",_addLegend:function(){var b=this.config,a=this.chart.components.legend,d=e(b.drawanchors,1),b={enabled:b.includeinlegend,type:this.type,drawLine:c(b.drawLine,
!0),fillColor:t({color:b.anchorbgcolor,alpha:b.anchorbgalpha}),strokeColor:t({color:b.anchorbordercolor,alpha:"100"}),rawFillColor:b.anchorbgcolor,rawStrokeColor:b.anchorbordercolor,anchorSide:d?b.anchorsides:0,strokeWidth:b.anchorborderthickness,label:na(this.JSONData.seriesname),lineWidth:b.linethickness};this.legendItemId=a.addItems(this,this.legendInteractivity,b)},draw:function(){var b,a,d=this,e=d.JSONData,g=d.chart,l=g.getJobList(),k=g.components,h=k.canvas.config.clip,q=d.config,f=d.index,
p=g.config,n=d.components,r=d.graphics,w=n.data,v=w.length,H=k.paper,F=k.xAxis[0],K=d.yAxis,I=n.removeDataArr||[],L=g.graphics,J=L.datalabelsGroup,M,N,O,T=q.linethickness,Q=r.container,R=r.trackerContainer,S=L.trackerGroup,ba=p.showtooltip,aa=L.lineGroup,V,ha=q.shadow,W,pa=r.dataLabelContainer,U={},Z,X,da,ca=g.is3D,ia=p.use3dlineshift,ea=d.graphics.errorGroupContainer,fa=d.graphics.errorTrackerContainer,ga=d.graphics.errorShadowContainer,ma=function(){!1!==d.visible||!1!==d._conatinerHidden&&void 0!==
d._conatinerHidden||(Q.lineGroup.hide(),Q.lineShadowGroup.hide(),Q.anchorShadowGroup.hide(),Q.anchorGroup.hide(),R.hide(),pa&&pa.hide(),ea&&ea.hide(),fa&&fa.hide(),ga&&ga.hide(),d._conatinerHidden=!0)},ka=function(){aa.lineConnector.attr({"clip-rect":null});aa.lineConnector.node&&aa.lineConnector.node.removeAttribute("clip-path");!1!==d.visible&&(Q.lineShadowGroup.show(),Q.anchorShadowGroup.show(),Q.anchorGroup.show(),R.show(),pa&&pa.show())},ja=!0,la,oa,na,ra=K.getAxisBase(),va=K.yBasePos=K.getAxisPosition(ra),
Aa=F.getPVR(),qa,sa=ca?10:0,ua=ca&&ia?10:0,Ha=h["clip-canvas"].slice(0),Ta=h["clip-canvas-init"].slice(0),Da=k.scrollBar,Ga=g.hasScroll||!1,Ja,Ia=q.lineDashStyle,Ka={color:q.linecolor,alpha:q.alpha},Ma=[t(Ka),Ia].join(":"),La,Ra,Qa,Pa,Oa,Sa=r.lineElement,Va=d.visible,Wa,Xa,$a=0,cb=!0!==d.drawn,ab=d.components.pool||(d.components.pool={}),db,hb,kb=d.startPosition,fb={},gb=v,Za,ib={},mb=q.lastPath||{},ob,lb,nb=0,sb=g.config.viewPortConfig,vb=sb.x,wb=sb.scaleX,tb,jb,xb,yb,zb,Bb,Ab,Hb,Eb,Jb,Sb,Ob,Tb,
Vb,Qb,Ub,Mb,Nb,cc=q.noOfImages=0,dc,Wb=g.get("config","animationObj"),Lb=Wb.duration,Xb=Wb.dummyObj,Yb=Wb.animObj,Zb=Wb.animType,gc=!cb&&Lb,hc,lc=p.height,ic=p.realTimeConfig&&p.realTimeConfig.clear,mc=gb;d.noOfNewDataAtEnd=0;q.hideAnimFlag=!1;q.imagesLoaded=0;aa.lineConnector=aa.lineConnector||H.group("line-connector",aa);Q||(Q=d.graphics.container={lineShadowGroup:H.group("connector-shadow",aa.lineConnector),anchorShadowGroup:H.group("anchor-shadow",aa.lineConnector),lineGroup:H.group("line",aa.lineConnector),
anchorGroup:H.group("anchors",aa.lineConnector)},Va||(Q.lineShadowGroup.hide(),Q.anchorShadowGroup.hide(),Q.lineGroup.hide(),Q.anchorGroup.hide()));R||(R=d.graphics.trackerContainer=H.group("line-hot",S),Va||R.hide());w||(w=d.components.data=[]);pa||(pa=d.graphics.dataLabelContainer=d.graphics.dataLabelContainer||H.group("datalabel",J),Va||pa.hide());Va&&(Q.lineShadowGroup&&Q.lineShadowGroup.show(),Q.lineGroup&&Q.lineGroup.show(),Q.anchorGroup&&Q.anchorGroup.show(),R&&R.show(),d._conatinerHidden=
!1,pa.show());qa=Aa*gb;g.isRealTime&&(Ha[1]=0,Ha[3]=lc,pa.attr({"clip-rect":Ha}),Q.anchorGroup.attr({"clip-rect":Ha}),Q.anchorShadowGroup.attr({"clip-rect":Ha}),Q.lineGroup.attr({"clip-rect":Ha}),Q.lineShadowGroup.attr({"clip-rect":Ha}));if(ic)for(Za=0,gb=I.length;Za<gb;Za++)d._removeDataVisuals(I.shift());else d._shiftOffRemovedPoints();fb=q.removePath||{};Ub=Q.anchorShadowGroup;for(Za=0;Za<mc;Za++)if(M=w[Za])da=M.config||{},Bb=da.setValue,void 0!==Bb&&(yb=M.graphics,zb=da.setLink,Wa=da.x||Za,la=
da.setLevelTooltext,U=da.anchorProps,X=U.symbol,Eb=U.radius,W=U.shadow,Jb=U.startAngle,Sb=U.bgColor,Ob=U.bgAlpha,Tb=U.borderColor,Vb=U.borderAlpha,Qb=U.borderThickness,Hb=da.displayValue,Xa=da.dip||0,M||(M=w[Za]={graphics:{}}),b=da.setColor,a=da.setAlpha,na=da.dashStyle,Pa=da.xPos||F.getAxisPosition(Wa)-sa+vb*wb,Oa=!d.visible&&Lb?va:K.getAxisPosition(Bb)+ua,Pa=za(Pa,q.linethickness,q.linethickness).position,Oa=za(Oa,q.linethickness,q.linethickness).position,V=da.hoverEffects,U.isAnchorHoverRadius=
V.anchorRadius,ob=F.getLabel(Za)||{},tb=ba?da.toolText+(la?"":da.toolTipValue):"",da.finalTooltext=tb,Ab=da.eventArgs=da.eventArgs||{},Ab.index=Za,Ab.link=zb,Ab.value=Bb,Ab.displayValue=Hb,Ab.categoryLabel=ob.label,Ab.toolText=tb,Ab.id=q.userID,Ab.datasetIndex=f||0,Ab.datasetName=e.seriesname,Ab.visible=Va,jb=M.graphics.element,Nb=M.graphics.image,xb=M.graphics.hotElement,dc={polypath:[X[1]||2,Pa,Oa,Eb,Jb,da.dip||0]},null!==Bb?(!jb&&gc&&!0!==kb&&(hb=gb+$a,db=F.getPixel(hb),M._xPos=db,M._yPos=Oa,mb=
d.getLinePath([M],mb),$a++),U.imageUrl?(Z=new A,da.anchorImageLoaded=!1,Z.onload=d._onAnchorImageLoad(d,Za,Ab,Pa,Oa,M),Z.onerror=d._onErrorSetter(d,Za),Z.src=U.imageUrl,cc++):(Nb&&Nb.hide(),jb||(ab.element&&ab.element.length?(jb=yb.element=ab.element.shift(),jb.show()):(jb=yb.element=H.polypath(Q.anchorGroup),jb.attr(dc)),gc&&jb.attr({polypath:[X[1]||2,db,Oa,Eb,Jb,0]})),jb.show().attr({transform:""}).animateWith(Xb,Yb,dc,Lb,Zb,ja&&ma),Lb||ja&&ma(),ja=!1,jb.attr({fill:t({color:Sb,alpha:Ob}),stroke:t({color:Tb,
alpha:Vb}),"stroke-width":Qb,visibility:Eb?Va:Ua}).shadow(W,Ub).data("anchorRadius",Eb).data("anchorHoverRadius",V.anchorRadius),V.enabled&&(O={polypath:[V.anchorSides||2,Pa,Oa,V.anchorRadius,V.startAngle,V.dip],fill:t({color:V.anchorColor,alpha:V.anchorBgAlpha}),stroke:t({color:V.anchorBorderColor,alpha:V.anchorBorderAlpha}),"stroke-width":V.anchorBorderThickness},N={polypath:[U.sides,Pa,Oa,U.radius,U.startAngle,Xa],fill:t({color:U.bgColor,alpha:U.bgAlpha}),stroke:t({color:U.borderColor,alpha:U.borderAlpha}),
"stroke-width":U.borderThickness},jb&&jb.data("anchorRadius",U.radius).data("anchorHoverRadius",V.anchorRadius).data(Na,O).data(ya,N)),da.trackerConfig||(da.trackerConfig={}),da.trackerConfig.trackerRadius=Ea(Eb,V&&V.anchorRadius||0,C)+(U.borderThickness||0)/2)):(jb&&jb.hide(),Nb&&Nb.hide(),xb&&xb.hide()),M._xPos=Pa,M._yPos=Oa,Qa=Ma!==[t({color:c(b,Ka.color),alpha:c(a,Ka.alpha)}),na||Ia].join(":"),oa=M.graphics.connector,lb=[],Qa&&(Mb=Za,ib=d.getLinePath(w,{},{begin:nb,end:Mb+1}),da.connStartIndex=
nb,da.connEndIndex=Mb,lb=ib.getPathArr(),lb.length&&(hc=D.animation({path:lb},Lb,Zb,ja&&ma),oa||(ab.connector&&ab.connector.length?oa=M.graphics.connector=ab.connector.shift():(oa=M.graphics.connector=H.path(Q.lineGroup),oa.attr({path:lb}))),oa.show().animateWith(Xb,Yb,hc),oa.attr({"stroke-dasharray":Ra,"stroke-width":T,stroke:La,"stroke-linecap":"round","stroke-linejoin":2<T?"round":"miter"}).shadow(ha,Q.lineShadowGroup),nb=Za,ib={}),Mb=null),Qa||lb.length||oa&&oa.hide(),null!==Bb&&(La=t({color:c(b,
Ka.color),alpha:c(a,Ka.alpha)}),Ra=na||Ia),Ma=[La,Ra].join(":"));0===cc&&(!0===d.drawn?d.drawTracker():l.trackerDrawID.push(pb.addJob(d.drawTracker,d,[],m.priorityList.tracker)),!0===d.drawn?d.drawLabel():l.labelDrawID.push(pb.addJob(d.drawLabel,d,[],m.priorityList.label)));q.pathStartIndex=nb;q.pathEndIndex=Mb;q.noOfImages=q.totalImages=cc;ib=d.getLinePath(w,{},{begin:nb,end:Mb});I&&g.isRealTime&&(fb=d.getLinePath(w,fb));g.isRealTime&&(q.lastPath=ib);Sa?Lb&&g.isRealTime&&Sa.attr({path:mb.getPathArr()}):
Sa=r.lineElement=H.path({path:ib.getPathArr()},Q.lineGroup);ic?Sa.hide():Sa.show().animateWith(Xb,Yb,{path:fb.getPathArr&&g.isRealTime?fb.getPathArr():ib.getPathArr()},Lb,Zb,ja&&ma);Sa.attr({"stroke-width":T,"stroke-dasharray":Ra,stroke:La,"stroke-linecap":"round","stroke-linejoin":2<=T?"round":"miter"}).shadow(ha,Q.lineShadowGroup);Ga&&(Ja=Da.conf.startPercent,Ha[2]=qa+Ta[0],1===Ja&&(Ta[0]=Ha[2],Ha[0]=0));Ha[3]+=ua;d._drawTracker&&d._drawTracker();Lb&&Va&&!d.drawn&&(Q.anchorGroup.hide(),Q.anchorShadowGroup.hide(),
pa.hide(),aa.lineConnector.attr({"clip-rect":Ta}).animateWith(Xb,Yb,{"clip-rect":Ha},Lb,Zb,ka));d.drawn=!0;d.drawErrorValue&&d.drawErrorValue()},getDataLimits:function(){var b=this.config,a=b.maxValue,b=b.minValue,c=this.chart.config.transposeAxis;!1===this.visible&&c&&(a=-Infinity,b=Infinity);return{max:a,min:b}},pointValueWatcher:function(b,a,c){var d=c.obj||(c.obj={}),e=c.objX||(c.objX={});null!==a&&(d.max=d.max>a?d.max:a,d.min=d.min<a?d.min:a);null!==b&&(e.max=e.max>b?e.max:b,e.min=e.min<b?e.min:
b);c.isRegression&&(b=b||0,a=a||0,c.sumX+=b,c.sumY+=a,c.sumXY+=b*a,c.sumXsqure+=yb(b,2),c.xValues.push(b),c.sumYsqure+=yb(a,2),c.yValues.push(a))}},"area"]);FusionCharts.register("component",["dataset","Realtimeline",{_realTimeConfigure:FusionCharts.get("component",["dataset","realtimecolumn"]).prototype._realTimeConfigure},"line"]);FusionCharts.register("component",["quadrant","cartesian",{pIndex:1,init:function(){var b=this.chart.components,a=b.xAxis[0];this.yAxis=b.yAxis[0];this.xAxis=a;this.components=
{};this.conf={};this.graphics={};this.configure()},configure:function(){var b,a,d,g,l,m,k,h,p,f,n=this.conf;p=this.chart;m=p.config;var t=p.jsonData.chart;a=p.components.canvas.config;var r=m.dataLabelStyle;b=p.linkedItems.smartLabel;if(n.enabled=e(t.drawquadrant,0))p=e(t.quadrantxval),f=e(t.quadrantyval),h=L(c(t.quadrantlinecolor,a.canvasBorderColor),c(t.quadrantlinealpha,t.quadrantlinealpha,aa)),a=e(t.quadrantlinethickness,a.canvasBorderThickness),g=e(t.quadrantlinedashed,t.quadrantlineisdashed,
0),d=e(t.quadrantlinedashlen,4),l=e(t.quadrantlinedashgap,2),d=g?I(d,l,a):"none",n.xVal=p,n.yVal=f,n.quadrantLineColor=h,n.quadrantLineThickness=a,n.dashStyle=d,a=Ja(t.quadrantlabeltl,""),h=Ja(t.quadrantlabeltr,""),p=Ja(t.quadrantlabelbl,""),f=Ja(t.quadrantlabelbr,""),n.quadrantLabelPadding=e(t.quadrantlabelpadding,3),b.useEllipsesOnOverflow(m.useEllipsesWhenOverflow),b.setStyle(r),""!==a&&(b=na(t.quadrantlabeltlbordercolor,t.quadrantlabelbordercolor,""),g=c(t.quadrantlabeltlbgcolor,t.quadrantlabelbgcolor),
m=e(t.quadrantlabeltlborderthickness,t.quadrantlabelborderthickness,1),b=b?L(b,e(t.quadrantlabeltlborderalpha,t.quadrantlabelborderalpha,t.quadrantlabeltlalpha,t.quadrantlabelalpha,100)):"",k=n.tlConfig,k||(k=n.tlConfig={enabled:!0,styleObj:{}}),k.label=a,k.styleObj.fontSize=c(e(t.quadrantlabeltlfontsize,t.quadrantlabelfontsize),parseInt(r.fontSize,10))+"px",k.styleObj.lineHeight=r.lineHeight,k.styleObj.fontFamily=c(t.quadrantlabeltlfont,t.quadrantlabelfont,r.fontFamily),k.styleObj.color=L(c(t.quadrantlabeltlfontcolor,
t.quadrantlabelfontcolor,r.color),e(t.quadrantlabeltlfontalpha,t.quadrantlabelfontalpha,100)),k.styleObj.fontWeight=e(t.quadrantlabeltlfontbold,t.quadrantlabelfontbold)?"bold":"normal",k.styleObj.fontStyle=e(t.quadrantlabeltlfontitalic,t.quadrantlabelfontitalic)?"italic":"normal",q(k.styleObj),a=e(t.quadrantlabeltlborderpadding,t.quadrantlabelborderpadding,2),d=e(t.quadrantlabeltlborderradius,t.quadrantlabelborderradius,0),g=g?L(g,e(t.quadrantlabeltlbgalpha,t.quadrantlabelbgalpha,t.quadrantlabeltlalpha,
t.quadrantlabelalpha,100)):"",l=e(t.quadrantlabeltlborderdashed,t.quadrantlabelborderdashed,0)?I(e(t.quadrantlabeltlborderdashlen,t.quadrantlabelborderdashlen,4),e(t.quadrantlabeltlborderdashgap,t.quadrantlabelborderdashgap,2),m):"none",k["text-bound"]=[g,b,m,a,d,l]),""!==h&&(b=na(t.quadrantlabeltrbordercolor,t.quadrantlabelbordercolor,""),g=c(t.quadrantlabeltrbgcolor,t.quadrantlabelbgcolor),m=e(t.quadrantlabeltrborderthickness,t.quadrantlabelborderthickness,1),b=b?L(b,e(t.quadrantlabeltrborderalpha,
t.quadrantlabelborderalpha,t.quadrantlabeltralpha,t.quadrantlabelalpha,100)):"",h=n.trConfig,h||(h=n.trConfig={enabled:!0,styleObj:{}}),h.label=Ja(t.quadrantlabeltr,""),h.styleObj.fontSize=c(e(t.quadrantlabeltrfontsize,t.quadrantlabelfontsize),parseInt(r.fontSize,10))+"px",h.styleObj.lineHeight=r.lineHeight,h.styleObj.fontFamily=c(t.quadrantlabeltrfont,t.quadrantlabelfont,r.fontFamily),h.styleObj.color=L(c(t.quadrantlabeltrfontcolor,t.quadrantlabelfontcolor,r.color),e(t.quadrantlabeltrfontalpha,t.quadrantrabelfontalpha,
100)),h.styleObj.fontWeight=e(t.quadrantlabeltrfontbold,t.quadrantlabelfontbold)?"bold":"normal",h.styleObj.fontStyle=e(t.quadrantlabeltrfontitalic,t.quadrantlabelfontitalic)?"italic":"normal",q(h.styleObj),a=e(t.quadrantlabeltrborderpadding,t.quadrantlabelborderpadding,2),d=e(t.quadrantlabeltrborderradius,t.quadrantlabelborderradius,0),g=g?L(g,e(t.quadrantlabeltrbgalpha,t.quadrantlabelbgalpha,t.quadrantlabeltralpha,t.quadrantlabelalpha,100)):"",l=e(t.quadrantlabeltrborderdashed,t.quadrantlabelborderdashed,
0)?I(e(t.quadrantlabeltrborderdashlen,t.quadrantlabelborderdashlen,4),e(t.quadrantlabeltrborderdashgap,t.quadrantlabelborderdashgap,2),m):"none",h["text-bound"]=[g,b,m,a,d,l]),""!==p&&(b=na(t.quadrantlabelblbordercolor,t.quadrantlabelbordercolor,""),g=c(t.quadrantlabelblbgcolor,t.quadrantlabelbgcolor),m=e(t.quadrantlabelblborderthickness,t.quadrantlabelborderthickness,1),b=b?L(b,e(t.quadrantlabelblborderalpha,t.quadrantlabelborderalpha,t.quadrantlabelblalpha,t.quadrantlabelalpha,100)):"",h=n.blConfig,
h||(h=n.blConfig={enabled:!0,styleObj:{}}),h.label=p,h.styleObj.fontSize=c(e(t.quadrantlabelblfontsize,t.quadrantlabelfontsize),parseInt(r.fontSize,10))+"px",h.styleObj.lineHeight=r.lineHeight,h.styleObj.fontFamily=c(t.quadrantlabelblfont,t.quadrantlabelfont,r.fontFamily),h.styleObj.color=L(c(t.quadrantlabelblfontcolor,t.quadrantlabelfontcolor,r.color),e(t.quadrantlabelblfontalpha,t.quadrantlabelfontalpha,100)),h.styleObj.fontWeight=e(t.quadrantlabelblfontbold,t.quadrantlabelfontbold)?"bold":"normal",
h.styleObj.fontStyle=e(t.quadrantlabelblfontitalic,t.quadrantlabelfontitalic)?"italic":"normal",q(h.styleObj),a=e(t.quadrantlabelblborderpadding,t.quadrantlabelborderpadding,2),d=e(t.quadrantlabelblborderradius,t.quadrantlabelborderradius,0),g=g?L(g,e(t.quadrantlabelblbgalpha,t.quadrantlabelbgalpha,t.quadrantlabelblalpha,t.quadrantlabelalpha,100)):"",l=e(t.quadrantlabelblborderdashed,t.quadrantlabelborderdashed,0)?I(e(t.quadrantlabelblborderdashlen,t.quadrantlabelborderdashlen,4),e(t.quadrantlabelblborderdashgap,
t.quadrantlabelborderdashgap,2),m):"none",h["text-bound"]=[g,b,m,a,d,l]),""!==f&&(b=na(t.quadrantlabelbrbordercolor,t.quadrantlabelbordercolor,""),g=c(t.quadrantlabelbrbgcolor,t.quadrantlabelbgcolor),m=e(t.quadrantlabelbrborderthickness,t.quadrantlabelborderthickness,1),b=b?L(b,e(t.quadrantlabelbrborderalpha,t.quadrantlabelborderalpha,t.quadrantlabelbralpha,t.quadrantlabelalpha,100)):"",p=n.brConfig,p||(p=n.brConfig={enabled:!0,styleObj:{}}),p.label=Ja(t.quadrantlabelbr,""),p.styleObj.fontSize=c(e(t.quadrantlabelbrfontsize,
t.quadrantlabelfontsize),parseInt(r.fontSize,10))+"px",p.styleObj.lineHeight=r.lineHeight,p.styleObj.fontFamily=c(t.quadrantlabelbrfont,t.quadrantlabelfont,r.fontFamily),p.styleObj.color=L(c(t.quadrantlabelbrfontcolor,t.quadrantlabelfontcolor,r.color),e(t.quadrantlabelbrfontalpha,t.quadrantrabelfontalpha,100)),p.styleObj.fontWeight=e(t.quadrantlabelbrfontbold,t.quadrantlabelfontbold)?"bold":"normal",p.styleObj.fontStyle=e(t.quadrantlabelbrfontitalic,t.quadrantlabelfontitalic)?"italic":"normal",q(p.styleObj),
g=g?L(g,e(t.quadrantlabelbrbgalpha,t.quadrantlabelbgalpha,t.quadrantlabelbralpha,t.quadrantlabelalpha,100)):"",a=e(t.quadrantlabelbrborderpadding,t.quadrantlabelborderpadding,2),d=e(t.quadrantlabelbrborderradius,t.quadrantlabelborderradius,0),l=e(t.quadrantlabelbrborderdashed,t.quadrantlabelborderdashed,0)?I(e(t.quadrantlabelbrborderdashlen,t.quadrantlabelborderdashlen,4),e(t.quadrantlabelbrborderdashgap,t.quadrantlabelborderdashgap,2),m):"none",p["text-bound"]=[g,b,m,a,d,l])},_preDraw:function(){var b,
a,c,d,e,g;c=this.conf;var k=this.chart;d=k.components;g=d.yAxis[0];e=d.xAxis[0].getLimit();var h=g.getLimit();d=e.max;g=h.max;var l=e.min;e=h.min;var k=k.config,f=k.canvasWidth,m=k.canvasHeight,k=c.quadrantLabelPadding,h=c.tlConfig,q=c.trConfig,p=c.blConfig,n=c.brConfig;b=c.xVal||(c.xVal=(l+d)/2);a=c.yVal||(c.yVal=(e+g)/2);if(a>=e&&a<=g&&b>=l&&b<=d){c=f/(d-l)*(b-l);d=f-c;g=m/(g-e)*(a-e);c-=k;e=m-g-k;g-=k;if(0>e||0>c)h.enabled=!1;if(0>e||0>d-k)q.enabled=!1;if(0>g||0>c)p.enabled=!1;if(0>g||0>c)n.enabled=
!1}else c.enabled=!1;return this},draw:function(){var b=this._preDraw(),a=b.conf,c=b.chart,d=c.graphics,e=c.config,g=c.components,k=c.linkedItems.smartLabel,b=b.graphics,h=b.tlLabel,l=b.trLabel,f=b.blLabel,m=b.brLabel,q=e.textDirection,p=g.xAxis[0],n=g.yAxis[0],g=g.paper,t=b.container,r=a.tlConfig||{},w=a.trConfig||{},v=a.blConfig||{},C=a.brConfig||{},r=r.enabled&&r.label,w=w.enabled&&w.label,v=v.enabled&&v.label,C=C.enabled&&C.label,A=e.canvasLeft,H=e.canvasTop,D=a.quadrantLabelPadding,F=p.getLimit(),
K=n.getLimit(),I=F.max,L=K.max,K=K.min,F=p.getPixel(F.min)+D,I=p.getPixel(I)-D,K=n.getPixel(K)-D,D=n.getPixel(L)+D,p=p.getPixel(a.xVal),J=n.getPixel(a.yVal),n=p-F,L=I-p,M=J-D,N=K-J,O=b.horizontalQuadLine,T=b.verticalQuadLine,S=c.get("config","animationObj"),c=S.duration||0,W=S.dummyObj,S=S.animObj,aa=!1;a.enabled?(t||(aa=!0,t=b.container=g.group("quadrant").insertBefore(d.datasetGroup)),t.animateWith(W,S,{"clip-rect":e.canvasLeft+","+e.canvasTop+","+e.canvasWidth+","+e.canvasHeight},aa?0:c),O||(O=
b.horizontalQuadLine=g.path(t)),O.animateWith(W,S,{path:"M"+A+" "+J+"h"+e.canvasWidth},c).attr({stroke:a.quadrantLineColor,"stroke-dasharray":a.dashStyle,"stroke-width":a.quadrantLineThickness,"stroke-linecap":"butt"}),T||(T=b.verticalQuadLine=g.path(t)),T.animateWith(W,S,{path:"M"+p+" "+H+"v"+e.canvasHeight},c).attr({stroke:a.quadrantLineColor,"stroke-width":a.quadrantLineThickness,"stroke-dasharray":a.dashStyle,"stroke-linecap":"butt"}),r?(h||(h=b.tlLabel=g.text(t).attr({"text-anchor":cb,"vertical-align":Xa}).css(a.tlConfig.styleObj)),
k.useEllipsesOnOverflow(e.useEllipsesWhenOverflow),k.setStyle(a.tlConfig.styleObj),d=k.getSmartText(r,n,M),r&&h.animateWith(W,S,{x:F,y:D},aa?0:c).attr({text:d.text,direction:q,"text-bound":a.tlConfig["text-bound"]}).show()):h&&h.hide(),w?(l||(l=b.trLabel=g.text(t).attr({"text-anchor":db,"vertical-align":Xa,direction:q}).css(a.trConfig.styleObj)),k.setStyle(a.trConfig.styleObj),d=k.getSmartText(w,L,M),w&&l.animateWith(W,S,{x:I,y:D},aa?0:c).attr({text:d.text,"text-bound":a.trConfig["text-bound"]}).show()):
l&&l.hide(),v?(f||(f=b.blLabel=g.text(t).attr({"text-anchor":cb,"vertical-align":lb,direction:q}).css(a.blConfig.styleObj)),k.setStyle(a.blConfig.styleObj),d=k.getSmartText(v,n,N),v&&f.animateWith(W,S,{x:F,y:K},aa?0:c).attr({text:d.text,"text-bound":a.blConfig["text-bound"]}).show()):f&&f.hide(),C?(m||(m=b.brLabel=g.text(t).attr({"text-anchor":db,"vertical-align":lb,direction:q}).css(a.brConfig.styleObj)),k.setStyle(a.brConfig.styleObj),d=k.getSmartText(C,L,N),C&&m.animateWith(W,S,{x:I,y:K},aa?0:
c).attr({text:d.text,"text-bound":a.brConfig["text-bound"]}).show()):m&&m.hide()):t&&t.hide()}}]);FusionCharts.register("component",["dataset","Scatter",{type:"scatter",configure:function(){var b,d,g,l=this.chart,q=l.components,p=m.parseUnsafeString,k=this.config,h=this.JSONData,n=l.areaAlpha,f=l.jsonData.chart,r=q.colorManager;b=e(h.showplotborder,f.showplotborder||1);var w=r.getPlotColor(this.index),v=k.lineDashed=e(h.linedashed,h.dashed,f.linedashed,0),C=this.isLineSet;k.plotColor=w;g=e(l.defaultPlotShadow,
r.getColor("showShadow"));k.xAxisLabelMode=c(f.xaxislabelmode,"categories");k.toolTipSepChar=c(f.tooltipsepchar,", ");k.parentYAxis=C?d=1:d="s"===c(h.parentyaxis&&h.parentyaxis.toLowerCase(),"p")?1:0;this.yAxis=q.yAxis[d];k.connectNullData=e(f.connectnulldata,0);k.includeInLegend=e(h.includeinlegend,1);k.enableAnimation=d=e(f.animation,f.defaultanimation,1);k.animation=d?{duration:1E3*e(f.animationduration,1)}:!1;k.transposeanimation=e(f.transposeanimation,d);k.transposeanimduration=1E3*e(f.transposeanimduration,
.2);k.showValues=e(h.showvalues,f.showvalues);k.valuePadding=e(f.valuepadding,2);k.valuePosition=c(h.valueposition,f.valueposition,"auto");k.showTooltip=e(f.showtooltip,1);k.seriesNameInTooltip=e(f.seriesnameintooltip,1);k.showRegressionLine=e(h.showregressionline,f.showregressionline,0);k.plotFillColor=c(h.color,f.plotfillcolor,w);k.plotFillAngle=c(f.plotfillangle,270);k.plotFillAlpha=c(h.alpha,f.plotfillalpha,n,"70");n=e(f.useplotgradientcolor,1);k.plotGradientColor=0!==n?m.getDefinedColor(f.plotgradientcolor,
r.getColor("plotGradientColor")):"";k.fillColor={color:k.plotFillColor+(k.plotGradientColor?","+k.plotGradientColor:a),alpha:k.plotFillAlpha,angle:k.plotFillAngle};k.plotBorderAlpha=b?c(h.plotborderalpha,f.plotborderalpha,h.alpha,"95"):0;k.plotBorderColor=c(h.plotbordercolor,f.plotbordercolor,f.areabordercolor,"666666");k.dashed=b=e(h.dashed,f.plotborderdashed);k.plotBorderDashLen=c(h.plotborderdashlen,f.plotborderdashlen,5);k.plotBorderDashGap=c(h.plotborderdashgap,f.plotborderdashgap,4);k.plotBorderThickness=
e(h.plotborderthickness,f.plotborderthickness,1);k.plotBorderDashStyle=b?m.getDashStyle(k.plotBorderDashLen,k.plotBorderDashGap,k.plotBorderThickness):"none";k.showHoverEffect=e(f.plothovereffect,f.anchorhovereffect,f.showhovereffect,void 0);k.rotateValues=e(f.rotatevalues)?270:0;k.drawLine=e(h.drawline,f.drawlines,0);k.lineThickness=e(h.linethickness,f.linethickness,2);k.lineDashLen=e(h.linedashlen,f.linedashlen,5);k.lineDashGap=e(h.linedashgap,f.linedashgap,4);k.lineAlpha=e(h.linealpha,f.linealpha,
h.alpha,aa);k.lineColor=c(h.linecolor,f.linecolor,h.color,k.plotColor);k.lineDashStyle=m.getDashStyle(k.lineDashLen,k.lineDashGap,k.lineThickness);k.lineDashStyle=v?k.lineDashStyle:"none";k.shadow={opacity:e(f.showshadow,g)?k.lineAlpha/100:0};k.drawanchors=e(h.drawanchors,h.showanchors,f.drawanchors,f.showanchors);k.anchorbgcolor=ib(c(h.anchorbgcolor,f.anchorbgcolor,r.getColor("anchorBgColor")));k.anchorbordercolor=ib(c(h.anchorbordercolor,h.color,f.anchorbordercolor,k.lineColor));k.anchorradius=
e(h.anchorradius,f.anchorradius,3);k.anchoralpha=c(h.anchoralpha,h.alpha,f.anchoralpha,aa);k.anchorbgalpha=c(h.anchorbgalpha,h.alpha,f.anchorbgalpha,aa);k.anchorborderthickness=c(h.anchorborderthickness,f.anchorborderthickness,1);k.anchorsides=e(h.anchorsides,f.anchorsides,this.index+3);k.anchorimageurl=c(h.anchorimageurl,f.anchorimageurl);k.anchorimagealpha=e(h.anchorimagealpha,f.anchorimagealpha,100);k.anchorimagescale=e(h.anchorimagescale,f.anchorimagescale,100);k.anchorimagepadding=e(h.anchorimagepadding,
f.anchorimagepadding,1);k.anchorstartangle=e(h.anchorstartangle,f.anchorstartangle,90);k.anchorshadow=e(h.anchorshadow,f.anchorshadow,0);k.plotToolText=m.getValidValue(p(c(h.plottooltext,f.plottooltext)));k.showRegressionLine&&(k.regressionObj={isRegression:!0,sumX:0,sumY:0,sumXY:0,sumXsqure:0,sumYsqure:0,xValues:[],yValues:[]},k.showYOnX=e(h.showyonx,f.showyonx,1),k.regressionLineColor=ib(c(h.regressionlinecolor,f.regressionlinecolor,k.anchorbordercolor)),k.regressionLineThickness=e(h.regressionlinethickness,
f.regressionlinethickness,k.anchorborderthickness),k.regressionLineAlpha=ba(e(h.regressionlinealpha,f.regressionlinealpha,k.anchoralpha)),k.regLineColor=t({color:k.regressionLineColor,alpha:k.regressionLineAlpha}));k.seriesNameInTooltip&&(k.seriesname=m.getFirstValue(h&&h.seriesname));this.visible=1===e(h.visible,!Number(h.initiallyhidden),1);this._setConfigure();!1!==l.hasLegend&&this._addLegend()},_setConfigure:function(){var b,d,g,l,q,p,k,h,n,f=-Infinity,t=Infinity,r=Infinity,w=-Infinity,v=this.components.data||
(this.components.data=[]);b=this.chart;var C=m.parseUnsafeString,A=this.config,H=this.JSONData,D=b.jsonData.chart,F=H.data||[],K=F.length,I=b.components.numberFormatter,L=C(D.yaxisname),J=C(D.xaxisname),M=A.lineDashed,N=A.lineDashStyle,Q=A.parentYAxis,R=A.toolTipSepChar,O=A.seriesname;for(b=A.imageCount=0;b<K;b+=1)l=F[b],g=v[b]||(v[b]={}),d=g.config||(g.config={}),d.setValue=q={x:I.getCleanValue(l.x),y:I.getCleanValue(l.y)},null!==q.x&&null!==q.y&&(q.x>w&&(w=q.x,A.rightMostData=g),q.x<r&&(r=q.x,A.leftMostData=
g),q.y>f&&(f=q.y,A.topMostData=g),q.y<t&&(t=q.y,A.bottomMostData=g)),A.showRegressionLine&&this.pointValueWatcher(q.x,q.y,A.regressionObj),d.setLink=c(l.link),d.anchorProps=this._parseAnchorProperties(b),d.showValue=e(l.showvalue,A.showValues),d.dashed=e(l.dashed,M),d.color=c(l.color,A.lineColor),d.alpha=c(l.alpha,A.lineAlpha),d.dashStyle=d.dashed?N:"none",d.toolTipValue=p=I.dataLabels(q.y,Q),d.setDisplayValue=n=C(l.displayvalue),h=d.formatedVal=c(l.toolTipValue,I.dataLabels(q.y,Q)),k=I.xAxis(q.x),
d.displayValue=c(n,p),d.setTooltext=m.getValidValue(C(c(l.tooltext,A.plotToolText))),A.showTooltip?void 0!==d.setTooltext?(q=[4,5,6,7,8,9,10,11],k={yaxisName:L,xaxisName:J,yDataValue:h,xDataValue:k},l=ea(d.setTooltext,q,k,l,D,H)):null===h?l=!1:(l=O?O+R:a,l+=q.x?k+R:a,l+=p):l=!1,d.toolText=l,g?g.graphics||(v[b].graphics={}):g=v[b]={graphics:{}},d.hoverEffects=this._parseHoverEffectOptions(g),d.anchorProps.isAnchorHoverRadius=d.hoverEffects.anchorRadius;A.xMax=w;A.xMin=r;A.yMin=t;A.yMax=f;A.showRegressionLine&&
(A.regressionData=this.getRegressionLineSeries(A.regressionObj,A.showYOnX,K));this.ErrorValueConfigure&&this.ErrorValueConfigure()},sortFN:function(b,a){return b-a},getRegressionLineSeries:function(b,a,c){var d,e,g,k;k=b.sumXY;var h=b.sumX,l=b.sumY;e=b.xValues;g=b.sumXsqure;d=b.yValues;b=b.sumYsqure;a?(e.sort(this.sortFN),d=e[0],e=e[e.length-1],k=(c*k-h*l)/(c*g-yb(h,2)),g=!isNaN(k)&&isFinite(k)?k*(d-h/c)+l/c:l/c,c=!isNaN(k)&&isFinite(k)?k*(e-h/c)+l/c:l/c,c=[{x:d,y:g},{x:e,y:c}]):(d.sort(this.sortFN),
g=d[0],d=d[d.length-1],k=(c*k-h*l)/(c*b-yb(l,2)),e=isNaN(k)?h/c:k*(g-l/c)+h/c,c=isNaN(k)?h/c:k*(d-l/c)+h/c,c=[{x:e,y:g},{x:c,y:d}]);return c},draw:function(){var b,a,d,e,g,l,k,h,q,f,p,n,r,w,v,C,H,D,F,K=this.JSONData,I=this.chart,L=I.getJobList(),J=I.components,M=this.components.removeDataArr,M=M&&M.length,N=I.jsonData.chart,Q=this.config,R=this.index,O=K.data||[],T=I.config,S=J.paper,aa=J.xAxis[0],J=J.yAxis[0],ba=m.parseUnsafeString,W=m.getValidValue,V=this.components.data,U=V.length;H={};a={};var Z=
Q.lineThickness;a=I.graphics;l=a.datalabelsGroup;var X=this.graphics.container,da=this.graphics.trackerContainer;w=a.trackerGroup;var ca=this.pool||(this.pool={}),pa=Q.connectNullData,ia=Q.showTooltip;a=a.datasetGroup;var fa=Q.shadow,ea=this.graphics.dataLabelContainer;g={};var ma=[Ea(0,T.canvasLeft),Ea(0,T.canvasTop),Ea(1,T.canvasWidth),Ea(1,T.canvasHeight)],T=[Ea(0,T.canvasLeft),Ea(0,T.canvasTop),1,Ea(1,T.canvasHeight)],ga=Q.lineDashStyle,ja={color:Q.lineColor,alpha:Q.lineAlpha},la=[],oa=[],ka=
null,na=[],ra=!1,Aa=this.graphics.lineElement;g=this.graphics.regressionLineElement;var qa=this.visible,sa=I.get("config","animationObj"),I=sa.duration||0,ua=sa.dummyObj,va=sa.animObj,sa=sa.animType,Ta=0;Q.imagesLoaded=0;a.line=a.line||S.group("line",a);a.lineConnector=a.lineConnector||S.group("line-connector",a);X||(X=this.graphics.container={lineShadowGroup:S.group("connector-shadow",a.lineConnector),anchorShadowGroup:S.group("anchor-shadow",a.lineConnector),lineGroup:S.group("connector",a.lineConnector),
anchorGroup:S.group("anchors",a.lineConnector)});da||(da=this.graphics.trackerContainer=S.group("line-hot"));V||(V=this.components.data=[]);w&&w.appendChild(da);ea||(ea=this.graphics.dataLabelContainer=S.group("datalabel",l).attr("class","fusioncharts-datalabels"));Q.showRegressionLine&&qa?(l=Q.regressionData[0],w=Q.regressionData[1],(a=Q._regressionAttr)||(Q._regressionAttr=a={}),a.stroke=Q.regLineColor,a["stroke-width"]=Q.regressionLineThickness,a["stroke-linecap"]="round",a["stroke-linejoin"]=
2<Q.regressionLineThickness?"round":"miter",a.path="M "+aa.getAxisPosition(l.x)+","+J.getAxisPosition(l.y)+" L "+aa.getAxisPosition(w.x)+","+J.getAxisPosition(w.y),g?g.animateWith(ua,va,a,I,sa):g=this.graphics.regressionLineElement=S.path(a,X.regLineGroup),g.show()):g&&g.hide();for(l=0;l<U;l+=1)if(g=O[l],w=V[l],D=w.config,d=D.trackerConfig={},a=w.graphics,n=D.setValue,p=D.setLink,W(ba(c(g.tooltext,K.plottooltext,N.plottooltext))),g=D.anchorProps,H=g.symbol,v=g.shadow,r=D.displayValue,w||(w=V[l]={graphics:{}}),
e=n.y,b=n.x,q=D.finalTooltext=D.toolText,null!==e&&null!==b){C=D.hoverEffects;k=aa.getAxisPosition(b);h=J.getAxisPosition(e);D.eventArgs={index:l,link:p,x:b,y:e,value:n,displayValue:r,toolText:q,id:Q.userID,datasetIndex:R||0,datasetName:K.seriesname,visible:qa};if(g.imageUrl)D.anchorImageLoaded=!1,d=new A,D.anchorImageLoaded=!1,qa||a.image&&a.image.animateWith(ua,va,{opacity:0},I,sa),d.onload=this._onAnchorImageLoad(this,l,void 0,k,h),d.onerror=this._onErrorSetter(this,l),d.src=g.imageUrl,Ta++;else if(f=
a.element,(D=a.image)&&D.hide(),f||(f=ca.element&&ca.element.length?a.element=ca.element.shift():a.element=S.polypath(X.anchorGroup),ra=!0,I&&ra&&f.attr({polypath:[H[1]||2,k,h,g.radius,g.startAngle,0],opacity:0,"fill-opacity":0,"stroke-opacity":0})),f.attr({fill:t({color:g.bgColor,alpha:g.bgAlpha}),stroke:t({color:g.borderColor,alpha:g.borderAlpha}),"stroke-width":g.borderThickness,cursor:p?"pointer":"",visibility:g.radius?qa:Ua}).shadow(v,X.anchorShadowGroup).animateWith(ua,va,{polypath:[H[1]||2,
k,h,g.radius,g.startAngle,0],opacity:qa?g.bgAlpha/100:0,"fill-opacity":qa?g.bgAlpha/100:0,"stroke-opacity":qa?g.borderAlpha/100:0},I,sa),p||ia||C)a=Ea(g.radius,C.anchorRadius||0),d.trackerRadius=a;C.enabled&&(a={polypath:[C.anchorSides||2,k,h,C.anchorRadius,C.startAngle,C.dip],fill:t({color:C.anchorColor,alpha:C.anchorBgAlpha}),stroke:t({color:C.anchorBorderColor,alpha:C.anchorBorderAlpha}),"stroke-width":C.anchorBorderThickness},H={polypath:[H[1]||2,k,h,g.radius,g.startAngle,0],fill:t({color:g.bgColor,
alpha:g.bgAlpha}),stroke:t({color:g.borderColor,alpha:g.borderAlpha}),"stroke-width":g.borderThickness},f&&f.data("anchorRadius",g.radius).data("anchorHoverRadius",C.anchorRadius).data(Na,a).data(ya,H));g.isAnchorHoverRadius=C.anchorRadius;null!==ka?(na.length&&(la=la.concat(na),na.length=0),la.join("")||la.push("M",F,ka),la.push("L",k,h)):na.push("M",k,h);F=k;ka=h;w._xPos=k;w._yPos=h}else na.length=0,pa||(ka=null);la.length&&(oa=oa.concat(la));Q.drawLine&&oa.join("")?(Aa||(Aa=this.graphics.lineElement=
S.path({path:oa},X.lineGroup),ra=!0),qa&&Aa.attr({"stroke-dasharray":ga,"stroke-width":Z,stroke:t(ja),"stroke-linecap":"round","stroke-linejoin":2<=Z?"round":"miter"}),qa?Aa.animateWith(ua,va,{path:oa,"stroke-opacity":1},I,sa,function(){this.shadow(fa,X.lineShadowGroup)}):Aa.animateWith(ua,va,{path:oa,"stroke-opacity":0},ra?0:I,sa).shadow(!1)):Aa&&Aa.animateWith(ua,va,{"stroke-opacity":0},I,sa).shadow(!1);Q.totalImages=Q.noOfImages=Ta;0===Ta&&(L.trackerDrawID.push(pb.addJob(this.drawTracker,this,
[],m.priorityList.tracker)),this.drawn?this.drawLabel():L.labelDrawID.push(pb.addJob(this.drawLabel,this,[],m.priorityList.label)));X.lineShadowGroup.hide();X.anchorShadowGroup.hide();ea.hide();ra&&X.lineGroup.attr({"clip-rect":T});X.lineGroup.animateWith(ua,va,{"clip-rect":ma},I,sa,function(){X.lineGroup.attr({"clip-rect":null});qa?(X.lineShadowGroup.show(),X.anchorShadowGroup.show(),X.anchorGroup.show(),da.show(),ea&&ea.show()):(X.lineShadowGroup.hide(),X.anchorShadowGroup.hide(),X.anchorGroup.hide(),
da.hide(),ea&&ea.hide())});M&&this.remove();this.drawErrorValue&&this.drawErrorValue();this.drawn=!0},getDataLimits:function(){var b=this.config,a=b.yMax,c=b.yMin,d=b.xMax,b=b.xMin,e=this.chart.config.transposeAxis;!1===this.visible&&e&&(a=-Infinity,c=Infinity,d=-Infinity,b=Infinity);return{max:a,min:c,xMax:d,xMin:b}},getAxisValuePadding:function(){return{left:0,right:0}},_addLegend:function(){var b,a=this.config,d=this.chart.components.legend,g=e(a.drawanchors,1);b=this.getPointColor(a.anchorbgcolor,
aa);var l={FCcolor:{color:a.anchorbordercolor,alpha:a.anchoralpha}};d.config.symbol3DLighting?b&&b.FCcolor?(b=p({},b),b.FCcolor.alpha="100"):b=c(b):b={FCcolor:{color:c(b&&(b.FCcolor&&b.FCcolor.color.split(",")[0]||b)),angle:0,ratio:"0",alpha:"100"}};this.legendItemId=d.addItems(this,this.legendInteractivity,{enabled:a.includeInLegend,type:this.type,drawLine:c(a.drawLine,!0),fillColor:t(b),strokeColor:t(c(l&&(l.FCcolor&&l.FCcolor.color.split(",")[0]||l))),rawFillColor:a.anchorbgcolor,rawStrokeColor:a.anchorbordercolor,
anchorSide:g?a.anchorsides:0,strokeWidth:a.anchorborderthickness,label:na(this.JSONData.seriesname)})},getPointColor:function(b,a){var c,d;b=ib(b);a=ba(a);c=ob(b,70);d=S(b,50);return{FCcolor:{gradientUnits:"objectBoundingBox",cx:.4,cy:.4,r:"100%",color:c+","+d,alpha:a+","+a,ratio:N,radialGradient:!0}}}},"Line"]);FusionCharts.register("component",["dataset","Pareto",{configure:function(){var b=this.chart,a=this.config,d=b.components,g=d.xAxis[0],l=this.JSONData,q=l.data,k=q&&q.length,h=b.jsonData.chart,
n=d.colorManager,f,r=n.getPlotColor(this.index||this.positionIndex),w=e(l.dashed,h.plotborderdashed),v=e(h.useplotgradientcolor,1),C=e(h.showtooltip,1),A=m.parseUnsafeString,H=A(h.yaxisname),D=A(h.xaxisname),F=m.parseTooltext,K,I,J,M,N,O,T,Q,R,S,ba,V,pa,ha,W,ia=m.getDashStyle,U=this.components.data,d=d.numberFormatter,Z,X=b.is3D,da,ca,ea,ga,fa,ka,ma,na,ja=-Infinity,la=Infinity,oa=this.type.toLowerCase(),ra,va,ya=0,Aa=[],qa=0,sa,ua=a.tootipSepChar=c(h.tooltipsepchar,", ");a.enableAnimation=T=e(h.animation,
h.defaultanimation,1);a.animation=T?{duration:1E3*e(h.animationduration,1)}:!1;a.showTooltip=e(h.showtooltip,1);a.valuePadding=e(h.valuepadding,2);a.rotateValues=e(h.rotatevalues)?270:0;a.showHoverEffect=T=e(h.plothovereffect,h.showhovereffect,void 0);a.showShadow=O||X?e(h.showshadow,1):e(h.showshadow,n.getColor("showShadow"));a.useDataPlotColorForLabels=sa=e(h.usedataplotcolorforlabels,0);a.use3dlineshift=e(h.use3dlineshift,b.use3dlineshift);/column/.test(oa)&&(f=a.showplotborder=e(h.showplotborder,
X?0:1),a.plotDashLen=J=e(h.plotborderdashlen,5),a.plotDashGap=M=e(h.plotborderdashgap,4),a.plotfillangle=Q=e(360-h.plotfillangle,90),a.plotfillalpha=R=c(h.plotfillalpha,aa),a.plotColor=r,a.isRoundEdges=O=e(h.useroundedges,0),a.plotRadius=e(h.useRoundEdges,a.isRoundEdges?1:0),a.plotfillratio=S=c(h.plotfillratio),a.plotgradientcolor=ba=m.getDefinedColor(h.plotgradientcolor,n.getColor("plotGradientColor")),!v&&(ba=""),a.plotborderalpha=V=f&&!X?c(h.plotborderalpha,R,aa):0,a.plotbordercolor=pa=c(h.plotbordercolor,
X?"#ffffff":n.getColor("plotBorderColor")),a.plotborderthickness=N=e(h.plotborderthickness,1),a.plotBorderDashStyle=ha=w?ia(J,M,N):"none",a.showValues=e(h.showvalues,1),a.definedGroupPadding=Ea(e(h.plotspacepercent),0),a.plotSpacePercent=Ea(e(h.plotspacepercent,20)%100,0),a.maxcolwidth=e(h.maxcolwidth,50),a.plotpaddingpercent=e(h.plotpaddingpercent),a.placevaluesinside=e(h.placevaluesinside,0),a.use3dlighting=e(h.use3dlighting,1),a.parentYAxis=0);"line"===oa&&(a.linecolor=ib(c(h.linecolor,n.getColor("plotBorderColor"))),
a.linethickness=e(h.linethickness,2),a.linealpha=c(h.linealpha,aa),a.linedashed=e(h.linedashed,0),a.linedashlen=e(l.linedashlen,h.linedashlen,5),a.linedashgap=e(l.linedashgap,h.linedashgap,4),w=m.getDashStyle(a.linedashlen,a.linedashgap,a.linethickness),a.lineDashStyle=a.linedashed?w:"none",a.drawanchors=e(h.drawanchors,h.showanchors),a.anchorbgcolor=c(h.anchorbgcolor,n.getColor("anchorBgColor")),a.anchorbordercolor=c(h.anchorbordercolor,a.linecolor),a.anchorradius=e(h.anchorradius,3),a.anchoralpha=
c(h.anchoralpha),a.anchorbgalpha=c(h.anchorbgalpha,100),a.anchorborderthickness=c(h.anchorborderthickness,1),a.anchorsides=c(h.anchorsides,0),a.anchorimageurl=c(h.anchorimageurl),a.anchorimagealpha=e(h.anchorimagealpha,100),a.anchorimagescale=e(h.anchorimagescale,100),a.anchorimagepadding=e(h.anchorimagepadding,1),a.anchorstartangle=e(h.anchorstartangle,90),a.parentYAxis=1,a.valuePosition=c(h.valueposition,"auto"),a.showValues=e(h.showlinevalues,h.showvalues,1),a.showShadow&&(a.shadow={opacity:a.lineAlpha/
100}),a.showCumulativeLine=e(h.showcumulativeline,1));U||(U=this.components.data=[]);for(w=0;w<k;w++)v=Ra(d.getCleanValue(q[w].value)),ya+=v,Aa[w]=p({},q[w]),Aa[w].value=v;Aa.sort(function(b,a){return a.value-b.value});for(w=a.imageCount=0;w<k;w++)v=Aa[w],(r=U[w])||(r=U[w]={graphics:{}}),r.config||(q=U[w].config={}),b=Ra(d.getCleanValue(v.value)),null!==b&&(q=r&&r.config,Z=g.getLabel(w),q.label=Ja(A(c(Z.label))),q.showValue=e(v.showvalue,a.showValues),q.setValue=b,q.setLink=c(v.link),q.setDisplayValue=
Z=A(v.displayvalue),qa+=q.setValue,ra=d.dataLabels(b),/column/.test(oa)?(r=e(v.dashed),K=e(v.dashlen,J),W=M=e(v.dashgap,M),q.plotBorderDashStyle=K=1===r?ia(K,W,N):0===r?"none":ha,r=n.getPlotColor(w),r=c(v.color,r),S=c(v.ratio,a.plotfillratio),R=c(v.alpha,a.plotfillalpha),V=c(v.alpha,a.plotborderalpha),0>b&&!O&&(I=Q,Q=360-Q),q.colorArr=W=m.graphics.getColumnColor(r+","+ba,R,S,Q,O,pa,V.toString(),0,X?!0:!1),0!==T&&(da=c(v.hovercolor,h.plotfillhovercolor,h.columnhovercolor,r),ca=c(v.hoveralpha,h.plotfillhoveralpha,
h.columnhoveralpha,R),ea=c(v.hovergradientcolor,h.plothovergradientcolor,ba),!ea&&(ea=""),S=c(v.hoverratio,h.plothoverratio,S),ga=e(360-v.hoverangle,360-l.hoverangle,360-h.plothoverangle,Q),fa=c(v.borderhovercolor,h.plotborderhovercolor,pa),V=c(v.borderhoveralpha,l.borderhoveralpha,h.plotborderhoveralpha,h.plotfillhoveralpha,V,R),R=e(v.borderhoverthickness,l.borderhoverthickness,h.plotborderhoverthickness,N),ka=e(v.borderhoverdashed,h.plotborderhoverdashed),ma=e(v.borderhoverdashgap,h.plotborderhoverdashgap,
J),na=e(v.borderhoverdashlen,h.plotborderhoverdashlen,M),ka=ka?ia(na,ma,R):K,1==T&&da===r&&(da=ob(da,70)),da=m.graphics.getColumnColor(da+","+ea,ca,S,ga,O,fa,V.toString(),0,X?!0:!1),q.setRolloutAttr={fill:X?[t(W[0]),!a.use3dlighting]:t(W[0]),stroke:f&&t(W[1]),"stroke-width":N,"stroke-dasharray":K},q.setRolloverAttr={fill:X?[t(da[0]),!a.use3dlighting]:t(da[0]),stroke:f&&t(da[1]),"stroke-width":R,"stroke-dasharray":ka}),sa&&g.updateCategory(w,{labelfontcolor:L(r)}),q.displayValue=c(Z,ra),K=q.setTooltext=
q.origToolText=Ja(A(c(v.tooltext,h.plottooltext))),q.toolTipValue=d.dataLabels(b,a.parentYAxis)):(b=q.setValue=qa/ya*100,va=d.percentValue(b),q.toolTipValue=va,q.displayValue=va,q.valuePosition=c(v.valueposition,a.valuePosition),q.anchorProps=this._parseAnchorProperties(w,Aa),q.hoverEffects=this._parseHoverEffectOptions(r)),r=q.toolTipValue,ja=Ea(ja,b),la=Va(la,b),C?(a.showTooltip?void 0!==K?(r={formattedValue:r,label:q.label,yaxisName:H,xaxisName:D,cumulativeValue:qa,cumulativeDataValue:d.dataLabels(qa),
cumulativePercentValue:va,sum:d.dataLabels(ya),unformattedSum:ya},b=[1,2,3,5,6,7,20,21,22,23,24,25],v=F(K,b,r,v,h)):v=q.label?q.label+ua:"":v=!1,q.toolText=v):v=!1,q.toolText=v,q.tooltext=K,q.setTooltext=v,I&&(Q=I));a.maxValue=ja;a.minValue=la},init:function(b,a,c){var d=b.chart.components;b.JSONData={data:a};b.type=c;b.yAxis="line"===c?d.yAxis[1]:d.yAxis[0];b.components={};b.graphics={};b.visible=!0;this.configure.call(b)}}]);FusionCharts.register("component",["datasetGroup","MSSplineArea",{},"area"]);
FusionCharts.register("component",["dataset","MSSplineArea",{configure:function(){FusionCharts.get("component",["dataset","area"]).prototype.configure.call(this);this._calculateMaxMin()},_calculateMaxMin:function(){var b=this.config,a=this.chart,c=a.config,d=a.origRenderWidth,e=c.connectnulldata,g=this.components.data,k=Number.MIN_VALUE,h=Number.MAX_VALUE;0===c.minimizetendency&&(a=a.getSplineExtremities(g,d,e),b.maxValue=Ea(b.maxValue,a.max),b.minValue=Va(b.minValue,a.min),b.maxValue===k&&(b.maxValue=
0),b.minValue===h&&(b.minValue=0))},getSplinePath:function(b,a,c,d){var e=function(b,a,c,d){a=(d-a)/Qa((c-b)*(c-b)+(d-a)*(d-a));a=Ra(.5*a);return b*a+c*(1-a)},g=function(b,a,c,d){var e=b.length,f=b[e-1],g=f.length,h=f[0],f=f[g-2];3>g||("R"!==h&&"C"!==h||3!==g||(b[e-1][0]="L"),a&&b.push(["L",f,d,c,d,"Z"]))},k=/area/ig.test(this.defaultDatasetType),h=[null],l=[],f=[],m=a.getAxisBase();a=a.getAxisPosition(m);var q,p,n,t,r,w,v,C,A,H,D,F,K,I,L,J;L=0;for(J=b.length;L<J;L+=1)if(A=b[L],n=b[L-1]||{},t=b[L+
1]||{},r=A.x,m=A.y,q=n.x,n=n.y,w=t.x,t=t.y,v=A.lastYPos,C=A.lastXPos,D=l.length,A=f.length,d)if(null!==v)if(p=K,L===b.length-1){v=h[L-F-1];A=w=(r+q)/2;D=(A-q)*v+n;if(n>m&&D<m||n<m&&D>m)D=m,A=(D-n)/v+q;K.push(A,D,w,(m+n)/2,r,m);l.push(K);f.push(K);k&&g(l,!0,I,a);k&&g(f,!1)}else{v=h[L-F-1];if(n>m&&t>=m||n<m&&t<=m)if(H=0,w=e(q,n,r,m),t=m,1!==L-F){A=w;D=(A-q)*v+n;if(n>m&&D<m||n<m&&D>m)D=m,A=(D-n)/v+q;K.push(A,D,w,t,r,m)}else K.push((r+q)/2,(m+n)/2,w,t,r,m);else if(n===m)H=0,K.push(q,n,r,m,r,m);else if(n>
m&&m>t||n<m&&m<t){H=(t-n)/(w-q);w=e(q,n,r,m);t=(w-r)*H+m;if(n>m&&t>n||n<m&&t<n)t=n,w=(t-m)/H+r;if(1!==L-F){A=w;D=(A-q)*v+n;if(n>m&&D<m||n<m&&D>m)D=m,A=(D-n)/v+q;K.push(A,D,w,t,r,m)}else K.push((r+q)/2,(m+n)/2,w,t,r,m)}h.push(H)}else null===v&&0!==L?(p||(p=[]),"C"===p[0]&&(l.push(K),f.push(K),k&&g(l,!0,I,a),k&&g(f,!1)),l.push(["M",r,m]),f.push(["M",r,m]),I=r,K=["C"],F=L,h=[null]):(l.push(["M",r,m]),f.push(["M",r,m]),I=r,K=["C"],F=L);else null!==v?2<=D?("M"===l[D-1][0]&&l.push(["R"]),"M"===f[A-1][0]&&
f.push(["R"]),D=l.length,A=f.length,p=l[D-1],q=p.length,l[D-1].push(r),l[D-1].push(m),f[A-1].push(r),f[A-1].push(m),L===c-1&&"R"===p[0]&&(g(l,!0,I,a),g(f,!1))):(l.push(["M",C,v]),l.push(["R",r,m]),f.push(["M",C,v]),f.push(["R",r,m]),I=C):null===v&&2<=D&&(p=l[D-1],"R"===p[0]&&(g(l,!0,I,a),g(f,!1)),l.push(["M",r,m]),f.push(["M",r,m]),I=r);p=l[l.length-1];k&&p&&(q=p.length,"Z"===p[q-1]||"R"!==p[0]&&"C"!==p[0]||(g(l,!0,I,a),g(f,!1)));k||(l=d?l:f,2<=l.length&&g(l,!1));return{closedPath:l,openPath:f}},
draw:function(){var b=this,a=b.config,c=b.chart,d=c.getJobList(),e=b.JSONData,g=c.config,k=c.components,h=k.canvas.config,l=b.index,f,q,p=k.paper,k=k.xAxis[0],n=b.yAxis,r,w,v,H,D=null,F=[],K=[],I=c.graphics,L=g.showtooltip,J,M=b.components.data,N,Q,R,O,T,S=g.connectnulldata,aa,ba,W=g.minimizetendency,V=n.getAxisBase(),U,Z=a.plotbordercolor,X=a.plotborderalpha,da=a.plotBorderDashStyle,ca=a.plotborderthickness,pa=b.graphics.container,ia=b.graphics.trackerContainer,fa=[],ea,ma=a.fillColor,ga=I.areaGroup,
ja=c.get("config","animationObj"),la=ja.duration,oa=ja.animType,ka=b.components.removeDataArr||[],na=ka.length,ra=function(){!1!==b.visible||!1!==b._conatinerHidden&&void 0!==b._conatinerHidden||(pa.areaGroup.hide(),Ha.hide(),pa.lineShadowGroup.hide(),pa.anchorShadowGroup.hide(),pa.anchorGroup.hide(),ia.hide(),za&&za.hide(),b._conatinerHidden=!0)},va=function(){ga.area.attr({"clip-rect":null});ga.area.node&&ga.area.node.removeAttribute("clip-path");!1!==b.visible&&(pa.lineShadowGroup.show(),pa.anchorShadowGroup.show(),
pa.anchorGroup.show(),za.show(),Ha.show())},qa=a.shadow,sa,ua=b.visible;ea=I.trackerGroup;var Ha=pa&&pa.shadowContainer,Ta,fa={},fa=I.datalabelsGroup,za=b.graphics.dataLabelContainer,I=h.clip["clip-canvas"].slice(0),h=h.clip["clip-canvas-init"].slice(0),g=!g.drawfullareaborder,Da=!0,Ga=b.components.pool||[],Ja=ja.dummyObj,ja=ja.animObj,Ia=b.graphics.connector,Ka=0,La;a.imagesLoaded=0;pa||(pa=b.graphics.container={lineShadowGroup:p.group("connector-shadow",ga.areaConnector),anchorShadowGroup:p.group("anchor-shadow",
ga.areaConnector),areaGroup:p.group("area",ga.area),anchorGroup:p.group("anchors",ga.areaConnector)},ua||(pa.lineShadowGroup.hide(),pa.anchorShadowGroup.hide(),pa.areaGroup.hide(),pa.anchorGroup.hide()));Ha||(Ha=b.graphics.shadowContainer=p.group("shadows",ga.shadows),ua||Ha.hide());ia||(ia=b.graphics.trackerContainer=p.group("area-hot",ea),ua||ia.hide());M||(M=b.components.data);za||(za=b.graphics.dataLabelContainer=b.graphics.dataLabelContainer||p.group("datalabel",fa),ua||za.hide());ua&&(pa.lineShadowGroup.show(),
pa.anchorShadowGroup.show(),pa.areaGroup.show(),pa.anchorGroup.show(),za.show(),Ha.show(),ia.show());f=k.getCategoryLen();ea=b.graphics.splineElement;for(q=0;q<f;q++)if(N=M[q])J=N&&N.config,T=J.setValue,O=J.setLink,fa=J.anchorProps,Ta=fa.shadow,r=J.setLevelTooltext,J&&(U=0<=T?J.previousPositiveY:J.previousNegativeY),R=N.graphics.element,w=N.graphics.hotElement,La=N.graphics.image,null===T?(R&&R.hide(),w&&w.hide(),La&&La.hide(),S||(D=null)):(n.getAxisPosition(U||V),v=n.getAxisPosition(T+(U||0)),w=
k.getAxisPosition(q),!1===ua&&la&&(v=n.getPixel(n.getAxisBase())),sa=J.hoverEffects,Q=L?J.toolText+(r?"":J.toolTipValue):"",J.finalTooltext=Q,r=J.eventArgs=J.eventArgs||{},r.index=q,r.link=O,r.value=T,r.displayValue=J.displayValue,r.categoryLabel=k.getLabel(q).label,r.toolText=Q,r.id=b.userID,r.datasetIndex=l||0,r.datasetName=e.seriesname,r.visible=ua,sa.enabled&&(J.setRolloverAttr={polypath:[sa.anchorSides||2,w,v,sa.anchorRadius,sa.startAngle,sa.dip],fill:t({color:sa.anchorColor,alpha:sa.anchorBgAlpha}),
stroke:t({color:sa.anchorBorderColor,alpha:sa.anchorBorderAlpha}),"stroke-width":sa.anchorBorderThickness},J.setRolloutAttr={polypath:[fa.symbol[1]||2,w,v,fa.radius,fa.startAngle,0],fill:t({color:fa.bgColor,alpha:fa.bgAlpha}),stroke:t({color:fa.borderColor,alpha:fa.borderAlpha}),"stroke-width":fa.borderThickness},ba=J.setRolloverAttr,aa=J.setRolloutAttr),O=[fa.symbol[1]||2,w,v,fa.radius,fa.startAngle,0],fa.imageUrl?(J.anchorImageLoaded=!1,Ka++,J=new A,J.onload=b._onAnchorImageLoad(b,q,r,w,v),J.onerror=
b._onErrorSetter(b,q),J.src=fa.imageUrl):(La&&La.hide(),R||(Ga.element&&Ga.element.length?R=N.graphics.element=Ga.element.shift():(R=N.graphics.element=p.polypath(pa.anchorGroup),R.attr({polypath:O}))),La&&La.hide(),R.show().animateWith(Ja,ja,{polypath:O},la,oa,Da&&void 0).attr({fill:t({color:fa.bgColor,alpha:fa.bgAlpha}),stroke:t({color:fa.borderColor,alpha:fa.borderAlpha}),"stroke-width":fa.borderThickness,visibility:fa.radius?ua:Ua}).shadow(Ta,pa.anchorShadowGroup).data("anchorRadius",fa.radius).data("anchorHoverRadius",
sa.anchorRadius).data(Na,ba).data(ya,aa),sa.enabled&&R&&R.data("anchorRadius",fa.radius).data("anchorHoverRadius",sa.anchorRadius).data(Na,ba).data(ya,aa),J.trackerConfig||(J.trackerConfig={}),J.trackerConfig.trackerRadius=Ea(fa.radius,sa&&sa.anchorRadius||0,C)+(fa.borderThickness||0)/2),N._xPos=w,N._yPos=v,K.push({x:w,y:v,lastXPos:H,lastYPos:D}),H=w,D=v);a.noOfImages=a.totalImages=Ka;0===Ka&&(d.trackerDrawID.push(pb.addJob(b.drawTracker,b,[],m.priorityList.tracker)),d.labelDrawID.push(pb.addJob(b.drawLabel,
b,[],m.priorityList.label)));fa=this.getSplinePath.call(c,K,n,f,W).closedPath;fa=fa.join();ea||(ea=b.graphics.splineElement=p.path(pa.areaGroup),ea.attr({path:fa}),la&&ua&&(pa.anchorGroup.hide(),pa.anchorShadowGroup.hide(),za.hide(),Ha.hide(),ga.area.attr({"clip-rect":h}).animateWith(Ja,ja,{"clip-rect":I},la,oa,va)));""===fa?ea.hide():ea.show().animateWith(Ja,ja,{path:fa},la,oa,Da&&ra);Da=!1;ea.attr({stroke:t({color:Z,alpha:X}),"stroke-width":g?0:ca,fill:t(ma),"stroke-linecap":"round","stroke-linejoin":2<
ca?"round":"miter","stroke-dasharray":da}).shadow(qa,Ha);g&&(Ia||(Ia=b.graphics.connector=p.path(pa.areaGroup)),Ia.animateWith(Ja,ja,{path:F},la,oa),Ia.attr({stroke:t({color:Z,alpha:X}),"stroke-width":ca,"stroke-linecap":"round","stroke-linejoin":2<ca?"round":"miter","stroke-dasharray":da}));for(q=0;q<na;q++)b._removeDataVisuals(ka.shift())}},"area"]);FusionCharts.register("component",["dataset","MSSpline",{type:"spline",configure:function(){var b=FusionCharts.get("component",["dataset","line"]),
a=FusionCharts.get("component",["dataset","MSSplineArea"]);b.prototype.configure.call(this);a.prototype._calculateMaxMin.call(this)},getSplinePath:function(b,a,c){var d=function(b,a,c,d){a=(d-a)/Qa((c-b)*(c-b)+(d-a)*(d-a));a=Ra(.5*a);return b*a+c*(1-a)},e=function(b,a,c,d){var e=b.length,f=b[e-1],g=f.length,h=f[0],f=f[g-2];3>g||("R"!==h&&"C"!==h||3!==g||(b[e-1][0]="L"),a&&b.push(["L",f,d,c,d,"Z"]))},g=this.chart,k=/area/ig.test(g.defaultDatasetType);a=a.getAxisPosition(a.getAxisBase());var g=g.config.minimizetendency,
h=[null],l=[],f=[],m,q,p,n,t,r,w,v,C,A,H,D,F,K,I,J,L;J=0;for(L=b.length;J<L;J+=1)if(A=b[J],n=b[J-1]||{},t=b[J+1]||{},r=A.x,p=A.y,m=n.x,n=n.y,w=t.x,t=t.y,v=A.lastYPos,C=A.lastXPos,D=l.length,A=f.length,g)if(null!==v)if(q=K,J===b.length-1){v=h[J-F-1];A=w=(r+m)/2;D=(A-m)*v+n;if(n>p&&D<p||n<p&&D>p)D=p,A=(D-n)/v+m;K.push(A,D,w,(p+n)/2,r,p);l.push(K);f.push(K);k&&e(l,!0,I,a);k&&e(f,!1)}else{v=h[J-F-1];if(n>p&&t>=p||n<p&&t<=p)if(H=0,w=d(m,n,r,p),t=p,1!==J-F){A=w;D=(A-m)*v+n;if(n>p&&D<p||n<p&&D>p)D=p,A=(D-
n)/v+m;K.push(A,D,w,t,r,p)}else K.push((r+m)/2,(p+n)/2,w,t,r,p);else if(n===p)H=0,K.push(m,n,r,p,r,p);else if(n>p&&p>t||n<p&&p<t){H=(t-n)/(w-m);w=d(m,n,r,p);t=(w-r)*H+p;if(n>p&&t>n||n<p&&t<n)t=n,w=(t-p)/H+r;if(1!==J-F){A=w;D=(A-m)*v+n;if(n>p&&D<p||n<p&&D>p)D=p,A=(D-n)/v+m;K.push(A,D,w,t,r,p)}else K.push((r+m)/2,(p+n)/2,w,t,r,p)}h.push(H)}else null===v&&0!==J?(q||(q=[]),"C"===q[0]&&(l.push(K),f.push(K),k&&e(l,!0,I,a),k&&e(f,!1)),l.push(["M",r,p]),f.push(["M",r,p]),I=r,K=["C"],F=J,h=[null]):(l.push(["M",
r,p]),f.push(["M",r,p]),I=r,K=["C"],F=J);else null!==v?2<=D?("M"===l[D-1][0]&&l.push(["R"]),"M"===f[A-1][0]&&f.push(["R"]),D=l.length,A=f.length,q=l[D-1],m=q.length,l[D-1].push(r),l[D-1].push(p),f[A-1].push(r),f[A-1].push(p),J===c-1&&"R"===q[0]&&(e(l,!0,I,a),e(f,!1))):(l.push(["M",C,v]),l.push(["R",r,p]),f.push(["M",C,v]),f.push(["R",r,p]),I=C):null===v&&2<=D&&(q=l[D-1],"R"===q[0]&&(e(l,!0,I,a),e(f,!1)),l.push(["M",r,p]),f.push(["M",r,p]),I=r);q=l[l.length-1];k&&q&&(m=q.length,"Z"===q[m-1]||"R"!==
q[0]&&"C"!==q[0]||(e(l,!0,I,a),e(f,!1)));k||(l=g?l:f,2<=l.length&&e(l,!1));return{closedPath:l,openPath:f}},draw:function(){var b=this,a=b.JSONData,d=[],e=[],g=b.chart,e=g.getJobList(),l=g.components,k=l.canvas.config,h=b.config,q=g.config,f=b.index||b.positionIndex,p=q.categories,n=l.paper,r=l.xAxis[0],w=b.yAxis,v,H,D=g.graphics,F=D.datalabelsGroup,K=m.parseUnsafeString,I=m.getValidValue,J,L,M,N,O,Q,R=b.components.data,T,l=h.linethickness,S=b.graphics.container,aa=b.graphics.trackerContainer,ba=
D.trackerGroup,V=q.connectnulldata,q=q.showtooltip,W=D.datasetGroup,pa,D=h.shadow,U=b.graphics.dataLabelContainer,Z={},X,da,Z=g.get("config","animationObj"),g=Z.duration,ca=Z.animType,ea=b.components.removeDataArr||[],ia=ea.length,fa=b.components.pool||[],ga=function(){!1!==b.visible||!1!==b._conatinerHidden&&void 0!==b._conatinerHidden||(S.lineGroup.hide(),S.lineShadowGroup.hide(),S.anchorShadowGroup.hide(),S.anchorGroup.hide(),aa.hide(),U&&U.hide())},ma=function(){W.lineConnector.attr({"clip-rect":null});
W.lineConnector.node&&W.lineConnector.node.removeAttribute("clip-path");!1!==b.visible&&(S.lineShadowGroup.show(),S.anchorShadowGroup.show(),S.anchorGroup.show(),aa.show(),U&&U.show())},ka=b.config.animFlag=b.config.animFlag||(b.config.animFlag=!0),ja=k.clip["clip-canvas"].slice(0),k=k.clip["clip-canvas-init"].slice(0),la=null,oa,na=!1,ra=h.lineDashStyle,va={color:h.linecolor,alpha:h.alpha},Aa,qa,sa=Z.dummyObj,ua=Z.animObj,Ha=0,Z=b.graphics.SplineElement,za=b.visible;h.imagesLoaded=0;W.lineConnector=
W.lineConnector||n.group("line-connector",W);S||(S=b.graphics.container={lineShadowGroup:n.group("connector-shadow",W.lineConnector),anchorShadowGroup:n.group("anchor-shadow",W.lineConnector),lineGroup:n.group("spline",W.lineConnector),anchorGroup:n.group("anchors",W.lineConnector)},za||(S.lineShadowGroup.hide(),S.anchorShadowGroup.hide(),S.lineGroup.hide(),S.anchorGroup.hide()));aa||(aa=b.graphics.trackerContainer=n.group("line-hot"),za||aa.hide());R||(R=b.components.data=[]);ba&&ba.appendChild(aa);
U||(U=b.graphics.dataLabelContainer=b.graphics.dataLabelContainer||n.group("datalabel",F),za||U.hide());za&&(S.lineShadowGroup.show(),S.anchorShadowGroup.show(),S.lineGroup.show(),S.anchorGroup.show(),U.show(),aa.show());Aa=r.getCategoryLen();for(ba=0;ba<Aa;ba++)if(F=R[ba])da=F.config,N=da.setValue,M=da.setLink,O=da.setLevelTooltext,Z=da.anchorProps,X=Z.symbol,T=Z.shadow,Q=da.displayValue,F||(F=R[ba]={graphics:{}}),L=F.graphics.element,qa=F.graphics.image,H=F.graphics.label,v=F.graphics.hotElement,
null===N?(L&&L.hide(),H&&H.hide(),v&&v.hide(),qa&&qa.hide(),V||(la=null)):(v=r.getAxisPosition(ba),H=w.getAxisPosition(N),pa=da.hoverEffects,Z.isAnchorHoverRadius=pa.anchorRadius,!1===za&&g&&(H=w.getPixel(w.getAxisBase())),I(K(c(p[ba].tooltext,p[ba].label))),J=q?da.toolText+(O?"":da.toolTipValue):"",da.finalTooltext=J,O=da.eventArgs||(da.eventArgs={}),O.index=ba,O.link=M,O.value=N,O.displayValue=Q,O.categoryLabel=r.getLabel(ba).label,O.toolText=J,O.id=h.userID,O.datasetIndex=f||0,O.datasetName=a.seriesname,
O.visible=za,Z.imageUrl?(da.anchorImageLoaded=!1,L=new A,L.onload=b._onAnchorImageLoad(b,ba,O,v,H),L.onerror=b._onErrorSetter(b,ba),L.src=Z.imageUrl,Ha++):(qa&&qa.hide(),M=[X[1]||2,v,H,Z.radius,Z.startAngle,0],L||(fa.element&&fa.element.length?L=F.graphics.element=fa.element.shift():(L=F.graphics.element=n.polypath(S.anchorGroup),L.attr({polypath:M}))),L.show().animateWith(sa,ua,{polypath:M},g,ca,ka&&ga),L.attr({fill:t({color:Z.bgColor,alpha:Z.bgAlpha}),stroke:t({color:Z.borderColor,alpha:Z.borderAlpha}),
"stroke-width":Z.borderThickness,visibility:Z.radius?za:Ua}).shadow(T,S.anchorShadowGroup),ka=!1,pa.enabled&&(M={polypath:[pa.anchorSides||2,v,H,pa.anchorRadius,pa.startAngle,pa.dip],fill:t({color:pa.anchorColor,alpha:pa.anchorBgAlpha}),stroke:t({color:pa.anchorBorderColor,alpha:pa.anchorBorderAlpha}),"stroke-width":pa.anchorBorderThickness},T={polypath:[Z.sides,v,H,Z.radius,Z.startAngle,0],fill:t({color:Z.bgColor,alpha:Z.bgAlpha}),stroke:t({color:Z.borderColor,alpha:Z.borderAlpha}),"stroke-width":Z.borderThickness},
L&&L.data("anchorRadius",Z.radius).data("anchorHoverRadius",pa.anchorRadius).data(Na,M).data(ya,T)),da.trackerConfig||(da.trackerConfig={}),da.trackerConfig.trackerRadius=Ea(Z.radius,pa&&pa.anchorRadius||0,C)+(Z.borderThickness||0)/2),d.push({x:v,y:H,lastXPos:oa,lastYPos:la}),oa=v,la=H,F._xPos=v,F._yPos=H,!Z.imageUrl&&this.drawLabel(ba));h.noOfImages=h.totalImages=Ha;0===Ha&&(e.trackerDrawID.push(pb.addJob(b.drawTracker,b,[],m.priorityList.tracker)),e.labelDrawID.push(pb.addJob(b.drawLabel,b,[],m.priorityList.label)));
e=b.getSplinePath(d,w).closedPath;Z=b.graphics.SplineElement;2<=e.length?(Z||(Z=b.graphics.SplineElement=n.path(e,S.lineGroup),na=!0),Z.show().animateWith(sa,ua,{path:e},g,ca,ka&&ga),Z.attr({"stroke-dasharray":ra,"stroke-width":l,stroke:t(va),"stroke-linecap":"round"}).shadow(D,S.lineShadowGroup),ka=!1):Z&&Z.hide();g&&za&&na&&(S.anchorGroup.hide(),S.lineShadowGroup.hide(),S.anchorShadowGroup.hide(),U.hide(),W.lineConnector.attr({"clip-rect":k}).animateWith(sa,ua,{"clip-rect":ja},g,ca,ma));b.drawn=
!0;for(ba=0;ba<ia;ba++)b._removeDataVisuals(ea.shift())}},"Line"]);FusionCharts.register("component",["dataset","Bubble",{type:"bubble",configure:function(){var b=this.chart,a=b.components,b=b.jsonData.chart,d=this.JSONData,g=this.config,l=d.data||[],q,k,h,p,f;q=a.colorManager;k=this.index;var a=a.numberFormatter,n,r=m.parseUnsafeString,w=c(r(b.tooltipsepchar),", "),v,A,C,H,D,F,K=-Infinity,I=Infinity,J=-Infinity,M=Infinity,N=-Infinity,O=Infinity,Q,R=m.graphics.getPointColor;g.includeInLegend=e(d.includeinlegend,
1);g.seriesname=r(d.seriesname);g.anchorBgColor=c(d.color,d.plotfillcolor,b.plotfillcolor,q.getPlotColor(k));g.showPlotBorder=e(d.showplotborder,b.showplotborder,1);g.anchorBorderThickness=g.showPlotBorder?e(d.plotborderthickness,b.plotborderthickness,1):0;g.anchorBorderColor=ib(c(d.plotbordercolor,b.plotbordercolor,"666666"));g.plotFillAlpha=c(d.plotfillalpha,d.bubblefillalpha,b.plotfillalpha,"100");g.plotBorderAlpha=c(d.plotborderalpha,b.plotborderalpha,"95");g.negativeColor=c(b.negativecolor,"FF0000");
g.is3d=0!==e(b.use3dlighting,d.is3d,b.is3d);g.bubbleScale=e(b.bubblescale,1);g.minBubbleRadius=e(b.minbubbleradius);g.clipBubbles=e(b.clipbubbles,1);g.showRegressionLine=e(d.showregressionline,b.showregressionline,0);g.enableAnimation=q=e(b.animation,b.defaultanimation,1);g.animation=q?{duration:1E3*e(b.animationduration,1)}:!1;g.showTooltip=e(b.showtooltip,1);g.transposeAnimation=e(b.transposeanimation,q);g.transposeAnimDuration=1E3*e(b.transposeanimduration,.2);g.seriesNameInTooltip=e(b.seriesnameintooltip,
1);g.rotateValues=e(b.rotatevalues)?270:0;g.showHoverEffect=e(b.plothovereffect,b.showhovereffect,void 0);g.showValues=e(d.showvalues,b.showvalues,0);p=this.components.data=this.components.data||(this.components.data=[]);q=l.length;g.showRegressionLine&&(this.events={hide:this.hideRLine,show:this.showRLine},n={sumX:0,sumY:0,sumXY:0,sumXsqure:0,sumYsqure:0,xValues:[],yValues:[],isRegression:!0},g.showYOnX=e(d.showyonx,b.showyonx,1),g.regressionLineColor=ib(c(d.regressionlinecolor,b.regressionlinecolor,
g.anchorBgColor)),g.regressionLineThickness=e(d.regressionlinethickness,b.regressionlinethickness,1),g.regressionLineAlpha=ba(e(d.regressionlinealpha,b.regressionlinealpha,100)),g.regLineColor=L(g.regressionLineColor,g.regressionLineAlpha));g.fillColor=g.is3d?t(R(g.anchorBgColor,g.plotFillAlpha)):t({color:g.anchorBgColor,alpha:g.plotFillAlpha});g.strokeColor=t({color:g.anchorBorderColor,alpha:g.plotFillAlpha});for(k=0;k<q;k++)if(A=l[k],h=p[k]=p[k]||(p[k]={}),!h.graphics&&(h.graphics={}),C=h.config=
{},C.x=a.getCleanValue(A.x),C.y=a.getCleanValue(A.y),C.z=a.getCleanValue(A.z,!0),C.showValue=e(A.showvalue,g.showValues),C.anchorProps={},F=C.label=C.x,C.setLink=Ja(A.link),g.max=N=Ea(N,C.z||0),g.min=O=Va(O,C.z||0),C.is3d=0!==e(A.is3d,g.is3d),K=Ea(K,C.x),I=Va(I,C.x),J=Ea(J,C.y),M=Va(M,C.y),h=C.color=ib(c(A.color,0>A.z?g.negativeColor:g.anchorBgColor)),f=C.alpha=c(A.alpha,g.plotFillAlpha),C.colorObj=Q=C.is3d?R(h,f):{color:h,alpha:f},C.setDisplayValue=H=r(c(A.displayvalue,A.name,A.label)),v=C.formatedVal=
null===C.y?C.y:a.dataLabels(C.y),C.displayValue=c(H,C.formatedVal),C.setTooltext=m.getValidValue(r(c(A.tooltext,d.plottooltext,b.plottooltext))),g.showTooltip?null===v?H=!1:void 0!==C.setTooltext?(H=[4,5,6,7,8,9,10,11,12,13,118],v={yDataValue:v,xDataValue:a.xAxis(F),yaxisName:r(b.yaxisname),xaxisName:r(b.xaxisname),zDataValue:a.dataLabels(C.z)},H=m.parseTooltext(C.setTooltext,H,v,A,b,d)):(g.seriesNameInTooltip&&(D=m.getFirstValue(d&&d.seriesname)),H=D?D+w:"",H+=F?a.xAxis(F)+w:"",H+=v,H+=A.z?w+a.dataLabels(A.z):
""):H=!1,C.toolText=H,this.pointValueWatcher(C.x,C.y,g.showRegressionLine&&n),v=C.hoverEffects={},0!==g.showHoverEffect){F=v.enabled=void 0!==c(A.hoveralpha,d.hoveralpha,b.bubblehoveralpha,A.hovercolor,d.hovercolor,d.bubblehovercolor,b.bubblehovercolor,A.borderhovercolor,d.borderhovercolor,b.plotborderhovercolor,A.borderhoveralpha,d.borderhoveralpha,b.plotborderhoveralpha,A.hoverscale,d.bubblehoverscale,b.bubblehoverscale,A.borderhovercolor,d.borderhovercolor,b.plotborderhovercolor,A.borderhoverthickness,
d.borderhoverthickness,b.plotborderhoverthickness,A.negativehovercolor,d.negativeColor,b.negativecolor,A.is3donhover,b.plotfillhovercolor,d.is3donhover,b.is3donhover,void 0);v.negativeColor=c(A.negativehovercolor,d.negativehovercolor,b.negativehovercolor,g.negativeColor);v.is3d=e(A.is3donhover,d.is3donhover,b.is3donhover,C.is3d);v.color=c(A.hovercolor,d.hovercolor,d.bubblehovercolor,b.plotfillhovercolor,b.bubblehovercolor,C.is3d?Q.FCcolor.color:h);v.color=v.negativeColor&&0>A.z?v.negativeColor:v.color;
v.scale=c(A.hoverscale,d.hoverscale,d.bubblehoverscale,b.bubblehoverscale,1);v.color=ib(v.color);v.alpha=c(A.hoveralpha,d.hoveralpha,b.plotfillhoveralpha,b.bubblehoveralpha,f);v.borderColor=c(A.borderhovercolor,d.borderhovercolor,b.plotborderhovercolor,g.anchorBorderColor);v.borderAlpha=c(A.borderhoveralpha,d.borderhoveralpha,b.plotborderhoveralpha,v.alpha,g.plotBorderAlpha);v.borderThickness=e(A.borderhoverthickness,d.borderhoverthickness,b.plotborderhoverthickness,g.anchorBorderThickness);v.color=
v.is3d?R(v.color,v.alpha):{FCcolor:{color:v.color,alpha:v.alpha}};A=F&&g.showHoverEffect?0:g.showHoverEffect;if(1===A){C=(A="string"==typeof v.color)?v.color.split(/\s{0,},\s{0,}/):v.color.FCcolor.color.split(/\s{0,},\s{0,}/);f=C.length;for(h=0;h<f;h++)C[h]=ob(C[h],70);A?v.color=C.join(","):v.color.FCcolor.color=C.join(",")}!1===F&&(v.enabled=!!g.showHoverEffect)}else v.enabled=!1;g.xMax=K;g.xMin=I;g.yMin=M;g.yMax=J;g.regressionData=g.showRegressionLine&&this.getRegressionLineSeries(n,g.showYOnX,
q);this.visible=1===e(d.visible,!Number(d.initiallyhidden),1);this._addLegend()},init:function(b){this.yAxis=this.chart.components.yAxis[0];this.components={};this.graphics={};this.JSONData=b;this.configure()},_addLegend:function(){var b=this.config;this.legendItemId=this.chart.components.legend.addItems(this,this.legendInteractivity,{enabled:b.includeInLegend,fillColor:b.fillColor,strokeColor:b.strokeColor,rawFillColor:b.anchorBgColor,rawStrokeColor:b.anchorBorderColor,anchorSide:1,type:this.type,
label:b.seriesname})},draw:function(){var b=this,a=b.JSONData,c=gb.sqrt,d=b.chart,g=d.getJobList(),l=d.components,k=l.canvas.config,h=l.paper,q=d.config,f=d.graphics,q=Va(q.canvasHeight,q.canvasWidth)/8,p=f.datasetGroup,n,r,v=b.yAxis,l=l.xAxis[0],w=b.config;n=w._regressionAttr;var A,H,D,F;A=k.clip["clip-canvas"].slice(0);var K=k.clip["clip-canvas-init"].slice(0),I,k=b.components.data,J=b.components.removeDataArr||[],L=J.length,M=b.graphics.container,N=function(){!1===b.visible&&(M.bubbleGroup.hide(),
M.regLineGroup.hide(),pa.hide(),U.hide(),b._containerHidden=!0)};I=function(){b.visible&&(pa.attr({"clip-rect":null}),M.regLineGroup.attr({"clip-rect":null}))};var O=w.minBubbleRadius,R=w.bubbleScale,T=d.getDataLimits().zMax||0,T=c(T);F=w.clipBubbles;var S=d.get("config","animationObj"),d=S.duration;H=b.graphics.regressionLineElement;D=w.showRegressionLine;var ba=b.visible,aa=w.showTooltip,V=f.trackerGroup,W=f.datalabelsGroup,pa=b.graphics.dataLabelContainer,U=b.graphics.trackerContainer,Z,X;Z={};
var da,ca,f=!0,ea=S.dummyObj,ia=S.animObj,S=S.animType,fa=b.components.pool||{},ga=FusionCharts.get("component",["dataset","area"]).prototype.drawTracker,ma=w.anchorBorderThickness;Z=b.drawn;M||(M=b.graphics.container={bubbleGroup:h.group("bubble",p),regLineGroup:h.group("regLine",p)},ba||(M.bubbleGroup.hide(),M.regLineGroup.hide()));U||(U=b.graphics.trackerContainer=h.group("bubble-hot"),ba||U.hide());pa||(pa=b.graphics.dataLabelContainer=h.group("datalabel",W),pa.attr({"clip-rect":K}).animateWith(ea,
ia,{"clip-rect":A},d,S,I),ba||pa.hide());F?Z?M.bubbleGroup.animateWith(ea,ia,{"clip-rect":A},d,S):M.bubbleGroup.attr({"clip-rect":A}):(M.bubbleGroup.attr({"clip-rect":null}),M.bubbleGroup.node&&M.bubbleGroup.node.removeAttribute&&M.bubbleGroup.node.removeAttribute("clip-path"));V&&V.appendChild(U);ba&&(M.bubbleGroup.show(),M.regLineGroup.show(),pa.show(),U.show());D?(Z=w.regressionData[0],p=w.regressionData[1],n||(w._regressionAttr=n={}),n.stroke=t({color:w.regressionLineColor,alpha:w.regressionLineAlpha}),
n["stroke-width"]=w.regressionLineThickness,n["stroke-linecap"]="round",n["stroke-linejoin"]=2<w.regressionLineThickness?"round":"miter",n.path="M "+l.getAxisPosition(Z.x)+","+v.getAxisPosition(Z.y)+" L "+l.getAxisPosition(p.x)+","+v.getAxisPosition(p.y),H?H.animateWith(ea,ia,n,d,S):(H=b.graphics.regressionLineElement=h.path(n,M.regLineGroup),M.regLineGroup.attr({"clip-rect":K}),M.regLineGroup.animateWith(ea,ia,{"clip-rect":A},d,S,I))):H&&H.hide();p=0;for(K=k.length;p<K;p+=1)A=k[p],I=A.config,F=e(I.x,
p),V=I.y,H=I.z,n=A.graphics.element,W=I.setLink,X=I.displayValue,D=I.toolText,I.finalTooltext=I.toolText,Z=I.hoverEffects,n=A.graphics.element,r=A.graphics.hotElement,ca=A.graphics.label,null!==V?(r=I.eventArgs||(I.eventArgs={}),r.index=p,r.link=W,r.value=V,r.y=V,r.x=F,r.z=H,r.displayValue=X,r.toolText=D,r.id=b.userID,r.datasetIndex=b.index||0,r.datasetName=a.seriesname,r.visible=ba,D=v.getAxisPosition(V),F=l.getAxisPosition(F),H=c(H),H=ab(H*q/T)*R||0,O&&(H=Ea(H,O)),V=I.setRolloutAttr={fill:t(I.colorObj),
"stroke-width":w.anchorBorderThickness,stroke:t({color:w.anchorBorderColor,alpha:w.plotBorderAlpha}),r:H},!1!==Z.enabled&&(da=I.setRolloverAttr={fill:t(Z.color),"stroke-width":Z.borderThickness,stroke:t({color:Z.borderColor,alpha:Z.borderAlpha}),r:H*Z.scale}),b.visible||(H=0),n||(fa.element&&fa.element.length?n=A.graphics.element=fa.element.shift():(n=A.graphics.element=h.circle(M.bubbleGroup),n.attr({cx:F,cy:D,r:d?0:H}))),n.show().animateWith(ea,ia,{cx:F,cy:D,r:H||0},d,S,f&&N).attr({fill:t(I.colorObj),
ishot:!aa,"stroke-width":w.anchorBorderThickness,stroke:V.stroke,visibility:ba}),f=!1,I.trackerConfig||(I.trackerConfig={}),I.trackerConfig.trackerRadius=Ea(H+(ma||0),C),n.data(Na,da).data(ya,V),A._xPos=F,A._yPos=D):(n&&n.hide(),r&&r.hide(),ca&&ca.hide());g.trackerDrawID.push(pb.addJob(ga,b,[],m.priorityList.tracker));b.drawn?b.drawLabel():g.labelDrawID.push(pb.addJob(b.drawLabel,b,[],m.priorityList.label));b.drawn=!0;for(p=0;p<L;p++)b._removeDataVisuals(J.shift())},show:function(){var b=this.chart,
a=this.graphics.container,c=this.graphics.dataLabelContainer,d=this.graphics.trackerContainer;this.visible=!0;a.bubbleGroup.show();a.regLineGroup&&a.regLineGroup.show();c.show();d.show();b._setAxisLimits();b._drawAxis();b._drawDataset()},hide:function(){var b=this.chart;this.visible=!1;b._setAxisLimits();b._drawAxis();b._drawDataset()},getDataLimits:function(){var b=this.config,a=b.yMax,c=b.yMin,d=this.chart.config.transposeAxis,e=b.xMin,g=b.xMax,k=b.max,b=b.min;!1===this.visible&&d&&(a=-Infinity,
e=c=Infinity,g=-Infinity);return{max:a,min:c,xMin:e,xMax:g,zMax:k,zMin:b}},drawLabel:function(){var b=this.chart,c=b.config.dataLabelStyle,d=this.components.data,e=b.components.paper,g;g="";var l=this.config,k=b.get("config","animationObj"),b=k.duration,h=k.animType,m=k.animObj,k=k.dummyObj,l=l.rotateValues,f,q=this.graphics.dataLabelContainer,p,n,t,r,v,w,A,C,H=this.components.pool||{};w=0;for(A=d.length;w<A;w++)if(g=d[w])p=g.config,f=g.graphics,t=g._yPos,n=g._xPos,g=p.displayValue,v=f.label,C=p.showValue,
void 0!==g&&null!==g&&g!==a&&null!==p.z&&C?(g={text:g,fill:c.color,"text-bound":[c.backgroundColor,c.borderColor,c.borderThickness,c.borderPadding,c.borderRadius,c.borderDash],"line-height":c.lineHeight,visibility:Pa},v||(H.label&&H.label.length?v=f.label=H.label.shift():(g.x=n,g.y=t,g.transform=e.getSuggestiveRotation(l,n,t),v=f.label=e.text(g,q),r=!0)),r||(v.show().animateWith(k,m,{x:n,y:t,transform:e.getSuggestiveRotation(l,n,t)},b,h),v.attr(g))):v&&v.hide()},_hoverFunc:function(b,a,c){b=b.graphics.element;
a="DataPlotRollOut"===a?b.data(ya):b.data(Na);c&&b.attr(a)}},"scatter"]);FusionCharts.register("component",["dataset","Pie2D",{type:"pie2d",configure:function(){var b=this.chart,a=b.config,g=a.dataLabelStyle,l=this.config,q=this.JSONData,p=b.jsonData.chart,k=m.parseUnsafeString,h=b.is3D,t,f;this.__setDefaultConfig();n({},this.config,b&&b.config);f=l.enableAnimation=e(p.animation,p.defaultanimation,1);l.animation=f?{duration:1E3*e(p.animationduration,p.moveduration,1)}:!1;l.transposeAnim=f||e(l.transposeanimation,
1)?{duration:1E3*e(p.transposeanimduration,.2)}:!1;l.showPlotBorder=e(p.showplotborder,1);l.showHoverEffect=e(p.plothovereffect,p.showhovereffect,void 0);l.showTooltip=e(p.showtooltip,1);l.toolText=Ja(k(c(q.plottooltext,p.plottooltext)));f=l.enableMultiSlicing=e(p.enablemultislicing,1);t=l.use3DLighting=e(p.use3dlighting,1);l.radius3D=t?e(p.radius3d,90):100;l.showZeroPies=e(p.showzeropies,1);l.showPercentInToolTip=e(p.showpercentintooltip,1);l.showLabels=e(p.showlabels,1);l.showValues=e(q.showvalues,
p.showvalues,1);l.showPercentValues=e(p.showpercentvalues,p.showpercentagevalues,0);t=l.toolTipSepChar=c(p.tooltipsepchar,p.hovercapsepchar,d);l.labelSepChar=c(p.labelsepchar,t);l.pieBorderColor=c(p.plotbordercolor,p.piebordercolor);l.pieBorderAlpha=e(p.plotborderalpha,p.pieborderalpha);l.pieBorderThickness=l.showPlotBorder?e(p.plotborderthickness,p.pieborderthickness,a.plotborderthickness,1):0;l.plotDashLen=e(p.plotborderdashlen,5);l.plotDashGap=e(p.plotborderdashgap,4);l.showValueInLegend=e(p.showvalueinlegend,
0);l.showLabelInLegend=e(p.showlabelinlegend,1);l.valueBeforeLabelInLegend=e(p.valuebeforelabelinlegend,0);l.showValueAsPercentInLegend=e(p.showvalueaspercentinlegend,1);l.legendSepChar=c(p.legendsepchar,", ");l.showvalues=e(p.showvalues,1);l.chartPosition=O(b.linkedItems.container);l.timerThreshold=30;l.centerLabelConfig={label:k(c(p.defaultcenterlabel,"")),font:c(p.centerlabelfont,g.fontFamily),fontSize:e(p.centerlabelfontsize,parseInt(g.fontSize,10)),color:ib(c(p.centerlabelcolor,p.valuefontcolor,
a.style.inCanvasStyle.color,"555555")),alpha:e(p.centerlabelalpha,100),bold:e(p.centerlabelbold,g.fontWeight),italic:e(p.centerlabelitalic,g.style),bgColor:c(p.centerlabelbgcolor,""),bgAlpha:e(p.centerlabelbgalpha,100),borderColor:c(p.centerlabelbordercolor,g.borderColor),borderAlpha:e(p.centerlabelborderalpha,100),borderThickness:e(p.centerlabelborderthickness,g.borderThickness),borderRadius:e(p.centerlabelborderradius,g.borderRadius),textPadding:e(p.centerlabeltextpadding,g.borderPadding),padding:e(p.centerlabelpadding,
2),bgOval:e(p.centerlabelbgoval,0),shadow:e(p.showcenterlabelshadow,0),hoverColor:p.centerlabelhovercolor&&ib(c(p.centerlabelhovercolor)),hoverAlpha:e(p.centerlabelhoveralpha),toolText:k(c(p.centerlabeltooltext,""))};l.showLegend=e(p.showlegend,0);l.reverselegend=!e(p.reverselegend,0);b.is3D=h;l.pieYScale=e(p.pieyscale,40);1>l.pieYScale&&(l.pieYScale=1);100<=l.pieYScale&&(l.pieYScale=80);l.pieYScale/=100;l.pieSliceDepth=e(p.pieslicedepth,15);1>l.pieSliceDepth&&(l.pieSliceDepth=1);l.managedPieSliceDepth=
l.pieSliceDepth;l.enableMultiSlicing=!!f;l.startAngle=e(p.startingangle,0)*-(Bb/180);l.usePerPointLabelColor=p.colorlabelsfromplot==T;l.reversePlotOrder=e(p.reverseplotorder,0);l.animateClockWise=e(p.animateclockwise,l.reversePlotOrder);l.showShadow=e(p.showshadow,1);l.singletonCase=1===q.data.length;l.valueTotal=0;this._setConfigure();this._addLegend()},_parseDisplayProperties:function(b,a){var d,g,l="",m,k,h,q,f,p,n;d=this.chart;var t=d.components.numberFormatter,r=d.jsonData.chart;q=this.config;
k=e(a.y,t.getCleanValue(b.value,!0));var v=q.valueTotal;h=q.showLabels;var w=K(c(a.seriesName,b.label,b.name,""));p=q.showPercentValues;m=q.showPercentInToolTip;var A=q.labelSepChar,C=q.toolTipSepChar,H=q.showTooltip;d=Ja(K(c(b.tooltext,q.toolText)));g=a.pValue=t.percentValue(k/v*100);k=a.value=t.dataLabels(k)||"";h=1===e(b.showlabel,h)?w:"";q=1===(n=e(b.showvalue,q.showValues))?1===p?g:k:"";m=m?g:k;f=Ja(K(b.displayvalue));p=c(f,w+A+(p?g:k),"");q=void 0!==f&&n?f:""!==q&&""!==h?h+A+q:c(h,q);H&&(void 0!==
d?l=ea(d,[1,2,3,5,6,7,14,24,25],{formattedValue:k,label:w,yaxisName:K(r.yaxisname),xaxisName:K(r.xaxisname),percentValue:g,sum:t.dataLabels(v),unformattedSum:v},b,r):(l=w,l=""!=l?l+C+m:m));a.displayValue=q;a.displayValueArgs=p;a.toolText=l;a.seriesName=w;a.categoryLabel=h},foldingFn:function(b){b=b.data("plotItem");return{ringpath:[b.center[0],b.center[1],b.radius,b.innerDiameter/2,b.angle,b.angle]}},_isStyled:function(b){if(this.chart.config.usedataplotcolorforlabels||b.labelbordercolor||b.labelbgcolor||
b.labelborderthickness||b.labelborderalpha||b.labelalpha||b.labelfont||b.labelfontsize||b.labelfontcolor||b.labelfontalpha||b.labelalpha||b.labelfontbold||b.labelfontitalic||b.labelborderpadding||b.labelborderradius||b.labelbgalpha||b.labelborderdashed||b.labelborderdashlen||b.labelborderdashgap)return!0},_setConfigure:function(b,a){var d,g,m,q,k,h,p,f,n,t,r,w,A,C,H,D,F,J;k=this.chart;var M=k.jsonData.chart,N=k.components;q=N.legend;var O=k.config,S=this.config,ba=this.JSONData;g=(t=(b||ba).data)&&
t.length;w=S.showZeroPies;var ba=S.valueTotal||0,Q=[],R=e(M.plotborderdashed,0),V=this.components.data||(this.components.data=[]),pa=N.numberFormatter,N=N.colorManager,ea=S.labelInLeg,ia=S.valInLeg,ha=S.centerLabelConfig,W=S.pieBorderThickness,ga=S.reversePlotOrder,U=S.radius3D,Z=S.enableMultiSlicing,X=S.lastSlicedid||0,da=e(M.plotBorderDashed,5),ca=e(M.plotborderdashgap,4),ka=e(M.valuebeforelabelinlegend,0),na=e(M.showvalueaspercentinlegend,1);J=0;var fa=c(M.legendsepchar,", ");k=k.get("config",
"animationObj");n=k.duration||0;h=k.dummyObj;f=k.animObj;r=k.animType;O.dataLabelStyle=v({},{},M,O.dataLabelStyle,p);for(k=0;k<g;k+=1)p=t[k],m=pa.getCleanValue(p.value,!0),null===m||!w&&0===m?J+=1:(Q.push(p),ba+=m);if(J&&V.length>g-J)for(q&&q.emptyItems(V.length-J),k=V.length-1;0<J;--k,--J)if(V[k]){p=V[k];g=p.config;m=p.graphics;for(d in m)q=m[d],q.animateWith(h,f,this.foldingFn.call(this,q),n,r,this.hideFn.call(this,m,d,this));g.y=null;p.legendItemId=void 0}0===ba&&(Q=[]);S.valueTotal=ba;S.dataLabelCounter=
0;O.allPlotSliceEnabled=O.enableslicing;for(k=(g=Q.length)-1;0<=k;--k){m=k;b?(J=Q[k],m=void 0!==a?a+k:V.length-g+k,p=V[m]):(p=V[k]||(V[k]={graphics:{},config:{}}),J=Q[k]);d=p&&p.config;d||(d=V[m].config={});p.graphics||(V[m].graphics={});d.y=m=pa.getCleanValue(J.value,!0);d.seriesName=h=K(c(J.label,J.name,""));p=c(J.color,N.getPlotColor(k));q=c(J.alpha,M.plotfillalpha,aa);f=d.borderConfig=this._parseBorderConfig(p,q,J);n=f.setPlotBorderColor;f=f.setPlotBorderAlpha;t={opacity:Ea(q,f)/100};if(w=!!e(J.issliced,
M.issliced,0))Z||(-1!==X&&(V[V.length-X-1].sliced=!1),S.lastSlicedid=k),S.preSliced=w;C=(r=e(J.dashed,R))?I(c(J.dashlen,da),c(J.dashgap,ca),W):"none";this._parseDisplayProperties(J,d);r=ea?h:"";ia&&(m=na?pa.legendPercentValue(m/ba*100):pa.legendValue(m),r=ka?m+(r&&fa+r):(r&&r+fa)+m);(m=d.displayValue)&&(S.dataLabelCounter+=1);D=d.value;H=d.pValue;m={label:c((A=J.centerlabel||M.centerlabel)&&this.replaceMacros(A,["\\$value","\\$percentValue","\\$displayValue","\\$label"],[D,H,void 0===m?"":m,h]),""),
font:ha.font,fontSize:e(J.centerlabelfontsize,ha.fontSize),color:ib(c(J.centerlabelcolor,ha.color)),alpha:e(J.centerlabelalpha,ha.alpha),bold:e(J.centerlabelbold,ha.bold),italic:e(J.centerlabelitalic,ha.italic),bgColor:c(J.centerlabelbgcolor,ha.bgColor),bgAlpha:e(J.centerlabelbgalpha,ha.bgAlpha),borderColor:c(J.centerlabelbordercolor,ha.borderColor),borderAlpha:e(J.centerlabelborderalpha,ha.borderAlpha),borderThickness:ha.borderThickness,borderRadius:ha.borderRadius,textPadding:ha.textPadding,padding:ha.padding,
bgOval:ha.bgOval,shadow:ha.shadow,hoverColor:(F=c(J.centerlabelhovercolor,ha.hoverColor))&&ib(F),hoverAlpha:e(J.centerlabelhoveralpha,ha.hoverAlpha),toolText:c(J.centerlabeltooltext,"")};this._isStyled(J)?d.style=v(J,{},M,O.dataLabelStyle,p):d.style&&delete d.style;d.showInLegend=""!==r;d.isVisible=!0;d.name=r;d.shadow=t;d.setColor=p;d.color=this._getPointColor(p,q,U);d._3dAlpha=q;d.borderColor=L(n,f);d.borderWidth=W;d.link=Ja(J.link);d.sliced=w;d.dashStyle=C;(d.doNotSlice=c(J.enableslicing,O.enableslicing)!=
T)||O.allPlotSliceEnabled!==l||(O.allPlotSliceEnabled=T);this._parseHoverEffectOptions(k);d.centerLabelConfig=m;d.radius3D=U}ga&&V&&V.reverse();S.dataArr=Q;S.enableRotation=1<V.length?e(M.enablerotation,1):0},_parseHoverEffectOptions:function(b){var a,d,g,l,m,k,h,q,f;k=this.chart.jsonData.chart;d=this.config;var p=this.components.data[b].config;h=this.JSONData;q=h.data[b];g=p.setColor;l=p._3dAlpha;b=d.radius3D;f=p.borderConfig;m=f.setPlotBorderAlpha;var n=f.setPlotBorderColor;f=d.setBorderWidth;d=
e(p.hovereffect,d.showHoverEffect);p=p.hoverEffects={enabled:d};void 0===d&&(d=p.enabled=void 0!==c(q.hovercolor,h.hovercolor,k.plotfillhovercolor,q.hoveralpha,h.hoveralpha,k.plotfillhoveralpha,q.borderhovercolor,h.borderhovercolor,k.plotborderhovercolor,q.borderhoveralpha,h.borderhoveralpha,k.plotborderhoveralpha,k.plotfillhoveralpha,q.borderhoverthickness,h.borderhoverthickness,k.plotborderhoverthickness,void 0));if(d){a=e(q.highlightonhover,h.highlight,k.highlight,1);(d=c(q.hovercolor,h.hovercolor,
k.plotfillhovercolor))&&a&&(a=0);d=c(d,g);g=c(q.hoveralpha,h.hoveralpha,k.plotfillhoveralpha,l);l=c(q.borderhovercolor,h.borderhovercolor,k.plotborderhovercolor,n);m=c(q.borderhoveralpha,h.borderhoveralpha,k.plotborderhoveralpha,k.plotfillhoveralpha,m);k=e(q.borderhoverthickness,h.borderhoverthickness,k.plotborderhoverthickness,f);d.replace(/,+?$/,"");if(1===a){q=(h="string"==typeof d)?d.split(/\s{0,},\s{0,}/):d.color.split(/\s{0,},\s{0,}/);f=q.length;for(a=0;a<f;a++)q[a]=ob(q[a],70);h?d=q.join(","):
d.color=q.join(",")}this._setHoverColor(p,d,g,b);p.borderColor=L(l,m);p.borderWidth=k}else p.enabled=!1},_setHoverColor:function(b,a,c,d){b.color=this._getPointColor(a,c,d)},replaceMacros:function(b,a,c){for(var d=a.length||0,e;d--;)e=new RegExp(a[d],"gi"),b=b.replace(e,c[d]);return b},containsMacro:function(b,a){for(var c=a.length||0,d;c--;)if(d=new RegExp(a[c],"gi"),d=b.match(d))return!0;return!1},updateData:function(b,a){this.config.valueTotal-=this.components.data[a].config.y;this.__base__.updateData.apply(this,
arguments)},_parsePiePlotOptions:function(){var b=this.config;return{size:b.pieMinRadius,slicedOffset:b.slicingDistance}},_parseDataLabelOptions:function(){return{style:this.chart.config.dataLabelStyle}},_addLegend:function(){var b,a,c,d=this.chart.components.legend,g=this.components.data;for(b=0;b<g.length;b+=1)c=g[b],a=c.config,null!==a.y&&(c.legendItemId=d.addItems(this,this.legendInteractivity,{index:b,fillColor:t(a.setColor),strokeColor:t(a.borderColor),type:this.type,label:a.seriesName,enabled:e(a.includeInLegend,
1),legendItemId:c.legendItemId}))},_parseBorderConfig:function(b,a,d){var e=this.chart.jsonData.chart,g=c(d.bordercolor,this.config.pieBorderColor);d=c(d.borderalpha,e.plotborderalpha,e.pieborderalpha);g=c(g,ob(b,25)).split(",")[0];d=e.showplotborder==l?l:c(d,a,"80");return{setPlotBorderColor:g,setPlotBorderAlpha:d}},_getPointColor:function(b,a,c){var d,e;b=ib(b);a=ba(a);100>c&&ga?(d=Math.floor(85*(100-.35*c))/100,d=S(b,d),e=Math.floor(50*(100+c))/100,b=ob(b,e),a={color:b+","+d,alpha:a+","+a,ratio:c+
","+(100-c),radialGradient:!0,gradientUnits:"userSpaceOnUse"}):a={color:b+","+b,alpha:a+","+a,ratio:"0,100"};return a},hideElements:function(){var b=this.data&&this.data("plotItem").chart,a=0,c=this._&&this._.shadows||[];if(b&&b.components.dataset[0])for(this.hide();a<c.length;a+=1)c[a].hide()},hideFn:function(b,a){return function(){b[a].hide()}},singleFillColor:function(b){return t({color:ib(b.color),alpha:ba(b.alpha)})},draw:function(){var b,a,c=this.chart,d=c.getJobList(),e=c.graphics,g=c.config,
k=g.dataLabelStyle,h=c.graphics,l=this.config,f=l.showShadow,q=c.components.paper,p=this.components,n=p.data,r=p.removeDataArr||[],v,w,A,C,H;v=g.style;v=e.datasetGroup.trackTooltip(!0);var D=this.graphics,F=this.pool,K=D.container,I=this.visible,L=D.shadowContainer;w=e.datalabelsGroup;var M=D.dataLabelContainer,N,O,S,T,ba,V,aa,W,pa,U=p.data||[],Z=U.length,p=g.canvasLeft+.5*g.canvasWidth,e=g.canvasTop+.5*g.canvasHeight,X=h.datasetGroup;C=g.alphaanimation;var da=!1,h=function(){da||(da=!0,M.show(),
X.animateWith(Ga,Ja,{opacity:1},Da,Ia))},ca=function(){var b,c;if(a)for(b=0;b<Z;b+=1)c=U[b],c.graphics.element&&c.graphics.element.attr({fill:t(c.config.color)})};N=function(){var b=l.pieCenter||[],a={cx:b[0],cy:b[1],r:(l.piePlotOptions||[]).size,r2:.5*(l.innerSize||0)};return function(b){var c,d=!1;for(c in b)if(5<Ra(b[c]-a[c])){d=!0;break}return d}}();O=function(){da||ca()};var ea=c._plotDragMove,ia=c._plotDragStart,fa=c._plotDragEnd,ga=c._plotRollOver,ma=c._plotRollOut,ka=!!l.enableRotation,ja=
l.piePlotOptions=this._parsePiePlotOptions(),g=g.textDirection,la=l.dataLabelOptions,oa=ja.slicedOffset,na,ja=ja.size,ra=.5*(l.innerSize||0),va=(l.startAngle||0)%zb,Aa,qa,sa,ua=va-zb,ya=l.animateClockWise,za=c.get("config","animationObj"),Da=za.duration||0,Ga=za.dummyObj,Ja=za.animObj,Ia=za.animType,Ea;K?(sa=!0,Da&&(Aa=O),a=N({cx:p,cy:e,r:ja,r2:ra})):(v.pie=q.group("pie",v),v.pieLabels=q.group("pie",v),K=D.container={lineShadowGroup:q.group("connector-shadow",v.pieLabels),anchorShadowGroup:q.group("anchor-shadow",
v.pieLabels),pieGroup:D.pieContainer=q.group("pie",v.pie),dataLabel:q.group("dataLabel",v.pie)},L=D.shadowContainer=v.shadows||(v.shadows=q.group("shadows",K.pieGroup).toBack()),M=D.dataLabelContainer=this.graphics.dataLabelContainer||q.group("datalabel",w).trackTooltip(!0),Da&&(Aa=h,M.hide()));M.css(k);I||(K.lineShadowGroup.hide(),K.anchorShadowGroup.hide(),K.pieGroup.hide(),K.dataLabel.hide(),L.hide(),M.hide());C&&X.attr({opacity:0});r.length&&this.remove();K=l.valueTotal;I=zb/K;l.pieCenter=[p,
e];N=r=va;d.labelDrawID.push(pb.addJob(c.placeDataLabels,c,[!1,n,l],m.priorityList.label));for(d=0;d<Z;d+=1)if(v=U[d],H=v.graphics,O=v.config,(za=O._textAttrs)||(za=O._textAttrs={}),S=O.y,T=O.displayValue,ba=O.sliced,w=O.toolText,C=!!O.link,v=O.style,V=C||ka||!O.doNotSlice,null!==S&&void 0!==S&&!1!==O.isVisible){N=O.color;N.r=ja;N.cx=p;N.cy=e;N=r;r-=l.singletonCase?zb:S*I;aa=.5*(r+N);A=H.element;W=H.label;na=H.connector;if(!A){A=F&&F.element.length?H.element=F.element.splice(0,1)[0].show():H.element=
q.ringpath(D.pieContainer).attr({"stroke-linejoin":"round",ishot:V}).drag(ea,ia,fa).hover(ga,ma);if(sa){if(d<Z)for(qa=void 0,b=d+1;b<Z&&void 0===qa;b+=1)qa=U[b].config.endAngle;void 0===qa&&(qa=ua)}else qa=ya?ua:va;A.attr({ringpath:[p,e,ja,ra,qa,qa]})}void 0!==T?(v?((Ea=O._textCss)||(Ea=O._textCss={}),Ea.fontFamily=v.fontFamily,Ea.fontSize=v.fontSize,Ea.lineHeight=v.lineHeight,Ea.fontWeight=v.fontWeight,Ea.fontStyle=v.fontStyle):O._textCss&&(W&&W.removeCSS(),delete O._textCss,Ea=void 0),O.style=v||
(v=k),za.text=T,za.fill=v.color||"#000000",za["text-bound"]=[v.backgroundColor,v.borderColor,v.borderThickness,v.borderPadding,v.borderRadius,v.borderDash],za.direction=g,za.lineHeight=v.lineHeight,W?(Ea&&(W.css(Ea),delete Ea.fontFamily,delete Ea.fontSize,delete Ea.lineHeight,delete Ea.fontWeight,delete Ea.fontStyle,Ea=void 0),delete za.ishot):F&&F.label.length?W=H.label=F.label.splice(0,1)[0]:za.ishot=V,0<la.distance&&(pa=la.connectorWidth)&&la.enableSmartLabels?(na||(na=F&&F.connector.length?H.connector=
F.connector.splice(0,1)[0]:H.connector=q.path("M 0 0 l 0 0",M).attr({visibility:tb,ishot:!0}).drag(ea,ia,fa).hover(ga,ma)),na.attr({"stroke-width":pa,stroke:la.connectorColor||"#606060"}).show()):na&&na.hide()):(za.visibility="hidden",W&&W.hide(),na&&na.hide());v=O.plotItem={chart:c,index:d,seriesData:l,value:S,angle:O.angle=aa,angle1:O.startAngle=r,angle2:O.endAngle=N,slicedX:jb(aa)*oa,slicedY:vb(aa)*oa,sliced:ba,labelText:T,toolText:w,name:O.name,link:O.link,percentage:K?S*K/100:0,originalIndex:Z-
d-1,style:O.style,color:t(O.color),borderColor:O.borderColor,borderWidth:O.borderWidth,rolloverProperties:O.hoverEffects,radius:ja,center:[p,e],innerDiameter:2*ra,centerLabelConfig:O.centerLabelConfig,graphic:A,isVisible:O.isVisible,label:W,connector:na,transX:O.transX=jb(aa)*oa,transY:O.transY=vb(aa)*oa,slicedTranslation:O.slicedTranslation="t"+jb(aa)*oa+","+vb(aa)*oa};H={index:l.reversePlotOrder?Z-1-d:d,link:O.link,value:O.y,displayValue:O.displayValueArgs,categoryLabel:O.categoryLabel,isSliced:ba,
toolText:w};A.animateWith(Ga,Ja,{ringpath:[p,e,ja,ra,r,N]},Da,Ia,Aa);A.attr({"stroke-width":O.borderWidth,stroke:O.borderColor,fill:J||sa&&a?this.singleFillColor(O.color):t(O.color),"stroke-dasharray":O.dashStyle,redrawDataLabels:va,cursor:C?"pointer":"",transform:v.sliced?v.slicedTranslation:""}).show().shadow(f&&O.shadow,L).tooltip(w).data("plotItem",v).data("eventArgs",H);za.plotItem=v;za.eventArgs=H;na&&na.data("plotItem",v).data("eventArgs",H)}Da?sa&&c.placeDataLabels(!1,n,l):(ca(),h())},remove:function(){var b=
this.components.removeDataArr||[],a=this.pool=this.pool={},c=b.length,d=this.config,e,g=d.pieCenter,k,h=g[0],g=g[1],l=this.hideElements,f=d.pieMinRadius,m=.5*(d.innerSize||0),q,d=d.startAngle-zb;q=this.chart.get("config","animationObj");var p=q.duration||0,n=q.dummyObj,t=q.animObj,r=q.animType;for(q=0;q<c;q++){e=b[0];e=e.graphics;for(k in e)e[k].data("plotItem"),e[k].animateWith(n,t,{ringpath:[h,g,f,m,d,d+.01]},p,r,l),a[k]||(a[k]=[]),a[k].push(e[k].hide());b.splice(0,1)}},legendInteractivity:function(b,
a){b.chart._plotGraphicClick.call(b.components.data[a.configuration.index].graphics.element)},init:function(b){var a=this.chart;if(!b)return!1;this.JSONData=b;this.chartGraphics=a.chartGraphics;this.components={};this.graphics={};this.visible=1===e(this.JSONData.visible,!Number(this.JSONData.initiallyhidden),1);this.configure()},_getInnerSize:function(){var a,c=this.config,d=this.chart.jsonData.chart;a=e(d.doughnutradius,0);var d=e(d.use3dlighting,1)?e(d.radius3d,d["3dradius"],50):100,g,l,m;g=c.pieMinRadius;
100<d&&(d=100);0>d&&(d=0);a=0>=a||a>=g?g/2:a;c.innerRadius=a;if(0<d&&ga&&(c=parseInt(a/g*100,10),g=(100-c)/2,d=parseInt(g*d/100,10),d=c+","+d+","+2*(g-d)+","+d,this&&(m=this.components.data)))for(c=0,g=m.length;c<g;c+=1)l=m[c],l=l.config,l.color&&(l.color.ratio=d,l.hoverEffects&&l.hoverEffects.color&&(l.hoverEffects.color.ratio=d));return 2*a},getEventArgs:function(a){a=a.configuration.index;var c=this.components.data[a].config||{};return{datasetName:c.seriesName,datasetIndex:a,id:c.userID,visible:c.isVisible,
label:c.seriesName,value:c.value,percentValue:c.pValue,tooltext:c.toolText,link:c.link,sliced:c.sliced}}},"area"]);FusionCharts.register("component",["dataset","Pie3D",{type:"pie3d",_parsePie3DOptions:function(){var a=this.config;return{size:2*a.pieMinRadius,slicedOffset:a.slicingDistance,allowPointSelect:!0,cursor:"pointer",innerSize:"pie3d"===this.type?0:this._getInnerSize()}},_parseBorderConfig:function(a,d,e){var g=this.chart.jsonData.chart,m=c(e.bordercolor,this.config.pieBorderColor);e=c(e.borderalpha,
g.plotborderalpha,g.pieborderalpha);m=c(m,ob(a,90)).split(",")[0];e=g.showplotborder==l?l:c(e,d,"80");return{setPlotBorderColor:m,setPlotBorderAlpha:e}},_setHoverColor:function(a,c,d){a.color=c;a.alpha=d},draw:function(){var b,c,d=this.pool||(this.pool={}),e=this.components,g=this.config,l=this.chart,k=l.get("config","animationObj"),h=k.duration||0,m=k.dummyObj,f=k.animObj,q=k.animType,p=l.config;b=l.graphics;var n=e.data,k=g.dataLabelOptions,r=k.style,v=l.components.paper,w=p.tooltip||{},w=w&&!1!==
w.enabled,A=g.slicingDistance,C=g.slicedOffsetY||(g.slicedOffsetY=A*g.pieYScale),H=l._plotDragMove,D=l._plotDragStart,F=l._plotDragEnd,K=l._plotRollOver,I=l._plotRollOut,J=!!g.enableRotation,L=g.showBorderEffect,M=n.length,N=g.usePerPointLabelColor,O=p.textDirection,S,T,ba,V,aa,pa,U,Z,X,da,ca,ea,ia;c=e.removeDataArr||[];var fa;ca=this.visible;var ga,ma,ka=!1,ja=this.graphics.dataLabelContainer,la=(g.startAngle||0)%zb,oa,na,ra,va=la-zb,za=g.animateClockWise,qa,sa,ua,ya=b.datasetGroup;ga=p.alphaanimation;
var Da=function(){ja.show();l.placeDataLabels(!1)},Ea=function(){ka||(ka=!0,ya.animateWith(m,f,{opacity:1},h,q,Da))};sa=function(){var a,b;if(!ka)for(Ea(),a=0;a<M;a+=1)b=n[a],b.graphics.element&&b.graphics.element.attr({fill:t(b.config.color)})};p=p.dataLabelStyle;ja?(ra=!0,h&&(Z=h,oa=sa)):(ja=this.graphics.dataLabelContainer=v.group("datalabel",b.datalabelsGroup).trackTooltip(!0),h&&(oa=Ea,Z=h,ja.hide(),ga&&ya.attr({opacity:0})));ja.css(p);ca||ja.hide();c.length&&this.remove();l._preDrawCalculate();
b=g.center;c=g.pieYScale;n&&M||(n=[]);for(ga=-1;++ga<M;)if(r=n[ga],ca=r.config,(sa=ca._textAttrs)||(sa=ca._textAttrs={}),ea=r.graphics,S=ca.y,T=ca.displayValue,V=ca.sliced,X=ca.shapeArgs,pa=ca.centerAngle,da=ca.toolText,ba=!!ca.link,r=ca.style,aa=ba||J||!ca.doNotSlice,null!==S&&void 0!==S){qa=ea.element;ia=ea.label;fa=ea.connector;if(!qa){qa=ea.element=e.Pie3DManager.useSliceFromPool();if(ra){if(ga<M)for(na=void 0,ma=ga+1;ma<M&&void 0===na;ma+=1)na=n[ma].config.shapeArgs.end;void 0===na&&(na=la)}else na=
za?la:va;qa||(qa=ea.element=e.Pie3DManager.createSlice().drag(H,D,F).mouseover(K).mouseout(I).attr({ishot:aa}));qa.attr({start:-na,end:-na,cx:b[0],cy:b[1],r:b[2],innerR:b[3],radiusYFactor:c})}void 0!==T?(r?((ua=ca._textCss)||(ua=ca._textCss={}),ua.fontFamily=r.fontFamily,ua.fontSize=r.fontSize,ua.lineHeight=r.lineHeight,ua.fontWeight=r.fontWeight,ua.fontStyle=r.fontStyle):ca._textCss&&(ia&&ia.removeCSS(),delete ca._textCss,ua=void 0),ca.style=r||(r=p),sa.text=T,sa.fill=(N?t(ca.color):r.color)||"#000000",
sa["text-bound"]=[r.backgroundColor,r.borderColor,r.borderThickness,r.borderPadding,r.borderRadius,r.borderDash],sa.direction=O,sa.lineHeight=r.lineHeight,ia?(ua&&(ia.css(ua),delete ua.fontFamily,delete ua.fontSize,delete ua.lineHeight,delete ua.fontWeight,delete ua.fontStyle,ua=void 0),delete sa.ishot):d&&d.graphics&&d.graphics.label&&d.graphics.label.length?ia=ea.label=d.graphics.label.splice(0,1):sa.ishot=aa,0<k.distance&&(U=k.connectorWidth)&&k.enableSmartLabels?(fa||(fa=d&&d.graphics&&d.graphics.connector&&
d.graphics.connector.length?ea.connector=d.graphics.connector.splice(0,1):ea.connector=v.path("M 0 0 l 0 0",ja).attr({visibility:"hidden",ishot:aa}).drag(H,D,F).hover(K,I)),fa.attr({"stroke-width":U,stroke:k.connectorColor||"#606060",cursor:ba?"pointer":""}).show()):fa&&fa.hide()):(ia&&ia.hide(),fa&&fa.hide());S={chart:l,index:ga,seriesData:g,value:S,angle:ca.angle=pa,link:ca.link,shapeArgs:X,slicedX:V&&!g.singletonCase?jb(pa)*A:0,slicedY:V&&!g.singletonCase?vb(pa)*C:0,sliced:V,labelText:T,name:ca.name,
percentage:ca.percentage,toolText:da,originalIndex:M-ga-1,style:ca.style,graphic:qa,transX:ca.transX=jb(pa)*A,transY:ca.transY=vb(pa)*C,slicedTranslation:ca.slicedTranslation="t"+ca.transX+","+ca.transY,label:ia,connector:fa};r={index:g.reversePlotOrder?ga:M-1-ga,link:ca.link,value:ca.y,displayValue:ca.displayValueArgs,categoryLabel:ca.categoryLabel,isSliced:ca.sliced,toolText:ca.toolText};qa.attr({transform:"t"+S.slicedX+","+S.slicedY,cursor:ba?"pointer":"",color:ca.color.color.split(",")[0],alpha:ca._3dAlpha,
borderWidth:ca.borderWidth,borderColor:ca.borderColor,showBorderEffect:L}).animateWith(m,f,{start:X.start,end:X.end,r:b[2],innerR:b[3],cx:b[0],cy:b[1],radiusYFactor:c},Z,q,oa).tooltip(w?da:a).data("groupId",ga).data("plotItem",S).data("eventArgs",r);sa.plotItem=S;sa.eventArgs=r;fa&&fa.data("plotItem",S).data("eventArgs",r)}!h&&Da()},hideFn:function(a,c,d){var e=d&&d.components||{};return function(){c===Ia?(e.Pie3DManager.removeSlice(a.element),delete a.element):a[c].hide()}},remove:function(){var a=
this.chart,c=this.config,d=this.components.removeDataArr||[],e=this.pool=this.pool=[],g=d.length,l,k,h,m,f=this.hideFn,c=c.startAngle;h=a.get("config","animationObj");var a=h.duration||0,q=h.dummyObj,p=h.animObj,n=h.animType;for(h=0;h<g;h++){l=d[0];l=l.graphics;for(k in l)m=l[k],e[k]||(e[k]=[]),k===Ia?m.animateWith(q,p,{start:-c,end:-c+.01},a,n,f(l,k,this)):e[k].push(m.hide());d.splice(0,1)}},foldingFn:function(){var a=this.config.startAngle;return{start:-a,end:-a+.01}},_getPointColor:function(a,
c){a=ib(a);c=ba(c);return{color:a+","+a,alpha:c+","+c,ratio:"0,100"}}},"pie2D",{setBorderWidth:void 0,showBorderEffect:void 0}]);FusionCharts.register("component",["dataset","Doughnut2D",{type:"doughnut2d",_getPointColor:function(a,c,d){var e;a=ib(a);c=ba(c);100>d&&ga?(e=S(a,hb(100*(85-.2*(100-d)))/100),a=ob(a,hb(100*(100-.5*d))/100),c={color:e+","+a+","+a+","+e,alpha:c+","+c+","+c+","+c,radialGradient:!0,gradientUnits:"userSpaceOnUse",r:d}):c={color:a+","+a,alpha:c+","+c,ratio:"0,100"};return c},
_parsePiePlotOptions:function(){var a=this.__base__._parsePiePlotOptions.call(this);a.innerSize=this._getInnerSize();return a},draw:function(){var a=this.chart,c=a.config,d=this.config,e=c.canvasLeft+.5*c.canvasWidth,c=c.canvasTop+.5*c.canvasHeight,g,l=d.centerLabelConfig,k=l.label;g=.5*((d.innerSize=this._getInnerSize())||0);this.__base__.draw.call(this);k&&g&&a.drawDoughnutCenterLabel(k,e,c,2*g,2*g,l,!0);d.lastCenterLabelConfig=l},singleFillColor:function(a){return t({color:ib(a.color,1),alpha:ba(a.alpha,
1)})}},"Pie2D"]);FusionCharts.register("component",["dataset","Doughnut3D",{type:"doughnut3d"},"Pie3D"]);FusionCharts.register("component",["datasetGroup","marimekko",{init:function(){this.__base__.init.call(this);this.stackConf=[]},getDataSetPosition:function(a,c){var d=this.numVisiblePositions,e=this.stackConfig[a.positionIndex||0],g=this.stackConf[c],l;if(!a.visible&&e.visible||0===d)l=0;return{columnWidth:g.columnWidth,height:l,x:g.x}},draw:function(){var a=this.positionStackArr,c=a.length,d=
this.chart.getJobList(),e,g,l,k;this.preDrawCalculate();this.drawLabel();this.drawSumValueFlag=!0;for(e=0;e<c;e++)for(g=a[e],l=g.length,this.manageClip=!0,g=0;g<l;g++)k=a[e][g].dataSet,k.draw();this.drawn?this.drawSumValue():d.labelDrawID.push(pb.addJob(this.drawSumValue,this,[],m.priorityList.label));this.drawn=!0},preDrawCalculate:function(){var a=this.chart,c=this.stackSumValue,d,g=a.isBar,l=a.jsonData.chart,m=a.components.xAxis[0];d=e(g?l.overlapbars:l.overlapcolumns,a.is3D?0:1);var k=m.getAxisPosition(0),
h=m.getAxisPosition(1),q=Ra(h-k),f=Ea(e(l.plotspacepercent),0),p=e(l.plotpaddingpercent),n,k=a.config.canvasWidth,t,r=h=0,v=m.config.axisRange.min,m=m.config.axisRange.max-v,w=a.config.categories,A;t=0;var C=a.components.numberFormatter;this.__base__.preDrawCalculate.call(this);a=v;n=this.numVisiblePositions;g=e(g?l.maxbarheight:l.maxcolwidth,Infinity);g=(1-.01*f)*q||Va(1*q,g*(n||1));g=0===n?g:g/n;Va(g-1,1<n?d||void 0!==p?0<p?g*p/100:0:4:0);d=0;for(p=c[0].length;d<p;d++)h+=c[0][d];this.totalSumValue=
h;for(d=0;d<w.length;d++)g=w[d],g.widthpercent&&(t+=C.getCleanValue(g.widthpercent));100===t&&(A=this.setUserWidth=1);d=0;for(p=c[0].length;d<p;d++)g=w[d],this.stackConf[d]||(this.stackConf[d]={}),t=this.stackConf[d],g=A?C.getCleanValue(g.widthpercent)/100:c[0][d]/h,t.columnWidth=g*k,r+=g,g=g*m/2+a,a=r*m+v,t.x=g;this.isCrisp=!0},getStackSumPercent:function(){var a=this.stackSumValue,c=this.totalSumValue,d,e=this.chart.components.numberFormatter,g=this.chart.config.categories,l=this.setUserWidth,k=
[];for(d=0;d<a[0].length;d++)k[d]=l?e.getCleanValue(g[d].widthpercent):a[0][d]/c*100;return k},drawLabel:function(){var a=this.chart,d=a.components,g=a.linkedItems.smartLabel,l=this.getStackSumPercent(),m=this.stackConf,q,k,h,p=a.graphics.datalabelsGroup,f=d.numberFormatter,n=0,t,r,v=d.paper,w=a.config.canvasBottom,A=d.xAxis[0];q=a.config.style;var C=a.config.dataLabelStyle,H=l.length,D,F=this.sumValues[0],K,I,J,L=a.jsonData.chart;I=d.canvas.config.clip["clip-canvas"];p=this.labelContainer=this.labelContainer||
v.group("labelGroup",p);k=e(L.showxaxispercentvalues,1);var L=this.xLabels=this.xLabels||[],M=a.get("config","animationObj"),a=M.duration,d=M.animType,N=M.dummyObj,M=M.animObj;p.attr({"clip-rect":I});g.setStyle(C);if(k)for(I=c(C.backgroundColor,"#ffffff"),K=c(""===C.borderColor?"#"+q.inCancolor:C.borderColor,"#000000"),J=c(C.borderThickness,1),h=0;h<H-1;h++)n+=l[h],t=f.percentValue(n),q=A.getAxisPosition(m[h].x)+m[h].columnWidth/2,k=w,D=L[h],F[h].positive===F[h].negative?D&&D.hide():(r={text:t,fill:C.color,
"text-bound":[I,K,J,C.borderPadding,C.borderRadius,C.borderDash],"line-height":C.lineHeight,visibility:Pa},t=g.getOriSize(t),k=k-t.height/2-J,D?(D.show().animateWith(N,M,{x:q,y:k},a,d),D.attr(r)):(r.x=q,r.y=k,L[h]=v.text(r,p)))},getSumValueConfig:function(a){var c=a.yAxis,d=a.stack100percent,e=a.sumValue;a=this.chart.components.xAxis[0].getAxisPosition(this.stackConf[a.xValue].x);c=c.getAxisPosition(d?100:e);return{xPos:a,yPos:c}}},"column"]);FusionCharts.register("component",["dataset","marimekko",
{type:"marimekko",configure:function(){m.each(this.JSONData.data,function(a){a&&(a.value=Ra(a.value))});this.__base__.configure.call(this)},_addLegend:function(){var a=this.chart,c=a.jsonData.chart,d,g;g=this.config;var a=a.components.legend,l=g.legendSymbolColor;d=e(c.us3dlighting,c.useplotgradientcolor,1);c=ob(l,60).replace(ra,V);d?(d=ob(l,40),d={FCcolor:{color:l+","+l+","+d+","+l+","+l,ratio:"0,70,30",angle:270,alpha:"100,100,100,100,100"}}):d={FCcolor:{color:l,angle:0,ratio:"0",alpha:"100"}};
g={enabled:g.includeInLegend,type:this.type,fillColor:t(d),strokeColor:t(c),rawFillColor:l,label:na(this.JSONData.seriesname)};this.legendItemId=a.addItems(this,this.legendInteractivity,g)},draw:function(){var a=this,d=a.JSONData,g=a.chart,l=g.getJobList(),q=g.jsonData.chart,p=g.config,k=a.config,h=a.groupManager,n=a.index,f,r,v=a.visible,A=g.components;r=A.canvas.config.clip;var C=A.paper,A=A.xAxis[0],H=A.getCategoryLen(),D=a.yAxis,F=g.graphics.datasetGroup,K=g.config.isstacked,I,L,M,N=g.graphics,
O=m.parseUnsafeString,S=m.getValidValue,T=m.Raphael,Q=p.showtooltip,R=g.get("config","animationObj"),ba=R.duration,V=R.dummyObj,aa=R.animObj,R=R.animType,pa=A.getAxisPosition(0),ea=A.getAxisPosition(1),W=k.groupMaxWidth=ea-pa,pa=h.stackSumValue[a.positionIndex],ea=p.maxcolwidth,ea=(1-.01*k.definedgrouppadding)*W||Va(1*W,1*ea),ia,U,Z,X=a.components,da=X.data,ca,ga,ka,fa,na,ma=a.drawn,ra=X.removeDataArr,ra=ra&&ra.length,ja=(X=X.addDataArr)&&X.length,X=D.getAxisBase(),la=D.yBasePos=D.getAxisPosition(X),
oa,va=0,k=k.showshadow,za=p.plotborderthickness,ya=p.useroundedges,Aa=a.graphics,qa=Aa.container,sa=Aa.trackerContainer,ua=Aa.dataLabelContainer,Da=Aa.shadowContainer,Aa=Aa.pool;ka=N.trackerGroup;var Ea,Ga=1,Ja=A.getAxisPosition(H-1)+0,Ia=A.getAxisPosition(0)+0,Ka=!0,La=a.startPosition,N=h.stackConf,Ma=p.showplotborder,Na=function(){!1!==a.visible||!1!==a._conatinerHidden&&void 0!==a._conatinerHidden||(qa.hide(),sa.hide(),Da.hide(),ua&&ua.hide(),a._conatinerHidden=!0)},Pa=function(){Ka&&Na();this.show()},
Oa=function(){return La?function(a,b){a.x=Ia-W*(ja-b);a.y=L;a.height=U}:!1===La?function(a){a.x=Ja+W*Ga++;a.y=L;a.height=U}:function(a){a.width=0}},g=g.components.canvas.config;Ea=g.oriCanvasBorderThickness;var g=0<g.canvasBorderWidth,Qa=p.canvasRight,Sa=p.canvasTop,p=p.canvasLeft;ma&&(Oa=Oa());qa||(qa=a.graphics.container=C.group("columns",F),v||qa.hide());sa||(sa=a.graphics.trackerContainer=C.group("col-hot",ka),v||sa.hide());Da||(Da=a.graphics.shadowContainer=C.group("shadow",F).toBack(),v||Da.hide());
r=r["clip-canvas"];g||(r[3]+=Ea/2,J&&(r[2]+=2*Ea));ma?(qa.animateWith(V,aa,{"clip-rect":r},ba,R),Da.animateWith(V,aa,{"clip-rect":r},ba,R)):(qa.attr({"clip-rect":r}),Da.attr({"clip-rect":r}));for(r=0;r<H;r++)f=(ga=(F=da[r])&&F.config)&&ga.setValue,void 0!==F&&null!==f&&(ka=h.getDataSetPosition(a,r),ia=e(ka.columnWidth,ea/1),fa=ka.height,ka=ga.setLink,Ea=ga.colorArr,F.graphics||(da[r].graphics={}),na=ga.displayValue,oa=ga.previousPositiveY,ca=S(O(c(ga.origToolText,d.plottooltext,q.plottooltext))),
K&&(oa=a._parseValues(r,oa,pa[r],ca),f=ga.value),I=N[r].x,Z=D.getAxisPosition(oa||X),I=A.getAxisPosition(I)-ia/2,0!==fa?(L=D.getAxisPosition(f+(oa||0)),U=Ra(Z-L)):(U=0,L=Z),L=Va(L,Z),parseInt(L)<=Sa&&(U-=Sa-L-+g,L=Sa-+g),1>=za&&(ab(I)<=p&&(ia+=I,I=p-za/2+ +!!za-+g,ia-=I),ab(I+ia)>=Qa&&(ia=Qa-I+za/2-+!!za+ +g)),h.isCrisp&&(M=T.crispBound(I,L,ia,U,za),I=M.x,L=M.y,ia=M.width,U=M.height),oa=F.trackerConfig||(F.trackerConfig={}),Z=!1!==ga.toolText&&ga.toolText+(ca?"":ga.toolTipValue),ca=ga.plotBorderDashStyle,
fa=oa.eventArgs||(oa.eventArgs={}),fa.index=r,fa.link=ka,fa.value=f,fa.displayValue=na,fa.categoryLabel=ga.label,fa.toolText=Z,fa.id="",fa.datasetIndex=n||0,fa.datasetName=d.seriesname,fa.visible=v,ba||(la=L,va=U),f={x:I,y:la,width:ia,height:va||1,r:ya,ishot:!Q,fill:t(Ea[0]),stroke:t(Ea[1]),"stroke-width":Ma?za:0,"stroke-dasharray":ca,"stroke-linejoin":"miter",visibility:v},F._xPos=I,F._yPos=L,F._height=U,F._width=ia,F._index=r,!F.graphics.element&&ma&&(Oa(f,r),Aa&&Aa[0].graphics.element?(ga=Aa[0].graphics.element,
ga.attr(f)):ga=F.graphics.element=C.rect(f,qa),Aa&&Aa[0].graphics.hotElement&&(F.graphics.hotElement=Aa[0].graphics.hotElement),Aa&&Aa.splice(0,1)),F.graphics.element?(f={x:I,y:L,width:ia,height:U||1},ba?ga=F.graphics.element.animateWith(V,aa,f,ba,R,Pa):(ga=F.graphics.element.attr(f),Ka&&Na())):(ga=F.graphics.element=C.rect(f,qa),ba&&(ga.animateWith(V,aa,{y:L,height:U||1},ba,R),Ka=!1)),ga.attr({r:ya,ishot:!Q,fill:t(Ea[0]),stroke:t(Ea[1]),"stroke-width":Ma?za:0,"stroke-dasharray":ca,"stroke-linejoin":"miter"}).shadow({opacity:k},
Da).data("BBox",M),f=oa.attr||(oa.attr={}),f.x=I,f.y=L,f.width=ia,f.height=U,f.r=ya,f.cursor=ka?"pointer":"",f.stroke=w,f["stroke-width"]=za,f.fill=w,f.ishot=!0,f.visibility=v);l.trackerDrawID.push(pb.addJob(a.drawTracker,a,[],m.priorityList.tracker));a.drawn?a.drawLabel():l.labelDrawID.push(pb.addJob(a.drawLabel,a,[],m.priorityList.label));a.drawn=!0;ra&&a.remove()},getDataLimits:function(){var a=this.conf;return{max:a.yMax,min:a.yMin,xMax:100,xMin:0}}},"column"])}]);FusionCharts.register("module",
["private","modules.renderer.js-interface",function(){var g=this,m=g.hcLib,D=g.renderer.getRenderer("javascript"),n=m.hasModule,F=m.loadModule,A=m.getMetaSentence,J=m.moduleCmdQueue,a=m.executeWaitingCommands,O=m.injectModuleDependency,d=m.moduleDependencies,l=m.getDependentModuleName,N,ga;N=function(d){var n,p,c,v={},D;d=A(d);for(n in g.core.items)n=g.core.items[n],p=n.chartType(),c=n.options.chartTypeSourcePath+p,(p=n.jsVars)&&p.waitingModule&&n.__state.rendering&&m.needsModule(d.predicate,c)&&
(p.waitingModuleError=!0,p=l(c).concat(p.userModules),p.length&&(p=p[p.length-1],v[p]=m.moduleCmdQueue[p]));for(D in v)a(v[D]);g.raiseError(g.core,"11171116151","run","HC-interface~renderer.load","Unable to load required modules and resources: "+d.key)};ga=function(a,d,l){var c=a.args,m=a.options;a._chartMessageImageStyle={imageHAlign:c.typeNotSupportedMessageImageHAlign||m.baseChartMessageImageHAlign,imageVAlign:c.typeNotSupportedMessageImageVAlign||m.baseChartMessageImageVAlign,imageAlpha:c.typeNotSupportedMessageImageAlpha||
m.baseChartMessageImageAlpha,imageScale:c.typeNotSupportedMessageImageScale||m.baseChartMessageImageScale};a._chartMessageStyle={color:c.typeNotSupportedMessageColor||m.baseChartMessageColor,fontFamily:c.typeNotSupportedMessageFont||m.baseChartMessageFont,fontSize:c.typeNotSupportedMessageFontSize||m.baseChartMessageFontSize};g.hcLib.createChart(a,d,"base",l,m.typeNotSupportedMessage)};m.eventList=g.extend(g.legacyEventList,{loaded:"FC_Loaded",dataloaded:"FC_DataLoaded",rendered:"FC_Rendered",drawcomplete:"FC_DrawComplete",
dataxmlinvalid:"FC_DataXMLInvalid",nodatatodisplay:"FC_NoDataToDisplay",exported:"FC_Exported"});m.raiseEvent=g.raiseEventWithLegacy;d.charts=g.extend(d.charts||{},{column2d:0,column3d:0,bar2d:0,bar3d:0,pie2d:0,pie3d:0,line:0,area2d:0,doughnut2d:0,doughnut3d:0,pareto2d:0,pareto3d:0,mscolumn2d:0,mscolumn3d:0,msline:0,msarea:0,msbar2d:0,msbar3d:0,stackedcolumn2d:0,marimekko:0,stackedcolumn3d:0,stackedarea2d:0,stackedcolumn2dline:0,stackedcolumn3dline:0,stackedbar2d:0,stackedbar3d:0,msstackedcolumn2d:0,
mscombi2d:0,mscombi3d:0,mscolumnline3d:0,mscombidy2d:0,mscolumn3dlinedy:0,stackedcolumn3dlinedy:0,msstackedcolumn2dlinedy:0,scatter:0,bubble:0,ssgrid:0,scrollcolumn2d:0,scrollcolumn3d:0,scrollline2d:0,scrollarea2d:0,scrollstackedcolumn2d:0,scrollcombi2d:0,scrollcombidy2d:0,zoomline:0,zoomlinedy:0,zoomscatter:0});d.powercharts=g.extend(d.powercharts||{},{spline:0,splinearea:0,msspline:0,mssplinearea:0,mssplinedy:0,multiaxisline:0,multilevelpie:0,waterfall2d:0,msstepline:0,inversemsline:0,inversemscolumn2d:0,
inversemsarea:0,errorbar2d:0,errorscatter:0,errorline:0,logmsline:0,logmscolumn2d:0,logstackedcolumn2d:0,radar:0,dragnode:0,candlestick:0,selectscatter:0,dragcolumn2d:0,dragline:0,dragarea:0,boxandwhisker2d:0,kagi:0,heatmap:0,treemap:0});d.widgets=g.extend(d.widgets||{},{angulargauge:0,bulb:0,cylinder:0,drawingpad:0,funnel:0,hbullet:0,hled:0,hlineargauge:0,vlineargauge:0,pyramid:0,realtimearea:0,realtimecolumn:0,realtimeline:0,realtimelinedy:0,realtimestackedarea:0,realtimestackedcolumn:0,sparkcolumn:0,
sparkline:0,sparkwinloss:0,thermometer:0,vbullet:0,gantt:0,vled:0});d.maps=g.extend(d.maps||{},{});g.extend(D,{render:function(a,d){var p=this.chartType(),c=this.options.chartTypeSourcePath+p,v=this.jsVars,A=this.__state,e=m.chartAPI,q=this.options,H=this.args,t=this.options.showChartLoadingMessage,F,K;F=l(c).concat(v.userModules);v.isResizing&&(v.isResizing=clearTimeout(v.isResizing));v.hcObj&&v.hcObj.destroy&&v.hcObj.destroy();if(e[p]){if(e[A.lastRenderedType]&&A.lastRenderedType!==p)for(K in g.raiseEvent("chartTypeChanged",
{previousType:A.lastRenderedType,newType:p},this),e[A.lastRenderedType].eiMethods)delete this[K];A.lastRenderedType=p;A.lastRenderedSrc=this.src;!v.waitingModuleError&&m.raiseEvent("internal.loaded",{type:p,triggeredModuleLoad:v.drLoadAttempted||v.waitingModule},this,[this.id]);delete v.waitingModule;delete v.waitingModuleError;delete v.drLoadAttempted;g.hcLib.createChart(this,a,p,d)}else{if(p&&n(F)){if(v.drLoadAttempted){g.raiseError(this,11112822001,"run","HC-interface~renderer.render","Chart runtimes not loaded even when resource is present");
ga(this,a,d);return}O(c)&&(F=l(c).concat(v.userModules));v.drLoadAttempted=!0}else{if(!F.length){ga(this,a,d);return}if(v.waitingModuleError){ga(this,a,d);delete v.waitingModule;delete v.waitingModuleError;return}}(p=J[F[F.length-1]])?(p.push({cmd:"render",obj:this,args:arguments}),v.waitingModule||(v=t?q.PBarLoadingText||q.loadMessage:"",this._chartMessageImageStyle={imageHAlign:H.loadMessageImageHAlign||q.baseChartMessageImageHAlign,imageVAlign:H.loadMessageImageVAlign||q.baseChartMessageImageVAlign,
imageAlpha:H.loadMessageImageAlpha||q.baseChartMessageImageAlpha,imageScale:H.loadMessageImageScale||q.baseChartMessageImageScale},this._chartMessageStyle={color:H.loadMessageColor||q.baseChartMessageColor,fontFamily:H.loadMessageFont||q.baseChartMessageFont,fontSize:H.loadMessageFontSize||q.baseChartMessageFontSize},g.hcLib.createChart(this,a,"base",void 0,v),D.load.call(this,a,d))):(g.raiseError(this,12080515551,"run","HC-interface~renderer.render","Unregistered module in dependentModule definition."),
this._chartMessageImageStyle={imageHAlign:H.renderErrorMessageImageHAlign||q.baseChartMessageImageHAlign,imageVAlign:H.renderErrorMessageImageVAlign||q.baseChartMessageImageVAlign,imageAlpha:H.renderErrorMessageImageAlpha||q.baseChartMessageImageAlpha,imageScale:H.renderErrorMessageImageScale||q.baseChartMessageImageScale},this._chartMessageStyle={color:H.renderErrorMessageColor||q.baseChartMessageColor,fontFamily:H.renderErrorMessageFont||q.baseChartMessageFont,fontSize:H.renderErrorMessageFontSize||
q.baseChartMessageFontSize},g.hcLib.createChart(this,a,"base",void 0,q.renderErrorMessage))}},update:function(a){var d=this.ref,l=this.jsVars,c=l&&l.fcObj,c=l.container||c&&c.options&&c.options.containerElement&&c.options.containerElement.childNodes[0];l.hcObj&&l.hcObj.destroy&&l.hcObj.destroy();l.isResizing&&(l.isResizing=clearTimeout(l.isResizing));void 0===a.error?(delete l.stallLoad,delete l.loadError,this.isActive()?this.src!==this.__state.lastRenderedSrc?this.render():g.hcLib.createChart(this,
c):this.__state.rendering&&!l.waitingModule&&g.hcLib.createChart(this,c)):(this.isActive()&&"function"===typeof d.showChartMessage&&d.showChartMessage("InvalidXMLText"),delete l.loadError)},resize:function(a){var d=this.ref,l,c=this.jsVars;d&&d.resize&&(c.isResizing&&(c.isResizing=clearTimeout(c.isResizing)),c.isResizing=setTimeout(function(){l=g.normalizeCSSDimension(a.width,a.height,d);void 0!==a.width&&(d.style.width=l.width);void 0!==a.height&&(d.style.height=l.height);d.resize();delete c.isResizing},
0))},dispose:function(){var a,d=this.jsVars;d.isResizing&&(d.isResizing=clearTimeout(d.isResizing));d.instanceAPI&&d.instanceAPI.dispose&&(d.instanceAPI.dispose(),delete d.instanceAPI);if(a=this.ref)g.purgeDOM(a),a.parentNode&&a.parentNode.removeChild(a);d.container=null;m.cleanupWaitingCommands(this)},load:function(d,n){var p=this.jsVars,c=this.chartType(),v=g.hcLib.chartAPI[c],c=l(c).concat(p.userModules),A=c[c.length-1];v||!c||c&&0===c.length?(delete p.waitingModule,d&&ga(this,d||this.ref,n)):
p.waitingModule||(p.waitingModule=!0,delete p.waitingModuleError,F(c,function(){delete p.waitingModule;a(m.moduleCmdQueue[A])},N,this))}})}]);FusionCharts.register("module",["private","modules.api.dynamicchartattributes",function(){var g=this;g.extend(g.core,{setChartAttribute:function(m,D){var n,F,A,J;if("string"===typeof m)n=m,m={},m[n]=D;else if(null===m||"object"!==typeof m)return;J=0;if(A=(n=this.getChartData(g.dataFormats.JSON))&&(n.chart||n.graph||n.map)){for(F in m)J+=1,null===m[F]?delete A[F.toLowerCase()]:
A[F.toLowerCase()]=m[F];0<J&&("undefined"===typeof A.animation&&(A.animation="0"),this.setChartData(n,g.dataFormats.JSON))}else g.raiseError(this,"2105141421","run","#setChartAttribute()","Could not retrieve attribute list. Is data ready?")},getChartAttribute:function(m){var D=this.getChartData(g.dataFormats.JSON),D=D&&(D.chart||D.graph||D.map),n,F;if(0===arguments.length||void 0===m||void 0===D)return D;if("string"===typeof m)n=D[m.toString().toLowerCase()];else if(m instanceof Array)for(n={},F=
0;F<m.length;F+=1)n[m[F]]=D[m[F].toString().toLowerCase()];else g.raiseError(this,"25081429","param","~getChartAttribute()",'Unexpected value of "attribute"');return n}},!0)}]);FusionCharts.register("module",["private","api.linkmanager",function(){var g=this,m=g.FusionChartsDOMInsertModes,D={},n=function(m,a){this.items={};this.root=m;this.parent=a;a instanceof g.core?this.level=this.parent.link.level+1:(D[m.id]=[{}],this.level=0)},F=function(g,a){return(g.options.containerElement===a.options.containerElement||
g.options.containerElementId===a.options.containerElementId)&&g.options.insertMode===m.REPLACE},A=function(m){var a;m.sender.link instanceof n&&!m.sender.link.root.disposed?m.sender.link.parent instanceof g.core&&(a=m.sender.link.parent.link.items,!a[m.sender.id]&&(a[m.sender.id]=m.sender)):m.sender.link=new n(m.sender)};g.policies.link=["link",void 0];n.prototype.configuration=function(){return D[this.root.id][this.level]||(D[this.root.id][this.level]={})};g.extend(g.core,{configureLink:function(m,
a){var n;if(m instanceof Array){for(n=0;n<m.length;n+=1)"object"!==typeof D[this.link.root.id][n]&&(D[this.link.root.id][n]={}),g.extend(D[this.link.root.id][n],m[n]);D[this.link.root.id].splice(m.length)}else"object"===typeof m?("number"!==typeof a&&(a=this.link.level),void 0===D[this.link.root.id][a]&&(D[this.link.root.id][a]={}),g.extend(D[this.link.root.id][a],m)):g.raiseError(this,"25081731","param","~configureLink()","Unable to update link configuration from set parameters")}},!0);g.addEventListener("beforeRender",
function(g){A(g)});g.addEventListener("beforeInitialize",function(g){A(g)});g.addEventListener("linkedChartInvoked",function(m,a){var A=m.sender,d=A.clone({dataSource:a.data,dataFormat:a.linkType,link:new n(A.link.root,A)},!0),l=a.alias,D;l&&(!d.typeSource&&d.swfUrl&&(d.typeSource=d.swfUrl.replace(/(.*?)?[^\/]*\.swf.*?/ig,"$1")),d.type=l);A.args&&0!==parseInt(A.args.animate,10)&&delete d.animate;g.extend(d,A.link.configuration());g.raiseEvent("beforeLinkedItemOpen",{level:A.link.level},A.link.root,
void 0,function(){g.core.items[d.id]instanceof g.core&&g.core.items[d.id].dispose();D=new g.core(d);F(D,A)||A.options.overlayButton&&A.options.overlayButton.message||("object"!==typeof A.options.overlayButton&&(A.options.overlayButton={}),A.options.overlayButton.message="Close");D.render();g.raiseEvent("linkedItemOpened",{level:A.link.level,item:D},A.link.root)})});g.addEventListener("overlayButtonClick",function(m,a){if("LinkManager"===a.id){var n=m.sender,d=n.link.level-1,l=n.link.parent,A=n.link.root;
g.raiseEvent("beforeLinkedItemClose",{level:d,item:n},A,n,function(){setTimeout(function(){g.core.items[n.id]&&n.dispose();g.raiseEvent("linkedItemClosed",{level:d},A)},0);l.disposed||l.isActive()||!F(n,l)||l.render()})}});g.addEventListener("Loaded",function(m){m=m.sender;var a;m&&void 0!==m.link&&m.link.root!==m&&m.link.parent instanceof g.core&&(m.ref&&"function"===typeof m.ref.drawOverlayButton?(a=g.extend({show:!0,id:"LinkManager"},m.link.parent.options.overlayButton),g.extend(a,m.link.parent.link.configuration().overlayButton||
{}),m.ref.drawOverlayButton(a)):g.raiseWarning(m,"04091602","run","::LinkManager^Loaded","Unable to draw overlay button on object. -"+m.id))});g.addEventListener("beforeDispose",function(m){var a=m.sender;a&&a.link instanceof n&&(a&&a.link&&a.link.parent instanceof g.core&&a.link.parent.link&&a.link.parent.link.items&&delete a.link.parent.link.items[m.sender.id],delete D[a.id])})}]);FusionCharts.register("module",["private","modules.renderer.js-thememanager",function(){var g=this,m,D,n,F=/\s+!important$/,
A=/\\!important$/,J=function(a,d){for(var c=d.length,g=-1;c--;)if(a===d[c]){g=c;break}return g},a=function(d,g,c,l,m){var e,q,n,t;m?(l.push(d),m.push(g)):(l=[d],m=[g]);if(g instanceof Array)for(e=0;e<g.length;e+=1){try{q=d[e],n=g[e]}catch(w){continue}if("object"!==typeof n)c&&void 0===n||(d[e]=n);else{if(null===q||"object"!==typeof q)q=d[e]=n instanceof Array?[]:{};t=J(n,m);-1!==t?q=d[e]=l[t]:a(q,n,c,l,m)}}else for(e in g){try{q=d[e],n=g[e]}catch(w){continue}if(null!==n&&"object"===typeof n)if(t=
Object.prototype.toString.call(n),"[object Object]"===t){if(null===q||"object"!==typeof q)q=d[e]={};t=J(n,m);-1!==t?q=d[e]=l[t]:a(q,n,c,l,m)}else"[object Array]"===t?(null!==q&&q instanceof Array||(q=d[e]=[]),t=J(n,m),-1!==t?q=d[e]=l[t]:a(q,n,c,l,m)):d[e]=n;else d[e]=n}return d},O=function(d,g,c){if("object"!==typeof d&&"object"!==typeof g)return null;if("object"!==typeof g||null===g)return d;"object"!==typeof d&&(d=g instanceof Array?[]:{});a(d,g,c);return d},d=function(a){var d={important:!1,str:""};
if(!a)return d;a=a.toString();F.test(a)?(a=a.replace(F,""),d.important=!0):(a=a.replace(A,"!imporant"),d.important=!1);d.str=a;return d},l=function(a,d){var c,g,m,e,q,n,t=0,w=0;for(c in a)if(g=a[c],g instanceof Array)for(n=g.length,q=0;q<n;q+=1){if(e=g[q],"object"===typeof e)if("category"===c)if("true"===e.vline){if(m=d.component("vline",t,e))N(e,m),t+=1}else{if(m=d.component("category",w,e,n))N(e,m),w+=1}else if(m=d.component(c,q,e,n))N(e,m),l(e,m)}else"object"===typeof g&&(m=d.component(c,null,
g))&&(N(g,m),l(g,m))},N=function(a,g){var c=g.getAll(),l,m;for(l in c)m=c[l].toString(),m=d(m),m.important?a[l.toLowerCase()]=m.str:void 0===a[l.toLowerCase()]&&(a[l.toLowerCase()]=m.str)},ga=function(a,d){"geo"===d.defaultSeriesType&&w.call(this,a,d)},w=function(a,d){var c=a.sender,l=c.getChartData(g.dataFormats.JSON,!0),m;l.error||((m=l.data.chart.theme)?n.themify(m,c,c.chartType(),l.data,"geo"===d.defaultSeriesType&&"geo"):c.jsVars&&c.jsVars.themeObject&&c.jsVars.themeObject.dispose())};m=function(){this.themeStore=
{}};m.prototype={constructor:m,add:function(a){for(var d=0,c=a.length,g;d<c;d+=1)(g=a[d].name)&&(this.themeStore[g]=a[d])},themify:function(a,d,c,l,m){var e=d.jsVars,q=a.split(","),n=[],t=q.length,A,F;if(t){for(F=0;F<t;F+=1){A=this.themeStore;var J;J=q[F];J=J.replace(/^\s\s*/,"");for(var N=/\s/,O=J.length;N.test(J.charAt(--O)););J=J.slice(0,O+1);(A=A[J])&&n.push(this.evaluateThemeJSON(A.theme,d,c,m))}n.length?(e.themeObject=new D(n,d,!1,l),this.applyTheme(d),d.addEventListener("chartTypeChanged",
w),d.addEventListener("internal.drawstart",ga)):g.raiseWarning(d,"14051100501","run","api.themes~themify()",'The theme "'+a+'" requested has not been registered.')}},evaluateThemeJSON:function(a,d,c,g){var l={},e=d.jsVars,m=function(a){var c,d;for(c in a)d=a[c],l[c]=d instanceof Array?O(l[c]||[],d):"object"===typeof d?O(l[c]||{},d):d};c=c||d.chartType();e.themeObject&&a!==e.themeObject&&(e.themeObject.dispose(),delete e.themeObject);m(a.base);g&&a[g]&&m(a[g]);c&&a[c]&&m(a[c]);return l},applyTheme:function(a){a=
a.jsVars.themeObject;var d=a.getThemedJSONData().data;d&&l(d,a)}};D=function(a,d,c,g){this.themeArray=a;this.themeComponents={};this.base={};this.chartInstance=d;this.isChildInstance=!!c;this.themedData=c?null:O({},g);this.length=a.length;d=0;for(c=a.length;d<c;d+=1)this.parse(a[d])};D.prototype={constructor:D,pushTheme:function(a){a&&(this.themeArray.push(a),this.parse(a),this.length+=1)},popTheme:function(){},parse:function(a){var g=this.themeComponents,c=this.chartInstance,l=this.base,m,e,q;for(e in a)if("string"===
typeof a[e]||"number"===typeof a[e])if(l[e]){if(m=d(a[e]),q=d(l[e]),m.important||!q.important)l[e]=a[e]}else l[e]=a[e];else g[e]||(g[e]=[]),m=g[e],a[e]instanceof Array?m.push(O([],a[e])):"object"===typeof a[e]?m.push(new D([a[e]],c,!0)):"function"===typeof a[e]&&m.push(a[e])},merge:function(a){var g=this.base,c=a.base,l=this.themeComponents,m=a.themeComponents,e,q,n;for(n in c)if(e=d(g[n]),q=d(c[n]),!e.important||q.important)g[n]=c[n];for(n in m)l[n]=l[n]?l[n].concat(m[n]):[].concat(m[n]);this.length+=
a.length},get:function(a){return this.base[a]},getAll:function(){return O({},this.base)},component:function(a,d,c,g){var l=this.themeComponents,e=this.chartInstance,m=new D([],e,!0),n,t,w;t=l[a];if(!t)return null;a=0;for(l=t.length;a<l;a+=1)w=t[a],"function"===typeof w?(d=d||0,m.pushTheme(w.call(e,d,c,g))):w instanceof Array?(d=d||0,n=w.length,d%=n,n=w[d],n instanceof D?m.merge(n):"function"===typeof n?m.pushTheme(n.call(e,d,c,g)):m.pushTheme(n)):w instanceof D?m.merge(w):m.pushTheme(w);return m},
getThemedJSONData:function(){return{data:this.themedData}},dispose:function(){var a=this.themeComponents,d=this.chartInstance,c,g;for(c in a)if(g=a[c].length){for(;g--;)a[c][g].dispose&&a[c][g].dispose();delete a[c]}this.isChildInstance||(d.removeEventListener("chartTypeChanged",w),d.removeEventListener("internal.drawstart",ga));this.dataWithoutTheme=this.isChildInstance=this.themeArray=this.base=this.chartInstance=this.themeComponents=null}};n=new m;g.registrars.theme=g.registerTheme=function(a){a&&
("[object Array]"!==Object.prototype.toString.call(a)&&(a=[a]),n.add(a))};g.addEventListener("beforeDataUpdate",function(a,d){var c=a.sender,l=g.core.transcodeData(d.data,d.format,g.dataFormats.JSON),m=l.chart&&l.chart.theme;m?n.themify(m,c,c.args.type,l):c.jsVars&&c.jsVars.themeObject&&(c.jsVars&&c.jsVars.themeObject.dispose(),c.jsVars&&delete c.jsVars.themeObject)})}]);FusionCharts.register("theme",{name:"default",theme:{base:{chart:{labelDisplay:"stagger !important",caption:"Theme Caption \\!important",
canvasBgColor:"#56EF22",borderThickness:"5 !important",borderColor:"#E60539",baseFontColor:"#781129"},categories:[{fontColor:"#0F4F40",fontSize:15,category:function(g){return{showLabel:g%2?0:1}},vline:{color:"#000000",thickness:2}}],dataset:[{color:"#8C3146",data:function(g,m){8==g&&(m.value="");return{color:32E3>Number(m.value)?"#8C3146":"#FF0000",alpha:"100"}}}],trendlines:[{line:function(g){return g?{color:"#ff0000",thickness:3}:{color:"#ffff00",thickness:3}}}]},pie2d:{chart:{bgColor:"#FF0000"}},
msline:{chart:{canvasBgColor:"#ff0000"}},geo:{chart:{canvasBgColor:"#0000ff"}},world:{chart:{canvasBgColor:"#00ff00"}}}});FusionCharts.register("module",["private","modules.renderer.js-highlightmanager",function(){var g=this,m=g.hcLib,D=m.extend2,n=m.pluckNumber,F=m.toRaphaelColor,A=/^#?[0-9a-f]{6}/i,J=/FFFFFF/i,a=/255,255,255/,O=m.getFirstAlpha,d=function(a){a=a.replace("rgba(","").split(",");return"#"+("000000"+(a[0]<<16|a[1]<<8|a[2]).toString(16)).slice(-6)},l=m.pluck,N=function(a){if(/rgb/.test(a))return a=
a.match(/[\d\.]+\)/g),parseFloat(a&&a[0]);if(a.FCcolor)return O(a.FCcolor.alpha)},ga=function(a){a=a.split(",");var c,d,e,g={},l;c=0;for(d=a.length;c<d;c++)e=a[c].split("="),l=e[0],e=e[1],g[l]=e;return g},w=function(a,c,e){var g,m=c.color;if(/rgb/.test(a))c=l(c.alpha,100*N(a)),/rgb/.test(m)&&(m=d(m)),g=e?F({color:l(m,d(a)),alpha:c}):a;else if(a.FCcolor){if(e){a=a.FCcolor;var n;e={};var p;for(n in a)if("alpha"===n){m=n;if(c.alpha){g=a[n];var r=c.alpha,w=void 0,v=void 0,D=[];if("number"===typeof g)g=
r;else{v=g.split&&g.split(",");for(w=0;w<v.length;w++)D.push(r);g=D.join()}}else g=a[n];e[m]=g}else"color"===n?(-1!==a[n].indexOf(",")&&c.color&&(p=c.color+","+a[n].substring(a[n].indexOf(",")+1)),e[n]=l(p||c.color,a[n])):e[n]=a[n];c=F(e)}else c=F(a.FCcolor);g=c}else A.test(a.color||a)&&(g=e?F({color:l(c.color,a.color,a),alpha:l(c.alpha,a.alpha)}):F({color:a.color||a,alpha:a.alpha}));return g},r=function(a,c,d){var e,g,m,n=a.chart;e=n.config;n=n.config.dataLabelStyle;a=a.components.data;var p,r,w,
v,A,C;p=0;for(r=a.length;p<r;p++)if(e=a[p])for(v in w=e.graphics,e=e.config,m=e.anchorProps,g=m.enabled,e={FCcolor:{alpha:d&&g?l(c.anchorbgalpha,c.alpha,m.bgAlpha):m.bgAlpha,color:d&&g?l(c.anchorbgcolor,c.color,m.bgColor):m.bgColor}},g={FCcolor:{alpha:d&&g?l(c.borderalpha,c.alpha,m.borderAlpha):m.borderAlpha,color:d&&g?l(c.anchorbordercolor,c.color,m.borderColor):m.borderColor}},m=d?c.alpha:m.imageAlpha,d||N(n.color),w)switch(C=(A=w[v])&&A.type,C){case "path":A.attr({fill:F(e),stroke:F(g)});break;
case "image":A.attr({opacity:m/100});break;case "text":M(A,c,n,d)}},p=function(c,e,g,m){var n=e.symbolAttr||{},p=n.fill,n=n.stroke,r=e.textAttr||{},r=m?l(g.color,d(r.fill)):d(r.fill),v=c.legendItemText,D=c.legendItemSymbol;c=c.legendItemLine;e=(e.lineAttr||{}).stroke;c&&e&&(A.test(e)?c.attr({stroke:m?F({color:l(g.color,e),alpha:g.alpha}):e}):(e=w(e,g,m),c.attr({stroke:e})));D&&(p&&(p=p.match(A)?m&&!J.test(p)?F({color:g.color||p,alpha:g.alpha}):p:a.test(p)?p:w(p,g,m)),n&&(n=A.test(n)?m&&!J.test(n)?
F({color:g.color||n,alpha:g.alpha}):n:m&&!a.test(n)?g.color?F({color:g.color,alpha:g.alpha}):n:n),D.attr({fill:p||"none",stroke:n||"none"}));v&&v.attr({fill:F({color:r,alpha:m?g.alpha:100})})},c={area:function(a,c,d){var e=this.chart,g=e.config,m=e.components.legend.components.items,n,w=this.legendItemId,v=m.length;a=ga(a);var A=this.graphics||{},e=A.legendGraphics,D=g.dataLabelStyle,J=A.dataLabelContainer,C=this.config,M,g=0<(C.shadow||{}).opacity;if(!d&&!0===this.visible){a.alpha=a.alpha||30;for(d=
0;d<v&&(n=m[d]||{},n.legendItemId!==w);d++);J&&J.attr({opacity:c?a.alpha/100:N(D.color)});d=C.plotbordercolor;m=C.plotborderalpha;w=C.plotfillalpha;v=C.plotgradientcolor;A=l(A.lineElement,A.splineElement);d=c?l(a.bordercolor,a.color,d):d;a.color&&(M=a.color+(v?","+v:""));v=C.fillColor.color;M=c?l(M,v):v;C=C.plotfillangle;w=c?a.alpha:w;m=c?l(a.borderalpha,a.alpha):m;g=g?c?a.alpha/100:w/100:!1;A.attr({fill:F({color:M,alpha:w,angle:C}),stroke:F({color:d,alpha:m})}).shadow(g);e&&p(e,n.config,a,c);r(this,
a,c)}},bubble:function(a,c,d){var e=this.chart,g=e.components.legend.components.items||[],n,r=g.length,w=this.legendItemId,e=e.config.dataLabelStyle,v=this.graphics,A=v.legendGraphics,D=m.graphics.getPointColor,J=v.dataLabelContainer;a=ga(a);if(!1===d&&!0===this.visible){a.alpha||(a.alpha=30);v=this.components.data||[];for(d=0;d<r&&(n=g[d]||{},n.legendItemId!==w);d++);p(A,n.config,a,c);J&&J.attr({opacity:c?a.alpha/100:N(e.color)});d=0;for(r=v.length;d<r;d++)if(g=v[d])w=g.graphics,n=g.config,g=n.colorObj,
A=n.is3d,n=w.element,w=w.label,A?(A=c?D(l(a.color,g.FCcolor.color),l(a.alpha,O(g.alpha))):g,A=F(A)):(A=c?l(a.color,g.color):g.color,g=c?a.alpha:g.alpha,A=F({color:A,alpha:g})),n&&n.attr({fill:A}),w&&M(w,a,e,c)}},pie:function(a,c,d,e){var g=e.chart,m;e=e._getPointColor;var n=this,r,w,v,A;v={};var n=this.legendItemId,J;w=g.components.legend.getItems()||[];a=ga(a);if(!1===d){a.alpha||(a.alpha=30);d=this.graphics.element;r=this.config;A=0;for(g=w.length;A<g&&(m=w[A],J=m.legendItemId,J!==n);A++);n=m.graphics;
p(n,m.config,a,c);w=r.color.color;n=d.data("plotItem");g=n.chart;m=n.style;g=g.is3D;if(A=n.center)v=A[0],A=A[1],n=n.radius,v={cx:v,cy:A,r:n};w=c?e(l(a.color,w),a.alpha,90):r.color;e=c?a.alpha:w.alpha;w=D(w,v);g?d&&d.attr({color:w.color.split(",")[0],alpha:e}):d&&d.attr({fill:F(w)});e=this.graphics.label;d=this.graphics.connector;e&&M(e,a,m,c);d&&d.attr({opacity:c?a.alpha/100:N(m.color)})}},line:function(a,c,d){var e=this.chart,g=e.components.legend.components.items||[],m=g.length,n,w=this.legendItemId,
v=e.config.dataLabelStyle;a=ga(a);var A=this.graphics||{},e=A.legendGraphics,D=A.dataLabelContainer,J=A.errorGroupContainer,C=this.config,M=C.linecolor,O=C.alpha,na=0<(C.shadow||{}).opacity;if(!d&&!0===this.visible){a.alpha||(a.alpha=30);for(d=0;d<m&&(n=g[d]||{},n.legendItemId!==w);d++);J&&(g=N(C.errorBarColor),g=c?l(a.alpha/100,g):g,J.attr({opacity:g}));D&&D.attr({opacity:c?a.alpha/100:N(v.color)});v=l(A.lineElement,A.SplineElement);M=c?l(a.color,M):M;O=c?l(a.alpha,O):O;na=na?c?a.alpha/100:O/100:
!1;v&&v.attr({stroke:F({color:M,alpha:O})}).shadow(na);e&&p(e,n.config,a,c);r(this,a,c)}},boxandwhisker2d:function(a,c,e){var g=this.config.isRoundEdges,l=this.graphics,n=l.legendGraphics,r=l.lowerWhiskerContainer,v=l.upperWhiskerContainer,A=l.dataLabelContainer,D=this.legendItemId,I=this.chart.components.legend.components.items||[],l=I.length,J;a=ga(a);if(!1===e&&!0===this.visible){a.alpha||(a.alpha=30);for(e=0;e<l&&(J=I[e]||{},J.legendItemId!==D);e++);p(n,J.config,a,c);r&&r.attr({opacity:c?a.alpha/
100:1});v&&v.attr({opacity:c?a.alpha/100:1});A&&A.attr({opacity:c?a.alpha/100:1});n=this.components.data;e=0;for(l=n.length;e<l;e++){r=n[e];v=r.config;r=r.graphics;J=a;var A=c,D=g,C={},M={},O=C=M=void 0,na=I=void 0,ea=void 0,ra=void 0,V=void 0;A?(M=m.graphics.getColumnColor(J.color||v.upperColorArr[0].FCcolor.color,J.alpha.toString(),v.upperColorArr[0].FCcolor.ratio,v.upperColorArr[0].FCcolor.angle,D,J.bordercolor||d(v.upperBoxBorder.color),J.borderalpha&&J.borderalpha.toString()||(100*N(v.lowerBoxBorder.color)).toString()),
M=F(M[0]),C=m.graphics.getColumnColor(J.color||v.lowerColorArr[0].FCcolor.color,J.alpha.toString(),v.lowerColorArr[0].FCcolor.ratio,v.lowerColorArr[0].FCcolor.angle,D,J.bordercolor||d(v.lowerBoxBorder.color),J.borderalpha&&J.borderalpha.toString()||(100*N(v.lowerBoxBorder.color)).toString()),C=F(C[0]),O=w(v.median.color,J,A),ea=w(v.lowerQuartile.color,J,A),ra=w(v.upperQuartile.color,J,A)):(M=F(v.upperColorArr[0]),C=F(v.lowerColorArr[0]),O=v.median.color,I=v.upperBoxBorder.color,na=v.lowerBoxBorder.color,
ra=v.upperQuartile.color,ea=v.lowerQuartile.color);V=r.upperBoxElem;V.attr({fill:M,"drop-shadow":V.attrs["drop-shadow"]&&"none"!==V.attrs["drop-shadow"]?[1,1,3,"rgba(64,64,64,"+N(M)+")",V.attrs[4],V.attrs["drop-shadow"][5]]:"none"});V=r.lowerBoxElem;V.attr({fill:C,"drop-shadow":V.attrs["drop-shadow"]&&"none"!==V.attrs["drop-shadow"]?[1,1,3,"rgba(64,64,64,"+N(C)+")",V.attrs[4],V.attrs["drop-shadow"][5]]:"none"});V=r.lowerBoxBorderEle;V.attr({stroke:na});r.upperBoxBorderEle&&r.upperBoxBorderEle.attr({stroke:I});
r.lowerQuartileEle&&r.lowerQuartileEle.attr({stroke:ea});r.upperQuartileEle&&r.upperQuartileEle.attr({stroke:ra});r.midLineElem&&r.midLineElem.attr({stroke:O})}}},heatmap:function(a,c,e,g){var m=g.chart,n=m.config;g=n.dataLabelStyle;var n=m.components.legend,r,v,m=this.legendItemId,w,A;a=ga(a);var D=n.getItems()||[];if(!e&&this.config.visible){a.alpha||(a.alpha=30);n=this.config;w=0;for(e=D.length;w<e&&(r=D[w],A=r.legendItemId,A!==m);w++);m=r.graphics;p(m,r.config,a,c);r=d(n.color);n=N(n.color);r=
c?l(a.color,r):r;n=c?a.alpha:100*n;e=this.graphics;m=e.element;m.attr({fill:F({color:r,alpha:n})});c||N(g.color);for(v in e)m=e[v],"text"===m.type&&M(m,a,g,c)}},funnelpyramid:function(a,c,e,g){g=g.chart.components.legend;var m,n,r,v,w;a=ga(a);g=g.getItems()||[];n=this.legendItemId;if(!1===e){a.alpha||(a.alpha=30);r=0;for(e=g.length;r<e&&(m=g[r],v=m.legendItemId,v!==n);r++);e=m.graphics;p(e,m.config,a,c);m=this.style;g=this.color;e=d(g);g=N(g);e=c?l(a.color,e):e;r=c?a.alpha:100*g;n=this.plot.graphic;
v=this.plot.dataLabel;w=this.plot.connector;g=this.plot.point.style;n&&n.attr({fill:F({color:e,alpha:r})});v&&M(v,a,g,c);w&&w.attr({opacity:c?a.alpha/100:N(m.color)})}},"default":function(a,c,d){var e=this.config,g=this.chart,r=g.config,v=r.dataLabelStyle,w=r.useroundedges,A=g.is3D,D,I,J;a=ga(a);var C=this.graphics,za=C.legendGraphics,Ja=C.dataLabelContainer;J=C.errorGroupContainer;var na,ea,r="",r=this.legendItemId,ra=g.components.legend.components.items||[];na=ra.length;g=e.showShadow;C=m.graphics.getColumnColor;
if(!1===d&&!0===this.visible){a.alpha||(a.alpha="30");d=this.components.data||[];for(D=0;D<na&&(I=ra[D]||{},I.legendItemId!==r);D++);za&&p(za,I.config,a,c);Ja&&Ja.attr({opacity:c?a.alpha/100:N(v.color)});J&&(na=N(e.errorBarColor),na=c?l(a.alpha/100,na):na,J.attr({opacity:na}));D=0;for(na=d.length;D<na;D++)if((e=d[D])&&e.graphics){r=e.config;J=r.colorArr[0];I=r.colorArr[1];za=I.FCcolor.alpha;r=J.FCcolor.color;r=-1!==(ea=r.indexOf(","))&&a.color?a.color+r.substring(ea):l(a.color,r);Ja=A?za:l(a.borderalpha,
a.alpha,za);0===n(za)&&(Ja="0");za=c?C(r,a.alpha,J.FCcolor.ratio,J.FCcolor.angle,w,l(a.bordercolor,I.FCcolor.color),Ja,!1,A):[J,I];if(J=e.graphics.element)r=F(za[0]),I=F(za[1]),J.attr({stroke:I,fill:r}).shadow({opacity:g?O(za[0].alpha)/100:0});e=e.graphics.label;M(e,a,v,c)}}}},v=function(){this.effectStore={};this.eventHandlers={}},M=function(a,c,e,g){var m,n,p,r,v;m=d(e.color);p=100*N(e.color);n=g?l(c.valuefontcolor,m):m;r=g?l(c.valuefontalpha,c.alpha,p):p;m=""===e.backgroundColor?"":d(e.backgroundColor);
p=""===e.backgroundColor?0:100*N(e.backgroundColor);isNaN(p)&&(p=0);v=g?l(c.valuebgcolor,m):m;p=g?l(c.valuebgalpha,c.alpha,p):p;v=F({color:v,alpha:p});m=""===e.borderColor?"":d(e.borderColor);p=""===e.borderColor?"":100*N(e.borderColor);isNaN(p)&&(p=0);m=g?l(c.valuebordercolor,m):m;c=g?l(c.valueborderalpha,c.alpha,p):p;c=F({color:m,alpha:c});a&&a.attr({fill:F({color:n,alpha:r}),"text-bound":[v,c,e.borderThickness,e.borderPadding,e.borderRadius,e.borderDash]})},e=new v;v.prototype.add=function(a){this.effectStore[a.name]=
a};v.prototype.attachEventHandlers=function(a,c){this.eventHandlers[a]||(this.eventHandlers[a]={},this.eventHandlers[a].listenerFn=g.addEventListener(a,c))};v.prototype.applyEffect=function(a,c,d){var e=this.effectStore,g=a.jsonData.chart,m=a.defaultDatasetType,n=g.plothighlighteffect&&g.plothighlighteffect.toLowerCase(),g=a.components.dataset;a=a.isSingleSeries?g[0].components.data:g;c=l(c.itemId,c.legendItemId,c.legendItemIndex);var p,r,v,w="",A;n&&(n=n.replace(/\s+/g,"").split("|"),A=n[0],w=n[1]||
"");if(A&&e[A])for(r=0,v=a.length;r<v;r++)n=a[r],m=n.type||m,m=m.toLowerCase(),p=l(n.itemId,n.legendItemId),void 0!==p&&(p=p===c,e[A][m]?e[A][m].call(n,w,d,p,g[0]):e[A]["default"].call(n,w,d,p,g[0]))};g.registrars.highlighteffect=function(a){a&&e.add(a)};e.attachEventHandlers("legenditemrollover",function(a,c){var d=a.sender.jsVars.instanceAPI;!1!==d.hasInteractiveLegend&&!1!==d.highlightEnabled&&e.applyEffect(d,c,!0)});e.attachEventHandlers("legenditemrollout",function(a,c){var d=a.sender.jsVars.instanceAPI;
!1!==d.hasInteractiveLegend&&!1!==d.highlightEnabled&&e.applyEffect(d,c,!1)});e.attachEventHandlers("legenditemclicked",function(a,c){var d=a.sender.jsVars.instanceAPI;!1!==d.hasInteractiveLegend&&!1!==d.highlightEnabled&&e.applyEffect(d,c,!0)});FusionCharts.register("highlightEffect",{name:"fadeout",area:c.area,radar:c.area,bubble:c.bubble,pie2d:c.pie,line:c.line,spline:c.line,areaspline:c.area,pie3d:c.pie,zoomline:c.line,funnel:c.funnelpyramid,pyramid:c.funnelpyramid,scatter:c.line,doughnut2d:c.pie,
doughnut3d:c.pie,heatmap:c.heatmap,boxandwhisker2d:c.boxandwhisker2d,multiaxisline:c.line,"default":c["default"]})}]);Jb&&(Ab.FusionCharts=FusionCharts);return FusionCharts});

},{}],5:[function(require,module,exports){
/*!
 * jQuery JavaScript Library v3.1.1
 * https://jquery.com/
 *
 * Includes Sizzle.js
 * https://sizzlejs.com/
 *
 * Copyright jQuery Foundation and other contributors
 * Released under the MIT license
 * https://jquery.org/license
 *
 * Date: 2016-09-22T22:30Z
 */
( function( global, factory ) {

	"use strict";

	if ( typeof module === "object" && typeof module.exports === "object" ) {

		// For CommonJS and CommonJS-like environments where a proper `window`
		// is present, execute the factory and get jQuery.
		// For environments that do not have a `window` with a `document`
		// (such as Node.js), expose a factory as module.exports.
		// This accentuates the need for the creation of a real `window`.
		// e.g. var jQuery = require("jquery")(window);
		// See ticket #14549 for more info.
		module.exports = global.document ?
			factory( global, true ) :
			function( w ) {
				if ( !w.document ) {
					throw new Error( "jQuery requires a window with a document" );
				}
				return factory( w );
			};
	} else {
		factory( global );
	}

// Pass this if window is not defined yet
} )( typeof window !== "undefined" ? window : this, function( window, noGlobal ) {

// Edge <= 12 - 13+, Firefox <=18 - 45+, IE 10 - 11, Safari 5.1 - 9+, iOS 6 - 9.1
// throw exceptions when non-strict code (e.g., ASP.NET 4.5) accesses strict mode
// arguments.callee.caller (trac-13335). But as of jQuery 3.0 (2016), strict mode should be common
// enough that all such attempts are guarded in a try block.
"use strict";

var arr = [];

var document = window.document;

var getProto = Object.getPrototypeOf;

var slice = arr.slice;

var concat = arr.concat;

var push = arr.push;

var indexOf = arr.indexOf;

var class2type = {};

var toString = class2type.toString;

var hasOwn = class2type.hasOwnProperty;

var fnToString = hasOwn.toString;

var ObjectFunctionString = fnToString.call( Object );

var support = {};



	function DOMEval( code, doc ) {
		doc = doc || document;

		var script = doc.createElement( "script" );

		script.text = code;
		doc.head.appendChild( script ).parentNode.removeChild( script );
	}
/* global Symbol */
// Defining this global in .eslintrc.json would create a danger of using the global
// unguarded in another place, it seems safer to define global only for this module



var
	version = "3.1.1",

	// Define a local copy of jQuery
	jQuery = function( selector, context ) {

		// The jQuery object is actually just the init constructor 'enhanced'
		// Need init if jQuery is called (just allow error to be thrown if not included)
		return new jQuery.fn.init( selector, context );
	},

	// Support: Android <=4.0 only
	// Make sure we trim BOM and NBSP
	rtrim = /^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,

	// Matches dashed string for camelizing
	rmsPrefix = /^-ms-/,
	rdashAlpha = /-([a-z])/g,

	// Used by jQuery.camelCase as callback to replace()
	fcamelCase = function( all, letter ) {
		return letter.toUpperCase();
	};

jQuery.fn = jQuery.prototype = {

	// The current version of jQuery being used
	jquery: version,

	constructor: jQuery,

	// The default length of a jQuery object is 0
	length: 0,

	toArray: function() {
		return slice.call( this );
	},

	// Get the Nth element in the matched element set OR
	// Get the whole matched element set as a clean array
	get: function( num ) {

		// Return all the elements in a clean array
		if ( num == null ) {
			return slice.call( this );
		}

		// Return just the one element from the set
		return num < 0 ? this[ num + this.length ] : this[ num ];
	},

	// Take an array of elements and push it onto the stack
	// (returning the new matched element set)
	pushStack: function( elems ) {

		// Build a new jQuery matched element set
		var ret = jQuery.merge( this.constructor(), elems );

		// Add the old object onto the stack (as a reference)
		ret.prevObject = this;

		// Return the newly-formed element set
		return ret;
	},

	// Execute a callback for every element in the matched set.
	each: function( callback ) {
		return jQuery.each( this, callback );
	},

	map: function( callback ) {
		return this.pushStack( jQuery.map( this, function( elem, i ) {
			return callback.call( elem, i, elem );
		} ) );
	},

	slice: function() {
		return this.pushStack( slice.apply( this, arguments ) );
	},

	first: function() {
		return this.eq( 0 );
	},

	last: function() {
		return this.eq( -1 );
	},

	eq: function( i ) {
		var len = this.length,
			j = +i + ( i < 0 ? len : 0 );
		return this.pushStack( j >= 0 && j < len ? [ this[ j ] ] : [] );
	},

	end: function() {
		return this.prevObject || this.constructor();
	},

	// For internal use only.
	// Behaves like an Array's method, not like a jQuery method.
	push: push,
	sort: arr.sort,
	splice: arr.splice
};

jQuery.extend = jQuery.fn.extend = function() {
	var options, name, src, copy, copyIsArray, clone,
		target = arguments[ 0 ] || {},
		i = 1,
		length = arguments.length,
		deep = false;

	// Handle a deep copy situation
	if ( typeof target === "boolean" ) {
		deep = target;

		// Skip the boolean and the target
		target = arguments[ i ] || {};
		i++;
	}

	// Handle case when target is a string or something (possible in deep copy)
	if ( typeof target !== "object" && !jQuery.isFunction( target ) ) {
		target = {};
	}

	// Extend jQuery itself if only one argument is passed
	if ( i === length ) {
		target = this;
		i--;
	}

	for ( ; i < length; i++ ) {

		// Only deal with non-null/undefined values
		if ( ( options = arguments[ i ] ) != null ) {

			// Extend the base object
			for ( name in options ) {
				src = target[ name ];
				copy = options[ name ];

				// Prevent never-ending loop
				if ( target === copy ) {
					continue;
				}

				// Recurse if we're merging plain objects or arrays
				if ( deep && copy && ( jQuery.isPlainObject( copy ) ||
					( copyIsArray = jQuery.isArray( copy ) ) ) ) {

					if ( copyIsArray ) {
						copyIsArray = false;
						clone = src && jQuery.isArray( src ) ? src : [];

					} else {
						clone = src && jQuery.isPlainObject( src ) ? src : {};
					}

					// Never move original objects, clone them
					target[ name ] = jQuery.extend( deep, clone, copy );

				// Don't bring in undefined values
				} else if ( copy !== undefined ) {
					target[ name ] = copy;
				}
			}
		}
	}

	// Return the modified object
	return target;
};

jQuery.extend( {

	// Unique for each copy of jQuery on the page
	expando: "jQuery" + ( version + Math.random() ).replace( /\D/g, "" ),

	// Assume jQuery is ready without the ready module
	isReady: true,

	error: function( msg ) {
		throw new Error( msg );
	},

	noop: function() {},

	isFunction: function( obj ) {
		return jQuery.type( obj ) === "function";
	},

	isArray: Array.isArray,

	isWindow: function( obj ) {
		return obj != null && obj === obj.window;
	},

	isNumeric: function( obj ) {

		// As of jQuery 3.0, isNumeric is limited to
		// strings and numbers (primitives or objects)
		// that can be coerced to finite numbers (gh-2662)
		var type = jQuery.type( obj );
		return ( type === "number" || type === "string" ) &&

			// parseFloat NaNs numeric-cast false positives ("")
			// ...but misinterprets leading-number strings, particularly hex literals ("0x...")
			// subtraction forces infinities to NaN
			!isNaN( obj - parseFloat( obj ) );
	},

	isPlainObject: function( obj ) {
		var proto, Ctor;

		// Detect obvious negatives
		// Use toString instead of jQuery.type to catch host objects
		if ( !obj || toString.call( obj ) !== "[object Object]" ) {
			return false;
		}

		proto = getProto( obj );

		// Objects with no prototype (e.g., `Object.create( null )`) are plain
		if ( !proto ) {
			return true;
		}

		// Objects with prototype are plain iff they were constructed by a global Object function
		Ctor = hasOwn.call( proto, "constructor" ) && proto.constructor;
		return typeof Ctor === "function" && fnToString.call( Ctor ) === ObjectFunctionString;
	},

	isEmptyObject: function( obj ) {

		/* eslint-disable no-unused-vars */
		// See https://github.com/eslint/eslint/issues/6125
		var name;

		for ( name in obj ) {
			return false;
		}
		return true;
	},

	type: function( obj ) {
		if ( obj == null ) {
			return obj + "";
		}

		// Support: Android <=2.3 only (functionish RegExp)
		return typeof obj === "object" || typeof obj === "function" ?
			class2type[ toString.call( obj ) ] || "object" :
			typeof obj;
	},

	// Evaluates a script in a global context
	globalEval: function( code ) {
		DOMEval( code );
	},

	// Convert dashed to camelCase; used by the css and data modules
	// Support: IE <=9 - 11, Edge 12 - 13
	// Microsoft forgot to hump their vendor prefix (#9572)
	camelCase: function( string ) {
		return string.replace( rmsPrefix, "ms-" ).replace( rdashAlpha, fcamelCase );
	},

	nodeName: function( elem, name ) {
		return elem.nodeName && elem.nodeName.toLowerCase() === name.toLowerCase();
	},

	each: function( obj, callback ) {
		var length, i = 0;

		if ( isArrayLike( obj ) ) {
			length = obj.length;
			for ( ; i < length; i++ ) {
				if ( callback.call( obj[ i ], i, obj[ i ] ) === false ) {
					break;
				}
			}
		} else {
			for ( i in obj ) {
				if ( callback.call( obj[ i ], i, obj[ i ] ) === false ) {
					break;
				}
			}
		}

		return obj;
	},

	// Support: Android <=4.0 only
	trim: function( text ) {
		return text == null ?
			"" :
			( text + "" ).replace( rtrim, "" );
	},

	// results is for internal usage only
	makeArray: function( arr, results ) {
		var ret = results || [];

		if ( arr != null ) {
			if ( isArrayLike( Object( arr ) ) ) {
				jQuery.merge( ret,
					typeof arr === "string" ?
					[ arr ] : arr
				);
			} else {
				push.call( ret, arr );
			}
		}

		return ret;
	},

	inArray: function( elem, arr, i ) {
		return arr == null ? -1 : indexOf.call( arr, elem, i );
	},

	// Support: Android <=4.0 only, PhantomJS 1 only
	// push.apply(_, arraylike) throws on ancient WebKit
	merge: function( first, second ) {
		var len = +second.length,
			j = 0,
			i = first.length;

		for ( ; j < len; j++ ) {
			first[ i++ ] = second[ j ];
		}

		first.length = i;

		return first;
	},

	grep: function( elems, callback, invert ) {
		var callbackInverse,
			matches = [],
			i = 0,
			length = elems.length,
			callbackExpect = !invert;

		// Go through the array, only saving the items
		// that pass the validator function
		for ( ; i < length; i++ ) {
			callbackInverse = !callback( elems[ i ], i );
			if ( callbackInverse !== callbackExpect ) {
				matches.push( elems[ i ] );
			}
		}

		return matches;
	},

	// arg is for internal usage only
	map: function( elems, callback, arg ) {
		var length, value,
			i = 0,
			ret = [];

		// Go through the array, translating each of the items to their new values
		if ( isArrayLike( elems ) ) {
			length = elems.length;
			for ( ; i < length; i++ ) {
				value = callback( elems[ i ], i, arg );

				if ( value != null ) {
					ret.push( value );
				}
			}

		// Go through every key on the object,
		} else {
			for ( i in elems ) {
				value = callback( elems[ i ], i, arg );

				if ( value != null ) {
					ret.push( value );
				}
			}
		}

		// Flatten any nested arrays
		return concat.apply( [], ret );
	},

	// A global GUID counter for objects
	guid: 1,

	// Bind a function to a context, optionally partially applying any
	// arguments.
	proxy: function( fn, context ) {
		var tmp, args, proxy;

		if ( typeof context === "string" ) {
			tmp = fn[ context ];
			context = fn;
			fn = tmp;
		}

		// Quick check to determine if target is callable, in the spec
		// this throws a TypeError, but we will just return undefined.
		if ( !jQuery.isFunction( fn ) ) {
			return undefined;
		}

		// Simulated bind
		args = slice.call( arguments, 2 );
		proxy = function() {
			return fn.apply( context || this, args.concat( slice.call( arguments ) ) );
		};

		// Set the guid of unique handler to the same of original handler, so it can be removed
		proxy.guid = fn.guid = fn.guid || jQuery.guid++;

		return proxy;
	},

	now: Date.now,

	// jQuery.support is not used in Core but other projects attach their
	// properties to it so it needs to exist.
	support: support
} );

if ( typeof Symbol === "function" ) {
	jQuery.fn[ Symbol.iterator ] = arr[ Symbol.iterator ];
}

// Populate the class2type map
jQuery.each( "Boolean Number String Function Array Date RegExp Object Error Symbol".split( " " ),
function( i, name ) {
	class2type[ "[object " + name + "]" ] = name.toLowerCase();
} );

function isArrayLike( obj ) {

	// Support: real iOS 8.2 only (not reproducible in simulator)
	// `in` check used to prevent JIT error (gh-2145)
	// hasOwn isn't used here due to false negatives
	// regarding Nodelist length in IE
	var length = !!obj && "length" in obj && obj.length,
		type = jQuery.type( obj );

	if ( type === "function" || jQuery.isWindow( obj ) ) {
		return false;
	}

	return type === "array" || length === 0 ||
		typeof length === "number" && length > 0 && ( length - 1 ) in obj;
}
var Sizzle =
/*!
 * Sizzle CSS Selector Engine v2.3.3
 * https://sizzlejs.com/
 *
 * Copyright jQuery Foundation and other contributors
 * Released under the MIT license
 * http://jquery.org/license
 *
 * Date: 2016-08-08
 */
(function( window ) {

var i,
	support,
	Expr,
	getText,
	isXML,
	tokenize,
	compile,
	select,
	outermostContext,
	sortInput,
	hasDuplicate,

	// Local document vars
	setDocument,
	document,
	docElem,
	documentIsHTML,
	rbuggyQSA,
	rbuggyMatches,
	matches,
	contains,

	// Instance-specific data
	expando = "sizzle" + 1 * new Date(),
	preferredDoc = window.document,
	dirruns = 0,
	done = 0,
	classCache = createCache(),
	tokenCache = createCache(),
	compilerCache = createCache(),
	sortOrder = function( a, b ) {
		if ( a === b ) {
			hasDuplicate = true;
		}
		return 0;
	},

	// Instance methods
	hasOwn = ({}).hasOwnProperty,
	arr = [],
	pop = arr.pop,
	push_native = arr.push,
	push = arr.push,
	slice = arr.slice,
	// Use a stripped-down indexOf as it's faster than native
	// https://jsperf.com/thor-indexof-vs-for/5
	indexOf = function( list, elem ) {
		var i = 0,
			len = list.length;
		for ( ; i < len; i++ ) {
			if ( list[i] === elem ) {
				return i;
			}
		}
		return -1;
	},

	booleans = "checked|selected|async|autofocus|autoplay|controls|defer|disabled|hidden|ismap|loop|multiple|open|readonly|required|scoped",

	// Regular expressions

	// http://www.w3.org/TR/css3-selectors/#whitespace
	whitespace = "[\\x20\\t\\r\\n\\f]",

	// http://www.w3.org/TR/CSS21/syndata.html#value-def-identifier
	identifier = "(?:\\\\.|[\\w-]|[^\0-\\xa0])+",

	// Attribute selectors: http://www.w3.org/TR/selectors/#attribute-selectors
	attributes = "\\[" + whitespace + "*(" + identifier + ")(?:" + whitespace +
		// Operator (capture 2)
		"*([*^$|!~]?=)" + whitespace +
		// "Attribute values must be CSS identifiers [capture 5] or strings [capture 3 or capture 4]"
		"*(?:'((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\"|(" + identifier + "))|)" + whitespace +
		"*\\]",

	pseudos = ":(" + identifier + ")(?:\\((" +
		// To reduce the number of selectors needing tokenize in the preFilter, prefer arguments:
		// 1. quoted (capture 3; capture 4 or capture 5)
		"('((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\")|" +
		// 2. simple (capture 6)
		"((?:\\\\.|[^\\\\()[\\]]|" + attributes + ")*)|" +
		// 3. anything else (capture 2)
		".*" +
		")\\)|)",

	// Leading and non-escaped trailing whitespace, capturing some non-whitespace characters preceding the latter
	rwhitespace = new RegExp( whitespace + "+", "g" ),
	rtrim = new RegExp( "^" + whitespace + "+|((?:^|[^\\\\])(?:\\\\.)*)" + whitespace + "+$", "g" ),

	rcomma = new RegExp( "^" + whitespace + "*," + whitespace + "*" ),
	rcombinators = new RegExp( "^" + whitespace + "*([>+~]|" + whitespace + ")" + whitespace + "*" ),

	rattributeQuotes = new RegExp( "=" + whitespace + "*([^\\]'\"]*?)" + whitespace + "*\\]", "g" ),

	rpseudo = new RegExp( pseudos ),
	ridentifier = new RegExp( "^" + identifier + "$" ),

	matchExpr = {
		"ID": new RegExp( "^#(" + identifier + ")" ),
		"CLASS": new RegExp( "^\\.(" + identifier + ")" ),
		"TAG": new RegExp( "^(" + identifier + "|[*])" ),
		"ATTR": new RegExp( "^" + attributes ),
		"PSEUDO": new RegExp( "^" + pseudos ),
		"CHILD": new RegExp( "^:(only|first|last|nth|nth-last)-(child|of-type)(?:\\(" + whitespace +
			"*(even|odd|(([+-]|)(\\d*)n|)" + whitespace + "*(?:([+-]|)" + whitespace +
			"*(\\d+)|))" + whitespace + "*\\)|)", "i" ),
		"bool": new RegExp( "^(?:" + booleans + ")$", "i" ),
		// For use in libraries implementing .is()
		// We use this for POS matching in `select`
		"needsContext": new RegExp( "^" + whitespace + "*[>+~]|:(even|odd|eq|gt|lt|nth|first|last)(?:\\(" +
			whitespace + "*((?:-\\d)?\\d*)" + whitespace + "*\\)|)(?=[^-]|$)", "i" )
	},

	rinputs = /^(?:input|select|textarea|button)$/i,
	rheader = /^h\d$/i,

	rnative = /^[^{]+\{\s*\[native \w/,

	// Easily-parseable/retrievable ID or TAG or CLASS selectors
	rquickExpr = /^(?:#([\w-]+)|(\w+)|\.([\w-]+))$/,

	rsibling = /[+~]/,

	// CSS escapes
	// http://www.w3.org/TR/CSS21/syndata.html#escaped-characters
	runescape = new RegExp( "\\\\([\\da-f]{1,6}" + whitespace + "?|(" + whitespace + ")|.)", "ig" ),
	funescape = function( _, escaped, escapedWhitespace ) {
		var high = "0x" + escaped - 0x10000;
		// NaN means non-codepoint
		// Support: Firefox<24
		// Workaround erroneous numeric interpretation of +"0x"
		return high !== high || escapedWhitespace ?
			escaped :
			high < 0 ?
				// BMP codepoint
				String.fromCharCode( high + 0x10000 ) :
				// Supplemental Plane codepoint (surrogate pair)
				String.fromCharCode( high >> 10 | 0xD800, high & 0x3FF | 0xDC00 );
	},

	// CSS string/identifier serialization
	// https://drafts.csswg.org/cssom/#common-serializing-idioms
	rcssescape = /([\0-\x1f\x7f]|^-?\d)|^-$|[^\0-\x1f\x7f-\uFFFF\w-]/g,
	fcssescape = function( ch, asCodePoint ) {
		if ( asCodePoint ) {

			// U+0000 NULL becomes U+FFFD REPLACEMENT CHARACTER
			if ( ch === "\0" ) {
				return "\uFFFD";
			}

			// Control characters and (dependent upon position) numbers get escaped as code points
			return ch.slice( 0, -1 ) + "\\" + ch.charCodeAt( ch.length - 1 ).toString( 16 ) + " ";
		}

		// Other potentially-special ASCII characters get backslash-escaped
		return "\\" + ch;
	},

	// Used for iframes
	// See setDocument()
	// Removing the function wrapper causes a "Permission Denied"
	// error in IE
	unloadHandler = function() {
		setDocument();
	},

	disabledAncestor = addCombinator(
		function( elem ) {
			return elem.disabled === true && ("form" in elem || "label" in elem);
		},
		{ dir: "parentNode", next: "legend" }
	);

// Optimize for push.apply( _, NodeList )
try {
	push.apply(
		(arr = slice.call( preferredDoc.childNodes )),
		preferredDoc.childNodes
	);
	// Support: Android<4.0
	// Detect silently failing push.apply
	arr[ preferredDoc.childNodes.length ].nodeType;
} catch ( e ) {
	push = { apply: arr.length ?

		// Leverage slice if possible
		function( target, els ) {
			push_native.apply( target, slice.call(els) );
		} :

		// Support: IE<9
		// Otherwise append directly
		function( target, els ) {
			var j = target.length,
				i = 0;
			// Can't trust NodeList.length
			while ( (target[j++] = els[i++]) ) {}
			target.length = j - 1;
		}
	};
}

function Sizzle( selector, context, results, seed ) {
	var m, i, elem, nid, match, groups, newSelector,
		newContext = context && context.ownerDocument,

		// nodeType defaults to 9, since context defaults to document
		nodeType = context ? context.nodeType : 9;

	results = results || [];

	// Return early from calls with invalid selector or context
	if ( typeof selector !== "string" || !selector ||
		nodeType !== 1 && nodeType !== 9 && nodeType !== 11 ) {

		return results;
	}

	// Try to shortcut find operations (as opposed to filters) in HTML documents
	if ( !seed ) {

		if ( ( context ? context.ownerDocument || context : preferredDoc ) !== document ) {
			setDocument( context );
		}
		context = context || document;

		if ( documentIsHTML ) {

			// If the selector is sufficiently simple, try using a "get*By*" DOM method
			// (excepting DocumentFragment context, where the methods don't exist)
			if ( nodeType !== 11 && (match = rquickExpr.exec( selector )) ) {

				// ID selector
				if ( (m = match[1]) ) {

					// Document context
					if ( nodeType === 9 ) {
						if ( (elem = context.getElementById( m )) ) {

							// Support: IE, Opera, Webkit
							// TODO: identify versions
							// getElementById can match elements by name instead of ID
							if ( elem.id === m ) {
								results.push( elem );
								return results;
							}
						} else {
							return results;
						}

					// Element context
					} else {

						// Support: IE, Opera, Webkit
						// TODO: identify versions
						// getElementById can match elements by name instead of ID
						if ( newContext && (elem = newContext.getElementById( m )) &&
							contains( context, elem ) &&
							elem.id === m ) {

							results.push( elem );
							return results;
						}
					}

				// Type selector
				} else if ( match[2] ) {
					push.apply( results, context.getElementsByTagName( selector ) );
					return results;

				// Class selector
				} else if ( (m = match[3]) && support.getElementsByClassName &&
					context.getElementsByClassName ) {

					push.apply( results, context.getElementsByClassName( m ) );
					return results;
				}
			}

			// Take advantage of querySelectorAll
			if ( support.qsa &&
				!compilerCache[ selector + " " ] &&
				(!rbuggyQSA || !rbuggyQSA.test( selector )) ) {

				if ( nodeType !== 1 ) {
					newContext = context;
					newSelector = selector;

				// qSA looks outside Element context, which is not what we want
				// Thanks to Andrew Dupont for this workaround technique
				// Support: IE <=8
				// Exclude object elements
				} else if ( context.nodeName.toLowerCase() !== "object" ) {

					// Capture the context ID, setting it first if necessary
					if ( (nid = context.getAttribute( "id" )) ) {
						nid = nid.replace( rcssescape, fcssescape );
					} else {
						context.setAttribute( "id", (nid = expando) );
					}

					// Prefix every selector in the list
					groups = tokenize( selector );
					i = groups.length;
					while ( i-- ) {
						groups[i] = "#" + nid + " " + toSelector( groups[i] );
					}
					newSelector = groups.join( "," );

					// Expand context for sibling selectors
					newContext = rsibling.test( selector ) && testContext( context.parentNode ) ||
						context;
				}

				if ( newSelector ) {
					try {
						push.apply( results,
							newContext.querySelectorAll( newSelector )
						);
						return results;
					} catch ( qsaError ) {
					} finally {
						if ( nid === expando ) {
							context.removeAttribute( "id" );
						}
					}
				}
			}
		}
	}

	// All others
	return select( selector.replace( rtrim, "$1" ), context, results, seed );
}

/**
 * Create key-value caches of limited size
 * @returns {function(string, object)} Returns the Object data after storing it on itself with
 *	property name the (space-suffixed) string and (if the cache is larger than Expr.cacheLength)
 *	deleting the oldest entry
 */
function createCache() {
	var keys = [];

	function cache( key, value ) {
		// Use (key + " ") to avoid collision with native prototype properties (see Issue #157)
		if ( keys.push( key + " " ) > Expr.cacheLength ) {
			// Only keep the most recent entries
			delete cache[ keys.shift() ];
		}
		return (cache[ key + " " ] = value);
	}
	return cache;
}

/**
 * Mark a function for special use by Sizzle
 * @param {Function} fn The function to mark
 */
function markFunction( fn ) {
	fn[ expando ] = true;
	return fn;
}

/**
 * Support testing using an element
 * @param {Function} fn Passed the created element and returns a boolean result
 */
function assert( fn ) {
	var el = document.createElement("fieldset");

	try {
		return !!fn( el );
	} catch (e) {
		return false;
	} finally {
		// Remove from its parent by default
		if ( el.parentNode ) {
			el.parentNode.removeChild( el );
		}
		// release memory in IE
		el = null;
	}
}

/**
 * Adds the same handler for all of the specified attrs
 * @param {String} attrs Pipe-separated list of attributes
 * @param {Function} handler The method that will be applied
 */
function addHandle( attrs, handler ) {
	var arr = attrs.split("|"),
		i = arr.length;

	while ( i-- ) {
		Expr.attrHandle[ arr[i] ] = handler;
	}
}

/**
 * Checks document order of two siblings
 * @param {Element} a
 * @param {Element} b
 * @returns {Number} Returns less than 0 if a precedes b, greater than 0 if a follows b
 */
function siblingCheck( a, b ) {
	var cur = b && a,
		diff = cur && a.nodeType === 1 && b.nodeType === 1 &&
			a.sourceIndex - b.sourceIndex;

	// Use IE sourceIndex if available on both nodes
	if ( diff ) {
		return diff;
	}

	// Check if b follows a
	if ( cur ) {
		while ( (cur = cur.nextSibling) ) {
			if ( cur === b ) {
				return -1;
			}
		}
	}

	return a ? 1 : -1;
}

/**
 * Returns a function to use in pseudos for input types
 * @param {String} type
 */
function createInputPseudo( type ) {
	return function( elem ) {
		var name = elem.nodeName.toLowerCase();
		return name === "input" && elem.type === type;
	};
}

/**
 * Returns a function to use in pseudos for buttons
 * @param {String} type
 */
function createButtonPseudo( type ) {
	return function( elem ) {
		var name = elem.nodeName.toLowerCase();
		return (name === "input" || name === "button") && elem.type === type;
	};
}

/**
 * Returns a function to use in pseudos for :enabled/:disabled
 * @param {Boolean} disabled true for :disabled; false for :enabled
 */
function createDisabledPseudo( disabled ) {

	// Known :disabled false positives: fieldset[disabled] > legend:nth-of-type(n+2) :can-disable
	return function( elem ) {

		// Only certain elements can match :enabled or :disabled
		// https://html.spec.whatwg.org/multipage/scripting.html#selector-enabled
		// https://html.spec.whatwg.org/multipage/scripting.html#selector-disabled
		if ( "form" in elem ) {

			// Check for inherited disabledness on relevant non-disabled elements:
			// * listed form-associated elements in a disabled fieldset
			//   https://html.spec.whatwg.org/multipage/forms.html#category-listed
			//   https://html.spec.whatwg.org/multipage/forms.html#concept-fe-disabled
			// * option elements in a disabled optgroup
			//   https://html.spec.whatwg.org/multipage/forms.html#concept-option-disabled
			// All such elements have a "form" property.
			if ( elem.parentNode && elem.disabled === false ) {

				// Option elements defer to a parent optgroup if present
				if ( "label" in elem ) {
					if ( "label" in elem.parentNode ) {
						return elem.parentNode.disabled === disabled;
					} else {
						return elem.disabled === disabled;
					}
				}

				// Support: IE 6 - 11
				// Use the isDisabled shortcut property to check for disabled fieldset ancestors
				return elem.isDisabled === disabled ||

					// Where there is no isDisabled, check manually
					/* jshint -W018 */
					elem.isDisabled !== !disabled &&
						disabledAncestor( elem ) === disabled;
			}

			return elem.disabled === disabled;

		// Try to winnow out elements that can't be disabled before trusting the disabled property.
		// Some victims get caught in our net (label, legend, menu, track), but it shouldn't
		// even exist on them, let alone have a boolean value.
		} else if ( "label" in elem ) {
			return elem.disabled === disabled;
		}

		// Remaining elements are neither :enabled nor :disabled
		return false;
	};
}

/**
 * Returns a function to use in pseudos for positionals
 * @param {Function} fn
 */
function createPositionalPseudo( fn ) {
	return markFunction(function( argument ) {
		argument = +argument;
		return markFunction(function( seed, matches ) {
			var j,
				matchIndexes = fn( [], seed.length, argument ),
				i = matchIndexes.length;

			// Match elements found at the specified indexes
			while ( i-- ) {
				if ( seed[ (j = matchIndexes[i]) ] ) {
					seed[j] = !(matches[j] = seed[j]);
				}
			}
		});
	});
}

/**
 * Checks a node for validity as a Sizzle context
 * @param {Element|Object=} context
 * @returns {Element|Object|Boolean} The input node if acceptable, otherwise a falsy value
 */
function testContext( context ) {
	return context && typeof context.getElementsByTagName !== "undefined" && context;
}

// Expose support vars for convenience
support = Sizzle.support = {};

/**
 * Detects XML nodes
 * @param {Element|Object} elem An element or a document
 * @returns {Boolean} True iff elem is a non-HTML XML node
 */
isXML = Sizzle.isXML = function( elem ) {
	// documentElement is verified for cases where it doesn't yet exist
	// (such as loading iframes in IE - #4833)
	var documentElement = elem && (elem.ownerDocument || elem).documentElement;
	return documentElement ? documentElement.nodeName !== "HTML" : false;
};

/**
 * Sets document-related variables once based on the current document
 * @param {Element|Object} [doc] An element or document object to use to set the document
 * @returns {Object} Returns the current document
 */
setDocument = Sizzle.setDocument = function( node ) {
	var hasCompare, subWindow,
		doc = node ? node.ownerDocument || node : preferredDoc;

	// Return early if doc is invalid or already selected
	if ( doc === document || doc.nodeType !== 9 || !doc.documentElement ) {
		return document;
	}

	// Update global variables
	document = doc;
	docElem = document.documentElement;
	documentIsHTML = !isXML( document );

	// Support: IE 9-11, Edge
	// Accessing iframe documents after unload throws "permission denied" errors (jQuery #13936)
	if ( preferredDoc !== document &&
		(subWindow = document.defaultView) && subWindow.top !== subWindow ) {

		// Support: IE 11, Edge
		if ( subWindow.addEventListener ) {
			subWindow.addEventListener( "unload", unloadHandler, false );

		// Support: IE 9 - 10 only
		} else if ( subWindow.attachEvent ) {
			subWindow.attachEvent( "onunload", unloadHandler );
		}
	}

	/* Attributes
	---------------------------------------------------------------------- */

	// Support: IE<8
	// Verify that getAttribute really returns attributes and not properties
	// (excepting IE8 booleans)
	support.attributes = assert(function( el ) {
		el.className = "i";
		return !el.getAttribute("className");
	});

	/* getElement(s)By*
	---------------------------------------------------------------------- */

	// Check if getElementsByTagName("*") returns only elements
	support.getElementsByTagName = assert(function( el ) {
		el.appendChild( document.createComment("") );
		return !el.getElementsByTagName("*").length;
	});

	// Support: IE<9
	support.getElementsByClassName = rnative.test( document.getElementsByClassName );

	// Support: IE<10
	// Check if getElementById returns elements by name
	// The broken getElementById methods don't pick up programmatically-set names,
	// so use a roundabout getElementsByName test
	support.getById = assert(function( el ) {
		docElem.appendChild( el ).id = expando;
		return !document.getElementsByName || !document.getElementsByName( expando ).length;
	});

	// ID filter and find
	if ( support.getById ) {
		Expr.filter["ID"] = function( id ) {
			var attrId = id.replace( runescape, funescape );
			return function( elem ) {
				return elem.getAttribute("id") === attrId;
			};
		};
		Expr.find["ID"] = function( id, context ) {
			if ( typeof context.getElementById !== "undefined" && documentIsHTML ) {
				var elem = context.getElementById( id );
				return elem ? [ elem ] : [];
			}
		};
	} else {
		Expr.filter["ID"] =  function( id ) {
			var attrId = id.replace( runescape, funescape );
			return function( elem ) {
				var node = typeof elem.getAttributeNode !== "undefined" &&
					elem.getAttributeNode("id");
				return node && node.value === attrId;
			};
		};

		// Support: IE 6 - 7 only
		// getElementById is not reliable as a find shortcut
		Expr.find["ID"] = function( id, context ) {
			if ( typeof context.getElementById !== "undefined" && documentIsHTML ) {
				var node, i, elems,
					elem = context.getElementById( id );

				if ( elem ) {

					// Verify the id attribute
					node = elem.getAttributeNode("id");
					if ( node && node.value === id ) {
						return [ elem ];
					}

					// Fall back on getElementsByName
					elems = context.getElementsByName( id );
					i = 0;
					while ( (elem = elems[i++]) ) {
						node = elem.getAttributeNode("id");
						if ( node && node.value === id ) {
							return [ elem ];
						}
					}
				}

				return [];
			}
		};
	}

	// Tag
	Expr.find["TAG"] = support.getElementsByTagName ?
		function( tag, context ) {
			if ( typeof context.getElementsByTagName !== "undefined" ) {
				return context.getElementsByTagName( tag );

			// DocumentFragment nodes don't have gEBTN
			} else if ( support.qsa ) {
				return context.querySelectorAll( tag );
			}
		} :

		function( tag, context ) {
			var elem,
				tmp = [],
				i = 0,
				// By happy coincidence, a (broken) gEBTN appears on DocumentFragment nodes too
				results = context.getElementsByTagName( tag );

			// Filter out possible comments
			if ( tag === "*" ) {
				while ( (elem = results[i++]) ) {
					if ( elem.nodeType === 1 ) {
						tmp.push( elem );
					}
				}

				return tmp;
			}
			return results;
		};

	// Class
	Expr.find["CLASS"] = support.getElementsByClassName && function( className, context ) {
		if ( typeof context.getElementsByClassName !== "undefined" && documentIsHTML ) {
			return context.getElementsByClassName( className );
		}
	};

	/* QSA/matchesSelector
	---------------------------------------------------------------------- */

	// QSA and matchesSelector support

	// matchesSelector(:active) reports false when true (IE9/Opera 11.5)
	rbuggyMatches = [];

	// qSa(:focus) reports false when true (Chrome 21)
	// We allow this because of a bug in IE8/9 that throws an error
	// whenever `document.activeElement` is accessed on an iframe
	// So, we allow :focus to pass through QSA all the time to avoid the IE error
	// See https://bugs.jquery.com/ticket/13378
	rbuggyQSA = [];

	if ( (support.qsa = rnative.test( document.querySelectorAll )) ) {
		// Build QSA regex
		// Regex strategy adopted from Diego Perini
		assert(function( el ) {
			// Select is set to empty string on purpose
			// This is to test IE's treatment of not explicitly
			// setting a boolean content attribute,
			// since its presence should be enough
			// https://bugs.jquery.com/ticket/12359
			docElem.appendChild( el ).innerHTML = "<a id='" + expando + "'></a>" +
				"<select id='" + expando + "-\r\\' msallowcapture=''>" +
				"<option selected=''></option></select>";

			// Support: IE8, Opera 11-12.16
			// Nothing should be selected when empty strings follow ^= or $= or *=
			// The test attribute must be unknown in Opera but "safe" for WinRT
			// https://msdn.microsoft.com/en-us/library/ie/hh465388.aspx#attribute_section
			if ( el.querySelectorAll("[msallowcapture^='']").length ) {
				rbuggyQSA.push( "[*^$]=" + whitespace + "*(?:''|\"\")" );
			}

			// Support: IE8
			// Boolean attributes and "value" are not treated correctly
			if ( !el.querySelectorAll("[selected]").length ) {
				rbuggyQSA.push( "\\[" + whitespace + "*(?:value|" + booleans + ")" );
			}

			// Support: Chrome<29, Android<4.4, Safari<7.0+, iOS<7.0+, PhantomJS<1.9.8+
			if ( !el.querySelectorAll( "[id~=" + expando + "-]" ).length ) {
				rbuggyQSA.push("~=");
			}

			// Webkit/Opera - :checked should return selected option elements
			// http://www.w3.org/TR/2011/REC-css3-selectors-20110929/#checked
			// IE8 throws error here and will not see later tests
			if ( !el.querySelectorAll(":checked").length ) {
				rbuggyQSA.push(":checked");
			}

			// Support: Safari 8+, iOS 8+
			// https://bugs.webkit.org/show_bug.cgi?id=136851
			// In-page `selector#id sibling-combinator selector` fails
			if ( !el.querySelectorAll( "a#" + expando + "+*" ).length ) {
				rbuggyQSA.push(".#.+[+~]");
			}
		});

		assert(function( el ) {
			el.innerHTML = "<a href='' disabled='disabled'></a>" +
				"<select disabled='disabled'><option/></select>";

			// Support: Windows 8 Native Apps
			// The type and name attributes are restricted during .innerHTML assignment
			var input = document.createElement("input");
			input.setAttribute( "type", "hidden" );
			el.appendChild( input ).setAttribute( "name", "D" );

			// Support: IE8
			// Enforce case-sensitivity of name attribute
			if ( el.querySelectorAll("[name=d]").length ) {
				rbuggyQSA.push( "name" + whitespace + "*[*^$|!~]?=" );
			}

			// FF 3.5 - :enabled/:disabled and hidden elements (hidden elements are still enabled)
			// IE8 throws error here and will not see later tests
			if ( el.querySelectorAll(":enabled").length !== 2 ) {
				rbuggyQSA.push( ":enabled", ":disabled" );
			}

			// Support: IE9-11+
			// IE's :disabled selector does not pick up the children of disabled fieldsets
			docElem.appendChild( el ).disabled = true;
			if ( el.querySelectorAll(":disabled").length !== 2 ) {
				rbuggyQSA.push( ":enabled", ":disabled" );
			}

			// Opera 10-11 does not throw on post-comma invalid pseudos
			el.querySelectorAll("*,:x");
			rbuggyQSA.push(",.*:");
		});
	}

	if ( (support.matchesSelector = rnative.test( (matches = docElem.matches ||
		docElem.webkitMatchesSelector ||
		docElem.mozMatchesSelector ||
		docElem.oMatchesSelector ||
		docElem.msMatchesSelector) )) ) {

		assert(function( el ) {
			// Check to see if it's possible to do matchesSelector
			// on a disconnected node (IE 9)
			support.disconnectedMatch = matches.call( el, "*" );

			// This should fail with an exception
			// Gecko does not error, returns false instead
			matches.call( el, "[s!='']:x" );
			rbuggyMatches.push( "!=", pseudos );
		});
	}

	rbuggyQSA = rbuggyQSA.length && new RegExp( rbuggyQSA.join("|") );
	rbuggyMatches = rbuggyMatches.length && new RegExp( rbuggyMatches.join("|") );

	/* Contains
	---------------------------------------------------------------------- */
	hasCompare = rnative.test( docElem.compareDocumentPosition );

	// Element contains another
	// Purposefully self-exclusive
	// As in, an element does not contain itself
	contains = hasCompare || rnative.test( docElem.contains ) ?
		function( a, b ) {
			var adown = a.nodeType === 9 ? a.documentElement : a,
				bup = b && b.parentNode;
			return a === bup || !!( bup && bup.nodeType === 1 && (
				adown.contains ?
					adown.contains( bup ) :
					a.compareDocumentPosition && a.compareDocumentPosition( bup ) & 16
			));
		} :
		function( a, b ) {
			if ( b ) {
				while ( (b = b.parentNode) ) {
					if ( b === a ) {
						return true;
					}
				}
			}
			return false;
		};

	/* Sorting
	---------------------------------------------------------------------- */

	// Document order sorting
	sortOrder = hasCompare ?
	function( a, b ) {

		// Flag for duplicate removal
		if ( a === b ) {
			hasDuplicate = true;
			return 0;
		}

		// Sort on method existence if only one input has compareDocumentPosition
		var compare = !a.compareDocumentPosition - !b.compareDocumentPosition;
		if ( compare ) {
			return compare;
		}

		// Calculate position if both inputs belong to the same document
		compare = ( a.ownerDocument || a ) === ( b.ownerDocument || b ) ?
			a.compareDocumentPosition( b ) :

			// Otherwise we know they are disconnected
			1;

		// Disconnected nodes
		if ( compare & 1 ||
			(!support.sortDetached && b.compareDocumentPosition( a ) === compare) ) {

			// Choose the first element that is related to our preferred document
			if ( a === document || a.ownerDocument === preferredDoc && contains(preferredDoc, a) ) {
				return -1;
			}
			if ( b === document || b.ownerDocument === preferredDoc && contains(preferredDoc, b) ) {
				return 1;
			}

			// Maintain original order
			return sortInput ?
				( indexOf( sortInput, a ) - indexOf( sortInput, b ) ) :
				0;
		}

		return compare & 4 ? -1 : 1;
	} :
	function( a, b ) {
		// Exit early if the nodes are identical
		if ( a === b ) {
			hasDuplicate = true;
			return 0;
		}

		var cur,
			i = 0,
			aup = a.parentNode,
			bup = b.parentNode,
			ap = [ a ],
			bp = [ b ];

		// Parentless nodes are either documents or disconnected
		if ( !aup || !bup ) {
			return a === document ? -1 :
				b === document ? 1 :
				aup ? -1 :
				bup ? 1 :
				sortInput ?
				( indexOf( sortInput, a ) - indexOf( sortInput, b ) ) :
				0;

		// If the nodes are siblings, we can do a quick check
		} else if ( aup === bup ) {
			return siblingCheck( a, b );
		}

		// Otherwise we need full lists of their ancestors for comparison
		cur = a;
		while ( (cur = cur.parentNode) ) {
			ap.unshift( cur );
		}
		cur = b;
		while ( (cur = cur.parentNode) ) {
			bp.unshift( cur );
		}

		// Walk down the tree looking for a discrepancy
		while ( ap[i] === bp[i] ) {
			i++;
		}

		return i ?
			// Do a sibling check if the nodes have a common ancestor
			siblingCheck( ap[i], bp[i] ) :

			// Otherwise nodes in our document sort first
			ap[i] === preferredDoc ? -1 :
			bp[i] === preferredDoc ? 1 :
			0;
	};

	return document;
};

Sizzle.matches = function( expr, elements ) {
	return Sizzle( expr, null, null, elements );
};

Sizzle.matchesSelector = function( elem, expr ) {
	// Set document vars if needed
	if ( ( elem.ownerDocument || elem ) !== document ) {
		setDocument( elem );
	}

	// Make sure that attribute selectors are quoted
	expr = expr.replace( rattributeQuotes, "='$1']" );

	if ( support.matchesSelector && documentIsHTML &&
		!compilerCache[ expr + " " ] &&
		( !rbuggyMatches || !rbuggyMatches.test( expr ) ) &&
		( !rbuggyQSA     || !rbuggyQSA.test( expr ) ) ) {

		try {
			var ret = matches.call( elem, expr );

			// IE 9's matchesSelector returns false on disconnected nodes
			if ( ret || support.disconnectedMatch ||
					// As well, disconnected nodes are said to be in a document
					// fragment in IE 9
					elem.document && elem.document.nodeType !== 11 ) {
				return ret;
			}
		} catch (e) {}
	}

	return Sizzle( expr, document, null, [ elem ] ).length > 0;
};

Sizzle.contains = function( context, elem ) {
	// Set document vars if needed
	if ( ( context.ownerDocument || context ) !== document ) {
		setDocument( context );
	}
	return contains( context, elem );
};

Sizzle.attr = function( elem, name ) {
	// Set document vars if needed
	if ( ( elem.ownerDocument || elem ) !== document ) {
		setDocument( elem );
	}

	var fn = Expr.attrHandle[ name.toLowerCase() ],
		// Don't get fooled by Object.prototype properties (jQuery #13807)
		val = fn && hasOwn.call( Expr.attrHandle, name.toLowerCase() ) ?
			fn( elem, name, !documentIsHTML ) :
			undefined;

	return val !== undefined ?
		val :
		support.attributes || !documentIsHTML ?
			elem.getAttribute( name ) :
			(val = elem.getAttributeNode(name)) && val.specified ?
				val.value :
				null;
};

Sizzle.escape = function( sel ) {
	return (sel + "").replace( rcssescape, fcssescape );
};

Sizzle.error = function( msg ) {
	throw new Error( "Syntax error, unrecognized expression: " + msg );
};

/**
 * Document sorting and removing duplicates
 * @param {ArrayLike} results
 */
Sizzle.uniqueSort = function( results ) {
	var elem,
		duplicates = [],
		j = 0,
		i = 0;

	// Unless we *know* we can detect duplicates, assume their presence
	hasDuplicate = !support.detectDuplicates;
	sortInput = !support.sortStable && results.slice( 0 );
	results.sort( sortOrder );

	if ( hasDuplicate ) {
		while ( (elem = results[i++]) ) {
			if ( elem === results[ i ] ) {
				j = duplicates.push( i );
			}
		}
		while ( j-- ) {
			results.splice( duplicates[ j ], 1 );
		}
	}

	// Clear input after sorting to release objects
	// See https://github.com/jquery/sizzle/pull/225
	sortInput = null;

	return results;
};

/**
 * Utility function for retrieving the text value of an array of DOM nodes
 * @param {Array|Element} elem
 */
getText = Sizzle.getText = function( elem ) {
	var node,
		ret = "",
		i = 0,
		nodeType = elem.nodeType;

	if ( !nodeType ) {
		// If no nodeType, this is expected to be an array
		while ( (node = elem[i++]) ) {
			// Do not traverse comment nodes
			ret += getText( node );
		}
	} else if ( nodeType === 1 || nodeType === 9 || nodeType === 11 ) {
		// Use textContent for elements
		// innerText usage removed for consistency of new lines (jQuery #11153)
		if ( typeof elem.textContent === "string" ) {
			return elem.textContent;
		} else {
			// Traverse its children
			for ( elem = elem.firstChild; elem; elem = elem.nextSibling ) {
				ret += getText( elem );
			}
		}
	} else if ( nodeType === 3 || nodeType === 4 ) {
		return elem.nodeValue;
	}
	// Do not include comment or processing instruction nodes

	return ret;
};

Expr = Sizzle.selectors = {

	// Can be adjusted by the user
	cacheLength: 50,

	createPseudo: markFunction,

	match: matchExpr,

	attrHandle: {},

	find: {},

	relative: {
		">": { dir: "parentNode", first: true },
		" ": { dir: "parentNode" },
		"+": { dir: "previousSibling", first: true },
		"~": { dir: "previousSibling" }
	},

	preFilter: {
		"ATTR": function( match ) {
			match[1] = match[1].replace( runescape, funescape );

			// Move the given value to match[3] whether quoted or unquoted
			match[3] = ( match[3] || match[4] || match[5] || "" ).replace( runescape, funescape );

			if ( match[2] === "~=" ) {
				match[3] = " " + match[3] + " ";
			}

			return match.slice( 0, 4 );
		},

		"CHILD": function( match ) {
			/* matches from matchExpr["CHILD"]
				1 type (only|nth|...)
				2 what (child|of-type)
				3 argument (even|odd|\d*|\d*n([+-]\d+)?|...)
				4 xn-component of xn+y argument ([+-]?\d*n|)
				5 sign of xn-component
				6 x of xn-component
				7 sign of y-component
				8 y of y-component
			*/
			match[1] = match[1].toLowerCase();

			if ( match[1].slice( 0, 3 ) === "nth" ) {
				// nth-* requires argument
				if ( !match[3] ) {
					Sizzle.error( match[0] );
				}

				// numeric x and y parameters for Expr.filter.CHILD
				// remember that false/true cast respectively to 0/1
				match[4] = +( match[4] ? match[5] + (match[6] || 1) : 2 * ( match[3] === "even" || match[3] === "odd" ) );
				match[5] = +( ( match[7] + match[8] ) || match[3] === "odd" );

			// other types prohibit arguments
			} else if ( match[3] ) {
				Sizzle.error( match[0] );
			}

			return match;
		},

		"PSEUDO": function( match ) {
			var excess,
				unquoted = !match[6] && match[2];

			if ( matchExpr["CHILD"].test( match[0] ) ) {
				return null;
			}

			// Accept quoted arguments as-is
			if ( match[3] ) {
				match[2] = match[4] || match[5] || "";

			// Strip excess characters from unquoted arguments
			} else if ( unquoted && rpseudo.test( unquoted ) &&
				// Get excess from tokenize (recursively)
				(excess = tokenize( unquoted, true )) &&
				// advance to the next closing parenthesis
				(excess = unquoted.indexOf( ")", unquoted.length - excess ) - unquoted.length) ) {

				// excess is a negative index
				match[0] = match[0].slice( 0, excess );
				match[2] = unquoted.slice( 0, excess );
			}

			// Return only captures needed by the pseudo filter method (type and argument)
			return match.slice( 0, 3 );
		}
	},

	filter: {

		"TAG": function( nodeNameSelector ) {
			var nodeName = nodeNameSelector.replace( runescape, funescape ).toLowerCase();
			return nodeNameSelector === "*" ?
				function() { return true; } :
				function( elem ) {
					return elem.nodeName && elem.nodeName.toLowerCase() === nodeName;
				};
		},

		"CLASS": function( className ) {
			var pattern = classCache[ className + " " ];

			return pattern ||
				(pattern = new RegExp( "(^|" + whitespace + ")" + className + "(" + whitespace + "|$)" )) &&
				classCache( className, function( elem ) {
					return pattern.test( typeof elem.className === "string" && elem.className || typeof elem.getAttribute !== "undefined" && elem.getAttribute("class") || "" );
				});
		},

		"ATTR": function( name, operator, check ) {
			return function( elem ) {
				var result = Sizzle.attr( elem, name );

				if ( result == null ) {
					return operator === "!=";
				}
				if ( !operator ) {
					return true;
				}

				result += "";

				return operator === "=" ? result === check :
					operator === "!=" ? result !== check :
					operator === "^=" ? check && result.indexOf( check ) === 0 :
					operator === "*=" ? check && result.indexOf( check ) > -1 :
					operator === "$=" ? check && result.slice( -check.length ) === check :
					operator === "~=" ? ( " " + result.replace( rwhitespace, " " ) + " " ).indexOf( check ) > -1 :
					operator === "|=" ? result === check || result.slice( 0, check.length + 1 ) === check + "-" :
					false;
			};
		},

		"CHILD": function( type, what, argument, first, last ) {
			var simple = type.slice( 0, 3 ) !== "nth",
				forward = type.slice( -4 ) !== "last",
				ofType = what === "of-type";

			return first === 1 && last === 0 ?

				// Shortcut for :nth-*(n)
				function( elem ) {
					return !!elem.parentNode;
				} :

				function( elem, context, xml ) {
					var cache, uniqueCache, outerCache, node, nodeIndex, start,
						dir = simple !== forward ? "nextSibling" : "previousSibling",
						parent = elem.parentNode,
						name = ofType && elem.nodeName.toLowerCase(),
						useCache = !xml && !ofType,
						diff = false;

					if ( parent ) {

						// :(first|last|only)-(child|of-type)
						if ( simple ) {
							while ( dir ) {
								node = elem;
								while ( (node = node[ dir ]) ) {
									if ( ofType ?
										node.nodeName.toLowerCase() === name :
										node.nodeType === 1 ) {

										return false;
									}
								}
								// Reverse direction for :only-* (if we haven't yet done so)
								start = dir = type === "only" && !start && "nextSibling";
							}
							return true;
						}

						start = [ forward ? parent.firstChild : parent.lastChild ];

						// non-xml :nth-child(...) stores cache data on `parent`
						if ( forward && useCache ) {

							// Seek `elem` from a previously-cached index

							// ...in a gzip-friendly way
							node = parent;
							outerCache = node[ expando ] || (node[ expando ] = {});

							// Support: IE <9 only
							// Defend against cloned attroperties (jQuery gh-1709)
							uniqueCache = outerCache[ node.uniqueID ] ||
								(outerCache[ node.uniqueID ] = {});

							cache = uniqueCache[ type ] || [];
							nodeIndex = cache[ 0 ] === dirruns && cache[ 1 ];
							diff = nodeIndex && cache[ 2 ];
							node = nodeIndex && parent.childNodes[ nodeIndex ];

							while ( (node = ++nodeIndex && node && node[ dir ] ||

								// Fallback to seeking `elem` from the start
								(diff = nodeIndex = 0) || start.pop()) ) {

								// When found, cache indexes on `parent` and break
								if ( node.nodeType === 1 && ++diff && node === elem ) {
									uniqueCache[ type ] = [ dirruns, nodeIndex, diff ];
									break;
								}
							}

						} else {
							// Use previously-cached element index if available
							if ( useCache ) {
								// ...in a gzip-friendly way
								node = elem;
								outerCache = node[ expando ] || (node[ expando ] = {});

								// Support: IE <9 only
								// Defend against cloned attroperties (jQuery gh-1709)
								uniqueCache = outerCache[ node.uniqueID ] ||
									(outerCache[ node.uniqueID ] = {});

								cache = uniqueCache[ type ] || [];
								nodeIndex = cache[ 0 ] === dirruns && cache[ 1 ];
								diff = nodeIndex;
							}

							// xml :nth-child(...)
							// or :nth-last-child(...) or :nth(-last)?-of-type(...)
							if ( diff === false ) {
								// Use the same loop as above to seek `elem` from the start
								while ( (node = ++nodeIndex && node && node[ dir ] ||
									(diff = nodeIndex = 0) || start.pop()) ) {

									if ( ( ofType ?
										node.nodeName.toLowerCase() === name :
										node.nodeType === 1 ) &&
										++diff ) {

										// Cache the index of each encountered element
										if ( useCache ) {
											outerCache = node[ expando ] || (node[ expando ] = {});

											// Support: IE <9 only
											// Defend against cloned attroperties (jQuery gh-1709)
											uniqueCache = outerCache[ node.uniqueID ] ||
												(outerCache[ node.uniqueID ] = {});

											uniqueCache[ type ] = [ dirruns, diff ];
										}

										if ( node === elem ) {
											break;
										}
									}
								}
							}
						}

						// Incorporate the offset, then check against cycle size
						diff -= last;
						return diff === first || ( diff % first === 0 && diff / first >= 0 );
					}
				};
		},

		"PSEUDO": function( pseudo, argument ) {
			// pseudo-class names are case-insensitive
			// http://www.w3.org/TR/selectors/#pseudo-classes
			// Prioritize by case sensitivity in case custom pseudos are added with uppercase letters
			// Remember that setFilters inherits from pseudos
			var args,
				fn = Expr.pseudos[ pseudo ] || Expr.setFilters[ pseudo.toLowerCase() ] ||
					Sizzle.error( "unsupported pseudo: " + pseudo );

			// The user may use createPseudo to indicate that
			// arguments are needed to create the filter function
			// just as Sizzle does
			if ( fn[ expando ] ) {
				return fn( argument );
			}

			// But maintain support for old signatures
			if ( fn.length > 1 ) {
				args = [ pseudo, pseudo, "", argument ];
				return Expr.setFilters.hasOwnProperty( pseudo.toLowerCase() ) ?
					markFunction(function( seed, matches ) {
						var idx,
							matched = fn( seed, argument ),
							i = matched.length;
						while ( i-- ) {
							idx = indexOf( seed, matched[i] );
							seed[ idx ] = !( matches[ idx ] = matched[i] );
						}
					}) :
					function( elem ) {
						return fn( elem, 0, args );
					};
			}

			return fn;
		}
	},

	pseudos: {
		// Potentially complex pseudos
		"not": markFunction(function( selector ) {
			// Trim the selector passed to compile
			// to avoid treating leading and trailing
			// spaces as combinators
			var input = [],
				results = [],
				matcher = compile( selector.replace( rtrim, "$1" ) );

			return matcher[ expando ] ?
				markFunction(function( seed, matches, context, xml ) {
					var elem,
						unmatched = matcher( seed, null, xml, [] ),
						i = seed.length;

					// Match elements unmatched by `matcher`
					while ( i-- ) {
						if ( (elem = unmatched[i]) ) {
							seed[i] = !(matches[i] = elem);
						}
					}
				}) :
				function( elem, context, xml ) {
					input[0] = elem;
					matcher( input, null, xml, results );
					// Don't keep the element (issue #299)
					input[0] = null;
					return !results.pop();
				};
		}),

		"has": markFunction(function( selector ) {
			return function( elem ) {
				return Sizzle( selector, elem ).length > 0;
			};
		}),

		"contains": markFunction(function( text ) {
			text = text.replace( runescape, funescape );
			return function( elem ) {
				return ( elem.textContent || elem.innerText || getText( elem ) ).indexOf( text ) > -1;
			};
		}),

		// "Whether an element is represented by a :lang() selector
		// is based solely on the element's language value
		// being equal to the identifier C,
		// or beginning with the identifier C immediately followed by "-".
		// The matching of C against the element's language value is performed case-insensitively.
		// The identifier C does not have to be a valid language name."
		// http://www.w3.org/TR/selectors/#lang-pseudo
		"lang": markFunction( function( lang ) {
			// lang value must be a valid identifier
			if ( !ridentifier.test(lang || "") ) {
				Sizzle.error( "unsupported lang: " + lang );
			}
			lang = lang.replace( runescape, funescape ).toLowerCase();
			return function( elem ) {
				var elemLang;
				do {
					if ( (elemLang = documentIsHTML ?
						elem.lang :
						elem.getAttribute("xml:lang") || elem.getAttribute("lang")) ) {

						elemLang = elemLang.toLowerCase();
						return elemLang === lang || elemLang.indexOf( lang + "-" ) === 0;
					}
				} while ( (elem = elem.parentNode) && elem.nodeType === 1 );
				return false;
			};
		}),

		// Miscellaneous
		"target": function( elem ) {
			var hash = window.location && window.location.hash;
			return hash && hash.slice( 1 ) === elem.id;
		},

		"root": function( elem ) {
			return elem === docElem;
		},

		"focus": function( elem ) {
			return elem === document.activeElement && (!document.hasFocus || document.hasFocus()) && !!(elem.type || elem.href || ~elem.tabIndex);
		},

		// Boolean properties
		"enabled": createDisabledPseudo( false ),
		"disabled": createDisabledPseudo( true ),

		"checked": function( elem ) {
			// In CSS3, :checked should return both checked and selected elements
			// http://www.w3.org/TR/2011/REC-css3-selectors-20110929/#checked
			var nodeName = elem.nodeName.toLowerCase();
			return (nodeName === "input" && !!elem.checked) || (nodeName === "option" && !!elem.selected);
		},

		"selected": function( elem ) {
			// Accessing this property makes selected-by-default
			// options in Safari work properly
			if ( elem.parentNode ) {
				elem.parentNode.selectedIndex;
			}

			return elem.selected === true;
		},

		// Contents
		"empty": function( elem ) {
			// http://www.w3.org/TR/selectors/#empty-pseudo
			// :empty is negated by element (1) or content nodes (text: 3; cdata: 4; entity ref: 5),
			//   but not by others (comment: 8; processing instruction: 7; etc.)
			// nodeType < 6 works because attributes (2) do not appear as children
			for ( elem = elem.firstChild; elem; elem = elem.nextSibling ) {
				if ( elem.nodeType < 6 ) {
					return false;
				}
			}
			return true;
		},

		"parent": function( elem ) {
			return !Expr.pseudos["empty"]( elem );
		},

		// Element/input types
		"header": function( elem ) {
			return rheader.test( elem.nodeName );
		},

		"input": function( elem ) {
			return rinputs.test( elem.nodeName );
		},

		"button": function( elem ) {
			var name = elem.nodeName.toLowerCase();
			return name === "input" && elem.type === "button" || name === "button";
		},

		"text": function( elem ) {
			var attr;
			return elem.nodeName.toLowerCase() === "input" &&
				elem.type === "text" &&

				// Support: IE<8
				// New HTML5 attribute values (e.g., "search") appear with elem.type === "text"
				( (attr = elem.getAttribute("type")) == null || attr.toLowerCase() === "text" );
		},

		// Position-in-collection
		"first": createPositionalPseudo(function() {
			return [ 0 ];
		}),

		"last": createPositionalPseudo(function( matchIndexes, length ) {
			return [ length - 1 ];
		}),

		"eq": createPositionalPseudo(function( matchIndexes, length, argument ) {
			return [ argument < 0 ? argument + length : argument ];
		}),

		"even": createPositionalPseudo(function( matchIndexes, length ) {
			var i = 0;
			for ( ; i < length; i += 2 ) {
				matchIndexes.push( i );
			}
			return matchIndexes;
		}),

		"odd": createPositionalPseudo(function( matchIndexes, length ) {
			var i = 1;
			for ( ; i < length; i += 2 ) {
				matchIndexes.push( i );
			}
			return matchIndexes;
		}),

		"lt": createPositionalPseudo(function( matchIndexes, length, argument ) {
			var i = argument < 0 ? argument + length : argument;
			for ( ; --i >= 0; ) {
				matchIndexes.push( i );
			}
			return matchIndexes;
		}),

		"gt": createPositionalPseudo(function( matchIndexes, length, argument ) {
			var i = argument < 0 ? argument + length : argument;
			for ( ; ++i < length; ) {
				matchIndexes.push( i );
			}
			return matchIndexes;
		})
	}
};

Expr.pseudos["nth"] = Expr.pseudos["eq"];

// Add button/input type pseudos
for ( i in { radio: true, checkbox: true, file: true, password: true, image: true } ) {
	Expr.pseudos[ i ] = createInputPseudo( i );
}
for ( i in { submit: true, reset: true } ) {
	Expr.pseudos[ i ] = createButtonPseudo( i );
}

// Easy API for creating new setFilters
function setFilters() {}
setFilters.prototype = Expr.filters = Expr.pseudos;
Expr.setFilters = new setFilters();

tokenize = Sizzle.tokenize = function( selector, parseOnly ) {
	var matched, match, tokens, type,
		soFar, groups, preFilters,
		cached = tokenCache[ selector + " " ];

	if ( cached ) {
		return parseOnly ? 0 : cached.slice( 0 );
	}

	soFar = selector;
	groups = [];
	preFilters = Expr.preFilter;

	while ( soFar ) {

		// Comma and first run
		if ( !matched || (match = rcomma.exec( soFar )) ) {
			if ( match ) {
				// Don't consume trailing commas as valid
				soFar = soFar.slice( match[0].length ) || soFar;
			}
			groups.push( (tokens = []) );
		}

		matched = false;

		// Combinators
		if ( (match = rcombinators.exec( soFar )) ) {
			matched = match.shift();
			tokens.push({
				value: matched,
				// Cast descendant combinators to space
				type: match[0].replace( rtrim, " " )
			});
			soFar = soFar.slice( matched.length );
		}

		// Filters
		for ( type in Expr.filter ) {
			if ( (match = matchExpr[ type ].exec( soFar )) && (!preFilters[ type ] ||
				(match = preFilters[ type ]( match ))) ) {
				matched = match.shift();
				tokens.push({
					value: matched,
					type: type,
					matches: match
				});
				soFar = soFar.slice( matched.length );
			}
		}

		if ( !matched ) {
			break;
		}
	}

	// Return the length of the invalid excess
	// if we're just parsing
	// Otherwise, throw an error or return tokens
	return parseOnly ?
		soFar.length :
		soFar ?
			Sizzle.error( selector ) :
			// Cache the tokens
			tokenCache( selector, groups ).slice( 0 );
};

function toSelector( tokens ) {
	var i = 0,
		len = tokens.length,
		selector = "";
	for ( ; i < len; i++ ) {
		selector += tokens[i].value;
	}
	return selector;
}

function addCombinator( matcher, combinator, base ) {
	var dir = combinator.dir,
		skip = combinator.next,
		key = skip || dir,
		checkNonElements = base && key === "parentNode",
		doneName = done++;

	return combinator.first ?
		// Check against closest ancestor/preceding element
		function( elem, context, xml ) {
			while ( (elem = elem[ dir ]) ) {
				if ( elem.nodeType === 1 || checkNonElements ) {
					return matcher( elem, context, xml );
				}
			}
			return false;
		} :

		// Check against all ancestor/preceding elements
		function( elem, context, xml ) {
			var oldCache, uniqueCache, outerCache,
				newCache = [ dirruns, doneName ];

			// We can't set arbitrary data on XML nodes, so they don't benefit from combinator caching
			if ( xml ) {
				while ( (elem = elem[ dir ]) ) {
					if ( elem.nodeType === 1 || checkNonElements ) {
						if ( matcher( elem, context, xml ) ) {
							return true;
						}
					}
				}
			} else {
				while ( (elem = elem[ dir ]) ) {
					if ( elem.nodeType === 1 || checkNonElements ) {
						outerCache = elem[ expando ] || (elem[ expando ] = {});

						// Support: IE <9 only
						// Defend against cloned attroperties (jQuery gh-1709)
						uniqueCache = outerCache[ elem.uniqueID ] || (outerCache[ elem.uniqueID ] = {});

						if ( skip && skip === elem.nodeName.toLowerCase() ) {
							elem = elem[ dir ] || elem;
						} else if ( (oldCache = uniqueCache[ key ]) &&
							oldCache[ 0 ] === dirruns && oldCache[ 1 ] === doneName ) {

							// Assign to newCache so results back-propagate to previous elements
							return (newCache[ 2 ] = oldCache[ 2 ]);
						} else {
							// Reuse newcache so results back-propagate to previous elements
							uniqueCache[ key ] = newCache;

							// A match means we're done; a fail means we have to keep checking
							if ( (newCache[ 2 ] = matcher( elem, context, xml )) ) {
								return true;
							}
						}
					}
				}
			}
			return false;
		};
}

function elementMatcher( matchers ) {
	return matchers.length > 1 ?
		function( elem, context, xml ) {
			var i = matchers.length;
			while ( i-- ) {
				if ( !matchers[i]( elem, context, xml ) ) {
					return false;
				}
			}
			return true;
		} :
		matchers[0];
}

function multipleContexts( selector, contexts, results ) {
	var i = 0,
		len = contexts.length;
	for ( ; i < len; i++ ) {
		Sizzle( selector, contexts[i], results );
	}
	return results;
}

function condense( unmatched, map, filter, context, xml ) {
	var elem,
		newUnmatched = [],
		i = 0,
		len = unmatched.length,
		mapped = map != null;

	for ( ; i < len; i++ ) {
		if ( (elem = unmatched[i]) ) {
			if ( !filter || filter( elem, context, xml ) ) {
				newUnmatched.push( elem );
				if ( mapped ) {
					map.push( i );
				}
			}
		}
	}

	return newUnmatched;
}

function setMatcher( preFilter, selector, matcher, postFilter, postFinder, postSelector ) {
	if ( postFilter && !postFilter[ expando ] ) {
		postFilter = setMatcher( postFilter );
	}
	if ( postFinder && !postFinder[ expando ] ) {
		postFinder = setMatcher( postFinder, postSelector );
	}
	return markFunction(function( seed, results, context, xml ) {
		var temp, i, elem,
			preMap = [],
			postMap = [],
			preexisting = results.length,

			// Get initial elements from seed or context
			elems = seed || multipleContexts( selector || "*", context.nodeType ? [ context ] : context, [] ),

			// Prefilter to get matcher input, preserving a map for seed-results synchronization
			matcherIn = preFilter && ( seed || !selector ) ?
				condense( elems, preMap, preFilter, context, xml ) :
				elems,

			matcherOut = matcher ?
				// If we have a postFinder, or filtered seed, or non-seed postFilter or preexisting results,
				postFinder || ( seed ? preFilter : preexisting || postFilter ) ?

					// ...intermediate processing is necessary
					[] :

					// ...otherwise use results directly
					results :
				matcherIn;

		// Find primary matches
		if ( matcher ) {
			matcher( matcherIn, matcherOut, context, xml );
		}

		// Apply postFilter
		if ( postFilter ) {
			temp = condense( matcherOut, postMap );
			postFilter( temp, [], context, xml );

			// Un-match failing elements by moving them back to matcherIn
			i = temp.length;
			while ( i-- ) {
				if ( (elem = temp[i]) ) {
					matcherOut[ postMap[i] ] = !(matcherIn[ postMap[i] ] = elem);
				}
			}
		}

		if ( seed ) {
			if ( postFinder || preFilter ) {
				if ( postFinder ) {
					// Get the final matcherOut by condensing this intermediate into postFinder contexts
					temp = [];
					i = matcherOut.length;
					while ( i-- ) {
						if ( (elem = matcherOut[i]) ) {
							// Restore matcherIn since elem is not yet a final match
							temp.push( (matcherIn[i] = elem) );
						}
					}
					postFinder( null, (matcherOut = []), temp, xml );
				}

				// Move matched elements from seed to results to keep them synchronized
				i = matcherOut.length;
				while ( i-- ) {
					if ( (elem = matcherOut[i]) &&
						(temp = postFinder ? indexOf( seed, elem ) : preMap[i]) > -1 ) {

						seed[temp] = !(results[temp] = elem);
					}
				}
			}

		// Add elements to results, through postFinder if defined
		} else {
			matcherOut = condense(
				matcherOut === results ?
					matcherOut.splice( preexisting, matcherOut.length ) :
					matcherOut
			);
			if ( postFinder ) {
				postFinder( null, results, matcherOut, xml );
			} else {
				push.apply( results, matcherOut );
			}
		}
	});
}

function matcherFromTokens( tokens ) {
	var checkContext, matcher, j,
		len = tokens.length,
		leadingRelative = Expr.relative[ tokens[0].type ],
		implicitRelative = leadingRelative || Expr.relative[" "],
		i = leadingRelative ? 1 : 0,

		// The foundational matcher ensures that elements are reachable from top-level context(s)
		matchContext = addCombinator( function( elem ) {
			return elem === checkContext;
		}, implicitRelative, true ),
		matchAnyContext = addCombinator( function( elem ) {
			return indexOf( checkContext, elem ) > -1;
		}, implicitRelative, true ),
		matchers = [ function( elem, context, xml ) {
			var ret = ( !leadingRelative && ( xml || context !== outermostContext ) ) || (
				(checkContext = context).nodeType ?
					matchContext( elem, context, xml ) :
					matchAnyContext( elem, context, xml ) );
			// Avoid hanging onto element (issue #299)
			checkContext = null;
			return ret;
		} ];

	for ( ; i < len; i++ ) {
		if ( (matcher = Expr.relative[ tokens[i].type ]) ) {
			matchers = [ addCombinator(elementMatcher( matchers ), matcher) ];
		} else {
			matcher = Expr.filter[ tokens[i].type ].apply( null, tokens[i].matches );

			// Return special upon seeing a positional matcher
			if ( matcher[ expando ] ) {
				// Find the next relative operator (if any) for proper handling
				j = ++i;
				for ( ; j < len; j++ ) {
					if ( Expr.relative[ tokens[j].type ] ) {
						break;
					}
				}
				return setMatcher(
					i > 1 && elementMatcher( matchers ),
					i > 1 && toSelector(
						// If the preceding token was a descendant combinator, insert an implicit any-element `*`
						tokens.slice( 0, i - 1 ).concat({ value: tokens[ i - 2 ].type === " " ? "*" : "" })
					).replace( rtrim, "$1" ),
					matcher,
					i < j && matcherFromTokens( tokens.slice( i, j ) ),
					j < len && matcherFromTokens( (tokens = tokens.slice( j )) ),
					j < len && toSelector( tokens )
				);
			}
			matchers.push( matcher );
		}
	}

	return elementMatcher( matchers );
}

function matcherFromGroupMatchers( elementMatchers, setMatchers ) {
	var bySet = setMatchers.length > 0,
		byElement = elementMatchers.length > 0,
		superMatcher = function( seed, context, xml, results, outermost ) {
			var elem, j, matcher,
				matchedCount = 0,
				i = "0",
				unmatched = seed && [],
				setMatched = [],
				contextBackup = outermostContext,
				// We must always have either seed elements or outermost context
				elems = seed || byElement && Expr.find["TAG"]( "*", outermost ),
				// Use integer dirruns iff this is the outermost matcher
				dirrunsUnique = (dirruns += contextBackup == null ? 1 : Math.random() || 0.1),
				len = elems.length;

			if ( outermost ) {
				outermostContext = context === document || context || outermost;
			}

			// Add elements passing elementMatchers directly to results
			// Support: IE<9, Safari
			// Tolerate NodeList properties (IE: "length"; Safari: <number>) matching elements by id
			for ( ; i !== len && (elem = elems[i]) != null; i++ ) {
				if ( byElement && elem ) {
					j = 0;
					if ( !context && elem.ownerDocument !== document ) {
						setDocument( elem );
						xml = !documentIsHTML;
					}
					while ( (matcher = elementMatchers[j++]) ) {
						if ( matcher( elem, context || document, xml) ) {
							results.push( elem );
							break;
						}
					}
					if ( outermost ) {
						dirruns = dirrunsUnique;
					}
				}

				// Track unmatched elements for set filters
				if ( bySet ) {
					// They will have gone through all possible matchers
					if ( (elem = !matcher && elem) ) {
						matchedCount--;
					}

					// Lengthen the array for every element, matched or not
					if ( seed ) {
						unmatched.push( elem );
					}
				}
			}

			// `i` is now the count of elements visited above, and adding it to `matchedCount`
			// makes the latter nonnegative.
			matchedCount += i;

			// Apply set filters to unmatched elements
			// NOTE: This can be skipped if there are no unmatched elements (i.e., `matchedCount`
			// equals `i`), unless we didn't visit _any_ elements in the above loop because we have
			// no element matchers and no seed.
			// Incrementing an initially-string "0" `i` allows `i` to remain a string only in that
			// case, which will result in a "00" `matchedCount` that differs from `i` but is also
			// numerically zero.
			if ( bySet && i !== matchedCount ) {
				j = 0;
				while ( (matcher = setMatchers[j++]) ) {
					matcher( unmatched, setMatched, context, xml );
				}

				if ( seed ) {
					// Reintegrate element matches to eliminate the need for sorting
					if ( matchedCount > 0 ) {
						while ( i-- ) {
							if ( !(unmatched[i] || setMatched[i]) ) {
								setMatched[i] = pop.call( results );
							}
						}
					}

					// Discard index placeholder values to get only actual matches
					setMatched = condense( setMatched );
				}

				// Add matches to results
				push.apply( results, setMatched );

				// Seedless set matches succeeding multiple successful matchers stipulate sorting
				if ( outermost && !seed && setMatched.length > 0 &&
					( matchedCount + setMatchers.length ) > 1 ) {

					Sizzle.uniqueSort( results );
				}
			}

			// Override manipulation of globals by nested matchers
			if ( outermost ) {
				dirruns = dirrunsUnique;
				outermostContext = contextBackup;
			}

			return unmatched;
		};

	return bySet ?
		markFunction( superMatcher ) :
		superMatcher;
}

compile = Sizzle.compile = function( selector, match /* Internal Use Only */ ) {
	var i,
		setMatchers = [],
		elementMatchers = [],
		cached = compilerCache[ selector + " " ];

	if ( !cached ) {
		// Generate a function of recursive functions that can be used to check each element
		if ( !match ) {
			match = tokenize( selector );
		}
		i = match.length;
		while ( i-- ) {
			cached = matcherFromTokens( match[i] );
			if ( cached[ expando ] ) {
				setMatchers.push( cached );
			} else {
				elementMatchers.push( cached );
			}
		}

		// Cache the compiled function
		cached = compilerCache( selector, matcherFromGroupMatchers( elementMatchers, setMatchers ) );

		// Save selector and tokenization
		cached.selector = selector;
	}
	return cached;
};

/**
 * A low-level selection function that works with Sizzle's compiled
 *  selector functions
 * @param {String|Function} selector A selector or a pre-compiled
 *  selector function built with Sizzle.compile
 * @param {Element} context
 * @param {Array} [results]
 * @param {Array} [seed] A set of elements to match against
 */
select = Sizzle.select = function( selector, context, results, seed ) {
	var i, tokens, token, type, find,
		compiled = typeof selector === "function" && selector,
		match = !seed && tokenize( (selector = compiled.selector || selector) );

	results = results || [];

	// Try to minimize operations if there is only one selector in the list and no seed
	// (the latter of which guarantees us context)
	if ( match.length === 1 ) {

		// Reduce context if the leading compound selector is an ID
		tokens = match[0] = match[0].slice( 0 );
		if ( tokens.length > 2 && (token = tokens[0]).type === "ID" &&
				context.nodeType === 9 && documentIsHTML && Expr.relative[ tokens[1].type ] ) {

			context = ( Expr.find["ID"]( token.matches[0].replace(runescape, funescape), context ) || [] )[0];
			if ( !context ) {
				return results;

			// Precompiled matchers will still verify ancestry, so step up a level
			} else if ( compiled ) {
				context = context.parentNode;
			}

			selector = selector.slice( tokens.shift().value.length );
		}

		// Fetch a seed set for right-to-left matching
		i = matchExpr["needsContext"].test( selector ) ? 0 : tokens.length;
		while ( i-- ) {
			token = tokens[i];

			// Abort if we hit a combinator
			if ( Expr.relative[ (type = token.type) ] ) {
				break;
			}
			if ( (find = Expr.find[ type ]) ) {
				// Search, expanding context for leading sibling combinators
				if ( (seed = find(
					token.matches[0].replace( runescape, funescape ),
					rsibling.test( tokens[0].type ) && testContext( context.parentNode ) || context
				)) ) {

					// If seed is empty or no tokens remain, we can return early
					tokens.splice( i, 1 );
					selector = seed.length && toSelector( tokens );
					if ( !selector ) {
						push.apply( results, seed );
						return results;
					}

					break;
				}
			}
		}
	}

	// Compile and execute a filtering function if one is not provided
	// Provide `match` to avoid retokenization if we modified the selector above
	( compiled || compile( selector, match ) )(
		seed,
		context,
		!documentIsHTML,
		results,
		!context || rsibling.test( selector ) && testContext( context.parentNode ) || context
	);
	return results;
};

// One-time assignments

// Sort stability
support.sortStable = expando.split("").sort( sortOrder ).join("") === expando;

// Support: Chrome 14-35+
// Always assume duplicates if they aren't passed to the comparison function
support.detectDuplicates = !!hasDuplicate;

// Initialize against the default document
setDocument();

// Support: Webkit<537.32 - Safari 6.0.3/Chrome 25 (fixed in Chrome 27)
// Detached nodes confoundingly follow *each other*
support.sortDetached = assert(function( el ) {
	// Should return 1, but returns 4 (following)
	return el.compareDocumentPosition( document.createElement("fieldset") ) & 1;
});

// Support: IE<8
// Prevent attribute/property "interpolation"
// https://msdn.microsoft.com/en-us/library/ms536429%28VS.85%29.aspx
if ( !assert(function( el ) {
	el.innerHTML = "<a href='#'></a>";
	return el.firstChild.getAttribute("href") === "#" ;
}) ) {
	addHandle( "type|href|height|width", function( elem, name, isXML ) {
		if ( !isXML ) {
			return elem.getAttribute( name, name.toLowerCase() === "type" ? 1 : 2 );
		}
	});
}

// Support: IE<9
// Use defaultValue in place of getAttribute("value")
if ( !support.attributes || !assert(function( el ) {
	el.innerHTML = "<input/>";
	el.firstChild.setAttribute( "value", "" );
	return el.firstChild.getAttribute( "value" ) === "";
}) ) {
	addHandle( "value", function( elem, name, isXML ) {
		if ( !isXML && elem.nodeName.toLowerCase() === "input" ) {
			return elem.defaultValue;
		}
	});
}

// Support: IE<9
// Use getAttributeNode to fetch booleans when getAttribute lies
if ( !assert(function( el ) {
	return el.getAttribute("disabled") == null;
}) ) {
	addHandle( booleans, function( elem, name, isXML ) {
		var val;
		if ( !isXML ) {
			return elem[ name ] === true ? name.toLowerCase() :
					(val = elem.getAttributeNode( name )) && val.specified ?
					val.value :
				null;
		}
	});
}

return Sizzle;

})( window );



jQuery.find = Sizzle;
jQuery.expr = Sizzle.selectors;

// Deprecated
jQuery.expr[ ":" ] = jQuery.expr.pseudos;
jQuery.uniqueSort = jQuery.unique = Sizzle.uniqueSort;
jQuery.text = Sizzle.getText;
jQuery.isXMLDoc = Sizzle.isXML;
jQuery.contains = Sizzle.contains;
jQuery.escapeSelector = Sizzle.escape;




var dir = function( elem, dir, until ) {
	var matched = [],
		truncate = until !== undefined;

	while ( ( elem = elem[ dir ] ) && elem.nodeType !== 9 ) {
		if ( elem.nodeType === 1 ) {
			if ( truncate && jQuery( elem ).is( until ) ) {
				break;
			}
			matched.push( elem );
		}
	}
	return matched;
};


var siblings = function( n, elem ) {
	var matched = [];

	for ( ; n; n = n.nextSibling ) {
		if ( n.nodeType === 1 && n !== elem ) {
			matched.push( n );
		}
	}

	return matched;
};


var rneedsContext = jQuery.expr.match.needsContext;

var rsingleTag = ( /^<([a-z][^\/\0>:\x20\t\r\n\f]*)[\x20\t\r\n\f]*\/?>(?:<\/\1>|)$/i );



var risSimple = /^.[^:#\[\.,]*$/;

// Implement the identical functionality for filter and not
function winnow( elements, qualifier, not ) {
	if ( jQuery.isFunction( qualifier ) ) {
		return jQuery.grep( elements, function( elem, i ) {
			return !!qualifier.call( elem, i, elem ) !== not;
		} );
	}

	// Single element
	if ( qualifier.nodeType ) {
		return jQuery.grep( elements, function( elem ) {
			return ( elem === qualifier ) !== not;
		} );
	}

	// Arraylike of elements (jQuery, arguments, Array)
	if ( typeof qualifier !== "string" ) {
		return jQuery.grep( elements, function( elem ) {
			return ( indexOf.call( qualifier, elem ) > -1 ) !== not;
		} );
	}

	// Simple selector that can be filtered directly, removing non-Elements
	if ( risSimple.test( qualifier ) ) {
		return jQuery.filter( qualifier, elements, not );
	}

	// Complex selector, compare the two sets, removing non-Elements
	qualifier = jQuery.filter( qualifier, elements );
	return jQuery.grep( elements, function( elem ) {
		return ( indexOf.call( qualifier, elem ) > -1 ) !== not && elem.nodeType === 1;
	} );
}

jQuery.filter = function( expr, elems, not ) {
	var elem = elems[ 0 ];

	if ( not ) {
		expr = ":not(" + expr + ")";
	}

	if ( elems.length === 1 && elem.nodeType === 1 ) {
		return jQuery.find.matchesSelector( elem, expr ) ? [ elem ] : [];
	}

	return jQuery.find.matches( expr, jQuery.grep( elems, function( elem ) {
		return elem.nodeType === 1;
	} ) );
};

jQuery.fn.extend( {
	find: function( selector ) {
		var i, ret,
			len = this.length,
			self = this;

		if ( typeof selector !== "string" ) {
			return this.pushStack( jQuery( selector ).filter( function() {
				for ( i = 0; i < len; i++ ) {
					if ( jQuery.contains( self[ i ], this ) ) {
						return true;
					}
				}
			} ) );
		}

		ret = this.pushStack( [] );

		for ( i = 0; i < len; i++ ) {
			jQuery.find( selector, self[ i ], ret );
		}

		return len > 1 ? jQuery.uniqueSort( ret ) : ret;
	},
	filter: function( selector ) {
		return this.pushStack( winnow( this, selector || [], false ) );
	},
	not: function( selector ) {
		return this.pushStack( winnow( this, selector || [], true ) );
	},
	is: function( selector ) {
		return !!winnow(
			this,

			// If this is a positional/relative selector, check membership in the returned set
			// so $("p:first").is("p:last") won't return true for a doc with two "p".
			typeof selector === "string" && rneedsContext.test( selector ) ?
				jQuery( selector ) :
				selector || [],
			false
		).length;
	}
} );


// Initialize a jQuery object


// A central reference to the root jQuery(document)
var rootjQuery,

	// A simple way to check for HTML strings
	// Prioritize #id over <tag> to avoid XSS via location.hash (#9521)
	// Strict HTML recognition (#11290: must start with <)
	// Shortcut simple #id case for speed
	rquickExpr = /^(?:\s*(<[\w\W]+>)[^>]*|#([\w-]+))$/,

	init = jQuery.fn.init = function( selector, context, root ) {
		var match, elem;

		// HANDLE: $(""), $(null), $(undefined), $(false)
		if ( !selector ) {
			return this;
		}

		// Method init() accepts an alternate rootjQuery
		// so migrate can support jQuery.sub (gh-2101)
		root = root || rootjQuery;

		// Handle HTML strings
		if ( typeof selector === "string" ) {
			if ( selector[ 0 ] === "<" &&
				selector[ selector.length - 1 ] === ">" &&
				selector.length >= 3 ) {

				// Assume that strings that start and end with <> are HTML and skip the regex check
				match = [ null, selector, null ];

			} else {
				match = rquickExpr.exec( selector );
			}

			// Match html or make sure no context is specified for #id
			if ( match && ( match[ 1 ] || !context ) ) {

				// HANDLE: $(html) -> $(array)
				if ( match[ 1 ] ) {
					context = context instanceof jQuery ? context[ 0 ] : context;

					// Option to run scripts is true for back-compat
					// Intentionally let the error be thrown if parseHTML is not present
					jQuery.merge( this, jQuery.parseHTML(
						match[ 1 ],
						context && context.nodeType ? context.ownerDocument || context : document,
						true
					) );

					// HANDLE: $(html, props)
					if ( rsingleTag.test( match[ 1 ] ) && jQuery.isPlainObject( context ) ) {
						for ( match in context ) {

							// Properties of context are called as methods if possible
							if ( jQuery.isFunction( this[ match ] ) ) {
								this[ match ]( context[ match ] );

							// ...and otherwise set as attributes
							} else {
								this.attr( match, context[ match ] );
							}
						}
					}

					return this;

				// HANDLE: $(#id)
				} else {
					elem = document.getElementById( match[ 2 ] );

					if ( elem ) {

						// Inject the element directly into the jQuery object
						this[ 0 ] = elem;
						this.length = 1;
					}
					return this;
				}

			// HANDLE: $(expr, $(...))
			} else if ( !context || context.jquery ) {
				return ( context || root ).find( selector );

			// HANDLE: $(expr, context)
			// (which is just equivalent to: $(context).find(expr)
			} else {
				return this.constructor( context ).find( selector );
			}

		// HANDLE: $(DOMElement)
		} else if ( selector.nodeType ) {
			this[ 0 ] = selector;
			this.length = 1;
			return this;

		// HANDLE: $(function)
		// Shortcut for document ready
		} else if ( jQuery.isFunction( selector ) ) {
			return root.ready !== undefined ?
				root.ready( selector ) :

				// Execute immediately if ready is not present
				selector( jQuery );
		}

		return jQuery.makeArray( selector, this );
	};

// Give the init function the jQuery prototype for later instantiation
init.prototype = jQuery.fn;

// Initialize central reference
rootjQuery = jQuery( document );


var rparentsprev = /^(?:parents|prev(?:Until|All))/,

	// Methods guaranteed to produce a unique set when starting from a unique set
	guaranteedUnique = {
		children: true,
		contents: true,
		next: true,
		prev: true
	};

jQuery.fn.extend( {
	has: function( target ) {
		var targets = jQuery( target, this ),
			l = targets.length;

		return this.filter( function() {
			var i = 0;
			for ( ; i < l; i++ ) {
				if ( jQuery.contains( this, targets[ i ] ) ) {
					return true;
				}
			}
		} );
	},

	closest: function( selectors, context ) {
		var cur,
			i = 0,
			l = this.length,
			matched = [],
			targets = typeof selectors !== "string" && jQuery( selectors );

		// Positional selectors never match, since there's no _selection_ context
		if ( !rneedsContext.test( selectors ) ) {
			for ( ; i < l; i++ ) {
				for ( cur = this[ i ]; cur && cur !== context; cur = cur.parentNode ) {

					// Always skip document fragments
					if ( cur.nodeType < 11 && ( targets ?
						targets.index( cur ) > -1 :

						// Don't pass non-elements to Sizzle
						cur.nodeType === 1 &&
							jQuery.find.matchesSelector( cur, selectors ) ) ) {

						matched.push( cur );
						break;
					}
				}
			}
		}

		return this.pushStack( matched.length > 1 ? jQuery.uniqueSort( matched ) : matched );
	},

	// Determine the position of an element within the set
	index: function( elem ) {

		// No argument, return index in parent
		if ( !elem ) {
			return ( this[ 0 ] && this[ 0 ].parentNode ) ? this.first().prevAll().length : -1;
		}

		// Index in selector
		if ( typeof elem === "string" ) {
			return indexOf.call( jQuery( elem ), this[ 0 ] );
		}

		// Locate the position of the desired element
		return indexOf.call( this,

			// If it receives a jQuery object, the first element is used
			elem.jquery ? elem[ 0 ] : elem
		);
	},

	add: function( selector, context ) {
		return this.pushStack(
			jQuery.uniqueSort(
				jQuery.merge( this.get(), jQuery( selector, context ) )
			)
		);
	},

	addBack: function( selector ) {
		return this.add( selector == null ?
			this.prevObject : this.prevObject.filter( selector )
		);
	}
} );

function sibling( cur, dir ) {
	while ( ( cur = cur[ dir ] ) && cur.nodeType !== 1 ) {}
	return cur;
}

jQuery.each( {
	parent: function( elem ) {
		var parent = elem.parentNode;
		return parent && parent.nodeType !== 11 ? parent : null;
	},
	parents: function( elem ) {
		return dir( elem, "parentNode" );
	},
	parentsUntil: function( elem, i, until ) {
		return dir( elem, "parentNode", until );
	},
	next: function( elem ) {
		return sibling( elem, "nextSibling" );
	},
	prev: function( elem ) {
		return sibling( elem, "previousSibling" );
	},
	nextAll: function( elem ) {
		return dir( elem, "nextSibling" );
	},
	prevAll: function( elem ) {
		return dir( elem, "previousSibling" );
	},
	nextUntil: function( elem, i, until ) {
		return dir( elem, "nextSibling", until );
	},
	prevUntil: function( elem, i, until ) {
		return dir( elem, "previousSibling", until );
	},
	siblings: function( elem ) {
		return siblings( ( elem.parentNode || {} ).firstChild, elem );
	},
	children: function( elem ) {
		return siblings( elem.firstChild );
	},
	contents: function( elem ) {
		return elem.contentDocument || jQuery.merge( [], elem.childNodes );
	}
}, function( name, fn ) {
	jQuery.fn[ name ] = function( until, selector ) {
		var matched = jQuery.map( this, fn, until );

		if ( name.slice( -5 ) !== "Until" ) {
			selector = until;
		}

		if ( selector && typeof selector === "string" ) {
			matched = jQuery.filter( selector, matched );
		}

		if ( this.length > 1 ) {

			// Remove duplicates
			if ( !guaranteedUnique[ name ] ) {
				jQuery.uniqueSort( matched );
			}

			// Reverse order for parents* and prev-derivatives
			if ( rparentsprev.test( name ) ) {
				matched.reverse();
			}
		}

		return this.pushStack( matched );
	};
} );
var rnothtmlwhite = ( /[^\x20\t\r\n\f]+/g );



// Convert String-formatted options into Object-formatted ones
function createOptions( options ) {
	var object = {};
	jQuery.each( options.match( rnothtmlwhite ) || [], function( _, flag ) {
		object[ flag ] = true;
	} );
	return object;
}

/*
 * Create a callback list using the following parameters:
 *
 *	options: an optional list of space-separated options that will change how
 *			the callback list behaves or a more traditional option object
 *
 * By default a callback list will act like an event callback list and can be
 * "fired" multiple times.
 *
 * Possible options:
 *
 *	once:			will ensure the callback list can only be fired once (like a Deferred)
 *
 *	memory:			will keep track of previous values and will call any callback added
 *					after the list has been fired right away with the latest "memorized"
 *					values (like a Deferred)
 *
 *	unique:			will ensure a callback can only be added once (no duplicate in the list)
 *
 *	stopOnFalse:	interrupt callings when a callback returns false
 *
 */
jQuery.Callbacks = function( options ) {

	// Convert options from String-formatted to Object-formatted if needed
	// (we check in cache first)
	options = typeof options === "string" ?
		createOptions( options ) :
		jQuery.extend( {}, options );

	var // Flag to know if list is currently firing
		firing,

		// Last fire value for non-forgettable lists
		memory,

		// Flag to know if list was already fired
		fired,

		// Flag to prevent firing
		locked,

		// Actual callback list
		list = [],

		// Queue of execution data for repeatable lists
		queue = [],

		// Index of currently firing callback (modified by add/remove as needed)
		firingIndex = -1,

		// Fire callbacks
		fire = function() {

			// Enforce single-firing
			locked = options.once;

			// Execute callbacks for all pending executions,
			// respecting firingIndex overrides and runtime changes
			fired = firing = true;
			for ( ; queue.length; firingIndex = -1 ) {
				memory = queue.shift();
				while ( ++firingIndex < list.length ) {

					// Run callback and check for early termination
					if ( list[ firingIndex ].apply( memory[ 0 ], memory[ 1 ] ) === false &&
						options.stopOnFalse ) {

						// Jump to end and forget the data so .add doesn't re-fire
						firingIndex = list.length;
						memory = false;
					}
				}
			}

			// Forget the data if we're done with it
			if ( !options.memory ) {
				memory = false;
			}

			firing = false;

			// Clean up if we're done firing for good
			if ( locked ) {

				// Keep an empty list if we have data for future add calls
				if ( memory ) {
					list = [];

				// Otherwise, this object is spent
				} else {
					list = "";
				}
			}
		},

		// Actual Callbacks object
		self = {

			// Add a callback or a collection of callbacks to the list
			add: function() {
				if ( list ) {

					// If we have memory from a past run, we should fire after adding
					if ( memory && !firing ) {
						firingIndex = list.length - 1;
						queue.push( memory );
					}

					( function add( args ) {
						jQuery.each( args, function( _, arg ) {
							if ( jQuery.isFunction( arg ) ) {
								if ( !options.unique || !self.has( arg ) ) {
									list.push( arg );
								}
							} else if ( arg && arg.length && jQuery.type( arg ) !== "string" ) {

								// Inspect recursively
								add( arg );
							}
						} );
					} )( arguments );

					if ( memory && !firing ) {
						fire();
					}
				}
				return this;
			},

			// Remove a callback from the list
			remove: function() {
				jQuery.each( arguments, function( _, arg ) {
					var index;
					while ( ( index = jQuery.inArray( arg, list, index ) ) > -1 ) {
						list.splice( index, 1 );

						// Handle firing indexes
						if ( index <= firingIndex ) {
							firingIndex--;
						}
					}
				} );
				return this;
			},

			// Check if a given callback is in the list.
			// If no argument is given, return whether or not list has callbacks attached.
			has: function( fn ) {
				return fn ?
					jQuery.inArray( fn, list ) > -1 :
					list.length > 0;
			},

			// Remove all callbacks from the list
			empty: function() {
				if ( list ) {
					list = [];
				}
				return this;
			},

			// Disable .fire and .add
			// Abort any current/pending executions
			// Clear all callbacks and values
			disable: function() {
				locked = queue = [];
				list = memory = "";
				return this;
			},
			disabled: function() {
				return !list;
			},

			// Disable .fire
			// Also disable .add unless we have memory (since it would have no effect)
			// Abort any pending executions
			lock: function() {
				locked = queue = [];
				if ( !memory && !firing ) {
					list = memory = "";
				}
				return this;
			},
			locked: function() {
				return !!locked;
			},

			// Call all callbacks with the given context and arguments
			fireWith: function( context, args ) {
				if ( !locked ) {
					args = args || [];
					args = [ context, args.slice ? args.slice() : args ];
					queue.push( args );
					if ( !firing ) {
						fire();
					}
				}
				return this;
			},

			// Call all the callbacks with the given arguments
			fire: function() {
				self.fireWith( this, arguments );
				return this;
			},

			// To know if the callbacks have already been called at least once
			fired: function() {
				return !!fired;
			}
		};

	return self;
};


function Identity( v ) {
	return v;
}
function Thrower( ex ) {
	throw ex;
}

function adoptValue( value, resolve, reject ) {
	var method;

	try {

		// Check for promise aspect first to privilege synchronous behavior
		if ( value && jQuery.isFunction( ( method = value.promise ) ) ) {
			method.call( value ).done( resolve ).fail( reject );

		// Other thenables
		} else if ( value && jQuery.isFunction( ( method = value.then ) ) ) {
			method.call( value, resolve, reject );

		// Other non-thenables
		} else {

			// Support: Android 4.0 only
			// Strict mode functions invoked without .call/.apply get global-object context
			resolve.call( undefined, value );
		}

	// For Promises/A+, convert exceptions into rejections
	// Since jQuery.when doesn't unwrap thenables, we can skip the extra checks appearing in
	// Deferred#then to conditionally suppress rejection.
	} catch ( value ) {

		// Support: Android 4.0 only
		// Strict mode functions invoked without .call/.apply get global-object context
		reject.call( undefined, value );
	}
}

jQuery.extend( {

	Deferred: function( func ) {
		var tuples = [

				// action, add listener, callbacks,
				// ... .then handlers, argument index, [final state]
				[ "notify", "progress", jQuery.Callbacks( "memory" ),
					jQuery.Callbacks( "memory" ), 2 ],
				[ "resolve", "done", jQuery.Callbacks( "once memory" ),
					jQuery.Callbacks( "once memory" ), 0, "resolved" ],
				[ "reject", "fail", jQuery.Callbacks( "once memory" ),
					jQuery.Callbacks( "once memory" ), 1, "rejected" ]
			],
			state = "pending",
			promise = {
				state: function() {
					return state;
				},
				always: function() {
					deferred.done( arguments ).fail( arguments );
					return this;
				},
				"catch": function( fn ) {
					return promise.then( null, fn );
				},

				// Keep pipe for back-compat
				pipe: function( /* fnDone, fnFail, fnProgress */ ) {
					var fns = arguments;

					return jQuery.Deferred( function( newDefer ) {
						jQuery.each( tuples, function( i, tuple ) {

							// Map tuples (progress, done, fail) to arguments (done, fail, progress)
							var fn = jQuery.isFunction( fns[ tuple[ 4 ] ] ) && fns[ tuple[ 4 ] ];

							// deferred.progress(function() { bind to newDefer or newDefer.notify })
							// deferred.done(function() { bind to newDefer or newDefer.resolve })
							// deferred.fail(function() { bind to newDefer or newDefer.reject })
							deferred[ tuple[ 1 ] ]( function() {
								var returned = fn && fn.apply( this, arguments );
								if ( returned && jQuery.isFunction( returned.promise ) ) {
									returned.promise()
										.progress( newDefer.notify )
										.done( newDefer.resolve )
										.fail( newDefer.reject );
								} else {
									newDefer[ tuple[ 0 ] + "With" ](
										this,
										fn ? [ returned ] : arguments
									);
								}
							} );
						} );
						fns = null;
					} ).promise();
				},
				then: function( onFulfilled, onRejected, onProgress ) {
					var maxDepth = 0;
					function resolve( depth, deferred, handler, special ) {
						return function() {
							var that = this,
								args = arguments,
								mightThrow = function() {
									var returned, then;

									// Support: Promises/A+ section 2.3.3.3.3
									// https://promisesaplus.com/#point-59
									// Ignore double-resolution attempts
									if ( depth < maxDepth ) {
										return;
									}

									returned = handler.apply( that, args );

									// Support: Promises/A+ section 2.3.1
									// https://promisesaplus.com/#point-48
									if ( returned === deferred.promise() ) {
										throw new TypeError( "Thenable self-resolution" );
									}

									// Support: Promises/A+ sections 2.3.3.1, 3.5
									// https://promisesaplus.com/#point-54
									// https://promisesaplus.com/#point-75
									// Retrieve `then` only once
									then = returned &&

										// Support: Promises/A+ section 2.3.4
										// https://promisesaplus.com/#point-64
										// Only check objects and functions for thenability
										( typeof returned === "object" ||
											typeof returned === "function" ) &&
										returned.then;

									// Handle a returned thenable
									if ( jQuery.isFunction( then ) ) {

										// Special processors (notify) just wait for resolution
										if ( special ) {
											then.call(
												returned,
												resolve( maxDepth, deferred, Identity, special ),
												resolve( maxDepth, deferred, Thrower, special )
											);

										// Normal processors (resolve) also hook into progress
										} else {

											// ...and disregard older resolution values
											maxDepth++;

											then.call(
												returned,
												resolve( maxDepth, deferred, Identity, special ),
												resolve( maxDepth, deferred, Thrower, special ),
												resolve( maxDepth, deferred, Identity,
													deferred.notifyWith )
											);
										}

									// Handle all other returned values
									} else {

										// Only substitute handlers pass on context
										// and multiple values (non-spec behavior)
										if ( handler !== Identity ) {
											that = undefined;
											args = [ returned ];
										}

										// Process the value(s)
										// Default process is resolve
										( special || deferred.resolveWith )( that, args );
									}
								},

								// Only normal processors (resolve) catch and reject exceptions
								process = special ?
									mightThrow :
									function() {
										try {
											mightThrow();
										} catch ( e ) {

											if ( jQuery.Deferred.exceptionHook ) {
												jQuery.Deferred.exceptionHook( e,
													process.stackTrace );
											}

											// Support: Promises/A+ section 2.3.3.3.4.1
											// https://promisesaplus.com/#point-61
											// Ignore post-resolution exceptions
											if ( depth + 1 >= maxDepth ) {

												// Only substitute handlers pass on context
												// and multiple values (non-spec behavior)
												if ( handler !== Thrower ) {
													that = undefined;
													args = [ e ];
												}

												deferred.rejectWith( that, args );
											}
										}
									};

							// Support: Promises/A+ section 2.3.3.3.1
							// https://promisesaplus.com/#point-57
							// Re-resolve promises immediately to dodge false rejection from
							// subsequent errors
							if ( depth ) {
								process();
							} else {

								// Call an optional hook to record the stack, in case of exception
								// since it's otherwise lost when execution goes async
								if ( jQuery.Deferred.getStackHook ) {
									process.stackTrace = jQuery.Deferred.getStackHook();
								}
								window.setTimeout( process );
							}
						};
					}

					return jQuery.Deferred( function( newDefer ) {

						// progress_handlers.add( ... )
						tuples[ 0 ][ 3 ].add(
							resolve(
								0,
								newDefer,
								jQuery.isFunction( onProgress ) ?
									onProgress :
									Identity,
								newDefer.notifyWith
							)
						);

						// fulfilled_handlers.add( ... )
						tuples[ 1 ][ 3 ].add(
							resolve(
								0,
								newDefer,
								jQuery.isFunction( onFulfilled ) ?
									onFulfilled :
									Identity
							)
						);

						// rejected_handlers.add( ... )
						tuples[ 2 ][ 3 ].add(
							resolve(
								0,
								newDefer,
								jQuery.isFunction( onRejected ) ?
									onRejected :
									Thrower
							)
						);
					} ).promise();
				},

				// Get a promise for this deferred
				// If obj is provided, the promise aspect is added to the object
				promise: function( obj ) {
					return obj != null ? jQuery.extend( obj, promise ) : promise;
				}
			},
			deferred = {};

		// Add list-specific methods
		jQuery.each( tuples, function( i, tuple ) {
			var list = tuple[ 2 ],
				stateString = tuple[ 5 ];

			// promise.progress = list.add
			// promise.done = list.add
			// promise.fail = list.add
			promise[ tuple[ 1 ] ] = list.add;

			// Handle state
			if ( stateString ) {
				list.add(
					function() {

						// state = "resolved" (i.e., fulfilled)
						// state = "rejected"
						state = stateString;
					},

					// rejected_callbacks.disable
					// fulfilled_callbacks.disable
					tuples[ 3 - i ][ 2 ].disable,

					// progress_callbacks.lock
					tuples[ 0 ][ 2 ].lock
				);
			}

			// progress_handlers.fire
			// fulfilled_handlers.fire
			// rejected_handlers.fire
			list.add( tuple[ 3 ].fire );

			// deferred.notify = function() { deferred.notifyWith(...) }
			// deferred.resolve = function() { deferred.resolveWith(...) }
			// deferred.reject = function() { deferred.rejectWith(...) }
			deferred[ tuple[ 0 ] ] = function() {
				deferred[ tuple[ 0 ] + "With" ]( this === deferred ? undefined : this, arguments );
				return this;
			};

			// deferred.notifyWith = list.fireWith
			// deferred.resolveWith = list.fireWith
			// deferred.rejectWith = list.fireWith
			deferred[ tuple[ 0 ] + "With" ] = list.fireWith;
		} );

		// Make the deferred a promise
		promise.promise( deferred );

		// Call given func if any
		if ( func ) {
			func.call( deferred, deferred );
		}

		// All done!
		return deferred;
	},

	// Deferred helper
	when: function( singleValue ) {
		var

			// count of uncompleted subordinates
			remaining = arguments.length,

			// count of unprocessed arguments
			i = remaining,

			// subordinate fulfillment data
			resolveContexts = Array( i ),
			resolveValues = slice.call( arguments ),

			// the master Deferred
			master = jQuery.Deferred(),

			// subordinate callback factory
			updateFunc = function( i ) {
				return function( value ) {
					resolveContexts[ i ] = this;
					resolveValues[ i ] = arguments.length > 1 ? slice.call( arguments ) : value;
					if ( !( --remaining ) ) {
						master.resolveWith( resolveContexts, resolveValues );
					}
				};
			};

		// Single- and empty arguments are adopted like Promise.resolve
		if ( remaining <= 1 ) {
			adoptValue( singleValue, master.done( updateFunc( i ) ).resolve, master.reject );

			// Use .then() to unwrap secondary thenables (cf. gh-3000)
			if ( master.state() === "pending" ||
				jQuery.isFunction( resolveValues[ i ] && resolveValues[ i ].then ) ) {

				return master.then();
			}
		}

		// Multiple arguments are aggregated like Promise.all array elements
		while ( i-- ) {
			adoptValue( resolveValues[ i ], updateFunc( i ), master.reject );
		}

		return master.promise();
	}
} );


// These usually indicate a programmer mistake during development,
// warn about them ASAP rather than swallowing them by default.
var rerrorNames = /^(Eval|Internal|Range|Reference|Syntax|Type|URI)Error$/;

jQuery.Deferred.exceptionHook = function( error, stack ) {

	// Support: IE 8 - 9 only
	// Console exists when dev tools are open, which can happen at any time
	if ( window.console && window.console.warn && error && rerrorNames.test( error.name ) ) {
		window.console.warn( "jQuery.Deferred exception: " + error.message, error.stack, stack );
	}
};




jQuery.readyException = function( error ) {
	window.setTimeout( function() {
		throw error;
	} );
};




// The deferred used on DOM ready
var readyList = jQuery.Deferred();

jQuery.fn.ready = function( fn ) {

	readyList
		.then( fn )

		// Wrap jQuery.readyException in a function so that the lookup
		// happens at the time of error handling instead of callback
		// registration.
		.catch( function( error ) {
			jQuery.readyException( error );
		} );

	return this;
};

jQuery.extend( {

	// Is the DOM ready to be used? Set to true once it occurs.
	isReady: false,

	// A counter to track how many items to wait for before
	// the ready event fires. See #6781
	readyWait: 1,

	// Hold (or release) the ready event
	holdReady: function( hold ) {
		if ( hold ) {
			jQuery.readyWait++;
		} else {
			jQuery.ready( true );
		}
	},

	// Handle when the DOM is ready
	ready: function( wait ) {

		// Abort if there are pending holds or we're already ready
		if ( wait === true ? --jQuery.readyWait : jQuery.isReady ) {
			return;
		}

		// Remember that the DOM is ready
		jQuery.isReady = true;

		// If a normal DOM Ready event fired, decrement, and wait if need be
		if ( wait !== true && --jQuery.readyWait > 0 ) {
			return;
		}

		// If there are functions bound, to execute
		readyList.resolveWith( document, [ jQuery ] );
	}
} );

jQuery.ready.then = readyList.then;

// The ready event handler and self cleanup method
function completed() {
	document.removeEventListener( "DOMContentLoaded", completed );
	window.removeEventListener( "load", completed );
	jQuery.ready();
}

// Catch cases where $(document).ready() is called
// after the browser event has already occurred.
// Support: IE <=9 - 10 only
// Older IE sometimes signals "interactive" too soon
if ( document.readyState === "complete" ||
	( document.readyState !== "loading" && !document.documentElement.doScroll ) ) {

	// Handle it asynchronously to allow scripts the opportunity to delay ready
	window.setTimeout( jQuery.ready );

} else {

	// Use the handy event callback
	document.addEventListener( "DOMContentLoaded", completed );

	// A fallback to window.onload, that will always work
	window.addEventListener( "load", completed );
}




// Multifunctional method to get and set values of a collection
// The value/s can optionally be executed if it's a function
var access = function( elems, fn, key, value, chainable, emptyGet, raw ) {
	var i = 0,
		len = elems.length,
		bulk = key == null;

	// Sets many values
	if ( jQuery.type( key ) === "object" ) {
		chainable = true;
		for ( i in key ) {
			access( elems, fn, i, key[ i ], true, emptyGet, raw );
		}

	// Sets one value
	} else if ( value !== undefined ) {
		chainable = true;

		if ( !jQuery.isFunction( value ) ) {
			raw = true;
		}

		if ( bulk ) {

			// Bulk operations run against the entire set
			if ( raw ) {
				fn.call( elems, value );
				fn = null;

			// ...except when executing function values
			} else {
				bulk = fn;
				fn = function( elem, key, value ) {
					return bulk.call( jQuery( elem ), value );
				};
			}
		}

		if ( fn ) {
			for ( ; i < len; i++ ) {
				fn(
					elems[ i ], key, raw ?
					value :
					value.call( elems[ i ], i, fn( elems[ i ], key ) )
				);
			}
		}
	}

	if ( chainable ) {
		return elems;
	}

	// Gets
	if ( bulk ) {
		return fn.call( elems );
	}

	return len ? fn( elems[ 0 ], key ) : emptyGet;
};
var acceptData = function( owner ) {

	// Accepts only:
	//  - Node
	//    - Node.ELEMENT_NODE
	//    - Node.DOCUMENT_NODE
	//  - Object
	//    - Any
	return owner.nodeType === 1 || owner.nodeType === 9 || !( +owner.nodeType );
};




function Data() {
	this.expando = jQuery.expando + Data.uid++;
}

Data.uid = 1;

Data.prototype = {

	cache: function( owner ) {

		// Check if the owner object already has a cache
		var value = owner[ this.expando ];

		// If not, create one
		if ( !value ) {
			value = {};

			// We can accept data for non-element nodes in modern browsers,
			// but we should not, see #8335.
			// Always return an empty object.
			if ( acceptData( owner ) ) {

				// If it is a node unlikely to be stringify-ed or looped over
				// use plain assignment
				if ( owner.nodeType ) {
					owner[ this.expando ] = value;

				// Otherwise secure it in a non-enumerable property
				// configurable must be true to allow the property to be
				// deleted when data is removed
				} else {
					Object.defineProperty( owner, this.expando, {
						value: value,
						configurable: true
					} );
				}
			}
		}

		return value;
	},
	set: function( owner, data, value ) {
		var prop,
			cache = this.cache( owner );

		// Handle: [ owner, key, value ] args
		// Always use camelCase key (gh-2257)
		if ( typeof data === "string" ) {
			cache[ jQuery.camelCase( data ) ] = value;

		// Handle: [ owner, { properties } ] args
		} else {

			// Copy the properties one-by-one to the cache object
			for ( prop in data ) {
				cache[ jQuery.camelCase( prop ) ] = data[ prop ];
			}
		}
		return cache;
	},
	get: function( owner, key ) {
		return key === undefined ?
			this.cache( owner ) :

			// Always use camelCase key (gh-2257)
			owner[ this.expando ] && owner[ this.expando ][ jQuery.camelCase( key ) ];
	},
	access: function( owner, key, value ) {

		// In cases where either:
		//
		//   1. No key was specified
		//   2. A string key was specified, but no value provided
		//
		// Take the "read" path and allow the get method to determine
		// which value to return, respectively either:
		//
		//   1. The entire cache object
		//   2. The data stored at the key
		//
		if ( key === undefined ||
				( ( key && typeof key === "string" ) && value === undefined ) ) {

			return this.get( owner, key );
		}

		// When the key is not a string, or both a key and value
		// are specified, set or extend (existing objects) with either:
		//
		//   1. An object of properties
		//   2. A key and value
		//
		this.set( owner, key, value );

		// Since the "set" path can have two possible entry points
		// return the expected data based on which path was taken[*]
		return value !== undefined ? value : key;
	},
	remove: function( owner, key ) {
		var i,
			cache = owner[ this.expando ];

		if ( cache === undefined ) {
			return;
		}

		if ( key !== undefined ) {

			// Support array or space separated string of keys
			if ( jQuery.isArray( key ) ) {

				// If key is an array of keys...
				// We always set camelCase keys, so remove that.
				key = key.map( jQuery.camelCase );
			} else {
				key = jQuery.camelCase( key );

				// If a key with the spaces exists, use it.
				// Otherwise, create an array by matching non-whitespace
				key = key in cache ?
					[ key ] :
					( key.match( rnothtmlwhite ) || [] );
			}

			i = key.length;

			while ( i-- ) {
				delete cache[ key[ i ] ];
			}
		}

		// Remove the expando if there's no more data
		if ( key === undefined || jQuery.isEmptyObject( cache ) ) {

			// Support: Chrome <=35 - 45
			// Webkit & Blink performance suffers when deleting properties
			// from DOM nodes, so set to undefined instead
			// https://bugs.chromium.org/p/chromium/issues/detail?id=378607 (bug restricted)
			if ( owner.nodeType ) {
				owner[ this.expando ] = undefined;
			} else {
				delete owner[ this.expando ];
			}
		}
	},
	hasData: function( owner ) {
		var cache = owner[ this.expando ];
		return cache !== undefined && !jQuery.isEmptyObject( cache );
	}
};
var dataPriv = new Data();

var dataUser = new Data();



//	Implementation Summary
//
//	1. Enforce API surface and semantic compatibility with 1.9.x branch
//	2. Improve the module's maintainability by reducing the storage
//		paths to a single mechanism.
//	3. Use the same single mechanism to support "private" and "user" data.
//	4. _Never_ expose "private" data to user code (TODO: Drop _data, _removeData)
//	5. Avoid exposing implementation details on user objects (eg. expando properties)
//	6. Provide a clear path for implementation upgrade to WeakMap in 2014

var rbrace = /^(?:\{[\w\W]*\}|\[[\w\W]*\])$/,
	rmultiDash = /[A-Z]/g;

function getData( data ) {
	if ( data === "true" ) {
		return true;
	}

	if ( data === "false" ) {
		return false;
	}

	if ( data === "null" ) {
		return null;
	}

	// Only convert to a number if it doesn't change the string
	if ( data === +data + "" ) {
		return +data;
	}

	if ( rbrace.test( data ) ) {
		return JSON.parse( data );
	}

	return data;
}

function dataAttr( elem, key, data ) {
	var name;

	// If nothing was found internally, try to fetch any
	// data from the HTML5 data-* attribute
	if ( data === undefined && elem.nodeType === 1 ) {
		name = "data-" + key.replace( rmultiDash, "-$&" ).toLowerCase();
		data = elem.getAttribute( name );

		if ( typeof data === "string" ) {
			try {
				data = getData( data );
			} catch ( e ) {}

			// Make sure we set the data so it isn't changed later
			dataUser.set( elem, key, data );
		} else {
			data = undefined;
		}
	}
	return data;
}

jQuery.extend( {
	hasData: function( elem ) {
		return dataUser.hasData( elem ) || dataPriv.hasData( elem );
	},

	data: function( elem, name, data ) {
		return dataUser.access( elem, name, data );
	},

	removeData: function( elem, name ) {
		dataUser.remove( elem, name );
	},

	// TODO: Now that all calls to _data and _removeData have been replaced
	// with direct calls to dataPriv methods, these can be deprecated.
	_data: function( elem, name, data ) {
		return dataPriv.access( elem, name, data );
	},

	_removeData: function( elem, name ) {
		dataPriv.remove( elem, name );
	}
} );

jQuery.fn.extend( {
	data: function( key, value ) {
		var i, name, data,
			elem = this[ 0 ],
			attrs = elem && elem.attributes;

		// Gets all values
		if ( key === undefined ) {
			if ( this.length ) {
				data = dataUser.get( elem );

				if ( elem.nodeType === 1 && !dataPriv.get( elem, "hasDataAttrs" ) ) {
					i = attrs.length;
					while ( i-- ) {

						// Support: IE 11 only
						// The attrs elements can be null (#14894)
						if ( attrs[ i ] ) {
							name = attrs[ i ].name;
							if ( name.indexOf( "data-" ) === 0 ) {
								name = jQuery.camelCase( name.slice( 5 ) );
								dataAttr( elem, name, data[ name ] );
							}
						}
					}
					dataPriv.set( elem, "hasDataAttrs", true );
				}
			}

			return data;
		}

		// Sets multiple values
		if ( typeof key === "object" ) {
			return this.each( function() {
				dataUser.set( this, key );
			} );
		}

		return access( this, function( value ) {
			var data;

			// The calling jQuery object (element matches) is not empty
			// (and therefore has an element appears at this[ 0 ]) and the
			// `value` parameter was not undefined. An empty jQuery object
			// will result in `undefined` for elem = this[ 0 ] which will
			// throw an exception if an attempt to read a data cache is made.
			if ( elem && value === undefined ) {

				// Attempt to get data from the cache
				// The key will always be camelCased in Data
				data = dataUser.get( elem, key );
				if ( data !== undefined ) {
					return data;
				}

				// Attempt to "discover" the data in
				// HTML5 custom data-* attrs
				data = dataAttr( elem, key );
				if ( data !== undefined ) {
					return data;
				}

				// We tried really hard, but the data doesn't exist.
				return;
			}

			// Set the data...
			this.each( function() {

				// We always store the camelCased key
				dataUser.set( this, key, value );
			} );
		}, null, value, arguments.length > 1, null, true );
	},

	removeData: function( key ) {
		return this.each( function() {
			dataUser.remove( this, key );
		} );
	}
} );


jQuery.extend( {
	queue: function( elem, type, data ) {
		var queue;

		if ( elem ) {
			type = ( type || "fx" ) + "queue";
			queue = dataPriv.get( elem, type );

			// Speed up dequeue by getting out quickly if this is just a lookup
			if ( data ) {
				if ( !queue || jQuery.isArray( data ) ) {
					queue = dataPriv.access( elem, type, jQuery.makeArray( data ) );
				} else {
					queue.push( data );
				}
			}
			return queue || [];
		}
	},

	dequeue: function( elem, type ) {
		type = type || "fx";

		var queue = jQuery.queue( elem, type ),
			startLength = queue.length,
			fn = queue.shift(),
			hooks = jQuery._queueHooks( elem, type ),
			next = function() {
				jQuery.dequeue( elem, type );
			};

		// If the fx queue is dequeued, always remove the progress sentinel
		if ( fn === "inprogress" ) {
			fn = queue.shift();
			startLength--;
		}

		if ( fn ) {

			// Add a progress sentinel to prevent the fx queue from being
			// automatically dequeued
			if ( type === "fx" ) {
				queue.unshift( "inprogress" );
			}

			// Clear up the last queue stop function
			delete hooks.stop;
			fn.call( elem, next, hooks );
		}

		if ( !startLength && hooks ) {
			hooks.empty.fire();
		}
	},

	// Not public - generate a queueHooks object, or return the current one
	_queueHooks: function( elem, type ) {
		var key = type + "queueHooks";
		return dataPriv.get( elem, key ) || dataPriv.access( elem, key, {
			empty: jQuery.Callbacks( "once memory" ).add( function() {
				dataPriv.remove( elem, [ type + "queue", key ] );
			} )
		} );
	}
} );

jQuery.fn.extend( {
	queue: function( type, data ) {
		var setter = 2;

		if ( typeof type !== "string" ) {
			data = type;
			type = "fx";
			setter--;
		}

		if ( arguments.length < setter ) {
			return jQuery.queue( this[ 0 ], type );
		}

		return data === undefined ?
			this :
			this.each( function() {
				var queue = jQuery.queue( this, type, data );

				// Ensure a hooks for this queue
				jQuery._queueHooks( this, type );

				if ( type === "fx" && queue[ 0 ] !== "inprogress" ) {
					jQuery.dequeue( this, type );
				}
			} );
	},
	dequeue: function( type ) {
		return this.each( function() {
			jQuery.dequeue( this, type );
		} );
	},
	clearQueue: function( type ) {
		return this.queue( type || "fx", [] );
	},

	// Get a promise resolved when queues of a certain type
	// are emptied (fx is the type by default)
	promise: function( type, obj ) {
		var tmp,
			count = 1,
			defer = jQuery.Deferred(),
			elements = this,
			i = this.length,
			resolve = function() {
				if ( !( --count ) ) {
					defer.resolveWith( elements, [ elements ] );
				}
			};

		if ( typeof type !== "string" ) {
			obj = type;
			type = undefined;
		}
		type = type || "fx";

		while ( i-- ) {
			tmp = dataPriv.get( elements[ i ], type + "queueHooks" );
			if ( tmp && tmp.empty ) {
				count++;
				tmp.empty.add( resolve );
			}
		}
		resolve();
		return defer.promise( obj );
	}
} );
var pnum = ( /[+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|)/ ).source;

var rcssNum = new RegExp( "^(?:([+-])=|)(" + pnum + ")([a-z%]*)$", "i" );


var cssExpand = [ "Top", "Right", "Bottom", "Left" ];

var isHiddenWithinTree = function( elem, el ) {

		// isHiddenWithinTree might be called from jQuery#filter function;
		// in that case, element will be second argument
		elem = el || elem;

		// Inline style trumps all
		return elem.style.display === "none" ||
			elem.style.display === "" &&

			// Otherwise, check computed style
			// Support: Firefox <=43 - 45
			// Disconnected elements can have computed display: none, so first confirm that elem is
			// in the document.
			jQuery.contains( elem.ownerDocument, elem ) &&

			jQuery.css( elem, "display" ) === "none";
	};

var swap = function( elem, options, callback, args ) {
	var ret, name,
		old = {};

	// Remember the old values, and insert the new ones
	for ( name in options ) {
		old[ name ] = elem.style[ name ];
		elem.style[ name ] = options[ name ];
	}

	ret = callback.apply( elem, args || [] );

	// Revert the old values
	for ( name in options ) {
		elem.style[ name ] = old[ name ];
	}

	return ret;
};




function adjustCSS( elem, prop, valueParts, tween ) {
	var adjusted,
		scale = 1,
		maxIterations = 20,
		currentValue = tween ?
			function() {
				return tween.cur();
			} :
			function() {
				return jQuery.css( elem, prop, "" );
			},
		initial = currentValue(),
		unit = valueParts && valueParts[ 3 ] || ( jQuery.cssNumber[ prop ] ? "" : "px" ),

		// Starting value computation is required for potential unit mismatches
		initialInUnit = ( jQuery.cssNumber[ prop ] || unit !== "px" && +initial ) &&
			rcssNum.exec( jQuery.css( elem, prop ) );

	if ( initialInUnit && initialInUnit[ 3 ] !== unit ) {

		// Trust units reported by jQuery.css
		unit = unit || initialInUnit[ 3 ];

		// Make sure we update the tween properties later on
		valueParts = valueParts || [];

		// Iteratively approximate from a nonzero starting point
		initialInUnit = +initial || 1;

		do {

			// If previous iteration zeroed out, double until we get *something*.
			// Use string for doubling so we don't accidentally see scale as unchanged below
			scale = scale || ".5";

			// Adjust and apply
			initialInUnit = initialInUnit / scale;
			jQuery.style( elem, prop, initialInUnit + unit );

		// Update scale, tolerating zero or NaN from tween.cur()
		// Break the loop if scale is unchanged or perfect, or if we've just had enough.
		} while (
			scale !== ( scale = currentValue() / initial ) && scale !== 1 && --maxIterations
		);
	}

	if ( valueParts ) {
		initialInUnit = +initialInUnit || +initial || 0;

		// Apply relative offset (+=/-=) if specified
		adjusted = valueParts[ 1 ] ?
			initialInUnit + ( valueParts[ 1 ] + 1 ) * valueParts[ 2 ] :
			+valueParts[ 2 ];
		if ( tween ) {
			tween.unit = unit;
			tween.start = initialInUnit;
			tween.end = adjusted;
		}
	}
	return adjusted;
}


var defaultDisplayMap = {};

function getDefaultDisplay( elem ) {
	var temp,
		doc = elem.ownerDocument,
		nodeName = elem.nodeName,
		display = defaultDisplayMap[ nodeName ];

	if ( display ) {
		return display;
	}

	temp = doc.body.appendChild( doc.createElement( nodeName ) );
	display = jQuery.css( temp, "display" );

	temp.parentNode.removeChild( temp );

	if ( display === "none" ) {
		display = "block";
	}
	defaultDisplayMap[ nodeName ] = display;

	return display;
}

function showHide( elements, show ) {
	var display, elem,
		values = [],
		index = 0,
		length = elements.length;

	// Determine new display value for elements that need to change
	for ( ; index < length; index++ ) {
		elem = elements[ index ];
		if ( !elem.style ) {
			continue;
		}

		display = elem.style.display;
		if ( show ) {

			// Since we force visibility upon cascade-hidden elements, an immediate (and slow)
			// check is required in this first loop unless we have a nonempty display value (either
			// inline or about-to-be-restored)
			if ( display === "none" ) {
				values[ index ] = dataPriv.get( elem, "display" ) || null;
				if ( !values[ index ] ) {
					elem.style.display = "";
				}
			}
			if ( elem.style.display === "" && isHiddenWithinTree( elem ) ) {
				values[ index ] = getDefaultDisplay( elem );
			}
		} else {
			if ( display !== "none" ) {
				values[ index ] = "none";

				// Remember what we're overwriting
				dataPriv.set( elem, "display", display );
			}
		}
	}

	// Set the display of the elements in a second loop to avoid constant reflow
	for ( index = 0; index < length; index++ ) {
		if ( values[ index ] != null ) {
			elements[ index ].style.display = values[ index ];
		}
	}

	return elements;
}

jQuery.fn.extend( {
	show: function() {
		return showHide( this, true );
	},
	hide: function() {
		return showHide( this );
	},
	toggle: function( state ) {
		if ( typeof state === "boolean" ) {
			return state ? this.show() : this.hide();
		}

		return this.each( function() {
			if ( isHiddenWithinTree( this ) ) {
				jQuery( this ).show();
			} else {
				jQuery( this ).hide();
			}
		} );
	}
} );
var rcheckableType = ( /^(?:checkbox|radio)$/i );

var rtagName = ( /<([a-z][^\/\0>\x20\t\r\n\f]+)/i );

var rscriptType = ( /^$|\/(?:java|ecma)script/i );



// We have to close these tags to support XHTML (#13200)
var wrapMap = {

	// Support: IE <=9 only
	option: [ 1, "<select multiple='multiple'>", "</select>" ],

	// XHTML parsers do not magically insert elements in the
	// same way that tag soup parsers do. So we cannot shorten
	// this by omitting <tbody> or other required elements.
	thead: [ 1, "<table>", "</table>" ],
	col: [ 2, "<table><colgroup>", "</colgroup></table>" ],
	tr: [ 2, "<table><tbody>", "</tbody></table>" ],
	td: [ 3, "<table><tbody><tr>", "</tr></tbody></table>" ],

	_default: [ 0, "", "" ]
};

// Support: IE <=9 only
wrapMap.optgroup = wrapMap.option;

wrapMap.tbody = wrapMap.tfoot = wrapMap.colgroup = wrapMap.caption = wrapMap.thead;
wrapMap.th = wrapMap.td;


function getAll( context, tag ) {

	// Support: IE <=9 - 11 only
	// Use typeof to avoid zero-argument method invocation on host objects (#15151)
	var ret;

	if ( typeof context.getElementsByTagName !== "undefined" ) {
		ret = context.getElementsByTagName( tag || "*" );

	} else if ( typeof context.querySelectorAll !== "undefined" ) {
		ret = context.querySelectorAll( tag || "*" );

	} else {
		ret = [];
	}

	if ( tag === undefined || tag && jQuery.nodeName( context, tag ) ) {
		return jQuery.merge( [ context ], ret );
	}

	return ret;
}


// Mark scripts as having already been evaluated
function setGlobalEval( elems, refElements ) {
	var i = 0,
		l = elems.length;

	for ( ; i < l; i++ ) {
		dataPriv.set(
			elems[ i ],
			"globalEval",
			!refElements || dataPriv.get( refElements[ i ], "globalEval" )
		);
	}
}


var rhtml = /<|&#?\w+;/;

function buildFragment( elems, context, scripts, selection, ignored ) {
	var elem, tmp, tag, wrap, contains, j,
		fragment = context.createDocumentFragment(),
		nodes = [],
		i = 0,
		l = elems.length;

	for ( ; i < l; i++ ) {
		elem = elems[ i ];

		if ( elem || elem === 0 ) {

			// Add nodes directly
			if ( jQuery.type( elem ) === "object" ) {

				// Support: Android <=4.0 only, PhantomJS 1 only
				// push.apply(_, arraylike) throws on ancient WebKit
				jQuery.merge( nodes, elem.nodeType ? [ elem ] : elem );

			// Convert non-html into a text node
			} else if ( !rhtml.test( elem ) ) {
				nodes.push( context.createTextNode( elem ) );

			// Convert html into DOM nodes
			} else {
				tmp = tmp || fragment.appendChild( context.createElement( "div" ) );

				// Deserialize a standard representation
				tag = ( rtagName.exec( elem ) || [ "", "" ] )[ 1 ].toLowerCase();
				wrap = wrapMap[ tag ] || wrapMap._default;
				tmp.innerHTML = wrap[ 1 ] + jQuery.htmlPrefilter( elem ) + wrap[ 2 ];

				// Descend through wrappers to the right content
				j = wrap[ 0 ];
				while ( j-- ) {
					tmp = tmp.lastChild;
				}

				// Support: Android <=4.0 only, PhantomJS 1 only
				// push.apply(_, arraylike) throws on ancient WebKit
				jQuery.merge( nodes, tmp.childNodes );

				// Remember the top-level container
				tmp = fragment.firstChild;

				// Ensure the created nodes are orphaned (#12392)
				tmp.textContent = "";
			}
		}
	}

	// Remove wrapper from fragment
	fragment.textContent = "";

	i = 0;
	while ( ( elem = nodes[ i++ ] ) ) {

		// Skip elements already in the context collection (trac-4087)
		if ( selection && jQuery.inArray( elem, selection ) > -1 ) {
			if ( ignored ) {
				ignored.push( elem );
			}
			continue;
		}

		contains = jQuery.contains( elem.ownerDocument, elem );

		// Append to fragment
		tmp = getAll( fragment.appendChild( elem ), "script" );

		// Preserve script evaluation history
		if ( contains ) {
			setGlobalEval( tmp );
		}

		// Capture executables
		if ( scripts ) {
			j = 0;
			while ( ( elem = tmp[ j++ ] ) ) {
				if ( rscriptType.test( elem.type || "" ) ) {
					scripts.push( elem );
				}
			}
		}
	}

	return fragment;
}


( function() {
	var fragment = document.createDocumentFragment(),
		div = fragment.appendChild( document.createElement( "div" ) ),
		input = document.createElement( "input" );

	// Support: Android 4.0 - 4.3 only
	// Check state lost if the name is set (#11217)
	// Support: Windows Web Apps (WWA)
	// `name` and `type` must use .setAttribute for WWA (#14901)
	input.setAttribute( "type", "radio" );
	input.setAttribute( "checked", "checked" );
	input.setAttribute( "name", "t" );

	div.appendChild( input );

	// Support: Android <=4.1 only
	// Older WebKit doesn't clone checked state correctly in fragments
	support.checkClone = div.cloneNode( true ).cloneNode( true ).lastChild.checked;

	// Support: IE <=11 only
	// Make sure textarea (and checkbox) defaultValue is properly cloned
	div.innerHTML = "<textarea>x</textarea>";
	support.noCloneChecked = !!div.cloneNode( true ).lastChild.defaultValue;
} )();
var documentElement = document.documentElement;



var
	rkeyEvent = /^key/,
	rmouseEvent = /^(?:mouse|pointer|contextmenu|drag|drop)|click/,
	rtypenamespace = /^([^.]*)(?:\.(.+)|)/;

function returnTrue() {
	return true;
}

function returnFalse() {
	return false;
}

// Support: IE <=9 only
// See #13393 for more info
function safeActiveElement() {
	try {
		return document.activeElement;
	} catch ( err ) { }
}

function on( elem, types, selector, data, fn, one ) {
	var origFn, type;

	// Types can be a map of types/handlers
	if ( typeof types === "object" ) {

		// ( types-Object, selector, data )
		if ( typeof selector !== "string" ) {

			// ( types-Object, data )
			data = data || selector;
			selector = undefined;
		}
		for ( type in types ) {
			on( elem, type, selector, data, types[ type ], one );
		}
		return elem;
	}

	if ( data == null && fn == null ) {

		// ( types, fn )
		fn = selector;
		data = selector = undefined;
	} else if ( fn == null ) {
		if ( typeof selector === "string" ) {

			// ( types, selector, fn )
			fn = data;
			data = undefined;
		} else {

			// ( types, data, fn )
			fn = data;
			data = selector;
			selector = undefined;
		}
	}
	if ( fn === false ) {
		fn = returnFalse;
	} else if ( !fn ) {
		return elem;
	}

	if ( one === 1 ) {
		origFn = fn;
		fn = function( event ) {

			// Can use an empty set, since event contains the info
			jQuery().off( event );
			return origFn.apply( this, arguments );
		};

		// Use same guid so caller can remove using origFn
		fn.guid = origFn.guid || ( origFn.guid = jQuery.guid++ );
	}
	return elem.each( function() {
		jQuery.event.add( this, types, fn, data, selector );
	} );
}

/*
 * Helper functions for managing events -- not part of the public interface.
 * Props to Dean Edwards' addEvent library for many of the ideas.
 */
jQuery.event = {

	global: {},

	add: function( elem, types, handler, data, selector ) {

		var handleObjIn, eventHandle, tmp,
			events, t, handleObj,
			special, handlers, type, namespaces, origType,
			elemData = dataPriv.get( elem );

		// Don't attach events to noData or text/comment nodes (but allow plain objects)
		if ( !elemData ) {
			return;
		}

		// Caller can pass in an object of custom data in lieu of the handler
		if ( handler.handler ) {
			handleObjIn = handler;
			handler = handleObjIn.handler;
			selector = handleObjIn.selector;
		}

		// Ensure that invalid selectors throw exceptions at attach time
		// Evaluate against documentElement in case elem is a non-element node (e.g., document)
		if ( selector ) {
			jQuery.find.matchesSelector( documentElement, selector );
		}

		// Make sure that the handler has a unique ID, used to find/remove it later
		if ( !handler.guid ) {
			handler.guid = jQuery.guid++;
		}

		// Init the element's event structure and main handler, if this is the first
		if ( !( events = elemData.events ) ) {
			events = elemData.events = {};
		}
		if ( !( eventHandle = elemData.handle ) ) {
			eventHandle = elemData.handle = function( e ) {

				// Discard the second event of a jQuery.event.trigger() and
				// when an event is called after a page has unloaded
				return typeof jQuery !== "undefined" && jQuery.event.triggered !== e.type ?
					jQuery.event.dispatch.apply( elem, arguments ) : undefined;
			};
		}

		// Handle multiple events separated by a space
		types = ( types || "" ).match( rnothtmlwhite ) || [ "" ];
		t = types.length;
		while ( t-- ) {
			tmp = rtypenamespace.exec( types[ t ] ) || [];
			type = origType = tmp[ 1 ];
			namespaces = ( tmp[ 2 ] || "" ).split( "." ).sort();

			// There *must* be a type, no attaching namespace-only handlers
			if ( !type ) {
				continue;
			}

			// If event changes its type, use the special event handlers for the changed type
			special = jQuery.event.special[ type ] || {};

			// If selector defined, determine special event api type, otherwise given type
			type = ( selector ? special.delegateType : special.bindType ) || type;

			// Update special based on newly reset type
			special = jQuery.event.special[ type ] || {};

			// handleObj is passed to all event handlers
			handleObj = jQuery.extend( {
				type: type,
				origType: origType,
				data: data,
				handler: handler,
				guid: handler.guid,
				selector: selector,
				needsContext: selector && jQuery.expr.match.needsContext.test( selector ),
				namespace: namespaces.join( "." )
			}, handleObjIn );

			// Init the event handler queue if we're the first
			if ( !( handlers = events[ type ] ) ) {
				handlers = events[ type ] = [];
				handlers.delegateCount = 0;

				// Only use addEventListener if the special events handler returns false
				if ( !special.setup ||
					special.setup.call( elem, data, namespaces, eventHandle ) === false ) {

					if ( elem.addEventListener ) {
						elem.addEventListener( type, eventHandle );
					}
				}
			}

			if ( special.add ) {
				special.add.call( elem, handleObj );

				if ( !handleObj.handler.guid ) {
					handleObj.handler.guid = handler.guid;
				}
			}

			// Add to the element's handler list, delegates in front
			if ( selector ) {
				handlers.splice( handlers.delegateCount++, 0, handleObj );
			} else {
				handlers.push( handleObj );
			}

			// Keep track of which events have ever been used, for event optimization
			jQuery.event.global[ type ] = true;
		}

	},

	// Detach an event or set of events from an element
	remove: function( elem, types, handler, selector, mappedTypes ) {

		var j, origCount, tmp,
			events, t, handleObj,
			special, handlers, type, namespaces, origType,
			elemData = dataPriv.hasData( elem ) && dataPriv.get( elem );

		if ( !elemData || !( events = elemData.events ) ) {
			return;
		}

		// Once for each type.namespace in types; type may be omitted
		types = ( types || "" ).match( rnothtmlwhite ) || [ "" ];
		t = types.length;
		while ( t-- ) {
			tmp = rtypenamespace.exec( types[ t ] ) || [];
			type = origType = tmp[ 1 ];
			namespaces = ( tmp[ 2 ] || "" ).split( "." ).sort();

			// Unbind all events (on this namespace, if provided) for the element
			if ( !type ) {
				for ( type in events ) {
					jQuery.event.remove( elem, type + types[ t ], handler, selector, true );
				}
				continue;
			}

			special = jQuery.event.special[ type ] || {};
			type = ( selector ? special.delegateType : special.bindType ) || type;
			handlers = events[ type ] || [];
			tmp = tmp[ 2 ] &&
				new RegExp( "(^|\\.)" + namespaces.join( "\\.(?:.*\\.|)" ) + "(\\.|$)" );

			// Remove matching events
			origCount = j = handlers.length;
			while ( j-- ) {
				handleObj = handlers[ j ];

				if ( ( mappedTypes || origType === handleObj.origType ) &&
					( !handler || handler.guid === handleObj.guid ) &&
					( !tmp || tmp.test( handleObj.namespace ) ) &&
					( !selector || selector === handleObj.selector ||
						selector === "**" && handleObj.selector ) ) {
					handlers.splice( j, 1 );

					if ( handleObj.selector ) {
						handlers.delegateCount--;
					}
					if ( special.remove ) {
						special.remove.call( elem, handleObj );
					}
				}
			}

			// Remove generic event handler if we removed something and no more handlers exist
			// (avoids potential for endless recursion during removal of special event handlers)
			if ( origCount && !handlers.length ) {
				if ( !special.teardown ||
					special.teardown.call( elem, namespaces, elemData.handle ) === false ) {

					jQuery.removeEvent( elem, type, elemData.handle );
				}

				delete events[ type ];
			}
		}

		// Remove data and the expando if it's no longer used
		if ( jQuery.isEmptyObject( events ) ) {
			dataPriv.remove( elem, "handle events" );
		}
	},

	dispatch: function( nativeEvent ) {

		// Make a writable jQuery.Event from the native event object
		var event = jQuery.event.fix( nativeEvent );

		var i, j, ret, matched, handleObj, handlerQueue,
			args = new Array( arguments.length ),
			handlers = ( dataPriv.get( this, "events" ) || {} )[ event.type ] || [],
			special = jQuery.event.special[ event.type ] || {};

		// Use the fix-ed jQuery.Event rather than the (read-only) native event
		args[ 0 ] = event;

		for ( i = 1; i < arguments.length; i++ ) {
			args[ i ] = arguments[ i ];
		}

		event.delegateTarget = this;

		// Call the preDispatch hook for the mapped type, and let it bail if desired
		if ( special.preDispatch && special.preDispatch.call( this, event ) === false ) {
			return;
		}

		// Determine handlers
		handlerQueue = jQuery.event.handlers.call( this, event, handlers );

		// Run delegates first; they may want to stop propagation beneath us
		i = 0;
		while ( ( matched = handlerQueue[ i++ ] ) && !event.isPropagationStopped() ) {
			event.currentTarget = matched.elem;

			j = 0;
			while ( ( handleObj = matched.handlers[ j++ ] ) &&
				!event.isImmediatePropagationStopped() ) {

				// Triggered event must either 1) have no namespace, or 2) have namespace(s)
				// a subset or equal to those in the bound event (both can have no namespace).
				if ( !event.rnamespace || event.rnamespace.test( handleObj.namespace ) ) {

					event.handleObj = handleObj;
					event.data = handleObj.data;

					ret = ( ( jQuery.event.special[ handleObj.origType ] || {} ).handle ||
						handleObj.handler ).apply( matched.elem, args );

					if ( ret !== undefined ) {
						if ( ( event.result = ret ) === false ) {
							event.preventDefault();
							event.stopPropagation();
						}
					}
				}
			}
		}

		// Call the postDispatch hook for the mapped type
		if ( special.postDispatch ) {
			special.postDispatch.call( this, event );
		}

		return event.result;
	},

	handlers: function( event, handlers ) {
		var i, handleObj, sel, matchedHandlers, matchedSelectors,
			handlerQueue = [],
			delegateCount = handlers.delegateCount,
			cur = event.target;

		// Find delegate handlers
		if ( delegateCount &&

			// Support: IE <=9
			// Black-hole SVG <use> instance trees (trac-13180)
			cur.nodeType &&

			// Support: Firefox <=42
			// Suppress spec-violating clicks indicating a non-primary pointer button (trac-3861)
			// https://www.w3.org/TR/DOM-Level-3-Events/#event-type-click
			// Support: IE 11 only
			// ...but not arrow key "clicks" of radio inputs, which can have `button` -1 (gh-2343)
			!( event.type === "click" && event.button >= 1 ) ) {

			for ( ; cur !== this; cur = cur.parentNode || this ) {

				// Don't check non-elements (#13208)
				// Don't process clicks on disabled elements (#6911, #8165, #11382, #11764)
				if ( cur.nodeType === 1 && !( event.type === "click" && cur.disabled === true ) ) {
					matchedHandlers = [];
					matchedSelectors = {};
					for ( i = 0; i < delegateCount; i++ ) {
						handleObj = handlers[ i ];

						// Don't conflict with Object.prototype properties (#13203)
						sel = handleObj.selector + " ";

						if ( matchedSelectors[ sel ] === undefined ) {
							matchedSelectors[ sel ] = handleObj.needsContext ?
								jQuery( sel, this ).index( cur ) > -1 :
								jQuery.find( sel, this, null, [ cur ] ).length;
						}
						if ( matchedSelectors[ sel ] ) {
							matchedHandlers.push( handleObj );
						}
					}
					if ( matchedHandlers.length ) {
						handlerQueue.push( { elem: cur, handlers: matchedHandlers } );
					}
				}
			}
		}

		// Add the remaining (directly-bound) handlers
		cur = this;
		if ( delegateCount < handlers.length ) {
			handlerQueue.push( { elem: cur, handlers: handlers.slice( delegateCount ) } );
		}

		return handlerQueue;
	},

	addProp: function( name, hook ) {
		Object.defineProperty( jQuery.Event.prototype, name, {
			enumerable: true,
			configurable: true,

			get: jQuery.isFunction( hook ) ?
				function() {
					if ( this.originalEvent ) {
							return hook( this.originalEvent );
					}
				} :
				function() {
					if ( this.originalEvent ) {
							return this.originalEvent[ name ];
					}
				},

			set: function( value ) {
				Object.defineProperty( this, name, {
					enumerable: true,
					configurable: true,
					writable: true,
					value: value
				} );
			}
		} );
	},

	fix: function( originalEvent ) {
		return originalEvent[ jQuery.expando ] ?
			originalEvent :
			new jQuery.Event( originalEvent );
	},

	special: {
		load: {

			// Prevent triggered image.load events from bubbling to window.load
			noBubble: true
		},
		focus: {

			// Fire native event if possible so blur/focus sequence is correct
			trigger: function() {
				if ( this !== safeActiveElement() && this.focus ) {
					this.focus();
					return false;
				}
			},
			delegateType: "focusin"
		},
		blur: {
			trigger: function() {
				if ( this === safeActiveElement() && this.blur ) {
					this.blur();
					return false;
				}
			},
			delegateType: "focusout"
		},
		click: {

			// For checkbox, fire native event so checked state will be right
			trigger: function() {
				if ( this.type === "checkbox" && this.click && jQuery.nodeName( this, "input" ) ) {
					this.click();
					return false;
				}
			},

			// For cross-browser consistency, don't fire native .click() on links
			_default: function( event ) {
				return jQuery.nodeName( event.target, "a" );
			}
		},

		beforeunload: {
			postDispatch: function( event ) {

				// Support: Firefox 20+
				// Firefox doesn't alert if the returnValue field is not set.
				if ( event.result !== undefined && event.originalEvent ) {
					event.originalEvent.returnValue = event.result;
				}
			}
		}
	}
};

jQuery.removeEvent = function( elem, type, handle ) {

	// This "if" is needed for plain objects
	if ( elem.removeEventListener ) {
		elem.removeEventListener( type, handle );
	}
};

jQuery.Event = function( src, props ) {

	// Allow instantiation without the 'new' keyword
	if ( !( this instanceof jQuery.Event ) ) {
		return new jQuery.Event( src, props );
	}

	// Event object
	if ( src && src.type ) {
		this.originalEvent = src;
		this.type = src.type;

		// Events bubbling up the document may have been marked as prevented
		// by a handler lower down the tree; reflect the correct value.
		this.isDefaultPrevented = src.defaultPrevented ||
				src.defaultPrevented === undefined &&

				// Support: Android <=2.3 only
				src.returnValue === false ?
			returnTrue :
			returnFalse;

		// Create target properties
		// Support: Safari <=6 - 7 only
		// Target should not be a text node (#504, #13143)
		this.target = ( src.target && src.target.nodeType === 3 ) ?
			src.target.parentNode :
			src.target;

		this.currentTarget = src.currentTarget;
		this.relatedTarget = src.relatedTarget;

	// Event type
	} else {
		this.type = src;
	}

	// Put explicitly provided properties onto the event object
	if ( props ) {
		jQuery.extend( this, props );
	}

	// Create a timestamp if incoming event doesn't have one
	this.timeStamp = src && src.timeStamp || jQuery.now();

	// Mark it as fixed
	this[ jQuery.expando ] = true;
};

// jQuery.Event is based on DOM3 Events as specified by the ECMAScript Language Binding
// https://www.w3.org/TR/2003/WD-DOM-Level-3-Events-20030331/ecma-script-binding.html
jQuery.Event.prototype = {
	constructor: jQuery.Event,
	isDefaultPrevented: returnFalse,
	isPropagationStopped: returnFalse,
	isImmediatePropagationStopped: returnFalse,
	isSimulated: false,

	preventDefault: function() {
		var e = this.originalEvent;

		this.isDefaultPrevented = returnTrue;

		if ( e && !this.isSimulated ) {
			e.preventDefault();
		}
	},
	stopPropagation: function() {
		var e = this.originalEvent;

		this.isPropagationStopped = returnTrue;

		if ( e && !this.isSimulated ) {
			e.stopPropagation();
		}
	},
	stopImmediatePropagation: function() {
		var e = this.originalEvent;

		this.isImmediatePropagationStopped = returnTrue;

		if ( e && !this.isSimulated ) {
			e.stopImmediatePropagation();
		}

		this.stopPropagation();
	}
};

// Includes all common event props including KeyEvent and MouseEvent specific props
jQuery.each( {
	altKey: true,
	bubbles: true,
	cancelable: true,
	changedTouches: true,
	ctrlKey: true,
	detail: true,
	eventPhase: true,
	metaKey: true,
	pageX: true,
	pageY: true,
	shiftKey: true,
	view: true,
	"char": true,
	charCode: true,
	key: true,
	keyCode: true,
	button: true,
	buttons: true,
	clientX: true,
	clientY: true,
	offsetX: true,
	offsetY: true,
	pointerId: true,
	pointerType: true,
	screenX: true,
	screenY: true,
	targetTouches: true,
	toElement: true,
	touches: true,

	which: function( event ) {
		var button = event.button;

		// Add which for key events
		if ( event.which == null && rkeyEvent.test( event.type ) ) {
			return event.charCode != null ? event.charCode : event.keyCode;
		}

		// Add which for click: 1 === left; 2 === middle; 3 === right
		if ( !event.which && button !== undefined && rmouseEvent.test( event.type ) ) {
			if ( button & 1 ) {
				return 1;
			}

			if ( button & 2 ) {
				return 3;
			}

			if ( button & 4 ) {
				return 2;
			}

			return 0;
		}

		return event.which;
	}
}, jQuery.event.addProp );

// Create mouseenter/leave events using mouseover/out and event-time checks
// so that event delegation works in jQuery.
// Do the same for pointerenter/pointerleave and pointerover/pointerout
//
// Support: Safari 7 only
// Safari sends mouseenter too often; see:
// https://bugs.chromium.org/p/chromium/issues/detail?id=470258
// for the description of the bug (it existed in older Chrome versions as well).
jQuery.each( {
	mouseenter: "mouseover",
	mouseleave: "mouseout",
	pointerenter: "pointerover",
	pointerleave: "pointerout"
}, function( orig, fix ) {
	jQuery.event.special[ orig ] = {
		delegateType: fix,
		bindType: fix,

		handle: function( event ) {
			var ret,
				target = this,
				related = event.relatedTarget,
				handleObj = event.handleObj;

			// For mouseenter/leave call the handler if related is outside the target.
			// NB: No relatedTarget if the mouse left/entered the browser window
			if ( !related || ( related !== target && !jQuery.contains( target, related ) ) ) {
				event.type = handleObj.origType;
				ret = handleObj.handler.apply( this, arguments );
				event.type = fix;
			}
			return ret;
		}
	};
} );

jQuery.fn.extend( {

	on: function( types, selector, data, fn ) {
		return on( this, types, selector, data, fn );
	},
	one: function( types, selector, data, fn ) {
		return on( this, types, selector, data, fn, 1 );
	},
	off: function( types, selector, fn ) {
		var handleObj, type;
		if ( types && types.preventDefault && types.handleObj ) {

			// ( event )  dispatched jQuery.Event
			handleObj = types.handleObj;
			jQuery( types.delegateTarget ).off(
				handleObj.namespace ?
					handleObj.origType + "." + handleObj.namespace :
					handleObj.origType,
				handleObj.selector,
				handleObj.handler
			);
			return this;
		}
		if ( typeof types === "object" ) {

			// ( types-object [, selector] )
			for ( type in types ) {
				this.off( type, selector, types[ type ] );
			}
			return this;
		}
		if ( selector === false || typeof selector === "function" ) {

			// ( types [, fn] )
			fn = selector;
			selector = undefined;
		}
		if ( fn === false ) {
			fn = returnFalse;
		}
		return this.each( function() {
			jQuery.event.remove( this, types, fn, selector );
		} );
	}
} );


var

	/* eslint-disable max-len */

	// See https://github.com/eslint/eslint/issues/3229
	rxhtmlTag = /<(?!area|br|col|embed|hr|img|input|link|meta|param)(([a-z][^\/\0>\x20\t\r\n\f]*)[^>]*)\/>/gi,

	/* eslint-enable */

	// Support: IE <=10 - 11, Edge 12 - 13
	// In IE/Edge using regex groups here causes severe slowdowns.
	// See https://connect.microsoft.com/IE/feedback/details/1736512/
	rnoInnerhtml = /<script|<style|<link/i,

	// checked="checked" or checked
	rchecked = /checked\s*(?:[^=]|=\s*.checked.)/i,
	rscriptTypeMasked = /^true\/(.*)/,
	rcleanScript = /^\s*<!(?:\[CDATA\[|--)|(?:\]\]|--)>\s*$/g;

function manipulationTarget( elem, content ) {
	if ( jQuery.nodeName( elem, "table" ) &&
		jQuery.nodeName( content.nodeType !== 11 ? content : content.firstChild, "tr" ) ) {

		return elem.getElementsByTagName( "tbody" )[ 0 ] || elem;
	}

	return elem;
}

// Replace/restore the type attribute of script elements for safe DOM manipulation
function disableScript( elem ) {
	elem.type = ( elem.getAttribute( "type" ) !== null ) + "/" + elem.type;
	return elem;
}
function restoreScript( elem ) {
	var match = rscriptTypeMasked.exec( elem.type );

	if ( match ) {
		elem.type = match[ 1 ];
	} else {
		elem.removeAttribute( "type" );
	}

	return elem;
}

function cloneCopyEvent( src, dest ) {
	var i, l, type, pdataOld, pdataCur, udataOld, udataCur, events;

	if ( dest.nodeType !== 1 ) {
		return;
	}

	// 1. Copy private data: events, handlers, etc.
	if ( dataPriv.hasData( src ) ) {
		pdataOld = dataPriv.access( src );
		pdataCur = dataPriv.set( dest, pdataOld );
		events = pdataOld.events;

		if ( events ) {
			delete pdataCur.handle;
			pdataCur.events = {};

			for ( type in events ) {
				for ( i = 0, l = events[ type ].length; i < l; i++ ) {
					jQuery.event.add( dest, type, events[ type ][ i ] );
				}
			}
		}
	}

	// 2. Copy user data
	if ( dataUser.hasData( src ) ) {
		udataOld = dataUser.access( src );
		udataCur = jQuery.extend( {}, udataOld );

		dataUser.set( dest, udataCur );
	}
}

// Fix IE bugs, see support tests
function fixInput( src, dest ) {
	var nodeName = dest.nodeName.toLowerCase();

	// Fails to persist the checked state of a cloned checkbox or radio button.
	if ( nodeName === "input" && rcheckableType.test( src.type ) ) {
		dest.checked = src.checked;

	// Fails to return the selected option to the default selected state when cloning options
	} else if ( nodeName === "input" || nodeName === "textarea" ) {
		dest.defaultValue = src.defaultValue;
	}
}

function domManip( collection, args, callback, ignored ) {

	// Flatten any nested arrays
	args = concat.apply( [], args );

	var fragment, first, scripts, hasScripts, node, doc,
		i = 0,
		l = collection.length,
		iNoClone = l - 1,
		value = args[ 0 ],
		isFunction = jQuery.isFunction( value );

	// We can't cloneNode fragments that contain checked, in WebKit
	if ( isFunction ||
			( l > 1 && typeof value === "string" &&
				!support.checkClone && rchecked.test( value ) ) ) {
		return collection.each( function( index ) {
			var self = collection.eq( index );
			if ( isFunction ) {
				args[ 0 ] = value.call( this, index, self.html() );
			}
			domManip( self, args, callback, ignored );
		} );
	}

	if ( l ) {
		fragment = buildFragment( args, collection[ 0 ].ownerDocument, false, collection, ignored );
		first = fragment.firstChild;

		if ( fragment.childNodes.length === 1 ) {
			fragment = first;
		}

		// Require either new content or an interest in ignored elements to invoke the callback
		if ( first || ignored ) {
			scripts = jQuery.map( getAll( fragment, "script" ), disableScript );
			hasScripts = scripts.length;

			// Use the original fragment for the last item
			// instead of the first because it can end up
			// being emptied incorrectly in certain situations (#8070).
			for ( ; i < l; i++ ) {
				node = fragment;

				if ( i !== iNoClone ) {
					node = jQuery.clone( node, true, true );

					// Keep references to cloned scripts for later restoration
					if ( hasScripts ) {

						// Support: Android <=4.0 only, PhantomJS 1 only
						// push.apply(_, arraylike) throws on ancient WebKit
						jQuery.merge( scripts, getAll( node, "script" ) );
					}
				}

				callback.call( collection[ i ], node, i );
			}

			if ( hasScripts ) {
				doc = scripts[ scripts.length - 1 ].ownerDocument;

				// Reenable scripts
				jQuery.map( scripts, restoreScript );

				// Evaluate executable scripts on first document insertion
				for ( i = 0; i < hasScripts; i++ ) {
					node = scripts[ i ];
					if ( rscriptType.test( node.type || "" ) &&
						!dataPriv.access( node, "globalEval" ) &&
						jQuery.contains( doc, node ) ) {

						if ( node.src ) {

							// Optional AJAX dependency, but won't run scripts if not present
							if ( jQuery._evalUrl ) {
								jQuery._evalUrl( node.src );
							}
						} else {
							DOMEval( node.textContent.replace( rcleanScript, "" ), doc );
						}
					}
				}
			}
		}
	}

	return collection;
}

function remove( elem, selector, keepData ) {
	var node,
		nodes = selector ? jQuery.filter( selector, elem ) : elem,
		i = 0;

	for ( ; ( node = nodes[ i ] ) != null; i++ ) {
		if ( !keepData && node.nodeType === 1 ) {
			jQuery.cleanData( getAll( node ) );
		}

		if ( node.parentNode ) {
			if ( keepData && jQuery.contains( node.ownerDocument, node ) ) {
				setGlobalEval( getAll( node, "script" ) );
			}
			node.parentNode.removeChild( node );
		}
	}

	return elem;
}

jQuery.extend( {
	htmlPrefilter: function( html ) {
		return html.replace( rxhtmlTag, "<$1></$2>" );
	},

	clone: function( elem, dataAndEvents, deepDataAndEvents ) {
		var i, l, srcElements, destElements,
			clone = elem.cloneNode( true ),
			inPage = jQuery.contains( elem.ownerDocument, elem );

		// Fix IE cloning issues
		if ( !support.noCloneChecked && ( elem.nodeType === 1 || elem.nodeType === 11 ) &&
				!jQuery.isXMLDoc( elem ) ) {

			// We eschew Sizzle here for performance reasons: https://jsperf.com/getall-vs-sizzle/2
			destElements = getAll( clone );
			srcElements = getAll( elem );

			for ( i = 0, l = srcElements.length; i < l; i++ ) {
				fixInput( srcElements[ i ], destElements[ i ] );
			}
		}

		// Copy the events from the original to the clone
		if ( dataAndEvents ) {
			if ( deepDataAndEvents ) {
				srcElements = srcElements || getAll( elem );
				destElements = destElements || getAll( clone );

				for ( i = 0, l = srcElements.length; i < l; i++ ) {
					cloneCopyEvent( srcElements[ i ], destElements[ i ] );
				}
			} else {
				cloneCopyEvent( elem, clone );
			}
		}

		// Preserve script evaluation history
		destElements = getAll( clone, "script" );
		if ( destElements.length > 0 ) {
			setGlobalEval( destElements, !inPage && getAll( elem, "script" ) );
		}

		// Return the cloned set
		return clone;
	},

	cleanData: function( elems ) {
		var data, elem, type,
			special = jQuery.event.special,
			i = 0;

		for ( ; ( elem = elems[ i ] ) !== undefined; i++ ) {
			if ( acceptData( elem ) ) {
				if ( ( data = elem[ dataPriv.expando ] ) ) {
					if ( data.events ) {
						for ( type in data.events ) {
							if ( special[ type ] ) {
								jQuery.event.remove( elem, type );

							// This is a shortcut to avoid jQuery.event.remove's overhead
							} else {
								jQuery.removeEvent( elem, type, data.handle );
							}
						}
					}

					// Support: Chrome <=35 - 45+
					// Assign undefined instead of using delete, see Data#remove
					elem[ dataPriv.expando ] = undefined;
				}
				if ( elem[ dataUser.expando ] ) {

					// Support: Chrome <=35 - 45+
					// Assign undefined instead of using delete, see Data#remove
					elem[ dataUser.expando ] = undefined;
				}
			}
		}
	}
} );

jQuery.fn.extend( {
	detach: function( selector ) {
		return remove( this, selector, true );
	},

	remove: function( selector ) {
		return remove( this, selector );
	},

	text: function( value ) {
		return access( this, function( value ) {
			return value === undefined ?
				jQuery.text( this ) :
				this.empty().each( function() {
					if ( this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9 ) {
						this.textContent = value;
					}
				} );
		}, null, value, arguments.length );
	},

	append: function() {
		return domManip( this, arguments, function( elem ) {
			if ( this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9 ) {
				var target = manipulationTarget( this, elem );
				target.appendChild( elem );
			}
		} );
	},

	prepend: function() {
		return domManip( this, arguments, function( elem ) {
			if ( this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9 ) {
				var target = manipulationTarget( this, elem );
				target.insertBefore( elem, target.firstChild );
			}
		} );
	},

	before: function() {
		return domManip( this, arguments, function( elem ) {
			if ( this.parentNode ) {
				this.parentNode.insertBefore( elem, this );
			}
		} );
	},

	after: function() {
		return domManip( this, arguments, function( elem ) {
			if ( this.parentNode ) {
				this.parentNode.insertBefore( elem, this.nextSibling );
			}
		} );
	},

	empty: function() {
		var elem,
			i = 0;

		for ( ; ( elem = this[ i ] ) != null; i++ ) {
			if ( elem.nodeType === 1 ) {

				// Prevent memory leaks
				jQuery.cleanData( getAll( elem, false ) );

				// Remove any remaining nodes
				elem.textContent = "";
			}
		}

		return this;
	},

	clone: function( dataAndEvents, deepDataAndEvents ) {
		dataAndEvents = dataAndEvents == null ? false : dataAndEvents;
		deepDataAndEvents = deepDataAndEvents == null ? dataAndEvents : deepDataAndEvents;

		return this.map( function() {
			return jQuery.clone( this, dataAndEvents, deepDataAndEvents );
		} );
	},

	html: function( value ) {
		return access( this, function( value ) {
			var elem = this[ 0 ] || {},
				i = 0,
				l = this.length;

			if ( value === undefined && elem.nodeType === 1 ) {
				return elem.innerHTML;
			}

			// See if we can take a shortcut and just use innerHTML
			if ( typeof value === "string" && !rnoInnerhtml.test( value ) &&
				!wrapMap[ ( rtagName.exec( value ) || [ "", "" ] )[ 1 ].toLowerCase() ] ) {

				value = jQuery.htmlPrefilter( value );

				try {
					for ( ; i < l; i++ ) {
						elem = this[ i ] || {};

						// Remove element nodes and prevent memory leaks
						if ( elem.nodeType === 1 ) {
							jQuery.cleanData( getAll( elem, false ) );
							elem.innerHTML = value;
						}
					}

					elem = 0;

				// If using innerHTML throws an exception, use the fallback method
				} catch ( e ) {}
			}

			if ( elem ) {
				this.empty().append( value );
			}
		}, null, value, arguments.length );
	},

	replaceWith: function() {
		var ignored = [];

		// Make the changes, replacing each non-ignored context element with the new content
		return domManip( this, arguments, function( elem ) {
			var parent = this.parentNode;

			if ( jQuery.inArray( this, ignored ) < 0 ) {
				jQuery.cleanData( getAll( this ) );
				if ( parent ) {
					parent.replaceChild( elem, this );
				}
			}

		// Force callback invocation
		}, ignored );
	}
} );

jQuery.each( {
	appendTo: "append",
	prependTo: "prepend",
	insertBefore: "before",
	insertAfter: "after",
	replaceAll: "replaceWith"
}, function( name, original ) {
	jQuery.fn[ name ] = function( selector ) {
		var elems,
			ret = [],
			insert = jQuery( selector ),
			last = insert.length - 1,
			i = 0;

		for ( ; i <= last; i++ ) {
			elems = i === last ? this : this.clone( true );
			jQuery( insert[ i ] )[ original ]( elems );

			// Support: Android <=4.0 only, PhantomJS 1 only
			// .get() because push.apply(_, arraylike) throws on ancient WebKit
			push.apply( ret, elems.get() );
		}

		return this.pushStack( ret );
	};
} );
var rmargin = ( /^margin/ );

var rnumnonpx = new RegExp( "^(" + pnum + ")(?!px)[a-z%]+$", "i" );

var getStyles = function( elem ) {

		// Support: IE <=11 only, Firefox <=30 (#15098, #14150)
		// IE throws on elements created in popups
		// FF meanwhile throws on frame elements through "defaultView.getComputedStyle"
		var view = elem.ownerDocument.defaultView;

		if ( !view || !view.opener ) {
			view = window;
		}

		return view.getComputedStyle( elem );
	};



( function() {

	// Executing both pixelPosition & boxSizingReliable tests require only one layout
	// so they're executed at the same time to save the second computation.
	function computeStyleTests() {

		// This is a singleton, we need to execute it only once
		if ( !div ) {
			return;
		}

		div.style.cssText =
			"box-sizing:border-box;" +
			"position:relative;display:block;" +
			"margin:auto;border:1px;padding:1px;" +
			"top:1%;width:50%";
		div.innerHTML = "";
		documentElement.appendChild( container );

		var divStyle = window.getComputedStyle( div );
		pixelPositionVal = divStyle.top !== "1%";

		// Support: Android 4.0 - 4.3 only, Firefox <=3 - 44
		reliableMarginLeftVal = divStyle.marginLeft === "2px";
		boxSizingReliableVal = divStyle.width === "4px";

		// Support: Android 4.0 - 4.3 only
		// Some styles come back with percentage values, even though they shouldn't
		div.style.marginRight = "50%";
		pixelMarginRightVal = divStyle.marginRight === "4px";

		documentElement.removeChild( container );

		// Nullify the div so it wouldn't be stored in the memory and
		// it will also be a sign that checks already performed
		div = null;
	}

	var pixelPositionVal, boxSizingReliableVal, pixelMarginRightVal, reliableMarginLeftVal,
		container = document.createElement( "div" ),
		div = document.createElement( "div" );

	// Finish early in limited (non-browser) environments
	if ( !div.style ) {
		return;
	}

	// Support: IE <=9 - 11 only
	// Style of cloned element affects source element cloned (#8908)
	div.style.backgroundClip = "content-box";
	div.cloneNode( true ).style.backgroundClip = "";
	support.clearCloneStyle = div.style.backgroundClip === "content-box";

	container.style.cssText = "border:0;width:8px;height:0;top:0;left:-9999px;" +
		"padding:0;margin-top:1px;position:absolute";
	container.appendChild( div );

	jQuery.extend( support, {
		pixelPosition: function() {
			computeStyleTests();
			return pixelPositionVal;
		},
		boxSizingReliable: function() {
			computeStyleTests();
			return boxSizingReliableVal;
		},
		pixelMarginRight: function() {
			computeStyleTests();
			return pixelMarginRightVal;
		},
		reliableMarginLeft: function() {
			computeStyleTests();
			return reliableMarginLeftVal;
		}
	} );
} )();


function curCSS( elem, name, computed ) {
	var width, minWidth, maxWidth, ret,
		style = elem.style;

	computed = computed || getStyles( elem );

	// Support: IE <=9 only
	// getPropertyValue is only needed for .css('filter') (#12537)
	if ( computed ) {
		ret = computed.getPropertyValue( name ) || computed[ name ];

		if ( ret === "" && !jQuery.contains( elem.ownerDocument, elem ) ) {
			ret = jQuery.style( elem, name );
		}

		// A tribute to the "awesome hack by Dean Edwards"
		// Android Browser returns percentage for some values,
		// but width seems to be reliably pixels.
		// This is against the CSSOM draft spec:
		// https://drafts.csswg.org/cssom/#resolved-values
		if ( !support.pixelMarginRight() && rnumnonpx.test( ret ) && rmargin.test( name ) ) {

			// Remember the original values
			width = style.width;
			minWidth = style.minWidth;
			maxWidth = style.maxWidth;

			// Put in the new values to get a computed value out
			style.minWidth = style.maxWidth = style.width = ret;
			ret = computed.width;

			// Revert the changed values
			style.width = width;
			style.minWidth = minWidth;
			style.maxWidth = maxWidth;
		}
	}

	return ret !== undefined ?

		// Support: IE <=9 - 11 only
		// IE returns zIndex value as an integer.
		ret + "" :
		ret;
}


function addGetHookIf( conditionFn, hookFn ) {

	// Define the hook, we'll check on the first run if it's really needed.
	return {
		get: function() {
			if ( conditionFn() ) {

				// Hook not needed (or it's not possible to use it due
				// to missing dependency), remove it.
				delete this.get;
				return;
			}

			// Hook needed; redefine it so that the support test is not executed again.
			return ( this.get = hookFn ).apply( this, arguments );
		}
	};
}


var

	// Swappable if display is none or starts with table
	// except "table", "table-cell", or "table-caption"
	// See here for display values: https://developer.mozilla.org/en-US/docs/CSS/display
	rdisplayswap = /^(none|table(?!-c[ea]).+)/,
	cssShow = { position: "absolute", visibility: "hidden", display: "block" },
	cssNormalTransform = {
		letterSpacing: "0",
		fontWeight: "400"
	},

	cssPrefixes = [ "Webkit", "Moz", "ms" ],
	emptyStyle = document.createElement( "div" ).style;

// Return a css property mapped to a potentially vendor prefixed property
function vendorPropName( name ) {

	// Shortcut for names that are not vendor prefixed
	if ( name in emptyStyle ) {
		return name;
	}

	// Check for vendor prefixed names
	var capName = name[ 0 ].toUpperCase() + name.slice( 1 ),
		i = cssPrefixes.length;

	while ( i-- ) {
		name = cssPrefixes[ i ] + capName;
		if ( name in emptyStyle ) {
			return name;
		}
	}
}

function setPositiveNumber( elem, value, subtract ) {

	// Any relative (+/-) values have already been
	// normalized at this point
	var matches = rcssNum.exec( value );
	return matches ?

		// Guard against undefined "subtract", e.g., when used as in cssHooks
		Math.max( 0, matches[ 2 ] - ( subtract || 0 ) ) + ( matches[ 3 ] || "px" ) :
		value;
}

function augmentWidthOrHeight( elem, name, extra, isBorderBox, styles ) {
	var i,
		val = 0;

	// If we already have the right measurement, avoid augmentation
	if ( extra === ( isBorderBox ? "border" : "content" ) ) {
		i = 4;

	// Otherwise initialize for horizontal or vertical properties
	} else {
		i = name === "width" ? 1 : 0;
	}

	for ( ; i < 4; i += 2 ) {

		// Both box models exclude margin, so add it if we want it
		if ( extra === "margin" ) {
			val += jQuery.css( elem, extra + cssExpand[ i ], true, styles );
		}

		if ( isBorderBox ) {

			// border-box includes padding, so remove it if we want content
			if ( extra === "content" ) {
				val -= jQuery.css( elem, "padding" + cssExpand[ i ], true, styles );
			}

			// At this point, extra isn't border nor margin, so remove border
			if ( extra !== "margin" ) {
				val -= jQuery.css( elem, "border" + cssExpand[ i ] + "Width", true, styles );
			}
		} else {

			// At this point, extra isn't content, so add padding
			val += jQuery.css( elem, "padding" + cssExpand[ i ], true, styles );

			// At this point, extra isn't content nor padding, so add border
			if ( extra !== "padding" ) {
				val += jQuery.css( elem, "border" + cssExpand[ i ] + "Width", true, styles );
			}
		}
	}

	return val;
}

function getWidthOrHeight( elem, name, extra ) {

	// Start with offset property, which is equivalent to the border-box value
	var val,
		valueIsBorderBox = true,
		styles = getStyles( elem ),
		isBorderBox = jQuery.css( elem, "boxSizing", false, styles ) === "border-box";

	// Support: IE <=11 only
	// Running getBoundingClientRect on a disconnected node
	// in IE throws an error.
	if ( elem.getClientRects().length ) {
		val = elem.getBoundingClientRect()[ name ];
	}

	// Some non-html elements return undefined for offsetWidth, so check for null/undefined
	// svg - https://bugzilla.mozilla.org/show_bug.cgi?id=649285
	// MathML - https://bugzilla.mozilla.org/show_bug.cgi?id=491668
	if ( val <= 0 || val == null ) {

		// Fall back to computed then uncomputed css if necessary
		val = curCSS( elem, name, styles );
		if ( val < 0 || val == null ) {
			val = elem.style[ name ];
		}

		// Computed unit is not pixels. Stop here and return.
		if ( rnumnonpx.test( val ) ) {
			return val;
		}

		// Check for style in case a browser which returns unreliable values
		// for getComputedStyle silently falls back to the reliable elem.style
		valueIsBorderBox = isBorderBox &&
			( support.boxSizingReliable() || val === elem.style[ name ] );

		// Normalize "", auto, and prepare for extra
		val = parseFloat( val ) || 0;
	}

	// Use the active box-sizing model to add/subtract irrelevant styles
	return ( val +
		augmentWidthOrHeight(
			elem,
			name,
			extra || ( isBorderBox ? "border" : "content" ),
			valueIsBorderBox,
			styles
		)
	) + "px";
}

jQuery.extend( {

	// Add in style property hooks for overriding the default
	// behavior of getting and setting a style property
	cssHooks: {
		opacity: {
			get: function( elem, computed ) {
				if ( computed ) {

					// We should always get a number back from opacity
					var ret = curCSS( elem, "opacity" );
					return ret === "" ? "1" : ret;
				}
			}
		}
	},

	// Don't automatically add "px" to these possibly-unitless properties
	cssNumber: {
		"animationIterationCount": true,
		"columnCount": true,
		"fillOpacity": true,
		"flexGrow": true,
		"flexShrink": true,
		"fontWeight": true,
		"lineHeight": true,
		"opacity": true,
		"order": true,
		"orphans": true,
		"widows": true,
		"zIndex": true,
		"zoom": true
	},

	// Add in properties whose names you wish to fix before
	// setting or getting the value
	cssProps: {
		"float": "cssFloat"
	},

	// Get and set the style property on a DOM Node
	style: function( elem, name, value, extra ) {

		// Don't set styles on text and comment nodes
		if ( !elem || elem.nodeType === 3 || elem.nodeType === 8 || !elem.style ) {
			return;
		}

		// Make sure that we're working with the right name
		var ret, type, hooks,
			origName = jQuery.camelCase( name ),
			style = elem.style;

		name = jQuery.cssProps[ origName ] ||
			( jQuery.cssProps[ origName ] = vendorPropName( origName ) || origName );

		// Gets hook for the prefixed version, then unprefixed version
		hooks = jQuery.cssHooks[ name ] || jQuery.cssHooks[ origName ];

		// Check if we're setting a value
		if ( value !== undefined ) {
			type = typeof value;

			// Convert "+=" or "-=" to relative numbers (#7345)
			if ( type === "string" && ( ret = rcssNum.exec( value ) ) && ret[ 1 ] ) {
				value = adjustCSS( elem, name, ret );

				// Fixes bug #9237
				type = "number";
			}

			// Make sure that null and NaN values aren't set (#7116)
			if ( value == null || value !== value ) {
				return;
			}

			// If a number was passed in, add the unit (except for certain CSS properties)
			if ( type === "number" ) {
				value += ret && ret[ 3 ] || ( jQuery.cssNumber[ origName ] ? "" : "px" );
			}

			// background-* props affect original clone's values
			if ( !support.clearCloneStyle && value === "" && name.indexOf( "background" ) === 0 ) {
				style[ name ] = "inherit";
			}

			// If a hook was provided, use that value, otherwise just set the specified value
			if ( !hooks || !( "set" in hooks ) ||
				( value = hooks.set( elem, value, extra ) ) !== undefined ) {

				style[ name ] = value;
			}

		} else {

			// If a hook was provided get the non-computed value from there
			if ( hooks && "get" in hooks &&
				( ret = hooks.get( elem, false, extra ) ) !== undefined ) {

				return ret;
			}

			// Otherwise just get the value from the style object
			return style[ name ];
		}
	},

	css: function( elem, name, extra, styles ) {
		var val, num, hooks,
			origName = jQuery.camelCase( name );

		// Make sure that we're working with the right name
		name = jQuery.cssProps[ origName ] ||
			( jQuery.cssProps[ origName ] = vendorPropName( origName ) || origName );

		// Try prefixed name followed by the unprefixed name
		hooks = jQuery.cssHooks[ name ] || jQuery.cssHooks[ origName ];

		// If a hook was provided get the computed value from there
		if ( hooks && "get" in hooks ) {
			val = hooks.get( elem, true, extra );
		}

		// Otherwise, if a way to get the computed value exists, use that
		if ( val === undefined ) {
			val = curCSS( elem, name, styles );
		}

		// Convert "normal" to computed value
		if ( val === "normal" && name in cssNormalTransform ) {
			val = cssNormalTransform[ name ];
		}

		// Make numeric if forced or a qualifier was provided and val looks numeric
		if ( extra === "" || extra ) {
			num = parseFloat( val );
			return extra === true || isFinite( num ) ? num || 0 : val;
		}
		return val;
	}
} );

jQuery.each( [ "height", "width" ], function( i, name ) {
	jQuery.cssHooks[ name ] = {
		get: function( elem, computed, extra ) {
			if ( computed ) {

				// Certain elements can have dimension info if we invisibly show them
				// but it must have a current display style that would benefit
				return rdisplayswap.test( jQuery.css( elem, "display" ) ) &&

					// Support: Safari 8+
					// Table columns in Safari have non-zero offsetWidth & zero
					// getBoundingClientRect().width unless display is changed.
					// Support: IE <=11 only
					// Running getBoundingClientRect on a disconnected node
					// in IE throws an error.
					( !elem.getClientRects().length || !elem.getBoundingClientRect().width ) ?
						swap( elem, cssShow, function() {
							return getWidthOrHeight( elem, name, extra );
						} ) :
						getWidthOrHeight( elem, name, extra );
			}
		},

		set: function( elem, value, extra ) {
			var matches,
				styles = extra && getStyles( elem ),
				subtract = extra && augmentWidthOrHeight(
					elem,
					name,
					extra,
					jQuery.css( elem, "boxSizing", false, styles ) === "border-box",
					styles
				);

			// Convert to pixels if value adjustment is needed
			if ( subtract && ( matches = rcssNum.exec( value ) ) &&
				( matches[ 3 ] || "px" ) !== "px" ) {

				elem.style[ name ] = value;
				value = jQuery.css( elem, name );
			}

			return setPositiveNumber( elem, value, subtract );
		}
	};
} );

jQuery.cssHooks.marginLeft = addGetHookIf( support.reliableMarginLeft,
	function( elem, computed ) {
		if ( computed ) {
			return ( parseFloat( curCSS( elem, "marginLeft" ) ) ||
				elem.getBoundingClientRect().left -
					swap( elem, { marginLeft: 0 }, function() {
						return elem.getBoundingClientRect().left;
					} )
				) + "px";
		}
	}
);

// These hooks are used by animate to expand properties
jQuery.each( {
	margin: "",
	padding: "",
	border: "Width"
}, function( prefix, suffix ) {
	jQuery.cssHooks[ prefix + suffix ] = {
		expand: function( value ) {
			var i = 0,
				expanded = {},

				// Assumes a single number if not a string
				parts = typeof value === "string" ? value.split( " " ) : [ value ];

			for ( ; i < 4; i++ ) {
				expanded[ prefix + cssExpand[ i ] + suffix ] =
					parts[ i ] || parts[ i - 2 ] || parts[ 0 ];
			}

			return expanded;
		}
	};

	if ( !rmargin.test( prefix ) ) {
		jQuery.cssHooks[ prefix + suffix ].set = setPositiveNumber;
	}
} );

jQuery.fn.extend( {
	css: function( name, value ) {
		return access( this, function( elem, name, value ) {
			var styles, len,
				map = {},
				i = 0;

			if ( jQuery.isArray( name ) ) {
				styles = getStyles( elem );
				len = name.length;

				for ( ; i < len; i++ ) {
					map[ name[ i ] ] = jQuery.css( elem, name[ i ], false, styles );
				}

				return map;
			}

			return value !== undefined ?
				jQuery.style( elem, name, value ) :
				jQuery.css( elem, name );
		}, name, value, arguments.length > 1 );
	}
} );


function Tween( elem, options, prop, end, easing ) {
	return new Tween.prototype.init( elem, options, prop, end, easing );
}
jQuery.Tween = Tween;

Tween.prototype = {
	constructor: Tween,
	init: function( elem, options, prop, end, easing, unit ) {
		this.elem = elem;
		this.prop = prop;
		this.easing = easing || jQuery.easing._default;
		this.options = options;
		this.start = this.now = this.cur();
		this.end = end;
		this.unit = unit || ( jQuery.cssNumber[ prop ] ? "" : "px" );
	},
	cur: function() {
		var hooks = Tween.propHooks[ this.prop ];

		return hooks && hooks.get ?
			hooks.get( this ) :
			Tween.propHooks._default.get( this );
	},
	run: function( percent ) {
		var eased,
			hooks = Tween.propHooks[ this.prop ];

		if ( this.options.duration ) {
			this.pos = eased = jQuery.easing[ this.easing ](
				percent, this.options.duration * percent, 0, 1, this.options.duration
			);
		} else {
			this.pos = eased = percent;
		}
		this.now = ( this.end - this.start ) * eased + this.start;

		if ( this.options.step ) {
			this.options.step.call( this.elem, this.now, this );
		}

		if ( hooks && hooks.set ) {
			hooks.set( this );
		} else {
			Tween.propHooks._default.set( this );
		}
		return this;
	}
};

Tween.prototype.init.prototype = Tween.prototype;

Tween.propHooks = {
	_default: {
		get: function( tween ) {
			var result;

			// Use a property on the element directly when it is not a DOM element,
			// or when there is no matching style property that exists.
			if ( tween.elem.nodeType !== 1 ||
				tween.elem[ tween.prop ] != null && tween.elem.style[ tween.prop ] == null ) {
				return tween.elem[ tween.prop ];
			}

			// Passing an empty string as a 3rd parameter to .css will automatically
			// attempt a parseFloat and fallback to a string if the parse fails.
			// Simple values such as "10px" are parsed to Float;
			// complex values such as "rotate(1rad)" are returned as-is.
			result = jQuery.css( tween.elem, tween.prop, "" );

			// Empty strings, null, undefined and "auto" are converted to 0.
			return !result || result === "auto" ? 0 : result;
		},
		set: function( tween ) {

			// Use step hook for back compat.
			// Use cssHook if its there.
			// Use .style if available and use plain properties where available.
			if ( jQuery.fx.step[ tween.prop ] ) {
				jQuery.fx.step[ tween.prop ]( tween );
			} else if ( tween.elem.nodeType === 1 &&
				( tween.elem.style[ jQuery.cssProps[ tween.prop ] ] != null ||
					jQuery.cssHooks[ tween.prop ] ) ) {
				jQuery.style( tween.elem, tween.prop, tween.now + tween.unit );
			} else {
				tween.elem[ tween.prop ] = tween.now;
			}
		}
	}
};

// Support: IE <=9 only
// Panic based approach to setting things on disconnected nodes
Tween.propHooks.scrollTop = Tween.propHooks.scrollLeft = {
	set: function( tween ) {
		if ( tween.elem.nodeType && tween.elem.parentNode ) {
			tween.elem[ tween.prop ] = tween.now;
		}
	}
};

jQuery.easing = {
	linear: function( p ) {
		return p;
	},
	swing: function( p ) {
		return 0.5 - Math.cos( p * Math.PI ) / 2;
	},
	_default: "swing"
};

jQuery.fx = Tween.prototype.init;

// Back compat <1.8 extension point
jQuery.fx.step = {};




var
	fxNow, timerId,
	rfxtypes = /^(?:toggle|show|hide)$/,
	rrun = /queueHooks$/;

function raf() {
	if ( timerId ) {
		window.requestAnimationFrame( raf );
		jQuery.fx.tick();
	}
}

// Animations created synchronously will run synchronously
function createFxNow() {
	window.setTimeout( function() {
		fxNow = undefined;
	} );
	return ( fxNow = jQuery.now() );
}

// Generate parameters to create a standard animation
function genFx( type, includeWidth ) {
	var which,
		i = 0,
		attrs = { height: type };

	// If we include width, step value is 1 to do all cssExpand values,
	// otherwise step value is 2 to skip over Left and Right
	includeWidth = includeWidth ? 1 : 0;
	for ( ; i < 4; i += 2 - includeWidth ) {
		which = cssExpand[ i ];
		attrs[ "margin" + which ] = attrs[ "padding" + which ] = type;
	}

	if ( includeWidth ) {
		attrs.opacity = attrs.width = type;
	}

	return attrs;
}

function createTween( value, prop, animation ) {
	var tween,
		collection = ( Animation.tweeners[ prop ] || [] ).concat( Animation.tweeners[ "*" ] ),
		index = 0,
		length = collection.length;
	for ( ; index < length; index++ ) {
		if ( ( tween = collection[ index ].call( animation, prop, value ) ) ) {

			// We're done with this property
			return tween;
		}
	}
}

function defaultPrefilter( elem, props, opts ) {
	var prop, value, toggle, hooks, oldfire, propTween, restoreDisplay, display,
		isBox = "width" in props || "height" in props,
		anim = this,
		orig = {},
		style = elem.style,
		hidden = elem.nodeType && isHiddenWithinTree( elem ),
		dataShow = dataPriv.get( elem, "fxshow" );

	// Queue-skipping animations hijack the fx hooks
	if ( !opts.queue ) {
		hooks = jQuery._queueHooks( elem, "fx" );
		if ( hooks.unqueued == null ) {
			hooks.unqueued = 0;
			oldfire = hooks.empty.fire;
			hooks.empty.fire = function() {
				if ( !hooks.unqueued ) {
					oldfire();
				}
			};
		}
		hooks.unqueued++;

		anim.always( function() {

			// Ensure the complete handler is called before this completes
			anim.always( function() {
				hooks.unqueued--;
				if ( !jQuery.queue( elem, "fx" ).length ) {
					hooks.empty.fire();
				}
			} );
		} );
	}

	// Detect show/hide animations
	for ( prop in props ) {
		value = props[ prop ];
		if ( rfxtypes.test( value ) ) {
			delete props[ prop ];
			toggle = toggle || value === "toggle";
			if ( value === ( hidden ? "hide" : "show" ) ) {

				// Pretend to be hidden if this is a "show" and
				// there is still data from a stopped show/hide
				if ( value === "show" && dataShow && dataShow[ prop ] !== undefined ) {
					hidden = true;

				// Ignore all other no-op show/hide data
				} else {
					continue;
				}
			}
			orig[ prop ] = dataShow && dataShow[ prop ] || jQuery.style( elem, prop );
		}
	}

	// Bail out if this is a no-op like .hide().hide()
	propTween = !jQuery.isEmptyObject( props );
	if ( !propTween && jQuery.isEmptyObject( orig ) ) {
		return;
	}

	// Restrict "overflow" and "display" styles during box animations
	if ( isBox && elem.nodeType === 1 ) {

		// Support: IE <=9 - 11, Edge 12 - 13
		// Record all 3 overflow attributes because IE does not infer the shorthand
		// from identically-valued overflowX and overflowY
		opts.overflow = [ style.overflow, style.overflowX, style.overflowY ];

		// Identify a display type, preferring old show/hide data over the CSS cascade
		restoreDisplay = dataShow && dataShow.display;
		if ( restoreDisplay == null ) {
			restoreDisplay = dataPriv.get( elem, "display" );
		}
		display = jQuery.css( elem, "display" );
		if ( display === "none" ) {
			if ( restoreDisplay ) {
				display = restoreDisplay;
			} else {

				// Get nonempty value(s) by temporarily forcing visibility
				showHide( [ elem ], true );
				restoreDisplay = elem.style.display || restoreDisplay;
				display = jQuery.css( elem, "display" );
				showHide( [ elem ] );
			}
		}

		// Animate inline elements as inline-block
		if ( display === "inline" || display === "inline-block" && restoreDisplay != null ) {
			if ( jQuery.css( elem, "float" ) === "none" ) {

				// Restore the original display value at the end of pure show/hide animations
				if ( !propTween ) {
					anim.done( function() {
						style.display = restoreDisplay;
					} );
					if ( restoreDisplay == null ) {
						display = style.display;
						restoreDisplay = display === "none" ? "" : display;
					}
				}
				style.display = "inline-block";
			}
		}
	}

	if ( opts.overflow ) {
		style.overflow = "hidden";
		anim.always( function() {
			style.overflow = opts.overflow[ 0 ];
			style.overflowX = opts.overflow[ 1 ];
			style.overflowY = opts.overflow[ 2 ];
		} );
	}

	// Implement show/hide animations
	propTween = false;
	for ( prop in orig ) {

		// General show/hide setup for this element animation
		if ( !propTween ) {
			if ( dataShow ) {
				if ( "hidden" in dataShow ) {
					hidden = dataShow.hidden;
				}
			} else {
				dataShow = dataPriv.access( elem, "fxshow", { display: restoreDisplay } );
			}

			// Store hidden/visible for toggle so `.stop().toggle()` "reverses"
			if ( toggle ) {
				dataShow.hidden = !hidden;
			}

			// Show elements before animating them
			if ( hidden ) {
				showHide( [ elem ], true );
			}

			/* eslint-disable no-loop-func */

			anim.done( function() {

			/* eslint-enable no-loop-func */

				// The final step of a "hide" animation is actually hiding the element
				if ( !hidden ) {
					showHide( [ elem ] );
				}
				dataPriv.remove( elem, "fxshow" );
				for ( prop in orig ) {
					jQuery.style( elem, prop, orig[ prop ] );
				}
			} );
		}

		// Per-property setup
		propTween = createTween( hidden ? dataShow[ prop ] : 0, prop, anim );
		if ( !( prop in dataShow ) ) {
			dataShow[ prop ] = propTween.start;
			if ( hidden ) {
				propTween.end = propTween.start;
				propTween.start = 0;
			}
		}
	}
}

function propFilter( props, specialEasing ) {
	var index, name, easing, value, hooks;

	// camelCase, specialEasing and expand cssHook pass
	for ( index in props ) {
		name = jQuery.camelCase( index );
		easing = specialEasing[ name ];
		value = props[ index ];
		if ( jQuery.isArray( value ) ) {
			easing = value[ 1 ];
			value = props[ index ] = value[ 0 ];
		}

		if ( index !== name ) {
			props[ name ] = value;
			delete props[ index ];
		}

		hooks = jQuery.cssHooks[ name ];
		if ( hooks && "expand" in hooks ) {
			value = hooks.expand( value );
			delete props[ name ];

			// Not quite $.extend, this won't overwrite existing keys.
			// Reusing 'index' because we have the correct "name"
			for ( index in value ) {
				if ( !( index in props ) ) {
					props[ index ] = value[ index ];
					specialEasing[ index ] = easing;
				}
			}
		} else {
			specialEasing[ name ] = easing;
		}
	}
}

function Animation( elem, properties, options ) {
	var result,
		stopped,
		index = 0,
		length = Animation.prefilters.length,
		deferred = jQuery.Deferred().always( function() {

			// Don't match elem in the :animated selector
			delete tick.elem;
		} ),
		tick = function() {
			if ( stopped ) {
				return false;
			}
			var currentTime = fxNow || createFxNow(),
				remaining = Math.max( 0, animation.startTime + animation.duration - currentTime ),

				// Support: Android 2.3 only
				// Archaic crash bug won't allow us to use `1 - ( 0.5 || 0 )` (#12497)
				temp = remaining / animation.duration || 0,
				percent = 1 - temp,
				index = 0,
				length = animation.tweens.length;

			for ( ; index < length; index++ ) {
				animation.tweens[ index ].run( percent );
			}

			deferred.notifyWith( elem, [ animation, percent, remaining ] );

			if ( percent < 1 && length ) {
				return remaining;
			} else {
				deferred.resolveWith( elem, [ animation ] );
				return false;
			}
		},
		animation = deferred.promise( {
			elem: elem,
			props: jQuery.extend( {}, properties ),
			opts: jQuery.extend( true, {
				specialEasing: {},
				easing: jQuery.easing._default
			}, options ),
			originalProperties: properties,
			originalOptions: options,
			startTime: fxNow || createFxNow(),
			duration: options.duration,
			tweens: [],
			createTween: function( prop, end ) {
				var tween = jQuery.Tween( elem, animation.opts, prop, end,
						animation.opts.specialEasing[ prop ] || animation.opts.easing );
				animation.tweens.push( tween );
				return tween;
			},
			stop: function( gotoEnd ) {
				var index = 0,

					// If we are going to the end, we want to run all the tweens
					// otherwise we skip this part
					length = gotoEnd ? animation.tweens.length : 0;
				if ( stopped ) {
					return this;
				}
				stopped = true;
				for ( ; index < length; index++ ) {
					animation.tweens[ index ].run( 1 );
				}

				// Resolve when we played the last frame; otherwise, reject
				if ( gotoEnd ) {
					deferred.notifyWith( elem, [ animation, 1, 0 ] );
					deferred.resolveWith( elem, [ animation, gotoEnd ] );
				} else {
					deferred.rejectWith( elem, [ animation, gotoEnd ] );
				}
				return this;
			}
		} ),
		props = animation.props;

	propFilter( props, animation.opts.specialEasing );

	for ( ; index < length; index++ ) {
		result = Animation.prefilters[ index ].call( animation, elem, props, animation.opts );
		if ( result ) {
			if ( jQuery.isFunction( result.stop ) ) {
				jQuery._queueHooks( animation.elem, animation.opts.queue ).stop =
					jQuery.proxy( result.stop, result );
			}
			return result;
		}
	}

	jQuery.map( props, createTween, animation );

	if ( jQuery.isFunction( animation.opts.start ) ) {
		animation.opts.start.call( elem, animation );
	}

	jQuery.fx.timer(
		jQuery.extend( tick, {
			elem: elem,
			anim: animation,
			queue: animation.opts.queue
		} )
	);

	// attach callbacks from options
	return animation.progress( animation.opts.progress )
		.done( animation.opts.done, animation.opts.complete )
		.fail( animation.opts.fail )
		.always( animation.opts.always );
}

jQuery.Animation = jQuery.extend( Animation, {

	tweeners: {
		"*": [ function( prop, value ) {
			var tween = this.createTween( prop, value );
			adjustCSS( tween.elem, prop, rcssNum.exec( value ), tween );
			return tween;
		} ]
	},

	tweener: function( props, callback ) {
		if ( jQuery.isFunction( props ) ) {
			callback = props;
			props = [ "*" ];
		} else {
			props = props.match( rnothtmlwhite );
		}

		var prop,
			index = 0,
			length = props.length;

		for ( ; index < length; index++ ) {
			prop = props[ index ];
			Animation.tweeners[ prop ] = Animation.tweeners[ prop ] || [];
			Animation.tweeners[ prop ].unshift( callback );
		}
	},

	prefilters: [ defaultPrefilter ],

	prefilter: function( callback, prepend ) {
		if ( prepend ) {
			Animation.prefilters.unshift( callback );
		} else {
			Animation.prefilters.push( callback );
		}
	}
} );

jQuery.speed = function( speed, easing, fn ) {
	var opt = speed && typeof speed === "object" ? jQuery.extend( {}, speed ) : {
		complete: fn || !fn && easing ||
			jQuery.isFunction( speed ) && speed,
		duration: speed,
		easing: fn && easing || easing && !jQuery.isFunction( easing ) && easing
	};

	// Go to the end state if fx are off or if document is hidden
	if ( jQuery.fx.off || document.hidden ) {
		opt.duration = 0;

	} else {
		if ( typeof opt.duration !== "number" ) {
			if ( opt.duration in jQuery.fx.speeds ) {
				opt.duration = jQuery.fx.speeds[ opt.duration ];

			} else {
				opt.duration = jQuery.fx.speeds._default;
			}
		}
	}

	// Normalize opt.queue - true/undefined/null -> "fx"
	if ( opt.queue == null || opt.queue === true ) {
		opt.queue = "fx";
	}

	// Queueing
	opt.old = opt.complete;

	opt.complete = function() {
		if ( jQuery.isFunction( opt.old ) ) {
			opt.old.call( this );
		}

		if ( opt.queue ) {
			jQuery.dequeue( this, opt.queue );
		}
	};

	return opt;
};

jQuery.fn.extend( {
	fadeTo: function( speed, to, easing, callback ) {

		// Show any hidden elements after setting opacity to 0
		return this.filter( isHiddenWithinTree ).css( "opacity", 0 ).show()

			// Animate to the value specified
			.end().animate( { opacity: to }, speed, easing, callback );
	},
	animate: function( prop, speed, easing, callback ) {
		var empty = jQuery.isEmptyObject( prop ),
			optall = jQuery.speed( speed, easing, callback ),
			doAnimation = function() {

				// Operate on a copy of prop so per-property easing won't be lost
				var anim = Animation( this, jQuery.extend( {}, prop ), optall );

				// Empty animations, or finishing resolves immediately
				if ( empty || dataPriv.get( this, "finish" ) ) {
					anim.stop( true );
				}
			};
			doAnimation.finish = doAnimation;

		return empty || optall.queue === false ?
			this.each( doAnimation ) :
			this.queue( optall.queue, doAnimation );
	},
	stop: function( type, clearQueue, gotoEnd ) {
		var stopQueue = function( hooks ) {
			var stop = hooks.stop;
			delete hooks.stop;
			stop( gotoEnd );
		};

		if ( typeof type !== "string" ) {
			gotoEnd = clearQueue;
			clearQueue = type;
			type = undefined;
		}
		if ( clearQueue && type !== false ) {
			this.queue( type || "fx", [] );
		}

		return this.each( function() {
			var dequeue = true,
				index = type != null && type + "queueHooks",
				timers = jQuery.timers,
				data = dataPriv.get( this );

			if ( index ) {
				if ( data[ index ] && data[ index ].stop ) {
					stopQueue( data[ index ] );
				}
			} else {
				for ( index in data ) {
					if ( data[ index ] && data[ index ].stop && rrun.test( index ) ) {
						stopQueue( data[ index ] );
					}
				}
			}

			for ( index = timers.length; index--; ) {
				if ( timers[ index ].elem === this &&
					( type == null || timers[ index ].queue === type ) ) {

					timers[ index ].anim.stop( gotoEnd );
					dequeue = false;
					timers.splice( index, 1 );
				}
			}

			// Start the next in the queue if the last step wasn't forced.
			// Timers currently will call their complete callbacks, which
			// will dequeue but only if they were gotoEnd.
			if ( dequeue || !gotoEnd ) {
				jQuery.dequeue( this, type );
			}
		} );
	},
	finish: function( type ) {
		if ( type !== false ) {
			type = type || "fx";
		}
		return this.each( function() {
			var index,
				data = dataPriv.get( this ),
				queue = data[ type + "queue" ],
				hooks = data[ type + "queueHooks" ],
				timers = jQuery.timers,
				length = queue ? queue.length : 0;

			// Enable finishing flag on private data
			data.finish = true;

			// Empty the queue first
			jQuery.queue( this, type, [] );

			if ( hooks && hooks.stop ) {
				hooks.stop.call( this, true );
			}

			// Look for any active animations, and finish them
			for ( index = timers.length; index--; ) {
				if ( timers[ index ].elem === this && timers[ index ].queue === type ) {
					timers[ index ].anim.stop( true );
					timers.splice( index, 1 );
				}
			}

			// Look for any animations in the old queue and finish them
			for ( index = 0; index < length; index++ ) {
				if ( queue[ index ] && queue[ index ].finish ) {
					queue[ index ].finish.call( this );
				}
			}

			// Turn off finishing flag
			delete data.finish;
		} );
	}
} );

jQuery.each( [ "toggle", "show", "hide" ], function( i, name ) {
	var cssFn = jQuery.fn[ name ];
	jQuery.fn[ name ] = function( speed, easing, callback ) {
		return speed == null || typeof speed === "boolean" ?
			cssFn.apply( this, arguments ) :
			this.animate( genFx( name, true ), speed, easing, callback );
	};
} );

// Generate shortcuts for custom animations
jQuery.each( {
	slideDown: genFx( "show" ),
	slideUp: genFx( "hide" ),
	slideToggle: genFx( "toggle" ),
	fadeIn: { opacity: "show" },
	fadeOut: { opacity: "hide" },
	fadeToggle: { opacity: "toggle" }
}, function( name, props ) {
	jQuery.fn[ name ] = function( speed, easing, callback ) {
		return this.animate( props, speed, easing, callback );
	};
} );

jQuery.timers = [];
jQuery.fx.tick = function() {
	var timer,
		i = 0,
		timers = jQuery.timers;

	fxNow = jQuery.now();

	for ( ; i < timers.length; i++ ) {
		timer = timers[ i ];

		// Checks the timer has not already been removed
		if ( !timer() && timers[ i ] === timer ) {
			timers.splice( i--, 1 );
		}
	}

	if ( !timers.length ) {
		jQuery.fx.stop();
	}
	fxNow = undefined;
};

jQuery.fx.timer = function( timer ) {
	jQuery.timers.push( timer );
	if ( timer() ) {
		jQuery.fx.start();
	} else {
		jQuery.timers.pop();
	}
};

jQuery.fx.interval = 13;
jQuery.fx.start = function() {
	if ( !timerId ) {
		timerId = window.requestAnimationFrame ?
			window.requestAnimationFrame( raf ) :
			window.setInterval( jQuery.fx.tick, jQuery.fx.interval );
	}
};

jQuery.fx.stop = function() {
	if ( window.cancelAnimationFrame ) {
		window.cancelAnimationFrame( timerId );
	} else {
		window.clearInterval( timerId );
	}

	timerId = null;
};

jQuery.fx.speeds = {
	slow: 600,
	fast: 200,

	// Default speed
	_default: 400
};


// Based off of the plugin by Clint Helfers, with permission.
// https://web.archive.org/web/20100324014747/http://blindsignals.com/index.php/2009/07/jquery-delay/
jQuery.fn.delay = function( time, type ) {
	time = jQuery.fx ? jQuery.fx.speeds[ time ] || time : time;
	type = type || "fx";

	return this.queue( type, function( next, hooks ) {
		var timeout = window.setTimeout( next, time );
		hooks.stop = function() {
			window.clearTimeout( timeout );
		};
	} );
};


( function() {
	var input = document.createElement( "input" ),
		select = document.createElement( "select" ),
		opt = select.appendChild( document.createElement( "option" ) );

	input.type = "checkbox";

	// Support: Android <=4.3 only
	// Default value for a checkbox should be "on"
	support.checkOn = input.value !== "";

	// Support: IE <=11 only
	// Must access selectedIndex to make default options select
	support.optSelected = opt.selected;

	// Support: IE <=11 only
	// An input loses its value after becoming a radio
	input = document.createElement( "input" );
	input.value = "t";
	input.type = "radio";
	support.radioValue = input.value === "t";
} )();


var boolHook,
	attrHandle = jQuery.expr.attrHandle;

jQuery.fn.extend( {
	attr: function( name, value ) {
		return access( this, jQuery.attr, name, value, arguments.length > 1 );
	},

	removeAttr: function( name ) {
		return this.each( function() {
			jQuery.removeAttr( this, name );
		} );
	}
} );

jQuery.extend( {
	attr: function( elem, name, value ) {
		var ret, hooks,
			nType = elem.nodeType;

		// Don't get/set attributes on text, comment and attribute nodes
		if ( nType === 3 || nType === 8 || nType === 2 ) {
			return;
		}

		// Fallback to prop when attributes are not supported
		if ( typeof elem.getAttribute === "undefined" ) {
			return jQuery.prop( elem, name, value );
		}

		// Attribute hooks are determined by the lowercase version
		// Grab necessary hook if one is defined
		if ( nType !== 1 || !jQuery.isXMLDoc( elem ) ) {
			hooks = jQuery.attrHooks[ name.toLowerCase() ] ||
				( jQuery.expr.match.bool.test( name ) ? boolHook : undefined );
		}

		if ( value !== undefined ) {
			if ( value === null ) {
				jQuery.removeAttr( elem, name );
				return;
			}

			if ( hooks && "set" in hooks &&
				( ret = hooks.set( elem, value, name ) ) !== undefined ) {
				return ret;
			}

			elem.setAttribute( name, value + "" );
			return value;
		}

		if ( hooks && "get" in hooks && ( ret = hooks.get( elem, name ) ) !== null ) {
			return ret;
		}

		ret = jQuery.find.attr( elem, name );

		// Non-existent attributes return null, we normalize to undefined
		return ret == null ? undefined : ret;
	},

	attrHooks: {
		type: {
			set: function( elem, value ) {
				if ( !support.radioValue && value === "radio" &&
					jQuery.nodeName( elem, "input" ) ) {
					var val = elem.value;
					elem.setAttribute( "type", value );
					if ( val ) {
						elem.value = val;
					}
					return value;
				}
			}
		}
	},

	removeAttr: function( elem, value ) {
		var name,
			i = 0,

			// Attribute names can contain non-HTML whitespace characters
			// https://html.spec.whatwg.org/multipage/syntax.html#attributes-2
			attrNames = value && value.match( rnothtmlwhite );

		if ( attrNames && elem.nodeType === 1 ) {
			while ( ( name = attrNames[ i++ ] ) ) {
				elem.removeAttribute( name );
			}
		}
	}
} );

// Hooks for boolean attributes
boolHook = {
	set: function( elem, value, name ) {
		if ( value === false ) {

			// Remove boolean attributes when set to false
			jQuery.removeAttr( elem, name );
		} else {
			elem.setAttribute( name, name );
		}
		return name;
	}
};

jQuery.each( jQuery.expr.match.bool.source.match( /\w+/g ), function( i, name ) {
	var getter = attrHandle[ name ] || jQuery.find.attr;

	attrHandle[ name ] = function( elem, name, isXML ) {
		var ret, handle,
			lowercaseName = name.toLowerCase();

		if ( !isXML ) {

			// Avoid an infinite loop by temporarily removing this function from the getter
			handle = attrHandle[ lowercaseName ];
			attrHandle[ lowercaseName ] = ret;
			ret = getter( elem, name, isXML ) != null ?
				lowercaseName :
				null;
			attrHandle[ lowercaseName ] = handle;
		}
		return ret;
	};
} );




var rfocusable = /^(?:input|select|textarea|button)$/i,
	rclickable = /^(?:a|area)$/i;

jQuery.fn.extend( {
	prop: function( name, value ) {
		return access( this, jQuery.prop, name, value, arguments.length > 1 );
	},

	removeProp: function( name ) {
		return this.each( function() {
			delete this[ jQuery.propFix[ name ] || name ];
		} );
	}
} );

jQuery.extend( {
	prop: function( elem, name, value ) {
		var ret, hooks,
			nType = elem.nodeType;

		// Don't get/set properties on text, comment and attribute nodes
		if ( nType === 3 || nType === 8 || nType === 2 ) {
			return;
		}

		if ( nType !== 1 || !jQuery.isXMLDoc( elem ) ) {

			// Fix name and attach hooks
			name = jQuery.propFix[ name ] || name;
			hooks = jQuery.propHooks[ name ];
		}

		if ( value !== undefined ) {
			if ( hooks && "set" in hooks &&
				( ret = hooks.set( elem, value, name ) ) !== undefined ) {
				return ret;
			}

			return ( elem[ name ] = value );
		}

		if ( hooks && "get" in hooks && ( ret = hooks.get( elem, name ) ) !== null ) {
			return ret;
		}

		return elem[ name ];
	},

	propHooks: {
		tabIndex: {
			get: function( elem ) {

				// Support: IE <=9 - 11 only
				// elem.tabIndex doesn't always return the
				// correct value when it hasn't been explicitly set
				// https://web.archive.org/web/20141116233347/http://fluidproject.org/blog/2008/01/09/getting-setting-and-removing-tabindex-values-with-javascript/
				// Use proper attribute retrieval(#12072)
				var tabindex = jQuery.find.attr( elem, "tabindex" );

				if ( tabindex ) {
					return parseInt( tabindex, 10 );
				}

				if (
					rfocusable.test( elem.nodeName ) ||
					rclickable.test( elem.nodeName ) &&
					elem.href
				) {
					return 0;
				}

				return -1;
			}
		}
	},

	propFix: {
		"for": "htmlFor",
		"class": "className"
	}
} );

// Support: IE <=11 only
// Accessing the selectedIndex property
// forces the browser to respect setting selected
// on the option
// The getter ensures a default option is selected
// when in an optgroup
// eslint rule "no-unused-expressions" is disabled for this code
// since it considers such accessions noop
if ( !support.optSelected ) {
	jQuery.propHooks.selected = {
		get: function( elem ) {

			/* eslint no-unused-expressions: "off" */

			var parent = elem.parentNode;
			if ( parent && parent.parentNode ) {
				parent.parentNode.selectedIndex;
			}
			return null;
		},
		set: function( elem ) {

			/* eslint no-unused-expressions: "off" */

			var parent = elem.parentNode;
			if ( parent ) {
				parent.selectedIndex;

				if ( parent.parentNode ) {
					parent.parentNode.selectedIndex;
				}
			}
		}
	};
}

jQuery.each( [
	"tabIndex",
	"readOnly",
	"maxLength",
	"cellSpacing",
	"cellPadding",
	"rowSpan",
	"colSpan",
	"useMap",
	"frameBorder",
	"contentEditable"
], function() {
	jQuery.propFix[ this.toLowerCase() ] = this;
} );




	// Strip and collapse whitespace according to HTML spec
	// https://html.spec.whatwg.org/multipage/infrastructure.html#strip-and-collapse-whitespace
	function stripAndCollapse( value ) {
		var tokens = value.match( rnothtmlwhite ) || [];
		return tokens.join( " " );
	}


function getClass( elem ) {
	return elem.getAttribute && elem.getAttribute( "class" ) || "";
}

jQuery.fn.extend( {
	addClass: function( value ) {
		var classes, elem, cur, curValue, clazz, j, finalValue,
			i = 0;

		if ( jQuery.isFunction( value ) ) {
			return this.each( function( j ) {
				jQuery( this ).addClass( value.call( this, j, getClass( this ) ) );
			} );
		}

		if ( typeof value === "string" && value ) {
			classes = value.match( rnothtmlwhite ) || [];

			while ( ( elem = this[ i++ ] ) ) {
				curValue = getClass( elem );
				cur = elem.nodeType === 1 && ( " " + stripAndCollapse( curValue ) + " " );

				if ( cur ) {
					j = 0;
					while ( ( clazz = classes[ j++ ] ) ) {
						if ( cur.indexOf( " " + clazz + " " ) < 0 ) {
							cur += clazz + " ";
						}
					}

					// Only assign if different to avoid unneeded rendering.
					finalValue = stripAndCollapse( cur );
					if ( curValue !== finalValue ) {
						elem.setAttribute( "class", finalValue );
					}
				}
			}
		}

		return this;
	},

	removeClass: function( value ) {
		var classes, elem, cur, curValue, clazz, j, finalValue,
			i = 0;

		if ( jQuery.isFunction( value ) ) {
			return this.each( function( j ) {
				jQuery( this ).removeClass( value.call( this, j, getClass( this ) ) );
			} );
		}

		if ( !arguments.length ) {
			return this.attr( "class", "" );
		}

		if ( typeof value === "string" && value ) {
			classes = value.match( rnothtmlwhite ) || [];

			while ( ( elem = this[ i++ ] ) ) {
				curValue = getClass( elem );

				// This expression is here for better compressibility (see addClass)
				cur = elem.nodeType === 1 && ( " " + stripAndCollapse( curValue ) + " " );

				if ( cur ) {
					j = 0;
					while ( ( clazz = classes[ j++ ] ) ) {

						// Remove *all* instances
						while ( cur.indexOf( " " + clazz + " " ) > -1 ) {
							cur = cur.replace( " " + clazz + " ", " " );
						}
					}

					// Only assign if different to avoid unneeded rendering.
					finalValue = stripAndCollapse( cur );
					if ( curValue !== finalValue ) {
						elem.setAttribute( "class", finalValue );
					}
				}
			}
		}

		return this;
	},

	toggleClass: function( value, stateVal ) {
		var type = typeof value;

		if ( typeof stateVal === "boolean" && type === "string" ) {
			return stateVal ? this.addClass( value ) : this.removeClass( value );
		}

		if ( jQuery.isFunction( value ) ) {
			return this.each( function( i ) {
				jQuery( this ).toggleClass(
					value.call( this, i, getClass( this ), stateVal ),
					stateVal
				);
			} );
		}

		return this.each( function() {
			var className, i, self, classNames;

			if ( type === "string" ) {

				// Toggle individual class names
				i = 0;
				self = jQuery( this );
				classNames = value.match( rnothtmlwhite ) || [];

				while ( ( className = classNames[ i++ ] ) ) {

					// Check each className given, space separated list
					if ( self.hasClass( className ) ) {
						self.removeClass( className );
					} else {
						self.addClass( className );
					}
				}

			// Toggle whole class name
			} else if ( value === undefined || type === "boolean" ) {
				className = getClass( this );
				if ( className ) {

					// Store className if set
					dataPriv.set( this, "__className__", className );
				}

				// If the element has a class name or if we're passed `false`,
				// then remove the whole classname (if there was one, the above saved it).
				// Otherwise bring back whatever was previously saved (if anything),
				// falling back to the empty string if nothing was stored.
				if ( this.setAttribute ) {
					this.setAttribute( "class",
						className || value === false ?
						"" :
						dataPriv.get( this, "__className__" ) || ""
					);
				}
			}
		} );
	},

	hasClass: function( selector ) {
		var className, elem,
			i = 0;

		className = " " + selector + " ";
		while ( ( elem = this[ i++ ] ) ) {
			if ( elem.nodeType === 1 &&
				( " " + stripAndCollapse( getClass( elem ) ) + " " ).indexOf( className ) > -1 ) {
					return true;
			}
		}

		return false;
	}
} );




var rreturn = /\r/g;

jQuery.fn.extend( {
	val: function( value ) {
		var hooks, ret, isFunction,
			elem = this[ 0 ];

		if ( !arguments.length ) {
			if ( elem ) {
				hooks = jQuery.valHooks[ elem.type ] ||
					jQuery.valHooks[ elem.nodeName.toLowerCase() ];

				if ( hooks &&
					"get" in hooks &&
					( ret = hooks.get( elem, "value" ) ) !== undefined
				) {
					return ret;
				}

				ret = elem.value;

				// Handle most common string cases
				if ( typeof ret === "string" ) {
					return ret.replace( rreturn, "" );
				}

				// Handle cases where value is null/undef or number
				return ret == null ? "" : ret;
			}

			return;
		}

		isFunction = jQuery.isFunction( value );

		return this.each( function( i ) {
			var val;

			if ( this.nodeType !== 1 ) {
				return;
			}

			if ( isFunction ) {
				val = value.call( this, i, jQuery( this ).val() );
			} else {
				val = value;
			}

			// Treat null/undefined as ""; convert numbers to string
			if ( val == null ) {
				val = "";

			} else if ( typeof val === "number" ) {
				val += "";

			} else if ( jQuery.isArray( val ) ) {
				val = jQuery.map( val, function( value ) {
					return value == null ? "" : value + "";
				} );
			}

			hooks = jQuery.valHooks[ this.type ] || jQuery.valHooks[ this.nodeName.toLowerCase() ];

			// If set returns undefined, fall back to normal setting
			if ( !hooks || !( "set" in hooks ) || hooks.set( this, val, "value" ) === undefined ) {
				this.value = val;
			}
		} );
	}
} );

jQuery.extend( {
	valHooks: {
		option: {
			get: function( elem ) {

				var val = jQuery.find.attr( elem, "value" );
				return val != null ?
					val :

					// Support: IE <=10 - 11 only
					// option.text throws exceptions (#14686, #14858)
					// Strip and collapse whitespace
					// https://html.spec.whatwg.org/#strip-and-collapse-whitespace
					stripAndCollapse( jQuery.text( elem ) );
			}
		},
		select: {
			get: function( elem ) {
				var value, option, i,
					options = elem.options,
					index = elem.selectedIndex,
					one = elem.type === "select-one",
					values = one ? null : [],
					max = one ? index + 1 : options.length;

				if ( index < 0 ) {
					i = max;

				} else {
					i = one ? index : 0;
				}

				// Loop through all the selected options
				for ( ; i < max; i++ ) {
					option = options[ i ];

					// Support: IE <=9 only
					// IE8-9 doesn't update selected after form reset (#2551)
					if ( ( option.selected || i === index ) &&

							// Don't return options that are disabled or in a disabled optgroup
							!option.disabled &&
							( !option.parentNode.disabled ||
								!jQuery.nodeName( option.parentNode, "optgroup" ) ) ) {

						// Get the specific value for the option
						value = jQuery( option ).val();

						// We don't need an array for one selects
						if ( one ) {
							return value;
						}

						// Multi-Selects return an array
						values.push( value );
					}
				}

				return values;
			},

			set: function( elem, value ) {
				var optionSet, option,
					options = elem.options,
					values = jQuery.makeArray( value ),
					i = options.length;

				while ( i-- ) {
					option = options[ i ];

					/* eslint-disable no-cond-assign */

					if ( option.selected =
						jQuery.inArray( jQuery.valHooks.option.get( option ), values ) > -1
					) {
						optionSet = true;
					}

					/* eslint-enable no-cond-assign */
				}

				// Force browsers to behave consistently when non-matching value is set
				if ( !optionSet ) {
					elem.selectedIndex = -1;
				}
				return values;
			}
		}
	}
} );

// Radios and checkboxes getter/setter
jQuery.each( [ "radio", "checkbox" ], function() {
	jQuery.valHooks[ this ] = {
		set: function( elem, value ) {
			if ( jQuery.isArray( value ) ) {
				return ( elem.checked = jQuery.inArray( jQuery( elem ).val(), value ) > -1 );
			}
		}
	};
	if ( !support.checkOn ) {
		jQuery.valHooks[ this ].get = function( elem ) {
			return elem.getAttribute( "value" ) === null ? "on" : elem.value;
		};
	}
} );




// Return jQuery for attributes-only inclusion


var rfocusMorph = /^(?:focusinfocus|focusoutblur)$/;

jQuery.extend( jQuery.event, {

	trigger: function( event, data, elem, onlyHandlers ) {

		var i, cur, tmp, bubbleType, ontype, handle, special,
			eventPath = [ elem || document ],
			type = hasOwn.call( event, "type" ) ? event.type : event,
			namespaces = hasOwn.call( event, "namespace" ) ? event.namespace.split( "." ) : [];

		cur = tmp = elem = elem || document;

		// Don't do events on text and comment nodes
		if ( elem.nodeType === 3 || elem.nodeType === 8 ) {
			return;
		}

		// focus/blur morphs to focusin/out; ensure we're not firing them right now
		if ( rfocusMorph.test( type + jQuery.event.triggered ) ) {
			return;
		}

		if ( type.indexOf( "." ) > -1 ) {

			// Namespaced trigger; create a regexp to match event type in handle()
			namespaces = type.split( "." );
			type = namespaces.shift();
			namespaces.sort();
		}
		ontype = type.indexOf( ":" ) < 0 && "on" + type;

		// Caller can pass in a jQuery.Event object, Object, or just an event type string
		event = event[ jQuery.expando ] ?
			event :
			new jQuery.Event( type, typeof event === "object" && event );

		// Trigger bitmask: & 1 for native handlers; & 2 for jQuery (always true)
		event.isTrigger = onlyHandlers ? 2 : 3;
		event.namespace = namespaces.join( "." );
		event.rnamespace = event.namespace ?
			new RegExp( "(^|\\.)" + namespaces.join( "\\.(?:.*\\.|)" ) + "(\\.|$)" ) :
			null;

		// Clean up the event in case it is being reused
		event.result = undefined;
		if ( !event.target ) {
			event.target = elem;
		}

		// Clone any incoming data and prepend the event, creating the handler arg list
		data = data == null ?
			[ event ] :
			jQuery.makeArray( data, [ event ] );

		// Allow special events to draw outside the lines
		special = jQuery.event.special[ type ] || {};
		if ( !onlyHandlers && special.trigger && special.trigger.apply( elem, data ) === false ) {
			return;
		}

		// Determine event propagation path in advance, per W3C events spec (#9951)
		// Bubble up to document, then to window; watch for a global ownerDocument var (#9724)
		if ( !onlyHandlers && !special.noBubble && !jQuery.isWindow( elem ) ) {

			bubbleType = special.delegateType || type;
			if ( !rfocusMorph.test( bubbleType + type ) ) {
				cur = cur.parentNode;
			}
			for ( ; cur; cur = cur.parentNode ) {
				eventPath.push( cur );
				tmp = cur;
			}

			// Only add window if we got to document (e.g., not plain obj or detached DOM)
			if ( tmp === ( elem.ownerDocument || document ) ) {
				eventPath.push( tmp.defaultView || tmp.parentWindow || window );
			}
		}

		// Fire handlers on the event path
		i = 0;
		while ( ( cur = eventPath[ i++ ] ) && !event.isPropagationStopped() ) {

			event.type = i > 1 ?
				bubbleType :
				special.bindType || type;

			// jQuery handler
			handle = ( dataPriv.get( cur, "events" ) || {} )[ event.type ] &&
				dataPriv.get( cur, "handle" );
			if ( handle ) {
				handle.apply( cur, data );
			}

			// Native handler
			handle = ontype && cur[ ontype ];
			if ( handle && handle.apply && acceptData( cur ) ) {
				event.result = handle.apply( cur, data );
				if ( event.result === false ) {
					event.preventDefault();
				}
			}
		}
		event.type = type;

		// If nobody prevented the default action, do it now
		if ( !onlyHandlers && !event.isDefaultPrevented() ) {

			if ( ( !special._default ||
				special._default.apply( eventPath.pop(), data ) === false ) &&
				acceptData( elem ) ) {

				// Call a native DOM method on the target with the same name as the event.
				// Don't do default actions on window, that's where global variables be (#6170)
				if ( ontype && jQuery.isFunction( elem[ type ] ) && !jQuery.isWindow( elem ) ) {

					// Don't re-trigger an onFOO event when we call its FOO() method
					tmp = elem[ ontype ];

					if ( tmp ) {
						elem[ ontype ] = null;
					}

					// Prevent re-triggering of the same event, since we already bubbled it above
					jQuery.event.triggered = type;
					elem[ type ]();
					jQuery.event.triggered = undefined;

					if ( tmp ) {
						elem[ ontype ] = tmp;
					}
				}
			}
		}

		return event.result;
	},

	// Piggyback on a donor event to simulate a different one
	// Used only for `focus(in | out)` events
	simulate: function( type, elem, event ) {
		var e = jQuery.extend(
			new jQuery.Event(),
			event,
			{
				type: type,
				isSimulated: true
			}
		);

		jQuery.event.trigger( e, null, elem );
	}

} );

jQuery.fn.extend( {

	trigger: function( type, data ) {
		return this.each( function() {
			jQuery.event.trigger( type, data, this );
		} );
	},
	triggerHandler: function( type, data ) {
		var elem = this[ 0 ];
		if ( elem ) {
			return jQuery.event.trigger( type, data, elem, true );
		}
	}
} );


jQuery.each( ( "blur focus focusin focusout resize scroll click dblclick " +
	"mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave " +
	"change select submit keydown keypress keyup contextmenu" ).split( " " ),
	function( i, name ) {

	// Handle event binding
	jQuery.fn[ name ] = function( data, fn ) {
		return arguments.length > 0 ?
			this.on( name, null, data, fn ) :
			this.trigger( name );
	};
} );

jQuery.fn.extend( {
	hover: function( fnOver, fnOut ) {
		return this.mouseenter( fnOver ).mouseleave( fnOut || fnOver );
	}
} );




support.focusin = "onfocusin" in window;


// Support: Firefox <=44
// Firefox doesn't have focus(in | out) events
// Related ticket - https://bugzilla.mozilla.org/show_bug.cgi?id=687787
//
// Support: Chrome <=48 - 49, Safari <=9.0 - 9.1
// focus(in | out) events fire after focus & blur events,
// which is spec violation - http://www.w3.org/TR/DOM-Level-3-Events/#events-focusevent-event-order
// Related ticket - https://bugs.chromium.org/p/chromium/issues/detail?id=449857
if ( !support.focusin ) {
	jQuery.each( { focus: "focusin", blur: "focusout" }, function( orig, fix ) {

		// Attach a single capturing handler on the document while someone wants focusin/focusout
		var handler = function( event ) {
			jQuery.event.simulate( fix, event.target, jQuery.event.fix( event ) );
		};

		jQuery.event.special[ fix ] = {
			setup: function() {
				var doc = this.ownerDocument || this,
					attaches = dataPriv.access( doc, fix );

				if ( !attaches ) {
					doc.addEventListener( orig, handler, true );
				}
				dataPriv.access( doc, fix, ( attaches || 0 ) + 1 );
			},
			teardown: function() {
				var doc = this.ownerDocument || this,
					attaches = dataPriv.access( doc, fix ) - 1;

				if ( !attaches ) {
					doc.removeEventListener( orig, handler, true );
					dataPriv.remove( doc, fix );

				} else {
					dataPriv.access( doc, fix, attaches );
				}
			}
		};
	} );
}
var location = window.location;

var nonce = jQuery.now();

var rquery = ( /\?/ );



// Cross-browser xml parsing
jQuery.parseXML = function( data ) {
	var xml;
	if ( !data || typeof data !== "string" ) {
		return null;
	}

	// Support: IE 9 - 11 only
	// IE throws on parseFromString with invalid input.
	try {
		xml = ( new window.DOMParser() ).parseFromString( data, "text/xml" );
	} catch ( e ) {
		xml = undefined;
	}

	if ( !xml || xml.getElementsByTagName( "parsererror" ).length ) {
		jQuery.error( "Invalid XML: " + data );
	}
	return xml;
};


var
	rbracket = /\[\]$/,
	rCRLF = /\r?\n/g,
	rsubmitterTypes = /^(?:submit|button|image|reset|file)$/i,
	rsubmittable = /^(?:input|select|textarea|keygen)/i;

function buildParams( prefix, obj, traditional, add ) {
	var name;

	if ( jQuery.isArray( obj ) ) {

		// Serialize array item.
		jQuery.each( obj, function( i, v ) {
			if ( traditional || rbracket.test( prefix ) ) {

				// Treat each array item as a scalar.
				add( prefix, v );

			} else {

				// Item is non-scalar (array or object), encode its numeric index.
				buildParams(
					prefix + "[" + ( typeof v === "object" && v != null ? i : "" ) + "]",
					v,
					traditional,
					add
				);
			}
		} );

	} else if ( !traditional && jQuery.type( obj ) === "object" ) {

		// Serialize object item.
		for ( name in obj ) {
			buildParams( prefix + "[" + name + "]", obj[ name ], traditional, add );
		}

	} else {

		// Serialize scalar item.
		add( prefix, obj );
	}
}

// Serialize an array of form elements or a set of
// key/values into a query string
jQuery.param = function( a, traditional ) {
	var prefix,
		s = [],
		add = function( key, valueOrFunction ) {

			// If value is a function, invoke it and use its return value
			var value = jQuery.isFunction( valueOrFunction ) ?
				valueOrFunction() :
				valueOrFunction;

			s[ s.length ] = encodeURIComponent( key ) + "=" +
				encodeURIComponent( value == null ? "" : value );
		};

	// If an array was passed in, assume that it is an array of form elements.
	if ( jQuery.isArray( a ) || ( a.jquery && !jQuery.isPlainObject( a ) ) ) {

		// Serialize the form elements
		jQuery.each( a, function() {
			add( this.name, this.value );
		} );

	} else {

		// If traditional, encode the "old" way (the way 1.3.2 or older
		// did it), otherwise encode params recursively.
		for ( prefix in a ) {
			buildParams( prefix, a[ prefix ], traditional, add );
		}
	}

	// Return the resulting serialization
	return s.join( "&" );
};

jQuery.fn.extend( {
	serialize: function() {
		return jQuery.param( this.serializeArray() );
	},
	serializeArray: function() {
		return this.map( function() {

			// Can add propHook for "elements" to filter or add form elements
			var elements = jQuery.prop( this, "elements" );
			return elements ? jQuery.makeArray( elements ) : this;
		} )
		.filter( function() {
			var type = this.type;

			// Use .is( ":disabled" ) so that fieldset[disabled] works
			return this.name && !jQuery( this ).is( ":disabled" ) &&
				rsubmittable.test( this.nodeName ) && !rsubmitterTypes.test( type ) &&
				( this.checked || !rcheckableType.test( type ) );
		} )
		.map( function( i, elem ) {
			var val = jQuery( this ).val();

			if ( val == null ) {
				return null;
			}

			if ( jQuery.isArray( val ) ) {
				return jQuery.map( val, function( val ) {
					return { name: elem.name, value: val.replace( rCRLF, "\r\n" ) };
				} );
			}

			return { name: elem.name, value: val.replace( rCRLF, "\r\n" ) };
		} ).get();
	}
} );


var
	r20 = /%20/g,
	rhash = /#.*$/,
	rantiCache = /([?&])_=[^&]*/,
	rheaders = /^(.*?):[ \t]*([^\r\n]*)$/mg,

	// #7653, #8125, #8152: local protocol detection
	rlocalProtocol = /^(?:about|app|app-storage|.+-extension|file|res|widget):$/,
	rnoContent = /^(?:GET|HEAD)$/,
	rprotocol = /^\/\//,

	/* Prefilters
	 * 1) They are useful to introduce custom dataTypes (see ajax/jsonp.js for an example)
	 * 2) These are called:
	 *    - BEFORE asking for a transport
	 *    - AFTER param serialization (s.data is a string if s.processData is true)
	 * 3) key is the dataType
	 * 4) the catchall symbol "*" can be used
	 * 5) execution will start with transport dataType and THEN continue down to "*" if needed
	 */
	prefilters = {},

	/* Transports bindings
	 * 1) key is the dataType
	 * 2) the catchall symbol "*" can be used
	 * 3) selection will start with transport dataType and THEN go to "*" if needed
	 */
	transports = {},

	// Avoid comment-prolog char sequence (#10098); must appease lint and evade compression
	allTypes = "*/".concat( "*" ),

	// Anchor tag for parsing the document origin
	originAnchor = document.createElement( "a" );
	originAnchor.href = location.href;

// Base "constructor" for jQuery.ajaxPrefilter and jQuery.ajaxTransport
function addToPrefiltersOrTransports( structure ) {

	// dataTypeExpression is optional and defaults to "*"
	return function( dataTypeExpression, func ) {

		if ( typeof dataTypeExpression !== "string" ) {
			func = dataTypeExpression;
			dataTypeExpression = "*";
		}

		var dataType,
			i = 0,
			dataTypes = dataTypeExpression.toLowerCase().match( rnothtmlwhite ) || [];

		if ( jQuery.isFunction( func ) ) {

			// For each dataType in the dataTypeExpression
			while ( ( dataType = dataTypes[ i++ ] ) ) {

				// Prepend if requested
				if ( dataType[ 0 ] === "+" ) {
					dataType = dataType.slice( 1 ) || "*";
					( structure[ dataType ] = structure[ dataType ] || [] ).unshift( func );

				// Otherwise append
				} else {
					( structure[ dataType ] = structure[ dataType ] || [] ).push( func );
				}
			}
		}
	};
}

// Base inspection function for prefilters and transports
function inspectPrefiltersOrTransports( structure, options, originalOptions, jqXHR ) {

	var inspected = {},
		seekingTransport = ( structure === transports );

	function inspect( dataType ) {
		var selected;
		inspected[ dataType ] = true;
		jQuery.each( structure[ dataType ] || [], function( _, prefilterOrFactory ) {
			var dataTypeOrTransport = prefilterOrFactory( options, originalOptions, jqXHR );
			if ( typeof dataTypeOrTransport === "string" &&
				!seekingTransport && !inspected[ dataTypeOrTransport ] ) {

				options.dataTypes.unshift( dataTypeOrTransport );
				inspect( dataTypeOrTransport );
				return false;
			} else if ( seekingTransport ) {
				return !( selected = dataTypeOrTransport );
			}
		} );
		return selected;
	}

	return inspect( options.dataTypes[ 0 ] ) || !inspected[ "*" ] && inspect( "*" );
}

// A special extend for ajax options
// that takes "flat" options (not to be deep extended)
// Fixes #9887
function ajaxExtend( target, src ) {
	var key, deep,
		flatOptions = jQuery.ajaxSettings.flatOptions || {};

	for ( key in src ) {
		if ( src[ key ] !== undefined ) {
			( flatOptions[ key ] ? target : ( deep || ( deep = {} ) ) )[ key ] = src[ key ];
		}
	}
	if ( deep ) {
		jQuery.extend( true, target, deep );
	}

	return target;
}

/* Handles responses to an ajax request:
 * - finds the right dataType (mediates between content-type and expected dataType)
 * - returns the corresponding response
 */
function ajaxHandleResponses( s, jqXHR, responses ) {

	var ct, type, finalDataType, firstDataType,
		contents = s.contents,
		dataTypes = s.dataTypes;

	// Remove auto dataType and get content-type in the process
	while ( dataTypes[ 0 ] === "*" ) {
		dataTypes.shift();
		if ( ct === undefined ) {
			ct = s.mimeType || jqXHR.getResponseHeader( "Content-Type" );
		}
	}

	// Check if we're dealing with a known content-type
	if ( ct ) {
		for ( type in contents ) {
			if ( contents[ type ] && contents[ type ].test( ct ) ) {
				dataTypes.unshift( type );
				break;
			}
		}
	}

	// Check to see if we have a response for the expected dataType
	if ( dataTypes[ 0 ] in responses ) {
		finalDataType = dataTypes[ 0 ];
	} else {

		// Try convertible dataTypes
		for ( type in responses ) {
			if ( !dataTypes[ 0 ] || s.converters[ type + " " + dataTypes[ 0 ] ] ) {
				finalDataType = type;
				break;
			}
			if ( !firstDataType ) {
				firstDataType = type;
			}
		}

		// Or just use first one
		finalDataType = finalDataType || firstDataType;
	}

	// If we found a dataType
	// We add the dataType to the list if needed
	// and return the corresponding response
	if ( finalDataType ) {
		if ( finalDataType !== dataTypes[ 0 ] ) {
			dataTypes.unshift( finalDataType );
		}
		return responses[ finalDataType ];
	}
}

/* Chain conversions given the request and the original response
 * Also sets the responseXXX fields on the jqXHR instance
 */
function ajaxConvert( s, response, jqXHR, isSuccess ) {
	var conv2, current, conv, tmp, prev,
		converters = {},

		// Work with a copy of dataTypes in case we need to modify it for conversion
		dataTypes = s.dataTypes.slice();

	// Create converters map with lowercased keys
	if ( dataTypes[ 1 ] ) {
		for ( conv in s.converters ) {
			converters[ conv.toLowerCase() ] = s.converters[ conv ];
		}
	}

	current = dataTypes.shift();

	// Convert to each sequential dataType
	while ( current ) {

		if ( s.responseFields[ current ] ) {
			jqXHR[ s.responseFields[ current ] ] = response;
		}

		// Apply the dataFilter if provided
		if ( !prev && isSuccess && s.dataFilter ) {
			response = s.dataFilter( response, s.dataType );
		}

		prev = current;
		current = dataTypes.shift();

		if ( current ) {

			// There's only work to do if current dataType is non-auto
			if ( current === "*" ) {

				current = prev;

			// Convert response if prev dataType is non-auto and differs from current
			} else if ( prev !== "*" && prev !== current ) {

				// Seek a direct converter
				conv = converters[ prev + " " + current ] || converters[ "* " + current ];

				// If none found, seek a pair
				if ( !conv ) {
					for ( conv2 in converters ) {

						// If conv2 outputs current
						tmp = conv2.split( " " );
						if ( tmp[ 1 ] === current ) {

							// If prev can be converted to accepted input
							conv = converters[ prev + " " + tmp[ 0 ] ] ||
								converters[ "* " + tmp[ 0 ] ];
							if ( conv ) {

								// Condense equivalence converters
								if ( conv === true ) {
									conv = converters[ conv2 ];

								// Otherwise, insert the intermediate dataType
								} else if ( converters[ conv2 ] !== true ) {
									current = tmp[ 0 ];
									dataTypes.unshift( tmp[ 1 ] );
								}
								break;
							}
						}
					}
				}

				// Apply converter (if not an equivalence)
				if ( conv !== true ) {

					// Unless errors are allowed to bubble, catch and return them
					if ( conv && s.throws ) {
						response = conv( response );
					} else {
						try {
							response = conv( response );
						} catch ( e ) {
							return {
								state: "parsererror",
								error: conv ? e : "No conversion from " + prev + " to " + current
							};
						}
					}
				}
			}
		}
	}

	return { state: "success", data: response };
}

jQuery.extend( {

	// Counter for holding the number of active queries
	active: 0,

	// Last-Modified header cache for next request
	lastModified: {},
	etag: {},

	ajaxSettings: {
		url: location.href,
		type: "GET",
		isLocal: rlocalProtocol.test( location.protocol ),
		global: true,
		processData: true,
		async: true,
		contentType: "application/x-www-form-urlencoded; charset=UTF-8",

		/*
		timeout: 0,
		data: null,
		dataType: null,
		username: null,
		password: null,
		cache: null,
		throws: false,
		traditional: false,
		headers: {},
		*/

		accepts: {
			"*": allTypes,
			text: "text/plain",
			html: "text/html",
			xml: "application/xml, text/xml",
			json: "application/json, text/javascript"
		},

		contents: {
			xml: /\bxml\b/,
			html: /\bhtml/,
			json: /\bjson\b/
		},

		responseFields: {
			xml: "responseXML",
			text: "responseText",
			json: "responseJSON"
		},

		// Data converters
		// Keys separate source (or catchall "*") and destination types with a single space
		converters: {

			// Convert anything to text
			"* text": String,

			// Text to html (true = no transformation)
			"text html": true,

			// Evaluate text as a json expression
			"text json": JSON.parse,

			// Parse text as xml
			"text xml": jQuery.parseXML
		},

		// For options that shouldn't be deep extended:
		// you can add your own custom options here if
		// and when you create one that shouldn't be
		// deep extended (see ajaxExtend)
		flatOptions: {
			url: true,
			context: true
		}
	},

	// Creates a full fledged settings object into target
	// with both ajaxSettings and settings fields.
	// If target is omitted, writes into ajaxSettings.
	ajaxSetup: function( target, settings ) {
		return settings ?

			// Building a settings object
			ajaxExtend( ajaxExtend( target, jQuery.ajaxSettings ), settings ) :

			// Extending ajaxSettings
			ajaxExtend( jQuery.ajaxSettings, target );
	},

	ajaxPrefilter: addToPrefiltersOrTransports( prefilters ),
	ajaxTransport: addToPrefiltersOrTransports( transports ),

	// Main method
	ajax: function( url, options ) {

		// If url is an object, simulate pre-1.5 signature
		if ( typeof url === "object" ) {
			options = url;
			url = undefined;
		}

		// Force options to be an object
		options = options || {};

		var transport,

			// URL without anti-cache param
			cacheURL,

			// Response headers
			responseHeadersString,
			responseHeaders,

			// timeout handle
			timeoutTimer,

			// Url cleanup var
			urlAnchor,

			// Request state (becomes false upon send and true upon completion)
			completed,

			// To know if global events are to be dispatched
			fireGlobals,

			// Loop variable
			i,

			// uncached part of the url
			uncached,

			// Create the final options object
			s = jQuery.ajaxSetup( {}, options ),

			// Callbacks context
			callbackContext = s.context || s,

			// Context for global events is callbackContext if it is a DOM node or jQuery collection
			globalEventContext = s.context &&
				( callbackContext.nodeType || callbackContext.jquery ) ?
					jQuery( callbackContext ) :
					jQuery.event,

			// Deferreds
			deferred = jQuery.Deferred(),
			completeDeferred = jQuery.Callbacks( "once memory" ),

			// Status-dependent callbacks
			statusCode = s.statusCode || {},

			// Headers (they are sent all at once)
			requestHeaders = {},
			requestHeadersNames = {},

			// Default abort message
			strAbort = "canceled",

			// Fake xhr
			jqXHR = {
				readyState: 0,

				// Builds headers hashtable if needed
				getResponseHeader: function( key ) {
					var match;
					if ( completed ) {
						if ( !responseHeaders ) {
							responseHeaders = {};
							while ( ( match = rheaders.exec( responseHeadersString ) ) ) {
								responseHeaders[ match[ 1 ].toLowerCase() ] = match[ 2 ];
							}
						}
						match = responseHeaders[ key.toLowerCase() ];
					}
					return match == null ? null : match;
				},

				// Raw string
				getAllResponseHeaders: function() {
					return completed ? responseHeadersString : null;
				},

				// Caches the header
				setRequestHeader: function( name, value ) {
					if ( completed == null ) {
						name = requestHeadersNames[ name.toLowerCase() ] =
							requestHeadersNames[ name.toLowerCase() ] || name;
						requestHeaders[ name ] = value;
					}
					return this;
				},

				// Overrides response content-type header
				overrideMimeType: function( type ) {
					if ( completed == null ) {
						s.mimeType = type;
					}
					return this;
				},

				// Status-dependent callbacks
				statusCode: function( map ) {
					var code;
					if ( map ) {
						if ( completed ) {

							// Execute the appropriate callbacks
							jqXHR.always( map[ jqXHR.status ] );
						} else {

							// Lazy-add the new callbacks in a way that preserves old ones
							for ( code in map ) {
								statusCode[ code ] = [ statusCode[ code ], map[ code ] ];
							}
						}
					}
					return this;
				},

				// Cancel the request
				abort: function( statusText ) {
					var finalText = statusText || strAbort;
					if ( transport ) {
						transport.abort( finalText );
					}
					done( 0, finalText );
					return this;
				}
			};

		// Attach deferreds
		deferred.promise( jqXHR );

		// Add protocol if not provided (prefilters might expect it)
		// Handle falsy url in the settings object (#10093: consistency with old signature)
		// We also use the url parameter if available
		s.url = ( ( url || s.url || location.href ) + "" )
			.replace( rprotocol, location.protocol + "//" );

		// Alias method option to type as per ticket #12004
		s.type = options.method || options.type || s.method || s.type;

		// Extract dataTypes list
		s.dataTypes = ( s.dataType || "*" ).toLowerCase().match( rnothtmlwhite ) || [ "" ];

		// A cross-domain request is in order when the origin doesn't match the current origin.
		if ( s.crossDomain == null ) {
			urlAnchor = document.createElement( "a" );

			// Support: IE <=8 - 11, Edge 12 - 13
			// IE throws exception on accessing the href property if url is malformed,
			// e.g. http://example.com:80x/
			try {
				urlAnchor.href = s.url;

				// Support: IE <=8 - 11 only
				// Anchor's host property isn't correctly set when s.url is relative
				urlAnchor.href = urlAnchor.href;
				s.crossDomain = originAnchor.protocol + "//" + originAnchor.host !==
					urlAnchor.protocol + "//" + urlAnchor.host;
			} catch ( e ) {

				// If there is an error parsing the URL, assume it is crossDomain,
				// it can be rejected by the transport if it is invalid
				s.crossDomain = true;
			}
		}

		// Convert data if not already a string
		if ( s.data && s.processData && typeof s.data !== "string" ) {
			s.data = jQuery.param( s.data, s.traditional );
		}

		// Apply prefilters
		inspectPrefiltersOrTransports( prefilters, s, options, jqXHR );

		// If request was aborted inside a prefilter, stop there
		if ( completed ) {
			return jqXHR;
		}

		// We can fire global events as of now if asked to
		// Don't fire events if jQuery.event is undefined in an AMD-usage scenario (#15118)
		fireGlobals = jQuery.event && s.global;

		// Watch for a new set of requests
		if ( fireGlobals && jQuery.active++ === 0 ) {
			jQuery.event.trigger( "ajaxStart" );
		}

		// Uppercase the type
		s.type = s.type.toUpperCase();

		// Determine if request has content
		s.hasContent = !rnoContent.test( s.type );

		// Save the URL in case we're toying with the If-Modified-Since
		// and/or If-None-Match header later on
		// Remove hash to simplify url manipulation
		cacheURL = s.url.replace( rhash, "" );

		// More options handling for requests with no content
		if ( !s.hasContent ) {

			// Remember the hash so we can put it back
			uncached = s.url.slice( cacheURL.length );

			// If data is available, append data to url
			if ( s.data ) {
				cacheURL += ( rquery.test( cacheURL ) ? "&" : "?" ) + s.data;

				// #9682: remove data so that it's not used in an eventual retry
				delete s.data;
			}

			// Add or update anti-cache param if needed
			if ( s.cache === false ) {
				cacheURL = cacheURL.replace( rantiCache, "$1" );
				uncached = ( rquery.test( cacheURL ) ? "&" : "?" ) + "_=" + ( nonce++ ) + uncached;
			}

			// Put hash and anti-cache on the URL that will be requested (gh-1732)
			s.url = cacheURL + uncached;

		// Change '%20' to '+' if this is encoded form body content (gh-2658)
		} else if ( s.data && s.processData &&
			( s.contentType || "" ).indexOf( "application/x-www-form-urlencoded" ) === 0 ) {
			s.data = s.data.replace( r20, "+" );
		}

		// Set the If-Modified-Since and/or If-None-Match header, if in ifModified mode.
		if ( s.ifModified ) {
			if ( jQuery.lastModified[ cacheURL ] ) {
				jqXHR.setRequestHeader( "If-Modified-Since", jQuery.lastModified[ cacheURL ] );
			}
			if ( jQuery.etag[ cacheURL ] ) {
				jqXHR.setRequestHeader( "If-None-Match", jQuery.etag[ cacheURL ] );
			}
		}

		// Set the correct header, if data is being sent
		if ( s.data && s.hasContent && s.contentType !== false || options.contentType ) {
			jqXHR.setRequestHeader( "Content-Type", s.contentType );
		}

		// Set the Accepts header for the server, depending on the dataType
		jqXHR.setRequestHeader(
			"Accept",
			s.dataTypes[ 0 ] && s.accepts[ s.dataTypes[ 0 ] ] ?
				s.accepts[ s.dataTypes[ 0 ] ] +
					( s.dataTypes[ 0 ] !== "*" ? ", " + allTypes + "; q=0.01" : "" ) :
				s.accepts[ "*" ]
		);

		// Check for headers option
		for ( i in s.headers ) {
			jqXHR.setRequestHeader( i, s.headers[ i ] );
		}

		// Allow custom headers/mimetypes and early abort
		if ( s.beforeSend &&
			( s.beforeSend.call( callbackContext, jqXHR, s ) === false || completed ) ) {

			// Abort if not done already and return
			return jqXHR.abort();
		}

		// Aborting is no longer a cancellation
		strAbort = "abort";

		// Install callbacks on deferreds
		completeDeferred.add( s.complete );
		jqXHR.done( s.success );
		jqXHR.fail( s.error );

		// Get transport
		transport = inspectPrefiltersOrTransports( transports, s, options, jqXHR );

		// If no transport, we auto-abort
		if ( !transport ) {
			done( -1, "No Transport" );
		} else {
			jqXHR.readyState = 1;

			// Send global event
			if ( fireGlobals ) {
				globalEventContext.trigger( "ajaxSend", [ jqXHR, s ] );
			}

			// If request was aborted inside ajaxSend, stop there
			if ( completed ) {
				return jqXHR;
			}

			// Timeout
			if ( s.async && s.timeout > 0 ) {
				timeoutTimer = window.setTimeout( function() {
					jqXHR.abort( "timeout" );
				}, s.timeout );
			}

			try {
				completed = false;
				transport.send( requestHeaders, done );
			} catch ( e ) {

				// Rethrow post-completion exceptions
				if ( completed ) {
					throw e;
				}

				// Propagate others as results
				done( -1, e );
			}
		}

		// Callback for when everything is done
		function done( status, nativeStatusText, responses, headers ) {
			var isSuccess, success, error, response, modified,
				statusText = nativeStatusText;

			// Ignore repeat invocations
			if ( completed ) {
				return;
			}

			completed = true;

			// Clear timeout if it exists
			if ( timeoutTimer ) {
				window.clearTimeout( timeoutTimer );
			}

			// Dereference transport for early garbage collection
			// (no matter how long the jqXHR object will be used)
			transport = undefined;

			// Cache response headers
			responseHeadersString = headers || "";

			// Set readyState
			jqXHR.readyState = status > 0 ? 4 : 0;

			// Determine if successful
			isSuccess = status >= 200 && status < 300 || status === 304;

			// Get response data
			if ( responses ) {
				response = ajaxHandleResponses( s, jqXHR, responses );
			}

			// Convert no matter what (that way responseXXX fields are always set)
			response = ajaxConvert( s, response, jqXHR, isSuccess );

			// If successful, handle type chaining
			if ( isSuccess ) {

				// Set the If-Modified-Since and/or If-None-Match header, if in ifModified mode.
				if ( s.ifModified ) {
					modified = jqXHR.getResponseHeader( "Last-Modified" );
					if ( modified ) {
						jQuery.lastModified[ cacheURL ] = modified;
					}
					modified = jqXHR.getResponseHeader( "etag" );
					if ( modified ) {
						jQuery.etag[ cacheURL ] = modified;
					}
				}

				// if no content
				if ( status === 204 || s.type === "HEAD" ) {
					statusText = "nocontent";

				// if not modified
				} else if ( status === 304 ) {
					statusText = "notmodified";

				// If we have data, let's convert it
				} else {
					statusText = response.state;
					success = response.data;
					error = response.error;
					isSuccess = !error;
				}
			} else {

				// Extract error from statusText and normalize for non-aborts
				error = statusText;
				if ( status || !statusText ) {
					statusText = "error";
					if ( status < 0 ) {
						status = 0;
					}
				}
			}

			// Set data for the fake xhr object
			jqXHR.status = status;
			jqXHR.statusText = ( nativeStatusText || statusText ) + "";

			// Success/Error
			if ( isSuccess ) {
				deferred.resolveWith( callbackContext, [ success, statusText, jqXHR ] );
			} else {
				deferred.rejectWith( callbackContext, [ jqXHR, statusText, error ] );
			}

			// Status-dependent callbacks
			jqXHR.statusCode( statusCode );
			statusCode = undefined;

			if ( fireGlobals ) {
				globalEventContext.trigger( isSuccess ? "ajaxSuccess" : "ajaxError",
					[ jqXHR, s, isSuccess ? success : error ] );
			}

			// Complete
			completeDeferred.fireWith( callbackContext, [ jqXHR, statusText ] );

			if ( fireGlobals ) {
				globalEventContext.trigger( "ajaxComplete", [ jqXHR, s ] );

				// Handle the global AJAX counter
				if ( !( --jQuery.active ) ) {
					jQuery.event.trigger( "ajaxStop" );
				}
			}
		}

		return jqXHR;
	},

	getJSON: function( url, data, callback ) {
		return jQuery.get( url, data, callback, "json" );
	},

	getScript: function( url, callback ) {
		return jQuery.get( url, undefined, callback, "script" );
	}
} );

jQuery.each( [ "get", "post" ], function( i, method ) {
	jQuery[ method ] = function( url, data, callback, type ) {

		// Shift arguments if data argument was omitted
		if ( jQuery.isFunction( data ) ) {
			type = type || callback;
			callback = data;
			data = undefined;
		}

		// The url can be an options object (which then must have .url)
		return jQuery.ajax( jQuery.extend( {
			url: url,
			type: method,
			dataType: type,
			data: data,
			success: callback
		}, jQuery.isPlainObject( url ) && url ) );
	};
} );


jQuery._evalUrl = function( url ) {
	return jQuery.ajax( {
		url: url,

		// Make this explicit, since user can override this through ajaxSetup (#11264)
		type: "GET",
		dataType: "script",
		cache: true,
		async: false,
		global: false,
		"throws": true
	} );
};


jQuery.fn.extend( {
	wrapAll: function( html ) {
		var wrap;

		if ( this[ 0 ] ) {
			if ( jQuery.isFunction( html ) ) {
				html = html.call( this[ 0 ] );
			}

			// The elements to wrap the target around
			wrap = jQuery( html, this[ 0 ].ownerDocument ).eq( 0 ).clone( true );

			if ( this[ 0 ].parentNode ) {
				wrap.insertBefore( this[ 0 ] );
			}

			wrap.map( function() {
				var elem = this;

				while ( elem.firstElementChild ) {
					elem = elem.firstElementChild;
				}

				return elem;
			} ).append( this );
		}

		return this;
	},

	wrapInner: function( html ) {
		if ( jQuery.isFunction( html ) ) {
			return this.each( function( i ) {
				jQuery( this ).wrapInner( html.call( this, i ) );
			} );
		}

		return this.each( function() {
			var self = jQuery( this ),
				contents = self.contents();

			if ( contents.length ) {
				contents.wrapAll( html );

			} else {
				self.append( html );
			}
		} );
	},

	wrap: function( html ) {
		var isFunction = jQuery.isFunction( html );

		return this.each( function( i ) {
			jQuery( this ).wrapAll( isFunction ? html.call( this, i ) : html );
		} );
	},

	unwrap: function( selector ) {
		this.parent( selector ).not( "body" ).each( function() {
			jQuery( this ).replaceWith( this.childNodes );
		} );
		return this;
	}
} );


jQuery.expr.pseudos.hidden = function( elem ) {
	return !jQuery.expr.pseudos.visible( elem );
};
jQuery.expr.pseudos.visible = function( elem ) {
	return !!( elem.offsetWidth || elem.offsetHeight || elem.getClientRects().length );
};




jQuery.ajaxSettings.xhr = function() {
	try {
		return new window.XMLHttpRequest();
	} catch ( e ) {}
};

var xhrSuccessStatus = {

		// File protocol always yields status code 0, assume 200
		0: 200,

		// Support: IE <=9 only
		// #1450: sometimes IE returns 1223 when it should be 204
		1223: 204
	},
	xhrSupported = jQuery.ajaxSettings.xhr();

support.cors = !!xhrSupported && ( "withCredentials" in xhrSupported );
support.ajax = xhrSupported = !!xhrSupported;

jQuery.ajaxTransport( function( options ) {
	var callback, errorCallback;

	// Cross domain only allowed if supported through XMLHttpRequest
	if ( support.cors || xhrSupported && !options.crossDomain ) {
		return {
			send: function( headers, complete ) {
				var i,
					xhr = options.xhr();

				xhr.open(
					options.type,
					options.url,
					options.async,
					options.username,
					options.password
				);

				// Apply custom fields if provided
				if ( options.xhrFields ) {
					for ( i in options.xhrFields ) {
						xhr[ i ] = options.xhrFields[ i ];
					}
				}

				// Override mime type if needed
				if ( options.mimeType && xhr.overrideMimeType ) {
					xhr.overrideMimeType( options.mimeType );
				}

				// X-Requested-With header
				// For cross-domain requests, seeing as conditions for a preflight are
				// akin to a jigsaw puzzle, we simply never set it to be sure.
				// (it can always be set on a per-request basis or even using ajaxSetup)
				// For same-domain requests, won't change header if already provided.
				if ( !options.crossDomain && !headers[ "X-Requested-With" ] ) {
					headers[ "X-Requested-With" ] = "XMLHttpRequest";
				}

				// Set headers
				for ( i in headers ) {
					xhr.setRequestHeader( i, headers[ i ] );
				}

				// Callback
				callback = function( type ) {
					return function() {
						if ( callback ) {
							callback = errorCallback = xhr.onload =
								xhr.onerror = xhr.onabort = xhr.onreadystatechange = null;

							if ( type === "abort" ) {
								xhr.abort();
							} else if ( type === "error" ) {

								// Support: IE <=9 only
								// On a manual native abort, IE9 throws
								// errors on any property access that is not readyState
								if ( typeof xhr.status !== "number" ) {
									complete( 0, "error" );
								} else {
									complete(

										// File: protocol always yields status 0; see #8605, #14207
										xhr.status,
										xhr.statusText
									);
								}
							} else {
								complete(
									xhrSuccessStatus[ xhr.status ] || xhr.status,
									xhr.statusText,

									// Support: IE <=9 only
									// IE9 has no XHR2 but throws on binary (trac-11426)
									// For XHR2 non-text, let the caller handle it (gh-2498)
									( xhr.responseType || "text" ) !== "text"  ||
									typeof xhr.responseText !== "string" ?
										{ binary: xhr.response } :
										{ text: xhr.responseText },
									xhr.getAllResponseHeaders()
								);
							}
						}
					};
				};

				// Listen to events
				xhr.onload = callback();
				errorCallback = xhr.onerror = callback( "error" );

				// Support: IE 9 only
				// Use onreadystatechange to replace onabort
				// to handle uncaught aborts
				if ( xhr.onabort !== undefined ) {
					xhr.onabort = errorCallback;
				} else {
					xhr.onreadystatechange = function() {

						// Check readyState before timeout as it changes
						if ( xhr.readyState === 4 ) {

							// Allow onerror to be called first,
							// but that will not handle a native abort
							// Also, save errorCallback to a variable
							// as xhr.onerror cannot be accessed
							window.setTimeout( function() {
								if ( callback ) {
									errorCallback();
								}
							} );
						}
					};
				}

				// Create the abort callback
				callback = callback( "abort" );

				try {

					// Do send the request (this may raise an exception)
					xhr.send( options.hasContent && options.data || null );
				} catch ( e ) {

					// #14683: Only rethrow if this hasn't been notified as an error yet
					if ( callback ) {
						throw e;
					}
				}
			},

			abort: function() {
				if ( callback ) {
					callback();
				}
			}
		};
	}
} );




// Prevent auto-execution of scripts when no explicit dataType was provided (See gh-2432)
jQuery.ajaxPrefilter( function( s ) {
	if ( s.crossDomain ) {
		s.contents.script = false;
	}
} );

// Install script dataType
jQuery.ajaxSetup( {
	accepts: {
		script: "text/javascript, application/javascript, " +
			"application/ecmascript, application/x-ecmascript"
	},
	contents: {
		script: /\b(?:java|ecma)script\b/
	},
	converters: {
		"text script": function( text ) {
			jQuery.globalEval( text );
			return text;
		}
	}
} );

// Handle cache's special case and crossDomain
jQuery.ajaxPrefilter( "script", function( s ) {
	if ( s.cache === undefined ) {
		s.cache = false;
	}
	if ( s.crossDomain ) {
		s.type = "GET";
	}
} );

// Bind script tag hack transport
jQuery.ajaxTransport( "script", function( s ) {

	// This transport only deals with cross domain requests
	if ( s.crossDomain ) {
		var script, callback;
		return {
			send: function( _, complete ) {
				script = jQuery( "<script>" ).prop( {
					charset: s.scriptCharset,
					src: s.url
				} ).on(
					"load error",
					callback = function( evt ) {
						script.remove();
						callback = null;
						if ( evt ) {
							complete( evt.type === "error" ? 404 : 200, evt.type );
						}
					}
				);

				// Use native DOM manipulation to avoid our domManip AJAX trickery
				document.head.appendChild( script[ 0 ] );
			},
			abort: function() {
				if ( callback ) {
					callback();
				}
			}
		};
	}
} );




var oldCallbacks = [],
	rjsonp = /(=)\?(?=&|$)|\?\?/;

// Default jsonp settings
jQuery.ajaxSetup( {
	jsonp: "callback",
	jsonpCallback: function() {
		var callback = oldCallbacks.pop() || ( jQuery.expando + "_" + ( nonce++ ) );
		this[ callback ] = true;
		return callback;
	}
} );

// Detect, normalize options and install callbacks for jsonp requests
jQuery.ajaxPrefilter( "json jsonp", function( s, originalSettings, jqXHR ) {

	var callbackName, overwritten, responseContainer,
		jsonProp = s.jsonp !== false && ( rjsonp.test( s.url ) ?
			"url" :
			typeof s.data === "string" &&
				( s.contentType || "" )
					.indexOf( "application/x-www-form-urlencoded" ) === 0 &&
				rjsonp.test( s.data ) && "data"
		);

	// Handle iff the expected data type is "jsonp" or we have a parameter to set
	if ( jsonProp || s.dataTypes[ 0 ] === "jsonp" ) {

		// Get callback name, remembering preexisting value associated with it
		callbackName = s.jsonpCallback = jQuery.isFunction( s.jsonpCallback ) ?
			s.jsonpCallback() :
			s.jsonpCallback;

		// Insert callback into url or form data
		if ( jsonProp ) {
			s[ jsonProp ] = s[ jsonProp ].replace( rjsonp, "$1" + callbackName );
		} else if ( s.jsonp !== false ) {
			s.url += ( rquery.test( s.url ) ? "&" : "?" ) + s.jsonp + "=" + callbackName;
		}

		// Use data converter to retrieve json after script execution
		s.converters[ "script json" ] = function() {
			if ( !responseContainer ) {
				jQuery.error( callbackName + " was not called" );
			}
			return responseContainer[ 0 ];
		};

		// Force json dataType
		s.dataTypes[ 0 ] = "json";

		// Install callback
		overwritten = window[ callbackName ];
		window[ callbackName ] = function() {
			responseContainer = arguments;
		};

		// Clean-up function (fires after converters)
		jqXHR.always( function() {

			// If previous value didn't exist - remove it
			if ( overwritten === undefined ) {
				jQuery( window ).removeProp( callbackName );

			// Otherwise restore preexisting value
			} else {
				window[ callbackName ] = overwritten;
			}

			// Save back as free
			if ( s[ callbackName ] ) {

				// Make sure that re-using the options doesn't screw things around
				s.jsonpCallback = originalSettings.jsonpCallback;

				// Save the callback name for future use
				oldCallbacks.push( callbackName );
			}

			// Call if it was a function and we have a response
			if ( responseContainer && jQuery.isFunction( overwritten ) ) {
				overwritten( responseContainer[ 0 ] );
			}

			responseContainer = overwritten = undefined;
		} );

		// Delegate to script
		return "script";
	}
} );




// Support: Safari 8 only
// In Safari 8 documents created via document.implementation.createHTMLDocument
// collapse sibling forms: the second one becomes a child of the first one.
// Because of that, this security measure has to be disabled in Safari 8.
// https://bugs.webkit.org/show_bug.cgi?id=137337
support.createHTMLDocument = ( function() {
	var body = document.implementation.createHTMLDocument( "" ).body;
	body.innerHTML = "<form></form><form></form>";
	return body.childNodes.length === 2;
} )();


// Argument "data" should be string of html
// context (optional): If specified, the fragment will be created in this context,
// defaults to document
// keepScripts (optional): If true, will include scripts passed in the html string
jQuery.parseHTML = function( data, context, keepScripts ) {
	if ( typeof data !== "string" ) {
		return [];
	}
	if ( typeof context === "boolean" ) {
		keepScripts = context;
		context = false;
	}

	var base, parsed, scripts;

	if ( !context ) {

		// Stop scripts or inline event handlers from being executed immediately
		// by using document.implementation
		if ( support.createHTMLDocument ) {
			context = document.implementation.createHTMLDocument( "" );

			// Set the base href for the created document
			// so any parsed elements with URLs
			// are based on the document's URL (gh-2965)
			base = context.createElement( "base" );
			base.href = document.location.href;
			context.head.appendChild( base );
		} else {
			context = document;
		}
	}

	parsed = rsingleTag.exec( data );
	scripts = !keepScripts && [];

	// Single tag
	if ( parsed ) {
		return [ context.createElement( parsed[ 1 ] ) ];
	}

	parsed = buildFragment( [ data ], context, scripts );

	if ( scripts && scripts.length ) {
		jQuery( scripts ).remove();
	}

	return jQuery.merge( [], parsed.childNodes );
};


/**
 * Load a url into a page
 */
jQuery.fn.load = function( url, params, callback ) {
	var selector, type, response,
		self = this,
		off = url.indexOf( " " );

	if ( off > -1 ) {
		selector = stripAndCollapse( url.slice( off ) );
		url = url.slice( 0, off );
	}

	// If it's a function
	if ( jQuery.isFunction( params ) ) {

		// We assume that it's the callback
		callback = params;
		params = undefined;

	// Otherwise, build a param string
	} else if ( params && typeof params === "object" ) {
		type = "POST";
	}

	// If we have elements to modify, make the request
	if ( self.length > 0 ) {
		jQuery.ajax( {
			url: url,

			// If "type" variable is undefined, then "GET" method will be used.
			// Make value of this field explicit since
			// user can override it through ajaxSetup method
			type: type || "GET",
			dataType: "html",
			data: params
		} ).done( function( responseText ) {

			// Save response for use in complete callback
			response = arguments;

			self.html( selector ?

				// If a selector was specified, locate the right elements in a dummy div
				// Exclude scripts to avoid IE 'Permission Denied' errors
				jQuery( "<div>" ).append( jQuery.parseHTML( responseText ) ).find( selector ) :

				// Otherwise use the full result
				responseText );

		// If the request succeeds, this function gets "data", "status", "jqXHR"
		// but they are ignored because response was set above.
		// If it fails, this function gets "jqXHR", "status", "error"
		} ).always( callback && function( jqXHR, status ) {
			self.each( function() {
				callback.apply( this, response || [ jqXHR.responseText, status, jqXHR ] );
			} );
		} );
	}

	return this;
};




// Attach a bunch of functions for handling common AJAX events
jQuery.each( [
	"ajaxStart",
	"ajaxStop",
	"ajaxComplete",
	"ajaxError",
	"ajaxSuccess",
	"ajaxSend"
], function( i, type ) {
	jQuery.fn[ type ] = function( fn ) {
		return this.on( type, fn );
	};
} );




jQuery.expr.pseudos.animated = function( elem ) {
	return jQuery.grep( jQuery.timers, function( fn ) {
		return elem === fn.elem;
	} ).length;
};




/**
 * Gets a window from an element
 */
function getWindow( elem ) {
	return jQuery.isWindow( elem ) ? elem : elem.nodeType === 9 && elem.defaultView;
}

jQuery.offset = {
	setOffset: function( elem, options, i ) {
		var curPosition, curLeft, curCSSTop, curTop, curOffset, curCSSLeft, calculatePosition,
			position = jQuery.css( elem, "position" ),
			curElem = jQuery( elem ),
			props = {};

		// Set position first, in-case top/left are set even on static elem
		if ( position === "static" ) {
			elem.style.position = "relative";
		}

		curOffset = curElem.offset();
		curCSSTop = jQuery.css( elem, "top" );
		curCSSLeft = jQuery.css( elem, "left" );
		calculatePosition = ( position === "absolute" || position === "fixed" ) &&
			( curCSSTop + curCSSLeft ).indexOf( "auto" ) > -1;

		// Need to be able to calculate position if either
		// top or left is auto and position is either absolute or fixed
		if ( calculatePosition ) {
			curPosition = curElem.position();
			curTop = curPosition.top;
			curLeft = curPosition.left;

		} else {
			curTop = parseFloat( curCSSTop ) || 0;
			curLeft = parseFloat( curCSSLeft ) || 0;
		}

		if ( jQuery.isFunction( options ) ) {

			// Use jQuery.extend here to allow modification of coordinates argument (gh-1848)
			options = options.call( elem, i, jQuery.extend( {}, curOffset ) );
		}

		if ( options.top != null ) {
			props.top = ( options.top - curOffset.top ) + curTop;
		}
		if ( options.left != null ) {
			props.left = ( options.left - curOffset.left ) + curLeft;
		}

		if ( "using" in options ) {
			options.using.call( elem, props );

		} else {
			curElem.css( props );
		}
	}
};

jQuery.fn.extend( {
	offset: function( options ) {

		// Preserve chaining for setter
		if ( arguments.length ) {
			return options === undefined ?
				this :
				this.each( function( i ) {
					jQuery.offset.setOffset( this, options, i );
				} );
		}

		var docElem, win, rect, doc,
			elem = this[ 0 ];

		if ( !elem ) {
			return;
		}

		// Support: IE <=11 only
		// Running getBoundingClientRect on a
		// disconnected node in IE throws an error
		if ( !elem.getClientRects().length ) {
			return { top: 0, left: 0 };
		}

		rect = elem.getBoundingClientRect();

		// Make sure element is not hidden (display: none)
		if ( rect.width || rect.height ) {
			doc = elem.ownerDocument;
			win = getWindow( doc );
			docElem = doc.documentElement;

			return {
				top: rect.top + win.pageYOffset - docElem.clientTop,
				left: rect.left + win.pageXOffset - docElem.clientLeft
			};
		}

		// Return zeros for disconnected and hidden elements (gh-2310)
		return rect;
	},

	position: function() {
		if ( !this[ 0 ] ) {
			return;
		}

		var offsetParent, offset,
			elem = this[ 0 ],
			parentOffset = { top: 0, left: 0 };

		// Fixed elements are offset from window (parentOffset = {top:0, left: 0},
		// because it is its only offset parent
		if ( jQuery.css( elem, "position" ) === "fixed" ) {

			// Assume getBoundingClientRect is there when computed position is fixed
			offset = elem.getBoundingClientRect();

		} else {

			// Get *real* offsetParent
			offsetParent = this.offsetParent();

			// Get correct offsets
			offset = this.offset();
			if ( !jQuery.nodeName( offsetParent[ 0 ], "html" ) ) {
				parentOffset = offsetParent.offset();
			}

			// Add offsetParent borders
			parentOffset = {
				top: parentOffset.top + jQuery.css( offsetParent[ 0 ], "borderTopWidth", true ),
				left: parentOffset.left + jQuery.css( offsetParent[ 0 ], "borderLeftWidth", true )
			};
		}

		// Subtract parent offsets and element margins
		return {
			top: offset.top - parentOffset.top - jQuery.css( elem, "marginTop", true ),
			left: offset.left - parentOffset.left - jQuery.css( elem, "marginLeft", true )
		};
	},

	// This method will return documentElement in the following cases:
	// 1) For the element inside the iframe without offsetParent, this method will return
	//    documentElement of the parent window
	// 2) For the hidden or detached element
	// 3) For body or html element, i.e. in case of the html node - it will return itself
	//
	// but those exceptions were never presented as a real life use-cases
	// and might be considered as more preferable results.
	//
	// This logic, however, is not guaranteed and can change at any point in the future
	offsetParent: function() {
		return this.map( function() {
			var offsetParent = this.offsetParent;

			while ( offsetParent && jQuery.css( offsetParent, "position" ) === "static" ) {
				offsetParent = offsetParent.offsetParent;
			}

			return offsetParent || documentElement;
		} );
	}
} );

// Create scrollLeft and scrollTop methods
jQuery.each( { scrollLeft: "pageXOffset", scrollTop: "pageYOffset" }, function( method, prop ) {
	var top = "pageYOffset" === prop;

	jQuery.fn[ method ] = function( val ) {
		return access( this, function( elem, method, val ) {
			var win = getWindow( elem );

			if ( val === undefined ) {
				return win ? win[ prop ] : elem[ method ];
			}

			if ( win ) {
				win.scrollTo(
					!top ? val : win.pageXOffset,
					top ? val : win.pageYOffset
				);

			} else {
				elem[ method ] = val;
			}
		}, method, val, arguments.length );
	};
} );

// Support: Safari <=7 - 9.1, Chrome <=37 - 49
// Add the top/left cssHooks using jQuery.fn.position
// Webkit bug: https://bugs.webkit.org/show_bug.cgi?id=29084
// Blink bug: https://bugs.chromium.org/p/chromium/issues/detail?id=589347
// getComputedStyle returns percent when specified for top/left/bottom/right;
// rather than make the css module depend on the offset module, just check for it here
jQuery.each( [ "top", "left" ], function( i, prop ) {
	jQuery.cssHooks[ prop ] = addGetHookIf( support.pixelPosition,
		function( elem, computed ) {
			if ( computed ) {
				computed = curCSS( elem, prop );

				// If curCSS returns percentage, fallback to offset
				return rnumnonpx.test( computed ) ?
					jQuery( elem ).position()[ prop ] + "px" :
					computed;
			}
		}
	);
} );


// Create innerHeight, innerWidth, height, width, outerHeight and outerWidth methods
jQuery.each( { Height: "height", Width: "width" }, function( name, type ) {
	jQuery.each( { padding: "inner" + name, content: type, "": "outer" + name },
		function( defaultExtra, funcName ) {

		// Margin is only for outerHeight, outerWidth
		jQuery.fn[ funcName ] = function( margin, value ) {
			var chainable = arguments.length && ( defaultExtra || typeof margin !== "boolean" ),
				extra = defaultExtra || ( margin === true || value === true ? "margin" : "border" );

			return access( this, function( elem, type, value ) {
				var doc;

				if ( jQuery.isWindow( elem ) ) {

					// $( window ).outerWidth/Height return w/h including scrollbars (gh-1729)
					return funcName.indexOf( "outer" ) === 0 ?
						elem[ "inner" + name ] :
						elem.document.documentElement[ "client" + name ];
				}

				// Get document width or height
				if ( elem.nodeType === 9 ) {
					doc = elem.documentElement;

					// Either scroll[Width/Height] or offset[Width/Height] or client[Width/Height],
					// whichever is greatest
					return Math.max(
						elem.body[ "scroll" + name ], doc[ "scroll" + name ],
						elem.body[ "offset" + name ], doc[ "offset" + name ],
						doc[ "client" + name ]
					);
				}

				return value === undefined ?

					// Get width or height on the element, requesting but not forcing parseFloat
					jQuery.css( elem, type, extra ) :

					// Set width or height on the element
					jQuery.style( elem, type, value, extra );
			}, type, chainable ? margin : undefined, chainable );
		};
	} );
} );


jQuery.fn.extend( {

	bind: function( types, data, fn ) {
		return this.on( types, null, data, fn );
	},
	unbind: function( types, fn ) {
		return this.off( types, null, fn );
	},

	delegate: function( selector, types, data, fn ) {
		return this.on( types, selector, data, fn );
	},
	undelegate: function( selector, types, fn ) {

		// ( namespace ) or ( selector, types [, fn] )
		return arguments.length === 1 ?
			this.off( selector, "**" ) :
			this.off( types, selector || "**", fn );
	}
} );

jQuery.parseJSON = JSON.parse;




// Register as a named AMD module, since jQuery can be concatenated with other
// files that may use define, but not via a proper concatenation script that
// understands anonymous AMD modules. A named AMD is safest and most robust
// way to register. Lowercase jquery is used because AMD module names are
// derived from file names, and jQuery is normally delivered in a lowercase
// file name. Do this after creating the global so that if an AMD module wants
// to call noConflict to hide this version of jQuery, it will work.

// Note that for maximum portability, libraries that are not jQuery should
// declare themselves as anonymous modules, and avoid setting a global if an
// AMD loader is present. jQuery is a special case. For more information, see
// https://github.com/jrburke/requirejs/wiki/Updating-existing-libraries#wiki-anon

if ( typeof define === "function" && define.amd ) {
	define( "jquery", [], function() {
		return jQuery;
	} );
}




var

	// Map over jQuery in case of overwrite
	_jQuery = window.jQuery,

	// Map over the $ in case of overwrite
	_$ = window.$;

jQuery.noConflict = function( deep ) {
	if ( window.$ === jQuery ) {
		window.$ = _$;
	}

	if ( deep && window.jQuery === jQuery ) {
		window.jQuery = _jQuery;
	}

	return jQuery;
};

// Expose jQuery and $ identifiers, even in AMD
// (#7102#comment:10, https://github.com/jquery/jquery/pull/557)
// and CommonJS for browser emulators (#13566)
if ( !noGlobal ) {
	window.jQuery = window.$ = jQuery;
}





return jQuery;
} );

},{}],6:[function(require,module,exports){
var FusionCharts = require('../../lib/jquery-fusioncharts');
var Charts = require('fusioncharts/fusioncharts.charts');
var $ = require('jquery');

$('document').ready(function () {
	// Load the chart module and pass FusionCharts as parameter
	// after the window with a document is ready.
	Charts(FusionCharts);

	// Render chart using insertFusionCharts method
	$('#chart-container').insertFusionCharts({
		type: "Column2D",
		dataFormat: 'json',
		dataSource: { data: [{ value: 500 }, { value: 300 }, { value: 300 }] }
	});

	// Convert HTML table to chart using convertToFusionCharts method
	$("#dataTable").convertToFusionCharts({
		type: "mscolumn2d",
		width: "700",
		height: "350",
		dataFormat: "htmltable",
		renderAt: "chart-container2"
	}, {
		"chartAttributes": {
			caption: "Units sold for last 2 years",
			xAxisName: "Month",
			yAxisName: "Units",
			bgColor: "FFFFFF",
			theme: "fint"
		}
	});
});

},{"../../lib/jquery-fusioncharts":1,"fusioncharts/fusioncharts.charts":3,"jquery":5}]},{},[6]);
